#include <tree_sitter/parser.h>

#if defined(__GNUC__) || defined(__clang__)
#pragma GCC diagnostic push
#pragma GCC diagnostic ignored "-Wmissing-field-initializers"
#endif

#define LANGUAGE_VERSION 10
#define STATE_COUNT 1037
#define SYMBOL_COUNT 219
#define ALIAS_COUNT 0
#define TOKEN_COUNT 101
#define EXTERNAL_TOKEN_COUNT 6
#define FIELD_COUNT 25
#define MAX_ALIAS_SEQUENCE_LENGTH 9

enum {
  sym_identifier = 1,
  anon_sym_import = 2,
  anon_sym_DOT = 3,
  anon_sym_from = 4,
  anon_sym___future__ = 5,
  anon_sym_LPAREN = 6,
  anon_sym_RPAREN = 7,
  anon_sym_COMMA = 8,
  anon_sym_as = 9,
  anon_sym_STAR = 10,
  anon_sym_print = 11,
  anon_sym_GT_GT = 12,
  anon_sym_assert = 13,
  anon_sym_COLON_EQ = 14,
  anon_sym_return = 15,
  anon_sym_del = 16,
  anon_sym_raise = 17,
  anon_sym_pass = 18,
  anon_sym_break = 19,
  anon_sym_continue = 20,
  anon_sym_if = 21,
  anon_sym_COLON = 22,
  anon_sym_elif = 23,
  anon_sym_else = 24,
  anon_sym_async = 25,
  anon_sym_for = 26,
  anon_sym_in = 27,
  anon_sym_while = 28,
  anon_sym_try = 29,
  anon_sym_except = 30,
  anon_sym_finally = 31,
  anon_sym_with = 32,
  anon_sym_def = 33,
  anon_sym_DASH_GT = 34,
  anon_sym_EQ = 35,
  anon_sym_STAR_STAR = 36,
  anon_sym_global = 37,
  anon_sym_nonlocal = 38,
  anon_sym_exec = 39,
  anon_sym_class = 40,
  anon_sym_AT = 41,
  anon_sym_not = 42,
  anon_sym_and = 43,
  anon_sym_or = 44,
  anon_sym_PLUS = 45,
  anon_sym_DASH = 46,
  anon_sym_SLASH = 47,
  anon_sym_PERCENT = 48,
  anon_sym_SLASH_SLASH = 49,
  anon_sym_PIPE = 50,
  anon_sym_AMP = 51,
  anon_sym_CARET = 52,
  anon_sym_LT_LT = 53,
  anon_sym_TILDE = 54,
  anon_sym_LT = 55,
  anon_sym_LT_EQ = 56,
  anon_sym_EQ_EQ = 57,
  anon_sym_BANG_EQ = 58,
  anon_sym_GT_EQ = 59,
  anon_sym_GT = 60,
  anon_sym_LT_GT = 61,
  anon_sym_is = 62,
  anon_sym_lambda = 63,
  anon_sym_PLUS_EQ = 64,
  anon_sym_DASH_EQ = 65,
  anon_sym_STAR_EQ = 66,
  anon_sym_SLASH_EQ = 67,
  anon_sym_AT_EQ = 68,
  anon_sym_SLASH_SLASH_EQ = 69,
  anon_sym_PERCENT_EQ = 70,
  anon_sym_STAR_STAR_EQ = 71,
  anon_sym_GT_GT_EQ = 72,
  anon_sym_LT_LT_EQ = 73,
  anon_sym_AMP_EQ = 74,
  anon_sym_CARET_EQ = 75,
  anon_sym_PIPE_EQ = 76,
  anon_sym_yield = 77,
  anon_sym_LBRACK = 78,
  anon_sym_RBRACK = 79,
  sym_ellipsis = 80,
  anon_sym_LBRACE = 81,
  anon_sym_RBRACE = 82,
  sym_escape_sequence = 83,
  sym__not_escape_sequence = 84,
  aux_sym_format_specifier_token1 = 85,
  sym_type_conversion = 86,
  sym_integer = 87,
  sym_float = 88,
  sym_true = 89,
  sym_false = 90,
  sym_none = 91,
  anon_sym_await = 92,
  sym_comment = 93,
  sym__semicolon = 94,
  sym__newline = 95,
  sym__indent = 96,
  sym__dedent = 97,
  sym__string_start = 98,
  sym__string_content = 99,
  sym__string_end = 100,
  sym_module = 101,
  sym__statement = 102,
  sym__simple_statements = 103,
  sym_import_statement = 104,
  sym_import_prefix = 105,
  sym_relative_import = 106,
  sym_future_import_statement = 107,
  sym_import_from_statement = 108,
  sym__import_list = 109,
  sym_aliased_import = 110,
  sym_wildcard_import = 111,
  sym_print_statement = 112,
  sym_chevron = 113,
  sym_assert_statement = 114,
  sym_expression_statement = 115,
  sym_named_expression = 116,
  sym_return_statement = 117,
  sym_delete_statement = 118,
  sym_raise_statement = 119,
  sym_pass_statement = 120,
  sym_break_statement = 121,
  sym_continue_statement = 122,
  sym_if_statement = 123,
  sym_elif_clause = 124,
  sym_else_clause = 125,
  sym_for_statement = 126,
  sym_while_statement = 127,
  sym_try_statement = 128,
  sym_except_clause = 129,
  sym_finally_clause = 130,
  sym_with_statement = 131,
  sym_with_item = 132,
  sym_function_definition = 133,
  sym_parameters = 134,
  sym_lambda_parameters = 135,
  sym__parameters = 136,
  sym_default_parameter = 137,
  sym_typed_default_parameter = 138,
  sym_list_splat = 139,
  sym_dictionary_splat = 140,
  sym_global_statement = 141,
  sym_nonlocal_statement = 142,
  sym_exec_statement = 143,
  sym_class_definition = 144,
  sym_parenthesized_list_splat = 145,
  sym_argument_list = 146,
  sym_decorated_definition = 147,
  sym_decorator = 148,
  sym_block = 149,
  sym_variables = 150,
  sym_expression_list = 151,
  sym_dotted_name = 152,
  sym__expression_within_for_in_clause = 153,
  sym__expression = 154,
  sym__primary_expression = 155,
  sym_not_operator = 156,
  sym_boolean_operator = 157,
  sym_binary_operator = 158,
  sym_unary_operator = 159,
  sym_comparison_operator = 160,
  sym_lambda = 161,
  sym_lambda_within_for_in_clause = 162,
  sym_assignment = 163,
  sym_augmented_assignment = 164,
  sym__right_hand_side = 165,
  sym_yield = 166,
  sym_attribute = 167,
  sym_subscript = 168,
  sym_slice = 169,
  sym_call = 170,
  sym_typed_parameter = 171,
  sym_type = 172,
  sym_keyword_argument = 173,
  sym_list = 174,
  sym__comprehension_clauses = 175,
  sym_list_comprehension = 176,
  sym_dictionary = 177,
  sym_dictionary_comprehension = 178,
  sym_pair = 179,
  sym_set = 180,
  sym_set_comprehension = 181,
  sym_parenthesized_expression = 182,
  sym_tuple = 183,
  sym_generator_expression = 184,
  sym_for_in_clause = 185,
  sym_if_clause = 186,
  sym_conditional_expression = 187,
  sym_concatenated_string = 188,
  sym_string = 189,
  sym_interpolation = 190,
  sym_format_specifier = 191,
  sym_format_expression = 192,
  sym_await = 193,
  aux_sym_module_repeat1 = 194,
  aux_sym__simple_statements_repeat1 = 195,
  aux_sym_import_prefix_repeat1 = 196,
  aux_sym__import_list_repeat1 = 197,
  aux_sym_print_statement_repeat1 = 198,
  aux_sym_assert_statement_repeat1 = 199,
  aux_sym_if_statement_repeat1 = 200,
  aux_sym_try_statement_repeat1 = 201,
  aux_sym_with_statement_repeat1 = 202,
  aux_sym__parameters_repeat1 = 203,
  aux_sym_global_statement_repeat1 = 204,
  aux_sym_argument_list_repeat1 = 205,
  aux_sym_decorated_definition_repeat1 = 206,
  aux_sym_variables_repeat1 = 207,
  aux_sym_dotted_name_repeat1 = 208,
  aux_sym_comparison_operator_repeat1 = 209,
  aux_sym_subscript_repeat1 = 210,
  aux_sym_list_repeat1 = 211,
  aux_sym__comprehension_clauses_repeat1 = 212,
  aux_sym_dictionary_repeat1 = 213,
  aux_sym_tuple_repeat1 = 214,
  aux_sym_for_in_clause_repeat1 = 215,
  aux_sym_concatenated_string_repeat1 = 216,
  aux_sym_string_repeat1 = 217,
  aux_sym_format_specifier_repeat1 = 218,
};

static const char *ts_symbol_names[] = {
  [ts_builtin_sym_end] = "end",
  [sym_identifier] = "identifier",
  [anon_sym_import] = "import",
  [anon_sym_DOT] = ".",
  [anon_sym_from] = "from",
  [anon_sym___future__] = "__future__",
  [anon_sym_LPAREN] = "(",
  [anon_sym_RPAREN] = ")",
  [anon_sym_COMMA] = ",",
  [anon_sym_as] = "as",
  [anon_sym_STAR] = "*",
  [anon_sym_print] = "print",
  [anon_sym_GT_GT] = ">>",
  [anon_sym_assert] = "assert",
  [anon_sym_COLON_EQ] = ":=",
  [anon_sym_return] = "return",
  [anon_sym_del] = "del",
  [anon_sym_raise] = "raise",
  [anon_sym_pass] = "pass",
  [anon_sym_break] = "break",
  [anon_sym_continue] = "continue",
  [anon_sym_if] = "if",
  [anon_sym_COLON] = ":",
  [anon_sym_elif] = "elif",
  [anon_sym_else] = "else",
  [anon_sym_async] = "async",
  [anon_sym_for] = "for",
  [anon_sym_in] = "in",
  [anon_sym_while] = "while",
  [anon_sym_try] = "try",
  [anon_sym_except] = "except",
  [anon_sym_finally] = "finally",
  [anon_sym_with] = "with",
  [anon_sym_def] = "def",
  [anon_sym_DASH_GT] = "->",
  [anon_sym_EQ] = "=",
  [anon_sym_STAR_STAR] = "**",
  [anon_sym_global] = "global",
  [anon_sym_nonlocal] = "nonlocal",
  [anon_sym_exec] = "exec",
  [anon_sym_class] = "class",
  [anon_sym_AT] = "@",
  [anon_sym_not] = "not",
  [anon_sym_and] = "and",
  [anon_sym_or] = "or",
  [anon_sym_PLUS] = "+",
  [anon_sym_DASH] = "-",
  [anon_sym_SLASH] = "/",
  [anon_sym_PERCENT] = "%",
  [anon_sym_SLASH_SLASH] = "//",
  [anon_sym_PIPE] = "|",
  [anon_sym_AMP] = "&",
  [anon_sym_CARET] = "^",
  [anon_sym_LT_LT] = "<<",
  [anon_sym_TILDE] = "~",
  [anon_sym_LT] = "<",
  [anon_sym_LT_EQ] = "<=",
  [anon_sym_EQ_EQ] = "==",
  [anon_sym_BANG_EQ] = "!=",
  [anon_sym_GT_EQ] = ">=",
  [anon_sym_GT] = ">",
  [anon_sym_LT_GT] = "<>",
  [anon_sym_is] = "is",
  [anon_sym_lambda] = "lambda",
  [anon_sym_PLUS_EQ] = "+=",
  [anon_sym_DASH_EQ] = "-=",
  [anon_sym_STAR_EQ] = "*=",
  [anon_sym_SLASH_EQ] = "/=",
  [anon_sym_AT_EQ] = "@=",
  [anon_sym_SLASH_SLASH_EQ] = "//=",
  [anon_sym_PERCENT_EQ] = "%=",
  [anon_sym_STAR_STAR_EQ] = "**=",
  [anon_sym_GT_GT_EQ] = ">>=",
  [anon_sym_LT_LT_EQ] = "<<=",
  [anon_sym_AMP_EQ] = "&=",
  [anon_sym_CARET_EQ] = "^=",
  [anon_sym_PIPE_EQ] = "|=",
  [anon_sym_yield] = "yield",
  [anon_sym_LBRACK] = "[",
  [anon_sym_RBRACK] = "]",
  [sym_ellipsis] = "ellipsis",
  [anon_sym_LBRACE] = "{",
  [anon_sym_RBRACE] = "}",
  [sym_escape_sequence] = "escape_sequence",
  [sym__not_escape_sequence] = "_not_escape_sequence",
  [aux_sym_format_specifier_token1] = "format_specifier_token1",
  [sym_type_conversion] = "type_conversion",
  [sym_integer] = "integer",
  [sym_float] = "float",
  [sym_true] = "true",
  [sym_false] = "false",
  [sym_none] = "none",
  [anon_sym_await] = "await",
  [sym_comment] = "comment",
  [sym__semicolon] = "_semicolon",
  [sym__newline] = "_newline",
  [sym__indent] = "_indent",
  [sym__dedent] = "_dedent",
  [sym__string_start] = "\"",
  [sym__string_content] = "_string_content",
  [sym__string_end] = "\"",
  [sym_module] = "module",
  [sym__statement] = "_statement",
  [sym__simple_statements] = "_simple_statements",
  [sym_import_statement] = "import_statement",
  [sym_import_prefix] = "import_prefix",
  [sym_relative_import] = "relative_import",
  [sym_future_import_statement] = "future_import_statement",
  [sym_import_from_statement] = "import_from_statement",
  [sym__import_list] = "_import_list",
  [sym_aliased_import] = "aliased_import",
  [sym_wildcard_import] = "wildcard_import",
  [sym_print_statement] = "print_statement",
  [sym_chevron] = "chevron",
  [sym_assert_statement] = "assert_statement",
  [sym_expression_statement] = "expression_statement",
  [sym_named_expression] = "named_expression",
  [sym_return_statement] = "return_statement",
  [sym_delete_statement] = "delete_statement",
  [sym_raise_statement] = "raise_statement",
  [sym_pass_statement] = "pass_statement",
  [sym_break_statement] = "break_statement",
  [sym_continue_statement] = "continue_statement",
  [sym_if_statement] = "if_statement",
  [sym_elif_clause] = "elif_clause",
  [sym_else_clause] = "else_clause",
  [sym_for_statement] = "for_statement",
  [sym_while_statement] = "while_statement",
  [sym_try_statement] = "try_statement",
  [sym_except_clause] = "except_clause",
  [sym_finally_clause] = "finally_clause",
  [sym_with_statement] = "with_statement",
  [sym_with_item] = "with_item",
  [sym_function_definition] = "function_definition",
  [sym_parameters] = "parameters",
  [sym_lambda_parameters] = "lambda_parameters",
  [sym__parameters] = "_parameters",
  [sym_default_parameter] = "default_parameter",
  [sym_typed_default_parameter] = "typed_default_parameter",
  [sym_list_splat] = "list_splat",
  [sym_dictionary_splat] = "dictionary_splat",
  [sym_global_statement] = "global_statement",
  [sym_nonlocal_statement] = "nonlocal_statement",
  [sym_exec_statement] = "exec_statement",
  [sym_class_definition] = "class_definition",
  [sym_parenthesized_list_splat] = "parenthesized_expression",
  [sym_argument_list] = "argument_list",
  [sym_decorated_definition] = "decorated_definition",
  [sym_decorator] = "decorator",
  [sym_block] = "block",
  [sym_variables] = "variables",
  [sym_expression_list] = "expression_list",
  [sym_dotted_name] = "dotted_name",
  [sym__expression_within_for_in_clause] = "_expression_within_for_in_clause",
  [sym__expression] = "_expression",
  [sym__primary_expression] = "_primary_expression",
  [sym_not_operator] = "not_operator",
  [sym_boolean_operator] = "boolean_operator",
  [sym_binary_operator] = "binary_operator",
  [sym_unary_operator] = "unary_operator",
  [sym_comparison_operator] = "comparison_operator",
  [sym_lambda] = "lambda",
  [sym_lambda_within_for_in_clause] = "lambda",
  [sym_assignment] = "assignment",
  [sym_augmented_assignment] = "augmented_assignment",
  [sym__right_hand_side] = "_right_hand_side",
  [sym_yield] = "yield",
  [sym_attribute] = "attribute",
  [sym_subscript] = "subscript",
  [sym_slice] = "slice",
  [sym_call] = "call",
  [sym_typed_parameter] = "typed_parameter",
  [sym_type] = "type",
  [sym_keyword_argument] = "keyword_argument",
  [sym_list] = "list",
  [sym__comprehension_clauses] = "_comprehension_clauses",
  [sym_list_comprehension] = "list_comprehension",
  [sym_dictionary] = "dictionary",
  [sym_dictionary_comprehension] = "dictionary_comprehension",
  [sym_pair] = "pair",
  [sym_set] = "set",
  [sym_set_comprehension] = "set_comprehension",
  [sym_parenthesized_expression] = "parenthesized_expression",
  [sym_tuple] = "tuple",
  [sym_generator_expression] = "generator_expression",
  [sym_for_in_clause] = "for_in_clause",
  [sym_if_clause] = "if_clause",
  [sym_conditional_expression] = "conditional_expression",
  [sym_concatenated_string] = "concatenated_string",
  [sym_string] = "string",
  [sym_interpolation] = "interpolation",
  [sym_format_specifier] = "format_specifier",
  [sym_format_expression] = "format_expression",
  [sym_await] = "await",
  [aux_sym_module_repeat1] = "module_repeat1",
  [aux_sym__simple_statements_repeat1] = "_simple_statements_repeat1",
  [aux_sym_import_prefix_repeat1] = "import_prefix_repeat1",
  [aux_sym__import_list_repeat1] = "_import_list_repeat1",
  [aux_sym_print_statement_repeat1] = "print_statement_repeat1",
  [aux_sym_assert_statement_repeat1] = "assert_statement_repeat1",
  [aux_sym_if_statement_repeat1] = "if_statement_repeat1",
  [aux_sym_try_statement_repeat1] = "try_statement_repeat1",
  [aux_sym_with_statement_repeat1] = "with_statement_repeat1",
  [aux_sym__parameters_repeat1] = "_parameters_repeat1",
  [aux_sym_global_statement_repeat1] = "global_statement_repeat1",
  [aux_sym_argument_list_repeat1] = "argument_list_repeat1",
  [aux_sym_decorated_definition_repeat1] = "decorated_definition_repeat1",
  [aux_sym_variables_repeat1] = "variables_repeat1",
  [aux_sym_dotted_name_repeat1] = "dotted_name_repeat1",
  [aux_sym_comparison_operator_repeat1] = "comparison_operator_repeat1",
  [aux_sym_subscript_repeat1] = "subscript_repeat1",
  [aux_sym_list_repeat1] = "list_repeat1",
  [aux_sym__comprehension_clauses_repeat1] = "_comprehension_clauses_repeat1",
  [aux_sym_dictionary_repeat1] = "dictionary_repeat1",
  [aux_sym_tuple_repeat1] = "tuple_repeat1",
  [aux_sym_for_in_clause_repeat1] = "for_in_clause_repeat1",
  [aux_sym_concatenated_string_repeat1] = "concatenated_string_repeat1",
  [aux_sym_string_repeat1] = "string_repeat1",
  [aux_sym_format_specifier_repeat1] = "format_specifier_repeat1",
};

static const TSSymbolMetadata ts_symbol_metadata[] = {
  [ts_builtin_sym_end] = {
    .visible = false,
    .named = true,
  },
  [sym_identifier] = {
    .visible = true,
    .named = true,
  },
  [anon_sym_import] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DOT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_from] = {
    .visible = true,
    .named = false,
  },
  [anon_sym___future__] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LPAREN] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_RPAREN] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_COMMA] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_as] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_STAR] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_print] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_GT_GT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_assert] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_COLON_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_return] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_del] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_raise] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_pass] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_break] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_continue] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_if] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_COLON] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_elif] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_else] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_async] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_for] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_in] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_while] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_try] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_except] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_finally] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_with] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_def] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DASH_GT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_STAR_STAR] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_global] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_nonlocal] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_exec] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_class] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_AT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_not] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_and] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_or] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_PLUS] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DASH] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_SLASH] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_PERCENT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_SLASH_SLASH] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_PIPE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_AMP] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_CARET] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LT_LT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_TILDE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LT_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_EQ_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_BANG_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_GT_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_GT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LT_GT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_is] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_lambda] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_PLUS_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DASH_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_STAR_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_SLASH_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_AT_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_SLASH_SLASH_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_PERCENT_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_STAR_STAR_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_GT_GT_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LT_LT_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_AMP_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_CARET_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_PIPE_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_yield] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LBRACK] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_RBRACK] = {
    .visible = true,
    .named = false,
  },
  [sym_ellipsis] = {
    .visible = true,
    .named = true,
  },
  [anon_sym_LBRACE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_RBRACE] = {
    .visible = true,
    .named = false,
  },
  [sym_escape_sequence] = {
    .visible = true,
    .named = true,
  },
  [sym__not_escape_sequence] = {
    .visible = false,
    .named = true,
  },
  [aux_sym_format_specifier_token1] = {
    .visible = false,
    .named = false,
  },
  [sym_type_conversion] = {
    .visible = true,
    .named = true,
  },
  [sym_integer] = {
    .visible = true,
    .named = true,
  },
  [sym_float] = {
    .visible = true,
    .named = true,
  },
  [sym_true] = {
    .visible = true,
    .named = true,
  },
  [sym_false] = {
    .visible = true,
    .named = true,
  },
  [sym_none] = {
    .visible = true,
    .named = true,
  },
  [anon_sym_await] = {
    .visible = true,
    .named = false,
  },
  [sym_comment] = {
    .visible = true,
    .named = true,
  },
  [sym__semicolon] = {
    .visible = false,
    .named = true,
  },
  [sym__newline] = {
    .visible = false,
    .named = true,
  },
  [sym__indent] = {
    .visible = false,
    .named = true,
  },
  [sym__dedent] = {
    .visible = false,
    .named = true,
  },
  [sym__string_start] = {
    .visible = true,
    .named = false,
  },
  [sym__string_content] = {
    .visible = false,
    .named = true,
  },
  [sym__string_end] = {
    .visible = true,
    .named = false,
  },
  [sym_module] = {
    .visible = true,
    .named = true,
  },
  [sym__statement] = {
    .visible = false,
    .named = true,
  },
  [sym__simple_statements] = {
    .visible = false,
    .named = true,
  },
  [sym_import_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_import_prefix] = {
    .visible = true,
    .named = true,
  },
  [sym_relative_import] = {
    .visible = true,
    .named = true,
  },
  [sym_future_import_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_import_from_statement] = {
    .visible = true,
    .named = true,
  },
  [sym__import_list] = {
    .visible = false,
    .named = true,
  },
  [sym_aliased_import] = {
    .visible = true,
    .named = true,
  },
  [sym_wildcard_import] = {
    .visible = true,
    .named = true,
  },
  [sym_print_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_chevron] = {
    .visible = true,
    .named = true,
  },
  [sym_assert_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_expression_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_named_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_return_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_delete_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_raise_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_pass_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_break_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_continue_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_if_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_elif_clause] = {
    .visible = true,
    .named = true,
  },
  [sym_else_clause] = {
    .visible = true,
    .named = true,
  },
  [sym_for_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_while_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_try_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_except_clause] = {
    .visible = true,
    .named = true,
  },
  [sym_finally_clause] = {
    .visible = true,
    .named = true,
  },
  [sym_with_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_with_item] = {
    .visible = true,
    .named = true,
  },
  [sym_function_definition] = {
    .visible = true,
    .named = true,
  },
  [sym_parameters] = {
    .visible = true,
    .named = true,
  },
  [sym_lambda_parameters] = {
    .visible = true,
    .named = true,
  },
  [sym__parameters] = {
    .visible = false,
    .named = true,
  },
  [sym_default_parameter] = {
    .visible = true,
    .named = true,
  },
  [sym_typed_default_parameter] = {
    .visible = true,
    .named = true,
  },
  [sym_list_splat] = {
    .visible = true,
    .named = true,
  },
  [sym_dictionary_splat] = {
    .visible = true,
    .named = true,
  },
  [sym_global_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_nonlocal_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_exec_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_class_definition] = {
    .visible = true,
    .named = true,
  },
  [sym_parenthesized_list_splat] = {
    .visible = true,
    .named = true,
  },
  [sym_argument_list] = {
    .visible = true,
    .named = true,
  },
  [sym_decorated_definition] = {
    .visible = true,
    .named = true,
  },
  [sym_decorator] = {
    .visible = true,
    .named = true,
  },
  [sym_block] = {
    .visible = true,
    .named = true,
  },
  [sym_variables] = {
    .visible = true,
    .named = true,
  },
  [sym_expression_list] = {
    .visible = true,
    .named = true,
  },
  [sym_dotted_name] = {
    .visible = true,
    .named = true,
  },
  [sym__expression_within_for_in_clause] = {
    .visible = false,
    .named = true,
  },
  [sym__expression] = {
    .visible = false,
    .named = true,
  },
  [sym__primary_expression] = {
    .visible = false,
    .named = true,
  },
  [sym_not_operator] = {
    .visible = true,
    .named = true,
  },
  [sym_boolean_operator] = {
    .visible = true,
    .named = true,
  },
  [sym_binary_operator] = {
    .visible = true,
    .named = true,
  },
  [sym_unary_operator] = {
    .visible = true,
    .named = true,
  },
  [sym_comparison_operator] = {
    .visible = true,
    .named = true,
  },
  [sym_lambda] = {
    .visible = true,
    .named = true,
  },
  [sym_lambda_within_for_in_clause] = {
    .visible = true,
    .named = true,
  },
  [sym_assignment] = {
    .visible = true,
    .named = true,
  },
  [sym_augmented_assignment] = {
    .visible = true,
    .named = true,
  },
  [sym__right_hand_side] = {
    .visible = false,
    .named = true,
  },
  [sym_yield] = {
    .visible = true,
    .named = true,
  },
  [sym_attribute] = {
    .visible = true,
    .named = true,
  },
  [sym_subscript] = {
    .visible = true,
    .named = true,
  },
  [sym_slice] = {
    .visible = true,
    .named = true,
  },
  [sym_call] = {
    .visible = true,
    .named = true,
  },
  [sym_typed_parameter] = {
    .visible = true,
    .named = true,
  },
  [sym_type] = {
    .visible = true,
    .named = true,
  },
  [sym_keyword_argument] = {
    .visible = true,
    .named = true,
  },
  [sym_list] = {
    .visible = true,
    .named = true,
  },
  [sym__comprehension_clauses] = {
    .visible = false,
    .named = true,
  },
  [sym_list_comprehension] = {
    .visible = true,
    .named = true,
  },
  [sym_dictionary] = {
    .visible = true,
    .named = true,
  },
  [sym_dictionary_comprehension] = {
    .visible = true,
    .named = true,
  },
  [sym_pair] = {
    .visible = true,
    .named = true,
  },
  [sym_set] = {
    .visible = true,
    .named = true,
  },
  [sym_set_comprehension] = {
    .visible = true,
    .named = true,
  },
  [sym_parenthesized_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_tuple] = {
    .visible = true,
    .named = true,
  },
  [sym_generator_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_for_in_clause] = {
    .visible = true,
    .named = true,
  },
  [sym_if_clause] = {
    .visible = true,
    .named = true,
  },
  [sym_conditional_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_concatenated_string] = {
    .visible = true,
    .named = true,
  },
  [sym_string] = {
    .visible = true,
    .named = true,
  },
  [sym_interpolation] = {
    .visible = true,
    .named = true,
  },
  [sym_format_specifier] = {
    .visible = true,
    .named = true,
  },
  [sym_format_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_await] = {
    .visible = true,
    .named = true,
  },
  [aux_sym_module_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym__simple_statements_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_import_prefix_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym__import_list_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_print_statement_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_assert_statement_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_if_statement_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_try_statement_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_with_statement_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym__parameters_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_global_statement_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_argument_list_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_decorated_definition_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_variables_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_dotted_name_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_comparison_operator_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_subscript_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_list_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym__comprehension_clauses_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_dictionary_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_tuple_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_for_in_clause_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_concatenated_string_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_string_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_format_specifier_repeat1] = {
    .visible = false,
    .named = false,
  },
};

enum {
  field_alias = 1,
  field_alternative = 2,
  field_argument = 3,
  field_arguments = 4,
  field_attribute = 5,
  field_body = 6,
  field_cause = 7,
  field_code = 8,
  field_condition = 9,
  field_consequence = 10,
  field_definition = 11,
  field_function = 12,
  field_key = 13,
  field_left = 14,
  field_module_name = 15,
  field_name = 16,
  field_object = 17,
  field_operator = 18,
  field_parameters = 19,
  field_return_type = 20,
  field_right = 21,
  field_subscript = 22,
  field_superclasses = 23,
  field_type = 24,
  field_value = 25,
};

static const char *ts_field_names[] = {
  [0] = NULL,
  [field_alias] = "alias",
  [field_alternative] = "alternative",
  [field_argument] = "argument",
  [field_arguments] = "arguments",
  [field_attribute] = "attribute",
  [field_body] = "body",
  [field_cause] = "cause",
  [field_code] = "code",
  [field_condition] = "condition",
  [field_consequence] = "consequence",
  [field_definition] = "definition",
  [field_function] = "function",
  [field_key] = "key",
  [field_left] = "left",
  [field_module_name] = "module_name",
  [field_name] = "name",
  [field_object] = "object",
  [field_operator] = "operator",
  [field_parameters] = "parameters",
  [field_return_type] = "return_type",
  [field_right] = "right",
  [field_subscript] = "subscript",
  [field_superclasses] = "superclasses",
  [field_type] = "type",
  [field_value] = "value",
};

static const TSFieldMapSlice ts_field_map_slices[] = {
  [2] = {.index = 0, .length = 1},
  [3] = {.index = 1, .length = 1},
  [4] = {.index = 2, .length = 1},
  [5] = {.index = 3, .length = 1},
  [6] = {.index = 4, .length = 1},
  [7] = {.index = 5, .length = 2},
  [9] = {.index = 7, .length = 2},
  [10] = {.index = 9, .length = 1},
  [11] = {.index = 10, .length = 2},
  [12] = {.index = 12, .length = 1},
  [13] = {.index = 13, .length = 2},
  [14] = {.index = 15, .length = 1},
  [15] = {.index = 16, .length = 1},
  [16] = {.index = 17, .length = 2},
  [17] = {.index = 19, .length = 2},
  [18] = {.index = 21, .length = 2},
  [19] = {.index = 23, .length = 3},
  [20] = {.index = 26, .length = 2},
  [21] = {.index = 28, .length = 1},
  [22] = {.index = 29, .length = 2},
  [23] = {.index = 31, .length = 2},
  [24] = {.index = 33, .length = 1},
  [25] = {.index = 34, .length = 2},
  [26] = {.index = 36, .length = 1},
  [27] = {.index = 37, .length = 2},
  [28] = {.index = 39, .length = 1},
  [29] = {.index = 40, .length = 2},
  [30] = {.index = 42, .length = 2},
  [31] = {.index = 16, .length = 1},
  [32] = {.index = 44, .length = 1},
  [33] = {.index = 45, .length = 2},
  [34] = {.index = 47, .length = 2},
  [35] = {.index = 49, .length = 1},
  [38] = {.index = 17, .length = 2},
  [39] = {.index = 50, .length = 1},
  [40] = {.index = 51, .length = 2},
  [41] = {.index = 53, .length = 2},
  [42] = {.index = 55, .length = 2},
  [43] = {.index = 57, .length = 3},
  [44] = {.index = 60, .length = 1},
  [45] = {.index = 61, .length = 3},
  [46] = {.index = 64, .length = 3},
  [47] = {.index = 67, .length = 1},
  [48] = {.index = 68, .length = 3},
  [49] = {.index = 71, .length = 3},
  [50] = {.index = 74, .length = 2},
  [51] = {.index = 76, .length = 2},
  [52] = {.index = 78, .length = 3},
  [53] = {.index = 81, .length = 3},
  [54] = {.index = 84, .length = 3},
  [55] = {.index = 87, .length = 3},
  [56] = {.index = 90, .length = 3},
  [57] = {.index = 93, .length = 1},
  [58] = {.index = 94, .length = 2},
  [59] = {.index = 96, .length = 2},
  [60] = {.index = 98, .length = 4},
  [61] = {.index = 102, .length = 4},
  [62] = {.index = 106, .length = 4},
  [63] = {.index = 110, .length = 2},
  [64] = {.index = 112, .length = 2},
  [65] = {.index = 114, .length = 1},
  [66] = {.index = 115, .length = 3},
  [67] = {.index = 118, .length = 3},
  [68] = {.index = 121, .length = 4},
  [70] = {.index = 125, .length = 4},
  [71] = {.index = 129, .length = 4},
  [72] = {.index = 133, .length = 3},
  [73] = {.index = 133, .length = 3},
  [74] = {.index = 136, .length = 2},
  [75] = {.index = 138, .length = 3},
  [76] = {.index = 141, .length = 5},
  [77] = {.index = 146, .length = 3},
  [78] = {.index = 149, .length = 2},
  [79] = {.index = 151, .length = 4},
  [80] = {.index = 155, .length = 4},
  [81] = {.index = 159, .length = 4},
  [83] = {.index = 163, .length = 4},
  [84] = {.index = 167, .length = 3},
  [85] = {.index = 170, .length = 4},
  [86] = {.index = 174, .length = 4},
  [87] = {.index = 178, .length = 4},
  [88] = {.index = 182, .length = 5},
  [89] = {.index = 187, .length = 5},
  [90] = {.index = 192, .length = 5},
  [91] = {.index = 197, .length = 5},
};

static const TSFieldMapEntry ts_field_map_entries[] = {
  [0] =
    {field_name, 1, .inherited = true},
  [1] =
    {field_name, 0},
  [2] =
    {field_argument, 1},
  [3] =
    {field_value, 0},
  [4] =
    {field_code, 1},
  [5] =
    {field_argument, 1},
    {field_operator, 0},
  [7] =
    {field_arguments, 1},
    {field_function, 0},
  [9] =
    {field_definition, 1},
  [10] =
    {field_name, 0},
    {field_name, 1, .inherited = true},
  [12] =
    {field_argument, 2, .inherited = true},
  [13] =
    {field_argument, 1},
    {field_argument, 2, .inherited = true},
  [15] =
    {field_cause, 2},
  [16] =
    {field_body, 2},
  [17] =
    {field_name, 0},
    {field_value, 2},
  [19] =
    {field_left, 0},
    {field_type, 2},
  [21] =
    {field_left, 0},
    {field_right, 2},
  [23] =
    {field_left, 0},
    {field_operator, 1},
    {field_right, 2},
  [26] =
    {field_attribute, 2},
    {field_object, 0},
  [28] =
    {field_name, 1},
  [29] =
    {field_name, 0, .inherited = true},
    {field_name, 1, .inherited = true},
  [31] =
    {field_alias, 2},
    {field_name, 0},
  [33] =
    {field_name, 3, .inherited = true},
  [34] =
    {field_module_name, 1},
    {field_name, 3, .inherited = true},
  [36] =
    {field_body, 1},
  [37] =
    {field_argument, 0, .inherited = true},
    {field_argument, 1, .inherited = true},
  [39] =
    {field_cause, 3},
  [40] =
    {field_condition, 1},
    {field_consequence, 3},
  [42] =
    {field_body, 3},
    {field_condition, 1},
  [44] =
    {field_body, 3},
  [45] =
    {field_alias, 2},
    {field_value, 0},
  [47] =
    {field_body, 3},
    {field_name, 1},
  [49] =
    {field_arguments, 2},
  [50] =
    {field_type, 2},
  [51] =
    {field_body, 3},
    {field_parameters, 1},
  [53] =
    {field_key, 0},
    {field_value, 2},
  [55] =
    {field_subscript, 2},
    {field_value, 0},
  [57] =
    {field_condition, 1},
    {field_consequence, 3},
    {field_consequence, 4},
  [60] =
    {field_alternative, 0},
  [61] =
    {field_alternative, 4},
    {field_condition, 1},
    {field_consequence, 3},
  [64] =
    {field_alternative, 4, .inherited = true},
    {field_condition, 1},
    {field_consequence, 3},
  [67] =
    {field_body, 4},
  [68] =
    {field_body, 3},
    {field_body, 4},
    {field_condition, 1},
  [71] =
    {field_alternative, 4},
    {field_body, 3},
    {field_condition, 1},
  [74] =
    {field_body, 2},
    {field_body, 3},
  [76] =
    {field_body, 3},
    {field_body, 4},
  [78] =
    {field_body, 4},
    {field_name, 1},
    {field_parameters, 2},
  [81] =
    {field_body, 3},
    {field_body, 4},
    {field_name, 1},
  [84] =
    {field_body, 4},
    {field_name, 1},
    {field_superclasses, 2},
  [87] =
    {field_left, 0},
    {field_right, 4},
    {field_type, 2},
  [90] =
    {field_subscript, 2},
    {field_subscript, 3},
    {field_value, 0},
  [93] =
    {field_name, 4, .inherited = true},
  [94] =
    {field_module_name, 1},
    {field_name, 4, .inherited = true},
  [96] =
    {field_left, 1},
    {field_right, 3},
  [98] =
    {field_alternative, 5},
    {field_condition, 1},
    {field_consequence, 3},
    {field_consequence, 4},
  [102] =
    {field_alternative, 5, .inherited = true},
    {field_condition, 1},
    {field_consequence, 3},
    {field_consequence, 4},
  [106] =
    {field_alternative, 4, .inherited = true},
    {field_alternative, 5},
    {field_condition, 1},
    {field_consequence, 3},
  [110] =
    {field_alternative, 0, .inherited = true},
    {field_alternative, 1, .inherited = true},
  [112] =
    {field_body, 4},
    {field_body, 5},
  [114] =
    {field_body, 5},
  [115] =
    {field_body, 5},
    {field_name, 2},
    {field_parameters, 3},
  [118] =
    {field_body, 5},
    {field_left, 1},
    {field_right, 3},
  [121] =
    {field_alternative, 5},
    {field_body, 3},
    {field_body, 4},
    {field_condition, 1},
  [125] =
    {field_body, 4},
    {field_body, 5},
    {field_name, 1},
    {field_parameters, 2},
  [129] =
    {field_body, 4},
    {field_body, 5},
    {field_name, 1},
    {field_superclasses, 2},
  [133] =
    {field_name, 0},
    {field_type, 2},
    {field_value, 4},
  [136] =
    {field_left, 2},
    {field_right, 4},
  [138] =
    {field_left, 1},
    {field_right, 3},
    {field_right, 4},
  [141] =
    {field_alternative, 5, .inherited = true},
    {field_alternative, 6},
    {field_condition, 1},
    {field_consequence, 3},
    {field_consequence, 4},
  [146] =
    {field_body, 6},
    {field_left, 2},
    {field_right, 4},
  [149] =
    {field_body, 5},
    {field_body, 6},
  [151] =
    {field_body, 5},
    {field_body, 6},
    {field_name, 2},
    {field_parameters, 3},
  [155] =
    {field_body, 5},
    {field_body, 6},
    {field_left, 1},
    {field_right, 3},
  [159] =
    {field_alternative, 6},
    {field_body, 5},
    {field_left, 1},
    {field_right, 3},
  [163] =
    {field_body, 6},
    {field_name, 1},
    {field_parameters, 2},
    {field_return_type, 4},
  [167] =
    {field_left, 2},
    {field_right, 4},
    {field_right, 5},
  [170] =
    {field_body, 6},
    {field_body, 7},
    {field_left, 2},
    {field_right, 4},
  [174] =
    {field_alternative, 7},
    {field_body, 6},
    {field_left, 2},
    {field_right, 4},
  [178] =
    {field_body, 7},
    {field_name, 2},
    {field_parameters, 3},
    {field_return_type, 5},
  [182] =
    {field_alternative, 7},
    {field_body, 5},
    {field_body, 6},
    {field_left, 1},
    {field_right, 3},
  [187] =
    {field_body, 6},
    {field_body, 7},
    {field_name, 1},
    {field_parameters, 2},
    {field_return_type, 4},
  [192] =
    {field_alternative, 8},
    {field_body, 6},
    {field_body, 7},
    {field_left, 2},
    {field_right, 4},
  [197] =
    {field_body, 7},
    {field_body, 8},
    {field_name, 2},
    {field_parameters, 3},
    {field_return_type, 5},
};

static TSSymbol ts_alias_sequences[93][MAX_ALIAS_SEQUENCE_LENGTH] = {
  [0] = {0},
  [1] = {
    [0] = sym_identifier,
  },
  [8] = {
    [0] = sym_list_splat,
  },
  [29] = {
    [3] = sym_block,
  },
  [30] = {
    [3] = sym_block,
  },
  [31] = {
    [2] = sym_block,
  },
  [32] = {
    [3] = sym_block,
  },
  [34] = {
    [3] = sym_block,
  },
  [36] = {
    [1] = sym_list_splat,
  },
  [37] = {
    [1] = sym_identifier,
  },
  [38] = {
    [0] = sym_identifier,
  },
  [45] = {
    [3] = sym_block,
  },
  [46] = {
    [3] = sym_block,
  },
  [47] = {
    [4] = sym_block,
  },
  [49] = {
    [3] = sym_block,
  },
  [52] = {
    [4] = sym_block,
  },
  [54] = {
    [4] = sym_block,
  },
  [62] = {
    [3] = sym_block,
  },
  [65] = {
    [5] = sym_block,
  },
  [66] = {
    [5] = sym_block,
  },
  [67] = {
    [5] = sym_block,
  },
  [69] = {
    [2] = sym_block,
  },
  [72] = {
    [0] = sym_identifier,
  },
  [77] = {
    [6] = sym_block,
  },
  [81] = {
    [5] = sym_block,
  },
  [82] = {
    [3] = sym_block,
  },
  [83] = {
    [6] = sym_block,
  },
  [86] = {
    [6] = sym_block,
  },
  [87] = {
    [7] = sym_block,
  },
  [92] = {
    [5] = sym_block,
  },
};

static bool ts_lex(TSLexer *lexer, TSStateId state) {
  START_LEXER();
  eof = lookahead == 0;
  switch (state) {
    case 0:
      if (eof) ADVANCE(39);
      if (lookahead == '!') ADVANCE(14);
      if (lookahead == '#') ADVANCE(111);
      if (lookahead == '%') ADVANCE(58);
      if (lookahead == '&') ADVANCE(61);
      if (lookahead == '(') ADVANCE(42);
      if (lookahead == ')') ADVANCE(43);
      if (lookahead == '*') ADVANCE(45);
      if (lookahead == '+') ADVANCE(54);
      if (lookahead == ',') ADVANCE(44);
      if (lookahead == '-') ADVANCE(56);
      if (lookahead == '.') ADVANCE(41);
      if (lookahead == '/') ADVANCE(57);
      if (lookahead == '0') ADVANCE(100);
      if (lookahead == ':') ADVANCE(49);
      if (lookahead == ';') ADVANCE(112);
      if (lookahead == '<') ADVANCE(65);
      if (lookahead == '=') ADVANCE(51);
      if (lookahead == '>') ADVANCE(70);
      if (lookahead == '@') ADVANCE(53);
      if (lookahead == '[') ADVANCE(85);
      if (lookahead == '\\') SKIP(35)
      if (lookahead == ']') ADVANCE(86);
      if (lookahead == '^') ADVANCE(62);
      if (lookahead == '{') ADVANCE(88);
      if (lookahead == '|') ADVANCE(60);
      if (lookahead == '}') ADVANCE(89);
      if (lookahead == '~') ADVANCE(64);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\f' ||
          lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == 8203 ||
          lookahead == 8288 ||
          lookahead == 65279) SKIP(0)
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(99);
      if (('A' <= lookahead && lookahead <= '_') ||
          ('a' <= lookahead && lookahead <= 'z') ||
          (913 <= lookahead && lookahead <= 937) ||
          (945 <= lookahead && lookahead <= 969)) ADVANCE(110);
      END_STATE();
    case 1:
      if (lookahead == '\n') SKIP(10)
      END_STATE();
    case 2:
      if (lookahead == '\n') SKIP(10)
      if (lookahead == '\r') SKIP(1)
      END_STATE();
    case 3:
      if (lookahead == '\n') ADVANCE(91);
      END_STATE();
    case 4:
      if (lookahead == '\n') SKIP(4)
      if (lookahead == '#') ADVANCE(95);
      if (lookahead == '\\') ADVANCE(93);
      if (lookahead == '{') ADVANCE(88);
      if (lookahead == '}') ADVANCE(89);
      if (lookahead == '\t' ||
          lookahead == '\f' ||
          lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == 8203 ||
          lookahead == 8288 ||
          lookahead == 65279) ADVANCE(94);
      if (lookahead != 0) ADVANCE(96);
      END_STATE();
    case 5:
      if (lookahead == '\n') SKIP(11)
      END_STATE();
    case 6:
      if (lookahead == '\n') SKIP(11)
      if (lookahead == '\r') SKIP(5)
      END_STATE();
    case 7:
      if (lookahead == '\n') SKIP(9)
      END_STATE();
    case 8:
      if (lookahead == '\n') SKIP(9)
      if (lookahead == '\r') SKIP(7)
      END_STATE();
    case 9:
      if (lookahead == '!') ADVANCE(14);
      if (lookahead == '#') ADVANCE(111);
      if (lookahead == '%') ADVANCE(58);
      if (lookahead == '&') ADVANCE(61);
      if (lookahead == '(') ADVANCE(42);
      if (lookahead == ')') ADVANCE(43);
      if (lookahead == '*') ADVANCE(45);
      if (lookahead == '+') ADVANCE(54);
      if (lookahead == ',') ADVANCE(44);
      if (lookahead == '-') ADVANCE(55);
      if (lookahead == '.') ADVANCE(40);
      if (lookahead == '/') ADVANCE(57);
      if (lookahead == ':') ADVANCE(49);
      if (lookahead == ';') ADVANCE(112);
      if (lookahead == '<') ADVANCE(65);
      if (lookahead == '=') ADVANCE(51);
      if (lookahead == '>') ADVANCE(70);
      if (lookahead == '@') ADVANCE(53);
      if (lookahead == '[') ADVANCE(85);
      if (lookahead == '\\') SKIP(8)
      if (lookahead == ']') ADVANCE(86);
      if (lookahead == '^') ADVANCE(62);
      if (lookahead == '|') ADVANCE(60);
      if (lookahead == '}') ADVANCE(89);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\f' ||
          lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == 8203 ||
          lookahead == 8288 ||
          lookahead == 65279) SKIP(9)
      if (('A' <= lookahead && lookahead <= '_') ||
          ('a' <= lookahead && lookahead <= 'z') ||
          (913 <= lookahead && lookahead <= 937) ||
          (945 <= lookahead && lookahead <= 969)) ADVANCE(110);
      END_STATE();
    case 10:
      if (lookahead == '!') ADVANCE(14);
      if (lookahead == '#') ADVANCE(111);
      if (lookahead == '%') ADVANCE(58);
      if (lookahead == '&') ADVANCE(61);
      if (lookahead == '(') ADVANCE(42);
      if (lookahead == ')') ADVANCE(43);
      if (lookahead == '*') ADVANCE(45);
      if (lookahead == '+') ADVANCE(54);
      if (lookahead == ',') ADVANCE(44);
      if (lookahead == '-') ADVANCE(55);
      if (lookahead == '.') ADVANCE(40);
      if (lookahead == '/') ADVANCE(57);
      if (lookahead == ':') ADVANCE(48);
      if (lookahead == ';') ADVANCE(112);
      if (lookahead == '<') ADVANCE(65);
      if (lookahead == '=') ADVANCE(51);
      if (lookahead == '>') ADVANCE(70);
      if (lookahead == '@') ADVANCE(53);
      if (lookahead == '[') ADVANCE(85);
      if (lookahead == '\\') SKIP(2)
      if (lookahead == ']') ADVANCE(86);
      if (lookahead == '^') ADVANCE(62);
      if (lookahead == '|') ADVANCE(60);
      if (lookahead == '}') ADVANCE(89);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\f' ||
          lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == 8203 ||
          lookahead == 8288 ||
          lookahead == 65279) SKIP(10)
      if (('A' <= lookahead && lookahead <= '_') ||
          ('a' <= lookahead && lookahead <= 'z') ||
          (913 <= lookahead && lookahead <= 937) ||
          (945 <= lookahead && lookahead <= 969)) ADVANCE(110);
      END_STATE();
    case 11:
      if (lookahead == '#') ADVANCE(111);
      if (lookahead == '-') ADVANCE(15);
      if (lookahead == ':') ADVANCE(48);
      if (lookahead == '\\') SKIP(6)
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\f' ||
          lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == 8203 ||
          lookahead == 8288 ||
          lookahead == 65279) SKIP(11)
      END_STATE();
    case 12:
      if (lookahead == '#') ADVANCE(111);
      if (lookahead == '\\') ADVANCE(92);
      if (lookahead == '{') ADVANCE(88);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\f' ||
          lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == 8203 ||
          lookahead == 8288 ||
          lookahead == 65279) SKIP(12)
      END_STATE();
    case 13:
      if (lookahead == '.') ADVANCE(87);
      END_STATE();
    case 14:
      if (lookahead == '=') ADVANCE(68);
      if (('a' <= lookahead && lookahead <= 'z')) ADVANCE(97);
      END_STATE();
    case 15:
      if (lookahead == '>') ADVANCE(50);
      END_STATE();
    case 16:
      if (lookahead == '_') ADVANCE(20);
      if (lookahead == '0' ||
          lookahead == '1') ADVANCE(102);
      END_STATE();
    case 17:
      if (lookahead == '_') ADVANCE(21);
      if (('0' <= lookahead && lookahead <= '7')) ADVANCE(103);
      END_STATE();
    case 18:
      if (lookahead == '_') ADVANCE(25);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(104);
      END_STATE();
    case 19:
      if (lookahead == '+' ||
          lookahead == '-') ADVANCE(22);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(107);
      END_STATE();
    case 20:
      if (lookahead == '0' ||
          lookahead == '1') ADVANCE(102);
      END_STATE();
    case 21:
      if (('0' <= lookahead && lookahead <= '7')) ADVANCE(103);
      END_STATE();
    case 22:
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(107);
      END_STATE();
    case 23:
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(90);
      END_STATE();
    case 24:
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(23);
      END_STATE();
    case 25:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(104);
      END_STATE();
    case 26:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(90);
      END_STATE();
    case 27:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(26);
      END_STATE();
    case 28:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(27);
      END_STATE();
    case 29:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(28);
      END_STATE();
    case 30:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(29);
      END_STATE();
    case 31:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(30);
      END_STATE();
    case 32:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(31);
      END_STATE();
    case 33:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(32);
      END_STATE();
    case 34:
      if (eof) ADVANCE(39);
      if (lookahead == '\n') SKIP(0)
      END_STATE();
    case 35:
      if (eof) ADVANCE(39);
      if (lookahead == '\n') SKIP(0)
      if (lookahead == '\r') SKIP(34)
      END_STATE();
    case 36:
      if (eof) ADVANCE(39);
      if (lookahead == '\n') SKIP(38)
      END_STATE();
    case 37:
      if (eof) ADVANCE(39);
      if (lookahead == '\n') SKIP(38)
      if (lookahead == '\r') SKIP(36)
      END_STATE();
    case 38:
      if (eof) ADVANCE(39);
      if (lookahead == '!') ADVANCE(14);
      if (lookahead == '#') ADVANCE(111);
      if (lookahead == '%') ADVANCE(58);
      if (lookahead == '&') ADVANCE(61);
      if (lookahead == '(') ADVANCE(42);
      if (lookahead == ')') ADVANCE(43);
      if (lookahead == '*') ADVANCE(45);
      if (lookahead == '+') ADVANCE(54);
      if (lookahead == ',') ADVANCE(44);
      if (lookahead == '-') ADVANCE(55);
      if (lookahead == '.') ADVANCE(41);
      if (lookahead == '/') ADVANCE(57);
      if (lookahead == '0') ADVANCE(100);
      if (lookahead == ':') ADVANCE(48);
      if (lookahead == ';') ADVANCE(112);
      if (lookahead == '<') ADVANCE(65);
      if (lookahead == '=') ADVANCE(51);
      if (lookahead == '>') ADVANCE(70);
      if (lookahead == '@') ADVANCE(53);
      if (lookahead == '[') ADVANCE(85);
      if (lookahead == '\\') SKIP(37)
      if (lookahead == ']') ADVANCE(86);
      if (lookahead == '^') ADVANCE(62);
      if (lookahead == '{') ADVANCE(88);
      if (lookahead == '|') ADVANCE(60);
      if (lookahead == '}') ADVANCE(89);
      if (lookahead == '~') ADVANCE(64);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\f' ||
          lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == 8203 ||
          lookahead == 8288 ||
          lookahead == 65279) SKIP(38)
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(99);
      if (('A' <= lookahead && lookahead <= '_') ||
          ('a' <= lookahead && lookahead <= 'z') ||
          (913 <= lookahead && lookahead <= 937) ||
          (945 <= lookahead && lookahead <= 969)) ADVANCE(110);
      END_STATE();
    case 39:
      ACCEPT_TOKEN(ts_builtin_sym_end);
      END_STATE();
    case 40:
      ACCEPT_TOKEN(anon_sym_DOT);
      END_STATE();
    case 41:
      ACCEPT_TOKEN(anon_sym_DOT);
      if (lookahead == '.') ADVANCE(13);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(106);
      END_STATE();
    case 42:
      ACCEPT_TOKEN(anon_sym_LPAREN);
      END_STATE();
    case 43:
      ACCEPT_TOKEN(anon_sym_RPAREN);
      END_STATE();
    case 44:
      ACCEPT_TOKEN(anon_sym_COMMA);
      END_STATE();
    case 45:
      ACCEPT_TOKEN(anon_sym_STAR);
      if (lookahead == '*') ADVANCE(52);
      if (lookahead == '=') ADVANCE(74);
      END_STATE();
    case 46:
      ACCEPT_TOKEN(anon_sym_GT_GT);
      if (lookahead == '=') ADVANCE(80);
      END_STATE();
    case 47:
      ACCEPT_TOKEN(anon_sym_COLON_EQ);
      END_STATE();
    case 48:
      ACCEPT_TOKEN(anon_sym_COLON);
      END_STATE();
    case 49:
      ACCEPT_TOKEN(anon_sym_COLON);
      if (lookahead == '=') ADVANCE(47);
      END_STATE();
    case 50:
      ACCEPT_TOKEN(anon_sym_DASH_GT);
      END_STATE();
    case 51:
      ACCEPT_TOKEN(anon_sym_EQ);
      if (lookahead == '=') ADVANCE(67);
      END_STATE();
    case 52:
      ACCEPT_TOKEN(anon_sym_STAR_STAR);
      if (lookahead == '=') ADVANCE(79);
      END_STATE();
    case 53:
      ACCEPT_TOKEN(anon_sym_AT);
      if (lookahead == '=') ADVANCE(76);
      END_STATE();
    case 54:
      ACCEPT_TOKEN(anon_sym_PLUS);
      if (lookahead == '=') ADVANCE(72);
      END_STATE();
    case 55:
      ACCEPT_TOKEN(anon_sym_DASH);
      if (lookahead == '=') ADVANCE(73);
      END_STATE();
    case 56:
      ACCEPT_TOKEN(anon_sym_DASH);
      if (lookahead == '=') ADVANCE(73);
      if (lookahead == '>') ADVANCE(50);
      END_STATE();
    case 57:
      ACCEPT_TOKEN(anon_sym_SLASH);
      if (lookahead == '/') ADVANCE(59);
      if (lookahead == '=') ADVANCE(75);
      END_STATE();
    case 58:
      ACCEPT_TOKEN(anon_sym_PERCENT);
      if (lookahead == '=') ADVANCE(78);
      END_STATE();
    case 59:
      ACCEPT_TOKEN(anon_sym_SLASH_SLASH);
      if (lookahead == '=') ADVANCE(77);
      END_STATE();
    case 60:
      ACCEPT_TOKEN(anon_sym_PIPE);
      if (lookahead == '=') ADVANCE(84);
      END_STATE();
    case 61:
      ACCEPT_TOKEN(anon_sym_AMP);
      if (lookahead == '=') ADVANCE(82);
      END_STATE();
    case 62:
      ACCEPT_TOKEN(anon_sym_CARET);
      if (lookahead == '=') ADVANCE(83);
      END_STATE();
    case 63:
      ACCEPT_TOKEN(anon_sym_LT_LT);
      if (lookahead == '=') ADVANCE(81);
      END_STATE();
    case 64:
      ACCEPT_TOKEN(anon_sym_TILDE);
      END_STATE();
    case 65:
      ACCEPT_TOKEN(anon_sym_LT);
      if (lookahead == '<') ADVANCE(63);
      if (lookahead == '=') ADVANCE(66);
      if (lookahead == '>') ADVANCE(71);
      END_STATE();
    case 66:
      ACCEPT_TOKEN(anon_sym_LT_EQ);
      END_STATE();
    case 67:
      ACCEPT_TOKEN(anon_sym_EQ_EQ);
      END_STATE();
    case 68:
      ACCEPT_TOKEN(anon_sym_BANG_EQ);
      END_STATE();
    case 69:
      ACCEPT_TOKEN(anon_sym_GT_EQ);
      END_STATE();
    case 70:
      ACCEPT_TOKEN(anon_sym_GT);
      if (lookahead == '=') ADVANCE(69);
      if (lookahead == '>') ADVANCE(46);
      END_STATE();
    case 71:
      ACCEPT_TOKEN(anon_sym_LT_GT);
      END_STATE();
    case 72:
      ACCEPT_TOKEN(anon_sym_PLUS_EQ);
      END_STATE();
    case 73:
      ACCEPT_TOKEN(anon_sym_DASH_EQ);
      END_STATE();
    case 74:
      ACCEPT_TOKEN(anon_sym_STAR_EQ);
      END_STATE();
    case 75:
      ACCEPT_TOKEN(anon_sym_SLASH_EQ);
      END_STATE();
    case 76:
      ACCEPT_TOKEN(anon_sym_AT_EQ);
      END_STATE();
    case 77:
      ACCEPT_TOKEN(anon_sym_SLASH_SLASH_EQ);
      END_STATE();
    case 78:
      ACCEPT_TOKEN(anon_sym_PERCENT_EQ);
      END_STATE();
    case 79:
      ACCEPT_TOKEN(anon_sym_STAR_STAR_EQ);
      END_STATE();
    case 80:
      ACCEPT_TOKEN(anon_sym_GT_GT_EQ);
      END_STATE();
    case 81:
      ACCEPT_TOKEN(anon_sym_LT_LT_EQ);
      END_STATE();
    case 82:
      ACCEPT_TOKEN(anon_sym_AMP_EQ);
      END_STATE();
    case 83:
      ACCEPT_TOKEN(anon_sym_CARET_EQ);
      END_STATE();
    case 84:
      ACCEPT_TOKEN(anon_sym_PIPE_EQ);
      END_STATE();
    case 85:
      ACCEPT_TOKEN(anon_sym_LBRACK);
      END_STATE();
    case 86:
      ACCEPT_TOKEN(anon_sym_RBRACK);
      END_STATE();
    case 87:
      ACCEPT_TOKEN(sym_ellipsis);
      END_STATE();
    case 88:
      ACCEPT_TOKEN(anon_sym_LBRACE);
      END_STATE();
    case 89:
      ACCEPT_TOKEN(anon_sym_RBRACE);
      END_STATE();
    case 90:
      ACCEPT_TOKEN(sym_escape_sequence);
      END_STATE();
    case 91:
      ACCEPT_TOKEN(sym_escape_sequence);
      if (lookahead == '\\') ADVANCE(92);
      END_STATE();
    case 92:
      ACCEPT_TOKEN(sym__not_escape_sequence);
      if (lookahead == '\n') ADVANCE(91);
      if (lookahead == '\r') ADVANCE(3);
      if (lookahead == 'U') ADVANCE(33);
      if (lookahead == 'u') ADVANCE(29);
      if (lookahead == 'x') ADVANCE(27);
      if (lookahead == '"' ||
          lookahead == '\'' ||
          lookahead == '\\' ||
          lookahead == 'a' ||
          lookahead == 'b' ||
          lookahead == 'f' ||
          lookahead == 'n' ||
          lookahead == 'r' ||
          ('t' <= lookahead && lookahead <= 'v')) ADVANCE(90);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(24);
      END_STATE();
    case 93:
      ACCEPT_TOKEN(aux_sym_format_specifier_token1);
      if (lookahead == '\r') ADVANCE(96);
      if (lookahead != 0 &&
          lookahead != '\n' &&
          lookahead != '{' &&
          lookahead != '}') ADVANCE(96);
      END_STATE();
    case 94:
      ACCEPT_TOKEN(aux_sym_format_specifier_token1);
      if (lookahead == '#') ADVANCE(95);
      if (lookahead == '\\') ADVANCE(93);
      if (lookahead == '\t' ||
          lookahead == '\f' ||
          lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == 8203 ||
          lookahead == 8288 ||
          lookahead == 65279) ADVANCE(94);
      if (lookahead != 0 &&
          lookahead != '\n' &&
          lookahead != '{' &&
          lookahead != '}') ADVANCE(96);
      END_STATE();
    case 95:
      ACCEPT_TOKEN(aux_sym_format_specifier_token1);
      if (lookahead == '{' ||
          lookahead == '}') ADVANCE(111);
      if (lookahead != 0 &&
          lookahead != '\n') ADVANCE(95);
      END_STATE();
    case 96:
      ACCEPT_TOKEN(aux_sym_format_specifier_token1);
      if (lookahead != 0 &&
          lookahead != '\n' &&
          lookahead != '{' &&
          lookahead != '}') ADVANCE(96);
      END_STATE();
    case 97:
      ACCEPT_TOKEN(sym_type_conversion);
      END_STATE();
    case 98:
      ACCEPT_TOKEN(sym_integer);
      END_STATE();
    case 99:
      ACCEPT_TOKEN(sym_integer);
      if (lookahead == '.') ADVANCE(108);
      if (lookahead == '_') ADVANCE(101);
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(19);
      if (lookahead == 'J' ||
          lookahead == 'L' ||
          lookahead == 'j' ||
          lookahead == 'l') ADVANCE(98);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(99);
      END_STATE();
    case 100:
      ACCEPT_TOKEN(sym_integer);
      if (lookahead == '.') ADVANCE(108);
      if (lookahead == 'B' ||
          lookahead == 'b') ADVANCE(16);
      if (lookahead == 'O' ||
          lookahead == 'o') ADVANCE(17);
      if (lookahead == 'X' ||
          lookahead == 'x') ADVANCE(18);
      if (lookahead == '_') ADVANCE(101);
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(19);
      if (lookahead == 'J' ||
          lookahead == 'L' ||
          lookahead == 'j' ||
          lookahead == 'l') ADVANCE(98);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(99);
      END_STATE();
    case 101:
      ACCEPT_TOKEN(sym_integer);
      if (lookahead == '.') ADVANCE(108);
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(19);
      if (lookahead == 'J' ||
          lookahead == 'L' ||
          lookahead == 'j' ||
          lookahead == 'l') ADVANCE(98);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(99);
      END_STATE();
    case 102:
      ACCEPT_TOKEN(sym_integer);
      if (lookahead == '_') ADVANCE(20);
      if (lookahead == '0' ||
          lookahead == '1') ADVANCE(102);
      if (lookahead == 'L' ||
          lookahead == 'l') ADVANCE(98);
      END_STATE();
    case 103:
      ACCEPT_TOKEN(sym_integer);
      if (lookahead == '_') ADVANCE(21);
      if (lookahead == 'L' ||
          lookahead == 'l') ADVANCE(98);
      if (('0' <= lookahead && lookahead <= '7')) ADVANCE(103);
      END_STATE();
    case 104:
      ACCEPT_TOKEN(sym_integer);
      if (lookahead == '_') ADVANCE(25);
      if (lookahead == 'L' ||
          lookahead == 'l') ADVANCE(98);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(104);
      END_STATE();
    case 105:
      ACCEPT_TOKEN(sym_float);
      END_STATE();
    case 106:
      ACCEPT_TOKEN(sym_float);
      if (lookahead == '_') ADVANCE(108);
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(19);
      if (lookahead == 'J' ||
          lookahead == 'L' ||
          lookahead == 'j' ||
          lookahead == 'l') ADVANCE(105);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(106);
      END_STATE();
    case 107:
      ACCEPT_TOKEN(sym_float);
      if (lookahead == '_') ADVANCE(109);
      if (lookahead == 'J' ||
          lookahead == 'L' ||
          lookahead == 'j' ||
          lookahead == 'l') ADVANCE(105);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(107);
      END_STATE();
    case 108:
      ACCEPT_TOKEN(sym_float);
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(19);
      if (lookahead == 'J' ||
          lookahead == 'L' ||
          lookahead == 'j' ||
          lookahead == 'l') ADVANCE(105);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(106);
      END_STATE();
    case 109:
      ACCEPT_TOKEN(sym_float);
      if (lookahead == 'J' ||
          lookahead == 'L' ||
          lookahead == 'j' ||
          lookahead == 'l') ADVANCE(105);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(107);
      END_STATE();
    case 110:
      ACCEPT_TOKEN(sym_identifier);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z') ||
          (913 <= lookahead && lookahead <= 937) ||
          (945 <= lookahead && lookahead <= 969)) ADVANCE(110);
      END_STATE();
    case 111:
      ACCEPT_TOKEN(sym_comment);
      if (lookahead != 0 &&
          lookahead != '\n') ADVANCE(111);
      END_STATE();
    case 112:
      ACCEPT_TOKEN(sym__semicolon);
      END_STATE();
    default:
      return false;
  }
}

static bool ts_lex_keywords(TSLexer *lexer, TSStateId state) {
  START_LEXER();
  eof = lookahead == 0;
  switch (state) {
    case 0:
      if (lookahead == 'F') ADVANCE(1);
      if (lookahead == 'N') ADVANCE(2);
      if (lookahead == 'T') ADVANCE(3);
      if (lookahead == '\\') SKIP(4)
      if (lookahead == '_') ADVANCE(5);
      if (lookahead == 'a') ADVANCE(6);
      if (lookahead == 'b') ADVANCE(7);
      if (lookahead == 'c') ADVANCE(8);
      if (lookahead == 'd') ADVANCE(9);
      if (lookahead == 'e') ADVANCE(10);
      if (lookahead == 'f') ADVANCE(11);
      if (lookahead == 'g') ADVANCE(12);
      if (lookahead == 'i') ADVANCE(13);
      if (lookahead == 'l') ADVANCE(14);
      if (lookahead == 'n') ADVANCE(15);
      if (lookahead == 'o') ADVANCE(16);
      if (lookahead == 'p') ADVANCE(17);
      if (lookahead == 'r') ADVANCE(18);
      if (lookahead == 't') ADVANCE(19);
      if (lookahead == 'w') ADVANCE(20);
      if (lookahead == 'y') ADVANCE(21);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\f' ||
          lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == 8203 ||
          lookahead == 8288 ||
          lookahead == 65279) SKIP(0)
      END_STATE();
    case 1:
      if (lookahead == 'a') ADVANCE(22);
      END_STATE();
    case 2:
      if (lookahead == 'o') ADVANCE(23);
      END_STATE();
    case 3:
      if (lookahead == 'r') ADVANCE(24);
      END_STATE();
    case 4:
      if (lookahead == '\n') SKIP(0)
      if (lookahead == '\r') SKIP(25)
      END_STATE();
    case 5:
      if (lookahead == '_') ADVANCE(26);
      END_STATE();
    case 6:
      if (lookahead == 'n') ADVANCE(27);
      if (lookahead == 's') ADVANCE(28);
      if (lookahead == 'w') ADVANCE(29);
      END_STATE();
    case 7:
      if (lookahead == 'r') ADVANCE(30);
      END_STATE();
    case 8:
      if (lookahead == 'l') ADVANCE(31);
      if (lookahead == 'o') ADVANCE(32);
      END_STATE();
    case 9:
      if (lookahead == 'e') ADVANCE(33);
      END_STATE();
    case 10:
      if (lookahead == 'l') ADVANCE(34);
      if (lookahead == 'x') ADVANCE(35);
      END_STATE();
    case 11:
      if (lookahead == 'i') ADVANCE(36);
      if (lookahead == 'o') ADVANCE(37);
      if (lookahead == 'r') ADVANCE(38);
      END_STATE();
    case 12:
      if (lookahead == 'l') ADVANCE(39);
      END_STATE();
    case 13:
      if (lookahead == 'f') ADVANCE(40);
      if (lookahead == 'm') ADVANCE(41);
      if (lookahead == 'n') ADVANCE(42);
      if (lookahead == 's') ADVANCE(43);
      END_STATE();
    case 14:
      if (lookahead == 'a') ADVANCE(44);
      END_STATE();
    case 15:
      if (lookahead == 'o') ADVANCE(45);
      END_STATE();
    case 16:
      if (lookahead == 'r') ADVANCE(46);
      END_STATE();
    case 17:
      if (lookahead == 'a') ADVANCE(47);
      if (lookahead == 'r') ADVANCE(48);
      END_STATE();
    case 18:
      if (lookahead == 'a') ADVANCE(49);
      if (lookahead == 'e') ADVANCE(50);
      END_STATE();
    case 19:
      if (lookahead == 'r') ADVANCE(51);
      END_STATE();
    case 20:
      if (lookahead == 'h') ADVANCE(52);
      if (lookahead == 'i') ADVANCE(53);
      END_STATE();
    case 21:
      if (lookahead == 'i') ADVANCE(54);
      END_STATE();
    case 22:
      if (lookahead == 'l') ADVANCE(55);
      END_STATE();
    case 23:
      if (lookahead == 'n') ADVANCE(56);
      END_STATE();
    case 24:
      if (lookahead == 'u') ADVANCE(57);
      END_STATE();
    case 25:
      if (lookahead == '\n') SKIP(0)
      END_STATE();
    case 26:
      if (lookahead == 'f') ADVANCE(58);
      END_STATE();
    case 27:
      if (lookahead == 'd') ADVANCE(59);
      END_STATE();
    case 28:
      ACCEPT_TOKEN(anon_sym_as);
      if (lookahead == 's') ADVANCE(60);
      if (lookahead == 'y') ADVANCE(61);
      END_STATE();
    case 29:
      if (lookahead == 'a') ADVANCE(62);
      END_STATE();
    case 30:
      if (lookahead == 'e') ADVANCE(63);
      END_STATE();
    case 31:
      if (lookahead == 'a') ADVANCE(64);
      END_STATE();
    case 32:
      if (lookahead == 'n') ADVANCE(65);
      END_STATE();
    case 33:
      if (lookahead == 'f') ADVANCE(66);
      if (lookahead == 'l') ADVANCE(67);
      END_STATE();
    case 34:
      if (lookahead == 'i') ADVANCE(68);
      if (lookahead == 's') ADVANCE(69);
      END_STATE();
    case 35:
      if (lookahead == 'c') ADVANCE(70);
      if (lookahead == 'e') ADVANCE(71);
      END_STATE();
    case 36:
      if (lookahead == 'n') ADVANCE(72);
      END_STATE();
    case 37:
      if (lookahead == 'r') ADVANCE(73);
      END_STATE();
    case 38:
      if (lookahead == 'o') ADVANCE(74);
      END_STATE();
    case 39:
      if (lookahead == 'o') ADVANCE(75);
      END_STATE();
    case 40:
      ACCEPT_TOKEN(anon_sym_if);
      END_STATE();
    case 41:
      if (lookahead == 'p') ADVANCE(76);
      END_STATE();
    case 42:
      ACCEPT_TOKEN(anon_sym_in);
      END_STATE();
    case 43:
      ACCEPT_TOKEN(anon_sym_is);
      END_STATE();
    case 44:
      if (lookahead == 'm') ADVANCE(77);
      END_STATE();
    case 45:
      if (lookahead == 'n') ADVANCE(78);
      if (lookahead == 't') ADVANCE(79);
      END_STATE();
    case 46:
      ACCEPT_TOKEN(anon_sym_or);
      END_STATE();
    case 47:
      if (lookahead == 's') ADVANCE(80);
      END_STATE();
    case 48:
      if (lookahead == 'i') ADVANCE(81);
      END_STATE();
    case 49:
      if (lookahead == 'i') ADVANCE(82);
      END_STATE();
    case 50:
      if (lookahead == 't') ADVANCE(83);
      END_STATE();
    case 51:
      if (lookahead == 'y') ADVANCE(84);
      END_STATE();
    case 52:
      if (lookahead == 'i') ADVANCE(85);
      END_STATE();
    case 53:
      if (lookahead == 't') ADVANCE(86);
      END_STATE();
    case 54:
      if (lookahead == 'e') ADVANCE(87);
      END_STATE();
    case 55:
      if (lookahead == 's') ADVANCE(88);
      END_STATE();
    case 56:
      if (lookahead == 'e') ADVANCE(89);
      END_STATE();
    case 57:
      if (lookahead == 'e') ADVANCE(90);
      END_STATE();
    case 58:
      if (lookahead == 'u') ADVANCE(91);
      END_STATE();
    case 59:
      ACCEPT_TOKEN(anon_sym_and);
      END_STATE();
    case 60:
      if (lookahead == 'e') ADVANCE(92);
      END_STATE();
    case 61:
      if (lookahead == 'n') ADVANCE(93);
      END_STATE();
    case 62:
      if (lookahead == 'i') ADVANCE(94);
      END_STATE();
    case 63:
      if (lookahead == 'a') ADVANCE(95);
      END_STATE();
    case 64:
      if (lookahead == 's') ADVANCE(96);
      END_STATE();
    case 65:
      if (lookahead == 't') ADVANCE(97);
      END_STATE();
    case 66:
      ACCEPT_TOKEN(anon_sym_def);
      END_STATE();
    case 67:
      ACCEPT_TOKEN(anon_sym_del);
      END_STATE();
    case 68:
      if (lookahead == 'f') ADVANCE(98);
      END_STATE();
    case 69:
      if (lookahead == 'e') ADVANCE(99);
      END_STATE();
    case 70:
      if (lookahead == 'e') ADVANCE(100);
      END_STATE();
    case 71:
      if (lookahead == 'c') ADVANCE(101);
      END_STATE();
    case 72:
      if (lookahead == 'a') ADVANCE(102);
      END_STATE();
    case 73:
      ACCEPT_TOKEN(anon_sym_for);
      END_STATE();
    case 74:
      if (lookahead == 'm') ADVANCE(103);
      END_STATE();
    case 75:
      if (lookahead == 'b') ADVANCE(104);
      END_STATE();
    case 76:
      if (lookahead == 'o') ADVANCE(105);
      END_STATE();
    case 77:
      if (lookahead == 'b') ADVANCE(106);
      END_STATE();
    case 78:
      if (lookahead == 'l') ADVANCE(107);
      END_STATE();
    case 79:
      ACCEPT_TOKEN(anon_sym_not);
      END_STATE();
    case 80:
      if (lookahead == 's') ADVANCE(108);
      END_STATE();
    case 81:
      if (lookahead == 'n') ADVANCE(109);
      END_STATE();
    case 82:
      if (lookahead == 's') ADVANCE(110);
      END_STATE();
    case 83:
      if (lookahead == 'u') ADVANCE(111);
      END_STATE();
    case 84:
      ACCEPT_TOKEN(anon_sym_try);
      END_STATE();
    case 85:
      if (lookahead == 'l') ADVANCE(112);
      END_STATE();
    case 86:
      if (lookahead == 'h') ADVANCE(113);
      END_STATE();
    case 87:
      if (lookahead == 'l') ADVANCE(114);
      END_STATE();
    case 88:
      if (lookahead == 'e') ADVANCE(115);
      END_STATE();
    case 89:
      ACCEPT_TOKEN(sym_none);
      END_STATE();
    case 90:
      ACCEPT_TOKEN(sym_true);
      END_STATE();
    case 91:
      if (lookahead == 't') ADVANCE(116);
      END_STATE();
    case 92:
      if (lookahead == 'r') ADVANCE(117);
      END_STATE();
    case 93:
      if (lookahead == 'c') ADVANCE(118);
      END_STATE();
    case 94:
      if (lookahead == 't') ADVANCE(119);
      END_STATE();
    case 95:
      if (lookahead == 'k') ADVANCE(120);
      END_STATE();
    case 96:
      if (lookahead == 's') ADVANCE(121);
      END_STATE();
    case 97:
      if (lookahead == 'i') ADVANCE(122);
      END_STATE();
    case 98:
      ACCEPT_TOKEN(anon_sym_elif);
      END_STATE();
    case 99:
      ACCEPT_TOKEN(anon_sym_else);
      END_STATE();
    case 100:
      if (lookahead == 'p') ADVANCE(123);
      END_STATE();
    case 101:
      ACCEPT_TOKEN(anon_sym_exec);
      END_STATE();
    case 102:
      if (lookahead == 'l') ADVANCE(124);
      END_STATE();
    case 103:
      ACCEPT_TOKEN(anon_sym_from);
      END_STATE();
    case 104:
      if (lookahead == 'a') ADVANCE(125);
      END_STATE();
    case 105:
      if (lookahead == 'r') ADVANCE(126);
      END_STATE();
    case 106:
      if (lookahead == 'd') ADVANCE(127);
      END_STATE();
    case 107:
      if (lookahead == 'o') ADVANCE(128);
      END_STATE();
    case 108:
      ACCEPT_TOKEN(anon_sym_pass);
      END_STATE();
    case 109:
      if (lookahead == 't') ADVANCE(129);
      END_STATE();
    case 110:
      if (lookahead == 'e') ADVANCE(130);
      END_STATE();
    case 111:
      if (lookahead == 'r') ADVANCE(131);
      END_STATE();
    case 112:
      if (lookahead == 'e') ADVANCE(132);
      END_STATE();
    case 113:
      ACCEPT_TOKEN(anon_sym_with);
      END_STATE();
    case 114:
      if (lookahead == 'd') ADVANCE(133);
      END_STATE();
    case 115:
      ACCEPT_TOKEN(sym_false);
      END_STATE();
    case 116:
      if (lookahead == 'u') ADVANCE(134);
      END_STATE();
    case 117:
      if (lookahead == 't') ADVANCE(135);
      END_STATE();
    case 118:
      ACCEPT_TOKEN(anon_sym_async);
      END_STATE();
    case 119:
      ACCEPT_TOKEN(anon_sym_await);
      END_STATE();
    case 120:
      ACCEPT_TOKEN(anon_sym_break);
      END_STATE();
    case 121:
      ACCEPT_TOKEN(anon_sym_class);
      END_STATE();
    case 122:
      if (lookahead == 'n') ADVANCE(136);
      END_STATE();
    case 123:
      if (lookahead == 't') ADVANCE(137);
      END_STATE();
    case 124:
      if (lookahead == 'l') ADVANCE(138);
      END_STATE();
    case 125:
      if (lookahead == 'l') ADVANCE(139);
      END_STATE();
    case 126:
      if (lookahead == 't') ADVANCE(140);
      END_STATE();
    case 127:
      if (lookahead == 'a') ADVANCE(141);
      END_STATE();
    case 128:
      if (lookahead == 'c') ADVANCE(142);
      END_STATE();
    case 129:
      ACCEPT_TOKEN(anon_sym_print);
      END_STATE();
    case 130:
      ACCEPT_TOKEN(anon_sym_raise);
      END_STATE();
    case 131:
      if (lookahead == 'n') ADVANCE(143);
      END_STATE();
    case 132:
      ACCEPT_TOKEN(anon_sym_while);
      END_STATE();
    case 133:
      ACCEPT_TOKEN(anon_sym_yield);
      END_STATE();
    case 134:
      if (lookahead == 'r') ADVANCE(144);
      END_STATE();
    case 135:
      ACCEPT_TOKEN(anon_sym_assert);
      END_STATE();
    case 136:
      if (lookahead == 'u') ADVANCE(145);
      END_STATE();
    case 137:
      ACCEPT_TOKEN(anon_sym_except);
      END_STATE();
    case 138:
      if (lookahead == 'y') ADVANCE(146);
      END_STATE();
    case 139:
      ACCEPT_TOKEN(anon_sym_global);
      END_STATE();
    case 140:
      ACCEPT_TOKEN(anon_sym_import);
      END_STATE();
    case 141:
      ACCEPT_TOKEN(anon_sym_lambda);
      END_STATE();
    case 142:
      if (lookahead == 'a') ADVANCE(147);
      END_STATE();
    case 143:
      ACCEPT_TOKEN(anon_sym_return);
      END_STATE();
    case 144:
      if (lookahead == 'e') ADVANCE(148);
      END_STATE();
    case 145:
      if (lookahead == 'e') ADVANCE(149);
      END_STATE();
    case 146:
      ACCEPT_TOKEN(anon_sym_finally);
      END_STATE();
    case 147:
      if (lookahead == 'l') ADVANCE(150);
      END_STATE();
    case 148:
      if (lookahead == '_') ADVANCE(151);
      END_STATE();
    case 149:
      ACCEPT_TOKEN(anon_sym_continue);
      END_STATE();
    case 150:
      ACCEPT_TOKEN(anon_sym_nonlocal);
      END_STATE();
    case 151:
      if (lookahead == '_') ADVANCE(152);
      END_STATE();
    case 152:
      ACCEPT_TOKEN(anon_sym___future__);
      END_STATE();
    default:
      return false;
  }
}

static TSLexMode ts_lex_modes[STATE_COUNT] = {
  [0] = {.lex_state = 0, .external_lex_state = 1},
  [1] = {.lex_state = 38, .external_lex_state = 2},
  [2] = {.lex_state = 38, .external_lex_state = 3},
  [3] = {.lex_state = 38, .external_lex_state = 3},
  [4] = {.lex_state = 38, .external_lex_state = 3},
  [5] = {.lex_state = 38, .external_lex_state = 3},
  [6] = {.lex_state = 38, .external_lex_state = 3},
  [7] = {.lex_state = 38, .external_lex_state = 3},
  [8] = {.lex_state = 38, .external_lex_state = 3},
  [9] = {.lex_state = 38, .external_lex_state = 3},
  [10] = {.lex_state = 38, .external_lex_state = 3},
  [11] = {.lex_state = 38, .external_lex_state = 3},
  [12] = {.lex_state = 38, .external_lex_state = 3},
  [13] = {.lex_state = 38, .external_lex_state = 3},
  [14] = {.lex_state = 38, .external_lex_state = 3},
  [15] = {.lex_state = 38, .external_lex_state = 3},
  [16] = {.lex_state = 38, .external_lex_state = 3},
  [17] = {.lex_state = 38, .external_lex_state = 3},
  [18] = {.lex_state = 38, .external_lex_state = 3},
  [19] = {.lex_state = 38, .external_lex_state = 3},
  [20] = {.lex_state = 38, .external_lex_state = 3},
  [21] = {.lex_state = 38, .external_lex_state = 3},
  [22] = {.lex_state = 38, .external_lex_state = 3},
  [23] = {.lex_state = 38, .external_lex_state = 3},
  [24] = {.lex_state = 38, .external_lex_state = 3},
  [25] = {.lex_state = 38, .external_lex_state = 3},
  [26] = {.lex_state = 38, .external_lex_state = 3},
  [27] = {.lex_state = 38, .external_lex_state = 3},
  [28] = {.lex_state = 38, .external_lex_state = 3},
  [29] = {.lex_state = 38, .external_lex_state = 3},
  [30] = {.lex_state = 38, .external_lex_state = 3},
  [31] = {.lex_state = 38, .external_lex_state = 3},
  [32] = {.lex_state = 38, .external_lex_state = 3},
  [33] = {.lex_state = 38, .external_lex_state = 3},
  [34] = {.lex_state = 38, .external_lex_state = 3},
  [35] = {.lex_state = 38, .external_lex_state = 3},
  [36] = {.lex_state = 38, .external_lex_state = 3},
  [37] = {.lex_state = 38, .external_lex_state = 3},
  [38] = {.lex_state = 38, .external_lex_state = 3},
  [39] = {.lex_state = 38, .external_lex_state = 3},
  [40] = {.lex_state = 38, .external_lex_state = 3},
  [41] = {.lex_state = 38, .external_lex_state = 3},
  [42] = {.lex_state = 38, .external_lex_state = 2},
  [43] = {.lex_state = 38, .external_lex_state = 3},
  [44] = {.lex_state = 38, .external_lex_state = 3},
  [45] = {.lex_state = 38, .external_lex_state = 2},
  [46] = {.lex_state = 38, .external_lex_state = 3},
  [47] = {.lex_state = 38, .external_lex_state = 3},
  [48] = {.lex_state = 38, .external_lex_state = 4},
  [49] = {.lex_state = 38, .external_lex_state = 5},
  [50] = {.lex_state = 38, .external_lex_state = 5},
  [51] = {.lex_state = 38, .external_lex_state = 5},
  [52] = {.lex_state = 38, .external_lex_state = 5},
  [53] = {.lex_state = 38, .external_lex_state = 5},
  [54] = {.lex_state = 38, .external_lex_state = 5},
  [55] = {.lex_state = 38, .external_lex_state = 5},
  [56] = {.lex_state = 38, .external_lex_state = 5},
  [57] = {.lex_state = 38, .external_lex_state = 5},
  [58] = {.lex_state = 38, .external_lex_state = 5},
  [59] = {.lex_state = 38, .external_lex_state = 5},
  [60] = {.lex_state = 38, .external_lex_state = 5},
  [61] = {.lex_state = 38, .external_lex_state = 5},
  [62] = {.lex_state = 38, .external_lex_state = 5},
  [63] = {.lex_state = 38, .external_lex_state = 5},
  [64] = {.lex_state = 38, .external_lex_state = 5},
  [65] = {.lex_state = 38, .external_lex_state = 5},
  [66] = {.lex_state = 38, .external_lex_state = 5},
  [67] = {.lex_state = 38, .external_lex_state = 5},
  [68] = {.lex_state = 38, .external_lex_state = 5},
  [69] = {.lex_state = 38, .external_lex_state = 5},
  [70] = {.lex_state = 38, .external_lex_state = 5},
  [71] = {.lex_state = 38, .external_lex_state = 5},
  [72] = {.lex_state = 38, .external_lex_state = 5},
  [73] = {.lex_state = 38, .external_lex_state = 5},
  [74] = {.lex_state = 38, .external_lex_state = 5},
  [75] = {.lex_state = 38, .external_lex_state = 5},
  [76] = {.lex_state = 38, .external_lex_state = 5},
  [77] = {.lex_state = 38, .external_lex_state = 5},
  [78] = {.lex_state = 38, .external_lex_state = 5},
  [79] = {.lex_state = 38, .external_lex_state = 5},
  [80] = {.lex_state = 38, .external_lex_state = 5},
  [81] = {.lex_state = 38, .external_lex_state = 5},
  [82] = {.lex_state = 38, .external_lex_state = 5},
  [83] = {.lex_state = 38, .external_lex_state = 5},
  [84] = {.lex_state = 38, .external_lex_state = 5},
  [85] = {.lex_state = 38, .external_lex_state = 5},
  [86] = {.lex_state = 38, .external_lex_state = 5},
  [87] = {.lex_state = 38, .external_lex_state = 5},
  [88] = {.lex_state = 38, .external_lex_state = 5},
  [89] = {.lex_state = 38, .external_lex_state = 4},
  [90] = {.lex_state = 38, .external_lex_state = 4},
  [91] = {.lex_state = 38, .external_lex_state = 4},
  [92] = {.lex_state = 38, .external_lex_state = 4},
  [93] = {.lex_state = 38, .external_lex_state = 4},
  [94] = {.lex_state = 38, .external_lex_state = 4},
  [95] = {.lex_state = 38, .external_lex_state = 2},
  [96] = {.lex_state = 38, .external_lex_state = 4},
  [97] = {.lex_state = 38, .external_lex_state = 4},
  [98] = {.lex_state = 38, .external_lex_state = 4},
  [99] = {.lex_state = 38, .external_lex_state = 4},
  [100] = {.lex_state = 38, .external_lex_state = 2},
  [101] = {.lex_state = 38, .external_lex_state = 2},
  [102] = {.lex_state = 38, .external_lex_state = 2},
  [103] = {.lex_state = 38, .external_lex_state = 2},
  [104] = {.lex_state = 38, .external_lex_state = 2},
  [105] = {.lex_state = 38, .external_lex_state = 2},
  [106] = {.lex_state = 38, .external_lex_state = 2},
  [107] = {.lex_state = 38, .external_lex_state = 2},
  [108] = {.lex_state = 38, .external_lex_state = 2},
  [109] = {.lex_state = 10, .external_lex_state = 6},
  [110] = {.lex_state = 38, .external_lex_state = 2},
  [111] = {.lex_state = 38, .external_lex_state = 2},
  [112] = {.lex_state = 38, .external_lex_state = 2},
  [113] = {.lex_state = 38, .external_lex_state = 2},
  [114] = {.lex_state = 38, .external_lex_state = 2},
  [115] = {.lex_state = 38, .external_lex_state = 2},
  [116] = {.lex_state = 38, .external_lex_state = 2},
  [117] = {.lex_state = 10, .external_lex_state = 4},
  [118] = {.lex_state = 38, .external_lex_state = 2},
  [119] = {.lex_state = 38, .external_lex_state = 2},
  [120] = {.lex_state = 10, .external_lex_state = 4},
  [121] = {.lex_state = 38, .external_lex_state = 2},
  [122] = {.lex_state = 10, .external_lex_state = 4},
  [123] = {.lex_state = 38, .external_lex_state = 2},
  [124] = {.lex_state = 38, .external_lex_state = 2},
  [125] = {.lex_state = 10, .external_lex_state = 6},
  [126] = {.lex_state = 38, .external_lex_state = 2},
  [127] = {.lex_state = 10, .external_lex_state = 6},
  [128] = {.lex_state = 10, .external_lex_state = 6},
  [129] = {.lex_state = 10, .external_lex_state = 6},
  [130] = {.lex_state = 38, .external_lex_state = 2},
  [131] = {.lex_state = 10, .external_lex_state = 6},
  [132] = {.lex_state = 10, .external_lex_state = 6},
  [133] = {.lex_state = 10, .external_lex_state = 6},
  [134] = {.lex_state = 10, .external_lex_state = 6},
  [135] = {.lex_state = 10, .external_lex_state = 6},
  [136] = {.lex_state = 10, .external_lex_state = 6},
  [137] = {.lex_state = 10, .external_lex_state = 4},
  [138] = {.lex_state = 9, .external_lex_state = 6},
  [139] = {.lex_state = 10, .external_lex_state = 4},
  [140] = {.lex_state = 10, .external_lex_state = 4},
  [141] = {.lex_state = 38, .external_lex_state = 4},
  [142] = {.lex_state = 10, .external_lex_state = 6},
  [143] = {.lex_state = 38, .external_lex_state = 2},
  [144] = {.lex_state = 38, .external_lex_state = 2},
  [145] = {.lex_state = 10, .external_lex_state = 6},
  [146] = {.lex_state = 38, .external_lex_state = 2},
  [147] = {.lex_state = 10, .external_lex_state = 6},
  [148] = {.lex_state = 10, .external_lex_state = 6},
  [149] = {.lex_state = 38, .external_lex_state = 2},
  [150] = {.lex_state = 38, .external_lex_state = 2},
  [151] = {.lex_state = 38, .external_lex_state = 2},
  [152] = {.lex_state = 10, .external_lex_state = 6},
  [153] = {.lex_state = 38, .external_lex_state = 2},
  [154] = {.lex_state = 10, .external_lex_state = 6},
  [155] = {.lex_state = 10, .external_lex_state = 6},
  [156] = {.lex_state = 10, .external_lex_state = 6},
  [157] = {.lex_state = 38, .external_lex_state = 2},
  [158] = {.lex_state = 10, .external_lex_state = 6},
  [159] = {.lex_state = 38, .external_lex_state = 2},
  [160] = {.lex_state = 10, .external_lex_state = 6},
  [161] = {.lex_state = 38, .external_lex_state = 2},
  [162] = {.lex_state = 10, .external_lex_state = 6},
  [163] = {.lex_state = 10, .external_lex_state = 6},
  [164] = {.lex_state = 10, .external_lex_state = 6},
  [165] = {.lex_state = 10, .external_lex_state = 6},
  [166] = {.lex_state = 10, .external_lex_state = 6},
  [167] = {.lex_state = 38, .external_lex_state = 4},
  [168] = {.lex_state = 10, .external_lex_state = 6},
  [169] = {.lex_state = 38, .external_lex_state = 2},
  [170] = {.lex_state = 10, .external_lex_state = 6},
  [171] = {.lex_state = 10, .external_lex_state = 6},
  [172] = {.lex_state = 10, .external_lex_state = 6},
  [173] = {.lex_state = 10, .external_lex_state = 6},
  [174] = {.lex_state = 10, .external_lex_state = 6},
  [175] = {.lex_state = 10, .external_lex_state = 6},
  [176] = {.lex_state = 10, .external_lex_state = 6},
  [177] = {.lex_state = 10, .external_lex_state = 6},
  [178] = {.lex_state = 38, .external_lex_state = 2},
  [179] = {.lex_state = 38, .external_lex_state = 2},
  [180] = {.lex_state = 10, .external_lex_state = 6},
  [181] = {.lex_state = 38, .external_lex_state = 2},
  [182] = {.lex_state = 10, .external_lex_state = 6},
  [183] = {.lex_state = 38, .external_lex_state = 2},
  [184] = {.lex_state = 10, .external_lex_state = 6},
  [185] = {.lex_state = 10, .external_lex_state = 6},
  [186] = {.lex_state = 10, .external_lex_state = 6},
  [187] = {.lex_state = 38, .external_lex_state = 3},
  [188] = {.lex_state = 10, .external_lex_state = 6},
  [189] = {.lex_state = 38, .external_lex_state = 2},
  [190] = {.lex_state = 10, .external_lex_state = 6},
  [191] = {.lex_state = 38, .external_lex_state = 3},
  [192] = {.lex_state = 38, .external_lex_state = 2},
  [193] = {.lex_state = 38, .external_lex_state = 2},
  [194] = {.lex_state = 38, .external_lex_state = 2},
  [195] = {.lex_state = 38, .external_lex_state = 2},
  [196] = {.lex_state = 38, .external_lex_state = 2},
  [197] = {.lex_state = 38, .external_lex_state = 4},
  [198] = {.lex_state = 38, .external_lex_state = 2},
  [199] = {.lex_state = 38, .external_lex_state = 2},
  [200] = {.lex_state = 38, .external_lex_state = 2},
  [201] = {.lex_state = 38, .external_lex_state = 2},
  [202] = {.lex_state = 38, .external_lex_state = 2},
  [203] = {.lex_state = 38, .external_lex_state = 2},
  [204] = {.lex_state = 38, .external_lex_state = 2},
  [205] = {.lex_state = 38, .external_lex_state = 2},
  [206] = {.lex_state = 38, .external_lex_state = 2},
  [207] = {.lex_state = 38, .external_lex_state = 2},
  [208] = {.lex_state = 38, .external_lex_state = 2},
  [209] = {.lex_state = 38, .external_lex_state = 2},
  [210] = {.lex_state = 38, .external_lex_state = 2},
  [211] = {.lex_state = 38, .external_lex_state = 2},
  [212] = {.lex_state = 38, .external_lex_state = 2},
  [213] = {.lex_state = 38, .external_lex_state = 2},
  [214] = {.lex_state = 38, .external_lex_state = 2},
  [215] = {.lex_state = 38, .external_lex_state = 2},
  [216] = {.lex_state = 38, .external_lex_state = 2},
  [217] = {.lex_state = 38, .external_lex_state = 2},
  [218] = {.lex_state = 38, .external_lex_state = 2},
  [219] = {.lex_state = 38, .external_lex_state = 2},
  [220] = {.lex_state = 38, .external_lex_state = 2},
  [221] = {.lex_state = 38, .external_lex_state = 2},
  [222] = {.lex_state = 38, .external_lex_state = 2},
  [223] = {.lex_state = 38, .external_lex_state = 2},
  [224] = {.lex_state = 38, .external_lex_state = 2},
  [225] = {.lex_state = 38, .external_lex_state = 2},
  [226] = {.lex_state = 38, .external_lex_state = 2},
  [227] = {.lex_state = 38, .external_lex_state = 2},
  [228] = {.lex_state = 38, .external_lex_state = 3},
  [229] = {.lex_state = 38, .external_lex_state = 4},
  [230] = {.lex_state = 38, .external_lex_state = 2},
  [231] = {.lex_state = 38, .external_lex_state = 4},
  [232] = {.lex_state = 38, .external_lex_state = 2},
  [233] = {.lex_state = 38, .external_lex_state = 2},
  [234] = {.lex_state = 38, .external_lex_state = 2},
  [235] = {.lex_state = 38, .external_lex_state = 2},
  [236] = {.lex_state = 38, .external_lex_state = 2},
  [237] = {.lex_state = 38, .external_lex_state = 2},
  [238] = {.lex_state = 38, .external_lex_state = 2},
  [239] = {.lex_state = 38, .external_lex_state = 2},
  [240] = {.lex_state = 38, .external_lex_state = 2},
  [241] = {.lex_state = 38, .external_lex_state = 2},
  [242] = {.lex_state = 38, .external_lex_state = 3},
  [243] = {.lex_state = 38, .external_lex_state = 4},
  [244] = {.lex_state = 38, .external_lex_state = 2},
  [245] = {.lex_state = 38, .external_lex_state = 4},
  [246] = {.lex_state = 38, .external_lex_state = 2},
  [247] = {.lex_state = 38, .external_lex_state = 3},
  [248] = {.lex_state = 38, .external_lex_state = 2},
  [249] = {.lex_state = 38, .external_lex_state = 3},
  [250] = {.lex_state = 38, .external_lex_state = 3},
  [251] = {.lex_state = 38, .external_lex_state = 2},
  [252] = {.lex_state = 38, .external_lex_state = 2},
  [253] = {.lex_state = 38, .external_lex_state = 2},
  [254] = {.lex_state = 38, .external_lex_state = 2},
  [255] = {.lex_state = 38, .external_lex_state = 2},
  [256] = {.lex_state = 38, .external_lex_state = 3},
  [257] = {.lex_state = 38, .external_lex_state = 2},
  [258] = {.lex_state = 38, .external_lex_state = 2},
  [259] = {.lex_state = 38, .external_lex_state = 2},
  [260] = {.lex_state = 38, .external_lex_state = 3},
  [261] = {.lex_state = 38, .external_lex_state = 3},
  [262] = {.lex_state = 38, .external_lex_state = 3},
  [263] = {.lex_state = 38, .external_lex_state = 2},
  [264] = {.lex_state = 38, .external_lex_state = 3},
  [265] = {.lex_state = 38, .external_lex_state = 2},
  [266] = {.lex_state = 38, .external_lex_state = 2},
  [267] = {.lex_state = 38, .external_lex_state = 2},
  [268] = {.lex_state = 38, .external_lex_state = 2},
  [269] = {.lex_state = 38, .external_lex_state = 2},
  [270] = {.lex_state = 38, .external_lex_state = 2},
  [271] = {.lex_state = 38, .external_lex_state = 2},
  [272] = {.lex_state = 38, .external_lex_state = 2},
  [273] = {.lex_state = 38, .external_lex_state = 2},
  [274] = {.lex_state = 38, .external_lex_state = 2},
  [275] = {.lex_state = 38, .external_lex_state = 2},
  [276] = {.lex_state = 38, .external_lex_state = 2},
  [277] = {.lex_state = 38, .external_lex_state = 2},
  [278] = {.lex_state = 38, .external_lex_state = 2},
  [279] = {.lex_state = 38, .external_lex_state = 3},
  [280] = {.lex_state = 38, .external_lex_state = 2},
  [281] = {.lex_state = 38, .external_lex_state = 2},
  [282] = {.lex_state = 38, .external_lex_state = 2},
  [283] = {.lex_state = 38, .external_lex_state = 2},
  [284] = {.lex_state = 38, .external_lex_state = 2},
  [285] = {.lex_state = 38, .external_lex_state = 2},
  [286] = {.lex_state = 38, .external_lex_state = 2},
  [287] = {.lex_state = 38, .external_lex_state = 2},
  [288] = {.lex_state = 38, .external_lex_state = 2},
  [289] = {.lex_state = 38, .external_lex_state = 3},
  [290] = {.lex_state = 38, .external_lex_state = 2},
  [291] = {.lex_state = 38, .external_lex_state = 3},
  [292] = {.lex_state = 38, .external_lex_state = 2},
  [293] = {.lex_state = 38, .external_lex_state = 2},
  [294] = {.lex_state = 38, .external_lex_state = 3},
  [295] = {.lex_state = 38, .external_lex_state = 2},
  [296] = {.lex_state = 38, .external_lex_state = 2},
  [297] = {.lex_state = 38, .external_lex_state = 3},
  [298] = {.lex_state = 38, .external_lex_state = 3},
  [299] = {.lex_state = 38, .external_lex_state = 2},
  [300] = {.lex_state = 38, .external_lex_state = 2},
  [301] = {.lex_state = 38, .external_lex_state = 2},
  [302] = {.lex_state = 38, .external_lex_state = 2},
  [303] = {.lex_state = 38, .external_lex_state = 2},
  [304] = {.lex_state = 38, .external_lex_state = 2},
  [305] = {.lex_state = 38, .external_lex_state = 2},
  [306] = {.lex_state = 38, .external_lex_state = 2},
  [307] = {.lex_state = 38, .external_lex_state = 2},
  [308] = {.lex_state = 38, .external_lex_state = 2},
  [309] = {.lex_state = 38, .external_lex_state = 2},
  [310] = {.lex_state = 38, .external_lex_state = 2},
  [311] = {.lex_state = 38, .external_lex_state = 2},
  [312] = {.lex_state = 38, .external_lex_state = 2},
  [313] = {.lex_state = 38, .external_lex_state = 2},
  [314] = {.lex_state = 38, .external_lex_state = 3},
  [315] = {.lex_state = 38, .external_lex_state = 2},
  [316] = {.lex_state = 38, .external_lex_state = 2},
  [317] = {.lex_state = 38, .external_lex_state = 2},
  [318] = {.lex_state = 38, .external_lex_state = 2},
  [319] = {.lex_state = 38, .external_lex_state = 2},
  [320] = {.lex_state = 38, .external_lex_state = 2},
  [321] = {.lex_state = 38, .external_lex_state = 2},
  [322] = {.lex_state = 38, .external_lex_state = 2},
  [323] = {.lex_state = 38, .external_lex_state = 2},
  [324] = {.lex_state = 38, .external_lex_state = 2},
  [325] = {.lex_state = 38, .external_lex_state = 2},
  [326] = {.lex_state = 38, .external_lex_state = 2},
  [327] = {.lex_state = 38, .external_lex_state = 2},
  [328] = {.lex_state = 38, .external_lex_state = 2},
  [329] = {.lex_state = 38, .external_lex_state = 2},
  [330] = {.lex_state = 38, .external_lex_state = 2},
  [331] = {.lex_state = 38, .external_lex_state = 2},
  [332] = {.lex_state = 38, .external_lex_state = 2},
  [333] = {.lex_state = 38, .external_lex_state = 2},
  [334] = {.lex_state = 38, .external_lex_state = 2},
  [335] = {.lex_state = 38, .external_lex_state = 2},
  [336] = {.lex_state = 38, .external_lex_state = 2},
  [337] = {.lex_state = 38, .external_lex_state = 2},
  [338] = {.lex_state = 38, .external_lex_state = 2},
  [339] = {.lex_state = 38, .external_lex_state = 2},
  [340] = {.lex_state = 38, .external_lex_state = 2},
  [341] = {.lex_state = 38, .external_lex_state = 2},
  [342] = {.lex_state = 38, .external_lex_state = 2},
  [343] = {.lex_state = 38, .external_lex_state = 2},
  [344] = {.lex_state = 38, .external_lex_state = 2},
  [345] = {.lex_state = 38, .external_lex_state = 2},
  [346] = {.lex_state = 38, .external_lex_state = 2},
  [347] = {.lex_state = 38, .external_lex_state = 2},
  [348] = {.lex_state = 38, .external_lex_state = 2},
  [349] = {.lex_state = 38, .external_lex_state = 2},
  [350] = {.lex_state = 38, .external_lex_state = 2},
  [351] = {.lex_state = 38, .external_lex_state = 2},
  [352] = {.lex_state = 38, .external_lex_state = 2},
  [353] = {.lex_state = 38, .external_lex_state = 2},
  [354] = {.lex_state = 38, .external_lex_state = 2},
  [355] = {.lex_state = 38, .external_lex_state = 2},
  [356] = {.lex_state = 38, .external_lex_state = 3},
  [357] = {.lex_state = 38, .external_lex_state = 2},
  [358] = {.lex_state = 38, .external_lex_state = 3},
  [359] = {.lex_state = 38, .external_lex_state = 2},
  [360] = {.lex_state = 38, .external_lex_state = 2},
  [361] = {.lex_state = 38, .external_lex_state = 3},
  [362] = {.lex_state = 38, .external_lex_state = 2},
  [363] = {.lex_state = 38, .external_lex_state = 2},
  [364] = {.lex_state = 38, .external_lex_state = 2},
  [365] = {.lex_state = 38, .external_lex_state = 3},
  [366] = {.lex_state = 38, .external_lex_state = 3},
  [367] = {.lex_state = 38, .external_lex_state = 3},
  [368] = {.lex_state = 38, .external_lex_state = 3},
  [369] = {.lex_state = 38, .external_lex_state = 3},
  [370] = {.lex_state = 38, .external_lex_state = 2},
  [371] = {.lex_state = 38, .external_lex_state = 2},
  [372] = {.lex_state = 38, .external_lex_state = 2},
  [373] = {.lex_state = 38, .external_lex_state = 3},
  [374] = {.lex_state = 38, .external_lex_state = 3},
  [375] = {.lex_state = 38, .external_lex_state = 3},
  [376] = {.lex_state = 38, .external_lex_state = 2},
  [377] = {.lex_state = 10, .external_lex_state = 2},
  [378] = {.lex_state = 10, .external_lex_state = 2},
  [379] = {.lex_state = 38, .external_lex_state = 3},
  [380] = {.lex_state = 38, .external_lex_state = 2},
  [381] = {.lex_state = 10, .external_lex_state = 2},
  [382] = {.lex_state = 38, .external_lex_state = 3},
  [383] = {.lex_state = 10},
  [384] = {.lex_state = 38, .external_lex_state = 2},
  [385] = {.lex_state = 38, .external_lex_state = 3},
  [386] = {.lex_state = 38, .external_lex_state = 2},
  [387] = {.lex_state = 38, .external_lex_state = 3},
  [388] = {.lex_state = 38, .external_lex_state = 3},
  [389] = {.lex_state = 38, .external_lex_state = 3},
  [390] = {.lex_state = 38, .external_lex_state = 3},
  [391] = {.lex_state = 38, .external_lex_state = 3},
  [392] = {.lex_state = 38, .external_lex_state = 3},
  [393] = {.lex_state = 38, .external_lex_state = 3},
  [394] = {.lex_state = 38, .external_lex_state = 3},
  [395] = {.lex_state = 38, .external_lex_state = 3},
  [396] = {.lex_state = 38, .external_lex_state = 3},
  [397] = {.lex_state = 38, .external_lex_state = 3},
  [398] = {.lex_state = 38, .external_lex_state = 3},
  [399] = {.lex_state = 38, .external_lex_state = 3},
  [400] = {.lex_state = 38, .external_lex_state = 3},
  [401] = {.lex_state = 38, .external_lex_state = 3},
  [402] = {.lex_state = 38, .external_lex_state = 3},
  [403] = {.lex_state = 38, .external_lex_state = 3},
  [404] = {.lex_state = 38, .external_lex_state = 2},
  [405] = {.lex_state = 38, .external_lex_state = 3},
  [406] = {.lex_state = 38, .external_lex_state = 3},
  [407] = {.lex_state = 38, .external_lex_state = 2},
  [408] = {.lex_state = 38, .external_lex_state = 2},
  [409] = {.lex_state = 38, .external_lex_state = 2},
  [410] = {.lex_state = 10},
  [411] = {.lex_state = 38, .external_lex_state = 3},
  [412] = {.lex_state = 38, .external_lex_state = 2},
  [413] = {.lex_state = 38, .external_lex_state = 2},
  [414] = {.lex_state = 38, .external_lex_state = 2},
  [415] = {.lex_state = 38, .external_lex_state = 3},
  [416] = {.lex_state = 38, .external_lex_state = 3},
  [417] = {.lex_state = 38, .external_lex_state = 3},
  [418] = {.lex_state = 38, .external_lex_state = 3},
  [419] = {.lex_state = 38, .external_lex_state = 3},
  [420] = {.lex_state = 38, .external_lex_state = 2},
  [421] = {.lex_state = 10},
  [422] = {.lex_state = 38, .external_lex_state = 2},
  [423] = {.lex_state = 10},
  [424] = {.lex_state = 10},
  [425] = {.lex_state = 38, .external_lex_state = 2},
  [426] = {.lex_state = 10},
  [427] = {.lex_state = 10},
  [428] = {.lex_state = 38, .external_lex_state = 3},
  [429] = {.lex_state = 10},
  [430] = {.lex_state = 38, .external_lex_state = 2},
  [431] = {.lex_state = 10},
  [432] = {.lex_state = 10},
  [433] = {.lex_state = 38, .external_lex_state = 2},
  [434] = {.lex_state = 38, .external_lex_state = 3},
  [435] = {.lex_state = 38, .external_lex_state = 3},
  [436] = {.lex_state = 10},
  [437] = {.lex_state = 38, .external_lex_state = 2},
  [438] = {.lex_state = 38, .external_lex_state = 3},
  [439] = {.lex_state = 38, .external_lex_state = 3},
  [440] = {.lex_state = 38, .external_lex_state = 2},
  [441] = {.lex_state = 38, .external_lex_state = 2},
  [442] = {.lex_state = 38, .external_lex_state = 2},
  [443] = {.lex_state = 38, .external_lex_state = 3},
  [444] = {.lex_state = 38, .external_lex_state = 2},
  [445] = {.lex_state = 38, .external_lex_state = 2},
  [446] = {.lex_state = 38, .external_lex_state = 2},
  [447] = {.lex_state = 38, .external_lex_state = 2},
  [448] = {.lex_state = 38, .external_lex_state = 3},
  [449] = {.lex_state = 38, .external_lex_state = 3},
  [450] = {.lex_state = 38, .external_lex_state = 3},
  [451] = {.lex_state = 38, .external_lex_state = 2},
  [452] = {.lex_state = 38, .external_lex_state = 2},
  [453] = {.lex_state = 38, .external_lex_state = 2},
  [454] = {.lex_state = 38, .external_lex_state = 2},
  [455] = {.lex_state = 38, .external_lex_state = 2},
  [456] = {.lex_state = 38, .external_lex_state = 2},
  [457] = {.lex_state = 38, .external_lex_state = 3},
  [458] = {.lex_state = 38, .external_lex_state = 3},
  [459] = {.lex_state = 38, .external_lex_state = 2},
  [460] = {.lex_state = 38, .external_lex_state = 2},
  [461] = {.lex_state = 38, .external_lex_state = 2},
  [462] = {.lex_state = 38, .external_lex_state = 2},
  [463] = {.lex_state = 38, .external_lex_state = 2},
  [464] = {.lex_state = 38, .external_lex_state = 2},
  [465] = {.lex_state = 38, .external_lex_state = 2},
  [466] = {.lex_state = 38, .external_lex_state = 2},
  [467] = {.lex_state = 38, .external_lex_state = 2},
  [468] = {.lex_state = 38, .external_lex_state = 2},
  [469] = {.lex_state = 9},
  [470] = {.lex_state = 10, .external_lex_state = 2},
  [471] = {.lex_state = 10, .external_lex_state = 2},
  [472] = {.lex_state = 10},
  [473] = {.lex_state = 10},
  [474] = {.lex_state = 10},
  [475] = {.lex_state = 10},
  [476] = {.lex_state = 10},
  [477] = {.lex_state = 10},
  [478] = {.lex_state = 10},
  [479] = {.lex_state = 10},
  [480] = {.lex_state = 10},
  [481] = {.lex_state = 10},
  [482] = {.lex_state = 10},
  [483] = {.lex_state = 10},
  [484] = {.lex_state = 10},
  [485] = {.lex_state = 10},
  [486] = {.lex_state = 10},
  [487] = {.lex_state = 10},
  [488] = {.lex_state = 10},
  [489] = {.lex_state = 10},
  [490] = {.lex_state = 10},
  [491] = {.lex_state = 10},
  [492] = {.lex_state = 10},
  [493] = {.lex_state = 10},
  [494] = {.lex_state = 10},
  [495] = {.lex_state = 10},
  [496] = {.lex_state = 10},
  [497] = {.lex_state = 10},
  [498] = {.lex_state = 10},
  [499] = {.lex_state = 10},
  [500] = {.lex_state = 10},
  [501] = {.lex_state = 10},
  [502] = {.lex_state = 10},
  [503] = {.lex_state = 10},
  [504] = {.lex_state = 9},
  [505] = {.lex_state = 10, .external_lex_state = 2},
  [506] = {.lex_state = 10, .external_lex_state = 2},
  [507] = {.lex_state = 10, .external_lex_state = 2},
  [508] = {.lex_state = 38, .external_lex_state = 2},
  [509] = {.lex_state = 38, .external_lex_state = 2},
  [510] = {.lex_state = 10},
  [511] = {.lex_state = 10},
  [512] = {.lex_state = 38, .external_lex_state = 2},
  [513] = {.lex_state = 38, .external_lex_state = 2},
  [514] = {.lex_state = 10},
  [515] = {.lex_state = 10},
  [516] = {.lex_state = 10},
  [517] = {.lex_state = 38, .external_lex_state = 2},
  [518] = {.lex_state = 10},
  [519] = {.lex_state = 10},
  [520] = {.lex_state = 10},
  [521] = {.lex_state = 10},
  [522] = {.lex_state = 38, .external_lex_state = 2},
  [523] = {.lex_state = 38, .external_lex_state = 2},
  [524] = {.lex_state = 38, .external_lex_state = 2},
  [525] = {.lex_state = 38, .external_lex_state = 2},
  [526] = {.lex_state = 10},
  [527] = {.lex_state = 38, .external_lex_state = 2},
  [528] = {.lex_state = 38, .external_lex_state = 2},
  [529] = {.lex_state = 10},
  [530] = {.lex_state = 38, .external_lex_state = 2},
  [531] = {.lex_state = 38, .external_lex_state = 2},
  [532] = {.lex_state = 10, .external_lex_state = 2},
  [533] = {.lex_state = 38, .external_lex_state = 2},
  [534] = {.lex_state = 38, .external_lex_state = 2},
  [535] = {.lex_state = 38, .external_lex_state = 2},
  [536] = {.lex_state = 38, .external_lex_state = 2},
  [537] = {.lex_state = 38, .external_lex_state = 2},
  [538] = {.lex_state = 38, .external_lex_state = 2},
  [539] = {.lex_state = 38, .external_lex_state = 2},
  [540] = {.lex_state = 38, .external_lex_state = 2},
  [541] = {.lex_state = 38, .external_lex_state = 2},
  [542] = {.lex_state = 38, .external_lex_state = 2},
  [543] = {.lex_state = 38, .external_lex_state = 2},
  [544] = {.lex_state = 38, .external_lex_state = 2},
  [545] = {.lex_state = 38, .external_lex_state = 2},
  [546] = {.lex_state = 38, .external_lex_state = 2},
  [547] = {.lex_state = 9},
  [548] = {.lex_state = 38, .external_lex_state = 6},
  [549] = {.lex_state = 38, .external_lex_state = 2},
  [550] = {.lex_state = 38, .external_lex_state = 2},
  [551] = {.lex_state = 38, .external_lex_state = 2},
  [552] = {.lex_state = 38, .external_lex_state = 2},
  [553] = {.lex_state = 38, .external_lex_state = 2},
  [554] = {.lex_state = 38, .external_lex_state = 2},
  [555] = {.lex_state = 38, .external_lex_state = 2},
  [556] = {.lex_state = 38, .external_lex_state = 2},
  [557] = {.lex_state = 38, .external_lex_state = 6},
  [558] = {.lex_state = 38, .external_lex_state = 2},
  [559] = {.lex_state = 38, .external_lex_state = 2},
  [560] = {.lex_state = 38, .external_lex_state = 2},
  [561] = {.lex_state = 38, .external_lex_state = 2},
  [562] = {.lex_state = 38, .external_lex_state = 2},
  [563] = {.lex_state = 38, .external_lex_state = 2},
  [564] = {.lex_state = 10, .external_lex_state = 2},
  [565] = {.lex_state = 38, .external_lex_state = 2},
  [566] = {.lex_state = 10},
  [567] = {.lex_state = 10},
  [568] = {.lex_state = 10},
  [569] = {.lex_state = 10},
  [570] = {.lex_state = 10},
  [571] = {.lex_state = 10},
  [572] = {.lex_state = 10},
  [573] = {.lex_state = 10},
  [574] = {.lex_state = 10},
  [575] = {.lex_state = 10},
  [576] = {.lex_state = 10},
  [577] = {.lex_state = 10},
  [578] = {.lex_state = 10},
  [579] = {.lex_state = 10},
  [580] = {.lex_state = 10},
  [581] = {.lex_state = 10},
  [582] = {.lex_state = 10},
  [583] = {.lex_state = 10},
  [584] = {.lex_state = 10},
  [585] = {.lex_state = 10},
  [586] = {.lex_state = 10},
  [587] = {.lex_state = 10},
  [588] = {.lex_state = 10},
  [589] = {.lex_state = 10},
  [590] = {.lex_state = 10},
  [591] = {.lex_state = 10},
  [592] = {.lex_state = 10},
  [593] = {.lex_state = 10},
  [594] = {.lex_state = 10},
  [595] = {.lex_state = 10},
  [596] = {.lex_state = 10},
  [597] = {.lex_state = 38},
  [598] = {.lex_state = 38},
  [599] = {.lex_state = 38, .external_lex_state = 6},
  [600] = {.lex_state = 38, .external_lex_state = 6},
  [601] = {.lex_state = 38, .external_lex_state = 6},
  [602] = {.lex_state = 38, .external_lex_state = 6},
  [603] = {.lex_state = 38, .external_lex_state = 6},
  [604] = {.lex_state = 38, .external_lex_state = 6},
  [605] = {.lex_state = 38, .external_lex_state = 6},
  [606] = {.lex_state = 38, .external_lex_state = 6},
  [607] = {.lex_state = 38, .external_lex_state = 6},
  [608] = {.lex_state = 38, .external_lex_state = 6},
  [609] = {.lex_state = 38, .external_lex_state = 6},
  [610] = {.lex_state = 10},
  [611] = {.lex_state = 10},
  [612] = {.lex_state = 38, .external_lex_state = 6},
  [613] = {.lex_state = 38, .external_lex_state = 6},
  [614] = {.lex_state = 38, .external_lex_state = 6},
  [615] = {.lex_state = 38, .external_lex_state = 6},
  [616] = {.lex_state = 38},
  [617] = {.lex_state = 38},
  [618] = {.lex_state = 38},
  [619] = {.lex_state = 38},
  [620] = {.lex_state = 38},
  [621] = {.lex_state = 38},
  [622] = {.lex_state = 38},
  [623] = {.lex_state = 0},
  [624] = {.lex_state = 38},
  [625] = {.lex_state = 0},
  [626] = {.lex_state = 38},
  [627] = {.lex_state = 38},
  [628] = {.lex_state = 38},
  [629] = {.lex_state = 0},
  [630] = {.lex_state = 0},
  [631] = {.lex_state = 0},
  [632] = {.lex_state = 38},
  [633] = {.lex_state = 38},
  [634] = {.lex_state = 0},
  [635] = {.lex_state = 38},
  [636] = {.lex_state = 38},
  [637] = {.lex_state = 38},
  [638] = {.lex_state = 38},
  [639] = {.lex_state = 38},
  [640] = {.lex_state = 38},
  [641] = {.lex_state = 0},
  [642] = {.lex_state = 38},
  [643] = {.lex_state = 38},
  [644] = {.lex_state = 0},
  [645] = {.lex_state = 0},
  [646] = {.lex_state = 38},
  [647] = {.lex_state = 38},
  [648] = {.lex_state = 38},
  [649] = {.lex_state = 0},
  [650] = {.lex_state = 0},
  [651] = {.lex_state = 0},
  [652] = {.lex_state = 0},
  [653] = {.lex_state = 0},
  [654] = {.lex_state = 0},
  [655] = {.lex_state = 0},
  [656] = {.lex_state = 0},
  [657] = {.lex_state = 0},
  [658] = {.lex_state = 0},
  [659] = {.lex_state = 0},
  [660] = {.lex_state = 0},
  [661] = {.lex_state = 0},
  [662] = {.lex_state = 0},
  [663] = {.lex_state = 0},
  [664] = {.lex_state = 0},
  [665] = {.lex_state = 0},
  [666] = {.lex_state = 0},
  [667] = {.lex_state = 0},
  [668] = {.lex_state = 38},
  [669] = {.lex_state = 0},
  [670] = {.lex_state = 0},
  [671] = {.lex_state = 0},
  [672] = {.lex_state = 0},
  [673] = {.lex_state = 38},
  [674] = {.lex_state = 12, .external_lex_state = 7},
  [675] = {.lex_state = 12, .external_lex_state = 7},
  [676] = {.lex_state = 0},
  [677] = {.lex_state = 0},
  [678] = {.lex_state = 12, .external_lex_state = 7},
  [679] = {.lex_state = 0},
  [680] = {.lex_state = 0, .external_lex_state = 6},
  [681] = {.lex_state = 10, .external_lex_state = 6},
  [682] = {.lex_state = 38},
  [683] = {.lex_state = 10},
  [684] = {.lex_state = 0, .external_lex_state = 6},
  [685] = {.lex_state = 12, .external_lex_state = 7},
  [686] = {.lex_state = 10, .external_lex_state = 6},
  [687] = {.lex_state = 12, .external_lex_state = 7},
  [688] = {.lex_state = 38},
  [689] = {.lex_state = 38},
  [690] = {.lex_state = 0},
  [691] = {.lex_state = 0, .external_lex_state = 6},
  [692] = {.lex_state = 12, .external_lex_state = 7},
  [693] = {.lex_state = 0},
  [694] = {.lex_state = 12, .external_lex_state = 7},
  [695] = {.lex_state = 12, .external_lex_state = 7},
  [696] = {.lex_state = 0},
  [697] = {.lex_state = 38},
  [698] = {.lex_state = 38},
  [699] = {.lex_state = 10, .external_lex_state = 6},
  [700] = {.lex_state = 0},
  [701] = {.lex_state = 0},
  [702] = {.lex_state = 38},
  [703] = {.lex_state = 12, .external_lex_state = 7},
  [704] = {.lex_state = 38},
  [705] = {.lex_state = 38},
  [706] = {.lex_state = 38},
  [707] = {.lex_state = 10},
  [708] = {.lex_state = 10, .external_lex_state = 6},
  [709] = {.lex_state = 38},
  [710] = {.lex_state = 0},
  [711] = {.lex_state = 38},
  [712] = {.lex_state = 38},
  [713] = {.lex_state = 0},
  [714] = {.lex_state = 0, .external_lex_state = 6},
  [715] = {.lex_state = 10},
  [716] = {.lex_state = 38},
  [717] = {.lex_state = 38},
  [718] = {.lex_state = 0},
  [719] = {.lex_state = 38},
  [720] = {.lex_state = 38},
  [721] = {.lex_state = 0},
  [722] = {.lex_state = 38},
  [723] = {.lex_state = 38},
  [724] = {.lex_state = 10},
  [725] = {.lex_state = 0},
  [726] = {.lex_state = 0, .external_lex_state = 6},
  [727] = {.lex_state = 38},
  [728] = {.lex_state = 38},
  [729] = {.lex_state = 38},
  [730] = {.lex_state = 38},
  [731] = {.lex_state = 38},
  [732] = {.lex_state = 0, .external_lex_state = 6},
  [733] = {.lex_state = 38},
  [734] = {.lex_state = 38},
  [735] = {.lex_state = 4},
  [736] = {.lex_state = 12, .external_lex_state = 7},
  [737] = {.lex_state = 0},
  [738] = {.lex_state = 0, .external_lex_state = 6},
  [739] = {.lex_state = 0},
  [740] = {.lex_state = 0},
  [741] = {.lex_state = 38},
  [742] = {.lex_state = 0},
  [743] = {.lex_state = 0},
  [744] = {.lex_state = 0},
  [745] = {.lex_state = 0, .external_lex_state = 6},
  [746] = {.lex_state = 0},
  [747] = {.lex_state = 0},
  [748] = {.lex_state = 0},
  [749] = {.lex_state = 0},
  [750] = {.lex_state = 12, .external_lex_state = 7},
  [751] = {.lex_state = 0, .external_lex_state = 6},
  [752] = {.lex_state = 0},
  [753] = {.lex_state = 0, .external_lex_state = 6},
  [754] = {.lex_state = 4},
  [755] = {.lex_state = 12, .external_lex_state = 7},
  [756] = {.lex_state = 10},
  [757] = {.lex_state = 0, .external_lex_state = 6},
  [758] = {.lex_state = 0, .external_lex_state = 6},
  [759] = {.lex_state = 38},
  [760] = {.lex_state = 38},
  [761] = {.lex_state = 0},
  [762] = {.lex_state = 4},
  [763] = {.lex_state = 0},
  [764] = {.lex_state = 38},
  [765] = {.lex_state = 0},
  [766] = {.lex_state = 0},
  [767] = {.lex_state = 0, .external_lex_state = 6},
  [768] = {.lex_state = 38},
  [769] = {.lex_state = 38},
  [770] = {.lex_state = 38},
  [771] = {.lex_state = 0},
  [772] = {.lex_state = 38},
  [773] = {.lex_state = 10},
  [774] = {.lex_state = 0, .external_lex_state = 6},
  [775] = {.lex_state = 0},
  [776] = {.lex_state = 38},
  [777] = {.lex_state = 0},
  [778] = {.lex_state = 0, .external_lex_state = 6},
  [779] = {.lex_state = 38},
  [780] = {.lex_state = 38},
  [781] = {.lex_state = 0, .external_lex_state = 6},
  [782] = {.lex_state = 0},
  [783] = {.lex_state = 38},
  [784] = {.lex_state = 38},
  [785] = {.lex_state = 0},
  [786] = {.lex_state = 0, .external_lex_state = 6},
  [787] = {.lex_state = 0, .external_lex_state = 6},
  [788] = {.lex_state = 0, .external_lex_state = 6},
  [789] = {.lex_state = 0},
  [790] = {.lex_state = 0, .external_lex_state = 6},
  [791] = {.lex_state = 0, .external_lex_state = 6},
  [792] = {.lex_state = 0, .external_lex_state = 6},
  [793] = {.lex_state = 38},
  [794] = {.lex_state = 0},
  [795] = {.lex_state = 38},
  [796] = {.lex_state = 0, .external_lex_state = 6},
  [797] = {.lex_state = 0},
  [798] = {.lex_state = 0, .external_lex_state = 6},
  [799] = {.lex_state = 0, .external_lex_state = 6},
  [800] = {.lex_state = 38},
  [801] = {.lex_state = 0, .external_lex_state = 6},
  [802] = {.lex_state = 38},
  [803] = {.lex_state = 10},
  [804] = {.lex_state = 0},
  [805] = {.lex_state = 0, .external_lex_state = 6},
  [806] = {.lex_state = 38},
  [807] = {.lex_state = 38},
  [808] = {.lex_state = 0},
  [809] = {.lex_state = 0},
  [810] = {.lex_state = 38},
  [811] = {.lex_state = 38},
  [812] = {.lex_state = 0},
  [813] = {.lex_state = 0},
  [814] = {.lex_state = 0},
  [815] = {.lex_state = 0, .external_lex_state = 6},
  [816] = {.lex_state = 0},
  [817] = {.lex_state = 0},
  [818] = {.lex_state = 0},
  [819] = {.lex_state = 0, .external_lex_state = 6},
  [820] = {.lex_state = 0, .external_lex_state = 6},
  [821] = {.lex_state = 0},
  [822] = {.lex_state = 38},
  [823] = {.lex_state = 0},
  [824] = {.lex_state = 0, .external_lex_state = 6},
  [825] = {.lex_state = 0},
  [826] = {.lex_state = 0, .external_lex_state = 6},
  [827] = {.lex_state = 38},
  [828] = {.lex_state = 0, .external_lex_state = 6},
  [829] = {.lex_state = 0},
  [830] = {.lex_state = 0},
  [831] = {.lex_state = 0, .external_lex_state = 6},
  [832] = {.lex_state = 0},
  [833] = {.lex_state = 0},
  [834] = {.lex_state = 38},
  [835] = {.lex_state = 38},
  [836] = {.lex_state = 0},
  [837] = {.lex_state = 38},
  [838] = {.lex_state = 0, .external_lex_state = 6},
  [839] = {.lex_state = 0},
  [840] = {.lex_state = 0},
  [841] = {.lex_state = 0},
  [842] = {.lex_state = 0},
  [843] = {.lex_state = 0},
  [844] = {.lex_state = 0, .external_lex_state = 6},
  [845] = {.lex_state = 0},
  [846] = {.lex_state = 0},
  [847] = {.lex_state = 38},
  [848] = {.lex_state = 38},
  [849] = {.lex_state = 0},
  [850] = {.lex_state = 0},
  [851] = {.lex_state = 38},
  [852] = {.lex_state = 0},
  [853] = {.lex_state = 38},
  [854] = {.lex_state = 38},
  [855] = {.lex_state = 0},
  [856] = {.lex_state = 38},
  [857] = {.lex_state = 0},
  [858] = {.lex_state = 0},
  [859] = {.lex_state = 0},
  [860] = {.lex_state = 0},
  [861] = {.lex_state = 0, .external_lex_state = 6},
  [862] = {.lex_state = 0},
  [863] = {.lex_state = 0},
  [864] = {.lex_state = 0},
  [865] = {.lex_state = 0},
  [866] = {.lex_state = 0},
  [867] = {.lex_state = 38},
  [868] = {.lex_state = 38},
  [869] = {.lex_state = 0},
  [870] = {.lex_state = 38},
  [871] = {.lex_state = 0},
  [872] = {.lex_state = 0},
  [873] = {.lex_state = 38},
  [874] = {.lex_state = 0},
  [875] = {.lex_state = 0, .external_lex_state = 6},
  [876] = {.lex_state = 38},
  [877] = {.lex_state = 0},
  [878] = {.lex_state = 38},
  [879] = {.lex_state = 38},
  [880] = {.lex_state = 0},
  [881] = {.lex_state = 38},
  [882] = {.lex_state = 0, .external_lex_state = 6},
  [883] = {.lex_state = 4},
  [884] = {.lex_state = 0},
  [885] = {.lex_state = 0, .external_lex_state = 6},
  [886] = {.lex_state = 0},
  [887] = {.lex_state = 0},
  [888] = {.lex_state = 0},
  [889] = {.lex_state = 0},
  [890] = {.lex_state = 0},
  [891] = {.lex_state = 0, .external_lex_state = 6},
  [892] = {.lex_state = 0},
  [893] = {.lex_state = 0, .external_lex_state = 6},
  [894] = {.lex_state = 0},
  [895] = {.lex_state = 38},
  [896] = {.lex_state = 0},
  [897] = {.lex_state = 0},
  [898] = {.lex_state = 0},
  [899] = {.lex_state = 0},
  [900] = {.lex_state = 0},
  [901] = {.lex_state = 0, .external_lex_state = 6},
  [902] = {.lex_state = 0},
  [903] = {.lex_state = 0},
  [904] = {.lex_state = 0},
  [905] = {.lex_state = 38},
  [906] = {.lex_state = 38},
  [907] = {.lex_state = 0},
  [908] = {.lex_state = 0},
  [909] = {.lex_state = 0, .external_lex_state = 6},
  [910] = {.lex_state = 0},
  [911] = {.lex_state = 0, .external_lex_state = 6},
  [912] = {.lex_state = 0},
  [913] = {.lex_state = 0, .external_lex_state = 6},
  [914] = {.lex_state = 0},
  [915] = {.lex_state = 11},
  [916] = {.lex_state = 0},
  [917] = {.lex_state = 0},
  [918] = {.lex_state = 0},
  [919] = {.lex_state = 0},
  [920] = {.lex_state = 0, .external_lex_state = 6},
  [921] = {.lex_state = 0, .external_lex_state = 6},
  [922] = {.lex_state = 0, .external_lex_state = 6},
  [923] = {.lex_state = 0, .external_lex_state = 6},
  [924] = {.lex_state = 0},
  [925] = {.lex_state = 0, .external_lex_state = 6},
  [926] = {.lex_state = 11},
  [927] = {.lex_state = 11},
  [928] = {.lex_state = 0, .external_lex_state = 6},
  [929] = {.lex_state = 0, .external_lex_state = 6},
  [930] = {.lex_state = 38},
  [931] = {.lex_state = 11},
  [932] = {.lex_state = 0},
  [933] = {.lex_state = 0},
  [934] = {.lex_state = 0, .external_lex_state = 6},
  [935] = {.lex_state = 38},
  [936] = {.lex_state = 0, .external_lex_state = 6},
  [937] = {.lex_state = 0},
  [938] = {.lex_state = 0},
  [939] = {.lex_state = 11},
  [940] = {.lex_state = 0, .external_lex_state = 6},
  [941] = {.lex_state = 0},
  [942] = {.lex_state = 0},
  [943] = {.lex_state = 0, .external_lex_state = 6},
  [944] = {.lex_state = 0, .external_lex_state = 6},
  [945] = {.lex_state = 0},
  [946] = {.lex_state = 11},
  [947] = {.lex_state = 0},
  [948] = {.lex_state = 0},
  [949] = {.lex_state = 0, .external_lex_state = 6},
  [950] = {.lex_state = 0, .external_lex_state = 6},
  [951] = {.lex_state = 0},
  [952] = {.lex_state = 0},
  [953] = {.lex_state = 0},
  [954] = {.lex_state = 0},
  [955] = {.lex_state = 38},
  [956] = {.lex_state = 0},
  [957] = {.lex_state = 0},
  [958] = {.lex_state = 0},
  [959] = {.lex_state = 0},
  [960] = {.lex_state = 0},
  [961] = {.lex_state = 38},
  [962] = {.lex_state = 0},
  [963] = {.lex_state = 0},
  [964] = {.lex_state = 0},
  [965] = {.lex_state = 0},
  [966] = {.lex_state = 0},
  [967] = {.lex_state = 0},
  [968] = {.lex_state = 0},
  [969] = {.lex_state = 0},
  [970] = {.lex_state = 0},
  [971] = {.lex_state = 38},
  [972] = {.lex_state = 38},
  [973] = {.lex_state = 0},
  [974] = {.lex_state = 0},
  [975] = {.lex_state = 0},
  [976] = {.lex_state = 0},
  [977] = {.lex_state = 0},
  [978] = {.lex_state = 38},
  [979] = {.lex_state = 0},
  [980] = {.lex_state = 0},
  [981] = {.lex_state = 0},
  [982] = {.lex_state = 0},
  [983] = {.lex_state = 0},
  [984] = {.lex_state = 0},
  [985] = {.lex_state = 0},
  [986] = {.lex_state = 0},
  [987] = {.lex_state = 0},
  [988] = {.lex_state = 0},
  [989] = {.lex_state = 0},
  [990] = {.lex_state = 0},
  [991] = {.lex_state = 0},
  [992] = {.lex_state = 38},
  [993] = {.lex_state = 0},
  [994] = {.lex_state = 0},
  [995] = {.lex_state = 0},
  [996] = {.lex_state = 0},
  [997] = {.lex_state = 0},
  [998] = {.lex_state = 38},
  [999] = {.lex_state = 0},
  [1000] = {.lex_state = 38},
  [1001] = {.lex_state = 0},
  [1002] = {.lex_state = 0},
  [1003] = {.lex_state = 38},
  [1004] = {.lex_state = 0},
  [1005] = {.lex_state = 38},
  [1006] = {.lex_state = 38},
  [1007] = {.lex_state = 38},
  [1008] = {.lex_state = 0},
  [1009] = {.lex_state = 38},
  [1010] = {.lex_state = 0},
  [1011] = {.lex_state = 38},
  [1012] = {.lex_state = 38},
  [1013] = {.lex_state = 0},
  [1014] = {.lex_state = 0},
  [1015] = {.lex_state = 0},
  [1016] = {.lex_state = 0},
  [1017] = {.lex_state = 38},
  [1018] = {.lex_state = 38},
  [1019] = {.lex_state = 0},
  [1020] = {.lex_state = 38},
  [1021] = {.lex_state = 0},
  [1022] = {.lex_state = 0},
  [1023] = {.lex_state = 0},
  [1024] = {.lex_state = 0},
  [1025] = {.lex_state = 0},
  [1026] = {.lex_state = 0},
  [1027] = {.lex_state = 0, .external_lex_state = 6},
  [1028] = {.lex_state = 38},
  [1029] = {.lex_state = 38},
  [1030] = {.lex_state = 0},
  [1031] = {.lex_state = 0},
  [1032] = {.lex_state = 0},
  [1033] = {.lex_state = 0},
  [1034] = {.lex_state = 0},
  [1035] = {.lex_state = 0},
  [1036] = {.lex_state = 38},
};

enum {
  ts_external_token__newline = 0,
  ts_external_token__indent = 1,
  ts_external_token__dedent = 2,
  ts_external_token__string_start = 3,
  ts_external_token__string_content = 4,
  ts_external_token__string_end = 5,
};

static TSSymbol ts_external_scanner_symbol_map[EXTERNAL_TOKEN_COUNT] = {
  [ts_external_token__newline] = sym__newline,
  [ts_external_token__indent] = sym__indent,
  [ts_external_token__dedent] = sym__dedent,
  [ts_external_token__string_start] = sym__string_start,
  [ts_external_token__string_content] = sym__string_content,
  [ts_external_token__string_end] = sym__string_end,
};

static bool ts_external_scanner_states[8][EXTERNAL_TOKEN_COUNT] = {
  [1] = {
    [ts_external_token__newline] = true,
    [ts_external_token__indent] = true,
    [ts_external_token__dedent] = true,
    [ts_external_token__string_start] = true,
    [ts_external_token__string_content] = true,
    [ts_external_token__string_end] = true,
  },
  [2] = {
    [ts_external_token__string_start] = true,
  },
  [3] = {
    [ts_external_token__dedent] = true,
    [ts_external_token__string_start] = true,
  },
  [4] = {
    [ts_external_token__newline] = true,
    [ts_external_token__string_start] = true,
  },
  [5] = {
    [ts_external_token__indent] = true,
    [ts_external_token__string_start] = true,
  },
  [6] = {
    [ts_external_token__newline] = true,
  },
  [7] = {
    [ts_external_token__string_content] = true,
    [ts_external_token__string_end] = true,
  },
};

static uint16_t ts_parse_table[STATE_COUNT][SYMBOL_COUNT] = {
  [0] = {
    [ts_builtin_sym_end] = ACTIONS(1),
    [sym_identifier] = ACTIONS(1),
    [anon_sym_import] = ACTIONS(1),
    [anon_sym_DOT] = ACTIONS(1),
    [anon_sym_from] = ACTIONS(1),
    [anon_sym___future__] = ACTIONS(1),
    [anon_sym_LPAREN] = ACTIONS(1),
    [anon_sym_RPAREN] = ACTIONS(1),
    [anon_sym_COMMA] = ACTIONS(1),
    [anon_sym_as] = ACTIONS(1),
    [anon_sym_STAR] = ACTIONS(1),
    [anon_sym_print] = ACTIONS(1),
    [anon_sym_GT_GT] = ACTIONS(1),
    [anon_sym_assert] = ACTIONS(1),
    [anon_sym_COLON_EQ] = ACTIONS(1),
    [anon_sym_return] = ACTIONS(1),
    [anon_sym_del] = ACTIONS(1),
    [anon_sym_raise] = ACTIONS(1),
    [anon_sym_pass] = ACTIONS(1),
    [anon_sym_break] = ACTIONS(1),
    [anon_sym_continue] = ACTIONS(1),
    [anon_sym_if] = ACTIONS(1),
    [anon_sym_COLON] = ACTIONS(1),
    [anon_sym_elif] = ACTIONS(1),
    [anon_sym_else] = ACTIONS(1),
    [anon_sym_async] = ACTIONS(1),
    [anon_sym_for] = ACTIONS(1),
    [anon_sym_in] = ACTIONS(1),
    [anon_sym_while] = ACTIONS(1),
    [anon_sym_try] = ACTIONS(1),
    [anon_sym_except] = ACTIONS(1),
    [anon_sym_finally] = ACTIONS(1),
    [anon_sym_with] = ACTIONS(1),
    [anon_sym_def] = ACTIONS(1),
    [anon_sym_DASH_GT] = ACTIONS(1),
    [anon_sym_EQ] = ACTIONS(1),
    [anon_sym_STAR_STAR] = ACTIONS(1),
    [anon_sym_global] = ACTIONS(1),
    [anon_sym_nonlocal] = ACTIONS(1),
    [anon_sym_exec] = ACTIONS(1),
    [anon_sym_class] = ACTIONS(1),
    [anon_sym_AT] = ACTIONS(1),
    [anon_sym_not] = ACTIONS(1),
    [anon_sym_and] = ACTIONS(1),
    [anon_sym_or] = ACTIONS(1),
    [anon_sym_PLUS] = ACTIONS(1),
    [anon_sym_DASH] = ACTIONS(1),
    [anon_sym_SLASH] = ACTIONS(1),
    [anon_sym_PERCENT] = ACTIONS(1),
    [anon_sym_SLASH_SLASH] = ACTIONS(1),
    [anon_sym_PIPE] = ACTIONS(1),
    [anon_sym_AMP] = ACTIONS(1),
    [anon_sym_CARET] = ACTIONS(1),
    [anon_sym_LT_LT] = ACTIONS(1),
    [anon_sym_TILDE] = ACTIONS(1),
    [anon_sym_LT] = ACTIONS(1),
    [anon_sym_LT_EQ] = ACTIONS(1),
    [anon_sym_EQ_EQ] = ACTIONS(1),
    [anon_sym_BANG_EQ] = ACTIONS(1),
    [anon_sym_GT_EQ] = ACTIONS(1),
    [anon_sym_GT] = ACTIONS(1),
    [anon_sym_LT_GT] = ACTIONS(1),
    [anon_sym_is] = ACTIONS(1),
    [anon_sym_lambda] = ACTIONS(1),
    [anon_sym_PLUS_EQ] = ACTIONS(1),
    [anon_sym_DASH_EQ] = ACTIONS(1),
    [anon_sym_STAR_EQ] = ACTIONS(1),
    [anon_sym_SLASH_EQ] = ACTIONS(1),
    [anon_sym_AT_EQ] = ACTIONS(1),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(1),
    [anon_sym_PERCENT_EQ] = ACTIONS(1),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1),
    [anon_sym_GT_GT_EQ] = ACTIONS(1),
    [anon_sym_LT_LT_EQ] = ACTIONS(1),
    [anon_sym_AMP_EQ] = ACTIONS(1),
    [anon_sym_CARET_EQ] = ACTIONS(1),
    [anon_sym_PIPE_EQ] = ACTIONS(1),
    [anon_sym_yield] = ACTIONS(1),
    [anon_sym_LBRACK] = ACTIONS(1),
    [anon_sym_RBRACK] = ACTIONS(1),
    [sym_ellipsis] = ACTIONS(1),
    [anon_sym_LBRACE] = ACTIONS(1),
    [anon_sym_RBRACE] = ACTIONS(1),
    [sym_type_conversion] = ACTIONS(1),
    [sym_integer] = ACTIONS(1),
    [sym_float] = ACTIONS(1),
    [sym_true] = ACTIONS(1),
    [sym_false] = ACTIONS(1),
    [sym_none] = ACTIONS(1),
    [anon_sym_await] = ACTIONS(1),
    [sym_comment] = ACTIONS(3),
    [sym__semicolon] = ACTIONS(1),
    [sym__newline] = ACTIONS(1),
    [sym__indent] = ACTIONS(1),
    [sym__dedent] = ACTIONS(1),
    [sym__string_start] = ACTIONS(1),
    [sym__string_content] = ACTIONS(1),
    [sym__string_end] = ACTIONS(1),
  },
  [1] = {
    [sym_module] = STATE(994),
    [sym__statement] = STATE(42),
    [sym__simple_statements] = STATE(42),
    [sym_import_statement] = STATE(831),
    [sym_future_import_statement] = STATE(831),
    [sym_import_from_statement] = STATE(831),
    [sym_print_statement] = STATE(831),
    [sym_assert_statement] = STATE(831),
    [sym_expression_statement] = STATE(831),
    [sym_named_expression] = STATE(601),
    [sym_return_statement] = STATE(831),
    [sym_delete_statement] = STATE(831),
    [sym_raise_statement] = STATE(831),
    [sym_pass_statement] = STATE(831),
    [sym_break_statement] = STATE(831),
    [sym_continue_statement] = STATE(831),
    [sym_if_statement] = STATE(42),
    [sym_for_statement] = STATE(42),
    [sym_while_statement] = STATE(42),
    [sym_try_statement] = STATE(42),
    [sym_with_statement] = STATE(42),
    [sym_function_definition] = STATE(42),
    [sym_global_statement] = STATE(831),
    [sym_nonlocal_statement] = STATE(831),
    [sym_exec_statement] = STATE(831),
    [sym_class_definition] = STATE(42),
    [sym_decorated_definition] = STATE(42),
    [sym_decorator] = STATE(669),
    [sym_expression_list] = STATE(618),
    [sym__expression] = STATE(601),
    [sym__primary_expression] = STATE(109),
    [sym_not_operator] = STATE(601),
    [sym_boolean_operator] = STATE(601),
    [sym_binary_operator] = STATE(109),
    [sym_unary_operator] = STATE(109),
    [sym_comparison_operator] = STATE(601),
    [sym_lambda] = STATE(601),
    [sym_assignment] = STATE(936),
    [sym_augmented_assignment] = STATE(936),
    [sym_yield] = STATE(936),
    [sym_attribute] = STATE(109),
    [sym_subscript] = STATE(109),
    [sym_call] = STATE(109),
    [sym_list] = STATE(109),
    [sym_list_comprehension] = STATE(109),
    [sym_dictionary] = STATE(109),
    [sym_dictionary_comprehension] = STATE(109),
    [sym_set] = STATE(109),
    [sym_set_comprehension] = STATE(109),
    [sym_parenthesized_expression] = STATE(109),
    [sym_tuple] = STATE(109),
    [sym_generator_expression] = STATE(109),
    [sym_conditional_expression] = STATE(601),
    [sym_concatenated_string] = STATE(109),
    [sym_string] = STATE(117),
    [sym_await] = STATE(601),
    [aux_sym_module_repeat1] = STATE(42),
    [aux_sym_decorated_definition_repeat1] = STATE(669),
    [ts_builtin_sym_end] = ACTIONS(5),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_import] = ACTIONS(9),
    [anon_sym_from] = ACTIONS(11),
    [anon_sym_LPAREN] = ACTIONS(13),
    [anon_sym_print] = ACTIONS(15),
    [anon_sym_assert] = ACTIONS(17),
    [anon_sym_return] = ACTIONS(19),
    [anon_sym_del] = ACTIONS(21),
    [anon_sym_raise] = ACTIONS(23),
    [anon_sym_pass] = ACTIONS(25),
    [anon_sym_break] = ACTIONS(27),
    [anon_sym_continue] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_async] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [anon_sym_try] = ACTIONS(39),
    [anon_sym_with] = ACTIONS(41),
    [anon_sym_def] = ACTIONS(43),
    [anon_sym_global] = ACTIONS(45),
    [anon_sym_nonlocal] = ACTIONS(47),
    [anon_sym_exec] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(51),
    [anon_sym_AT] = ACTIONS(53),
    [anon_sym_not] = ACTIONS(55),
    [anon_sym_PLUS] = ACTIONS(57),
    [anon_sym_DASH] = ACTIONS(57),
    [anon_sym_TILDE] = ACTIONS(57),
    [anon_sym_lambda] = ACTIONS(59),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [sym_ellipsis] = ACTIONS(65),
    [anon_sym_LBRACE] = ACTIONS(67),
    [sym_integer] = ACTIONS(69),
    [sym_float] = ACTIONS(65),
    [sym_true] = ACTIONS(69),
    [sym_false] = ACTIONS(69),
    [sym_none] = ACTIONS(69),
    [anon_sym_await] = ACTIONS(71),
    [sym_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(73),
  },
  [2] = {
    [sym__statement] = STATE(44),
    [sym__simple_statements] = STATE(44),
    [sym_import_statement] = STATE(861),
    [sym_future_import_statement] = STATE(861),
    [sym_import_from_statement] = STATE(861),
    [sym_print_statement] = STATE(861),
    [sym_assert_statement] = STATE(861),
    [sym_expression_statement] = STATE(861),
    [sym_named_expression] = STATE(601),
    [sym_return_statement] = STATE(861),
    [sym_delete_statement] = STATE(861),
    [sym_raise_statement] = STATE(861),
    [sym_pass_statement] = STATE(861),
    [sym_break_statement] = STATE(861),
    [sym_continue_statement] = STATE(861),
    [sym_if_statement] = STATE(44),
    [sym_for_statement] = STATE(44),
    [sym_while_statement] = STATE(44),
    [sym_try_statement] = STATE(44),
    [sym_with_statement] = STATE(44),
    [sym_function_definition] = STATE(44),
    [sym_global_statement] = STATE(861),
    [sym_nonlocal_statement] = STATE(861),
    [sym_exec_statement] = STATE(861),
    [sym_class_definition] = STATE(44),
    [sym_decorated_definition] = STATE(44),
    [sym_decorator] = STATE(667),
    [sym_block] = STATE(355),
    [sym_expression_list] = STATE(618),
    [sym__expression] = STATE(601),
    [sym__primary_expression] = STATE(109),
    [sym_not_operator] = STATE(601),
    [sym_boolean_operator] = STATE(601),
    [sym_binary_operator] = STATE(109),
    [sym_unary_operator] = STATE(109),
    [sym_comparison_operator] = STATE(601),
    [sym_lambda] = STATE(601),
    [sym_assignment] = STATE(936),
    [sym_augmented_assignment] = STATE(936),
    [sym_yield] = STATE(936),
    [sym_attribute] = STATE(109),
    [sym_subscript] = STATE(109),
    [sym_call] = STATE(109),
    [sym_list] = STATE(109),
    [sym_list_comprehension] = STATE(109),
    [sym_dictionary] = STATE(109),
    [sym_dictionary_comprehension] = STATE(109),
    [sym_set] = STATE(109),
    [sym_set_comprehension] = STATE(109),
    [sym_parenthesized_expression] = STATE(109),
    [sym_tuple] = STATE(109),
    [sym_generator_expression] = STATE(109),
    [sym_conditional_expression] = STATE(601),
    [sym_concatenated_string] = STATE(109),
    [sym_string] = STATE(117),
    [sym_await] = STATE(601),
    [aux_sym_module_repeat1] = STATE(44),
    [aux_sym_decorated_definition_repeat1] = STATE(667),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_import] = ACTIONS(9),
    [anon_sym_from] = ACTIONS(11),
    [anon_sym_LPAREN] = ACTIONS(13),
    [anon_sym_print] = ACTIONS(15),
    [anon_sym_assert] = ACTIONS(17),
    [anon_sym_return] = ACTIONS(19),
    [anon_sym_del] = ACTIONS(21),
    [anon_sym_raise] = ACTIONS(23),
    [anon_sym_pass] = ACTIONS(25),
    [anon_sym_break] = ACTIONS(27),
    [anon_sym_continue] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(75),
    [anon_sym_async] = ACTIONS(77),
    [anon_sym_for] = ACTIONS(79),
    [anon_sym_while] = ACTIONS(81),
    [anon_sym_try] = ACTIONS(83),
    [anon_sym_with] = ACTIONS(85),
    [anon_sym_def] = ACTIONS(87),
    [anon_sym_global] = ACTIONS(45),
    [anon_sym_nonlocal] = ACTIONS(47),
    [anon_sym_exec] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(89),
    [anon_sym_AT] = ACTIONS(53),
    [anon_sym_not] = ACTIONS(55),
    [anon_sym_PLUS] = ACTIONS(57),
    [anon_sym_DASH] = ACTIONS(57),
    [anon_sym_TILDE] = ACTIONS(57),
    [anon_sym_lambda] = ACTIONS(59),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [sym_ellipsis] = ACTIONS(65),
    [anon_sym_LBRACE] = ACTIONS(67),
    [sym_integer] = ACTIONS(69),
    [sym_float] = ACTIONS(65),
    [sym_true] = ACTIONS(69),
    [sym_false] = ACTIONS(69),
    [sym_none] = ACTIONS(69),
    [anon_sym_await] = ACTIONS(71),
    [sym_comment] = ACTIONS(3),
    [sym__dedent] = ACTIONS(91),
    [sym__string_start] = ACTIONS(73),
  },
  [3] = {
    [sym__statement] = STATE(47),
    [sym__simple_statements] = STATE(47),
    [sym_import_statement] = STATE(861),
    [sym_future_import_statement] = STATE(861),
    [sym_import_from_statement] = STATE(861),
    [sym_print_statement] = STATE(861),
    [sym_assert_statement] = STATE(861),
    [sym_expression_statement] = STATE(861),
    [sym_named_expression] = STATE(601),
    [sym_return_statement] = STATE(861),
    [sym_delete_statement] = STATE(861),
    [sym_raise_statement] = STATE(861),
    [sym_pass_statement] = STATE(861),
    [sym_break_statement] = STATE(861),
    [sym_continue_statement] = STATE(861),
    [sym_if_statement] = STATE(47),
    [sym_for_statement] = STATE(47),
    [sym_while_statement] = STATE(47),
    [sym_try_statement] = STATE(47),
    [sym_with_statement] = STATE(47),
    [sym_function_definition] = STATE(47),
    [sym_global_statement] = STATE(861),
    [sym_nonlocal_statement] = STATE(861),
    [sym_exec_statement] = STATE(861),
    [sym_class_definition] = STATE(47),
    [sym_decorated_definition] = STATE(47),
    [sym_decorator] = STATE(667),
    [sym_block] = STATE(367),
    [sym_expression_list] = STATE(618),
    [sym__expression] = STATE(601),
    [sym__primary_expression] = STATE(109),
    [sym_not_operator] = STATE(601),
    [sym_boolean_operator] = STATE(601),
    [sym_binary_operator] = STATE(109),
    [sym_unary_operator] = STATE(109),
    [sym_comparison_operator] = STATE(601),
    [sym_lambda] = STATE(601),
    [sym_assignment] = STATE(936),
    [sym_augmented_assignment] = STATE(936),
    [sym_yield] = STATE(936),
    [sym_attribute] = STATE(109),
    [sym_subscript] = STATE(109),
    [sym_call] = STATE(109),
    [sym_list] = STATE(109),
    [sym_list_comprehension] = STATE(109),
    [sym_dictionary] = STATE(109),
    [sym_dictionary_comprehension] = STATE(109),
    [sym_set] = STATE(109),
    [sym_set_comprehension] = STATE(109),
    [sym_parenthesized_expression] = STATE(109),
    [sym_tuple] = STATE(109),
    [sym_generator_expression] = STATE(109),
    [sym_conditional_expression] = STATE(601),
    [sym_concatenated_string] = STATE(109),
    [sym_string] = STATE(117),
    [sym_await] = STATE(601),
    [aux_sym_module_repeat1] = STATE(47),
    [aux_sym_decorated_definition_repeat1] = STATE(667),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_import] = ACTIONS(9),
    [anon_sym_from] = ACTIONS(11),
    [anon_sym_LPAREN] = ACTIONS(13),
    [anon_sym_print] = ACTIONS(15),
    [anon_sym_assert] = ACTIONS(17),
    [anon_sym_return] = ACTIONS(19),
    [anon_sym_del] = ACTIONS(21),
    [anon_sym_raise] = ACTIONS(23),
    [anon_sym_pass] = ACTIONS(25),
    [anon_sym_break] = ACTIONS(27),
    [anon_sym_continue] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(75),
    [anon_sym_async] = ACTIONS(77),
    [anon_sym_for] = ACTIONS(79),
    [anon_sym_while] = ACTIONS(81),
    [anon_sym_try] = ACTIONS(83),
    [anon_sym_with] = ACTIONS(85),
    [anon_sym_def] = ACTIONS(87),
    [anon_sym_global] = ACTIONS(45),
    [anon_sym_nonlocal] = ACTIONS(47),
    [anon_sym_exec] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(89),
    [anon_sym_AT] = ACTIONS(53),
    [anon_sym_not] = ACTIONS(55),
    [anon_sym_PLUS] = ACTIONS(57),
    [anon_sym_DASH] = ACTIONS(57),
    [anon_sym_TILDE] = ACTIONS(57),
    [anon_sym_lambda] = ACTIONS(59),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [sym_ellipsis] = ACTIONS(65),
    [anon_sym_LBRACE] = ACTIONS(67),
    [sym_integer] = ACTIONS(69),
    [sym_float] = ACTIONS(65),
    [sym_true] = ACTIONS(69),
    [sym_false] = ACTIONS(69),
    [sym_none] = ACTIONS(69),
    [anon_sym_await] = ACTIONS(71),
    [sym_comment] = ACTIONS(3),
    [sym__dedent] = ACTIONS(93),
    [sym__string_start] = ACTIONS(73),
  },
  [4] = {
    [sym__statement] = STATE(43),
    [sym__simple_statements] = STATE(43),
    [sym_import_statement] = STATE(861),
    [sym_future_import_statement] = STATE(861),
    [sym_import_from_statement] = STATE(861),
    [sym_print_statement] = STATE(861),
    [sym_assert_statement] = STATE(861),
    [sym_expression_statement] = STATE(861),
    [sym_named_expression] = STATE(601),
    [sym_return_statement] = STATE(861),
    [sym_delete_statement] = STATE(861),
    [sym_raise_statement] = STATE(861),
    [sym_pass_statement] = STATE(861),
    [sym_break_statement] = STATE(861),
    [sym_continue_statement] = STATE(861),
    [sym_if_statement] = STATE(43),
    [sym_for_statement] = STATE(43),
    [sym_while_statement] = STATE(43),
    [sym_try_statement] = STATE(43),
    [sym_with_statement] = STATE(43),
    [sym_function_definition] = STATE(43),
    [sym_global_statement] = STATE(861),
    [sym_nonlocal_statement] = STATE(861),
    [sym_exec_statement] = STATE(861),
    [sym_class_definition] = STATE(43),
    [sym_decorated_definition] = STATE(43),
    [sym_decorator] = STATE(667),
    [sym_block] = STATE(743),
    [sym_expression_list] = STATE(618),
    [sym__expression] = STATE(601),
    [sym__primary_expression] = STATE(109),
    [sym_not_operator] = STATE(601),
    [sym_boolean_operator] = STATE(601),
    [sym_binary_operator] = STATE(109),
    [sym_unary_operator] = STATE(109),
    [sym_comparison_operator] = STATE(601),
    [sym_lambda] = STATE(601),
    [sym_assignment] = STATE(936),
    [sym_augmented_assignment] = STATE(936),
    [sym_yield] = STATE(936),
    [sym_attribute] = STATE(109),
    [sym_subscript] = STATE(109),
    [sym_call] = STATE(109),
    [sym_list] = STATE(109),
    [sym_list_comprehension] = STATE(109),
    [sym_dictionary] = STATE(109),
    [sym_dictionary_comprehension] = STATE(109),
    [sym_set] = STATE(109),
    [sym_set_comprehension] = STATE(109),
    [sym_parenthesized_expression] = STATE(109),
    [sym_tuple] = STATE(109),
    [sym_generator_expression] = STATE(109),
    [sym_conditional_expression] = STATE(601),
    [sym_concatenated_string] = STATE(109),
    [sym_string] = STATE(117),
    [sym_await] = STATE(601),
    [aux_sym_module_repeat1] = STATE(43),
    [aux_sym_decorated_definition_repeat1] = STATE(667),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_import] = ACTIONS(9),
    [anon_sym_from] = ACTIONS(11),
    [anon_sym_LPAREN] = ACTIONS(13),
    [anon_sym_print] = ACTIONS(15),
    [anon_sym_assert] = ACTIONS(17),
    [anon_sym_return] = ACTIONS(19),
    [anon_sym_del] = ACTIONS(21),
    [anon_sym_raise] = ACTIONS(23),
    [anon_sym_pass] = ACTIONS(25),
    [anon_sym_break] = ACTIONS(27),
    [anon_sym_continue] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(75),
    [anon_sym_async] = ACTIONS(77),
    [anon_sym_for] = ACTIONS(79),
    [anon_sym_while] = ACTIONS(81),
    [anon_sym_try] = ACTIONS(83),
    [anon_sym_with] = ACTIONS(85),
    [anon_sym_def] = ACTIONS(87),
    [anon_sym_global] = ACTIONS(45),
    [anon_sym_nonlocal] = ACTIONS(47),
    [anon_sym_exec] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(89),
    [anon_sym_AT] = ACTIONS(53),
    [anon_sym_not] = ACTIONS(55),
    [anon_sym_PLUS] = ACTIONS(57),
    [anon_sym_DASH] = ACTIONS(57),
    [anon_sym_TILDE] = ACTIONS(57),
    [anon_sym_lambda] = ACTIONS(59),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [sym_ellipsis] = ACTIONS(65),
    [anon_sym_LBRACE] = ACTIONS(67),
    [sym_integer] = ACTIONS(69),
    [sym_float] = ACTIONS(65),
    [sym_true] = ACTIONS(69),
    [sym_false] = ACTIONS(69),
    [sym_none] = ACTIONS(69),
    [anon_sym_await] = ACTIONS(71),
    [sym_comment] = ACTIONS(3),
    [sym__dedent] = ACTIONS(95),
    [sym__string_start] = ACTIONS(73),
  },
  [5] = {
    [sym__statement] = STATE(44),
    [sym__simple_statements] = STATE(44),
    [sym_import_statement] = STATE(861),
    [sym_future_import_statement] = STATE(861),
    [sym_import_from_statement] = STATE(861),
    [sym_print_statement] = STATE(861),
    [sym_assert_statement] = STATE(861),
    [sym_expression_statement] = STATE(861),
    [sym_named_expression] = STATE(601),
    [sym_return_statement] = STATE(861),
    [sym_delete_statement] = STATE(861),
    [sym_raise_statement] = STATE(861),
    [sym_pass_statement] = STATE(861),
    [sym_break_statement] = STATE(861),
    [sym_continue_statement] = STATE(861),
    [sym_if_statement] = STATE(44),
    [sym_for_statement] = STATE(44),
    [sym_while_statement] = STATE(44),
    [sym_try_statement] = STATE(44),
    [sym_with_statement] = STATE(44),
    [sym_function_definition] = STATE(44),
    [sym_global_statement] = STATE(861),
    [sym_nonlocal_statement] = STATE(861),
    [sym_exec_statement] = STATE(861),
    [sym_class_definition] = STATE(44),
    [sym_decorated_definition] = STATE(44),
    [sym_decorator] = STATE(667),
    [sym_block] = STATE(441),
    [sym_expression_list] = STATE(618),
    [sym__expression] = STATE(601),
    [sym__primary_expression] = STATE(109),
    [sym_not_operator] = STATE(601),
    [sym_boolean_operator] = STATE(601),
    [sym_binary_operator] = STATE(109),
    [sym_unary_operator] = STATE(109),
    [sym_comparison_operator] = STATE(601),
    [sym_lambda] = STATE(601),
    [sym_assignment] = STATE(936),
    [sym_augmented_assignment] = STATE(936),
    [sym_yield] = STATE(936),
    [sym_attribute] = STATE(109),
    [sym_subscript] = STATE(109),
    [sym_call] = STATE(109),
    [sym_list] = STATE(109),
    [sym_list_comprehension] = STATE(109),
    [sym_dictionary] = STATE(109),
    [sym_dictionary_comprehension] = STATE(109),
    [sym_set] = STATE(109),
    [sym_set_comprehension] = STATE(109),
    [sym_parenthesized_expression] = STATE(109),
    [sym_tuple] = STATE(109),
    [sym_generator_expression] = STATE(109),
    [sym_conditional_expression] = STATE(601),
    [sym_concatenated_string] = STATE(109),
    [sym_string] = STATE(117),
    [sym_await] = STATE(601),
    [aux_sym_module_repeat1] = STATE(44),
    [aux_sym_decorated_definition_repeat1] = STATE(667),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_import] = ACTIONS(9),
    [anon_sym_from] = ACTIONS(11),
    [anon_sym_LPAREN] = ACTIONS(13),
    [anon_sym_print] = ACTIONS(15),
    [anon_sym_assert] = ACTIONS(17),
    [anon_sym_return] = ACTIONS(19),
    [anon_sym_del] = ACTIONS(21),
    [anon_sym_raise] = ACTIONS(23),
    [anon_sym_pass] = ACTIONS(25),
    [anon_sym_break] = ACTIONS(27),
    [anon_sym_continue] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(75),
    [anon_sym_async] = ACTIONS(77),
    [anon_sym_for] = ACTIONS(79),
    [anon_sym_while] = ACTIONS(81),
    [anon_sym_try] = ACTIONS(83),
    [anon_sym_with] = ACTIONS(85),
    [anon_sym_def] = ACTIONS(87),
    [anon_sym_global] = ACTIONS(45),
    [anon_sym_nonlocal] = ACTIONS(47),
    [anon_sym_exec] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(89),
    [anon_sym_AT] = ACTIONS(53),
    [anon_sym_not] = ACTIONS(55),
    [anon_sym_PLUS] = ACTIONS(57),
    [anon_sym_DASH] = ACTIONS(57),
    [anon_sym_TILDE] = ACTIONS(57),
    [anon_sym_lambda] = ACTIONS(59),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [sym_ellipsis] = ACTIONS(65),
    [anon_sym_LBRACE] = ACTIONS(67),
    [sym_integer] = ACTIONS(69),
    [sym_float] = ACTIONS(65),
    [sym_true] = ACTIONS(69),
    [sym_false] = ACTIONS(69),
    [sym_none] = ACTIONS(69),
    [anon_sym_await] = ACTIONS(71),
    [sym_comment] = ACTIONS(3),
    [sym__dedent] = ACTIONS(91),
    [sym__string_start] = ACTIONS(73),
  },
  [6] = {
    [sym__statement] = STATE(44),
    [sym__simple_statements] = STATE(44),
    [sym_import_statement] = STATE(861),
    [sym_future_import_statement] = STATE(861),
    [sym_import_from_statement] = STATE(861),
    [sym_print_statement] = STATE(861),
    [sym_assert_statement] = STATE(861),
    [sym_expression_statement] = STATE(861),
    [sym_named_expression] = STATE(601),
    [sym_return_statement] = STATE(861),
    [sym_delete_statement] = STATE(861),
    [sym_raise_statement] = STATE(861),
    [sym_pass_statement] = STATE(861),
    [sym_break_statement] = STATE(861),
    [sym_continue_statement] = STATE(861),
    [sym_if_statement] = STATE(44),
    [sym_for_statement] = STATE(44),
    [sym_while_statement] = STATE(44),
    [sym_try_statement] = STATE(44),
    [sym_with_statement] = STATE(44),
    [sym_function_definition] = STATE(44),
    [sym_global_statement] = STATE(861),
    [sym_nonlocal_statement] = STATE(861),
    [sym_exec_statement] = STATE(861),
    [sym_class_definition] = STATE(44),
    [sym_decorated_definition] = STATE(44),
    [sym_decorator] = STATE(667),
    [sym_block] = STATE(460),
    [sym_expression_list] = STATE(618),
    [sym__expression] = STATE(601),
    [sym__primary_expression] = STATE(109),
    [sym_not_operator] = STATE(601),
    [sym_boolean_operator] = STATE(601),
    [sym_binary_operator] = STATE(109),
    [sym_unary_operator] = STATE(109),
    [sym_comparison_operator] = STATE(601),
    [sym_lambda] = STATE(601),
    [sym_assignment] = STATE(936),
    [sym_augmented_assignment] = STATE(936),
    [sym_yield] = STATE(936),
    [sym_attribute] = STATE(109),
    [sym_subscript] = STATE(109),
    [sym_call] = STATE(109),
    [sym_list] = STATE(109),
    [sym_list_comprehension] = STATE(109),
    [sym_dictionary] = STATE(109),
    [sym_dictionary_comprehension] = STATE(109),
    [sym_set] = STATE(109),
    [sym_set_comprehension] = STATE(109),
    [sym_parenthesized_expression] = STATE(109),
    [sym_tuple] = STATE(109),
    [sym_generator_expression] = STATE(109),
    [sym_conditional_expression] = STATE(601),
    [sym_concatenated_string] = STATE(109),
    [sym_string] = STATE(117),
    [sym_await] = STATE(601),
    [aux_sym_module_repeat1] = STATE(44),
    [aux_sym_decorated_definition_repeat1] = STATE(667),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_import] = ACTIONS(9),
    [anon_sym_from] = ACTIONS(11),
    [anon_sym_LPAREN] = ACTIONS(13),
    [anon_sym_print] = ACTIONS(15),
    [anon_sym_assert] = ACTIONS(17),
    [anon_sym_return] = ACTIONS(19),
    [anon_sym_del] = ACTIONS(21),
    [anon_sym_raise] = ACTIONS(23),
    [anon_sym_pass] = ACTIONS(25),
    [anon_sym_break] = ACTIONS(27),
    [anon_sym_continue] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(75),
    [anon_sym_async] = ACTIONS(77),
    [anon_sym_for] = ACTIONS(79),
    [anon_sym_while] = ACTIONS(81),
    [anon_sym_try] = ACTIONS(83),
    [anon_sym_with] = ACTIONS(85),
    [anon_sym_def] = ACTIONS(87),
    [anon_sym_global] = ACTIONS(45),
    [anon_sym_nonlocal] = ACTIONS(47),
    [anon_sym_exec] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(89),
    [anon_sym_AT] = ACTIONS(53),
    [anon_sym_not] = ACTIONS(55),
    [anon_sym_PLUS] = ACTIONS(57),
    [anon_sym_DASH] = ACTIONS(57),
    [anon_sym_TILDE] = ACTIONS(57),
    [anon_sym_lambda] = ACTIONS(59),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [sym_ellipsis] = ACTIONS(65),
    [anon_sym_LBRACE] = ACTIONS(67),
    [sym_integer] = ACTIONS(69),
    [sym_float] = ACTIONS(65),
    [sym_true] = ACTIONS(69),
    [sym_false] = ACTIONS(69),
    [sym_none] = ACTIONS(69),
    [anon_sym_await] = ACTIONS(71),
    [sym_comment] = ACTIONS(3),
    [sym__dedent] = ACTIONS(91),
    [sym__string_start] = ACTIONS(73),
  },
  [7] = {
    [sym__statement] = STATE(44),
    [sym__simple_statements] = STATE(44),
    [sym_import_statement] = STATE(861),
    [sym_future_import_statement] = STATE(861),
    [sym_import_from_statement] = STATE(861),
    [sym_print_statement] = STATE(861),
    [sym_assert_statement] = STATE(861),
    [sym_expression_statement] = STATE(861),
    [sym_named_expression] = STATE(601),
    [sym_return_statement] = STATE(861),
    [sym_delete_statement] = STATE(861),
    [sym_raise_statement] = STATE(861),
    [sym_pass_statement] = STATE(861),
    [sym_break_statement] = STATE(861),
    [sym_continue_statement] = STATE(861),
    [sym_if_statement] = STATE(44),
    [sym_for_statement] = STATE(44),
    [sym_while_statement] = STATE(44),
    [sym_try_statement] = STATE(44),
    [sym_with_statement] = STATE(44),
    [sym_function_definition] = STATE(44),
    [sym_global_statement] = STATE(861),
    [sym_nonlocal_statement] = STATE(861),
    [sym_exec_statement] = STATE(861),
    [sym_class_definition] = STATE(44),
    [sym_decorated_definition] = STATE(44),
    [sym_decorator] = STATE(667),
    [sym_block] = STATE(364),
    [sym_expression_list] = STATE(618),
    [sym__expression] = STATE(601),
    [sym__primary_expression] = STATE(109),
    [sym_not_operator] = STATE(601),
    [sym_boolean_operator] = STATE(601),
    [sym_binary_operator] = STATE(109),
    [sym_unary_operator] = STATE(109),
    [sym_comparison_operator] = STATE(601),
    [sym_lambda] = STATE(601),
    [sym_assignment] = STATE(936),
    [sym_augmented_assignment] = STATE(936),
    [sym_yield] = STATE(936),
    [sym_attribute] = STATE(109),
    [sym_subscript] = STATE(109),
    [sym_call] = STATE(109),
    [sym_list] = STATE(109),
    [sym_list_comprehension] = STATE(109),
    [sym_dictionary] = STATE(109),
    [sym_dictionary_comprehension] = STATE(109),
    [sym_set] = STATE(109),
    [sym_set_comprehension] = STATE(109),
    [sym_parenthesized_expression] = STATE(109),
    [sym_tuple] = STATE(109),
    [sym_generator_expression] = STATE(109),
    [sym_conditional_expression] = STATE(601),
    [sym_concatenated_string] = STATE(109),
    [sym_string] = STATE(117),
    [sym_await] = STATE(601),
    [aux_sym_module_repeat1] = STATE(44),
    [aux_sym_decorated_definition_repeat1] = STATE(667),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_import] = ACTIONS(9),
    [anon_sym_from] = ACTIONS(11),
    [anon_sym_LPAREN] = ACTIONS(13),
    [anon_sym_print] = ACTIONS(15),
    [anon_sym_assert] = ACTIONS(17),
    [anon_sym_return] = ACTIONS(19),
    [anon_sym_del] = ACTIONS(21),
    [anon_sym_raise] = ACTIONS(23),
    [anon_sym_pass] = ACTIONS(25),
    [anon_sym_break] = ACTIONS(27),
    [anon_sym_continue] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(75),
    [anon_sym_async] = ACTIONS(77),
    [anon_sym_for] = ACTIONS(79),
    [anon_sym_while] = ACTIONS(81),
    [anon_sym_try] = ACTIONS(83),
    [anon_sym_with] = ACTIONS(85),
    [anon_sym_def] = ACTIONS(87),
    [anon_sym_global] = ACTIONS(45),
    [anon_sym_nonlocal] = ACTIONS(47),
    [anon_sym_exec] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(89),
    [anon_sym_AT] = ACTIONS(53),
    [anon_sym_not] = ACTIONS(55),
    [anon_sym_PLUS] = ACTIONS(57),
    [anon_sym_DASH] = ACTIONS(57),
    [anon_sym_TILDE] = ACTIONS(57),
    [anon_sym_lambda] = ACTIONS(59),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [sym_ellipsis] = ACTIONS(65),
    [anon_sym_LBRACE] = ACTIONS(67),
    [sym_integer] = ACTIONS(69),
    [sym_float] = ACTIONS(65),
    [sym_true] = ACTIONS(69),
    [sym_false] = ACTIONS(69),
    [sym_none] = ACTIONS(69),
    [anon_sym_await] = ACTIONS(71),
    [sym_comment] = ACTIONS(3),
    [sym__dedent] = ACTIONS(91),
    [sym__string_start] = ACTIONS(73),
  },
  [8] = {
    [sym__statement] = STATE(44),
    [sym__simple_statements] = STATE(44),
    [sym_import_statement] = STATE(861),
    [sym_future_import_statement] = STATE(861),
    [sym_import_from_statement] = STATE(861),
    [sym_print_statement] = STATE(861),
    [sym_assert_statement] = STATE(861),
    [sym_expression_statement] = STATE(861),
    [sym_named_expression] = STATE(601),
    [sym_return_statement] = STATE(861),
    [sym_delete_statement] = STATE(861),
    [sym_raise_statement] = STATE(861),
    [sym_pass_statement] = STATE(861),
    [sym_break_statement] = STATE(861),
    [sym_continue_statement] = STATE(861),
    [sym_if_statement] = STATE(44),
    [sym_for_statement] = STATE(44),
    [sym_while_statement] = STATE(44),
    [sym_try_statement] = STATE(44),
    [sym_with_statement] = STATE(44),
    [sym_function_definition] = STATE(44),
    [sym_global_statement] = STATE(861),
    [sym_nonlocal_statement] = STATE(861),
    [sym_exec_statement] = STATE(861),
    [sym_class_definition] = STATE(44),
    [sym_decorated_definition] = STATE(44),
    [sym_decorator] = STATE(667),
    [sym_block] = STATE(444),
    [sym_expression_list] = STATE(618),
    [sym__expression] = STATE(601),
    [sym__primary_expression] = STATE(109),
    [sym_not_operator] = STATE(601),
    [sym_boolean_operator] = STATE(601),
    [sym_binary_operator] = STATE(109),
    [sym_unary_operator] = STATE(109),
    [sym_comparison_operator] = STATE(601),
    [sym_lambda] = STATE(601),
    [sym_assignment] = STATE(936),
    [sym_augmented_assignment] = STATE(936),
    [sym_yield] = STATE(936),
    [sym_attribute] = STATE(109),
    [sym_subscript] = STATE(109),
    [sym_call] = STATE(109),
    [sym_list] = STATE(109),
    [sym_list_comprehension] = STATE(109),
    [sym_dictionary] = STATE(109),
    [sym_dictionary_comprehension] = STATE(109),
    [sym_set] = STATE(109),
    [sym_set_comprehension] = STATE(109),
    [sym_parenthesized_expression] = STATE(109),
    [sym_tuple] = STATE(109),
    [sym_generator_expression] = STATE(109),
    [sym_conditional_expression] = STATE(601),
    [sym_concatenated_string] = STATE(109),
    [sym_string] = STATE(117),
    [sym_await] = STATE(601),
    [aux_sym_module_repeat1] = STATE(44),
    [aux_sym_decorated_definition_repeat1] = STATE(667),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_import] = ACTIONS(9),
    [anon_sym_from] = ACTIONS(11),
    [anon_sym_LPAREN] = ACTIONS(13),
    [anon_sym_print] = ACTIONS(15),
    [anon_sym_assert] = ACTIONS(17),
    [anon_sym_return] = ACTIONS(19),
    [anon_sym_del] = ACTIONS(21),
    [anon_sym_raise] = ACTIONS(23),
    [anon_sym_pass] = ACTIONS(25),
    [anon_sym_break] = ACTIONS(27),
    [anon_sym_continue] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(75),
    [anon_sym_async] = ACTIONS(77),
    [anon_sym_for] = ACTIONS(79),
    [anon_sym_while] = ACTIONS(81),
    [anon_sym_try] = ACTIONS(83),
    [anon_sym_with] = ACTIONS(85),
    [anon_sym_def] = ACTIONS(87),
    [anon_sym_global] = ACTIONS(45),
    [anon_sym_nonlocal] = ACTIONS(47),
    [anon_sym_exec] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(89),
    [anon_sym_AT] = ACTIONS(53),
    [anon_sym_not] = ACTIONS(55),
    [anon_sym_PLUS] = ACTIONS(57),
    [anon_sym_DASH] = ACTIONS(57),
    [anon_sym_TILDE] = ACTIONS(57),
    [anon_sym_lambda] = ACTIONS(59),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [sym_ellipsis] = ACTIONS(65),
    [anon_sym_LBRACE] = ACTIONS(67),
    [sym_integer] = ACTIONS(69),
    [sym_float] = ACTIONS(65),
    [sym_true] = ACTIONS(69),
    [sym_false] = ACTIONS(69),
    [sym_none] = ACTIONS(69),
    [anon_sym_await] = ACTIONS(71),
    [sym_comment] = ACTIONS(3),
    [sym__dedent] = ACTIONS(91),
    [sym__string_start] = ACTIONS(73),
  },
  [9] = {
    [sym__statement] = STATE(44),
    [sym__simple_statements] = STATE(44),
    [sym_import_statement] = STATE(861),
    [sym_future_import_statement] = STATE(861),
    [sym_import_from_statement] = STATE(861),
    [sym_print_statement] = STATE(861),
    [sym_assert_statement] = STATE(861),
    [sym_expression_statement] = STATE(861),
    [sym_named_expression] = STATE(601),
    [sym_return_statement] = STATE(861),
    [sym_delete_statement] = STATE(861),
    [sym_raise_statement] = STATE(861),
    [sym_pass_statement] = STATE(861),
    [sym_break_statement] = STATE(861),
    [sym_continue_statement] = STATE(861),
    [sym_if_statement] = STATE(44),
    [sym_for_statement] = STATE(44),
    [sym_while_statement] = STATE(44),
    [sym_try_statement] = STATE(44),
    [sym_with_statement] = STATE(44),
    [sym_function_definition] = STATE(44),
    [sym_global_statement] = STATE(861),
    [sym_nonlocal_statement] = STATE(861),
    [sym_exec_statement] = STATE(861),
    [sym_class_definition] = STATE(44),
    [sym_decorated_definition] = STATE(44),
    [sym_decorator] = STATE(667),
    [sym_block] = STATE(300),
    [sym_expression_list] = STATE(618),
    [sym__expression] = STATE(601),
    [sym__primary_expression] = STATE(109),
    [sym_not_operator] = STATE(601),
    [sym_boolean_operator] = STATE(601),
    [sym_binary_operator] = STATE(109),
    [sym_unary_operator] = STATE(109),
    [sym_comparison_operator] = STATE(601),
    [sym_lambda] = STATE(601),
    [sym_assignment] = STATE(936),
    [sym_augmented_assignment] = STATE(936),
    [sym_yield] = STATE(936),
    [sym_attribute] = STATE(109),
    [sym_subscript] = STATE(109),
    [sym_call] = STATE(109),
    [sym_list] = STATE(109),
    [sym_list_comprehension] = STATE(109),
    [sym_dictionary] = STATE(109),
    [sym_dictionary_comprehension] = STATE(109),
    [sym_set] = STATE(109),
    [sym_set_comprehension] = STATE(109),
    [sym_parenthesized_expression] = STATE(109),
    [sym_tuple] = STATE(109),
    [sym_generator_expression] = STATE(109),
    [sym_conditional_expression] = STATE(601),
    [sym_concatenated_string] = STATE(109),
    [sym_string] = STATE(117),
    [sym_await] = STATE(601),
    [aux_sym_module_repeat1] = STATE(44),
    [aux_sym_decorated_definition_repeat1] = STATE(667),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_import] = ACTIONS(9),
    [anon_sym_from] = ACTIONS(11),
    [anon_sym_LPAREN] = ACTIONS(13),
    [anon_sym_print] = ACTIONS(15),
    [anon_sym_assert] = ACTIONS(17),
    [anon_sym_return] = ACTIONS(19),
    [anon_sym_del] = ACTIONS(21),
    [anon_sym_raise] = ACTIONS(23),
    [anon_sym_pass] = ACTIONS(25),
    [anon_sym_break] = ACTIONS(27),
    [anon_sym_continue] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(75),
    [anon_sym_async] = ACTIONS(77),
    [anon_sym_for] = ACTIONS(79),
    [anon_sym_while] = ACTIONS(81),
    [anon_sym_try] = ACTIONS(83),
    [anon_sym_with] = ACTIONS(85),
    [anon_sym_def] = ACTIONS(87),
    [anon_sym_global] = ACTIONS(45),
    [anon_sym_nonlocal] = ACTIONS(47),
    [anon_sym_exec] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(89),
    [anon_sym_AT] = ACTIONS(53),
    [anon_sym_not] = ACTIONS(55),
    [anon_sym_PLUS] = ACTIONS(57),
    [anon_sym_DASH] = ACTIONS(57),
    [anon_sym_TILDE] = ACTIONS(57),
    [anon_sym_lambda] = ACTIONS(59),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [sym_ellipsis] = ACTIONS(65),
    [anon_sym_LBRACE] = ACTIONS(67),
    [sym_integer] = ACTIONS(69),
    [sym_float] = ACTIONS(65),
    [sym_true] = ACTIONS(69),
    [sym_false] = ACTIONS(69),
    [sym_none] = ACTIONS(69),
    [anon_sym_await] = ACTIONS(71),
    [sym_comment] = ACTIONS(3),
    [sym__dedent] = ACTIONS(91),
    [sym__string_start] = ACTIONS(73),
  },
  [10] = {
    [sym__statement] = STATE(44),
    [sym__simple_statements] = STATE(44),
    [sym_import_statement] = STATE(861),
    [sym_future_import_statement] = STATE(861),
    [sym_import_from_statement] = STATE(861),
    [sym_print_statement] = STATE(861),
    [sym_assert_statement] = STATE(861),
    [sym_expression_statement] = STATE(861),
    [sym_named_expression] = STATE(601),
    [sym_return_statement] = STATE(861),
    [sym_delete_statement] = STATE(861),
    [sym_raise_statement] = STATE(861),
    [sym_pass_statement] = STATE(861),
    [sym_break_statement] = STATE(861),
    [sym_continue_statement] = STATE(861),
    [sym_if_statement] = STATE(44),
    [sym_for_statement] = STATE(44),
    [sym_while_statement] = STATE(44),
    [sym_try_statement] = STATE(44),
    [sym_with_statement] = STATE(44),
    [sym_function_definition] = STATE(44),
    [sym_global_statement] = STATE(861),
    [sym_nonlocal_statement] = STATE(861),
    [sym_exec_statement] = STATE(861),
    [sym_class_definition] = STATE(44),
    [sym_decorated_definition] = STATE(44),
    [sym_decorator] = STATE(667),
    [sym_block] = STATE(461),
    [sym_expression_list] = STATE(618),
    [sym__expression] = STATE(601),
    [sym__primary_expression] = STATE(109),
    [sym_not_operator] = STATE(601),
    [sym_boolean_operator] = STATE(601),
    [sym_binary_operator] = STATE(109),
    [sym_unary_operator] = STATE(109),
    [sym_comparison_operator] = STATE(601),
    [sym_lambda] = STATE(601),
    [sym_assignment] = STATE(936),
    [sym_augmented_assignment] = STATE(936),
    [sym_yield] = STATE(936),
    [sym_attribute] = STATE(109),
    [sym_subscript] = STATE(109),
    [sym_call] = STATE(109),
    [sym_list] = STATE(109),
    [sym_list_comprehension] = STATE(109),
    [sym_dictionary] = STATE(109),
    [sym_dictionary_comprehension] = STATE(109),
    [sym_set] = STATE(109),
    [sym_set_comprehension] = STATE(109),
    [sym_parenthesized_expression] = STATE(109),
    [sym_tuple] = STATE(109),
    [sym_generator_expression] = STATE(109),
    [sym_conditional_expression] = STATE(601),
    [sym_concatenated_string] = STATE(109),
    [sym_string] = STATE(117),
    [sym_await] = STATE(601),
    [aux_sym_module_repeat1] = STATE(44),
    [aux_sym_decorated_definition_repeat1] = STATE(667),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_import] = ACTIONS(9),
    [anon_sym_from] = ACTIONS(11),
    [anon_sym_LPAREN] = ACTIONS(13),
    [anon_sym_print] = ACTIONS(15),
    [anon_sym_assert] = ACTIONS(17),
    [anon_sym_return] = ACTIONS(19),
    [anon_sym_del] = ACTIONS(21),
    [anon_sym_raise] = ACTIONS(23),
    [anon_sym_pass] = ACTIONS(25),
    [anon_sym_break] = ACTIONS(27),
    [anon_sym_continue] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(75),
    [anon_sym_async] = ACTIONS(77),
    [anon_sym_for] = ACTIONS(79),
    [anon_sym_while] = ACTIONS(81),
    [anon_sym_try] = ACTIONS(83),
    [anon_sym_with] = ACTIONS(85),
    [anon_sym_def] = ACTIONS(87),
    [anon_sym_global] = ACTIONS(45),
    [anon_sym_nonlocal] = ACTIONS(47),
    [anon_sym_exec] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(89),
    [anon_sym_AT] = ACTIONS(53),
    [anon_sym_not] = ACTIONS(55),
    [anon_sym_PLUS] = ACTIONS(57),
    [anon_sym_DASH] = ACTIONS(57),
    [anon_sym_TILDE] = ACTIONS(57),
    [anon_sym_lambda] = ACTIONS(59),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [sym_ellipsis] = ACTIONS(65),
    [anon_sym_LBRACE] = ACTIONS(67),
    [sym_integer] = ACTIONS(69),
    [sym_float] = ACTIONS(65),
    [sym_true] = ACTIONS(69),
    [sym_false] = ACTIONS(69),
    [sym_none] = ACTIONS(69),
    [anon_sym_await] = ACTIONS(71),
    [sym_comment] = ACTIONS(3),
    [sym__dedent] = ACTIONS(91),
    [sym__string_start] = ACTIONS(73),
  },
  [11] = {
    [sym__statement] = STATE(44),
    [sym__simple_statements] = STATE(44),
    [sym_import_statement] = STATE(861),
    [sym_future_import_statement] = STATE(861),
    [sym_import_from_statement] = STATE(861),
    [sym_print_statement] = STATE(861),
    [sym_assert_statement] = STATE(861),
    [sym_expression_statement] = STATE(861),
    [sym_named_expression] = STATE(601),
    [sym_return_statement] = STATE(861),
    [sym_delete_statement] = STATE(861),
    [sym_raise_statement] = STATE(861),
    [sym_pass_statement] = STATE(861),
    [sym_break_statement] = STATE(861),
    [sym_continue_statement] = STATE(861),
    [sym_if_statement] = STATE(44),
    [sym_for_statement] = STATE(44),
    [sym_while_statement] = STATE(44),
    [sym_try_statement] = STATE(44),
    [sym_with_statement] = STATE(44),
    [sym_function_definition] = STATE(44),
    [sym_global_statement] = STATE(861),
    [sym_nonlocal_statement] = STATE(861),
    [sym_exec_statement] = STATE(861),
    [sym_class_definition] = STATE(44),
    [sym_decorated_definition] = STATE(44),
    [sym_decorator] = STATE(667),
    [sym_block] = STATE(363),
    [sym_expression_list] = STATE(618),
    [sym__expression] = STATE(601),
    [sym__primary_expression] = STATE(109),
    [sym_not_operator] = STATE(601),
    [sym_boolean_operator] = STATE(601),
    [sym_binary_operator] = STATE(109),
    [sym_unary_operator] = STATE(109),
    [sym_comparison_operator] = STATE(601),
    [sym_lambda] = STATE(601),
    [sym_assignment] = STATE(936),
    [sym_augmented_assignment] = STATE(936),
    [sym_yield] = STATE(936),
    [sym_attribute] = STATE(109),
    [sym_subscript] = STATE(109),
    [sym_call] = STATE(109),
    [sym_list] = STATE(109),
    [sym_list_comprehension] = STATE(109),
    [sym_dictionary] = STATE(109),
    [sym_dictionary_comprehension] = STATE(109),
    [sym_set] = STATE(109),
    [sym_set_comprehension] = STATE(109),
    [sym_parenthesized_expression] = STATE(109),
    [sym_tuple] = STATE(109),
    [sym_generator_expression] = STATE(109),
    [sym_conditional_expression] = STATE(601),
    [sym_concatenated_string] = STATE(109),
    [sym_string] = STATE(117),
    [sym_await] = STATE(601),
    [aux_sym_module_repeat1] = STATE(44),
    [aux_sym_decorated_definition_repeat1] = STATE(667),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_import] = ACTIONS(9),
    [anon_sym_from] = ACTIONS(11),
    [anon_sym_LPAREN] = ACTIONS(13),
    [anon_sym_print] = ACTIONS(15),
    [anon_sym_assert] = ACTIONS(17),
    [anon_sym_return] = ACTIONS(19),
    [anon_sym_del] = ACTIONS(21),
    [anon_sym_raise] = ACTIONS(23),
    [anon_sym_pass] = ACTIONS(25),
    [anon_sym_break] = ACTIONS(27),
    [anon_sym_continue] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(75),
    [anon_sym_async] = ACTIONS(77),
    [anon_sym_for] = ACTIONS(79),
    [anon_sym_while] = ACTIONS(81),
    [anon_sym_try] = ACTIONS(83),
    [anon_sym_with] = ACTIONS(85),
    [anon_sym_def] = ACTIONS(87),
    [anon_sym_global] = ACTIONS(45),
    [anon_sym_nonlocal] = ACTIONS(47),
    [anon_sym_exec] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(89),
    [anon_sym_AT] = ACTIONS(53),
    [anon_sym_not] = ACTIONS(55),
    [anon_sym_PLUS] = ACTIONS(57),
    [anon_sym_DASH] = ACTIONS(57),
    [anon_sym_TILDE] = ACTIONS(57),
    [anon_sym_lambda] = ACTIONS(59),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [sym_ellipsis] = ACTIONS(65),
    [anon_sym_LBRACE] = ACTIONS(67),
    [sym_integer] = ACTIONS(69),
    [sym_float] = ACTIONS(65),
    [sym_true] = ACTIONS(69),
    [sym_false] = ACTIONS(69),
    [sym_none] = ACTIONS(69),
    [anon_sym_await] = ACTIONS(71),
    [sym_comment] = ACTIONS(3),
    [sym__dedent] = ACTIONS(91),
    [sym__string_start] = ACTIONS(73),
  },
  [12] = {
    [sym__statement] = STATE(44),
    [sym__simple_statements] = STATE(44),
    [sym_import_statement] = STATE(861),
    [sym_future_import_statement] = STATE(861),
    [sym_import_from_statement] = STATE(861),
    [sym_print_statement] = STATE(861),
    [sym_assert_statement] = STATE(861),
    [sym_expression_statement] = STATE(861),
    [sym_named_expression] = STATE(601),
    [sym_return_statement] = STATE(861),
    [sym_delete_statement] = STATE(861),
    [sym_raise_statement] = STATE(861),
    [sym_pass_statement] = STATE(861),
    [sym_break_statement] = STATE(861),
    [sym_continue_statement] = STATE(861),
    [sym_if_statement] = STATE(44),
    [sym_for_statement] = STATE(44),
    [sym_while_statement] = STATE(44),
    [sym_try_statement] = STATE(44),
    [sym_with_statement] = STATE(44),
    [sym_function_definition] = STATE(44),
    [sym_global_statement] = STATE(861),
    [sym_nonlocal_statement] = STATE(861),
    [sym_exec_statement] = STATE(861),
    [sym_class_definition] = STATE(44),
    [sym_decorated_definition] = STATE(44),
    [sym_decorator] = STATE(667),
    [sym_block] = STATE(384),
    [sym_expression_list] = STATE(618),
    [sym__expression] = STATE(601),
    [sym__primary_expression] = STATE(109),
    [sym_not_operator] = STATE(601),
    [sym_boolean_operator] = STATE(601),
    [sym_binary_operator] = STATE(109),
    [sym_unary_operator] = STATE(109),
    [sym_comparison_operator] = STATE(601),
    [sym_lambda] = STATE(601),
    [sym_assignment] = STATE(936),
    [sym_augmented_assignment] = STATE(936),
    [sym_yield] = STATE(936),
    [sym_attribute] = STATE(109),
    [sym_subscript] = STATE(109),
    [sym_call] = STATE(109),
    [sym_list] = STATE(109),
    [sym_list_comprehension] = STATE(109),
    [sym_dictionary] = STATE(109),
    [sym_dictionary_comprehension] = STATE(109),
    [sym_set] = STATE(109),
    [sym_set_comprehension] = STATE(109),
    [sym_parenthesized_expression] = STATE(109),
    [sym_tuple] = STATE(109),
    [sym_generator_expression] = STATE(109),
    [sym_conditional_expression] = STATE(601),
    [sym_concatenated_string] = STATE(109),
    [sym_string] = STATE(117),
    [sym_await] = STATE(601),
    [aux_sym_module_repeat1] = STATE(44),
    [aux_sym_decorated_definition_repeat1] = STATE(667),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_import] = ACTIONS(9),
    [anon_sym_from] = ACTIONS(11),
    [anon_sym_LPAREN] = ACTIONS(13),
    [anon_sym_print] = ACTIONS(15),
    [anon_sym_assert] = ACTIONS(17),
    [anon_sym_return] = ACTIONS(19),
    [anon_sym_del] = ACTIONS(21),
    [anon_sym_raise] = ACTIONS(23),
    [anon_sym_pass] = ACTIONS(25),
    [anon_sym_break] = ACTIONS(27),
    [anon_sym_continue] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(75),
    [anon_sym_async] = ACTIONS(77),
    [anon_sym_for] = ACTIONS(79),
    [anon_sym_while] = ACTIONS(81),
    [anon_sym_try] = ACTIONS(83),
    [anon_sym_with] = ACTIONS(85),
    [anon_sym_def] = ACTIONS(87),
    [anon_sym_global] = ACTIONS(45),
    [anon_sym_nonlocal] = ACTIONS(47),
    [anon_sym_exec] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(89),
    [anon_sym_AT] = ACTIONS(53),
    [anon_sym_not] = ACTIONS(55),
    [anon_sym_PLUS] = ACTIONS(57),
    [anon_sym_DASH] = ACTIONS(57),
    [anon_sym_TILDE] = ACTIONS(57),
    [anon_sym_lambda] = ACTIONS(59),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [sym_ellipsis] = ACTIONS(65),
    [anon_sym_LBRACE] = ACTIONS(67),
    [sym_integer] = ACTIONS(69),
    [sym_float] = ACTIONS(65),
    [sym_true] = ACTIONS(69),
    [sym_false] = ACTIONS(69),
    [sym_none] = ACTIONS(69),
    [anon_sym_await] = ACTIONS(71),
    [sym_comment] = ACTIONS(3),
    [sym__dedent] = ACTIONS(91),
    [sym__string_start] = ACTIONS(73),
  },
  [13] = {
    [sym__statement] = STATE(47),
    [sym__simple_statements] = STATE(47),
    [sym_import_statement] = STATE(861),
    [sym_future_import_statement] = STATE(861),
    [sym_import_from_statement] = STATE(861),
    [sym_print_statement] = STATE(861),
    [sym_assert_statement] = STATE(861),
    [sym_expression_statement] = STATE(861),
    [sym_named_expression] = STATE(601),
    [sym_return_statement] = STATE(861),
    [sym_delete_statement] = STATE(861),
    [sym_raise_statement] = STATE(861),
    [sym_pass_statement] = STATE(861),
    [sym_break_statement] = STATE(861),
    [sym_continue_statement] = STATE(861),
    [sym_if_statement] = STATE(47),
    [sym_for_statement] = STATE(47),
    [sym_while_statement] = STATE(47),
    [sym_try_statement] = STATE(47),
    [sym_with_statement] = STATE(47),
    [sym_function_definition] = STATE(47),
    [sym_global_statement] = STATE(861),
    [sym_nonlocal_statement] = STATE(861),
    [sym_exec_statement] = STATE(861),
    [sym_class_definition] = STATE(47),
    [sym_decorated_definition] = STATE(47),
    [sym_decorator] = STATE(667),
    [sym_block] = STATE(314),
    [sym_expression_list] = STATE(618),
    [sym__expression] = STATE(601),
    [sym__primary_expression] = STATE(109),
    [sym_not_operator] = STATE(601),
    [sym_boolean_operator] = STATE(601),
    [sym_binary_operator] = STATE(109),
    [sym_unary_operator] = STATE(109),
    [sym_comparison_operator] = STATE(601),
    [sym_lambda] = STATE(601),
    [sym_assignment] = STATE(936),
    [sym_augmented_assignment] = STATE(936),
    [sym_yield] = STATE(936),
    [sym_attribute] = STATE(109),
    [sym_subscript] = STATE(109),
    [sym_call] = STATE(109),
    [sym_list] = STATE(109),
    [sym_list_comprehension] = STATE(109),
    [sym_dictionary] = STATE(109),
    [sym_dictionary_comprehension] = STATE(109),
    [sym_set] = STATE(109),
    [sym_set_comprehension] = STATE(109),
    [sym_parenthesized_expression] = STATE(109),
    [sym_tuple] = STATE(109),
    [sym_generator_expression] = STATE(109),
    [sym_conditional_expression] = STATE(601),
    [sym_concatenated_string] = STATE(109),
    [sym_string] = STATE(117),
    [sym_await] = STATE(601),
    [aux_sym_module_repeat1] = STATE(47),
    [aux_sym_decorated_definition_repeat1] = STATE(667),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_import] = ACTIONS(9),
    [anon_sym_from] = ACTIONS(11),
    [anon_sym_LPAREN] = ACTIONS(13),
    [anon_sym_print] = ACTIONS(15),
    [anon_sym_assert] = ACTIONS(17),
    [anon_sym_return] = ACTIONS(19),
    [anon_sym_del] = ACTIONS(21),
    [anon_sym_raise] = ACTIONS(23),
    [anon_sym_pass] = ACTIONS(25),
    [anon_sym_break] = ACTIONS(27),
    [anon_sym_continue] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(75),
    [anon_sym_async] = ACTIONS(77),
    [anon_sym_for] = ACTIONS(79),
    [anon_sym_while] = ACTIONS(81),
    [anon_sym_try] = ACTIONS(83),
    [anon_sym_with] = ACTIONS(85),
    [anon_sym_def] = ACTIONS(87),
    [anon_sym_global] = ACTIONS(45),
    [anon_sym_nonlocal] = ACTIONS(47),
    [anon_sym_exec] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(89),
    [anon_sym_AT] = ACTIONS(53),
    [anon_sym_not] = ACTIONS(55),
    [anon_sym_PLUS] = ACTIONS(57),
    [anon_sym_DASH] = ACTIONS(57),
    [anon_sym_TILDE] = ACTIONS(57),
    [anon_sym_lambda] = ACTIONS(59),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [sym_ellipsis] = ACTIONS(65),
    [anon_sym_LBRACE] = ACTIONS(67),
    [sym_integer] = ACTIONS(69),
    [sym_float] = ACTIONS(65),
    [sym_true] = ACTIONS(69),
    [sym_false] = ACTIONS(69),
    [sym_none] = ACTIONS(69),
    [anon_sym_await] = ACTIONS(71),
    [sym_comment] = ACTIONS(3),
    [sym__dedent] = ACTIONS(93),
    [sym__string_start] = ACTIONS(73),
  },
  [14] = {
    [sym__statement] = STATE(47),
    [sym__simple_statements] = STATE(47),
    [sym_import_statement] = STATE(861),
    [sym_future_import_statement] = STATE(861),
    [sym_import_from_statement] = STATE(861),
    [sym_print_statement] = STATE(861),
    [sym_assert_statement] = STATE(861),
    [sym_expression_statement] = STATE(861),
    [sym_named_expression] = STATE(601),
    [sym_return_statement] = STATE(861),
    [sym_delete_statement] = STATE(861),
    [sym_raise_statement] = STATE(861),
    [sym_pass_statement] = STATE(861),
    [sym_break_statement] = STATE(861),
    [sym_continue_statement] = STATE(861),
    [sym_if_statement] = STATE(47),
    [sym_for_statement] = STATE(47),
    [sym_while_statement] = STATE(47),
    [sym_try_statement] = STATE(47),
    [sym_with_statement] = STATE(47),
    [sym_function_definition] = STATE(47),
    [sym_global_statement] = STATE(861),
    [sym_nonlocal_statement] = STATE(861),
    [sym_exec_statement] = STATE(861),
    [sym_class_definition] = STATE(47),
    [sym_decorated_definition] = STATE(47),
    [sym_decorator] = STATE(667),
    [sym_block] = STATE(247),
    [sym_expression_list] = STATE(618),
    [sym__expression] = STATE(601),
    [sym__primary_expression] = STATE(109),
    [sym_not_operator] = STATE(601),
    [sym_boolean_operator] = STATE(601),
    [sym_binary_operator] = STATE(109),
    [sym_unary_operator] = STATE(109),
    [sym_comparison_operator] = STATE(601),
    [sym_lambda] = STATE(601),
    [sym_assignment] = STATE(936),
    [sym_augmented_assignment] = STATE(936),
    [sym_yield] = STATE(936),
    [sym_attribute] = STATE(109),
    [sym_subscript] = STATE(109),
    [sym_call] = STATE(109),
    [sym_list] = STATE(109),
    [sym_list_comprehension] = STATE(109),
    [sym_dictionary] = STATE(109),
    [sym_dictionary_comprehension] = STATE(109),
    [sym_set] = STATE(109),
    [sym_set_comprehension] = STATE(109),
    [sym_parenthesized_expression] = STATE(109),
    [sym_tuple] = STATE(109),
    [sym_generator_expression] = STATE(109),
    [sym_conditional_expression] = STATE(601),
    [sym_concatenated_string] = STATE(109),
    [sym_string] = STATE(117),
    [sym_await] = STATE(601),
    [aux_sym_module_repeat1] = STATE(47),
    [aux_sym_decorated_definition_repeat1] = STATE(667),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_import] = ACTIONS(9),
    [anon_sym_from] = ACTIONS(11),
    [anon_sym_LPAREN] = ACTIONS(13),
    [anon_sym_print] = ACTIONS(15),
    [anon_sym_assert] = ACTIONS(17),
    [anon_sym_return] = ACTIONS(19),
    [anon_sym_del] = ACTIONS(21),
    [anon_sym_raise] = ACTIONS(23),
    [anon_sym_pass] = ACTIONS(25),
    [anon_sym_break] = ACTIONS(27),
    [anon_sym_continue] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(75),
    [anon_sym_async] = ACTIONS(77),
    [anon_sym_for] = ACTIONS(79),
    [anon_sym_while] = ACTIONS(81),
    [anon_sym_try] = ACTIONS(83),
    [anon_sym_with] = ACTIONS(85),
    [anon_sym_def] = ACTIONS(87),
    [anon_sym_global] = ACTIONS(45),
    [anon_sym_nonlocal] = ACTIONS(47),
    [anon_sym_exec] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(89),
    [anon_sym_AT] = ACTIONS(53),
    [anon_sym_not] = ACTIONS(55),
    [anon_sym_PLUS] = ACTIONS(57),
    [anon_sym_DASH] = ACTIONS(57),
    [anon_sym_TILDE] = ACTIONS(57),
    [anon_sym_lambda] = ACTIONS(59),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [sym_ellipsis] = ACTIONS(65),
    [anon_sym_LBRACE] = ACTIONS(67),
    [sym_integer] = ACTIONS(69),
    [sym_float] = ACTIONS(65),
    [sym_true] = ACTIONS(69),
    [sym_false] = ACTIONS(69),
    [sym_none] = ACTIONS(69),
    [anon_sym_await] = ACTIONS(71),
    [sym_comment] = ACTIONS(3),
    [sym__dedent] = ACTIONS(93),
    [sym__string_start] = ACTIONS(73),
  },
  [15] = {
    [sym__statement] = STATE(43),
    [sym__simple_statements] = STATE(43),
    [sym_import_statement] = STATE(861),
    [sym_future_import_statement] = STATE(861),
    [sym_import_from_statement] = STATE(861),
    [sym_print_statement] = STATE(861),
    [sym_assert_statement] = STATE(861),
    [sym_expression_statement] = STATE(861),
    [sym_named_expression] = STATE(601),
    [sym_return_statement] = STATE(861),
    [sym_delete_statement] = STATE(861),
    [sym_raise_statement] = STATE(861),
    [sym_pass_statement] = STATE(861),
    [sym_break_statement] = STATE(861),
    [sym_continue_statement] = STATE(861),
    [sym_if_statement] = STATE(43),
    [sym_for_statement] = STATE(43),
    [sym_while_statement] = STATE(43),
    [sym_try_statement] = STATE(43),
    [sym_with_statement] = STATE(43),
    [sym_function_definition] = STATE(43),
    [sym_global_statement] = STATE(861),
    [sym_nonlocal_statement] = STATE(861),
    [sym_exec_statement] = STATE(861),
    [sym_class_definition] = STATE(43),
    [sym_decorated_definition] = STATE(43),
    [sym_decorator] = STATE(667),
    [sym_block] = STATE(763),
    [sym_expression_list] = STATE(618),
    [sym__expression] = STATE(601),
    [sym__primary_expression] = STATE(109),
    [sym_not_operator] = STATE(601),
    [sym_boolean_operator] = STATE(601),
    [sym_binary_operator] = STATE(109),
    [sym_unary_operator] = STATE(109),
    [sym_comparison_operator] = STATE(601),
    [sym_lambda] = STATE(601),
    [sym_assignment] = STATE(936),
    [sym_augmented_assignment] = STATE(936),
    [sym_yield] = STATE(936),
    [sym_attribute] = STATE(109),
    [sym_subscript] = STATE(109),
    [sym_call] = STATE(109),
    [sym_list] = STATE(109),
    [sym_list_comprehension] = STATE(109),
    [sym_dictionary] = STATE(109),
    [sym_dictionary_comprehension] = STATE(109),
    [sym_set] = STATE(109),
    [sym_set_comprehension] = STATE(109),
    [sym_parenthesized_expression] = STATE(109),
    [sym_tuple] = STATE(109),
    [sym_generator_expression] = STATE(109),
    [sym_conditional_expression] = STATE(601),
    [sym_concatenated_string] = STATE(109),
    [sym_string] = STATE(117),
    [sym_await] = STATE(601),
    [aux_sym_module_repeat1] = STATE(43),
    [aux_sym_decorated_definition_repeat1] = STATE(667),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_import] = ACTIONS(9),
    [anon_sym_from] = ACTIONS(11),
    [anon_sym_LPAREN] = ACTIONS(13),
    [anon_sym_print] = ACTIONS(15),
    [anon_sym_assert] = ACTIONS(17),
    [anon_sym_return] = ACTIONS(19),
    [anon_sym_del] = ACTIONS(21),
    [anon_sym_raise] = ACTIONS(23),
    [anon_sym_pass] = ACTIONS(25),
    [anon_sym_break] = ACTIONS(27),
    [anon_sym_continue] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(75),
    [anon_sym_async] = ACTIONS(77),
    [anon_sym_for] = ACTIONS(79),
    [anon_sym_while] = ACTIONS(81),
    [anon_sym_try] = ACTIONS(83),
    [anon_sym_with] = ACTIONS(85),
    [anon_sym_def] = ACTIONS(87),
    [anon_sym_global] = ACTIONS(45),
    [anon_sym_nonlocal] = ACTIONS(47),
    [anon_sym_exec] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(89),
    [anon_sym_AT] = ACTIONS(53),
    [anon_sym_not] = ACTIONS(55),
    [anon_sym_PLUS] = ACTIONS(57),
    [anon_sym_DASH] = ACTIONS(57),
    [anon_sym_TILDE] = ACTIONS(57),
    [anon_sym_lambda] = ACTIONS(59),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [sym_ellipsis] = ACTIONS(65),
    [anon_sym_LBRACE] = ACTIONS(67),
    [sym_integer] = ACTIONS(69),
    [sym_float] = ACTIONS(65),
    [sym_true] = ACTIONS(69),
    [sym_false] = ACTIONS(69),
    [sym_none] = ACTIONS(69),
    [anon_sym_await] = ACTIONS(71),
    [sym_comment] = ACTIONS(3),
    [sym__dedent] = ACTIONS(95),
    [sym__string_start] = ACTIONS(73),
  },
  [16] = {
    [sym__statement] = STATE(47),
    [sym__simple_statements] = STATE(47),
    [sym_import_statement] = STATE(861),
    [sym_future_import_statement] = STATE(861),
    [sym_import_from_statement] = STATE(861),
    [sym_print_statement] = STATE(861),
    [sym_assert_statement] = STATE(861),
    [sym_expression_statement] = STATE(861),
    [sym_named_expression] = STATE(601),
    [sym_return_statement] = STATE(861),
    [sym_delete_statement] = STATE(861),
    [sym_raise_statement] = STATE(861),
    [sym_pass_statement] = STATE(861),
    [sym_break_statement] = STATE(861),
    [sym_continue_statement] = STATE(861),
    [sym_if_statement] = STATE(47),
    [sym_for_statement] = STATE(47),
    [sym_while_statement] = STATE(47),
    [sym_try_statement] = STATE(47),
    [sym_with_statement] = STATE(47),
    [sym_function_definition] = STATE(47),
    [sym_global_statement] = STATE(861),
    [sym_nonlocal_statement] = STATE(861),
    [sym_exec_statement] = STATE(861),
    [sym_class_definition] = STATE(47),
    [sym_decorated_definition] = STATE(47),
    [sym_decorator] = STATE(667),
    [sym_block] = STATE(387),
    [sym_expression_list] = STATE(618),
    [sym__expression] = STATE(601),
    [sym__primary_expression] = STATE(109),
    [sym_not_operator] = STATE(601),
    [sym_boolean_operator] = STATE(601),
    [sym_binary_operator] = STATE(109),
    [sym_unary_operator] = STATE(109),
    [sym_comparison_operator] = STATE(601),
    [sym_lambda] = STATE(601),
    [sym_assignment] = STATE(936),
    [sym_augmented_assignment] = STATE(936),
    [sym_yield] = STATE(936),
    [sym_attribute] = STATE(109),
    [sym_subscript] = STATE(109),
    [sym_call] = STATE(109),
    [sym_list] = STATE(109),
    [sym_list_comprehension] = STATE(109),
    [sym_dictionary] = STATE(109),
    [sym_dictionary_comprehension] = STATE(109),
    [sym_set] = STATE(109),
    [sym_set_comprehension] = STATE(109),
    [sym_parenthesized_expression] = STATE(109),
    [sym_tuple] = STATE(109),
    [sym_generator_expression] = STATE(109),
    [sym_conditional_expression] = STATE(601),
    [sym_concatenated_string] = STATE(109),
    [sym_string] = STATE(117),
    [sym_await] = STATE(601),
    [aux_sym_module_repeat1] = STATE(47),
    [aux_sym_decorated_definition_repeat1] = STATE(667),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_import] = ACTIONS(9),
    [anon_sym_from] = ACTIONS(11),
    [anon_sym_LPAREN] = ACTIONS(13),
    [anon_sym_print] = ACTIONS(15),
    [anon_sym_assert] = ACTIONS(17),
    [anon_sym_return] = ACTIONS(19),
    [anon_sym_del] = ACTIONS(21),
    [anon_sym_raise] = ACTIONS(23),
    [anon_sym_pass] = ACTIONS(25),
    [anon_sym_break] = ACTIONS(27),
    [anon_sym_continue] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(75),
    [anon_sym_async] = ACTIONS(77),
    [anon_sym_for] = ACTIONS(79),
    [anon_sym_while] = ACTIONS(81),
    [anon_sym_try] = ACTIONS(83),
    [anon_sym_with] = ACTIONS(85),
    [anon_sym_def] = ACTIONS(87),
    [anon_sym_global] = ACTIONS(45),
    [anon_sym_nonlocal] = ACTIONS(47),
    [anon_sym_exec] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(89),
    [anon_sym_AT] = ACTIONS(53),
    [anon_sym_not] = ACTIONS(55),
    [anon_sym_PLUS] = ACTIONS(57),
    [anon_sym_DASH] = ACTIONS(57),
    [anon_sym_TILDE] = ACTIONS(57),
    [anon_sym_lambda] = ACTIONS(59),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [sym_ellipsis] = ACTIONS(65),
    [anon_sym_LBRACE] = ACTIONS(67),
    [sym_integer] = ACTIONS(69),
    [sym_float] = ACTIONS(65),
    [sym_true] = ACTIONS(69),
    [sym_false] = ACTIONS(69),
    [sym_none] = ACTIONS(69),
    [anon_sym_await] = ACTIONS(71),
    [sym_comment] = ACTIONS(3),
    [sym__dedent] = ACTIONS(93),
    [sym__string_start] = ACTIONS(73),
  },
  [17] = {
    [sym__statement] = STATE(44),
    [sym__simple_statements] = STATE(44),
    [sym_import_statement] = STATE(861),
    [sym_future_import_statement] = STATE(861),
    [sym_import_from_statement] = STATE(861),
    [sym_print_statement] = STATE(861),
    [sym_assert_statement] = STATE(861),
    [sym_expression_statement] = STATE(861),
    [sym_named_expression] = STATE(601),
    [sym_return_statement] = STATE(861),
    [sym_delete_statement] = STATE(861),
    [sym_raise_statement] = STATE(861),
    [sym_pass_statement] = STATE(861),
    [sym_break_statement] = STATE(861),
    [sym_continue_statement] = STATE(861),
    [sym_if_statement] = STATE(44),
    [sym_for_statement] = STATE(44),
    [sym_while_statement] = STATE(44),
    [sym_try_statement] = STATE(44),
    [sym_with_statement] = STATE(44),
    [sym_function_definition] = STATE(44),
    [sym_global_statement] = STATE(861),
    [sym_nonlocal_statement] = STATE(861),
    [sym_exec_statement] = STATE(861),
    [sym_class_definition] = STATE(44),
    [sym_decorated_definition] = STATE(44),
    [sym_decorator] = STATE(667),
    [sym_block] = STATE(386),
    [sym_expression_list] = STATE(618),
    [sym__expression] = STATE(601),
    [sym__primary_expression] = STATE(109),
    [sym_not_operator] = STATE(601),
    [sym_boolean_operator] = STATE(601),
    [sym_binary_operator] = STATE(109),
    [sym_unary_operator] = STATE(109),
    [sym_comparison_operator] = STATE(601),
    [sym_lambda] = STATE(601),
    [sym_assignment] = STATE(936),
    [sym_augmented_assignment] = STATE(936),
    [sym_yield] = STATE(936),
    [sym_attribute] = STATE(109),
    [sym_subscript] = STATE(109),
    [sym_call] = STATE(109),
    [sym_list] = STATE(109),
    [sym_list_comprehension] = STATE(109),
    [sym_dictionary] = STATE(109),
    [sym_dictionary_comprehension] = STATE(109),
    [sym_set] = STATE(109),
    [sym_set_comprehension] = STATE(109),
    [sym_parenthesized_expression] = STATE(109),
    [sym_tuple] = STATE(109),
    [sym_generator_expression] = STATE(109),
    [sym_conditional_expression] = STATE(601),
    [sym_concatenated_string] = STATE(109),
    [sym_string] = STATE(117),
    [sym_await] = STATE(601),
    [aux_sym_module_repeat1] = STATE(44),
    [aux_sym_decorated_definition_repeat1] = STATE(667),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_import] = ACTIONS(9),
    [anon_sym_from] = ACTIONS(11),
    [anon_sym_LPAREN] = ACTIONS(13),
    [anon_sym_print] = ACTIONS(15),
    [anon_sym_assert] = ACTIONS(17),
    [anon_sym_return] = ACTIONS(19),
    [anon_sym_del] = ACTIONS(21),
    [anon_sym_raise] = ACTIONS(23),
    [anon_sym_pass] = ACTIONS(25),
    [anon_sym_break] = ACTIONS(27),
    [anon_sym_continue] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(75),
    [anon_sym_async] = ACTIONS(77),
    [anon_sym_for] = ACTIONS(79),
    [anon_sym_while] = ACTIONS(81),
    [anon_sym_try] = ACTIONS(83),
    [anon_sym_with] = ACTIONS(85),
    [anon_sym_def] = ACTIONS(87),
    [anon_sym_global] = ACTIONS(45),
    [anon_sym_nonlocal] = ACTIONS(47),
    [anon_sym_exec] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(89),
    [anon_sym_AT] = ACTIONS(53),
    [anon_sym_not] = ACTIONS(55),
    [anon_sym_PLUS] = ACTIONS(57),
    [anon_sym_DASH] = ACTIONS(57),
    [anon_sym_TILDE] = ACTIONS(57),
    [anon_sym_lambda] = ACTIONS(59),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [sym_ellipsis] = ACTIONS(65),
    [anon_sym_LBRACE] = ACTIONS(67),
    [sym_integer] = ACTIONS(69),
    [sym_float] = ACTIONS(65),
    [sym_true] = ACTIONS(69),
    [sym_false] = ACTIONS(69),
    [sym_none] = ACTIONS(69),
    [anon_sym_await] = ACTIONS(71),
    [sym_comment] = ACTIONS(3),
    [sym__dedent] = ACTIONS(91),
    [sym__string_start] = ACTIONS(73),
  },
  [18] = {
    [sym__statement] = STATE(47),
    [sym__simple_statements] = STATE(47),
    [sym_import_statement] = STATE(861),
    [sym_future_import_statement] = STATE(861),
    [sym_import_from_statement] = STATE(861),
    [sym_print_statement] = STATE(861),
    [sym_assert_statement] = STATE(861),
    [sym_expression_statement] = STATE(861),
    [sym_named_expression] = STATE(601),
    [sym_return_statement] = STATE(861),
    [sym_delete_statement] = STATE(861),
    [sym_raise_statement] = STATE(861),
    [sym_pass_statement] = STATE(861),
    [sym_break_statement] = STATE(861),
    [sym_continue_statement] = STATE(861),
    [sym_if_statement] = STATE(47),
    [sym_for_statement] = STATE(47),
    [sym_while_statement] = STATE(47),
    [sym_try_statement] = STATE(47),
    [sym_with_statement] = STATE(47),
    [sym_function_definition] = STATE(47),
    [sym_global_statement] = STATE(861),
    [sym_nonlocal_statement] = STATE(861),
    [sym_exec_statement] = STATE(861),
    [sym_class_definition] = STATE(47),
    [sym_decorated_definition] = STATE(47),
    [sym_decorator] = STATE(667),
    [sym_block] = STATE(400),
    [sym_expression_list] = STATE(618),
    [sym__expression] = STATE(601),
    [sym__primary_expression] = STATE(109),
    [sym_not_operator] = STATE(601),
    [sym_boolean_operator] = STATE(601),
    [sym_binary_operator] = STATE(109),
    [sym_unary_operator] = STATE(109),
    [sym_comparison_operator] = STATE(601),
    [sym_lambda] = STATE(601),
    [sym_assignment] = STATE(936),
    [sym_augmented_assignment] = STATE(936),
    [sym_yield] = STATE(936),
    [sym_attribute] = STATE(109),
    [sym_subscript] = STATE(109),
    [sym_call] = STATE(109),
    [sym_list] = STATE(109),
    [sym_list_comprehension] = STATE(109),
    [sym_dictionary] = STATE(109),
    [sym_dictionary_comprehension] = STATE(109),
    [sym_set] = STATE(109),
    [sym_set_comprehension] = STATE(109),
    [sym_parenthesized_expression] = STATE(109),
    [sym_tuple] = STATE(109),
    [sym_generator_expression] = STATE(109),
    [sym_conditional_expression] = STATE(601),
    [sym_concatenated_string] = STATE(109),
    [sym_string] = STATE(117),
    [sym_await] = STATE(601),
    [aux_sym_module_repeat1] = STATE(47),
    [aux_sym_decorated_definition_repeat1] = STATE(667),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_import] = ACTIONS(9),
    [anon_sym_from] = ACTIONS(11),
    [anon_sym_LPAREN] = ACTIONS(13),
    [anon_sym_print] = ACTIONS(15),
    [anon_sym_assert] = ACTIONS(17),
    [anon_sym_return] = ACTIONS(19),
    [anon_sym_del] = ACTIONS(21),
    [anon_sym_raise] = ACTIONS(23),
    [anon_sym_pass] = ACTIONS(25),
    [anon_sym_break] = ACTIONS(27),
    [anon_sym_continue] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(75),
    [anon_sym_async] = ACTIONS(77),
    [anon_sym_for] = ACTIONS(79),
    [anon_sym_while] = ACTIONS(81),
    [anon_sym_try] = ACTIONS(83),
    [anon_sym_with] = ACTIONS(85),
    [anon_sym_def] = ACTIONS(87),
    [anon_sym_global] = ACTIONS(45),
    [anon_sym_nonlocal] = ACTIONS(47),
    [anon_sym_exec] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(89),
    [anon_sym_AT] = ACTIONS(53),
    [anon_sym_not] = ACTIONS(55),
    [anon_sym_PLUS] = ACTIONS(57),
    [anon_sym_DASH] = ACTIONS(57),
    [anon_sym_TILDE] = ACTIONS(57),
    [anon_sym_lambda] = ACTIONS(59),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [sym_ellipsis] = ACTIONS(65),
    [anon_sym_LBRACE] = ACTIONS(67),
    [sym_integer] = ACTIONS(69),
    [sym_float] = ACTIONS(65),
    [sym_true] = ACTIONS(69),
    [sym_false] = ACTIONS(69),
    [sym_none] = ACTIONS(69),
    [anon_sym_await] = ACTIONS(71),
    [sym_comment] = ACTIONS(3),
    [sym__dedent] = ACTIONS(93),
    [sym__string_start] = ACTIONS(73),
  },
  [19] = {
    [sym__statement] = STATE(44),
    [sym__simple_statements] = STATE(44),
    [sym_import_statement] = STATE(861),
    [sym_future_import_statement] = STATE(861),
    [sym_import_from_statement] = STATE(861),
    [sym_print_statement] = STATE(861),
    [sym_assert_statement] = STATE(861),
    [sym_expression_statement] = STATE(861),
    [sym_named_expression] = STATE(601),
    [sym_return_statement] = STATE(861),
    [sym_delete_statement] = STATE(861),
    [sym_raise_statement] = STATE(861),
    [sym_pass_statement] = STATE(861),
    [sym_break_statement] = STATE(861),
    [sym_continue_statement] = STATE(861),
    [sym_if_statement] = STATE(44),
    [sym_for_statement] = STATE(44),
    [sym_while_statement] = STATE(44),
    [sym_try_statement] = STATE(44),
    [sym_with_statement] = STATE(44),
    [sym_function_definition] = STATE(44),
    [sym_global_statement] = STATE(861),
    [sym_nonlocal_statement] = STATE(861),
    [sym_exec_statement] = STATE(861),
    [sym_class_definition] = STATE(44),
    [sym_decorated_definition] = STATE(44),
    [sym_decorator] = STATE(667),
    [sym_block] = STATE(452),
    [sym_expression_list] = STATE(618),
    [sym__expression] = STATE(601),
    [sym__primary_expression] = STATE(109),
    [sym_not_operator] = STATE(601),
    [sym_boolean_operator] = STATE(601),
    [sym_binary_operator] = STATE(109),
    [sym_unary_operator] = STATE(109),
    [sym_comparison_operator] = STATE(601),
    [sym_lambda] = STATE(601),
    [sym_assignment] = STATE(936),
    [sym_augmented_assignment] = STATE(936),
    [sym_yield] = STATE(936),
    [sym_attribute] = STATE(109),
    [sym_subscript] = STATE(109),
    [sym_call] = STATE(109),
    [sym_list] = STATE(109),
    [sym_list_comprehension] = STATE(109),
    [sym_dictionary] = STATE(109),
    [sym_dictionary_comprehension] = STATE(109),
    [sym_set] = STATE(109),
    [sym_set_comprehension] = STATE(109),
    [sym_parenthesized_expression] = STATE(109),
    [sym_tuple] = STATE(109),
    [sym_generator_expression] = STATE(109),
    [sym_conditional_expression] = STATE(601),
    [sym_concatenated_string] = STATE(109),
    [sym_string] = STATE(117),
    [sym_await] = STATE(601),
    [aux_sym_module_repeat1] = STATE(44),
    [aux_sym_decorated_definition_repeat1] = STATE(667),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_import] = ACTIONS(9),
    [anon_sym_from] = ACTIONS(11),
    [anon_sym_LPAREN] = ACTIONS(13),
    [anon_sym_print] = ACTIONS(15),
    [anon_sym_assert] = ACTIONS(17),
    [anon_sym_return] = ACTIONS(19),
    [anon_sym_del] = ACTIONS(21),
    [anon_sym_raise] = ACTIONS(23),
    [anon_sym_pass] = ACTIONS(25),
    [anon_sym_break] = ACTIONS(27),
    [anon_sym_continue] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(75),
    [anon_sym_async] = ACTIONS(77),
    [anon_sym_for] = ACTIONS(79),
    [anon_sym_while] = ACTIONS(81),
    [anon_sym_try] = ACTIONS(83),
    [anon_sym_with] = ACTIONS(85),
    [anon_sym_def] = ACTIONS(87),
    [anon_sym_global] = ACTIONS(45),
    [anon_sym_nonlocal] = ACTIONS(47),
    [anon_sym_exec] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(89),
    [anon_sym_AT] = ACTIONS(53),
    [anon_sym_not] = ACTIONS(55),
    [anon_sym_PLUS] = ACTIONS(57),
    [anon_sym_DASH] = ACTIONS(57),
    [anon_sym_TILDE] = ACTIONS(57),
    [anon_sym_lambda] = ACTIONS(59),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [sym_ellipsis] = ACTIONS(65),
    [anon_sym_LBRACE] = ACTIONS(67),
    [sym_integer] = ACTIONS(69),
    [sym_float] = ACTIONS(65),
    [sym_true] = ACTIONS(69),
    [sym_false] = ACTIONS(69),
    [sym_none] = ACTIONS(69),
    [anon_sym_await] = ACTIONS(71),
    [sym_comment] = ACTIONS(3),
    [sym__dedent] = ACTIONS(91),
    [sym__string_start] = ACTIONS(73),
  },
  [20] = {
    [sym__statement] = STATE(44),
    [sym__simple_statements] = STATE(44),
    [sym_import_statement] = STATE(861),
    [sym_future_import_statement] = STATE(861),
    [sym_import_from_statement] = STATE(861),
    [sym_print_statement] = STATE(861),
    [sym_assert_statement] = STATE(861),
    [sym_expression_statement] = STATE(861),
    [sym_named_expression] = STATE(601),
    [sym_return_statement] = STATE(861),
    [sym_delete_statement] = STATE(861),
    [sym_raise_statement] = STATE(861),
    [sym_pass_statement] = STATE(861),
    [sym_break_statement] = STATE(861),
    [sym_continue_statement] = STATE(861),
    [sym_if_statement] = STATE(44),
    [sym_for_statement] = STATE(44),
    [sym_while_statement] = STATE(44),
    [sym_try_statement] = STATE(44),
    [sym_with_statement] = STATE(44),
    [sym_function_definition] = STATE(44),
    [sym_global_statement] = STATE(861),
    [sym_nonlocal_statement] = STATE(861),
    [sym_exec_statement] = STATE(861),
    [sym_class_definition] = STATE(44),
    [sym_decorated_definition] = STATE(44),
    [sym_decorator] = STATE(667),
    [sym_block] = STATE(455),
    [sym_expression_list] = STATE(618),
    [sym__expression] = STATE(601),
    [sym__primary_expression] = STATE(109),
    [sym_not_operator] = STATE(601),
    [sym_boolean_operator] = STATE(601),
    [sym_binary_operator] = STATE(109),
    [sym_unary_operator] = STATE(109),
    [sym_comparison_operator] = STATE(601),
    [sym_lambda] = STATE(601),
    [sym_assignment] = STATE(936),
    [sym_augmented_assignment] = STATE(936),
    [sym_yield] = STATE(936),
    [sym_attribute] = STATE(109),
    [sym_subscript] = STATE(109),
    [sym_call] = STATE(109),
    [sym_list] = STATE(109),
    [sym_list_comprehension] = STATE(109),
    [sym_dictionary] = STATE(109),
    [sym_dictionary_comprehension] = STATE(109),
    [sym_set] = STATE(109),
    [sym_set_comprehension] = STATE(109),
    [sym_parenthesized_expression] = STATE(109),
    [sym_tuple] = STATE(109),
    [sym_generator_expression] = STATE(109),
    [sym_conditional_expression] = STATE(601),
    [sym_concatenated_string] = STATE(109),
    [sym_string] = STATE(117),
    [sym_await] = STATE(601),
    [aux_sym_module_repeat1] = STATE(44),
    [aux_sym_decorated_definition_repeat1] = STATE(667),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_import] = ACTIONS(9),
    [anon_sym_from] = ACTIONS(11),
    [anon_sym_LPAREN] = ACTIONS(13),
    [anon_sym_print] = ACTIONS(15),
    [anon_sym_assert] = ACTIONS(17),
    [anon_sym_return] = ACTIONS(19),
    [anon_sym_del] = ACTIONS(21),
    [anon_sym_raise] = ACTIONS(23),
    [anon_sym_pass] = ACTIONS(25),
    [anon_sym_break] = ACTIONS(27),
    [anon_sym_continue] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(75),
    [anon_sym_async] = ACTIONS(77),
    [anon_sym_for] = ACTIONS(79),
    [anon_sym_while] = ACTIONS(81),
    [anon_sym_try] = ACTIONS(83),
    [anon_sym_with] = ACTIONS(85),
    [anon_sym_def] = ACTIONS(87),
    [anon_sym_global] = ACTIONS(45),
    [anon_sym_nonlocal] = ACTIONS(47),
    [anon_sym_exec] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(89),
    [anon_sym_AT] = ACTIONS(53),
    [anon_sym_not] = ACTIONS(55),
    [anon_sym_PLUS] = ACTIONS(57),
    [anon_sym_DASH] = ACTIONS(57),
    [anon_sym_TILDE] = ACTIONS(57),
    [anon_sym_lambda] = ACTIONS(59),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [sym_ellipsis] = ACTIONS(65),
    [anon_sym_LBRACE] = ACTIONS(67),
    [sym_integer] = ACTIONS(69),
    [sym_float] = ACTIONS(65),
    [sym_true] = ACTIONS(69),
    [sym_false] = ACTIONS(69),
    [sym_none] = ACTIONS(69),
    [anon_sym_await] = ACTIONS(71),
    [sym_comment] = ACTIONS(3),
    [sym__dedent] = ACTIONS(91),
    [sym__string_start] = ACTIONS(73),
  },
  [21] = {
    [sym__statement] = STATE(44),
    [sym__simple_statements] = STATE(44),
    [sym_import_statement] = STATE(861),
    [sym_future_import_statement] = STATE(861),
    [sym_import_from_statement] = STATE(861),
    [sym_print_statement] = STATE(861),
    [sym_assert_statement] = STATE(861),
    [sym_expression_statement] = STATE(861),
    [sym_named_expression] = STATE(601),
    [sym_return_statement] = STATE(861),
    [sym_delete_statement] = STATE(861),
    [sym_raise_statement] = STATE(861),
    [sym_pass_statement] = STATE(861),
    [sym_break_statement] = STATE(861),
    [sym_continue_statement] = STATE(861),
    [sym_if_statement] = STATE(44),
    [sym_for_statement] = STATE(44),
    [sym_while_statement] = STATE(44),
    [sym_try_statement] = STATE(44),
    [sym_with_statement] = STATE(44),
    [sym_function_definition] = STATE(44),
    [sym_global_statement] = STATE(861),
    [sym_nonlocal_statement] = STATE(861),
    [sym_exec_statement] = STATE(861),
    [sym_class_definition] = STATE(44),
    [sym_decorated_definition] = STATE(44),
    [sym_decorator] = STATE(667),
    [sym_block] = STATE(465),
    [sym_expression_list] = STATE(618),
    [sym__expression] = STATE(601),
    [sym__primary_expression] = STATE(109),
    [sym_not_operator] = STATE(601),
    [sym_boolean_operator] = STATE(601),
    [sym_binary_operator] = STATE(109),
    [sym_unary_operator] = STATE(109),
    [sym_comparison_operator] = STATE(601),
    [sym_lambda] = STATE(601),
    [sym_assignment] = STATE(936),
    [sym_augmented_assignment] = STATE(936),
    [sym_yield] = STATE(936),
    [sym_attribute] = STATE(109),
    [sym_subscript] = STATE(109),
    [sym_call] = STATE(109),
    [sym_list] = STATE(109),
    [sym_list_comprehension] = STATE(109),
    [sym_dictionary] = STATE(109),
    [sym_dictionary_comprehension] = STATE(109),
    [sym_set] = STATE(109),
    [sym_set_comprehension] = STATE(109),
    [sym_parenthesized_expression] = STATE(109),
    [sym_tuple] = STATE(109),
    [sym_generator_expression] = STATE(109),
    [sym_conditional_expression] = STATE(601),
    [sym_concatenated_string] = STATE(109),
    [sym_string] = STATE(117),
    [sym_await] = STATE(601),
    [aux_sym_module_repeat1] = STATE(44),
    [aux_sym_decorated_definition_repeat1] = STATE(667),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_import] = ACTIONS(9),
    [anon_sym_from] = ACTIONS(11),
    [anon_sym_LPAREN] = ACTIONS(13),
    [anon_sym_print] = ACTIONS(15),
    [anon_sym_assert] = ACTIONS(17),
    [anon_sym_return] = ACTIONS(19),
    [anon_sym_del] = ACTIONS(21),
    [anon_sym_raise] = ACTIONS(23),
    [anon_sym_pass] = ACTIONS(25),
    [anon_sym_break] = ACTIONS(27),
    [anon_sym_continue] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(75),
    [anon_sym_async] = ACTIONS(77),
    [anon_sym_for] = ACTIONS(79),
    [anon_sym_while] = ACTIONS(81),
    [anon_sym_try] = ACTIONS(83),
    [anon_sym_with] = ACTIONS(85),
    [anon_sym_def] = ACTIONS(87),
    [anon_sym_global] = ACTIONS(45),
    [anon_sym_nonlocal] = ACTIONS(47),
    [anon_sym_exec] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(89),
    [anon_sym_AT] = ACTIONS(53),
    [anon_sym_not] = ACTIONS(55),
    [anon_sym_PLUS] = ACTIONS(57),
    [anon_sym_DASH] = ACTIONS(57),
    [anon_sym_TILDE] = ACTIONS(57),
    [anon_sym_lambda] = ACTIONS(59),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [sym_ellipsis] = ACTIONS(65),
    [anon_sym_LBRACE] = ACTIONS(67),
    [sym_integer] = ACTIONS(69),
    [sym_float] = ACTIONS(65),
    [sym_true] = ACTIONS(69),
    [sym_false] = ACTIONS(69),
    [sym_none] = ACTIONS(69),
    [anon_sym_await] = ACTIONS(71),
    [sym_comment] = ACTIONS(3),
    [sym__dedent] = ACTIONS(91),
    [sym__string_start] = ACTIONS(73),
  },
  [22] = {
    [sym__statement] = STATE(44),
    [sym__simple_statements] = STATE(44),
    [sym_import_statement] = STATE(861),
    [sym_future_import_statement] = STATE(861),
    [sym_import_from_statement] = STATE(861),
    [sym_print_statement] = STATE(861),
    [sym_assert_statement] = STATE(861),
    [sym_expression_statement] = STATE(861),
    [sym_named_expression] = STATE(601),
    [sym_return_statement] = STATE(861),
    [sym_delete_statement] = STATE(861),
    [sym_raise_statement] = STATE(861),
    [sym_pass_statement] = STATE(861),
    [sym_break_statement] = STATE(861),
    [sym_continue_statement] = STATE(861),
    [sym_if_statement] = STATE(44),
    [sym_for_statement] = STATE(44),
    [sym_while_statement] = STATE(44),
    [sym_try_statement] = STATE(44),
    [sym_with_statement] = STATE(44),
    [sym_function_definition] = STATE(44),
    [sym_global_statement] = STATE(861),
    [sym_nonlocal_statement] = STATE(861),
    [sym_exec_statement] = STATE(861),
    [sym_class_definition] = STATE(44),
    [sym_decorated_definition] = STATE(44),
    [sym_decorator] = STATE(667),
    [sym_block] = STATE(422),
    [sym_expression_list] = STATE(618),
    [sym__expression] = STATE(601),
    [sym__primary_expression] = STATE(109),
    [sym_not_operator] = STATE(601),
    [sym_boolean_operator] = STATE(601),
    [sym_binary_operator] = STATE(109),
    [sym_unary_operator] = STATE(109),
    [sym_comparison_operator] = STATE(601),
    [sym_lambda] = STATE(601),
    [sym_assignment] = STATE(936),
    [sym_augmented_assignment] = STATE(936),
    [sym_yield] = STATE(936),
    [sym_attribute] = STATE(109),
    [sym_subscript] = STATE(109),
    [sym_call] = STATE(109),
    [sym_list] = STATE(109),
    [sym_list_comprehension] = STATE(109),
    [sym_dictionary] = STATE(109),
    [sym_dictionary_comprehension] = STATE(109),
    [sym_set] = STATE(109),
    [sym_set_comprehension] = STATE(109),
    [sym_parenthesized_expression] = STATE(109),
    [sym_tuple] = STATE(109),
    [sym_generator_expression] = STATE(109),
    [sym_conditional_expression] = STATE(601),
    [sym_concatenated_string] = STATE(109),
    [sym_string] = STATE(117),
    [sym_await] = STATE(601),
    [aux_sym_module_repeat1] = STATE(44),
    [aux_sym_decorated_definition_repeat1] = STATE(667),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_import] = ACTIONS(9),
    [anon_sym_from] = ACTIONS(11),
    [anon_sym_LPAREN] = ACTIONS(13),
    [anon_sym_print] = ACTIONS(15),
    [anon_sym_assert] = ACTIONS(17),
    [anon_sym_return] = ACTIONS(19),
    [anon_sym_del] = ACTIONS(21),
    [anon_sym_raise] = ACTIONS(23),
    [anon_sym_pass] = ACTIONS(25),
    [anon_sym_break] = ACTIONS(27),
    [anon_sym_continue] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(75),
    [anon_sym_async] = ACTIONS(77),
    [anon_sym_for] = ACTIONS(79),
    [anon_sym_while] = ACTIONS(81),
    [anon_sym_try] = ACTIONS(83),
    [anon_sym_with] = ACTIONS(85),
    [anon_sym_def] = ACTIONS(87),
    [anon_sym_global] = ACTIONS(45),
    [anon_sym_nonlocal] = ACTIONS(47),
    [anon_sym_exec] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(89),
    [anon_sym_AT] = ACTIONS(53),
    [anon_sym_not] = ACTIONS(55),
    [anon_sym_PLUS] = ACTIONS(57),
    [anon_sym_DASH] = ACTIONS(57),
    [anon_sym_TILDE] = ACTIONS(57),
    [anon_sym_lambda] = ACTIONS(59),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [sym_ellipsis] = ACTIONS(65),
    [anon_sym_LBRACE] = ACTIONS(67),
    [sym_integer] = ACTIONS(69),
    [sym_float] = ACTIONS(65),
    [sym_true] = ACTIONS(69),
    [sym_false] = ACTIONS(69),
    [sym_none] = ACTIONS(69),
    [anon_sym_await] = ACTIONS(71),
    [sym_comment] = ACTIONS(3),
    [sym__dedent] = ACTIONS(91),
    [sym__string_start] = ACTIONS(73),
  },
  [23] = {
    [sym__statement] = STATE(44),
    [sym__simple_statements] = STATE(44),
    [sym_import_statement] = STATE(861),
    [sym_future_import_statement] = STATE(861),
    [sym_import_from_statement] = STATE(861),
    [sym_print_statement] = STATE(861),
    [sym_assert_statement] = STATE(861),
    [sym_expression_statement] = STATE(861),
    [sym_named_expression] = STATE(601),
    [sym_return_statement] = STATE(861),
    [sym_delete_statement] = STATE(861),
    [sym_raise_statement] = STATE(861),
    [sym_pass_statement] = STATE(861),
    [sym_break_statement] = STATE(861),
    [sym_continue_statement] = STATE(861),
    [sym_if_statement] = STATE(44),
    [sym_for_statement] = STATE(44),
    [sym_while_statement] = STATE(44),
    [sym_try_statement] = STATE(44),
    [sym_with_statement] = STATE(44),
    [sym_function_definition] = STATE(44),
    [sym_global_statement] = STATE(861),
    [sym_nonlocal_statement] = STATE(861),
    [sym_exec_statement] = STATE(861),
    [sym_class_definition] = STATE(44),
    [sym_decorated_definition] = STATE(44),
    [sym_decorator] = STATE(667),
    [sym_block] = STATE(315),
    [sym_expression_list] = STATE(618),
    [sym__expression] = STATE(601),
    [sym__primary_expression] = STATE(109),
    [sym_not_operator] = STATE(601),
    [sym_boolean_operator] = STATE(601),
    [sym_binary_operator] = STATE(109),
    [sym_unary_operator] = STATE(109),
    [sym_comparison_operator] = STATE(601),
    [sym_lambda] = STATE(601),
    [sym_assignment] = STATE(936),
    [sym_augmented_assignment] = STATE(936),
    [sym_yield] = STATE(936),
    [sym_attribute] = STATE(109),
    [sym_subscript] = STATE(109),
    [sym_call] = STATE(109),
    [sym_list] = STATE(109),
    [sym_list_comprehension] = STATE(109),
    [sym_dictionary] = STATE(109),
    [sym_dictionary_comprehension] = STATE(109),
    [sym_set] = STATE(109),
    [sym_set_comprehension] = STATE(109),
    [sym_parenthesized_expression] = STATE(109),
    [sym_tuple] = STATE(109),
    [sym_generator_expression] = STATE(109),
    [sym_conditional_expression] = STATE(601),
    [sym_concatenated_string] = STATE(109),
    [sym_string] = STATE(117),
    [sym_await] = STATE(601),
    [aux_sym_module_repeat1] = STATE(44),
    [aux_sym_decorated_definition_repeat1] = STATE(667),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_import] = ACTIONS(9),
    [anon_sym_from] = ACTIONS(11),
    [anon_sym_LPAREN] = ACTIONS(13),
    [anon_sym_print] = ACTIONS(15),
    [anon_sym_assert] = ACTIONS(17),
    [anon_sym_return] = ACTIONS(19),
    [anon_sym_del] = ACTIONS(21),
    [anon_sym_raise] = ACTIONS(23),
    [anon_sym_pass] = ACTIONS(25),
    [anon_sym_break] = ACTIONS(27),
    [anon_sym_continue] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(75),
    [anon_sym_async] = ACTIONS(77),
    [anon_sym_for] = ACTIONS(79),
    [anon_sym_while] = ACTIONS(81),
    [anon_sym_try] = ACTIONS(83),
    [anon_sym_with] = ACTIONS(85),
    [anon_sym_def] = ACTIONS(87),
    [anon_sym_global] = ACTIONS(45),
    [anon_sym_nonlocal] = ACTIONS(47),
    [anon_sym_exec] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(89),
    [anon_sym_AT] = ACTIONS(53),
    [anon_sym_not] = ACTIONS(55),
    [anon_sym_PLUS] = ACTIONS(57),
    [anon_sym_DASH] = ACTIONS(57),
    [anon_sym_TILDE] = ACTIONS(57),
    [anon_sym_lambda] = ACTIONS(59),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [sym_ellipsis] = ACTIONS(65),
    [anon_sym_LBRACE] = ACTIONS(67),
    [sym_integer] = ACTIONS(69),
    [sym_float] = ACTIONS(65),
    [sym_true] = ACTIONS(69),
    [sym_false] = ACTIONS(69),
    [sym_none] = ACTIONS(69),
    [anon_sym_await] = ACTIONS(71),
    [sym_comment] = ACTIONS(3),
    [sym__dedent] = ACTIONS(91),
    [sym__string_start] = ACTIONS(73),
  },
  [24] = {
    [sym__statement] = STATE(47),
    [sym__simple_statements] = STATE(47),
    [sym_import_statement] = STATE(861),
    [sym_future_import_statement] = STATE(861),
    [sym_import_from_statement] = STATE(861),
    [sym_print_statement] = STATE(861),
    [sym_assert_statement] = STATE(861),
    [sym_expression_statement] = STATE(861),
    [sym_named_expression] = STATE(601),
    [sym_return_statement] = STATE(861),
    [sym_delete_statement] = STATE(861),
    [sym_raise_statement] = STATE(861),
    [sym_pass_statement] = STATE(861),
    [sym_break_statement] = STATE(861),
    [sym_continue_statement] = STATE(861),
    [sym_if_statement] = STATE(47),
    [sym_for_statement] = STATE(47),
    [sym_while_statement] = STATE(47),
    [sym_try_statement] = STATE(47),
    [sym_with_statement] = STATE(47),
    [sym_function_definition] = STATE(47),
    [sym_global_statement] = STATE(861),
    [sym_nonlocal_statement] = STATE(861),
    [sym_exec_statement] = STATE(861),
    [sym_class_definition] = STATE(47),
    [sym_decorated_definition] = STATE(47),
    [sym_decorator] = STATE(667),
    [sym_block] = STATE(417),
    [sym_expression_list] = STATE(618),
    [sym__expression] = STATE(601),
    [sym__primary_expression] = STATE(109),
    [sym_not_operator] = STATE(601),
    [sym_boolean_operator] = STATE(601),
    [sym_binary_operator] = STATE(109),
    [sym_unary_operator] = STATE(109),
    [sym_comparison_operator] = STATE(601),
    [sym_lambda] = STATE(601),
    [sym_assignment] = STATE(936),
    [sym_augmented_assignment] = STATE(936),
    [sym_yield] = STATE(936),
    [sym_attribute] = STATE(109),
    [sym_subscript] = STATE(109),
    [sym_call] = STATE(109),
    [sym_list] = STATE(109),
    [sym_list_comprehension] = STATE(109),
    [sym_dictionary] = STATE(109),
    [sym_dictionary_comprehension] = STATE(109),
    [sym_set] = STATE(109),
    [sym_set_comprehension] = STATE(109),
    [sym_parenthesized_expression] = STATE(109),
    [sym_tuple] = STATE(109),
    [sym_generator_expression] = STATE(109),
    [sym_conditional_expression] = STATE(601),
    [sym_concatenated_string] = STATE(109),
    [sym_string] = STATE(117),
    [sym_await] = STATE(601),
    [aux_sym_module_repeat1] = STATE(47),
    [aux_sym_decorated_definition_repeat1] = STATE(667),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_import] = ACTIONS(9),
    [anon_sym_from] = ACTIONS(11),
    [anon_sym_LPAREN] = ACTIONS(13),
    [anon_sym_print] = ACTIONS(15),
    [anon_sym_assert] = ACTIONS(17),
    [anon_sym_return] = ACTIONS(19),
    [anon_sym_del] = ACTIONS(21),
    [anon_sym_raise] = ACTIONS(23),
    [anon_sym_pass] = ACTIONS(25),
    [anon_sym_break] = ACTIONS(27),
    [anon_sym_continue] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(75),
    [anon_sym_async] = ACTIONS(77),
    [anon_sym_for] = ACTIONS(79),
    [anon_sym_while] = ACTIONS(81),
    [anon_sym_try] = ACTIONS(83),
    [anon_sym_with] = ACTIONS(85),
    [anon_sym_def] = ACTIONS(87),
    [anon_sym_global] = ACTIONS(45),
    [anon_sym_nonlocal] = ACTIONS(47),
    [anon_sym_exec] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(89),
    [anon_sym_AT] = ACTIONS(53),
    [anon_sym_not] = ACTIONS(55),
    [anon_sym_PLUS] = ACTIONS(57),
    [anon_sym_DASH] = ACTIONS(57),
    [anon_sym_TILDE] = ACTIONS(57),
    [anon_sym_lambda] = ACTIONS(59),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [sym_ellipsis] = ACTIONS(65),
    [anon_sym_LBRACE] = ACTIONS(67),
    [sym_integer] = ACTIONS(69),
    [sym_float] = ACTIONS(65),
    [sym_true] = ACTIONS(69),
    [sym_false] = ACTIONS(69),
    [sym_none] = ACTIONS(69),
    [anon_sym_await] = ACTIONS(71),
    [sym_comment] = ACTIONS(3),
    [sym__dedent] = ACTIONS(93),
    [sym__string_start] = ACTIONS(73),
  },
  [25] = {
    [sym__statement] = STATE(44),
    [sym__simple_statements] = STATE(44),
    [sym_import_statement] = STATE(861),
    [sym_future_import_statement] = STATE(861),
    [sym_import_from_statement] = STATE(861),
    [sym_print_statement] = STATE(861),
    [sym_assert_statement] = STATE(861),
    [sym_expression_statement] = STATE(861),
    [sym_named_expression] = STATE(601),
    [sym_return_statement] = STATE(861),
    [sym_delete_statement] = STATE(861),
    [sym_raise_statement] = STATE(861),
    [sym_pass_statement] = STATE(861),
    [sym_break_statement] = STATE(861),
    [sym_continue_statement] = STATE(861),
    [sym_if_statement] = STATE(44),
    [sym_for_statement] = STATE(44),
    [sym_while_statement] = STATE(44),
    [sym_try_statement] = STATE(44),
    [sym_with_statement] = STATE(44),
    [sym_function_definition] = STATE(44),
    [sym_global_statement] = STATE(861),
    [sym_nonlocal_statement] = STATE(861),
    [sym_exec_statement] = STATE(861),
    [sym_class_definition] = STATE(44),
    [sym_decorated_definition] = STATE(44),
    [sym_decorator] = STATE(667),
    [sym_block] = STATE(305),
    [sym_expression_list] = STATE(618),
    [sym__expression] = STATE(601),
    [sym__primary_expression] = STATE(109),
    [sym_not_operator] = STATE(601),
    [sym_boolean_operator] = STATE(601),
    [sym_binary_operator] = STATE(109),
    [sym_unary_operator] = STATE(109),
    [sym_comparison_operator] = STATE(601),
    [sym_lambda] = STATE(601),
    [sym_assignment] = STATE(936),
    [sym_augmented_assignment] = STATE(936),
    [sym_yield] = STATE(936),
    [sym_attribute] = STATE(109),
    [sym_subscript] = STATE(109),
    [sym_call] = STATE(109),
    [sym_list] = STATE(109),
    [sym_list_comprehension] = STATE(109),
    [sym_dictionary] = STATE(109),
    [sym_dictionary_comprehension] = STATE(109),
    [sym_set] = STATE(109),
    [sym_set_comprehension] = STATE(109),
    [sym_parenthesized_expression] = STATE(109),
    [sym_tuple] = STATE(109),
    [sym_generator_expression] = STATE(109),
    [sym_conditional_expression] = STATE(601),
    [sym_concatenated_string] = STATE(109),
    [sym_string] = STATE(117),
    [sym_await] = STATE(601),
    [aux_sym_module_repeat1] = STATE(44),
    [aux_sym_decorated_definition_repeat1] = STATE(667),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_import] = ACTIONS(9),
    [anon_sym_from] = ACTIONS(11),
    [anon_sym_LPAREN] = ACTIONS(13),
    [anon_sym_print] = ACTIONS(15),
    [anon_sym_assert] = ACTIONS(17),
    [anon_sym_return] = ACTIONS(19),
    [anon_sym_del] = ACTIONS(21),
    [anon_sym_raise] = ACTIONS(23),
    [anon_sym_pass] = ACTIONS(25),
    [anon_sym_break] = ACTIONS(27),
    [anon_sym_continue] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(75),
    [anon_sym_async] = ACTIONS(77),
    [anon_sym_for] = ACTIONS(79),
    [anon_sym_while] = ACTIONS(81),
    [anon_sym_try] = ACTIONS(83),
    [anon_sym_with] = ACTIONS(85),
    [anon_sym_def] = ACTIONS(87),
    [anon_sym_global] = ACTIONS(45),
    [anon_sym_nonlocal] = ACTIONS(47),
    [anon_sym_exec] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(89),
    [anon_sym_AT] = ACTIONS(53),
    [anon_sym_not] = ACTIONS(55),
    [anon_sym_PLUS] = ACTIONS(57),
    [anon_sym_DASH] = ACTIONS(57),
    [anon_sym_TILDE] = ACTIONS(57),
    [anon_sym_lambda] = ACTIONS(59),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [sym_ellipsis] = ACTIONS(65),
    [anon_sym_LBRACE] = ACTIONS(67),
    [sym_integer] = ACTIONS(69),
    [sym_float] = ACTIONS(65),
    [sym_true] = ACTIONS(69),
    [sym_false] = ACTIONS(69),
    [sym_none] = ACTIONS(69),
    [anon_sym_await] = ACTIONS(71),
    [sym_comment] = ACTIONS(3),
    [sym__dedent] = ACTIONS(91),
    [sym__string_start] = ACTIONS(73),
  },
  [26] = {
    [sym__statement] = STATE(47),
    [sym__simple_statements] = STATE(47),
    [sym_import_statement] = STATE(861),
    [sym_future_import_statement] = STATE(861),
    [sym_import_from_statement] = STATE(861),
    [sym_print_statement] = STATE(861),
    [sym_assert_statement] = STATE(861),
    [sym_expression_statement] = STATE(861),
    [sym_named_expression] = STATE(601),
    [sym_return_statement] = STATE(861),
    [sym_delete_statement] = STATE(861),
    [sym_raise_statement] = STATE(861),
    [sym_pass_statement] = STATE(861),
    [sym_break_statement] = STATE(861),
    [sym_continue_statement] = STATE(861),
    [sym_if_statement] = STATE(47),
    [sym_for_statement] = STATE(47),
    [sym_while_statement] = STATE(47),
    [sym_try_statement] = STATE(47),
    [sym_with_statement] = STATE(47),
    [sym_function_definition] = STATE(47),
    [sym_global_statement] = STATE(861),
    [sym_nonlocal_statement] = STATE(861),
    [sym_exec_statement] = STATE(861),
    [sym_class_definition] = STATE(47),
    [sym_decorated_definition] = STATE(47),
    [sym_decorator] = STATE(667),
    [sym_block] = STATE(398),
    [sym_expression_list] = STATE(618),
    [sym__expression] = STATE(601),
    [sym__primary_expression] = STATE(109),
    [sym_not_operator] = STATE(601),
    [sym_boolean_operator] = STATE(601),
    [sym_binary_operator] = STATE(109),
    [sym_unary_operator] = STATE(109),
    [sym_comparison_operator] = STATE(601),
    [sym_lambda] = STATE(601),
    [sym_assignment] = STATE(936),
    [sym_augmented_assignment] = STATE(936),
    [sym_yield] = STATE(936),
    [sym_attribute] = STATE(109),
    [sym_subscript] = STATE(109),
    [sym_call] = STATE(109),
    [sym_list] = STATE(109),
    [sym_list_comprehension] = STATE(109),
    [sym_dictionary] = STATE(109),
    [sym_dictionary_comprehension] = STATE(109),
    [sym_set] = STATE(109),
    [sym_set_comprehension] = STATE(109),
    [sym_parenthesized_expression] = STATE(109),
    [sym_tuple] = STATE(109),
    [sym_generator_expression] = STATE(109),
    [sym_conditional_expression] = STATE(601),
    [sym_concatenated_string] = STATE(109),
    [sym_string] = STATE(117),
    [sym_await] = STATE(601),
    [aux_sym_module_repeat1] = STATE(47),
    [aux_sym_decorated_definition_repeat1] = STATE(667),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_import] = ACTIONS(9),
    [anon_sym_from] = ACTIONS(11),
    [anon_sym_LPAREN] = ACTIONS(13),
    [anon_sym_print] = ACTIONS(15),
    [anon_sym_assert] = ACTIONS(17),
    [anon_sym_return] = ACTIONS(19),
    [anon_sym_del] = ACTIONS(21),
    [anon_sym_raise] = ACTIONS(23),
    [anon_sym_pass] = ACTIONS(25),
    [anon_sym_break] = ACTIONS(27),
    [anon_sym_continue] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(75),
    [anon_sym_async] = ACTIONS(77),
    [anon_sym_for] = ACTIONS(79),
    [anon_sym_while] = ACTIONS(81),
    [anon_sym_try] = ACTIONS(83),
    [anon_sym_with] = ACTIONS(85),
    [anon_sym_def] = ACTIONS(87),
    [anon_sym_global] = ACTIONS(45),
    [anon_sym_nonlocal] = ACTIONS(47),
    [anon_sym_exec] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(89),
    [anon_sym_AT] = ACTIONS(53),
    [anon_sym_not] = ACTIONS(55),
    [anon_sym_PLUS] = ACTIONS(57),
    [anon_sym_DASH] = ACTIONS(57),
    [anon_sym_TILDE] = ACTIONS(57),
    [anon_sym_lambda] = ACTIONS(59),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [sym_ellipsis] = ACTIONS(65),
    [anon_sym_LBRACE] = ACTIONS(67),
    [sym_integer] = ACTIONS(69),
    [sym_float] = ACTIONS(65),
    [sym_true] = ACTIONS(69),
    [sym_false] = ACTIONS(69),
    [sym_none] = ACTIONS(69),
    [anon_sym_await] = ACTIONS(71),
    [sym_comment] = ACTIONS(3),
    [sym__dedent] = ACTIONS(93),
    [sym__string_start] = ACTIONS(73),
  },
  [27] = {
    [sym__statement] = STATE(44),
    [sym__simple_statements] = STATE(44),
    [sym_import_statement] = STATE(861),
    [sym_future_import_statement] = STATE(861),
    [sym_import_from_statement] = STATE(861),
    [sym_print_statement] = STATE(861),
    [sym_assert_statement] = STATE(861),
    [sym_expression_statement] = STATE(861),
    [sym_named_expression] = STATE(601),
    [sym_return_statement] = STATE(861),
    [sym_delete_statement] = STATE(861),
    [sym_raise_statement] = STATE(861),
    [sym_pass_statement] = STATE(861),
    [sym_break_statement] = STATE(861),
    [sym_continue_statement] = STATE(861),
    [sym_if_statement] = STATE(44),
    [sym_for_statement] = STATE(44),
    [sym_while_statement] = STATE(44),
    [sym_try_statement] = STATE(44),
    [sym_with_statement] = STATE(44),
    [sym_function_definition] = STATE(44),
    [sym_global_statement] = STATE(861),
    [sym_nonlocal_statement] = STATE(861),
    [sym_exec_statement] = STATE(861),
    [sym_class_definition] = STATE(44),
    [sym_decorated_definition] = STATE(44),
    [sym_decorator] = STATE(667),
    [sym_block] = STATE(456),
    [sym_expression_list] = STATE(618),
    [sym__expression] = STATE(601),
    [sym__primary_expression] = STATE(109),
    [sym_not_operator] = STATE(601),
    [sym_boolean_operator] = STATE(601),
    [sym_binary_operator] = STATE(109),
    [sym_unary_operator] = STATE(109),
    [sym_comparison_operator] = STATE(601),
    [sym_lambda] = STATE(601),
    [sym_assignment] = STATE(936),
    [sym_augmented_assignment] = STATE(936),
    [sym_yield] = STATE(936),
    [sym_attribute] = STATE(109),
    [sym_subscript] = STATE(109),
    [sym_call] = STATE(109),
    [sym_list] = STATE(109),
    [sym_list_comprehension] = STATE(109),
    [sym_dictionary] = STATE(109),
    [sym_dictionary_comprehension] = STATE(109),
    [sym_set] = STATE(109),
    [sym_set_comprehension] = STATE(109),
    [sym_parenthesized_expression] = STATE(109),
    [sym_tuple] = STATE(109),
    [sym_generator_expression] = STATE(109),
    [sym_conditional_expression] = STATE(601),
    [sym_concatenated_string] = STATE(109),
    [sym_string] = STATE(117),
    [sym_await] = STATE(601),
    [aux_sym_module_repeat1] = STATE(44),
    [aux_sym_decorated_definition_repeat1] = STATE(667),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_import] = ACTIONS(9),
    [anon_sym_from] = ACTIONS(11),
    [anon_sym_LPAREN] = ACTIONS(13),
    [anon_sym_print] = ACTIONS(15),
    [anon_sym_assert] = ACTIONS(17),
    [anon_sym_return] = ACTIONS(19),
    [anon_sym_del] = ACTIONS(21),
    [anon_sym_raise] = ACTIONS(23),
    [anon_sym_pass] = ACTIONS(25),
    [anon_sym_break] = ACTIONS(27),
    [anon_sym_continue] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(75),
    [anon_sym_async] = ACTIONS(77),
    [anon_sym_for] = ACTIONS(79),
    [anon_sym_while] = ACTIONS(81),
    [anon_sym_try] = ACTIONS(83),
    [anon_sym_with] = ACTIONS(85),
    [anon_sym_def] = ACTIONS(87),
    [anon_sym_global] = ACTIONS(45),
    [anon_sym_nonlocal] = ACTIONS(47),
    [anon_sym_exec] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(89),
    [anon_sym_AT] = ACTIONS(53),
    [anon_sym_not] = ACTIONS(55),
    [anon_sym_PLUS] = ACTIONS(57),
    [anon_sym_DASH] = ACTIONS(57),
    [anon_sym_TILDE] = ACTIONS(57),
    [anon_sym_lambda] = ACTIONS(59),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [sym_ellipsis] = ACTIONS(65),
    [anon_sym_LBRACE] = ACTIONS(67),
    [sym_integer] = ACTIONS(69),
    [sym_float] = ACTIONS(65),
    [sym_true] = ACTIONS(69),
    [sym_false] = ACTIONS(69),
    [sym_none] = ACTIONS(69),
    [anon_sym_await] = ACTIONS(71),
    [sym_comment] = ACTIONS(3),
    [sym__dedent] = ACTIONS(91),
    [sym__string_start] = ACTIONS(73),
  },
  [28] = {
    [sym__statement] = STATE(47),
    [sym__simple_statements] = STATE(47),
    [sym_import_statement] = STATE(861),
    [sym_future_import_statement] = STATE(861),
    [sym_import_from_statement] = STATE(861),
    [sym_print_statement] = STATE(861),
    [sym_assert_statement] = STATE(861),
    [sym_expression_statement] = STATE(861),
    [sym_named_expression] = STATE(601),
    [sym_return_statement] = STATE(861),
    [sym_delete_statement] = STATE(861),
    [sym_raise_statement] = STATE(861),
    [sym_pass_statement] = STATE(861),
    [sym_break_statement] = STATE(861),
    [sym_continue_statement] = STATE(861),
    [sym_if_statement] = STATE(47),
    [sym_for_statement] = STATE(47),
    [sym_while_statement] = STATE(47),
    [sym_try_statement] = STATE(47),
    [sym_with_statement] = STATE(47),
    [sym_function_definition] = STATE(47),
    [sym_global_statement] = STATE(861),
    [sym_nonlocal_statement] = STATE(861),
    [sym_exec_statement] = STATE(861),
    [sym_class_definition] = STATE(47),
    [sym_decorated_definition] = STATE(47),
    [sym_decorator] = STATE(667),
    [sym_block] = STATE(438),
    [sym_expression_list] = STATE(618),
    [sym__expression] = STATE(601),
    [sym__primary_expression] = STATE(109),
    [sym_not_operator] = STATE(601),
    [sym_boolean_operator] = STATE(601),
    [sym_binary_operator] = STATE(109),
    [sym_unary_operator] = STATE(109),
    [sym_comparison_operator] = STATE(601),
    [sym_lambda] = STATE(601),
    [sym_assignment] = STATE(936),
    [sym_augmented_assignment] = STATE(936),
    [sym_yield] = STATE(936),
    [sym_attribute] = STATE(109),
    [sym_subscript] = STATE(109),
    [sym_call] = STATE(109),
    [sym_list] = STATE(109),
    [sym_list_comprehension] = STATE(109),
    [sym_dictionary] = STATE(109),
    [sym_dictionary_comprehension] = STATE(109),
    [sym_set] = STATE(109),
    [sym_set_comprehension] = STATE(109),
    [sym_parenthesized_expression] = STATE(109),
    [sym_tuple] = STATE(109),
    [sym_generator_expression] = STATE(109),
    [sym_conditional_expression] = STATE(601),
    [sym_concatenated_string] = STATE(109),
    [sym_string] = STATE(117),
    [sym_await] = STATE(601),
    [aux_sym_module_repeat1] = STATE(47),
    [aux_sym_decorated_definition_repeat1] = STATE(667),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_import] = ACTIONS(9),
    [anon_sym_from] = ACTIONS(11),
    [anon_sym_LPAREN] = ACTIONS(13),
    [anon_sym_print] = ACTIONS(15),
    [anon_sym_assert] = ACTIONS(17),
    [anon_sym_return] = ACTIONS(19),
    [anon_sym_del] = ACTIONS(21),
    [anon_sym_raise] = ACTIONS(23),
    [anon_sym_pass] = ACTIONS(25),
    [anon_sym_break] = ACTIONS(27),
    [anon_sym_continue] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(75),
    [anon_sym_async] = ACTIONS(77),
    [anon_sym_for] = ACTIONS(79),
    [anon_sym_while] = ACTIONS(81),
    [anon_sym_try] = ACTIONS(83),
    [anon_sym_with] = ACTIONS(85),
    [anon_sym_def] = ACTIONS(87),
    [anon_sym_global] = ACTIONS(45),
    [anon_sym_nonlocal] = ACTIONS(47),
    [anon_sym_exec] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(89),
    [anon_sym_AT] = ACTIONS(53),
    [anon_sym_not] = ACTIONS(55),
    [anon_sym_PLUS] = ACTIONS(57),
    [anon_sym_DASH] = ACTIONS(57),
    [anon_sym_TILDE] = ACTIONS(57),
    [anon_sym_lambda] = ACTIONS(59),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [sym_ellipsis] = ACTIONS(65),
    [anon_sym_LBRACE] = ACTIONS(67),
    [sym_integer] = ACTIONS(69),
    [sym_float] = ACTIONS(65),
    [sym_true] = ACTIONS(69),
    [sym_false] = ACTIONS(69),
    [sym_none] = ACTIONS(69),
    [anon_sym_await] = ACTIONS(71),
    [sym_comment] = ACTIONS(3),
    [sym__dedent] = ACTIONS(93),
    [sym__string_start] = ACTIONS(73),
  },
  [29] = {
    [sym__statement] = STATE(47),
    [sym__simple_statements] = STATE(47),
    [sym_import_statement] = STATE(861),
    [sym_future_import_statement] = STATE(861),
    [sym_import_from_statement] = STATE(861),
    [sym_print_statement] = STATE(861),
    [sym_assert_statement] = STATE(861),
    [sym_expression_statement] = STATE(861),
    [sym_named_expression] = STATE(601),
    [sym_return_statement] = STATE(861),
    [sym_delete_statement] = STATE(861),
    [sym_raise_statement] = STATE(861),
    [sym_pass_statement] = STATE(861),
    [sym_break_statement] = STATE(861),
    [sym_continue_statement] = STATE(861),
    [sym_if_statement] = STATE(47),
    [sym_for_statement] = STATE(47),
    [sym_while_statement] = STATE(47),
    [sym_try_statement] = STATE(47),
    [sym_with_statement] = STATE(47),
    [sym_function_definition] = STATE(47),
    [sym_global_statement] = STATE(861),
    [sym_nonlocal_statement] = STATE(861),
    [sym_exec_statement] = STATE(861),
    [sym_class_definition] = STATE(47),
    [sym_decorated_definition] = STATE(47),
    [sym_decorator] = STATE(667),
    [sym_block] = STATE(394),
    [sym_expression_list] = STATE(618),
    [sym__expression] = STATE(601),
    [sym__primary_expression] = STATE(109),
    [sym_not_operator] = STATE(601),
    [sym_boolean_operator] = STATE(601),
    [sym_binary_operator] = STATE(109),
    [sym_unary_operator] = STATE(109),
    [sym_comparison_operator] = STATE(601),
    [sym_lambda] = STATE(601),
    [sym_assignment] = STATE(936),
    [sym_augmented_assignment] = STATE(936),
    [sym_yield] = STATE(936),
    [sym_attribute] = STATE(109),
    [sym_subscript] = STATE(109),
    [sym_call] = STATE(109),
    [sym_list] = STATE(109),
    [sym_list_comprehension] = STATE(109),
    [sym_dictionary] = STATE(109),
    [sym_dictionary_comprehension] = STATE(109),
    [sym_set] = STATE(109),
    [sym_set_comprehension] = STATE(109),
    [sym_parenthesized_expression] = STATE(109),
    [sym_tuple] = STATE(109),
    [sym_generator_expression] = STATE(109),
    [sym_conditional_expression] = STATE(601),
    [sym_concatenated_string] = STATE(109),
    [sym_string] = STATE(117),
    [sym_await] = STATE(601),
    [aux_sym_module_repeat1] = STATE(47),
    [aux_sym_decorated_definition_repeat1] = STATE(667),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_import] = ACTIONS(9),
    [anon_sym_from] = ACTIONS(11),
    [anon_sym_LPAREN] = ACTIONS(13),
    [anon_sym_print] = ACTIONS(15),
    [anon_sym_assert] = ACTIONS(17),
    [anon_sym_return] = ACTIONS(19),
    [anon_sym_del] = ACTIONS(21),
    [anon_sym_raise] = ACTIONS(23),
    [anon_sym_pass] = ACTIONS(25),
    [anon_sym_break] = ACTIONS(27),
    [anon_sym_continue] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(75),
    [anon_sym_async] = ACTIONS(77),
    [anon_sym_for] = ACTIONS(79),
    [anon_sym_while] = ACTIONS(81),
    [anon_sym_try] = ACTIONS(83),
    [anon_sym_with] = ACTIONS(85),
    [anon_sym_def] = ACTIONS(87),
    [anon_sym_global] = ACTIONS(45),
    [anon_sym_nonlocal] = ACTIONS(47),
    [anon_sym_exec] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(89),
    [anon_sym_AT] = ACTIONS(53),
    [anon_sym_not] = ACTIONS(55),
    [anon_sym_PLUS] = ACTIONS(57),
    [anon_sym_DASH] = ACTIONS(57),
    [anon_sym_TILDE] = ACTIONS(57),
    [anon_sym_lambda] = ACTIONS(59),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [sym_ellipsis] = ACTIONS(65),
    [anon_sym_LBRACE] = ACTIONS(67),
    [sym_integer] = ACTIONS(69),
    [sym_float] = ACTIONS(65),
    [sym_true] = ACTIONS(69),
    [sym_false] = ACTIONS(69),
    [sym_none] = ACTIONS(69),
    [anon_sym_await] = ACTIONS(71),
    [sym_comment] = ACTIONS(3),
    [sym__dedent] = ACTIONS(93),
    [sym__string_start] = ACTIONS(73),
  },
  [30] = {
    [sym__statement] = STATE(47),
    [sym__simple_statements] = STATE(47),
    [sym_import_statement] = STATE(861),
    [sym_future_import_statement] = STATE(861),
    [sym_import_from_statement] = STATE(861),
    [sym_print_statement] = STATE(861),
    [sym_assert_statement] = STATE(861),
    [sym_expression_statement] = STATE(861),
    [sym_named_expression] = STATE(601),
    [sym_return_statement] = STATE(861),
    [sym_delete_statement] = STATE(861),
    [sym_raise_statement] = STATE(861),
    [sym_pass_statement] = STATE(861),
    [sym_break_statement] = STATE(861),
    [sym_continue_statement] = STATE(861),
    [sym_if_statement] = STATE(47),
    [sym_for_statement] = STATE(47),
    [sym_while_statement] = STATE(47),
    [sym_try_statement] = STATE(47),
    [sym_with_statement] = STATE(47),
    [sym_function_definition] = STATE(47),
    [sym_global_statement] = STATE(861),
    [sym_nonlocal_statement] = STATE(861),
    [sym_exec_statement] = STATE(861),
    [sym_class_definition] = STATE(47),
    [sym_decorated_definition] = STATE(47),
    [sym_decorator] = STATE(667),
    [sym_block] = STATE(458),
    [sym_expression_list] = STATE(618),
    [sym__expression] = STATE(601),
    [sym__primary_expression] = STATE(109),
    [sym_not_operator] = STATE(601),
    [sym_boolean_operator] = STATE(601),
    [sym_binary_operator] = STATE(109),
    [sym_unary_operator] = STATE(109),
    [sym_comparison_operator] = STATE(601),
    [sym_lambda] = STATE(601),
    [sym_assignment] = STATE(936),
    [sym_augmented_assignment] = STATE(936),
    [sym_yield] = STATE(936),
    [sym_attribute] = STATE(109),
    [sym_subscript] = STATE(109),
    [sym_call] = STATE(109),
    [sym_list] = STATE(109),
    [sym_list_comprehension] = STATE(109),
    [sym_dictionary] = STATE(109),
    [sym_dictionary_comprehension] = STATE(109),
    [sym_set] = STATE(109),
    [sym_set_comprehension] = STATE(109),
    [sym_parenthesized_expression] = STATE(109),
    [sym_tuple] = STATE(109),
    [sym_generator_expression] = STATE(109),
    [sym_conditional_expression] = STATE(601),
    [sym_concatenated_string] = STATE(109),
    [sym_string] = STATE(117),
    [sym_await] = STATE(601),
    [aux_sym_module_repeat1] = STATE(47),
    [aux_sym_decorated_definition_repeat1] = STATE(667),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_import] = ACTIONS(9),
    [anon_sym_from] = ACTIONS(11),
    [anon_sym_LPAREN] = ACTIONS(13),
    [anon_sym_print] = ACTIONS(15),
    [anon_sym_assert] = ACTIONS(17),
    [anon_sym_return] = ACTIONS(19),
    [anon_sym_del] = ACTIONS(21),
    [anon_sym_raise] = ACTIONS(23),
    [anon_sym_pass] = ACTIONS(25),
    [anon_sym_break] = ACTIONS(27),
    [anon_sym_continue] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(75),
    [anon_sym_async] = ACTIONS(77),
    [anon_sym_for] = ACTIONS(79),
    [anon_sym_while] = ACTIONS(81),
    [anon_sym_try] = ACTIONS(83),
    [anon_sym_with] = ACTIONS(85),
    [anon_sym_def] = ACTIONS(87),
    [anon_sym_global] = ACTIONS(45),
    [anon_sym_nonlocal] = ACTIONS(47),
    [anon_sym_exec] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(89),
    [anon_sym_AT] = ACTIONS(53),
    [anon_sym_not] = ACTIONS(55),
    [anon_sym_PLUS] = ACTIONS(57),
    [anon_sym_DASH] = ACTIONS(57),
    [anon_sym_TILDE] = ACTIONS(57),
    [anon_sym_lambda] = ACTIONS(59),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [sym_ellipsis] = ACTIONS(65),
    [anon_sym_LBRACE] = ACTIONS(67),
    [sym_integer] = ACTIONS(69),
    [sym_float] = ACTIONS(65),
    [sym_true] = ACTIONS(69),
    [sym_false] = ACTIONS(69),
    [sym_none] = ACTIONS(69),
    [anon_sym_await] = ACTIONS(71),
    [sym_comment] = ACTIONS(3),
    [sym__dedent] = ACTIONS(93),
    [sym__string_start] = ACTIONS(73),
  },
  [31] = {
    [sym__statement] = STATE(47),
    [sym__simple_statements] = STATE(47),
    [sym_import_statement] = STATE(861),
    [sym_future_import_statement] = STATE(861),
    [sym_import_from_statement] = STATE(861),
    [sym_print_statement] = STATE(861),
    [sym_assert_statement] = STATE(861),
    [sym_expression_statement] = STATE(861),
    [sym_named_expression] = STATE(601),
    [sym_return_statement] = STATE(861),
    [sym_delete_statement] = STATE(861),
    [sym_raise_statement] = STATE(861),
    [sym_pass_statement] = STATE(861),
    [sym_break_statement] = STATE(861),
    [sym_continue_statement] = STATE(861),
    [sym_if_statement] = STATE(47),
    [sym_for_statement] = STATE(47),
    [sym_while_statement] = STATE(47),
    [sym_try_statement] = STATE(47),
    [sym_with_statement] = STATE(47),
    [sym_function_definition] = STATE(47),
    [sym_global_statement] = STATE(861),
    [sym_nonlocal_statement] = STATE(861),
    [sym_exec_statement] = STATE(861),
    [sym_class_definition] = STATE(47),
    [sym_decorated_definition] = STATE(47),
    [sym_decorator] = STATE(667),
    [sym_block] = STATE(428),
    [sym_expression_list] = STATE(618),
    [sym__expression] = STATE(601),
    [sym__primary_expression] = STATE(109),
    [sym_not_operator] = STATE(601),
    [sym_boolean_operator] = STATE(601),
    [sym_binary_operator] = STATE(109),
    [sym_unary_operator] = STATE(109),
    [sym_comparison_operator] = STATE(601),
    [sym_lambda] = STATE(601),
    [sym_assignment] = STATE(936),
    [sym_augmented_assignment] = STATE(936),
    [sym_yield] = STATE(936),
    [sym_attribute] = STATE(109),
    [sym_subscript] = STATE(109),
    [sym_call] = STATE(109),
    [sym_list] = STATE(109),
    [sym_list_comprehension] = STATE(109),
    [sym_dictionary] = STATE(109),
    [sym_dictionary_comprehension] = STATE(109),
    [sym_set] = STATE(109),
    [sym_set_comprehension] = STATE(109),
    [sym_parenthesized_expression] = STATE(109),
    [sym_tuple] = STATE(109),
    [sym_generator_expression] = STATE(109),
    [sym_conditional_expression] = STATE(601),
    [sym_concatenated_string] = STATE(109),
    [sym_string] = STATE(117),
    [sym_await] = STATE(601),
    [aux_sym_module_repeat1] = STATE(47),
    [aux_sym_decorated_definition_repeat1] = STATE(667),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_import] = ACTIONS(9),
    [anon_sym_from] = ACTIONS(11),
    [anon_sym_LPAREN] = ACTIONS(13),
    [anon_sym_print] = ACTIONS(15),
    [anon_sym_assert] = ACTIONS(17),
    [anon_sym_return] = ACTIONS(19),
    [anon_sym_del] = ACTIONS(21),
    [anon_sym_raise] = ACTIONS(23),
    [anon_sym_pass] = ACTIONS(25),
    [anon_sym_break] = ACTIONS(27),
    [anon_sym_continue] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(75),
    [anon_sym_async] = ACTIONS(77),
    [anon_sym_for] = ACTIONS(79),
    [anon_sym_while] = ACTIONS(81),
    [anon_sym_try] = ACTIONS(83),
    [anon_sym_with] = ACTIONS(85),
    [anon_sym_def] = ACTIONS(87),
    [anon_sym_global] = ACTIONS(45),
    [anon_sym_nonlocal] = ACTIONS(47),
    [anon_sym_exec] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(89),
    [anon_sym_AT] = ACTIONS(53),
    [anon_sym_not] = ACTIONS(55),
    [anon_sym_PLUS] = ACTIONS(57),
    [anon_sym_DASH] = ACTIONS(57),
    [anon_sym_TILDE] = ACTIONS(57),
    [anon_sym_lambda] = ACTIONS(59),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [sym_ellipsis] = ACTIONS(65),
    [anon_sym_LBRACE] = ACTIONS(67),
    [sym_integer] = ACTIONS(69),
    [sym_float] = ACTIONS(65),
    [sym_true] = ACTIONS(69),
    [sym_false] = ACTIONS(69),
    [sym_none] = ACTIONS(69),
    [anon_sym_await] = ACTIONS(71),
    [sym_comment] = ACTIONS(3),
    [sym__dedent] = ACTIONS(93),
    [sym__string_start] = ACTIONS(73),
  },
  [32] = {
    [sym__statement] = STATE(44),
    [sym__simple_statements] = STATE(44),
    [sym_import_statement] = STATE(861),
    [sym_future_import_statement] = STATE(861),
    [sym_import_from_statement] = STATE(861),
    [sym_print_statement] = STATE(861),
    [sym_assert_statement] = STATE(861),
    [sym_expression_statement] = STATE(861),
    [sym_named_expression] = STATE(601),
    [sym_return_statement] = STATE(861),
    [sym_delete_statement] = STATE(861),
    [sym_raise_statement] = STATE(861),
    [sym_pass_statement] = STATE(861),
    [sym_break_statement] = STATE(861),
    [sym_continue_statement] = STATE(861),
    [sym_if_statement] = STATE(44),
    [sym_for_statement] = STATE(44),
    [sym_while_statement] = STATE(44),
    [sym_try_statement] = STATE(44),
    [sym_with_statement] = STATE(44),
    [sym_function_definition] = STATE(44),
    [sym_global_statement] = STATE(861),
    [sym_nonlocal_statement] = STATE(861),
    [sym_exec_statement] = STATE(861),
    [sym_class_definition] = STATE(44),
    [sym_decorated_definition] = STATE(44),
    [sym_decorator] = STATE(667),
    [sym_block] = STATE(237),
    [sym_expression_list] = STATE(618),
    [sym__expression] = STATE(601),
    [sym__primary_expression] = STATE(109),
    [sym_not_operator] = STATE(601),
    [sym_boolean_operator] = STATE(601),
    [sym_binary_operator] = STATE(109),
    [sym_unary_operator] = STATE(109),
    [sym_comparison_operator] = STATE(601),
    [sym_lambda] = STATE(601),
    [sym_assignment] = STATE(936),
    [sym_augmented_assignment] = STATE(936),
    [sym_yield] = STATE(936),
    [sym_attribute] = STATE(109),
    [sym_subscript] = STATE(109),
    [sym_call] = STATE(109),
    [sym_list] = STATE(109),
    [sym_list_comprehension] = STATE(109),
    [sym_dictionary] = STATE(109),
    [sym_dictionary_comprehension] = STATE(109),
    [sym_set] = STATE(109),
    [sym_set_comprehension] = STATE(109),
    [sym_parenthesized_expression] = STATE(109),
    [sym_tuple] = STATE(109),
    [sym_generator_expression] = STATE(109),
    [sym_conditional_expression] = STATE(601),
    [sym_concatenated_string] = STATE(109),
    [sym_string] = STATE(117),
    [sym_await] = STATE(601),
    [aux_sym_module_repeat1] = STATE(44),
    [aux_sym_decorated_definition_repeat1] = STATE(667),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_import] = ACTIONS(9),
    [anon_sym_from] = ACTIONS(11),
    [anon_sym_LPAREN] = ACTIONS(13),
    [anon_sym_print] = ACTIONS(15),
    [anon_sym_assert] = ACTIONS(17),
    [anon_sym_return] = ACTIONS(19),
    [anon_sym_del] = ACTIONS(21),
    [anon_sym_raise] = ACTIONS(23),
    [anon_sym_pass] = ACTIONS(25),
    [anon_sym_break] = ACTIONS(27),
    [anon_sym_continue] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(75),
    [anon_sym_async] = ACTIONS(77),
    [anon_sym_for] = ACTIONS(79),
    [anon_sym_while] = ACTIONS(81),
    [anon_sym_try] = ACTIONS(83),
    [anon_sym_with] = ACTIONS(85),
    [anon_sym_def] = ACTIONS(87),
    [anon_sym_global] = ACTIONS(45),
    [anon_sym_nonlocal] = ACTIONS(47),
    [anon_sym_exec] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(89),
    [anon_sym_AT] = ACTIONS(53),
    [anon_sym_not] = ACTIONS(55),
    [anon_sym_PLUS] = ACTIONS(57),
    [anon_sym_DASH] = ACTIONS(57),
    [anon_sym_TILDE] = ACTIONS(57),
    [anon_sym_lambda] = ACTIONS(59),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [sym_ellipsis] = ACTIONS(65),
    [anon_sym_LBRACE] = ACTIONS(67),
    [sym_integer] = ACTIONS(69),
    [sym_float] = ACTIONS(65),
    [sym_true] = ACTIONS(69),
    [sym_false] = ACTIONS(69),
    [sym_none] = ACTIONS(69),
    [anon_sym_await] = ACTIONS(71),
    [sym_comment] = ACTIONS(3),
    [sym__dedent] = ACTIONS(91),
    [sym__string_start] = ACTIONS(73),
  },
  [33] = {
    [sym__statement] = STATE(47),
    [sym__simple_statements] = STATE(47),
    [sym_import_statement] = STATE(861),
    [sym_future_import_statement] = STATE(861),
    [sym_import_from_statement] = STATE(861),
    [sym_print_statement] = STATE(861),
    [sym_assert_statement] = STATE(861),
    [sym_expression_statement] = STATE(861),
    [sym_named_expression] = STATE(601),
    [sym_return_statement] = STATE(861),
    [sym_delete_statement] = STATE(861),
    [sym_raise_statement] = STATE(861),
    [sym_pass_statement] = STATE(861),
    [sym_break_statement] = STATE(861),
    [sym_continue_statement] = STATE(861),
    [sym_if_statement] = STATE(47),
    [sym_for_statement] = STATE(47),
    [sym_while_statement] = STATE(47),
    [sym_try_statement] = STATE(47),
    [sym_with_statement] = STATE(47),
    [sym_function_definition] = STATE(47),
    [sym_global_statement] = STATE(861),
    [sym_nonlocal_statement] = STATE(861),
    [sym_exec_statement] = STATE(861),
    [sym_class_definition] = STATE(47),
    [sym_decorated_definition] = STATE(47),
    [sym_decorator] = STATE(667),
    [sym_block] = STATE(361),
    [sym_expression_list] = STATE(618),
    [sym__expression] = STATE(601),
    [sym__primary_expression] = STATE(109),
    [sym_not_operator] = STATE(601),
    [sym_boolean_operator] = STATE(601),
    [sym_binary_operator] = STATE(109),
    [sym_unary_operator] = STATE(109),
    [sym_comparison_operator] = STATE(601),
    [sym_lambda] = STATE(601),
    [sym_assignment] = STATE(936),
    [sym_augmented_assignment] = STATE(936),
    [sym_yield] = STATE(936),
    [sym_attribute] = STATE(109),
    [sym_subscript] = STATE(109),
    [sym_call] = STATE(109),
    [sym_list] = STATE(109),
    [sym_list_comprehension] = STATE(109),
    [sym_dictionary] = STATE(109),
    [sym_dictionary_comprehension] = STATE(109),
    [sym_set] = STATE(109),
    [sym_set_comprehension] = STATE(109),
    [sym_parenthesized_expression] = STATE(109),
    [sym_tuple] = STATE(109),
    [sym_generator_expression] = STATE(109),
    [sym_conditional_expression] = STATE(601),
    [sym_concatenated_string] = STATE(109),
    [sym_string] = STATE(117),
    [sym_await] = STATE(601),
    [aux_sym_module_repeat1] = STATE(47),
    [aux_sym_decorated_definition_repeat1] = STATE(667),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_import] = ACTIONS(9),
    [anon_sym_from] = ACTIONS(11),
    [anon_sym_LPAREN] = ACTIONS(13),
    [anon_sym_print] = ACTIONS(15),
    [anon_sym_assert] = ACTIONS(17),
    [anon_sym_return] = ACTIONS(19),
    [anon_sym_del] = ACTIONS(21),
    [anon_sym_raise] = ACTIONS(23),
    [anon_sym_pass] = ACTIONS(25),
    [anon_sym_break] = ACTIONS(27),
    [anon_sym_continue] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(75),
    [anon_sym_async] = ACTIONS(77),
    [anon_sym_for] = ACTIONS(79),
    [anon_sym_while] = ACTIONS(81),
    [anon_sym_try] = ACTIONS(83),
    [anon_sym_with] = ACTIONS(85),
    [anon_sym_def] = ACTIONS(87),
    [anon_sym_global] = ACTIONS(45),
    [anon_sym_nonlocal] = ACTIONS(47),
    [anon_sym_exec] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(89),
    [anon_sym_AT] = ACTIONS(53),
    [anon_sym_not] = ACTIONS(55),
    [anon_sym_PLUS] = ACTIONS(57),
    [anon_sym_DASH] = ACTIONS(57),
    [anon_sym_TILDE] = ACTIONS(57),
    [anon_sym_lambda] = ACTIONS(59),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [sym_ellipsis] = ACTIONS(65),
    [anon_sym_LBRACE] = ACTIONS(67),
    [sym_integer] = ACTIONS(69),
    [sym_float] = ACTIONS(65),
    [sym_true] = ACTIONS(69),
    [sym_false] = ACTIONS(69),
    [sym_none] = ACTIONS(69),
    [anon_sym_await] = ACTIONS(71),
    [sym_comment] = ACTIONS(3),
    [sym__dedent] = ACTIONS(93),
    [sym__string_start] = ACTIONS(73),
  },
  [34] = {
    [sym__statement] = STATE(47),
    [sym__simple_statements] = STATE(47),
    [sym_import_statement] = STATE(861),
    [sym_future_import_statement] = STATE(861),
    [sym_import_from_statement] = STATE(861),
    [sym_print_statement] = STATE(861),
    [sym_assert_statement] = STATE(861),
    [sym_expression_statement] = STATE(861),
    [sym_named_expression] = STATE(601),
    [sym_return_statement] = STATE(861),
    [sym_delete_statement] = STATE(861),
    [sym_raise_statement] = STATE(861),
    [sym_pass_statement] = STATE(861),
    [sym_break_statement] = STATE(861),
    [sym_continue_statement] = STATE(861),
    [sym_if_statement] = STATE(47),
    [sym_for_statement] = STATE(47),
    [sym_while_statement] = STATE(47),
    [sym_try_statement] = STATE(47),
    [sym_with_statement] = STATE(47),
    [sym_function_definition] = STATE(47),
    [sym_global_statement] = STATE(861),
    [sym_nonlocal_statement] = STATE(861),
    [sym_exec_statement] = STATE(861),
    [sym_class_definition] = STATE(47),
    [sym_decorated_definition] = STATE(47),
    [sym_decorator] = STATE(667),
    [sym_block] = STATE(450),
    [sym_expression_list] = STATE(618),
    [sym__expression] = STATE(601),
    [sym__primary_expression] = STATE(109),
    [sym_not_operator] = STATE(601),
    [sym_boolean_operator] = STATE(601),
    [sym_binary_operator] = STATE(109),
    [sym_unary_operator] = STATE(109),
    [sym_comparison_operator] = STATE(601),
    [sym_lambda] = STATE(601),
    [sym_assignment] = STATE(936),
    [sym_augmented_assignment] = STATE(936),
    [sym_yield] = STATE(936),
    [sym_attribute] = STATE(109),
    [sym_subscript] = STATE(109),
    [sym_call] = STATE(109),
    [sym_list] = STATE(109),
    [sym_list_comprehension] = STATE(109),
    [sym_dictionary] = STATE(109),
    [sym_dictionary_comprehension] = STATE(109),
    [sym_set] = STATE(109),
    [sym_set_comprehension] = STATE(109),
    [sym_parenthesized_expression] = STATE(109),
    [sym_tuple] = STATE(109),
    [sym_generator_expression] = STATE(109),
    [sym_conditional_expression] = STATE(601),
    [sym_concatenated_string] = STATE(109),
    [sym_string] = STATE(117),
    [sym_await] = STATE(601),
    [aux_sym_module_repeat1] = STATE(47),
    [aux_sym_decorated_definition_repeat1] = STATE(667),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_import] = ACTIONS(9),
    [anon_sym_from] = ACTIONS(11),
    [anon_sym_LPAREN] = ACTIONS(13),
    [anon_sym_print] = ACTIONS(15),
    [anon_sym_assert] = ACTIONS(17),
    [anon_sym_return] = ACTIONS(19),
    [anon_sym_del] = ACTIONS(21),
    [anon_sym_raise] = ACTIONS(23),
    [anon_sym_pass] = ACTIONS(25),
    [anon_sym_break] = ACTIONS(27),
    [anon_sym_continue] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(75),
    [anon_sym_async] = ACTIONS(77),
    [anon_sym_for] = ACTIONS(79),
    [anon_sym_while] = ACTIONS(81),
    [anon_sym_try] = ACTIONS(83),
    [anon_sym_with] = ACTIONS(85),
    [anon_sym_def] = ACTIONS(87),
    [anon_sym_global] = ACTIONS(45),
    [anon_sym_nonlocal] = ACTIONS(47),
    [anon_sym_exec] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(89),
    [anon_sym_AT] = ACTIONS(53),
    [anon_sym_not] = ACTIONS(55),
    [anon_sym_PLUS] = ACTIONS(57),
    [anon_sym_DASH] = ACTIONS(57),
    [anon_sym_TILDE] = ACTIONS(57),
    [anon_sym_lambda] = ACTIONS(59),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [sym_ellipsis] = ACTIONS(65),
    [anon_sym_LBRACE] = ACTIONS(67),
    [sym_integer] = ACTIONS(69),
    [sym_float] = ACTIONS(65),
    [sym_true] = ACTIONS(69),
    [sym_false] = ACTIONS(69),
    [sym_none] = ACTIONS(69),
    [anon_sym_await] = ACTIONS(71),
    [sym_comment] = ACTIONS(3),
    [sym__dedent] = ACTIONS(93),
    [sym__string_start] = ACTIONS(73),
  },
  [35] = {
    [sym__statement] = STATE(47),
    [sym__simple_statements] = STATE(47),
    [sym_import_statement] = STATE(861),
    [sym_future_import_statement] = STATE(861),
    [sym_import_from_statement] = STATE(861),
    [sym_print_statement] = STATE(861),
    [sym_assert_statement] = STATE(861),
    [sym_expression_statement] = STATE(861),
    [sym_named_expression] = STATE(601),
    [sym_return_statement] = STATE(861),
    [sym_delete_statement] = STATE(861),
    [sym_raise_statement] = STATE(861),
    [sym_pass_statement] = STATE(861),
    [sym_break_statement] = STATE(861),
    [sym_continue_statement] = STATE(861),
    [sym_if_statement] = STATE(47),
    [sym_for_statement] = STATE(47),
    [sym_while_statement] = STATE(47),
    [sym_try_statement] = STATE(47),
    [sym_with_statement] = STATE(47),
    [sym_function_definition] = STATE(47),
    [sym_global_statement] = STATE(861),
    [sym_nonlocal_statement] = STATE(861),
    [sym_exec_statement] = STATE(861),
    [sym_class_definition] = STATE(47),
    [sym_decorated_definition] = STATE(47),
    [sym_decorator] = STATE(667),
    [sym_block] = STATE(291),
    [sym_expression_list] = STATE(618),
    [sym__expression] = STATE(601),
    [sym__primary_expression] = STATE(109),
    [sym_not_operator] = STATE(601),
    [sym_boolean_operator] = STATE(601),
    [sym_binary_operator] = STATE(109),
    [sym_unary_operator] = STATE(109),
    [sym_comparison_operator] = STATE(601),
    [sym_lambda] = STATE(601),
    [sym_assignment] = STATE(936),
    [sym_augmented_assignment] = STATE(936),
    [sym_yield] = STATE(936),
    [sym_attribute] = STATE(109),
    [sym_subscript] = STATE(109),
    [sym_call] = STATE(109),
    [sym_list] = STATE(109),
    [sym_list_comprehension] = STATE(109),
    [sym_dictionary] = STATE(109),
    [sym_dictionary_comprehension] = STATE(109),
    [sym_set] = STATE(109),
    [sym_set_comprehension] = STATE(109),
    [sym_parenthesized_expression] = STATE(109),
    [sym_tuple] = STATE(109),
    [sym_generator_expression] = STATE(109),
    [sym_conditional_expression] = STATE(601),
    [sym_concatenated_string] = STATE(109),
    [sym_string] = STATE(117),
    [sym_await] = STATE(601),
    [aux_sym_module_repeat1] = STATE(47),
    [aux_sym_decorated_definition_repeat1] = STATE(667),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_import] = ACTIONS(9),
    [anon_sym_from] = ACTIONS(11),
    [anon_sym_LPAREN] = ACTIONS(13),
    [anon_sym_print] = ACTIONS(15),
    [anon_sym_assert] = ACTIONS(17),
    [anon_sym_return] = ACTIONS(19),
    [anon_sym_del] = ACTIONS(21),
    [anon_sym_raise] = ACTIONS(23),
    [anon_sym_pass] = ACTIONS(25),
    [anon_sym_break] = ACTIONS(27),
    [anon_sym_continue] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(75),
    [anon_sym_async] = ACTIONS(77),
    [anon_sym_for] = ACTIONS(79),
    [anon_sym_while] = ACTIONS(81),
    [anon_sym_try] = ACTIONS(83),
    [anon_sym_with] = ACTIONS(85),
    [anon_sym_def] = ACTIONS(87),
    [anon_sym_global] = ACTIONS(45),
    [anon_sym_nonlocal] = ACTIONS(47),
    [anon_sym_exec] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(89),
    [anon_sym_AT] = ACTIONS(53),
    [anon_sym_not] = ACTIONS(55),
    [anon_sym_PLUS] = ACTIONS(57),
    [anon_sym_DASH] = ACTIONS(57),
    [anon_sym_TILDE] = ACTIONS(57),
    [anon_sym_lambda] = ACTIONS(59),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [sym_ellipsis] = ACTIONS(65),
    [anon_sym_LBRACE] = ACTIONS(67),
    [sym_integer] = ACTIONS(69),
    [sym_float] = ACTIONS(65),
    [sym_true] = ACTIONS(69),
    [sym_false] = ACTIONS(69),
    [sym_none] = ACTIONS(69),
    [anon_sym_await] = ACTIONS(71),
    [sym_comment] = ACTIONS(3),
    [sym__dedent] = ACTIONS(93),
    [sym__string_start] = ACTIONS(73),
  },
  [36] = {
    [sym__statement] = STATE(47),
    [sym__simple_statements] = STATE(47),
    [sym_import_statement] = STATE(861),
    [sym_future_import_statement] = STATE(861),
    [sym_import_from_statement] = STATE(861),
    [sym_print_statement] = STATE(861),
    [sym_assert_statement] = STATE(861),
    [sym_expression_statement] = STATE(861),
    [sym_named_expression] = STATE(601),
    [sym_return_statement] = STATE(861),
    [sym_delete_statement] = STATE(861),
    [sym_raise_statement] = STATE(861),
    [sym_pass_statement] = STATE(861),
    [sym_break_statement] = STATE(861),
    [sym_continue_statement] = STATE(861),
    [sym_if_statement] = STATE(47),
    [sym_for_statement] = STATE(47),
    [sym_while_statement] = STATE(47),
    [sym_try_statement] = STATE(47),
    [sym_with_statement] = STATE(47),
    [sym_function_definition] = STATE(47),
    [sym_global_statement] = STATE(861),
    [sym_nonlocal_statement] = STATE(861),
    [sym_exec_statement] = STATE(861),
    [sym_class_definition] = STATE(47),
    [sym_decorated_definition] = STATE(47),
    [sym_decorator] = STATE(667),
    [sym_block] = STATE(297),
    [sym_expression_list] = STATE(618),
    [sym__expression] = STATE(601),
    [sym__primary_expression] = STATE(109),
    [sym_not_operator] = STATE(601),
    [sym_boolean_operator] = STATE(601),
    [sym_binary_operator] = STATE(109),
    [sym_unary_operator] = STATE(109),
    [sym_comparison_operator] = STATE(601),
    [sym_lambda] = STATE(601),
    [sym_assignment] = STATE(936),
    [sym_augmented_assignment] = STATE(936),
    [sym_yield] = STATE(936),
    [sym_attribute] = STATE(109),
    [sym_subscript] = STATE(109),
    [sym_call] = STATE(109),
    [sym_list] = STATE(109),
    [sym_list_comprehension] = STATE(109),
    [sym_dictionary] = STATE(109),
    [sym_dictionary_comprehension] = STATE(109),
    [sym_set] = STATE(109),
    [sym_set_comprehension] = STATE(109),
    [sym_parenthesized_expression] = STATE(109),
    [sym_tuple] = STATE(109),
    [sym_generator_expression] = STATE(109),
    [sym_conditional_expression] = STATE(601),
    [sym_concatenated_string] = STATE(109),
    [sym_string] = STATE(117),
    [sym_await] = STATE(601),
    [aux_sym_module_repeat1] = STATE(47),
    [aux_sym_decorated_definition_repeat1] = STATE(667),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_import] = ACTIONS(9),
    [anon_sym_from] = ACTIONS(11),
    [anon_sym_LPAREN] = ACTIONS(13),
    [anon_sym_print] = ACTIONS(15),
    [anon_sym_assert] = ACTIONS(17),
    [anon_sym_return] = ACTIONS(19),
    [anon_sym_del] = ACTIONS(21),
    [anon_sym_raise] = ACTIONS(23),
    [anon_sym_pass] = ACTIONS(25),
    [anon_sym_break] = ACTIONS(27),
    [anon_sym_continue] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(75),
    [anon_sym_async] = ACTIONS(77),
    [anon_sym_for] = ACTIONS(79),
    [anon_sym_while] = ACTIONS(81),
    [anon_sym_try] = ACTIONS(83),
    [anon_sym_with] = ACTIONS(85),
    [anon_sym_def] = ACTIONS(87),
    [anon_sym_global] = ACTIONS(45),
    [anon_sym_nonlocal] = ACTIONS(47),
    [anon_sym_exec] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(89),
    [anon_sym_AT] = ACTIONS(53),
    [anon_sym_not] = ACTIONS(55),
    [anon_sym_PLUS] = ACTIONS(57),
    [anon_sym_DASH] = ACTIONS(57),
    [anon_sym_TILDE] = ACTIONS(57),
    [anon_sym_lambda] = ACTIONS(59),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [sym_ellipsis] = ACTIONS(65),
    [anon_sym_LBRACE] = ACTIONS(67),
    [sym_integer] = ACTIONS(69),
    [sym_float] = ACTIONS(65),
    [sym_true] = ACTIONS(69),
    [sym_false] = ACTIONS(69),
    [sym_none] = ACTIONS(69),
    [anon_sym_await] = ACTIONS(71),
    [sym_comment] = ACTIONS(3),
    [sym__dedent] = ACTIONS(93),
    [sym__string_start] = ACTIONS(73),
  },
  [37] = {
    [sym__statement] = STATE(47),
    [sym__simple_statements] = STATE(47),
    [sym_import_statement] = STATE(861),
    [sym_future_import_statement] = STATE(861),
    [sym_import_from_statement] = STATE(861),
    [sym_print_statement] = STATE(861),
    [sym_assert_statement] = STATE(861),
    [sym_expression_statement] = STATE(861),
    [sym_named_expression] = STATE(601),
    [sym_return_statement] = STATE(861),
    [sym_delete_statement] = STATE(861),
    [sym_raise_statement] = STATE(861),
    [sym_pass_statement] = STATE(861),
    [sym_break_statement] = STATE(861),
    [sym_continue_statement] = STATE(861),
    [sym_if_statement] = STATE(47),
    [sym_for_statement] = STATE(47),
    [sym_while_statement] = STATE(47),
    [sym_try_statement] = STATE(47),
    [sym_with_statement] = STATE(47),
    [sym_function_definition] = STATE(47),
    [sym_global_statement] = STATE(861),
    [sym_nonlocal_statement] = STATE(861),
    [sym_exec_statement] = STATE(861),
    [sym_class_definition] = STATE(47),
    [sym_decorated_definition] = STATE(47),
    [sym_decorator] = STATE(667),
    [sym_block] = STATE(373),
    [sym_expression_list] = STATE(618),
    [sym__expression] = STATE(601),
    [sym__primary_expression] = STATE(109),
    [sym_not_operator] = STATE(601),
    [sym_boolean_operator] = STATE(601),
    [sym_binary_operator] = STATE(109),
    [sym_unary_operator] = STATE(109),
    [sym_comparison_operator] = STATE(601),
    [sym_lambda] = STATE(601),
    [sym_assignment] = STATE(936),
    [sym_augmented_assignment] = STATE(936),
    [sym_yield] = STATE(936),
    [sym_attribute] = STATE(109),
    [sym_subscript] = STATE(109),
    [sym_call] = STATE(109),
    [sym_list] = STATE(109),
    [sym_list_comprehension] = STATE(109),
    [sym_dictionary] = STATE(109),
    [sym_dictionary_comprehension] = STATE(109),
    [sym_set] = STATE(109),
    [sym_set_comprehension] = STATE(109),
    [sym_parenthesized_expression] = STATE(109),
    [sym_tuple] = STATE(109),
    [sym_generator_expression] = STATE(109),
    [sym_conditional_expression] = STATE(601),
    [sym_concatenated_string] = STATE(109),
    [sym_string] = STATE(117),
    [sym_await] = STATE(601),
    [aux_sym_module_repeat1] = STATE(47),
    [aux_sym_decorated_definition_repeat1] = STATE(667),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_import] = ACTIONS(9),
    [anon_sym_from] = ACTIONS(11),
    [anon_sym_LPAREN] = ACTIONS(13),
    [anon_sym_print] = ACTIONS(15),
    [anon_sym_assert] = ACTIONS(17),
    [anon_sym_return] = ACTIONS(19),
    [anon_sym_del] = ACTIONS(21),
    [anon_sym_raise] = ACTIONS(23),
    [anon_sym_pass] = ACTIONS(25),
    [anon_sym_break] = ACTIONS(27),
    [anon_sym_continue] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(75),
    [anon_sym_async] = ACTIONS(77),
    [anon_sym_for] = ACTIONS(79),
    [anon_sym_while] = ACTIONS(81),
    [anon_sym_try] = ACTIONS(83),
    [anon_sym_with] = ACTIONS(85),
    [anon_sym_def] = ACTIONS(87),
    [anon_sym_global] = ACTIONS(45),
    [anon_sym_nonlocal] = ACTIONS(47),
    [anon_sym_exec] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(89),
    [anon_sym_AT] = ACTIONS(53),
    [anon_sym_not] = ACTIONS(55),
    [anon_sym_PLUS] = ACTIONS(57),
    [anon_sym_DASH] = ACTIONS(57),
    [anon_sym_TILDE] = ACTIONS(57),
    [anon_sym_lambda] = ACTIONS(59),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [sym_ellipsis] = ACTIONS(65),
    [anon_sym_LBRACE] = ACTIONS(67),
    [sym_integer] = ACTIONS(69),
    [sym_float] = ACTIONS(65),
    [sym_true] = ACTIONS(69),
    [sym_false] = ACTIONS(69),
    [sym_none] = ACTIONS(69),
    [anon_sym_await] = ACTIONS(71),
    [sym_comment] = ACTIONS(3),
    [sym__dedent] = ACTIONS(93),
    [sym__string_start] = ACTIONS(73),
  },
  [38] = {
    [sym__statement] = STATE(47),
    [sym__simple_statements] = STATE(47),
    [sym_import_statement] = STATE(861),
    [sym_future_import_statement] = STATE(861),
    [sym_import_from_statement] = STATE(861),
    [sym_print_statement] = STATE(861),
    [sym_assert_statement] = STATE(861),
    [sym_expression_statement] = STATE(861),
    [sym_named_expression] = STATE(601),
    [sym_return_statement] = STATE(861),
    [sym_delete_statement] = STATE(861),
    [sym_raise_statement] = STATE(861),
    [sym_pass_statement] = STATE(861),
    [sym_break_statement] = STATE(861),
    [sym_continue_statement] = STATE(861),
    [sym_if_statement] = STATE(47),
    [sym_for_statement] = STATE(47),
    [sym_while_statement] = STATE(47),
    [sym_try_statement] = STATE(47),
    [sym_with_statement] = STATE(47),
    [sym_function_definition] = STATE(47),
    [sym_global_statement] = STATE(861),
    [sym_nonlocal_statement] = STATE(861),
    [sym_exec_statement] = STATE(861),
    [sym_class_definition] = STATE(47),
    [sym_decorated_definition] = STATE(47),
    [sym_decorator] = STATE(667),
    [sym_block] = STATE(356),
    [sym_expression_list] = STATE(618),
    [sym__expression] = STATE(601),
    [sym__primary_expression] = STATE(109),
    [sym_not_operator] = STATE(601),
    [sym_boolean_operator] = STATE(601),
    [sym_binary_operator] = STATE(109),
    [sym_unary_operator] = STATE(109),
    [sym_comparison_operator] = STATE(601),
    [sym_lambda] = STATE(601),
    [sym_assignment] = STATE(936),
    [sym_augmented_assignment] = STATE(936),
    [sym_yield] = STATE(936),
    [sym_attribute] = STATE(109),
    [sym_subscript] = STATE(109),
    [sym_call] = STATE(109),
    [sym_list] = STATE(109),
    [sym_list_comprehension] = STATE(109),
    [sym_dictionary] = STATE(109),
    [sym_dictionary_comprehension] = STATE(109),
    [sym_set] = STATE(109),
    [sym_set_comprehension] = STATE(109),
    [sym_parenthesized_expression] = STATE(109),
    [sym_tuple] = STATE(109),
    [sym_generator_expression] = STATE(109),
    [sym_conditional_expression] = STATE(601),
    [sym_concatenated_string] = STATE(109),
    [sym_string] = STATE(117),
    [sym_await] = STATE(601),
    [aux_sym_module_repeat1] = STATE(47),
    [aux_sym_decorated_definition_repeat1] = STATE(667),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_import] = ACTIONS(9),
    [anon_sym_from] = ACTIONS(11),
    [anon_sym_LPAREN] = ACTIONS(13),
    [anon_sym_print] = ACTIONS(15),
    [anon_sym_assert] = ACTIONS(17),
    [anon_sym_return] = ACTIONS(19),
    [anon_sym_del] = ACTIONS(21),
    [anon_sym_raise] = ACTIONS(23),
    [anon_sym_pass] = ACTIONS(25),
    [anon_sym_break] = ACTIONS(27),
    [anon_sym_continue] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(75),
    [anon_sym_async] = ACTIONS(77),
    [anon_sym_for] = ACTIONS(79),
    [anon_sym_while] = ACTIONS(81),
    [anon_sym_try] = ACTIONS(83),
    [anon_sym_with] = ACTIONS(85),
    [anon_sym_def] = ACTIONS(87),
    [anon_sym_global] = ACTIONS(45),
    [anon_sym_nonlocal] = ACTIONS(47),
    [anon_sym_exec] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(89),
    [anon_sym_AT] = ACTIONS(53),
    [anon_sym_not] = ACTIONS(55),
    [anon_sym_PLUS] = ACTIONS(57),
    [anon_sym_DASH] = ACTIONS(57),
    [anon_sym_TILDE] = ACTIONS(57),
    [anon_sym_lambda] = ACTIONS(59),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [sym_ellipsis] = ACTIONS(65),
    [anon_sym_LBRACE] = ACTIONS(67),
    [sym_integer] = ACTIONS(69),
    [sym_float] = ACTIONS(65),
    [sym_true] = ACTIONS(69),
    [sym_false] = ACTIONS(69),
    [sym_none] = ACTIONS(69),
    [anon_sym_await] = ACTIONS(71),
    [sym_comment] = ACTIONS(3),
    [sym__dedent] = ACTIONS(93),
    [sym__string_start] = ACTIONS(73),
  },
  [39] = {
    [sym__statement] = STATE(44),
    [sym__simple_statements] = STATE(44),
    [sym_import_statement] = STATE(861),
    [sym_future_import_statement] = STATE(861),
    [sym_import_from_statement] = STATE(861),
    [sym_print_statement] = STATE(861),
    [sym_assert_statement] = STATE(861),
    [sym_expression_statement] = STATE(861),
    [sym_named_expression] = STATE(601),
    [sym_return_statement] = STATE(861),
    [sym_delete_statement] = STATE(861),
    [sym_raise_statement] = STATE(861),
    [sym_pass_statement] = STATE(861),
    [sym_break_statement] = STATE(861),
    [sym_continue_statement] = STATE(861),
    [sym_if_statement] = STATE(44),
    [sym_for_statement] = STATE(44),
    [sym_while_statement] = STATE(44),
    [sym_try_statement] = STATE(44),
    [sym_with_statement] = STATE(44),
    [sym_function_definition] = STATE(44),
    [sym_global_statement] = STATE(861),
    [sym_nonlocal_statement] = STATE(861),
    [sym_exec_statement] = STATE(861),
    [sym_class_definition] = STATE(44),
    [sym_decorated_definition] = STATE(44),
    [sym_decorator] = STATE(667),
    [sym_block] = STATE(370),
    [sym_expression_list] = STATE(618),
    [sym__expression] = STATE(601),
    [sym__primary_expression] = STATE(109),
    [sym_not_operator] = STATE(601),
    [sym_boolean_operator] = STATE(601),
    [sym_binary_operator] = STATE(109),
    [sym_unary_operator] = STATE(109),
    [sym_comparison_operator] = STATE(601),
    [sym_lambda] = STATE(601),
    [sym_assignment] = STATE(936),
    [sym_augmented_assignment] = STATE(936),
    [sym_yield] = STATE(936),
    [sym_attribute] = STATE(109),
    [sym_subscript] = STATE(109),
    [sym_call] = STATE(109),
    [sym_list] = STATE(109),
    [sym_list_comprehension] = STATE(109),
    [sym_dictionary] = STATE(109),
    [sym_dictionary_comprehension] = STATE(109),
    [sym_set] = STATE(109),
    [sym_set_comprehension] = STATE(109),
    [sym_parenthesized_expression] = STATE(109),
    [sym_tuple] = STATE(109),
    [sym_generator_expression] = STATE(109),
    [sym_conditional_expression] = STATE(601),
    [sym_concatenated_string] = STATE(109),
    [sym_string] = STATE(117),
    [sym_await] = STATE(601),
    [aux_sym_module_repeat1] = STATE(44),
    [aux_sym_decorated_definition_repeat1] = STATE(667),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_import] = ACTIONS(9),
    [anon_sym_from] = ACTIONS(11),
    [anon_sym_LPAREN] = ACTIONS(13),
    [anon_sym_print] = ACTIONS(15),
    [anon_sym_assert] = ACTIONS(17),
    [anon_sym_return] = ACTIONS(19),
    [anon_sym_del] = ACTIONS(21),
    [anon_sym_raise] = ACTIONS(23),
    [anon_sym_pass] = ACTIONS(25),
    [anon_sym_break] = ACTIONS(27),
    [anon_sym_continue] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(75),
    [anon_sym_async] = ACTIONS(77),
    [anon_sym_for] = ACTIONS(79),
    [anon_sym_while] = ACTIONS(81),
    [anon_sym_try] = ACTIONS(83),
    [anon_sym_with] = ACTIONS(85),
    [anon_sym_def] = ACTIONS(87),
    [anon_sym_global] = ACTIONS(45),
    [anon_sym_nonlocal] = ACTIONS(47),
    [anon_sym_exec] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(89),
    [anon_sym_AT] = ACTIONS(53),
    [anon_sym_not] = ACTIONS(55),
    [anon_sym_PLUS] = ACTIONS(57),
    [anon_sym_DASH] = ACTIONS(57),
    [anon_sym_TILDE] = ACTIONS(57),
    [anon_sym_lambda] = ACTIONS(59),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [sym_ellipsis] = ACTIONS(65),
    [anon_sym_LBRACE] = ACTIONS(67),
    [sym_integer] = ACTIONS(69),
    [sym_float] = ACTIONS(65),
    [sym_true] = ACTIONS(69),
    [sym_false] = ACTIONS(69),
    [sym_none] = ACTIONS(69),
    [anon_sym_await] = ACTIONS(71),
    [sym_comment] = ACTIONS(3),
    [sym__dedent] = ACTIONS(91),
    [sym__string_start] = ACTIONS(73),
  },
  [40] = {
    [sym__statement] = STATE(47),
    [sym__simple_statements] = STATE(47),
    [sym_import_statement] = STATE(861),
    [sym_future_import_statement] = STATE(861),
    [sym_import_from_statement] = STATE(861),
    [sym_print_statement] = STATE(861),
    [sym_assert_statement] = STATE(861),
    [sym_expression_statement] = STATE(861),
    [sym_named_expression] = STATE(601),
    [sym_return_statement] = STATE(861),
    [sym_delete_statement] = STATE(861),
    [sym_raise_statement] = STATE(861),
    [sym_pass_statement] = STATE(861),
    [sym_break_statement] = STATE(861),
    [sym_continue_statement] = STATE(861),
    [sym_if_statement] = STATE(47),
    [sym_for_statement] = STATE(47),
    [sym_while_statement] = STATE(47),
    [sym_try_statement] = STATE(47),
    [sym_with_statement] = STATE(47),
    [sym_function_definition] = STATE(47),
    [sym_global_statement] = STATE(861),
    [sym_nonlocal_statement] = STATE(861),
    [sym_exec_statement] = STATE(861),
    [sym_class_definition] = STATE(47),
    [sym_decorated_definition] = STATE(47),
    [sym_decorator] = STATE(667),
    [sym_block] = STATE(382),
    [sym_expression_list] = STATE(618),
    [sym__expression] = STATE(601),
    [sym__primary_expression] = STATE(109),
    [sym_not_operator] = STATE(601),
    [sym_boolean_operator] = STATE(601),
    [sym_binary_operator] = STATE(109),
    [sym_unary_operator] = STATE(109),
    [sym_comparison_operator] = STATE(601),
    [sym_lambda] = STATE(601),
    [sym_assignment] = STATE(936),
    [sym_augmented_assignment] = STATE(936),
    [sym_yield] = STATE(936),
    [sym_attribute] = STATE(109),
    [sym_subscript] = STATE(109),
    [sym_call] = STATE(109),
    [sym_list] = STATE(109),
    [sym_list_comprehension] = STATE(109),
    [sym_dictionary] = STATE(109),
    [sym_dictionary_comprehension] = STATE(109),
    [sym_set] = STATE(109),
    [sym_set_comprehension] = STATE(109),
    [sym_parenthesized_expression] = STATE(109),
    [sym_tuple] = STATE(109),
    [sym_generator_expression] = STATE(109),
    [sym_conditional_expression] = STATE(601),
    [sym_concatenated_string] = STATE(109),
    [sym_string] = STATE(117),
    [sym_await] = STATE(601),
    [aux_sym_module_repeat1] = STATE(47),
    [aux_sym_decorated_definition_repeat1] = STATE(667),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_import] = ACTIONS(9),
    [anon_sym_from] = ACTIONS(11),
    [anon_sym_LPAREN] = ACTIONS(13),
    [anon_sym_print] = ACTIONS(15),
    [anon_sym_assert] = ACTIONS(17),
    [anon_sym_return] = ACTIONS(19),
    [anon_sym_del] = ACTIONS(21),
    [anon_sym_raise] = ACTIONS(23),
    [anon_sym_pass] = ACTIONS(25),
    [anon_sym_break] = ACTIONS(27),
    [anon_sym_continue] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(75),
    [anon_sym_async] = ACTIONS(77),
    [anon_sym_for] = ACTIONS(79),
    [anon_sym_while] = ACTIONS(81),
    [anon_sym_try] = ACTIONS(83),
    [anon_sym_with] = ACTIONS(85),
    [anon_sym_def] = ACTIONS(87),
    [anon_sym_global] = ACTIONS(45),
    [anon_sym_nonlocal] = ACTIONS(47),
    [anon_sym_exec] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(89),
    [anon_sym_AT] = ACTIONS(53),
    [anon_sym_not] = ACTIONS(55),
    [anon_sym_PLUS] = ACTIONS(57),
    [anon_sym_DASH] = ACTIONS(57),
    [anon_sym_TILDE] = ACTIONS(57),
    [anon_sym_lambda] = ACTIONS(59),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [sym_ellipsis] = ACTIONS(65),
    [anon_sym_LBRACE] = ACTIONS(67),
    [sym_integer] = ACTIONS(69),
    [sym_float] = ACTIONS(65),
    [sym_true] = ACTIONS(69),
    [sym_false] = ACTIONS(69),
    [sym_none] = ACTIONS(69),
    [anon_sym_await] = ACTIONS(71),
    [sym_comment] = ACTIONS(3),
    [sym__dedent] = ACTIONS(93),
    [sym__string_start] = ACTIONS(73),
  },
  [41] = {
    [sym__statement] = STATE(47),
    [sym__simple_statements] = STATE(47),
    [sym_import_statement] = STATE(861),
    [sym_future_import_statement] = STATE(861),
    [sym_import_from_statement] = STATE(861),
    [sym_print_statement] = STATE(861),
    [sym_assert_statement] = STATE(861),
    [sym_expression_statement] = STATE(861),
    [sym_named_expression] = STATE(601),
    [sym_return_statement] = STATE(861),
    [sym_delete_statement] = STATE(861),
    [sym_raise_statement] = STATE(861),
    [sym_pass_statement] = STATE(861),
    [sym_break_statement] = STATE(861),
    [sym_continue_statement] = STATE(861),
    [sym_if_statement] = STATE(47),
    [sym_for_statement] = STATE(47),
    [sym_while_statement] = STATE(47),
    [sym_try_statement] = STATE(47),
    [sym_with_statement] = STATE(47),
    [sym_function_definition] = STATE(47),
    [sym_global_statement] = STATE(861),
    [sym_nonlocal_statement] = STATE(861),
    [sym_exec_statement] = STATE(861),
    [sym_class_definition] = STATE(47),
    [sym_decorated_definition] = STATE(47),
    [sym_decorator] = STATE(667),
    [sym_block] = STATE(418),
    [sym_expression_list] = STATE(618),
    [sym__expression] = STATE(601),
    [sym__primary_expression] = STATE(109),
    [sym_not_operator] = STATE(601),
    [sym_boolean_operator] = STATE(601),
    [sym_binary_operator] = STATE(109),
    [sym_unary_operator] = STATE(109),
    [sym_comparison_operator] = STATE(601),
    [sym_lambda] = STATE(601),
    [sym_assignment] = STATE(936),
    [sym_augmented_assignment] = STATE(936),
    [sym_yield] = STATE(936),
    [sym_attribute] = STATE(109),
    [sym_subscript] = STATE(109),
    [sym_call] = STATE(109),
    [sym_list] = STATE(109),
    [sym_list_comprehension] = STATE(109),
    [sym_dictionary] = STATE(109),
    [sym_dictionary_comprehension] = STATE(109),
    [sym_set] = STATE(109),
    [sym_set_comprehension] = STATE(109),
    [sym_parenthesized_expression] = STATE(109),
    [sym_tuple] = STATE(109),
    [sym_generator_expression] = STATE(109),
    [sym_conditional_expression] = STATE(601),
    [sym_concatenated_string] = STATE(109),
    [sym_string] = STATE(117),
    [sym_await] = STATE(601),
    [aux_sym_module_repeat1] = STATE(47),
    [aux_sym_decorated_definition_repeat1] = STATE(667),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_import] = ACTIONS(9),
    [anon_sym_from] = ACTIONS(11),
    [anon_sym_LPAREN] = ACTIONS(13),
    [anon_sym_print] = ACTIONS(15),
    [anon_sym_assert] = ACTIONS(17),
    [anon_sym_return] = ACTIONS(19),
    [anon_sym_del] = ACTIONS(21),
    [anon_sym_raise] = ACTIONS(23),
    [anon_sym_pass] = ACTIONS(25),
    [anon_sym_break] = ACTIONS(27),
    [anon_sym_continue] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(75),
    [anon_sym_async] = ACTIONS(77),
    [anon_sym_for] = ACTIONS(79),
    [anon_sym_while] = ACTIONS(81),
    [anon_sym_try] = ACTIONS(83),
    [anon_sym_with] = ACTIONS(85),
    [anon_sym_def] = ACTIONS(87),
    [anon_sym_global] = ACTIONS(45),
    [anon_sym_nonlocal] = ACTIONS(47),
    [anon_sym_exec] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(89),
    [anon_sym_AT] = ACTIONS(53),
    [anon_sym_not] = ACTIONS(55),
    [anon_sym_PLUS] = ACTIONS(57),
    [anon_sym_DASH] = ACTIONS(57),
    [anon_sym_TILDE] = ACTIONS(57),
    [anon_sym_lambda] = ACTIONS(59),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [sym_ellipsis] = ACTIONS(65),
    [anon_sym_LBRACE] = ACTIONS(67),
    [sym_integer] = ACTIONS(69),
    [sym_float] = ACTIONS(65),
    [sym_true] = ACTIONS(69),
    [sym_false] = ACTIONS(69),
    [sym_none] = ACTIONS(69),
    [anon_sym_await] = ACTIONS(71),
    [sym_comment] = ACTIONS(3),
    [sym__dedent] = ACTIONS(93),
    [sym__string_start] = ACTIONS(73),
  },
  [42] = {
    [sym__statement] = STATE(45),
    [sym__simple_statements] = STATE(45),
    [sym_import_statement] = STATE(831),
    [sym_future_import_statement] = STATE(831),
    [sym_import_from_statement] = STATE(831),
    [sym_print_statement] = STATE(831),
    [sym_assert_statement] = STATE(831),
    [sym_expression_statement] = STATE(831),
    [sym_named_expression] = STATE(601),
    [sym_return_statement] = STATE(831),
    [sym_delete_statement] = STATE(831),
    [sym_raise_statement] = STATE(831),
    [sym_pass_statement] = STATE(831),
    [sym_break_statement] = STATE(831),
    [sym_continue_statement] = STATE(831),
    [sym_if_statement] = STATE(45),
    [sym_for_statement] = STATE(45),
    [sym_while_statement] = STATE(45),
    [sym_try_statement] = STATE(45),
    [sym_with_statement] = STATE(45),
    [sym_function_definition] = STATE(45),
    [sym_global_statement] = STATE(831),
    [sym_nonlocal_statement] = STATE(831),
    [sym_exec_statement] = STATE(831),
    [sym_class_definition] = STATE(45),
    [sym_decorated_definition] = STATE(45),
    [sym_decorator] = STATE(669),
    [sym_expression_list] = STATE(618),
    [sym__expression] = STATE(601),
    [sym__primary_expression] = STATE(109),
    [sym_not_operator] = STATE(601),
    [sym_boolean_operator] = STATE(601),
    [sym_binary_operator] = STATE(109),
    [sym_unary_operator] = STATE(109),
    [sym_comparison_operator] = STATE(601),
    [sym_lambda] = STATE(601),
    [sym_assignment] = STATE(936),
    [sym_augmented_assignment] = STATE(936),
    [sym_yield] = STATE(936),
    [sym_attribute] = STATE(109),
    [sym_subscript] = STATE(109),
    [sym_call] = STATE(109),
    [sym_list] = STATE(109),
    [sym_list_comprehension] = STATE(109),
    [sym_dictionary] = STATE(109),
    [sym_dictionary_comprehension] = STATE(109),
    [sym_set] = STATE(109),
    [sym_set_comprehension] = STATE(109),
    [sym_parenthesized_expression] = STATE(109),
    [sym_tuple] = STATE(109),
    [sym_generator_expression] = STATE(109),
    [sym_conditional_expression] = STATE(601),
    [sym_concatenated_string] = STATE(109),
    [sym_string] = STATE(117),
    [sym_await] = STATE(601),
    [aux_sym_module_repeat1] = STATE(45),
    [aux_sym_decorated_definition_repeat1] = STATE(669),
    [ts_builtin_sym_end] = ACTIONS(97),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_import] = ACTIONS(9),
    [anon_sym_from] = ACTIONS(11),
    [anon_sym_LPAREN] = ACTIONS(13),
    [anon_sym_print] = ACTIONS(15),
    [anon_sym_assert] = ACTIONS(17),
    [anon_sym_return] = ACTIONS(19),
    [anon_sym_del] = ACTIONS(21),
    [anon_sym_raise] = ACTIONS(23),
    [anon_sym_pass] = ACTIONS(25),
    [anon_sym_break] = ACTIONS(27),
    [anon_sym_continue] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_async] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [anon_sym_try] = ACTIONS(39),
    [anon_sym_with] = ACTIONS(41),
    [anon_sym_def] = ACTIONS(43),
    [anon_sym_global] = ACTIONS(45),
    [anon_sym_nonlocal] = ACTIONS(47),
    [anon_sym_exec] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(51),
    [anon_sym_AT] = ACTIONS(53),
    [anon_sym_not] = ACTIONS(55),
    [anon_sym_PLUS] = ACTIONS(57),
    [anon_sym_DASH] = ACTIONS(57),
    [anon_sym_TILDE] = ACTIONS(57),
    [anon_sym_lambda] = ACTIONS(59),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [sym_ellipsis] = ACTIONS(65),
    [anon_sym_LBRACE] = ACTIONS(67),
    [sym_integer] = ACTIONS(69),
    [sym_float] = ACTIONS(65),
    [sym_true] = ACTIONS(69),
    [sym_false] = ACTIONS(69),
    [sym_none] = ACTIONS(69),
    [anon_sym_await] = ACTIONS(71),
    [sym_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(73),
  },
  [43] = {
    [sym__statement] = STATE(46),
    [sym__simple_statements] = STATE(46),
    [sym_import_statement] = STATE(861),
    [sym_future_import_statement] = STATE(861),
    [sym_import_from_statement] = STATE(861),
    [sym_print_statement] = STATE(861),
    [sym_assert_statement] = STATE(861),
    [sym_expression_statement] = STATE(861),
    [sym_named_expression] = STATE(601),
    [sym_return_statement] = STATE(861),
    [sym_delete_statement] = STATE(861),
    [sym_raise_statement] = STATE(861),
    [sym_pass_statement] = STATE(861),
    [sym_break_statement] = STATE(861),
    [sym_continue_statement] = STATE(861),
    [sym_if_statement] = STATE(46),
    [sym_for_statement] = STATE(46),
    [sym_while_statement] = STATE(46),
    [sym_try_statement] = STATE(46),
    [sym_with_statement] = STATE(46),
    [sym_function_definition] = STATE(46),
    [sym_global_statement] = STATE(861),
    [sym_nonlocal_statement] = STATE(861),
    [sym_exec_statement] = STATE(861),
    [sym_class_definition] = STATE(46),
    [sym_decorated_definition] = STATE(46),
    [sym_decorator] = STATE(667),
    [sym_expression_list] = STATE(618),
    [sym__expression] = STATE(601),
    [sym__primary_expression] = STATE(109),
    [sym_not_operator] = STATE(601),
    [sym_boolean_operator] = STATE(601),
    [sym_binary_operator] = STATE(109),
    [sym_unary_operator] = STATE(109),
    [sym_comparison_operator] = STATE(601),
    [sym_lambda] = STATE(601),
    [sym_assignment] = STATE(936),
    [sym_augmented_assignment] = STATE(936),
    [sym_yield] = STATE(936),
    [sym_attribute] = STATE(109),
    [sym_subscript] = STATE(109),
    [sym_call] = STATE(109),
    [sym_list] = STATE(109),
    [sym_list_comprehension] = STATE(109),
    [sym_dictionary] = STATE(109),
    [sym_dictionary_comprehension] = STATE(109),
    [sym_set] = STATE(109),
    [sym_set_comprehension] = STATE(109),
    [sym_parenthesized_expression] = STATE(109),
    [sym_tuple] = STATE(109),
    [sym_generator_expression] = STATE(109),
    [sym_conditional_expression] = STATE(601),
    [sym_concatenated_string] = STATE(109),
    [sym_string] = STATE(117),
    [sym_await] = STATE(601),
    [aux_sym_module_repeat1] = STATE(46),
    [aux_sym_decorated_definition_repeat1] = STATE(667),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_import] = ACTIONS(9),
    [anon_sym_from] = ACTIONS(11),
    [anon_sym_LPAREN] = ACTIONS(13),
    [anon_sym_print] = ACTIONS(15),
    [anon_sym_assert] = ACTIONS(17),
    [anon_sym_return] = ACTIONS(19),
    [anon_sym_del] = ACTIONS(21),
    [anon_sym_raise] = ACTIONS(23),
    [anon_sym_pass] = ACTIONS(25),
    [anon_sym_break] = ACTIONS(27),
    [anon_sym_continue] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(75),
    [anon_sym_async] = ACTIONS(77),
    [anon_sym_for] = ACTIONS(79),
    [anon_sym_while] = ACTIONS(81),
    [anon_sym_try] = ACTIONS(83),
    [anon_sym_with] = ACTIONS(85),
    [anon_sym_def] = ACTIONS(87),
    [anon_sym_global] = ACTIONS(45),
    [anon_sym_nonlocal] = ACTIONS(47),
    [anon_sym_exec] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(89),
    [anon_sym_AT] = ACTIONS(53),
    [anon_sym_not] = ACTIONS(55),
    [anon_sym_PLUS] = ACTIONS(57),
    [anon_sym_DASH] = ACTIONS(57),
    [anon_sym_TILDE] = ACTIONS(57),
    [anon_sym_lambda] = ACTIONS(59),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [sym_ellipsis] = ACTIONS(65),
    [anon_sym_LBRACE] = ACTIONS(67),
    [sym_integer] = ACTIONS(69),
    [sym_float] = ACTIONS(65),
    [sym_true] = ACTIONS(69),
    [sym_false] = ACTIONS(69),
    [sym_none] = ACTIONS(69),
    [anon_sym_await] = ACTIONS(71),
    [sym_comment] = ACTIONS(3),
    [sym__dedent] = ACTIONS(99),
    [sym__string_start] = ACTIONS(73),
  },
  [44] = {
    [sym__statement] = STATE(46),
    [sym__simple_statements] = STATE(46),
    [sym_import_statement] = STATE(861),
    [sym_future_import_statement] = STATE(861),
    [sym_import_from_statement] = STATE(861),
    [sym_print_statement] = STATE(861),
    [sym_assert_statement] = STATE(861),
    [sym_expression_statement] = STATE(861),
    [sym_named_expression] = STATE(601),
    [sym_return_statement] = STATE(861),
    [sym_delete_statement] = STATE(861),
    [sym_raise_statement] = STATE(861),
    [sym_pass_statement] = STATE(861),
    [sym_break_statement] = STATE(861),
    [sym_continue_statement] = STATE(861),
    [sym_if_statement] = STATE(46),
    [sym_for_statement] = STATE(46),
    [sym_while_statement] = STATE(46),
    [sym_try_statement] = STATE(46),
    [sym_with_statement] = STATE(46),
    [sym_function_definition] = STATE(46),
    [sym_global_statement] = STATE(861),
    [sym_nonlocal_statement] = STATE(861),
    [sym_exec_statement] = STATE(861),
    [sym_class_definition] = STATE(46),
    [sym_decorated_definition] = STATE(46),
    [sym_decorator] = STATE(667),
    [sym_expression_list] = STATE(618),
    [sym__expression] = STATE(601),
    [sym__primary_expression] = STATE(109),
    [sym_not_operator] = STATE(601),
    [sym_boolean_operator] = STATE(601),
    [sym_binary_operator] = STATE(109),
    [sym_unary_operator] = STATE(109),
    [sym_comparison_operator] = STATE(601),
    [sym_lambda] = STATE(601),
    [sym_assignment] = STATE(936),
    [sym_augmented_assignment] = STATE(936),
    [sym_yield] = STATE(936),
    [sym_attribute] = STATE(109),
    [sym_subscript] = STATE(109),
    [sym_call] = STATE(109),
    [sym_list] = STATE(109),
    [sym_list_comprehension] = STATE(109),
    [sym_dictionary] = STATE(109),
    [sym_dictionary_comprehension] = STATE(109),
    [sym_set] = STATE(109),
    [sym_set_comprehension] = STATE(109),
    [sym_parenthesized_expression] = STATE(109),
    [sym_tuple] = STATE(109),
    [sym_generator_expression] = STATE(109),
    [sym_conditional_expression] = STATE(601),
    [sym_concatenated_string] = STATE(109),
    [sym_string] = STATE(117),
    [sym_await] = STATE(601),
    [aux_sym_module_repeat1] = STATE(46),
    [aux_sym_decorated_definition_repeat1] = STATE(667),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_import] = ACTIONS(9),
    [anon_sym_from] = ACTIONS(11),
    [anon_sym_LPAREN] = ACTIONS(13),
    [anon_sym_print] = ACTIONS(15),
    [anon_sym_assert] = ACTIONS(17),
    [anon_sym_return] = ACTIONS(19),
    [anon_sym_del] = ACTIONS(21),
    [anon_sym_raise] = ACTIONS(23),
    [anon_sym_pass] = ACTIONS(25),
    [anon_sym_break] = ACTIONS(27),
    [anon_sym_continue] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(75),
    [anon_sym_async] = ACTIONS(77),
    [anon_sym_for] = ACTIONS(79),
    [anon_sym_while] = ACTIONS(81),
    [anon_sym_try] = ACTIONS(83),
    [anon_sym_with] = ACTIONS(85),
    [anon_sym_def] = ACTIONS(87),
    [anon_sym_global] = ACTIONS(45),
    [anon_sym_nonlocal] = ACTIONS(47),
    [anon_sym_exec] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(89),
    [anon_sym_AT] = ACTIONS(53),
    [anon_sym_not] = ACTIONS(55),
    [anon_sym_PLUS] = ACTIONS(57),
    [anon_sym_DASH] = ACTIONS(57),
    [anon_sym_TILDE] = ACTIONS(57),
    [anon_sym_lambda] = ACTIONS(59),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [sym_ellipsis] = ACTIONS(65),
    [anon_sym_LBRACE] = ACTIONS(67),
    [sym_integer] = ACTIONS(69),
    [sym_float] = ACTIONS(65),
    [sym_true] = ACTIONS(69),
    [sym_false] = ACTIONS(69),
    [sym_none] = ACTIONS(69),
    [anon_sym_await] = ACTIONS(71),
    [sym_comment] = ACTIONS(3),
    [sym__dedent] = ACTIONS(101),
    [sym__string_start] = ACTIONS(73),
  },
  [45] = {
    [sym__statement] = STATE(45),
    [sym__simple_statements] = STATE(45),
    [sym_import_statement] = STATE(831),
    [sym_future_import_statement] = STATE(831),
    [sym_import_from_statement] = STATE(831),
    [sym_print_statement] = STATE(831),
    [sym_assert_statement] = STATE(831),
    [sym_expression_statement] = STATE(831),
    [sym_named_expression] = STATE(601),
    [sym_return_statement] = STATE(831),
    [sym_delete_statement] = STATE(831),
    [sym_raise_statement] = STATE(831),
    [sym_pass_statement] = STATE(831),
    [sym_break_statement] = STATE(831),
    [sym_continue_statement] = STATE(831),
    [sym_if_statement] = STATE(45),
    [sym_for_statement] = STATE(45),
    [sym_while_statement] = STATE(45),
    [sym_try_statement] = STATE(45),
    [sym_with_statement] = STATE(45),
    [sym_function_definition] = STATE(45),
    [sym_global_statement] = STATE(831),
    [sym_nonlocal_statement] = STATE(831),
    [sym_exec_statement] = STATE(831),
    [sym_class_definition] = STATE(45),
    [sym_decorated_definition] = STATE(45),
    [sym_decorator] = STATE(669),
    [sym_expression_list] = STATE(618),
    [sym__expression] = STATE(601),
    [sym__primary_expression] = STATE(109),
    [sym_not_operator] = STATE(601),
    [sym_boolean_operator] = STATE(601),
    [sym_binary_operator] = STATE(109),
    [sym_unary_operator] = STATE(109),
    [sym_comparison_operator] = STATE(601),
    [sym_lambda] = STATE(601),
    [sym_assignment] = STATE(936),
    [sym_augmented_assignment] = STATE(936),
    [sym_yield] = STATE(936),
    [sym_attribute] = STATE(109),
    [sym_subscript] = STATE(109),
    [sym_call] = STATE(109),
    [sym_list] = STATE(109),
    [sym_list_comprehension] = STATE(109),
    [sym_dictionary] = STATE(109),
    [sym_dictionary_comprehension] = STATE(109),
    [sym_set] = STATE(109),
    [sym_set_comprehension] = STATE(109),
    [sym_parenthesized_expression] = STATE(109),
    [sym_tuple] = STATE(109),
    [sym_generator_expression] = STATE(109),
    [sym_conditional_expression] = STATE(601),
    [sym_concatenated_string] = STATE(109),
    [sym_string] = STATE(117),
    [sym_await] = STATE(601),
    [aux_sym_module_repeat1] = STATE(45),
    [aux_sym_decorated_definition_repeat1] = STATE(669),
    [ts_builtin_sym_end] = ACTIONS(103),
    [sym_identifier] = ACTIONS(105),
    [anon_sym_import] = ACTIONS(108),
    [anon_sym_from] = ACTIONS(111),
    [anon_sym_LPAREN] = ACTIONS(114),
    [anon_sym_print] = ACTIONS(117),
    [anon_sym_assert] = ACTIONS(120),
    [anon_sym_return] = ACTIONS(123),
    [anon_sym_del] = ACTIONS(126),
    [anon_sym_raise] = ACTIONS(129),
    [anon_sym_pass] = ACTIONS(132),
    [anon_sym_break] = ACTIONS(135),
    [anon_sym_continue] = ACTIONS(138),
    [anon_sym_if] = ACTIONS(141),
    [anon_sym_async] = ACTIONS(144),
    [anon_sym_for] = ACTIONS(147),
    [anon_sym_while] = ACTIONS(150),
    [anon_sym_try] = ACTIONS(153),
    [anon_sym_with] = ACTIONS(156),
    [anon_sym_def] = ACTIONS(159),
    [anon_sym_global] = ACTIONS(162),
    [anon_sym_nonlocal] = ACTIONS(165),
    [anon_sym_exec] = ACTIONS(168),
    [anon_sym_class] = ACTIONS(171),
    [anon_sym_AT] = ACTIONS(174),
    [anon_sym_not] = ACTIONS(177),
    [anon_sym_PLUS] = ACTIONS(180),
    [anon_sym_DASH] = ACTIONS(180),
    [anon_sym_TILDE] = ACTIONS(180),
    [anon_sym_lambda] = ACTIONS(183),
    [anon_sym_yield] = ACTIONS(186),
    [anon_sym_LBRACK] = ACTIONS(189),
    [sym_ellipsis] = ACTIONS(192),
    [anon_sym_LBRACE] = ACTIONS(195),
    [sym_integer] = ACTIONS(198),
    [sym_float] = ACTIONS(192),
    [sym_true] = ACTIONS(198),
    [sym_false] = ACTIONS(198),
    [sym_none] = ACTIONS(198),
    [anon_sym_await] = ACTIONS(201),
    [sym_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(204),
  },
  [46] = {
    [sym__statement] = STATE(46),
    [sym__simple_statements] = STATE(46),
    [sym_import_statement] = STATE(861),
    [sym_future_import_statement] = STATE(861),
    [sym_import_from_statement] = STATE(861),
    [sym_print_statement] = STATE(861),
    [sym_assert_statement] = STATE(861),
    [sym_expression_statement] = STATE(861),
    [sym_named_expression] = STATE(601),
    [sym_return_statement] = STATE(861),
    [sym_delete_statement] = STATE(861),
    [sym_raise_statement] = STATE(861),
    [sym_pass_statement] = STATE(861),
    [sym_break_statement] = STATE(861),
    [sym_continue_statement] = STATE(861),
    [sym_if_statement] = STATE(46),
    [sym_for_statement] = STATE(46),
    [sym_while_statement] = STATE(46),
    [sym_try_statement] = STATE(46),
    [sym_with_statement] = STATE(46),
    [sym_function_definition] = STATE(46),
    [sym_global_statement] = STATE(861),
    [sym_nonlocal_statement] = STATE(861),
    [sym_exec_statement] = STATE(861),
    [sym_class_definition] = STATE(46),
    [sym_decorated_definition] = STATE(46),
    [sym_decorator] = STATE(667),
    [sym_expression_list] = STATE(618),
    [sym__expression] = STATE(601),
    [sym__primary_expression] = STATE(109),
    [sym_not_operator] = STATE(601),
    [sym_boolean_operator] = STATE(601),
    [sym_binary_operator] = STATE(109),
    [sym_unary_operator] = STATE(109),
    [sym_comparison_operator] = STATE(601),
    [sym_lambda] = STATE(601),
    [sym_assignment] = STATE(936),
    [sym_augmented_assignment] = STATE(936),
    [sym_yield] = STATE(936),
    [sym_attribute] = STATE(109),
    [sym_subscript] = STATE(109),
    [sym_call] = STATE(109),
    [sym_list] = STATE(109),
    [sym_list_comprehension] = STATE(109),
    [sym_dictionary] = STATE(109),
    [sym_dictionary_comprehension] = STATE(109),
    [sym_set] = STATE(109),
    [sym_set_comprehension] = STATE(109),
    [sym_parenthesized_expression] = STATE(109),
    [sym_tuple] = STATE(109),
    [sym_generator_expression] = STATE(109),
    [sym_conditional_expression] = STATE(601),
    [sym_concatenated_string] = STATE(109),
    [sym_string] = STATE(117),
    [sym_await] = STATE(601),
    [aux_sym_module_repeat1] = STATE(46),
    [aux_sym_decorated_definition_repeat1] = STATE(667),
    [sym_identifier] = ACTIONS(105),
    [anon_sym_import] = ACTIONS(108),
    [anon_sym_from] = ACTIONS(111),
    [anon_sym_LPAREN] = ACTIONS(114),
    [anon_sym_print] = ACTIONS(117),
    [anon_sym_assert] = ACTIONS(120),
    [anon_sym_return] = ACTIONS(123),
    [anon_sym_del] = ACTIONS(126),
    [anon_sym_raise] = ACTIONS(129),
    [anon_sym_pass] = ACTIONS(132),
    [anon_sym_break] = ACTIONS(135),
    [anon_sym_continue] = ACTIONS(138),
    [anon_sym_if] = ACTIONS(207),
    [anon_sym_async] = ACTIONS(210),
    [anon_sym_for] = ACTIONS(213),
    [anon_sym_while] = ACTIONS(216),
    [anon_sym_try] = ACTIONS(219),
    [anon_sym_with] = ACTIONS(222),
    [anon_sym_def] = ACTIONS(225),
    [anon_sym_global] = ACTIONS(162),
    [anon_sym_nonlocal] = ACTIONS(165),
    [anon_sym_exec] = ACTIONS(168),
    [anon_sym_class] = ACTIONS(228),
    [anon_sym_AT] = ACTIONS(174),
    [anon_sym_not] = ACTIONS(177),
    [anon_sym_PLUS] = ACTIONS(180),
    [anon_sym_DASH] = ACTIONS(180),
    [anon_sym_TILDE] = ACTIONS(180),
    [anon_sym_lambda] = ACTIONS(183),
    [anon_sym_yield] = ACTIONS(186),
    [anon_sym_LBRACK] = ACTIONS(189),
    [sym_ellipsis] = ACTIONS(192),
    [anon_sym_LBRACE] = ACTIONS(195),
    [sym_integer] = ACTIONS(198),
    [sym_float] = ACTIONS(192),
    [sym_true] = ACTIONS(198),
    [sym_false] = ACTIONS(198),
    [sym_none] = ACTIONS(198),
    [anon_sym_await] = ACTIONS(201),
    [sym_comment] = ACTIONS(3),
    [sym__dedent] = ACTIONS(103),
    [sym__string_start] = ACTIONS(204),
  },
  [47] = {
    [sym__statement] = STATE(46),
    [sym__simple_statements] = STATE(46),
    [sym_import_statement] = STATE(861),
    [sym_future_import_statement] = STATE(861),
    [sym_import_from_statement] = STATE(861),
    [sym_print_statement] = STATE(861),
    [sym_assert_statement] = STATE(861),
    [sym_expression_statement] = STATE(861),
    [sym_named_expression] = STATE(601),
    [sym_return_statement] = STATE(861),
    [sym_delete_statement] = STATE(861),
    [sym_raise_statement] = STATE(861),
    [sym_pass_statement] = STATE(861),
    [sym_break_statement] = STATE(861),
    [sym_continue_statement] = STATE(861),
    [sym_if_statement] = STATE(46),
    [sym_for_statement] = STATE(46),
    [sym_while_statement] = STATE(46),
    [sym_try_statement] = STATE(46),
    [sym_with_statement] = STATE(46),
    [sym_function_definition] = STATE(46),
    [sym_global_statement] = STATE(861),
    [sym_nonlocal_statement] = STATE(861),
    [sym_exec_statement] = STATE(861),
    [sym_class_definition] = STATE(46),
    [sym_decorated_definition] = STATE(46),
    [sym_decorator] = STATE(667),
    [sym_expression_list] = STATE(618),
    [sym__expression] = STATE(601),
    [sym__primary_expression] = STATE(109),
    [sym_not_operator] = STATE(601),
    [sym_boolean_operator] = STATE(601),
    [sym_binary_operator] = STATE(109),
    [sym_unary_operator] = STATE(109),
    [sym_comparison_operator] = STATE(601),
    [sym_lambda] = STATE(601),
    [sym_assignment] = STATE(936),
    [sym_augmented_assignment] = STATE(936),
    [sym_yield] = STATE(936),
    [sym_attribute] = STATE(109),
    [sym_subscript] = STATE(109),
    [sym_call] = STATE(109),
    [sym_list] = STATE(109),
    [sym_list_comprehension] = STATE(109),
    [sym_dictionary] = STATE(109),
    [sym_dictionary_comprehension] = STATE(109),
    [sym_set] = STATE(109),
    [sym_set_comprehension] = STATE(109),
    [sym_parenthesized_expression] = STATE(109),
    [sym_tuple] = STATE(109),
    [sym_generator_expression] = STATE(109),
    [sym_conditional_expression] = STATE(601),
    [sym_concatenated_string] = STATE(109),
    [sym_string] = STATE(117),
    [sym_await] = STATE(601),
    [aux_sym_module_repeat1] = STATE(46),
    [aux_sym_decorated_definition_repeat1] = STATE(667),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_import] = ACTIONS(9),
    [anon_sym_from] = ACTIONS(11),
    [anon_sym_LPAREN] = ACTIONS(13),
    [anon_sym_print] = ACTIONS(15),
    [anon_sym_assert] = ACTIONS(17),
    [anon_sym_return] = ACTIONS(19),
    [anon_sym_del] = ACTIONS(21),
    [anon_sym_raise] = ACTIONS(23),
    [anon_sym_pass] = ACTIONS(25),
    [anon_sym_break] = ACTIONS(27),
    [anon_sym_continue] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(75),
    [anon_sym_async] = ACTIONS(77),
    [anon_sym_for] = ACTIONS(79),
    [anon_sym_while] = ACTIONS(81),
    [anon_sym_try] = ACTIONS(83),
    [anon_sym_with] = ACTIONS(85),
    [anon_sym_def] = ACTIONS(87),
    [anon_sym_global] = ACTIONS(45),
    [anon_sym_nonlocal] = ACTIONS(47),
    [anon_sym_exec] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(89),
    [anon_sym_AT] = ACTIONS(53),
    [anon_sym_not] = ACTIONS(55),
    [anon_sym_PLUS] = ACTIONS(57),
    [anon_sym_DASH] = ACTIONS(57),
    [anon_sym_TILDE] = ACTIONS(57),
    [anon_sym_lambda] = ACTIONS(59),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [sym_ellipsis] = ACTIONS(65),
    [anon_sym_LBRACE] = ACTIONS(67),
    [sym_integer] = ACTIONS(69),
    [sym_float] = ACTIONS(65),
    [sym_true] = ACTIONS(69),
    [sym_false] = ACTIONS(69),
    [sym_none] = ACTIONS(69),
    [anon_sym_await] = ACTIONS(71),
    [sym_comment] = ACTIONS(3),
    [sym__dedent] = ACTIONS(231),
    [sym__string_start] = ACTIONS(73),
  },
  [48] = {
    [sym_chevron] = STATE(805),
    [sym_named_expression] = STATE(680),
    [sym__expression] = STATE(680),
    [sym__primary_expression] = STATE(109),
    [sym_not_operator] = STATE(680),
    [sym_boolean_operator] = STATE(680),
    [sym_binary_operator] = STATE(109),
    [sym_unary_operator] = STATE(109),
    [sym_comparison_operator] = STATE(680),
    [sym_lambda] = STATE(680),
    [sym_attribute] = STATE(109),
    [sym_subscript] = STATE(109),
    [sym_call] = STATE(109),
    [sym_list] = STATE(109),
    [sym_list_comprehension] = STATE(109),
    [sym_dictionary] = STATE(109),
    [sym_dictionary_comprehension] = STATE(109),
    [sym_set] = STATE(109),
    [sym_set_comprehension] = STATE(109),
    [sym_parenthesized_expression] = STATE(109),
    [sym_tuple] = STATE(109),
    [sym_generator_expression] = STATE(109),
    [sym_conditional_expression] = STATE(680),
    [sym_concatenated_string] = STATE(109),
    [sym_string] = STATE(117),
    [sym_await] = STATE(680),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_DOT] = ACTIONS(233),
    [anon_sym_LPAREN] = ACTIONS(235),
    [anon_sym_COMMA] = ACTIONS(235),
    [anon_sym_STAR] = ACTIONS(233),
    [anon_sym_print] = ACTIONS(237),
    [anon_sym_GT_GT] = ACTIONS(239),
    [anon_sym_if] = ACTIONS(233),
    [anon_sym_COLON] = ACTIONS(235),
    [anon_sym_in] = ACTIONS(233),
    [anon_sym_EQ] = ACTIONS(233),
    [anon_sym_STAR_STAR] = ACTIONS(233),
    [anon_sym_exec] = ACTIONS(237),
    [anon_sym_AT] = ACTIONS(233),
    [anon_sym_not] = ACTIONS(233),
    [anon_sym_and] = ACTIONS(233),
    [anon_sym_or] = ACTIONS(233),
    [anon_sym_PLUS] = ACTIONS(233),
    [anon_sym_DASH] = ACTIONS(233),
    [anon_sym_SLASH] = ACTIONS(233),
    [anon_sym_PERCENT] = ACTIONS(233),
    [anon_sym_SLASH_SLASH] = ACTIONS(233),
    [anon_sym_PIPE] = ACTIONS(233),
    [anon_sym_AMP] = ACTIONS(233),
    [anon_sym_CARET] = ACTIONS(233),
    [anon_sym_LT_LT] = ACTIONS(233),
    [anon_sym_TILDE] = ACTIONS(57),
    [anon_sym_LT] = ACTIONS(233),
    [anon_sym_LT_EQ] = ACTIONS(235),
    [anon_sym_EQ_EQ] = ACTIONS(235),
    [anon_sym_BANG_EQ] = ACTIONS(235),
    [anon_sym_GT_EQ] = ACTIONS(235),
    [anon_sym_GT] = ACTIONS(233),
    [anon_sym_LT_GT] = ACTIONS(235),
    [anon_sym_is] = ACTIONS(233),
    [anon_sym_lambda] = ACTIONS(59),
    [anon_sym_PLUS_EQ] = ACTIONS(235),
    [anon_sym_DASH_EQ] = ACTIONS(235),
    [anon_sym_STAR_EQ] = ACTIONS(235),
    [anon_sym_SLASH_EQ] = ACTIONS(235),
    [anon_sym_AT_EQ] = ACTIONS(235),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(235),
    [anon_sym_PERCENT_EQ] = ACTIONS(235),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(235),
    [anon_sym_GT_GT_EQ] = ACTIONS(235),
    [anon_sym_LT_LT_EQ] = ACTIONS(235),
    [anon_sym_AMP_EQ] = ACTIONS(235),
    [anon_sym_CARET_EQ] = ACTIONS(235),
    [anon_sym_PIPE_EQ] = ACTIONS(235),
    [anon_sym_LBRACK] = ACTIONS(235),
    [sym_ellipsis] = ACTIONS(65),
    [anon_sym_LBRACE] = ACTIONS(67),
    [sym_integer] = ACTIONS(69),
    [sym_float] = ACTIONS(65),
    [sym_true] = ACTIONS(69),
    [sym_false] = ACTIONS(69),
    [sym_none] = ACTIONS(69),
    [anon_sym_await] = ACTIONS(71),
    [sym_comment] = ACTIONS(3),
    [sym__semicolon] = ACTIONS(235),
    [sym__newline] = ACTIONS(235),
    [sym__string_start] = ACTIONS(73),
  },
  [49] = {
    [sym__simple_statements] = STATE(366),
    [sym_import_statement] = STATE(861),
    [sym_future_import_statement] = STATE(861),
    [sym_import_from_statement] = STATE(861),
    [sym_print_statement] = STATE(861),
    [sym_assert_statement] = STATE(861),
    [sym_expression_statement] = STATE(861),
    [sym_named_expression] = STATE(601),
    [sym_return_statement] = STATE(861),
    [sym_delete_statement] = STATE(861),
    [sym_raise_statement] = STATE(861),
    [sym_pass_statement] = STATE(861),
    [sym_break_statement] = STATE(861),
    [sym_continue_statement] = STATE(861),
    [sym_global_statement] = STATE(861),
    [sym_nonlocal_statement] = STATE(861),
    [sym_exec_statement] = STATE(861),
    [sym_expression_list] = STATE(618),
    [sym__expression] = STATE(601),
    [sym__primary_expression] = STATE(109),
    [sym_not_operator] = STATE(601),
    [sym_boolean_operator] = STATE(601),
    [sym_binary_operator] = STATE(109),
    [sym_unary_operator] = STATE(109),
    [sym_comparison_operator] = STATE(601),
    [sym_lambda] = STATE(601),
    [sym_assignment] = STATE(936),
    [sym_augmented_assignment] = STATE(936),
    [sym_yield] = STATE(936),
    [sym_attribute] = STATE(109),
    [sym_subscript] = STATE(109),
    [sym_call] = STATE(109),
    [sym_list] = STATE(109),
    [sym_list_comprehension] = STATE(109),
    [sym_dictionary] = STATE(109),
    [sym_dictionary_comprehension] = STATE(109),
    [sym_set] = STATE(109),
    [sym_set_comprehension] = STATE(109),
    [sym_parenthesized_expression] = STATE(109),
    [sym_tuple] = STATE(109),
    [sym_generator_expression] = STATE(109),
    [sym_conditional_expression] = STATE(601),
    [sym_concatenated_string] = STATE(109),
    [sym_string] = STATE(117),
    [sym_await] = STATE(601),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_import] = ACTIONS(9),
    [anon_sym_from] = ACTIONS(11),
    [anon_sym_LPAREN] = ACTIONS(13),
    [anon_sym_print] = ACTIONS(15),
    [anon_sym_assert] = ACTIONS(17),
    [anon_sym_return] = ACTIONS(19),
    [anon_sym_del] = ACTIONS(21),
    [anon_sym_raise] = ACTIONS(23),
    [anon_sym_pass] = ACTIONS(25),
    [anon_sym_break] = ACTIONS(27),
    [anon_sym_continue] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(45),
    [anon_sym_nonlocal] = ACTIONS(47),
    [anon_sym_exec] = ACTIONS(49),
    [anon_sym_not] = ACTIONS(55),
    [anon_sym_PLUS] = ACTIONS(57),
    [anon_sym_DASH] = ACTIONS(57),
    [anon_sym_TILDE] = ACTIONS(57),
    [anon_sym_lambda] = ACTIONS(59),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [sym_ellipsis] = ACTIONS(65),
    [anon_sym_LBRACE] = ACTIONS(67),
    [sym_integer] = ACTIONS(69),
    [sym_float] = ACTIONS(65),
    [sym_true] = ACTIONS(69),
    [sym_false] = ACTIONS(69),
    [sym_none] = ACTIONS(69),
    [anon_sym_await] = ACTIONS(71),
    [sym_comment] = ACTIONS(3),
    [sym__indent] = ACTIONS(241),
    [sym__string_start] = ACTIONS(73),
  },
  [50] = {
    [sym__simple_statements] = STATE(399),
    [sym_import_statement] = STATE(861),
    [sym_future_import_statement] = STATE(861),
    [sym_import_from_statement] = STATE(861),
    [sym_print_statement] = STATE(861),
    [sym_assert_statement] = STATE(861),
    [sym_expression_statement] = STATE(861),
    [sym_named_expression] = STATE(601),
    [sym_return_statement] = STATE(861),
    [sym_delete_statement] = STATE(861),
    [sym_raise_statement] = STATE(861),
    [sym_pass_statement] = STATE(861),
    [sym_break_statement] = STATE(861),
    [sym_continue_statement] = STATE(861),
    [sym_global_statement] = STATE(861),
    [sym_nonlocal_statement] = STATE(861),
    [sym_exec_statement] = STATE(861),
    [sym_expression_list] = STATE(618),
    [sym__expression] = STATE(601),
    [sym__primary_expression] = STATE(109),
    [sym_not_operator] = STATE(601),
    [sym_boolean_operator] = STATE(601),
    [sym_binary_operator] = STATE(109),
    [sym_unary_operator] = STATE(109),
    [sym_comparison_operator] = STATE(601),
    [sym_lambda] = STATE(601),
    [sym_assignment] = STATE(936),
    [sym_augmented_assignment] = STATE(936),
    [sym_yield] = STATE(936),
    [sym_attribute] = STATE(109),
    [sym_subscript] = STATE(109),
    [sym_call] = STATE(109),
    [sym_list] = STATE(109),
    [sym_list_comprehension] = STATE(109),
    [sym_dictionary] = STATE(109),
    [sym_dictionary_comprehension] = STATE(109),
    [sym_set] = STATE(109),
    [sym_set_comprehension] = STATE(109),
    [sym_parenthesized_expression] = STATE(109),
    [sym_tuple] = STATE(109),
    [sym_generator_expression] = STATE(109),
    [sym_conditional_expression] = STATE(601),
    [sym_concatenated_string] = STATE(109),
    [sym_string] = STATE(117),
    [sym_await] = STATE(601),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_import] = ACTIONS(9),
    [anon_sym_from] = ACTIONS(11),
    [anon_sym_LPAREN] = ACTIONS(13),
    [anon_sym_print] = ACTIONS(15),
    [anon_sym_assert] = ACTIONS(17),
    [anon_sym_return] = ACTIONS(19),
    [anon_sym_del] = ACTIONS(21),
    [anon_sym_raise] = ACTIONS(23),
    [anon_sym_pass] = ACTIONS(25),
    [anon_sym_break] = ACTIONS(27),
    [anon_sym_continue] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(45),
    [anon_sym_nonlocal] = ACTIONS(47),
    [anon_sym_exec] = ACTIONS(49),
    [anon_sym_not] = ACTIONS(55),
    [anon_sym_PLUS] = ACTIONS(57),
    [anon_sym_DASH] = ACTIONS(57),
    [anon_sym_TILDE] = ACTIONS(57),
    [anon_sym_lambda] = ACTIONS(59),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [sym_ellipsis] = ACTIONS(65),
    [anon_sym_LBRACE] = ACTIONS(67),
    [sym_integer] = ACTIONS(69),
    [sym_float] = ACTIONS(65),
    [sym_true] = ACTIONS(69),
    [sym_false] = ACTIONS(69),
    [sym_none] = ACTIONS(69),
    [anon_sym_await] = ACTIONS(71),
    [sym_comment] = ACTIONS(3),
    [sym__indent] = ACTIONS(243),
    [sym__string_start] = ACTIONS(73),
  },
  [51] = {
    [sym__simple_statements] = STATE(408),
    [sym_import_statement] = STATE(831),
    [sym_future_import_statement] = STATE(831),
    [sym_import_from_statement] = STATE(831),
    [sym_print_statement] = STATE(831),
    [sym_assert_statement] = STATE(831),
    [sym_expression_statement] = STATE(831),
    [sym_named_expression] = STATE(601),
    [sym_return_statement] = STATE(831),
    [sym_delete_statement] = STATE(831),
    [sym_raise_statement] = STATE(831),
    [sym_pass_statement] = STATE(831),
    [sym_break_statement] = STATE(831),
    [sym_continue_statement] = STATE(831),
    [sym_global_statement] = STATE(831),
    [sym_nonlocal_statement] = STATE(831),
    [sym_exec_statement] = STATE(831),
    [sym_expression_list] = STATE(618),
    [sym__expression] = STATE(601),
    [sym__primary_expression] = STATE(109),
    [sym_not_operator] = STATE(601),
    [sym_boolean_operator] = STATE(601),
    [sym_binary_operator] = STATE(109),
    [sym_unary_operator] = STATE(109),
    [sym_comparison_operator] = STATE(601),
    [sym_lambda] = STATE(601),
    [sym_assignment] = STATE(936),
    [sym_augmented_assignment] = STATE(936),
    [sym_yield] = STATE(936),
    [sym_attribute] = STATE(109),
    [sym_subscript] = STATE(109),
    [sym_call] = STATE(109),
    [sym_list] = STATE(109),
    [sym_list_comprehension] = STATE(109),
    [sym_dictionary] = STATE(109),
    [sym_dictionary_comprehension] = STATE(109),
    [sym_set] = STATE(109),
    [sym_set_comprehension] = STATE(109),
    [sym_parenthesized_expression] = STATE(109),
    [sym_tuple] = STATE(109),
    [sym_generator_expression] = STATE(109),
    [sym_conditional_expression] = STATE(601),
    [sym_concatenated_string] = STATE(109),
    [sym_string] = STATE(117),
    [sym_await] = STATE(601),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_import] = ACTIONS(9),
    [anon_sym_from] = ACTIONS(11),
    [anon_sym_LPAREN] = ACTIONS(13),
    [anon_sym_print] = ACTIONS(15),
    [anon_sym_assert] = ACTIONS(17),
    [anon_sym_return] = ACTIONS(19),
    [anon_sym_del] = ACTIONS(21),
    [anon_sym_raise] = ACTIONS(23),
    [anon_sym_pass] = ACTIONS(25),
    [anon_sym_break] = ACTIONS(27),
    [anon_sym_continue] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(45),
    [anon_sym_nonlocal] = ACTIONS(47),
    [anon_sym_exec] = ACTIONS(49),
    [anon_sym_not] = ACTIONS(55),
    [anon_sym_PLUS] = ACTIONS(57),
    [anon_sym_DASH] = ACTIONS(57),
    [anon_sym_TILDE] = ACTIONS(57),
    [anon_sym_lambda] = ACTIONS(59),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [sym_ellipsis] = ACTIONS(65),
    [anon_sym_LBRACE] = ACTIONS(67),
    [sym_integer] = ACTIONS(69),
    [sym_float] = ACTIONS(65),
    [sym_true] = ACTIONS(69),
    [sym_false] = ACTIONS(69),
    [sym_none] = ACTIONS(69),
    [anon_sym_await] = ACTIONS(71),
    [sym_comment] = ACTIONS(3),
    [sym__indent] = ACTIONS(245),
    [sym__string_start] = ACTIONS(73),
  },
  [52] = {
    [sym__simple_statements] = STATE(372),
    [sym_import_statement] = STATE(831),
    [sym_future_import_statement] = STATE(831),
    [sym_import_from_statement] = STATE(831),
    [sym_print_statement] = STATE(831),
    [sym_assert_statement] = STATE(831),
    [sym_expression_statement] = STATE(831),
    [sym_named_expression] = STATE(601),
    [sym_return_statement] = STATE(831),
    [sym_delete_statement] = STATE(831),
    [sym_raise_statement] = STATE(831),
    [sym_pass_statement] = STATE(831),
    [sym_break_statement] = STATE(831),
    [sym_continue_statement] = STATE(831),
    [sym_global_statement] = STATE(831),
    [sym_nonlocal_statement] = STATE(831),
    [sym_exec_statement] = STATE(831),
    [sym_expression_list] = STATE(618),
    [sym__expression] = STATE(601),
    [sym__primary_expression] = STATE(109),
    [sym_not_operator] = STATE(601),
    [sym_boolean_operator] = STATE(601),
    [sym_binary_operator] = STATE(109),
    [sym_unary_operator] = STATE(109),
    [sym_comparison_operator] = STATE(601),
    [sym_lambda] = STATE(601),
    [sym_assignment] = STATE(936),
    [sym_augmented_assignment] = STATE(936),
    [sym_yield] = STATE(936),
    [sym_attribute] = STATE(109),
    [sym_subscript] = STATE(109),
    [sym_call] = STATE(109),
    [sym_list] = STATE(109),
    [sym_list_comprehension] = STATE(109),
    [sym_dictionary] = STATE(109),
    [sym_dictionary_comprehension] = STATE(109),
    [sym_set] = STATE(109),
    [sym_set_comprehension] = STATE(109),
    [sym_parenthesized_expression] = STATE(109),
    [sym_tuple] = STATE(109),
    [sym_generator_expression] = STATE(109),
    [sym_conditional_expression] = STATE(601),
    [sym_concatenated_string] = STATE(109),
    [sym_string] = STATE(117),
    [sym_await] = STATE(601),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_import] = ACTIONS(9),
    [anon_sym_from] = ACTIONS(11),
    [anon_sym_LPAREN] = ACTIONS(13),
    [anon_sym_print] = ACTIONS(15),
    [anon_sym_assert] = ACTIONS(17),
    [anon_sym_return] = ACTIONS(19),
    [anon_sym_del] = ACTIONS(21),
    [anon_sym_raise] = ACTIONS(23),
    [anon_sym_pass] = ACTIONS(25),
    [anon_sym_break] = ACTIONS(27),
    [anon_sym_continue] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(45),
    [anon_sym_nonlocal] = ACTIONS(47),
    [anon_sym_exec] = ACTIONS(49),
    [anon_sym_not] = ACTIONS(55),
    [anon_sym_PLUS] = ACTIONS(57),
    [anon_sym_DASH] = ACTIONS(57),
    [anon_sym_TILDE] = ACTIONS(57),
    [anon_sym_lambda] = ACTIONS(59),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [sym_ellipsis] = ACTIONS(65),
    [anon_sym_LBRACE] = ACTIONS(67),
    [sym_integer] = ACTIONS(69),
    [sym_float] = ACTIONS(65),
    [sym_true] = ACTIONS(69),
    [sym_false] = ACTIONS(69),
    [sym_none] = ACTIONS(69),
    [anon_sym_await] = ACTIONS(71),
    [sym_comment] = ACTIONS(3),
    [sym__indent] = ACTIONS(247),
    [sym__string_start] = ACTIONS(73),
  },
  [53] = {
    [sym__simple_statements] = STATE(357),
    [sym_import_statement] = STATE(831),
    [sym_future_import_statement] = STATE(831),
    [sym_import_from_statement] = STATE(831),
    [sym_print_statement] = STATE(831),
    [sym_assert_statement] = STATE(831),
    [sym_expression_statement] = STATE(831),
    [sym_named_expression] = STATE(601),
    [sym_return_statement] = STATE(831),
    [sym_delete_statement] = STATE(831),
    [sym_raise_statement] = STATE(831),
    [sym_pass_statement] = STATE(831),
    [sym_break_statement] = STATE(831),
    [sym_continue_statement] = STATE(831),
    [sym_global_statement] = STATE(831),
    [sym_nonlocal_statement] = STATE(831),
    [sym_exec_statement] = STATE(831),
    [sym_expression_list] = STATE(618),
    [sym__expression] = STATE(601),
    [sym__primary_expression] = STATE(109),
    [sym_not_operator] = STATE(601),
    [sym_boolean_operator] = STATE(601),
    [sym_binary_operator] = STATE(109),
    [sym_unary_operator] = STATE(109),
    [sym_comparison_operator] = STATE(601),
    [sym_lambda] = STATE(601),
    [sym_assignment] = STATE(936),
    [sym_augmented_assignment] = STATE(936),
    [sym_yield] = STATE(936),
    [sym_attribute] = STATE(109),
    [sym_subscript] = STATE(109),
    [sym_call] = STATE(109),
    [sym_list] = STATE(109),
    [sym_list_comprehension] = STATE(109),
    [sym_dictionary] = STATE(109),
    [sym_dictionary_comprehension] = STATE(109),
    [sym_set] = STATE(109),
    [sym_set_comprehension] = STATE(109),
    [sym_parenthesized_expression] = STATE(109),
    [sym_tuple] = STATE(109),
    [sym_generator_expression] = STATE(109),
    [sym_conditional_expression] = STATE(601),
    [sym_concatenated_string] = STATE(109),
    [sym_string] = STATE(117),
    [sym_await] = STATE(601),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_import] = ACTIONS(9),
    [anon_sym_from] = ACTIONS(11),
    [anon_sym_LPAREN] = ACTIONS(13),
    [anon_sym_print] = ACTIONS(15),
    [anon_sym_assert] = ACTIONS(17),
    [anon_sym_return] = ACTIONS(19),
    [anon_sym_del] = ACTIONS(21),
    [anon_sym_raise] = ACTIONS(23),
    [anon_sym_pass] = ACTIONS(25),
    [anon_sym_break] = ACTIONS(27),
    [anon_sym_continue] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(45),
    [anon_sym_nonlocal] = ACTIONS(47),
    [anon_sym_exec] = ACTIONS(49),
    [anon_sym_not] = ACTIONS(55),
    [anon_sym_PLUS] = ACTIONS(57),
    [anon_sym_DASH] = ACTIONS(57),
    [anon_sym_TILDE] = ACTIONS(57),
    [anon_sym_lambda] = ACTIONS(59),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [sym_ellipsis] = ACTIONS(65),
    [anon_sym_LBRACE] = ACTIONS(67),
    [sym_integer] = ACTIONS(69),
    [sym_float] = ACTIONS(65),
    [sym_true] = ACTIONS(69),
    [sym_false] = ACTIONS(69),
    [sym_none] = ACTIONS(69),
    [anon_sym_await] = ACTIONS(71),
    [sym_comment] = ACTIONS(3),
    [sym__indent] = ACTIONS(249),
    [sym__string_start] = ACTIONS(73),
  },
  [54] = {
    [sym__simple_statements] = STATE(414),
    [sym_import_statement] = STATE(831),
    [sym_future_import_statement] = STATE(831),
    [sym_import_from_statement] = STATE(831),
    [sym_print_statement] = STATE(831),
    [sym_assert_statement] = STATE(831),
    [sym_expression_statement] = STATE(831),
    [sym_named_expression] = STATE(601),
    [sym_return_statement] = STATE(831),
    [sym_delete_statement] = STATE(831),
    [sym_raise_statement] = STATE(831),
    [sym_pass_statement] = STATE(831),
    [sym_break_statement] = STATE(831),
    [sym_continue_statement] = STATE(831),
    [sym_global_statement] = STATE(831),
    [sym_nonlocal_statement] = STATE(831),
    [sym_exec_statement] = STATE(831),
    [sym_expression_list] = STATE(618),
    [sym__expression] = STATE(601),
    [sym__primary_expression] = STATE(109),
    [sym_not_operator] = STATE(601),
    [sym_boolean_operator] = STATE(601),
    [sym_binary_operator] = STATE(109),
    [sym_unary_operator] = STATE(109),
    [sym_comparison_operator] = STATE(601),
    [sym_lambda] = STATE(601),
    [sym_assignment] = STATE(936),
    [sym_augmented_assignment] = STATE(936),
    [sym_yield] = STATE(936),
    [sym_attribute] = STATE(109),
    [sym_subscript] = STATE(109),
    [sym_call] = STATE(109),
    [sym_list] = STATE(109),
    [sym_list_comprehension] = STATE(109),
    [sym_dictionary] = STATE(109),
    [sym_dictionary_comprehension] = STATE(109),
    [sym_set] = STATE(109),
    [sym_set_comprehension] = STATE(109),
    [sym_parenthesized_expression] = STATE(109),
    [sym_tuple] = STATE(109),
    [sym_generator_expression] = STATE(109),
    [sym_conditional_expression] = STATE(601),
    [sym_concatenated_string] = STATE(109),
    [sym_string] = STATE(117),
    [sym_await] = STATE(601),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_import] = ACTIONS(9),
    [anon_sym_from] = ACTIONS(11),
    [anon_sym_LPAREN] = ACTIONS(13),
    [anon_sym_print] = ACTIONS(15),
    [anon_sym_assert] = ACTIONS(17),
    [anon_sym_return] = ACTIONS(19),
    [anon_sym_del] = ACTIONS(21),
    [anon_sym_raise] = ACTIONS(23),
    [anon_sym_pass] = ACTIONS(25),
    [anon_sym_break] = ACTIONS(27),
    [anon_sym_continue] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(45),
    [anon_sym_nonlocal] = ACTIONS(47),
    [anon_sym_exec] = ACTIONS(49),
    [anon_sym_not] = ACTIONS(55),
    [anon_sym_PLUS] = ACTIONS(57),
    [anon_sym_DASH] = ACTIONS(57),
    [anon_sym_TILDE] = ACTIONS(57),
    [anon_sym_lambda] = ACTIONS(59),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [sym_ellipsis] = ACTIONS(65),
    [anon_sym_LBRACE] = ACTIONS(67),
    [sym_integer] = ACTIONS(69),
    [sym_float] = ACTIONS(65),
    [sym_true] = ACTIONS(69),
    [sym_false] = ACTIONS(69),
    [sym_none] = ACTIONS(69),
    [anon_sym_await] = ACTIONS(71),
    [sym_comment] = ACTIONS(3),
    [sym__indent] = ACTIONS(251),
    [sym__string_start] = ACTIONS(73),
  },
  [55] = {
    [sym__simple_statements] = STATE(749),
    [sym_import_statement] = STATE(828),
    [sym_future_import_statement] = STATE(828),
    [sym_import_from_statement] = STATE(828),
    [sym_print_statement] = STATE(828),
    [sym_assert_statement] = STATE(828),
    [sym_expression_statement] = STATE(828),
    [sym_named_expression] = STATE(601),
    [sym_return_statement] = STATE(828),
    [sym_delete_statement] = STATE(828),
    [sym_raise_statement] = STATE(828),
    [sym_pass_statement] = STATE(828),
    [sym_break_statement] = STATE(828),
    [sym_continue_statement] = STATE(828),
    [sym_global_statement] = STATE(828),
    [sym_nonlocal_statement] = STATE(828),
    [sym_exec_statement] = STATE(828),
    [sym_expression_list] = STATE(618),
    [sym__expression] = STATE(601),
    [sym__primary_expression] = STATE(109),
    [sym_not_operator] = STATE(601),
    [sym_boolean_operator] = STATE(601),
    [sym_binary_operator] = STATE(109),
    [sym_unary_operator] = STATE(109),
    [sym_comparison_operator] = STATE(601),
    [sym_lambda] = STATE(601),
    [sym_assignment] = STATE(936),
    [sym_augmented_assignment] = STATE(936),
    [sym_yield] = STATE(936),
    [sym_attribute] = STATE(109),
    [sym_subscript] = STATE(109),
    [sym_call] = STATE(109),
    [sym_list] = STATE(109),
    [sym_list_comprehension] = STATE(109),
    [sym_dictionary] = STATE(109),
    [sym_dictionary_comprehension] = STATE(109),
    [sym_set] = STATE(109),
    [sym_set_comprehension] = STATE(109),
    [sym_parenthesized_expression] = STATE(109),
    [sym_tuple] = STATE(109),
    [sym_generator_expression] = STATE(109),
    [sym_conditional_expression] = STATE(601),
    [sym_concatenated_string] = STATE(109),
    [sym_string] = STATE(117),
    [sym_await] = STATE(601),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_import] = ACTIONS(9),
    [anon_sym_from] = ACTIONS(11),
    [anon_sym_LPAREN] = ACTIONS(13),
    [anon_sym_print] = ACTIONS(15),
    [anon_sym_assert] = ACTIONS(17),
    [anon_sym_return] = ACTIONS(19),
    [anon_sym_del] = ACTIONS(21),
    [anon_sym_raise] = ACTIONS(23),
    [anon_sym_pass] = ACTIONS(25),
    [anon_sym_break] = ACTIONS(27),
    [anon_sym_continue] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(45),
    [anon_sym_nonlocal] = ACTIONS(47),
    [anon_sym_exec] = ACTIONS(49),
    [anon_sym_not] = ACTIONS(55),
    [anon_sym_PLUS] = ACTIONS(57),
    [anon_sym_DASH] = ACTIONS(57),
    [anon_sym_TILDE] = ACTIONS(57),
    [anon_sym_lambda] = ACTIONS(59),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [sym_ellipsis] = ACTIONS(65),
    [anon_sym_LBRACE] = ACTIONS(67),
    [sym_integer] = ACTIONS(69),
    [sym_float] = ACTIONS(65),
    [sym_true] = ACTIONS(69),
    [sym_false] = ACTIONS(69),
    [sym_none] = ACTIONS(69),
    [anon_sym_await] = ACTIONS(71),
    [sym_comment] = ACTIONS(3),
    [sym__indent] = ACTIONS(253),
    [sym__string_start] = ACTIONS(73),
  },
  [56] = {
    [sym__simple_statements] = STATE(330),
    [sym_import_statement] = STATE(831),
    [sym_future_import_statement] = STATE(831),
    [sym_import_from_statement] = STATE(831),
    [sym_print_statement] = STATE(831),
    [sym_assert_statement] = STATE(831),
    [sym_expression_statement] = STATE(831),
    [sym_named_expression] = STATE(601),
    [sym_return_statement] = STATE(831),
    [sym_delete_statement] = STATE(831),
    [sym_raise_statement] = STATE(831),
    [sym_pass_statement] = STATE(831),
    [sym_break_statement] = STATE(831),
    [sym_continue_statement] = STATE(831),
    [sym_global_statement] = STATE(831),
    [sym_nonlocal_statement] = STATE(831),
    [sym_exec_statement] = STATE(831),
    [sym_expression_list] = STATE(618),
    [sym__expression] = STATE(601),
    [sym__primary_expression] = STATE(109),
    [sym_not_operator] = STATE(601),
    [sym_boolean_operator] = STATE(601),
    [sym_binary_operator] = STATE(109),
    [sym_unary_operator] = STATE(109),
    [sym_comparison_operator] = STATE(601),
    [sym_lambda] = STATE(601),
    [sym_assignment] = STATE(936),
    [sym_augmented_assignment] = STATE(936),
    [sym_yield] = STATE(936),
    [sym_attribute] = STATE(109),
    [sym_subscript] = STATE(109),
    [sym_call] = STATE(109),
    [sym_list] = STATE(109),
    [sym_list_comprehension] = STATE(109),
    [sym_dictionary] = STATE(109),
    [sym_dictionary_comprehension] = STATE(109),
    [sym_set] = STATE(109),
    [sym_set_comprehension] = STATE(109),
    [sym_parenthesized_expression] = STATE(109),
    [sym_tuple] = STATE(109),
    [sym_generator_expression] = STATE(109),
    [sym_conditional_expression] = STATE(601),
    [sym_concatenated_string] = STATE(109),
    [sym_string] = STATE(117),
    [sym_await] = STATE(601),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_import] = ACTIONS(9),
    [anon_sym_from] = ACTIONS(11),
    [anon_sym_LPAREN] = ACTIONS(13),
    [anon_sym_print] = ACTIONS(15),
    [anon_sym_assert] = ACTIONS(17),
    [anon_sym_return] = ACTIONS(19),
    [anon_sym_del] = ACTIONS(21),
    [anon_sym_raise] = ACTIONS(23),
    [anon_sym_pass] = ACTIONS(25),
    [anon_sym_break] = ACTIONS(27),
    [anon_sym_continue] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(45),
    [anon_sym_nonlocal] = ACTIONS(47),
    [anon_sym_exec] = ACTIONS(49),
    [anon_sym_not] = ACTIONS(55),
    [anon_sym_PLUS] = ACTIONS(57),
    [anon_sym_DASH] = ACTIONS(57),
    [anon_sym_TILDE] = ACTIONS(57),
    [anon_sym_lambda] = ACTIONS(59),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [sym_ellipsis] = ACTIONS(65),
    [anon_sym_LBRACE] = ACTIONS(67),
    [sym_integer] = ACTIONS(69),
    [sym_float] = ACTIONS(65),
    [sym_true] = ACTIONS(69),
    [sym_false] = ACTIONS(69),
    [sym_none] = ACTIONS(69),
    [anon_sym_await] = ACTIONS(71),
    [sym_comment] = ACTIONS(3),
    [sym__indent] = ACTIONS(255),
    [sym__string_start] = ACTIONS(73),
  },
  [57] = {
    [sym__simple_statements] = STATE(302),
    [sym_import_statement] = STATE(831),
    [sym_future_import_statement] = STATE(831),
    [sym_import_from_statement] = STATE(831),
    [sym_print_statement] = STATE(831),
    [sym_assert_statement] = STATE(831),
    [sym_expression_statement] = STATE(831),
    [sym_named_expression] = STATE(601),
    [sym_return_statement] = STATE(831),
    [sym_delete_statement] = STATE(831),
    [sym_raise_statement] = STATE(831),
    [sym_pass_statement] = STATE(831),
    [sym_break_statement] = STATE(831),
    [sym_continue_statement] = STATE(831),
    [sym_global_statement] = STATE(831),
    [sym_nonlocal_statement] = STATE(831),
    [sym_exec_statement] = STATE(831),
    [sym_expression_list] = STATE(618),
    [sym__expression] = STATE(601),
    [sym__primary_expression] = STATE(109),
    [sym_not_operator] = STATE(601),
    [sym_boolean_operator] = STATE(601),
    [sym_binary_operator] = STATE(109),
    [sym_unary_operator] = STATE(109),
    [sym_comparison_operator] = STATE(601),
    [sym_lambda] = STATE(601),
    [sym_assignment] = STATE(936),
    [sym_augmented_assignment] = STATE(936),
    [sym_yield] = STATE(936),
    [sym_attribute] = STATE(109),
    [sym_subscript] = STATE(109),
    [sym_call] = STATE(109),
    [sym_list] = STATE(109),
    [sym_list_comprehension] = STATE(109),
    [sym_dictionary] = STATE(109),
    [sym_dictionary_comprehension] = STATE(109),
    [sym_set] = STATE(109),
    [sym_set_comprehension] = STATE(109),
    [sym_parenthesized_expression] = STATE(109),
    [sym_tuple] = STATE(109),
    [sym_generator_expression] = STATE(109),
    [sym_conditional_expression] = STATE(601),
    [sym_concatenated_string] = STATE(109),
    [sym_string] = STATE(117),
    [sym_await] = STATE(601),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_import] = ACTIONS(9),
    [anon_sym_from] = ACTIONS(11),
    [anon_sym_LPAREN] = ACTIONS(13),
    [anon_sym_print] = ACTIONS(15),
    [anon_sym_assert] = ACTIONS(17),
    [anon_sym_return] = ACTIONS(19),
    [anon_sym_del] = ACTIONS(21),
    [anon_sym_raise] = ACTIONS(23),
    [anon_sym_pass] = ACTIONS(25),
    [anon_sym_break] = ACTIONS(27),
    [anon_sym_continue] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(45),
    [anon_sym_nonlocal] = ACTIONS(47),
    [anon_sym_exec] = ACTIONS(49),
    [anon_sym_not] = ACTIONS(55),
    [anon_sym_PLUS] = ACTIONS(57),
    [anon_sym_DASH] = ACTIONS(57),
    [anon_sym_TILDE] = ACTIONS(57),
    [anon_sym_lambda] = ACTIONS(59),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [sym_ellipsis] = ACTIONS(65),
    [anon_sym_LBRACE] = ACTIONS(67),
    [sym_integer] = ACTIONS(69),
    [sym_float] = ACTIONS(65),
    [sym_true] = ACTIONS(69),
    [sym_false] = ACTIONS(69),
    [sym_none] = ACTIONS(69),
    [anon_sym_await] = ACTIONS(71),
    [sym_comment] = ACTIONS(3),
    [sym__indent] = ACTIONS(257),
    [sym__string_start] = ACTIONS(73),
  },
  [58] = {
    [sym__simple_statements] = STATE(226),
    [sym_import_statement] = STATE(831),
    [sym_future_import_statement] = STATE(831),
    [sym_import_from_statement] = STATE(831),
    [sym_print_statement] = STATE(831),
    [sym_assert_statement] = STATE(831),
    [sym_expression_statement] = STATE(831),
    [sym_named_expression] = STATE(601),
    [sym_return_statement] = STATE(831),
    [sym_delete_statement] = STATE(831),
    [sym_raise_statement] = STATE(831),
    [sym_pass_statement] = STATE(831),
    [sym_break_statement] = STATE(831),
    [sym_continue_statement] = STATE(831),
    [sym_global_statement] = STATE(831),
    [sym_nonlocal_statement] = STATE(831),
    [sym_exec_statement] = STATE(831),
    [sym_expression_list] = STATE(618),
    [sym__expression] = STATE(601),
    [sym__primary_expression] = STATE(109),
    [sym_not_operator] = STATE(601),
    [sym_boolean_operator] = STATE(601),
    [sym_binary_operator] = STATE(109),
    [sym_unary_operator] = STATE(109),
    [sym_comparison_operator] = STATE(601),
    [sym_lambda] = STATE(601),
    [sym_assignment] = STATE(936),
    [sym_augmented_assignment] = STATE(936),
    [sym_yield] = STATE(936),
    [sym_attribute] = STATE(109),
    [sym_subscript] = STATE(109),
    [sym_call] = STATE(109),
    [sym_list] = STATE(109),
    [sym_list_comprehension] = STATE(109),
    [sym_dictionary] = STATE(109),
    [sym_dictionary_comprehension] = STATE(109),
    [sym_set] = STATE(109),
    [sym_set_comprehension] = STATE(109),
    [sym_parenthesized_expression] = STATE(109),
    [sym_tuple] = STATE(109),
    [sym_generator_expression] = STATE(109),
    [sym_conditional_expression] = STATE(601),
    [sym_concatenated_string] = STATE(109),
    [sym_string] = STATE(117),
    [sym_await] = STATE(601),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_import] = ACTIONS(9),
    [anon_sym_from] = ACTIONS(11),
    [anon_sym_LPAREN] = ACTIONS(13),
    [anon_sym_print] = ACTIONS(15),
    [anon_sym_assert] = ACTIONS(17),
    [anon_sym_return] = ACTIONS(19),
    [anon_sym_del] = ACTIONS(21),
    [anon_sym_raise] = ACTIONS(23),
    [anon_sym_pass] = ACTIONS(25),
    [anon_sym_break] = ACTIONS(27),
    [anon_sym_continue] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(45),
    [anon_sym_nonlocal] = ACTIONS(47),
    [anon_sym_exec] = ACTIONS(49),
    [anon_sym_not] = ACTIONS(55),
    [anon_sym_PLUS] = ACTIONS(57),
    [anon_sym_DASH] = ACTIONS(57),
    [anon_sym_TILDE] = ACTIONS(57),
    [anon_sym_lambda] = ACTIONS(59),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [sym_ellipsis] = ACTIONS(65),
    [anon_sym_LBRACE] = ACTIONS(67),
    [sym_integer] = ACTIONS(69),
    [sym_float] = ACTIONS(65),
    [sym_true] = ACTIONS(69),
    [sym_false] = ACTIONS(69),
    [sym_none] = ACTIONS(69),
    [anon_sym_await] = ACTIONS(71),
    [sym_comment] = ACTIONS(3),
    [sym__indent] = ACTIONS(259),
    [sym__string_start] = ACTIONS(73),
  },
  [59] = {
    [sym__simple_statements] = STATE(446),
    [sym_import_statement] = STATE(831),
    [sym_future_import_statement] = STATE(831),
    [sym_import_from_statement] = STATE(831),
    [sym_print_statement] = STATE(831),
    [sym_assert_statement] = STATE(831),
    [sym_expression_statement] = STATE(831),
    [sym_named_expression] = STATE(601),
    [sym_return_statement] = STATE(831),
    [sym_delete_statement] = STATE(831),
    [sym_raise_statement] = STATE(831),
    [sym_pass_statement] = STATE(831),
    [sym_break_statement] = STATE(831),
    [sym_continue_statement] = STATE(831),
    [sym_global_statement] = STATE(831),
    [sym_nonlocal_statement] = STATE(831),
    [sym_exec_statement] = STATE(831),
    [sym_expression_list] = STATE(618),
    [sym__expression] = STATE(601),
    [sym__primary_expression] = STATE(109),
    [sym_not_operator] = STATE(601),
    [sym_boolean_operator] = STATE(601),
    [sym_binary_operator] = STATE(109),
    [sym_unary_operator] = STATE(109),
    [sym_comparison_operator] = STATE(601),
    [sym_lambda] = STATE(601),
    [sym_assignment] = STATE(936),
    [sym_augmented_assignment] = STATE(936),
    [sym_yield] = STATE(936),
    [sym_attribute] = STATE(109),
    [sym_subscript] = STATE(109),
    [sym_call] = STATE(109),
    [sym_list] = STATE(109),
    [sym_list_comprehension] = STATE(109),
    [sym_dictionary] = STATE(109),
    [sym_dictionary_comprehension] = STATE(109),
    [sym_set] = STATE(109),
    [sym_set_comprehension] = STATE(109),
    [sym_parenthesized_expression] = STATE(109),
    [sym_tuple] = STATE(109),
    [sym_generator_expression] = STATE(109),
    [sym_conditional_expression] = STATE(601),
    [sym_concatenated_string] = STATE(109),
    [sym_string] = STATE(117),
    [sym_await] = STATE(601),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_import] = ACTIONS(9),
    [anon_sym_from] = ACTIONS(11),
    [anon_sym_LPAREN] = ACTIONS(13),
    [anon_sym_print] = ACTIONS(15),
    [anon_sym_assert] = ACTIONS(17),
    [anon_sym_return] = ACTIONS(19),
    [anon_sym_del] = ACTIONS(21),
    [anon_sym_raise] = ACTIONS(23),
    [anon_sym_pass] = ACTIONS(25),
    [anon_sym_break] = ACTIONS(27),
    [anon_sym_continue] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(45),
    [anon_sym_nonlocal] = ACTIONS(47),
    [anon_sym_exec] = ACTIONS(49),
    [anon_sym_not] = ACTIONS(55),
    [anon_sym_PLUS] = ACTIONS(57),
    [anon_sym_DASH] = ACTIONS(57),
    [anon_sym_TILDE] = ACTIONS(57),
    [anon_sym_lambda] = ACTIONS(59),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [sym_ellipsis] = ACTIONS(65),
    [anon_sym_LBRACE] = ACTIONS(67),
    [sym_integer] = ACTIONS(69),
    [sym_float] = ACTIONS(65),
    [sym_true] = ACTIONS(69),
    [sym_false] = ACTIONS(69),
    [sym_none] = ACTIONS(69),
    [anon_sym_await] = ACTIONS(71),
    [sym_comment] = ACTIONS(3),
    [sym__indent] = ACTIONS(261),
    [sym__string_start] = ACTIONS(73),
  },
  [60] = {
    [sym__simple_statements] = STATE(360),
    [sym_import_statement] = STATE(831),
    [sym_future_import_statement] = STATE(831),
    [sym_import_from_statement] = STATE(831),
    [sym_print_statement] = STATE(831),
    [sym_assert_statement] = STATE(831),
    [sym_expression_statement] = STATE(831),
    [sym_named_expression] = STATE(601),
    [sym_return_statement] = STATE(831),
    [sym_delete_statement] = STATE(831),
    [sym_raise_statement] = STATE(831),
    [sym_pass_statement] = STATE(831),
    [sym_break_statement] = STATE(831),
    [sym_continue_statement] = STATE(831),
    [sym_global_statement] = STATE(831),
    [sym_nonlocal_statement] = STATE(831),
    [sym_exec_statement] = STATE(831),
    [sym_expression_list] = STATE(618),
    [sym__expression] = STATE(601),
    [sym__primary_expression] = STATE(109),
    [sym_not_operator] = STATE(601),
    [sym_boolean_operator] = STATE(601),
    [sym_binary_operator] = STATE(109),
    [sym_unary_operator] = STATE(109),
    [sym_comparison_operator] = STATE(601),
    [sym_lambda] = STATE(601),
    [sym_assignment] = STATE(936),
    [sym_augmented_assignment] = STATE(936),
    [sym_yield] = STATE(936),
    [sym_attribute] = STATE(109),
    [sym_subscript] = STATE(109),
    [sym_call] = STATE(109),
    [sym_list] = STATE(109),
    [sym_list_comprehension] = STATE(109),
    [sym_dictionary] = STATE(109),
    [sym_dictionary_comprehension] = STATE(109),
    [sym_set] = STATE(109),
    [sym_set_comprehension] = STATE(109),
    [sym_parenthesized_expression] = STATE(109),
    [sym_tuple] = STATE(109),
    [sym_generator_expression] = STATE(109),
    [sym_conditional_expression] = STATE(601),
    [sym_concatenated_string] = STATE(109),
    [sym_string] = STATE(117),
    [sym_await] = STATE(601),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_import] = ACTIONS(9),
    [anon_sym_from] = ACTIONS(11),
    [anon_sym_LPAREN] = ACTIONS(13),
    [anon_sym_print] = ACTIONS(15),
    [anon_sym_assert] = ACTIONS(17),
    [anon_sym_return] = ACTIONS(19),
    [anon_sym_del] = ACTIONS(21),
    [anon_sym_raise] = ACTIONS(23),
    [anon_sym_pass] = ACTIONS(25),
    [anon_sym_break] = ACTIONS(27),
    [anon_sym_continue] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(45),
    [anon_sym_nonlocal] = ACTIONS(47),
    [anon_sym_exec] = ACTIONS(49),
    [anon_sym_not] = ACTIONS(55),
    [anon_sym_PLUS] = ACTIONS(57),
    [anon_sym_DASH] = ACTIONS(57),
    [anon_sym_TILDE] = ACTIONS(57),
    [anon_sym_lambda] = ACTIONS(59),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [sym_ellipsis] = ACTIONS(65),
    [anon_sym_LBRACE] = ACTIONS(67),
    [sym_integer] = ACTIONS(69),
    [sym_float] = ACTIONS(65),
    [sym_true] = ACTIONS(69),
    [sym_false] = ACTIONS(69),
    [sym_none] = ACTIONS(69),
    [anon_sym_await] = ACTIONS(71),
    [sym_comment] = ACTIONS(3),
    [sym__indent] = ACTIONS(263),
    [sym__string_start] = ACTIONS(73),
  },
  [61] = {
    [sym__simple_statements] = STATE(242),
    [sym_import_statement] = STATE(861),
    [sym_future_import_statement] = STATE(861),
    [sym_import_from_statement] = STATE(861),
    [sym_print_statement] = STATE(861),
    [sym_assert_statement] = STATE(861),
    [sym_expression_statement] = STATE(861),
    [sym_named_expression] = STATE(601),
    [sym_return_statement] = STATE(861),
    [sym_delete_statement] = STATE(861),
    [sym_raise_statement] = STATE(861),
    [sym_pass_statement] = STATE(861),
    [sym_break_statement] = STATE(861),
    [sym_continue_statement] = STATE(861),
    [sym_global_statement] = STATE(861),
    [sym_nonlocal_statement] = STATE(861),
    [sym_exec_statement] = STATE(861),
    [sym_expression_list] = STATE(618),
    [sym__expression] = STATE(601),
    [sym__primary_expression] = STATE(109),
    [sym_not_operator] = STATE(601),
    [sym_boolean_operator] = STATE(601),
    [sym_binary_operator] = STATE(109),
    [sym_unary_operator] = STATE(109),
    [sym_comparison_operator] = STATE(601),
    [sym_lambda] = STATE(601),
    [sym_assignment] = STATE(936),
    [sym_augmented_assignment] = STATE(936),
    [sym_yield] = STATE(936),
    [sym_attribute] = STATE(109),
    [sym_subscript] = STATE(109),
    [sym_call] = STATE(109),
    [sym_list] = STATE(109),
    [sym_list_comprehension] = STATE(109),
    [sym_dictionary] = STATE(109),
    [sym_dictionary_comprehension] = STATE(109),
    [sym_set] = STATE(109),
    [sym_set_comprehension] = STATE(109),
    [sym_parenthesized_expression] = STATE(109),
    [sym_tuple] = STATE(109),
    [sym_generator_expression] = STATE(109),
    [sym_conditional_expression] = STATE(601),
    [sym_concatenated_string] = STATE(109),
    [sym_string] = STATE(117),
    [sym_await] = STATE(601),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_import] = ACTIONS(9),
    [anon_sym_from] = ACTIONS(11),
    [anon_sym_LPAREN] = ACTIONS(13),
    [anon_sym_print] = ACTIONS(15),
    [anon_sym_assert] = ACTIONS(17),
    [anon_sym_return] = ACTIONS(19),
    [anon_sym_del] = ACTIONS(21),
    [anon_sym_raise] = ACTIONS(23),
    [anon_sym_pass] = ACTIONS(25),
    [anon_sym_break] = ACTIONS(27),
    [anon_sym_continue] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(45),
    [anon_sym_nonlocal] = ACTIONS(47),
    [anon_sym_exec] = ACTIONS(49),
    [anon_sym_not] = ACTIONS(55),
    [anon_sym_PLUS] = ACTIONS(57),
    [anon_sym_DASH] = ACTIONS(57),
    [anon_sym_TILDE] = ACTIONS(57),
    [anon_sym_lambda] = ACTIONS(59),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [sym_ellipsis] = ACTIONS(65),
    [anon_sym_LBRACE] = ACTIONS(67),
    [sym_integer] = ACTIONS(69),
    [sym_float] = ACTIONS(65),
    [sym_true] = ACTIONS(69),
    [sym_false] = ACTIONS(69),
    [sym_none] = ACTIONS(69),
    [anon_sym_await] = ACTIONS(71),
    [sym_comment] = ACTIONS(3),
    [sym__indent] = ACTIONS(265),
    [sym__string_start] = ACTIONS(73),
  },
  [62] = {
    [sym__simple_statements] = STATE(463),
    [sym_import_statement] = STATE(831),
    [sym_future_import_statement] = STATE(831),
    [sym_import_from_statement] = STATE(831),
    [sym_print_statement] = STATE(831),
    [sym_assert_statement] = STATE(831),
    [sym_expression_statement] = STATE(831),
    [sym_named_expression] = STATE(601),
    [sym_return_statement] = STATE(831),
    [sym_delete_statement] = STATE(831),
    [sym_raise_statement] = STATE(831),
    [sym_pass_statement] = STATE(831),
    [sym_break_statement] = STATE(831),
    [sym_continue_statement] = STATE(831),
    [sym_global_statement] = STATE(831),
    [sym_nonlocal_statement] = STATE(831),
    [sym_exec_statement] = STATE(831),
    [sym_expression_list] = STATE(618),
    [sym__expression] = STATE(601),
    [sym__primary_expression] = STATE(109),
    [sym_not_operator] = STATE(601),
    [sym_boolean_operator] = STATE(601),
    [sym_binary_operator] = STATE(109),
    [sym_unary_operator] = STATE(109),
    [sym_comparison_operator] = STATE(601),
    [sym_lambda] = STATE(601),
    [sym_assignment] = STATE(936),
    [sym_augmented_assignment] = STATE(936),
    [sym_yield] = STATE(936),
    [sym_attribute] = STATE(109),
    [sym_subscript] = STATE(109),
    [sym_call] = STATE(109),
    [sym_list] = STATE(109),
    [sym_list_comprehension] = STATE(109),
    [sym_dictionary] = STATE(109),
    [sym_dictionary_comprehension] = STATE(109),
    [sym_set] = STATE(109),
    [sym_set_comprehension] = STATE(109),
    [sym_parenthesized_expression] = STATE(109),
    [sym_tuple] = STATE(109),
    [sym_generator_expression] = STATE(109),
    [sym_conditional_expression] = STATE(601),
    [sym_concatenated_string] = STATE(109),
    [sym_string] = STATE(117),
    [sym_await] = STATE(601),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_import] = ACTIONS(9),
    [anon_sym_from] = ACTIONS(11),
    [anon_sym_LPAREN] = ACTIONS(13),
    [anon_sym_print] = ACTIONS(15),
    [anon_sym_assert] = ACTIONS(17),
    [anon_sym_return] = ACTIONS(19),
    [anon_sym_del] = ACTIONS(21),
    [anon_sym_raise] = ACTIONS(23),
    [anon_sym_pass] = ACTIONS(25),
    [anon_sym_break] = ACTIONS(27),
    [anon_sym_continue] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(45),
    [anon_sym_nonlocal] = ACTIONS(47),
    [anon_sym_exec] = ACTIONS(49),
    [anon_sym_not] = ACTIONS(55),
    [anon_sym_PLUS] = ACTIONS(57),
    [anon_sym_DASH] = ACTIONS(57),
    [anon_sym_TILDE] = ACTIONS(57),
    [anon_sym_lambda] = ACTIONS(59),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [sym_ellipsis] = ACTIONS(65),
    [anon_sym_LBRACE] = ACTIONS(67),
    [sym_integer] = ACTIONS(69),
    [sym_float] = ACTIONS(65),
    [sym_true] = ACTIONS(69),
    [sym_false] = ACTIONS(69),
    [sym_none] = ACTIONS(69),
    [anon_sym_await] = ACTIONS(71),
    [sym_comment] = ACTIONS(3),
    [sym__indent] = ACTIONS(267),
    [sym__string_start] = ACTIONS(73),
  },
  [63] = {
    [sym__simple_statements] = STATE(374),
    [sym_import_statement] = STATE(861),
    [sym_future_import_statement] = STATE(861),
    [sym_import_from_statement] = STATE(861),
    [sym_print_statement] = STATE(861),
    [sym_assert_statement] = STATE(861),
    [sym_expression_statement] = STATE(861),
    [sym_named_expression] = STATE(601),
    [sym_return_statement] = STATE(861),
    [sym_delete_statement] = STATE(861),
    [sym_raise_statement] = STATE(861),
    [sym_pass_statement] = STATE(861),
    [sym_break_statement] = STATE(861),
    [sym_continue_statement] = STATE(861),
    [sym_global_statement] = STATE(861),
    [sym_nonlocal_statement] = STATE(861),
    [sym_exec_statement] = STATE(861),
    [sym_expression_list] = STATE(618),
    [sym__expression] = STATE(601),
    [sym__primary_expression] = STATE(109),
    [sym_not_operator] = STATE(601),
    [sym_boolean_operator] = STATE(601),
    [sym_binary_operator] = STATE(109),
    [sym_unary_operator] = STATE(109),
    [sym_comparison_operator] = STATE(601),
    [sym_lambda] = STATE(601),
    [sym_assignment] = STATE(936),
    [sym_augmented_assignment] = STATE(936),
    [sym_yield] = STATE(936),
    [sym_attribute] = STATE(109),
    [sym_subscript] = STATE(109),
    [sym_call] = STATE(109),
    [sym_list] = STATE(109),
    [sym_list_comprehension] = STATE(109),
    [sym_dictionary] = STATE(109),
    [sym_dictionary_comprehension] = STATE(109),
    [sym_set] = STATE(109),
    [sym_set_comprehension] = STATE(109),
    [sym_parenthesized_expression] = STATE(109),
    [sym_tuple] = STATE(109),
    [sym_generator_expression] = STATE(109),
    [sym_conditional_expression] = STATE(601),
    [sym_concatenated_string] = STATE(109),
    [sym_string] = STATE(117),
    [sym_await] = STATE(601),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_import] = ACTIONS(9),
    [anon_sym_from] = ACTIONS(11),
    [anon_sym_LPAREN] = ACTIONS(13),
    [anon_sym_print] = ACTIONS(15),
    [anon_sym_assert] = ACTIONS(17),
    [anon_sym_return] = ACTIONS(19),
    [anon_sym_del] = ACTIONS(21),
    [anon_sym_raise] = ACTIONS(23),
    [anon_sym_pass] = ACTIONS(25),
    [anon_sym_break] = ACTIONS(27),
    [anon_sym_continue] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(45),
    [anon_sym_nonlocal] = ACTIONS(47),
    [anon_sym_exec] = ACTIONS(49),
    [anon_sym_not] = ACTIONS(55),
    [anon_sym_PLUS] = ACTIONS(57),
    [anon_sym_DASH] = ACTIONS(57),
    [anon_sym_TILDE] = ACTIONS(57),
    [anon_sym_lambda] = ACTIONS(59),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [sym_ellipsis] = ACTIONS(65),
    [anon_sym_LBRACE] = ACTIONS(67),
    [sym_integer] = ACTIONS(69),
    [sym_float] = ACTIONS(65),
    [sym_true] = ACTIONS(69),
    [sym_false] = ACTIONS(69),
    [sym_none] = ACTIONS(69),
    [anon_sym_await] = ACTIONS(71),
    [sym_comment] = ACTIONS(3),
    [sym__indent] = ACTIONS(269),
    [sym__string_start] = ACTIONS(73),
  },
  [64] = {
    [sym__simple_statements] = STATE(407),
    [sym_import_statement] = STATE(831),
    [sym_future_import_statement] = STATE(831),
    [sym_import_from_statement] = STATE(831),
    [sym_print_statement] = STATE(831),
    [sym_assert_statement] = STATE(831),
    [sym_expression_statement] = STATE(831),
    [sym_named_expression] = STATE(601),
    [sym_return_statement] = STATE(831),
    [sym_delete_statement] = STATE(831),
    [sym_raise_statement] = STATE(831),
    [sym_pass_statement] = STATE(831),
    [sym_break_statement] = STATE(831),
    [sym_continue_statement] = STATE(831),
    [sym_global_statement] = STATE(831),
    [sym_nonlocal_statement] = STATE(831),
    [sym_exec_statement] = STATE(831),
    [sym_expression_list] = STATE(618),
    [sym__expression] = STATE(601),
    [sym__primary_expression] = STATE(109),
    [sym_not_operator] = STATE(601),
    [sym_boolean_operator] = STATE(601),
    [sym_binary_operator] = STATE(109),
    [sym_unary_operator] = STATE(109),
    [sym_comparison_operator] = STATE(601),
    [sym_lambda] = STATE(601),
    [sym_assignment] = STATE(936),
    [sym_augmented_assignment] = STATE(936),
    [sym_yield] = STATE(936),
    [sym_attribute] = STATE(109),
    [sym_subscript] = STATE(109),
    [sym_call] = STATE(109),
    [sym_list] = STATE(109),
    [sym_list_comprehension] = STATE(109),
    [sym_dictionary] = STATE(109),
    [sym_dictionary_comprehension] = STATE(109),
    [sym_set] = STATE(109),
    [sym_set_comprehension] = STATE(109),
    [sym_parenthesized_expression] = STATE(109),
    [sym_tuple] = STATE(109),
    [sym_generator_expression] = STATE(109),
    [sym_conditional_expression] = STATE(601),
    [sym_concatenated_string] = STATE(109),
    [sym_string] = STATE(117),
    [sym_await] = STATE(601),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_import] = ACTIONS(9),
    [anon_sym_from] = ACTIONS(11),
    [anon_sym_LPAREN] = ACTIONS(13),
    [anon_sym_print] = ACTIONS(15),
    [anon_sym_assert] = ACTIONS(17),
    [anon_sym_return] = ACTIONS(19),
    [anon_sym_del] = ACTIONS(21),
    [anon_sym_raise] = ACTIONS(23),
    [anon_sym_pass] = ACTIONS(25),
    [anon_sym_break] = ACTIONS(27),
    [anon_sym_continue] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(45),
    [anon_sym_nonlocal] = ACTIONS(47),
    [anon_sym_exec] = ACTIONS(49),
    [anon_sym_not] = ACTIONS(55),
    [anon_sym_PLUS] = ACTIONS(57),
    [anon_sym_DASH] = ACTIONS(57),
    [anon_sym_TILDE] = ACTIONS(57),
    [anon_sym_lambda] = ACTIONS(59),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [sym_ellipsis] = ACTIONS(65),
    [anon_sym_LBRACE] = ACTIONS(67),
    [sym_integer] = ACTIONS(69),
    [sym_float] = ACTIONS(65),
    [sym_true] = ACTIONS(69),
    [sym_false] = ACTIONS(69),
    [sym_none] = ACTIONS(69),
    [anon_sym_await] = ACTIONS(71),
    [sym_comment] = ACTIONS(3),
    [sym__indent] = ACTIONS(271),
    [sym__string_start] = ACTIONS(73),
  },
  [65] = {
    [sym__simple_statements] = STATE(385),
    [sym_import_statement] = STATE(861),
    [sym_future_import_statement] = STATE(861),
    [sym_import_from_statement] = STATE(861),
    [sym_print_statement] = STATE(861),
    [sym_assert_statement] = STATE(861),
    [sym_expression_statement] = STATE(861),
    [sym_named_expression] = STATE(601),
    [sym_return_statement] = STATE(861),
    [sym_delete_statement] = STATE(861),
    [sym_raise_statement] = STATE(861),
    [sym_pass_statement] = STATE(861),
    [sym_break_statement] = STATE(861),
    [sym_continue_statement] = STATE(861),
    [sym_global_statement] = STATE(861),
    [sym_nonlocal_statement] = STATE(861),
    [sym_exec_statement] = STATE(861),
    [sym_expression_list] = STATE(618),
    [sym__expression] = STATE(601),
    [sym__primary_expression] = STATE(109),
    [sym_not_operator] = STATE(601),
    [sym_boolean_operator] = STATE(601),
    [sym_binary_operator] = STATE(109),
    [sym_unary_operator] = STATE(109),
    [sym_comparison_operator] = STATE(601),
    [sym_lambda] = STATE(601),
    [sym_assignment] = STATE(936),
    [sym_augmented_assignment] = STATE(936),
    [sym_yield] = STATE(936),
    [sym_attribute] = STATE(109),
    [sym_subscript] = STATE(109),
    [sym_call] = STATE(109),
    [sym_list] = STATE(109),
    [sym_list_comprehension] = STATE(109),
    [sym_dictionary] = STATE(109),
    [sym_dictionary_comprehension] = STATE(109),
    [sym_set] = STATE(109),
    [sym_set_comprehension] = STATE(109),
    [sym_parenthesized_expression] = STATE(109),
    [sym_tuple] = STATE(109),
    [sym_generator_expression] = STATE(109),
    [sym_conditional_expression] = STATE(601),
    [sym_concatenated_string] = STATE(109),
    [sym_string] = STATE(117),
    [sym_await] = STATE(601),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_import] = ACTIONS(9),
    [anon_sym_from] = ACTIONS(11),
    [anon_sym_LPAREN] = ACTIONS(13),
    [anon_sym_print] = ACTIONS(15),
    [anon_sym_assert] = ACTIONS(17),
    [anon_sym_return] = ACTIONS(19),
    [anon_sym_del] = ACTIONS(21),
    [anon_sym_raise] = ACTIONS(23),
    [anon_sym_pass] = ACTIONS(25),
    [anon_sym_break] = ACTIONS(27),
    [anon_sym_continue] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(45),
    [anon_sym_nonlocal] = ACTIONS(47),
    [anon_sym_exec] = ACTIONS(49),
    [anon_sym_not] = ACTIONS(55),
    [anon_sym_PLUS] = ACTIONS(57),
    [anon_sym_DASH] = ACTIONS(57),
    [anon_sym_TILDE] = ACTIONS(57),
    [anon_sym_lambda] = ACTIONS(59),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [sym_ellipsis] = ACTIONS(65),
    [anon_sym_LBRACE] = ACTIONS(67),
    [sym_integer] = ACTIONS(69),
    [sym_float] = ACTIONS(65),
    [sym_true] = ACTIONS(69),
    [sym_false] = ACTIONS(69),
    [sym_none] = ACTIONS(69),
    [anon_sym_await] = ACTIONS(71),
    [sym_comment] = ACTIONS(3),
    [sym__indent] = ACTIONS(273),
    [sym__string_start] = ACTIONS(73),
  },
  [66] = {
    [sym__simple_statements] = STATE(411),
    [sym_import_statement] = STATE(861),
    [sym_future_import_statement] = STATE(861),
    [sym_import_from_statement] = STATE(861),
    [sym_print_statement] = STATE(861),
    [sym_assert_statement] = STATE(861),
    [sym_expression_statement] = STATE(861),
    [sym_named_expression] = STATE(601),
    [sym_return_statement] = STATE(861),
    [sym_delete_statement] = STATE(861),
    [sym_raise_statement] = STATE(861),
    [sym_pass_statement] = STATE(861),
    [sym_break_statement] = STATE(861),
    [sym_continue_statement] = STATE(861),
    [sym_global_statement] = STATE(861),
    [sym_nonlocal_statement] = STATE(861),
    [sym_exec_statement] = STATE(861),
    [sym_expression_list] = STATE(618),
    [sym__expression] = STATE(601),
    [sym__primary_expression] = STATE(109),
    [sym_not_operator] = STATE(601),
    [sym_boolean_operator] = STATE(601),
    [sym_binary_operator] = STATE(109),
    [sym_unary_operator] = STATE(109),
    [sym_comparison_operator] = STATE(601),
    [sym_lambda] = STATE(601),
    [sym_assignment] = STATE(936),
    [sym_augmented_assignment] = STATE(936),
    [sym_yield] = STATE(936),
    [sym_attribute] = STATE(109),
    [sym_subscript] = STATE(109),
    [sym_call] = STATE(109),
    [sym_list] = STATE(109),
    [sym_list_comprehension] = STATE(109),
    [sym_dictionary] = STATE(109),
    [sym_dictionary_comprehension] = STATE(109),
    [sym_set] = STATE(109),
    [sym_set_comprehension] = STATE(109),
    [sym_parenthesized_expression] = STATE(109),
    [sym_tuple] = STATE(109),
    [sym_generator_expression] = STATE(109),
    [sym_conditional_expression] = STATE(601),
    [sym_concatenated_string] = STATE(109),
    [sym_string] = STATE(117),
    [sym_await] = STATE(601),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_import] = ACTIONS(9),
    [anon_sym_from] = ACTIONS(11),
    [anon_sym_LPAREN] = ACTIONS(13),
    [anon_sym_print] = ACTIONS(15),
    [anon_sym_assert] = ACTIONS(17),
    [anon_sym_return] = ACTIONS(19),
    [anon_sym_del] = ACTIONS(21),
    [anon_sym_raise] = ACTIONS(23),
    [anon_sym_pass] = ACTIONS(25),
    [anon_sym_break] = ACTIONS(27),
    [anon_sym_continue] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(45),
    [anon_sym_nonlocal] = ACTIONS(47),
    [anon_sym_exec] = ACTIONS(49),
    [anon_sym_not] = ACTIONS(55),
    [anon_sym_PLUS] = ACTIONS(57),
    [anon_sym_DASH] = ACTIONS(57),
    [anon_sym_TILDE] = ACTIONS(57),
    [anon_sym_lambda] = ACTIONS(59),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [sym_ellipsis] = ACTIONS(65),
    [anon_sym_LBRACE] = ACTIONS(67),
    [sym_integer] = ACTIONS(69),
    [sym_float] = ACTIONS(65),
    [sym_true] = ACTIONS(69),
    [sym_false] = ACTIONS(69),
    [sym_none] = ACTIONS(69),
    [anon_sym_await] = ACTIONS(71),
    [sym_comment] = ACTIONS(3),
    [sym__indent] = ACTIONS(275),
    [sym__string_start] = ACTIONS(73),
  },
  [67] = {
    [sym__simple_statements] = STATE(405),
    [sym_import_statement] = STATE(861),
    [sym_future_import_statement] = STATE(861),
    [sym_import_from_statement] = STATE(861),
    [sym_print_statement] = STATE(861),
    [sym_assert_statement] = STATE(861),
    [sym_expression_statement] = STATE(861),
    [sym_named_expression] = STATE(601),
    [sym_return_statement] = STATE(861),
    [sym_delete_statement] = STATE(861),
    [sym_raise_statement] = STATE(861),
    [sym_pass_statement] = STATE(861),
    [sym_break_statement] = STATE(861),
    [sym_continue_statement] = STATE(861),
    [sym_global_statement] = STATE(861),
    [sym_nonlocal_statement] = STATE(861),
    [sym_exec_statement] = STATE(861),
    [sym_expression_list] = STATE(618),
    [sym__expression] = STATE(601),
    [sym__primary_expression] = STATE(109),
    [sym_not_operator] = STATE(601),
    [sym_boolean_operator] = STATE(601),
    [sym_binary_operator] = STATE(109),
    [sym_unary_operator] = STATE(109),
    [sym_comparison_operator] = STATE(601),
    [sym_lambda] = STATE(601),
    [sym_assignment] = STATE(936),
    [sym_augmented_assignment] = STATE(936),
    [sym_yield] = STATE(936),
    [sym_attribute] = STATE(109),
    [sym_subscript] = STATE(109),
    [sym_call] = STATE(109),
    [sym_list] = STATE(109),
    [sym_list_comprehension] = STATE(109),
    [sym_dictionary] = STATE(109),
    [sym_dictionary_comprehension] = STATE(109),
    [sym_set] = STATE(109),
    [sym_set_comprehension] = STATE(109),
    [sym_parenthesized_expression] = STATE(109),
    [sym_tuple] = STATE(109),
    [sym_generator_expression] = STATE(109),
    [sym_conditional_expression] = STATE(601),
    [sym_concatenated_string] = STATE(109),
    [sym_string] = STATE(117),
    [sym_await] = STATE(601),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_import] = ACTIONS(9),
    [anon_sym_from] = ACTIONS(11),
    [anon_sym_LPAREN] = ACTIONS(13),
    [anon_sym_print] = ACTIONS(15),
    [anon_sym_assert] = ACTIONS(17),
    [anon_sym_return] = ACTIONS(19),
    [anon_sym_del] = ACTIONS(21),
    [anon_sym_raise] = ACTIONS(23),
    [anon_sym_pass] = ACTIONS(25),
    [anon_sym_break] = ACTIONS(27),
    [anon_sym_continue] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(45),
    [anon_sym_nonlocal] = ACTIONS(47),
    [anon_sym_exec] = ACTIONS(49),
    [anon_sym_not] = ACTIONS(55),
    [anon_sym_PLUS] = ACTIONS(57),
    [anon_sym_DASH] = ACTIONS(57),
    [anon_sym_TILDE] = ACTIONS(57),
    [anon_sym_lambda] = ACTIONS(59),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [sym_ellipsis] = ACTIONS(65),
    [anon_sym_LBRACE] = ACTIONS(67),
    [sym_integer] = ACTIONS(69),
    [sym_float] = ACTIONS(65),
    [sym_true] = ACTIONS(69),
    [sym_false] = ACTIONS(69),
    [sym_none] = ACTIONS(69),
    [anon_sym_await] = ACTIONS(71),
    [sym_comment] = ACTIONS(3),
    [sym__indent] = ACTIONS(277),
    [sym__string_start] = ACTIONS(73),
  },
  [68] = {
    [sym__simple_statements] = STATE(430),
    [sym_import_statement] = STATE(831),
    [sym_future_import_statement] = STATE(831),
    [sym_import_from_statement] = STATE(831),
    [sym_print_statement] = STATE(831),
    [sym_assert_statement] = STATE(831),
    [sym_expression_statement] = STATE(831),
    [sym_named_expression] = STATE(601),
    [sym_return_statement] = STATE(831),
    [sym_delete_statement] = STATE(831),
    [sym_raise_statement] = STATE(831),
    [sym_pass_statement] = STATE(831),
    [sym_break_statement] = STATE(831),
    [sym_continue_statement] = STATE(831),
    [sym_global_statement] = STATE(831),
    [sym_nonlocal_statement] = STATE(831),
    [sym_exec_statement] = STATE(831),
    [sym_expression_list] = STATE(618),
    [sym__expression] = STATE(601),
    [sym__primary_expression] = STATE(109),
    [sym_not_operator] = STATE(601),
    [sym_boolean_operator] = STATE(601),
    [sym_binary_operator] = STATE(109),
    [sym_unary_operator] = STATE(109),
    [sym_comparison_operator] = STATE(601),
    [sym_lambda] = STATE(601),
    [sym_assignment] = STATE(936),
    [sym_augmented_assignment] = STATE(936),
    [sym_yield] = STATE(936),
    [sym_attribute] = STATE(109),
    [sym_subscript] = STATE(109),
    [sym_call] = STATE(109),
    [sym_list] = STATE(109),
    [sym_list_comprehension] = STATE(109),
    [sym_dictionary] = STATE(109),
    [sym_dictionary_comprehension] = STATE(109),
    [sym_set] = STATE(109),
    [sym_set_comprehension] = STATE(109),
    [sym_parenthesized_expression] = STATE(109),
    [sym_tuple] = STATE(109),
    [sym_generator_expression] = STATE(109),
    [sym_conditional_expression] = STATE(601),
    [sym_concatenated_string] = STATE(109),
    [sym_string] = STATE(117),
    [sym_await] = STATE(601),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_import] = ACTIONS(9),
    [anon_sym_from] = ACTIONS(11),
    [anon_sym_LPAREN] = ACTIONS(13),
    [anon_sym_print] = ACTIONS(15),
    [anon_sym_assert] = ACTIONS(17),
    [anon_sym_return] = ACTIONS(19),
    [anon_sym_del] = ACTIONS(21),
    [anon_sym_raise] = ACTIONS(23),
    [anon_sym_pass] = ACTIONS(25),
    [anon_sym_break] = ACTIONS(27),
    [anon_sym_continue] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(45),
    [anon_sym_nonlocal] = ACTIONS(47),
    [anon_sym_exec] = ACTIONS(49),
    [anon_sym_not] = ACTIONS(55),
    [anon_sym_PLUS] = ACTIONS(57),
    [anon_sym_DASH] = ACTIONS(57),
    [anon_sym_TILDE] = ACTIONS(57),
    [anon_sym_lambda] = ACTIONS(59),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [sym_ellipsis] = ACTIONS(65),
    [anon_sym_LBRACE] = ACTIONS(67),
    [sym_integer] = ACTIONS(69),
    [sym_float] = ACTIONS(65),
    [sym_true] = ACTIONS(69),
    [sym_false] = ACTIONS(69),
    [sym_none] = ACTIONS(69),
    [anon_sym_await] = ACTIONS(71),
    [sym_comment] = ACTIONS(3),
    [sym__indent] = ACTIONS(279),
    [sym__string_start] = ACTIONS(73),
  },
  [69] = {
    [sym__simple_statements] = STATE(451),
    [sym_import_statement] = STATE(831),
    [sym_future_import_statement] = STATE(831),
    [sym_import_from_statement] = STATE(831),
    [sym_print_statement] = STATE(831),
    [sym_assert_statement] = STATE(831),
    [sym_expression_statement] = STATE(831),
    [sym_named_expression] = STATE(601),
    [sym_return_statement] = STATE(831),
    [sym_delete_statement] = STATE(831),
    [sym_raise_statement] = STATE(831),
    [sym_pass_statement] = STATE(831),
    [sym_break_statement] = STATE(831),
    [sym_continue_statement] = STATE(831),
    [sym_global_statement] = STATE(831),
    [sym_nonlocal_statement] = STATE(831),
    [sym_exec_statement] = STATE(831),
    [sym_expression_list] = STATE(618),
    [sym__expression] = STATE(601),
    [sym__primary_expression] = STATE(109),
    [sym_not_operator] = STATE(601),
    [sym_boolean_operator] = STATE(601),
    [sym_binary_operator] = STATE(109),
    [sym_unary_operator] = STATE(109),
    [sym_comparison_operator] = STATE(601),
    [sym_lambda] = STATE(601),
    [sym_assignment] = STATE(936),
    [sym_augmented_assignment] = STATE(936),
    [sym_yield] = STATE(936),
    [sym_attribute] = STATE(109),
    [sym_subscript] = STATE(109),
    [sym_call] = STATE(109),
    [sym_list] = STATE(109),
    [sym_list_comprehension] = STATE(109),
    [sym_dictionary] = STATE(109),
    [sym_dictionary_comprehension] = STATE(109),
    [sym_set] = STATE(109),
    [sym_set_comprehension] = STATE(109),
    [sym_parenthesized_expression] = STATE(109),
    [sym_tuple] = STATE(109),
    [sym_generator_expression] = STATE(109),
    [sym_conditional_expression] = STATE(601),
    [sym_concatenated_string] = STATE(109),
    [sym_string] = STATE(117),
    [sym_await] = STATE(601),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_import] = ACTIONS(9),
    [anon_sym_from] = ACTIONS(11),
    [anon_sym_LPAREN] = ACTIONS(13),
    [anon_sym_print] = ACTIONS(15),
    [anon_sym_assert] = ACTIONS(17),
    [anon_sym_return] = ACTIONS(19),
    [anon_sym_del] = ACTIONS(21),
    [anon_sym_raise] = ACTIONS(23),
    [anon_sym_pass] = ACTIONS(25),
    [anon_sym_break] = ACTIONS(27),
    [anon_sym_continue] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(45),
    [anon_sym_nonlocal] = ACTIONS(47),
    [anon_sym_exec] = ACTIONS(49),
    [anon_sym_not] = ACTIONS(55),
    [anon_sym_PLUS] = ACTIONS(57),
    [anon_sym_DASH] = ACTIONS(57),
    [anon_sym_TILDE] = ACTIONS(57),
    [anon_sym_lambda] = ACTIONS(59),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [sym_ellipsis] = ACTIONS(65),
    [anon_sym_LBRACE] = ACTIONS(67),
    [sym_integer] = ACTIONS(69),
    [sym_float] = ACTIONS(65),
    [sym_true] = ACTIONS(69),
    [sym_false] = ACTIONS(69),
    [sym_none] = ACTIONS(69),
    [anon_sym_await] = ACTIONS(71),
    [sym_comment] = ACTIONS(3),
    [sym__indent] = ACTIONS(281),
    [sym__string_start] = ACTIONS(73),
  },
  [70] = {
    [sym__simple_statements] = STATE(425),
    [sym_import_statement] = STATE(831),
    [sym_future_import_statement] = STATE(831),
    [sym_import_from_statement] = STATE(831),
    [sym_print_statement] = STATE(831),
    [sym_assert_statement] = STATE(831),
    [sym_expression_statement] = STATE(831),
    [sym_named_expression] = STATE(601),
    [sym_return_statement] = STATE(831),
    [sym_delete_statement] = STATE(831),
    [sym_raise_statement] = STATE(831),
    [sym_pass_statement] = STATE(831),
    [sym_break_statement] = STATE(831),
    [sym_continue_statement] = STATE(831),
    [sym_global_statement] = STATE(831),
    [sym_nonlocal_statement] = STATE(831),
    [sym_exec_statement] = STATE(831),
    [sym_expression_list] = STATE(618),
    [sym__expression] = STATE(601),
    [sym__primary_expression] = STATE(109),
    [sym_not_operator] = STATE(601),
    [sym_boolean_operator] = STATE(601),
    [sym_binary_operator] = STATE(109),
    [sym_unary_operator] = STATE(109),
    [sym_comparison_operator] = STATE(601),
    [sym_lambda] = STATE(601),
    [sym_assignment] = STATE(936),
    [sym_augmented_assignment] = STATE(936),
    [sym_yield] = STATE(936),
    [sym_attribute] = STATE(109),
    [sym_subscript] = STATE(109),
    [sym_call] = STATE(109),
    [sym_list] = STATE(109),
    [sym_list_comprehension] = STATE(109),
    [sym_dictionary] = STATE(109),
    [sym_dictionary_comprehension] = STATE(109),
    [sym_set] = STATE(109),
    [sym_set_comprehension] = STATE(109),
    [sym_parenthesized_expression] = STATE(109),
    [sym_tuple] = STATE(109),
    [sym_generator_expression] = STATE(109),
    [sym_conditional_expression] = STATE(601),
    [sym_concatenated_string] = STATE(109),
    [sym_string] = STATE(117),
    [sym_await] = STATE(601),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_import] = ACTIONS(9),
    [anon_sym_from] = ACTIONS(11),
    [anon_sym_LPAREN] = ACTIONS(13),
    [anon_sym_print] = ACTIONS(15),
    [anon_sym_assert] = ACTIONS(17),
    [anon_sym_return] = ACTIONS(19),
    [anon_sym_del] = ACTIONS(21),
    [anon_sym_raise] = ACTIONS(23),
    [anon_sym_pass] = ACTIONS(25),
    [anon_sym_break] = ACTIONS(27),
    [anon_sym_continue] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(45),
    [anon_sym_nonlocal] = ACTIONS(47),
    [anon_sym_exec] = ACTIONS(49),
    [anon_sym_not] = ACTIONS(55),
    [anon_sym_PLUS] = ACTIONS(57),
    [anon_sym_DASH] = ACTIONS(57),
    [anon_sym_TILDE] = ACTIONS(57),
    [anon_sym_lambda] = ACTIONS(59),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [sym_ellipsis] = ACTIONS(65),
    [anon_sym_LBRACE] = ACTIONS(67),
    [sym_integer] = ACTIONS(69),
    [sym_float] = ACTIONS(65),
    [sym_true] = ACTIONS(69),
    [sym_false] = ACTIONS(69),
    [sym_none] = ACTIONS(69),
    [anon_sym_await] = ACTIONS(71),
    [sym_comment] = ACTIONS(3),
    [sym__indent] = ACTIONS(283),
    [sym__string_start] = ACTIONS(73),
  },
  [71] = {
    [sym__simple_statements] = STATE(320),
    [sym_import_statement] = STATE(831),
    [sym_future_import_statement] = STATE(831),
    [sym_import_from_statement] = STATE(831),
    [sym_print_statement] = STATE(831),
    [sym_assert_statement] = STATE(831),
    [sym_expression_statement] = STATE(831),
    [sym_named_expression] = STATE(601),
    [sym_return_statement] = STATE(831),
    [sym_delete_statement] = STATE(831),
    [sym_raise_statement] = STATE(831),
    [sym_pass_statement] = STATE(831),
    [sym_break_statement] = STATE(831),
    [sym_continue_statement] = STATE(831),
    [sym_global_statement] = STATE(831),
    [sym_nonlocal_statement] = STATE(831),
    [sym_exec_statement] = STATE(831),
    [sym_expression_list] = STATE(618),
    [sym__expression] = STATE(601),
    [sym__primary_expression] = STATE(109),
    [sym_not_operator] = STATE(601),
    [sym_boolean_operator] = STATE(601),
    [sym_binary_operator] = STATE(109),
    [sym_unary_operator] = STATE(109),
    [sym_comparison_operator] = STATE(601),
    [sym_lambda] = STATE(601),
    [sym_assignment] = STATE(936),
    [sym_augmented_assignment] = STATE(936),
    [sym_yield] = STATE(936),
    [sym_attribute] = STATE(109),
    [sym_subscript] = STATE(109),
    [sym_call] = STATE(109),
    [sym_list] = STATE(109),
    [sym_list_comprehension] = STATE(109),
    [sym_dictionary] = STATE(109),
    [sym_dictionary_comprehension] = STATE(109),
    [sym_set] = STATE(109),
    [sym_set_comprehension] = STATE(109),
    [sym_parenthesized_expression] = STATE(109),
    [sym_tuple] = STATE(109),
    [sym_generator_expression] = STATE(109),
    [sym_conditional_expression] = STATE(601),
    [sym_concatenated_string] = STATE(109),
    [sym_string] = STATE(117),
    [sym_await] = STATE(601),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_import] = ACTIONS(9),
    [anon_sym_from] = ACTIONS(11),
    [anon_sym_LPAREN] = ACTIONS(13),
    [anon_sym_print] = ACTIONS(15),
    [anon_sym_assert] = ACTIONS(17),
    [anon_sym_return] = ACTIONS(19),
    [anon_sym_del] = ACTIONS(21),
    [anon_sym_raise] = ACTIONS(23),
    [anon_sym_pass] = ACTIONS(25),
    [anon_sym_break] = ACTIONS(27),
    [anon_sym_continue] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(45),
    [anon_sym_nonlocal] = ACTIONS(47),
    [anon_sym_exec] = ACTIONS(49),
    [anon_sym_not] = ACTIONS(55),
    [anon_sym_PLUS] = ACTIONS(57),
    [anon_sym_DASH] = ACTIONS(57),
    [anon_sym_TILDE] = ACTIONS(57),
    [anon_sym_lambda] = ACTIONS(59),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [sym_ellipsis] = ACTIONS(65),
    [anon_sym_LBRACE] = ACTIONS(67),
    [sym_integer] = ACTIONS(69),
    [sym_float] = ACTIONS(65),
    [sym_true] = ACTIONS(69),
    [sym_false] = ACTIONS(69),
    [sym_none] = ACTIONS(69),
    [anon_sym_await] = ACTIONS(71),
    [sym_comment] = ACTIONS(3),
    [sym__indent] = ACTIONS(285),
    [sym__string_start] = ACTIONS(73),
  },
  [72] = {
    [sym__simple_statements] = STATE(468),
    [sym_import_statement] = STATE(831),
    [sym_future_import_statement] = STATE(831),
    [sym_import_from_statement] = STATE(831),
    [sym_print_statement] = STATE(831),
    [sym_assert_statement] = STATE(831),
    [sym_expression_statement] = STATE(831),
    [sym_named_expression] = STATE(601),
    [sym_return_statement] = STATE(831),
    [sym_delete_statement] = STATE(831),
    [sym_raise_statement] = STATE(831),
    [sym_pass_statement] = STATE(831),
    [sym_break_statement] = STATE(831),
    [sym_continue_statement] = STATE(831),
    [sym_global_statement] = STATE(831),
    [sym_nonlocal_statement] = STATE(831),
    [sym_exec_statement] = STATE(831),
    [sym_expression_list] = STATE(618),
    [sym__expression] = STATE(601),
    [sym__primary_expression] = STATE(109),
    [sym_not_operator] = STATE(601),
    [sym_boolean_operator] = STATE(601),
    [sym_binary_operator] = STATE(109),
    [sym_unary_operator] = STATE(109),
    [sym_comparison_operator] = STATE(601),
    [sym_lambda] = STATE(601),
    [sym_assignment] = STATE(936),
    [sym_augmented_assignment] = STATE(936),
    [sym_yield] = STATE(936),
    [sym_attribute] = STATE(109),
    [sym_subscript] = STATE(109),
    [sym_call] = STATE(109),
    [sym_list] = STATE(109),
    [sym_list_comprehension] = STATE(109),
    [sym_dictionary] = STATE(109),
    [sym_dictionary_comprehension] = STATE(109),
    [sym_set] = STATE(109),
    [sym_set_comprehension] = STATE(109),
    [sym_parenthesized_expression] = STATE(109),
    [sym_tuple] = STATE(109),
    [sym_generator_expression] = STATE(109),
    [sym_conditional_expression] = STATE(601),
    [sym_concatenated_string] = STATE(109),
    [sym_string] = STATE(117),
    [sym_await] = STATE(601),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_import] = ACTIONS(9),
    [anon_sym_from] = ACTIONS(11),
    [anon_sym_LPAREN] = ACTIONS(13),
    [anon_sym_print] = ACTIONS(15),
    [anon_sym_assert] = ACTIONS(17),
    [anon_sym_return] = ACTIONS(19),
    [anon_sym_del] = ACTIONS(21),
    [anon_sym_raise] = ACTIONS(23),
    [anon_sym_pass] = ACTIONS(25),
    [anon_sym_break] = ACTIONS(27),
    [anon_sym_continue] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(45),
    [anon_sym_nonlocal] = ACTIONS(47),
    [anon_sym_exec] = ACTIONS(49),
    [anon_sym_not] = ACTIONS(55),
    [anon_sym_PLUS] = ACTIONS(57),
    [anon_sym_DASH] = ACTIONS(57),
    [anon_sym_TILDE] = ACTIONS(57),
    [anon_sym_lambda] = ACTIONS(59),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [sym_ellipsis] = ACTIONS(65),
    [anon_sym_LBRACE] = ACTIONS(67),
    [sym_integer] = ACTIONS(69),
    [sym_float] = ACTIONS(65),
    [sym_true] = ACTIONS(69),
    [sym_false] = ACTIONS(69),
    [sym_none] = ACTIONS(69),
    [anon_sym_await] = ACTIONS(71),
    [sym_comment] = ACTIONS(3),
    [sym__indent] = ACTIONS(287),
    [sym__string_start] = ACTIONS(73),
  },
  [73] = {
    [sym__simple_statements] = STATE(397),
    [sym_import_statement] = STATE(861),
    [sym_future_import_statement] = STATE(861),
    [sym_import_from_statement] = STATE(861),
    [sym_print_statement] = STATE(861),
    [sym_assert_statement] = STATE(861),
    [sym_expression_statement] = STATE(861),
    [sym_named_expression] = STATE(601),
    [sym_return_statement] = STATE(861),
    [sym_delete_statement] = STATE(861),
    [sym_raise_statement] = STATE(861),
    [sym_pass_statement] = STATE(861),
    [sym_break_statement] = STATE(861),
    [sym_continue_statement] = STATE(861),
    [sym_global_statement] = STATE(861),
    [sym_nonlocal_statement] = STATE(861),
    [sym_exec_statement] = STATE(861),
    [sym_expression_list] = STATE(618),
    [sym__expression] = STATE(601),
    [sym__primary_expression] = STATE(109),
    [sym_not_operator] = STATE(601),
    [sym_boolean_operator] = STATE(601),
    [sym_binary_operator] = STATE(109),
    [sym_unary_operator] = STATE(109),
    [sym_comparison_operator] = STATE(601),
    [sym_lambda] = STATE(601),
    [sym_assignment] = STATE(936),
    [sym_augmented_assignment] = STATE(936),
    [sym_yield] = STATE(936),
    [sym_attribute] = STATE(109),
    [sym_subscript] = STATE(109),
    [sym_call] = STATE(109),
    [sym_list] = STATE(109),
    [sym_list_comprehension] = STATE(109),
    [sym_dictionary] = STATE(109),
    [sym_dictionary_comprehension] = STATE(109),
    [sym_set] = STATE(109),
    [sym_set_comprehension] = STATE(109),
    [sym_parenthesized_expression] = STATE(109),
    [sym_tuple] = STATE(109),
    [sym_generator_expression] = STATE(109),
    [sym_conditional_expression] = STATE(601),
    [sym_concatenated_string] = STATE(109),
    [sym_string] = STATE(117),
    [sym_await] = STATE(601),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_import] = ACTIONS(9),
    [anon_sym_from] = ACTIONS(11),
    [anon_sym_LPAREN] = ACTIONS(13),
    [anon_sym_print] = ACTIONS(15),
    [anon_sym_assert] = ACTIONS(17),
    [anon_sym_return] = ACTIONS(19),
    [anon_sym_del] = ACTIONS(21),
    [anon_sym_raise] = ACTIONS(23),
    [anon_sym_pass] = ACTIONS(25),
    [anon_sym_break] = ACTIONS(27),
    [anon_sym_continue] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(45),
    [anon_sym_nonlocal] = ACTIONS(47),
    [anon_sym_exec] = ACTIONS(49),
    [anon_sym_not] = ACTIONS(55),
    [anon_sym_PLUS] = ACTIONS(57),
    [anon_sym_DASH] = ACTIONS(57),
    [anon_sym_TILDE] = ACTIONS(57),
    [anon_sym_lambda] = ACTIONS(59),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [sym_ellipsis] = ACTIONS(65),
    [anon_sym_LBRACE] = ACTIONS(67),
    [sym_integer] = ACTIONS(69),
    [sym_float] = ACTIONS(65),
    [sym_true] = ACTIONS(69),
    [sym_false] = ACTIONS(69),
    [sym_none] = ACTIONS(69),
    [anon_sym_await] = ACTIONS(71),
    [sym_comment] = ACTIONS(3),
    [sym__indent] = ACTIONS(289),
    [sym__string_start] = ACTIONS(73),
  },
  [74] = {
    [sym__simple_statements] = STATE(437),
    [sym_import_statement] = STATE(831),
    [sym_future_import_statement] = STATE(831),
    [sym_import_from_statement] = STATE(831),
    [sym_print_statement] = STATE(831),
    [sym_assert_statement] = STATE(831),
    [sym_expression_statement] = STATE(831),
    [sym_named_expression] = STATE(601),
    [sym_return_statement] = STATE(831),
    [sym_delete_statement] = STATE(831),
    [sym_raise_statement] = STATE(831),
    [sym_pass_statement] = STATE(831),
    [sym_break_statement] = STATE(831),
    [sym_continue_statement] = STATE(831),
    [sym_global_statement] = STATE(831),
    [sym_nonlocal_statement] = STATE(831),
    [sym_exec_statement] = STATE(831),
    [sym_expression_list] = STATE(618),
    [sym__expression] = STATE(601),
    [sym__primary_expression] = STATE(109),
    [sym_not_operator] = STATE(601),
    [sym_boolean_operator] = STATE(601),
    [sym_binary_operator] = STATE(109),
    [sym_unary_operator] = STATE(109),
    [sym_comparison_operator] = STATE(601),
    [sym_lambda] = STATE(601),
    [sym_assignment] = STATE(936),
    [sym_augmented_assignment] = STATE(936),
    [sym_yield] = STATE(936),
    [sym_attribute] = STATE(109),
    [sym_subscript] = STATE(109),
    [sym_call] = STATE(109),
    [sym_list] = STATE(109),
    [sym_list_comprehension] = STATE(109),
    [sym_dictionary] = STATE(109),
    [sym_dictionary_comprehension] = STATE(109),
    [sym_set] = STATE(109),
    [sym_set_comprehension] = STATE(109),
    [sym_parenthesized_expression] = STATE(109),
    [sym_tuple] = STATE(109),
    [sym_generator_expression] = STATE(109),
    [sym_conditional_expression] = STATE(601),
    [sym_concatenated_string] = STATE(109),
    [sym_string] = STATE(117),
    [sym_await] = STATE(601),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_import] = ACTIONS(9),
    [anon_sym_from] = ACTIONS(11),
    [anon_sym_LPAREN] = ACTIONS(13),
    [anon_sym_print] = ACTIONS(15),
    [anon_sym_assert] = ACTIONS(17),
    [anon_sym_return] = ACTIONS(19),
    [anon_sym_del] = ACTIONS(21),
    [anon_sym_raise] = ACTIONS(23),
    [anon_sym_pass] = ACTIONS(25),
    [anon_sym_break] = ACTIONS(27),
    [anon_sym_continue] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(45),
    [anon_sym_nonlocal] = ACTIONS(47),
    [anon_sym_exec] = ACTIONS(49),
    [anon_sym_not] = ACTIONS(55),
    [anon_sym_PLUS] = ACTIONS(57),
    [anon_sym_DASH] = ACTIONS(57),
    [anon_sym_TILDE] = ACTIONS(57),
    [anon_sym_lambda] = ACTIONS(59),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [sym_ellipsis] = ACTIONS(65),
    [anon_sym_LBRACE] = ACTIONS(67),
    [sym_integer] = ACTIONS(69),
    [sym_float] = ACTIONS(65),
    [sym_true] = ACTIONS(69),
    [sym_false] = ACTIONS(69),
    [sym_none] = ACTIONS(69),
    [anon_sym_await] = ACTIONS(71),
    [sym_comment] = ACTIONS(3),
    [sym__indent] = ACTIONS(291),
    [sym__string_start] = ACTIONS(73),
  },
  [75] = {
    [sym__simple_statements] = STATE(359),
    [sym_import_statement] = STATE(831),
    [sym_future_import_statement] = STATE(831),
    [sym_import_from_statement] = STATE(831),
    [sym_print_statement] = STATE(831),
    [sym_assert_statement] = STATE(831),
    [sym_expression_statement] = STATE(831),
    [sym_named_expression] = STATE(601),
    [sym_return_statement] = STATE(831),
    [sym_delete_statement] = STATE(831),
    [sym_raise_statement] = STATE(831),
    [sym_pass_statement] = STATE(831),
    [sym_break_statement] = STATE(831),
    [sym_continue_statement] = STATE(831),
    [sym_global_statement] = STATE(831),
    [sym_nonlocal_statement] = STATE(831),
    [sym_exec_statement] = STATE(831),
    [sym_expression_list] = STATE(618),
    [sym__expression] = STATE(601),
    [sym__primary_expression] = STATE(109),
    [sym_not_operator] = STATE(601),
    [sym_boolean_operator] = STATE(601),
    [sym_binary_operator] = STATE(109),
    [sym_unary_operator] = STATE(109),
    [sym_comparison_operator] = STATE(601),
    [sym_lambda] = STATE(601),
    [sym_assignment] = STATE(936),
    [sym_augmented_assignment] = STATE(936),
    [sym_yield] = STATE(936),
    [sym_attribute] = STATE(109),
    [sym_subscript] = STATE(109),
    [sym_call] = STATE(109),
    [sym_list] = STATE(109),
    [sym_list_comprehension] = STATE(109),
    [sym_dictionary] = STATE(109),
    [sym_dictionary_comprehension] = STATE(109),
    [sym_set] = STATE(109),
    [sym_set_comprehension] = STATE(109),
    [sym_parenthesized_expression] = STATE(109),
    [sym_tuple] = STATE(109),
    [sym_generator_expression] = STATE(109),
    [sym_conditional_expression] = STATE(601),
    [sym_concatenated_string] = STATE(109),
    [sym_string] = STATE(117),
    [sym_await] = STATE(601),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_import] = ACTIONS(9),
    [anon_sym_from] = ACTIONS(11),
    [anon_sym_LPAREN] = ACTIONS(13),
    [anon_sym_print] = ACTIONS(15),
    [anon_sym_assert] = ACTIONS(17),
    [anon_sym_return] = ACTIONS(19),
    [anon_sym_del] = ACTIONS(21),
    [anon_sym_raise] = ACTIONS(23),
    [anon_sym_pass] = ACTIONS(25),
    [anon_sym_break] = ACTIONS(27),
    [anon_sym_continue] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(45),
    [anon_sym_nonlocal] = ACTIONS(47),
    [anon_sym_exec] = ACTIONS(49),
    [anon_sym_not] = ACTIONS(55),
    [anon_sym_PLUS] = ACTIONS(57),
    [anon_sym_DASH] = ACTIONS(57),
    [anon_sym_TILDE] = ACTIONS(57),
    [anon_sym_lambda] = ACTIONS(59),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [sym_ellipsis] = ACTIONS(65),
    [anon_sym_LBRACE] = ACTIONS(67),
    [sym_integer] = ACTIONS(69),
    [sym_float] = ACTIONS(65),
    [sym_true] = ACTIONS(69),
    [sym_false] = ACTIONS(69),
    [sym_none] = ACTIONS(69),
    [anon_sym_await] = ACTIONS(71),
    [sym_comment] = ACTIONS(3),
    [sym__indent] = ACTIONS(293),
    [sym__string_start] = ACTIONS(73),
  },
  [76] = {
    [sym__simple_statements] = STATE(393),
    [sym_import_statement] = STATE(861),
    [sym_future_import_statement] = STATE(861),
    [sym_import_from_statement] = STATE(861),
    [sym_print_statement] = STATE(861),
    [sym_assert_statement] = STATE(861),
    [sym_expression_statement] = STATE(861),
    [sym_named_expression] = STATE(601),
    [sym_return_statement] = STATE(861),
    [sym_delete_statement] = STATE(861),
    [sym_raise_statement] = STATE(861),
    [sym_pass_statement] = STATE(861),
    [sym_break_statement] = STATE(861),
    [sym_continue_statement] = STATE(861),
    [sym_global_statement] = STATE(861),
    [sym_nonlocal_statement] = STATE(861),
    [sym_exec_statement] = STATE(861),
    [sym_expression_list] = STATE(618),
    [sym__expression] = STATE(601),
    [sym__primary_expression] = STATE(109),
    [sym_not_operator] = STATE(601),
    [sym_boolean_operator] = STATE(601),
    [sym_binary_operator] = STATE(109),
    [sym_unary_operator] = STATE(109),
    [sym_comparison_operator] = STATE(601),
    [sym_lambda] = STATE(601),
    [sym_assignment] = STATE(936),
    [sym_augmented_assignment] = STATE(936),
    [sym_yield] = STATE(936),
    [sym_attribute] = STATE(109),
    [sym_subscript] = STATE(109),
    [sym_call] = STATE(109),
    [sym_list] = STATE(109),
    [sym_list_comprehension] = STATE(109),
    [sym_dictionary] = STATE(109),
    [sym_dictionary_comprehension] = STATE(109),
    [sym_set] = STATE(109),
    [sym_set_comprehension] = STATE(109),
    [sym_parenthesized_expression] = STATE(109),
    [sym_tuple] = STATE(109),
    [sym_generator_expression] = STATE(109),
    [sym_conditional_expression] = STATE(601),
    [sym_concatenated_string] = STATE(109),
    [sym_string] = STATE(117),
    [sym_await] = STATE(601),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_import] = ACTIONS(9),
    [anon_sym_from] = ACTIONS(11),
    [anon_sym_LPAREN] = ACTIONS(13),
    [anon_sym_print] = ACTIONS(15),
    [anon_sym_assert] = ACTIONS(17),
    [anon_sym_return] = ACTIONS(19),
    [anon_sym_del] = ACTIONS(21),
    [anon_sym_raise] = ACTIONS(23),
    [anon_sym_pass] = ACTIONS(25),
    [anon_sym_break] = ACTIONS(27),
    [anon_sym_continue] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(45),
    [anon_sym_nonlocal] = ACTIONS(47),
    [anon_sym_exec] = ACTIONS(49),
    [anon_sym_not] = ACTIONS(55),
    [anon_sym_PLUS] = ACTIONS(57),
    [anon_sym_DASH] = ACTIONS(57),
    [anon_sym_TILDE] = ACTIONS(57),
    [anon_sym_lambda] = ACTIONS(59),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [sym_ellipsis] = ACTIONS(65),
    [anon_sym_LBRACE] = ACTIONS(67),
    [sym_integer] = ACTIONS(69),
    [sym_float] = ACTIONS(65),
    [sym_true] = ACTIONS(69),
    [sym_false] = ACTIONS(69),
    [sym_none] = ACTIONS(69),
    [anon_sym_await] = ACTIONS(71),
    [sym_comment] = ACTIONS(3),
    [sym__indent] = ACTIONS(295),
    [sym__string_start] = ACTIONS(73),
  },
  [77] = {
    [sym__simple_statements] = STATE(289),
    [sym_import_statement] = STATE(861),
    [sym_future_import_statement] = STATE(861),
    [sym_import_from_statement] = STATE(861),
    [sym_print_statement] = STATE(861),
    [sym_assert_statement] = STATE(861),
    [sym_expression_statement] = STATE(861),
    [sym_named_expression] = STATE(601),
    [sym_return_statement] = STATE(861),
    [sym_delete_statement] = STATE(861),
    [sym_raise_statement] = STATE(861),
    [sym_pass_statement] = STATE(861),
    [sym_break_statement] = STATE(861),
    [sym_continue_statement] = STATE(861),
    [sym_global_statement] = STATE(861),
    [sym_nonlocal_statement] = STATE(861),
    [sym_exec_statement] = STATE(861),
    [sym_expression_list] = STATE(618),
    [sym__expression] = STATE(601),
    [sym__primary_expression] = STATE(109),
    [sym_not_operator] = STATE(601),
    [sym_boolean_operator] = STATE(601),
    [sym_binary_operator] = STATE(109),
    [sym_unary_operator] = STATE(109),
    [sym_comparison_operator] = STATE(601),
    [sym_lambda] = STATE(601),
    [sym_assignment] = STATE(936),
    [sym_augmented_assignment] = STATE(936),
    [sym_yield] = STATE(936),
    [sym_attribute] = STATE(109),
    [sym_subscript] = STATE(109),
    [sym_call] = STATE(109),
    [sym_list] = STATE(109),
    [sym_list_comprehension] = STATE(109),
    [sym_dictionary] = STATE(109),
    [sym_dictionary_comprehension] = STATE(109),
    [sym_set] = STATE(109),
    [sym_set_comprehension] = STATE(109),
    [sym_parenthesized_expression] = STATE(109),
    [sym_tuple] = STATE(109),
    [sym_generator_expression] = STATE(109),
    [sym_conditional_expression] = STATE(601),
    [sym_concatenated_string] = STATE(109),
    [sym_string] = STATE(117),
    [sym_await] = STATE(601),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_import] = ACTIONS(9),
    [anon_sym_from] = ACTIONS(11),
    [anon_sym_LPAREN] = ACTIONS(13),
    [anon_sym_print] = ACTIONS(15),
    [anon_sym_assert] = ACTIONS(17),
    [anon_sym_return] = ACTIONS(19),
    [anon_sym_del] = ACTIONS(21),
    [anon_sym_raise] = ACTIONS(23),
    [anon_sym_pass] = ACTIONS(25),
    [anon_sym_break] = ACTIONS(27),
    [anon_sym_continue] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(45),
    [anon_sym_nonlocal] = ACTIONS(47),
    [anon_sym_exec] = ACTIONS(49),
    [anon_sym_not] = ACTIONS(55),
    [anon_sym_PLUS] = ACTIONS(57),
    [anon_sym_DASH] = ACTIONS(57),
    [anon_sym_TILDE] = ACTIONS(57),
    [anon_sym_lambda] = ACTIONS(59),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [sym_ellipsis] = ACTIONS(65),
    [anon_sym_LBRACE] = ACTIONS(67),
    [sym_integer] = ACTIONS(69),
    [sym_float] = ACTIONS(65),
    [sym_true] = ACTIONS(69),
    [sym_false] = ACTIONS(69),
    [sym_none] = ACTIONS(69),
    [anon_sym_await] = ACTIONS(71),
    [sym_comment] = ACTIONS(3),
    [sym__indent] = ACTIONS(297),
    [sym__string_start] = ACTIONS(73),
  },
  [78] = {
    [sym__simple_statements] = STATE(380),
    [sym_import_statement] = STATE(831),
    [sym_future_import_statement] = STATE(831),
    [sym_import_from_statement] = STATE(831),
    [sym_print_statement] = STATE(831),
    [sym_assert_statement] = STATE(831),
    [sym_expression_statement] = STATE(831),
    [sym_named_expression] = STATE(601),
    [sym_return_statement] = STATE(831),
    [sym_delete_statement] = STATE(831),
    [sym_raise_statement] = STATE(831),
    [sym_pass_statement] = STATE(831),
    [sym_break_statement] = STATE(831),
    [sym_continue_statement] = STATE(831),
    [sym_global_statement] = STATE(831),
    [sym_nonlocal_statement] = STATE(831),
    [sym_exec_statement] = STATE(831),
    [sym_expression_list] = STATE(618),
    [sym__expression] = STATE(601),
    [sym__primary_expression] = STATE(109),
    [sym_not_operator] = STATE(601),
    [sym_boolean_operator] = STATE(601),
    [sym_binary_operator] = STATE(109),
    [sym_unary_operator] = STATE(109),
    [sym_comparison_operator] = STATE(601),
    [sym_lambda] = STATE(601),
    [sym_assignment] = STATE(936),
    [sym_augmented_assignment] = STATE(936),
    [sym_yield] = STATE(936),
    [sym_attribute] = STATE(109),
    [sym_subscript] = STATE(109),
    [sym_call] = STATE(109),
    [sym_list] = STATE(109),
    [sym_list_comprehension] = STATE(109),
    [sym_dictionary] = STATE(109),
    [sym_dictionary_comprehension] = STATE(109),
    [sym_set] = STATE(109),
    [sym_set_comprehension] = STATE(109),
    [sym_parenthesized_expression] = STATE(109),
    [sym_tuple] = STATE(109),
    [sym_generator_expression] = STATE(109),
    [sym_conditional_expression] = STATE(601),
    [sym_concatenated_string] = STATE(109),
    [sym_string] = STATE(117),
    [sym_await] = STATE(601),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_import] = ACTIONS(9),
    [anon_sym_from] = ACTIONS(11),
    [anon_sym_LPAREN] = ACTIONS(13),
    [anon_sym_print] = ACTIONS(15),
    [anon_sym_assert] = ACTIONS(17),
    [anon_sym_return] = ACTIONS(19),
    [anon_sym_del] = ACTIONS(21),
    [anon_sym_raise] = ACTIONS(23),
    [anon_sym_pass] = ACTIONS(25),
    [anon_sym_break] = ACTIONS(27),
    [anon_sym_continue] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(45),
    [anon_sym_nonlocal] = ACTIONS(47),
    [anon_sym_exec] = ACTIONS(49),
    [anon_sym_not] = ACTIONS(55),
    [anon_sym_PLUS] = ACTIONS(57),
    [anon_sym_DASH] = ACTIONS(57),
    [anon_sym_TILDE] = ACTIONS(57),
    [anon_sym_lambda] = ACTIONS(59),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [sym_ellipsis] = ACTIONS(65),
    [anon_sym_LBRACE] = ACTIONS(67),
    [sym_integer] = ACTIONS(69),
    [sym_float] = ACTIONS(65),
    [sym_true] = ACTIONS(69),
    [sym_false] = ACTIONS(69),
    [sym_none] = ACTIONS(69),
    [anon_sym_await] = ACTIONS(71),
    [sym_comment] = ACTIONS(3),
    [sym__indent] = ACTIONS(299),
    [sym__string_start] = ACTIONS(73),
  },
  [79] = {
    [sym__simple_statements] = STATE(392),
    [sym_import_statement] = STATE(861),
    [sym_future_import_statement] = STATE(861),
    [sym_import_from_statement] = STATE(861),
    [sym_print_statement] = STATE(861),
    [sym_assert_statement] = STATE(861),
    [sym_expression_statement] = STATE(861),
    [sym_named_expression] = STATE(601),
    [sym_return_statement] = STATE(861),
    [sym_delete_statement] = STATE(861),
    [sym_raise_statement] = STATE(861),
    [sym_pass_statement] = STATE(861),
    [sym_break_statement] = STATE(861),
    [sym_continue_statement] = STATE(861),
    [sym_global_statement] = STATE(861),
    [sym_nonlocal_statement] = STATE(861),
    [sym_exec_statement] = STATE(861),
    [sym_expression_list] = STATE(618),
    [sym__expression] = STATE(601),
    [sym__primary_expression] = STATE(109),
    [sym_not_operator] = STATE(601),
    [sym_boolean_operator] = STATE(601),
    [sym_binary_operator] = STATE(109),
    [sym_unary_operator] = STATE(109),
    [sym_comparison_operator] = STATE(601),
    [sym_lambda] = STATE(601),
    [sym_assignment] = STATE(936),
    [sym_augmented_assignment] = STATE(936),
    [sym_yield] = STATE(936),
    [sym_attribute] = STATE(109),
    [sym_subscript] = STATE(109),
    [sym_call] = STATE(109),
    [sym_list] = STATE(109),
    [sym_list_comprehension] = STATE(109),
    [sym_dictionary] = STATE(109),
    [sym_dictionary_comprehension] = STATE(109),
    [sym_set] = STATE(109),
    [sym_set_comprehension] = STATE(109),
    [sym_parenthesized_expression] = STATE(109),
    [sym_tuple] = STATE(109),
    [sym_generator_expression] = STATE(109),
    [sym_conditional_expression] = STATE(601),
    [sym_concatenated_string] = STATE(109),
    [sym_string] = STATE(117),
    [sym_await] = STATE(601),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_import] = ACTIONS(9),
    [anon_sym_from] = ACTIONS(11),
    [anon_sym_LPAREN] = ACTIONS(13),
    [anon_sym_print] = ACTIONS(15),
    [anon_sym_assert] = ACTIONS(17),
    [anon_sym_return] = ACTIONS(19),
    [anon_sym_del] = ACTIONS(21),
    [anon_sym_raise] = ACTIONS(23),
    [anon_sym_pass] = ACTIONS(25),
    [anon_sym_break] = ACTIONS(27),
    [anon_sym_continue] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(45),
    [anon_sym_nonlocal] = ACTIONS(47),
    [anon_sym_exec] = ACTIONS(49),
    [anon_sym_not] = ACTIONS(55),
    [anon_sym_PLUS] = ACTIONS(57),
    [anon_sym_DASH] = ACTIONS(57),
    [anon_sym_TILDE] = ACTIONS(57),
    [anon_sym_lambda] = ACTIONS(59),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [sym_ellipsis] = ACTIONS(65),
    [anon_sym_LBRACE] = ACTIONS(67),
    [sym_integer] = ACTIONS(69),
    [sym_float] = ACTIONS(65),
    [sym_true] = ACTIONS(69),
    [sym_false] = ACTIONS(69),
    [sym_none] = ACTIONS(69),
    [anon_sym_await] = ACTIONS(71),
    [sym_comment] = ACTIONS(3),
    [sym__indent] = ACTIONS(301),
    [sym__string_start] = ACTIONS(73),
  },
  [80] = {
    [sym__simple_statements] = STATE(448),
    [sym_import_statement] = STATE(861),
    [sym_future_import_statement] = STATE(861),
    [sym_import_from_statement] = STATE(861),
    [sym_print_statement] = STATE(861),
    [sym_assert_statement] = STATE(861),
    [sym_expression_statement] = STATE(861),
    [sym_named_expression] = STATE(601),
    [sym_return_statement] = STATE(861),
    [sym_delete_statement] = STATE(861),
    [sym_raise_statement] = STATE(861),
    [sym_pass_statement] = STATE(861),
    [sym_break_statement] = STATE(861),
    [sym_continue_statement] = STATE(861),
    [sym_global_statement] = STATE(861),
    [sym_nonlocal_statement] = STATE(861),
    [sym_exec_statement] = STATE(861),
    [sym_expression_list] = STATE(618),
    [sym__expression] = STATE(601),
    [sym__primary_expression] = STATE(109),
    [sym_not_operator] = STATE(601),
    [sym_boolean_operator] = STATE(601),
    [sym_binary_operator] = STATE(109),
    [sym_unary_operator] = STATE(109),
    [sym_comparison_operator] = STATE(601),
    [sym_lambda] = STATE(601),
    [sym_assignment] = STATE(936),
    [sym_augmented_assignment] = STATE(936),
    [sym_yield] = STATE(936),
    [sym_attribute] = STATE(109),
    [sym_subscript] = STATE(109),
    [sym_call] = STATE(109),
    [sym_list] = STATE(109),
    [sym_list_comprehension] = STATE(109),
    [sym_dictionary] = STATE(109),
    [sym_dictionary_comprehension] = STATE(109),
    [sym_set] = STATE(109),
    [sym_set_comprehension] = STATE(109),
    [sym_parenthesized_expression] = STATE(109),
    [sym_tuple] = STATE(109),
    [sym_generator_expression] = STATE(109),
    [sym_conditional_expression] = STATE(601),
    [sym_concatenated_string] = STATE(109),
    [sym_string] = STATE(117),
    [sym_await] = STATE(601),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_import] = ACTIONS(9),
    [anon_sym_from] = ACTIONS(11),
    [anon_sym_LPAREN] = ACTIONS(13),
    [anon_sym_print] = ACTIONS(15),
    [anon_sym_assert] = ACTIONS(17),
    [anon_sym_return] = ACTIONS(19),
    [anon_sym_del] = ACTIONS(21),
    [anon_sym_raise] = ACTIONS(23),
    [anon_sym_pass] = ACTIONS(25),
    [anon_sym_break] = ACTIONS(27),
    [anon_sym_continue] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(45),
    [anon_sym_nonlocal] = ACTIONS(47),
    [anon_sym_exec] = ACTIONS(49),
    [anon_sym_not] = ACTIONS(55),
    [anon_sym_PLUS] = ACTIONS(57),
    [anon_sym_DASH] = ACTIONS(57),
    [anon_sym_TILDE] = ACTIONS(57),
    [anon_sym_lambda] = ACTIONS(59),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [sym_ellipsis] = ACTIONS(65),
    [anon_sym_LBRACE] = ACTIONS(67),
    [sym_integer] = ACTIONS(69),
    [sym_float] = ACTIONS(65),
    [sym_true] = ACTIONS(69),
    [sym_false] = ACTIONS(69),
    [sym_none] = ACTIONS(69),
    [anon_sym_await] = ACTIONS(71),
    [sym_comment] = ACTIONS(3),
    [sym__indent] = ACTIONS(303),
    [sym__string_start] = ACTIONS(73),
  },
  [81] = {
    [sym__simple_statements] = STATE(368),
    [sym_import_statement] = STATE(861),
    [sym_future_import_statement] = STATE(861),
    [sym_import_from_statement] = STATE(861),
    [sym_print_statement] = STATE(861),
    [sym_assert_statement] = STATE(861),
    [sym_expression_statement] = STATE(861),
    [sym_named_expression] = STATE(601),
    [sym_return_statement] = STATE(861),
    [sym_delete_statement] = STATE(861),
    [sym_raise_statement] = STATE(861),
    [sym_pass_statement] = STATE(861),
    [sym_break_statement] = STATE(861),
    [sym_continue_statement] = STATE(861),
    [sym_global_statement] = STATE(861),
    [sym_nonlocal_statement] = STATE(861),
    [sym_exec_statement] = STATE(861),
    [sym_expression_list] = STATE(618),
    [sym__expression] = STATE(601),
    [sym__primary_expression] = STATE(109),
    [sym_not_operator] = STATE(601),
    [sym_boolean_operator] = STATE(601),
    [sym_binary_operator] = STATE(109),
    [sym_unary_operator] = STATE(109),
    [sym_comparison_operator] = STATE(601),
    [sym_lambda] = STATE(601),
    [sym_assignment] = STATE(936),
    [sym_augmented_assignment] = STATE(936),
    [sym_yield] = STATE(936),
    [sym_attribute] = STATE(109),
    [sym_subscript] = STATE(109),
    [sym_call] = STATE(109),
    [sym_list] = STATE(109),
    [sym_list_comprehension] = STATE(109),
    [sym_dictionary] = STATE(109),
    [sym_dictionary_comprehension] = STATE(109),
    [sym_set] = STATE(109),
    [sym_set_comprehension] = STATE(109),
    [sym_parenthesized_expression] = STATE(109),
    [sym_tuple] = STATE(109),
    [sym_generator_expression] = STATE(109),
    [sym_conditional_expression] = STATE(601),
    [sym_concatenated_string] = STATE(109),
    [sym_string] = STATE(117),
    [sym_await] = STATE(601),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_import] = ACTIONS(9),
    [anon_sym_from] = ACTIONS(11),
    [anon_sym_LPAREN] = ACTIONS(13),
    [anon_sym_print] = ACTIONS(15),
    [anon_sym_assert] = ACTIONS(17),
    [anon_sym_return] = ACTIONS(19),
    [anon_sym_del] = ACTIONS(21),
    [anon_sym_raise] = ACTIONS(23),
    [anon_sym_pass] = ACTIONS(25),
    [anon_sym_break] = ACTIONS(27),
    [anon_sym_continue] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(45),
    [anon_sym_nonlocal] = ACTIONS(47),
    [anon_sym_exec] = ACTIONS(49),
    [anon_sym_not] = ACTIONS(55),
    [anon_sym_PLUS] = ACTIONS(57),
    [anon_sym_DASH] = ACTIONS(57),
    [anon_sym_TILDE] = ACTIONS(57),
    [anon_sym_lambda] = ACTIONS(59),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [sym_ellipsis] = ACTIONS(65),
    [anon_sym_LBRACE] = ACTIONS(67),
    [sym_integer] = ACTIONS(69),
    [sym_float] = ACTIONS(65),
    [sym_true] = ACTIONS(69),
    [sym_false] = ACTIONS(69),
    [sym_none] = ACTIONS(69),
    [anon_sym_await] = ACTIONS(71),
    [sym_comment] = ACTIONS(3),
    [sym__indent] = ACTIONS(305),
    [sym__string_start] = ACTIONS(73),
  },
  [82] = {
    [sym__simple_statements] = STATE(752),
    [sym_import_statement] = STATE(828),
    [sym_future_import_statement] = STATE(828),
    [sym_import_from_statement] = STATE(828),
    [sym_print_statement] = STATE(828),
    [sym_assert_statement] = STATE(828),
    [sym_expression_statement] = STATE(828),
    [sym_named_expression] = STATE(601),
    [sym_return_statement] = STATE(828),
    [sym_delete_statement] = STATE(828),
    [sym_raise_statement] = STATE(828),
    [sym_pass_statement] = STATE(828),
    [sym_break_statement] = STATE(828),
    [sym_continue_statement] = STATE(828),
    [sym_global_statement] = STATE(828),
    [sym_nonlocal_statement] = STATE(828),
    [sym_exec_statement] = STATE(828),
    [sym_expression_list] = STATE(618),
    [sym__expression] = STATE(601),
    [sym__primary_expression] = STATE(109),
    [sym_not_operator] = STATE(601),
    [sym_boolean_operator] = STATE(601),
    [sym_binary_operator] = STATE(109),
    [sym_unary_operator] = STATE(109),
    [sym_comparison_operator] = STATE(601),
    [sym_lambda] = STATE(601),
    [sym_assignment] = STATE(936),
    [sym_augmented_assignment] = STATE(936),
    [sym_yield] = STATE(936),
    [sym_attribute] = STATE(109),
    [sym_subscript] = STATE(109),
    [sym_call] = STATE(109),
    [sym_list] = STATE(109),
    [sym_list_comprehension] = STATE(109),
    [sym_dictionary] = STATE(109),
    [sym_dictionary_comprehension] = STATE(109),
    [sym_set] = STATE(109),
    [sym_set_comprehension] = STATE(109),
    [sym_parenthesized_expression] = STATE(109),
    [sym_tuple] = STATE(109),
    [sym_generator_expression] = STATE(109),
    [sym_conditional_expression] = STATE(601),
    [sym_concatenated_string] = STATE(109),
    [sym_string] = STATE(117),
    [sym_await] = STATE(601),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_import] = ACTIONS(9),
    [anon_sym_from] = ACTIONS(11),
    [anon_sym_LPAREN] = ACTIONS(13),
    [anon_sym_print] = ACTIONS(15),
    [anon_sym_assert] = ACTIONS(17),
    [anon_sym_return] = ACTIONS(19),
    [anon_sym_del] = ACTIONS(21),
    [anon_sym_raise] = ACTIONS(23),
    [anon_sym_pass] = ACTIONS(25),
    [anon_sym_break] = ACTIONS(27),
    [anon_sym_continue] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(45),
    [anon_sym_nonlocal] = ACTIONS(47),
    [anon_sym_exec] = ACTIONS(49),
    [anon_sym_not] = ACTIONS(55),
    [anon_sym_PLUS] = ACTIONS(57),
    [anon_sym_DASH] = ACTIONS(57),
    [anon_sym_TILDE] = ACTIONS(57),
    [anon_sym_lambda] = ACTIONS(59),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [sym_ellipsis] = ACTIONS(65),
    [anon_sym_LBRACE] = ACTIONS(67),
    [sym_integer] = ACTIONS(69),
    [sym_float] = ACTIONS(65),
    [sym_true] = ACTIONS(69),
    [sym_false] = ACTIONS(69),
    [sym_none] = ACTIONS(69),
    [anon_sym_await] = ACTIONS(71),
    [sym_comment] = ACTIONS(3),
    [sym__indent] = ACTIONS(307),
    [sym__string_start] = ACTIONS(73),
  },
  [83] = {
    [sym__simple_statements] = STATE(439),
    [sym_import_statement] = STATE(861),
    [sym_future_import_statement] = STATE(861),
    [sym_import_from_statement] = STATE(861),
    [sym_print_statement] = STATE(861),
    [sym_assert_statement] = STATE(861),
    [sym_expression_statement] = STATE(861),
    [sym_named_expression] = STATE(601),
    [sym_return_statement] = STATE(861),
    [sym_delete_statement] = STATE(861),
    [sym_raise_statement] = STATE(861),
    [sym_pass_statement] = STATE(861),
    [sym_break_statement] = STATE(861),
    [sym_continue_statement] = STATE(861),
    [sym_global_statement] = STATE(861),
    [sym_nonlocal_statement] = STATE(861),
    [sym_exec_statement] = STATE(861),
    [sym_expression_list] = STATE(618),
    [sym__expression] = STATE(601),
    [sym__primary_expression] = STATE(109),
    [sym_not_operator] = STATE(601),
    [sym_boolean_operator] = STATE(601),
    [sym_binary_operator] = STATE(109),
    [sym_unary_operator] = STATE(109),
    [sym_comparison_operator] = STATE(601),
    [sym_lambda] = STATE(601),
    [sym_assignment] = STATE(936),
    [sym_augmented_assignment] = STATE(936),
    [sym_yield] = STATE(936),
    [sym_attribute] = STATE(109),
    [sym_subscript] = STATE(109),
    [sym_call] = STATE(109),
    [sym_list] = STATE(109),
    [sym_list_comprehension] = STATE(109),
    [sym_dictionary] = STATE(109),
    [sym_dictionary_comprehension] = STATE(109),
    [sym_set] = STATE(109),
    [sym_set_comprehension] = STATE(109),
    [sym_parenthesized_expression] = STATE(109),
    [sym_tuple] = STATE(109),
    [sym_generator_expression] = STATE(109),
    [sym_conditional_expression] = STATE(601),
    [sym_concatenated_string] = STATE(109),
    [sym_string] = STATE(117),
    [sym_await] = STATE(601),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_import] = ACTIONS(9),
    [anon_sym_from] = ACTIONS(11),
    [anon_sym_LPAREN] = ACTIONS(13),
    [anon_sym_print] = ACTIONS(15),
    [anon_sym_assert] = ACTIONS(17),
    [anon_sym_return] = ACTIONS(19),
    [anon_sym_del] = ACTIONS(21),
    [anon_sym_raise] = ACTIONS(23),
    [anon_sym_pass] = ACTIONS(25),
    [anon_sym_break] = ACTIONS(27),
    [anon_sym_continue] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(45),
    [anon_sym_nonlocal] = ACTIONS(47),
    [anon_sym_exec] = ACTIONS(49),
    [anon_sym_not] = ACTIONS(55),
    [anon_sym_PLUS] = ACTIONS(57),
    [anon_sym_DASH] = ACTIONS(57),
    [anon_sym_TILDE] = ACTIONS(57),
    [anon_sym_lambda] = ACTIONS(59),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [sym_ellipsis] = ACTIONS(65),
    [anon_sym_LBRACE] = ACTIONS(67),
    [sym_integer] = ACTIONS(69),
    [sym_float] = ACTIONS(65),
    [sym_true] = ACTIONS(69),
    [sym_false] = ACTIONS(69),
    [sym_none] = ACTIONS(69),
    [anon_sym_await] = ACTIONS(71),
    [sym_comment] = ACTIONS(3),
    [sym__indent] = ACTIONS(309),
    [sym__string_start] = ACTIONS(73),
  },
  [84] = {
    [sym__simple_statements] = STATE(294),
    [sym_import_statement] = STATE(861),
    [sym_future_import_statement] = STATE(861),
    [sym_import_from_statement] = STATE(861),
    [sym_print_statement] = STATE(861),
    [sym_assert_statement] = STATE(861),
    [sym_expression_statement] = STATE(861),
    [sym_named_expression] = STATE(601),
    [sym_return_statement] = STATE(861),
    [sym_delete_statement] = STATE(861),
    [sym_raise_statement] = STATE(861),
    [sym_pass_statement] = STATE(861),
    [sym_break_statement] = STATE(861),
    [sym_continue_statement] = STATE(861),
    [sym_global_statement] = STATE(861),
    [sym_nonlocal_statement] = STATE(861),
    [sym_exec_statement] = STATE(861),
    [sym_expression_list] = STATE(618),
    [sym__expression] = STATE(601),
    [sym__primary_expression] = STATE(109),
    [sym_not_operator] = STATE(601),
    [sym_boolean_operator] = STATE(601),
    [sym_binary_operator] = STATE(109),
    [sym_unary_operator] = STATE(109),
    [sym_comparison_operator] = STATE(601),
    [sym_lambda] = STATE(601),
    [sym_assignment] = STATE(936),
    [sym_augmented_assignment] = STATE(936),
    [sym_yield] = STATE(936),
    [sym_attribute] = STATE(109),
    [sym_subscript] = STATE(109),
    [sym_call] = STATE(109),
    [sym_list] = STATE(109),
    [sym_list_comprehension] = STATE(109),
    [sym_dictionary] = STATE(109),
    [sym_dictionary_comprehension] = STATE(109),
    [sym_set] = STATE(109),
    [sym_set_comprehension] = STATE(109),
    [sym_parenthesized_expression] = STATE(109),
    [sym_tuple] = STATE(109),
    [sym_generator_expression] = STATE(109),
    [sym_conditional_expression] = STATE(601),
    [sym_concatenated_string] = STATE(109),
    [sym_string] = STATE(117),
    [sym_await] = STATE(601),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_import] = ACTIONS(9),
    [anon_sym_from] = ACTIONS(11),
    [anon_sym_LPAREN] = ACTIONS(13),
    [anon_sym_print] = ACTIONS(15),
    [anon_sym_assert] = ACTIONS(17),
    [anon_sym_return] = ACTIONS(19),
    [anon_sym_del] = ACTIONS(21),
    [anon_sym_raise] = ACTIONS(23),
    [anon_sym_pass] = ACTIONS(25),
    [anon_sym_break] = ACTIONS(27),
    [anon_sym_continue] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(45),
    [anon_sym_nonlocal] = ACTIONS(47),
    [anon_sym_exec] = ACTIONS(49),
    [anon_sym_not] = ACTIONS(55),
    [anon_sym_PLUS] = ACTIONS(57),
    [anon_sym_DASH] = ACTIONS(57),
    [anon_sym_TILDE] = ACTIONS(57),
    [anon_sym_lambda] = ACTIONS(59),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [sym_ellipsis] = ACTIONS(65),
    [anon_sym_LBRACE] = ACTIONS(67),
    [sym_integer] = ACTIONS(69),
    [sym_float] = ACTIONS(65),
    [sym_true] = ACTIONS(69),
    [sym_false] = ACTIONS(69),
    [sym_none] = ACTIONS(69),
    [anon_sym_await] = ACTIONS(71),
    [sym_comment] = ACTIONS(3),
    [sym__indent] = ACTIONS(311),
    [sym__string_start] = ACTIONS(73),
  },
  [85] = {
    [sym__simple_statements] = STATE(375),
    [sym_import_statement] = STATE(861),
    [sym_future_import_statement] = STATE(861),
    [sym_import_from_statement] = STATE(861),
    [sym_print_statement] = STATE(861),
    [sym_assert_statement] = STATE(861),
    [sym_expression_statement] = STATE(861),
    [sym_named_expression] = STATE(601),
    [sym_return_statement] = STATE(861),
    [sym_delete_statement] = STATE(861),
    [sym_raise_statement] = STATE(861),
    [sym_pass_statement] = STATE(861),
    [sym_break_statement] = STATE(861),
    [sym_continue_statement] = STATE(861),
    [sym_global_statement] = STATE(861),
    [sym_nonlocal_statement] = STATE(861),
    [sym_exec_statement] = STATE(861),
    [sym_expression_list] = STATE(618),
    [sym__expression] = STATE(601),
    [sym__primary_expression] = STATE(109),
    [sym_not_operator] = STATE(601),
    [sym_boolean_operator] = STATE(601),
    [sym_binary_operator] = STATE(109),
    [sym_unary_operator] = STATE(109),
    [sym_comparison_operator] = STATE(601),
    [sym_lambda] = STATE(601),
    [sym_assignment] = STATE(936),
    [sym_augmented_assignment] = STATE(936),
    [sym_yield] = STATE(936),
    [sym_attribute] = STATE(109),
    [sym_subscript] = STATE(109),
    [sym_call] = STATE(109),
    [sym_list] = STATE(109),
    [sym_list_comprehension] = STATE(109),
    [sym_dictionary] = STATE(109),
    [sym_dictionary_comprehension] = STATE(109),
    [sym_set] = STATE(109),
    [sym_set_comprehension] = STATE(109),
    [sym_parenthesized_expression] = STATE(109),
    [sym_tuple] = STATE(109),
    [sym_generator_expression] = STATE(109),
    [sym_conditional_expression] = STATE(601),
    [sym_concatenated_string] = STATE(109),
    [sym_string] = STATE(117),
    [sym_await] = STATE(601),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_import] = ACTIONS(9),
    [anon_sym_from] = ACTIONS(11),
    [anon_sym_LPAREN] = ACTIONS(13),
    [anon_sym_print] = ACTIONS(15),
    [anon_sym_assert] = ACTIONS(17),
    [anon_sym_return] = ACTIONS(19),
    [anon_sym_del] = ACTIONS(21),
    [anon_sym_raise] = ACTIONS(23),
    [anon_sym_pass] = ACTIONS(25),
    [anon_sym_break] = ACTIONS(27),
    [anon_sym_continue] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(45),
    [anon_sym_nonlocal] = ACTIONS(47),
    [anon_sym_exec] = ACTIONS(49),
    [anon_sym_not] = ACTIONS(55),
    [anon_sym_PLUS] = ACTIONS(57),
    [anon_sym_DASH] = ACTIONS(57),
    [anon_sym_TILDE] = ACTIONS(57),
    [anon_sym_lambda] = ACTIONS(59),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [sym_ellipsis] = ACTIONS(65),
    [anon_sym_LBRACE] = ACTIONS(67),
    [sym_integer] = ACTIONS(69),
    [sym_float] = ACTIONS(65),
    [sym_true] = ACTIONS(69),
    [sym_false] = ACTIONS(69),
    [sym_none] = ACTIONS(69),
    [anon_sym_await] = ACTIONS(71),
    [sym_comment] = ACTIONS(3),
    [sym__indent] = ACTIONS(313),
    [sym__string_start] = ACTIONS(73),
  },
  [86] = {
    [sym__simple_statements] = STATE(379),
    [sym_import_statement] = STATE(861),
    [sym_future_import_statement] = STATE(861),
    [sym_import_from_statement] = STATE(861),
    [sym_print_statement] = STATE(861),
    [sym_assert_statement] = STATE(861),
    [sym_expression_statement] = STATE(861),
    [sym_named_expression] = STATE(601),
    [sym_return_statement] = STATE(861),
    [sym_delete_statement] = STATE(861),
    [sym_raise_statement] = STATE(861),
    [sym_pass_statement] = STATE(861),
    [sym_break_statement] = STATE(861),
    [sym_continue_statement] = STATE(861),
    [sym_global_statement] = STATE(861),
    [sym_nonlocal_statement] = STATE(861),
    [sym_exec_statement] = STATE(861),
    [sym_expression_list] = STATE(618),
    [sym__expression] = STATE(601),
    [sym__primary_expression] = STATE(109),
    [sym_not_operator] = STATE(601),
    [sym_boolean_operator] = STATE(601),
    [sym_binary_operator] = STATE(109),
    [sym_unary_operator] = STATE(109),
    [sym_comparison_operator] = STATE(601),
    [sym_lambda] = STATE(601),
    [sym_assignment] = STATE(936),
    [sym_augmented_assignment] = STATE(936),
    [sym_yield] = STATE(936),
    [sym_attribute] = STATE(109),
    [sym_subscript] = STATE(109),
    [sym_call] = STATE(109),
    [sym_list] = STATE(109),
    [sym_list_comprehension] = STATE(109),
    [sym_dictionary] = STATE(109),
    [sym_dictionary_comprehension] = STATE(109),
    [sym_set] = STATE(109),
    [sym_set_comprehension] = STATE(109),
    [sym_parenthesized_expression] = STATE(109),
    [sym_tuple] = STATE(109),
    [sym_generator_expression] = STATE(109),
    [sym_conditional_expression] = STATE(601),
    [sym_concatenated_string] = STATE(109),
    [sym_string] = STATE(117),
    [sym_await] = STATE(601),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_import] = ACTIONS(9),
    [anon_sym_from] = ACTIONS(11),
    [anon_sym_LPAREN] = ACTIONS(13),
    [anon_sym_print] = ACTIONS(15),
    [anon_sym_assert] = ACTIONS(17),
    [anon_sym_return] = ACTIONS(19),
    [anon_sym_del] = ACTIONS(21),
    [anon_sym_raise] = ACTIONS(23),
    [anon_sym_pass] = ACTIONS(25),
    [anon_sym_break] = ACTIONS(27),
    [anon_sym_continue] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(45),
    [anon_sym_nonlocal] = ACTIONS(47),
    [anon_sym_exec] = ACTIONS(49),
    [anon_sym_not] = ACTIONS(55),
    [anon_sym_PLUS] = ACTIONS(57),
    [anon_sym_DASH] = ACTIONS(57),
    [anon_sym_TILDE] = ACTIONS(57),
    [anon_sym_lambda] = ACTIONS(59),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [sym_ellipsis] = ACTIONS(65),
    [anon_sym_LBRACE] = ACTIONS(67),
    [sym_integer] = ACTIONS(69),
    [sym_float] = ACTIONS(65),
    [sym_true] = ACTIONS(69),
    [sym_false] = ACTIONS(69),
    [sym_none] = ACTIONS(69),
    [anon_sym_await] = ACTIONS(71),
    [sym_comment] = ACTIONS(3),
    [sym__indent] = ACTIONS(315),
    [sym__string_start] = ACTIONS(73),
  },
  [87] = {
    [sym__simple_statements] = STATE(298),
    [sym_import_statement] = STATE(861),
    [sym_future_import_statement] = STATE(861),
    [sym_import_from_statement] = STATE(861),
    [sym_print_statement] = STATE(861),
    [sym_assert_statement] = STATE(861),
    [sym_expression_statement] = STATE(861),
    [sym_named_expression] = STATE(601),
    [sym_return_statement] = STATE(861),
    [sym_delete_statement] = STATE(861),
    [sym_raise_statement] = STATE(861),
    [sym_pass_statement] = STATE(861),
    [sym_break_statement] = STATE(861),
    [sym_continue_statement] = STATE(861),
    [sym_global_statement] = STATE(861),
    [sym_nonlocal_statement] = STATE(861),
    [sym_exec_statement] = STATE(861),
    [sym_expression_list] = STATE(618),
    [sym__expression] = STATE(601),
    [sym__primary_expression] = STATE(109),
    [sym_not_operator] = STATE(601),
    [sym_boolean_operator] = STATE(601),
    [sym_binary_operator] = STATE(109),
    [sym_unary_operator] = STATE(109),
    [sym_comparison_operator] = STATE(601),
    [sym_lambda] = STATE(601),
    [sym_assignment] = STATE(936),
    [sym_augmented_assignment] = STATE(936),
    [sym_yield] = STATE(936),
    [sym_attribute] = STATE(109),
    [sym_subscript] = STATE(109),
    [sym_call] = STATE(109),
    [sym_list] = STATE(109),
    [sym_list_comprehension] = STATE(109),
    [sym_dictionary] = STATE(109),
    [sym_dictionary_comprehension] = STATE(109),
    [sym_set] = STATE(109),
    [sym_set_comprehension] = STATE(109),
    [sym_parenthesized_expression] = STATE(109),
    [sym_tuple] = STATE(109),
    [sym_generator_expression] = STATE(109),
    [sym_conditional_expression] = STATE(601),
    [sym_concatenated_string] = STATE(109),
    [sym_string] = STATE(117),
    [sym_await] = STATE(601),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_import] = ACTIONS(9),
    [anon_sym_from] = ACTIONS(11),
    [anon_sym_LPAREN] = ACTIONS(13),
    [anon_sym_print] = ACTIONS(15),
    [anon_sym_assert] = ACTIONS(17),
    [anon_sym_return] = ACTIONS(19),
    [anon_sym_del] = ACTIONS(21),
    [anon_sym_raise] = ACTIONS(23),
    [anon_sym_pass] = ACTIONS(25),
    [anon_sym_break] = ACTIONS(27),
    [anon_sym_continue] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(45),
    [anon_sym_nonlocal] = ACTIONS(47),
    [anon_sym_exec] = ACTIONS(49),
    [anon_sym_not] = ACTIONS(55),
    [anon_sym_PLUS] = ACTIONS(57),
    [anon_sym_DASH] = ACTIONS(57),
    [anon_sym_TILDE] = ACTIONS(57),
    [anon_sym_lambda] = ACTIONS(59),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [sym_ellipsis] = ACTIONS(65),
    [anon_sym_LBRACE] = ACTIONS(67),
    [sym_integer] = ACTIONS(69),
    [sym_float] = ACTIONS(65),
    [sym_true] = ACTIONS(69),
    [sym_false] = ACTIONS(69),
    [sym_none] = ACTIONS(69),
    [anon_sym_await] = ACTIONS(71),
    [sym_comment] = ACTIONS(3),
    [sym__indent] = ACTIONS(317),
    [sym__string_start] = ACTIONS(73),
  },
  [88] = {
    [sym__simple_statements] = STATE(389),
    [sym_import_statement] = STATE(861),
    [sym_future_import_statement] = STATE(861),
    [sym_import_from_statement] = STATE(861),
    [sym_print_statement] = STATE(861),
    [sym_assert_statement] = STATE(861),
    [sym_expression_statement] = STATE(861),
    [sym_named_expression] = STATE(601),
    [sym_return_statement] = STATE(861),
    [sym_delete_statement] = STATE(861),
    [sym_raise_statement] = STATE(861),
    [sym_pass_statement] = STATE(861),
    [sym_break_statement] = STATE(861),
    [sym_continue_statement] = STATE(861),
    [sym_global_statement] = STATE(861),
    [sym_nonlocal_statement] = STATE(861),
    [sym_exec_statement] = STATE(861),
    [sym_expression_list] = STATE(618),
    [sym__expression] = STATE(601),
    [sym__primary_expression] = STATE(109),
    [sym_not_operator] = STATE(601),
    [sym_boolean_operator] = STATE(601),
    [sym_binary_operator] = STATE(109),
    [sym_unary_operator] = STATE(109),
    [sym_comparison_operator] = STATE(601),
    [sym_lambda] = STATE(601),
    [sym_assignment] = STATE(936),
    [sym_augmented_assignment] = STATE(936),
    [sym_yield] = STATE(936),
    [sym_attribute] = STATE(109),
    [sym_subscript] = STATE(109),
    [sym_call] = STATE(109),
    [sym_list] = STATE(109),
    [sym_list_comprehension] = STATE(109),
    [sym_dictionary] = STATE(109),
    [sym_dictionary_comprehension] = STATE(109),
    [sym_set] = STATE(109),
    [sym_set_comprehension] = STATE(109),
    [sym_parenthesized_expression] = STATE(109),
    [sym_tuple] = STATE(109),
    [sym_generator_expression] = STATE(109),
    [sym_conditional_expression] = STATE(601),
    [sym_concatenated_string] = STATE(109),
    [sym_string] = STATE(117),
    [sym_await] = STATE(601),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_import] = ACTIONS(9),
    [anon_sym_from] = ACTIONS(11),
    [anon_sym_LPAREN] = ACTIONS(13),
    [anon_sym_print] = ACTIONS(15),
    [anon_sym_assert] = ACTIONS(17),
    [anon_sym_return] = ACTIONS(19),
    [anon_sym_del] = ACTIONS(21),
    [anon_sym_raise] = ACTIONS(23),
    [anon_sym_pass] = ACTIONS(25),
    [anon_sym_break] = ACTIONS(27),
    [anon_sym_continue] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(45),
    [anon_sym_nonlocal] = ACTIONS(47),
    [anon_sym_exec] = ACTIONS(49),
    [anon_sym_not] = ACTIONS(55),
    [anon_sym_PLUS] = ACTIONS(57),
    [anon_sym_DASH] = ACTIONS(57),
    [anon_sym_TILDE] = ACTIONS(57),
    [anon_sym_lambda] = ACTIONS(59),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [sym_ellipsis] = ACTIONS(65),
    [anon_sym_LBRACE] = ACTIONS(67),
    [sym_integer] = ACTIONS(69),
    [sym_float] = ACTIONS(65),
    [sym_true] = ACTIONS(69),
    [sym_false] = ACTIONS(69),
    [sym_none] = ACTIONS(69),
    [anon_sym_await] = ACTIONS(71),
    [sym_comment] = ACTIONS(3),
    [sym__indent] = ACTIONS(319),
    [sym__string_start] = ACTIONS(73),
  },
  [89] = {
    [sym_import_statement] = STATE(943),
    [sym_future_import_statement] = STATE(943),
    [sym_import_from_statement] = STATE(943),
    [sym_print_statement] = STATE(943),
    [sym_assert_statement] = STATE(943),
    [sym_expression_statement] = STATE(943),
    [sym_named_expression] = STATE(601),
    [sym_return_statement] = STATE(943),
    [sym_delete_statement] = STATE(943),
    [sym_raise_statement] = STATE(943),
    [sym_pass_statement] = STATE(943),
    [sym_break_statement] = STATE(943),
    [sym_continue_statement] = STATE(943),
    [sym_global_statement] = STATE(943),
    [sym_nonlocal_statement] = STATE(943),
    [sym_exec_statement] = STATE(943),
    [sym_expression_list] = STATE(618),
    [sym__expression] = STATE(601),
    [sym__primary_expression] = STATE(109),
    [sym_not_operator] = STATE(601),
    [sym_boolean_operator] = STATE(601),
    [sym_binary_operator] = STATE(109),
    [sym_unary_operator] = STATE(109),
    [sym_comparison_operator] = STATE(601),
    [sym_lambda] = STATE(601),
    [sym_assignment] = STATE(936),
    [sym_augmented_assignment] = STATE(936),
    [sym_yield] = STATE(936),
    [sym_attribute] = STATE(109),
    [sym_subscript] = STATE(109),
    [sym_call] = STATE(109),
    [sym_list] = STATE(109),
    [sym_list_comprehension] = STATE(109),
    [sym_dictionary] = STATE(109),
    [sym_dictionary_comprehension] = STATE(109),
    [sym_set] = STATE(109),
    [sym_set_comprehension] = STATE(109),
    [sym_parenthesized_expression] = STATE(109),
    [sym_tuple] = STATE(109),
    [sym_generator_expression] = STATE(109),
    [sym_conditional_expression] = STATE(601),
    [sym_concatenated_string] = STATE(109),
    [sym_string] = STATE(117),
    [sym_await] = STATE(601),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_import] = ACTIONS(9),
    [anon_sym_from] = ACTIONS(11),
    [anon_sym_LPAREN] = ACTIONS(13),
    [anon_sym_print] = ACTIONS(15),
    [anon_sym_assert] = ACTIONS(17),
    [anon_sym_return] = ACTIONS(19),
    [anon_sym_del] = ACTIONS(21),
    [anon_sym_raise] = ACTIONS(23),
    [anon_sym_pass] = ACTIONS(25),
    [anon_sym_break] = ACTIONS(27),
    [anon_sym_continue] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(45),
    [anon_sym_nonlocal] = ACTIONS(47),
    [anon_sym_exec] = ACTIONS(49),
    [anon_sym_not] = ACTIONS(55),
    [anon_sym_PLUS] = ACTIONS(57),
    [anon_sym_DASH] = ACTIONS(57),
    [anon_sym_TILDE] = ACTIONS(57),
    [anon_sym_lambda] = ACTIONS(59),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [sym_ellipsis] = ACTIONS(65),
    [anon_sym_LBRACE] = ACTIONS(67),
    [sym_integer] = ACTIONS(69),
    [sym_float] = ACTIONS(65),
    [sym_true] = ACTIONS(69),
    [sym_false] = ACTIONS(69),
    [sym_none] = ACTIONS(69),
    [anon_sym_await] = ACTIONS(71),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(321),
    [sym__string_start] = ACTIONS(73),
  },
  [90] = {
    [sym_import_statement] = STATE(943),
    [sym_future_import_statement] = STATE(943),
    [sym_import_from_statement] = STATE(943),
    [sym_print_statement] = STATE(943),
    [sym_assert_statement] = STATE(943),
    [sym_expression_statement] = STATE(943),
    [sym_named_expression] = STATE(601),
    [sym_return_statement] = STATE(943),
    [sym_delete_statement] = STATE(943),
    [sym_raise_statement] = STATE(943),
    [sym_pass_statement] = STATE(943),
    [sym_break_statement] = STATE(943),
    [sym_continue_statement] = STATE(943),
    [sym_global_statement] = STATE(943),
    [sym_nonlocal_statement] = STATE(943),
    [sym_exec_statement] = STATE(943),
    [sym_expression_list] = STATE(618),
    [sym__expression] = STATE(601),
    [sym__primary_expression] = STATE(109),
    [sym_not_operator] = STATE(601),
    [sym_boolean_operator] = STATE(601),
    [sym_binary_operator] = STATE(109),
    [sym_unary_operator] = STATE(109),
    [sym_comparison_operator] = STATE(601),
    [sym_lambda] = STATE(601),
    [sym_assignment] = STATE(936),
    [sym_augmented_assignment] = STATE(936),
    [sym_yield] = STATE(936),
    [sym_attribute] = STATE(109),
    [sym_subscript] = STATE(109),
    [sym_call] = STATE(109),
    [sym_list] = STATE(109),
    [sym_list_comprehension] = STATE(109),
    [sym_dictionary] = STATE(109),
    [sym_dictionary_comprehension] = STATE(109),
    [sym_set] = STATE(109),
    [sym_set_comprehension] = STATE(109),
    [sym_parenthesized_expression] = STATE(109),
    [sym_tuple] = STATE(109),
    [sym_generator_expression] = STATE(109),
    [sym_conditional_expression] = STATE(601),
    [sym_concatenated_string] = STATE(109),
    [sym_string] = STATE(117),
    [sym_await] = STATE(601),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_import] = ACTIONS(9),
    [anon_sym_from] = ACTIONS(11),
    [anon_sym_LPAREN] = ACTIONS(13),
    [anon_sym_print] = ACTIONS(15),
    [anon_sym_assert] = ACTIONS(17),
    [anon_sym_return] = ACTIONS(19),
    [anon_sym_del] = ACTIONS(21),
    [anon_sym_raise] = ACTIONS(23),
    [anon_sym_pass] = ACTIONS(25),
    [anon_sym_break] = ACTIONS(27),
    [anon_sym_continue] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(45),
    [anon_sym_nonlocal] = ACTIONS(47),
    [anon_sym_exec] = ACTIONS(49),
    [anon_sym_not] = ACTIONS(55),
    [anon_sym_PLUS] = ACTIONS(57),
    [anon_sym_DASH] = ACTIONS(57),
    [anon_sym_TILDE] = ACTIONS(57),
    [anon_sym_lambda] = ACTIONS(59),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [sym_ellipsis] = ACTIONS(65),
    [anon_sym_LBRACE] = ACTIONS(67),
    [sym_integer] = ACTIONS(69),
    [sym_float] = ACTIONS(65),
    [sym_true] = ACTIONS(69),
    [sym_false] = ACTIONS(69),
    [sym_none] = ACTIONS(69),
    [anon_sym_await] = ACTIONS(71),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(323),
    [sym__string_start] = ACTIONS(73),
  },
  [91] = {
    [sym_import_statement] = STATE(943),
    [sym_future_import_statement] = STATE(943),
    [sym_import_from_statement] = STATE(943),
    [sym_print_statement] = STATE(943),
    [sym_assert_statement] = STATE(943),
    [sym_expression_statement] = STATE(943),
    [sym_named_expression] = STATE(601),
    [sym_return_statement] = STATE(943),
    [sym_delete_statement] = STATE(943),
    [sym_raise_statement] = STATE(943),
    [sym_pass_statement] = STATE(943),
    [sym_break_statement] = STATE(943),
    [sym_continue_statement] = STATE(943),
    [sym_global_statement] = STATE(943),
    [sym_nonlocal_statement] = STATE(943),
    [sym_exec_statement] = STATE(943),
    [sym_expression_list] = STATE(618),
    [sym__expression] = STATE(601),
    [sym__primary_expression] = STATE(109),
    [sym_not_operator] = STATE(601),
    [sym_boolean_operator] = STATE(601),
    [sym_binary_operator] = STATE(109),
    [sym_unary_operator] = STATE(109),
    [sym_comparison_operator] = STATE(601),
    [sym_lambda] = STATE(601),
    [sym_assignment] = STATE(936),
    [sym_augmented_assignment] = STATE(936),
    [sym_yield] = STATE(936),
    [sym_attribute] = STATE(109),
    [sym_subscript] = STATE(109),
    [sym_call] = STATE(109),
    [sym_list] = STATE(109),
    [sym_list_comprehension] = STATE(109),
    [sym_dictionary] = STATE(109),
    [sym_dictionary_comprehension] = STATE(109),
    [sym_set] = STATE(109),
    [sym_set_comprehension] = STATE(109),
    [sym_parenthesized_expression] = STATE(109),
    [sym_tuple] = STATE(109),
    [sym_generator_expression] = STATE(109),
    [sym_conditional_expression] = STATE(601),
    [sym_concatenated_string] = STATE(109),
    [sym_string] = STATE(117),
    [sym_await] = STATE(601),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_import] = ACTIONS(9),
    [anon_sym_from] = ACTIONS(11),
    [anon_sym_LPAREN] = ACTIONS(13),
    [anon_sym_print] = ACTIONS(15),
    [anon_sym_assert] = ACTIONS(17),
    [anon_sym_return] = ACTIONS(19),
    [anon_sym_del] = ACTIONS(21),
    [anon_sym_raise] = ACTIONS(23),
    [anon_sym_pass] = ACTIONS(25),
    [anon_sym_break] = ACTIONS(27),
    [anon_sym_continue] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(45),
    [anon_sym_nonlocal] = ACTIONS(47),
    [anon_sym_exec] = ACTIONS(49),
    [anon_sym_not] = ACTIONS(55),
    [anon_sym_PLUS] = ACTIONS(57),
    [anon_sym_DASH] = ACTIONS(57),
    [anon_sym_TILDE] = ACTIONS(57),
    [anon_sym_lambda] = ACTIONS(59),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [sym_ellipsis] = ACTIONS(65),
    [anon_sym_LBRACE] = ACTIONS(67),
    [sym_integer] = ACTIONS(69),
    [sym_float] = ACTIONS(65),
    [sym_true] = ACTIONS(69),
    [sym_false] = ACTIONS(69),
    [sym_none] = ACTIONS(69),
    [anon_sym_await] = ACTIONS(71),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(325),
    [sym__string_start] = ACTIONS(73),
  },
  [92] = {
    [sym_import_statement] = STATE(943),
    [sym_future_import_statement] = STATE(943),
    [sym_import_from_statement] = STATE(943),
    [sym_print_statement] = STATE(943),
    [sym_assert_statement] = STATE(943),
    [sym_expression_statement] = STATE(943),
    [sym_named_expression] = STATE(601),
    [sym_return_statement] = STATE(943),
    [sym_delete_statement] = STATE(943),
    [sym_raise_statement] = STATE(943),
    [sym_pass_statement] = STATE(943),
    [sym_break_statement] = STATE(943),
    [sym_continue_statement] = STATE(943),
    [sym_global_statement] = STATE(943),
    [sym_nonlocal_statement] = STATE(943),
    [sym_exec_statement] = STATE(943),
    [sym_expression_list] = STATE(618),
    [sym__expression] = STATE(601),
    [sym__primary_expression] = STATE(109),
    [sym_not_operator] = STATE(601),
    [sym_boolean_operator] = STATE(601),
    [sym_binary_operator] = STATE(109),
    [sym_unary_operator] = STATE(109),
    [sym_comparison_operator] = STATE(601),
    [sym_lambda] = STATE(601),
    [sym_assignment] = STATE(936),
    [sym_augmented_assignment] = STATE(936),
    [sym_yield] = STATE(936),
    [sym_attribute] = STATE(109),
    [sym_subscript] = STATE(109),
    [sym_call] = STATE(109),
    [sym_list] = STATE(109),
    [sym_list_comprehension] = STATE(109),
    [sym_dictionary] = STATE(109),
    [sym_dictionary_comprehension] = STATE(109),
    [sym_set] = STATE(109),
    [sym_set_comprehension] = STATE(109),
    [sym_parenthesized_expression] = STATE(109),
    [sym_tuple] = STATE(109),
    [sym_generator_expression] = STATE(109),
    [sym_conditional_expression] = STATE(601),
    [sym_concatenated_string] = STATE(109),
    [sym_string] = STATE(117),
    [sym_await] = STATE(601),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_import] = ACTIONS(9),
    [anon_sym_from] = ACTIONS(11),
    [anon_sym_LPAREN] = ACTIONS(13),
    [anon_sym_print] = ACTIONS(15),
    [anon_sym_assert] = ACTIONS(17),
    [anon_sym_return] = ACTIONS(19),
    [anon_sym_del] = ACTIONS(21),
    [anon_sym_raise] = ACTIONS(23),
    [anon_sym_pass] = ACTIONS(25),
    [anon_sym_break] = ACTIONS(27),
    [anon_sym_continue] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(45),
    [anon_sym_nonlocal] = ACTIONS(47),
    [anon_sym_exec] = ACTIONS(49),
    [anon_sym_not] = ACTIONS(55),
    [anon_sym_PLUS] = ACTIONS(57),
    [anon_sym_DASH] = ACTIONS(57),
    [anon_sym_TILDE] = ACTIONS(57),
    [anon_sym_lambda] = ACTIONS(59),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [sym_ellipsis] = ACTIONS(65),
    [anon_sym_LBRACE] = ACTIONS(67),
    [sym_integer] = ACTIONS(69),
    [sym_float] = ACTIONS(65),
    [sym_true] = ACTIONS(69),
    [sym_false] = ACTIONS(69),
    [sym_none] = ACTIONS(69),
    [anon_sym_await] = ACTIONS(71),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(327),
    [sym__string_start] = ACTIONS(73),
  },
  [93] = {
    [sym_import_statement] = STATE(943),
    [sym_future_import_statement] = STATE(943),
    [sym_import_from_statement] = STATE(943),
    [sym_print_statement] = STATE(943),
    [sym_assert_statement] = STATE(943),
    [sym_expression_statement] = STATE(943),
    [sym_named_expression] = STATE(601),
    [sym_return_statement] = STATE(943),
    [sym_delete_statement] = STATE(943),
    [sym_raise_statement] = STATE(943),
    [sym_pass_statement] = STATE(943),
    [sym_break_statement] = STATE(943),
    [sym_continue_statement] = STATE(943),
    [sym_global_statement] = STATE(943),
    [sym_nonlocal_statement] = STATE(943),
    [sym_exec_statement] = STATE(943),
    [sym_expression_list] = STATE(618),
    [sym__expression] = STATE(601),
    [sym__primary_expression] = STATE(109),
    [sym_not_operator] = STATE(601),
    [sym_boolean_operator] = STATE(601),
    [sym_binary_operator] = STATE(109),
    [sym_unary_operator] = STATE(109),
    [sym_comparison_operator] = STATE(601),
    [sym_lambda] = STATE(601),
    [sym_assignment] = STATE(936),
    [sym_augmented_assignment] = STATE(936),
    [sym_yield] = STATE(936),
    [sym_attribute] = STATE(109),
    [sym_subscript] = STATE(109),
    [sym_call] = STATE(109),
    [sym_list] = STATE(109),
    [sym_list_comprehension] = STATE(109),
    [sym_dictionary] = STATE(109),
    [sym_dictionary_comprehension] = STATE(109),
    [sym_set] = STATE(109),
    [sym_set_comprehension] = STATE(109),
    [sym_parenthesized_expression] = STATE(109),
    [sym_tuple] = STATE(109),
    [sym_generator_expression] = STATE(109),
    [sym_conditional_expression] = STATE(601),
    [sym_concatenated_string] = STATE(109),
    [sym_string] = STATE(117),
    [sym_await] = STATE(601),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_import] = ACTIONS(9),
    [anon_sym_from] = ACTIONS(11),
    [anon_sym_LPAREN] = ACTIONS(13),
    [anon_sym_print] = ACTIONS(15),
    [anon_sym_assert] = ACTIONS(17),
    [anon_sym_return] = ACTIONS(19),
    [anon_sym_del] = ACTIONS(21),
    [anon_sym_raise] = ACTIONS(23),
    [anon_sym_pass] = ACTIONS(25),
    [anon_sym_break] = ACTIONS(27),
    [anon_sym_continue] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(45),
    [anon_sym_nonlocal] = ACTIONS(47),
    [anon_sym_exec] = ACTIONS(49),
    [anon_sym_not] = ACTIONS(55),
    [anon_sym_PLUS] = ACTIONS(57),
    [anon_sym_DASH] = ACTIONS(57),
    [anon_sym_TILDE] = ACTIONS(57),
    [anon_sym_lambda] = ACTIONS(59),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [sym_ellipsis] = ACTIONS(65),
    [anon_sym_LBRACE] = ACTIONS(67),
    [sym_integer] = ACTIONS(69),
    [sym_float] = ACTIONS(65),
    [sym_true] = ACTIONS(69),
    [sym_false] = ACTIONS(69),
    [sym_none] = ACTIONS(69),
    [anon_sym_await] = ACTIONS(71),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(329),
    [sym__string_start] = ACTIONS(73),
  },
  [94] = {
    [sym_import_statement] = STATE(943),
    [sym_future_import_statement] = STATE(943),
    [sym_import_from_statement] = STATE(943),
    [sym_print_statement] = STATE(943),
    [sym_assert_statement] = STATE(943),
    [sym_expression_statement] = STATE(943),
    [sym_named_expression] = STATE(601),
    [sym_return_statement] = STATE(943),
    [sym_delete_statement] = STATE(943),
    [sym_raise_statement] = STATE(943),
    [sym_pass_statement] = STATE(943),
    [sym_break_statement] = STATE(943),
    [sym_continue_statement] = STATE(943),
    [sym_global_statement] = STATE(943),
    [sym_nonlocal_statement] = STATE(943),
    [sym_exec_statement] = STATE(943),
    [sym_expression_list] = STATE(618),
    [sym__expression] = STATE(601),
    [sym__primary_expression] = STATE(109),
    [sym_not_operator] = STATE(601),
    [sym_boolean_operator] = STATE(601),
    [sym_binary_operator] = STATE(109),
    [sym_unary_operator] = STATE(109),
    [sym_comparison_operator] = STATE(601),
    [sym_lambda] = STATE(601),
    [sym_assignment] = STATE(936),
    [sym_augmented_assignment] = STATE(936),
    [sym_yield] = STATE(936),
    [sym_attribute] = STATE(109),
    [sym_subscript] = STATE(109),
    [sym_call] = STATE(109),
    [sym_list] = STATE(109),
    [sym_list_comprehension] = STATE(109),
    [sym_dictionary] = STATE(109),
    [sym_dictionary_comprehension] = STATE(109),
    [sym_set] = STATE(109),
    [sym_set_comprehension] = STATE(109),
    [sym_parenthesized_expression] = STATE(109),
    [sym_tuple] = STATE(109),
    [sym_generator_expression] = STATE(109),
    [sym_conditional_expression] = STATE(601),
    [sym_concatenated_string] = STATE(109),
    [sym_string] = STATE(117),
    [sym_await] = STATE(601),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_import] = ACTIONS(9),
    [anon_sym_from] = ACTIONS(11),
    [anon_sym_LPAREN] = ACTIONS(13),
    [anon_sym_print] = ACTIONS(15),
    [anon_sym_assert] = ACTIONS(17),
    [anon_sym_return] = ACTIONS(19),
    [anon_sym_del] = ACTIONS(21),
    [anon_sym_raise] = ACTIONS(23),
    [anon_sym_pass] = ACTIONS(25),
    [anon_sym_break] = ACTIONS(27),
    [anon_sym_continue] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(45),
    [anon_sym_nonlocal] = ACTIONS(47),
    [anon_sym_exec] = ACTIONS(49),
    [anon_sym_not] = ACTIONS(55),
    [anon_sym_PLUS] = ACTIONS(57),
    [anon_sym_DASH] = ACTIONS(57),
    [anon_sym_TILDE] = ACTIONS(57),
    [anon_sym_lambda] = ACTIONS(59),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [sym_ellipsis] = ACTIONS(65),
    [anon_sym_LBRACE] = ACTIONS(67),
    [sym_integer] = ACTIONS(69),
    [sym_float] = ACTIONS(65),
    [sym_true] = ACTIONS(69),
    [sym_false] = ACTIONS(69),
    [sym_none] = ACTIONS(69),
    [anon_sym_await] = ACTIONS(71),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(331),
    [sym__string_start] = ACTIONS(73),
  },
  [95] = {
    [sym_import_statement] = STATE(943),
    [sym_future_import_statement] = STATE(943),
    [sym_import_from_statement] = STATE(943),
    [sym_print_statement] = STATE(943),
    [sym_assert_statement] = STATE(943),
    [sym_expression_statement] = STATE(943),
    [sym_named_expression] = STATE(601),
    [sym_return_statement] = STATE(943),
    [sym_delete_statement] = STATE(943),
    [sym_raise_statement] = STATE(943),
    [sym_pass_statement] = STATE(943),
    [sym_break_statement] = STATE(943),
    [sym_continue_statement] = STATE(943),
    [sym_global_statement] = STATE(943),
    [sym_nonlocal_statement] = STATE(943),
    [sym_exec_statement] = STATE(943),
    [sym_expression_list] = STATE(618),
    [sym__expression] = STATE(601),
    [sym__primary_expression] = STATE(109),
    [sym_not_operator] = STATE(601),
    [sym_boolean_operator] = STATE(601),
    [sym_binary_operator] = STATE(109),
    [sym_unary_operator] = STATE(109),
    [sym_comparison_operator] = STATE(601),
    [sym_lambda] = STATE(601),
    [sym_assignment] = STATE(936),
    [sym_augmented_assignment] = STATE(936),
    [sym_yield] = STATE(936),
    [sym_attribute] = STATE(109),
    [sym_subscript] = STATE(109),
    [sym_call] = STATE(109),
    [sym_list] = STATE(109),
    [sym_list_comprehension] = STATE(109),
    [sym_dictionary] = STATE(109),
    [sym_dictionary_comprehension] = STATE(109),
    [sym_set] = STATE(109),
    [sym_set_comprehension] = STATE(109),
    [sym_parenthesized_expression] = STATE(109),
    [sym_tuple] = STATE(109),
    [sym_generator_expression] = STATE(109),
    [sym_conditional_expression] = STATE(601),
    [sym_concatenated_string] = STATE(109),
    [sym_string] = STATE(117),
    [sym_await] = STATE(601),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_import] = ACTIONS(9),
    [anon_sym_from] = ACTIONS(11),
    [anon_sym_LPAREN] = ACTIONS(13),
    [anon_sym_print] = ACTIONS(15),
    [anon_sym_assert] = ACTIONS(17),
    [anon_sym_return] = ACTIONS(19),
    [anon_sym_del] = ACTIONS(21),
    [anon_sym_raise] = ACTIONS(23),
    [anon_sym_pass] = ACTIONS(25),
    [anon_sym_break] = ACTIONS(27),
    [anon_sym_continue] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(45),
    [anon_sym_nonlocal] = ACTIONS(47),
    [anon_sym_exec] = ACTIONS(49),
    [anon_sym_not] = ACTIONS(55),
    [anon_sym_PLUS] = ACTIONS(57),
    [anon_sym_DASH] = ACTIONS(57),
    [anon_sym_TILDE] = ACTIONS(57),
    [anon_sym_lambda] = ACTIONS(59),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [sym_ellipsis] = ACTIONS(65),
    [anon_sym_LBRACE] = ACTIONS(67),
    [sym_integer] = ACTIONS(69),
    [sym_float] = ACTIONS(65),
    [sym_true] = ACTIONS(69),
    [sym_false] = ACTIONS(69),
    [sym_none] = ACTIONS(69),
    [anon_sym_await] = ACTIONS(71),
    [sym_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(73),
  },
  [96] = {
    [sym_named_expression] = STATE(600),
    [sym__expression] = STATE(600),
    [sym__primary_expression] = STATE(109),
    [sym_not_operator] = STATE(600),
    [sym_boolean_operator] = STATE(600),
    [sym_binary_operator] = STATE(109),
    [sym_unary_operator] = STATE(109),
    [sym_comparison_operator] = STATE(600),
    [sym_lambda] = STATE(600),
    [sym_attribute] = STATE(109),
    [sym_subscript] = STATE(109),
    [sym_call] = STATE(109),
    [sym_list] = STATE(109),
    [sym_list_comprehension] = STATE(109),
    [sym_dictionary] = STATE(109),
    [sym_dictionary_comprehension] = STATE(109),
    [sym_set] = STATE(109),
    [sym_set_comprehension] = STATE(109),
    [sym_parenthesized_expression] = STATE(109),
    [sym_tuple] = STATE(109),
    [sym_generator_expression] = STATE(109),
    [sym_conditional_expression] = STATE(600),
    [sym_concatenated_string] = STATE(109),
    [sym_string] = STATE(117),
    [sym_await] = STATE(600),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_from] = ACTIONS(333),
    [anon_sym_LPAREN] = ACTIONS(13),
    [anon_sym_print] = ACTIONS(237),
    [anon_sym_COLON] = ACTIONS(335),
    [anon_sym_EQ] = ACTIONS(335),
    [anon_sym_exec] = ACTIONS(237),
    [anon_sym_not] = ACTIONS(55),
    [anon_sym_PLUS] = ACTIONS(337),
    [anon_sym_DASH] = ACTIONS(337),
    [anon_sym_TILDE] = ACTIONS(57),
    [anon_sym_lambda] = ACTIONS(59),
    [anon_sym_PLUS_EQ] = ACTIONS(335),
    [anon_sym_DASH_EQ] = ACTIONS(335),
    [anon_sym_STAR_EQ] = ACTIONS(335),
    [anon_sym_SLASH_EQ] = ACTIONS(335),
    [anon_sym_AT_EQ] = ACTIONS(335),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(335),
    [anon_sym_PERCENT_EQ] = ACTIONS(335),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(335),
    [anon_sym_GT_GT_EQ] = ACTIONS(335),
    [anon_sym_LT_LT_EQ] = ACTIONS(335),
    [anon_sym_AMP_EQ] = ACTIONS(335),
    [anon_sym_CARET_EQ] = ACTIONS(335),
    [anon_sym_PIPE_EQ] = ACTIONS(335),
    [anon_sym_LBRACK] = ACTIONS(63),
    [sym_ellipsis] = ACTIONS(65),
    [anon_sym_LBRACE] = ACTIONS(67),
    [sym_integer] = ACTIONS(69),
    [sym_float] = ACTIONS(65),
    [sym_true] = ACTIONS(69),
    [sym_false] = ACTIONS(69),
    [sym_none] = ACTIONS(69),
    [anon_sym_await] = ACTIONS(71),
    [sym_comment] = ACTIONS(3),
    [sym__semicolon] = ACTIONS(335),
    [sym__newline] = ACTIONS(335),
    [sym__string_start] = ACTIONS(73),
  },
  [97] = {
    [sym_named_expression] = STATE(600),
    [sym__expression] = STATE(600),
    [sym__primary_expression] = STATE(109),
    [sym_not_operator] = STATE(600),
    [sym_boolean_operator] = STATE(600),
    [sym_binary_operator] = STATE(109),
    [sym_unary_operator] = STATE(109),
    [sym_comparison_operator] = STATE(600),
    [sym_lambda] = STATE(600),
    [sym_attribute] = STATE(109),
    [sym_subscript] = STATE(109),
    [sym_call] = STATE(109),
    [sym_list] = STATE(109),
    [sym_list_comprehension] = STATE(109),
    [sym_dictionary] = STATE(109),
    [sym_dictionary_comprehension] = STATE(109),
    [sym_set] = STATE(109),
    [sym_set_comprehension] = STATE(109),
    [sym_parenthesized_expression] = STATE(109),
    [sym_tuple] = STATE(109),
    [sym_generator_expression] = STATE(109),
    [sym_conditional_expression] = STATE(600),
    [sym_concatenated_string] = STATE(109),
    [sym_string] = STATE(117),
    [sym_await] = STATE(600),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_from] = ACTIONS(339),
    [anon_sym_LPAREN] = ACTIONS(13),
    [anon_sym_print] = ACTIONS(237),
    [anon_sym_COLON] = ACTIONS(341),
    [anon_sym_EQ] = ACTIONS(341),
    [anon_sym_exec] = ACTIONS(237),
    [anon_sym_not] = ACTIONS(55),
    [anon_sym_PLUS] = ACTIONS(337),
    [anon_sym_DASH] = ACTIONS(337),
    [anon_sym_TILDE] = ACTIONS(57),
    [anon_sym_lambda] = ACTIONS(59),
    [anon_sym_PLUS_EQ] = ACTIONS(341),
    [anon_sym_DASH_EQ] = ACTIONS(341),
    [anon_sym_STAR_EQ] = ACTIONS(341),
    [anon_sym_SLASH_EQ] = ACTIONS(341),
    [anon_sym_AT_EQ] = ACTIONS(341),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(341),
    [anon_sym_PERCENT_EQ] = ACTIONS(341),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(341),
    [anon_sym_GT_GT_EQ] = ACTIONS(341),
    [anon_sym_LT_LT_EQ] = ACTIONS(341),
    [anon_sym_AMP_EQ] = ACTIONS(341),
    [anon_sym_CARET_EQ] = ACTIONS(341),
    [anon_sym_PIPE_EQ] = ACTIONS(341),
    [anon_sym_LBRACK] = ACTIONS(63),
    [sym_ellipsis] = ACTIONS(65),
    [anon_sym_LBRACE] = ACTIONS(67),
    [sym_integer] = ACTIONS(69),
    [sym_float] = ACTIONS(65),
    [sym_true] = ACTIONS(69),
    [sym_false] = ACTIONS(69),
    [sym_none] = ACTIONS(69),
    [anon_sym_await] = ACTIONS(71),
    [sym_comment] = ACTIONS(3),
    [sym__semicolon] = ACTIONS(341),
    [sym__newline] = ACTIONS(341),
    [sym__string_start] = ACTIONS(73),
  },
  [98] = {
    [sym_named_expression] = STATE(600),
    [sym__expression] = STATE(600),
    [sym__primary_expression] = STATE(109),
    [sym_not_operator] = STATE(600),
    [sym_boolean_operator] = STATE(600),
    [sym_binary_operator] = STATE(109),
    [sym_unary_operator] = STATE(109),
    [sym_comparison_operator] = STATE(600),
    [sym_lambda] = STATE(600),
    [sym_attribute] = STATE(109),
    [sym_subscript] = STATE(109),
    [sym_call] = STATE(109),
    [sym_list] = STATE(109),
    [sym_list_comprehension] = STATE(109),
    [sym_dictionary] = STATE(109),
    [sym_dictionary_comprehension] = STATE(109),
    [sym_set] = STATE(109),
    [sym_set_comprehension] = STATE(109),
    [sym_parenthesized_expression] = STATE(109),
    [sym_tuple] = STATE(109),
    [sym_generator_expression] = STATE(109),
    [sym_conditional_expression] = STATE(600),
    [sym_concatenated_string] = STATE(109),
    [sym_string] = STATE(117),
    [sym_await] = STATE(600),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(13),
    [anon_sym_print] = ACTIONS(237),
    [anon_sym_COLON] = ACTIONS(341),
    [anon_sym_EQ] = ACTIONS(341),
    [anon_sym_exec] = ACTIONS(237),
    [anon_sym_not] = ACTIONS(55),
    [anon_sym_PLUS] = ACTIONS(337),
    [anon_sym_DASH] = ACTIONS(337),
    [anon_sym_TILDE] = ACTIONS(57),
    [anon_sym_lambda] = ACTIONS(59),
    [anon_sym_PLUS_EQ] = ACTIONS(341),
    [anon_sym_DASH_EQ] = ACTIONS(341),
    [anon_sym_STAR_EQ] = ACTIONS(341),
    [anon_sym_SLASH_EQ] = ACTIONS(341),
    [anon_sym_AT_EQ] = ACTIONS(341),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(341),
    [anon_sym_PERCENT_EQ] = ACTIONS(341),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(341),
    [anon_sym_GT_GT_EQ] = ACTIONS(341),
    [anon_sym_LT_LT_EQ] = ACTIONS(341),
    [anon_sym_AMP_EQ] = ACTIONS(341),
    [anon_sym_CARET_EQ] = ACTIONS(341),
    [anon_sym_PIPE_EQ] = ACTIONS(341),
    [anon_sym_LBRACK] = ACTIONS(63),
    [sym_ellipsis] = ACTIONS(65),
    [anon_sym_LBRACE] = ACTIONS(67),
    [sym_integer] = ACTIONS(69),
    [sym_float] = ACTIONS(65),
    [sym_true] = ACTIONS(69),
    [sym_false] = ACTIONS(69),
    [sym_none] = ACTIONS(69),
    [anon_sym_await] = ACTIONS(71),
    [sym_comment] = ACTIONS(3),
    [sym__semicolon] = ACTIONS(343),
    [sym__newline] = ACTIONS(343),
    [sym__string_start] = ACTIONS(73),
  },
  [99] = {
    [sym_named_expression] = STATE(600),
    [sym__expression] = STATE(600),
    [sym__primary_expression] = STATE(109),
    [sym_not_operator] = STATE(600),
    [sym_boolean_operator] = STATE(600),
    [sym_binary_operator] = STATE(109),
    [sym_unary_operator] = STATE(109),
    [sym_comparison_operator] = STATE(600),
    [sym_lambda] = STATE(600),
    [sym_attribute] = STATE(109),
    [sym_subscript] = STATE(109),
    [sym_call] = STATE(109),
    [sym_list] = STATE(109),
    [sym_list_comprehension] = STATE(109),
    [sym_dictionary] = STATE(109),
    [sym_dictionary_comprehension] = STATE(109),
    [sym_set] = STATE(109),
    [sym_set_comprehension] = STATE(109),
    [sym_parenthesized_expression] = STATE(109),
    [sym_tuple] = STATE(109),
    [sym_generator_expression] = STATE(109),
    [sym_conditional_expression] = STATE(600),
    [sym_concatenated_string] = STATE(109),
    [sym_string] = STATE(117),
    [sym_await] = STATE(600),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(13),
    [anon_sym_print] = ACTIONS(237),
    [anon_sym_COLON] = ACTIONS(335),
    [anon_sym_EQ] = ACTIONS(335),
    [anon_sym_exec] = ACTIONS(237),
    [anon_sym_not] = ACTIONS(55),
    [anon_sym_PLUS] = ACTIONS(337),
    [anon_sym_DASH] = ACTIONS(337),
    [anon_sym_TILDE] = ACTIONS(57),
    [anon_sym_lambda] = ACTIONS(59),
    [anon_sym_PLUS_EQ] = ACTIONS(335),
    [anon_sym_DASH_EQ] = ACTIONS(335),
    [anon_sym_STAR_EQ] = ACTIONS(335),
    [anon_sym_SLASH_EQ] = ACTIONS(335),
    [anon_sym_AT_EQ] = ACTIONS(335),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(335),
    [anon_sym_PERCENT_EQ] = ACTIONS(335),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(335),
    [anon_sym_GT_GT_EQ] = ACTIONS(335),
    [anon_sym_LT_LT_EQ] = ACTIONS(335),
    [anon_sym_AMP_EQ] = ACTIONS(335),
    [anon_sym_CARET_EQ] = ACTIONS(335),
    [anon_sym_PIPE_EQ] = ACTIONS(335),
    [anon_sym_LBRACK] = ACTIONS(63),
    [sym_ellipsis] = ACTIONS(65),
    [anon_sym_LBRACE] = ACTIONS(67),
    [sym_integer] = ACTIONS(69),
    [sym_float] = ACTIONS(65),
    [sym_true] = ACTIONS(69),
    [sym_false] = ACTIONS(69),
    [sym_none] = ACTIONS(69),
    [anon_sym_await] = ACTIONS(71),
    [sym_comment] = ACTIONS(3),
    [sym__semicolon] = ACTIONS(345),
    [sym__newline] = ACTIONS(345),
    [sym__string_start] = ACTIONS(73),
  },
  [100] = {
    [sym_named_expression] = STATE(710),
    [sym_list_splat] = STATE(874),
    [sym_dictionary_splat] = STATE(874),
    [sym_parenthesized_list_splat] = STATE(874),
    [sym__expression] = STATE(710),
    [sym__primary_expression] = STATE(383),
    [sym_not_operator] = STATE(710),
    [sym_boolean_operator] = STATE(710),
    [sym_binary_operator] = STATE(383),
    [sym_unary_operator] = STATE(383),
    [sym_comparison_operator] = STATE(710),
    [sym_lambda] = STATE(710),
    [sym_attribute] = STATE(383),
    [sym_subscript] = STATE(383),
    [sym_call] = STATE(383),
    [sym_keyword_argument] = STATE(874),
    [sym_list] = STATE(383),
    [sym_list_comprehension] = STATE(383),
    [sym_dictionary] = STATE(383),
    [sym_dictionary_comprehension] = STATE(383),
    [sym_set] = STATE(383),
    [sym_set_comprehension] = STATE(383),
    [sym_parenthesized_expression] = STATE(383),
    [sym_tuple] = STATE(383),
    [sym_generator_expression] = STATE(383),
    [sym_conditional_expression] = STATE(710),
    [sym_concatenated_string] = STATE(383),
    [sym_string] = STATE(381),
    [sym_await] = STATE(710),
    [sym_identifier] = ACTIONS(347),
    [anon_sym_LPAREN] = ACTIONS(349),
    [anon_sym_RPAREN] = ACTIONS(351),
    [anon_sym_COMMA] = ACTIONS(353),
    [anon_sym_STAR] = ACTIONS(355),
    [anon_sym_print] = ACTIONS(357),
    [anon_sym_STAR_STAR] = ACTIONS(359),
    [anon_sym_exec] = ACTIONS(357),
    [anon_sym_not] = ACTIONS(361),
    [anon_sym_PLUS] = ACTIONS(363),
    [anon_sym_DASH] = ACTIONS(363),
    [anon_sym_TILDE] = ACTIONS(363),
    [anon_sym_lambda] = ACTIONS(365),
    [anon_sym_LBRACK] = ACTIONS(367),
    [sym_ellipsis] = ACTIONS(369),
    [anon_sym_LBRACE] = ACTIONS(371),
    [sym_integer] = ACTIONS(373),
    [sym_float] = ACTIONS(369),
    [sym_true] = ACTIONS(373),
    [sym_false] = ACTIONS(373),
    [sym_none] = ACTIONS(373),
    [anon_sym_await] = ACTIONS(375),
    [sym_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(377),
  },
  [101] = {
    [sym_named_expression] = STATE(713),
    [sym_list_splat] = STATE(877),
    [sym_dictionary_splat] = STATE(877),
    [sym_parenthesized_list_splat] = STATE(877),
    [sym__expression] = STATE(713),
    [sym__primary_expression] = STATE(383),
    [sym_not_operator] = STATE(713),
    [sym_boolean_operator] = STATE(713),
    [sym_binary_operator] = STATE(383),
    [sym_unary_operator] = STATE(383),
    [sym_comparison_operator] = STATE(713),
    [sym_lambda] = STATE(713),
    [sym_attribute] = STATE(383),
    [sym_subscript] = STATE(383),
    [sym_call] = STATE(383),
    [sym_keyword_argument] = STATE(877),
    [sym_list] = STATE(383),
    [sym_list_comprehension] = STATE(383),
    [sym_dictionary] = STATE(383),
    [sym_dictionary_comprehension] = STATE(383),
    [sym_set] = STATE(383),
    [sym_set_comprehension] = STATE(383),
    [sym_parenthesized_expression] = STATE(383),
    [sym_tuple] = STATE(383),
    [sym_generator_expression] = STATE(383),
    [sym_conditional_expression] = STATE(713),
    [sym_concatenated_string] = STATE(383),
    [sym_string] = STATE(381),
    [sym_await] = STATE(713),
    [sym_identifier] = ACTIONS(347),
    [anon_sym_LPAREN] = ACTIONS(349),
    [anon_sym_RPAREN] = ACTIONS(379),
    [anon_sym_COMMA] = ACTIONS(381),
    [anon_sym_STAR] = ACTIONS(355),
    [anon_sym_print] = ACTIONS(357),
    [anon_sym_STAR_STAR] = ACTIONS(359),
    [anon_sym_exec] = ACTIONS(357),
    [anon_sym_not] = ACTIONS(361),
    [anon_sym_PLUS] = ACTIONS(363),
    [anon_sym_DASH] = ACTIONS(363),
    [anon_sym_TILDE] = ACTIONS(363),
    [anon_sym_lambda] = ACTIONS(365),
    [anon_sym_LBRACK] = ACTIONS(367),
    [sym_ellipsis] = ACTIONS(369),
    [anon_sym_LBRACE] = ACTIONS(371),
    [sym_integer] = ACTIONS(373),
    [sym_float] = ACTIONS(369),
    [sym_true] = ACTIONS(373),
    [sym_false] = ACTIONS(373),
    [sym_none] = ACTIONS(373),
    [anon_sym_await] = ACTIONS(375),
    [sym_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(377),
  },
  [102] = {
    [sym_named_expression] = STATE(653),
    [sym_list_splat] = STATE(908),
    [sym_dictionary_splat] = STATE(908),
    [sym_parenthesized_list_splat] = STATE(908),
    [sym__expression] = STATE(653),
    [sym__primary_expression] = STATE(383),
    [sym_not_operator] = STATE(653),
    [sym_boolean_operator] = STATE(653),
    [sym_binary_operator] = STATE(383),
    [sym_unary_operator] = STATE(383),
    [sym_comparison_operator] = STATE(653),
    [sym_lambda] = STATE(653),
    [sym_attribute] = STATE(383),
    [sym_subscript] = STATE(383),
    [sym_call] = STATE(383),
    [sym_keyword_argument] = STATE(908),
    [sym_list] = STATE(383),
    [sym_list_comprehension] = STATE(383),
    [sym_dictionary] = STATE(383),
    [sym_dictionary_comprehension] = STATE(383),
    [sym_set] = STATE(383),
    [sym_set_comprehension] = STATE(383),
    [sym_parenthesized_expression] = STATE(383),
    [sym_tuple] = STATE(383),
    [sym_generator_expression] = STATE(383),
    [sym_conditional_expression] = STATE(653),
    [sym_concatenated_string] = STATE(383),
    [sym_string] = STATE(381),
    [sym_await] = STATE(653),
    [sym_identifier] = ACTIONS(347),
    [anon_sym_LPAREN] = ACTIONS(349),
    [anon_sym_RPAREN] = ACTIONS(383),
    [anon_sym_COMMA] = ACTIONS(385),
    [anon_sym_STAR] = ACTIONS(355),
    [anon_sym_print] = ACTIONS(357),
    [anon_sym_STAR_STAR] = ACTIONS(359),
    [anon_sym_exec] = ACTIONS(357),
    [anon_sym_not] = ACTIONS(361),
    [anon_sym_PLUS] = ACTIONS(363),
    [anon_sym_DASH] = ACTIONS(363),
    [anon_sym_TILDE] = ACTIONS(363),
    [anon_sym_lambda] = ACTIONS(365),
    [anon_sym_LBRACK] = ACTIONS(367),
    [sym_ellipsis] = ACTIONS(369),
    [anon_sym_LBRACE] = ACTIONS(371),
    [sym_integer] = ACTIONS(373),
    [sym_float] = ACTIONS(369),
    [sym_true] = ACTIONS(373),
    [sym_false] = ACTIONS(373),
    [sym_none] = ACTIONS(373),
    [anon_sym_await] = ACTIONS(375),
    [sym_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(377),
  },
  [103] = {
    [sym_named_expression] = STATE(662),
    [sym__expression_within_for_in_clause] = STATE(676),
    [sym__expression] = STATE(662),
    [sym__primary_expression] = STATE(383),
    [sym_not_operator] = STATE(662),
    [sym_boolean_operator] = STATE(662),
    [sym_binary_operator] = STATE(383),
    [sym_unary_operator] = STATE(383),
    [sym_comparison_operator] = STATE(662),
    [sym_lambda] = STATE(662),
    [sym_lambda_within_for_in_clause] = STATE(676),
    [sym_attribute] = STATE(383),
    [sym_subscript] = STATE(383),
    [sym_call] = STATE(383),
    [sym_list] = STATE(383),
    [sym_list_comprehension] = STATE(383),
    [sym_dictionary] = STATE(383),
    [sym_dictionary_comprehension] = STATE(383),
    [sym_set] = STATE(383),
    [sym_set_comprehension] = STATE(383),
    [sym_parenthesized_expression] = STATE(383),
    [sym_tuple] = STATE(383),
    [sym_generator_expression] = STATE(383),
    [sym_conditional_expression] = STATE(662),
    [sym_concatenated_string] = STATE(383),
    [sym_string] = STATE(381),
    [sym_await] = STATE(662),
    [sym_identifier] = ACTIONS(387),
    [anon_sym_LPAREN] = ACTIONS(389),
    [anon_sym_RPAREN] = ACTIONS(391),
    [anon_sym_print] = ACTIONS(393),
    [anon_sym_if] = ACTIONS(395),
    [anon_sym_async] = ACTIONS(395),
    [anon_sym_for] = ACTIONS(395),
    [anon_sym_exec] = ACTIONS(393),
    [anon_sym_not] = ACTIONS(361),
    [anon_sym_PLUS] = ACTIONS(363),
    [anon_sym_DASH] = ACTIONS(363),
    [anon_sym_TILDE] = ACTIONS(363),
    [anon_sym_lambda] = ACTIONS(397),
    [anon_sym_LBRACK] = ACTIONS(367),
    [anon_sym_RBRACK] = ACTIONS(391),
    [sym_ellipsis] = ACTIONS(369),
    [anon_sym_LBRACE] = ACTIONS(371),
    [anon_sym_RBRACE] = ACTIONS(391),
    [sym_integer] = ACTIONS(373),
    [sym_float] = ACTIONS(369),
    [sym_true] = ACTIONS(373),
    [sym_false] = ACTIONS(373),
    [sym_none] = ACTIONS(373),
    [anon_sym_await] = ACTIONS(375),
    [sym_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(377),
  },
  [104] = {
    [sym_named_expression] = STATE(656),
    [sym_list_splat] = STATE(874),
    [sym_dictionary_splat] = STATE(874),
    [sym_parenthesized_list_splat] = STATE(874),
    [sym__expression] = STATE(656),
    [sym__primary_expression] = STATE(383),
    [sym_not_operator] = STATE(656),
    [sym_boolean_operator] = STATE(656),
    [sym_binary_operator] = STATE(383),
    [sym_unary_operator] = STATE(383),
    [sym_comparison_operator] = STATE(656),
    [sym_lambda] = STATE(656),
    [sym_attribute] = STATE(383),
    [sym_subscript] = STATE(383),
    [sym_call] = STATE(383),
    [sym_keyword_argument] = STATE(874),
    [sym_list] = STATE(383),
    [sym_list_comprehension] = STATE(383),
    [sym_dictionary] = STATE(383),
    [sym_dictionary_comprehension] = STATE(383),
    [sym_set] = STATE(383),
    [sym_set_comprehension] = STATE(383),
    [sym_parenthesized_expression] = STATE(383),
    [sym_tuple] = STATE(383),
    [sym_generator_expression] = STATE(383),
    [sym_conditional_expression] = STATE(656),
    [sym_concatenated_string] = STATE(383),
    [sym_string] = STATE(381),
    [sym_await] = STATE(656),
    [sym_identifier] = ACTIONS(347),
    [anon_sym_LPAREN] = ACTIONS(349),
    [anon_sym_RPAREN] = ACTIONS(351),
    [anon_sym_COMMA] = ACTIONS(353),
    [anon_sym_STAR] = ACTIONS(355),
    [anon_sym_print] = ACTIONS(357),
    [anon_sym_STAR_STAR] = ACTIONS(359),
    [anon_sym_exec] = ACTIONS(357),
    [anon_sym_not] = ACTIONS(361),
    [anon_sym_PLUS] = ACTIONS(363),
    [anon_sym_DASH] = ACTIONS(363),
    [anon_sym_TILDE] = ACTIONS(363),
    [anon_sym_lambda] = ACTIONS(365),
    [anon_sym_LBRACK] = ACTIONS(367),
    [sym_ellipsis] = ACTIONS(369),
    [anon_sym_LBRACE] = ACTIONS(371),
    [sym_integer] = ACTIONS(373),
    [sym_float] = ACTIONS(369),
    [sym_true] = ACTIONS(373),
    [sym_false] = ACTIONS(373),
    [sym_none] = ACTIONS(373),
    [anon_sym_await] = ACTIONS(375),
    [sym_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(377),
  },
  [105] = {
    [sym_named_expression] = STATE(662),
    [sym__expression_within_for_in_clause] = STATE(676),
    [sym__expression] = STATE(662),
    [sym__primary_expression] = STATE(383),
    [sym_not_operator] = STATE(662),
    [sym_boolean_operator] = STATE(662),
    [sym_binary_operator] = STATE(383),
    [sym_unary_operator] = STATE(383),
    [sym_comparison_operator] = STATE(662),
    [sym_lambda] = STATE(662),
    [sym_lambda_within_for_in_clause] = STATE(676),
    [sym_attribute] = STATE(383),
    [sym_subscript] = STATE(383),
    [sym_call] = STATE(383),
    [sym_list] = STATE(383),
    [sym_list_comprehension] = STATE(383),
    [sym_dictionary] = STATE(383),
    [sym_dictionary_comprehension] = STATE(383),
    [sym_set] = STATE(383),
    [sym_set_comprehension] = STATE(383),
    [sym_parenthesized_expression] = STATE(383),
    [sym_tuple] = STATE(383),
    [sym_generator_expression] = STATE(383),
    [sym_conditional_expression] = STATE(662),
    [sym_concatenated_string] = STATE(383),
    [sym_string] = STATE(381),
    [sym_await] = STATE(662),
    [sym_identifier] = ACTIONS(387),
    [anon_sym_LPAREN] = ACTIONS(389),
    [anon_sym_RPAREN] = ACTIONS(399),
    [anon_sym_print] = ACTIONS(393),
    [anon_sym_if] = ACTIONS(401),
    [anon_sym_async] = ACTIONS(401),
    [anon_sym_for] = ACTIONS(401),
    [anon_sym_exec] = ACTIONS(393),
    [anon_sym_not] = ACTIONS(361),
    [anon_sym_PLUS] = ACTIONS(363),
    [anon_sym_DASH] = ACTIONS(363),
    [anon_sym_TILDE] = ACTIONS(363),
    [anon_sym_lambda] = ACTIONS(397),
    [anon_sym_LBRACK] = ACTIONS(367),
    [anon_sym_RBRACK] = ACTIONS(399),
    [sym_ellipsis] = ACTIONS(369),
    [anon_sym_LBRACE] = ACTIONS(371),
    [anon_sym_RBRACE] = ACTIONS(399),
    [sym_integer] = ACTIONS(373),
    [sym_float] = ACTIONS(369),
    [sym_true] = ACTIONS(373),
    [sym_false] = ACTIONS(373),
    [sym_none] = ACTIONS(373),
    [anon_sym_await] = ACTIONS(375),
    [sym_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(377),
  },
  [106] = {
    [sym_named_expression] = STATE(662),
    [sym__expression_within_for_in_clause] = STATE(676),
    [sym__expression] = STATE(662),
    [sym__primary_expression] = STATE(383),
    [sym_not_operator] = STATE(662),
    [sym_boolean_operator] = STATE(662),
    [sym_binary_operator] = STATE(383),
    [sym_unary_operator] = STATE(383),
    [sym_comparison_operator] = STATE(662),
    [sym_lambda] = STATE(662),
    [sym_lambda_within_for_in_clause] = STATE(676),
    [sym_attribute] = STATE(383),
    [sym_subscript] = STATE(383),
    [sym_call] = STATE(383),
    [sym_list] = STATE(383),
    [sym_list_comprehension] = STATE(383),
    [sym_dictionary] = STATE(383),
    [sym_dictionary_comprehension] = STATE(383),
    [sym_set] = STATE(383),
    [sym_set_comprehension] = STATE(383),
    [sym_parenthesized_expression] = STATE(383),
    [sym_tuple] = STATE(383),
    [sym_generator_expression] = STATE(383),
    [sym_conditional_expression] = STATE(662),
    [sym_concatenated_string] = STATE(383),
    [sym_string] = STATE(381),
    [sym_await] = STATE(662),
    [sym_identifier] = ACTIONS(387),
    [anon_sym_LPAREN] = ACTIONS(389),
    [anon_sym_RPAREN] = ACTIONS(403),
    [anon_sym_print] = ACTIONS(393),
    [anon_sym_if] = ACTIONS(405),
    [anon_sym_async] = ACTIONS(405),
    [anon_sym_for] = ACTIONS(405),
    [anon_sym_exec] = ACTIONS(393),
    [anon_sym_not] = ACTIONS(361),
    [anon_sym_PLUS] = ACTIONS(363),
    [anon_sym_DASH] = ACTIONS(363),
    [anon_sym_TILDE] = ACTIONS(363),
    [anon_sym_lambda] = ACTIONS(397),
    [anon_sym_LBRACK] = ACTIONS(367),
    [anon_sym_RBRACK] = ACTIONS(403),
    [sym_ellipsis] = ACTIONS(369),
    [anon_sym_LBRACE] = ACTIONS(371),
    [anon_sym_RBRACE] = ACTIONS(403),
    [sym_integer] = ACTIONS(373),
    [sym_float] = ACTIONS(369),
    [sym_true] = ACTIONS(373),
    [sym_false] = ACTIONS(373),
    [sym_none] = ACTIONS(373),
    [anon_sym_await] = ACTIONS(375),
    [sym_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(377),
  },
  [107] = {
    [sym_named_expression] = STATE(662),
    [sym__expression_within_for_in_clause] = STATE(676),
    [sym__expression] = STATE(662),
    [sym__primary_expression] = STATE(383),
    [sym_not_operator] = STATE(662),
    [sym_boolean_operator] = STATE(662),
    [sym_binary_operator] = STATE(383),
    [sym_unary_operator] = STATE(383),
    [sym_comparison_operator] = STATE(662),
    [sym_lambda] = STATE(662),
    [sym_lambda_within_for_in_clause] = STATE(676),
    [sym_attribute] = STATE(383),
    [sym_subscript] = STATE(383),
    [sym_call] = STATE(383),
    [sym_list] = STATE(383),
    [sym_list_comprehension] = STATE(383),
    [sym_dictionary] = STATE(383),
    [sym_dictionary_comprehension] = STATE(383),
    [sym_set] = STATE(383),
    [sym_set_comprehension] = STATE(383),
    [sym_parenthesized_expression] = STATE(383),
    [sym_tuple] = STATE(383),
    [sym_generator_expression] = STATE(383),
    [sym_conditional_expression] = STATE(662),
    [sym_concatenated_string] = STATE(383),
    [sym_string] = STATE(381),
    [sym_await] = STATE(662),
    [sym_identifier] = ACTIONS(387),
    [anon_sym_LPAREN] = ACTIONS(389),
    [anon_sym_RPAREN] = ACTIONS(407),
    [anon_sym_print] = ACTIONS(393),
    [anon_sym_if] = ACTIONS(409),
    [anon_sym_async] = ACTIONS(409),
    [anon_sym_for] = ACTIONS(409),
    [anon_sym_exec] = ACTIONS(393),
    [anon_sym_not] = ACTIONS(361),
    [anon_sym_PLUS] = ACTIONS(363),
    [anon_sym_DASH] = ACTIONS(363),
    [anon_sym_TILDE] = ACTIONS(363),
    [anon_sym_lambda] = ACTIONS(397),
    [anon_sym_LBRACK] = ACTIONS(367),
    [anon_sym_RBRACK] = ACTIONS(407),
    [sym_ellipsis] = ACTIONS(369),
    [anon_sym_LBRACE] = ACTIONS(371),
    [anon_sym_RBRACE] = ACTIONS(407),
    [sym_integer] = ACTIONS(373),
    [sym_float] = ACTIONS(369),
    [sym_true] = ACTIONS(373),
    [sym_false] = ACTIONS(373),
    [sym_none] = ACTIONS(373),
    [anon_sym_await] = ACTIONS(375),
    [sym_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(377),
  },
  [108] = {
    [sym_named_expression] = STATE(655),
    [sym_list_splat] = STATE(877),
    [sym_dictionary_splat] = STATE(877),
    [sym_parenthesized_list_splat] = STATE(877),
    [sym__expression] = STATE(655),
    [sym__primary_expression] = STATE(383),
    [sym_not_operator] = STATE(655),
    [sym_boolean_operator] = STATE(655),
    [sym_binary_operator] = STATE(383),
    [sym_unary_operator] = STATE(383),
    [sym_comparison_operator] = STATE(655),
    [sym_lambda] = STATE(655),
    [sym_attribute] = STATE(383),
    [sym_subscript] = STATE(383),
    [sym_call] = STATE(383),
    [sym_keyword_argument] = STATE(877),
    [sym_list] = STATE(383),
    [sym_list_comprehension] = STATE(383),
    [sym_dictionary] = STATE(383),
    [sym_dictionary_comprehension] = STATE(383),
    [sym_set] = STATE(383),
    [sym_set_comprehension] = STATE(383),
    [sym_parenthesized_expression] = STATE(383),
    [sym_tuple] = STATE(383),
    [sym_generator_expression] = STATE(383),
    [sym_conditional_expression] = STATE(655),
    [sym_concatenated_string] = STATE(383),
    [sym_string] = STATE(381),
    [sym_await] = STATE(655),
    [sym_identifier] = ACTIONS(347),
    [anon_sym_LPAREN] = ACTIONS(349),
    [anon_sym_RPAREN] = ACTIONS(379),
    [anon_sym_COMMA] = ACTIONS(381),
    [anon_sym_STAR] = ACTIONS(355),
    [anon_sym_print] = ACTIONS(357),
    [anon_sym_STAR_STAR] = ACTIONS(359),
    [anon_sym_exec] = ACTIONS(357),
    [anon_sym_not] = ACTIONS(361),
    [anon_sym_PLUS] = ACTIONS(363),
    [anon_sym_DASH] = ACTIONS(363),
    [anon_sym_TILDE] = ACTIONS(363),
    [anon_sym_lambda] = ACTIONS(365),
    [anon_sym_LBRACK] = ACTIONS(367),
    [sym_ellipsis] = ACTIONS(369),
    [anon_sym_LBRACE] = ACTIONS(371),
    [sym_integer] = ACTIONS(373),
    [sym_float] = ACTIONS(369),
    [sym_true] = ACTIONS(373),
    [sym_false] = ACTIONS(373),
    [sym_none] = ACTIONS(373),
    [anon_sym_await] = ACTIONS(375),
    [sym_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(377),
  },
  [109] = {
    [sym_argument_list] = STATE(145),
    [sym_generator_expression] = STATE(145),
    [aux_sym_comparison_operator_repeat1] = STATE(548),
    [anon_sym_DOT] = ACTIONS(411),
    [anon_sym_from] = ACTIONS(413),
    [anon_sym_LPAREN] = ACTIONS(415),
    [anon_sym_COMMA] = ACTIONS(413),
    [anon_sym_STAR] = ACTIONS(417),
    [anon_sym_GT_GT] = ACTIONS(419),
    [anon_sym_if] = ACTIONS(413),
    [anon_sym_COLON] = ACTIONS(413),
    [anon_sym_in] = ACTIONS(421),
    [anon_sym_EQ] = ACTIONS(423),
    [anon_sym_STAR_STAR] = ACTIONS(425),
    [anon_sym_AT] = ACTIONS(417),
    [anon_sym_not] = ACTIONS(427),
    [anon_sym_and] = ACTIONS(413),
    [anon_sym_or] = ACTIONS(413),
    [anon_sym_PLUS] = ACTIONS(429),
    [anon_sym_DASH] = ACTIONS(429),
    [anon_sym_SLASH] = ACTIONS(417),
    [anon_sym_PERCENT] = ACTIONS(417),
    [anon_sym_SLASH_SLASH] = ACTIONS(417),
    [anon_sym_PIPE] = ACTIONS(431),
    [anon_sym_AMP] = ACTIONS(433),
    [anon_sym_CARET] = ACTIONS(435),
    [anon_sym_LT_LT] = ACTIONS(419),
    [anon_sym_LT] = ACTIONS(437),
    [anon_sym_LT_EQ] = ACTIONS(421),
    [anon_sym_EQ_EQ] = ACTIONS(421),
    [anon_sym_BANG_EQ] = ACTIONS(421),
    [anon_sym_GT_EQ] = ACTIONS(421),
    [anon_sym_GT] = ACTIONS(437),
    [anon_sym_LT_GT] = ACTIONS(421),
    [anon_sym_is] = ACTIONS(439),
    [anon_sym_PLUS_EQ] = ACTIONS(413),
    [anon_sym_DASH_EQ] = ACTIONS(413),
    [anon_sym_STAR_EQ] = ACTIONS(413),
    [anon_sym_SLASH_EQ] = ACTIONS(413),
    [anon_sym_AT_EQ] = ACTIONS(413),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(413),
    [anon_sym_PERCENT_EQ] = ACTIONS(413),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(413),
    [anon_sym_GT_GT_EQ] = ACTIONS(413),
    [anon_sym_LT_LT_EQ] = ACTIONS(413),
    [anon_sym_AMP_EQ] = ACTIONS(413),
    [anon_sym_CARET_EQ] = ACTIONS(413),
    [anon_sym_PIPE_EQ] = ACTIONS(413),
    [anon_sym_LBRACK] = ACTIONS(441),
    [sym_comment] = ACTIONS(3),
    [sym__semicolon] = ACTIONS(413),
    [sym__newline] = ACTIONS(413),
  },
  [110] = {
    [sym_named_expression] = STATE(647),
    [sym_list_splat] = STATE(839),
    [sym_dictionary_splat] = STATE(840),
    [sym__expression] = STATE(647),
    [sym__primary_expression] = STATE(383),
    [sym_not_operator] = STATE(647),
    [sym_boolean_operator] = STATE(647),
    [sym_binary_operator] = STATE(383),
    [sym_unary_operator] = STATE(383),
    [sym_comparison_operator] = STATE(647),
    [sym_lambda] = STATE(647),
    [sym_attribute] = STATE(383),
    [sym_subscript] = STATE(383),
    [sym_call] = STATE(383),
    [sym_list] = STATE(383),
    [sym_list_comprehension] = STATE(383),
    [sym_dictionary] = STATE(383),
    [sym_dictionary_comprehension] = STATE(383),
    [sym_pair] = STATE(701),
    [sym_set] = STATE(383),
    [sym_set_comprehension] = STATE(383),
    [sym_parenthesized_expression] = STATE(383),
    [sym_tuple] = STATE(383),
    [sym_generator_expression] = STATE(383),
    [sym_conditional_expression] = STATE(647),
    [sym_concatenated_string] = STATE(383),
    [sym_string] = STATE(381),
    [sym_await] = STATE(647),
    [sym_identifier] = ACTIONS(387),
    [anon_sym_LPAREN] = ACTIONS(389),
    [anon_sym_COMMA] = ACTIONS(443),
    [anon_sym_STAR] = ACTIONS(355),
    [anon_sym_print] = ACTIONS(393),
    [anon_sym_STAR_STAR] = ACTIONS(359),
    [anon_sym_exec] = ACTIONS(393),
    [anon_sym_not] = ACTIONS(361),
    [anon_sym_PLUS] = ACTIONS(363),
    [anon_sym_DASH] = ACTIONS(363),
    [anon_sym_TILDE] = ACTIONS(363),
    [anon_sym_lambda] = ACTIONS(365),
    [anon_sym_LBRACK] = ACTIONS(367),
    [sym_ellipsis] = ACTIONS(369),
    [anon_sym_LBRACE] = ACTIONS(371),
    [anon_sym_RBRACE] = ACTIONS(445),
    [sym_integer] = ACTIONS(373),
    [sym_float] = ACTIONS(369),
    [sym_true] = ACTIONS(373),
    [sym_false] = ACTIONS(373),
    [sym_none] = ACTIONS(373),
    [anon_sym_await] = ACTIONS(375),
    [sym_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(377),
  },
  [111] = {
    [sym_named_expression] = STATE(646),
    [sym_list_splat] = STATE(846),
    [sym_dictionary_splat] = STATE(842),
    [sym__expression] = STATE(646),
    [sym__primary_expression] = STATE(383),
    [sym_not_operator] = STATE(646),
    [sym_boolean_operator] = STATE(646),
    [sym_binary_operator] = STATE(383),
    [sym_unary_operator] = STATE(383),
    [sym_comparison_operator] = STATE(646),
    [sym_lambda] = STATE(646),
    [sym_attribute] = STATE(383),
    [sym_subscript] = STATE(383),
    [sym_call] = STATE(383),
    [sym_list] = STATE(383),
    [sym_list_comprehension] = STATE(383),
    [sym_dictionary] = STATE(383),
    [sym_dictionary_comprehension] = STATE(383),
    [sym_pair] = STATE(693),
    [sym_set] = STATE(383),
    [sym_set_comprehension] = STATE(383),
    [sym_parenthesized_expression] = STATE(383),
    [sym_tuple] = STATE(383),
    [sym_generator_expression] = STATE(383),
    [sym_conditional_expression] = STATE(646),
    [sym_concatenated_string] = STATE(383),
    [sym_string] = STATE(381),
    [sym_await] = STATE(646),
    [sym_identifier] = ACTIONS(387),
    [anon_sym_LPAREN] = ACTIONS(389),
    [anon_sym_COMMA] = ACTIONS(447),
    [anon_sym_STAR] = ACTIONS(355),
    [anon_sym_print] = ACTIONS(393),
    [anon_sym_STAR_STAR] = ACTIONS(359),
    [anon_sym_exec] = ACTIONS(393),
    [anon_sym_not] = ACTIONS(361),
    [anon_sym_PLUS] = ACTIONS(363),
    [anon_sym_DASH] = ACTIONS(363),
    [anon_sym_TILDE] = ACTIONS(363),
    [anon_sym_lambda] = ACTIONS(365),
    [anon_sym_LBRACK] = ACTIONS(367),
    [sym_ellipsis] = ACTIONS(369),
    [anon_sym_LBRACE] = ACTIONS(371),
    [anon_sym_RBRACE] = ACTIONS(449),
    [sym_integer] = ACTIONS(373),
    [sym_float] = ACTIONS(369),
    [sym_true] = ACTIONS(373),
    [sym_false] = ACTIONS(373),
    [sym_none] = ACTIONS(373),
    [anon_sym_await] = ACTIONS(375),
    [sym_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(377),
  },
  [112] = {
    [sym_named_expression] = STATE(742),
    [sym_list_splat] = STATE(941),
    [sym_dictionary_splat] = STATE(941),
    [sym_parenthesized_list_splat] = STATE(941),
    [sym__expression] = STATE(742),
    [sym__primary_expression] = STATE(383),
    [sym_not_operator] = STATE(742),
    [sym_boolean_operator] = STATE(742),
    [sym_binary_operator] = STATE(383),
    [sym_unary_operator] = STATE(383),
    [sym_comparison_operator] = STATE(742),
    [sym_lambda] = STATE(742),
    [sym_attribute] = STATE(383),
    [sym_subscript] = STATE(383),
    [sym_call] = STATE(383),
    [sym_keyword_argument] = STATE(941),
    [sym_list] = STATE(383),
    [sym_list_comprehension] = STATE(383),
    [sym_dictionary] = STATE(383),
    [sym_dictionary_comprehension] = STATE(383),
    [sym_set] = STATE(383),
    [sym_set_comprehension] = STATE(383),
    [sym_parenthesized_expression] = STATE(383),
    [sym_tuple] = STATE(383),
    [sym_generator_expression] = STATE(383),
    [sym_conditional_expression] = STATE(742),
    [sym_concatenated_string] = STATE(383),
    [sym_string] = STATE(381),
    [sym_await] = STATE(742),
    [sym_identifier] = ACTIONS(347),
    [anon_sym_LPAREN] = ACTIONS(349),
    [anon_sym_RPAREN] = ACTIONS(451),
    [anon_sym_STAR] = ACTIONS(355),
    [anon_sym_print] = ACTIONS(357),
    [anon_sym_STAR_STAR] = ACTIONS(359),
    [anon_sym_exec] = ACTIONS(357),
    [anon_sym_not] = ACTIONS(361),
    [anon_sym_PLUS] = ACTIONS(363),
    [anon_sym_DASH] = ACTIONS(363),
    [anon_sym_TILDE] = ACTIONS(363),
    [anon_sym_lambda] = ACTIONS(365),
    [anon_sym_LBRACK] = ACTIONS(367),
    [sym_ellipsis] = ACTIONS(369),
    [anon_sym_LBRACE] = ACTIONS(371),
    [sym_integer] = ACTIONS(373),
    [sym_float] = ACTIONS(369),
    [sym_true] = ACTIONS(373),
    [sym_false] = ACTIONS(373),
    [sym_none] = ACTIONS(373),
    [anon_sym_await] = ACTIONS(375),
    [sym_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(377),
  },
  [113] = {
    [sym_named_expression] = STATE(742),
    [sym_list_splat] = STATE(941),
    [sym_dictionary_splat] = STATE(941),
    [sym_parenthesized_list_splat] = STATE(941),
    [sym__expression] = STATE(742),
    [sym__primary_expression] = STATE(383),
    [sym_not_operator] = STATE(742),
    [sym_boolean_operator] = STATE(742),
    [sym_binary_operator] = STATE(383),
    [sym_unary_operator] = STATE(383),
    [sym_comparison_operator] = STATE(742),
    [sym_lambda] = STATE(742),
    [sym_attribute] = STATE(383),
    [sym_subscript] = STATE(383),
    [sym_call] = STATE(383),
    [sym_keyword_argument] = STATE(941),
    [sym_list] = STATE(383),
    [sym_list_comprehension] = STATE(383),
    [sym_dictionary] = STATE(383),
    [sym_dictionary_comprehension] = STATE(383),
    [sym_set] = STATE(383),
    [sym_set_comprehension] = STATE(383),
    [sym_parenthesized_expression] = STATE(383),
    [sym_tuple] = STATE(383),
    [sym_generator_expression] = STATE(383),
    [sym_conditional_expression] = STATE(742),
    [sym_concatenated_string] = STATE(383),
    [sym_string] = STATE(381),
    [sym_await] = STATE(742),
    [sym_identifier] = ACTIONS(347),
    [anon_sym_LPAREN] = ACTIONS(349),
    [anon_sym_RPAREN] = ACTIONS(453),
    [anon_sym_STAR] = ACTIONS(355),
    [anon_sym_print] = ACTIONS(357),
    [anon_sym_STAR_STAR] = ACTIONS(359),
    [anon_sym_exec] = ACTIONS(357),
    [anon_sym_not] = ACTIONS(361),
    [anon_sym_PLUS] = ACTIONS(363),
    [anon_sym_DASH] = ACTIONS(363),
    [anon_sym_TILDE] = ACTIONS(363),
    [anon_sym_lambda] = ACTIONS(365),
    [anon_sym_LBRACK] = ACTIONS(367),
    [sym_ellipsis] = ACTIONS(369),
    [anon_sym_LBRACE] = ACTIONS(371),
    [sym_integer] = ACTIONS(373),
    [sym_float] = ACTIONS(369),
    [sym_true] = ACTIONS(373),
    [sym_false] = ACTIONS(373),
    [sym_none] = ACTIONS(373),
    [anon_sym_await] = ACTIONS(375),
    [sym_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(377),
  },
  [114] = {
    [sym_named_expression] = STATE(742),
    [sym_list_splat] = STATE(941),
    [sym_dictionary_splat] = STATE(941),
    [sym_parenthesized_list_splat] = STATE(941),
    [sym__expression] = STATE(742),
    [sym__primary_expression] = STATE(383),
    [sym_not_operator] = STATE(742),
    [sym_boolean_operator] = STATE(742),
    [sym_binary_operator] = STATE(383),
    [sym_unary_operator] = STATE(383),
    [sym_comparison_operator] = STATE(742),
    [sym_lambda] = STATE(742),
    [sym_attribute] = STATE(383),
    [sym_subscript] = STATE(383),
    [sym_call] = STATE(383),
    [sym_keyword_argument] = STATE(941),
    [sym_list] = STATE(383),
    [sym_list_comprehension] = STATE(383),
    [sym_dictionary] = STATE(383),
    [sym_dictionary_comprehension] = STATE(383),
    [sym_set] = STATE(383),
    [sym_set_comprehension] = STATE(383),
    [sym_parenthesized_expression] = STATE(383),
    [sym_tuple] = STATE(383),
    [sym_generator_expression] = STATE(383),
    [sym_conditional_expression] = STATE(742),
    [sym_concatenated_string] = STATE(383),
    [sym_string] = STATE(381),
    [sym_await] = STATE(742),
    [sym_identifier] = ACTIONS(347),
    [anon_sym_LPAREN] = ACTIONS(349),
    [anon_sym_RPAREN] = ACTIONS(455),
    [anon_sym_STAR] = ACTIONS(355),
    [anon_sym_print] = ACTIONS(357),
    [anon_sym_STAR_STAR] = ACTIONS(359),
    [anon_sym_exec] = ACTIONS(357),
    [anon_sym_not] = ACTIONS(361),
    [anon_sym_PLUS] = ACTIONS(363),
    [anon_sym_DASH] = ACTIONS(363),
    [anon_sym_TILDE] = ACTIONS(363),
    [anon_sym_lambda] = ACTIONS(365),
    [anon_sym_LBRACK] = ACTIONS(367),
    [sym_ellipsis] = ACTIONS(369),
    [anon_sym_LBRACE] = ACTIONS(371),
    [sym_integer] = ACTIONS(373),
    [sym_float] = ACTIONS(369),
    [sym_true] = ACTIONS(373),
    [sym_false] = ACTIONS(373),
    [sym_none] = ACTIONS(373),
    [anon_sym_await] = ACTIONS(375),
    [sym_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(377),
  },
  [115] = {
    [sym_named_expression] = STATE(742),
    [sym_list_splat] = STATE(941),
    [sym_dictionary_splat] = STATE(941),
    [sym_parenthesized_list_splat] = STATE(941),
    [sym__expression] = STATE(742),
    [sym__primary_expression] = STATE(383),
    [sym_not_operator] = STATE(742),
    [sym_boolean_operator] = STATE(742),
    [sym_binary_operator] = STATE(383),
    [sym_unary_operator] = STATE(383),
    [sym_comparison_operator] = STATE(742),
    [sym_lambda] = STATE(742),
    [sym_attribute] = STATE(383),
    [sym_subscript] = STATE(383),
    [sym_call] = STATE(383),
    [sym_keyword_argument] = STATE(941),
    [sym_list] = STATE(383),
    [sym_list_comprehension] = STATE(383),
    [sym_dictionary] = STATE(383),
    [sym_dictionary_comprehension] = STATE(383),
    [sym_set] = STATE(383),
    [sym_set_comprehension] = STATE(383),
    [sym_parenthesized_expression] = STATE(383),
    [sym_tuple] = STATE(383),
    [sym_generator_expression] = STATE(383),
    [sym_conditional_expression] = STATE(742),
    [sym_concatenated_string] = STATE(383),
    [sym_string] = STATE(381),
    [sym_await] = STATE(742),
    [sym_identifier] = ACTIONS(347),
    [anon_sym_LPAREN] = ACTIONS(349),
    [anon_sym_RPAREN] = ACTIONS(457),
    [anon_sym_STAR] = ACTIONS(355),
    [anon_sym_print] = ACTIONS(357),
    [anon_sym_STAR_STAR] = ACTIONS(359),
    [anon_sym_exec] = ACTIONS(357),
    [anon_sym_not] = ACTIONS(361),
    [anon_sym_PLUS] = ACTIONS(363),
    [anon_sym_DASH] = ACTIONS(363),
    [anon_sym_TILDE] = ACTIONS(363),
    [anon_sym_lambda] = ACTIONS(365),
    [anon_sym_LBRACK] = ACTIONS(367),
    [sym_ellipsis] = ACTIONS(369),
    [anon_sym_LBRACE] = ACTIONS(371),
    [sym_integer] = ACTIONS(373),
    [sym_float] = ACTIONS(369),
    [sym_true] = ACTIONS(373),
    [sym_false] = ACTIONS(373),
    [sym_none] = ACTIONS(373),
    [anon_sym_await] = ACTIONS(375),
    [sym_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(377),
  },
  [116] = {
    [sym_named_expression] = STATE(654),
    [sym_list_splat] = STATE(1021),
    [sym_parenthesized_list_splat] = STATE(1021),
    [sym__expression] = STATE(654),
    [sym__primary_expression] = STATE(383),
    [sym_not_operator] = STATE(654),
    [sym_boolean_operator] = STATE(654),
    [sym_binary_operator] = STATE(383),
    [sym_unary_operator] = STATE(383),
    [sym_comparison_operator] = STATE(654),
    [sym_lambda] = STATE(654),
    [sym_yield] = STATE(833),
    [sym_attribute] = STATE(383),
    [sym_subscript] = STATE(383),
    [sym_call] = STATE(383),
    [sym_list] = STATE(383),
    [sym_list_comprehension] = STATE(383),
    [sym_dictionary] = STATE(383),
    [sym_dictionary_comprehension] = STATE(383),
    [sym_set] = STATE(383),
    [sym_set_comprehension] = STATE(383),
    [sym_parenthesized_expression] = STATE(383),
    [sym_tuple] = STATE(383),
    [sym_generator_expression] = STATE(383),
    [sym_conditional_expression] = STATE(654),
    [sym_concatenated_string] = STATE(383),
    [sym_string] = STATE(381),
    [sym_await] = STATE(654),
    [sym_identifier] = ACTIONS(387),
    [anon_sym_LPAREN] = ACTIONS(349),
    [anon_sym_RPAREN] = ACTIONS(459),
    [anon_sym_COMMA] = ACTIONS(461),
    [anon_sym_STAR] = ACTIONS(463),
    [anon_sym_print] = ACTIONS(393),
    [anon_sym_exec] = ACTIONS(393),
    [anon_sym_not] = ACTIONS(361),
    [anon_sym_PLUS] = ACTIONS(363),
    [anon_sym_DASH] = ACTIONS(363),
    [anon_sym_TILDE] = ACTIONS(363),
    [anon_sym_lambda] = ACTIONS(365),
    [anon_sym_yield] = ACTIONS(465),
    [anon_sym_LBRACK] = ACTIONS(367),
    [sym_ellipsis] = ACTIONS(369),
    [anon_sym_LBRACE] = ACTIONS(371),
    [sym_integer] = ACTIONS(373),
    [sym_float] = ACTIONS(369),
    [sym_true] = ACTIONS(373),
    [sym_false] = ACTIONS(373),
    [sym_none] = ACTIONS(373),
    [anon_sym_await] = ACTIONS(375),
    [sym_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(377),
  },
  [117] = {
    [sym_string] = STATE(122),
    [aux_sym_concatenated_string_repeat1] = STATE(122),
    [anon_sym_DOT] = ACTIONS(467),
    [anon_sym_from] = ACTIONS(467),
    [anon_sym_LPAREN] = ACTIONS(467),
    [anon_sym_COMMA] = ACTIONS(467),
    [anon_sym_STAR] = ACTIONS(469),
    [anon_sym_GT_GT] = ACTIONS(469),
    [anon_sym_if] = ACTIONS(467),
    [anon_sym_COLON] = ACTIONS(467),
    [anon_sym_in] = ACTIONS(467),
    [anon_sym_EQ] = ACTIONS(469),
    [anon_sym_STAR_STAR] = ACTIONS(469),
    [anon_sym_AT] = ACTIONS(469),
    [anon_sym_not] = ACTIONS(467),
    [anon_sym_and] = ACTIONS(467),
    [anon_sym_or] = ACTIONS(467),
    [anon_sym_PLUS] = ACTIONS(469),
    [anon_sym_DASH] = ACTIONS(469),
    [anon_sym_SLASH] = ACTIONS(469),
    [anon_sym_PERCENT] = ACTIONS(469),
    [anon_sym_SLASH_SLASH] = ACTIONS(469),
    [anon_sym_PIPE] = ACTIONS(469),
    [anon_sym_AMP] = ACTIONS(469),
    [anon_sym_CARET] = ACTIONS(469),
    [anon_sym_LT_LT] = ACTIONS(469),
    [anon_sym_LT] = ACTIONS(469),
    [anon_sym_LT_EQ] = ACTIONS(467),
    [anon_sym_EQ_EQ] = ACTIONS(467),
    [anon_sym_BANG_EQ] = ACTIONS(467),
    [anon_sym_GT_EQ] = ACTIONS(467),
    [anon_sym_GT] = ACTIONS(469),
    [anon_sym_LT_GT] = ACTIONS(467),
    [anon_sym_is] = ACTIONS(467),
    [anon_sym_PLUS_EQ] = ACTIONS(467),
    [anon_sym_DASH_EQ] = ACTIONS(467),
    [anon_sym_STAR_EQ] = ACTIONS(467),
    [anon_sym_SLASH_EQ] = ACTIONS(467),
    [anon_sym_AT_EQ] = ACTIONS(467),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(467),
    [anon_sym_PERCENT_EQ] = ACTIONS(467),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(467),
    [anon_sym_GT_GT_EQ] = ACTIONS(467),
    [anon_sym_LT_LT_EQ] = ACTIONS(467),
    [anon_sym_AMP_EQ] = ACTIONS(467),
    [anon_sym_CARET_EQ] = ACTIONS(467),
    [anon_sym_PIPE_EQ] = ACTIONS(467),
    [anon_sym_LBRACK] = ACTIONS(467),
    [sym_comment] = ACTIONS(3),
    [sym__semicolon] = ACTIONS(467),
    [sym__newline] = ACTIONS(467),
    [sym__string_start] = ACTIONS(73),
  },
  [118] = {
    [sym_named_expression] = STATE(742),
    [sym_list_splat] = STATE(941),
    [sym_dictionary_splat] = STATE(941),
    [sym_parenthesized_list_splat] = STATE(941),
    [sym__expression] = STATE(742),
    [sym__primary_expression] = STATE(383),
    [sym_not_operator] = STATE(742),
    [sym_boolean_operator] = STATE(742),
    [sym_binary_operator] = STATE(383),
    [sym_unary_operator] = STATE(383),
    [sym_comparison_operator] = STATE(742),
    [sym_lambda] = STATE(742),
    [sym_attribute] = STATE(383),
    [sym_subscript] = STATE(383),
    [sym_call] = STATE(383),
    [sym_keyword_argument] = STATE(941),
    [sym_list] = STATE(383),
    [sym_list_comprehension] = STATE(383),
    [sym_dictionary] = STATE(383),
    [sym_dictionary_comprehension] = STATE(383),
    [sym_set] = STATE(383),
    [sym_set_comprehension] = STATE(383),
    [sym_parenthesized_expression] = STATE(383),
    [sym_tuple] = STATE(383),
    [sym_generator_expression] = STATE(383),
    [sym_conditional_expression] = STATE(742),
    [sym_concatenated_string] = STATE(383),
    [sym_string] = STATE(381),
    [sym_await] = STATE(742),
    [sym_identifier] = ACTIONS(347),
    [anon_sym_LPAREN] = ACTIONS(349),
    [anon_sym_RPAREN] = ACTIONS(471),
    [anon_sym_STAR] = ACTIONS(355),
    [anon_sym_print] = ACTIONS(357),
    [anon_sym_STAR_STAR] = ACTIONS(359),
    [anon_sym_exec] = ACTIONS(357),
    [anon_sym_not] = ACTIONS(361),
    [anon_sym_PLUS] = ACTIONS(363),
    [anon_sym_DASH] = ACTIONS(363),
    [anon_sym_TILDE] = ACTIONS(363),
    [anon_sym_lambda] = ACTIONS(365),
    [anon_sym_LBRACK] = ACTIONS(367),
    [sym_ellipsis] = ACTIONS(369),
    [anon_sym_LBRACE] = ACTIONS(371),
    [sym_integer] = ACTIONS(373),
    [sym_float] = ACTIONS(369),
    [sym_true] = ACTIONS(373),
    [sym_false] = ACTIONS(373),
    [sym_none] = ACTIONS(373),
    [anon_sym_await] = ACTIONS(375),
    [sym_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(377),
  },
  [119] = {
    [sym_named_expression] = STATE(742),
    [sym_list_splat] = STATE(941),
    [sym_dictionary_splat] = STATE(941),
    [sym_parenthesized_list_splat] = STATE(941),
    [sym__expression] = STATE(742),
    [sym__primary_expression] = STATE(383),
    [sym_not_operator] = STATE(742),
    [sym_boolean_operator] = STATE(742),
    [sym_binary_operator] = STATE(383),
    [sym_unary_operator] = STATE(383),
    [sym_comparison_operator] = STATE(742),
    [sym_lambda] = STATE(742),
    [sym_attribute] = STATE(383),
    [sym_subscript] = STATE(383),
    [sym_call] = STATE(383),
    [sym_keyword_argument] = STATE(941),
    [sym_list] = STATE(383),
    [sym_list_comprehension] = STATE(383),
    [sym_dictionary] = STATE(383),
    [sym_dictionary_comprehension] = STATE(383),
    [sym_set] = STATE(383),
    [sym_set_comprehension] = STATE(383),
    [sym_parenthesized_expression] = STATE(383),
    [sym_tuple] = STATE(383),
    [sym_generator_expression] = STATE(383),
    [sym_conditional_expression] = STATE(742),
    [sym_concatenated_string] = STATE(383),
    [sym_string] = STATE(381),
    [sym_await] = STATE(742),
    [sym_identifier] = ACTIONS(347),
    [anon_sym_LPAREN] = ACTIONS(349),
    [anon_sym_RPAREN] = ACTIONS(473),
    [anon_sym_STAR] = ACTIONS(355),
    [anon_sym_print] = ACTIONS(357),
    [anon_sym_STAR_STAR] = ACTIONS(359),
    [anon_sym_exec] = ACTIONS(357),
    [anon_sym_not] = ACTIONS(361),
    [anon_sym_PLUS] = ACTIONS(363),
    [anon_sym_DASH] = ACTIONS(363),
    [anon_sym_TILDE] = ACTIONS(363),
    [anon_sym_lambda] = ACTIONS(365),
    [anon_sym_LBRACK] = ACTIONS(367),
    [sym_ellipsis] = ACTIONS(369),
    [anon_sym_LBRACE] = ACTIONS(371),
    [sym_integer] = ACTIONS(373),
    [sym_float] = ACTIONS(369),
    [sym_true] = ACTIONS(373),
    [sym_false] = ACTIONS(373),
    [sym_none] = ACTIONS(373),
    [anon_sym_await] = ACTIONS(375),
    [sym_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(377),
  },
  [120] = {
    [sym_string] = STATE(120),
    [aux_sym_concatenated_string_repeat1] = STATE(120),
    [anon_sym_DOT] = ACTIONS(475),
    [anon_sym_from] = ACTIONS(475),
    [anon_sym_LPAREN] = ACTIONS(475),
    [anon_sym_COMMA] = ACTIONS(475),
    [anon_sym_STAR] = ACTIONS(477),
    [anon_sym_GT_GT] = ACTIONS(477),
    [anon_sym_if] = ACTIONS(475),
    [anon_sym_COLON] = ACTIONS(475),
    [anon_sym_in] = ACTIONS(475),
    [anon_sym_EQ] = ACTIONS(477),
    [anon_sym_STAR_STAR] = ACTIONS(477),
    [anon_sym_AT] = ACTIONS(477),
    [anon_sym_not] = ACTIONS(475),
    [anon_sym_and] = ACTIONS(475),
    [anon_sym_or] = ACTIONS(475),
    [anon_sym_PLUS] = ACTIONS(477),
    [anon_sym_DASH] = ACTIONS(477),
    [anon_sym_SLASH] = ACTIONS(477),
    [anon_sym_PERCENT] = ACTIONS(477),
    [anon_sym_SLASH_SLASH] = ACTIONS(477),
    [anon_sym_PIPE] = ACTIONS(477),
    [anon_sym_AMP] = ACTIONS(477),
    [anon_sym_CARET] = ACTIONS(477),
    [anon_sym_LT_LT] = ACTIONS(477),
    [anon_sym_LT] = ACTIONS(477),
    [anon_sym_LT_EQ] = ACTIONS(475),
    [anon_sym_EQ_EQ] = ACTIONS(475),
    [anon_sym_BANG_EQ] = ACTIONS(475),
    [anon_sym_GT_EQ] = ACTIONS(475),
    [anon_sym_GT] = ACTIONS(477),
    [anon_sym_LT_GT] = ACTIONS(475),
    [anon_sym_is] = ACTIONS(475),
    [anon_sym_PLUS_EQ] = ACTIONS(475),
    [anon_sym_DASH_EQ] = ACTIONS(475),
    [anon_sym_STAR_EQ] = ACTIONS(475),
    [anon_sym_SLASH_EQ] = ACTIONS(475),
    [anon_sym_AT_EQ] = ACTIONS(475),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(475),
    [anon_sym_PERCENT_EQ] = ACTIONS(475),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(475),
    [anon_sym_GT_GT_EQ] = ACTIONS(475),
    [anon_sym_LT_LT_EQ] = ACTIONS(475),
    [anon_sym_AMP_EQ] = ACTIONS(475),
    [anon_sym_CARET_EQ] = ACTIONS(475),
    [anon_sym_PIPE_EQ] = ACTIONS(475),
    [anon_sym_LBRACK] = ACTIONS(475),
    [sym_comment] = ACTIONS(3),
    [sym__semicolon] = ACTIONS(475),
    [sym__newline] = ACTIONS(475),
    [sym__string_start] = ACTIONS(479),
  },
  [121] = {
    [sym_named_expression] = STATE(648),
    [sym_list_splat] = STATE(898),
    [sym_dictionary_splat] = STATE(896),
    [sym__expression] = STATE(648),
    [sym__primary_expression] = STATE(383),
    [sym_not_operator] = STATE(648),
    [sym_boolean_operator] = STATE(648),
    [sym_binary_operator] = STATE(383),
    [sym_unary_operator] = STATE(383),
    [sym_comparison_operator] = STATE(648),
    [sym_lambda] = STATE(648),
    [sym_attribute] = STATE(383),
    [sym_subscript] = STATE(383),
    [sym_call] = STATE(383),
    [sym_list] = STATE(383),
    [sym_list_comprehension] = STATE(383),
    [sym_dictionary] = STATE(383),
    [sym_dictionary_comprehension] = STATE(383),
    [sym_pair] = STATE(677),
    [sym_set] = STATE(383),
    [sym_set_comprehension] = STATE(383),
    [sym_parenthesized_expression] = STATE(383),
    [sym_tuple] = STATE(383),
    [sym_generator_expression] = STATE(383),
    [sym_conditional_expression] = STATE(648),
    [sym_concatenated_string] = STATE(383),
    [sym_string] = STATE(381),
    [sym_await] = STATE(648),
    [sym_identifier] = ACTIONS(387),
    [anon_sym_LPAREN] = ACTIONS(389),
    [anon_sym_COMMA] = ACTIONS(482),
    [anon_sym_STAR] = ACTIONS(355),
    [anon_sym_print] = ACTIONS(393),
    [anon_sym_STAR_STAR] = ACTIONS(359),
    [anon_sym_exec] = ACTIONS(393),
    [anon_sym_not] = ACTIONS(361),
    [anon_sym_PLUS] = ACTIONS(363),
    [anon_sym_DASH] = ACTIONS(363),
    [anon_sym_TILDE] = ACTIONS(363),
    [anon_sym_lambda] = ACTIONS(365),
    [anon_sym_LBRACK] = ACTIONS(367),
    [sym_ellipsis] = ACTIONS(369),
    [anon_sym_LBRACE] = ACTIONS(371),
    [anon_sym_RBRACE] = ACTIONS(484),
    [sym_integer] = ACTIONS(373),
    [sym_float] = ACTIONS(369),
    [sym_true] = ACTIONS(373),
    [sym_false] = ACTIONS(373),
    [sym_none] = ACTIONS(373),
    [anon_sym_await] = ACTIONS(375),
    [sym_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(377),
  },
  [122] = {
    [sym_string] = STATE(120),
    [aux_sym_concatenated_string_repeat1] = STATE(120),
    [anon_sym_DOT] = ACTIONS(486),
    [anon_sym_from] = ACTIONS(486),
    [anon_sym_LPAREN] = ACTIONS(486),
    [anon_sym_COMMA] = ACTIONS(486),
    [anon_sym_STAR] = ACTIONS(488),
    [anon_sym_GT_GT] = ACTIONS(488),
    [anon_sym_if] = ACTIONS(486),
    [anon_sym_COLON] = ACTIONS(486),
    [anon_sym_in] = ACTIONS(486),
    [anon_sym_EQ] = ACTIONS(488),
    [anon_sym_STAR_STAR] = ACTIONS(488),
    [anon_sym_AT] = ACTIONS(488),
    [anon_sym_not] = ACTIONS(486),
    [anon_sym_and] = ACTIONS(486),
    [anon_sym_or] = ACTIONS(486),
    [anon_sym_PLUS] = ACTIONS(488),
    [anon_sym_DASH] = ACTIONS(488),
    [anon_sym_SLASH] = ACTIONS(488),
    [anon_sym_PERCENT] = ACTIONS(488),
    [anon_sym_SLASH_SLASH] = ACTIONS(488),
    [anon_sym_PIPE] = ACTIONS(488),
    [anon_sym_AMP] = ACTIONS(488),
    [anon_sym_CARET] = ACTIONS(488),
    [anon_sym_LT_LT] = ACTIONS(488),
    [anon_sym_LT] = ACTIONS(488),
    [anon_sym_LT_EQ] = ACTIONS(486),
    [anon_sym_EQ_EQ] = ACTIONS(486),
    [anon_sym_BANG_EQ] = ACTIONS(486),
    [anon_sym_GT_EQ] = ACTIONS(486),
    [anon_sym_GT] = ACTIONS(488),
    [anon_sym_LT_GT] = ACTIONS(486),
    [anon_sym_is] = ACTIONS(486),
    [anon_sym_PLUS_EQ] = ACTIONS(486),
    [anon_sym_DASH_EQ] = ACTIONS(486),
    [anon_sym_STAR_EQ] = ACTIONS(486),
    [anon_sym_SLASH_EQ] = ACTIONS(486),
    [anon_sym_AT_EQ] = ACTIONS(486),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(486),
    [anon_sym_PERCENT_EQ] = ACTIONS(486),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(486),
    [anon_sym_GT_GT_EQ] = ACTIONS(486),
    [anon_sym_LT_LT_EQ] = ACTIONS(486),
    [anon_sym_AMP_EQ] = ACTIONS(486),
    [anon_sym_CARET_EQ] = ACTIONS(486),
    [anon_sym_PIPE_EQ] = ACTIONS(486),
    [anon_sym_LBRACK] = ACTIONS(486),
    [sym_comment] = ACTIONS(3),
    [sym__semicolon] = ACTIONS(486),
    [sym__newline] = ACTIONS(486),
    [sym__string_start] = ACTIONS(73),
  },
  [123] = {
    [sym_named_expression] = STATE(599),
    [sym_expression_list] = STATE(615),
    [sym__expression] = STATE(599),
    [sym__primary_expression] = STATE(109),
    [sym_not_operator] = STATE(599),
    [sym_boolean_operator] = STATE(599),
    [sym_binary_operator] = STATE(109),
    [sym_unary_operator] = STATE(109),
    [sym_comparison_operator] = STATE(599),
    [sym_lambda] = STATE(599),
    [sym_assignment] = STATE(950),
    [sym_augmented_assignment] = STATE(950),
    [sym__right_hand_side] = STATE(950),
    [sym_yield] = STATE(950),
    [sym_attribute] = STATE(109),
    [sym_subscript] = STATE(109),
    [sym_call] = STATE(109),
    [sym_list] = STATE(109),
    [sym_list_comprehension] = STATE(109),
    [sym_dictionary] = STATE(109),
    [sym_dictionary_comprehension] = STATE(109),
    [sym_set] = STATE(109),
    [sym_set_comprehension] = STATE(109),
    [sym_parenthesized_expression] = STATE(109),
    [sym_tuple] = STATE(109),
    [sym_generator_expression] = STATE(109),
    [sym_conditional_expression] = STATE(599),
    [sym_concatenated_string] = STATE(109),
    [sym_string] = STATE(117),
    [sym_await] = STATE(599),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(13),
    [anon_sym_print] = ACTIONS(237),
    [anon_sym_exec] = ACTIONS(237),
    [anon_sym_not] = ACTIONS(55),
    [anon_sym_PLUS] = ACTIONS(57),
    [anon_sym_DASH] = ACTIONS(57),
    [anon_sym_TILDE] = ACTIONS(57),
    [anon_sym_lambda] = ACTIONS(59),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [sym_ellipsis] = ACTIONS(65),
    [anon_sym_LBRACE] = ACTIONS(67),
    [sym_integer] = ACTIONS(69),
    [sym_float] = ACTIONS(65),
    [sym_true] = ACTIONS(69),
    [sym_false] = ACTIONS(69),
    [sym_none] = ACTIONS(69),
    [anon_sym_await] = ACTIONS(71),
    [sym_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(73),
  },
  [124] = {
    [sym_named_expression] = STATE(599),
    [sym_expression_list] = STATE(615),
    [sym__expression] = STATE(599),
    [sym__primary_expression] = STATE(109),
    [sym_not_operator] = STATE(599),
    [sym_boolean_operator] = STATE(599),
    [sym_binary_operator] = STATE(109),
    [sym_unary_operator] = STATE(109),
    [sym_comparison_operator] = STATE(599),
    [sym_lambda] = STATE(599),
    [sym_assignment] = STATE(949),
    [sym_augmented_assignment] = STATE(949),
    [sym__right_hand_side] = STATE(949),
    [sym_yield] = STATE(949),
    [sym_attribute] = STATE(109),
    [sym_subscript] = STATE(109),
    [sym_call] = STATE(109),
    [sym_list] = STATE(109),
    [sym_list_comprehension] = STATE(109),
    [sym_dictionary] = STATE(109),
    [sym_dictionary_comprehension] = STATE(109),
    [sym_set] = STATE(109),
    [sym_set_comprehension] = STATE(109),
    [sym_parenthesized_expression] = STATE(109),
    [sym_tuple] = STATE(109),
    [sym_generator_expression] = STATE(109),
    [sym_conditional_expression] = STATE(599),
    [sym_concatenated_string] = STATE(109),
    [sym_string] = STATE(117),
    [sym_await] = STATE(599),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(13),
    [anon_sym_print] = ACTIONS(237),
    [anon_sym_exec] = ACTIONS(237),
    [anon_sym_not] = ACTIONS(55),
    [anon_sym_PLUS] = ACTIONS(57),
    [anon_sym_DASH] = ACTIONS(57),
    [anon_sym_TILDE] = ACTIONS(57),
    [anon_sym_lambda] = ACTIONS(59),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [sym_ellipsis] = ACTIONS(65),
    [anon_sym_LBRACE] = ACTIONS(67),
    [sym_integer] = ACTIONS(69),
    [sym_float] = ACTIONS(65),
    [sym_true] = ACTIONS(69),
    [sym_false] = ACTIONS(69),
    [sym_none] = ACTIONS(69),
    [anon_sym_await] = ACTIONS(71),
    [sym_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(73),
  },
  [125] = {
    [sym_argument_list] = STATE(145),
    [sym_generator_expression] = STATE(145),
    [anon_sym_DOT] = ACTIONS(490),
    [anon_sym_from] = ACTIONS(490),
    [anon_sym_LPAREN] = ACTIONS(415),
    [anon_sym_COMMA] = ACTIONS(490),
    [anon_sym_STAR] = ACTIONS(492),
    [anon_sym_GT_GT] = ACTIONS(492),
    [anon_sym_if] = ACTIONS(490),
    [anon_sym_COLON] = ACTIONS(490),
    [anon_sym_in] = ACTIONS(490),
    [anon_sym_EQ] = ACTIONS(492),
    [anon_sym_STAR_STAR] = ACTIONS(492),
    [anon_sym_AT] = ACTIONS(492),
    [anon_sym_not] = ACTIONS(490),
    [anon_sym_and] = ACTIONS(490),
    [anon_sym_or] = ACTIONS(490),
    [anon_sym_PLUS] = ACTIONS(492),
    [anon_sym_DASH] = ACTIONS(492),
    [anon_sym_SLASH] = ACTIONS(492),
    [anon_sym_PERCENT] = ACTIONS(492),
    [anon_sym_SLASH_SLASH] = ACTIONS(492),
    [anon_sym_PIPE] = ACTIONS(492),
    [anon_sym_AMP] = ACTIONS(492),
    [anon_sym_CARET] = ACTIONS(492),
    [anon_sym_LT_LT] = ACTIONS(492),
    [anon_sym_LT] = ACTIONS(492),
    [anon_sym_LT_EQ] = ACTIONS(490),
    [anon_sym_EQ_EQ] = ACTIONS(490),
    [anon_sym_BANG_EQ] = ACTIONS(490),
    [anon_sym_GT_EQ] = ACTIONS(490),
    [anon_sym_GT] = ACTIONS(492),
    [anon_sym_LT_GT] = ACTIONS(490),
    [anon_sym_is] = ACTIONS(490),
    [anon_sym_PLUS_EQ] = ACTIONS(490),
    [anon_sym_DASH_EQ] = ACTIONS(490),
    [anon_sym_STAR_EQ] = ACTIONS(490),
    [anon_sym_SLASH_EQ] = ACTIONS(490),
    [anon_sym_AT_EQ] = ACTIONS(490),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(490),
    [anon_sym_PERCENT_EQ] = ACTIONS(490),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(490),
    [anon_sym_GT_GT_EQ] = ACTIONS(490),
    [anon_sym_LT_LT_EQ] = ACTIONS(490),
    [anon_sym_AMP_EQ] = ACTIONS(490),
    [anon_sym_CARET_EQ] = ACTIONS(490),
    [anon_sym_PIPE_EQ] = ACTIONS(490),
    [anon_sym_LBRACK] = ACTIONS(490),
    [sym_comment] = ACTIONS(3),
    [sym__semicolon] = ACTIONS(490),
    [sym__newline] = ACTIONS(490),
  },
  [126] = {
    [sym_named_expression] = STATE(599),
    [sym_expression_list] = STATE(615),
    [sym__expression] = STATE(599),
    [sym__primary_expression] = STATE(109),
    [sym_not_operator] = STATE(599),
    [sym_boolean_operator] = STATE(599),
    [sym_binary_operator] = STATE(109),
    [sym_unary_operator] = STATE(109),
    [sym_comparison_operator] = STATE(599),
    [sym_lambda] = STATE(599),
    [sym_assignment] = STATE(940),
    [sym_augmented_assignment] = STATE(940),
    [sym__right_hand_side] = STATE(940),
    [sym_yield] = STATE(940),
    [sym_attribute] = STATE(109),
    [sym_subscript] = STATE(109),
    [sym_call] = STATE(109),
    [sym_list] = STATE(109),
    [sym_list_comprehension] = STATE(109),
    [sym_dictionary] = STATE(109),
    [sym_dictionary_comprehension] = STATE(109),
    [sym_set] = STATE(109),
    [sym_set_comprehension] = STATE(109),
    [sym_parenthesized_expression] = STATE(109),
    [sym_tuple] = STATE(109),
    [sym_generator_expression] = STATE(109),
    [sym_conditional_expression] = STATE(599),
    [sym_concatenated_string] = STATE(109),
    [sym_string] = STATE(117),
    [sym_await] = STATE(599),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(13),
    [anon_sym_print] = ACTIONS(237),
    [anon_sym_exec] = ACTIONS(237),
    [anon_sym_not] = ACTIONS(55),
    [anon_sym_PLUS] = ACTIONS(57),
    [anon_sym_DASH] = ACTIONS(57),
    [anon_sym_TILDE] = ACTIONS(57),
    [anon_sym_lambda] = ACTIONS(59),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [sym_ellipsis] = ACTIONS(65),
    [anon_sym_LBRACE] = ACTIONS(67),
    [sym_integer] = ACTIONS(69),
    [sym_float] = ACTIONS(65),
    [sym_true] = ACTIONS(69),
    [sym_false] = ACTIONS(69),
    [sym_none] = ACTIONS(69),
    [anon_sym_await] = ACTIONS(71),
    [sym_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(73),
  },
  [127] = {
    [sym_argument_list] = STATE(145),
    [sym_generator_expression] = STATE(145),
    [anon_sym_DOT] = ACTIONS(494),
    [anon_sym_from] = ACTIONS(494),
    [anon_sym_LPAREN] = ACTIONS(415),
    [anon_sym_COMMA] = ACTIONS(494),
    [anon_sym_STAR] = ACTIONS(496),
    [anon_sym_GT_GT] = ACTIONS(496),
    [anon_sym_if] = ACTIONS(494),
    [anon_sym_COLON] = ACTIONS(494),
    [anon_sym_in] = ACTIONS(494),
    [anon_sym_EQ] = ACTIONS(496),
    [anon_sym_STAR_STAR] = ACTIONS(425),
    [anon_sym_AT] = ACTIONS(496),
    [anon_sym_not] = ACTIONS(494),
    [anon_sym_and] = ACTIONS(494),
    [anon_sym_or] = ACTIONS(494),
    [anon_sym_PLUS] = ACTIONS(496),
    [anon_sym_DASH] = ACTIONS(496),
    [anon_sym_SLASH] = ACTIONS(496),
    [anon_sym_PERCENT] = ACTIONS(496),
    [anon_sym_SLASH_SLASH] = ACTIONS(496),
    [anon_sym_PIPE] = ACTIONS(496),
    [anon_sym_AMP] = ACTIONS(496),
    [anon_sym_CARET] = ACTIONS(496),
    [anon_sym_LT_LT] = ACTIONS(496),
    [anon_sym_LT] = ACTIONS(496),
    [anon_sym_LT_EQ] = ACTIONS(494),
    [anon_sym_EQ_EQ] = ACTIONS(494),
    [anon_sym_BANG_EQ] = ACTIONS(494),
    [anon_sym_GT_EQ] = ACTIONS(494),
    [anon_sym_GT] = ACTIONS(496),
    [anon_sym_LT_GT] = ACTIONS(494),
    [anon_sym_is] = ACTIONS(494),
    [anon_sym_PLUS_EQ] = ACTIONS(494),
    [anon_sym_DASH_EQ] = ACTIONS(494),
    [anon_sym_STAR_EQ] = ACTIONS(494),
    [anon_sym_SLASH_EQ] = ACTIONS(494),
    [anon_sym_AT_EQ] = ACTIONS(494),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(494),
    [anon_sym_PERCENT_EQ] = ACTIONS(494),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(494),
    [anon_sym_GT_GT_EQ] = ACTIONS(494),
    [anon_sym_LT_LT_EQ] = ACTIONS(494),
    [anon_sym_AMP_EQ] = ACTIONS(494),
    [anon_sym_CARET_EQ] = ACTIONS(494),
    [anon_sym_PIPE_EQ] = ACTIONS(494),
    [anon_sym_LBRACK] = ACTIONS(494),
    [sym_comment] = ACTIONS(3),
    [sym__semicolon] = ACTIONS(494),
    [sym__newline] = ACTIONS(494),
  },
  [128] = {
    [sym_argument_list] = STATE(145),
    [sym_generator_expression] = STATE(145),
    [anon_sym_DOT] = ACTIONS(494),
    [anon_sym_from] = ACTIONS(494),
    [anon_sym_LPAREN] = ACTIONS(415),
    [anon_sym_COMMA] = ACTIONS(494),
    [anon_sym_STAR] = ACTIONS(417),
    [anon_sym_GT_GT] = ACTIONS(496),
    [anon_sym_if] = ACTIONS(494),
    [anon_sym_COLON] = ACTIONS(494),
    [anon_sym_in] = ACTIONS(494),
    [anon_sym_EQ] = ACTIONS(496),
    [anon_sym_STAR_STAR] = ACTIONS(425),
    [anon_sym_AT] = ACTIONS(417),
    [anon_sym_not] = ACTIONS(494),
    [anon_sym_and] = ACTIONS(494),
    [anon_sym_or] = ACTIONS(494),
    [anon_sym_PLUS] = ACTIONS(429),
    [anon_sym_DASH] = ACTIONS(429),
    [anon_sym_SLASH] = ACTIONS(417),
    [anon_sym_PERCENT] = ACTIONS(417),
    [anon_sym_SLASH_SLASH] = ACTIONS(417),
    [anon_sym_PIPE] = ACTIONS(496),
    [anon_sym_AMP] = ACTIONS(496),
    [anon_sym_CARET] = ACTIONS(496),
    [anon_sym_LT_LT] = ACTIONS(496),
    [anon_sym_LT] = ACTIONS(496),
    [anon_sym_LT_EQ] = ACTIONS(494),
    [anon_sym_EQ_EQ] = ACTIONS(494),
    [anon_sym_BANG_EQ] = ACTIONS(494),
    [anon_sym_GT_EQ] = ACTIONS(494),
    [anon_sym_GT] = ACTIONS(496),
    [anon_sym_LT_GT] = ACTIONS(494),
    [anon_sym_is] = ACTIONS(494),
    [anon_sym_PLUS_EQ] = ACTIONS(494),
    [anon_sym_DASH_EQ] = ACTIONS(494),
    [anon_sym_STAR_EQ] = ACTIONS(494),
    [anon_sym_SLASH_EQ] = ACTIONS(494),
    [anon_sym_AT_EQ] = ACTIONS(494),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(494),
    [anon_sym_PERCENT_EQ] = ACTIONS(494),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(494),
    [anon_sym_GT_GT_EQ] = ACTIONS(494),
    [anon_sym_LT_LT_EQ] = ACTIONS(494),
    [anon_sym_AMP_EQ] = ACTIONS(494),
    [anon_sym_CARET_EQ] = ACTIONS(494),
    [anon_sym_PIPE_EQ] = ACTIONS(494),
    [anon_sym_LBRACK] = ACTIONS(494),
    [sym_comment] = ACTIONS(3),
    [sym__semicolon] = ACTIONS(494),
    [sym__newline] = ACTIONS(494),
  },
  [129] = {
    [sym_argument_list] = STATE(145),
    [sym_generator_expression] = STATE(145),
    [anon_sym_DOT] = ACTIONS(494),
    [anon_sym_from] = ACTIONS(494),
    [anon_sym_LPAREN] = ACTIONS(415),
    [anon_sym_COMMA] = ACTIONS(494),
    [anon_sym_STAR] = ACTIONS(417),
    [anon_sym_GT_GT] = ACTIONS(419),
    [anon_sym_if] = ACTIONS(494),
    [anon_sym_COLON] = ACTIONS(494),
    [anon_sym_in] = ACTIONS(494),
    [anon_sym_EQ] = ACTIONS(496),
    [anon_sym_STAR_STAR] = ACTIONS(425),
    [anon_sym_AT] = ACTIONS(417),
    [anon_sym_not] = ACTIONS(494),
    [anon_sym_and] = ACTIONS(494),
    [anon_sym_or] = ACTIONS(494),
    [anon_sym_PLUS] = ACTIONS(429),
    [anon_sym_DASH] = ACTIONS(429),
    [anon_sym_SLASH] = ACTIONS(417),
    [anon_sym_PERCENT] = ACTIONS(417),
    [anon_sym_SLASH_SLASH] = ACTIONS(417),
    [anon_sym_PIPE] = ACTIONS(496),
    [anon_sym_AMP] = ACTIONS(433),
    [anon_sym_CARET] = ACTIONS(435),
    [anon_sym_LT_LT] = ACTIONS(419),
    [anon_sym_LT] = ACTIONS(496),
    [anon_sym_LT_EQ] = ACTIONS(494),
    [anon_sym_EQ_EQ] = ACTIONS(494),
    [anon_sym_BANG_EQ] = ACTIONS(494),
    [anon_sym_GT_EQ] = ACTIONS(494),
    [anon_sym_GT] = ACTIONS(496),
    [anon_sym_LT_GT] = ACTIONS(494),
    [anon_sym_is] = ACTIONS(494),
    [anon_sym_PLUS_EQ] = ACTIONS(494),
    [anon_sym_DASH_EQ] = ACTIONS(494),
    [anon_sym_STAR_EQ] = ACTIONS(494),
    [anon_sym_SLASH_EQ] = ACTIONS(494),
    [anon_sym_AT_EQ] = ACTIONS(494),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(494),
    [anon_sym_PERCENT_EQ] = ACTIONS(494),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(494),
    [anon_sym_GT_GT_EQ] = ACTIONS(494),
    [anon_sym_LT_LT_EQ] = ACTIONS(494),
    [anon_sym_AMP_EQ] = ACTIONS(494),
    [anon_sym_CARET_EQ] = ACTIONS(494),
    [anon_sym_PIPE_EQ] = ACTIONS(494),
    [anon_sym_LBRACK] = ACTIONS(494),
    [sym_comment] = ACTIONS(3),
    [sym__semicolon] = ACTIONS(494),
    [sym__newline] = ACTIONS(494),
  },
  [130] = {
    [sym_named_expression] = STATE(742),
    [sym_list_splat] = STATE(941),
    [sym_dictionary_splat] = STATE(941),
    [sym_parenthesized_list_splat] = STATE(941),
    [sym__expression] = STATE(742),
    [sym__primary_expression] = STATE(383),
    [sym_not_operator] = STATE(742),
    [sym_boolean_operator] = STATE(742),
    [sym_binary_operator] = STATE(383),
    [sym_unary_operator] = STATE(383),
    [sym_comparison_operator] = STATE(742),
    [sym_lambda] = STATE(742),
    [sym_attribute] = STATE(383),
    [sym_subscript] = STATE(383),
    [sym_call] = STATE(383),
    [sym_keyword_argument] = STATE(941),
    [sym_list] = STATE(383),
    [sym_list_comprehension] = STATE(383),
    [sym_dictionary] = STATE(383),
    [sym_dictionary_comprehension] = STATE(383),
    [sym_set] = STATE(383),
    [sym_set_comprehension] = STATE(383),
    [sym_parenthesized_expression] = STATE(383),
    [sym_tuple] = STATE(383),
    [sym_generator_expression] = STATE(383),
    [sym_conditional_expression] = STATE(742),
    [sym_concatenated_string] = STATE(383),
    [sym_string] = STATE(381),
    [sym_await] = STATE(742),
    [sym_identifier] = ACTIONS(347),
    [anon_sym_LPAREN] = ACTIONS(349),
    [anon_sym_STAR] = ACTIONS(355),
    [anon_sym_print] = ACTIONS(357),
    [anon_sym_STAR_STAR] = ACTIONS(359),
    [anon_sym_exec] = ACTIONS(357),
    [anon_sym_not] = ACTIONS(361),
    [anon_sym_PLUS] = ACTIONS(363),
    [anon_sym_DASH] = ACTIONS(363),
    [anon_sym_TILDE] = ACTIONS(363),
    [anon_sym_lambda] = ACTIONS(365),
    [anon_sym_LBRACK] = ACTIONS(367),
    [sym_ellipsis] = ACTIONS(369),
    [anon_sym_LBRACE] = ACTIONS(371),
    [sym_integer] = ACTIONS(373),
    [sym_float] = ACTIONS(369),
    [sym_true] = ACTIONS(373),
    [sym_false] = ACTIONS(373),
    [sym_none] = ACTIONS(373),
    [anon_sym_await] = ACTIONS(375),
    [sym_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(377),
  },
  [131] = {
    [sym_argument_list] = STATE(145),
    [sym_generator_expression] = STATE(145),
    [anon_sym_DOT] = ACTIONS(494),
    [anon_sym_from] = ACTIONS(494),
    [anon_sym_LPAREN] = ACTIONS(415),
    [anon_sym_COMMA] = ACTIONS(494),
    [anon_sym_STAR] = ACTIONS(417),
    [anon_sym_GT_GT] = ACTIONS(419),
    [anon_sym_if] = ACTIONS(494),
    [anon_sym_COLON] = ACTIONS(494),
    [anon_sym_in] = ACTIONS(494),
    [anon_sym_EQ] = ACTIONS(496),
    [anon_sym_STAR_STAR] = ACTIONS(425),
    [anon_sym_AT] = ACTIONS(417),
    [anon_sym_not] = ACTIONS(494),
    [anon_sym_and] = ACTIONS(494),
    [anon_sym_or] = ACTIONS(494),
    [anon_sym_PLUS] = ACTIONS(429),
    [anon_sym_DASH] = ACTIONS(429),
    [anon_sym_SLASH] = ACTIONS(417),
    [anon_sym_PERCENT] = ACTIONS(417),
    [anon_sym_SLASH_SLASH] = ACTIONS(417),
    [anon_sym_PIPE] = ACTIONS(496),
    [anon_sym_AMP] = ACTIONS(496),
    [anon_sym_CARET] = ACTIONS(496),
    [anon_sym_LT_LT] = ACTIONS(419),
    [anon_sym_LT] = ACTIONS(496),
    [anon_sym_LT_EQ] = ACTIONS(494),
    [anon_sym_EQ_EQ] = ACTIONS(494),
    [anon_sym_BANG_EQ] = ACTIONS(494),
    [anon_sym_GT_EQ] = ACTIONS(494),
    [anon_sym_GT] = ACTIONS(496),
    [anon_sym_LT_GT] = ACTIONS(494),
    [anon_sym_is] = ACTIONS(494),
    [anon_sym_PLUS_EQ] = ACTIONS(494),
    [anon_sym_DASH_EQ] = ACTIONS(494),
    [anon_sym_STAR_EQ] = ACTIONS(494),
    [anon_sym_SLASH_EQ] = ACTIONS(494),
    [anon_sym_AT_EQ] = ACTIONS(494),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(494),
    [anon_sym_PERCENT_EQ] = ACTIONS(494),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(494),
    [anon_sym_GT_GT_EQ] = ACTIONS(494),
    [anon_sym_LT_LT_EQ] = ACTIONS(494),
    [anon_sym_AMP_EQ] = ACTIONS(494),
    [anon_sym_CARET_EQ] = ACTIONS(494),
    [anon_sym_PIPE_EQ] = ACTIONS(494),
    [anon_sym_LBRACK] = ACTIONS(494),
    [sym_comment] = ACTIONS(3),
    [sym__semicolon] = ACTIONS(494),
    [sym__newline] = ACTIONS(494),
  },
  [132] = {
    [sym_argument_list] = STATE(145),
    [sym_generator_expression] = STATE(145),
    [anon_sym_DOT] = ACTIONS(411),
    [anon_sym_from] = ACTIONS(498),
    [anon_sym_LPAREN] = ACTIONS(415),
    [anon_sym_COMMA] = ACTIONS(498),
    [anon_sym_STAR] = ACTIONS(417),
    [anon_sym_GT_GT] = ACTIONS(419),
    [anon_sym_if] = ACTIONS(498),
    [anon_sym_COLON] = ACTIONS(498),
    [anon_sym_in] = ACTIONS(498),
    [anon_sym_EQ] = ACTIONS(500),
    [anon_sym_STAR_STAR] = ACTIONS(425),
    [anon_sym_AT] = ACTIONS(417),
    [anon_sym_not] = ACTIONS(498),
    [anon_sym_and] = ACTIONS(498),
    [anon_sym_or] = ACTIONS(498),
    [anon_sym_PLUS] = ACTIONS(429),
    [anon_sym_DASH] = ACTIONS(429),
    [anon_sym_SLASH] = ACTIONS(417),
    [anon_sym_PERCENT] = ACTIONS(417),
    [anon_sym_SLASH_SLASH] = ACTIONS(417),
    [anon_sym_PIPE] = ACTIONS(431),
    [anon_sym_AMP] = ACTIONS(433),
    [anon_sym_CARET] = ACTIONS(435),
    [anon_sym_LT_LT] = ACTIONS(419),
    [anon_sym_LT] = ACTIONS(500),
    [anon_sym_LT_EQ] = ACTIONS(498),
    [anon_sym_EQ_EQ] = ACTIONS(498),
    [anon_sym_BANG_EQ] = ACTIONS(498),
    [anon_sym_GT_EQ] = ACTIONS(498),
    [anon_sym_GT] = ACTIONS(500),
    [anon_sym_LT_GT] = ACTIONS(498),
    [anon_sym_is] = ACTIONS(498),
    [anon_sym_PLUS_EQ] = ACTIONS(498),
    [anon_sym_DASH_EQ] = ACTIONS(498),
    [anon_sym_STAR_EQ] = ACTIONS(498),
    [anon_sym_SLASH_EQ] = ACTIONS(498),
    [anon_sym_AT_EQ] = ACTIONS(498),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(498),
    [anon_sym_PERCENT_EQ] = ACTIONS(498),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(498),
    [anon_sym_GT_GT_EQ] = ACTIONS(498),
    [anon_sym_LT_LT_EQ] = ACTIONS(498),
    [anon_sym_AMP_EQ] = ACTIONS(498),
    [anon_sym_CARET_EQ] = ACTIONS(498),
    [anon_sym_PIPE_EQ] = ACTIONS(498),
    [anon_sym_LBRACK] = ACTIONS(441),
    [sym_comment] = ACTIONS(3),
    [sym__semicolon] = ACTIONS(498),
    [sym__newline] = ACTIONS(498),
  },
  [133] = {
    [sym_argument_list] = STATE(145),
    [sym_generator_expression] = STATE(145),
    [anon_sym_DOT] = ACTIONS(494),
    [anon_sym_from] = ACTIONS(494),
    [anon_sym_LPAREN] = ACTIONS(415),
    [anon_sym_COMMA] = ACTIONS(494),
    [anon_sym_STAR] = ACTIONS(417),
    [anon_sym_GT_GT] = ACTIONS(419),
    [anon_sym_if] = ACTIONS(494),
    [anon_sym_COLON] = ACTIONS(494),
    [anon_sym_in] = ACTIONS(494),
    [anon_sym_EQ] = ACTIONS(496),
    [anon_sym_STAR_STAR] = ACTIONS(425),
    [anon_sym_AT] = ACTIONS(417),
    [anon_sym_not] = ACTIONS(494),
    [anon_sym_and] = ACTIONS(494),
    [anon_sym_or] = ACTIONS(494),
    [anon_sym_PLUS] = ACTIONS(429),
    [anon_sym_DASH] = ACTIONS(429),
    [anon_sym_SLASH] = ACTIONS(417),
    [anon_sym_PERCENT] = ACTIONS(417),
    [anon_sym_SLASH_SLASH] = ACTIONS(417),
    [anon_sym_PIPE] = ACTIONS(496),
    [anon_sym_AMP] = ACTIONS(496),
    [anon_sym_CARET] = ACTIONS(435),
    [anon_sym_LT_LT] = ACTIONS(419),
    [anon_sym_LT] = ACTIONS(496),
    [anon_sym_LT_EQ] = ACTIONS(494),
    [anon_sym_EQ_EQ] = ACTIONS(494),
    [anon_sym_BANG_EQ] = ACTIONS(494),
    [anon_sym_GT_EQ] = ACTIONS(494),
    [anon_sym_GT] = ACTIONS(496),
    [anon_sym_LT_GT] = ACTIONS(494),
    [anon_sym_is] = ACTIONS(494),
    [anon_sym_PLUS_EQ] = ACTIONS(494),
    [anon_sym_DASH_EQ] = ACTIONS(494),
    [anon_sym_STAR_EQ] = ACTIONS(494),
    [anon_sym_SLASH_EQ] = ACTIONS(494),
    [anon_sym_AT_EQ] = ACTIONS(494),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(494),
    [anon_sym_PERCENT_EQ] = ACTIONS(494),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(494),
    [anon_sym_GT_GT_EQ] = ACTIONS(494),
    [anon_sym_LT_LT_EQ] = ACTIONS(494),
    [anon_sym_AMP_EQ] = ACTIONS(494),
    [anon_sym_CARET_EQ] = ACTIONS(494),
    [anon_sym_PIPE_EQ] = ACTIONS(494),
    [anon_sym_LBRACK] = ACTIONS(494),
    [sym_comment] = ACTIONS(3),
    [sym__semicolon] = ACTIONS(494),
    [sym__newline] = ACTIONS(494),
  },
  [134] = {
    [sym_argument_list] = STATE(145),
    [sym_generator_expression] = STATE(145),
    [anon_sym_DOT] = ACTIONS(494),
    [anon_sym_from] = ACTIONS(494),
    [anon_sym_LPAREN] = ACTIONS(415),
    [anon_sym_COMMA] = ACTIONS(494),
    [anon_sym_STAR] = ACTIONS(417),
    [anon_sym_GT_GT] = ACTIONS(496),
    [anon_sym_if] = ACTIONS(494),
    [anon_sym_COLON] = ACTIONS(494),
    [anon_sym_in] = ACTIONS(494),
    [anon_sym_EQ] = ACTIONS(496),
    [anon_sym_STAR_STAR] = ACTIONS(425),
    [anon_sym_AT] = ACTIONS(417),
    [anon_sym_not] = ACTIONS(494),
    [anon_sym_and] = ACTIONS(494),
    [anon_sym_or] = ACTIONS(494),
    [anon_sym_PLUS] = ACTIONS(496),
    [anon_sym_DASH] = ACTIONS(496),
    [anon_sym_SLASH] = ACTIONS(417),
    [anon_sym_PERCENT] = ACTIONS(417),
    [anon_sym_SLASH_SLASH] = ACTIONS(417),
    [anon_sym_PIPE] = ACTIONS(496),
    [anon_sym_AMP] = ACTIONS(496),
    [anon_sym_CARET] = ACTIONS(496),
    [anon_sym_LT_LT] = ACTIONS(496),
    [anon_sym_LT] = ACTIONS(496),
    [anon_sym_LT_EQ] = ACTIONS(494),
    [anon_sym_EQ_EQ] = ACTIONS(494),
    [anon_sym_BANG_EQ] = ACTIONS(494),
    [anon_sym_GT_EQ] = ACTIONS(494),
    [anon_sym_GT] = ACTIONS(496),
    [anon_sym_LT_GT] = ACTIONS(494),
    [anon_sym_is] = ACTIONS(494),
    [anon_sym_PLUS_EQ] = ACTIONS(494),
    [anon_sym_DASH_EQ] = ACTIONS(494),
    [anon_sym_STAR_EQ] = ACTIONS(494),
    [anon_sym_SLASH_EQ] = ACTIONS(494),
    [anon_sym_AT_EQ] = ACTIONS(494),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(494),
    [anon_sym_PERCENT_EQ] = ACTIONS(494),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(494),
    [anon_sym_GT_GT_EQ] = ACTIONS(494),
    [anon_sym_LT_LT_EQ] = ACTIONS(494),
    [anon_sym_AMP_EQ] = ACTIONS(494),
    [anon_sym_CARET_EQ] = ACTIONS(494),
    [anon_sym_PIPE_EQ] = ACTIONS(494),
    [anon_sym_LBRACK] = ACTIONS(494),
    [sym_comment] = ACTIONS(3),
    [sym__semicolon] = ACTIONS(494),
    [sym__newline] = ACTIONS(494),
  },
  [135] = {
    [sym_argument_list] = STATE(145),
    [sym_generator_expression] = STATE(145),
    [anon_sym_DOT] = ACTIONS(411),
    [anon_sym_from] = ACTIONS(502),
    [anon_sym_LPAREN] = ACTIONS(415),
    [anon_sym_COMMA] = ACTIONS(502),
    [anon_sym_STAR] = ACTIONS(417),
    [anon_sym_GT_GT] = ACTIONS(419),
    [anon_sym_if] = ACTIONS(502),
    [anon_sym_COLON] = ACTIONS(502),
    [anon_sym_in] = ACTIONS(502),
    [anon_sym_EQ] = ACTIONS(504),
    [anon_sym_STAR_STAR] = ACTIONS(425),
    [anon_sym_AT] = ACTIONS(417),
    [anon_sym_not] = ACTIONS(502),
    [anon_sym_and] = ACTIONS(502),
    [anon_sym_or] = ACTIONS(502),
    [anon_sym_PLUS] = ACTIONS(429),
    [anon_sym_DASH] = ACTIONS(429),
    [anon_sym_SLASH] = ACTIONS(417),
    [anon_sym_PERCENT] = ACTIONS(417),
    [anon_sym_SLASH_SLASH] = ACTIONS(417),
    [anon_sym_PIPE] = ACTIONS(431),
    [anon_sym_AMP] = ACTIONS(433),
    [anon_sym_CARET] = ACTIONS(435),
    [anon_sym_LT_LT] = ACTIONS(419),
    [anon_sym_LT] = ACTIONS(504),
    [anon_sym_LT_EQ] = ACTIONS(502),
    [anon_sym_EQ_EQ] = ACTIONS(502),
    [anon_sym_BANG_EQ] = ACTIONS(502),
    [anon_sym_GT_EQ] = ACTIONS(502),
    [anon_sym_GT] = ACTIONS(504),
    [anon_sym_LT_GT] = ACTIONS(502),
    [anon_sym_is] = ACTIONS(502),
    [anon_sym_PLUS_EQ] = ACTIONS(502),
    [anon_sym_DASH_EQ] = ACTIONS(502),
    [anon_sym_STAR_EQ] = ACTIONS(502),
    [anon_sym_SLASH_EQ] = ACTIONS(502),
    [anon_sym_AT_EQ] = ACTIONS(502),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(502),
    [anon_sym_PERCENT_EQ] = ACTIONS(502),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(502),
    [anon_sym_GT_GT_EQ] = ACTIONS(502),
    [anon_sym_LT_LT_EQ] = ACTIONS(502),
    [anon_sym_AMP_EQ] = ACTIONS(502),
    [anon_sym_CARET_EQ] = ACTIONS(502),
    [anon_sym_PIPE_EQ] = ACTIONS(502),
    [anon_sym_LBRACK] = ACTIONS(441),
    [sym_comment] = ACTIONS(3),
    [sym__semicolon] = ACTIONS(502),
    [sym__newline] = ACTIONS(502),
  },
  [136] = {
    [sym_argument_list] = STATE(145),
    [sym_generator_expression] = STATE(145),
    [anon_sym_DOT] = ACTIONS(494),
    [anon_sym_from] = ACTIONS(494),
    [anon_sym_LPAREN] = ACTIONS(415),
    [anon_sym_COMMA] = ACTIONS(494),
    [anon_sym_STAR] = ACTIONS(496),
    [anon_sym_GT_GT] = ACTIONS(496),
    [anon_sym_if] = ACTIONS(494),
    [anon_sym_COLON] = ACTIONS(494),
    [anon_sym_in] = ACTIONS(494),
    [anon_sym_EQ] = ACTIONS(496),
    [anon_sym_STAR_STAR] = ACTIONS(496),
    [anon_sym_AT] = ACTIONS(496),
    [anon_sym_not] = ACTIONS(494),
    [anon_sym_and] = ACTIONS(494),
    [anon_sym_or] = ACTIONS(494),
    [anon_sym_PLUS] = ACTIONS(496),
    [anon_sym_DASH] = ACTIONS(496),
    [anon_sym_SLASH] = ACTIONS(496),
    [anon_sym_PERCENT] = ACTIONS(496),
    [anon_sym_SLASH_SLASH] = ACTIONS(496),
    [anon_sym_PIPE] = ACTIONS(496),
    [anon_sym_AMP] = ACTIONS(496),
    [anon_sym_CARET] = ACTIONS(496),
    [anon_sym_LT_LT] = ACTIONS(496),
    [anon_sym_LT] = ACTIONS(496),
    [anon_sym_LT_EQ] = ACTIONS(494),
    [anon_sym_EQ_EQ] = ACTIONS(494),
    [anon_sym_BANG_EQ] = ACTIONS(494),
    [anon_sym_GT_EQ] = ACTIONS(494),
    [anon_sym_GT] = ACTIONS(496),
    [anon_sym_LT_GT] = ACTIONS(494),
    [anon_sym_is] = ACTIONS(494),
    [anon_sym_PLUS_EQ] = ACTIONS(494),
    [anon_sym_DASH_EQ] = ACTIONS(494),
    [anon_sym_STAR_EQ] = ACTIONS(494),
    [anon_sym_SLASH_EQ] = ACTIONS(494),
    [anon_sym_AT_EQ] = ACTIONS(494),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(494),
    [anon_sym_PERCENT_EQ] = ACTIONS(494),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(494),
    [anon_sym_GT_GT_EQ] = ACTIONS(494),
    [anon_sym_LT_LT_EQ] = ACTIONS(494),
    [anon_sym_AMP_EQ] = ACTIONS(494),
    [anon_sym_CARET_EQ] = ACTIONS(494),
    [anon_sym_PIPE_EQ] = ACTIONS(494),
    [anon_sym_LBRACK] = ACTIONS(494),
    [sym_comment] = ACTIONS(3),
    [sym__semicolon] = ACTIONS(494),
    [sym__newline] = ACTIONS(494),
  },
  [137] = {
    [anon_sym_DOT] = ACTIONS(506),
    [anon_sym_from] = ACTIONS(506),
    [anon_sym_LPAREN] = ACTIONS(506),
    [anon_sym_COMMA] = ACTIONS(506),
    [anon_sym_STAR] = ACTIONS(508),
    [anon_sym_GT_GT] = ACTIONS(508),
    [anon_sym_if] = ACTIONS(506),
    [anon_sym_COLON] = ACTIONS(506),
    [anon_sym_in] = ACTIONS(506),
    [anon_sym_EQ] = ACTIONS(508),
    [anon_sym_STAR_STAR] = ACTIONS(508),
    [anon_sym_AT] = ACTIONS(508),
    [anon_sym_not] = ACTIONS(506),
    [anon_sym_and] = ACTIONS(506),
    [anon_sym_or] = ACTIONS(506),
    [anon_sym_PLUS] = ACTIONS(508),
    [anon_sym_DASH] = ACTIONS(508),
    [anon_sym_SLASH] = ACTIONS(508),
    [anon_sym_PERCENT] = ACTIONS(508),
    [anon_sym_SLASH_SLASH] = ACTIONS(508),
    [anon_sym_PIPE] = ACTIONS(508),
    [anon_sym_AMP] = ACTIONS(508),
    [anon_sym_CARET] = ACTIONS(508),
    [anon_sym_LT_LT] = ACTIONS(508),
    [anon_sym_LT] = ACTIONS(508),
    [anon_sym_LT_EQ] = ACTIONS(506),
    [anon_sym_EQ_EQ] = ACTIONS(506),
    [anon_sym_BANG_EQ] = ACTIONS(506),
    [anon_sym_GT_EQ] = ACTIONS(506),
    [anon_sym_GT] = ACTIONS(508),
    [anon_sym_LT_GT] = ACTIONS(506),
    [anon_sym_is] = ACTIONS(506),
    [anon_sym_PLUS_EQ] = ACTIONS(506),
    [anon_sym_DASH_EQ] = ACTIONS(506),
    [anon_sym_STAR_EQ] = ACTIONS(506),
    [anon_sym_SLASH_EQ] = ACTIONS(506),
    [anon_sym_AT_EQ] = ACTIONS(506),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(506),
    [anon_sym_PERCENT_EQ] = ACTIONS(506),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(506),
    [anon_sym_GT_GT_EQ] = ACTIONS(506),
    [anon_sym_LT_LT_EQ] = ACTIONS(506),
    [anon_sym_AMP_EQ] = ACTIONS(506),
    [anon_sym_CARET_EQ] = ACTIONS(506),
    [anon_sym_PIPE_EQ] = ACTIONS(506),
    [anon_sym_LBRACK] = ACTIONS(506),
    [sym_comment] = ACTIONS(3),
    [sym__semicolon] = ACTIONS(506),
    [sym__newline] = ACTIONS(506),
    [sym__string_start] = ACTIONS(506),
  },
  [138] = {
    [anon_sym_DOT] = ACTIONS(467),
    [anon_sym_from] = ACTIONS(467),
    [anon_sym_LPAREN] = ACTIONS(467),
    [anon_sym_COMMA] = ACTIONS(467),
    [anon_sym_STAR] = ACTIONS(469),
    [anon_sym_GT_GT] = ACTIONS(469),
    [anon_sym_COLON_EQ] = ACTIONS(510),
    [anon_sym_if] = ACTIONS(467),
    [anon_sym_COLON] = ACTIONS(469),
    [anon_sym_in] = ACTIONS(467),
    [anon_sym_EQ] = ACTIONS(469),
    [anon_sym_STAR_STAR] = ACTIONS(469),
    [anon_sym_AT] = ACTIONS(469),
    [anon_sym_not] = ACTIONS(467),
    [anon_sym_and] = ACTIONS(467),
    [anon_sym_or] = ACTIONS(467),
    [anon_sym_PLUS] = ACTIONS(469),
    [anon_sym_DASH] = ACTIONS(469),
    [anon_sym_SLASH] = ACTIONS(469),
    [anon_sym_PERCENT] = ACTIONS(469),
    [anon_sym_SLASH_SLASH] = ACTIONS(469),
    [anon_sym_PIPE] = ACTIONS(469),
    [anon_sym_AMP] = ACTIONS(469),
    [anon_sym_CARET] = ACTIONS(469),
    [anon_sym_LT_LT] = ACTIONS(469),
    [anon_sym_LT] = ACTIONS(469),
    [anon_sym_LT_EQ] = ACTIONS(467),
    [anon_sym_EQ_EQ] = ACTIONS(467),
    [anon_sym_BANG_EQ] = ACTIONS(467),
    [anon_sym_GT_EQ] = ACTIONS(467),
    [anon_sym_GT] = ACTIONS(469),
    [anon_sym_LT_GT] = ACTIONS(467),
    [anon_sym_is] = ACTIONS(467),
    [anon_sym_PLUS_EQ] = ACTIONS(467),
    [anon_sym_DASH_EQ] = ACTIONS(467),
    [anon_sym_STAR_EQ] = ACTIONS(467),
    [anon_sym_SLASH_EQ] = ACTIONS(467),
    [anon_sym_AT_EQ] = ACTIONS(467),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(467),
    [anon_sym_PERCENT_EQ] = ACTIONS(467),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(467),
    [anon_sym_GT_GT_EQ] = ACTIONS(467),
    [anon_sym_LT_LT_EQ] = ACTIONS(467),
    [anon_sym_AMP_EQ] = ACTIONS(467),
    [anon_sym_CARET_EQ] = ACTIONS(467),
    [anon_sym_PIPE_EQ] = ACTIONS(467),
    [anon_sym_LBRACK] = ACTIONS(467),
    [sym_comment] = ACTIONS(3),
    [sym__semicolon] = ACTIONS(467),
    [sym__newline] = ACTIONS(467),
  },
  [139] = {
    [sym_string] = STATE(893),
    [anon_sym_DOT] = ACTIONS(235),
    [anon_sym_LPAREN] = ACTIONS(235),
    [anon_sym_COMMA] = ACTIONS(235),
    [anon_sym_STAR] = ACTIONS(233),
    [anon_sym_GT_GT] = ACTIONS(233),
    [anon_sym_if] = ACTIONS(235),
    [anon_sym_COLON] = ACTIONS(235),
    [anon_sym_in] = ACTIONS(235),
    [anon_sym_EQ] = ACTIONS(233),
    [anon_sym_STAR_STAR] = ACTIONS(233),
    [anon_sym_AT] = ACTIONS(233),
    [anon_sym_not] = ACTIONS(235),
    [anon_sym_and] = ACTIONS(235),
    [anon_sym_or] = ACTIONS(235),
    [anon_sym_PLUS] = ACTIONS(233),
    [anon_sym_DASH] = ACTIONS(233),
    [anon_sym_SLASH] = ACTIONS(233),
    [anon_sym_PERCENT] = ACTIONS(233),
    [anon_sym_SLASH_SLASH] = ACTIONS(233),
    [anon_sym_PIPE] = ACTIONS(233),
    [anon_sym_AMP] = ACTIONS(233),
    [anon_sym_CARET] = ACTIONS(233),
    [anon_sym_LT_LT] = ACTIONS(233),
    [anon_sym_LT] = ACTIONS(233),
    [anon_sym_LT_EQ] = ACTIONS(235),
    [anon_sym_EQ_EQ] = ACTIONS(235),
    [anon_sym_BANG_EQ] = ACTIONS(235),
    [anon_sym_GT_EQ] = ACTIONS(235),
    [anon_sym_GT] = ACTIONS(233),
    [anon_sym_LT_GT] = ACTIONS(235),
    [anon_sym_is] = ACTIONS(235),
    [anon_sym_PLUS_EQ] = ACTIONS(235),
    [anon_sym_DASH_EQ] = ACTIONS(235),
    [anon_sym_STAR_EQ] = ACTIONS(235),
    [anon_sym_SLASH_EQ] = ACTIONS(235),
    [anon_sym_AT_EQ] = ACTIONS(235),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(235),
    [anon_sym_PERCENT_EQ] = ACTIONS(235),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(235),
    [anon_sym_GT_GT_EQ] = ACTIONS(235),
    [anon_sym_LT_LT_EQ] = ACTIONS(235),
    [anon_sym_AMP_EQ] = ACTIONS(235),
    [anon_sym_CARET_EQ] = ACTIONS(235),
    [anon_sym_PIPE_EQ] = ACTIONS(235),
    [anon_sym_LBRACK] = ACTIONS(235),
    [sym_comment] = ACTIONS(3),
    [sym__semicolon] = ACTIONS(235),
    [sym__newline] = ACTIONS(235),
    [sym__string_start] = ACTIONS(512),
  },
  [140] = {
    [anon_sym_DOT] = ACTIONS(514),
    [anon_sym_from] = ACTIONS(514),
    [anon_sym_LPAREN] = ACTIONS(514),
    [anon_sym_COMMA] = ACTIONS(514),
    [anon_sym_STAR] = ACTIONS(516),
    [anon_sym_GT_GT] = ACTIONS(516),
    [anon_sym_if] = ACTIONS(514),
    [anon_sym_COLON] = ACTIONS(514),
    [anon_sym_in] = ACTIONS(514),
    [anon_sym_EQ] = ACTIONS(516),
    [anon_sym_STAR_STAR] = ACTIONS(516),
    [anon_sym_AT] = ACTIONS(516),
    [anon_sym_not] = ACTIONS(514),
    [anon_sym_and] = ACTIONS(514),
    [anon_sym_or] = ACTIONS(514),
    [anon_sym_PLUS] = ACTIONS(516),
    [anon_sym_DASH] = ACTIONS(516),
    [anon_sym_SLASH] = ACTIONS(516),
    [anon_sym_PERCENT] = ACTIONS(516),
    [anon_sym_SLASH_SLASH] = ACTIONS(516),
    [anon_sym_PIPE] = ACTIONS(516),
    [anon_sym_AMP] = ACTIONS(516),
    [anon_sym_CARET] = ACTIONS(516),
    [anon_sym_LT_LT] = ACTIONS(516),
    [anon_sym_LT] = ACTIONS(516),
    [anon_sym_LT_EQ] = ACTIONS(514),
    [anon_sym_EQ_EQ] = ACTIONS(514),
    [anon_sym_BANG_EQ] = ACTIONS(514),
    [anon_sym_GT_EQ] = ACTIONS(514),
    [anon_sym_GT] = ACTIONS(516),
    [anon_sym_LT_GT] = ACTIONS(514),
    [anon_sym_is] = ACTIONS(514),
    [anon_sym_PLUS_EQ] = ACTIONS(514),
    [anon_sym_DASH_EQ] = ACTIONS(514),
    [anon_sym_STAR_EQ] = ACTIONS(514),
    [anon_sym_SLASH_EQ] = ACTIONS(514),
    [anon_sym_AT_EQ] = ACTIONS(514),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(514),
    [anon_sym_PERCENT_EQ] = ACTIONS(514),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(514),
    [anon_sym_GT_GT_EQ] = ACTIONS(514),
    [anon_sym_LT_LT_EQ] = ACTIONS(514),
    [anon_sym_AMP_EQ] = ACTIONS(514),
    [anon_sym_CARET_EQ] = ACTIONS(514),
    [anon_sym_PIPE_EQ] = ACTIONS(514),
    [anon_sym_LBRACK] = ACTIONS(514),
    [sym_comment] = ACTIONS(3),
    [sym__semicolon] = ACTIONS(514),
    [sym__newline] = ACTIONS(514),
    [sym__string_start] = ACTIONS(514),
  },
  [141] = {
    [sym_named_expression] = STATE(599),
    [sym_expression_list] = STATE(911),
    [sym__expression] = STATE(599),
    [sym__primary_expression] = STATE(109),
    [sym_not_operator] = STATE(599),
    [sym_boolean_operator] = STATE(599),
    [sym_binary_operator] = STATE(109),
    [sym_unary_operator] = STATE(109),
    [sym_comparison_operator] = STATE(599),
    [sym_lambda] = STATE(599),
    [sym_attribute] = STATE(109),
    [sym_subscript] = STATE(109),
    [sym_call] = STATE(109),
    [sym_list] = STATE(109),
    [sym_list_comprehension] = STATE(109),
    [sym_dictionary] = STATE(109),
    [sym_dictionary_comprehension] = STATE(109),
    [sym_set] = STATE(109),
    [sym_set_comprehension] = STATE(109),
    [sym_parenthesized_expression] = STATE(109),
    [sym_tuple] = STATE(109),
    [sym_generator_expression] = STATE(109),
    [sym_conditional_expression] = STATE(599),
    [sym_concatenated_string] = STATE(109),
    [sym_string] = STATE(117),
    [sym_await] = STATE(599),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_from] = ACTIONS(518),
    [anon_sym_LPAREN] = ACTIONS(13),
    [anon_sym_print] = ACTIONS(237),
    [anon_sym_exec] = ACTIONS(237),
    [anon_sym_not] = ACTIONS(55),
    [anon_sym_PLUS] = ACTIONS(57),
    [anon_sym_DASH] = ACTIONS(57),
    [anon_sym_TILDE] = ACTIONS(57),
    [anon_sym_lambda] = ACTIONS(59),
    [anon_sym_LBRACK] = ACTIONS(63),
    [sym_ellipsis] = ACTIONS(65),
    [anon_sym_LBRACE] = ACTIONS(67),
    [sym_integer] = ACTIONS(69),
    [sym_float] = ACTIONS(65),
    [sym_true] = ACTIONS(69),
    [sym_false] = ACTIONS(69),
    [sym_none] = ACTIONS(69),
    [anon_sym_await] = ACTIONS(71),
    [sym_comment] = ACTIONS(3),
    [sym__semicolon] = ACTIONS(520),
    [sym__newline] = ACTIONS(520),
    [sym__string_start] = ACTIONS(73),
  },
  [142] = {
    [anon_sym_DOT] = ACTIONS(522),
    [anon_sym_from] = ACTIONS(522),
    [anon_sym_LPAREN] = ACTIONS(522),
    [anon_sym_COMMA] = ACTIONS(522),
    [anon_sym_STAR] = ACTIONS(524),
    [anon_sym_GT_GT] = ACTIONS(524),
    [anon_sym_if] = ACTIONS(522),
    [anon_sym_COLON] = ACTIONS(522),
    [anon_sym_in] = ACTIONS(522),
    [anon_sym_EQ] = ACTIONS(524),
    [anon_sym_STAR_STAR] = ACTIONS(524),
    [anon_sym_AT] = ACTIONS(524),
    [anon_sym_not] = ACTIONS(522),
    [anon_sym_and] = ACTIONS(522),
    [anon_sym_or] = ACTIONS(522),
    [anon_sym_PLUS] = ACTIONS(524),
    [anon_sym_DASH] = ACTIONS(524),
    [anon_sym_SLASH] = ACTIONS(524),
    [anon_sym_PERCENT] = ACTIONS(524),
    [anon_sym_SLASH_SLASH] = ACTIONS(524),
    [anon_sym_PIPE] = ACTIONS(524),
    [anon_sym_AMP] = ACTIONS(524),
    [anon_sym_CARET] = ACTIONS(524),
    [anon_sym_LT_LT] = ACTIONS(524),
    [anon_sym_LT] = ACTIONS(524),
    [anon_sym_LT_EQ] = ACTIONS(522),
    [anon_sym_EQ_EQ] = ACTIONS(522),
    [anon_sym_BANG_EQ] = ACTIONS(522),
    [anon_sym_GT_EQ] = ACTIONS(522),
    [anon_sym_GT] = ACTIONS(524),
    [anon_sym_LT_GT] = ACTIONS(522),
    [anon_sym_is] = ACTIONS(522),
    [anon_sym_PLUS_EQ] = ACTIONS(522),
    [anon_sym_DASH_EQ] = ACTIONS(522),
    [anon_sym_STAR_EQ] = ACTIONS(522),
    [anon_sym_SLASH_EQ] = ACTIONS(522),
    [anon_sym_AT_EQ] = ACTIONS(522),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(522),
    [anon_sym_PERCENT_EQ] = ACTIONS(522),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(522),
    [anon_sym_GT_GT_EQ] = ACTIONS(522),
    [anon_sym_LT_LT_EQ] = ACTIONS(522),
    [anon_sym_AMP_EQ] = ACTIONS(522),
    [anon_sym_CARET_EQ] = ACTIONS(522),
    [anon_sym_PIPE_EQ] = ACTIONS(522),
    [anon_sym_LBRACK] = ACTIONS(522),
    [sym_comment] = ACTIONS(3),
    [sym__semicolon] = ACTIONS(522),
    [sym__newline] = ACTIONS(522),
  },
  [143] = {
    [sym_named_expression] = STATE(768),
    [sym_dictionary_splat] = STATE(918),
    [sym__expression] = STATE(768),
    [sym__primary_expression] = STATE(383),
    [sym_not_operator] = STATE(768),
    [sym_boolean_operator] = STATE(768),
    [sym_binary_operator] = STATE(383),
    [sym_unary_operator] = STATE(383),
    [sym_comparison_operator] = STATE(768),
    [sym_lambda] = STATE(768),
    [sym_attribute] = STATE(383),
    [sym_subscript] = STATE(383),
    [sym_call] = STATE(383),
    [sym_list] = STATE(383),
    [sym_list_comprehension] = STATE(383),
    [sym_dictionary] = STATE(383),
    [sym_dictionary_comprehension] = STATE(383),
    [sym_pair] = STATE(918),
    [sym_set] = STATE(383),
    [sym_set_comprehension] = STATE(383),
    [sym_parenthesized_expression] = STATE(383),
    [sym_tuple] = STATE(383),
    [sym_generator_expression] = STATE(383),
    [sym_conditional_expression] = STATE(768),
    [sym_concatenated_string] = STATE(383),
    [sym_string] = STATE(381),
    [sym_await] = STATE(768),
    [sym_identifier] = ACTIONS(387),
    [anon_sym_LPAREN] = ACTIONS(389),
    [anon_sym_print] = ACTIONS(393),
    [anon_sym_STAR_STAR] = ACTIONS(359),
    [anon_sym_exec] = ACTIONS(393),
    [anon_sym_not] = ACTIONS(361),
    [anon_sym_PLUS] = ACTIONS(363),
    [anon_sym_DASH] = ACTIONS(363),
    [anon_sym_TILDE] = ACTIONS(363),
    [anon_sym_lambda] = ACTIONS(365),
    [anon_sym_LBRACK] = ACTIONS(367),
    [sym_ellipsis] = ACTIONS(369),
    [anon_sym_LBRACE] = ACTIONS(371),
    [anon_sym_RBRACE] = ACTIONS(526),
    [sym_integer] = ACTIONS(373),
    [sym_float] = ACTIONS(369),
    [sym_true] = ACTIONS(373),
    [sym_false] = ACTIONS(373),
    [sym_none] = ACTIONS(373),
    [anon_sym_await] = ACTIONS(375),
    [sym_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(377),
  },
  [144] = {
    [sym_named_expression] = STATE(768),
    [sym_dictionary_splat] = STATE(918),
    [sym__expression] = STATE(768),
    [sym__primary_expression] = STATE(383),
    [sym_not_operator] = STATE(768),
    [sym_boolean_operator] = STATE(768),
    [sym_binary_operator] = STATE(383),
    [sym_unary_operator] = STATE(383),
    [sym_comparison_operator] = STATE(768),
    [sym_lambda] = STATE(768),
    [sym_attribute] = STATE(383),
    [sym_subscript] = STATE(383),
    [sym_call] = STATE(383),
    [sym_list] = STATE(383),
    [sym_list_comprehension] = STATE(383),
    [sym_dictionary] = STATE(383),
    [sym_dictionary_comprehension] = STATE(383),
    [sym_pair] = STATE(918),
    [sym_set] = STATE(383),
    [sym_set_comprehension] = STATE(383),
    [sym_parenthesized_expression] = STATE(383),
    [sym_tuple] = STATE(383),
    [sym_generator_expression] = STATE(383),
    [sym_conditional_expression] = STATE(768),
    [sym_concatenated_string] = STATE(383),
    [sym_string] = STATE(381),
    [sym_await] = STATE(768),
    [sym_identifier] = ACTIONS(387),
    [anon_sym_LPAREN] = ACTIONS(389),
    [anon_sym_print] = ACTIONS(393),
    [anon_sym_STAR_STAR] = ACTIONS(359),
    [anon_sym_exec] = ACTIONS(393),
    [anon_sym_not] = ACTIONS(361),
    [anon_sym_PLUS] = ACTIONS(363),
    [anon_sym_DASH] = ACTIONS(363),
    [anon_sym_TILDE] = ACTIONS(363),
    [anon_sym_lambda] = ACTIONS(365),
    [anon_sym_LBRACK] = ACTIONS(367),
    [sym_ellipsis] = ACTIONS(369),
    [anon_sym_LBRACE] = ACTIONS(371),
    [anon_sym_RBRACE] = ACTIONS(528),
    [sym_integer] = ACTIONS(373),
    [sym_float] = ACTIONS(369),
    [sym_true] = ACTIONS(373),
    [sym_false] = ACTIONS(373),
    [sym_none] = ACTIONS(373),
    [anon_sym_await] = ACTIONS(375),
    [sym_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(377),
  },
  [145] = {
    [anon_sym_DOT] = ACTIONS(530),
    [anon_sym_from] = ACTIONS(530),
    [anon_sym_LPAREN] = ACTIONS(530),
    [anon_sym_COMMA] = ACTIONS(530),
    [anon_sym_STAR] = ACTIONS(532),
    [anon_sym_GT_GT] = ACTIONS(532),
    [anon_sym_if] = ACTIONS(530),
    [anon_sym_COLON] = ACTIONS(530),
    [anon_sym_in] = ACTIONS(530),
    [anon_sym_EQ] = ACTIONS(532),
    [anon_sym_STAR_STAR] = ACTIONS(532),
    [anon_sym_AT] = ACTIONS(532),
    [anon_sym_not] = ACTIONS(530),
    [anon_sym_and] = ACTIONS(530),
    [anon_sym_or] = ACTIONS(530),
    [anon_sym_PLUS] = ACTIONS(532),
    [anon_sym_DASH] = ACTIONS(532),
    [anon_sym_SLASH] = ACTIONS(532),
    [anon_sym_PERCENT] = ACTIONS(532),
    [anon_sym_SLASH_SLASH] = ACTIONS(532),
    [anon_sym_PIPE] = ACTIONS(532),
    [anon_sym_AMP] = ACTIONS(532),
    [anon_sym_CARET] = ACTIONS(532),
    [anon_sym_LT_LT] = ACTIONS(532),
    [anon_sym_LT] = ACTIONS(532),
    [anon_sym_LT_EQ] = ACTIONS(530),
    [anon_sym_EQ_EQ] = ACTIONS(530),
    [anon_sym_BANG_EQ] = ACTIONS(530),
    [anon_sym_GT_EQ] = ACTIONS(530),
    [anon_sym_GT] = ACTIONS(532),
    [anon_sym_LT_GT] = ACTIONS(530),
    [anon_sym_is] = ACTIONS(530),
    [anon_sym_PLUS_EQ] = ACTIONS(530),
    [anon_sym_DASH_EQ] = ACTIONS(530),
    [anon_sym_STAR_EQ] = ACTIONS(530),
    [anon_sym_SLASH_EQ] = ACTIONS(530),
    [anon_sym_AT_EQ] = ACTIONS(530),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(530),
    [anon_sym_PERCENT_EQ] = ACTIONS(530),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(530),
    [anon_sym_GT_GT_EQ] = ACTIONS(530),
    [anon_sym_LT_LT_EQ] = ACTIONS(530),
    [anon_sym_AMP_EQ] = ACTIONS(530),
    [anon_sym_CARET_EQ] = ACTIONS(530),
    [anon_sym_PIPE_EQ] = ACTIONS(530),
    [anon_sym_LBRACK] = ACTIONS(530),
    [sym_comment] = ACTIONS(3),
    [sym__semicolon] = ACTIONS(530),
    [sym__newline] = ACTIONS(530),
  },
  [146] = {
    [sym_named_expression] = STATE(768),
    [sym_dictionary_splat] = STATE(918),
    [sym__expression] = STATE(768),
    [sym__primary_expression] = STATE(383),
    [sym_not_operator] = STATE(768),
    [sym_boolean_operator] = STATE(768),
    [sym_binary_operator] = STATE(383),
    [sym_unary_operator] = STATE(383),
    [sym_comparison_operator] = STATE(768),
    [sym_lambda] = STATE(768),
    [sym_attribute] = STATE(383),
    [sym_subscript] = STATE(383),
    [sym_call] = STATE(383),
    [sym_list] = STATE(383),
    [sym_list_comprehension] = STATE(383),
    [sym_dictionary] = STATE(383),
    [sym_dictionary_comprehension] = STATE(383),
    [sym_pair] = STATE(918),
    [sym_set] = STATE(383),
    [sym_set_comprehension] = STATE(383),
    [sym_parenthesized_expression] = STATE(383),
    [sym_tuple] = STATE(383),
    [sym_generator_expression] = STATE(383),
    [sym_conditional_expression] = STATE(768),
    [sym_concatenated_string] = STATE(383),
    [sym_string] = STATE(381),
    [sym_await] = STATE(768),
    [sym_identifier] = ACTIONS(387),
    [anon_sym_LPAREN] = ACTIONS(389),
    [anon_sym_print] = ACTIONS(393),
    [anon_sym_STAR_STAR] = ACTIONS(359),
    [anon_sym_exec] = ACTIONS(393),
    [anon_sym_not] = ACTIONS(361),
    [anon_sym_PLUS] = ACTIONS(363),
    [anon_sym_DASH] = ACTIONS(363),
    [anon_sym_TILDE] = ACTIONS(363),
    [anon_sym_lambda] = ACTIONS(365),
    [anon_sym_LBRACK] = ACTIONS(367),
    [sym_ellipsis] = ACTIONS(369),
    [anon_sym_LBRACE] = ACTIONS(371),
    [anon_sym_RBRACE] = ACTIONS(534),
    [sym_integer] = ACTIONS(373),
    [sym_float] = ACTIONS(369),
    [sym_true] = ACTIONS(373),
    [sym_false] = ACTIONS(373),
    [sym_none] = ACTIONS(373),
    [anon_sym_await] = ACTIONS(375),
    [sym_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(377),
  },
  [147] = {
    [anon_sym_DOT] = ACTIONS(536),
    [anon_sym_from] = ACTIONS(536),
    [anon_sym_LPAREN] = ACTIONS(536),
    [anon_sym_COMMA] = ACTIONS(536),
    [anon_sym_STAR] = ACTIONS(538),
    [anon_sym_GT_GT] = ACTIONS(538),
    [anon_sym_if] = ACTIONS(536),
    [anon_sym_COLON] = ACTIONS(536),
    [anon_sym_in] = ACTIONS(536),
    [anon_sym_EQ] = ACTIONS(538),
    [anon_sym_STAR_STAR] = ACTIONS(538),
    [anon_sym_AT] = ACTIONS(538),
    [anon_sym_not] = ACTIONS(536),
    [anon_sym_and] = ACTIONS(536),
    [anon_sym_or] = ACTIONS(536),
    [anon_sym_PLUS] = ACTIONS(538),
    [anon_sym_DASH] = ACTIONS(538),
    [anon_sym_SLASH] = ACTIONS(538),
    [anon_sym_PERCENT] = ACTIONS(538),
    [anon_sym_SLASH_SLASH] = ACTIONS(538),
    [anon_sym_PIPE] = ACTIONS(538),
    [anon_sym_AMP] = ACTIONS(538),
    [anon_sym_CARET] = ACTIONS(538),
    [anon_sym_LT_LT] = ACTIONS(538),
    [anon_sym_LT] = ACTIONS(538),
    [anon_sym_LT_EQ] = ACTIONS(536),
    [anon_sym_EQ_EQ] = ACTIONS(536),
    [anon_sym_BANG_EQ] = ACTIONS(536),
    [anon_sym_GT_EQ] = ACTIONS(536),
    [anon_sym_GT] = ACTIONS(538),
    [anon_sym_LT_GT] = ACTIONS(536),
    [anon_sym_is] = ACTIONS(536),
    [anon_sym_PLUS_EQ] = ACTIONS(536),
    [anon_sym_DASH_EQ] = ACTIONS(536),
    [anon_sym_STAR_EQ] = ACTIONS(536),
    [anon_sym_SLASH_EQ] = ACTIONS(536),
    [anon_sym_AT_EQ] = ACTIONS(536),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(536),
    [anon_sym_PERCENT_EQ] = ACTIONS(536),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(536),
    [anon_sym_GT_GT_EQ] = ACTIONS(536),
    [anon_sym_LT_LT_EQ] = ACTIONS(536),
    [anon_sym_AMP_EQ] = ACTIONS(536),
    [anon_sym_CARET_EQ] = ACTIONS(536),
    [anon_sym_PIPE_EQ] = ACTIONS(536),
    [anon_sym_LBRACK] = ACTIONS(536),
    [sym_comment] = ACTIONS(3),
    [sym__semicolon] = ACTIONS(536),
    [sym__newline] = ACTIONS(536),
  },
  [148] = {
    [anon_sym_DOT] = ACTIONS(540),
    [anon_sym_from] = ACTIONS(540),
    [anon_sym_LPAREN] = ACTIONS(540),
    [anon_sym_COMMA] = ACTIONS(540),
    [anon_sym_STAR] = ACTIONS(542),
    [anon_sym_GT_GT] = ACTIONS(542),
    [anon_sym_if] = ACTIONS(540),
    [anon_sym_COLON] = ACTIONS(540),
    [anon_sym_in] = ACTIONS(540),
    [anon_sym_EQ] = ACTIONS(542),
    [anon_sym_STAR_STAR] = ACTIONS(542),
    [anon_sym_AT] = ACTIONS(542),
    [anon_sym_not] = ACTIONS(540),
    [anon_sym_and] = ACTIONS(540),
    [anon_sym_or] = ACTIONS(540),
    [anon_sym_PLUS] = ACTIONS(542),
    [anon_sym_DASH] = ACTIONS(542),
    [anon_sym_SLASH] = ACTIONS(542),
    [anon_sym_PERCENT] = ACTIONS(542),
    [anon_sym_SLASH_SLASH] = ACTIONS(542),
    [anon_sym_PIPE] = ACTIONS(542),
    [anon_sym_AMP] = ACTIONS(542),
    [anon_sym_CARET] = ACTIONS(542),
    [anon_sym_LT_LT] = ACTIONS(542),
    [anon_sym_LT] = ACTIONS(542),
    [anon_sym_LT_EQ] = ACTIONS(540),
    [anon_sym_EQ_EQ] = ACTIONS(540),
    [anon_sym_BANG_EQ] = ACTIONS(540),
    [anon_sym_GT_EQ] = ACTIONS(540),
    [anon_sym_GT] = ACTIONS(542),
    [anon_sym_LT_GT] = ACTIONS(540),
    [anon_sym_is] = ACTIONS(540),
    [anon_sym_PLUS_EQ] = ACTIONS(540),
    [anon_sym_DASH_EQ] = ACTIONS(540),
    [anon_sym_STAR_EQ] = ACTIONS(540),
    [anon_sym_SLASH_EQ] = ACTIONS(540),
    [anon_sym_AT_EQ] = ACTIONS(540),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(540),
    [anon_sym_PERCENT_EQ] = ACTIONS(540),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(540),
    [anon_sym_GT_GT_EQ] = ACTIONS(540),
    [anon_sym_LT_LT_EQ] = ACTIONS(540),
    [anon_sym_AMP_EQ] = ACTIONS(540),
    [anon_sym_CARET_EQ] = ACTIONS(540),
    [anon_sym_PIPE_EQ] = ACTIONS(540),
    [anon_sym_LBRACK] = ACTIONS(540),
    [sym_comment] = ACTIONS(3),
    [sym__semicolon] = ACTIONS(540),
    [sym__newline] = ACTIONS(540),
  },
  [149] = {
    [sym_else_clause] = STATE(371),
    [sym_except_clause] = STATE(232),
    [sym_finally_clause] = STATE(420),
    [aux_sym_try_statement_repeat1] = STATE(232),
    [ts_builtin_sym_end] = ACTIONS(544),
    [sym_identifier] = ACTIONS(546),
    [anon_sym_import] = ACTIONS(546),
    [anon_sym_from] = ACTIONS(546),
    [anon_sym_LPAREN] = ACTIONS(544),
    [anon_sym_print] = ACTIONS(546),
    [anon_sym_assert] = ACTIONS(546),
    [anon_sym_return] = ACTIONS(546),
    [anon_sym_del] = ACTIONS(546),
    [anon_sym_raise] = ACTIONS(546),
    [anon_sym_pass] = ACTIONS(546),
    [anon_sym_break] = ACTIONS(546),
    [anon_sym_continue] = ACTIONS(546),
    [anon_sym_if] = ACTIONS(546),
    [anon_sym_else] = ACTIONS(548),
    [anon_sym_async] = ACTIONS(546),
    [anon_sym_for] = ACTIONS(546),
    [anon_sym_while] = ACTIONS(546),
    [anon_sym_try] = ACTIONS(546),
    [anon_sym_except] = ACTIONS(550),
    [anon_sym_finally] = ACTIONS(552),
    [anon_sym_with] = ACTIONS(546),
    [anon_sym_def] = ACTIONS(546),
    [anon_sym_global] = ACTIONS(546),
    [anon_sym_nonlocal] = ACTIONS(546),
    [anon_sym_exec] = ACTIONS(546),
    [anon_sym_class] = ACTIONS(546),
    [anon_sym_AT] = ACTIONS(544),
    [anon_sym_not] = ACTIONS(546),
    [anon_sym_PLUS] = ACTIONS(544),
    [anon_sym_DASH] = ACTIONS(544),
    [anon_sym_TILDE] = ACTIONS(544),
    [anon_sym_lambda] = ACTIONS(546),
    [anon_sym_yield] = ACTIONS(546),
    [anon_sym_LBRACK] = ACTIONS(544),
    [sym_ellipsis] = ACTIONS(544),
    [anon_sym_LBRACE] = ACTIONS(544),
    [sym_integer] = ACTIONS(546),
    [sym_float] = ACTIONS(544),
    [sym_true] = ACTIONS(546),
    [sym_false] = ACTIONS(546),
    [sym_none] = ACTIONS(546),
    [anon_sym_await] = ACTIONS(546),
    [sym_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(544),
  },
  [150] = {
    [sym_named_expression] = STATE(651),
    [sym_list_splat] = STATE(836),
    [sym__expression] = STATE(651),
    [sym__primary_expression] = STATE(383),
    [sym_not_operator] = STATE(651),
    [sym_boolean_operator] = STATE(651),
    [sym_binary_operator] = STATE(383),
    [sym_unary_operator] = STATE(383),
    [sym_comparison_operator] = STATE(651),
    [sym_lambda] = STATE(651),
    [sym_attribute] = STATE(383),
    [sym_subscript] = STATE(383),
    [sym_call] = STATE(383),
    [sym_list] = STATE(383),
    [sym_list_comprehension] = STATE(383),
    [sym_dictionary] = STATE(383),
    [sym_dictionary_comprehension] = STATE(383),
    [sym_set] = STATE(383),
    [sym_set_comprehension] = STATE(383),
    [sym_parenthesized_expression] = STATE(383),
    [sym_tuple] = STATE(383),
    [sym_generator_expression] = STATE(383),
    [sym_conditional_expression] = STATE(651),
    [sym_concatenated_string] = STATE(383),
    [sym_string] = STATE(381),
    [sym_await] = STATE(651),
    [sym_identifier] = ACTIONS(387),
    [anon_sym_LPAREN] = ACTIONS(389),
    [anon_sym_COMMA] = ACTIONS(554),
    [anon_sym_STAR] = ACTIONS(463),
    [anon_sym_print] = ACTIONS(393),
    [anon_sym_exec] = ACTIONS(393),
    [anon_sym_not] = ACTIONS(361),
    [anon_sym_PLUS] = ACTIONS(363),
    [anon_sym_DASH] = ACTIONS(363),
    [anon_sym_TILDE] = ACTIONS(363),
    [anon_sym_lambda] = ACTIONS(365),
    [anon_sym_LBRACK] = ACTIONS(367),
    [anon_sym_RBRACK] = ACTIONS(556),
    [sym_ellipsis] = ACTIONS(369),
    [anon_sym_LBRACE] = ACTIONS(371),
    [sym_integer] = ACTIONS(373),
    [sym_float] = ACTIONS(369),
    [sym_true] = ACTIONS(373),
    [sym_false] = ACTIONS(373),
    [sym_none] = ACTIONS(373),
    [anon_sym_await] = ACTIONS(375),
    [sym_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(377),
  },
  [151] = {
    [sym_named_expression] = STATE(654),
    [sym__expression] = STATE(654),
    [sym__primary_expression] = STATE(383),
    [sym_not_operator] = STATE(654),
    [sym_boolean_operator] = STATE(654),
    [sym_binary_operator] = STATE(383),
    [sym_unary_operator] = STATE(383),
    [sym_comparison_operator] = STATE(654),
    [sym_lambda] = STATE(654),
    [sym_yield] = STATE(833),
    [sym_attribute] = STATE(383),
    [sym_subscript] = STATE(383),
    [sym_call] = STATE(383),
    [sym_list] = STATE(383),
    [sym_list_comprehension] = STATE(383),
    [sym_dictionary] = STATE(383),
    [sym_dictionary_comprehension] = STATE(383),
    [sym_set] = STATE(383),
    [sym_set_comprehension] = STATE(383),
    [sym_parenthesized_expression] = STATE(383),
    [sym_tuple] = STATE(383),
    [sym_generator_expression] = STATE(383),
    [sym_conditional_expression] = STATE(654),
    [sym_concatenated_string] = STATE(383),
    [sym_string] = STATE(381),
    [sym_await] = STATE(654),
    [sym_identifier] = ACTIONS(387),
    [anon_sym_LPAREN] = ACTIONS(389),
    [anon_sym_RPAREN] = ACTIONS(459),
    [anon_sym_COMMA] = ACTIONS(461),
    [anon_sym_print] = ACTIONS(393),
    [anon_sym_exec] = ACTIONS(393),
    [anon_sym_not] = ACTIONS(361),
    [anon_sym_PLUS] = ACTIONS(363),
    [anon_sym_DASH] = ACTIONS(363),
    [anon_sym_TILDE] = ACTIONS(363),
    [anon_sym_lambda] = ACTIONS(365),
    [anon_sym_yield] = ACTIONS(465),
    [anon_sym_LBRACK] = ACTIONS(367),
    [sym_ellipsis] = ACTIONS(369),
    [anon_sym_LBRACE] = ACTIONS(371),
    [sym_integer] = ACTIONS(373),
    [sym_float] = ACTIONS(369),
    [sym_true] = ACTIONS(373),
    [sym_false] = ACTIONS(373),
    [sym_none] = ACTIONS(373),
    [anon_sym_await] = ACTIONS(375),
    [sym_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(377),
  },
  [152] = {
    [anon_sym_DOT] = ACTIONS(558),
    [anon_sym_from] = ACTIONS(558),
    [anon_sym_LPAREN] = ACTIONS(558),
    [anon_sym_COMMA] = ACTIONS(558),
    [anon_sym_STAR] = ACTIONS(560),
    [anon_sym_GT_GT] = ACTIONS(560),
    [anon_sym_if] = ACTIONS(558),
    [anon_sym_COLON] = ACTIONS(558),
    [anon_sym_in] = ACTIONS(558),
    [anon_sym_EQ] = ACTIONS(560),
    [anon_sym_STAR_STAR] = ACTIONS(560),
    [anon_sym_AT] = ACTIONS(560),
    [anon_sym_not] = ACTIONS(558),
    [anon_sym_and] = ACTIONS(558),
    [anon_sym_or] = ACTIONS(558),
    [anon_sym_PLUS] = ACTIONS(560),
    [anon_sym_DASH] = ACTIONS(560),
    [anon_sym_SLASH] = ACTIONS(560),
    [anon_sym_PERCENT] = ACTIONS(560),
    [anon_sym_SLASH_SLASH] = ACTIONS(560),
    [anon_sym_PIPE] = ACTIONS(560),
    [anon_sym_AMP] = ACTIONS(560),
    [anon_sym_CARET] = ACTIONS(560),
    [anon_sym_LT_LT] = ACTIONS(560),
    [anon_sym_LT] = ACTIONS(560),
    [anon_sym_LT_EQ] = ACTIONS(558),
    [anon_sym_EQ_EQ] = ACTIONS(558),
    [anon_sym_BANG_EQ] = ACTIONS(558),
    [anon_sym_GT_EQ] = ACTIONS(558),
    [anon_sym_GT] = ACTIONS(560),
    [anon_sym_LT_GT] = ACTIONS(558),
    [anon_sym_is] = ACTIONS(558),
    [anon_sym_PLUS_EQ] = ACTIONS(558),
    [anon_sym_DASH_EQ] = ACTIONS(558),
    [anon_sym_STAR_EQ] = ACTIONS(558),
    [anon_sym_SLASH_EQ] = ACTIONS(558),
    [anon_sym_AT_EQ] = ACTIONS(558),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(558),
    [anon_sym_PERCENT_EQ] = ACTIONS(558),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(558),
    [anon_sym_GT_GT_EQ] = ACTIONS(558),
    [anon_sym_LT_LT_EQ] = ACTIONS(558),
    [anon_sym_AMP_EQ] = ACTIONS(558),
    [anon_sym_CARET_EQ] = ACTIONS(558),
    [anon_sym_PIPE_EQ] = ACTIONS(558),
    [anon_sym_LBRACK] = ACTIONS(558),
    [sym_comment] = ACTIONS(3),
    [sym__semicolon] = ACTIONS(558),
    [sym__newline] = ACTIONS(558),
  },
  [153] = {
    [sym_named_expression] = STATE(657),
    [sym_list_splat] = STATE(902),
    [sym__expression] = STATE(657),
    [sym__primary_expression] = STATE(383),
    [sym_not_operator] = STATE(657),
    [sym_boolean_operator] = STATE(657),
    [sym_binary_operator] = STATE(383),
    [sym_unary_operator] = STATE(383),
    [sym_comparison_operator] = STATE(657),
    [sym_lambda] = STATE(657),
    [sym_attribute] = STATE(383),
    [sym_subscript] = STATE(383),
    [sym_call] = STATE(383),
    [sym_list] = STATE(383),
    [sym_list_comprehension] = STATE(383),
    [sym_dictionary] = STATE(383),
    [sym_dictionary_comprehension] = STATE(383),
    [sym_set] = STATE(383),
    [sym_set_comprehension] = STATE(383),
    [sym_parenthesized_expression] = STATE(383),
    [sym_tuple] = STATE(383),
    [sym_generator_expression] = STATE(383),
    [sym_conditional_expression] = STATE(657),
    [sym_concatenated_string] = STATE(383),
    [sym_string] = STATE(381),
    [sym_await] = STATE(657),
    [sym_identifier] = ACTIONS(387),
    [anon_sym_LPAREN] = ACTIONS(389),
    [anon_sym_COMMA] = ACTIONS(562),
    [anon_sym_STAR] = ACTIONS(463),
    [anon_sym_print] = ACTIONS(393),
    [anon_sym_exec] = ACTIONS(393),
    [anon_sym_not] = ACTIONS(361),
    [anon_sym_PLUS] = ACTIONS(363),
    [anon_sym_DASH] = ACTIONS(363),
    [anon_sym_TILDE] = ACTIONS(363),
    [anon_sym_lambda] = ACTIONS(365),
    [anon_sym_LBRACK] = ACTIONS(367),
    [anon_sym_RBRACK] = ACTIONS(564),
    [sym_ellipsis] = ACTIONS(369),
    [anon_sym_LBRACE] = ACTIONS(371),
    [sym_integer] = ACTIONS(373),
    [sym_float] = ACTIONS(369),
    [sym_true] = ACTIONS(373),
    [sym_false] = ACTIONS(373),
    [sym_none] = ACTIONS(373),
    [anon_sym_await] = ACTIONS(375),
    [sym_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(377),
  },
  [154] = {
    [anon_sym_DOT] = ACTIONS(566),
    [anon_sym_from] = ACTIONS(566),
    [anon_sym_LPAREN] = ACTIONS(566),
    [anon_sym_COMMA] = ACTIONS(566),
    [anon_sym_STAR] = ACTIONS(568),
    [anon_sym_GT_GT] = ACTIONS(568),
    [anon_sym_if] = ACTIONS(566),
    [anon_sym_COLON] = ACTIONS(566),
    [anon_sym_in] = ACTIONS(566),
    [anon_sym_EQ] = ACTIONS(568),
    [anon_sym_STAR_STAR] = ACTIONS(568),
    [anon_sym_AT] = ACTIONS(568),
    [anon_sym_not] = ACTIONS(566),
    [anon_sym_and] = ACTIONS(566),
    [anon_sym_or] = ACTIONS(566),
    [anon_sym_PLUS] = ACTIONS(568),
    [anon_sym_DASH] = ACTIONS(568),
    [anon_sym_SLASH] = ACTIONS(568),
    [anon_sym_PERCENT] = ACTIONS(568),
    [anon_sym_SLASH_SLASH] = ACTIONS(568),
    [anon_sym_PIPE] = ACTIONS(568),
    [anon_sym_AMP] = ACTIONS(568),
    [anon_sym_CARET] = ACTIONS(568),
    [anon_sym_LT_LT] = ACTIONS(568),
    [anon_sym_LT] = ACTIONS(568),
    [anon_sym_LT_EQ] = ACTIONS(566),
    [anon_sym_EQ_EQ] = ACTIONS(566),
    [anon_sym_BANG_EQ] = ACTIONS(566),
    [anon_sym_GT_EQ] = ACTIONS(566),
    [anon_sym_GT] = ACTIONS(568),
    [anon_sym_LT_GT] = ACTIONS(566),
    [anon_sym_is] = ACTIONS(566),
    [anon_sym_PLUS_EQ] = ACTIONS(566),
    [anon_sym_DASH_EQ] = ACTIONS(566),
    [anon_sym_STAR_EQ] = ACTIONS(566),
    [anon_sym_SLASH_EQ] = ACTIONS(566),
    [anon_sym_AT_EQ] = ACTIONS(566),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(566),
    [anon_sym_PERCENT_EQ] = ACTIONS(566),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(566),
    [anon_sym_GT_GT_EQ] = ACTIONS(566),
    [anon_sym_LT_LT_EQ] = ACTIONS(566),
    [anon_sym_AMP_EQ] = ACTIONS(566),
    [anon_sym_CARET_EQ] = ACTIONS(566),
    [anon_sym_PIPE_EQ] = ACTIONS(566),
    [anon_sym_LBRACK] = ACTIONS(566),
    [sym_comment] = ACTIONS(3),
    [sym__semicolon] = ACTIONS(566),
    [sym__newline] = ACTIONS(566),
  },
  [155] = {
    [anon_sym_DOT] = ACTIONS(570),
    [anon_sym_from] = ACTIONS(570),
    [anon_sym_LPAREN] = ACTIONS(570),
    [anon_sym_COMMA] = ACTIONS(570),
    [anon_sym_STAR] = ACTIONS(572),
    [anon_sym_GT_GT] = ACTIONS(572),
    [anon_sym_if] = ACTIONS(570),
    [anon_sym_COLON] = ACTIONS(570),
    [anon_sym_in] = ACTIONS(570),
    [anon_sym_EQ] = ACTIONS(572),
    [anon_sym_STAR_STAR] = ACTIONS(572),
    [anon_sym_AT] = ACTIONS(572),
    [anon_sym_not] = ACTIONS(570),
    [anon_sym_and] = ACTIONS(570),
    [anon_sym_or] = ACTIONS(570),
    [anon_sym_PLUS] = ACTIONS(572),
    [anon_sym_DASH] = ACTIONS(572),
    [anon_sym_SLASH] = ACTIONS(572),
    [anon_sym_PERCENT] = ACTIONS(572),
    [anon_sym_SLASH_SLASH] = ACTIONS(572),
    [anon_sym_PIPE] = ACTIONS(572),
    [anon_sym_AMP] = ACTIONS(572),
    [anon_sym_CARET] = ACTIONS(572),
    [anon_sym_LT_LT] = ACTIONS(572),
    [anon_sym_LT] = ACTIONS(572),
    [anon_sym_LT_EQ] = ACTIONS(570),
    [anon_sym_EQ_EQ] = ACTIONS(570),
    [anon_sym_BANG_EQ] = ACTIONS(570),
    [anon_sym_GT_EQ] = ACTIONS(570),
    [anon_sym_GT] = ACTIONS(572),
    [anon_sym_LT_GT] = ACTIONS(570),
    [anon_sym_is] = ACTIONS(570),
    [anon_sym_PLUS_EQ] = ACTIONS(570),
    [anon_sym_DASH_EQ] = ACTIONS(570),
    [anon_sym_STAR_EQ] = ACTIONS(570),
    [anon_sym_SLASH_EQ] = ACTIONS(570),
    [anon_sym_AT_EQ] = ACTIONS(570),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(570),
    [anon_sym_PERCENT_EQ] = ACTIONS(570),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(570),
    [anon_sym_GT_GT_EQ] = ACTIONS(570),
    [anon_sym_LT_LT_EQ] = ACTIONS(570),
    [anon_sym_AMP_EQ] = ACTIONS(570),
    [anon_sym_CARET_EQ] = ACTIONS(570),
    [anon_sym_PIPE_EQ] = ACTIONS(570),
    [anon_sym_LBRACK] = ACTIONS(570),
    [sym_comment] = ACTIONS(3),
    [sym__semicolon] = ACTIONS(570),
    [sym__newline] = ACTIONS(570),
  },
  [156] = {
    [anon_sym_DOT] = ACTIONS(574),
    [anon_sym_from] = ACTIONS(574),
    [anon_sym_LPAREN] = ACTIONS(574),
    [anon_sym_COMMA] = ACTIONS(574),
    [anon_sym_STAR] = ACTIONS(576),
    [anon_sym_GT_GT] = ACTIONS(576),
    [anon_sym_if] = ACTIONS(574),
    [anon_sym_COLON] = ACTIONS(574),
    [anon_sym_in] = ACTIONS(574),
    [anon_sym_EQ] = ACTIONS(576),
    [anon_sym_STAR_STAR] = ACTIONS(576),
    [anon_sym_AT] = ACTIONS(576),
    [anon_sym_not] = ACTIONS(574),
    [anon_sym_and] = ACTIONS(574),
    [anon_sym_or] = ACTIONS(574),
    [anon_sym_PLUS] = ACTIONS(576),
    [anon_sym_DASH] = ACTIONS(576),
    [anon_sym_SLASH] = ACTIONS(576),
    [anon_sym_PERCENT] = ACTIONS(576),
    [anon_sym_SLASH_SLASH] = ACTIONS(576),
    [anon_sym_PIPE] = ACTIONS(576),
    [anon_sym_AMP] = ACTIONS(576),
    [anon_sym_CARET] = ACTIONS(576),
    [anon_sym_LT_LT] = ACTIONS(576),
    [anon_sym_LT] = ACTIONS(576),
    [anon_sym_LT_EQ] = ACTIONS(574),
    [anon_sym_EQ_EQ] = ACTIONS(574),
    [anon_sym_BANG_EQ] = ACTIONS(574),
    [anon_sym_GT_EQ] = ACTIONS(574),
    [anon_sym_GT] = ACTIONS(576),
    [anon_sym_LT_GT] = ACTIONS(574),
    [anon_sym_is] = ACTIONS(574),
    [anon_sym_PLUS_EQ] = ACTIONS(574),
    [anon_sym_DASH_EQ] = ACTIONS(574),
    [anon_sym_STAR_EQ] = ACTIONS(574),
    [anon_sym_SLASH_EQ] = ACTIONS(574),
    [anon_sym_AT_EQ] = ACTIONS(574),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(574),
    [anon_sym_PERCENT_EQ] = ACTIONS(574),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(574),
    [anon_sym_GT_GT_EQ] = ACTIONS(574),
    [anon_sym_LT_LT_EQ] = ACTIONS(574),
    [anon_sym_AMP_EQ] = ACTIONS(574),
    [anon_sym_CARET_EQ] = ACTIONS(574),
    [anon_sym_PIPE_EQ] = ACTIONS(574),
    [anon_sym_LBRACK] = ACTIONS(574),
    [sym_comment] = ACTIONS(3),
    [sym__semicolon] = ACTIONS(574),
    [sym__newline] = ACTIONS(574),
  },
  [157] = {
    [sym_named_expression] = STATE(650),
    [sym_list_splat] = STATE(850),
    [sym__expression] = STATE(650),
    [sym__primary_expression] = STATE(383),
    [sym_not_operator] = STATE(650),
    [sym_boolean_operator] = STATE(650),
    [sym_binary_operator] = STATE(383),
    [sym_unary_operator] = STATE(383),
    [sym_comparison_operator] = STATE(650),
    [sym_lambda] = STATE(650),
    [sym_attribute] = STATE(383),
    [sym_subscript] = STATE(383),
    [sym_call] = STATE(383),
    [sym_list] = STATE(383),
    [sym_list_comprehension] = STATE(383),
    [sym_dictionary] = STATE(383),
    [sym_dictionary_comprehension] = STATE(383),
    [sym_set] = STATE(383),
    [sym_set_comprehension] = STATE(383),
    [sym_parenthesized_expression] = STATE(383),
    [sym_tuple] = STATE(383),
    [sym_generator_expression] = STATE(383),
    [sym_conditional_expression] = STATE(650),
    [sym_concatenated_string] = STATE(383),
    [sym_string] = STATE(381),
    [sym_await] = STATE(650),
    [sym_identifier] = ACTIONS(387),
    [anon_sym_LPAREN] = ACTIONS(389),
    [anon_sym_COMMA] = ACTIONS(578),
    [anon_sym_STAR] = ACTIONS(463),
    [anon_sym_print] = ACTIONS(393),
    [anon_sym_exec] = ACTIONS(393),
    [anon_sym_not] = ACTIONS(361),
    [anon_sym_PLUS] = ACTIONS(363),
    [anon_sym_DASH] = ACTIONS(363),
    [anon_sym_TILDE] = ACTIONS(363),
    [anon_sym_lambda] = ACTIONS(365),
    [anon_sym_LBRACK] = ACTIONS(367),
    [anon_sym_RBRACK] = ACTIONS(580),
    [sym_ellipsis] = ACTIONS(369),
    [anon_sym_LBRACE] = ACTIONS(371),
    [sym_integer] = ACTIONS(373),
    [sym_float] = ACTIONS(369),
    [sym_true] = ACTIONS(373),
    [sym_false] = ACTIONS(373),
    [sym_none] = ACTIONS(373),
    [anon_sym_await] = ACTIONS(375),
    [sym_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(377),
  },
  [158] = {
    [anon_sym_DOT] = ACTIONS(582),
    [anon_sym_from] = ACTIONS(582),
    [anon_sym_LPAREN] = ACTIONS(582),
    [anon_sym_COMMA] = ACTIONS(582),
    [anon_sym_STAR] = ACTIONS(584),
    [anon_sym_GT_GT] = ACTIONS(584),
    [anon_sym_if] = ACTIONS(582),
    [anon_sym_COLON] = ACTIONS(582),
    [anon_sym_in] = ACTIONS(582),
    [anon_sym_EQ] = ACTIONS(584),
    [anon_sym_STAR_STAR] = ACTIONS(584),
    [anon_sym_AT] = ACTIONS(584),
    [anon_sym_not] = ACTIONS(582),
    [anon_sym_and] = ACTIONS(582),
    [anon_sym_or] = ACTIONS(582),
    [anon_sym_PLUS] = ACTIONS(584),
    [anon_sym_DASH] = ACTIONS(584),
    [anon_sym_SLASH] = ACTIONS(584),
    [anon_sym_PERCENT] = ACTIONS(584),
    [anon_sym_SLASH_SLASH] = ACTIONS(584),
    [anon_sym_PIPE] = ACTIONS(584),
    [anon_sym_AMP] = ACTIONS(584),
    [anon_sym_CARET] = ACTIONS(584),
    [anon_sym_LT_LT] = ACTIONS(584),
    [anon_sym_LT] = ACTIONS(584),
    [anon_sym_LT_EQ] = ACTIONS(582),
    [anon_sym_EQ_EQ] = ACTIONS(582),
    [anon_sym_BANG_EQ] = ACTIONS(582),
    [anon_sym_GT_EQ] = ACTIONS(582),
    [anon_sym_GT] = ACTIONS(584),
    [anon_sym_LT_GT] = ACTIONS(582),
    [anon_sym_is] = ACTIONS(582),
    [anon_sym_PLUS_EQ] = ACTIONS(582),
    [anon_sym_DASH_EQ] = ACTIONS(582),
    [anon_sym_STAR_EQ] = ACTIONS(582),
    [anon_sym_SLASH_EQ] = ACTIONS(582),
    [anon_sym_AT_EQ] = ACTIONS(582),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(582),
    [anon_sym_PERCENT_EQ] = ACTIONS(582),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(582),
    [anon_sym_GT_GT_EQ] = ACTIONS(582),
    [anon_sym_LT_LT_EQ] = ACTIONS(582),
    [anon_sym_AMP_EQ] = ACTIONS(582),
    [anon_sym_CARET_EQ] = ACTIONS(582),
    [anon_sym_PIPE_EQ] = ACTIONS(582),
    [anon_sym_LBRACK] = ACTIONS(582),
    [sym_comment] = ACTIONS(3),
    [sym__semicolon] = ACTIONS(582),
    [sym__newline] = ACTIONS(582),
  },
  [159] = {
    [sym_named_expression] = STATE(768),
    [sym_dictionary_splat] = STATE(918),
    [sym__expression] = STATE(768),
    [sym__primary_expression] = STATE(383),
    [sym_not_operator] = STATE(768),
    [sym_boolean_operator] = STATE(768),
    [sym_binary_operator] = STATE(383),
    [sym_unary_operator] = STATE(383),
    [sym_comparison_operator] = STATE(768),
    [sym_lambda] = STATE(768),
    [sym_attribute] = STATE(383),
    [sym_subscript] = STATE(383),
    [sym_call] = STATE(383),
    [sym_list] = STATE(383),
    [sym_list_comprehension] = STATE(383),
    [sym_dictionary] = STATE(383),
    [sym_dictionary_comprehension] = STATE(383),
    [sym_pair] = STATE(918),
    [sym_set] = STATE(383),
    [sym_set_comprehension] = STATE(383),
    [sym_parenthesized_expression] = STATE(383),
    [sym_tuple] = STATE(383),
    [sym_generator_expression] = STATE(383),
    [sym_conditional_expression] = STATE(768),
    [sym_concatenated_string] = STATE(383),
    [sym_string] = STATE(381),
    [sym_await] = STATE(768),
    [sym_identifier] = ACTIONS(387),
    [anon_sym_LPAREN] = ACTIONS(389),
    [anon_sym_print] = ACTIONS(393),
    [anon_sym_STAR_STAR] = ACTIONS(359),
    [anon_sym_exec] = ACTIONS(393),
    [anon_sym_not] = ACTIONS(361),
    [anon_sym_PLUS] = ACTIONS(363),
    [anon_sym_DASH] = ACTIONS(363),
    [anon_sym_TILDE] = ACTIONS(363),
    [anon_sym_lambda] = ACTIONS(365),
    [anon_sym_LBRACK] = ACTIONS(367),
    [sym_ellipsis] = ACTIONS(369),
    [anon_sym_LBRACE] = ACTIONS(371),
    [anon_sym_RBRACE] = ACTIONS(586),
    [sym_integer] = ACTIONS(373),
    [sym_float] = ACTIONS(369),
    [sym_true] = ACTIONS(373),
    [sym_false] = ACTIONS(373),
    [sym_none] = ACTIONS(373),
    [anon_sym_await] = ACTIONS(375),
    [sym_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(377),
  },
  [160] = {
    [anon_sym_DOT] = ACTIONS(588),
    [anon_sym_from] = ACTIONS(588),
    [anon_sym_LPAREN] = ACTIONS(588),
    [anon_sym_COMMA] = ACTIONS(588),
    [anon_sym_STAR] = ACTIONS(590),
    [anon_sym_GT_GT] = ACTIONS(590),
    [anon_sym_if] = ACTIONS(588),
    [anon_sym_COLON] = ACTIONS(588),
    [anon_sym_in] = ACTIONS(588),
    [anon_sym_EQ] = ACTIONS(590),
    [anon_sym_STAR_STAR] = ACTIONS(590),
    [anon_sym_AT] = ACTIONS(590),
    [anon_sym_not] = ACTIONS(588),
    [anon_sym_and] = ACTIONS(588),
    [anon_sym_or] = ACTIONS(588),
    [anon_sym_PLUS] = ACTIONS(590),
    [anon_sym_DASH] = ACTIONS(590),
    [anon_sym_SLASH] = ACTIONS(590),
    [anon_sym_PERCENT] = ACTIONS(590),
    [anon_sym_SLASH_SLASH] = ACTIONS(590),
    [anon_sym_PIPE] = ACTIONS(590),
    [anon_sym_AMP] = ACTIONS(590),
    [anon_sym_CARET] = ACTIONS(590),
    [anon_sym_LT_LT] = ACTIONS(590),
    [anon_sym_LT] = ACTIONS(590),
    [anon_sym_LT_EQ] = ACTIONS(588),
    [anon_sym_EQ_EQ] = ACTIONS(588),
    [anon_sym_BANG_EQ] = ACTIONS(588),
    [anon_sym_GT_EQ] = ACTIONS(588),
    [anon_sym_GT] = ACTIONS(590),
    [anon_sym_LT_GT] = ACTIONS(588),
    [anon_sym_is] = ACTIONS(588),
    [anon_sym_PLUS_EQ] = ACTIONS(588),
    [anon_sym_DASH_EQ] = ACTIONS(588),
    [anon_sym_STAR_EQ] = ACTIONS(588),
    [anon_sym_SLASH_EQ] = ACTIONS(588),
    [anon_sym_AT_EQ] = ACTIONS(588),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(588),
    [anon_sym_PERCENT_EQ] = ACTIONS(588),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(588),
    [anon_sym_GT_GT_EQ] = ACTIONS(588),
    [anon_sym_LT_LT_EQ] = ACTIONS(588),
    [anon_sym_AMP_EQ] = ACTIONS(588),
    [anon_sym_CARET_EQ] = ACTIONS(588),
    [anon_sym_PIPE_EQ] = ACTIONS(588),
    [anon_sym_LBRACK] = ACTIONS(588),
    [sym_comment] = ACTIONS(3),
    [sym__semicolon] = ACTIONS(588),
    [sym__newline] = ACTIONS(588),
  },
  [161] = {
    [sym_named_expression] = STATE(768),
    [sym_dictionary_splat] = STATE(918),
    [sym__expression] = STATE(768),
    [sym__primary_expression] = STATE(383),
    [sym_not_operator] = STATE(768),
    [sym_boolean_operator] = STATE(768),
    [sym_binary_operator] = STATE(383),
    [sym_unary_operator] = STATE(383),
    [sym_comparison_operator] = STATE(768),
    [sym_lambda] = STATE(768),
    [sym_attribute] = STATE(383),
    [sym_subscript] = STATE(383),
    [sym_call] = STATE(383),
    [sym_list] = STATE(383),
    [sym_list_comprehension] = STATE(383),
    [sym_dictionary] = STATE(383),
    [sym_dictionary_comprehension] = STATE(383),
    [sym_pair] = STATE(918),
    [sym_set] = STATE(383),
    [sym_set_comprehension] = STATE(383),
    [sym_parenthesized_expression] = STATE(383),
    [sym_tuple] = STATE(383),
    [sym_generator_expression] = STATE(383),
    [sym_conditional_expression] = STATE(768),
    [sym_concatenated_string] = STATE(383),
    [sym_string] = STATE(381),
    [sym_await] = STATE(768),
    [sym_identifier] = ACTIONS(387),
    [anon_sym_LPAREN] = ACTIONS(389),
    [anon_sym_print] = ACTIONS(393),
    [anon_sym_STAR_STAR] = ACTIONS(359),
    [anon_sym_exec] = ACTIONS(393),
    [anon_sym_not] = ACTIONS(361),
    [anon_sym_PLUS] = ACTIONS(363),
    [anon_sym_DASH] = ACTIONS(363),
    [anon_sym_TILDE] = ACTIONS(363),
    [anon_sym_lambda] = ACTIONS(365),
    [anon_sym_LBRACK] = ACTIONS(367),
    [sym_ellipsis] = ACTIONS(369),
    [anon_sym_LBRACE] = ACTIONS(371),
    [anon_sym_RBRACE] = ACTIONS(592),
    [sym_integer] = ACTIONS(373),
    [sym_float] = ACTIONS(369),
    [sym_true] = ACTIONS(373),
    [sym_false] = ACTIONS(373),
    [sym_none] = ACTIONS(373),
    [anon_sym_await] = ACTIONS(375),
    [sym_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(377),
  },
  [162] = {
    [anon_sym_DOT] = ACTIONS(594),
    [anon_sym_from] = ACTIONS(594),
    [anon_sym_LPAREN] = ACTIONS(594),
    [anon_sym_COMMA] = ACTIONS(594),
    [anon_sym_STAR] = ACTIONS(596),
    [anon_sym_GT_GT] = ACTIONS(596),
    [anon_sym_if] = ACTIONS(594),
    [anon_sym_COLON] = ACTIONS(594),
    [anon_sym_in] = ACTIONS(594),
    [anon_sym_EQ] = ACTIONS(596),
    [anon_sym_STAR_STAR] = ACTIONS(596),
    [anon_sym_AT] = ACTIONS(596),
    [anon_sym_not] = ACTIONS(594),
    [anon_sym_and] = ACTIONS(594),
    [anon_sym_or] = ACTIONS(594),
    [anon_sym_PLUS] = ACTIONS(596),
    [anon_sym_DASH] = ACTIONS(596),
    [anon_sym_SLASH] = ACTIONS(596),
    [anon_sym_PERCENT] = ACTIONS(596),
    [anon_sym_SLASH_SLASH] = ACTIONS(596),
    [anon_sym_PIPE] = ACTIONS(596),
    [anon_sym_AMP] = ACTIONS(596),
    [anon_sym_CARET] = ACTIONS(596),
    [anon_sym_LT_LT] = ACTIONS(596),
    [anon_sym_LT] = ACTIONS(596),
    [anon_sym_LT_EQ] = ACTIONS(594),
    [anon_sym_EQ_EQ] = ACTIONS(594),
    [anon_sym_BANG_EQ] = ACTIONS(594),
    [anon_sym_GT_EQ] = ACTIONS(594),
    [anon_sym_GT] = ACTIONS(596),
    [anon_sym_LT_GT] = ACTIONS(594),
    [anon_sym_is] = ACTIONS(594),
    [anon_sym_PLUS_EQ] = ACTIONS(594),
    [anon_sym_DASH_EQ] = ACTIONS(594),
    [anon_sym_STAR_EQ] = ACTIONS(594),
    [anon_sym_SLASH_EQ] = ACTIONS(594),
    [anon_sym_AT_EQ] = ACTIONS(594),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(594),
    [anon_sym_PERCENT_EQ] = ACTIONS(594),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(594),
    [anon_sym_GT_GT_EQ] = ACTIONS(594),
    [anon_sym_LT_LT_EQ] = ACTIONS(594),
    [anon_sym_AMP_EQ] = ACTIONS(594),
    [anon_sym_CARET_EQ] = ACTIONS(594),
    [anon_sym_PIPE_EQ] = ACTIONS(594),
    [anon_sym_LBRACK] = ACTIONS(594),
    [sym_comment] = ACTIONS(3),
    [sym__semicolon] = ACTIONS(594),
    [sym__newline] = ACTIONS(594),
  },
  [163] = {
    [anon_sym_DOT] = ACTIONS(598),
    [anon_sym_from] = ACTIONS(598),
    [anon_sym_LPAREN] = ACTIONS(598),
    [anon_sym_COMMA] = ACTIONS(598),
    [anon_sym_STAR] = ACTIONS(600),
    [anon_sym_GT_GT] = ACTIONS(600),
    [anon_sym_if] = ACTIONS(598),
    [anon_sym_COLON] = ACTIONS(598),
    [anon_sym_in] = ACTIONS(598),
    [anon_sym_EQ] = ACTIONS(600),
    [anon_sym_STAR_STAR] = ACTIONS(600),
    [anon_sym_AT] = ACTIONS(600),
    [anon_sym_not] = ACTIONS(598),
    [anon_sym_and] = ACTIONS(598),
    [anon_sym_or] = ACTIONS(598),
    [anon_sym_PLUS] = ACTIONS(600),
    [anon_sym_DASH] = ACTIONS(600),
    [anon_sym_SLASH] = ACTIONS(600),
    [anon_sym_PERCENT] = ACTIONS(600),
    [anon_sym_SLASH_SLASH] = ACTIONS(600),
    [anon_sym_PIPE] = ACTIONS(600),
    [anon_sym_AMP] = ACTIONS(600),
    [anon_sym_CARET] = ACTIONS(600),
    [anon_sym_LT_LT] = ACTIONS(600),
    [anon_sym_LT] = ACTIONS(600),
    [anon_sym_LT_EQ] = ACTIONS(598),
    [anon_sym_EQ_EQ] = ACTIONS(598),
    [anon_sym_BANG_EQ] = ACTIONS(598),
    [anon_sym_GT_EQ] = ACTIONS(598),
    [anon_sym_GT] = ACTIONS(600),
    [anon_sym_LT_GT] = ACTIONS(598),
    [anon_sym_is] = ACTIONS(598),
    [anon_sym_PLUS_EQ] = ACTIONS(598),
    [anon_sym_DASH_EQ] = ACTIONS(598),
    [anon_sym_STAR_EQ] = ACTIONS(598),
    [anon_sym_SLASH_EQ] = ACTIONS(598),
    [anon_sym_AT_EQ] = ACTIONS(598),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(598),
    [anon_sym_PERCENT_EQ] = ACTIONS(598),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(598),
    [anon_sym_GT_GT_EQ] = ACTIONS(598),
    [anon_sym_LT_LT_EQ] = ACTIONS(598),
    [anon_sym_AMP_EQ] = ACTIONS(598),
    [anon_sym_CARET_EQ] = ACTIONS(598),
    [anon_sym_PIPE_EQ] = ACTIONS(598),
    [anon_sym_LBRACK] = ACTIONS(598),
    [sym_comment] = ACTIONS(3),
    [sym__semicolon] = ACTIONS(598),
    [sym__newline] = ACTIONS(598),
  },
  [164] = {
    [anon_sym_DOT] = ACTIONS(602),
    [anon_sym_from] = ACTIONS(602),
    [anon_sym_LPAREN] = ACTIONS(602),
    [anon_sym_COMMA] = ACTIONS(602),
    [anon_sym_STAR] = ACTIONS(604),
    [anon_sym_GT_GT] = ACTIONS(604),
    [anon_sym_if] = ACTIONS(602),
    [anon_sym_COLON] = ACTIONS(602),
    [anon_sym_in] = ACTIONS(602),
    [anon_sym_EQ] = ACTIONS(604),
    [anon_sym_STAR_STAR] = ACTIONS(604),
    [anon_sym_AT] = ACTIONS(604),
    [anon_sym_not] = ACTIONS(602),
    [anon_sym_and] = ACTIONS(602),
    [anon_sym_or] = ACTIONS(602),
    [anon_sym_PLUS] = ACTIONS(604),
    [anon_sym_DASH] = ACTIONS(604),
    [anon_sym_SLASH] = ACTIONS(604),
    [anon_sym_PERCENT] = ACTIONS(604),
    [anon_sym_SLASH_SLASH] = ACTIONS(604),
    [anon_sym_PIPE] = ACTIONS(604),
    [anon_sym_AMP] = ACTIONS(604),
    [anon_sym_CARET] = ACTIONS(604),
    [anon_sym_LT_LT] = ACTIONS(604),
    [anon_sym_LT] = ACTIONS(604),
    [anon_sym_LT_EQ] = ACTIONS(602),
    [anon_sym_EQ_EQ] = ACTIONS(602),
    [anon_sym_BANG_EQ] = ACTIONS(602),
    [anon_sym_GT_EQ] = ACTIONS(602),
    [anon_sym_GT] = ACTIONS(604),
    [anon_sym_LT_GT] = ACTIONS(602),
    [anon_sym_is] = ACTIONS(602),
    [anon_sym_PLUS_EQ] = ACTIONS(602),
    [anon_sym_DASH_EQ] = ACTIONS(602),
    [anon_sym_STAR_EQ] = ACTIONS(602),
    [anon_sym_SLASH_EQ] = ACTIONS(602),
    [anon_sym_AT_EQ] = ACTIONS(602),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(602),
    [anon_sym_PERCENT_EQ] = ACTIONS(602),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(602),
    [anon_sym_GT_GT_EQ] = ACTIONS(602),
    [anon_sym_LT_LT_EQ] = ACTIONS(602),
    [anon_sym_AMP_EQ] = ACTIONS(602),
    [anon_sym_CARET_EQ] = ACTIONS(602),
    [anon_sym_PIPE_EQ] = ACTIONS(602),
    [anon_sym_LBRACK] = ACTIONS(602),
    [sym_comment] = ACTIONS(3),
    [sym__semicolon] = ACTIONS(602),
    [sym__newline] = ACTIONS(602),
  },
  [165] = {
    [anon_sym_DOT] = ACTIONS(606),
    [anon_sym_from] = ACTIONS(606),
    [anon_sym_LPAREN] = ACTIONS(606),
    [anon_sym_COMMA] = ACTIONS(606),
    [anon_sym_STAR] = ACTIONS(608),
    [anon_sym_GT_GT] = ACTIONS(608),
    [anon_sym_if] = ACTIONS(606),
    [anon_sym_COLON] = ACTIONS(606),
    [anon_sym_in] = ACTIONS(606),
    [anon_sym_EQ] = ACTIONS(608),
    [anon_sym_STAR_STAR] = ACTIONS(608),
    [anon_sym_AT] = ACTIONS(608),
    [anon_sym_not] = ACTIONS(606),
    [anon_sym_and] = ACTIONS(606),
    [anon_sym_or] = ACTIONS(606),
    [anon_sym_PLUS] = ACTIONS(608),
    [anon_sym_DASH] = ACTIONS(608),
    [anon_sym_SLASH] = ACTIONS(608),
    [anon_sym_PERCENT] = ACTIONS(608),
    [anon_sym_SLASH_SLASH] = ACTIONS(608),
    [anon_sym_PIPE] = ACTIONS(608),
    [anon_sym_AMP] = ACTIONS(608),
    [anon_sym_CARET] = ACTIONS(608),
    [anon_sym_LT_LT] = ACTIONS(608),
    [anon_sym_LT] = ACTIONS(608),
    [anon_sym_LT_EQ] = ACTIONS(606),
    [anon_sym_EQ_EQ] = ACTIONS(606),
    [anon_sym_BANG_EQ] = ACTIONS(606),
    [anon_sym_GT_EQ] = ACTIONS(606),
    [anon_sym_GT] = ACTIONS(608),
    [anon_sym_LT_GT] = ACTIONS(606),
    [anon_sym_is] = ACTIONS(606),
    [anon_sym_PLUS_EQ] = ACTIONS(606),
    [anon_sym_DASH_EQ] = ACTIONS(606),
    [anon_sym_STAR_EQ] = ACTIONS(606),
    [anon_sym_SLASH_EQ] = ACTIONS(606),
    [anon_sym_AT_EQ] = ACTIONS(606),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(606),
    [anon_sym_PERCENT_EQ] = ACTIONS(606),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(606),
    [anon_sym_GT_GT_EQ] = ACTIONS(606),
    [anon_sym_LT_LT_EQ] = ACTIONS(606),
    [anon_sym_AMP_EQ] = ACTIONS(606),
    [anon_sym_CARET_EQ] = ACTIONS(606),
    [anon_sym_PIPE_EQ] = ACTIONS(606),
    [anon_sym_LBRACK] = ACTIONS(606),
    [sym_comment] = ACTIONS(3),
    [sym__semicolon] = ACTIONS(606),
    [sym__newline] = ACTIONS(606),
  },
  [166] = {
    [anon_sym_DOT] = ACTIONS(610),
    [anon_sym_from] = ACTIONS(610),
    [anon_sym_LPAREN] = ACTIONS(610),
    [anon_sym_COMMA] = ACTIONS(610),
    [anon_sym_STAR] = ACTIONS(612),
    [anon_sym_GT_GT] = ACTIONS(612),
    [anon_sym_if] = ACTIONS(610),
    [anon_sym_COLON] = ACTIONS(610),
    [anon_sym_in] = ACTIONS(610),
    [anon_sym_EQ] = ACTIONS(612),
    [anon_sym_STAR_STAR] = ACTIONS(612),
    [anon_sym_AT] = ACTIONS(612),
    [anon_sym_not] = ACTIONS(610),
    [anon_sym_and] = ACTIONS(610),
    [anon_sym_or] = ACTIONS(610),
    [anon_sym_PLUS] = ACTIONS(612),
    [anon_sym_DASH] = ACTIONS(612),
    [anon_sym_SLASH] = ACTIONS(612),
    [anon_sym_PERCENT] = ACTIONS(612),
    [anon_sym_SLASH_SLASH] = ACTIONS(612),
    [anon_sym_PIPE] = ACTIONS(612),
    [anon_sym_AMP] = ACTIONS(612),
    [anon_sym_CARET] = ACTIONS(612),
    [anon_sym_LT_LT] = ACTIONS(612),
    [anon_sym_LT] = ACTIONS(612),
    [anon_sym_LT_EQ] = ACTIONS(610),
    [anon_sym_EQ_EQ] = ACTIONS(610),
    [anon_sym_BANG_EQ] = ACTIONS(610),
    [anon_sym_GT_EQ] = ACTIONS(610),
    [anon_sym_GT] = ACTIONS(612),
    [anon_sym_LT_GT] = ACTIONS(610),
    [anon_sym_is] = ACTIONS(610),
    [anon_sym_PLUS_EQ] = ACTIONS(610),
    [anon_sym_DASH_EQ] = ACTIONS(610),
    [anon_sym_STAR_EQ] = ACTIONS(610),
    [anon_sym_SLASH_EQ] = ACTIONS(610),
    [anon_sym_AT_EQ] = ACTIONS(610),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(610),
    [anon_sym_PERCENT_EQ] = ACTIONS(610),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(610),
    [anon_sym_GT_GT_EQ] = ACTIONS(610),
    [anon_sym_LT_LT_EQ] = ACTIONS(610),
    [anon_sym_AMP_EQ] = ACTIONS(610),
    [anon_sym_CARET_EQ] = ACTIONS(610),
    [anon_sym_PIPE_EQ] = ACTIONS(610),
    [anon_sym_LBRACK] = ACTIONS(610),
    [sym_comment] = ACTIONS(3),
    [sym__semicolon] = ACTIONS(610),
    [sym__newline] = ACTIONS(610),
  },
  [167] = {
    [sym_named_expression] = STATE(599),
    [sym_expression_list] = STATE(875),
    [sym__expression] = STATE(599),
    [sym__primary_expression] = STATE(109),
    [sym_not_operator] = STATE(599),
    [sym_boolean_operator] = STATE(599),
    [sym_binary_operator] = STATE(109),
    [sym_unary_operator] = STATE(109),
    [sym_comparison_operator] = STATE(599),
    [sym_lambda] = STATE(599),
    [sym_attribute] = STATE(109),
    [sym_subscript] = STATE(109),
    [sym_call] = STATE(109),
    [sym_list] = STATE(109),
    [sym_list_comprehension] = STATE(109),
    [sym_dictionary] = STATE(109),
    [sym_dictionary_comprehension] = STATE(109),
    [sym_set] = STATE(109),
    [sym_set_comprehension] = STATE(109),
    [sym_parenthesized_expression] = STATE(109),
    [sym_tuple] = STATE(109),
    [sym_generator_expression] = STATE(109),
    [sym_conditional_expression] = STATE(599),
    [sym_concatenated_string] = STATE(109),
    [sym_string] = STATE(117),
    [sym_await] = STATE(599),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_from] = ACTIONS(614),
    [anon_sym_LPAREN] = ACTIONS(13),
    [anon_sym_print] = ACTIONS(237),
    [anon_sym_exec] = ACTIONS(237),
    [anon_sym_not] = ACTIONS(55),
    [anon_sym_PLUS] = ACTIONS(57),
    [anon_sym_DASH] = ACTIONS(57),
    [anon_sym_TILDE] = ACTIONS(57),
    [anon_sym_lambda] = ACTIONS(59),
    [anon_sym_LBRACK] = ACTIONS(63),
    [sym_ellipsis] = ACTIONS(65),
    [anon_sym_LBRACE] = ACTIONS(67),
    [sym_integer] = ACTIONS(69),
    [sym_float] = ACTIONS(65),
    [sym_true] = ACTIONS(69),
    [sym_false] = ACTIONS(69),
    [sym_none] = ACTIONS(69),
    [anon_sym_await] = ACTIONS(71),
    [sym_comment] = ACTIONS(3),
    [sym__semicolon] = ACTIONS(616),
    [sym__newline] = ACTIONS(616),
    [sym__string_start] = ACTIONS(73),
  },
  [168] = {
    [anon_sym_DOT] = ACTIONS(618),
    [anon_sym_from] = ACTIONS(618),
    [anon_sym_LPAREN] = ACTIONS(618),
    [anon_sym_COMMA] = ACTIONS(618),
    [anon_sym_STAR] = ACTIONS(620),
    [anon_sym_GT_GT] = ACTIONS(620),
    [anon_sym_if] = ACTIONS(618),
    [anon_sym_COLON] = ACTIONS(618),
    [anon_sym_in] = ACTIONS(618),
    [anon_sym_EQ] = ACTIONS(620),
    [anon_sym_STAR_STAR] = ACTIONS(620),
    [anon_sym_AT] = ACTIONS(620),
    [anon_sym_not] = ACTIONS(618),
    [anon_sym_and] = ACTIONS(618),
    [anon_sym_or] = ACTIONS(618),
    [anon_sym_PLUS] = ACTIONS(620),
    [anon_sym_DASH] = ACTIONS(620),
    [anon_sym_SLASH] = ACTIONS(620),
    [anon_sym_PERCENT] = ACTIONS(620),
    [anon_sym_SLASH_SLASH] = ACTIONS(620),
    [anon_sym_PIPE] = ACTIONS(620),
    [anon_sym_AMP] = ACTIONS(620),
    [anon_sym_CARET] = ACTIONS(620),
    [anon_sym_LT_LT] = ACTIONS(620),
    [anon_sym_LT] = ACTIONS(620),
    [anon_sym_LT_EQ] = ACTIONS(618),
    [anon_sym_EQ_EQ] = ACTIONS(618),
    [anon_sym_BANG_EQ] = ACTIONS(618),
    [anon_sym_GT_EQ] = ACTIONS(618),
    [anon_sym_GT] = ACTIONS(620),
    [anon_sym_LT_GT] = ACTIONS(618),
    [anon_sym_is] = ACTIONS(618),
    [anon_sym_PLUS_EQ] = ACTIONS(618),
    [anon_sym_DASH_EQ] = ACTIONS(618),
    [anon_sym_STAR_EQ] = ACTIONS(618),
    [anon_sym_SLASH_EQ] = ACTIONS(618),
    [anon_sym_AT_EQ] = ACTIONS(618),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(618),
    [anon_sym_PERCENT_EQ] = ACTIONS(618),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(618),
    [anon_sym_GT_GT_EQ] = ACTIONS(618),
    [anon_sym_LT_LT_EQ] = ACTIONS(618),
    [anon_sym_AMP_EQ] = ACTIONS(618),
    [anon_sym_CARET_EQ] = ACTIONS(618),
    [anon_sym_PIPE_EQ] = ACTIONS(618),
    [anon_sym_LBRACK] = ACTIONS(618),
    [sym_comment] = ACTIONS(3),
    [sym__semicolon] = ACTIONS(618),
    [sym__newline] = ACTIONS(618),
  },
  [169] = {
    [sym_named_expression] = STATE(649),
    [sym__expression] = STATE(649),
    [sym__primary_expression] = STATE(383),
    [sym_not_operator] = STATE(649),
    [sym_boolean_operator] = STATE(649),
    [sym_binary_operator] = STATE(383),
    [sym_unary_operator] = STATE(383),
    [sym_comparison_operator] = STATE(649),
    [sym_lambda] = STATE(649),
    [sym_yield] = STATE(857),
    [sym_attribute] = STATE(383),
    [sym_subscript] = STATE(383),
    [sym_call] = STATE(383),
    [sym_list] = STATE(383),
    [sym_list_comprehension] = STATE(383),
    [sym_dictionary] = STATE(383),
    [sym_dictionary_comprehension] = STATE(383),
    [sym_set] = STATE(383),
    [sym_set_comprehension] = STATE(383),
    [sym_parenthesized_expression] = STATE(383),
    [sym_tuple] = STATE(383),
    [sym_generator_expression] = STATE(383),
    [sym_conditional_expression] = STATE(649),
    [sym_concatenated_string] = STATE(383),
    [sym_string] = STATE(381),
    [sym_await] = STATE(649),
    [sym_identifier] = ACTIONS(387),
    [anon_sym_LPAREN] = ACTIONS(389),
    [anon_sym_RPAREN] = ACTIONS(622),
    [anon_sym_COMMA] = ACTIONS(624),
    [anon_sym_print] = ACTIONS(393),
    [anon_sym_exec] = ACTIONS(393),
    [anon_sym_not] = ACTIONS(361),
    [anon_sym_PLUS] = ACTIONS(363),
    [anon_sym_DASH] = ACTIONS(363),
    [anon_sym_TILDE] = ACTIONS(363),
    [anon_sym_lambda] = ACTIONS(365),
    [anon_sym_yield] = ACTIONS(465),
    [anon_sym_LBRACK] = ACTIONS(367),
    [sym_ellipsis] = ACTIONS(369),
    [anon_sym_LBRACE] = ACTIONS(371),
    [sym_integer] = ACTIONS(373),
    [sym_float] = ACTIONS(369),
    [sym_true] = ACTIONS(373),
    [sym_false] = ACTIONS(373),
    [sym_none] = ACTIONS(373),
    [anon_sym_await] = ACTIONS(375),
    [sym_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(377),
  },
  [170] = {
    [anon_sym_DOT] = ACTIONS(626),
    [anon_sym_from] = ACTIONS(626),
    [anon_sym_LPAREN] = ACTIONS(626),
    [anon_sym_COMMA] = ACTIONS(626),
    [anon_sym_STAR] = ACTIONS(628),
    [anon_sym_GT_GT] = ACTIONS(628),
    [anon_sym_if] = ACTIONS(626),
    [anon_sym_COLON] = ACTIONS(626),
    [anon_sym_in] = ACTIONS(626),
    [anon_sym_EQ] = ACTIONS(628),
    [anon_sym_STAR_STAR] = ACTIONS(628),
    [anon_sym_AT] = ACTIONS(628),
    [anon_sym_not] = ACTIONS(626),
    [anon_sym_and] = ACTIONS(626),
    [anon_sym_or] = ACTIONS(626),
    [anon_sym_PLUS] = ACTIONS(628),
    [anon_sym_DASH] = ACTIONS(628),
    [anon_sym_SLASH] = ACTIONS(628),
    [anon_sym_PERCENT] = ACTIONS(628),
    [anon_sym_SLASH_SLASH] = ACTIONS(628),
    [anon_sym_PIPE] = ACTIONS(628),
    [anon_sym_AMP] = ACTIONS(628),
    [anon_sym_CARET] = ACTIONS(628),
    [anon_sym_LT_LT] = ACTIONS(628),
    [anon_sym_LT] = ACTIONS(628),
    [anon_sym_LT_EQ] = ACTIONS(626),
    [anon_sym_EQ_EQ] = ACTIONS(626),
    [anon_sym_BANG_EQ] = ACTIONS(626),
    [anon_sym_GT_EQ] = ACTIONS(626),
    [anon_sym_GT] = ACTIONS(628),
    [anon_sym_LT_GT] = ACTIONS(626),
    [anon_sym_is] = ACTIONS(626),
    [anon_sym_PLUS_EQ] = ACTIONS(626),
    [anon_sym_DASH_EQ] = ACTIONS(626),
    [anon_sym_STAR_EQ] = ACTIONS(626),
    [anon_sym_SLASH_EQ] = ACTIONS(626),
    [anon_sym_AT_EQ] = ACTIONS(626),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(626),
    [anon_sym_PERCENT_EQ] = ACTIONS(626),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(626),
    [anon_sym_GT_GT_EQ] = ACTIONS(626),
    [anon_sym_LT_LT_EQ] = ACTIONS(626),
    [anon_sym_AMP_EQ] = ACTIONS(626),
    [anon_sym_CARET_EQ] = ACTIONS(626),
    [anon_sym_PIPE_EQ] = ACTIONS(626),
    [anon_sym_LBRACK] = ACTIONS(626),
    [sym_comment] = ACTIONS(3),
    [sym__semicolon] = ACTIONS(626),
    [sym__newline] = ACTIONS(626),
  },
  [171] = {
    [anon_sym_DOT] = ACTIONS(630),
    [anon_sym_from] = ACTIONS(630),
    [anon_sym_LPAREN] = ACTIONS(630),
    [anon_sym_COMMA] = ACTIONS(630),
    [anon_sym_STAR] = ACTIONS(632),
    [anon_sym_GT_GT] = ACTIONS(632),
    [anon_sym_if] = ACTIONS(630),
    [anon_sym_COLON] = ACTIONS(630),
    [anon_sym_in] = ACTIONS(630),
    [anon_sym_EQ] = ACTIONS(632),
    [anon_sym_STAR_STAR] = ACTIONS(632),
    [anon_sym_AT] = ACTIONS(632),
    [anon_sym_not] = ACTIONS(630),
    [anon_sym_and] = ACTIONS(630),
    [anon_sym_or] = ACTIONS(630),
    [anon_sym_PLUS] = ACTIONS(632),
    [anon_sym_DASH] = ACTIONS(632),
    [anon_sym_SLASH] = ACTIONS(632),
    [anon_sym_PERCENT] = ACTIONS(632),
    [anon_sym_SLASH_SLASH] = ACTIONS(632),
    [anon_sym_PIPE] = ACTIONS(632),
    [anon_sym_AMP] = ACTIONS(632),
    [anon_sym_CARET] = ACTIONS(632),
    [anon_sym_LT_LT] = ACTIONS(632),
    [anon_sym_LT] = ACTIONS(632),
    [anon_sym_LT_EQ] = ACTIONS(630),
    [anon_sym_EQ_EQ] = ACTIONS(630),
    [anon_sym_BANG_EQ] = ACTIONS(630),
    [anon_sym_GT_EQ] = ACTIONS(630),
    [anon_sym_GT] = ACTIONS(632),
    [anon_sym_LT_GT] = ACTIONS(630),
    [anon_sym_is] = ACTIONS(630),
    [anon_sym_PLUS_EQ] = ACTIONS(630),
    [anon_sym_DASH_EQ] = ACTIONS(630),
    [anon_sym_STAR_EQ] = ACTIONS(630),
    [anon_sym_SLASH_EQ] = ACTIONS(630),
    [anon_sym_AT_EQ] = ACTIONS(630),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(630),
    [anon_sym_PERCENT_EQ] = ACTIONS(630),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(630),
    [anon_sym_GT_GT_EQ] = ACTIONS(630),
    [anon_sym_LT_LT_EQ] = ACTIONS(630),
    [anon_sym_AMP_EQ] = ACTIONS(630),
    [anon_sym_CARET_EQ] = ACTIONS(630),
    [anon_sym_PIPE_EQ] = ACTIONS(630),
    [anon_sym_LBRACK] = ACTIONS(630),
    [sym_comment] = ACTIONS(3),
    [sym__semicolon] = ACTIONS(630),
    [sym__newline] = ACTIONS(630),
  },
  [172] = {
    [anon_sym_DOT] = ACTIONS(634),
    [anon_sym_from] = ACTIONS(634),
    [anon_sym_LPAREN] = ACTIONS(634),
    [anon_sym_COMMA] = ACTIONS(634),
    [anon_sym_STAR] = ACTIONS(636),
    [anon_sym_GT_GT] = ACTIONS(636),
    [anon_sym_if] = ACTIONS(634),
    [anon_sym_COLON] = ACTIONS(634),
    [anon_sym_in] = ACTIONS(634),
    [anon_sym_EQ] = ACTIONS(636),
    [anon_sym_STAR_STAR] = ACTIONS(636),
    [anon_sym_AT] = ACTIONS(636),
    [anon_sym_not] = ACTIONS(634),
    [anon_sym_and] = ACTIONS(634),
    [anon_sym_or] = ACTIONS(634),
    [anon_sym_PLUS] = ACTIONS(636),
    [anon_sym_DASH] = ACTIONS(636),
    [anon_sym_SLASH] = ACTIONS(636),
    [anon_sym_PERCENT] = ACTIONS(636),
    [anon_sym_SLASH_SLASH] = ACTIONS(636),
    [anon_sym_PIPE] = ACTIONS(636),
    [anon_sym_AMP] = ACTIONS(636),
    [anon_sym_CARET] = ACTIONS(636),
    [anon_sym_LT_LT] = ACTIONS(636),
    [anon_sym_LT] = ACTIONS(636),
    [anon_sym_LT_EQ] = ACTIONS(634),
    [anon_sym_EQ_EQ] = ACTIONS(634),
    [anon_sym_BANG_EQ] = ACTIONS(634),
    [anon_sym_GT_EQ] = ACTIONS(634),
    [anon_sym_GT] = ACTIONS(636),
    [anon_sym_LT_GT] = ACTIONS(634),
    [anon_sym_is] = ACTIONS(634),
    [anon_sym_PLUS_EQ] = ACTIONS(634),
    [anon_sym_DASH_EQ] = ACTIONS(634),
    [anon_sym_STAR_EQ] = ACTIONS(634),
    [anon_sym_SLASH_EQ] = ACTIONS(634),
    [anon_sym_AT_EQ] = ACTIONS(634),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(634),
    [anon_sym_PERCENT_EQ] = ACTIONS(634),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(634),
    [anon_sym_GT_GT_EQ] = ACTIONS(634),
    [anon_sym_LT_LT_EQ] = ACTIONS(634),
    [anon_sym_AMP_EQ] = ACTIONS(634),
    [anon_sym_CARET_EQ] = ACTIONS(634),
    [anon_sym_PIPE_EQ] = ACTIONS(634),
    [anon_sym_LBRACK] = ACTIONS(634),
    [sym_comment] = ACTIONS(3),
    [sym__semicolon] = ACTIONS(634),
    [sym__newline] = ACTIONS(634),
  },
  [173] = {
    [anon_sym_DOT] = ACTIONS(638),
    [anon_sym_from] = ACTIONS(638),
    [anon_sym_LPAREN] = ACTIONS(638),
    [anon_sym_COMMA] = ACTIONS(638),
    [anon_sym_STAR] = ACTIONS(640),
    [anon_sym_GT_GT] = ACTIONS(640),
    [anon_sym_if] = ACTIONS(638),
    [anon_sym_COLON] = ACTIONS(638),
    [anon_sym_in] = ACTIONS(638),
    [anon_sym_EQ] = ACTIONS(640),
    [anon_sym_STAR_STAR] = ACTIONS(640),
    [anon_sym_AT] = ACTIONS(640),
    [anon_sym_not] = ACTIONS(638),
    [anon_sym_and] = ACTIONS(638),
    [anon_sym_or] = ACTIONS(638),
    [anon_sym_PLUS] = ACTIONS(640),
    [anon_sym_DASH] = ACTIONS(640),
    [anon_sym_SLASH] = ACTIONS(640),
    [anon_sym_PERCENT] = ACTIONS(640),
    [anon_sym_SLASH_SLASH] = ACTIONS(640),
    [anon_sym_PIPE] = ACTIONS(640),
    [anon_sym_AMP] = ACTIONS(640),
    [anon_sym_CARET] = ACTIONS(640),
    [anon_sym_LT_LT] = ACTIONS(640),
    [anon_sym_LT] = ACTIONS(640),
    [anon_sym_LT_EQ] = ACTIONS(638),
    [anon_sym_EQ_EQ] = ACTIONS(638),
    [anon_sym_BANG_EQ] = ACTIONS(638),
    [anon_sym_GT_EQ] = ACTIONS(638),
    [anon_sym_GT] = ACTIONS(640),
    [anon_sym_LT_GT] = ACTIONS(638),
    [anon_sym_is] = ACTIONS(638),
    [anon_sym_PLUS_EQ] = ACTIONS(638),
    [anon_sym_DASH_EQ] = ACTIONS(638),
    [anon_sym_STAR_EQ] = ACTIONS(638),
    [anon_sym_SLASH_EQ] = ACTIONS(638),
    [anon_sym_AT_EQ] = ACTIONS(638),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(638),
    [anon_sym_PERCENT_EQ] = ACTIONS(638),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(638),
    [anon_sym_GT_GT_EQ] = ACTIONS(638),
    [anon_sym_LT_LT_EQ] = ACTIONS(638),
    [anon_sym_AMP_EQ] = ACTIONS(638),
    [anon_sym_CARET_EQ] = ACTIONS(638),
    [anon_sym_PIPE_EQ] = ACTIONS(638),
    [anon_sym_LBRACK] = ACTIONS(638),
    [sym_comment] = ACTIONS(3),
    [sym__semicolon] = ACTIONS(638),
    [sym__newline] = ACTIONS(638),
  },
  [174] = {
    [anon_sym_DOT] = ACTIONS(235),
    [anon_sym_from] = ACTIONS(235),
    [anon_sym_LPAREN] = ACTIONS(235),
    [anon_sym_COMMA] = ACTIONS(235),
    [anon_sym_STAR] = ACTIONS(233),
    [anon_sym_GT_GT] = ACTIONS(233),
    [anon_sym_if] = ACTIONS(235),
    [anon_sym_COLON] = ACTIONS(235),
    [anon_sym_in] = ACTIONS(235),
    [anon_sym_EQ] = ACTIONS(233),
    [anon_sym_STAR_STAR] = ACTIONS(233),
    [anon_sym_AT] = ACTIONS(233),
    [anon_sym_not] = ACTIONS(235),
    [anon_sym_and] = ACTIONS(235),
    [anon_sym_or] = ACTIONS(235),
    [anon_sym_PLUS] = ACTIONS(233),
    [anon_sym_DASH] = ACTIONS(233),
    [anon_sym_SLASH] = ACTIONS(233),
    [anon_sym_PERCENT] = ACTIONS(233),
    [anon_sym_SLASH_SLASH] = ACTIONS(233),
    [anon_sym_PIPE] = ACTIONS(233),
    [anon_sym_AMP] = ACTIONS(233),
    [anon_sym_CARET] = ACTIONS(233),
    [anon_sym_LT_LT] = ACTIONS(233),
    [anon_sym_LT] = ACTIONS(233),
    [anon_sym_LT_EQ] = ACTIONS(235),
    [anon_sym_EQ_EQ] = ACTIONS(235),
    [anon_sym_BANG_EQ] = ACTIONS(235),
    [anon_sym_GT_EQ] = ACTIONS(235),
    [anon_sym_GT] = ACTIONS(233),
    [anon_sym_LT_GT] = ACTIONS(235),
    [anon_sym_is] = ACTIONS(235),
    [anon_sym_PLUS_EQ] = ACTIONS(235),
    [anon_sym_DASH_EQ] = ACTIONS(235),
    [anon_sym_STAR_EQ] = ACTIONS(235),
    [anon_sym_SLASH_EQ] = ACTIONS(235),
    [anon_sym_AT_EQ] = ACTIONS(235),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(235),
    [anon_sym_PERCENT_EQ] = ACTIONS(235),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(235),
    [anon_sym_GT_GT_EQ] = ACTIONS(235),
    [anon_sym_LT_LT_EQ] = ACTIONS(235),
    [anon_sym_AMP_EQ] = ACTIONS(235),
    [anon_sym_CARET_EQ] = ACTIONS(235),
    [anon_sym_PIPE_EQ] = ACTIONS(235),
    [anon_sym_LBRACK] = ACTIONS(235),
    [sym_comment] = ACTIONS(3),
    [sym__semicolon] = ACTIONS(235),
    [sym__newline] = ACTIONS(235),
  },
  [175] = {
    [anon_sym_DOT] = ACTIONS(642),
    [anon_sym_from] = ACTIONS(642),
    [anon_sym_LPAREN] = ACTIONS(642),
    [anon_sym_COMMA] = ACTIONS(642),
    [anon_sym_STAR] = ACTIONS(644),
    [anon_sym_GT_GT] = ACTIONS(644),
    [anon_sym_if] = ACTIONS(642),
    [anon_sym_COLON] = ACTIONS(642),
    [anon_sym_in] = ACTIONS(642),
    [anon_sym_EQ] = ACTIONS(644),
    [anon_sym_STAR_STAR] = ACTIONS(644),
    [anon_sym_AT] = ACTIONS(644),
    [anon_sym_not] = ACTIONS(642),
    [anon_sym_and] = ACTIONS(642),
    [anon_sym_or] = ACTIONS(642),
    [anon_sym_PLUS] = ACTIONS(644),
    [anon_sym_DASH] = ACTIONS(644),
    [anon_sym_SLASH] = ACTIONS(644),
    [anon_sym_PERCENT] = ACTIONS(644),
    [anon_sym_SLASH_SLASH] = ACTIONS(644),
    [anon_sym_PIPE] = ACTIONS(644),
    [anon_sym_AMP] = ACTIONS(644),
    [anon_sym_CARET] = ACTIONS(644),
    [anon_sym_LT_LT] = ACTIONS(644),
    [anon_sym_LT] = ACTIONS(644),
    [anon_sym_LT_EQ] = ACTIONS(642),
    [anon_sym_EQ_EQ] = ACTIONS(642),
    [anon_sym_BANG_EQ] = ACTIONS(642),
    [anon_sym_GT_EQ] = ACTIONS(642),
    [anon_sym_GT] = ACTIONS(644),
    [anon_sym_LT_GT] = ACTIONS(642),
    [anon_sym_is] = ACTIONS(642),
    [anon_sym_PLUS_EQ] = ACTIONS(642),
    [anon_sym_DASH_EQ] = ACTIONS(642),
    [anon_sym_STAR_EQ] = ACTIONS(642),
    [anon_sym_SLASH_EQ] = ACTIONS(642),
    [anon_sym_AT_EQ] = ACTIONS(642),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(642),
    [anon_sym_PERCENT_EQ] = ACTIONS(642),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(642),
    [anon_sym_GT_GT_EQ] = ACTIONS(642),
    [anon_sym_LT_LT_EQ] = ACTIONS(642),
    [anon_sym_AMP_EQ] = ACTIONS(642),
    [anon_sym_CARET_EQ] = ACTIONS(642),
    [anon_sym_PIPE_EQ] = ACTIONS(642),
    [anon_sym_LBRACK] = ACTIONS(642),
    [sym_comment] = ACTIONS(3),
    [sym__semicolon] = ACTIONS(642),
    [sym__newline] = ACTIONS(642),
  },
  [176] = {
    [anon_sym_DOT] = ACTIONS(646),
    [anon_sym_from] = ACTIONS(646),
    [anon_sym_LPAREN] = ACTIONS(646),
    [anon_sym_COMMA] = ACTIONS(646),
    [anon_sym_STAR] = ACTIONS(648),
    [anon_sym_GT_GT] = ACTIONS(648),
    [anon_sym_if] = ACTIONS(646),
    [anon_sym_COLON] = ACTIONS(646),
    [anon_sym_in] = ACTIONS(646),
    [anon_sym_EQ] = ACTIONS(648),
    [anon_sym_STAR_STAR] = ACTIONS(648),
    [anon_sym_AT] = ACTIONS(648),
    [anon_sym_not] = ACTIONS(646),
    [anon_sym_and] = ACTIONS(646),
    [anon_sym_or] = ACTIONS(646),
    [anon_sym_PLUS] = ACTIONS(648),
    [anon_sym_DASH] = ACTIONS(648),
    [anon_sym_SLASH] = ACTIONS(648),
    [anon_sym_PERCENT] = ACTIONS(648),
    [anon_sym_SLASH_SLASH] = ACTIONS(648),
    [anon_sym_PIPE] = ACTIONS(648),
    [anon_sym_AMP] = ACTIONS(648),
    [anon_sym_CARET] = ACTIONS(648),
    [anon_sym_LT_LT] = ACTIONS(648),
    [anon_sym_LT] = ACTIONS(648),
    [anon_sym_LT_EQ] = ACTIONS(646),
    [anon_sym_EQ_EQ] = ACTIONS(646),
    [anon_sym_BANG_EQ] = ACTIONS(646),
    [anon_sym_GT_EQ] = ACTIONS(646),
    [anon_sym_GT] = ACTIONS(648),
    [anon_sym_LT_GT] = ACTIONS(646),
    [anon_sym_is] = ACTIONS(646),
    [anon_sym_PLUS_EQ] = ACTIONS(646),
    [anon_sym_DASH_EQ] = ACTIONS(646),
    [anon_sym_STAR_EQ] = ACTIONS(646),
    [anon_sym_SLASH_EQ] = ACTIONS(646),
    [anon_sym_AT_EQ] = ACTIONS(646),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(646),
    [anon_sym_PERCENT_EQ] = ACTIONS(646),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(646),
    [anon_sym_GT_GT_EQ] = ACTIONS(646),
    [anon_sym_LT_LT_EQ] = ACTIONS(646),
    [anon_sym_AMP_EQ] = ACTIONS(646),
    [anon_sym_CARET_EQ] = ACTIONS(646),
    [anon_sym_PIPE_EQ] = ACTIONS(646),
    [anon_sym_LBRACK] = ACTIONS(646),
    [sym_comment] = ACTIONS(3),
    [sym__semicolon] = ACTIONS(646),
    [sym__newline] = ACTIONS(646),
  },
  [177] = {
    [anon_sym_DOT] = ACTIONS(650),
    [anon_sym_from] = ACTIONS(650),
    [anon_sym_LPAREN] = ACTIONS(650),
    [anon_sym_COMMA] = ACTIONS(650),
    [anon_sym_STAR] = ACTIONS(652),
    [anon_sym_GT_GT] = ACTIONS(652),
    [anon_sym_if] = ACTIONS(650),
    [anon_sym_COLON] = ACTIONS(650),
    [anon_sym_in] = ACTIONS(650),
    [anon_sym_EQ] = ACTIONS(652),
    [anon_sym_STAR_STAR] = ACTIONS(652),
    [anon_sym_AT] = ACTIONS(652),
    [anon_sym_not] = ACTIONS(650),
    [anon_sym_and] = ACTIONS(650),
    [anon_sym_or] = ACTIONS(650),
    [anon_sym_PLUS] = ACTIONS(652),
    [anon_sym_DASH] = ACTIONS(652),
    [anon_sym_SLASH] = ACTIONS(652),
    [anon_sym_PERCENT] = ACTIONS(652),
    [anon_sym_SLASH_SLASH] = ACTIONS(652),
    [anon_sym_PIPE] = ACTIONS(652),
    [anon_sym_AMP] = ACTIONS(652),
    [anon_sym_CARET] = ACTIONS(652),
    [anon_sym_LT_LT] = ACTIONS(652),
    [anon_sym_LT] = ACTIONS(652),
    [anon_sym_LT_EQ] = ACTIONS(650),
    [anon_sym_EQ_EQ] = ACTIONS(650),
    [anon_sym_BANG_EQ] = ACTIONS(650),
    [anon_sym_GT_EQ] = ACTIONS(650),
    [anon_sym_GT] = ACTIONS(652),
    [anon_sym_LT_GT] = ACTIONS(650),
    [anon_sym_is] = ACTIONS(650),
    [anon_sym_PLUS_EQ] = ACTIONS(650),
    [anon_sym_DASH_EQ] = ACTIONS(650),
    [anon_sym_STAR_EQ] = ACTIONS(650),
    [anon_sym_SLASH_EQ] = ACTIONS(650),
    [anon_sym_AT_EQ] = ACTIONS(650),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(650),
    [anon_sym_PERCENT_EQ] = ACTIONS(650),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(650),
    [anon_sym_GT_GT_EQ] = ACTIONS(650),
    [anon_sym_LT_LT_EQ] = ACTIONS(650),
    [anon_sym_AMP_EQ] = ACTIONS(650),
    [anon_sym_CARET_EQ] = ACTIONS(650),
    [anon_sym_PIPE_EQ] = ACTIONS(650),
    [anon_sym_LBRACK] = ACTIONS(650),
    [sym_comment] = ACTIONS(3),
    [sym__semicolon] = ACTIONS(650),
    [sym__newline] = ACTIONS(650),
  },
  [178] = {
    [sym_named_expression] = STATE(718),
    [sym__expression] = STATE(718),
    [sym__primary_expression] = STATE(383),
    [sym_not_operator] = STATE(718),
    [sym_boolean_operator] = STATE(718),
    [sym_binary_operator] = STATE(383),
    [sym_unary_operator] = STATE(383),
    [sym_comparison_operator] = STATE(718),
    [sym_lambda] = STATE(718),
    [sym_yield] = STATE(865),
    [sym_attribute] = STATE(383),
    [sym_subscript] = STATE(383),
    [sym_call] = STATE(383),
    [sym_list] = STATE(383),
    [sym_list_comprehension] = STATE(383),
    [sym_dictionary] = STATE(383),
    [sym_dictionary_comprehension] = STATE(383),
    [sym_set] = STATE(383),
    [sym_set_comprehension] = STATE(383),
    [sym_parenthesized_expression] = STATE(383),
    [sym_tuple] = STATE(383),
    [sym_generator_expression] = STATE(383),
    [sym_conditional_expression] = STATE(718),
    [sym_concatenated_string] = STATE(383),
    [sym_string] = STATE(381),
    [sym_await] = STATE(718),
    [sym_identifier] = ACTIONS(387),
    [anon_sym_LPAREN] = ACTIONS(389),
    [anon_sym_RPAREN] = ACTIONS(459),
    [anon_sym_COMMA] = ACTIONS(461),
    [anon_sym_print] = ACTIONS(393),
    [anon_sym_exec] = ACTIONS(393),
    [anon_sym_not] = ACTIONS(361),
    [anon_sym_PLUS] = ACTIONS(363),
    [anon_sym_DASH] = ACTIONS(363),
    [anon_sym_TILDE] = ACTIONS(363),
    [anon_sym_lambda] = ACTIONS(365),
    [anon_sym_yield] = ACTIONS(465),
    [anon_sym_LBRACK] = ACTIONS(367),
    [sym_ellipsis] = ACTIONS(369),
    [anon_sym_LBRACE] = ACTIONS(371),
    [sym_integer] = ACTIONS(373),
    [sym_float] = ACTIONS(369),
    [sym_true] = ACTIONS(373),
    [sym_false] = ACTIONS(373),
    [sym_none] = ACTIONS(373),
    [anon_sym_await] = ACTIONS(375),
    [sym_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(377),
  },
  [179] = {
    [sym_else_clause] = STATE(376),
    [sym_except_clause] = STATE(232),
    [sym_finally_clause] = STATE(464),
    [aux_sym_try_statement_repeat1] = STATE(232),
    [ts_builtin_sym_end] = ACTIONS(654),
    [sym_identifier] = ACTIONS(656),
    [anon_sym_import] = ACTIONS(656),
    [anon_sym_from] = ACTIONS(656),
    [anon_sym_LPAREN] = ACTIONS(654),
    [anon_sym_print] = ACTIONS(656),
    [anon_sym_assert] = ACTIONS(656),
    [anon_sym_return] = ACTIONS(656),
    [anon_sym_del] = ACTIONS(656),
    [anon_sym_raise] = ACTIONS(656),
    [anon_sym_pass] = ACTIONS(656),
    [anon_sym_break] = ACTIONS(656),
    [anon_sym_continue] = ACTIONS(656),
    [anon_sym_if] = ACTIONS(656),
    [anon_sym_else] = ACTIONS(548),
    [anon_sym_async] = ACTIONS(656),
    [anon_sym_for] = ACTIONS(656),
    [anon_sym_while] = ACTIONS(656),
    [anon_sym_try] = ACTIONS(656),
    [anon_sym_except] = ACTIONS(550),
    [anon_sym_finally] = ACTIONS(552),
    [anon_sym_with] = ACTIONS(656),
    [anon_sym_def] = ACTIONS(656),
    [anon_sym_global] = ACTIONS(656),
    [anon_sym_nonlocal] = ACTIONS(656),
    [anon_sym_exec] = ACTIONS(656),
    [anon_sym_class] = ACTIONS(656),
    [anon_sym_AT] = ACTIONS(654),
    [anon_sym_not] = ACTIONS(656),
    [anon_sym_PLUS] = ACTIONS(654),
    [anon_sym_DASH] = ACTIONS(654),
    [anon_sym_TILDE] = ACTIONS(654),
    [anon_sym_lambda] = ACTIONS(656),
    [anon_sym_yield] = ACTIONS(656),
    [anon_sym_LBRACK] = ACTIONS(654),
    [sym_ellipsis] = ACTIONS(654),
    [anon_sym_LBRACE] = ACTIONS(654),
    [sym_integer] = ACTIONS(656),
    [sym_float] = ACTIONS(654),
    [sym_true] = ACTIONS(656),
    [sym_false] = ACTIONS(656),
    [sym_none] = ACTIONS(656),
    [anon_sym_await] = ACTIONS(656),
    [sym_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(654),
  },
  [180] = {
    [anon_sym_DOT] = ACTIONS(658),
    [anon_sym_from] = ACTIONS(658),
    [anon_sym_LPAREN] = ACTIONS(658),
    [anon_sym_COMMA] = ACTIONS(658),
    [anon_sym_STAR] = ACTIONS(660),
    [anon_sym_GT_GT] = ACTIONS(660),
    [anon_sym_if] = ACTIONS(658),
    [anon_sym_COLON] = ACTIONS(658),
    [anon_sym_in] = ACTIONS(658),
    [anon_sym_EQ] = ACTIONS(660),
    [anon_sym_STAR_STAR] = ACTIONS(660),
    [anon_sym_AT] = ACTIONS(660),
    [anon_sym_not] = ACTIONS(658),
    [anon_sym_and] = ACTIONS(658),
    [anon_sym_or] = ACTIONS(658),
    [anon_sym_PLUS] = ACTIONS(660),
    [anon_sym_DASH] = ACTIONS(660),
    [anon_sym_SLASH] = ACTIONS(660),
    [anon_sym_PERCENT] = ACTIONS(660),
    [anon_sym_SLASH_SLASH] = ACTIONS(660),
    [anon_sym_PIPE] = ACTIONS(660),
    [anon_sym_AMP] = ACTIONS(660),
    [anon_sym_CARET] = ACTIONS(660),
    [anon_sym_LT_LT] = ACTIONS(660),
    [anon_sym_LT] = ACTIONS(660),
    [anon_sym_LT_EQ] = ACTIONS(658),
    [anon_sym_EQ_EQ] = ACTIONS(658),
    [anon_sym_BANG_EQ] = ACTIONS(658),
    [anon_sym_GT_EQ] = ACTIONS(658),
    [anon_sym_GT] = ACTIONS(660),
    [anon_sym_LT_GT] = ACTIONS(658),
    [anon_sym_is] = ACTIONS(658),
    [anon_sym_PLUS_EQ] = ACTIONS(658),
    [anon_sym_DASH_EQ] = ACTIONS(658),
    [anon_sym_STAR_EQ] = ACTIONS(658),
    [anon_sym_SLASH_EQ] = ACTIONS(658),
    [anon_sym_AT_EQ] = ACTIONS(658),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(658),
    [anon_sym_PERCENT_EQ] = ACTIONS(658),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(658),
    [anon_sym_GT_GT_EQ] = ACTIONS(658),
    [anon_sym_LT_LT_EQ] = ACTIONS(658),
    [anon_sym_AMP_EQ] = ACTIONS(658),
    [anon_sym_CARET_EQ] = ACTIONS(658),
    [anon_sym_PIPE_EQ] = ACTIONS(658),
    [anon_sym_LBRACK] = ACTIONS(658),
    [sym_comment] = ACTIONS(3),
    [sym__semicolon] = ACTIONS(658),
    [sym__newline] = ACTIONS(658),
  },
  [181] = {
    [sym_named_expression] = STATE(652),
    [sym__expression] = STATE(652),
    [sym__primary_expression] = STATE(383),
    [sym_not_operator] = STATE(652),
    [sym_boolean_operator] = STATE(652),
    [sym_binary_operator] = STATE(383),
    [sym_unary_operator] = STATE(383),
    [sym_comparison_operator] = STATE(652),
    [sym_lambda] = STATE(652),
    [sym_yield] = STATE(825),
    [sym_attribute] = STATE(383),
    [sym_subscript] = STATE(383),
    [sym_call] = STATE(383),
    [sym_list] = STATE(383),
    [sym_list_comprehension] = STATE(383),
    [sym_dictionary] = STATE(383),
    [sym_dictionary_comprehension] = STATE(383),
    [sym_set] = STATE(383),
    [sym_set_comprehension] = STATE(383),
    [sym_parenthesized_expression] = STATE(383),
    [sym_tuple] = STATE(383),
    [sym_generator_expression] = STATE(383),
    [sym_conditional_expression] = STATE(652),
    [sym_concatenated_string] = STATE(383),
    [sym_string] = STATE(381),
    [sym_await] = STATE(652),
    [sym_identifier] = ACTIONS(387),
    [anon_sym_LPAREN] = ACTIONS(389),
    [anon_sym_RPAREN] = ACTIONS(662),
    [anon_sym_COMMA] = ACTIONS(664),
    [anon_sym_print] = ACTIONS(393),
    [anon_sym_exec] = ACTIONS(393),
    [anon_sym_not] = ACTIONS(361),
    [anon_sym_PLUS] = ACTIONS(363),
    [anon_sym_DASH] = ACTIONS(363),
    [anon_sym_TILDE] = ACTIONS(363),
    [anon_sym_lambda] = ACTIONS(365),
    [anon_sym_yield] = ACTIONS(465),
    [anon_sym_LBRACK] = ACTIONS(367),
    [sym_ellipsis] = ACTIONS(369),
    [anon_sym_LBRACE] = ACTIONS(371),
    [sym_integer] = ACTIONS(373),
    [sym_float] = ACTIONS(369),
    [sym_true] = ACTIONS(373),
    [sym_false] = ACTIONS(373),
    [sym_none] = ACTIONS(373),
    [anon_sym_await] = ACTIONS(375),
    [sym_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(377),
  },
  [182] = {
    [anon_sym_DOT] = ACTIONS(666),
    [anon_sym_from] = ACTIONS(666),
    [anon_sym_LPAREN] = ACTIONS(666),
    [anon_sym_COMMA] = ACTIONS(666),
    [anon_sym_STAR] = ACTIONS(668),
    [anon_sym_GT_GT] = ACTIONS(668),
    [anon_sym_if] = ACTIONS(666),
    [anon_sym_COLON] = ACTIONS(666),
    [anon_sym_in] = ACTIONS(666),
    [anon_sym_EQ] = ACTIONS(668),
    [anon_sym_STAR_STAR] = ACTIONS(668),
    [anon_sym_AT] = ACTIONS(668),
    [anon_sym_not] = ACTIONS(666),
    [anon_sym_and] = ACTIONS(666),
    [anon_sym_or] = ACTIONS(666),
    [anon_sym_PLUS] = ACTIONS(668),
    [anon_sym_DASH] = ACTIONS(668),
    [anon_sym_SLASH] = ACTIONS(668),
    [anon_sym_PERCENT] = ACTIONS(668),
    [anon_sym_SLASH_SLASH] = ACTIONS(668),
    [anon_sym_PIPE] = ACTIONS(668),
    [anon_sym_AMP] = ACTIONS(668),
    [anon_sym_CARET] = ACTIONS(668),
    [anon_sym_LT_LT] = ACTIONS(668),
    [anon_sym_LT] = ACTIONS(668),
    [anon_sym_LT_EQ] = ACTIONS(666),
    [anon_sym_EQ_EQ] = ACTIONS(666),
    [anon_sym_BANG_EQ] = ACTIONS(666),
    [anon_sym_GT_EQ] = ACTIONS(666),
    [anon_sym_GT] = ACTIONS(668),
    [anon_sym_LT_GT] = ACTIONS(666),
    [anon_sym_is] = ACTIONS(666),
    [anon_sym_PLUS_EQ] = ACTIONS(666),
    [anon_sym_DASH_EQ] = ACTIONS(666),
    [anon_sym_STAR_EQ] = ACTIONS(666),
    [anon_sym_SLASH_EQ] = ACTIONS(666),
    [anon_sym_AT_EQ] = ACTIONS(666),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(666),
    [anon_sym_PERCENT_EQ] = ACTIONS(666),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(666),
    [anon_sym_GT_GT_EQ] = ACTIONS(666),
    [anon_sym_LT_LT_EQ] = ACTIONS(666),
    [anon_sym_AMP_EQ] = ACTIONS(666),
    [anon_sym_CARET_EQ] = ACTIONS(666),
    [anon_sym_PIPE_EQ] = ACTIONS(666),
    [anon_sym_LBRACK] = ACTIONS(666),
    [sym_comment] = ACTIONS(3),
    [sym__semicolon] = ACTIONS(666),
    [sym__newline] = ACTIONS(666),
  },
  [183] = {
    [sym_named_expression] = STATE(768),
    [sym_dictionary_splat] = STATE(918),
    [sym__expression] = STATE(768),
    [sym__primary_expression] = STATE(383),
    [sym_not_operator] = STATE(768),
    [sym_boolean_operator] = STATE(768),
    [sym_binary_operator] = STATE(383),
    [sym_unary_operator] = STATE(383),
    [sym_comparison_operator] = STATE(768),
    [sym_lambda] = STATE(768),
    [sym_attribute] = STATE(383),
    [sym_subscript] = STATE(383),
    [sym_call] = STATE(383),
    [sym_list] = STATE(383),
    [sym_list_comprehension] = STATE(383),
    [sym_dictionary] = STATE(383),
    [sym_dictionary_comprehension] = STATE(383),
    [sym_pair] = STATE(918),
    [sym_set] = STATE(383),
    [sym_set_comprehension] = STATE(383),
    [sym_parenthesized_expression] = STATE(383),
    [sym_tuple] = STATE(383),
    [sym_generator_expression] = STATE(383),
    [sym_conditional_expression] = STATE(768),
    [sym_concatenated_string] = STATE(383),
    [sym_string] = STATE(381),
    [sym_await] = STATE(768),
    [sym_identifier] = ACTIONS(387),
    [anon_sym_LPAREN] = ACTIONS(389),
    [anon_sym_print] = ACTIONS(393),
    [anon_sym_STAR_STAR] = ACTIONS(359),
    [anon_sym_exec] = ACTIONS(393),
    [anon_sym_not] = ACTIONS(361),
    [anon_sym_PLUS] = ACTIONS(363),
    [anon_sym_DASH] = ACTIONS(363),
    [anon_sym_TILDE] = ACTIONS(363),
    [anon_sym_lambda] = ACTIONS(365),
    [anon_sym_LBRACK] = ACTIONS(367),
    [sym_ellipsis] = ACTIONS(369),
    [anon_sym_LBRACE] = ACTIONS(371),
    [anon_sym_RBRACE] = ACTIONS(670),
    [sym_integer] = ACTIONS(373),
    [sym_float] = ACTIONS(369),
    [sym_true] = ACTIONS(373),
    [sym_false] = ACTIONS(373),
    [sym_none] = ACTIONS(373),
    [anon_sym_await] = ACTIONS(375),
    [sym_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(377),
  },
  [184] = {
    [anon_sym_DOT] = ACTIONS(672),
    [anon_sym_from] = ACTIONS(672),
    [anon_sym_LPAREN] = ACTIONS(672),
    [anon_sym_COMMA] = ACTIONS(672),
    [anon_sym_STAR] = ACTIONS(674),
    [anon_sym_GT_GT] = ACTIONS(674),
    [anon_sym_if] = ACTIONS(672),
    [anon_sym_COLON] = ACTIONS(672),
    [anon_sym_in] = ACTIONS(672),
    [anon_sym_EQ] = ACTIONS(674),
    [anon_sym_STAR_STAR] = ACTIONS(674),
    [anon_sym_AT] = ACTIONS(674),
    [anon_sym_not] = ACTIONS(672),
    [anon_sym_and] = ACTIONS(672),
    [anon_sym_or] = ACTIONS(672),
    [anon_sym_PLUS] = ACTIONS(674),
    [anon_sym_DASH] = ACTIONS(674),
    [anon_sym_SLASH] = ACTIONS(674),
    [anon_sym_PERCENT] = ACTIONS(674),
    [anon_sym_SLASH_SLASH] = ACTIONS(674),
    [anon_sym_PIPE] = ACTIONS(674),
    [anon_sym_AMP] = ACTIONS(674),
    [anon_sym_CARET] = ACTIONS(674),
    [anon_sym_LT_LT] = ACTIONS(674),
    [anon_sym_LT] = ACTIONS(674),
    [anon_sym_LT_EQ] = ACTIONS(672),
    [anon_sym_EQ_EQ] = ACTIONS(672),
    [anon_sym_BANG_EQ] = ACTIONS(672),
    [anon_sym_GT_EQ] = ACTIONS(672),
    [anon_sym_GT] = ACTIONS(674),
    [anon_sym_LT_GT] = ACTIONS(672),
    [anon_sym_is] = ACTIONS(672),
    [anon_sym_PLUS_EQ] = ACTIONS(672),
    [anon_sym_DASH_EQ] = ACTIONS(672),
    [anon_sym_STAR_EQ] = ACTIONS(672),
    [anon_sym_SLASH_EQ] = ACTIONS(672),
    [anon_sym_AT_EQ] = ACTIONS(672),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(672),
    [anon_sym_PERCENT_EQ] = ACTIONS(672),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(672),
    [anon_sym_GT_GT_EQ] = ACTIONS(672),
    [anon_sym_LT_LT_EQ] = ACTIONS(672),
    [anon_sym_AMP_EQ] = ACTIONS(672),
    [anon_sym_CARET_EQ] = ACTIONS(672),
    [anon_sym_PIPE_EQ] = ACTIONS(672),
    [anon_sym_LBRACK] = ACTIONS(672),
    [sym_comment] = ACTIONS(3),
    [sym__semicolon] = ACTIONS(672),
    [sym__newline] = ACTIONS(672),
  },
  [185] = {
    [anon_sym_DOT] = ACTIONS(676),
    [anon_sym_from] = ACTIONS(676),
    [anon_sym_LPAREN] = ACTIONS(676),
    [anon_sym_COMMA] = ACTIONS(676),
    [anon_sym_STAR] = ACTIONS(678),
    [anon_sym_GT_GT] = ACTIONS(678),
    [anon_sym_if] = ACTIONS(676),
    [anon_sym_COLON] = ACTIONS(676),
    [anon_sym_in] = ACTIONS(676),
    [anon_sym_EQ] = ACTIONS(678),
    [anon_sym_STAR_STAR] = ACTIONS(678),
    [anon_sym_AT] = ACTIONS(678),
    [anon_sym_not] = ACTIONS(676),
    [anon_sym_and] = ACTIONS(676),
    [anon_sym_or] = ACTIONS(676),
    [anon_sym_PLUS] = ACTIONS(678),
    [anon_sym_DASH] = ACTIONS(678),
    [anon_sym_SLASH] = ACTIONS(678),
    [anon_sym_PERCENT] = ACTIONS(678),
    [anon_sym_SLASH_SLASH] = ACTIONS(678),
    [anon_sym_PIPE] = ACTIONS(678),
    [anon_sym_AMP] = ACTIONS(678),
    [anon_sym_CARET] = ACTIONS(678),
    [anon_sym_LT_LT] = ACTIONS(678),
    [anon_sym_LT] = ACTIONS(678),
    [anon_sym_LT_EQ] = ACTIONS(676),
    [anon_sym_EQ_EQ] = ACTIONS(676),
    [anon_sym_BANG_EQ] = ACTIONS(676),
    [anon_sym_GT_EQ] = ACTIONS(676),
    [anon_sym_GT] = ACTIONS(678),
    [anon_sym_LT_GT] = ACTIONS(676),
    [anon_sym_is] = ACTIONS(676),
    [anon_sym_PLUS_EQ] = ACTIONS(676),
    [anon_sym_DASH_EQ] = ACTIONS(676),
    [anon_sym_STAR_EQ] = ACTIONS(676),
    [anon_sym_SLASH_EQ] = ACTIONS(676),
    [anon_sym_AT_EQ] = ACTIONS(676),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(676),
    [anon_sym_PERCENT_EQ] = ACTIONS(676),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(676),
    [anon_sym_GT_GT_EQ] = ACTIONS(676),
    [anon_sym_LT_LT_EQ] = ACTIONS(676),
    [anon_sym_AMP_EQ] = ACTIONS(676),
    [anon_sym_CARET_EQ] = ACTIONS(676),
    [anon_sym_PIPE_EQ] = ACTIONS(676),
    [anon_sym_LBRACK] = ACTIONS(676),
    [sym_comment] = ACTIONS(3),
    [sym__semicolon] = ACTIONS(676),
    [sym__newline] = ACTIONS(676),
  },
  [186] = {
    [anon_sym_DOT] = ACTIONS(680),
    [anon_sym_from] = ACTIONS(680),
    [anon_sym_LPAREN] = ACTIONS(680),
    [anon_sym_COMMA] = ACTIONS(680),
    [anon_sym_STAR] = ACTIONS(682),
    [anon_sym_GT_GT] = ACTIONS(682),
    [anon_sym_if] = ACTIONS(680),
    [anon_sym_COLON] = ACTIONS(680),
    [anon_sym_in] = ACTIONS(680),
    [anon_sym_EQ] = ACTIONS(682),
    [anon_sym_STAR_STAR] = ACTIONS(682),
    [anon_sym_AT] = ACTIONS(682),
    [anon_sym_not] = ACTIONS(680),
    [anon_sym_and] = ACTIONS(680),
    [anon_sym_or] = ACTIONS(680),
    [anon_sym_PLUS] = ACTIONS(682),
    [anon_sym_DASH] = ACTIONS(682),
    [anon_sym_SLASH] = ACTIONS(682),
    [anon_sym_PERCENT] = ACTIONS(682),
    [anon_sym_SLASH_SLASH] = ACTIONS(682),
    [anon_sym_PIPE] = ACTIONS(682),
    [anon_sym_AMP] = ACTIONS(682),
    [anon_sym_CARET] = ACTIONS(682),
    [anon_sym_LT_LT] = ACTIONS(682),
    [anon_sym_LT] = ACTIONS(682),
    [anon_sym_LT_EQ] = ACTIONS(680),
    [anon_sym_EQ_EQ] = ACTIONS(680),
    [anon_sym_BANG_EQ] = ACTIONS(680),
    [anon_sym_GT_EQ] = ACTIONS(680),
    [anon_sym_GT] = ACTIONS(682),
    [anon_sym_LT_GT] = ACTIONS(680),
    [anon_sym_is] = ACTIONS(680),
    [anon_sym_PLUS_EQ] = ACTIONS(680),
    [anon_sym_DASH_EQ] = ACTIONS(680),
    [anon_sym_STAR_EQ] = ACTIONS(680),
    [anon_sym_SLASH_EQ] = ACTIONS(680),
    [anon_sym_AT_EQ] = ACTIONS(680),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(680),
    [anon_sym_PERCENT_EQ] = ACTIONS(680),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(680),
    [anon_sym_GT_GT_EQ] = ACTIONS(680),
    [anon_sym_LT_LT_EQ] = ACTIONS(680),
    [anon_sym_AMP_EQ] = ACTIONS(680),
    [anon_sym_CARET_EQ] = ACTIONS(680),
    [anon_sym_PIPE_EQ] = ACTIONS(680),
    [anon_sym_LBRACK] = ACTIONS(680),
    [sym_comment] = ACTIONS(3),
    [sym__semicolon] = ACTIONS(680),
    [sym__newline] = ACTIONS(680),
  },
  [187] = {
    [sym_else_clause] = STATE(358),
    [sym_except_clause] = STATE(250),
    [sym_finally_clause] = STATE(390),
    [aux_sym_try_statement_repeat1] = STATE(250),
    [sym_identifier] = ACTIONS(656),
    [anon_sym_import] = ACTIONS(656),
    [anon_sym_from] = ACTIONS(656),
    [anon_sym_LPAREN] = ACTIONS(654),
    [anon_sym_print] = ACTIONS(656),
    [anon_sym_assert] = ACTIONS(656),
    [anon_sym_return] = ACTIONS(656),
    [anon_sym_del] = ACTIONS(656),
    [anon_sym_raise] = ACTIONS(656),
    [anon_sym_pass] = ACTIONS(656),
    [anon_sym_break] = ACTIONS(656),
    [anon_sym_continue] = ACTIONS(656),
    [anon_sym_if] = ACTIONS(656),
    [anon_sym_else] = ACTIONS(684),
    [anon_sym_async] = ACTIONS(656),
    [anon_sym_for] = ACTIONS(656),
    [anon_sym_while] = ACTIONS(656),
    [anon_sym_try] = ACTIONS(656),
    [anon_sym_except] = ACTIONS(686),
    [anon_sym_finally] = ACTIONS(688),
    [anon_sym_with] = ACTIONS(656),
    [anon_sym_def] = ACTIONS(656),
    [anon_sym_global] = ACTIONS(656),
    [anon_sym_nonlocal] = ACTIONS(656),
    [anon_sym_exec] = ACTIONS(656),
    [anon_sym_class] = ACTIONS(656),
    [anon_sym_AT] = ACTIONS(654),
    [anon_sym_not] = ACTIONS(656),
    [anon_sym_PLUS] = ACTIONS(654),
    [anon_sym_DASH] = ACTIONS(654),
    [anon_sym_TILDE] = ACTIONS(654),
    [anon_sym_lambda] = ACTIONS(656),
    [anon_sym_yield] = ACTIONS(656),
    [anon_sym_LBRACK] = ACTIONS(654),
    [sym_ellipsis] = ACTIONS(654),
    [anon_sym_LBRACE] = ACTIONS(654),
    [sym_integer] = ACTIONS(656),
    [sym_float] = ACTIONS(654),
    [sym_true] = ACTIONS(656),
    [sym_false] = ACTIONS(656),
    [sym_none] = ACTIONS(656),
    [anon_sym_await] = ACTIONS(656),
    [sym_comment] = ACTIONS(3),
    [sym__dedent] = ACTIONS(654),
    [sym__string_start] = ACTIONS(654),
  },
  [188] = {
    [anon_sym_DOT] = ACTIONS(690),
    [anon_sym_from] = ACTIONS(690),
    [anon_sym_LPAREN] = ACTIONS(690),
    [anon_sym_COMMA] = ACTIONS(690),
    [anon_sym_STAR] = ACTIONS(692),
    [anon_sym_GT_GT] = ACTIONS(692),
    [anon_sym_if] = ACTIONS(690),
    [anon_sym_COLON] = ACTIONS(690),
    [anon_sym_in] = ACTIONS(690),
    [anon_sym_EQ] = ACTIONS(692),
    [anon_sym_STAR_STAR] = ACTIONS(692),
    [anon_sym_AT] = ACTIONS(692),
    [anon_sym_not] = ACTIONS(690),
    [anon_sym_and] = ACTIONS(690),
    [anon_sym_or] = ACTIONS(690),
    [anon_sym_PLUS] = ACTIONS(692),
    [anon_sym_DASH] = ACTIONS(692),
    [anon_sym_SLASH] = ACTIONS(692),
    [anon_sym_PERCENT] = ACTIONS(692),
    [anon_sym_SLASH_SLASH] = ACTIONS(692),
    [anon_sym_PIPE] = ACTIONS(692),
    [anon_sym_AMP] = ACTIONS(692),
    [anon_sym_CARET] = ACTIONS(692),
    [anon_sym_LT_LT] = ACTIONS(692),
    [anon_sym_LT] = ACTIONS(692),
    [anon_sym_LT_EQ] = ACTIONS(690),
    [anon_sym_EQ_EQ] = ACTIONS(690),
    [anon_sym_BANG_EQ] = ACTIONS(690),
    [anon_sym_GT_EQ] = ACTIONS(690),
    [anon_sym_GT] = ACTIONS(692),
    [anon_sym_LT_GT] = ACTIONS(690),
    [anon_sym_is] = ACTIONS(690),
    [anon_sym_PLUS_EQ] = ACTIONS(690),
    [anon_sym_DASH_EQ] = ACTIONS(690),
    [anon_sym_STAR_EQ] = ACTIONS(690),
    [anon_sym_SLASH_EQ] = ACTIONS(690),
    [anon_sym_AT_EQ] = ACTIONS(690),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(690),
    [anon_sym_PERCENT_EQ] = ACTIONS(690),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(690),
    [anon_sym_GT_GT_EQ] = ACTIONS(690),
    [anon_sym_LT_LT_EQ] = ACTIONS(690),
    [anon_sym_AMP_EQ] = ACTIONS(690),
    [anon_sym_CARET_EQ] = ACTIONS(690),
    [anon_sym_PIPE_EQ] = ACTIONS(690),
    [anon_sym_LBRACK] = ACTIONS(690),
    [sym_comment] = ACTIONS(3),
    [sym__semicolon] = ACTIONS(690),
    [sym__newline] = ACTIONS(690),
  },
  [189] = {
    [sym_named_expression] = STATE(698),
    [sym_expression_list] = STATE(938),
    [sym__expression] = STATE(698),
    [sym__primary_expression] = STATE(383),
    [sym_not_operator] = STATE(698),
    [sym_boolean_operator] = STATE(698),
    [sym_binary_operator] = STATE(383),
    [sym_unary_operator] = STATE(383),
    [sym_comparison_operator] = STATE(698),
    [sym_lambda] = STATE(698),
    [sym_attribute] = STATE(383),
    [sym_subscript] = STATE(383),
    [sym_call] = STATE(383),
    [sym_list] = STATE(383),
    [sym_list_comprehension] = STATE(383),
    [sym_dictionary] = STATE(383),
    [sym_dictionary_comprehension] = STATE(383),
    [sym_set] = STATE(383),
    [sym_set_comprehension] = STATE(383),
    [sym_parenthesized_expression] = STATE(383),
    [sym_tuple] = STATE(383),
    [sym_generator_expression] = STATE(383),
    [sym_conditional_expression] = STATE(698),
    [sym_concatenated_string] = STATE(383),
    [sym_string] = STATE(381),
    [sym_await] = STATE(698),
    [sym_identifier] = ACTIONS(387),
    [anon_sym_from] = ACTIONS(694),
    [anon_sym_LPAREN] = ACTIONS(389),
    [anon_sym_RPAREN] = ACTIONS(520),
    [anon_sym_COMMA] = ACTIONS(520),
    [anon_sym_print] = ACTIONS(393),
    [anon_sym_exec] = ACTIONS(393),
    [anon_sym_not] = ACTIONS(361),
    [anon_sym_PLUS] = ACTIONS(363),
    [anon_sym_DASH] = ACTIONS(363),
    [anon_sym_TILDE] = ACTIONS(363),
    [anon_sym_lambda] = ACTIONS(365),
    [anon_sym_LBRACK] = ACTIONS(367),
    [sym_ellipsis] = ACTIONS(369),
    [anon_sym_LBRACE] = ACTIONS(371),
    [sym_integer] = ACTIONS(373),
    [sym_float] = ACTIONS(369),
    [sym_true] = ACTIONS(373),
    [sym_false] = ACTIONS(373),
    [sym_none] = ACTIONS(373),
    [anon_sym_await] = ACTIONS(375),
    [sym_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(377),
  },
  [190] = {
    [anon_sym_DOT] = ACTIONS(696),
    [anon_sym_from] = ACTIONS(696),
    [anon_sym_LPAREN] = ACTIONS(696),
    [anon_sym_COMMA] = ACTIONS(696),
    [anon_sym_STAR] = ACTIONS(698),
    [anon_sym_GT_GT] = ACTIONS(698),
    [anon_sym_if] = ACTIONS(696),
    [anon_sym_COLON] = ACTIONS(696),
    [anon_sym_in] = ACTIONS(696),
    [anon_sym_EQ] = ACTIONS(698),
    [anon_sym_STAR_STAR] = ACTIONS(698),
    [anon_sym_AT] = ACTIONS(698),
    [anon_sym_not] = ACTIONS(696),
    [anon_sym_and] = ACTIONS(696),
    [anon_sym_or] = ACTIONS(696),
    [anon_sym_PLUS] = ACTIONS(698),
    [anon_sym_DASH] = ACTIONS(698),
    [anon_sym_SLASH] = ACTIONS(698),
    [anon_sym_PERCENT] = ACTIONS(698),
    [anon_sym_SLASH_SLASH] = ACTIONS(698),
    [anon_sym_PIPE] = ACTIONS(698),
    [anon_sym_AMP] = ACTIONS(698),
    [anon_sym_CARET] = ACTIONS(698),
    [anon_sym_LT_LT] = ACTIONS(698),
    [anon_sym_LT] = ACTIONS(698),
    [anon_sym_LT_EQ] = ACTIONS(696),
    [anon_sym_EQ_EQ] = ACTIONS(696),
    [anon_sym_BANG_EQ] = ACTIONS(696),
    [anon_sym_GT_EQ] = ACTIONS(696),
    [anon_sym_GT] = ACTIONS(698),
    [anon_sym_LT_GT] = ACTIONS(696),
    [anon_sym_is] = ACTIONS(696),
    [anon_sym_PLUS_EQ] = ACTIONS(696),
    [anon_sym_DASH_EQ] = ACTIONS(696),
    [anon_sym_STAR_EQ] = ACTIONS(696),
    [anon_sym_SLASH_EQ] = ACTIONS(696),
    [anon_sym_AT_EQ] = ACTIONS(696),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(696),
    [anon_sym_PERCENT_EQ] = ACTIONS(696),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(696),
    [anon_sym_GT_GT_EQ] = ACTIONS(696),
    [anon_sym_LT_LT_EQ] = ACTIONS(696),
    [anon_sym_AMP_EQ] = ACTIONS(696),
    [anon_sym_CARET_EQ] = ACTIONS(696),
    [anon_sym_PIPE_EQ] = ACTIONS(696),
    [anon_sym_LBRACK] = ACTIONS(696),
    [sym_comment] = ACTIONS(3),
    [sym__semicolon] = ACTIONS(696),
    [sym__newline] = ACTIONS(696),
  },
  [191] = {
    [sym_else_clause] = STATE(369),
    [sym_except_clause] = STATE(250),
    [sym_finally_clause] = STATE(401),
    [aux_sym_try_statement_repeat1] = STATE(250),
    [sym_identifier] = ACTIONS(546),
    [anon_sym_import] = ACTIONS(546),
    [anon_sym_from] = ACTIONS(546),
    [anon_sym_LPAREN] = ACTIONS(544),
    [anon_sym_print] = ACTIONS(546),
    [anon_sym_assert] = ACTIONS(546),
    [anon_sym_return] = ACTIONS(546),
    [anon_sym_del] = ACTIONS(546),
    [anon_sym_raise] = ACTIONS(546),
    [anon_sym_pass] = ACTIONS(546),
    [anon_sym_break] = ACTIONS(546),
    [anon_sym_continue] = ACTIONS(546),
    [anon_sym_if] = ACTIONS(546),
    [anon_sym_else] = ACTIONS(684),
    [anon_sym_async] = ACTIONS(546),
    [anon_sym_for] = ACTIONS(546),
    [anon_sym_while] = ACTIONS(546),
    [anon_sym_try] = ACTIONS(546),
    [anon_sym_except] = ACTIONS(686),
    [anon_sym_finally] = ACTIONS(688),
    [anon_sym_with] = ACTIONS(546),
    [anon_sym_def] = ACTIONS(546),
    [anon_sym_global] = ACTIONS(546),
    [anon_sym_nonlocal] = ACTIONS(546),
    [anon_sym_exec] = ACTIONS(546),
    [anon_sym_class] = ACTIONS(546),
    [anon_sym_AT] = ACTIONS(544),
    [anon_sym_not] = ACTIONS(546),
    [anon_sym_PLUS] = ACTIONS(544),
    [anon_sym_DASH] = ACTIONS(544),
    [anon_sym_TILDE] = ACTIONS(544),
    [anon_sym_lambda] = ACTIONS(546),
    [anon_sym_yield] = ACTIONS(546),
    [anon_sym_LBRACK] = ACTIONS(544),
    [sym_ellipsis] = ACTIONS(544),
    [anon_sym_LBRACE] = ACTIONS(544),
    [sym_integer] = ACTIONS(546),
    [sym_float] = ACTIONS(544),
    [sym_true] = ACTIONS(546),
    [sym_false] = ACTIONS(546),
    [sym_none] = ACTIONS(546),
    [anon_sym_await] = ACTIONS(546),
    [sym_comment] = ACTIONS(3),
    [sym__dedent] = ACTIONS(544),
    [sym__string_start] = ACTIONS(544),
  },
  [192] = {
    [sym_named_expression] = STATE(729),
    [sym__expression] = STATE(729),
    [sym__primary_expression] = STATE(383),
    [sym_not_operator] = STATE(729),
    [sym_boolean_operator] = STATE(729),
    [sym_binary_operator] = STATE(383),
    [sym_unary_operator] = STATE(383),
    [sym_comparison_operator] = STATE(729),
    [sym_lambda] = STATE(729),
    [sym_attribute] = STATE(383),
    [sym_subscript] = STATE(383),
    [sym_slice] = STATE(947),
    [sym_call] = STATE(383),
    [sym_list] = STATE(383),
    [sym_list_comprehension] = STATE(383),
    [sym_dictionary] = STATE(383),
    [sym_dictionary_comprehension] = STATE(383),
    [sym_set] = STATE(383),
    [sym_set_comprehension] = STATE(383),
    [sym_parenthesized_expression] = STATE(383),
    [sym_tuple] = STATE(383),
    [sym_generator_expression] = STATE(383),
    [sym_conditional_expression] = STATE(729),
    [sym_concatenated_string] = STATE(383),
    [sym_string] = STATE(381),
    [sym_await] = STATE(729),
    [sym_identifier] = ACTIONS(387),
    [anon_sym_LPAREN] = ACTIONS(389),
    [anon_sym_print] = ACTIONS(393),
    [anon_sym_COLON] = ACTIONS(700),
    [anon_sym_exec] = ACTIONS(393),
    [anon_sym_not] = ACTIONS(361),
    [anon_sym_PLUS] = ACTIONS(363),
    [anon_sym_DASH] = ACTIONS(363),
    [anon_sym_TILDE] = ACTIONS(363),
    [anon_sym_lambda] = ACTIONS(365),
    [anon_sym_LBRACK] = ACTIONS(367),
    [anon_sym_RBRACK] = ACTIONS(702),
    [sym_ellipsis] = ACTIONS(369),
    [anon_sym_LBRACE] = ACTIONS(371),
    [sym_integer] = ACTIONS(373),
    [sym_float] = ACTIONS(369),
    [sym_true] = ACTIONS(373),
    [sym_false] = ACTIONS(373),
    [sym_none] = ACTIONS(373),
    [anon_sym_await] = ACTIONS(375),
    [sym_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(377),
  },
  [193] = {
    [sym_named_expression] = STATE(729),
    [sym__expression] = STATE(729),
    [sym__primary_expression] = STATE(383),
    [sym_not_operator] = STATE(729),
    [sym_boolean_operator] = STATE(729),
    [sym_binary_operator] = STATE(383),
    [sym_unary_operator] = STATE(383),
    [sym_comparison_operator] = STATE(729),
    [sym_lambda] = STATE(729),
    [sym_attribute] = STATE(383),
    [sym_subscript] = STATE(383),
    [sym_slice] = STATE(947),
    [sym_call] = STATE(383),
    [sym_list] = STATE(383),
    [sym_list_comprehension] = STATE(383),
    [sym_dictionary] = STATE(383),
    [sym_dictionary_comprehension] = STATE(383),
    [sym_set] = STATE(383),
    [sym_set_comprehension] = STATE(383),
    [sym_parenthesized_expression] = STATE(383),
    [sym_tuple] = STATE(383),
    [sym_generator_expression] = STATE(383),
    [sym_conditional_expression] = STATE(729),
    [sym_concatenated_string] = STATE(383),
    [sym_string] = STATE(381),
    [sym_await] = STATE(729),
    [sym_identifier] = ACTIONS(387),
    [anon_sym_LPAREN] = ACTIONS(389),
    [anon_sym_print] = ACTIONS(393),
    [anon_sym_COLON] = ACTIONS(700),
    [anon_sym_exec] = ACTIONS(393),
    [anon_sym_not] = ACTIONS(361),
    [anon_sym_PLUS] = ACTIONS(363),
    [anon_sym_DASH] = ACTIONS(363),
    [anon_sym_TILDE] = ACTIONS(363),
    [anon_sym_lambda] = ACTIONS(365),
    [anon_sym_LBRACK] = ACTIONS(367),
    [anon_sym_RBRACK] = ACTIONS(704),
    [sym_ellipsis] = ACTIONS(369),
    [anon_sym_LBRACE] = ACTIONS(371),
    [sym_integer] = ACTIONS(373),
    [sym_float] = ACTIONS(369),
    [sym_true] = ACTIONS(373),
    [sym_false] = ACTIONS(373),
    [sym_none] = ACTIONS(373),
    [anon_sym_await] = ACTIONS(375),
    [sym_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(377),
  },
  [194] = {
    [sym_named_expression] = STATE(748),
    [sym__expression] = STATE(748),
    [sym__primary_expression] = STATE(383),
    [sym_not_operator] = STATE(748),
    [sym_boolean_operator] = STATE(748),
    [sym_binary_operator] = STATE(383),
    [sym_unary_operator] = STATE(383),
    [sym_comparison_operator] = STATE(748),
    [sym_lambda] = STATE(748),
    [sym_yield] = STATE(951),
    [sym_attribute] = STATE(383),
    [sym_subscript] = STATE(383),
    [sym_call] = STATE(383),
    [sym_list] = STATE(383),
    [sym_list_comprehension] = STATE(383),
    [sym_dictionary] = STATE(383),
    [sym_dictionary_comprehension] = STATE(383),
    [sym_set] = STATE(383),
    [sym_set_comprehension] = STATE(383),
    [sym_parenthesized_expression] = STATE(383),
    [sym_tuple] = STATE(383),
    [sym_generator_expression] = STATE(383),
    [sym_conditional_expression] = STATE(748),
    [sym_concatenated_string] = STATE(383),
    [sym_string] = STATE(381),
    [sym_await] = STATE(748),
    [sym_identifier] = ACTIONS(387),
    [anon_sym_LPAREN] = ACTIONS(389),
    [anon_sym_RPAREN] = ACTIONS(706),
    [anon_sym_print] = ACTIONS(393),
    [anon_sym_exec] = ACTIONS(393),
    [anon_sym_not] = ACTIONS(361),
    [anon_sym_PLUS] = ACTIONS(363),
    [anon_sym_DASH] = ACTIONS(363),
    [anon_sym_TILDE] = ACTIONS(363),
    [anon_sym_lambda] = ACTIONS(365),
    [anon_sym_yield] = ACTIONS(465),
    [anon_sym_LBRACK] = ACTIONS(367),
    [sym_ellipsis] = ACTIONS(369),
    [anon_sym_LBRACE] = ACTIONS(371),
    [sym_integer] = ACTIONS(373),
    [sym_float] = ACTIONS(369),
    [sym_true] = ACTIONS(373),
    [sym_false] = ACTIONS(373),
    [sym_none] = ACTIONS(373),
    [anon_sym_await] = ACTIONS(375),
    [sym_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(377),
  },
  [195] = {
    [sym_named_expression] = STATE(721),
    [sym_list_splat] = STATE(812),
    [sym__expression] = STATE(721),
    [sym__primary_expression] = STATE(383),
    [sym_not_operator] = STATE(721),
    [sym_boolean_operator] = STATE(721),
    [sym_binary_operator] = STATE(383),
    [sym_unary_operator] = STATE(383),
    [sym_comparison_operator] = STATE(721),
    [sym_lambda] = STATE(721),
    [sym_attribute] = STATE(383),
    [sym_subscript] = STATE(383),
    [sym_call] = STATE(383),
    [sym_list] = STATE(383),
    [sym_list_comprehension] = STATE(383),
    [sym_dictionary] = STATE(383),
    [sym_dictionary_comprehension] = STATE(383),
    [sym_set] = STATE(383),
    [sym_set_comprehension] = STATE(383),
    [sym_parenthesized_expression] = STATE(383),
    [sym_tuple] = STATE(383),
    [sym_generator_expression] = STATE(383),
    [sym_conditional_expression] = STATE(721),
    [sym_concatenated_string] = STATE(383),
    [sym_string] = STATE(381),
    [sym_await] = STATE(721),
    [sym_identifier] = ACTIONS(387),
    [anon_sym_LPAREN] = ACTIONS(389),
    [anon_sym_STAR] = ACTIONS(463),
    [anon_sym_print] = ACTIONS(393),
    [anon_sym_exec] = ACTIONS(393),
    [anon_sym_not] = ACTIONS(361),
    [anon_sym_PLUS] = ACTIONS(363),
    [anon_sym_DASH] = ACTIONS(363),
    [anon_sym_TILDE] = ACTIONS(363),
    [anon_sym_lambda] = ACTIONS(365),
    [anon_sym_LBRACK] = ACTIONS(367),
    [anon_sym_RBRACK] = ACTIONS(708),
    [sym_ellipsis] = ACTIONS(369),
    [anon_sym_LBRACE] = ACTIONS(371),
    [sym_integer] = ACTIONS(373),
    [sym_float] = ACTIONS(369),
    [sym_true] = ACTIONS(373),
    [sym_false] = ACTIONS(373),
    [sym_none] = ACTIONS(373),
    [anon_sym_await] = ACTIONS(375),
    [sym_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(377),
  },
  [196] = {
    [sym_named_expression] = STATE(721),
    [sym_list_splat] = STATE(812),
    [sym__expression] = STATE(721),
    [sym__primary_expression] = STATE(383),
    [sym_not_operator] = STATE(721),
    [sym_boolean_operator] = STATE(721),
    [sym_binary_operator] = STATE(383),
    [sym_unary_operator] = STATE(383),
    [sym_comparison_operator] = STATE(721),
    [sym_lambda] = STATE(721),
    [sym_attribute] = STATE(383),
    [sym_subscript] = STATE(383),
    [sym_call] = STATE(383),
    [sym_list] = STATE(383),
    [sym_list_comprehension] = STATE(383),
    [sym_dictionary] = STATE(383),
    [sym_dictionary_comprehension] = STATE(383),
    [sym_set] = STATE(383),
    [sym_set_comprehension] = STATE(383),
    [sym_parenthesized_expression] = STATE(383),
    [sym_tuple] = STATE(383),
    [sym_generator_expression] = STATE(383),
    [sym_conditional_expression] = STATE(721),
    [sym_concatenated_string] = STATE(383),
    [sym_string] = STATE(381),
    [sym_await] = STATE(721),
    [sym_identifier] = ACTIONS(387),
    [anon_sym_LPAREN] = ACTIONS(389),
    [anon_sym_STAR] = ACTIONS(463),
    [anon_sym_print] = ACTIONS(393),
    [anon_sym_exec] = ACTIONS(393),
    [anon_sym_not] = ACTIONS(361),
    [anon_sym_PLUS] = ACTIONS(363),
    [anon_sym_DASH] = ACTIONS(363),
    [anon_sym_TILDE] = ACTIONS(363),
    [anon_sym_lambda] = ACTIONS(365),
    [anon_sym_LBRACK] = ACTIONS(367),
    [anon_sym_RBRACK] = ACTIONS(710),
    [sym_ellipsis] = ACTIONS(369),
    [anon_sym_LBRACE] = ACTIONS(371),
    [sym_integer] = ACTIONS(373),
    [sym_float] = ACTIONS(369),
    [sym_true] = ACTIONS(373),
    [sym_false] = ACTIONS(373),
    [sym_none] = ACTIONS(373),
    [anon_sym_await] = ACTIONS(375),
    [sym_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(377),
  },
  [197] = {
    [sym_named_expression] = STATE(599),
    [sym_expression_list] = STATE(928),
    [sym__expression] = STATE(599),
    [sym__primary_expression] = STATE(109),
    [sym_not_operator] = STATE(599),
    [sym_boolean_operator] = STATE(599),
    [sym_binary_operator] = STATE(109),
    [sym_unary_operator] = STATE(109),
    [sym_comparison_operator] = STATE(599),
    [sym_lambda] = STATE(599),
    [sym_attribute] = STATE(109),
    [sym_subscript] = STATE(109),
    [sym_call] = STATE(109),
    [sym_list] = STATE(109),
    [sym_list_comprehension] = STATE(109),
    [sym_dictionary] = STATE(109),
    [sym_dictionary_comprehension] = STATE(109),
    [sym_set] = STATE(109),
    [sym_set_comprehension] = STATE(109),
    [sym_parenthesized_expression] = STATE(109),
    [sym_tuple] = STATE(109),
    [sym_generator_expression] = STATE(109),
    [sym_conditional_expression] = STATE(599),
    [sym_concatenated_string] = STATE(109),
    [sym_string] = STATE(117),
    [sym_await] = STATE(599),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(13),
    [anon_sym_print] = ACTIONS(237),
    [anon_sym_exec] = ACTIONS(237),
    [anon_sym_not] = ACTIONS(55),
    [anon_sym_PLUS] = ACTIONS(57),
    [anon_sym_DASH] = ACTIONS(57),
    [anon_sym_TILDE] = ACTIONS(57),
    [anon_sym_lambda] = ACTIONS(59),
    [anon_sym_LBRACK] = ACTIONS(63),
    [sym_ellipsis] = ACTIONS(65),
    [anon_sym_LBRACE] = ACTIONS(67),
    [sym_integer] = ACTIONS(69),
    [sym_float] = ACTIONS(65),
    [sym_true] = ACTIONS(69),
    [sym_false] = ACTIONS(69),
    [sym_none] = ACTIONS(69),
    [anon_sym_await] = ACTIONS(71),
    [sym_comment] = ACTIONS(3),
    [sym__semicolon] = ACTIONS(712),
    [sym__newline] = ACTIONS(712),
    [sym__string_start] = ACTIONS(73),
  },
  [198] = {
    [sym_named_expression] = STATE(717),
    [sym__expression] = STATE(717),
    [sym__primary_expression] = STATE(383),
    [sym_not_operator] = STATE(717),
    [sym_boolean_operator] = STATE(717),
    [sym_binary_operator] = STATE(383),
    [sym_unary_operator] = STATE(383),
    [sym_comparison_operator] = STATE(717),
    [sym_lambda] = STATE(717),
    [sym_attribute] = STATE(383),
    [sym_subscript] = STATE(383),
    [sym_call] = STATE(383),
    [sym_list] = STATE(383),
    [sym_list_comprehension] = STATE(383),
    [sym_dictionary] = STATE(383),
    [sym_dictionary_comprehension] = STATE(383),
    [sym_set] = STATE(383),
    [sym_set_comprehension] = STATE(383),
    [sym_parenthesized_expression] = STATE(383),
    [sym_tuple] = STATE(383),
    [sym_generator_expression] = STATE(383),
    [sym_conditional_expression] = STATE(717),
    [sym_concatenated_string] = STATE(383),
    [sym_string] = STATE(381),
    [sym_await] = STATE(717),
    [sym_identifier] = ACTIONS(387),
    [anon_sym_LPAREN] = ACTIONS(389),
    [anon_sym_COMMA] = ACTIONS(714),
    [anon_sym_print] = ACTIONS(393),
    [anon_sym_COLON] = ACTIONS(716),
    [anon_sym_exec] = ACTIONS(393),
    [anon_sym_not] = ACTIONS(361),
    [anon_sym_PLUS] = ACTIONS(363),
    [anon_sym_DASH] = ACTIONS(363),
    [anon_sym_TILDE] = ACTIONS(363),
    [anon_sym_lambda] = ACTIONS(365),
    [anon_sym_LBRACK] = ACTIONS(367),
    [anon_sym_RBRACK] = ACTIONS(714),
    [sym_ellipsis] = ACTIONS(369),
    [anon_sym_LBRACE] = ACTIONS(371),
    [sym_integer] = ACTIONS(373),
    [sym_float] = ACTIONS(369),
    [sym_true] = ACTIONS(373),
    [sym_false] = ACTIONS(373),
    [sym_none] = ACTIONS(373),
    [anon_sym_await] = ACTIONS(375),
    [sym_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(377),
  },
  [199] = {
    [sym_named_expression] = STATE(711),
    [sym__expression] = STATE(711),
    [sym__primary_expression] = STATE(383),
    [sym_not_operator] = STATE(711),
    [sym_boolean_operator] = STATE(711),
    [sym_binary_operator] = STATE(383),
    [sym_unary_operator] = STATE(383),
    [sym_comparison_operator] = STATE(711),
    [sym_lambda] = STATE(711),
    [sym_attribute] = STATE(383),
    [sym_subscript] = STATE(383),
    [sym_call] = STATE(383),
    [sym_list] = STATE(383),
    [sym_list_comprehension] = STATE(383),
    [sym_dictionary] = STATE(383),
    [sym_dictionary_comprehension] = STATE(383),
    [sym_set] = STATE(383),
    [sym_set_comprehension] = STATE(383),
    [sym_parenthesized_expression] = STATE(383),
    [sym_tuple] = STATE(383),
    [sym_generator_expression] = STATE(383),
    [sym_conditional_expression] = STATE(711),
    [sym_concatenated_string] = STATE(383),
    [sym_string] = STATE(381),
    [sym_await] = STATE(711),
    [sym_identifier] = ACTIONS(387),
    [anon_sym_LPAREN] = ACTIONS(389),
    [anon_sym_COMMA] = ACTIONS(718),
    [anon_sym_print] = ACTIONS(393),
    [anon_sym_COLON] = ACTIONS(720),
    [anon_sym_exec] = ACTIONS(393),
    [anon_sym_not] = ACTIONS(361),
    [anon_sym_PLUS] = ACTIONS(363),
    [anon_sym_DASH] = ACTIONS(363),
    [anon_sym_TILDE] = ACTIONS(363),
    [anon_sym_lambda] = ACTIONS(365),
    [anon_sym_LBRACK] = ACTIONS(367),
    [anon_sym_RBRACK] = ACTIONS(718),
    [sym_ellipsis] = ACTIONS(369),
    [anon_sym_LBRACE] = ACTIONS(371),
    [sym_integer] = ACTIONS(373),
    [sym_float] = ACTIONS(369),
    [sym_true] = ACTIONS(373),
    [sym_false] = ACTIONS(373),
    [sym_none] = ACTIONS(373),
    [anon_sym_await] = ACTIONS(375),
    [sym_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(377),
  },
  [200] = {
    [sym_named_expression] = STATE(748),
    [sym__expression] = STATE(748),
    [sym__primary_expression] = STATE(383),
    [sym_not_operator] = STATE(748),
    [sym_boolean_operator] = STATE(748),
    [sym_binary_operator] = STATE(383),
    [sym_unary_operator] = STATE(383),
    [sym_comparison_operator] = STATE(748),
    [sym_lambda] = STATE(748),
    [sym_yield] = STATE(951),
    [sym_attribute] = STATE(383),
    [sym_subscript] = STATE(383),
    [sym_call] = STATE(383),
    [sym_list] = STATE(383),
    [sym_list_comprehension] = STATE(383),
    [sym_dictionary] = STATE(383),
    [sym_dictionary_comprehension] = STATE(383),
    [sym_set] = STATE(383),
    [sym_set_comprehension] = STATE(383),
    [sym_parenthesized_expression] = STATE(383),
    [sym_tuple] = STATE(383),
    [sym_generator_expression] = STATE(383),
    [sym_conditional_expression] = STATE(748),
    [sym_concatenated_string] = STATE(383),
    [sym_string] = STATE(381),
    [sym_await] = STATE(748),
    [sym_identifier] = ACTIONS(387),
    [anon_sym_LPAREN] = ACTIONS(389),
    [anon_sym_RPAREN] = ACTIONS(722),
    [anon_sym_print] = ACTIONS(393),
    [anon_sym_exec] = ACTIONS(393),
    [anon_sym_not] = ACTIONS(361),
    [anon_sym_PLUS] = ACTIONS(363),
    [anon_sym_DASH] = ACTIONS(363),
    [anon_sym_TILDE] = ACTIONS(363),
    [anon_sym_lambda] = ACTIONS(365),
    [anon_sym_yield] = ACTIONS(465),
    [anon_sym_LBRACK] = ACTIONS(367),
    [sym_ellipsis] = ACTIONS(369),
    [anon_sym_LBRACE] = ACTIONS(371),
    [sym_integer] = ACTIONS(373),
    [sym_float] = ACTIONS(369),
    [sym_true] = ACTIONS(373),
    [sym_false] = ACTIONS(373),
    [sym_none] = ACTIONS(373),
    [anon_sym_await] = ACTIONS(375),
    [sym_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(377),
  },
  [201] = {
    [sym_named_expression] = STATE(729),
    [sym__expression] = STATE(729),
    [sym__primary_expression] = STATE(383),
    [sym_not_operator] = STATE(729),
    [sym_boolean_operator] = STATE(729),
    [sym_binary_operator] = STATE(383),
    [sym_unary_operator] = STATE(383),
    [sym_comparison_operator] = STATE(729),
    [sym_lambda] = STATE(729),
    [sym_attribute] = STATE(383),
    [sym_subscript] = STATE(383),
    [sym_slice] = STATE(947),
    [sym_call] = STATE(383),
    [sym_list] = STATE(383),
    [sym_list_comprehension] = STATE(383),
    [sym_dictionary] = STATE(383),
    [sym_dictionary_comprehension] = STATE(383),
    [sym_set] = STATE(383),
    [sym_set_comprehension] = STATE(383),
    [sym_parenthesized_expression] = STATE(383),
    [sym_tuple] = STATE(383),
    [sym_generator_expression] = STATE(383),
    [sym_conditional_expression] = STATE(729),
    [sym_concatenated_string] = STATE(383),
    [sym_string] = STATE(381),
    [sym_await] = STATE(729),
    [sym_identifier] = ACTIONS(387),
    [anon_sym_LPAREN] = ACTIONS(389),
    [anon_sym_print] = ACTIONS(393),
    [anon_sym_COLON] = ACTIONS(700),
    [anon_sym_exec] = ACTIONS(393),
    [anon_sym_not] = ACTIONS(361),
    [anon_sym_PLUS] = ACTIONS(363),
    [anon_sym_DASH] = ACTIONS(363),
    [anon_sym_TILDE] = ACTIONS(363),
    [anon_sym_lambda] = ACTIONS(365),
    [anon_sym_LBRACK] = ACTIONS(367),
    [anon_sym_RBRACK] = ACTIONS(724),
    [sym_ellipsis] = ACTIONS(369),
    [anon_sym_LBRACE] = ACTIONS(371),
    [sym_integer] = ACTIONS(373),
    [sym_float] = ACTIONS(369),
    [sym_true] = ACTIONS(373),
    [sym_false] = ACTIONS(373),
    [sym_none] = ACTIONS(373),
    [anon_sym_await] = ACTIONS(375),
    [sym_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(377),
  },
  [202] = {
    [sym_named_expression] = STATE(721),
    [sym_list_splat] = STATE(812),
    [sym__expression] = STATE(721),
    [sym__primary_expression] = STATE(383),
    [sym_not_operator] = STATE(721),
    [sym_boolean_operator] = STATE(721),
    [sym_binary_operator] = STATE(383),
    [sym_unary_operator] = STATE(383),
    [sym_comparison_operator] = STATE(721),
    [sym_lambda] = STATE(721),
    [sym_attribute] = STATE(383),
    [sym_subscript] = STATE(383),
    [sym_call] = STATE(383),
    [sym_list] = STATE(383),
    [sym_list_comprehension] = STATE(383),
    [sym_dictionary] = STATE(383),
    [sym_dictionary_comprehension] = STATE(383),
    [sym_set] = STATE(383),
    [sym_set_comprehension] = STATE(383),
    [sym_parenthesized_expression] = STATE(383),
    [sym_tuple] = STATE(383),
    [sym_generator_expression] = STATE(383),
    [sym_conditional_expression] = STATE(721),
    [sym_concatenated_string] = STATE(383),
    [sym_string] = STATE(381),
    [sym_await] = STATE(721),
    [sym_identifier] = ACTIONS(387),
    [anon_sym_LPAREN] = ACTIONS(389),
    [anon_sym_STAR] = ACTIONS(463),
    [anon_sym_print] = ACTIONS(393),
    [anon_sym_exec] = ACTIONS(393),
    [anon_sym_not] = ACTIONS(361),
    [anon_sym_PLUS] = ACTIONS(363),
    [anon_sym_DASH] = ACTIONS(363),
    [anon_sym_TILDE] = ACTIONS(363),
    [anon_sym_lambda] = ACTIONS(365),
    [anon_sym_LBRACK] = ACTIONS(367),
    [anon_sym_RBRACK] = ACTIONS(726),
    [sym_ellipsis] = ACTIONS(369),
    [anon_sym_LBRACE] = ACTIONS(371),
    [sym_integer] = ACTIONS(373),
    [sym_float] = ACTIONS(369),
    [sym_true] = ACTIONS(373),
    [sym_false] = ACTIONS(373),
    [sym_none] = ACTIONS(373),
    [anon_sym_await] = ACTIONS(375),
    [sym_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(377),
  },
  [203] = {
    [sym_named_expression] = STATE(668),
    [sym__expression] = STATE(668),
    [sym__primary_expression] = STATE(383),
    [sym_not_operator] = STATE(668),
    [sym_boolean_operator] = STATE(668),
    [sym_binary_operator] = STATE(383),
    [sym_unary_operator] = STATE(383),
    [sym_comparison_operator] = STATE(668),
    [sym_lambda] = STATE(668),
    [sym_attribute] = STATE(383),
    [sym_subscript] = STATE(383),
    [sym_call] = STATE(383),
    [sym_list] = STATE(383),
    [sym_list_comprehension] = STATE(383),
    [sym_dictionary] = STATE(383),
    [sym_dictionary_comprehension] = STATE(383),
    [sym_set] = STATE(383),
    [sym_set_comprehension] = STATE(383),
    [sym_parenthesized_expression] = STATE(383),
    [sym_tuple] = STATE(383),
    [sym_generator_expression] = STATE(383),
    [sym_conditional_expression] = STATE(668),
    [sym_concatenated_string] = STATE(383),
    [sym_string] = STATE(381),
    [sym_await] = STATE(668),
    [sym_identifier] = ACTIONS(387),
    [anon_sym_LPAREN] = ACTIONS(389),
    [anon_sym_RPAREN] = ACTIONS(728),
    [anon_sym_COMMA] = ACTIONS(728),
    [anon_sym_print] = ACTIONS(393),
    [anon_sym_COLON] = ACTIONS(728),
    [anon_sym_exec] = ACTIONS(393),
    [anon_sym_not] = ACTIONS(361),
    [anon_sym_PLUS] = ACTIONS(363),
    [anon_sym_DASH] = ACTIONS(363),
    [anon_sym_TILDE] = ACTIONS(363),
    [anon_sym_lambda] = ACTIONS(365),
    [anon_sym_LBRACK] = ACTIONS(367),
    [sym_ellipsis] = ACTIONS(369),
    [anon_sym_LBRACE] = ACTIONS(371),
    [sym_integer] = ACTIONS(373),
    [sym_float] = ACTIONS(369),
    [sym_true] = ACTIONS(373),
    [sym_false] = ACTIONS(373),
    [sym_none] = ACTIONS(373),
    [anon_sym_await] = ACTIONS(375),
    [sym_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(377),
  },
  [204] = {
    [sym_named_expression] = STATE(721),
    [sym_list_splat] = STATE(812),
    [sym__expression] = STATE(721),
    [sym__primary_expression] = STATE(383),
    [sym_not_operator] = STATE(721),
    [sym_boolean_operator] = STATE(721),
    [sym_binary_operator] = STATE(383),
    [sym_unary_operator] = STATE(383),
    [sym_comparison_operator] = STATE(721),
    [sym_lambda] = STATE(721),
    [sym_attribute] = STATE(383),
    [sym_subscript] = STATE(383),
    [sym_call] = STATE(383),
    [sym_list] = STATE(383),
    [sym_list_comprehension] = STATE(383),
    [sym_dictionary] = STATE(383),
    [sym_dictionary_comprehension] = STATE(383),
    [sym_set] = STATE(383),
    [sym_set_comprehension] = STATE(383),
    [sym_parenthesized_expression] = STATE(383),
    [sym_tuple] = STATE(383),
    [sym_generator_expression] = STATE(383),
    [sym_conditional_expression] = STATE(721),
    [sym_concatenated_string] = STATE(383),
    [sym_string] = STATE(381),
    [sym_await] = STATE(721),
    [sym_identifier] = ACTIONS(387),
    [anon_sym_LPAREN] = ACTIONS(389),
    [anon_sym_STAR] = ACTIONS(463),
    [anon_sym_print] = ACTIONS(393),
    [anon_sym_exec] = ACTIONS(393),
    [anon_sym_not] = ACTIONS(361),
    [anon_sym_PLUS] = ACTIONS(363),
    [anon_sym_DASH] = ACTIONS(363),
    [anon_sym_TILDE] = ACTIONS(363),
    [anon_sym_lambda] = ACTIONS(365),
    [anon_sym_LBRACK] = ACTIONS(367),
    [sym_ellipsis] = ACTIONS(369),
    [anon_sym_LBRACE] = ACTIONS(371),
    [anon_sym_RBRACE] = ACTIONS(730),
    [sym_integer] = ACTIONS(373),
    [sym_float] = ACTIONS(369),
    [sym_true] = ACTIONS(373),
    [sym_false] = ACTIONS(373),
    [sym_none] = ACTIONS(373),
    [anon_sym_await] = ACTIONS(375),
    [sym_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(377),
  },
  [205] = {
    [sym_named_expression] = STATE(719),
    [sym__expression] = STATE(719),
    [sym__primary_expression] = STATE(383),
    [sym_not_operator] = STATE(719),
    [sym_boolean_operator] = STATE(719),
    [sym_binary_operator] = STATE(383),
    [sym_unary_operator] = STATE(383),
    [sym_comparison_operator] = STATE(719),
    [sym_lambda] = STATE(719),
    [sym_attribute] = STATE(383),
    [sym_subscript] = STATE(383),
    [sym_call] = STATE(383),
    [sym_list] = STATE(383),
    [sym_list_comprehension] = STATE(383),
    [sym_dictionary] = STATE(383),
    [sym_dictionary_comprehension] = STATE(383),
    [sym_set] = STATE(383),
    [sym_set_comprehension] = STATE(383),
    [sym_parenthesized_expression] = STATE(383),
    [sym_tuple] = STATE(383),
    [sym_generator_expression] = STATE(383),
    [sym_conditional_expression] = STATE(719),
    [sym_concatenated_string] = STATE(383),
    [sym_string] = STATE(381),
    [sym_await] = STATE(719),
    [sym_identifier] = ACTIONS(387),
    [anon_sym_LPAREN] = ACTIONS(389),
    [anon_sym_RPAREN] = ACTIONS(335),
    [anon_sym_COMMA] = ACTIONS(335),
    [anon_sym_print] = ACTIONS(393),
    [anon_sym_COLON] = ACTIONS(335),
    [anon_sym_exec] = ACTIONS(393),
    [anon_sym_not] = ACTIONS(361),
    [anon_sym_PLUS] = ACTIONS(363),
    [anon_sym_DASH] = ACTIONS(363),
    [anon_sym_TILDE] = ACTIONS(363),
    [anon_sym_lambda] = ACTIONS(365),
    [anon_sym_LBRACK] = ACTIONS(367),
    [sym_ellipsis] = ACTIONS(369),
    [anon_sym_LBRACE] = ACTIONS(371),
    [sym_integer] = ACTIONS(373),
    [sym_float] = ACTIONS(369),
    [sym_true] = ACTIONS(373),
    [sym_false] = ACTIONS(373),
    [sym_none] = ACTIONS(373),
    [anon_sym_await] = ACTIONS(375),
    [sym_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(377),
  },
  [206] = {
    [sym_named_expression] = STATE(721),
    [sym_list_splat] = STATE(812),
    [sym__expression] = STATE(721),
    [sym__primary_expression] = STATE(383),
    [sym_not_operator] = STATE(721),
    [sym_boolean_operator] = STATE(721),
    [sym_binary_operator] = STATE(383),
    [sym_unary_operator] = STATE(383),
    [sym_comparison_operator] = STATE(721),
    [sym_lambda] = STATE(721),
    [sym_attribute] = STATE(383),
    [sym_subscript] = STATE(383),
    [sym_call] = STATE(383),
    [sym_list] = STATE(383),
    [sym_list_comprehension] = STATE(383),
    [sym_dictionary] = STATE(383),
    [sym_dictionary_comprehension] = STATE(383),
    [sym_set] = STATE(383),
    [sym_set_comprehension] = STATE(383),
    [sym_parenthesized_expression] = STATE(383),
    [sym_tuple] = STATE(383),
    [sym_generator_expression] = STATE(383),
    [sym_conditional_expression] = STATE(721),
    [sym_concatenated_string] = STATE(383),
    [sym_string] = STATE(381),
    [sym_await] = STATE(721),
    [sym_identifier] = ACTIONS(387),
    [anon_sym_LPAREN] = ACTIONS(389),
    [anon_sym_STAR] = ACTIONS(463),
    [anon_sym_print] = ACTIONS(393),
    [anon_sym_exec] = ACTIONS(393),
    [anon_sym_not] = ACTIONS(361),
    [anon_sym_PLUS] = ACTIONS(363),
    [anon_sym_DASH] = ACTIONS(363),
    [anon_sym_TILDE] = ACTIONS(363),
    [anon_sym_lambda] = ACTIONS(365),
    [anon_sym_LBRACK] = ACTIONS(367),
    [sym_ellipsis] = ACTIONS(369),
    [anon_sym_LBRACE] = ACTIONS(371),
    [anon_sym_RBRACE] = ACTIONS(732),
    [sym_integer] = ACTIONS(373),
    [sym_float] = ACTIONS(369),
    [sym_true] = ACTIONS(373),
    [sym_false] = ACTIONS(373),
    [sym_none] = ACTIONS(373),
    [anon_sym_await] = ACTIONS(375),
    [sym_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(377),
  },
  [207] = {
    [sym_named_expression] = STATE(719),
    [sym__expression] = STATE(719),
    [sym__primary_expression] = STATE(383),
    [sym_not_operator] = STATE(719),
    [sym_boolean_operator] = STATE(719),
    [sym_binary_operator] = STATE(383),
    [sym_unary_operator] = STATE(383),
    [sym_comparison_operator] = STATE(719),
    [sym_lambda] = STATE(719),
    [sym_attribute] = STATE(383),
    [sym_subscript] = STATE(383),
    [sym_call] = STATE(383),
    [sym_list] = STATE(383),
    [sym_list_comprehension] = STATE(383),
    [sym_dictionary] = STATE(383),
    [sym_dictionary_comprehension] = STATE(383),
    [sym_set] = STATE(383),
    [sym_set_comprehension] = STATE(383),
    [sym_parenthesized_expression] = STATE(383),
    [sym_tuple] = STATE(383),
    [sym_generator_expression] = STATE(383),
    [sym_conditional_expression] = STATE(719),
    [sym_concatenated_string] = STATE(383),
    [sym_string] = STATE(381),
    [sym_await] = STATE(719),
    [sym_identifier] = ACTIONS(387),
    [anon_sym_LPAREN] = ACTIONS(389),
    [anon_sym_RPAREN] = ACTIONS(341),
    [anon_sym_COMMA] = ACTIONS(341),
    [anon_sym_print] = ACTIONS(393),
    [anon_sym_COLON] = ACTIONS(341),
    [anon_sym_exec] = ACTIONS(393),
    [anon_sym_not] = ACTIONS(361),
    [anon_sym_PLUS] = ACTIONS(363),
    [anon_sym_DASH] = ACTIONS(363),
    [anon_sym_TILDE] = ACTIONS(363),
    [anon_sym_lambda] = ACTIONS(365),
    [anon_sym_LBRACK] = ACTIONS(367),
    [sym_ellipsis] = ACTIONS(369),
    [anon_sym_LBRACE] = ACTIONS(371),
    [sym_integer] = ACTIONS(373),
    [sym_float] = ACTIONS(369),
    [sym_true] = ACTIONS(373),
    [sym_false] = ACTIONS(373),
    [sym_none] = ACTIONS(373),
    [anon_sym_await] = ACTIONS(375),
    [sym_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(377),
  },
  [208] = {
    [sym_named_expression] = STATE(748),
    [sym__expression] = STATE(748),
    [sym__primary_expression] = STATE(383),
    [sym_not_operator] = STATE(748),
    [sym_boolean_operator] = STATE(748),
    [sym_binary_operator] = STATE(383),
    [sym_unary_operator] = STATE(383),
    [sym_comparison_operator] = STATE(748),
    [sym_lambda] = STATE(748),
    [sym_yield] = STATE(951),
    [sym_attribute] = STATE(383),
    [sym_subscript] = STATE(383),
    [sym_call] = STATE(383),
    [sym_list] = STATE(383),
    [sym_list_comprehension] = STATE(383),
    [sym_dictionary] = STATE(383),
    [sym_dictionary_comprehension] = STATE(383),
    [sym_set] = STATE(383),
    [sym_set_comprehension] = STATE(383),
    [sym_parenthesized_expression] = STATE(383),
    [sym_tuple] = STATE(383),
    [sym_generator_expression] = STATE(383),
    [sym_conditional_expression] = STATE(748),
    [sym_concatenated_string] = STATE(383),
    [sym_string] = STATE(381),
    [sym_await] = STATE(748),
    [sym_identifier] = ACTIONS(387),
    [anon_sym_LPAREN] = ACTIONS(389),
    [anon_sym_RPAREN] = ACTIONS(734),
    [anon_sym_print] = ACTIONS(393),
    [anon_sym_exec] = ACTIONS(393),
    [anon_sym_not] = ACTIONS(361),
    [anon_sym_PLUS] = ACTIONS(363),
    [anon_sym_DASH] = ACTIONS(363),
    [anon_sym_TILDE] = ACTIONS(363),
    [anon_sym_lambda] = ACTIONS(365),
    [anon_sym_yield] = ACTIONS(465),
    [anon_sym_LBRACK] = ACTIONS(367),
    [sym_ellipsis] = ACTIONS(369),
    [anon_sym_LBRACE] = ACTIONS(371),
    [sym_integer] = ACTIONS(373),
    [sym_float] = ACTIONS(369),
    [sym_true] = ACTIONS(373),
    [sym_false] = ACTIONS(373),
    [sym_none] = ACTIONS(373),
    [anon_sym_await] = ACTIONS(375),
    [sym_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(377),
  },
  [209] = {
    [sym_named_expression] = STATE(721),
    [sym_list_splat] = STATE(812),
    [sym__expression] = STATE(721),
    [sym__primary_expression] = STATE(383),
    [sym_not_operator] = STATE(721),
    [sym_boolean_operator] = STATE(721),
    [sym_binary_operator] = STATE(383),
    [sym_unary_operator] = STATE(383),
    [sym_comparison_operator] = STATE(721),
    [sym_lambda] = STATE(721),
    [sym_attribute] = STATE(383),
    [sym_subscript] = STATE(383),
    [sym_call] = STATE(383),
    [sym_list] = STATE(383),
    [sym_list_comprehension] = STATE(383),
    [sym_dictionary] = STATE(383),
    [sym_dictionary_comprehension] = STATE(383),
    [sym_set] = STATE(383),
    [sym_set_comprehension] = STATE(383),
    [sym_parenthesized_expression] = STATE(383),
    [sym_tuple] = STATE(383),
    [sym_generator_expression] = STATE(383),
    [sym_conditional_expression] = STATE(721),
    [sym_concatenated_string] = STATE(383),
    [sym_string] = STATE(381),
    [sym_await] = STATE(721),
    [sym_identifier] = ACTIONS(387),
    [anon_sym_LPAREN] = ACTIONS(389),
    [anon_sym_STAR] = ACTIONS(463),
    [anon_sym_print] = ACTIONS(393),
    [anon_sym_exec] = ACTIONS(393),
    [anon_sym_not] = ACTIONS(361),
    [anon_sym_PLUS] = ACTIONS(363),
    [anon_sym_DASH] = ACTIONS(363),
    [anon_sym_TILDE] = ACTIONS(363),
    [anon_sym_lambda] = ACTIONS(365),
    [anon_sym_LBRACK] = ACTIONS(367),
    [sym_ellipsis] = ACTIONS(369),
    [anon_sym_LBRACE] = ACTIONS(371),
    [anon_sym_RBRACE] = ACTIONS(736),
    [sym_integer] = ACTIONS(373),
    [sym_float] = ACTIONS(369),
    [sym_true] = ACTIONS(373),
    [sym_false] = ACTIONS(373),
    [sym_none] = ACTIONS(373),
    [anon_sym_await] = ACTIONS(375),
    [sym_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(377),
  },
  [210] = {
    [sym_named_expression] = STATE(729),
    [sym__expression] = STATE(729),
    [sym__primary_expression] = STATE(383),
    [sym_not_operator] = STATE(729),
    [sym_boolean_operator] = STATE(729),
    [sym_binary_operator] = STATE(383),
    [sym_unary_operator] = STATE(383),
    [sym_comparison_operator] = STATE(729),
    [sym_lambda] = STATE(729),
    [sym_attribute] = STATE(383),
    [sym_subscript] = STATE(383),
    [sym_slice] = STATE(947),
    [sym_call] = STATE(383),
    [sym_list] = STATE(383),
    [sym_list_comprehension] = STATE(383),
    [sym_dictionary] = STATE(383),
    [sym_dictionary_comprehension] = STATE(383),
    [sym_set] = STATE(383),
    [sym_set_comprehension] = STATE(383),
    [sym_parenthesized_expression] = STATE(383),
    [sym_tuple] = STATE(383),
    [sym_generator_expression] = STATE(383),
    [sym_conditional_expression] = STATE(729),
    [sym_concatenated_string] = STATE(383),
    [sym_string] = STATE(381),
    [sym_await] = STATE(729),
    [sym_identifier] = ACTIONS(387),
    [anon_sym_LPAREN] = ACTIONS(389),
    [anon_sym_print] = ACTIONS(393),
    [anon_sym_COLON] = ACTIONS(700),
    [anon_sym_exec] = ACTIONS(393),
    [anon_sym_not] = ACTIONS(361),
    [anon_sym_PLUS] = ACTIONS(363),
    [anon_sym_DASH] = ACTIONS(363),
    [anon_sym_TILDE] = ACTIONS(363),
    [anon_sym_lambda] = ACTIONS(365),
    [anon_sym_LBRACK] = ACTIONS(367),
    [anon_sym_RBRACK] = ACTIONS(738),
    [sym_ellipsis] = ACTIONS(369),
    [anon_sym_LBRACE] = ACTIONS(371),
    [sym_integer] = ACTIONS(373),
    [sym_float] = ACTIONS(369),
    [sym_true] = ACTIONS(373),
    [sym_false] = ACTIONS(373),
    [sym_none] = ACTIONS(373),
    [anon_sym_await] = ACTIONS(375),
    [sym_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(377),
  },
  [211] = {
    [sym_named_expression] = STATE(668),
    [sym__expression] = STATE(668),
    [sym__primary_expression] = STATE(383),
    [sym_not_operator] = STATE(668),
    [sym_boolean_operator] = STATE(668),
    [sym_binary_operator] = STATE(383),
    [sym_unary_operator] = STATE(383),
    [sym_comparison_operator] = STATE(668),
    [sym_lambda] = STATE(668),
    [sym_attribute] = STATE(383),
    [sym_subscript] = STATE(383),
    [sym_call] = STATE(383),
    [sym_list] = STATE(383),
    [sym_list_comprehension] = STATE(383),
    [sym_dictionary] = STATE(383),
    [sym_dictionary_comprehension] = STATE(383),
    [sym_set] = STATE(383),
    [sym_set_comprehension] = STATE(383),
    [sym_parenthesized_expression] = STATE(383),
    [sym_tuple] = STATE(383),
    [sym_generator_expression] = STATE(383),
    [sym_conditional_expression] = STATE(668),
    [sym_concatenated_string] = STATE(383),
    [sym_string] = STATE(381),
    [sym_await] = STATE(668),
    [aux_sym__parameters_repeat1] = STATE(853),
    [sym_identifier] = ACTIONS(387),
    [anon_sym_LPAREN] = ACTIONS(389),
    [anon_sym_COMMA] = ACTIONS(740),
    [anon_sym_print] = ACTIONS(393),
    [anon_sym_COLON] = ACTIONS(742),
    [anon_sym_exec] = ACTIONS(393),
    [anon_sym_not] = ACTIONS(361),
    [anon_sym_PLUS] = ACTIONS(363),
    [anon_sym_DASH] = ACTIONS(363),
    [anon_sym_TILDE] = ACTIONS(363),
    [anon_sym_lambda] = ACTIONS(365),
    [anon_sym_LBRACK] = ACTIONS(367),
    [sym_ellipsis] = ACTIONS(369),
    [anon_sym_LBRACE] = ACTIONS(371),
    [sym_integer] = ACTIONS(373),
    [sym_float] = ACTIONS(369),
    [sym_true] = ACTIONS(373),
    [sym_false] = ACTIONS(373),
    [sym_none] = ACTIONS(373),
    [anon_sym_await] = ACTIONS(375),
    [sym_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(377),
  },
  [212] = {
    [sym_named_expression] = STATE(768),
    [sym_dictionary_splat] = STATE(918),
    [sym__expression] = STATE(768),
    [sym__primary_expression] = STATE(383),
    [sym_not_operator] = STATE(768),
    [sym_boolean_operator] = STATE(768),
    [sym_binary_operator] = STATE(383),
    [sym_unary_operator] = STATE(383),
    [sym_comparison_operator] = STATE(768),
    [sym_lambda] = STATE(768),
    [sym_attribute] = STATE(383),
    [sym_subscript] = STATE(383),
    [sym_call] = STATE(383),
    [sym_list] = STATE(383),
    [sym_list_comprehension] = STATE(383),
    [sym_dictionary] = STATE(383),
    [sym_dictionary_comprehension] = STATE(383),
    [sym_pair] = STATE(918),
    [sym_set] = STATE(383),
    [sym_set_comprehension] = STATE(383),
    [sym_parenthesized_expression] = STATE(383),
    [sym_tuple] = STATE(383),
    [sym_generator_expression] = STATE(383),
    [sym_conditional_expression] = STATE(768),
    [sym_concatenated_string] = STATE(383),
    [sym_string] = STATE(381),
    [sym_await] = STATE(768),
    [sym_identifier] = ACTIONS(387),
    [anon_sym_LPAREN] = ACTIONS(389),
    [anon_sym_print] = ACTIONS(393),
    [anon_sym_STAR_STAR] = ACTIONS(359),
    [anon_sym_exec] = ACTIONS(393),
    [anon_sym_not] = ACTIONS(361),
    [anon_sym_PLUS] = ACTIONS(363),
    [anon_sym_DASH] = ACTIONS(363),
    [anon_sym_TILDE] = ACTIONS(363),
    [anon_sym_lambda] = ACTIONS(365),
    [anon_sym_LBRACK] = ACTIONS(367),
    [sym_ellipsis] = ACTIONS(369),
    [anon_sym_LBRACE] = ACTIONS(371),
    [sym_integer] = ACTIONS(373),
    [sym_float] = ACTIONS(369),
    [sym_true] = ACTIONS(373),
    [sym_false] = ACTIONS(373),
    [sym_none] = ACTIONS(373),
    [anon_sym_await] = ACTIONS(375),
    [sym_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(377),
  },
  [213] = {
    [sym_named_expression] = STATE(748),
    [sym__expression] = STATE(748),
    [sym__primary_expression] = STATE(383),
    [sym_not_operator] = STATE(748),
    [sym_boolean_operator] = STATE(748),
    [sym_binary_operator] = STATE(383),
    [sym_unary_operator] = STATE(383),
    [sym_comparison_operator] = STATE(748),
    [sym_lambda] = STATE(748),
    [sym_yield] = STATE(951),
    [sym_attribute] = STATE(383),
    [sym_subscript] = STATE(383),
    [sym_call] = STATE(383),
    [sym_list] = STATE(383),
    [sym_list_comprehension] = STATE(383),
    [sym_dictionary] = STATE(383),
    [sym_dictionary_comprehension] = STATE(383),
    [sym_set] = STATE(383),
    [sym_set_comprehension] = STATE(383),
    [sym_parenthesized_expression] = STATE(383),
    [sym_tuple] = STATE(383),
    [sym_generator_expression] = STATE(383),
    [sym_conditional_expression] = STATE(748),
    [sym_concatenated_string] = STATE(383),
    [sym_string] = STATE(381),
    [sym_await] = STATE(748),
    [sym_identifier] = ACTIONS(387),
    [anon_sym_LPAREN] = ACTIONS(389),
    [anon_sym_RPAREN] = ACTIONS(744),
    [anon_sym_print] = ACTIONS(393),
    [anon_sym_exec] = ACTIONS(393),
    [anon_sym_not] = ACTIONS(361),
    [anon_sym_PLUS] = ACTIONS(363),
    [anon_sym_DASH] = ACTIONS(363),
    [anon_sym_TILDE] = ACTIONS(363),
    [anon_sym_lambda] = ACTIONS(365),
    [anon_sym_yield] = ACTIONS(465),
    [anon_sym_LBRACK] = ACTIONS(367),
    [sym_ellipsis] = ACTIONS(369),
    [anon_sym_LBRACE] = ACTIONS(371),
    [sym_integer] = ACTIONS(373),
    [sym_float] = ACTIONS(369),
    [sym_true] = ACTIONS(373),
    [sym_false] = ACTIONS(373),
    [sym_none] = ACTIONS(373),
    [anon_sym_await] = ACTIONS(375),
    [sym_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(377),
  },
  [214] = {
    [sym_named_expression] = STATE(668),
    [sym__expression] = STATE(668),
    [sym__primary_expression] = STATE(383),
    [sym_not_operator] = STATE(668),
    [sym_boolean_operator] = STATE(668),
    [sym_binary_operator] = STATE(383),
    [sym_unary_operator] = STATE(383),
    [sym_comparison_operator] = STATE(668),
    [sym_lambda] = STATE(668),
    [sym_attribute] = STATE(383),
    [sym_subscript] = STATE(383),
    [sym_call] = STATE(383),
    [sym_list] = STATE(383),
    [sym_list_comprehension] = STATE(383),
    [sym_dictionary] = STATE(383),
    [sym_dictionary_comprehension] = STATE(383),
    [sym_set] = STATE(383),
    [sym_set_comprehension] = STATE(383),
    [sym_parenthesized_expression] = STATE(383),
    [sym_tuple] = STATE(383),
    [sym_generator_expression] = STATE(383),
    [sym_conditional_expression] = STATE(668),
    [sym_concatenated_string] = STATE(383),
    [sym_string] = STATE(381),
    [sym_await] = STATE(668),
    [aux_sym__parameters_repeat1] = STATE(860),
    [sym_identifier] = ACTIONS(387),
    [anon_sym_LPAREN] = ACTIONS(389),
    [anon_sym_RPAREN] = ACTIONS(742),
    [anon_sym_COMMA] = ACTIONS(746),
    [anon_sym_print] = ACTIONS(393),
    [anon_sym_exec] = ACTIONS(393),
    [anon_sym_not] = ACTIONS(361),
    [anon_sym_PLUS] = ACTIONS(363),
    [anon_sym_DASH] = ACTIONS(363),
    [anon_sym_TILDE] = ACTIONS(363),
    [anon_sym_lambda] = ACTIONS(365),
    [anon_sym_LBRACK] = ACTIONS(367),
    [sym_ellipsis] = ACTIONS(369),
    [anon_sym_LBRACE] = ACTIONS(371),
    [sym_integer] = ACTIONS(373),
    [sym_float] = ACTIONS(369),
    [sym_true] = ACTIONS(373),
    [sym_false] = ACTIONS(373),
    [sym_none] = ACTIONS(373),
    [anon_sym_await] = ACTIONS(375),
    [sym_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(377),
  },
  [215] = {
    [sym_named_expression] = STATE(729),
    [sym__expression] = STATE(729),
    [sym__primary_expression] = STATE(383),
    [sym_not_operator] = STATE(729),
    [sym_boolean_operator] = STATE(729),
    [sym_binary_operator] = STATE(383),
    [sym_unary_operator] = STATE(383),
    [sym_comparison_operator] = STATE(729),
    [sym_lambda] = STATE(729),
    [sym_attribute] = STATE(383),
    [sym_subscript] = STATE(383),
    [sym_slice] = STATE(947),
    [sym_call] = STATE(383),
    [sym_list] = STATE(383),
    [sym_list_comprehension] = STATE(383),
    [sym_dictionary] = STATE(383),
    [sym_dictionary_comprehension] = STATE(383),
    [sym_set] = STATE(383),
    [sym_set_comprehension] = STATE(383),
    [sym_parenthesized_expression] = STATE(383),
    [sym_tuple] = STATE(383),
    [sym_generator_expression] = STATE(383),
    [sym_conditional_expression] = STATE(729),
    [sym_concatenated_string] = STATE(383),
    [sym_string] = STATE(381),
    [sym_await] = STATE(729),
    [sym_identifier] = ACTIONS(387),
    [anon_sym_LPAREN] = ACTIONS(389),
    [anon_sym_print] = ACTIONS(393),
    [anon_sym_COLON] = ACTIONS(700),
    [anon_sym_exec] = ACTIONS(393),
    [anon_sym_not] = ACTIONS(361),
    [anon_sym_PLUS] = ACTIONS(363),
    [anon_sym_DASH] = ACTIONS(363),
    [anon_sym_TILDE] = ACTIONS(363),
    [anon_sym_lambda] = ACTIONS(365),
    [anon_sym_LBRACK] = ACTIONS(367),
    [anon_sym_RBRACK] = ACTIONS(748),
    [sym_ellipsis] = ACTIONS(369),
    [anon_sym_LBRACE] = ACTIONS(371),
    [sym_integer] = ACTIONS(373),
    [sym_float] = ACTIONS(369),
    [sym_true] = ACTIONS(373),
    [sym_false] = ACTIONS(373),
    [sym_none] = ACTIONS(373),
    [anon_sym_await] = ACTIONS(375),
    [sym_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(377),
  },
  [216] = {
    [sym_named_expression] = STATE(729),
    [sym__expression] = STATE(729),
    [sym__primary_expression] = STATE(383),
    [sym_not_operator] = STATE(729),
    [sym_boolean_operator] = STATE(729),
    [sym_binary_operator] = STATE(383),
    [sym_unary_operator] = STATE(383),
    [sym_comparison_operator] = STATE(729),
    [sym_lambda] = STATE(729),
    [sym_attribute] = STATE(383),
    [sym_subscript] = STATE(383),
    [sym_slice] = STATE(947),
    [sym_call] = STATE(383),
    [sym_list] = STATE(383),
    [sym_list_comprehension] = STATE(383),
    [sym_dictionary] = STATE(383),
    [sym_dictionary_comprehension] = STATE(383),
    [sym_set] = STATE(383),
    [sym_set_comprehension] = STATE(383),
    [sym_parenthesized_expression] = STATE(383),
    [sym_tuple] = STATE(383),
    [sym_generator_expression] = STATE(383),
    [sym_conditional_expression] = STATE(729),
    [sym_concatenated_string] = STATE(383),
    [sym_string] = STATE(381),
    [sym_await] = STATE(729),
    [sym_identifier] = ACTIONS(387),
    [anon_sym_LPAREN] = ACTIONS(389),
    [anon_sym_print] = ACTIONS(393),
    [anon_sym_COLON] = ACTIONS(700),
    [anon_sym_exec] = ACTIONS(393),
    [anon_sym_not] = ACTIONS(361),
    [anon_sym_PLUS] = ACTIONS(363),
    [anon_sym_DASH] = ACTIONS(363),
    [anon_sym_TILDE] = ACTIONS(363),
    [anon_sym_lambda] = ACTIONS(365),
    [anon_sym_LBRACK] = ACTIONS(367),
    [anon_sym_RBRACK] = ACTIONS(750),
    [sym_ellipsis] = ACTIONS(369),
    [anon_sym_LBRACE] = ACTIONS(371),
    [sym_integer] = ACTIONS(373),
    [sym_float] = ACTIONS(369),
    [sym_true] = ACTIONS(373),
    [sym_false] = ACTIONS(373),
    [sym_none] = ACTIONS(373),
    [anon_sym_await] = ACTIONS(375),
    [sym_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(377),
  },
  [217] = {
    [sym_named_expression] = STATE(721),
    [sym_list_splat] = STATE(812),
    [sym__expression] = STATE(721),
    [sym__primary_expression] = STATE(383),
    [sym_not_operator] = STATE(721),
    [sym_boolean_operator] = STATE(721),
    [sym_binary_operator] = STATE(383),
    [sym_unary_operator] = STATE(383),
    [sym_comparison_operator] = STATE(721),
    [sym_lambda] = STATE(721),
    [sym_attribute] = STATE(383),
    [sym_subscript] = STATE(383),
    [sym_call] = STATE(383),
    [sym_list] = STATE(383),
    [sym_list_comprehension] = STATE(383),
    [sym_dictionary] = STATE(383),
    [sym_dictionary_comprehension] = STATE(383),
    [sym_set] = STATE(383),
    [sym_set_comprehension] = STATE(383),
    [sym_parenthesized_expression] = STATE(383),
    [sym_tuple] = STATE(383),
    [sym_generator_expression] = STATE(383),
    [sym_conditional_expression] = STATE(721),
    [sym_concatenated_string] = STATE(383),
    [sym_string] = STATE(381),
    [sym_await] = STATE(721),
    [sym_identifier] = ACTIONS(387),
    [anon_sym_LPAREN] = ACTIONS(389),
    [anon_sym_STAR] = ACTIONS(463),
    [anon_sym_print] = ACTIONS(393),
    [anon_sym_exec] = ACTIONS(393),
    [anon_sym_not] = ACTIONS(361),
    [anon_sym_PLUS] = ACTIONS(363),
    [anon_sym_DASH] = ACTIONS(363),
    [anon_sym_TILDE] = ACTIONS(363),
    [anon_sym_lambda] = ACTIONS(365),
    [anon_sym_LBRACK] = ACTIONS(367),
    [sym_ellipsis] = ACTIONS(369),
    [anon_sym_LBRACE] = ACTIONS(371),
    [anon_sym_RBRACE] = ACTIONS(752),
    [sym_integer] = ACTIONS(373),
    [sym_float] = ACTIONS(369),
    [sym_true] = ACTIONS(373),
    [sym_false] = ACTIONS(373),
    [sym_none] = ACTIONS(373),
    [anon_sym_await] = ACTIONS(375),
    [sym_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(377),
  },
  [218] = {
    [sym_named_expression] = STATE(748),
    [sym__expression] = STATE(748),
    [sym__primary_expression] = STATE(383),
    [sym_not_operator] = STATE(748),
    [sym_boolean_operator] = STATE(748),
    [sym_binary_operator] = STATE(383),
    [sym_unary_operator] = STATE(383),
    [sym_comparison_operator] = STATE(748),
    [sym_lambda] = STATE(748),
    [sym_yield] = STATE(951),
    [sym_attribute] = STATE(383),
    [sym_subscript] = STATE(383),
    [sym_call] = STATE(383),
    [sym_list] = STATE(383),
    [sym_list_comprehension] = STATE(383),
    [sym_dictionary] = STATE(383),
    [sym_dictionary_comprehension] = STATE(383),
    [sym_set] = STATE(383),
    [sym_set_comprehension] = STATE(383),
    [sym_parenthesized_expression] = STATE(383),
    [sym_tuple] = STATE(383),
    [sym_generator_expression] = STATE(383),
    [sym_conditional_expression] = STATE(748),
    [sym_concatenated_string] = STATE(383),
    [sym_string] = STATE(381),
    [sym_await] = STATE(748),
    [sym_identifier] = ACTIONS(387),
    [anon_sym_LPAREN] = ACTIONS(389),
    [anon_sym_RPAREN] = ACTIONS(754),
    [anon_sym_print] = ACTIONS(393),
    [anon_sym_exec] = ACTIONS(393),
    [anon_sym_not] = ACTIONS(361),
    [anon_sym_PLUS] = ACTIONS(363),
    [anon_sym_DASH] = ACTIONS(363),
    [anon_sym_TILDE] = ACTIONS(363),
    [anon_sym_lambda] = ACTIONS(365),
    [anon_sym_yield] = ACTIONS(465),
    [anon_sym_LBRACK] = ACTIONS(367),
    [sym_ellipsis] = ACTIONS(369),
    [anon_sym_LBRACE] = ACTIONS(371),
    [sym_integer] = ACTIONS(373),
    [sym_float] = ACTIONS(369),
    [sym_true] = ACTIONS(373),
    [sym_false] = ACTIONS(373),
    [sym_none] = ACTIONS(373),
    [anon_sym_await] = ACTIONS(375),
    [sym_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(377),
  },
  [219] = {
    [sym_named_expression] = STATE(721),
    [sym_list_splat] = STATE(812),
    [sym__expression] = STATE(721),
    [sym__primary_expression] = STATE(383),
    [sym_not_operator] = STATE(721),
    [sym_boolean_operator] = STATE(721),
    [sym_binary_operator] = STATE(383),
    [sym_unary_operator] = STATE(383),
    [sym_comparison_operator] = STATE(721),
    [sym_lambda] = STATE(721),
    [sym_attribute] = STATE(383),
    [sym_subscript] = STATE(383),
    [sym_call] = STATE(383),
    [sym_list] = STATE(383),
    [sym_list_comprehension] = STATE(383),
    [sym_dictionary] = STATE(383),
    [sym_dictionary_comprehension] = STATE(383),
    [sym_set] = STATE(383),
    [sym_set_comprehension] = STATE(383),
    [sym_parenthesized_expression] = STATE(383),
    [sym_tuple] = STATE(383),
    [sym_generator_expression] = STATE(383),
    [sym_conditional_expression] = STATE(721),
    [sym_concatenated_string] = STATE(383),
    [sym_string] = STATE(381),
    [sym_await] = STATE(721),
    [sym_identifier] = ACTIONS(387),
    [anon_sym_LPAREN] = ACTIONS(389),
    [anon_sym_STAR] = ACTIONS(463),
    [anon_sym_print] = ACTIONS(393),
    [anon_sym_exec] = ACTIONS(393),
    [anon_sym_not] = ACTIONS(361),
    [anon_sym_PLUS] = ACTIONS(363),
    [anon_sym_DASH] = ACTIONS(363),
    [anon_sym_TILDE] = ACTIONS(363),
    [anon_sym_lambda] = ACTIONS(365),
    [anon_sym_LBRACK] = ACTIONS(367),
    [anon_sym_RBRACK] = ACTIONS(756),
    [sym_ellipsis] = ACTIONS(369),
    [anon_sym_LBRACE] = ACTIONS(371),
    [sym_integer] = ACTIONS(373),
    [sym_float] = ACTIONS(369),
    [sym_true] = ACTIONS(373),
    [sym_false] = ACTIONS(373),
    [sym_none] = ACTIONS(373),
    [anon_sym_await] = ACTIONS(375),
    [sym_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(377),
  },
  [220] = {
    [sym_named_expression] = STATE(748),
    [sym__expression] = STATE(748),
    [sym__primary_expression] = STATE(383),
    [sym_not_operator] = STATE(748),
    [sym_boolean_operator] = STATE(748),
    [sym_binary_operator] = STATE(383),
    [sym_unary_operator] = STATE(383),
    [sym_comparison_operator] = STATE(748),
    [sym_lambda] = STATE(748),
    [sym_yield] = STATE(951),
    [sym_attribute] = STATE(383),
    [sym_subscript] = STATE(383),
    [sym_call] = STATE(383),
    [sym_list] = STATE(383),
    [sym_list_comprehension] = STATE(383),
    [sym_dictionary] = STATE(383),
    [sym_dictionary_comprehension] = STATE(383),
    [sym_set] = STATE(383),
    [sym_set_comprehension] = STATE(383),
    [sym_parenthesized_expression] = STATE(383),
    [sym_tuple] = STATE(383),
    [sym_generator_expression] = STATE(383),
    [sym_conditional_expression] = STATE(748),
    [sym_concatenated_string] = STATE(383),
    [sym_string] = STATE(381),
    [sym_await] = STATE(748),
    [sym_identifier] = ACTIONS(387),
    [anon_sym_LPAREN] = ACTIONS(389),
    [anon_sym_RPAREN] = ACTIONS(758),
    [anon_sym_print] = ACTIONS(393),
    [anon_sym_exec] = ACTIONS(393),
    [anon_sym_not] = ACTIONS(361),
    [anon_sym_PLUS] = ACTIONS(363),
    [anon_sym_DASH] = ACTIONS(363),
    [anon_sym_TILDE] = ACTIONS(363),
    [anon_sym_lambda] = ACTIONS(365),
    [anon_sym_yield] = ACTIONS(465),
    [anon_sym_LBRACK] = ACTIONS(367),
    [sym_ellipsis] = ACTIONS(369),
    [anon_sym_LBRACE] = ACTIONS(371),
    [sym_integer] = ACTIONS(373),
    [sym_float] = ACTIONS(369),
    [sym_true] = ACTIONS(373),
    [sym_false] = ACTIONS(373),
    [sym_none] = ACTIONS(373),
    [anon_sym_await] = ACTIONS(375),
    [sym_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(377),
  },
  [221] = {
    [sym_named_expression] = STATE(721),
    [sym_list_splat] = STATE(812),
    [sym__expression] = STATE(721),
    [sym__primary_expression] = STATE(383),
    [sym_not_operator] = STATE(721),
    [sym_boolean_operator] = STATE(721),
    [sym_binary_operator] = STATE(383),
    [sym_unary_operator] = STATE(383),
    [sym_comparison_operator] = STATE(721),
    [sym_lambda] = STATE(721),
    [sym_attribute] = STATE(383),
    [sym_subscript] = STATE(383),
    [sym_call] = STATE(383),
    [sym_list] = STATE(383),
    [sym_list_comprehension] = STATE(383),
    [sym_dictionary] = STATE(383),
    [sym_dictionary_comprehension] = STATE(383),
    [sym_set] = STATE(383),
    [sym_set_comprehension] = STATE(383),
    [sym_parenthesized_expression] = STATE(383),
    [sym_tuple] = STATE(383),
    [sym_generator_expression] = STATE(383),
    [sym_conditional_expression] = STATE(721),
    [sym_concatenated_string] = STATE(383),
    [sym_string] = STATE(381),
    [sym_await] = STATE(721),
    [sym_identifier] = ACTIONS(387),
    [anon_sym_LPAREN] = ACTIONS(389),
    [anon_sym_STAR] = ACTIONS(463),
    [anon_sym_print] = ACTIONS(393),
    [anon_sym_exec] = ACTIONS(393),
    [anon_sym_not] = ACTIONS(361),
    [anon_sym_PLUS] = ACTIONS(363),
    [anon_sym_DASH] = ACTIONS(363),
    [anon_sym_TILDE] = ACTIONS(363),
    [anon_sym_lambda] = ACTIONS(365),
    [anon_sym_LBRACK] = ACTIONS(367),
    [anon_sym_RBRACK] = ACTIONS(760),
    [sym_ellipsis] = ACTIONS(369),
    [anon_sym_LBRACE] = ACTIONS(371),
    [sym_integer] = ACTIONS(373),
    [sym_float] = ACTIONS(369),
    [sym_true] = ACTIONS(373),
    [sym_false] = ACTIONS(373),
    [sym_none] = ACTIONS(373),
    [anon_sym_await] = ACTIONS(375),
    [sym_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(377),
  },
  [222] = {
    [sym_named_expression] = STATE(721),
    [sym_list_splat] = STATE(812),
    [sym__expression] = STATE(721),
    [sym__primary_expression] = STATE(383),
    [sym_not_operator] = STATE(721),
    [sym_boolean_operator] = STATE(721),
    [sym_binary_operator] = STATE(383),
    [sym_unary_operator] = STATE(383),
    [sym_comparison_operator] = STATE(721),
    [sym_lambda] = STATE(721),
    [sym_attribute] = STATE(383),
    [sym_subscript] = STATE(383),
    [sym_call] = STATE(383),
    [sym_list] = STATE(383),
    [sym_list_comprehension] = STATE(383),
    [sym_dictionary] = STATE(383),
    [sym_dictionary_comprehension] = STATE(383),
    [sym_set] = STATE(383),
    [sym_set_comprehension] = STATE(383),
    [sym_parenthesized_expression] = STATE(383),
    [sym_tuple] = STATE(383),
    [sym_generator_expression] = STATE(383),
    [sym_conditional_expression] = STATE(721),
    [sym_concatenated_string] = STATE(383),
    [sym_string] = STATE(381),
    [sym_await] = STATE(721),
    [sym_identifier] = ACTIONS(387),
    [anon_sym_LPAREN] = ACTIONS(389),
    [anon_sym_STAR] = ACTIONS(463),
    [anon_sym_print] = ACTIONS(393),
    [anon_sym_exec] = ACTIONS(393),
    [anon_sym_not] = ACTIONS(361),
    [anon_sym_PLUS] = ACTIONS(363),
    [anon_sym_DASH] = ACTIONS(363),
    [anon_sym_TILDE] = ACTIONS(363),
    [anon_sym_lambda] = ACTIONS(365),
    [anon_sym_LBRACK] = ACTIONS(367),
    [sym_ellipsis] = ACTIONS(369),
    [anon_sym_LBRACE] = ACTIONS(371),
    [anon_sym_RBRACE] = ACTIONS(762),
    [sym_integer] = ACTIONS(373),
    [sym_float] = ACTIONS(369),
    [sym_true] = ACTIONS(373),
    [sym_false] = ACTIONS(373),
    [sym_none] = ACTIONS(373),
    [anon_sym_await] = ACTIONS(375),
    [sym_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(377),
  },
  [223] = {
    [sym_named_expression] = STATE(721),
    [sym_list_splat] = STATE(812),
    [sym__expression] = STATE(721),
    [sym__primary_expression] = STATE(383),
    [sym_not_operator] = STATE(721),
    [sym_boolean_operator] = STATE(721),
    [sym_binary_operator] = STATE(383),
    [sym_unary_operator] = STATE(383),
    [sym_comparison_operator] = STATE(721),
    [sym_lambda] = STATE(721),
    [sym_attribute] = STATE(383),
    [sym_subscript] = STATE(383),
    [sym_call] = STATE(383),
    [sym_list] = STATE(383),
    [sym_list_comprehension] = STATE(383),
    [sym_dictionary] = STATE(383),
    [sym_dictionary_comprehension] = STATE(383),
    [sym_set] = STATE(383),
    [sym_set_comprehension] = STATE(383),
    [sym_parenthesized_expression] = STATE(383),
    [sym_tuple] = STATE(383),
    [sym_generator_expression] = STATE(383),
    [sym_conditional_expression] = STATE(721),
    [sym_concatenated_string] = STATE(383),
    [sym_string] = STATE(381),
    [sym_await] = STATE(721),
    [sym_identifier] = ACTIONS(387),
    [anon_sym_LPAREN] = ACTIONS(389),
    [anon_sym_STAR] = ACTIONS(463),
    [anon_sym_print] = ACTIONS(393),
    [anon_sym_exec] = ACTIONS(393),
    [anon_sym_not] = ACTIONS(361),
    [anon_sym_PLUS] = ACTIONS(363),
    [anon_sym_DASH] = ACTIONS(363),
    [anon_sym_TILDE] = ACTIONS(363),
    [anon_sym_lambda] = ACTIONS(365),
    [anon_sym_LBRACK] = ACTIONS(367),
    [sym_ellipsis] = ACTIONS(369),
    [anon_sym_LBRACE] = ACTIONS(371),
    [anon_sym_RBRACE] = ACTIONS(764),
    [sym_integer] = ACTIONS(373),
    [sym_float] = ACTIONS(369),
    [sym_true] = ACTIONS(373),
    [sym_false] = ACTIONS(373),
    [sym_none] = ACTIONS(373),
    [anon_sym_await] = ACTIONS(375),
    [sym_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(377),
  },
  [224] = {
    [sym_named_expression] = STATE(721),
    [sym_list_splat] = STATE(812),
    [sym__expression] = STATE(721),
    [sym__primary_expression] = STATE(383),
    [sym_not_operator] = STATE(721),
    [sym_boolean_operator] = STATE(721),
    [sym_binary_operator] = STATE(383),
    [sym_unary_operator] = STATE(383),
    [sym_comparison_operator] = STATE(721),
    [sym_lambda] = STATE(721),
    [sym_attribute] = STATE(383),
    [sym_subscript] = STATE(383),
    [sym_call] = STATE(383),
    [sym_list] = STATE(383),
    [sym_list_comprehension] = STATE(383),
    [sym_dictionary] = STATE(383),
    [sym_dictionary_comprehension] = STATE(383),
    [sym_set] = STATE(383),
    [sym_set_comprehension] = STATE(383),
    [sym_parenthesized_expression] = STATE(383),
    [sym_tuple] = STATE(383),
    [sym_generator_expression] = STATE(383),
    [sym_conditional_expression] = STATE(721),
    [sym_concatenated_string] = STATE(383),
    [sym_string] = STATE(381),
    [sym_await] = STATE(721),
    [sym_identifier] = ACTIONS(387),
    [anon_sym_LPAREN] = ACTIONS(389),
    [anon_sym_STAR] = ACTIONS(463),
    [anon_sym_print] = ACTIONS(393),
    [anon_sym_exec] = ACTIONS(393),
    [anon_sym_not] = ACTIONS(361),
    [anon_sym_PLUS] = ACTIONS(363),
    [anon_sym_DASH] = ACTIONS(363),
    [anon_sym_TILDE] = ACTIONS(363),
    [anon_sym_lambda] = ACTIONS(365),
    [anon_sym_LBRACK] = ACTIONS(367),
    [anon_sym_RBRACK] = ACTIONS(766),
    [sym_ellipsis] = ACTIONS(369),
    [anon_sym_LBRACE] = ACTIONS(371),
    [sym_integer] = ACTIONS(373),
    [sym_float] = ACTIONS(369),
    [sym_true] = ACTIONS(373),
    [sym_false] = ACTIONS(373),
    [sym_none] = ACTIONS(373),
    [anon_sym_await] = ACTIONS(375),
    [sym_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(377),
  },
  [225] = {
    [sym_named_expression] = STATE(662),
    [sym__expression_within_for_in_clause] = STATE(671),
    [sym__expression] = STATE(662),
    [sym__primary_expression] = STATE(383),
    [sym_not_operator] = STATE(662),
    [sym_boolean_operator] = STATE(662),
    [sym_binary_operator] = STATE(383),
    [sym_unary_operator] = STATE(383),
    [sym_comparison_operator] = STATE(662),
    [sym_lambda] = STATE(662),
    [sym_lambda_within_for_in_clause] = STATE(671),
    [sym_attribute] = STATE(383),
    [sym_subscript] = STATE(383),
    [sym_call] = STATE(383),
    [sym_list] = STATE(383),
    [sym_list_comprehension] = STATE(383),
    [sym_dictionary] = STATE(383),
    [sym_dictionary_comprehension] = STATE(383),
    [sym_set] = STATE(383),
    [sym_set_comprehension] = STATE(383),
    [sym_parenthesized_expression] = STATE(383),
    [sym_tuple] = STATE(383),
    [sym_generator_expression] = STATE(383),
    [sym_conditional_expression] = STATE(662),
    [sym_concatenated_string] = STATE(383),
    [sym_string] = STATE(381),
    [sym_await] = STATE(662),
    [sym_identifier] = ACTIONS(387),
    [anon_sym_LPAREN] = ACTIONS(389),
    [anon_sym_print] = ACTIONS(393),
    [anon_sym_exec] = ACTIONS(393),
    [anon_sym_not] = ACTIONS(361),
    [anon_sym_PLUS] = ACTIONS(363),
    [anon_sym_DASH] = ACTIONS(363),
    [anon_sym_TILDE] = ACTIONS(363),
    [anon_sym_lambda] = ACTIONS(397),
    [anon_sym_LBRACK] = ACTIONS(367),
    [sym_ellipsis] = ACTIONS(369),
    [anon_sym_LBRACE] = ACTIONS(371),
    [sym_integer] = ACTIONS(373),
    [sym_float] = ACTIONS(369),
    [sym_true] = ACTIONS(373),
    [sym_false] = ACTIONS(373),
    [sym_none] = ACTIONS(373),
    [anon_sym_await] = ACTIONS(375),
    [sym_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(377),
  },
  [226] = {
    [sym_elif_clause] = STATE(362),
    [sym_else_clause] = STATE(404),
    [aux_sym_if_statement_repeat1] = STATE(234),
    [ts_builtin_sym_end] = ACTIONS(768),
    [sym_identifier] = ACTIONS(770),
    [anon_sym_import] = ACTIONS(770),
    [anon_sym_from] = ACTIONS(770),
    [anon_sym_LPAREN] = ACTIONS(768),
    [anon_sym_print] = ACTIONS(770),
    [anon_sym_assert] = ACTIONS(770),
    [anon_sym_return] = ACTIONS(770),
    [anon_sym_del] = ACTIONS(770),
    [anon_sym_raise] = ACTIONS(770),
    [anon_sym_pass] = ACTIONS(770),
    [anon_sym_break] = ACTIONS(770),
    [anon_sym_continue] = ACTIONS(770),
    [anon_sym_if] = ACTIONS(770),
    [anon_sym_elif] = ACTIONS(772),
    [anon_sym_else] = ACTIONS(548),
    [anon_sym_async] = ACTIONS(770),
    [anon_sym_for] = ACTIONS(770),
    [anon_sym_while] = ACTIONS(770),
    [anon_sym_try] = ACTIONS(770),
    [anon_sym_with] = ACTIONS(770),
    [anon_sym_def] = ACTIONS(770),
    [anon_sym_global] = ACTIONS(770),
    [anon_sym_nonlocal] = ACTIONS(770),
    [anon_sym_exec] = ACTIONS(770),
    [anon_sym_class] = ACTIONS(770),
    [anon_sym_AT] = ACTIONS(768),
    [anon_sym_not] = ACTIONS(770),
    [anon_sym_PLUS] = ACTIONS(768),
    [anon_sym_DASH] = ACTIONS(768),
    [anon_sym_TILDE] = ACTIONS(768),
    [anon_sym_lambda] = ACTIONS(770),
    [anon_sym_yield] = ACTIONS(770),
    [anon_sym_LBRACK] = ACTIONS(768),
    [sym_ellipsis] = ACTIONS(768),
    [anon_sym_LBRACE] = ACTIONS(768),
    [sym_integer] = ACTIONS(770),
    [sym_float] = ACTIONS(768),
    [sym_true] = ACTIONS(770),
    [sym_false] = ACTIONS(770),
    [sym_none] = ACTIONS(770),
    [anon_sym_await] = ACTIONS(770),
    [sym_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(768),
  },
  [227] = {
    [sym_named_expression] = STATE(662),
    [sym__expression_within_for_in_clause] = STATE(676),
    [sym__expression] = STATE(662),
    [sym__primary_expression] = STATE(383),
    [sym_not_operator] = STATE(662),
    [sym_boolean_operator] = STATE(662),
    [sym_binary_operator] = STATE(383),
    [sym_unary_operator] = STATE(383),
    [sym_comparison_operator] = STATE(662),
    [sym_lambda] = STATE(662),
    [sym_lambda_within_for_in_clause] = STATE(676),
    [sym_attribute] = STATE(383),
    [sym_subscript] = STATE(383),
    [sym_call] = STATE(383),
    [sym_list] = STATE(383),
    [sym_list_comprehension] = STATE(383),
    [sym_dictionary] = STATE(383),
    [sym_dictionary_comprehension] = STATE(383),
    [sym_set] = STATE(383),
    [sym_set_comprehension] = STATE(383),
    [sym_parenthesized_expression] = STATE(383),
    [sym_tuple] = STATE(383),
    [sym_generator_expression] = STATE(383),
    [sym_conditional_expression] = STATE(662),
    [sym_concatenated_string] = STATE(383),
    [sym_string] = STATE(381),
    [sym_await] = STATE(662),
    [sym_identifier] = ACTIONS(387),
    [anon_sym_LPAREN] = ACTIONS(389),
    [anon_sym_print] = ACTIONS(393),
    [anon_sym_exec] = ACTIONS(393),
    [anon_sym_not] = ACTIONS(361),
    [anon_sym_PLUS] = ACTIONS(363),
    [anon_sym_DASH] = ACTIONS(363),
    [anon_sym_TILDE] = ACTIONS(363),
    [anon_sym_lambda] = ACTIONS(397),
    [anon_sym_LBRACK] = ACTIONS(367),
    [sym_ellipsis] = ACTIONS(369),
    [anon_sym_LBRACE] = ACTIONS(371),
    [sym_integer] = ACTIONS(373),
    [sym_float] = ACTIONS(369),
    [sym_true] = ACTIONS(373),
    [sym_false] = ACTIONS(373),
    [sym_none] = ACTIONS(373),
    [anon_sym_await] = ACTIONS(375),
    [sym_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(377),
  },
  [228] = {
    [sym_elif_clause] = STATE(365),
    [sym_else_clause] = STATE(416),
    [aux_sym_if_statement_repeat1] = STATE(279),
    [sym_identifier] = ACTIONS(774),
    [anon_sym_import] = ACTIONS(774),
    [anon_sym_from] = ACTIONS(774),
    [anon_sym_LPAREN] = ACTIONS(776),
    [anon_sym_print] = ACTIONS(774),
    [anon_sym_assert] = ACTIONS(774),
    [anon_sym_return] = ACTIONS(774),
    [anon_sym_del] = ACTIONS(774),
    [anon_sym_raise] = ACTIONS(774),
    [anon_sym_pass] = ACTIONS(774),
    [anon_sym_break] = ACTIONS(774),
    [anon_sym_continue] = ACTIONS(774),
    [anon_sym_if] = ACTIONS(774),
    [anon_sym_elif] = ACTIONS(778),
    [anon_sym_else] = ACTIONS(684),
    [anon_sym_async] = ACTIONS(774),
    [anon_sym_for] = ACTIONS(774),
    [anon_sym_while] = ACTIONS(774),
    [anon_sym_try] = ACTIONS(774),
    [anon_sym_with] = ACTIONS(774),
    [anon_sym_def] = ACTIONS(774),
    [anon_sym_global] = ACTIONS(774),
    [anon_sym_nonlocal] = ACTIONS(774),
    [anon_sym_exec] = ACTIONS(774),
    [anon_sym_class] = ACTIONS(774),
    [anon_sym_AT] = ACTIONS(776),
    [anon_sym_not] = ACTIONS(774),
    [anon_sym_PLUS] = ACTIONS(776),
    [anon_sym_DASH] = ACTIONS(776),
    [anon_sym_TILDE] = ACTIONS(776),
    [anon_sym_lambda] = ACTIONS(774),
    [anon_sym_yield] = ACTIONS(774),
    [anon_sym_LBRACK] = ACTIONS(776),
    [sym_ellipsis] = ACTIONS(776),
    [anon_sym_LBRACE] = ACTIONS(776),
    [sym_integer] = ACTIONS(774),
    [sym_float] = ACTIONS(776),
    [sym_true] = ACTIONS(774),
    [sym_false] = ACTIONS(774),
    [sym_none] = ACTIONS(774),
    [anon_sym_await] = ACTIONS(774),
    [sym_comment] = ACTIONS(3),
    [sym__dedent] = ACTIONS(776),
    [sym__string_start] = ACTIONS(776),
  },
  [229] = {
    [sym_named_expression] = STATE(714),
    [sym__expression] = STATE(714),
    [sym__primary_expression] = STATE(109),
    [sym_not_operator] = STATE(714),
    [sym_boolean_operator] = STATE(714),
    [sym_binary_operator] = STATE(109),
    [sym_unary_operator] = STATE(109),
    [sym_comparison_operator] = STATE(714),
    [sym_lambda] = STATE(714),
    [sym_attribute] = STATE(109),
    [sym_subscript] = STATE(109),
    [sym_call] = STATE(109),
    [sym_list] = STATE(109),
    [sym_list_comprehension] = STATE(109),
    [sym_dictionary] = STATE(109),
    [sym_dictionary_comprehension] = STATE(109),
    [sym_set] = STATE(109),
    [sym_set_comprehension] = STATE(109),
    [sym_parenthesized_expression] = STATE(109),
    [sym_tuple] = STATE(109),
    [sym_generator_expression] = STATE(109),
    [sym_conditional_expression] = STATE(714),
    [sym_concatenated_string] = STATE(109),
    [sym_string] = STATE(117),
    [sym_await] = STATE(714),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(13),
    [anon_sym_print] = ACTIONS(237),
    [anon_sym_exec] = ACTIONS(237),
    [anon_sym_not] = ACTIONS(55),
    [anon_sym_PLUS] = ACTIONS(57),
    [anon_sym_DASH] = ACTIONS(57),
    [anon_sym_TILDE] = ACTIONS(57),
    [anon_sym_lambda] = ACTIONS(59),
    [anon_sym_LBRACK] = ACTIONS(63),
    [sym_ellipsis] = ACTIONS(65),
    [anon_sym_LBRACE] = ACTIONS(67),
    [sym_integer] = ACTIONS(69),
    [sym_float] = ACTIONS(65),
    [sym_true] = ACTIONS(69),
    [sym_false] = ACTIONS(69),
    [sym_none] = ACTIONS(69),
    [anon_sym_await] = ACTIONS(71),
    [sym_comment] = ACTIONS(3),
    [sym__semicolon] = ACTIONS(780),
    [sym__newline] = ACTIONS(780),
    [sym__string_start] = ACTIONS(73),
  },
  [230] = {
    [sym_named_expression] = STATE(721),
    [sym_list_splat] = STATE(812),
    [sym__expression] = STATE(721),
    [sym__primary_expression] = STATE(383),
    [sym_not_operator] = STATE(721),
    [sym_boolean_operator] = STATE(721),
    [sym_binary_operator] = STATE(383),
    [sym_unary_operator] = STATE(383),
    [sym_comparison_operator] = STATE(721),
    [sym_lambda] = STATE(721),
    [sym_attribute] = STATE(383),
    [sym_subscript] = STATE(383),
    [sym_call] = STATE(383),
    [sym_list] = STATE(383),
    [sym_list_comprehension] = STATE(383),
    [sym_dictionary] = STATE(383),
    [sym_dictionary_comprehension] = STATE(383),
    [sym_set] = STATE(383),
    [sym_set_comprehension] = STATE(383),
    [sym_parenthesized_expression] = STATE(383),
    [sym_tuple] = STATE(383),
    [sym_generator_expression] = STATE(383),
    [sym_conditional_expression] = STATE(721),
    [sym_concatenated_string] = STATE(383),
    [sym_string] = STATE(381),
    [sym_await] = STATE(721),
    [sym_identifier] = ACTIONS(387),
    [anon_sym_LPAREN] = ACTIONS(389),
    [anon_sym_STAR] = ACTIONS(463),
    [anon_sym_print] = ACTIONS(393),
    [anon_sym_exec] = ACTIONS(393),
    [anon_sym_not] = ACTIONS(361),
    [anon_sym_PLUS] = ACTIONS(363),
    [anon_sym_DASH] = ACTIONS(363),
    [anon_sym_TILDE] = ACTIONS(363),
    [anon_sym_lambda] = ACTIONS(365),
    [anon_sym_LBRACK] = ACTIONS(367),
    [sym_ellipsis] = ACTIONS(369),
    [anon_sym_LBRACE] = ACTIONS(371),
    [sym_integer] = ACTIONS(373),
    [sym_float] = ACTIONS(369),
    [sym_true] = ACTIONS(373),
    [sym_false] = ACTIONS(373),
    [sym_none] = ACTIONS(373),
    [anon_sym_await] = ACTIONS(375),
    [sym_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(377),
  },
  [231] = {
    [sym_named_expression] = STATE(714),
    [sym__expression] = STATE(714),
    [sym__primary_expression] = STATE(109),
    [sym_not_operator] = STATE(714),
    [sym_boolean_operator] = STATE(714),
    [sym_binary_operator] = STATE(109),
    [sym_unary_operator] = STATE(109),
    [sym_comparison_operator] = STATE(714),
    [sym_lambda] = STATE(714),
    [sym_attribute] = STATE(109),
    [sym_subscript] = STATE(109),
    [sym_call] = STATE(109),
    [sym_list] = STATE(109),
    [sym_list_comprehension] = STATE(109),
    [sym_dictionary] = STATE(109),
    [sym_dictionary_comprehension] = STATE(109),
    [sym_set] = STATE(109),
    [sym_set_comprehension] = STATE(109),
    [sym_parenthesized_expression] = STATE(109),
    [sym_tuple] = STATE(109),
    [sym_generator_expression] = STATE(109),
    [sym_conditional_expression] = STATE(714),
    [sym_concatenated_string] = STATE(109),
    [sym_string] = STATE(117),
    [sym_await] = STATE(714),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(13),
    [anon_sym_print] = ACTIONS(237),
    [anon_sym_exec] = ACTIONS(237),
    [anon_sym_not] = ACTIONS(55),
    [anon_sym_PLUS] = ACTIONS(57),
    [anon_sym_DASH] = ACTIONS(57),
    [anon_sym_TILDE] = ACTIONS(57),
    [anon_sym_lambda] = ACTIONS(59),
    [anon_sym_LBRACK] = ACTIONS(63),
    [sym_ellipsis] = ACTIONS(65),
    [anon_sym_LBRACE] = ACTIONS(67),
    [sym_integer] = ACTIONS(69),
    [sym_float] = ACTIONS(65),
    [sym_true] = ACTIONS(69),
    [sym_false] = ACTIONS(69),
    [sym_none] = ACTIONS(69),
    [anon_sym_await] = ACTIONS(71),
    [sym_comment] = ACTIONS(3),
    [sym__semicolon] = ACTIONS(782),
    [sym__newline] = ACTIONS(782),
    [sym__string_start] = ACTIONS(73),
  },
  [232] = {
    [sym_except_clause] = STATE(232),
    [aux_sym_try_statement_repeat1] = STATE(232),
    [ts_builtin_sym_end] = ACTIONS(784),
    [sym_identifier] = ACTIONS(786),
    [anon_sym_import] = ACTIONS(786),
    [anon_sym_from] = ACTIONS(786),
    [anon_sym_LPAREN] = ACTIONS(784),
    [anon_sym_print] = ACTIONS(786),
    [anon_sym_assert] = ACTIONS(786),
    [anon_sym_return] = ACTIONS(786),
    [anon_sym_del] = ACTIONS(786),
    [anon_sym_raise] = ACTIONS(786),
    [anon_sym_pass] = ACTIONS(786),
    [anon_sym_break] = ACTIONS(786),
    [anon_sym_continue] = ACTIONS(786),
    [anon_sym_if] = ACTIONS(786),
    [anon_sym_else] = ACTIONS(786),
    [anon_sym_async] = ACTIONS(786),
    [anon_sym_for] = ACTIONS(786),
    [anon_sym_while] = ACTIONS(786),
    [anon_sym_try] = ACTIONS(786),
    [anon_sym_except] = ACTIONS(788),
    [anon_sym_finally] = ACTIONS(786),
    [anon_sym_with] = ACTIONS(786),
    [anon_sym_def] = ACTIONS(786),
    [anon_sym_global] = ACTIONS(786),
    [anon_sym_nonlocal] = ACTIONS(786),
    [anon_sym_exec] = ACTIONS(786),
    [anon_sym_class] = ACTIONS(786),
    [anon_sym_AT] = ACTIONS(784),
    [anon_sym_not] = ACTIONS(786),
    [anon_sym_PLUS] = ACTIONS(784),
    [anon_sym_DASH] = ACTIONS(784),
    [anon_sym_TILDE] = ACTIONS(784),
    [anon_sym_lambda] = ACTIONS(786),
    [anon_sym_yield] = ACTIONS(786),
    [anon_sym_LBRACK] = ACTIONS(784),
    [sym_ellipsis] = ACTIONS(784),
    [anon_sym_LBRACE] = ACTIONS(784),
    [sym_integer] = ACTIONS(786),
    [sym_float] = ACTIONS(784),
    [sym_true] = ACTIONS(786),
    [sym_false] = ACTIONS(786),
    [sym_none] = ACTIONS(786),
    [anon_sym_await] = ACTIONS(786),
    [sym_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(784),
  },
  [233] = {
    [sym_named_expression] = STATE(688),
    [sym__expression] = STATE(688),
    [sym__primary_expression] = STATE(383),
    [sym_not_operator] = STATE(688),
    [sym_boolean_operator] = STATE(688),
    [sym_binary_operator] = STATE(383),
    [sym_unary_operator] = STATE(383),
    [sym_comparison_operator] = STATE(688),
    [sym_lambda] = STATE(688),
    [sym_attribute] = STATE(383),
    [sym_subscript] = STATE(383),
    [sym_slice] = STATE(880),
    [sym_call] = STATE(383),
    [sym_list] = STATE(383),
    [sym_list_comprehension] = STATE(383),
    [sym_dictionary] = STATE(383),
    [sym_dictionary_comprehension] = STATE(383),
    [sym_set] = STATE(383),
    [sym_set_comprehension] = STATE(383),
    [sym_parenthesized_expression] = STATE(383),
    [sym_tuple] = STATE(383),
    [sym_generator_expression] = STATE(383),
    [sym_conditional_expression] = STATE(688),
    [sym_concatenated_string] = STATE(383),
    [sym_string] = STATE(381),
    [sym_await] = STATE(688),
    [sym_identifier] = ACTIONS(387),
    [anon_sym_LPAREN] = ACTIONS(389),
    [anon_sym_print] = ACTIONS(393),
    [anon_sym_COLON] = ACTIONS(700),
    [anon_sym_exec] = ACTIONS(393),
    [anon_sym_not] = ACTIONS(361),
    [anon_sym_PLUS] = ACTIONS(363),
    [anon_sym_DASH] = ACTIONS(363),
    [anon_sym_TILDE] = ACTIONS(363),
    [anon_sym_lambda] = ACTIONS(365),
    [anon_sym_LBRACK] = ACTIONS(367),
    [sym_ellipsis] = ACTIONS(369),
    [anon_sym_LBRACE] = ACTIONS(371),
    [sym_integer] = ACTIONS(373),
    [sym_float] = ACTIONS(369),
    [sym_true] = ACTIONS(373),
    [sym_false] = ACTIONS(373),
    [sym_none] = ACTIONS(373),
    [anon_sym_await] = ACTIONS(375),
    [sym_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(377),
  },
  [234] = {
    [sym_elif_clause] = STATE(362),
    [sym_else_clause] = STATE(433),
    [aux_sym_if_statement_repeat1] = STATE(277),
    [ts_builtin_sym_end] = ACTIONS(791),
    [sym_identifier] = ACTIONS(793),
    [anon_sym_import] = ACTIONS(793),
    [anon_sym_from] = ACTIONS(793),
    [anon_sym_LPAREN] = ACTIONS(791),
    [anon_sym_print] = ACTIONS(793),
    [anon_sym_assert] = ACTIONS(793),
    [anon_sym_return] = ACTIONS(793),
    [anon_sym_del] = ACTIONS(793),
    [anon_sym_raise] = ACTIONS(793),
    [anon_sym_pass] = ACTIONS(793),
    [anon_sym_break] = ACTIONS(793),
    [anon_sym_continue] = ACTIONS(793),
    [anon_sym_if] = ACTIONS(793),
    [anon_sym_elif] = ACTIONS(772),
    [anon_sym_else] = ACTIONS(548),
    [anon_sym_async] = ACTIONS(793),
    [anon_sym_for] = ACTIONS(793),
    [anon_sym_while] = ACTIONS(793),
    [anon_sym_try] = ACTIONS(793),
    [anon_sym_with] = ACTIONS(793),
    [anon_sym_def] = ACTIONS(793),
    [anon_sym_global] = ACTIONS(793),
    [anon_sym_nonlocal] = ACTIONS(793),
    [anon_sym_exec] = ACTIONS(793),
    [anon_sym_class] = ACTIONS(793),
    [anon_sym_AT] = ACTIONS(791),
    [anon_sym_not] = ACTIONS(793),
    [anon_sym_PLUS] = ACTIONS(791),
    [anon_sym_DASH] = ACTIONS(791),
    [anon_sym_TILDE] = ACTIONS(791),
    [anon_sym_lambda] = ACTIONS(793),
    [anon_sym_yield] = ACTIONS(793),
    [anon_sym_LBRACK] = ACTIONS(791),
    [sym_ellipsis] = ACTIONS(791),
    [anon_sym_LBRACE] = ACTIONS(791),
    [sym_integer] = ACTIONS(793),
    [sym_float] = ACTIONS(791),
    [sym_true] = ACTIONS(793),
    [sym_false] = ACTIONS(793),
    [sym_none] = ACTIONS(793),
    [anon_sym_await] = ACTIONS(793),
    [sym_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(791),
  },
  [235] = {
    [sym_named_expression] = STATE(660),
    [sym__expression_within_for_in_clause] = STATE(690),
    [sym__expression] = STATE(660),
    [sym__primary_expression] = STATE(383),
    [sym_not_operator] = STATE(660),
    [sym_boolean_operator] = STATE(660),
    [sym_binary_operator] = STATE(383),
    [sym_unary_operator] = STATE(383),
    [sym_comparison_operator] = STATE(660),
    [sym_lambda] = STATE(660),
    [sym_lambda_within_for_in_clause] = STATE(690),
    [sym_attribute] = STATE(383),
    [sym_subscript] = STATE(383),
    [sym_call] = STATE(383),
    [sym_list] = STATE(383),
    [sym_list_comprehension] = STATE(383),
    [sym_dictionary] = STATE(383),
    [sym_dictionary_comprehension] = STATE(383),
    [sym_set] = STATE(383),
    [sym_set_comprehension] = STATE(383),
    [sym_parenthesized_expression] = STATE(383),
    [sym_tuple] = STATE(383),
    [sym_generator_expression] = STATE(383),
    [sym_conditional_expression] = STATE(660),
    [sym_concatenated_string] = STATE(383),
    [sym_string] = STATE(381),
    [sym_await] = STATE(660),
    [sym_identifier] = ACTIONS(387),
    [anon_sym_LPAREN] = ACTIONS(389),
    [anon_sym_print] = ACTIONS(393),
    [anon_sym_exec] = ACTIONS(393),
    [anon_sym_not] = ACTIONS(361),
    [anon_sym_PLUS] = ACTIONS(363),
    [anon_sym_DASH] = ACTIONS(363),
    [anon_sym_TILDE] = ACTIONS(363),
    [anon_sym_lambda] = ACTIONS(397),
    [anon_sym_LBRACK] = ACTIONS(367),
    [sym_ellipsis] = ACTIONS(369),
    [anon_sym_LBRACE] = ACTIONS(371),
    [sym_integer] = ACTIONS(373),
    [sym_float] = ACTIONS(369),
    [sym_true] = ACTIONS(373),
    [sym_false] = ACTIONS(373),
    [sym_none] = ACTIONS(373),
    [anon_sym_await] = ACTIONS(375),
    [sym_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(377),
  },
  [236] = {
    [sym_named_expression] = STATE(761),
    [sym__expression] = STATE(761),
    [sym__primary_expression] = STATE(383),
    [sym_not_operator] = STATE(761),
    [sym_boolean_operator] = STATE(761),
    [sym_binary_operator] = STATE(383),
    [sym_unary_operator] = STATE(383),
    [sym_comparison_operator] = STATE(761),
    [sym_lambda] = STATE(761),
    [sym_attribute] = STATE(383),
    [sym_subscript] = STATE(383),
    [sym_call] = STATE(383),
    [sym_list] = STATE(383),
    [sym_list_comprehension] = STATE(383),
    [sym_dictionary] = STATE(383),
    [sym_dictionary_comprehension] = STATE(383),
    [sym_set] = STATE(383),
    [sym_set_comprehension] = STATE(383),
    [sym_parenthesized_expression] = STATE(383),
    [sym_tuple] = STATE(383),
    [sym_generator_expression] = STATE(383),
    [sym_conditional_expression] = STATE(761),
    [sym_concatenated_string] = STATE(383),
    [sym_string] = STATE(381),
    [sym_await] = STATE(761),
    [sym_identifier] = ACTIONS(387),
    [anon_sym_LPAREN] = ACTIONS(389),
    [anon_sym_COMMA] = ACTIONS(795),
    [anon_sym_print] = ACTIONS(393),
    [anon_sym_exec] = ACTIONS(393),
    [anon_sym_not] = ACTIONS(361),
    [anon_sym_PLUS] = ACTIONS(363),
    [anon_sym_DASH] = ACTIONS(363),
    [anon_sym_TILDE] = ACTIONS(363),
    [anon_sym_lambda] = ACTIONS(365),
    [anon_sym_LBRACK] = ACTIONS(367),
    [anon_sym_RBRACK] = ACTIONS(795),
    [sym_ellipsis] = ACTIONS(369),
    [anon_sym_LBRACE] = ACTIONS(371),
    [sym_integer] = ACTIONS(373),
    [sym_float] = ACTIONS(369),
    [sym_true] = ACTIONS(373),
    [sym_false] = ACTIONS(373),
    [sym_none] = ACTIONS(373),
    [anon_sym_await] = ACTIONS(375),
    [sym_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(377),
  },
  [237] = {
    [sym_elif_clause] = STATE(362),
    [sym_else_clause] = STATE(467),
    [aux_sym_if_statement_repeat1] = STATE(239),
    [ts_builtin_sym_end] = ACTIONS(797),
    [sym_identifier] = ACTIONS(799),
    [anon_sym_import] = ACTIONS(799),
    [anon_sym_from] = ACTIONS(799),
    [anon_sym_LPAREN] = ACTIONS(797),
    [anon_sym_print] = ACTIONS(799),
    [anon_sym_assert] = ACTIONS(799),
    [anon_sym_return] = ACTIONS(799),
    [anon_sym_del] = ACTIONS(799),
    [anon_sym_raise] = ACTIONS(799),
    [anon_sym_pass] = ACTIONS(799),
    [anon_sym_break] = ACTIONS(799),
    [anon_sym_continue] = ACTIONS(799),
    [anon_sym_if] = ACTIONS(799),
    [anon_sym_elif] = ACTIONS(772),
    [anon_sym_else] = ACTIONS(548),
    [anon_sym_async] = ACTIONS(799),
    [anon_sym_for] = ACTIONS(799),
    [anon_sym_while] = ACTIONS(799),
    [anon_sym_try] = ACTIONS(799),
    [anon_sym_with] = ACTIONS(799),
    [anon_sym_def] = ACTIONS(799),
    [anon_sym_global] = ACTIONS(799),
    [anon_sym_nonlocal] = ACTIONS(799),
    [anon_sym_exec] = ACTIONS(799),
    [anon_sym_class] = ACTIONS(799),
    [anon_sym_AT] = ACTIONS(797),
    [anon_sym_not] = ACTIONS(799),
    [anon_sym_PLUS] = ACTIONS(797),
    [anon_sym_DASH] = ACTIONS(797),
    [anon_sym_TILDE] = ACTIONS(797),
    [anon_sym_lambda] = ACTIONS(799),
    [anon_sym_yield] = ACTIONS(799),
    [anon_sym_LBRACK] = ACTIONS(797),
    [sym_ellipsis] = ACTIONS(797),
    [anon_sym_LBRACE] = ACTIONS(797),
    [sym_integer] = ACTIONS(799),
    [sym_float] = ACTIONS(797),
    [sym_true] = ACTIONS(799),
    [sym_false] = ACTIONS(799),
    [sym_none] = ACTIONS(799),
    [anon_sym_await] = ACTIONS(799),
    [sym_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(797),
  },
  [238] = {
    [sym_named_expression] = STATE(662),
    [sym__expression_within_for_in_clause] = STATE(664),
    [sym__expression] = STATE(662),
    [sym__primary_expression] = STATE(383),
    [sym_not_operator] = STATE(662),
    [sym_boolean_operator] = STATE(662),
    [sym_binary_operator] = STATE(383),
    [sym_unary_operator] = STATE(383),
    [sym_comparison_operator] = STATE(662),
    [sym_lambda] = STATE(662),
    [sym_lambda_within_for_in_clause] = STATE(664),
    [sym_attribute] = STATE(383),
    [sym_subscript] = STATE(383),
    [sym_call] = STATE(383),
    [sym_list] = STATE(383),
    [sym_list_comprehension] = STATE(383),
    [sym_dictionary] = STATE(383),
    [sym_dictionary_comprehension] = STATE(383),
    [sym_set] = STATE(383),
    [sym_set_comprehension] = STATE(383),
    [sym_parenthesized_expression] = STATE(383),
    [sym_tuple] = STATE(383),
    [sym_generator_expression] = STATE(383),
    [sym_conditional_expression] = STATE(662),
    [sym_concatenated_string] = STATE(383),
    [sym_string] = STATE(381),
    [sym_await] = STATE(662),
    [sym_identifier] = ACTIONS(387),
    [anon_sym_LPAREN] = ACTIONS(389),
    [anon_sym_print] = ACTIONS(393),
    [anon_sym_exec] = ACTIONS(393),
    [anon_sym_not] = ACTIONS(361),
    [anon_sym_PLUS] = ACTIONS(363),
    [anon_sym_DASH] = ACTIONS(363),
    [anon_sym_TILDE] = ACTIONS(363),
    [anon_sym_lambda] = ACTIONS(397),
    [anon_sym_LBRACK] = ACTIONS(367),
    [sym_ellipsis] = ACTIONS(369),
    [anon_sym_LBRACE] = ACTIONS(371),
    [sym_integer] = ACTIONS(373),
    [sym_float] = ACTIONS(369),
    [sym_true] = ACTIONS(373),
    [sym_false] = ACTIONS(373),
    [sym_none] = ACTIONS(373),
    [anon_sym_await] = ACTIONS(375),
    [sym_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(377),
  },
  [239] = {
    [sym_elif_clause] = STATE(362),
    [sym_else_clause] = STATE(459),
    [aux_sym_if_statement_repeat1] = STATE(277),
    [ts_builtin_sym_end] = ACTIONS(776),
    [sym_identifier] = ACTIONS(774),
    [anon_sym_import] = ACTIONS(774),
    [anon_sym_from] = ACTIONS(774),
    [anon_sym_LPAREN] = ACTIONS(776),
    [anon_sym_print] = ACTIONS(774),
    [anon_sym_assert] = ACTIONS(774),
    [anon_sym_return] = ACTIONS(774),
    [anon_sym_del] = ACTIONS(774),
    [anon_sym_raise] = ACTIONS(774),
    [anon_sym_pass] = ACTIONS(774),
    [anon_sym_break] = ACTIONS(774),
    [anon_sym_continue] = ACTIONS(774),
    [anon_sym_if] = ACTIONS(774),
    [anon_sym_elif] = ACTIONS(772),
    [anon_sym_else] = ACTIONS(548),
    [anon_sym_async] = ACTIONS(774),
    [anon_sym_for] = ACTIONS(774),
    [anon_sym_while] = ACTIONS(774),
    [anon_sym_try] = ACTIONS(774),
    [anon_sym_with] = ACTIONS(774),
    [anon_sym_def] = ACTIONS(774),
    [anon_sym_global] = ACTIONS(774),
    [anon_sym_nonlocal] = ACTIONS(774),
    [anon_sym_exec] = ACTIONS(774),
    [anon_sym_class] = ACTIONS(774),
    [anon_sym_AT] = ACTIONS(776),
    [anon_sym_not] = ACTIONS(774),
    [anon_sym_PLUS] = ACTIONS(776),
    [anon_sym_DASH] = ACTIONS(776),
    [anon_sym_TILDE] = ACTIONS(776),
    [anon_sym_lambda] = ACTIONS(774),
    [anon_sym_yield] = ACTIONS(774),
    [anon_sym_LBRACK] = ACTIONS(776),
    [sym_ellipsis] = ACTIONS(776),
    [anon_sym_LBRACE] = ACTIONS(776),
    [sym_integer] = ACTIONS(774),
    [sym_float] = ACTIONS(776),
    [sym_true] = ACTIONS(774),
    [sym_false] = ACTIONS(774),
    [sym_none] = ACTIONS(774),
    [anon_sym_await] = ACTIONS(774),
    [sym_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(776),
  },
  [240] = {
    [sym_named_expression] = STATE(702),
    [sym__expression] = STATE(702),
    [sym__primary_expression] = STATE(383),
    [sym_not_operator] = STATE(702),
    [sym_boolean_operator] = STATE(702),
    [sym_binary_operator] = STATE(383),
    [sym_unary_operator] = STATE(383),
    [sym_comparison_operator] = STATE(702),
    [sym_lambda] = STATE(702),
    [sym_attribute] = STATE(383),
    [sym_subscript] = STATE(383),
    [sym_slice] = STATE(900),
    [sym_call] = STATE(383),
    [sym_list] = STATE(383),
    [sym_list_comprehension] = STATE(383),
    [sym_dictionary] = STATE(383),
    [sym_dictionary_comprehension] = STATE(383),
    [sym_set] = STATE(383),
    [sym_set_comprehension] = STATE(383),
    [sym_parenthesized_expression] = STATE(383),
    [sym_tuple] = STATE(383),
    [sym_generator_expression] = STATE(383),
    [sym_conditional_expression] = STATE(702),
    [sym_concatenated_string] = STATE(383),
    [sym_string] = STATE(381),
    [sym_await] = STATE(702),
    [sym_identifier] = ACTIONS(387),
    [anon_sym_LPAREN] = ACTIONS(389),
    [anon_sym_print] = ACTIONS(393),
    [anon_sym_COLON] = ACTIONS(700),
    [anon_sym_exec] = ACTIONS(393),
    [anon_sym_not] = ACTIONS(361),
    [anon_sym_PLUS] = ACTIONS(363),
    [anon_sym_DASH] = ACTIONS(363),
    [anon_sym_TILDE] = ACTIONS(363),
    [anon_sym_lambda] = ACTIONS(365),
    [anon_sym_LBRACK] = ACTIONS(367),
    [sym_ellipsis] = ACTIONS(369),
    [anon_sym_LBRACE] = ACTIONS(371),
    [sym_integer] = ACTIONS(373),
    [sym_float] = ACTIONS(369),
    [sym_true] = ACTIONS(373),
    [sym_false] = ACTIONS(373),
    [sym_none] = ACTIONS(373),
    [anon_sym_await] = ACTIONS(375),
    [sym_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(377),
  },
  [241] = {
    [sym_named_expression] = STATE(748),
    [sym__expression] = STATE(748),
    [sym__primary_expression] = STATE(383),
    [sym_not_operator] = STATE(748),
    [sym_boolean_operator] = STATE(748),
    [sym_binary_operator] = STATE(383),
    [sym_unary_operator] = STATE(383),
    [sym_comparison_operator] = STATE(748),
    [sym_lambda] = STATE(748),
    [sym_yield] = STATE(951),
    [sym_attribute] = STATE(383),
    [sym_subscript] = STATE(383),
    [sym_call] = STATE(383),
    [sym_list] = STATE(383),
    [sym_list_comprehension] = STATE(383),
    [sym_dictionary] = STATE(383),
    [sym_dictionary_comprehension] = STATE(383),
    [sym_set] = STATE(383),
    [sym_set_comprehension] = STATE(383),
    [sym_parenthesized_expression] = STATE(383),
    [sym_tuple] = STATE(383),
    [sym_generator_expression] = STATE(383),
    [sym_conditional_expression] = STATE(748),
    [sym_concatenated_string] = STATE(383),
    [sym_string] = STATE(381),
    [sym_await] = STATE(748),
    [sym_identifier] = ACTIONS(387),
    [anon_sym_LPAREN] = ACTIONS(389),
    [anon_sym_print] = ACTIONS(393),
    [anon_sym_exec] = ACTIONS(393),
    [anon_sym_not] = ACTIONS(361),
    [anon_sym_PLUS] = ACTIONS(363),
    [anon_sym_DASH] = ACTIONS(363),
    [anon_sym_TILDE] = ACTIONS(363),
    [anon_sym_lambda] = ACTIONS(365),
    [anon_sym_yield] = ACTIONS(465),
    [anon_sym_LBRACK] = ACTIONS(367),
    [sym_ellipsis] = ACTIONS(369),
    [anon_sym_LBRACE] = ACTIONS(371),
    [sym_integer] = ACTIONS(373),
    [sym_float] = ACTIONS(369),
    [sym_true] = ACTIONS(373),
    [sym_false] = ACTIONS(373),
    [sym_none] = ACTIONS(373),
    [anon_sym_await] = ACTIONS(375),
    [sym_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(377),
  },
  [242] = {
    [sym_elif_clause] = STATE(365),
    [sym_else_clause] = STATE(406),
    [aux_sym_if_statement_repeat1] = STATE(249),
    [sym_identifier] = ACTIONS(770),
    [anon_sym_import] = ACTIONS(770),
    [anon_sym_from] = ACTIONS(770),
    [anon_sym_LPAREN] = ACTIONS(768),
    [anon_sym_print] = ACTIONS(770),
    [anon_sym_assert] = ACTIONS(770),
    [anon_sym_return] = ACTIONS(770),
    [anon_sym_del] = ACTIONS(770),
    [anon_sym_raise] = ACTIONS(770),
    [anon_sym_pass] = ACTIONS(770),
    [anon_sym_break] = ACTIONS(770),
    [anon_sym_continue] = ACTIONS(770),
    [anon_sym_if] = ACTIONS(770),
    [anon_sym_elif] = ACTIONS(778),
    [anon_sym_else] = ACTIONS(684),
    [anon_sym_async] = ACTIONS(770),
    [anon_sym_for] = ACTIONS(770),
    [anon_sym_while] = ACTIONS(770),
    [anon_sym_try] = ACTIONS(770),
    [anon_sym_with] = ACTIONS(770),
    [anon_sym_def] = ACTIONS(770),
    [anon_sym_global] = ACTIONS(770),
    [anon_sym_nonlocal] = ACTIONS(770),
    [anon_sym_exec] = ACTIONS(770),
    [anon_sym_class] = ACTIONS(770),
    [anon_sym_AT] = ACTIONS(768),
    [anon_sym_not] = ACTIONS(770),
    [anon_sym_PLUS] = ACTIONS(768),
    [anon_sym_DASH] = ACTIONS(768),
    [anon_sym_TILDE] = ACTIONS(768),
    [anon_sym_lambda] = ACTIONS(770),
    [anon_sym_yield] = ACTIONS(770),
    [anon_sym_LBRACK] = ACTIONS(768),
    [sym_ellipsis] = ACTIONS(768),
    [anon_sym_LBRACE] = ACTIONS(768),
    [sym_integer] = ACTIONS(770),
    [sym_float] = ACTIONS(768),
    [sym_true] = ACTIONS(770),
    [sym_false] = ACTIONS(770),
    [sym_none] = ACTIONS(770),
    [anon_sym_await] = ACTIONS(770),
    [sym_comment] = ACTIONS(3),
    [sym__dedent] = ACTIONS(768),
    [sym__string_start] = ACTIONS(768),
  },
  [243] = {
    [sym_named_expression] = STATE(714),
    [sym__expression] = STATE(714),
    [sym__primary_expression] = STATE(109),
    [sym_not_operator] = STATE(714),
    [sym_boolean_operator] = STATE(714),
    [sym_binary_operator] = STATE(109),
    [sym_unary_operator] = STATE(109),
    [sym_comparison_operator] = STATE(714),
    [sym_lambda] = STATE(714),
    [sym_attribute] = STATE(109),
    [sym_subscript] = STATE(109),
    [sym_call] = STATE(109),
    [sym_list] = STATE(109),
    [sym_list_comprehension] = STATE(109),
    [sym_dictionary] = STATE(109),
    [sym_dictionary_comprehension] = STATE(109),
    [sym_set] = STATE(109),
    [sym_set_comprehension] = STATE(109),
    [sym_parenthesized_expression] = STATE(109),
    [sym_tuple] = STATE(109),
    [sym_generator_expression] = STATE(109),
    [sym_conditional_expression] = STATE(714),
    [sym_concatenated_string] = STATE(109),
    [sym_string] = STATE(117),
    [sym_await] = STATE(714),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(13),
    [anon_sym_print] = ACTIONS(237),
    [anon_sym_exec] = ACTIONS(237),
    [anon_sym_not] = ACTIONS(55),
    [anon_sym_PLUS] = ACTIONS(57),
    [anon_sym_DASH] = ACTIONS(57),
    [anon_sym_TILDE] = ACTIONS(57),
    [anon_sym_lambda] = ACTIONS(59),
    [anon_sym_LBRACK] = ACTIONS(63),
    [sym_ellipsis] = ACTIONS(65),
    [anon_sym_LBRACE] = ACTIONS(67),
    [sym_integer] = ACTIONS(69),
    [sym_float] = ACTIONS(65),
    [sym_true] = ACTIONS(69),
    [sym_false] = ACTIONS(69),
    [sym_none] = ACTIONS(69),
    [anon_sym_await] = ACTIONS(71),
    [sym_comment] = ACTIONS(3),
    [sym__semicolon] = ACTIONS(801),
    [sym__newline] = ACTIONS(801),
    [sym__string_start] = ACTIONS(73),
  },
  [244] = {
    [sym_named_expression] = STATE(739),
    [sym__expression] = STATE(739),
    [sym__primary_expression] = STATE(383),
    [sym_not_operator] = STATE(739),
    [sym_boolean_operator] = STATE(739),
    [sym_binary_operator] = STATE(383),
    [sym_unary_operator] = STATE(383),
    [sym_comparison_operator] = STATE(739),
    [sym_lambda] = STATE(739),
    [sym_attribute] = STATE(383),
    [sym_subscript] = STATE(383),
    [sym_call] = STATE(383),
    [sym_list] = STATE(383),
    [sym_list_comprehension] = STATE(383),
    [sym_dictionary] = STATE(383),
    [sym_dictionary_comprehension] = STATE(383),
    [sym_set] = STATE(383),
    [sym_set_comprehension] = STATE(383),
    [sym_parenthesized_expression] = STATE(383),
    [sym_tuple] = STATE(383),
    [sym_generator_expression] = STATE(383),
    [sym_conditional_expression] = STATE(739),
    [sym_concatenated_string] = STATE(383),
    [sym_string] = STATE(381),
    [sym_await] = STATE(739),
    [sym_identifier] = ACTIONS(387),
    [anon_sym_LPAREN] = ACTIONS(389),
    [anon_sym_COMMA] = ACTIONS(714),
    [anon_sym_print] = ACTIONS(393),
    [anon_sym_exec] = ACTIONS(393),
    [anon_sym_not] = ACTIONS(361),
    [anon_sym_PLUS] = ACTIONS(363),
    [anon_sym_DASH] = ACTIONS(363),
    [anon_sym_TILDE] = ACTIONS(363),
    [anon_sym_lambda] = ACTIONS(365),
    [anon_sym_LBRACK] = ACTIONS(367),
    [anon_sym_RBRACK] = ACTIONS(714),
    [sym_ellipsis] = ACTIONS(369),
    [anon_sym_LBRACE] = ACTIONS(371),
    [sym_integer] = ACTIONS(373),
    [sym_float] = ACTIONS(369),
    [sym_true] = ACTIONS(373),
    [sym_false] = ACTIONS(373),
    [sym_none] = ACTIONS(373),
    [anon_sym_await] = ACTIONS(375),
    [sym_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(377),
  },
  [245] = {
    [sym_named_expression] = STATE(714),
    [sym__expression] = STATE(714),
    [sym__primary_expression] = STATE(109),
    [sym_not_operator] = STATE(714),
    [sym_boolean_operator] = STATE(714),
    [sym_binary_operator] = STATE(109),
    [sym_unary_operator] = STATE(109),
    [sym_comparison_operator] = STATE(714),
    [sym_lambda] = STATE(714),
    [sym_attribute] = STATE(109),
    [sym_subscript] = STATE(109),
    [sym_call] = STATE(109),
    [sym_list] = STATE(109),
    [sym_list_comprehension] = STATE(109),
    [sym_dictionary] = STATE(109),
    [sym_dictionary_comprehension] = STATE(109),
    [sym_set] = STATE(109),
    [sym_set_comprehension] = STATE(109),
    [sym_parenthesized_expression] = STATE(109),
    [sym_tuple] = STATE(109),
    [sym_generator_expression] = STATE(109),
    [sym_conditional_expression] = STATE(714),
    [sym_concatenated_string] = STATE(109),
    [sym_string] = STATE(117),
    [sym_await] = STATE(714),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(13),
    [anon_sym_print] = ACTIONS(237),
    [anon_sym_exec] = ACTIONS(237),
    [anon_sym_not] = ACTIONS(55),
    [anon_sym_PLUS] = ACTIONS(57),
    [anon_sym_DASH] = ACTIONS(57),
    [anon_sym_TILDE] = ACTIONS(57),
    [anon_sym_lambda] = ACTIONS(59),
    [anon_sym_LBRACK] = ACTIONS(63),
    [sym_ellipsis] = ACTIONS(65),
    [anon_sym_LBRACE] = ACTIONS(67),
    [sym_integer] = ACTIONS(69),
    [sym_float] = ACTIONS(65),
    [sym_true] = ACTIONS(69),
    [sym_false] = ACTIONS(69),
    [sym_none] = ACTIONS(69),
    [anon_sym_await] = ACTIONS(71),
    [sym_comment] = ACTIONS(3),
    [sym__semicolon] = ACTIONS(803),
    [sym__newline] = ACTIONS(803),
    [sym__string_start] = ACTIONS(73),
  },
  [246] = {
    [sym_named_expression] = STATE(673),
    [sym__expression] = STATE(673),
    [sym__primary_expression] = STATE(383),
    [sym_not_operator] = STATE(673),
    [sym_boolean_operator] = STATE(673),
    [sym_binary_operator] = STATE(383),
    [sym_unary_operator] = STATE(383),
    [sym_comparison_operator] = STATE(673),
    [sym_lambda] = STATE(673),
    [sym_attribute] = STATE(383),
    [sym_subscript] = STATE(383),
    [sym_slice] = STATE(884),
    [sym_call] = STATE(383),
    [sym_list] = STATE(383),
    [sym_list_comprehension] = STATE(383),
    [sym_dictionary] = STATE(383),
    [sym_dictionary_comprehension] = STATE(383),
    [sym_set] = STATE(383),
    [sym_set_comprehension] = STATE(383),
    [sym_parenthesized_expression] = STATE(383),
    [sym_tuple] = STATE(383),
    [sym_generator_expression] = STATE(383),
    [sym_conditional_expression] = STATE(673),
    [sym_concatenated_string] = STATE(383),
    [sym_string] = STATE(381),
    [sym_await] = STATE(673),
    [sym_identifier] = ACTIONS(387),
    [anon_sym_LPAREN] = ACTIONS(389),
    [anon_sym_print] = ACTIONS(393),
    [anon_sym_COLON] = ACTIONS(700),
    [anon_sym_exec] = ACTIONS(393),
    [anon_sym_not] = ACTIONS(361),
    [anon_sym_PLUS] = ACTIONS(363),
    [anon_sym_DASH] = ACTIONS(363),
    [anon_sym_TILDE] = ACTIONS(363),
    [anon_sym_lambda] = ACTIONS(365),
    [anon_sym_LBRACK] = ACTIONS(367),
    [sym_ellipsis] = ACTIONS(369),
    [anon_sym_LBRACE] = ACTIONS(371),
    [sym_integer] = ACTIONS(373),
    [sym_float] = ACTIONS(369),
    [sym_true] = ACTIONS(373),
    [sym_false] = ACTIONS(373),
    [sym_none] = ACTIONS(373),
    [anon_sym_await] = ACTIONS(375),
    [sym_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(377),
  },
  [247] = {
    [sym_elif_clause] = STATE(365),
    [sym_else_clause] = STATE(396),
    [aux_sym_if_statement_repeat1] = STATE(228),
    [sym_identifier] = ACTIONS(799),
    [anon_sym_import] = ACTIONS(799),
    [anon_sym_from] = ACTIONS(799),
    [anon_sym_LPAREN] = ACTIONS(797),
    [anon_sym_print] = ACTIONS(799),
    [anon_sym_assert] = ACTIONS(799),
    [anon_sym_return] = ACTIONS(799),
    [anon_sym_del] = ACTIONS(799),
    [anon_sym_raise] = ACTIONS(799),
    [anon_sym_pass] = ACTIONS(799),
    [anon_sym_break] = ACTIONS(799),
    [anon_sym_continue] = ACTIONS(799),
    [anon_sym_if] = ACTIONS(799),
    [anon_sym_elif] = ACTIONS(778),
    [anon_sym_else] = ACTIONS(684),
    [anon_sym_async] = ACTIONS(799),
    [anon_sym_for] = ACTIONS(799),
    [anon_sym_while] = ACTIONS(799),
    [anon_sym_try] = ACTIONS(799),
    [anon_sym_with] = ACTIONS(799),
    [anon_sym_def] = ACTIONS(799),
    [anon_sym_global] = ACTIONS(799),
    [anon_sym_nonlocal] = ACTIONS(799),
    [anon_sym_exec] = ACTIONS(799),
    [anon_sym_class] = ACTIONS(799),
    [anon_sym_AT] = ACTIONS(797),
    [anon_sym_not] = ACTIONS(799),
    [anon_sym_PLUS] = ACTIONS(797),
    [anon_sym_DASH] = ACTIONS(797),
    [anon_sym_TILDE] = ACTIONS(797),
    [anon_sym_lambda] = ACTIONS(799),
    [anon_sym_yield] = ACTIONS(799),
    [anon_sym_LBRACK] = ACTIONS(797),
    [sym_ellipsis] = ACTIONS(797),
    [anon_sym_LBRACE] = ACTIONS(797),
    [sym_integer] = ACTIONS(799),
    [sym_float] = ACTIONS(797),
    [sym_true] = ACTIONS(799),
    [sym_false] = ACTIONS(799),
    [sym_none] = ACTIONS(799),
    [anon_sym_await] = ACTIONS(799),
    [sym_comment] = ACTIONS(3),
    [sym__dedent] = ACTIONS(797),
    [sym__string_start] = ACTIONS(797),
  },
  [248] = {
    [sym_named_expression] = STATE(737),
    [sym__expression] = STATE(737),
    [sym__primary_expression] = STATE(383),
    [sym_not_operator] = STATE(737),
    [sym_boolean_operator] = STATE(737),
    [sym_binary_operator] = STATE(383),
    [sym_unary_operator] = STATE(383),
    [sym_comparison_operator] = STATE(737),
    [sym_lambda] = STATE(737),
    [sym_attribute] = STATE(383),
    [sym_subscript] = STATE(383),
    [sym_call] = STATE(383),
    [sym_list] = STATE(383),
    [sym_list_comprehension] = STATE(383),
    [sym_dictionary] = STATE(383),
    [sym_dictionary_comprehension] = STATE(383),
    [sym_set] = STATE(383),
    [sym_set_comprehension] = STATE(383),
    [sym_parenthesized_expression] = STATE(383),
    [sym_tuple] = STATE(383),
    [sym_generator_expression] = STATE(383),
    [sym_conditional_expression] = STATE(737),
    [sym_concatenated_string] = STATE(383),
    [sym_string] = STATE(381),
    [sym_await] = STATE(737),
    [sym_identifier] = ACTIONS(387),
    [anon_sym_LPAREN] = ACTIONS(389),
    [anon_sym_COMMA] = ACTIONS(805),
    [anon_sym_print] = ACTIONS(393),
    [anon_sym_exec] = ACTIONS(393),
    [anon_sym_not] = ACTIONS(361),
    [anon_sym_PLUS] = ACTIONS(363),
    [anon_sym_DASH] = ACTIONS(363),
    [anon_sym_TILDE] = ACTIONS(363),
    [anon_sym_lambda] = ACTIONS(365),
    [anon_sym_LBRACK] = ACTIONS(367),
    [anon_sym_RBRACK] = ACTIONS(805),
    [sym_ellipsis] = ACTIONS(369),
    [anon_sym_LBRACE] = ACTIONS(371),
    [sym_integer] = ACTIONS(373),
    [sym_float] = ACTIONS(369),
    [sym_true] = ACTIONS(373),
    [sym_false] = ACTIONS(373),
    [sym_none] = ACTIONS(373),
    [anon_sym_await] = ACTIONS(375),
    [sym_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(377),
  },
  [249] = {
    [sym_elif_clause] = STATE(365),
    [sym_else_clause] = STATE(395),
    [aux_sym_if_statement_repeat1] = STATE(279),
    [sym_identifier] = ACTIONS(793),
    [anon_sym_import] = ACTIONS(793),
    [anon_sym_from] = ACTIONS(793),
    [anon_sym_LPAREN] = ACTIONS(791),
    [anon_sym_print] = ACTIONS(793),
    [anon_sym_assert] = ACTIONS(793),
    [anon_sym_return] = ACTIONS(793),
    [anon_sym_del] = ACTIONS(793),
    [anon_sym_raise] = ACTIONS(793),
    [anon_sym_pass] = ACTIONS(793),
    [anon_sym_break] = ACTIONS(793),
    [anon_sym_continue] = ACTIONS(793),
    [anon_sym_if] = ACTIONS(793),
    [anon_sym_elif] = ACTIONS(778),
    [anon_sym_else] = ACTIONS(684),
    [anon_sym_async] = ACTIONS(793),
    [anon_sym_for] = ACTIONS(793),
    [anon_sym_while] = ACTIONS(793),
    [anon_sym_try] = ACTIONS(793),
    [anon_sym_with] = ACTIONS(793),
    [anon_sym_def] = ACTIONS(793),
    [anon_sym_global] = ACTIONS(793),
    [anon_sym_nonlocal] = ACTIONS(793),
    [anon_sym_exec] = ACTIONS(793),
    [anon_sym_class] = ACTIONS(793),
    [anon_sym_AT] = ACTIONS(791),
    [anon_sym_not] = ACTIONS(793),
    [anon_sym_PLUS] = ACTIONS(791),
    [anon_sym_DASH] = ACTIONS(791),
    [anon_sym_TILDE] = ACTIONS(791),
    [anon_sym_lambda] = ACTIONS(793),
    [anon_sym_yield] = ACTIONS(793),
    [anon_sym_LBRACK] = ACTIONS(791),
    [sym_ellipsis] = ACTIONS(791),
    [anon_sym_LBRACE] = ACTIONS(791),
    [sym_integer] = ACTIONS(793),
    [sym_float] = ACTIONS(791),
    [sym_true] = ACTIONS(793),
    [sym_false] = ACTIONS(793),
    [sym_none] = ACTIONS(793),
    [anon_sym_await] = ACTIONS(793),
    [sym_comment] = ACTIONS(3),
    [sym__dedent] = ACTIONS(791),
    [sym__string_start] = ACTIONS(791),
  },
  [250] = {
    [sym_except_clause] = STATE(250),
    [aux_sym_try_statement_repeat1] = STATE(250),
    [sym_identifier] = ACTIONS(786),
    [anon_sym_import] = ACTIONS(786),
    [anon_sym_from] = ACTIONS(786),
    [anon_sym_LPAREN] = ACTIONS(784),
    [anon_sym_print] = ACTIONS(786),
    [anon_sym_assert] = ACTIONS(786),
    [anon_sym_return] = ACTIONS(786),
    [anon_sym_del] = ACTIONS(786),
    [anon_sym_raise] = ACTIONS(786),
    [anon_sym_pass] = ACTIONS(786),
    [anon_sym_break] = ACTIONS(786),
    [anon_sym_continue] = ACTIONS(786),
    [anon_sym_if] = ACTIONS(786),
    [anon_sym_else] = ACTIONS(786),
    [anon_sym_async] = ACTIONS(786),
    [anon_sym_for] = ACTIONS(786),
    [anon_sym_while] = ACTIONS(786),
    [anon_sym_try] = ACTIONS(786),
    [anon_sym_except] = ACTIONS(807),
    [anon_sym_finally] = ACTIONS(786),
    [anon_sym_with] = ACTIONS(786),
    [anon_sym_def] = ACTIONS(786),
    [anon_sym_global] = ACTIONS(786),
    [anon_sym_nonlocal] = ACTIONS(786),
    [anon_sym_exec] = ACTIONS(786),
    [anon_sym_class] = ACTIONS(786),
    [anon_sym_AT] = ACTIONS(784),
    [anon_sym_not] = ACTIONS(786),
    [anon_sym_PLUS] = ACTIONS(784),
    [anon_sym_DASH] = ACTIONS(784),
    [anon_sym_TILDE] = ACTIONS(784),
    [anon_sym_lambda] = ACTIONS(786),
    [anon_sym_yield] = ACTIONS(786),
    [anon_sym_LBRACK] = ACTIONS(784),
    [sym_ellipsis] = ACTIONS(784),
    [anon_sym_LBRACE] = ACTIONS(784),
    [sym_integer] = ACTIONS(786),
    [sym_float] = ACTIONS(784),
    [sym_true] = ACTIONS(786),
    [sym_false] = ACTIONS(786),
    [sym_none] = ACTIONS(786),
    [anon_sym_await] = ACTIONS(786),
    [sym_comment] = ACTIONS(3),
    [sym__dedent] = ACTIONS(784),
    [sym__string_start] = ACTIONS(784),
  },
  [251] = {
    [sym_named_expression] = STATE(659),
    [sym__expression_within_for_in_clause] = STATE(700),
    [sym__expression] = STATE(659),
    [sym__primary_expression] = STATE(383),
    [sym_not_operator] = STATE(659),
    [sym_boolean_operator] = STATE(659),
    [sym_binary_operator] = STATE(383),
    [sym_unary_operator] = STATE(383),
    [sym_comparison_operator] = STATE(659),
    [sym_lambda] = STATE(659),
    [sym_lambda_within_for_in_clause] = STATE(700),
    [sym_attribute] = STATE(383),
    [sym_subscript] = STATE(383),
    [sym_call] = STATE(383),
    [sym_list] = STATE(383),
    [sym_list_comprehension] = STATE(383),
    [sym_dictionary] = STATE(383),
    [sym_dictionary_comprehension] = STATE(383),
    [sym_set] = STATE(383),
    [sym_set_comprehension] = STATE(383),
    [sym_parenthesized_expression] = STATE(383),
    [sym_tuple] = STATE(383),
    [sym_generator_expression] = STATE(383),
    [sym_conditional_expression] = STATE(659),
    [sym_concatenated_string] = STATE(383),
    [sym_string] = STATE(381),
    [sym_await] = STATE(659),
    [sym_identifier] = ACTIONS(387),
    [anon_sym_LPAREN] = ACTIONS(389),
    [anon_sym_print] = ACTIONS(393),
    [anon_sym_exec] = ACTIONS(393),
    [anon_sym_not] = ACTIONS(361),
    [anon_sym_PLUS] = ACTIONS(363),
    [anon_sym_DASH] = ACTIONS(363),
    [anon_sym_TILDE] = ACTIONS(363),
    [anon_sym_lambda] = ACTIONS(397),
    [anon_sym_LBRACK] = ACTIONS(367),
    [sym_ellipsis] = ACTIONS(369),
    [anon_sym_LBRACE] = ACTIONS(371),
    [sym_integer] = ACTIONS(373),
    [sym_float] = ACTIONS(369),
    [sym_true] = ACTIONS(373),
    [sym_false] = ACTIONS(373),
    [sym_none] = ACTIONS(373),
    [anon_sym_await] = ACTIONS(375),
    [sym_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(377),
  },
  [252] = {
    [sym_named_expression] = STATE(729),
    [sym__expression] = STATE(729),
    [sym__primary_expression] = STATE(383),
    [sym_not_operator] = STATE(729),
    [sym_boolean_operator] = STATE(729),
    [sym_binary_operator] = STATE(383),
    [sym_unary_operator] = STATE(383),
    [sym_comparison_operator] = STATE(729),
    [sym_lambda] = STATE(729),
    [sym_attribute] = STATE(383),
    [sym_subscript] = STATE(383),
    [sym_slice] = STATE(947),
    [sym_call] = STATE(383),
    [sym_list] = STATE(383),
    [sym_list_comprehension] = STATE(383),
    [sym_dictionary] = STATE(383),
    [sym_dictionary_comprehension] = STATE(383),
    [sym_set] = STATE(383),
    [sym_set_comprehension] = STATE(383),
    [sym_parenthesized_expression] = STATE(383),
    [sym_tuple] = STATE(383),
    [sym_generator_expression] = STATE(383),
    [sym_conditional_expression] = STATE(729),
    [sym_concatenated_string] = STATE(383),
    [sym_string] = STATE(381),
    [sym_await] = STATE(729),
    [sym_identifier] = ACTIONS(387),
    [anon_sym_LPAREN] = ACTIONS(389),
    [anon_sym_print] = ACTIONS(393),
    [anon_sym_COLON] = ACTIONS(700),
    [anon_sym_exec] = ACTIONS(393),
    [anon_sym_not] = ACTIONS(361),
    [anon_sym_PLUS] = ACTIONS(363),
    [anon_sym_DASH] = ACTIONS(363),
    [anon_sym_TILDE] = ACTIONS(363),
    [anon_sym_lambda] = ACTIONS(365),
    [anon_sym_LBRACK] = ACTIONS(367),
    [sym_ellipsis] = ACTIONS(369),
    [anon_sym_LBRACE] = ACTIONS(371),
    [sym_integer] = ACTIONS(373),
    [sym_float] = ACTIONS(369),
    [sym_true] = ACTIONS(373),
    [sym_false] = ACTIONS(373),
    [sym_none] = ACTIONS(373),
    [anon_sym_await] = ACTIONS(375),
    [sym_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(377),
  },
  [253] = {
    [sym_named_expression] = STATE(733),
    [sym__expression] = STATE(733),
    [sym__primary_expression] = STATE(503),
    [sym_not_operator] = STATE(733),
    [sym_boolean_operator] = STATE(733),
    [sym_binary_operator] = STATE(503),
    [sym_unary_operator] = STATE(503),
    [sym_comparison_operator] = STATE(733),
    [sym_lambda] = STATE(733),
    [sym_attribute] = STATE(503),
    [sym_subscript] = STATE(503),
    [sym_call] = STATE(503),
    [sym_list] = STATE(503),
    [sym_list_comprehension] = STATE(503),
    [sym_dictionary] = STATE(503),
    [sym_dictionary_comprehension] = STATE(503),
    [sym_set] = STATE(503),
    [sym_set_comprehension] = STATE(503),
    [sym_parenthesized_expression] = STATE(503),
    [sym_tuple] = STATE(503),
    [sym_generator_expression] = STATE(503),
    [sym_conditional_expression] = STATE(733),
    [sym_concatenated_string] = STATE(503),
    [sym_string] = STATE(505),
    [sym_await] = STATE(733),
    [sym_identifier] = ACTIONS(810),
    [anon_sym_LPAREN] = ACTIONS(812),
    [anon_sym_print] = ACTIONS(814),
    [anon_sym_COLON] = ACTIONS(816),
    [anon_sym_exec] = ACTIONS(814),
    [anon_sym_not] = ACTIONS(818),
    [anon_sym_PLUS] = ACTIONS(820),
    [anon_sym_DASH] = ACTIONS(820),
    [anon_sym_TILDE] = ACTIONS(820),
    [anon_sym_lambda] = ACTIONS(822),
    [anon_sym_LBRACK] = ACTIONS(824),
    [sym_ellipsis] = ACTIONS(826),
    [anon_sym_LBRACE] = ACTIONS(828),
    [sym_integer] = ACTIONS(830),
    [sym_float] = ACTIONS(826),
    [sym_true] = ACTIONS(830),
    [sym_false] = ACTIONS(830),
    [sym_none] = ACTIONS(830),
    [anon_sym_await] = ACTIONS(832),
    [sym_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(834),
  },
  [254] = {
    [sym_named_expression] = STATE(698),
    [sym_expression_list] = STATE(1012),
    [sym__expression] = STATE(698),
    [sym__primary_expression] = STATE(383),
    [sym_not_operator] = STATE(698),
    [sym_boolean_operator] = STATE(698),
    [sym_binary_operator] = STATE(383),
    [sym_unary_operator] = STATE(383),
    [sym_comparison_operator] = STATE(698),
    [sym_lambda] = STATE(698),
    [sym_attribute] = STATE(383),
    [sym_subscript] = STATE(383),
    [sym_call] = STATE(383),
    [sym_list] = STATE(383),
    [sym_list_comprehension] = STATE(383),
    [sym_dictionary] = STATE(383),
    [sym_dictionary_comprehension] = STATE(383),
    [sym_set] = STATE(383),
    [sym_set_comprehension] = STATE(383),
    [sym_parenthesized_expression] = STATE(383),
    [sym_tuple] = STATE(383),
    [sym_generator_expression] = STATE(383),
    [sym_conditional_expression] = STATE(698),
    [sym_concatenated_string] = STATE(383),
    [sym_string] = STATE(381),
    [sym_await] = STATE(698),
    [sym_identifier] = ACTIONS(387),
    [anon_sym_LPAREN] = ACTIONS(389),
    [anon_sym_print] = ACTIONS(393),
    [anon_sym_exec] = ACTIONS(393),
    [anon_sym_not] = ACTIONS(361),
    [anon_sym_PLUS] = ACTIONS(363),
    [anon_sym_DASH] = ACTIONS(363),
    [anon_sym_TILDE] = ACTIONS(363),
    [anon_sym_lambda] = ACTIONS(365),
    [anon_sym_LBRACK] = ACTIONS(367),
    [sym_ellipsis] = ACTIONS(369),
    [anon_sym_LBRACE] = ACTIONS(371),
    [sym_integer] = ACTIONS(373),
    [sym_float] = ACTIONS(369),
    [sym_true] = ACTIONS(373),
    [sym_false] = ACTIONS(373),
    [sym_none] = ACTIONS(373),
    [anon_sym_await] = ACTIONS(375),
    [sym_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(377),
  },
  [255] = {
    [sym_named_expression] = STATE(682),
    [sym__expression] = STATE(682),
    [sym__primary_expression] = STATE(383),
    [sym_not_operator] = STATE(682),
    [sym_boolean_operator] = STATE(682),
    [sym_binary_operator] = STATE(383),
    [sym_unary_operator] = STATE(383),
    [sym_comparison_operator] = STATE(682),
    [sym_lambda] = STATE(682),
    [sym_attribute] = STATE(383),
    [sym_subscript] = STATE(383),
    [sym_call] = STATE(383),
    [sym_type] = STATE(1011),
    [sym_list] = STATE(383),
    [sym_list_comprehension] = STATE(383),
    [sym_dictionary] = STATE(383),
    [sym_dictionary_comprehension] = STATE(383),
    [sym_set] = STATE(383),
    [sym_set_comprehension] = STATE(383),
    [sym_parenthesized_expression] = STATE(383),
    [sym_tuple] = STATE(383),
    [sym_generator_expression] = STATE(383),
    [sym_conditional_expression] = STATE(682),
    [sym_concatenated_string] = STATE(383),
    [sym_string] = STATE(381),
    [sym_await] = STATE(682),
    [sym_identifier] = ACTIONS(387),
    [anon_sym_LPAREN] = ACTIONS(389),
    [anon_sym_print] = ACTIONS(393),
    [anon_sym_exec] = ACTIONS(393),
    [anon_sym_not] = ACTIONS(361),
    [anon_sym_PLUS] = ACTIONS(363),
    [anon_sym_DASH] = ACTIONS(363),
    [anon_sym_TILDE] = ACTIONS(363),
    [anon_sym_lambda] = ACTIONS(365),
    [anon_sym_LBRACK] = ACTIONS(367),
    [sym_ellipsis] = ACTIONS(369),
    [anon_sym_LBRACE] = ACTIONS(371),
    [sym_integer] = ACTIONS(373),
    [sym_float] = ACTIONS(369),
    [sym_true] = ACTIONS(373),
    [sym_false] = ACTIONS(373),
    [sym_none] = ACTIONS(373),
    [anon_sym_await] = ACTIONS(375),
    [sym_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(377),
  },
  [256] = {
    [sym_identifier] = ACTIONS(836),
    [anon_sym_import] = ACTIONS(836),
    [anon_sym_from] = ACTIONS(836),
    [anon_sym_LPAREN] = ACTIONS(838),
    [anon_sym_print] = ACTIONS(836),
    [anon_sym_assert] = ACTIONS(836),
    [anon_sym_return] = ACTIONS(836),
    [anon_sym_del] = ACTIONS(836),
    [anon_sym_raise] = ACTIONS(836),
    [anon_sym_pass] = ACTIONS(836),
    [anon_sym_break] = ACTIONS(836),
    [anon_sym_continue] = ACTIONS(836),
    [anon_sym_if] = ACTIONS(836),
    [anon_sym_elif] = ACTIONS(836),
    [anon_sym_else] = ACTIONS(836),
    [anon_sym_async] = ACTIONS(836),
    [anon_sym_for] = ACTIONS(836),
    [anon_sym_while] = ACTIONS(836),
    [anon_sym_try] = ACTIONS(836),
    [anon_sym_except] = ACTIONS(836),
    [anon_sym_finally] = ACTIONS(836),
    [anon_sym_with] = ACTIONS(836),
    [anon_sym_def] = ACTIONS(836),
    [anon_sym_global] = ACTIONS(836),
    [anon_sym_nonlocal] = ACTIONS(836),
    [anon_sym_exec] = ACTIONS(836),
    [anon_sym_class] = ACTIONS(836),
    [anon_sym_AT] = ACTIONS(838),
    [anon_sym_not] = ACTIONS(836),
    [anon_sym_PLUS] = ACTIONS(838),
    [anon_sym_DASH] = ACTIONS(838),
    [anon_sym_TILDE] = ACTIONS(838),
    [anon_sym_lambda] = ACTIONS(836),
    [anon_sym_yield] = ACTIONS(836),
    [anon_sym_LBRACK] = ACTIONS(838),
    [sym_ellipsis] = ACTIONS(838),
    [anon_sym_LBRACE] = ACTIONS(838),
    [sym_integer] = ACTIONS(836),
    [sym_float] = ACTIONS(838),
    [sym_true] = ACTIONS(836),
    [sym_false] = ACTIONS(836),
    [sym_none] = ACTIONS(836),
    [anon_sym_await] = ACTIONS(836),
    [sym_comment] = ACTIONS(3),
    [sym__dedent] = ACTIONS(838),
    [sym__string_start] = ACTIONS(838),
  },
  [257] = {
    [ts_builtin_sym_end] = ACTIONS(840),
    [sym_identifier] = ACTIONS(842),
    [anon_sym_import] = ACTIONS(842),
    [anon_sym_from] = ACTIONS(842),
    [anon_sym_LPAREN] = ACTIONS(840),
    [anon_sym_print] = ACTIONS(842),
    [anon_sym_assert] = ACTIONS(842),
    [anon_sym_return] = ACTIONS(842),
    [anon_sym_del] = ACTIONS(842),
    [anon_sym_raise] = ACTIONS(842),
    [anon_sym_pass] = ACTIONS(842),
    [anon_sym_break] = ACTIONS(842),
    [anon_sym_continue] = ACTIONS(842),
    [anon_sym_if] = ACTIONS(842),
    [anon_sym_elif] = ACTIONS(842),
    [anon_sym_else] = ACTIONS(842),
    [anon_sym_async] = ACTIONS(842),
    [anon_sym_for] = ACTIONS(842),
    [anon_sym_while] = ACTIONS(842),
    [anon_sym_try] = ACTIONS(842),
    [anon_sym_except] = ACTIONS(842),
    [anon_sym_finally] = ACTIONS(842),
    [anon_sym_with] = ACTIONS(842),
    [anon_sym_def] = ACTIONS(842),
    [anon_sym_global] = ACTIONS(842),
    [anon_sym_nonlocal] = ACTIONS(842),
    [anon_sym_exec] = ACTIONS(842),
    [anon_sym_class] = ACTIONS(842),
    [anon_sym_AT] = ACTIONS(840),
    [anon_sym_not] = ACTIONS(842),
    [anon_sym_PLUS] = ACTIONS(840),
    [anon_sym_DASH] = ACTIONS(840),
    [anon_sym_TILDE] = ACTIONS(840),
    [anon_sym_lambda] = ACTIONS(842),
    [anon_sym_yield] = ACTIONS(842),
    [anon_sym_LBRACK] = ACTIONS(840),
    [sym_ellipsis] = ACTIONS(840),
    [anon_sym_LBRACE] = ACTIONS(840),
    [sym_integer] = ACTIONS(842),
    [sym_float] = ACTIONS(840),
    [sym_true] = ACTIONS(842),
    [sym_false] = ACTIONS(842),
    [sym_none] = ACTIONS(842),
    [anon_sym_await] = ACTIONS(842),
    [sym_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(840),
  },
  [258] = {
    [sym_named_expression] = STATE(599),
    [sym_expression_list] = STATE(925),
    [sym__expression] = STATE(599),
    [sym__primary_expression] = STATE(109),
    [sym_not_operator] = STATE(599),
    [sym_boolean_operator] = STATE(599),
    [sym_binary_operator] = STATE(109),
    [sym_unary_operator] = STATE(109),
    [sym_comparison_operator] = STATE(599),
    [sym_lambda] = STATE(599),
    [sym_attribute] = STATE(109),
    [sym_subscript] = STATE(109),
    [sym_call] = STATE(109),
    [sym_list] = STATE(109),
    [sym_list_comprehension] = STATE(109),
    [sym_dictionary] = STATE(109),
    [sym_dictionary_comprehension] = STATE(109),
    [sym_set] = STATE(109),
    [sym_set_comprehension] = STATE(109),
    [sym_parenthesized_expression] = STATE(109),
    [sym_tuple] = STATE(109),
    [sym_generator_expression] = STATE(109),
    [sym_conditional_expression] = STATE(599),
    [sym_concatenated_string] = STATE(109),
    [sym_string] = STATE(117),
    [sym_await] = STATE(599),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(13),
    [anon_sym_print] = ACTIONS(237),
    [anon_sym_exec] = ACTIONS(237),
    [anon_sym_not] = ACTIONS(55),
    [anon_sym_PLUS] = ACTIONS(57),
    [anon_sym_DASH] = ACTIONS(57),
    [anon_sym_TILDE] = ACTIONS(57),
    [anon_sym_lambda] = ACTIONS(59),
    [anon_sym_LBRACK] = ACTIONS(63),
    [sym_ellipsis] = ACTIONS(65),
    [anon_sym_LBRACE] = ACTIONS(67),
    [sym_integer] = ACTIONS(69),
    [sym_float] = ACTIONS(65),
    [sym_true] = ACTIONS(69),
    [sym_false] = ACTIONS(69),
    [sym_none] = ACTIONS(69),
    [anon_sym_await] = ACTIONS(71),
    [sym_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(73),
  },
  [259] = {
    [sym_named_expression] = STATE(682),
    [sym__expression] = STATE(682),
    [sym__primary_expression] = STATE(383),
    [sym_not_operator] = STATE(682),
    [sym_boolean_operator] = STATE(682),
    [sym_binary_operator] = STATE(383),
    [sym_unary_operator] = STATE(383),
    [sym_comparison_operator] = STATE(682),
    [sym_lambda] = STATE(682),
    [sym_attribute] = STATE(383),
    [sym_subscript] = STATE(383),
    [sym_call] = STATE(383),
    [sym_type] = STATE(1009),
    [sym_list] = STATE(383),
    [sym_list_comprehension] = STATE(383),
    [sym_dictionary] = STATE(383),
    [sym_dictionary_comprehension] = STATE(383),
    [sym_set] = STATE(383),
    [sym_set_comprehension] = STATE(383),
    [sym_parenthesized_expression] = STATE(383),
    [sym_tuple] = STATE(383),
    [sym_generator_expression] = STATE(383),
    [sym_conditional_expression] = STATE(682),
    [sym_concatenated_string] = STATE(383),
    [sym_string] = STATE(381),
    [sym_await] = STATE(682),
    [sym_identifier] = ACTIONS(387),
    [anon_sym_LPAREN] = ACTIONS(389),
    [anon_sym_print] = ACTIONS(393),
    [anon_sym_exec] = ACTIONS(393),
    [anon_sym_not] = ACTIONS(361),
    [anon_sym_PLUS] = ACTIONS(363),
    [anon_sym_DASH] = ACTIONS(363),
    [anon_sym_TILDE] = ACTIONS(363),
    [anon_sym_lambda] = ACTIONS(365),
    [anon_sym_LBRACK] = ACTIONS(367),
    [sym_ellipsis] = ACTIONS(369),
    [anon_sym_LBRACE] = ACTIONS(371),
    [sym_integer] = ACTIONS(373),
    [sym_float] = ACTIONS(369),
    [sym_true] = ACTIONS(373),
    [sym_false] = ACTIONS(373),
    [sym_none] = ACTIONS(373),
    [anon_sym_await] = ACTIONS(375),
    [sym_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(377),
  },
  [260] = {
    [sym_identifier] = ACTIONS(844),
    [anon_sym_import] = ACTIONS(844),
    [anon_sym_from] = ACTIONS(844),
    [anon_sym_LPAREN] = ACTIONS(846),
    [anon_sym_print] = ACTIONS(844),
    [anon_sym_assert] = ACTIONS(844),
    [anon_sym_return] = ACTIONS(844),
    [anon_sym_del] = ACTIONS(844),
    [anon_sym_raise] = ACTIONS(844),
    [anon_sym_pass] = ACTIONS(844),
    [anon_sym_break] = ACTIONS(844),
    [anon_sym_continue] = ACTIONS(844),
    [anon_sym_if] = ACTIONS(844),
    [anon_sym_elif] = ACTIONS(844),
    [anon_sym_else] = ACTIONS(844),
    [anon_sym_async] = ACTIONS(844),
    [anon_sym_for] = ACTIONS(844),
    [anon_sym_while] = ACTIONS(844),
    [anon_sym_try] = ACTIONS(844),
    [anon_sym_except] = ACTIONS(844),
    [anon_sym_finally] = ACTIONS(844),
    [anon_sym_with] = ACTIONS(844),
    [anon_sym_def] = ACTIONS(844),
    [anon_sym_global] = ACTIONS(844),
    [anon_sym_nonlocal] = ACTIONS(844),
    [anon_sym_exec] = ACTIONS(844),
    [anon_sym_class] = ACTIONS(844),
    [anon_sym_AT] = ACTIONS(846),
    [anon_sym_not] = ACTIONS(844),
    [anon_sym_PLUS] = ACTIONS(846),
    [anon_sym_DASH] = ACTIONS(846),
    [anon_sym_TILDE] = ACTIONS(846),
    [anon_sym_lambda] = ACTIONS(844),
    [anon_sym_yield] = ACTIONS(844),
    [anon_sym_LBRACK] = ACTIONS(846),
    [sym_ellipsis] = ACTIONS(846),
    [anon_sym_LBRACE] = ACTIONS(846),
    [sym_integer] = ACTIONS(844),
    [sym_float] = ACTIONS(846),
    [sym_true] = ACTIONS(844),
    [sym_false] = ACTIONS(844),
    [sym_none] = ACTIONS(844),
    [anon_sym_await] = ACTIONS(844),
    [sym_comment] = ACTIONS(3),
    [sym__dedent] = ACTIONS(846),
    [sym__string_start] = ACTIONS(846),
  },
  [261] = {
    [sym_identifier] = ACTIONS(848),
    [anon_sym_import] = ACTIONS(848),
    [anon_sym_from] = ACTIONS(848),
    [anon_sym_LPAREN] = ACTIONS(850),
    [anon_sym_print] = ACTIONS(848),
    [anon_sym_assert] = ACTIONS(848),
    [anon_sym_return] = ACTIONS(848),
    [anon_sym_del] = ACTIONS(848),
    [anon_sym_raise] = ACTIONS(848),
    [anon_sym_pass] = ACTIONS(848),
    [anon_sym_break] = ACTIONS(848),
    [anon_sym_continue] = ACTIONS(848),
    [anon_sym_if] = ACTIONS(848),
    [anon_sym_elif] = ACTIONS(848),
    [anon_sym_else] = ACTIONS(848),
    [anon_sym_async] = ACTIONS(848),
    [anon_sym_for] = ACTIONS(848),
    [anon_sym_while] = ACTIONS(848),
    [anon_sym_try] = ACTIONS(848),
    [anon_sym_except] = ACTIONS(848),
    [anon_sym_finally] = ACTIONS(848),
    [anon_sym_with] = ACTIONS(848),
    [anon_sym_def] = ACTIONS(848),
    [anon_sym_global] = ACTIONS(848),
    [anon_sym_nonlocal] = ACTIONS(848),
    [anon_sym_exec] = ACTIONS(848),
    [anon_sym_class] = ACTIONS(848),
    [anon_sym_AT] = ACTIONS(850),
    [anon_sym_not] = ACTIONS(848),
    [anon_sym_PLUS] = ACTIONS(850),
    [anon_sym_DASH] = ACTIONS(850),
    [anon_sym_TILDE] = ACTIONS(850),
    [anon_sym_lambda] = ACTIONS(848),
    [anon_sym_yield] = ACTIONS(848),
    [anon_sym_LBRACK] = ACTIONS(850),
    [sym_ellipsis] = ACTIONS(850),
    [anon_sym_LBRACE] = ACTIONS(850),
    [sym_integer] = ACTIONS(848),
    [sym_float] = ACTIONS(850),
    [sym_true] = ACTIONS(848),
    [sym_false] = ACTIONS(848),
    [sym_none] = ACTIONS(848),
    [anon_sym_await] = ACTIONS(848),
    [sym_comment] = ACTIONS(3),
    [sym__dedent] = ACTIONS(850),
    [sym__string_start] = ACTIONS(850),
  },
  [262] = {
    [sym_identifier] = ACTIONS(852),
    [anon_sym_import] = ACTIONS(852),
    [anon_sym_from] = ACTIONS(852),
    [anon_sym_LPAREN] = ACTIONS(854),
    [anon_sym_print] = ACTIONS(852),
    [anon_sym_assert] = ACTIONS(852),
    [anon_sym_return] = ACTIONS(852),
    [anon_sym_del] = ACTIONS(852),
    [anon_sym_raise] = ACTIONS(852),
    [anon_sym_pass] = ACTIONS(852),
    [anon_sym_break] = ACTIONS(852),
    [anon_sym_continue] = ACTIONS(852),
    [anon_sym_if] = ACTIONS(852),
    [anon_sym_elif] = ACTIONS(852),
    [anon_sym_else] = ACTIONS(852),
    [anon_sym_async] = ACTIONS(852),
    [anon_sym_for] = ACTIONS(852),
    [anon_sym_while] = ACTIONS(852),
    [anon_sym_try] = ACTIONS(852),
    [anon_sym_except] = ACTIONS(852),
    [anon_sym_finally] = ACTIONS(852),
    [anon_sym_with] = ACTIONS(852),
    [anon_sym_def] = ACTIONS(852),
    [anon_sym_global] = ACTIONS(852),
    [anon_sym_nonlocal] = ACTIONS(852),
    [anon_sym_exec] = ACTIONS(852),
    [anon_sym_class] = ACTIONS(852),
    [anon_sym_AT] = ACTIONS(854),
    [anon_sym_not] = ACTIONS(852),
    [anon_sym_PLUS] = ACTIONS(854),
    [anon_sym_DASH] = ACTIONS(854),
    [anon_sym_TILDE] = ACTIONS(854),
    [anon_sym_lambda] = ACTIONS(852),
    [anon_sym_yield] = ACTIONS(852),
    [anon_sym_LBRACK] = ACTIONS(854),
    [sym_ellipsis] = ACTIONS(854),
    [anon_sym_LBRACE] = ACTIONS(854),
    [sym_integer] = ACTIONS(852),
    [sym_float] = ACTIONS(854),
    [sym_true] = ACTIONS(852),
    [sym_false] = ACTIONS(852),
    [sym_none] = ACTIONS(852),
    [anon_sym_await] = ACTIONS(852),
    [sym_comment] = ACTIONS(3),
    [sym__dedent] = ACTIONS(854),
    [sym__string_start] = ACTIONS(854),
  },
  [263] = {
    [ts_builtin_sym_end] = ACTIONS(854),
    [sym_identifier] = ACTIONS(852),
    [anon_sym_import] = ACTIONS(852),
    [anon_sym_from] = ACTIONS(852),
    [anon_sym_LPAREN] = ACTIONS(854),
    [anon_sym_print] = ACTIONS(852),
    [anon_sym_assert] = ACTIONS(852),
    [anon_sym_return] = ACTIONS(852),
    [anon_sym_del] = ACTIONS(852),
    [anon_sym_raise] = ACTIONS(852),
    [anon_sym_pass] = ACTIONS(852),
    [anon_sym_break] = ACTIONS(852),
    [anon_sym_continue] = ACTIONS(852),
    [anon_sym_if] = ACTIONS(852),
    [anon_sym_elif] = ACTIONS(852),
    [anon_sym_else] = ACTIONS(852),
    [anon_sym_async] = ACTIONS(852),
    [anon_sym_for] = ACTIONS(852),
    [anon_sym_while] = ACTIONS(852),
    [anon_sym_try] = ACTIONS(852),
    [anon_sym_except] = ACTIONS(852),
    [anon_sym_finally] = ACTIONS(852),
    [anon_sym_with] = ACTIONS(852),
    [anon_sym_def] = ACTIONS(852),
    [anon_sym_global] = ACTIONS(852),
    [anon_sym_nonlocal] = ACTIONS(852),
    [anon_sym_exec] = ACTIONS(852),
    [anon_sym_class] = ACTIONS(852),
    [anon_sym_AT] = ACTIONS(854),
    [anon_sym_not] = ACTIONS(852),
    [anon_sym_PLUS] = ACTIONS(854),
    [anon_sym_DASH] = ACTIONS(854),
    [anon_sym_TILDE] = ACTIONS(854),
    [anon_sym_lambda] = ACTIONS(852),
    [anon_sym_yield] = ACTIONS(852),
    [anon_sym_LBRACK] = ACTIONS(854),
    [sym_ellipsis] = ACTIONS(854),
    [anon_sym_LBRACE] = ACTIONS(854),
    [sym_integer] = ACTIONS(852),
    [sym_float] = ACTIONS(854),
    [sym_true] = ACTIONS(852),
    [sym_false] = ACTIONS(852),
    [sym_none] = ACTIONS(852),
    [anon_sym_await] = ACTIONS(852),
    [sym_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(854),
  },
  [264] = {
    [sym_identifier] = ACTIONS(842),
    [anon_sym_import] = ACTIONS(842),
    [anon_sym_from] = ACTIONS(842),
    [anon_sym_LPAREN] = ACTIONS(840),
    [anon_sym_print] = ACTIONS(842),
    [anon_sym_assert] = ACTIONS(842),
    [anon_sym_return] = ACTIONS(842),
    [anon_sym_del] = ACTIONS(842),
    [anon_sym_raise] = ACTIONS(842),
    [anon_sym_pass] = ACTIONS(842),
    [anon_sym_break] = ACTIONS(842),
    [anon_sym_continue] = ACTIONS(842),
    [anon_sym_if] = ACTIONS(842),
    [anon_sym_elif] = ACTIONS(842),
    [anon_sym_else] = ACTIONS(842),
    [anon_sym_async] = ACTIONS(842),
    [anon_sym_for] = ACTIONS(842),
    [anon_sym_while] = ACTIONS(842),
    [anon_sym_try] = ACTIONS(842),
    [anon_sym_except] = ACTIONS(842),
    [anon_sym_finally] = ACTIONS(842),
    [anon_sym_with] = ACTIONS(842),
    [anon_sym_def] = ACTIONS(842),
    [anon_sym_global] = ACTIONS(842),
    [anon_sym_nonlocal] = ACTIONS(842),
    [anon_sym_exec] = ACTIONS(842),
    [anon_sym_class] = ACTIONS(842),
    [anon_sym_AT] = ACTIONS(840),
    [anon_sym_not] = ACTIONS(842),
    [anon_sym_PLUS] = ACTIONS(840),
    [anon_sym_DASH] = ACTIONS(840),
    [anon_sym_TILDE] = ACTIONS(840),
    [anon_sym_lambda] = ACTIONS(842),
    [anon_sym_yield] = ACTIONS(842),
    [anon_sym_LBRACK] = ACTIONS(840),
    [sym_ellipsis] = ACTIONS(840),
    [anon_sym_LBRACE] = ACTIONS(840),
    [sym_integer] = ACTIONS(842),
    [sym_float] = ACTIONS(840),
    [sym_true] = ACTIONS(842),
    [sym_false] = ACTIONS(842),
    [sym_none] = ACTIONS(842),
    [anon_sym_await] = ACTIONS(842),
    [sym_comment] = ACTIONS(3),
    [sym__dedent] = ACTIONS(840),
    [sym__string_start] = ACTIONS(840),
  },
  [265] = {
    [sym_named_expression] = STATE(698),
    [sym_expression_list] = STATE(1007),
    [sym__expression] = STATE(698),
    [sym__primary_expression] = STATE(383),
    [sym_not_operator] = STATE(698),
    [sym_boolean_operator] = STATE(698),
    [sym_binary_operator] = STATE(383),
    [sym_unary_operator] = STATE(383),
    [sym_comparison_operator] = STATE(698),
    [sym_lambda] = STATE(698),
    [sym_attribute] = STATE(383),
    [sym_subscript] = STATE(383),
    [sym_call] = STATE(383),
    [sym_list] = STATE(383),
    [sym_list_comprehension] = STATE(383),
    [sym_dictionary] = STATE(383),
    [sym_dictionary_comprehension] = STATE(383),
    [sym_set] = STATE(383),
    [sym_set_comprehension] = STATE(383),
    [sym_parenthesized_expression] = STATE(383),
    [sym_tuple] = STATE(383),
    [sym_generator_expression] = STATE(383),
    [sym_conditional_expression] = STATE(698),
    [sym_concatenated_string] = STATE(383),
    [sym_string] = STATE(381),
    [sym_await] = STATE(698),
    [sym_identifier] = ACTIONS(387),
    [anon_sym_LPAREN] = ACTIONS(389),
    [anon_sym_print] = ACTIONS(393),
    [anon_sym_exec] = ACTIONS(393),
    [anon_sym_not] = ACTIONS(361),
    [anon_sym_PLUS] = ACTIONS(363),
    [anon_sym_DASH] = ACTIONS(363),
    [anon_sym_TILDE] = ACTIONS(363),
    [anon_sym_lambda] = ACTIONS(365),
    [anon_sym_LBRACK] = ACTIONS(367),
    [sym_ellipsis] = ACTIONS(369),
    [anon_sym_LBRACE] = ACTIONS(371),
    [sym_integer] = ACTIONS(373),
    [sym_float] = ACTIONS(369),
    [sym_true] = ACTIONS(373),
    [sym_false] = ACTIONS(373),
    [sym_none] = ACTIONS(373),
    [anon_sym_await] = ACTIONS(375),
    [sym_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(377),
  },
  [266] = {
    [sym_named_expression] = STATE(698),
    [sym_expression_list] = STATE(1003),
    [sym__expression] = STATE(698),
    [sym__primary_expression] = STATE(383),
    [sym_not_operator] = STATE(698),
    [sym_boolean_operator] = STATE(698),
    [sym_binary_operator] = STATE(383),
    [sym_unary_operator] = STATE(383),
    [sym_comparison_operator] = STATE(698),
    [sym_lambda] = STATE(698),
    [sym_attribute] = STATE(383),
    [sym_subscript] = STATE(383),
    [sym_call] = STATE(383),
    [sym_list] = STATE(383),
    [sym_list_comprehension] = STATE(383),
    [sym_dictionary] = STATE(383),
    [sym_dictionary_comprehension] = STATE(383),
    [sym_set] = STATE(383),
    [sym_set_comprehension] = STATE(383),
    [sym_parenthesized_expression] = STATE(383),
    [sym_tuple] = STATE(383),
    [sym_generator_expression] = STATE(383),
    [sym_conditional_expression] = STATE(698),
    [sym_concatenated_string] = STATE(383),
    [sym_string] = STATE(381),
    [sym_await] = STATE(698),
    [sym_identifier] = ACTIONS(387),
    [anon_sym_LPAREN] = ACTIONS(389),
    [anon_sym_print] = ACTIONS(393),
    [anon_sym_exec] = ACTIONS(393),
    [anon_sym_not] = ACTIONS(361),
    [anon_sym_PLUS] = ACTIONS(363),
    [anon_sym_DASH] = ACTIONS(363),
    [anon_sym_TILDE] = ACTIONS(363),
    [anon_sym_lambda] = ACTIONS(365),
    [anon_sym_LBRACK] = ACTIONS(367),
    [sym_ellipsis] = ACTIONS(369),
    [anon_sym_LBRACE] = ACTIONS(371),
    [sym_integer] = ACTIONS(373),
    [sym_float] = ACTIONS(369),
    [sym_true] = ACTIONS(373),
    [sym_false] = ACTIONS(373),
    [sym_none] = ACTIONS(373),
    [anon_sym_await] = ACTIONS(375),
    [sym_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(377),
  },
  [267] = {
    [ts_builtin_sym_end] = ACTIONS(850),
    [sym_identifier] = ACTIONS(848),
    [anon_sym_import] = ACTIONS(848),
    [anon_sym_from] = ACTIONS(848),
    [anon_sym_LPAREN] = ACTIONS(850),
    [anon_sym_print] = ACTIONS(848),
    [anon_sym_assert] = ACTIONS(848),
    [anon_sym_return] = ACTIONS(848),
    [anon_sym_del] = ACTIONS(848),
    [anon_sym_raise] = ACTIONS(848),
    [anon_sym_pass] = ACTIONS(848),
    [anon_sym_break] = ACTIONS(848),
    [anon_sym_continue] = ACTIONS(848),
    [anon_sym_if] = ACTIONS(848),
    [anon_sym_elif] = ACTIONS(848),
    [anon_sym_else] = ACTIONS(848),
    [anon_sym_async] = ACTIONS(848),
    [anon_sym_for] = ACTIONS(848),
    [anon_sym_while] = ACTIONS(848),
    [anon_sym_try] = ACTIONS(848),
    [anon_sym_except] = ACTIONS(848),
    [anon_sym_finally] = ACTIONS(848),
    [anon_sym_with] = ACTIONS(848),
    [anon_sym_def] = ACTIONS(848),
    [anon_sym_global] = ACTIONS(848),
    [anon_sym_nonlocal] = ACTIONS(848),
    [anon_sym_exec] = ACTIONS(848),
    [anon_sym_class] = ACTIONS(848),
    [anon_sym_AT] = ACTIONS(850),
    [anon_sym_not] = ACTIONS(848),
    [anon_sym_PLUS] = ACTIONS(850),
    [anon_sym_DASH] = ACTIONS(850),
    [anon_sym_TILDE] = ACTIONS(850),
    [anon_sym_lambda] = ACTIONS(848),
    [anon_sym_yield] = ACTIONS(848),
    [anon_sym_LBRACK] = ACTIONS(850),
    [sym_ellipsis] = ACTIONS(850),
    [anon_sym_LBRACE] = ACTIONS(850),
    [sym_integer] = ACTIONS(848),
    [sym_float] = ACTIONS(850),
    [sym_true] = ACTIONS(848),
    [sym_false] = ACTIONS(848),
    [sym_none] = ACTIONS(848),
    [anon_sym_await] = ACTIONS(848),
    [sym_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(850),
  },
  [268] = {
    [sym_named_expression] = STATE(722),
    [sym_with_item] = STATE(822),
    [sym__expression] = STATE(722),
    [sym__primary_expression] = STATE(503),
    [sym_not_operator] = STATE(722),
    [sym_boolean_operator] = STATE(722),
    [sym_binary_operator] = STATE(503),
    [sym_unary_operator] = STATE(503),
    [sym_comparison_operator] = STATE(722),
    [sym_lambda] = STATE(722),
    [sym_attribute] = STATE(503),
    [sym_subscript] = STATE(503),
    [sym_call] = STATE(503),
    [sym_list] = STATE(503),
    [sym_list_comprehension] = STATE(503),
    [sym_dictionary] = STATE(503),
    [sym_dictionary_comprehension] = STATE(503),
    [sym_set] = STATE(503),
    [sym_set_comprehension] = STATE(503),
    [sym_parenthesized_expression] = STATE(503),
    [sym_tuple] = STATE(503),
    [sym_generator_expression] = STATE(503),
    [sym_conditional_expression] = STATE(722),
    [sym_concatenated_string] = STATE(503),
    [sym_string] = STATE(505),
    [sym_await] = STATE(722),
    [sym_identifier] = ACTIONS(810),
    [anon_sym_LPAREN] = ACTIONS(812),
    [anon_sym_print] = ACTIONS(814),
    [anon_sym_exec] = ACTIONS(814),
    [anon_sym_not] = ACTIONS(818),
    [anon_sym_PLUS] = ACTIONS(820),
    [anon_sym_DASH] = ACTIONS(820),
    [anon_sym_TILDE] = ACTIONS(820),
    [anon_sym_lambda] = ACTIONS(822),
    [anon_sym_LBRACK] = ACTIONS(824),
    [sym_ellipsis] = ACTIONS(826),
    [anon_sym_LBRACE] = ACTIONS(828),
    [sym_integer] = ACTIONS(830),
    [sym_float] = ACTIONS(826),
    [sym_true] = ACTIONS(830),
    [sym_false] = ACTIONS(830),
    [sym_none] = ACTIONS(830),
    [anon_sym_await] = ACTIONS(832),
    [sym_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(834),
  },
  [269] = {
    [sym_named_expression] = STATE(722),
    [sym_with_item] = STATE(835),
    [sym__expression] = STATE(722),
    [sym__primary_expression] = STATE(503),
    [sym_not_operator] = STATE(722),
    [sym_boolean_operator] = STATE(722),
    [sym_binary_operator] = STATE(503),
    [sym_unary_operator] = STATE(503),
    [sym_comparison_operator] = STATE(722),
    [sym_lambda] = STATE(722),
    [sym_attribute] = STATE(503),
    [sym_subscript] = STATE(503),
    [sym_call] = STATE(503),
    [sym_list] = STATE(503),
    [sym_list_comprehension] = STATE(503),
    [sym_dictionary] = STATE(503),
    [sym_dictionary_comprehension] = STATE(503),
    [sym_set] = STATE(503),
    [sym_set_comprehension] = STATE(503),
    [sym_parenthesized_expression] = STATE(503),
    [sym_tuple] = STATE(503),
    [sym_generator_expression] = STATE(503),
    [sym_conditional_expression] = STATE(722),
    [sym_concatenated_string] = STATE(503),
    [sym_string] = STATE(505),
    [sym_await] = STATE(722),
    [sym_identifier] = ACTIONS(810),
    [anon_sym_LPAREN] = ACTIONS(812),
    [anon_sym_print] = ACTIONS(814),
    [anon_sym_exec] = ACTIONS(814),
    [anon_sym_not] = ACTIONS(818),
    [anon_sym_PLUS] = ACTIONS(820),
    [anon_sym_DASH] = ACTIONS(820),
    [anon_sym_TILDE] = ACTIONS(820),
    [anon_sym_lambda] = ACTIONS(822),
    [anon_sym_LBRACK] = ACTIONS(824),
    [sym_ellipsis] = ACTIONS(826),
    [anon_sym_LBRACE] = ACTIONS(828),
    [sym_integer] = ACTIONS(830),
    [sym_float] = ACTIONS(826),
    [sym_true] = ACTIONS(830),
    [sym_false] = ACTIONS(830),
    [sym_none] = ACTIONS(830),
    [anon_sym_await] = ACTIONS(832),
    [sym_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(834),
  },
  [270] = {
    [sym_named_expression] = STATE(722),
    [sym_with_item] = STATE(879),
    [sym__expression] = STATE(722),
    [sym__primary_expression] = STATE(503),
    [sym_not_operator] = STATE(722),
    [sym_boolean_operator] = STATE(722),
    [sym_binary_operator] = STATE(503),
    [sym_unary_operator] = STATE(503),
    [sym_comparison_operator] = STATE(722),
    [sym_lambda] = STATE(722),
    [sym_attribute] = STATE(503),
    [sym_subscript] = STATE(503),
    [sym_call] = STATE(503),
    [sym_list] = STATE(503),
    [sym_list_comprehension] = STATE(503),
    [sym_dictionary] = STATE(503),
    [sym_dictionary_comprehension] = STATE(503),
    [sym_set] = STATE(503),
    [sym_set_comprehension] = STATE(503),
    [sym_parenthesized_expression] = STATE(503),
    [sym_tuple] = STATE(503),
    [sym_generator_expression] = STATE(503),
    [sym_conditional_expression] = STATE(722),
    [sym_concatenated_string] = STATE(503),
    [sym_string] = STATE(505),
    [sym_await] = STATE(722),
    [sym_identifier] = ACTIONS(810),
    [anon_sym_LPAREN] = ACTIONS(812),
    [anon_sym_print] = ACTIONS(814),
    [anon_sym_exec] = ACTIONS(814),
    [anon_sym_not] = ACTIONS(818),
    [anon_sym_PLUS] = ACTIONS(820),
    [anon_sym_DASH] = ACTIONS(820),
    [anon_sym_TILDE] = ACTIONS(820),
    [anon_sym_lambda] = ACTIONS(822),
    [anon_sym_LBRACK] = ACTIONS(824),
    [sym_ellipsis] = ACTIONS(826),
    [anon_sym_LBRACE] = ACTIONS(828),
    [sym_integer] = ACTIONS(830),
    [sym_float] = ACTIONS(826),
    [sym_true] = ACTIONS(830),
    [sym_false] = ACTIONS(830),
    [sym_none] = ACTIONS(830),
    [anon_sym_await] = ACTIONS(832),
    [sym_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(834),
  },
  [271] = {
    [sym_named_expression] = STATE(682),
    [sym__expression] = STATE(682),
    [sym__primary_expression] = STATE(383),
    [sym_not_operator] = STATE(682),
    [sym_boolean_operator] = STATE(682),
    [sym_binary_operator] = STATE(383),
    [sym_unary_operator] = STATE(383),
    [sym_comparison_operator] = STATE(682),
    [sym_lambda] = STATE(682),
    [sym_attribute] = STATE(383),
    [sym_subscript] = STATE(383),
    [sym_call] = STATE(383),
    [sym_type] = STATE(1020),
    [sym_list] = STATE(383),
    [sym_list_comprehension] = STATE(383),
    [sym_dictionary] = STATE(383),
    [sym_dictionary_comprehension] = STATE(383),
    [sym_set] = STATE(383),
    [sym_set_comprehension] = STATE(383),
    [sym_parenthesized_expression] = STATE(383),
    [sym_tuple] = STATE(383),
    [sym_generator_expression] = STATE(383),
    [sym_conditional_expression] = STATE(682),
    [sym_concatenated_string] = STATE(383),
    [sym_string] = STATE(381),
    [sym_await] = STATE(682),
    [sym_identifier] = ACTIONS(387),
    [anon_sym_LPAREN] = ACTIONS(389),
    [anon_sym_print] = ACTIONS(393),
    [anon_sym_exec] = ACTIONS(393),
    [anon_sym_not] = ACTIONS(361),
    [anon_sym_PLUS] = ACTIONS(363),
    [anon_sym_DASH] = ACTIONS(363),
    [anon_sym_TILDE] = ACTIONS(363),
    [anon_sym_lambda] = ACTIONS(365),
    [anon_sym_LBRACK] = ACTIONS(367),
    [sym_ellipsis] = ACTIONS(369),
    [anon_sym_LBRACE] = ACTIONS(371),
    [sym_integer] = ACTIONS(373),
    [sym_float] = ACTIONS(369),
    [sym_true] = ACTIONS(373),
    [sym_false] = ACTIONS(373),
    [sym_none] = ACTIONS(373),
    [anon_sym_await] = ACTIONS(375),
    [sym_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(377),
  },
  [272] = {
    [sym_named_expression] = STATE(732),
    [sym__expression] = STATE(732),
    [sym__primary_expression] = STATE(109),
    [sym_not_operator] = STATE(732),
    [sym_boolean_operator] = STATE(732),
    [sym_binary_operator] = STATE(109),
    [sym_unary_operator] = STATE(109),
    [sym_comparison_operator] = STATE(732),
    [sym_lambda] = STATE(732),
    [sym_attribute] = STATE(109),
    [sym_subscript] = STATE(109),
    [sym_call] = STATE(109),
    [sym_type] = STATE(815),
    [sym_list] = STATE(109),
    [sym_list_comprehension] = STATE(109),
    [sym_dictionary] = STATE(109),
    [sym_dictionary_comprehension] = STATE(109),
    [sym_set] = STATE(109),
    [sym_set_comprehension] = STATE(109),
    [sym_parenthesized_expression] = STATE(109),
    [sym_tuple] = STATE(109),
    [sym_generator_expression] = STATE(109),
    [sym_conditional_expression] = STATE(732),
    [sym_concatenated_string] = STATE(109),
    [sym_string] = STATE(117),
    [sym_await] = STATE(732),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(13),
    [anon_sym_print] = ACTIONS(237),
    [anon_sym_exec] = ACTIONS(237),
    [anon_sym_not] = ACTIONS(55),
    [anon_sym_PLUS] = ACTIONS(57),
    [anon_sym_DASH] = ACTIONS(57),
    [anon_sym_TILDE] = ACTIONS(57),
    [anon_sym_lambda] = ACTIONS(59),
    [anon_sym_LBRACK] = ACTIONS(63),
    [sym_ellipsis] = ACTIONS(65),
    [anon_sym_LBRACE] = ACTIONS(67),
    [sym_integer] = ACTIONS(69),
    [sym_float] = ACTIONS(65),
    [sym_true] = ACTIONS(69),
    [sym_false] = ACTIONS(69),
    [sym_none] = ACTIONS(69),
    [anon_sym_await] = ACTIONS(71),
    [sym_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(73),
  },
  [273] = {
    [ts_builtin_sym_end] = ACTIONS(838),
    [sym_identifier] = ACTIONS(836),
    [anon_sym_import] = ACTIONS(836),
    [anon_sym_from] = ACTIONS(836),
    [anon_sym_LPAREN] = ACTIONS(838),
    [anon_sym_print] = ACTIONS(836),
    [anon_sym_assert] = ACTIONS(836),
    [anon_sym_return] = ACTIONS(836),
    [anon_sym_del] = ACTIONS(836),
    [anon_sym_raise] = ACTIONS(836),
    [anon_sym_pass] = ACTIONS(836),
    [anon_sym_break] = ACTIONS(836),
    [anon_sym_continue] = ACTIONS(836),
    [anon_sym_if] = ACTIONS(836),
    [anon_sym_elif] = ACTIONS(836),
    [anon_sym_else] = ACTIONS(836),
    [anon_sym_async] = ACTIONS(836),
    [anon_sym_for] = ACTIONS(836),
    [anon_sym_while] = ACTIONS(836),
    [anon_sym_try] = ACTIONS(836),
    [anon_sym_except] = ACTIONS(836),
    [anon_sym_finally] = ACTIONS(836),
    [anon_sym_with] = ACTIONS(836),
    [anon_sym_def] = ACTIONS(836),
    [anon_sym_global] = ACTIONS(836),
    [anon_sym_nonlocal] = ACTIONS(836),
    [anon_sym_exec] = ACTIONS(836),
    [anon_sym_class] = ACTIONS(836),
    [anon_sym_AT] = ACTIONS(838),
    [anon_sym_not] = ACTIONS(836),
    [anon_sym_PLUS] = ACTIONS(838),
    [anon_sym_DASH] = ACTIONS(838),
    [anon_sym_TILDE] = ACTIONS(838),
    [anon_sym_lambda] = ACTIONS(836),
    [anon_sym_yield] = ACTIONS(836),
    [anon_sym_LBRACK] = ACTIONS(838),
    [sym_ellipsis] = ACTIONS(838),
    [anon_sym_LBRACE] = ACTIONS(838),
    [sym_integer] = ACTIONS(836),
    [sym_float] = ACTIONS(838),
    [sym_true] = ACTIONS(836),
    [sym_false] = ACTIONS(836),
    [sym_none] = ACTIONS(836),
    [anon_sym_await] = ACTIONS(836),
    [sym_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(838),
  },
  [274] = {
    [sym_named_expression] = STATE(682),
    [sym__expression] = STATE(682),
    [sym__primary_expression] = STATE(383),
    [sym_not_operator] = STATE(682),
    [sym_boolean_operator] = STATE(682),
    [sym_binary_operator] = STATE(383),
    [sym_unary_operator] = STATE(383),
    [sym_comparison_operator] = STATE(682),
    [sym_lambda] = STATE(682),
    [sym_attribute] = STATE(383),
    [sym_subscript] = STATE(383),
    [sym_call] = STATE(383),
    [sym_type] = STATE(1010),
    [sym_list] = STATE(383),
    [sym_list_comprehension] = STATE(383),
    [sym_dictionary] = STATE(383),
    [sym_dictionary_comprehension] = STATE(383),
    [sym_set] = STATE(383),
    [sym_set_comprehension] = STATE(383),
    [sym_parenthesized_expression] = STATE(383),
    [sym_tuple] = STATE(383),
    [sym_generator_expression] = STATE(383),
    [sym_conditional_expression] = STATE(682),
    [sym_concatenated_string] = STATE(383),
    [sym_string] = STATE(381),
    [sym_await] = STATE(682),
    [sym_identifier] = ACTIONS(387),
    [anon_sym_LPAREN] = ACTIONS(389),
    [anon_sym_print] = ACTIONS(393),
    [anon_sym_exec] = ACTIONS(393),
    [anon_sym_not] = ACTIONS(361),
    [anon_sym_PLUS] = ACTIONS(363),
    [anon_sym_DASH] = ACTIONS(363),
    [anon_sym_TILDE] = ACTIONS(363),
    [anon_sym_lambda] = ACTIONS(365),
    [anon_sym_LBRACK] = ACTIONS(367),
    [sym_ellipsis] = ACTIONS(369),
    [anon_sym_LBRACE] = ACTIONS(371),
    [sym_integer] = ACTIONS(373),
    [sym_float] = ACTIONS(369),
    [sym_true] = ACTIONS(373),
    [sym_false] = ACTIONS(373),
    [sym_none] = ACTIONS(373),
    [anon_sym_await] = ACTIONS(375),
    [sym_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(377),
  },
  [275] = {
    [sym_named_expression] = STATE(722),
    [sym_with_item] = STATE(935),
    [sym__expression] = STATE(722),
    [sym__primary_expression] = STATE(503),
    [sym_not_operator] = STATE(722),
    [sym_boolean_operator] = STATE(722),
    [sym_binary_operator] = STATE(503),
    [sym_unary_operator] = STATE(503),
    [sym_comparison_operator] = STATE(722),
    [sym_lambda] = STATE(722),
    [sym_attribute] = STATE(503),
    [sym_subscript] = STATE(503),
    [sym_call] = STATE(503),
    [sym_list] = STATE(503),
    [sym_list_comprehension] = STATE(503),
    [sym_dictionary] = STATE(503),
    [sym_dictionary_comprehension] = STATE(503),
    [sym_set] = STATE(503),
    [sym_set_comprehension] = STATE(503),
    [sym_parenthesized_expression] = STATE(503),
    [sym_tuple] = STATE(503),
    [sym_generator_expression] = STATE(503),
    [sym_conditional_expression] = STATE(722),
    [sym_concatenated_string] = STATE(503),
    [sym_string] = STATE(505),
    [sym_await] = STATE(722),
    [sym_identifier] = ACTIONS(810),
    [anon_sym_LPAREN] = ACTIONS(812),
    [anon_sym_print] = ACTIONS(814),
    [anon_sym_exec] = ACTIONS(814),
    [anon_sym_not] = ACTIONS(818),
    [anon_sym_PLUS] = ACTIONS(820),
    [anon_sym_DASH] = ACTIONS(820),
    [anon_sym_TILDE] = ACTIONS(820),
    [anon_sym_lambda] = ACTIONS(822),
    [anon_sym_LBRACK] = ACTIONS(824),
    [sym_ellipsis] = ACTIONS(826),
    [anon_sym_LBRACE] = ACTIONS(828),
    [sym_integer] = ACTIONS(830),
    [sym_float] = ACTIONS(826),
    [sym_true] = ACTIONS(830),
    [sym_false] = ACTIONS(830),
    [sym_none] = ACTIONS(830),
    [anon_sym_await] = ACTIONS(832),
    [sym_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(834),
  },
  [276] = {
    [sym_named_expression] = STATE(731),
    [sym__expression] = STATE(731),
    [sym__primary_expression] = STATE(503),
    [sym_not_operator] = STATE(731),
    [sym_boolean_operator] = STATE(731),
    [sym_binary_operator] = STATE(503),
    [sym_unary_operator] = STATE(503),
    [sym_comparison_operator] = STATE(731),
    [sym_lambda] = STATE(731),
    [sym_attribute] = STATE(503),
    [sym_subscript] = STATE(503),
    [sym_call] = STATE(503),
    [sym_list] = STATE(503),
    [sym_list_comprehension] = STATE(503),
    [sym_dictionary] = STATE(503),
    [sym_dictionary_comprehension] = STATE(503),
    [sym_set] = STATE(503),
    [sym_set_comprehension] = STATE(503),
    [sym_parenthesized_expression] = STATE(503),
    [sym_tuple] = STATE(503),
    [sym_generator_expression] = STATE(503),
    [sym_conditional_expression] = STATE(731),
    [sym_concatenated_string] = STATE(503),
    [sym_string] = STATE(505),
    [sym_await] = STATE(731),
    [sym_identifier] = ACTIONS(810),
    [anon_sym_LPAREN] = ACTIONS(812),
    [anon_sym_print] = ACTIONS(814),
    [anon_sym_COLON] = ACTIONS(856),
    [anon_sym_exec] = ACTIONS(814),
    [anon_sym_not] = ACTIONS(818),
    [anon_sym_PLUS] = ACTIONS(820),
    [anon_sym_DASH] = ACTIONS(820),
    [anon_sym_TILDE] = ACTIONS(820),
    [anon_sym_lambda] = ACTIONS(822),
    [anon_sym_LBRACK] = ACTIONS(824),
    [sym_ellipsis] = ACTIONS(826),
    [anon_sym_LBRACE] = ACTIONS(828),
    [sym_integer] = ACTIONS(830),
    [sym_float] = ACTIONS(826),
    [sym_true] = ACTIONS(830),
    [sym_false] = ACTIONS(830),
    [sym_none] = ACTIONS(830),
    [anon_sym_await] = ACTIONS(832),
    [sym_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(834),
  },
  [277] = {
    [sym_elif_clause] = STATE(362),
    [aux_sym_if_statement_repeat1] = STATE(277),
    [ts_builtin_sym_end] = ACTIONS(858),
    [sym_identifier] = ACTIONS(860),
    [anon_sym_import] = ACTIONS(860),
    [anon_sym_from] = ACTIONS(860),
    [anon_sym_LPAREN] = ACTIONS(858),
    [anon_sym_print] = ACTIONS(860),
    [anon_sym_assert] = ACTIONS(860),
    [anon_sym_return] = ACTIONS(860),
    [anon_sym_del] = ACTIONS(860),
    [anon_sym_raise] = ACTIONS(860),
    [anon_sym_pass] = ACTIONS(860),
    [anon_sym_break] = ACTIONS(860),
    [anon_sym_continue] = ACTIONS(860),
    [anon_sym_if] = ACTIONS(860),
    [anon_sym_elif] = ACTIONS(862),
    [anon_sym_else] = ACTIONS(860),
    [anon_sym_async] = ACTIONS(860),
    [anon_sym_for] = ACTIONS(860),
    [anon_sym_while] = ACTIONS(860),
    [anon_sym_try] = ACTIONS(860),
    [anon_sym_with] = ACTIONS(860),
    [anon_sym_def] = ACTIONS(860),
    [anon_sym_global] = ACTIONS(860),
    [anon_sym_nonlocal] = ACTIONS(860),
    [anon_sym_exec] = ACTIONS(860),
    [anon_sym_class] = ACTIONS(860),
    [anon_sym_AT] = ACTIONS(858),
    [anon_sym_not] = ACTIONS(860),
    [anon_sym_PLUS] = ACTIONS(858),
    [anon_sym_DASH] = ACTIONS(858),
    [anon_sym_TILDE] = ACTIONS(858),
    [anon_sym_lambda] = ACTIONS(860),
    [anon_sym_yield] = ACTIONS(860),
    [anon_sym_LBRACK] = ACTIONS(858),
    [sym_ellipsis] = ACTIONS(858),
    [anon_sym_LBRACE] = ACTIONS(858),
    [sym_integer] = ACTIONS(860),
    [sym_float] = ACTIONS(858),
    [sym_true] = ACTIONS(860),
    [sym_false] = ACTIONS(860),
    [sym_none] = ACTIONS(860),
    [anon_sym_await] = ACTIONS(860),
    [sym_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(858),
  },
  [278] = {
    [sym_named_expression] = STATE(682),
    [sym__expression] = STATE(682),
    [sym__primary_expression] = STATE(383),
    [sym_not_operator] = STATE(682),
    [sym_boolean_operator] = STATE(682),
    [sym_binary_operator] = STATE(383),
    [sym_unary_operator] = STATE(383),
    [sym_comparison_operator] = STATE(682),
    [sym_lambda] = STATE(682),
    [sym_attribute] = STATE(383),
    [sym_subscript] = STATE(383),
    [sym_call] = STATE(383),
    [sym_type] = STATE(955),
    [sym_list] = STATE(383),
    [sym_list_comprehension] = STATE(383),
    [sym_dictionary] = STATE(383),
    [sym_dictionary_comprehension] = STATE(383),
    [sym_set] = STATE(383),
    [sym_set_comprehension] = STATE(383),
    [sym_parenthesized_expression] = STATE(383),
    [sym_tuple] = STATE(383),
    [sym_generator_expression] = STATE(383),
    [sym_conditional_expression] = STATE(682),
    [sym_concatenated_string] = STATE(383),
    [sym_string] = STATE(381),
    [sym_await] = STATE(682),
    [sym_identifier] = ACTIONS(387),
    [anon_sym_LPAREN] = ACTIONS(389),
    [anon_sym_print] = ACTIONS(393),
    [anon_sym_exec] = ACTIONS(393),
    [anon_sym_not] = ACTIONS(361),
    [anon_sym_PLUS] = ACTIONS(363),
    [anon_sym_DASH] = ACTIONS(363),
    [anon_sym_TILDE] = ACTIONS(363),
    [anon_sym_lambda] = ACTIONS(365),
    [anon_sym_LBRACK] = ACTIONS(367),
    [sym_ellipsis] = ACTIONS(369),
    [anon_sym_LBRACE] = ACTIONS(371),
    [sym_integer] = ACTIONS(373),
    [sym_float] = ACTIONS(369),
    [sym_true] = ACTIONS(373),
    [sym_false] = ACTIONS(373),
    [sym_none] = ACTIONS(373),
    [anon_sym_await] = ACTIONS(375),
    [sym_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(377),
  },
  [279] = {
    [sym_elif_clause] = STATE(365),
    [aux_sym_if_statement_repeat1] = STATE(279),
    [sym_identifier] = ACTIONS(860),
    [anon_sym_import] = ACTIONS(860),
    [anon_sym_from] = ACTIONS(860),
    [anon_sym_LPAREN] = ACTIONS(858),
    [anon_sym_print] = ACTIONS(860),
    [anon_sym_assert] = ACTIONS(860),
    [anon_sym_return] = ACTIONS(860),
    [anon_sym_del] = ACTIONS(860),
    [anon_sym_raise] = ACTIONS(860),
    [anon_sym_pass] = ACTIONS(860),
    [anon_sym_break] = ACTIONS(860),
    [anon_sym_continue] = ACTIONS(860),
    [anon_sym_if] = ACTIONS(860),
    [anon_sym_elif] = ACTIONS(865),
    [anon_sym_else] = ACTIONS(860),
    [anon_sym_async] = ACTIONS(860),
    [anon_sym_for] = ACTIONS(860),
    [anon_sym_while] = ACTIONS(860),
    [anon_sym_try] = ACTIONS(860),
    [anon_sym_with] = ACTIONS(860),
    [anon_sym_def] = ACTIONS(860),
    [anon_sym_global] = ACTIONS(860),
    [anon_sym_nonlocal] = ACTIONS(860),
    [anon_sym_exec] = ACTIONS(860),
    [anon_sym_class] = ACTIONS(860),
    [anon_sym_AT] = ACTIONS(858),
    [anon_sym_not] = ACTIONS(860),
    [anon_sym_PLUS] = ACTIONS(858),
    [anon_sym_DASH] = ACTIONS(858),
    [anon_sym_TILDE] = ACTIONS(858),
    [anon_sym_lambda] = ACTIONS(860),
    [anon_sym_yield] = ACTIONS(860),
    [anon_sym_LBRACK] = ACTIONS(858),
    [sym_ellipsis] = ACTIONS(858),
    [anon_sym_LBRACE] = ACTIONS(858),
    [sym_integer] = ACTIONS(860),
    [sym_float] = ACTIONS(858),
    [sym_true] = ACTIONS(860),
    [sym_false] = ACTIONS(860),
    [sym_none] = ACTIONS(860),
    [anon_sym_await] = ACTIONS(860),
    [sym_comment] = ACTIONS(3),
    [sym__dedent] = ACTIONS(858),
    [sym__string_start] = ACTIONS(858),
  },
  [280] = {
    [sym_named_expression] = STATE(682),
    [sym__expression] = STATE(682),
    [sym__primary_expression] = STATE(383),
    [sym_not_operator] = STATE(682),
    [sym_boolean_operator] = STATE(682),
    [sym_binary_operator] = STATE(383),
    [sym_unary_operator] = STATE(383),
    [sym_comparison_operator] = STATE(682),
    [sym_lambda] = STATE(682),
    [sym_attribute] = STATE(383),
    [sym_subscript] = STATE(383),
    [sym_call] = STATE(383),
    [sym_type] = STATE(779),
    [sym_list] = STATE(383),
    [sym_list_comprehension] = STATE(383),
    [sym_dictionary] = STATE(383),
    [sym_dictionary_comprehension] = STATE(383),
    [sym_set] = STATE(383),
    [sym_set_comprehension] = STATE(383),
    [sym_parenthesized_expression] = STATE(383),
    [sym_tuple] = STATE(383),
    [sym_generator_expression] = STATE(383),
    [sym_conditional_expression] = STATE(682),
    [sym_concatenated_string] = STATE(383),
    [sym_string] = STATE(381),
    [sym_await] = STATE(682),
    [sym_identifier] = ACTIONS(387),
    [anon_sym_LPAREN] = ACTIONS(389),
    [anon_sym_print] = ACTIONS(393),
    [anon_sym_exec] = ACTIONS(393),
    [anon_sym_not] = ACTIONS(361),
    [anon_sym_PLUS] = ACTIONS(363),
    [anon_sym_DASH] = ACTIONS(363),
    [anon_sym_TILDE] = ACTIONS(363),
    [anon_sym_lambda] = ACTIONS(365),
    [anon_sym_LBRACK] = ACTIONS(367),
    [sym_ellipsis] = ACTIONS(369),
    [anon_sym_LBRACE] = ACTIONS(371),
    [sym_integer] = ACTIONS(373),
    [sym_float] = ACTIONS(369),
    [sym_true] = ACTIONS(373),
    [sym_false] = ACTIONS(373),
    [sym_none] = ACTIONS(373),
    [anon_sym_await] = ACTIONS(375),
    [sym_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(377),
  },
  [281] = {
    [sym_named_expression] = STATE(682),
    [sym__expression] = STATE(682),
    [sym__primary_expression] = STATE(383),
    [sym_not_operator] = STATE(682),
    [sym_boolean_operator] = STATE(682),
    [sym_binary_operator] = STATE(383),
    [sym_unary_operator] = STATE(383),
    [sym_comparison_operator] = STATE(682),
    [sym_lambda] = STATE(682),
    [sym_attribute] = STATE(383),
    [sym_subscript] = STATE(383),
    [sym_call] = STATE(383),
    [sym_type] = STATE(881),
    [sym_list] = STATE(383),
    [sym_list_comprehension] = STATE(383),
    [sym_dictionary] = STATE(383),
    [sym_dictionary_comprehension] = STATE(383),
    [sym_set] = STATE(383),
    [sym_set_comprehension] = STATE(383),
    [sym_parenthesized_expression] = STATE(383),
    [sym_tuple] = STATE(383),
    [sym_generator_expression] = STATE(383),
    [sym_conditional_expression] = STATE(682),
    [sym_concatenated_string] = STATE(383),
    [sym_string] = STATE(381),
    [sym_await] = STATE(682),
    [sym_identifier] = ACTIONS(387),
    [anon_sym_LPAREN] = ACTIONS(389),
    [anon_sym_print] = ACTIONS(393),
    [anon_sym_exec] = ACTIONS(393),
    [anon_sym_not] = ACTIONS(361),
    [anon_sym_PLUS] = ACTIONS(363),
    [anon_sym_DASH] = ACTIONS(363),
    [anon_sym_TILDE] = ACTIONS(363),
    [anon_sym_lambda] = ACTIONS(365),
    [anon_sym_LBRACK] = ACTIONS(367),
    [sym_ellipsis] = ACTIONS(369),
    [anon_sym_LBRACE] = ACTIONS(371),
    [sym_integer] = ACTIONS(373),
    [sym_float] = ACTIONS(369),
    [sym_true] = ACTIONS(373),
    [sym_false] = ACTIONS(373),
    [sym_none] = ACTIONS(373),
    [anon_sym_await] = ACTIONS(375),
    [sym_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(377),
  },
  [282] = {
    [ts_builtin_sym_end] = ACTIONS(846),
    [sym_identifier] = ACTIONS(844),
    [anon_sym_import] = ACTIONS(844),
    [anon_sym_from] = ACTIONS(844),
    [anon_sym_LPAREN] = ACTIONS(846),
    [anon_sym_print] = ACTIONS(844),
    [anon_sym_assert] = ACTIONS(844),
    [anon_sym_return] = ACTIONS(844),
    [anon_sym_del] = ACTIONS(844),
    [anon_sym_raise] = ACTIONS(844),
    [anon_sym_pass] = ACTIONS(844),
    [anon_sym_break] = ACTIONS(844),
    [anon_sym_continue] = ACTIONS(844),
    [anon_sym_if] = ACTIONS(844),
    [anon_sym_elif] = ACTIONS(844),
    [anon_sym_else] = ACTIONS(844),
    [anon_sym_async] = ACTIONS(844),
    [anon_sym_for] = ACTIONS(844),
    [anon_sym_while] = ACTIONS(844),
    [anon_sym_try] = ACTIONS(844),
    [anon_sym_except] = ACTIONS(844),
    [anon_sym_finally] = ACTIONS(844),
    [anon_sym_with] = ACTIONS(844),
    [anon_sym_def] = ACTIONS(844),
    [anon_sym_global] = ACTIONS(844),
    [anon_sym_nonlocal] = ACTIONS(844),
    [anon_sym_exec] = ACTIONS(844),
    [anon_sym_class] = ACTIONS(844),
    [anon_sym_AT] = ACTIONS(846),
    [anon_sym_not] = ACTIONS(844),
    [anon_sym_PLUS] = ACTIONS(846),
    [anon_sym_DASH] = ACTIONS(846),
    [anon_sym_TILDE] = ACTIONS(846),
    [anon_sym_lambda] = ACTIONS(844),
    [anon_sym_yield] = ACTIONS(844),
    [anon_sym_LBRACK] = ACTIONS(846),
    [sym_ellipsis] = ACTIONS(846),
    [anon_sym_LBRACE] = ACTIONS(846),
    [sym_integer] = ACTIONS(844),
    [sym_float] = ACTIONS(846),
    [sym_true] = ACTIONS(844),
    [sym_false] = ACTIONS(844),
    [sym_none] = ACTIONS(844),
    [anon_sym_await] = ACTIONS(844),
    [sym_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(846),
  },
  [283] = {
    [sym_named_expression] = STATE(698),
    [sym_expression_list] = STATE(1029),
    [sym__expression] = STATE(698),
    [sym__primary_expression] = STATE(383),
    [sym_not_operator] = STATE(698),
    [sym_boolean_operator] = STATE(698),
    [sym_binary_operator] = STATE(383),
    [sym_unary_operator] = STATE(383),
    [sym_comparison_operator] = STATE(698),
    [sym_lambda] = STATE(698),
    [sym_attribute] = STATE(383),
    [sym_subscript] = STATE(383),
    [sym_call] = STATE(383),
    [sym_list] = STATE(383),
    [sym_list_comprehension] = STATE(383),
    [sym_dictionary] = STATE(383),
    [sym_dictionary_comprehension] = STATE(383),
    [sym_set] = STATE(383),
    [sym_set_comprehension] = STATE(383),
    [sym_parenthesized_expression] = STATE(383),
    [sym_tuple] = STATE(383),
    [sym_generator_expression] = STATE(383),
    [sym_conditional_expression] = STATE(698),
    [sym_concatenated_string] = STATE(383),
    [sym_string] = STATE(381),
    [sym_await] = STATE(698),
    [sym_identifier] = ACTIONS(387),
    [anon_sym_LPAREN] = ACTIONS(389),
    [anon_sym_print] = ACTIONS(393),
    [anon_sym_exec] = ACTIONS(393),
    [anon_sym_not] = ACTIONS(361),
    [anon_sym_PLUS] = ACTIONS(363),
    [anon_sym_DASH] = ACTIONS(363),
    [anon_sym_TILDE] = ACTIONS(363),
    [anon_sym_lambda] = ACTIONS(365),
    [anon_sym_LBRACK] = ACTIONS(367),
    [sym_ellipsis] = ACTIONS(369),
    [anon_sym_LBRACE] = ACTIONS(371),
    [sym_integer] = ACTIONS(373),
    [sym_float] = ACTIONS(369),
    [sym_true] = ACTIONS(373),
    [sym_false] = ACTIONS(373),
    [sym_none] = ACTIONS(373),
    [anon_sym_await] = ACTIONS(375),
    [sym_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(377),
  },
  [284] = {
    [sym_named_expression] = STATE(722),
    [sym_with_item] = STATE(876),
    [sym__expression] = STATE(722),
    [sym__primary_expression] = STATE(503),
    [sym_not_operator] = STATE(722),
    [sym_boolean_operator] = STATE(722),
    [sym_binary_operator] = STATE(503),
    [sym_unary_operator] = STATE(503),
    [sym_comparison_operator] = STATE(722),
    [sym_lambda] = STATE(722),
    [sym_attribute] = STATE(503),
    [sym_subscript] = STATE(503),
    [sym_call] = STATE(503),
    [sym_list] = STATE(503),
    [sym_list_comprehension] = STATE(503),
    [sym_dictionary] = STATE(503),
    [sym_dictionary_comprehension] = STATE(503),
    [sym_set] = STATE(503),
    [sym_set_comprehension] = STATE(503),
    [sym_parenthesized_expression] = STATE(503),
    [sym_tuple] = STATE(503),
    [sym_generator_expression] = STATE(503),
    [sym_conditional_expression] = STATE(722),
    [sym_concatenated_string] = STATE(503),
    [sym_string] = STATE(505),
    [sym_await] = STATE(722),
    [sym_identifier] = ACTIONS(810),
    [anon_sym_LPAREN] = ACTIONS(812),
    [anon_sym_print] = ACTIONS(814),
    [anon_sym_exec] = ACTIONS(814),
    [anon_sym_not] = ACTIONS(818),
    [anon_sym_PLUS] = ACTIONS(820),
    [anon_sym_DASH] = ACTIONS(820),
    [anon_sym_TILDE] = ACTIONS(820),
    [anon_sym_lambda] = ACTIONS(822),
    [anon_sym_LBRACK] = ACTIONS(824),
    [sym_ellipsis] = ACTIONS(826),
    [anon_sym_LBRACE] = ACTIONS(828),
    [sym_integer] = ACTIONS(830),
    [sym_float] = ACTIONS(826),
    [sym_true] = ACTIONS(830),
    [sym_false] = ACTIONS(830),
    [sym_none] = ACTIONS(830),
    [anon_sym_await] = ACTIONS(832),
    [sym_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(834),
  },
  [285] = {
    [sym_named_expression] = STATE(705),
    [sym__expression] = STATE(705),
    [sym__primary_expression] = STATE(383),
    [sym_not_operator] = STATE(705),
    [sym_boolean_operator] = STATE(705),
    [sym_binary_operator] = STATE(383),
    [sym_unary_operator] = STATE(383),
    [sym_comparison_operator] = STATE(705),
    [sym_lambda] = STATE(705),
    [sym_attribute] = STATE(383),
    [sym_subscript] = STATE(383),
    [sym_call] = STATE(383),
    [sym_list] = STATE(383),
    [sym_list_comprehension] = STATE(383),
    [sym_dictionary] = STATE(383),
    [sym_dictionary_comprehension] = STATE(383),
    [sym_set] = STATE(383),
    [sym_set_comprehension] = STATE(383),
    [sym_parenthesized_expression] = STATE(383),
    [sym_tuple] = STATE(383),
    [sym_generator_expression] = STATE(383),
    [sym_conditional_expression] = STATE(705),
    [sym_concatenated_string] = STATE(383),
    [sym_string] = STATE(381),
    [sym_await] = STATE(705),
    [sym_identifier] = ACTIONS(387),
    [anon_sym_LPAREN] = ACTIONS(389),
    [anon_sym_print] = ACTIONS(393),
    [anon_sym_exec] = ACTIONS(393),
    [anon_sym_not] = ACTIONS(361),
    [anon_sym_PLUS] = ACTIONS(363),
    [anon_sym_DASH] = ACTIONS(363),
    [anon_sym_TILDE] = ACTIONS(363),
    [anon_sym_lambda] = ACTIONS(365),
    [anon_sym_LBRACK] = ACTIONS(367),
    [sym_ellipsis] = ACTIONS(369),
    [anon_sym_LBRACE] = ACTIONS(371),
    [sym_integer] = ACTIONS(373),
    [sym_float] = ACTIONS(369),
    [sym_true] = ACTIONS(373),
    [sym_false] = ACTIONS(373),
    [sym_none] = ACTIONS(373),
    [anon_sym_await] = ACTIONS(375),
    [sym_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(377),
  },
  [286] = {
    [sym_named_expression] = STATE(789),
    [sym__expression] = STATE(789),
    [sym__primary_expression] = STATE(383),
    [sym_not_operator] = STATE(789),
    [sym_boolean_operator] = STATE(789),
    [sym_binary_operator] = STATE(383),
    [sym_unary_operator] = STATE(383),
    [sym_comparison_operator] = STATE(789),
    [sym_lambda] = STATE(789),
    [sym_attribute] = STATE(383),
    [sym_subscript] = STATE(383),
    [sym_call] = STATE(383),
    [sym_list] = STATE(383),
    [sym_list_comprehension] = STATE(383),
    [sym_dictionary] = STATE(383),
    [sym_dictionary_comprehension] = STATE(383),
    [sym_set] = STATE(383),
    [sym_set_comprehension] = STATE(383),
    [sym_parenthesized_expression] = STATE(383),
    [sym_tuple] = STATE(383),
    [sym_generator_expression] = STATE(383),
    [sym_conditional_expression] = STATE(789),
    [sym_concatenated_string] = STATE(383),
    [sym_string] = STATE(381),
    [sym_await] = STATE(789),
    [sym_identifier] = ACTIONS(387),
    [anon_sym_LPAREN] = ACTIONS(389),
    [anon_sym_print] = ACTIONS(393),
    [anon_sym_exec] = ACTIONS(393),
    [anon_sym_not] = ACTIONS(361),
    [anon_sym_PLUS] = ACTIONS(363),
    [anon_sym_DASH] = ACTIONS(363),
    [anon_sym_TILDE] = ACTIONS(363),
    [anon_sym_lambda] = ACTIONS(365),
    [anon_sym_LBRACK] = ACTIONS(367),
    [sym_ellipsis] = ACTIONS(369),
    [anon_sym_LBRACE] = ACTIONS(371),
    [sym_integer] = ACTIONS(373),
    [sym_float] = ACTIONS(369),
    [sym_true] = ACTIONS(373),
    [sym_false] = ACTIONS(373),
    [sym_none] = ACTIONS(373),
    [anon_sym_await] = ACTIONS(375),
    [sym_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(377),
  },
  [287] = {
    [sym_named_expression] = STATE(751),
    [sym__expression] = STATE(751),
    [sym__primary_expression] = STATE(109),
    [sym_not_operator] = STATE(751),
    [sym_boolean_operator] = STATE(751),
    [sym_binary_operator] = STATE(109),
    [sym_unary_operator] = STATE(109),
    [sym_comparison_operator] = STATE(751),
    [sym_lambda] = STATE(751),
    [sym_attribute] = STATE(109),
    [sym_subscript] = STATE(109),
    [sym_call] = STATE(109),
    [sym_list] = STATE(109),
    [sym_list_comprehension] = STATE(109),
    [sym_dictionary] = STATE(109),
    [sym_dictionary_comprehension] = STATE(109),
    [sym_set] = STATE(109),
    [sym_set_comprehension] = STATE(109),
    [sym_parenthesized_expression] = STATE(109),
    [sym_tuple] = STATE(109),
    [sym_generator_expression] = STATE(109),
    [sym_conditional_expression] = STATE(751),
    [sym_concatenated_string] = STATE(109),
    [sym_string] = STATE(117),
    [sym_await] = STATE(751),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(13),
    [anon_sym_print] = ACTIONS(237),
    [anon_sym_exec] = ACTIONS(237),
    [anon_sym_not] = ACTIONS(55),
    [anon_sym_PLUS] = ACTIONS(57),
    [anon_sym_DASH] = ACTIONS(57),
    [anon_sym_TILDE] = ACTIONS(57),
    [anon_sym_lambda] = ACTIONS(59),
    [anon_sym_LBRACK] = ACTIONS(63),
    [sym_ellipsis] = ACTIONS(65),
    [anon_sym_LBRACE] = ACTIONS(67),
    [sym_integer] = ACTIONS(69),
    [sym_float] = ACTIONS(65),
    [sym_true] = ACTIONS(69),
    [sym_false] = ACTIONS(69),
    [sym_none] = ACTIONS(69),
    [anon_sym_await] = ACTIONS(71),
    [sym_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(73),
  },
  [288] = {
    [sym_named_expression] = STATE(697),
    [sym__expression] = STATE(697),
    [sym__primary_expression] = STATE(383),
    [sym_not_operator] = STATE(697),
    [sym_boolean_operator] = STATE(697),
    [sym_binary_operator] = STATE(383),
    [sym_unary_operator] = STATE(383),
    [sym_comparison_operator] = STATE(697),
    [sym_lambda] = STATE(697),
    [sym_attribute] = STATE(383),
    [sym_subscript] = STATE(383),
    [sym_call] = STATE(383),
    [sym_list] = STATE(383),
    [sym_list_comprehension] = STATE(383),
    [sym_dictionary] = STATE(383),
    [sym_dictionary_comprehension] = STATE(383),
    [sym_set] = STATE(383),
    [sym_set_comprehension] = STATE(383),
    [sym_parenthesized_expression] = STATE(383),
    [sym_tuple] = STATE(383),
    [sym_generator_expression] = STATE(383),
    [sym_conditional_expression] = STATE(697),
    [sym_concatenated_string] = STATE(383),
    [sym_string] = STATE(381),
    [sym_await] = STATE(697),
    [sym_identifier] = ACTIONS(387),
    [anon_sym_LPAREN] = ACTIONS(389),
    [anon_sym_print] = ACTIONS(393),
    [anon_sym_exec] = ACTIONS(393),
    [anon_sym_not] = ACTIONS(361),
    [anon_sym_PLUS] = ACTIONS(363),
    [anon_sym_DASH] = ACTIONS(363),
    [anon_sym_TILDE] = ACTIONS(363),
    [anon_sym_lambda] = ACTIONS(365),
    [anon_sym_LBRACK] = ACTIONS(367),
    [sym_ellipsis] = ACTIONS(369),
    [anon_sym_LBRACE] = ACTIONS(371),
    [sym_integer] = ACTIONS(373),
    [sym_float] = ACTIONS(369),
    [sym_true] = ACTIONS(373),
    [sym_false] = ACTIONS(373),
    [sym_none] = ACTIONS(373),
    [anon_sym_await] = ACTIONS(375),
    [sym_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(377),
  },
  [289] = {
    [sym_identifier] = ACTIONS(868),
    [anon_sym_import] = ACTIONS(868),
    [anon_sym_from] = ACTIONS(868),
    [anon_sym_LPAREN] = ACTIONS(870),
    [anon_sym_print] = ACTIONS(868),
    [anon_sym_assert] = ACTIONS(868),
    [anon_sym_return] = ACTIONS(868),
    [anon_sym_del] = ACTIONS(868),
    [anon_sym_raise] = ACTIONS(868),
    [anon_sym_pass] = ACTIONS(868),
    [anon_sym_break] = ACTIONS(868),
    [anon_sym_continue] = ACTIONS(868),
    [anon_sym_if] = ACTIONS(868),
    [anon_sym_else] = ACTIONS(868),
    [anon_sym_async] = ACTIONS(868),
    [anon_sym_for] = ACTIONS(868),
    [anon_sym_while] = ACTIONS(868),
    [anon_sym_try] = ACTIONS(868),
    [anon_sym_except] = ACTIONS(868),
    [anon_sym_finally] = ACTIONS(868),
    [anon_sym_with] = ACTIONS(868),
    [anon_sym_def] = ACTIONS(868),
    [anon_sym_global] = ACTIONS(868),
    [anon_sym_nonlocal] = ACTIONS(868),
    [anon_sym_exec] = ACTIONS(868),
    [anon_sym_class] = ACTIONS(868),
    [anon_sym_AT] = ACTIONS(870),
    [anon_sym_not] = ACTIONS(868),
    [anon_sym_PLUS] = ACTIONS(870),
    [anon_sym_DASH] = ACTIONS(870),
    [anon_sym_TILDE] = ACTIONS(870),
    [anon_sym_lambda] = ACTIONS(868),
    [anon_sym_yield] = ACTIONS(868),
    [anon_sym_LBRACK] = ACTIONS(870),
    [sym_ellipsis] = ACTIONS(870),
    [anon_sym_LBRACE] = ACTIONS(870),
    [sym_integer] = ACTIONS(868),
    [sym_float] = ACTIONS(870),
    [sym_true] = ACTIONS(868),
    [sym_false] = ACTIONS(868),
    [sym_none] = ACTIONS(868),
    [anon_sym_await] = ACTIONS(868),
    [sym_comment] = ACTIONS(3),
    [sym__dedent] = ACTIONS(870),
    [sym__string_start] = ACTIONS(870),
  },
  [290] = {
    [sym_named_expression] = STATE(604),
    [sym__expression] = STATE(604),
    [sym__primary_expression] = STATE(109),
    [sym_not_operator] = STATE(604),
    [sym_boolean_operator] = STATE(604),
    [sym_binary_operator] = STATE(109),
    [sym_unary_operator] = STATE(109),
    [sym_comparison_operator] = STATE(604),
    [sym_lambda] = STATE(604),
    [sym_attribute] = STATE(109),
    [sym_subscript] = STATE(109),
    [sym_call] = STATE(109),
    [sym_list] = STATE(109),
    [sym_list_comprehension] = STATE(109),
    [sym_dictionary] = STATE(109),
    [sym_dictionary_comprehension] = STATE(109),
    [sym_set] = STATE(109),
    [sym_set_comprehension] = STATE(109),
    [sym_parenthesized_expression] = STATE(109),
    [sym_tuple] = STATE(109),
    [sym_generator_expression] = STATE(109),
    [sym_conditional_expression] = STATE(604),
    [sym_concatenated_string] = STATE(109),
    [sym_string] = STATE(117),
    [sym_await] = STATE(604),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(13),
    [anon_sym_print] = ACTIONS(237),
    [anon_sym_exec] = ACTIONS(237),
    [anon_sym_not] = ACTIONS(55),
    [anon_sym_PLUS] = ACTIONS(57),
    [anon_sym_DASH] = ACTIONS(57),
    [anon_sym_TILDE] = ACTIONS(57),
    [anon_sym_lambda] = ACTIONS(59),
    [anon_sym_LBRACK] = ACTIONS(63),
    [sym_ellipsis] = ACTIONS(65),
    [anon_sym_LBRACE] = ACTIONS(67),
    [sym_integer] = ACTIONS(69),
    [sym_float] = ACTIONS(65),
    [sym_true] = ACTIONS(69),
    [sym_false] = ACTIONS(69),
    [sym_none] = ACTIONS(69),
    [anon_sym_await] = ACTIONS(71),
    [sym_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(73),
  },
  [291] = {
    [sym_identifier] = ACTIONS(872),
    [anon_sym_import] = ACTIONS(872),
    [anon_sym_from] = ACTIONS(872),
    [anon_sym_LPAREN] = ACTIONS(874),
    [anon_sym_print] = ACTIONS(872),
    [anon_sym_assert] = ACTIONS(872),
    [anon_sym_return] = ACTIONS(872),
    [anon_sym_del] = ACTIONS(872),
    [anon_sym_raise] = ACTIONS(872),
    [anon_sym_pass] = ACTIONS(872),
    [anon_sym_break] = ACTIONS(872),
    [anon_sym_continue] = ACTIONS(872),
    [anon_sym_if] = ACTIONS(872),
    [anon_sym_else] = ACTIONS(872),
    [anon_sym_async] = ACTIONS(872),
    [anon_sym_for] = ACTIONS(872),
    [anon_sym_while] = ACTIONS(872),
    [anon_sym_try] = ACTIONS(872),
    [anon_sym_except] = ACTIONS(872),
    [anon_sym_finally] = ACTIONS(872),
    [anon_sym_with] = ACTIONS(872),
    [anon_sym_def] = ACTIONS(872),
    [anon_sym_global] = ACTIONS(872),
    [anon_sym_nonlocal] = ACTIONS(872),
    [anon_sym_exec] = ACTIONS(872),
    [anon_sym_class] = ACTIONS(872),
    [anon_sym_AT] = ACTIONS(874),
    [anon_sym_not] = ACTIONS(872),
    [anon_sym_PLUS] = ACTIONS(874),
    [anon_sym_DASH] = ACTIONS(874),
    [anon_sym_TILDE] = ACTIONS(874),
    [anon_sym_lambda] = ACTIONS(872),
    [anon_sym_yield] = ACTIONS(872),
    [anon_sym_LBRACK] = ACTIONS(874),
    [sym_ellipsis] = ACTIONS(874),
    [anon_sym_LBRACE] = ACTIONS(874),
    [sym_integer] = ACTIONS(872),
    [sym_float] = ACTIONS(874),
    [sym_true] = ACTIONS(872),
    [sym_false] = ACTIONS(872),
    [sym_none] = ACTIONS(872),
    [anon_sym_await] = ACTIONS(872),
    [sym_comment] = ACTIONS(3),
    [sym__dedent] = ACTIONS(874),
    [sym__string_start] = ACTIONS(874),
  },
  [292] = {
    [sym_named_expression] = STATE(670),
    [sym__expression] = STATE(670),
    [sym__primary_expression] = STATE(383),
    [sym_not_operator] = STATE(670),
    [sym_boolean_operator] = STATE(670),
    [sym_binary_operator] = STATE(383),
    [sym_unary_operator] = STATE(383),
    [sym_comparison_operator] = STATE(670),
    [sym_lambda] = STATE(670),
    [sym_attribute] = STATE(383),
    [sym_subscript] = STATE(383),
    [sym_call] = STATE(383),
    [sym_list] = STATE(383),
    [sym_list_comprehension] = STATE(383),
    [sym_dictionary] = STATE(383),
    [sym_dictionary_comprehension] = STATE(383),
    [sym_set] = STATE(383),
    [sym_set_comprehension] = STATE(383),
    [sym_parenthesized_expression] = STATE(383),
    [sym_tuple] = STATE(383),
    [sym_generator_expression] = STATE(383),
    [sym_conditional_expression] = STATE(670),
    [sym_concatenated_string] = STATE(383),
    [sym_string] = STATE(381),
    [sym_await] = STATE(670),
    [sym_identifier] = ACTIONS(387),
    [anon_sym_LPAREN] = ACTIONS(389),
    [anon_sym_print] = ACTIONS(393),
    [anon_sym_exec] = ACTIONS(393),
    [anon_sym_not] = ACTIONS(361),
    [anon_sym_PLUS] = ACTIONS(363),
    [anon_sym_DASH] = ACTIONS(363),
    [anon_sym_TILDE] = ACTIONS(363),
    [anon_sym_lambda] = ACTIONS(365),
    [anon_sym_LBRACK] = ACTIONS(367),
    [sym_ellipsis] = ACTIONS(369),
    [anon_sym_LBRACE] = ACTIONS(371),
    [sym_integer] = ACTIONS(373),
    [sym_float] = ACTIONS(369),
    [sym_true] = ACTIONS(373),
    [sym_false] = ACTIONS(373),
    [sym_none] = ACTIONS(373),
    [anon_sym_await] = ACTIONS(375),
    [sym_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(377),
  },
  [293] = {
    [sym_named_expression] = STATE(757),
    [sym__expression] = STATE(757),
    [sym__primary_expression] = STATE(109),
    [sym_not_operator] = STATE(757),
    [sym_boolean_operator] = STATE(757),
    [sym_binary_operator] = STATE(109),
    [sym_unary_operator] = STATE(109),
    [sym_comparison_operator] = STATE(757),
    [sym_lambda] = STATE(757),
    [sym_attribute] = STATE(109),
    [sym_subscript] = STATE(109),
    [sym_call] = STATE(109),
    [sym_list] = STATE(109),
    [sym_list_comprehension] = STATE(109),
    [sym_dictionary] = STATE(109),
    [sym_dictionary_comprehension] = STATE(109),
    [sym_set] = STATE(109),
    [sym_set_comprehension] = STATE(109),
    [sym_parenthesized_expression] = STATE(109),
    [sym_tuple] = STATE(109),
    [sym_generator_expression] = STATE(109),
    [sym_conditional_expression] = STATE(757),
    [sym_concatenated_string] = STATE(109),
    [sym_string] = STATE(117),
    [sym_await] = STATE(757),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(13),
    [anon_sym_print] = ACTIONS(237),
    [anon_sym_exec] = ACTIONS(237),
    [anon_sym_not] = ACTIONS(55),
    [anon_sym_PLUS] = ACTIONS(57),
    [anon_sym_DASH] = ACTIONS(57),
    [anon_sym_TILDE] = ACTIONS(57),
    [anon_sym_lambda] = ACTIONS(59),
    [anon_sym_LBRACK] = ACTIONS(63),
    [sym_ellipsis] = ACTIONS(65),
    [anon_sym_LBRACE] = ACTIONS(67),
    [sym_integer] = ACTIONS(69),
    [sym_float] = ACTIONS(65),
    [sym_true] = ACTIONS(69),
    [sym_false] = ACTIONS(69),
    [sym_none] = ACTIONS(69),
    [anon_sym_await] = ACTIONS(71),
    [sym_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(73),
  },
  [294] = {
    [sym_identifier] = ACTIONS(876),
    [anon_sym_import] = ACTIONS(876),
    [anon_sym_from] = ACTIONS(876),
    [anon_sym_LPAREN] = ACTIONS(878),
    [anon_sym_print] = ACTIONS(876),
    [anon_sym_assert] = ACTIONS(876),
    [anon_sym_return] = ACTIONS(876),
    [anon_sym_del] = ACTIONS(876),
    [anon_sym_raise] = ACTIONS(876),
    [anon_sym_pass] = ACTIONS(876),
    [anon_sym_break] = ACTIONS(876),
    [anon_sym_continue] = ACTIONS(876),
    [anon_sym_if] = ACTIONS(876),
    [anon_sym_else] = ACTIONS(876),
    [anon_sym_async] = ACTIONS(876),
    [anon_sym_for] = ACTIONS(876),
    [anon_sym_while] = ACTIONS(876),
    [anon_sym_try] = ACTIONS(876),
    [anon_sym_except] = ACTIONS(876),
    [anon_sym_finally] = ACTIONS(876),
    [anon_sym_with] = ACTIONS(876),
    [anon_sym_def] = ACTIONS(876),
    [anon_sym_global] = ACTIONS(876),
    [anon_sym_nonlocal] = ACTIONS(876),
    [anon_sym_exec] = ACTIONS(876),
    [anon_sym_class] = ACTIONS(876),
    [anon_sym_AT] = ACTIONS(878),
    [anon_sym_not] = ACTIONS(876),
    [anon_sym_PLUS] = ACTIONS(878),
    [anon_sym_DASH] = ACTIONS(878),
    [anon_sym_TILDE] = ACTIONS(878),
    [anon_sym_lambda] = ACTIONS(876),
    [anon_sym_yield] = ACTIONS(876),
    [anon_sym_LBRACK] = ACTIONS(878),
    [sym_ellipsis] = ACTIONS(878),
    [anon_sym_LBRACE] = ACTIONS(878),
    [sym_integer] = ACTIONS(876),
    [sym_float] = ACTIONS(878),
    [sym_true] = ACTIONS(876),
    [sym_false] = ACTIONS(876),
    [sym_none] = ACTIONS(876),
    [anon_sym_await] = ACTIONS(876),
    [sym_comment] = ACTIONS(3),
    [sym__dedent] = ACTIONS(878),
    [sym__string_start] = ACTIONS(878),
  },
  [295] = {
    [sym_named_expression] = STATE(738),
    [sym__expression] = STATE(738),
    [sym__primary_expression] = STATE(109),
    [sym_not_operator] = STATE(738),
    [sym_boolean_operator] = STATE(738),
    [sym_binary_operator] = STATE(109),
    [sym_unary_operator] = STATE(109),
    [sym_comparison_operator] = STATE(738),
    [sym_lambda] = STATE(738),
    [sym_attribute] = STATE(109),
    [sym_subscript] = STATE(109),
    [sym_call] = STATE(109),
    [sym_list] = STATE(109),
    [sym_list_comprehension] = STATE(109),
    [sym_dictionary] = STATE(109),
    [sym_dictionary_comprehension] = STATE(109),
    [sym_set] = STATE(109),
    [sym_set_comprehension] = STATE(109),
    [sym_parenthesized_expression] = STATE(109),
    [sym_tuple] = STATE(109),
    [sym_generator_expression] = STATE(109),
    [sym_conditional_expression] = STATE(738),
    [sym_concatenated_string] = STATE(109),
    [sym_string] = STATE(117),
    [sym_await] = STATE(738),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(13),
    [anon_sym_print] = ACTIONS(237),
    [anon_sym_exec] = ACTIONS(237),
    [anon_sym_not] = ACTIONS(55),
    [anon_sym_PLUS] = ACTIONS(57),
    [anon_sym_DASH] = ACTIONS(57),
    [anon_sym_TILDE] = ACTIONS(57),
    [anon_sym_lambda] = ACTIONS(59),
    [anon_sym_LBRACK] = ACTIONS(63),
    [sym_ellipsis] = ACTIONS(65),
    [anon_sym_LBRACE] = ACTIONS(67),
    [sym_integer] = ACTIONS(69),
    [sym_float] = ACTIONS(65),
    [sym_true] = ACTIONS(69),
    [sym_false] = ACTIONS(69),
    [sym_none] = ACTIONS(69),
    [anon_sym_await] = ACTIONS(71),
    [sym_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(73),
  },
  [296] = {
    [sym_named_expression] = STATE(730),
    [sym__expression] = STATE(730),
    [sym__primary_expression] = STATE(503),
    [sym_not_operator] = STATE(730),
    [sym_boolean_operator] = STATE(730),
    [sym_binary_operator] = STATE(503),
    [sym_unary_operator] = STATE(503),
    [sym_comparison_operator] = STATE(730),
    [sym_lambda] = STATE(730),
    [sym_attribute] = STATE(503),
    [sym_subscript] = STATE(503),
    [sym_call] = STATE(503),
    [sym_list] = STATE(503),
    [sym_list_comprehension] = STATE(503),
    [sym_dictionary] = STATE(503),
    [sym_dictionary_comprehension] = STATE(503),
    [sym_set] = STATE(503),
    [sym_set_comprehension] = STATE(503),
    [sym_parenthesized_expression] = STATE(503),
    [sym_tuple] = STATE(503),
    [sym_generator_expression] = STATE(503),
    [sym_conditional_expression] = STATE(730),
    [sym_concatenated_string] = STATE(503),
    [sym_string] = STATE(505),
    [sym_await] = STATE(730),
    [sym_identifier] = ACTIONS(810),
    [anon_sym_LPAREN] = ACTIONS(812),
    [anon_sym_print] = ACTIONS(814),
    [anon_sym_exec] = ACTIONS(814),
    [anon_sym_not] = ACTIONS(818),
    [anon_sym_PLUS] = ACTIONS(820),
    [anon_sym_DASH] = ACTIONS(820),
    [anon_sym_TILDE] = ACTIONS(820),
    [anon_sym_lambda] = ACTIONS(822),
    [anon_sym_LBRACK] = ACTIONS(824),
    [sym_ellipsis] = ACTIONS(826),
    [anon_sym_LBRACE] = ACTIONS(828),
    [sym_integer] = ACTIONS(830),
    [sym_float] = ACTIONS(826),
    [sym_true] = ACTIONS(830),
    [sym_false] = ACTIONS(830),
    [sym_none] = ACTIONS(830),
    [anon_sym_await] = ACTIONS(832),
    [sym_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(834),
  },
  [297] = {
    [sym_identifier] = ACTIONS(880),
    [anon_sym_import] = ACTIONS(880),
    [anon_sym_from] = ACTIONS(880),
    [anon_sym_LPAREN] = ACTIONS(882),
    [anon_sym_print] = ACTIONS(880),
    [anon_sym_assert] = ACTIONS(880),
    [anon_sym_return] = ACTIONS(880),
    [anon_sym_del] = ACTIONS(880),
    [anon_sym_raise] = ACTIONS(880),
    [anon_sym_pass] = ACTIONS(880),
    [anon_sym_break] = ACTIONS(880),
    [anon_sym_continue] = ACTIONS(880),
    [anon_sym_if] = ACTIONS(880),
    [anon_sym_else] = ACTIONS(880),
    [anon_sym_async] = ACTIONS(880),
    [anon_sym_for] = ACTIONS(880),
    [anon_sym_while] = ACTIONS(880),
    [anon_sym_try] = ACTIONS(880),
    [anon_sym_except] = ACTIONS(880),
    [anon_sym_finally] = ACTIONS(880),
    [anon_sym_with] = ACTIONS(880),
    [anon_sym_def] = ACTIONS(880),
    [anon_sym_global] = ACTIONS(880),
    [anon_sym_nonlocal] = ACTIONS(880),
    [anon_sym_exec] = ACTIONS(880),
    [anon_sym_class] = ACTIONS(880),
    [anon_sym_AT] = ACTIONS(882),
    [anon_sym_not] = ACTIONS(880),
    [anon_sym_PLUS] = ACTIONS(882),
    [anon_sym_DASH] = ACTIONS(882),
    [anon_sym_TILDE] = ACTIONS(882),
    [anon_sym_lambda] = ACTIONS(880),
    [anon_sym_yield] = ACTIONS(880),
    [anon_sym_LBRACK] = ACTIONS(882),
    [sym_ellipsis] = ACTIONS(882),
    [anon_sym_LBRACE] = ACTIONS(882),
    [sym_integer] = ACTIONS(880),
    [sym_float] = ACTIONS(882),
    [sym_true] = ACTIONS(880),
    [sym_false] = ACTIONS(880),
    [sym_none] = ACTIONS(880),
    [anon_sym_await] = ACTIONS(880),
    [sym_comment] = ACTIONS(3),
    [sym__dedent] = ACTIONS(882),
    [sym__string_start] = ACTIONS(882),
  },
  [298] = {
    [sym_identifier] = ACTIONS(884),
    [anon_sym_import] = ACTIONS(884),
    [anon_sym_from] = ACTIONS(884),
    [anon_sym_LPAREN] = ACTIONS(886),
    [anon_sym_print] = ACTIONS(884),
    [anon_sym_assert] = ACTIONS(884),
    [anon_sym_return] = ACTIONS(884),
    [anon_sym_del] = ACTIONS(884),
    [anon_sym_raise] = ACTIONS(884),
    [anon_sym_pass] = ACTIONS(884),
    [anon_sym_break] = ACTIONS(884),
    [anon_sym_continue] = ACTIONS(884),
    [anon_sym_if] = ACTIONS(884),
    [anon_sym_else] = ACTIONS(884),
    [anon_sym_async] = ACTIONS(884),
    [anon_sym_for] = ACTIONS(884),
    [anon_sym_while] = ACTIONS(884),
    [anon_sym_try] = ACTIONS(884),
    [anon_sym_except] = ACTIONS(884),
    [anon_sym_finally] = ACTIONS(884),
    [anon_sym_with] = ACTIONS(884),
    [anon_sym_def] = ACTIONS(884),
    [anon_sym_global] = ACTIONS(884),
    [anon_sym_nonlocal] = ACTIONS(884),
    [anon_sym_exec] = ACTIONS(884),
    [anon_sym_class] = ACTIONS(884),
    [anon_sym_AT] = ACTIONS(886),
    [anon_sym_not] = ACTIONS(884),
    [anon_sym_PLUS] = ACTIONS(886),
    [anon_sym_DASH] = ACTIONS(886),
    [anon_sym_TILDE] = ACTIONS(886),
    [anon_sym_lambda] = ACTIONS(884),
    [anon_sym_yield] = ACTIONS(884),
    [anon_sym_LBRACK] = ACTIONS(886),
    [sym_ellipsis] = ACTIONS(886),
    [anon_sym_LBRACE] = ACTIONS(886),
    [sym_integer] = ACTIONS(884),
    [sym_float] = ACTIONS(886),
    [sym_true] = ACTIONS(884),
    [sym_false] = ACTIONS(884),
    [sym_none] = ACTIONS(884),
    [anon_sym_await] = ACTIONS(884),
    [sym_comment] = ACTIONS(3),
    [sym__dedent] = ACTIONS(886),
    [sym__string_start] = ACTIONS(886),
  },
  [299] = {
    [sym_named_expression] = STATE(726),
    [sym__expression] = STATE(726),
    [sym__primary_expression] = STATE(109),
    [sym_not_operator] = STATE(726),
    [sym_boolean_operator] = STATE(726),
    [sym_binary_operator] = STATE(109),
    [sym_unary_operator] = STATE(109),
    [sym_comparison_operator] = STATE(726),
    [sym_lambda] = STATE(726),
    [sym_attribute] = STATE(109),
    [sym_subscript] = STATE(109),
    [sym_call] = STATE(109),
    [sym_list] = STATE(109),
    [sym_list_comprehension] = STATE(109),
    [sym_dictionary] = STATE(109),
    [sym_dictionary_comprehension] = STATE(109),
    [sym_set] = STATE(109),
    [sym_set_comprehension] = STATE(109),
    [sym_parenthesized_expression] = STATE(109),
    [sym_tuple] = STATE(109),
    [sym_generator_expression] = STATE(109),
    [sym_conditional_expression] = STATE(726),
    [sym_concatenated_string] = STATE(109),
    [sym_string] = STATE(117),
    [sym_await] = STATE(726),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(13),
    [anon_sym_print] = ACTIONS(237),
    [anon_sym_exec] = ACTIONS(237),
    [anon_sym_not] = ACTIONS(55),
    [anon_sym_PLUS] = ACTIONS(57),
    [anon_sym_DASH] = ACTIONS(57),
    [anon_sym_TILDE] = ACTIONS(57),
    [anon_sym_lambda] = ACTIONS(59),
    [anon_sym_LBRACK] = ACTIONS(63),
    [sym_ellipsis] = ACTIONS(65),
    [anon_sym_LBRACE] = ACTIONS(67),
    [sym_integer] = ACTIONS(69),
    [sym_float] = ACTIONS(65),
    [sym_true] = ACTIONS(69),
    [sym_false] = ACTIONS(69),
    [sym_none] = ACTIONS(69),
    [anon_sym_await] = ACTIONS(71),
    [sym_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(73),
  },
  [300] = {
    [ts_builtin_sym_end] = ACTIONS(874),
    [sym_identifier] = ACTIONS(872),
    [anon_sym_import] = ACTIONS(872),
    [anon_sym_from] = ACTIONS(872),
    [anon_sym_LPAREN] = ACTIONS(874),
    [anon_sym_print] = ACTIONS(872),
    [anon_sym_assert] = ACTIONS(872),
    [anon_sym_return] = ACTIONS(872),
    [anon_sym_del] = ACTIONS(872),
    [anon_sym_raise] = ACTIONS(872),
    [anon_sym_pass] = ACTIONS(872),
    [anon_sym_break] = ACTIONS(872),
    [anon_sym_continue] = ACTIONS(872),
    [anon_sym_if] = ACTIONS(872),
    [anon_sym_else] = ACTIONS(872),
    [anon_sym_async] = ACTIONS(872),
    [anon_sym_for] = ACTIONS(872),
    [anon_sym_while] = ACTIONS(872),
    [anon_sym_try] = ACTIONS(872),
    [anon_sym_except] = ACTIONS(872),
    [anon_sym_finally] = ACTIONS(872),
    [anon_sym_with] = ACTIONS(872),
    [anon_sym_def] = ACTIONS(872),
    [anon_sym_global] = ACTIONS(872),
    [anon_sym_nonlocal] = ACTIONS(872),
    [anon_sym_exec] = ACTIONS(872),
    [anon_sym_class] = ACTIONS(872),
    [anon_sym_AT] = ACTIONS(874),
    [anon_sym_not] = ACTIONS(872),
    [anon_sym_PLUS] = ACTIONS(874),
    [anon_sym_DASH] = ACTIONS(874),
    [anon_sym_TILDE] = ACTIONS(874),
    [anon_sym_lambda] = ACTIONS(872),
    [anon_sym_yield] = ACTIONS(872),
    [anon_sym_LBRACK] = ACTIONS(874),
    [sym_ellipsis] = ACTIONS(874),
    [anon_sym_LBRACE] = ACTIONS(874),
    [sym_integer] = ACTIONS(872),
    [sym_float] = ACTIONS(874),
    [sym_true] = ACTIONS(872),
    [sym_false] = ACTIONS(872),
    [sym_none] = ACTIONS(872),
    [anon_sym_await] = ACTIONS(872),
    [sym_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(874),
  },
  [301] = {
    [sym_named_expression] = STATE(696),
    [sym__expression] = STATE(696),
    [sym__primary_expression] = STATE(383),
    [sym_not_operator] = STATE(696),
    [sym_boolean_operator] = STATE(696),
    [sym_binary_operator] = STATE(383),
    [sym_unary_operator] = STATE(383),
    [sym_comparison_operator] = STATE(696),
    [sym_lambda] = STATE(696),
    [sym_attribute] = STATE(383),
    [sym_subscript] = STATE(383),
    [sym_call] = STATE(383),
    [sym_list] = STATE(383),
    [sym_list_comprehension] = STATE(383),
    [sym_dictionary] = STATE(383),
    [sym_dictionary_comprehension] = STATE(383),
    [sym_set] = STATE(383),
    [sym_set_comprehension] = STATE(383),
    [sym_parenthesized_expression] = STATE(383),
    [sym_tuple] = STATE(383),
    [sym_generator_expression] = STATE(383),
    [sym_conditional_expression] = STATE(696),
    [sym_concatenated_string] = STATE(383),
    [sym_string] = STATE(381),
    [sym_await] = STATE(696),
    [sym_identifier] = ACTIONS(387),
    [anon_sym_LPAREN] = ACTIONS(389),
    [anon_sym_print] = ACTIONS(393),
    [anon_sym_exec] = ACTIONS(393),
    [anon_sym_not] = ACTIONS(361),
    [anon_sym_PLUS] = ACTIONS(363),
    [anon_sym_DASH] = ACTIONS(363),
    [anon_sym_TILDE] = ACTIONS(363),
    [anon_sym_lambda] = ACTIONS(365),
    [anon_sym_LBRACK] = ACTIONS(367),
    [sym_ellipsis] = ACTIONS(369),
    [anon_sym_LBRACE] = ACTIONS(371),
    [sym_integer] = ACTIONS(373),
    [sym_float] = ACTIONS(369),
    [sym_true] = ACTIONS(373),
    [sym_false] = ACTIONS(373),
    [sym_none] = ACTIONS(373),
    [anon_sym_await] = ACTIONS(375),
    [sym_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(377),
  },
  [302] = {
    [ts_builtin_sym_end] = ACTIONS(870),
    [sym_identifier] = ACTIONS(868),
    [anon_sym_import] = ACTIONS(868),
    [anon_sym_from] = ACTIONS(868),
    [anon_sym_LPAREN] = ACTIONS(870),
    [anon_sym_print] = ACTIONS(868),
    [anon_sym_assert] = ACTIONS(868),
    [anon_sym_return] = ACTIONS(868),
    [anon_sym_del] = ACTIONS(868),
    [anon_sym_raise] = ACTIONS(868),
    [anon_sym_pass] = ACTIONS(868),
    [anon_sym_break] = ACTIONS(868),
    [anon_sym_continue] = ACTIONS(868),
    [anon_sym_if] = ACTIONS(868),
    [anon_sym_else] = ACTIONS(868),
    [anon_sym_async] = ACTIONS(868),
    [anon_sym_for] = ACTIONS(868),
    [anon_sym_while] = ACTIONS(868),
    [anon_sym_try] = ACTIONS(868),
    [anon_sym_except] = ACTIONS(868),
    [anon_sym_finally] = ACTIONS(868),
    [anon_sym_with] = ACTIONS(868),
    [anon_sym_def] = ACTIONS(868),
    [anon_sym_global] = ACTIONS(868),
    [anon_sym_nonlocal] = ACTIONS(868),
    [anon_sym_exec] = ACTIONS(868),
    [anon_sym_class] = ACTIONS(868),
    [anon_sym_AT] = ACTIONS(870),
    [anon_sym_not] = ACTIONS(868),
    [anon_sym_PLUS] = ACTIONS(870),
    [anon_sym_DASH] = ACTIONS(870),
    [anon_sym_TILDE] = ACTIONS(870),
    [anon_sym_lambda] = ACTIONS(868),
    [anon_sym_yield] = ACTIONS(868),
    [anon_sym_LBRACK] = ACTIONS(870),
    [sym_ellipsis] = ACTIONS(870),
    [anon_sym_LBRACE] = ACTIONS(870),
    [sym_integer] = ACTIONS(868),
    [sym_float] = ACTIONS(870),
    [sym_true] = ACTIONS(868),
    [sym_false] = ACTIONS(868),
    [sym_none] = ACTIONS(868),
    [anon_sym_await] = ACTIONS(868),
    [sym_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(870),
  },
  [303] = {
    [sym_named_expression] = STATE(706),
    [sym__expression] = STATE(706),
    [sym__primary_expression] = STATE(383),
    [sym_not_operator] = STATE(706),
    [sym_boolean_operator] = STATE(706),
    [sym_binary_operator] = STATE(383),
    [sym_unary_operator] = STATE(383),
    [sym_comparison_operator] = STATE(706),
    [sym_lambda] = STATE(706),
    [sym_attribute] = STATE(383),
    [sym_subscript] = STATE(383),
    [sym_call] = STATE(383),
    [sym_list] = STATE(383),
    [sym_list_comprehension] = STATE(383),
    [sym_dictionary] = STATE(383),
    [sym_dictionary_comprehension] = STATE(383),
    [sym_set] = STATE(383),
    [sym_set_comprehension] = STATE(383),
    [sym_parenthesized_expression] = STATE(383),
    [sym_tuple] = STATE(383),
    [sym_generator_expression] = STATE(383),
    [sym_conditional_expression] = STATE(706),
    [sym_concatenated_string] = STATE(383),
    [sym_string] = STATE(381),
    [sym_await] = STATE(706),
    [sym_identifier] = ACTIONS(387),
    [anon_sym_LPAREN] = ACTIONS(389),
    [anon_sym_print] = ACTIONS(393),
    [anon_sym_exec] = ACTIONS(393),
    [anon_sym_not] = ACTIONS(361),
    [anon_sym_PLUS] = ACTIONS(363),
    [anon_sym_DASH] = ACTIONS(363),
    [anon_sym_TILDE] = ACTIONS(363),
    [anon_sym_lambda] = ACTIONS(365),
    [anon_sym_LBRACK] = ACTIONS(367),
    [sym_ellipsis] = ACTIONS(369),
    [anon_sym_LBRACE] = ACTIONS(371),
    [sym_integer] = ACTIONS(373),
    [sym_float] = ACTIONS(369),
    [sym_true] = ACTIONS(373),
    [sym_false] = ACTIONS(373),
    [sym_none] = ACTIONS(373),
    [anon_sym_await] = ACTIONS(375),
    [sym_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(377),
  },
  [304] = {
    [sym_named_expression] = STATE(712),
    [sym__expression] = STATE(712),
    [sym__primary_expression] = STATE(503),
    [sym_not_operator] = STATE(712),
    [sym_boolean_operator] = STATE(712),
    [sym_binary_operator] = STATE(503),
    [sym_unary_operator] = STATE(503),
    [sym_comparison_operator] = STATE(712),
    [sym_lambda] = STATE(712),
    [sym_attribute] = STATE(503),
    [sym_subscript] = STATE(503),
    [sym_call] = STATE(503),
    [sym_list] = STATE(503),
    [sym_list_comprehension] = STATE(503),
    [sym_dictionary] = STATE(503),
    [sym_dictionary_comprehension] = STATE(503),
    [sym_set] = STATE(503),
    [sym_set_comprehension] = STATE(503),
    [sym_parenthesized_expression] = STATE(503),
    [sym_tuple] = STATE(503),
    [sym_generator_expression] = STATE(503),
    [sym_conditional_expression] = STATE(712),
    [sym_concatenated_string] = STATE(503),
    [sym_string] = STATE(505),
    [sym_await] = STATE(712),
    [sym_identifier] = ACTIONS(810),
    [anon_sym_LPAREN] = ACTIONS(812),
    [anon_sym_print] = ACTIONS(814),
    [anon_sym_exec] = ACTIONS(814),
    [anon_sym_not] = ACTIONS(818),
    [anon_sym_PLUS] = ACTIONS(820),
    [anon_sym_DASH] = ACTIONS(820),
    [anon_sym_TILDE] = ACTIONS(820),
    [anon_sym_lambda] = ACTIONS(822),
    [anon_sym_LBRACK] = ACTIONS(824),
    [sym_ellipsis] = ACTIONS(826),
    [anon_sym_LBRACE] = ACTIONS(828),
    [sym_integer] = ACTIONS(830),
    [sym_float] = ACTIONS(826),
    [sym_true] = ACTIONS(830),
    [sym_false] = ACTIONS(830),
    [sym_none] = ACTIONS(830),
    [anon_sym_await] = ACTIONS(832),
    [sym_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(834),
  },
  [305] = {
    [ts_builtin_sym_end] = ACTIONS(888),
    [sym_identifier] = ACTIONS(890),
    [anon_sym_import] = ACTIONS(890),
    [anon_sym_from] = ACTIONS(890),
    [anon_sym_LPAREN] = ACTIONS(888),
    [anon_sym_print] = ACTIONS(890),
    [anon_sym_assert] = ACTIONS(890),
    [anon_sym_return] = ACTIONS(890),
    [anon_sym_del] = ACTIONS(890),
    [anon_sym_raise] = ACTIONS(890),
    [anon_sym_pass] = ACTIONS(890),
    [anon_sym_break] = ACTIONS(890),
    [anon_sym_continue] = ACTIONS(890),
    [anon_sym_if] = ACTIONS(890),
    [anon_sym_else] = ACTIONS(890),
    [anon_sym_async] = ACTIONS(890),
    [anon_sym_for] = ACTIONS(890),
    [anon_sym_while] = ACTIONS(890),
    [anon_sym_try] = ACTIONS(890),
    [anon_sym_except] = ACTIONS(890),
    [anon_sym_finally] = ACTIONS(890),
    [anon_sym_with] = ACTIONS(890),
    [anon_sym_def] = ACTIONS(890),
    [anon_sym_global] = ACTIONS(890),
    [anon_sym_nonlocal] = ACTIONS(890),
    [anon_sym_exec] = ACTIONS(890),
    [anon_sym_class] = ACTIONS(890),
    [anon_sym_AT] = ACTIONS(888),
    [anon_sym_not] = ACTIONS(890),
    [anon_sym_PLUS] = ACTIONS(888),
    [anon_sym_DASH] = ACTIONS(888),
    [anon_sym_TILDE] = ACTIONS(888),
    [anon_sym_lambda] = ACTIONS(890),
    [anon_sym_yield] = ACTIONS(890),
    [anon_sym_LBRACK] = ACTIONS(888),
    [sym_ellipsis] = ACTIONS(888),
    [anon_sym_LBRACE] = ACTIONS(888),
    [sym_integer] = ACTIONS(890),
    [sym_float] = ACTIONS(888),
    [sym_true] = ACTIONS(890),
    [sym_false] = ACTIONS(890),
    [sym_none] = ACTIONS(890),
    [anon_sym_await] = ACTIONS(890),
    [sym_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(888),
  },
  [306] = {
    [sym_named_expression] = STATE(704),
    [sym__expression] = STATE(704),
    [sym__primary_expression] = STATE(503),
    [sym_not_operator] = STATE(704),
    [sym_boolean_operator] = STATE(704),
    [sym_binary_operator] = STATE(503),
    [sym_unary_operator] = STATE(503),
    [sym_comparison_operator] = STATE(704),
    [sym_lambda] = STATE(704),
    [sym_attribute] = STATE(503),
    [sym_subscript] = STATE(503),
    [sym_call] = STATE(503),
    [sym_list] = STATE(503),
    [sym_list_comprehension] = STATE(503),
    [sym_dictionary] = STATE(503),
    [sym_dictionary_comprehension] = STATE(503),
    [sym_set] = STATE(503),
    [sym_set_comprehension] = STATE(503),
    [sym_parenthesized_expression] = STATE(503),
    [sym_tuple] = STATE(503),
    [sym_generator_expression] = STATE(503),
    [sym_conditional_expression] = STATE(704),
    [sym_concatenated_string] = STATE(503),
    [sym_string] = STATE(505),
    [sym_await] = STATE(704),
    [sym_identifier] = ACTIONS(810),
    [anon_sym_LPAREN] = ACTIONS(812),
    [anon_sym_print] = ACTIONS(814),
    [anon_sym_exec] = ACTIONS(814),
    [anon_sym_not] = ACTIONS(818),
    [anon_sym_PLUS] = ACTIONS(820),
    [anon_sym_DASH] = ACTIONS(820),
    [anon_sym_TILDE] = ACTIONS(820),
    [anon_sym_lambda] = ACTIONS(822),
    [anon_sym_LBRACK] = ACTIONS(824),
    [sym_ellipsis] = ACTIONS(826),
    [anon_sym_LBRACE] = ACTIONS(828),
    [sym_integer] = ACTIONS(830),
    [sym_float] = ACTIONS(826),
    [sym_true] = ACTIONS(830),
    [sym_false] = ACTIONS(830),
    [sym_none] = ACTIONS(830),
    [anon_sym_await] = ACTIONS(832),
    [sym_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(834),
  },
  [307] = {
    [sym_named_expression] = STATE(607),
    [sym__expression] = STATE(607),
    [sym__primary_expression] = STATE(109),
    [sym_not_operator] = STATE(607),
    [sym_boolean_operator] = STATE(607),
    [sym_binary_operator] = STATE(109),
    [sym_unary_operator] = STATE(109),
    [sym_comparison_operator] = STATE(607),
    [sym_lambda] = STATE(607),
    [sym_attribute] = STATE(109),
    [sym_subscript] = STATE(109),
    [sym_call] = STATE(109),
    [sym_list] = STATE(109),
    [sym_list_comprehension] = STATE(109),
    [sym_dictionary] = STATE(109),
    [sym_dictionary_comprehension] = STATE(109),
    [sym_set] = STATE(109),
    [sym_set_comprehension] = STATE(109),
    [sym_parenthesized_expression] = STATE(109),
    [sym_tuple] = STATE(109),
    [sym_generator_expression] = STATE(109),
    [sym_conditional_expression] = STATE(607),
    [sym_concatenated_string] = STATE(109),
    [sym_string] = STATE(117),
    [sym_await] = STATE(607),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(13),
    [anon_sym_print] = ACTIONS(237),
    [anon_sym_exec] = ACTIONS(237),
    [anon_sym_not] = ACTIONS(55),
    [anon_sym_PLUS] = ACTIONS(57),
    [anon_sym_DASH] = ACTIONS(57),
    [anon_sym_TILDE] = ACTIONS(57),
    [anon_sym_lambda] = ACTIONS(59),
    [anon_sym_LBRACK] = ACTIONS(63),
    [sym_ellipsis] = ACTIONS(65),
    [anon_sym_LBRACE] = ACTIONS(67),
    [sym_integer] = ACTIONS(69),
    [sym_float] = ACTIONS(65),
    [sym_true] = ACTIONS(69),
    [sym_false] = ACTIONS(69),
    [sym_none] = ACTIONS(69),
    [anon_sym_await] = ACTIONS(71),
    [sym_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(73),
  },
  [308] = {
    [sym_named_expression] = STATE(643),
    [sym__expression] = STATE(643),
    [sym__primary_expression] = STATE(383),
    [sym_not_operator] = STATE(643),
    [sym_boolean_operator] = STATE(643),
    [sym_binary_operator] = STATE(383),
    [sym_unary_operator] = STATE(383),
    [sym_comparison_operator] = STATE(643),
    [sym_lambda] = STATE(643),
    [sym_attribute] = STATE(383),
    [sym_subscript] = STATE(383),
    [sym_call] = STATE(383),
    [sym_list] = STATE(383),
    [sym_list_comprehension] = STATE(383),
    [sym_dictionary] = STATE(383),
    [sym_dictionary_comprehension] = STATE(383),
    [sym_set] = STATE(383),
    [sym_set_comprehension] = STATE(383),
    [sym_parenthesized_expression] = STATE(383),
    [sym_tuple] = STATE(383),
    [sym_generator_expression] = STATE(383),
    [sym_conditional_expression] = STATE(643),
    [sym_concatenated_string] = STATE(383),
    [sym_string] = STATE(381),
    [sym_await] = STATE(643),
    [sym_identifier] = ACTIONS(387),
    [anon_sym_LPAREN] = ACTIONS(389),
    [anon_sym_print] = ACTIONS(393),
    [anon_sym_exec] = ACTIONS(393),
    [anon_sym_not] = ACTIONS(361),
    [anon_sym_PLUS] = ACTIONS(363),
    [anon_sym_DASH] = ACTIONS(363),
    [anon_sym_TILDE] = ACTIONS(363),
    [anon_sym_lambda] = ACTIONS(365),
    [anon_sym_LBRACK] = ACTIONS(367),
    [sym_ellipsis] = ACTIONS(369),
    [anon_sym_LBRACE] = ACTIONS(371),
    [sym_integer] = ACTIONS(373),
    [sym_float] = ACTIONS(369),
    [sym_true] = ACTIONS(373),
    [sym_false] = ACTIONS(373),
    [sym_none] = ACTIONS(373),
    [anon_sym_await] = ACTIONS(375),
    [sym_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(377),
  },
  [309] = {
    [sym_named_expression] = STATE(689),
    [sym__expression] = STATE(689),
    [sym__primary_expression] = STATE(383),
    [sym_not_operator] = STATE(689),
    [sym_boolean_operator] = STATE(689),
    [sym_binary_operator] = STATE(383),
    [sym_unary_operator] = STATE(383),
    [sym_comparison_operator] = STATE(689),
    [sym_lambda] = STATE(689),
    [sym_attribute] = STATE(383),
    [sym_subscript] = STATE(383),
    [sym_call] = STATE(383),
    [sym_list] = STATE(383),
    [sym_list_comprehension] = STATE(383),
    [sym_dictionary] = STATE(383),
    [sym_dictionary_comprehension] = STATE(383),
    [sym_set] = STATE(383),
    [sym_set_comprehension] = STATE(383),
    [sym_parenthesized_expression] = STATE(383),
    [sym_tuple] = STATE(383),
    [sym_generator_expression] = STATE(383),
    [sym_conditional_expression] = STATE(689),
    [sym_concatenated_string] = STATE(383),
    [sym_string] = STATE(381),
    [sym_await] = STATE(689),
    [sym_identifier] = ACTIONS(387),
    [anon_sym_LPAREN] = ACTIONS(389),
    [anon_sym_print] = ACTIONS(393),
    [anon_sym_exec] = ACTIONS(393),
    [anon_sym_not] = ACTIONS(361),
    [anon_sym_PLUS] = ACTIONS(363),
    [anon_sym_DASH] = ACTIONS(363),
    [anon_sym_TILDE] = ACTIONS(363),
    [anon_sym_lambda] = ACTIONS(365),
    [anon_sym_LBRACK] = ACTIONS(367),
    [sym_ellipsis] = ACTIONS(369),
    [anon_sym_LBRACE] = ACTIONS(371),
    [sym_integer] = ACTIONS(373),
    [sym_float] = ACTIONS(369),
    [sym_true] = ACTIONS(373),
    [sym_false] = ACTIONS(373),
    [sym_none] = ACTIONS(373),
    [anon_sym_await] = ACTIONS(375),
    [sym_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(377),
  },
  [310] = {
    [sym_named_expression] = STATE(727),
    [sym__expression] = STATE(727),
    [sym__primary_expression] = STATE(383),
    [sym_not_operator] = STATE(727),
    [sym_boolean_operator] = STATE(727),
    [sym_binary_operator] = STATE(383),
    [sym_unary_operator] = STATE(383),
    [sym_comparison_operator] = STATE(727),
    [sym_lambda] = STATE(727),
    [sym_attribute] = STATE(383),
    [sym_subscript] = STATE(383),
    [sym_call] = STATE(383),
    [sym_list] = STATE(383),
    [sym_list_comprehension] = STATE(383),
    [sym_dictionary] = STATE(383),
    [sym_dictionary_comprehension] = STATE(383),
    [sym_set] = STATE(383),
    [sym_set_comprehension] = STATE(383),
    [sym_parenthesized_expression] = STATE(383),
    [sym_tuple] = STATE(383),
    [sym_generator_expression] = STATE(383),
    [sym_conditional_expression] = STATE(727),
    [sym_concatenated_string] = STATE(383),
    [sym_string] = STATE(381),
    [sym_await] = STATE(727),
    [sym_identifier] = ACTIONS(387),
    [anon_sym_LPAREN] = ACTIONS(389),
    [anon_sym_print] = ACTIONS(393),
    [anon_sym_exec] = ACTIONS(393),
    [anon_sym_not] = ACTIONS(361),
    [anon_sym_PLUS] = ACTIONS(363),
    [anon_sym_DASH] = ACTIONS(363),
    [anon_sym_TILDE] = ACTIONS(363),
    [anon_sym_lambda] = ACTIONS(365),
    [anon_sym_LBRACK] = ACTIONS(367),
    [sym_ellipsis] = ACTIONS(369),
    [anon_sym_LBRACE] = ACTIONS(371),
    [sym_integer] = ACTIONS(373),
    [sym_float] = ACTIONS(369),
    [sym_true] = ACTIONS(373),
    [sym_false] = ACTIONS(373),
    [sym_none] = ACTIONS(373),
    [anon_sym_await] = ACTIONS(375),
    [sym_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(377),
  },
  [311] = {
    [sym_named_expression] = STATE(668),
    [sym__expression] = STATE(668),
    [sym__primary_expression] = STATE(383),
    [sym_not_operator] = STATE(668),
    [sym_boolean_operator] = STATE(668),
    [sym_binary_operator] = STATE(383),
    [sym_unary_operator] = STATE(383),
    [sym_comparison_operator] = STATE(668),
    [sym_lambda] = STATE(668),
    [sym_attribute] = STATE(383),
    [sym_subscript] = STATE(383),
    [sym_call] = STATE(383),
    [sym_list] = STATE(383),
    [sym_list_comprehension] = STATE(383),
    [sym_dictionary] = STATE(383),
    [sym_dictionary_comprehension] = STATE(383),
    [sym_set] = STATE(383),
    [sym_set_comprehension] = STATE(383),
    [sym_parenthesized_expression] = STATE(383),
    [sym_tuple] = STATE(383),
    [sym_generator_expression] = STATE(383),
    [sym_conditional_expression] = STATE(668),
    [sym_concatenated_string] = STATE(383),
    [sym_string] = STATE(381),
    [sym_await] = STATE(668),
    [sym_identifier] = ACTIONS(387),
    [anon_sym_LPAREN] = ACTIONS(389),
    [anon_sym_print] = ACTIONS(393),
    [anon_sym_exec] = ACTIONS(393),
    [anon_sym_not] = ACTIONS(361),
    [anon_sym_PLUS] = ACTIONS(363),
    [anon_sym_DASH] = ACTIONS(363),
    [anon_sym_TILDE] = ACTIONS(363),
    [anon_sym_lambda] = ACTIONS(365),
    [anon_sym_LBRACK] = ACTIONS(367),
    [sym_ellipsis] = ACTIONS(369),
    [anon_sym_LBRACE] = ACTIONS(371),
    [sym_integer] = ACTIONS(373),
    [sym_float] = ACTIONS(369),
    [sym_true] = ACTIONS(373),
    [sym_false] = ACTIONS(373),
    [sym_none] = ACTIONS(373),
    [anon_sym_await] = ACTIONS(375),
    [sym_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(377),
  },
  [312] = {
    [sym_named_expression] = STATE(628),
    [sym__expression] = STATE(628),
    [sym__primary_expression] = STATE(383),
    [sym_not_operator] = STATE(628),
    [sym_boolean_operator] = STATE(628),
    [sym_binary_operator] = STATE(383),
    [sym_unary_operator] = STATE(383),
    [sym_comparison_operator] = STATE(628),
    [sym_lambda] = STATE(628),
    [sym_attribute] = STATE(383),
    [sym_subscript] = STATE(383),
    [sym_call] = STATE(383),
    [sym_list] = STATE(383),
    [sym_list_comprehension] = STATE(383),
    [sym_dictionary] = STATE(383),
    [sym_dictionary_comprehension] = STATE(383),
    [sym_set] = STATE(383),
    [sym_set_comprehension] = STATE(383),
    [sym_parenthesized_expression] = STATE(383),
    [sym_tuple] = STATE(383),
    [sym_generator_expression] = STATE(383),
    [sym_conditional_expression] = STATE(628),
    [sym_concatenated_string] = STATE(383),
    [sym_string] = STATE(381),
    [sym_await] = STATE(628),
    [sym_identifier] = ACTIONS(387),
    [anon_sym_LPAREN] = ACTIONS(389),
    [anon_sym_print] = ACTIONS(393),
    [anon_sym_exec] = ACTIONS(393),
    [anon_sym_not] = ACTIONS(361),
    [anon_sym_PLUS] = ACTIONS(363),
    [anon_sym_DASH] = ACTIONS(363),
    [anon_sym_TILDE] = ACTIONS(363),
    [anon_sym_lambda] = ACTIONS(365),
    [anon_sym_LBRACK] = ACTIONS(367),
    [sym_ellipsis] = ACTIONS(369),
    [anon_sym_LBRACE] = ACTIONS(371),
    [sym_integer] = ACTIONS(373),
    [sym_float] = ACTIONS(369),
    [sym_true] = ACTIONS(373),
    [sym_false] = ACTIONS(373),
    [sym_none] = ACTIONS(373),
    [anon_sym_await] = ACTIONS(375),
    [sym_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(377),
  },
  [313] = {
    [sym_named_expression] = STATE(605),
    [sym__expression] = STATE(605),
    [sym__primary_expression] = STATE(109),
    [sym_not_operator] = STATE(605),
    [sym_boolean_operator] = STATE(605),
    [sym_binary_operator] = STATE(109),
    [sym_unary_operator] = STATE(109),
    [sym_comparison_operator] = STATE(605),
    [sym_lambda] = STATE(605),
    [sym_attribute] = STATE(109),
    [sym_subscript] = STATE(109),
    [sym_call] = STATE(109),
    [sym_list] = STATE(109),
    [sym_list_comprehension] = STATE(109),
    [sym_dictionary] = STATE(109),
    [sym_dictionary_comprehension] = STATE(109),
    [sym_set] = STATE(109),
    [sym_set_comprehension] = STATE(109),
    [sym_parenthesized_expression] = STATE(109),
    [sym_tuple] = STATE(109),
    [sym_generator_expression] = STATE(109),
    [sym_conditional_expression] = STATE(605),
    [sym_concatenated_string] = STATE(109),
    [sym_string] = STATE(117),
    [sym_await] = STATE(605),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(13),
    [anon_sym_print] = ACTIONS(237),
    [anon_sym_exec] = ACTIONS(237),
    [anon_sym_not] = ACTIONS(55),
    [anon_sym_PLUS] = ACTIONS(57),
    [anon_sym_DASH] = ACTIONS(57),
    [anon_sym_TILDE] = ACTIONS(57),
    [anon_sym_lambda] = ACTIONS(59),
    [anon_sym_LBRACK] = ACTIONS(63),
    [sym_ellipsis] = ACTIONS(65),
    [anon_sym_LBRACE] = ACTIONS(67),
    [sym_integer] = ACTIONS(69),
    [sym_float] = ACTIONS(65),
    [sym_true] = ACTIONS(69),
    [sym_false] = ACTIONS(69),
    [sym_none] = ACTIONS(69),
    [anon_sym_await] = ACTIONS(71),
    [sym_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(73),
  },
  [314] = {
    [sym_identifier] = ACTIONS(890),
    [anon_sym_import] = ACTIONS(890),
    [anon_sym_from] = ACTIONS(890),
    [anon_sym_LPAREN] = ACTIONS(888),
    [anon_sym_print] = ACTIONS(890),
    [anon_sym_assert] = ACTIONS(890),
    [anon_sym_return] = ACTIONS(890),
    [anon_sym_del] = ACTIONS(890),
    [anon_sym_raise] = ACTIONS(890),
    [anon_sym_pass] = ACTIONS(890),
    [anon_sym_break] = ACTIONS(890),
    [anon_sym_continue] = ACTIONS(890),
    [anon_sym_if] = ACTIONS(890),
    [anon_sym_else] = ACTIONS(890),
    [anon_sym_async] = ACTIONS(890),
    [anon_sym_for] = ACTIONS(890),
    [anon_sym_while] = ACTIONS(890),
    [anon_sym_try] = ACTIONS(890),
    [anon_sym_except] = ACTIONS(890),
    [anon_sym_finally] = ACTIONS(890),
    [anon_sym_with] = ACTIONS(890),
    [anon_sym_def] = ACTIONS(890),
    [anon_sym_global] = ACTIONS(890),
    [anon_sym_nonlocal] = ACTIONS(890),
    [anon_sym_exec] = ACTIONS(890),
    [anon_sym_class] = ACTIONS(890),
    [anon_sym_AT] = ACTIONS(888),
    [anon_sym_not] = ACTIONS(890),
    [anon_sym_PLUS] = ACTIONS(888),
    [anon_sym_DASH] = ACTIONS(888),
    [anon_sym_TILDE] = ACTIONS(888),
    [anon_sym_lambda] = ACTIONS(890),
    [anon_sym_yield] = ACTIONS(890),
    [anon_sym_LBRACK] = ACTIONS(888),
    [sym_ellipsis] = ACTIONS(888),
    [anon_sym_LBRACE] = ACTIONS(888),
    [sym_integer] = ACTIONS(890),
    [sym_float] = ACTIONS(888),
    [sym_true] = ACTIONS(890),
    [sym_false] = ACTIONS(890),
    [sym_none] = ACTIONS(890),
    [anon_sym_await] = ACTIONS(890),
    [sym_comment] = ACTIONS(3),
    [sym__dedent] = ACTIONS(888),
    [sym__string_start] = ACTIONS(888),
  },
  [315] = {
    [ts_builtin_sym_end] = ACTIONS(882),
    [sym_identifier] = ACTIONS(880),
    [anon_sym_import] = ACTIONS(880),
    [anon_sym_from] = ACTIONS(880),
    [anon_sym_LPAREN] = ACTIONS(882),
    [anon_sym_print] = ACTIONS(880),
    [anon_sym_assert] = ACTIONS(880),
    [anon_sym_return] = ACTIONS(880),
    [anon_sym_del] = ACTIONS(880),
    [anon_sym_raise] = ACTIONS(880),
    [anon_sym_pass] = ACTIONS(880),
    [anon_sym_break] = ACTIONS(880),
    [anon_sym_continue] = ACTIONS(880),
    [anon_sym_if] = ACTIONS(880),
    [anon_sym_else] = ACTIONS(880),
    [anon_sym_async] = ACTIONS(880),
    [anon_sym_for] = ACTIONS(880),
    [anon_sym_while] = ACTIONS(880),
    [anon_sym_try] = ACTIONS(880),
    [anon_sym_except] = ACTIONS(880),
    [anon_sym_finally] = ACTIONS(880),
    [anon_sym_with] = ACTIONS(880),
    [anon_sym_def] = ACTIONS(880),
    [anon_sym_global] = ACTIONS(880),
    [anon_sym_nonlocal] = ACTIONS(880),
    [anon_sym_exec] = ACTIONS(880),
    [anon_sym_class] = ACTIONS(880),
    [anon_sym_AT] = ACTIONS(882),
    [anon_sym_not] = ACTIONS(880),
    [anon_sym_PLUS] = ACTIONS(882),
    [anon_sym_DASH] = ACTIONS(882),
    [anon_sym_TILDE] = ACTIONS(882),
    [anon_sym_lambda] = ACTIONS(880),
    [anon_sym_yield] = ACTIONS(880),
    [anon_sym_LBRACK] = ACTIONS(882),
    [sym_ellipsis] = ACTIONS(882),
    [anon_sym_LBRACE] = ACTIONS(882),
    [sym_integer] = ACTIONS(880),
    [sym_float] = ACTIONS(882),
    [sym_true] = ACTIONS(880),
    [sym_false] = ACTIONS(880),
    [sym_none] = ACTIONS(880),
    [anon_sym_await] = ACTIONS(880),
    [sym_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(882),
  },
  [316] = {
    [sym_named_expression] = STATE(775),
    [sym__expression] = STATE(775),
    [sym__primary_expression] = STATE(383),
    [sym_not_operator] = STATE(775),
    [sym_boolean_operator] = STATE(775),
    [sym_binary_operator] = STATE(383),
    [sym_unary_operator] = STATE(383),
    [sym_comparison_operator] = STATE(775),
    [sym_lambda] = STATE(775),
    [sym_attribute] = STATE(383),
    [sym_subscript] = STATE(383),
    [sym_call] = STATE(383),
    [sym_list] = STATE(383),
    [sym_list_comprehension] = STATE(383),
    [sym_dictionary] = STATE(383),
    [sym_dictionary_comprehension] = STATE(383),
    [sym_set] = STATE(383),
    [sym_set_comprehension] = STATE(383),
    [sym_parenthesized_expression] = STATE(383),
    [sym_tuple] = STATE(383),
    [sym_generator_expression] = STATE(383),
    [sym_conditional_expression] = STATE(775),
    [sym_concatenated_string] = STATE(383),
    [sym_string] = STATE(381),
    [sym_await] = STATE(775),
    [sym_identifier] = ACTIONS(387),
    [anon_sym_LPAREN] = ACTIONS(389),
    [anon_sym_print] = ACTIONS(393),
    [anon_sym_exec] = ACTIONS(393),
    [anon_sym_not] = ACTIONS(361),
    [anon_sym_PLUS] = ACTIONS(363),
    [anon_sym_DASH] = ACTIONS(363),
    [anon_sym_TILDE] = ACTIONS(363),
    [anon_sym_lambda] = ACTIONS(365),
    [anon_sym_LBRACK] = ACTIONS(367),
    [sym_ellipsis] = ACTIONS(369),
    [anon_sym_LBRACE] = ACTIONS(371),
    [sym_integer] = ACTIONS(373),
    [sym_float] = ACTIONS(369),
    [sym_true] = ACTIONS(373),
    [sym_false] = ACTIONS(373),
    [sym_none] = ACTIONS(373),
    [anon_sym_await] = ACTIONS(375),
    [sym_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(377),
  },
  [317] = {
    [sym_named_expression] = STATE(740),
    [sym__expression] = STATE(740),
    [sym__primary_expression] = STATE(383),
    [sym_not_operator] = STATE(740),
    [sym_boolean_operator] = STATE(740),
    [sym_binary_operator] = STATE(383),
    [sym_unary_operator] = STATE(383),
    [sym_comparison_operator] = STATE(740),
    [sym_lambda] = STATE(740),
    [sym_attribute] = STATE(383),
    [sym_subscript] = STATE(383),
    [sym_call] = STATE(383),
    [sym_list] = STATE(383),
    [sym_list_comprehension] = STATE(383),
    [sym_dictionary] = STATE(383),
    [sym_dictionary_comprehension] = STATE(383),
    [sym_set] = STATE(383),
    [sym_set_comprehension] = STATE(383),
    [sym_parenthesized_expression] = STATE(383),
    [sym_tuple] = STATE(383),
    [sym_generator_expression] = STATE(383),
    [sym_conditional_expression] = STATE(740),
    [sym_concatenated_string] = STATE(383),
    [sym_string] = STATE(381),
    [sym_await] = STATE(740),
    [sym_identifier] = ACTIONS(387),
    [anon_sym_LPAREN] = ACTIONS(389),
    [anon_sym_print] = ACTIONS(393),
    [anon_sym_exec] = ACTIONS(393),
    [anon_sym_not] = ACTIONS(361),
    [anon_sym_PLUS] = ACTIONS(363),
    [anon_sym_DASH] = ACTIONS(363),
    [anon_sym_TILDE] = ACTIONS(363),
    [anon_sym_lambda] = ACTIONS(365),
    [anon_sym_LBRACK] = ACTIONS(367),
    [sym_ellipsis] = ACTIONS(369),
    [anon_sym_LBRACE] = ACTIONS(371),
    [sym_integer] = ACTIONS(373),
    [sym_float] = ACTIONS(369),
    [sym_true] = ACTIONS(373),
    [sym_false] = ACTIONS(373),
    [sym_none] = ACTIONS(373),
    [anon_sym_await] = ACTIONS(375),
    [sym_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(377),
  },
  [318] = {
    [sym_named_expression] = STATE(603),
    [sym__expression] = STATE(603),
    [sym__primary_expression] = STATE(109),
    [sym_not_operator] = STATE(603),
    [sym_boolean_operator] = STATE(603),
    [sym_binary_operator] = STATE(109),
    [sym_unary_operator] = STATE(109),
    [sym_comparison_operator] = STATE(603),
    [sym_lambda] = STATE(603),
    [sym_attribute] = STATE(109),
    [sym_subscript] = STATE(109),
    [sym_call] = STATE(109),
    [sym_list] = STATE(109),
    [sym_list_comprehension] = STATE(109),
    [sym_dictionary] = STATE(109),
    [sym_dictionary_comprehension] = STATE(109),
    [sym_set] = STATE(109),
    [sym_set_comprehension] = STATE(109),
    [sym_parenthesized_expression] = STATE(109),
    [sym_tuple] = STATE(109),
    [sym_generator_expression] = STATE(109),
    [sym_conditional_expression] = STATE(603),
    [sym_concatenated_string] = STATE(109),
    [sym_string] = STATE(117),
    [sym_await] = STATE(603),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(13),
    [anon_sym_print] = ACTIONS(237),
    [anon_sym_exec] = ACTIONS(237),
    [anon_sym_not] = ACTIONS(55),
    [anon_sym_PLUS] = ACTIONS(57),
    [anon_sym_DASH] = ACTIONS(57),
    [anon_sym_TILDE] = ACTIONS(57),
    [anon_sym_lambda] = ACTIONS(59),
    [anon_sym_LBRACK] = ACTIONS(63),
    [sym_ellipsis] = ACTIONS(65),
    [anon_sym_LBRACE] = ACTIONS(67),
    [sym_integer] = ACTIONS(69),
    [sym_float] = ACTIONS(65),
    [sym_true] = ACTIONS(69),
    [sym_false] = ACTIONS(69),
    [sym_none] = ACTIONS(69),
    [anon_sym_await] = ACTIONS(71),
    [sym_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(73),
  },
  [319] = {
    [sym_named_expression] = STATE(600),
    [sym__expression] = STATE(600),
    [sym__primary_expression] = STATE(109),
    [sym_not_operator] = STATE(600),
    [sym_boolean_operator] = STATE(600),
    [sym_binary_operator] = STATE(109),
    [sym_unary_operator] = STATE(109),
    [sym_comparison_operator] = STATE(600),
    [sym_lambda] = STATE(600),
    [sym_attribute] = STATE(109),
    [sym_subscript] = STATE(109),
    [sym_call] = STATE(109),
    [sym_list] = STATE(109),
    [sym_list_comprehension] = STATE(109),
    [sym_dictionary] = STATE(109),
    [sym_dictionary_comprehension] = STATE(109),
    [sym_set] = STATE(109),
    [sym_set_comprehension] = STATE(109),
    [sym_parenthesized_expression] = STATE(109),
    [sym_tuple] = STATE(109),
    [sym_generator_expression] = STATE(109),
    [sym_conditional_expression] = STATE(600),
    [sym_concatenated_string] = STATE(109),
    [sym_string] = STATE(117),
    [sym_await] = STATE(600),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(13),
    [anon_sym_print] = ACTIONS(237),
    [anon_sym_exec] = ACTIONS(237),
    [anon_sym_not] = ACTIONS(55),
    [anon_sym_PLUS] = ACTIONS(57),
    [anon_sym_DASH] = ACTIONS(57),
    [anon_sym_TILDE] = ACTIONS(57),
    [anon_sym_lambda] = ACTIONS(59),
    [anon_sym_LBRACK] = ACTIONS(63),
    [sym_ellipsis] = ACTIONS(65),
    [anon_sym_LBRACE] = ACTIONS(67),
    [sym_integer] = ACTIONS(69),
    [sym_float] = ACTIONS(65),
    [sym_true] = ACTIONS(69),
    [sym_false] = ACTIONS(69),
    [sym_none] = ACTIONS(69),
    [anon_sym_await] = ACTIONS(71),
    [sym_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(73),
  },
  [320] = {
    [ts_builtin_sym_end] = ACTIONS(878),
    [sym_identifier] = ACTIONS(876),
    [anon_sym_import] = ACTIONS(876),
    [anon_sym_from] = ACTIONS(876),
    [anon_sym_LPAREN] = ACTIONS(878),
    [anon_sym_print] = ACTIONS(876),
    [anon_sym_assert] = ACTIONS(876),
    [anon_sym_return] = ACTIONS(876),
    [anon_sym_del] = ACTIONS(876),
    [anon_sym_raise] = ACTIONS(876),
    [anon_sym_pass] = ACTIONS(876),
    [anon_sym_break] = ACTIONS(876),
    [anon_sym_continue] = ACTIONS(876),
    [anon_sym_if] = ACTIONS(876),
    [anon_sym_else] = ACTIONS(876),
    [anon_sym_async] = ACTIONS(876),
    [anon_sym_for] = ACTIONS(876),
    [anon_sym_while] = ACTIONS(876),
    [anon_sym_try] = ACTIONS(876),
    [anon_sym_except] = ACTIONS(876),
    [anon_sym_finally] = ACTIONS(876),
    [anon_sym_with] = ACTIONS(876),
    [anon_sym_def] = ACTIONS(876),
    [anon_sym_global] = ACTIONS(876),
    [anon_sym_nonlocal] = ACTIONS(876),
    [anon_sym_exec] = ACTIONS(876),
    [anon_sym_class] = ACTIONS(876),
    [anon_sym_AT] = ACTIONS(878),
    [anon_sym_not] = ACTIONS(876),
    [anon_sym_PLUS] = ACTIONS(878),
    [anon_sym_DASH] = ACTIONS(878),
    [anon_sym_TILDE] = ACTIONS(878),
    [anon_sym_lambda] = ACTIONS(876),
    [anon_sym_yield] = ACTIONS(876),
    [anon_sym_LBRACK] = ACTIONS(878),
    [sym_ellipsis] = ACTIONS(878),
    [anon_sym_LBRACE] = ACTIONS(878),
    [sym_integer] = ACTIONS(876),
    [sym_float] = ACTIONS(878),
    [sym_true] = ACTIONS(876),
    [sym_false] = ACTIONS(876),
    [sym_none] = ACTIONS(876),
    [anon_sym_await] = ACTIONS(876),
    [sym_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(878),
  },
  [321] = {
    [sym_named_expression] = STATE(627),
    [sym__expression] = STATE(627),
    [sym__primary_expression] = STATE(383),
    [sym_not_operator] = STATE(627),
    [sym_boolean_operator] = STATE(627),
    [sym_binary_operator] = STATE(383),
    [sym_unary_operator] = STATE(383),
    [sym_comparison_operator] = STATE(627),
    [sym_lambda] = STATE(627),
    [sym_attribute] = STATE(383),
    [sym_subscript] = STATE(383),
    [sym_call] = STATE(383),
    [sym_list] = STATE(383),
    [sym_list_comprehension] = STATE(383),
    [sym_dictionary] = STATE(383),
    [sym_dictionary_comprehension] = STATE(383),
    [sym_set] = STATE(383),
    [sym_set_comprehension] = STATE(383),
    [sym_parenthesized_expression] = STATE(383),
    [sym_tuple] = STATE(383),
    [sym_generator_expression] = STATE(383),
    [sym_conditional_expression] = STATE(627),
    [sym_concatenated_string] = STATE(383),
    [sym_string] = STATE(381),
    [sym_await] = STATE(627),
    [sym_identifier] = ACTIONS(387),
    [anon_sym_LPAREN] = ACTIONS(389),
    [anon_sym_print] = ACTIONS(393),
    [anon_sym_exec] = ACTIONS(393),
    [anon_sym_not] = ACTIONS(361),
    [anon_sym_PLUS] = ACTIONS(363),
    [anon_sym_DASH] = ACTIONS(363),
    [anon_sym_TILDE] = ACTIONS(363),
    [anon_sym_lambda] = ACTIONS(365),
    [anon_sym_LBRACK] = ACTIONS(367),
    [sym_ellipsis] = ACTIONS(369),
    [anon_sym_LBRACE] = ACTIONS(371),
    [sym_integer] = ACTIONS(373),
    [sym_float] = ACTIONS(369),
    [sym_true] = ACTIONS(373),
    [sym_false] = ACTIONS(373),
    [sym_none] = ACTIONS(373),
    [anon_sym_await] = ACTIONS(375),
    [sym_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(377),
  },
  [322] = {
    [sym_named_expression] = STATE(764),
    [sym__expression] = STATE(764),
    [sym__primary_expression] = STATE(383),
    [sym_not_operator] = STATE(764),
    [sym_boolean_operator] = STATE(764),
    [sym_binary_operator] = STATE(383),
    [sym_unary_operator] = STATE(383),
    [sym_comparison_operator] = STATE(764),
    [sym_lambda] = STATE(764),
    [sym_attribute] = STATE(383),
    [sym_subscript] = STATE(383),
    [sym_call] = STATE(383),
    [sym_list] = STATE(383),
    [sym_list_comprehension] = STATE(383),
    [sym_dictionary] = STATE(383),
    [sym_dictionary_comprehension] = STATE(383),
    [sym_set] = STATE(383),
    [sym_set_comprehension] = STATE(383),
    [sym_parenthesized_expression] = STATE(383),
    [sym_tuple] = STATE(383),
    [sym_generator_expression] = STATE(383),
    [sym_conditional_expression] = STATE(764),
    [sym_concatenated_string] = STATE(383),
    [sym_string] = STATE(381),
    [sym_await] = STATE(764),
    [sym_identifier] = ACTIONS(387),
    [anon_sym_LPAREN] = ACTIONS(389),
    [anon_sym_print] = ACTIONS(393),
    [anon_sym_exec] = ACTIONS(393),
    [anon_sym_not] = ACTIONS(361),
    [anon_sym_PLUS] = ACTIONS(363),
    [anon_sym_DASH] = ACTIONS(363),
    [anon_sym_TILDE] = ACTIONS(363),
    [anon_sym_lambda] = ACTIONS(365),
    [anon_sym_LBRACK] = ACTIONS(367),
    [sym_ellipsis] = ACTIONS(369),
    [anon_sym_LBRACE] = ACTIONS(371),
    [sym_integer] = ACTIONS(373),
    [sym_float] = ACTIONS(369),
    [sym_true] = ACTIONS(373),
    [sym_false] = ACTIONS(373),
    [sym_none] = ACTIONS(373),
    [anon_sym_await] = ACTIONS(375),
    [sym_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(377),
  },
  [323] = {
    [sym_named_expression] = STATE(734),
    [sym__expression] = STATE(734),
    [sym__primary_expression] = STATE(383),
    [sym_not_operator] = STATE(734),
    [sym_boolean_operator] = STATE(734),
    [sym_binary_operator] = STATE(383),
    [sym_unary_operator] = STATE(383),
    [sym_comparison_operator] = STATE(734),
    [sym_lambda] = STATE(734),
    [sym_attribute] = STATE(383),
    [sym_subscript] = STATE(383),
    [sym_call] = STATE(383),
    [sym_list] = STATE(383),
    [sym_list_comprehension] = STATE(383),
    [sym_dictionary] = STATE(383),
    [sym_dictionary_comprehension] = STATE(383),
    [sym_set] = STATE(383),
    [sym_set_comprehension] = STATE(383),
    [sym_parenthesized_expression] = STATE(383),
    [sym_tuple] = STATE(383),
    [sym_generator_expression] = STATE(383),
    [sym_conditional_expression] = STATE(734),
    [sym_concatenated_string] = STATE(383),
    [sym_string] = STATE(381),
    [sym_await] = STATE(734),
    [sym_identifier] = ACTIONS(387),
    [anon_sym_LPAREN] = ACTIONS(389),
    [anon_sym_print] = ACTIONS(393),
    [anon_sym_exec] = ACTIONS(393),
    [anon_sym_not] = ACTIONS(361),
    [anon_sym_PLUS] = ACTIONS(363),
    [anon_sym_DASH] = ACTIONS(363),
    [anon_sym_TILDE] = ACTIONS(363),
    [anon_sym_lambda] = ACTIONS(365),
    [anon_sym_LBRACK] = ACTIONS(367),
    [sym_ellipsis] = ACTIONS(369),
    [anon_sym_LBRACE] = ACTIONS(371),
    [sym_integer] = ACTIONS(373),
    [sym_float] = ACTIONS(369),
    [sym_true] = ACTIONS(373),
    [sym_false] = ACTIONS(373),
    [sym_none] = ACTIONS(373),
    [anon_sym_await] = ACTIONS(375),
    [sym_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(377),
  },
  [324] = {
    [sym_named_expression] = STATE(714),
    [sym__expression] = STATE(714),
    [sym__primary_expression] = STATE(109),
    [sym_not_operator] = STATE(714),
    [sym_boolean_operator] = STATE(714),
    [sym_binary_operator] = STATE(109),
    [sym_unary_operator] = STATE(109),
    [sym_comparison_operator] = STATE(714),
    [sym_lambda] = STATE(714),
    [sym_attribute] = STATE(109),
    [sym_subscript] = STATE(109),
    [sym_call] = STATE(109),
    [sym_list] = STATE(109),
    [sym_list_comprehension] = STATE(109),
    [sym_dictionary] = STATE(109),
    [sym_dictionary_comprehension] = STATE(109),
    [sym_set] = STATE(109),
    [sym_set_comprehension] = STATE(109),
    [sym_parenthesized_expression] = STATE(109),
    [sym_tuple] = STATE(109),
    [sym_generator_expression] = STATE(109),
    [sym_conditional_expression] = STATE(714),
    [sym_concatenated_string] = STATE(109),
    [sym_string] = STATE(117),
    [sym_await] = STATE(714),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(13),
    [anon_sym_print] = ACTIONS(237),
    [anon_sym_exec] = ACTIONS(237),
    [anon_sym_not] = ACTIONS(55),
    [anon_sym_PLUS] = ACTIONS(57),
    [anon_sym_DASH] = ACTIONS(57),
    [anon_sym_TILDE] = ACTIONS(57),
    [anon_sym_lambda] = ACTIONS(59),
    [anon_sym_LBRACK] = ACTIONS(63),
    [sym_ellipsis] = ACTIONS(65),
    [anon_sym_LBRACE] = ACTIONS(67),
    [sym_integer] = ACTIONS(69),
    [sym_float] = ACTIONS(65),
    [sym_true] = ACTIONS(69),
    [sym_false] = ACTIONS(69),
    [sym_none] = ACTIONS(69),
    [anon_sym_await] = ACTIONS(71),
    [sym_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(73),
  },
  [325] = {
    [sym_named_expression] = STATE(728),
    [sym__expression] = STATE(728),
    [sym__primary_expression] = STATE(503),
    [sym_not_operator] = STATE(728),
    [sym_boolean_operator] = STATE(728),
    [sym_binary_operator] = STATE(503),
    [sym_unary_operator] = STATE(503),
    [sym_comparison_operator] = STATE(728),
    [sym_lambda] = STATE(728),
    [sym_attribute] = STATE(503),
    [sym_subscript] = STATE(503),
    [sym_call] = STATE(503),
    [sym_list] = STATE(503),
    [sym_list_comprehension] = STATE(503),
    [sym_dictionary] = STATE(503),
    [sym_dictionary_comprehension] = STATE(503),
    [sym_set] = STATE(503),
    [sym_set_comprehension] = STATE(503),
    [sym_parenthesized_expression] = STATE(503),
    [sym_tuple] = STATE(503),
    [sym_generator_expression] = STATE(503),
    [sym_conditional_expression] = STATE(728),
    [sym_concatenated_string] = STATE(503),
    [sym_string] = STATE(505),
    [sym_await] = STATE(728),
    [sym_identifier] = ACTIONS(810),
    [anon_sym_LPAREN] = ACTIONS(812),
    [anon_sym_print] = ACTIONS(814),
    [anon_sym_exec] = ACTIONS(814),
    [anon_sym_not] = ACTIONS(818),
    [anon_sym_PLUS] = ACTIONS(820),
    [anon_sym_DASH] = ACTIONS(820),
    [anon_sym_TILDE] = ACTIONS(820),
    [anon_sym_lambda] = ACTIONS(822),
    [anon_sym_LBRACK] = ACTIONS(824),
    [sym_ellipsis] = ACTIONS(826),
    [anon_sym_LBRACE] = ACTIONS(828),
    [sym_integer] = ACTIONS(830),
    [sym_float] = ACTIONS(826),
    [sym_true] = ACTIONS(830),
    [sym_false] = ACTIONS(830),
    [sym_none] = ACTIONS(830),
    [anon_sym_await] = ACTIONS(832),
    [sym_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(834),
  },
  [326] = {
    [sym_named_expression] = STATE(602),
    [sym__expression] = STATE(602),
    [sym__primary_expression] = STATE(109),
    [sym_not_operator] = STATE(602),
    [sym_boolean_operator] = STATE(602),
    [sym_binary_operator] = STATE(109),
    [sym_unary_operator] = STATE(109),
    [sym_comparison_operator] = STATE(602),
    [sym_lambda] = STATE(602),
    [sym_attribute] = STATE(109),
    [sym_subscript] = STATE(109),
    [sym_call] = STATE(109),
    [sym_list] = STATE(109),
    [sym_list_comprehension] = STATE(109),
    [sym_dictionary] = STATE(109),
    [sym_dictionary_comprehension] = STATE(109),
    [sym_set] = STATE(109),
    [sym_set_comprehension] = STATE(109),
    [sym_parenthesized_expression] = STATE(109),
    [sym_tuple] = STATE(109),
    [sym_generator_expression] = STATE(109),
    [sym_conditional_expression] = STATE(602),
    [sym_concatenated_string] = STATE(109),
    [sym_string] = STATE(117),
    [sym_await] = STATE(602),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(13),
    [anon_sym_print] = ACTIONS(237),
    [anon_sym_exec] = ACTIONS(237),
    [anon_sym_not] = ACTIONS(55),
    [anon_sym_PLUS] = ACTIONS(57),
    [anon_sym_DASH] = ACTIONS(57),
    [anon_sym_TILDE] = ACTIONS(57),
    [anon_sym_lambda] = ACTIONS(59),
    [anon_sym_LBRACK] = ACTIONS(63),
    [sym_ellipsis] = ACTIONS(65),
    [anon_sym_LBRACE] = ACTIONS(67),
    [sym_integer] = ACTIONS(69),
    [sym_float] = ACTIONS(65),
    [sym_true] = ACTIONS(69),
    [sym_false] = ACTIONS(69),
    [sym_none] = ACTIONS(69),
    [anon_sym_await] = ACTIONS(71),
    [sym_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(73),
  },
  [327] = {
    [sym_named_expression] = STATE(626),
    [sym__expression] = STATE(626),
    [sym__primary_expression] = STATE(383),
    [sym_not_operator] = STATE(626),
    [sym_boolean_operator] = STATE(626),
    [sym_binary_operator] = STATE(383),
    [sym_unary_operator] = STATE(383),
    [sym_comparison_operator] = STATE(626),
    [sym_lambda] = STATE(626),
    [sym_attribute] = STATE(383),
    [sym_subscript] = STATE(383),
    [sym_call] = STATE(383),
    [sym_list] = STATE(383),
    [sym_list_comprehension] = STATE(383),
    [sym_dictionary] = STATE(383),
    [sym_dictionary_comprehension] = STATE(383),
    [sym_set] = STATE(383),
    [sym_set_comprehension] = STATE(383),
    [sym_parenthesized_expression] = STATE(383),
    [sym_tuple] = STATE(383),
    [sym_generator_expression] = STATE(383),
    [sym_conditional_expression] = STATE(626),
    [sym_concatenated_string] = STATE(383),
    [sym_string] = STATE(381),
    [sym_await] = STATE(626),
    [sym_identifier] = ACTIONS(387),
    [anon_sym_LPAREN] = ACTIONS(389),
    [anon_sym_print] = ACTIONS(393),
    [anon_sym_exec] = ACTIONS(393),
    [anon_sym_not] = ACTIONS(361),
    [anon_sym_PLUS] = ACTIONS(363),
    [anon_sym_DASH] = ACTIONS(363),
    [anon_sym_TILDE] = ACTIONS(363),
    [anon_sym_lambda] = ACTIONS(365),
    [anon_sym_LBRACK] = ACTIONS(367),
    [sym_ellipsis] = ACTIONS(369),
    [anon_sym_LBRACE] = ACTIONS(371),
    [sym_integer] = ACTIONS(373),
    [sym_float] = ACTIONS(369),
    [sym_true] = ACTIONS(373),
    [sym_false] = ACTIONS(373),
    [sym_none] = ACTIONS(373),
    [anon_sym_await] = ACTIONS(375),
    [sym_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(377),
  },
  [328] = {
    [sym_named_expression] = STATE(770),
    [sym__expression] = STATE(770),
    [sym__primary_expression] = STATE(383),
    [sym_not_operator] = STATE(770),
    [sym_boolean_operator] = STATE(770),
    [sym_binary_operator] = STATE(383),
    [sym_unary_operator] = STATE(383),
    [sym_comparison_operator] = STATE(770),
    [sym_lambda] = STATE(770),
    [sym_attribute] = STATE(383),
    [sym_subscript] = STATE(383),
    [sym_call] = STATE(383),
    [sym_list] = STATE(383),
    [sym_list_comprehension] = STATE(383),
    [sym_dictionary] = STATE(383),
    [sym_dictionary_comprehension] = STATE(383),
    [sym_set] = STATE(383),
    [sym_set_comprehension] = STATE(383),
    [sym_parenthesized_expression] = STATE(383),
    [sym_tuple] = STATE(383),
    [sym_generator_expression] = STATE(383),
    [sym_conditional_expression] = STATE(770),
    [sym_concatenated_string] = STATE(383),
    [sym_string] = STATE(381),
    [sym_await] = STATE(770),
    [sym_identifier] = ACTIONS(387),
    [anon_sym_LPAREN] = ACTIONS(389),
    [anon_sym_print] = ACTIONS(393),
    [anon_sym_exec] = ACTIONS(393),
    [anon_sym_not] = ACTIONS(361),
    [anon_sym_PLUS] = ACTIONS(363),
    [anon_sym_DASH] = ACTIONS(363),
    [anon_sym_TILDE] = ACTIONS(363),
    [anon_sym_lambda] = ACTIONS(365),
    [anon_sym_LBRACK] = ACTIONS(367),
    [sym_ellipsis] = ACTIONS(369),
    [anon_sym_LBRACE] = ACTIONS(371),
    [sym_integer] = ACTIONS(373),
    [sym_float] = ACTIONS(369),
    [sym_true] = ACTIONS(373),
    [sym_false] = ACTIONS(373),
    [sym_none] = ACTIONS(373),
    [anon_sym_await] = ACTIONS(375),
    [sym_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(377),
  },
  [329] = {
    [sym_named_expression] = STATE(640),
    [sym__expression] = STATE(640),
    [sym__primary_expression] = STATE(383),
    [sym_not_operator] = STATE(640),
    [sym_boolean_operator] = STATE(640),
    [sym_binary_operator] = STATE(383),
    [sym_unary_operator] = STATE(383),
    [sym_comparison_operator] = STATE(640),
    [sym_lambda] = STATE(640),
    [sym_attribute] = STATE(383),
    [sym_subscript] = STATE(383),
    [sym_call] = STATE(383),
    [sym_list] = STATE(383),
    [sym_list_comprehension] = STATE(383),
    [sym_dictionary] = STATE(383),
    [sym_dictionary_comprehension] = STATE(383),
    [sym_set] = STATE(383),
    [sym_set_comprehension] = STATE(383),
    [sym_parenthesized_expression] = STATE(383),
    [sym_tuple] = STATE(383),
    [sym_generator_expression] = STATE(383),
    [sym_conditional_expression] = STATE(640),
    [sym_concatenated_string] = STATE(383),
    [sym_string] = STATE(381),
    [sym_await] = STATE(640),
    [sym_identifier] = ACTIONS(387),
    [anon_sym_LPAREN] = ACTIONS(389),
    [anon_sym_print] = ACTIONS(393),
    [anon_sym_exec] = ACTIONS(393),
    [anon_sym_not] = ACTIONS(361),
    [anon_sym_PLUS] = ACTIONS(363),
    [anon_sym_DASH] = ACTIONS(363),
    [anon_sym_TILDE] = ACTIONS(363),
    [anon_sym_lambda] = ACTIONS(365),
    [anon_sym_LBRACK] = ACTIONS(367),
    [sym_ellipsis] = ACTIONS(369),
    [anon_sym_LBRACE] = ACTIONS(371),
    [sym_integer] = ACTIONS(373),
    [sym_float] = ACTIONS(369),
    [sym_true] = ACTIONS(373),
    [sym_false] = ACTIONS(373),
    [sym_none] = ACTIONS(373),
    [anon_sym_await] = ACTIONS(375),
    [sym_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(377),
  },
  [330] = {
    [ts_builtin_sym_end] = ACTIONS(886),
    [sym_identifier] = ACTIONS(884),
    [anon_sym_import] = ACTIONS(884),
    [anon_sym_from] = ACTIONS(884),
    [anon_sym_LPAREN] = ACTIONS(886),
    [anon_sym_print] = ACTIONS(884),
    [anon_sym_assert] = ACTIONS(884),
    [anon_sym_return] = ACTIONS(884),
    [anon_sym_del] = ACTIONS(884),
    [anon_sym_raise] = ACTIONS(884),
    [anon_sym_pass] = ACTIONS(884),
    [anon_sym_break] = ACTIONS(884),
    [anon_sym_continue] = ACTIONS(884),
    [anon_sym_if] = ACTIONS(884),
    [anon_sym_else] = ACTIONS(884),
    [anon_sym_async] = ACTIONS(884),
    [anon_sym_for] = ACTIONS(884),
    [anon_sym_while] = ACTIONS(884),
    [anon_sym_try] = ACTIONS(884),
    [anon_sym_except] = ACTIONS(884),
    [anon_sym_finally] = ACTIONS(884),
    [anon_sym_with] = ACTIONS(884),
    [anon_sym_def] = ACTIONS(884),
    [anon_sym_global] = ACTIONS(884),
    [anon_sym_nonlocal] = ACTIONS(884),
    [anon_sym_exec] = ACTIONS(884),
    [anon_sym_class] = ACTIONS(884),
    [anon_sym_AT] = ACTIONS(886),
    [anon_sym_not] = ACTIONS(884),
    [anon_sym_PLUS] = ACTIONS(886),
    [anon_sym_DASH] = ACTIONS(886),
    [anon_sym_TILDE] = ACTIONS(886),
    [anon_sym_lambda] = ACTIONS(884),
    [anon_sym_yield] = ACTIONS(884),
    [anon_sym_LBRACK] = ACTIONS(886),
    [sym_ellipsis] = ACTIONS(886),
    [anon_sym_LBRACE] = ACTIONS(886),
    [sym_integer] = ACTIONS(884),
    [sym_float] = ACTIONS(886),
    [sym_true] = ACTIONS(884),
    [sym_false] = ACTIONS(884),
    [sym_none] = ACTIONS(884),
    [anon_sym_await] = ACTIONS(884),
    [sym_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(886),
  },
  [331] = {
    [sym_named_expression] = STATE(772),
    [sym__expression] = STATE(772),
    [sym__primary_expression] = STATE(383),
    [sym_not_operator] = STATE(772),
    [sym_boolean_operator] = STATE(772),
    [sym_binary_operator] = STATE(383),
    [sym_unary_operator] = STATE(383),
    [sym_comparison_operator] = STATE(772),
    [sym_lambda] = STATE(772),
    [sym_attribute] = STATE(383),
    [sym_subscript] = STATE(383),
    [sym_call] = STATE(383),
    [sym_list] = STATE(383),
    [sym_list_comprehension] = STATE(383),
    [sym_dictionary] = STATE(383),
    [sym_dictionary_comprehension] = STATE(383),
    [sym_set] = STATE(383),
    [sym_set_comprehension] = STATE(383),
    [sym_parenthesized_expression] = STATE(383),
    [sym_tuple] = STATE(383),
    [sym_generator_expression] = STATE(383),
    [sym_conditional_expression] = STATE(772),
    [sym_concatenated_string] = STATE(383),
    [sym_string] = STATE(381),
    [sym_await] = STATE(772),
    [sym_identifier] = ACTIONS(387),
    [anon_sym_LPAREN] = ACTIONS(389),
    [anon_sym_print] = ACTIONS(393),
    [anon_sym_exec] = ACTIONS(393),
    [anon_sym_not] = ACTIONS(361),
    [anon_sym_PLUS] = ACTIONS(363),
    [anon_sym_DASH] = ACTIONS(363),
    [anon_sym_TILDE] = ACTIONS(363),
    [anon_sym_lambda] = ACTIONS(365),
    [anon_sym_LBRACK] = ACTIONS(367),
    [sym_ellipsis] = ACTIONS(369),
    [anon_sym_LBRACE] = ACTIONS(371),
    [sym_integer] = ACTIONS(373),
    [sym_float] = ACTIONS(369),
    [sym_true] = ACTIONS(373),
    [sym_false] = ACTIONS(373),
    [sym_none] = ACTIONS(373),
    [anon_sym_await] = ACTIONS(375),
    [sym_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(377),
  },
  [332] = {
    [sym_named_expression] = STATE(719),
    [sym__expression] = STATE(719),
    [sym__primary_expression] = STATE(383),
    [sym_not_operator] = STATE(719),
    [sym_boolean_operator] = STATE(719),
    [sym_binary_operator] = STATE(383),
    [sym_unary_operator] = STATE(383),
    [sym_comparison_operator] = STATE(719),
    [sym_lambda] = STATE(719),
    [sym_attribute] = STATE(383),
    [sym_subscript] = STATE(383),
    [sym_call] = STATE(383),
    [sym_list] = STATE(383),
    [sym_list_comprehension] = STATE(383),
    [sym_dictionary] = STATE(383),
    [sym_dictionary_comprehension] = STATE(383),
    [sym_set] = STATE(383),
    [sym_set_comprehension] = STATE(383),
    [sym_parenthesized_expression] = STATE(383),
    [sym_tuple] = STATE(383),
    [sym_generator_expression] = STATE(383),
    [sym_conditional_expression] = STATE(719),
    [sym_concatenated_string] = STATE(383),
    [sym_string] = STATE(381),
    [sym_await] = STATE(719),
    [sym_identifier] = ACTIONS(387),
    [anon_sym_LPAREN] = ACTIONS(389),
    [anon_sym_print] = ACTIONS(393),
    [anon_sym_exec] = ACTIONS(393),
    [anon_sym_not] = ACTIONS(361),
    [anon_sym_PLUS] = ACTIONS(363),
    [anon_sym_DASH] = ACTIONS(363),
    [anon_sym_TILDE] = ACTIONS(363),
    [anon_sym_lambda] = ACTIONS(365),
    [anon_sym_LBRACK] = ACTIONS(367),
    [sym_ellipsis] = ACTIONS(369),
    [anon_sym_LBRACE] = ACTIONS(371),
    [sym_integer] = ACTIONS(373),
    [sym_float] = ACTIONS(369),
    [sym_true] = ACTIONS(373),
    [sym_false] = ACTIONS(373),
    [sym_none] = ACTIONS(373),
    [anon_sym_await] = ACTIONS(375),
    [sym_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(377),
  },
  [333] = {
    [sym_named_expression] = STATE(800),
    [sym__expression] = STATE(800),
    [sym__primary_expression] = STATE(383),
    [sym_not_operator] = STATE(800),
    [sym_boolean_operator] = STATE(800),
    [sym_binary_operator] = STATE(383),
    [sym_unary_operator] = STATE(383),
    [sym_comparison_operator] = STATE(800),
    [sym_lambda] = STATE(800),
    [sym_attribute] = STATE(383),
    [sym_subscript] = STATE(383),
    [sym_call] = STATE(383),
    [sym_list] = STATE(383),
    [sym_list_comprehension] = STATE(383),
    [sym_dictionary] = STATE(383),
    [sym_dictionary_comprehension] = STATE(383),
    [sym_set] = STATE(383),
    [sym_set_comprehension] = STATE(383),
    [sym_parenthesized_expression] = STATE(383),
    [sym_tuple] = STATE(383),
    [sym_generator_expression] = STATE(383),
    [sym_conditional_expression] = STATE(800),
    [sym_concatenated_string] = STATE(383),
    [sym_string] = STATE(381),
    [sym_await] = STATE(800),
    [sym_identifier] = ACTIONS(387),
    [anon_sym_LPAREN] = ACTIONS(389),
    [anon_sym_print] = ACTIONS(393),
    [anon_sym_exec] = ACTIONS(393),
    [anon_sym_not] = ACTIONS(361),
    [anon_sym_PLUS] = ACTIONS(363),
    [anon_sym_DASH] = ACTIONS(363),
    [anon_sym_TILDE] = ACTIONS(363),
    [anon_sym_lambda] = ACTIONS(365),
    [anon_sym_LBRACK] = ACTIONS(367),
    [sym_ellipsis] = ACTIONS(369),
    [anon_sym_LBRACE] = ACTIONS(371),
    [sym_integer] = ACTIONS(373),
    [sym_float] = ACTIONS(369),
    [sym_true] = ACTIONS(373),
    [sym_false] = ACTIONS(373),
    [sym_none] = ACTIONS(373),
    [anon_sym_await] = ACTIONS(375),
    [sym_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(377),
  },
  [334] = {
    [sym_named_expression] = STATE(793),
    [sym__expression] = STATE(793),
    [sym__primary_expression] = STATE(383),
    [sym_not_operator] = STATE(793),
    [sym_boolean_operator] = STATE(793),
    [sym_binary_operator] = STATE(383),
    [sym_unary_operator] = STATE(383),
    [sym_comparison_operator] = STATE(793),
    [sym_lambda] = STATE(793),
    [sym_attribute] = STATE(383),
    [sym_subscript] = STATE(383),
    [sym_call] = STATE(383),
    [sym_list] = STATE(383),
    [sym_list_comprehension] = STATE(383),
    [sym_dictionary] = STATE(383),
    [sym_dictionary_comprehension] = STATE(383),
    [sym_set] = STATE(383),
    [sym_set_comprehension] = STATE(383),
    [sym_parenthesized_expression] = STATE(383),
    [sym_tuple] = STATE(383),
    [sym_generator_expression] = STATE(383),
    [sym_conditional_expression] = STATE(793),
    [sym_concatenated_string] = STATE(383),
    [sym_string] = STATE(381),
    [sym_await] = STATE(793),
    [sym_identifier] = ACTIONS(387),
    [anon_sym_LPAREN] = ACTIONS(389),
    [anon_sym_print] = ACTIONS(393),
    [anon_sym_exec] = ACTIONS(393),
    [anon_sym_not] = ACTIONS(361),
    [anon_sym_PLUS] = ACTIONS(363),
    [anon_sym_DASH] = ACTIONS(363),
    [anon_sym_TILDE] = ACTIONS(363),
    [anon_sym_lambda] = ACTIONS(365),
    [anon_sym_LBRACK] = ACTIONS(367),
    [sym_ellipsis] = ACTIONS(369),
    [anon_sym_LBRACE] = ACTIONS(371),
    [sym_integer] = ACTIONS(373),
    [sym_float] = ACTIONS(369),
    [sym_true] = ACTIONS(373),
    [sym_false] = ACTIONS(373),
    [sym_none] = ACTIONS(373),
    [anon_sym_await] = ACTIONS(375),
    [sym_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(377),
  },
  [335] = {
    [sym_named_expression] = STATE(633),
    [sym__expression] = STATE(633),
    [sym__primary_expression] = STATE(383),
    [sym_not_operator] = STATE(633),
    [sym_boolean_operator] = STATE(633),
    [sym_binary_operator] = STATE(383),
    [sym_unary_operator] = STATE(383),
    [sym_comparison_operator] = STATE(633),
    [sym_lambda] = STATE(633),
    [sym_attribute] = STATE(383),
    [sym_subscript] = STATE(383),
    [sym_call] = STATE(383),
    [sym_list] = STATE(383),
    [sym_list_comprehension] = STATE(383),
    [sym_dictionary] = STATE(383),
    [sym_dictionary_comprehension] = STATE(383),
    [sym_set] = STATE(383),
    [sym_set_comprehension] = STATE(383),
    [sym_parenthesized_expression] = STATE(383),
    [sym_tuple] = STATE(383),
    [sym_generator_expression] = STATE(383),
    [sym_conditional_expression] = STATE(633),
    [sym_concatenated_string] = STATE(383),
    [sym_string] = STATE(381),
    [sym_await] = STATE(633),
    [sym_identifier] = ACTIONS(387),
    [anon_sym_LPAREN] = ACTIONS(389),
    [anon_sym_print] = ACTIONS(393),
    [anon_sym_exec] = ACTIONS(393),
    [anon_sym_not] = ACTIONS(361),
    [anon_sym_PLUS] = ACTIONS(363),
    [anon_sym_DASH] = ACTIONS(363),
    [anon_sym_TILDE] = ACTIONS(363),
    [anon_sym_lambda] = ACTIONS(365),
    [anon_sym_LBRACK] = ACTIONS(367),
    [sym_ellipsis] = ACTIONS(369),
    [anon_sym_LBRACE] = ACTIONS(371),
    [sym_integer] = ACTIONS(373),
    [sym_float] = ACTIONS(369),
    [sym_true] = ACTIONS(373),
    [sym_false] = ACTIONS(373),
    [sym_none] = ACTIONS(373),
    [anon_sym_await] = ACTIONS(375),
    [sym_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(377),
  },
  [336] = {
    [sym_named_expression] = STATE(794),
    [sym__expression] = STATE(794),
    [sym__primary_expression] = STATE(383),
    [sym_not_operator] = STATE(794),
    [sym_boolean_operator] = STATE(794),
    [sym_binary_operator] = STATE(383),
    [sym_unary_operator] = STATE(383),
    [sym_comparison_operator] = STATE(794),
    [sym_lambda] = STATE(794),
    [sym_attribute] = STATE(383),
    [sym_subscript] = STATE(383),
    [sym_call] = STATE(383),
    [sym_list] = STATE(383),
    [sym_list_comprehension] = STATE(383),
    [sym_dictionary] = STATE(383),
    [sym_dictionary_comprehension] = STATE(383),
    [sym_set] = STATE(383),
    [sym_set_comprehension] = STATE(383),
    [sym_parenthesized_expression] = STATE(383),
    [sym_tuple] = STATE(383),
    [sym_generator_expression] = STATE(383),
    [sym_conditional_expression] = STATE(794),
    [sym_concatenated_string] = STATE(383),
    [sym_string] = STATE(381),
    [sym_await] = STATE(794),
    [sym_identifier] = ACTIONS(387),
    [anon_sym_LPAREN] = ACTIONS(389),
    [anon_sym_print] = ACTIONS(393),
    [anon_sym_exec] = ACTIONS(393),
    [anon_sym_not] = ACTIONS(361),
    [anon_sym_PLUS] = ACTIONS(363),
    [anon_sym_DASH] = ACTIONS(363),
    [anon_sym_TILDE] = ACTIONS(363),
    [anon_sym_lambda] = ACTIONS(365),
    [anon_sym_LBRACK] = ACTIONS(367),
    [sym_ellipsis] = ACTIONS(369),
    [anon_sym_LBRACE] = ACTIONS(371),
    [sym_integer] = ACTIONS(373),
    [sym_float] = ACTIONS(369),
    [sym_true] = ACTIONS(373),
    [sym_false] = ACTIONS(373),
    [sym_none] = ACTIONS(373),
    [anon_sym_await] = ACTIONS(375),
    [sym_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(377),
  },
  [337] = {
    [sym_named_expression] = STATE(609),
    [sym__expression] = STATE(609),
    [sym__primary_expression] = STATE(109),
    [sym_not_operator] = STATE(609),
    [sym_boolean_operator] = STATE(609),
    [sym_binary_operator] = STATE(109),
    [sym_unary_operator] = STATE(109),
    [sym_comparison_operator] = STATE(609),
    [sym_lambda] = STATE(609),
    [sym_attribute] = STATE(109),
    [sym_subscript] = STATE(109),
    [sym_call] = STATE(109),
    [sym_list] = STATE(109),
    [sym_list_comprehension] = STATE(109),
    [sym_dictionary] = STATE(109),
    [sym_dictionary_comprehension] = STATE(109),
    [sym_set] = STATE(109),
    [sym_set_comprehension] = STATE(109),
    [sym_parenthesized_expression] = STATE(109),
    [sym_tuple] = STATE(109),
    [sym_generator_expression] = STATE(109),
    [sym_conditional_expression] = STATE(609),
    [sym_concatenated_string] = STATE(109),
    [sym_string] = STATE(117),
    [sym_await] = STATE(609),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(13),
    [anon_sym_print] = ACTIONS(237),
    [anon_sym_exec] = ACTIONS(237),
    [anon_sym_not] = ACTIONS(55),
    [anon_sym_PLUS] = ACTIONS(57),
    [anon_sym_DASH] = ACTIONS(57),
    [anon_sym_TILDE] = ACTIONS(57),
    [anon_sym_lambda] = ACTIONS(59),
    [anon_sym_LBRACK] = ACTIONS(63),
    [sym_ellipsis] = ACTIONS(65),
    [anon_sym_LBRACE] = ACTIONS(67),
    [sym_integer] = ACTIONS(69),
    [sym_float] = ACTIONS(65),
    [sym_true] = ACTIONS(69),
    [sym_false] = ACTIONS(69),
    [sym_none] = ACTIONS(69),
    [anon_sym_await] = ACTIONS(71),
    [sym_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(73),
  },
  [338] = {
    [sym_named_expression] = STATE(802),
    [sym__expression] = STATE(802),
    [sym__primary_expression] = STATE(383),
    [sym_not_operator] = STATE(802),
    [sym_boolean_operator] = STATE(802),
    [sym_binary_operator] = STATE(383),
    [sym_unary_operator] = STATE(383),
    [sym_comparison_operator] = STATE(802),
    [sym_lambda] = STATE(802),
    [sym_attribute] = STATE(383),
    [sym_subscript] = STATE(383),
    [sym_call] = STATE(383),
    [sym_list] = STATE(383),
    [sym_list_comprehension] = STATE(383),
    [sym_dictionary] = STATE(383),
    [sym_dictionary_comprehension] = STATE(383),
    [sym_set] = STATE(383),
    [sym_set_comprehension] = STATE(383),
    [sym_parenthesized_expression] = STATE(383),
    [sym_tuple] = STATE(383),
    [sym_generator_expression] = STATE(383),
    [sym_conditional_expression] = STATE(802),
    [sym_concatenated_string] = STATE(383),
    [sym_string] = STATE(381),
    [sym_await] = STATE(802),
    [sym_identifier] = ACTIONS(387),
    [anon_sym_LPAREN] = ACTIONS(389),
    [anon_sym_print] = ACTIONS(393),
    [anon_sym_exec] = ACTIONS(393),
    [anon_sym_not] = ACTIONS(361),
    [anon_sym_PLUS] = ACTIONS(363),
    [anon_sym_DASH] = ACTIONS(363),
    [anon_sym_TILDE] = ACTIONS(363),
    [anon_sym_lambda] = ACTIONS(365),
    [anon_sym_LBRACK] = ACTIONS(367),
    [sym_ellipsis] = ACTIONS(369),
    [anon_sym_LBRACE] = ACTIONS(371),
    [sym_integer] = ACTIONS(373),
    [sym_float] = ACTIONS(369),
    [sym_true] = ACTIONS(373),
    [sym_false] = ACTIONS(373),
    [sym_none] = ACTIONS(373),
    [anon_sym_await] = ACTIONS(375),
    [sym_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(377),
  },
  [339] = {
    [sym_named_expression] = STATE(797),
    [sym__expression] = STATE(797),
    [sym__primary_expression] = STATE(383),
    [sym_not_operator] = STATE(797),
    [sym_boolean_operator] = STATE(797),
    [sym_binary_operator] = STATE(383),
    [sym_unary_operator] = STATE(383),
    [sym_comparison_operator] = STATE(797),
    [sym_lambda] = STATE(797),
    [sym_attribute] = STATE(383),
    [sym_subscript] = STATE(383),
    [sym_call] = STATE(383),
    [sym_list] = STATE(383),
    [sym_list_comprehension] = STATE(383),
    [sym_dictionary] = STATE(383),
    [sym_dictionary_comprehension] = STATE(383),
    [sym_set] = STATE(383),
    [sym_set_comprehension] = STATE(383),
    [sym_parenthesized_expression] = STATE(383),
    [sym_tuple] = STATE(383),
    [sym_generator_expression] = STATE(383),
    [sym_conditional_expression] = STATE(797),
    [sym_concatenated_string] = STATE(383),
    [sym_string] = STATE(381),
    [sym_await] = STATE(797),
    [sym_identifier] = ACTIONS(387),
    [anon_sym_LPAREN] = ACTIONS(389),
    [anon_sym_print] = ACTIONS(393),
    [anon_sym_exec] = ACTIONS(393),
    [anon_sym_not] = ACTIONS(361),
    [anon_sym_PLUS] = ACTIONS(363),
    [anon_sym_DASH] = ACTIONS(363),
    [anon_sym_TILDE] = ACTIONS(363),
    [anon_sym_lambda] = ACTIONS(365),
    [anon_sym_LBRACK] = ACTIONS(367),
    [sym_ellipsis] = ACTIONS(369),
    [anon_sym_LBRACE] = ACTIONS(371),
    [sym_integer] = ACTIONS(373),
    [sym_float] = ACTIONS(369),
    [sym_true] = ACTIONS(373),
    [sym_false] = ACTIONS(373),
    [sym_none] = ACTIONS(373),
    [anon_sym_await] = ACTIONS(375),
    [sym_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(377),
  },
  [340] = {
    [sym_named_expression] = STATE(691),
    [sym__expression] = STATE(691),
    [sym__primary_expression] = STATE(109),
    [sym_not_operator] = STATE(691),
    [sym_boolean_operator] = STATE(691),
    [sym_binary_operator] = STATE(109),
    [sym_unary_operator] = STATE(109),
    [sym_comparison_operator] = STATE(691),
    [sym_lambda] = STATE(691),
    [sym_attribute] = STATE(109),
    [sym_subscript] = STATE(109),
    [sym_call] = STATE(109),
    [sym_list] = STATE(109),
    [sym_list_comprehension] = STATE(109),
    [sym_dictionary] = STATE(109),
    [sym_dictionary_comprehension] = STATE(109),
    [sym_set] = STATE(109),
    [sym_set_comprehension] = STATE(109),
    [sym_parenthesized_expression] = STATE(109),
    [sym_tuple] = STATE(109),
    [sym_generator_expression] = STATE(109),
    [sym_conditional_expression] = STATE(691),
    [sym_concatenated_string] = STATE(109),
    [sym_string] = STATE(117),
    [sym_await] = STATE(691),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(13),
    [anon_sym_print] = ACTIONS(237),
    [anon_sym_exec] = ACTIONS(237),
    [anon_sym_not] = ACTIONS(55),
    [anon_sym_PLUS] = ACTIONS(57),
    [anon_sym_DASH] = ACTIONS(57),
    [anon_sym_TILDE] = ACTIONS(57),
    [anon_sym_lambda] = ACTIONS(59),
    [anon_sym_LBRACK] = ACTIONS(63),
    [sym_ellipsis] = ACTIONS(65),
    [anon_sym_LBRACE] = ACTIONS(67),
    [sym_integer] = ACTIONS(69),
    [sym_float] = ACTIONS(65),
    [sym_true] = ACTIONS(69),
    [sym_false] = ACTIONS(69),
    [sym_none] = ACTIONS(69),
    [anon_sym_await] = ACTIONS(71),
    [sym_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(73),
  },
  [341] = {
    [sym_named_expression] = STATE(608),
    [sym__expression] = STATE(608),
    [sym__primary_expression] = STATE(109),
    [sym_not_operator] = STATE(608),
    [sym_boolean_operator] = STATE(608),
    [sym_binary_operator] = STATE(109),
    [sym_unary_operator] = STATE(109),
    [sym_comparison_operator] = STATE(608),
    [sym_lambda] = STATE(608),
    [sym_attribute] = STATE(109),
    [sym_subscript] = STATE(109),
    [sym_call] = STATE(109),
    [sym_list] = STATE(109),
    [sym_list_comprehension] = STATE(109),
    [sym_dictionary] = STATE(109),
    [sym_dictionary_comprehension] = STATE(109),
    [sym_set] = STATE(109),
    [sym_set_comprehension] = STATE(109),
    [sym_parenthesized_expression] = STATE(109),
    [sym_tuple] = STATE(109),
    [sym_generator_expression] = STATE(109),
    [sym_conditional_expression] = STATE(608),
    [sym_concatenated_string] = STATE(109),
    [sym_string] = STATE(117),
    [sym_await] = STATE(608),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(13),
    [anon_sym_print] = ACTIONS(237),
    [anon_sym_exec] = ACTIONS(237),
    [anon_sym_not] = ACTIONS(55),
    [anon_sym_PLUS] = ACTIONS(57),
    [anon_sym_DASH] = ACTIONS(57),
    [anon_sym_TILDE] = ACTIONS(57),
    [anon_sym_lambda] = ACTIONS(59),
    [anon_sym_LBRACK] = ACTIONS(63),
    [sym_ellipsis] = ACTIONS(65),
    [anon_sym_LBRACE] = ACTIONS(67),
    [sym_integer] = ACTIONS(69),
    [sym_float] = ACTIONS(65),
    [sym_true] = ACTIONS(69),
    [sym_false] = ACTIONS(69),
    [sym_none] = ACTIONS(69),
    [anon_sym_await] = ACTIONS(71),
    [sym_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(73),
  },
  [342] = {
    [sym_named_expression] = STATE(776),
    [sym__expression] = STATE(776),
    [sym__primary_expression] = STATE(383),
    [sym_not_operator] = STATE(776),
    [sym_boolean_operator] = STATE(776),
    [sym_binary_operator] = STATE(383),
    [sym_unary_operator] = STATE(383),
    [sym_comparison_operator] = STATE(776),
    [sym_lambda] = STATE(776),
    [sym_attribute] = STATE(383),
    [sym_subscript] = STATE(383),
    [sym_call] = STATE(383),
    [sym_list] = STATE(383),
    [sym_list_comprehension] = STATE(383),
    [sym_dictionary] = STATE(383),
    [sym_dictionary_comprehension] = STATE(383),
    [sym_set] = STATE(383),
    [sym_set_comprehension] = STATE(383),
    [sym_parenthesized_expression] = STATE(383),
    [sym_tuple] = STATE(383),
    [sym_generator_expression] = STATE(383),
    [sym_conditional_expression] = STATE(776),
    [sym_concatenated_string] = STATE(383),
    [sym_string] = STATE(381),
    [sym_await] = STATE(776),
    [sym_identifier] = ACTIONS(387),
    [anon_sym_LPAREN] = ACTIONS(389),
    [anon_sym_print] = ACTIONS(393),
    [anon_sym_exec] = ACTIONS(393),
    [anon_sym_not] = ACTIONS(361),
    [anon_sym_PLUS] = ACTIONS(363),
    [anon_sym_DASH] = ACTIONS(363),
    [anon_sym_TILDE] = ACTIONS(363),
    [anon_sym_lambda] = ACTIONS(365),
    [anon_sym_LBRACK] = ACTIONS(367),
    [sym_ellipsis] = ACTIONS(369),
    [anon_sym_LBRACE] = ACTIONS(371),
    [sym_integer] = ACTIONS(373),
    [sym_float] = ACTIONS(369),
    [sym_true] = ACTIONS(373),
    [sym_false] = ACTIONS(373),
    [sym_none] = ACTIONS(373),
    [anon_sym_await] = ACTIONS(375),
    [sym_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(377),
  },
  [343] = {
    [sym_named_expression] = STATE(637),
    [sym__expression] = STATE(637),
    [sym__primary_expression] = STATE(383),
    [sym_not_operator] = STATE(637),
    [sym_boolean_operator] = STATE(637),
    [sym_binary_operator] = STATE(383),
    [sym_unary_operator] = STATE(383),
    [sym_comparison_operator] = STATE(637),
    [sym_lambda] = STATE(637),
    [sym_attribute] = STATE(383),
    [sym_subscript] = STATE(383),
    [sym_call] = STATE(383),
    [sym_list] = STATE(383),
    [sym_list_comprehension] = STATE(383),
    [sym_dictionary] = STATE(383),
    [sym_dictionary_comprehension] = STATE(383),
    [sym_set] = STATE(383),
    [sym_set_comprehension] = STATE(383),
    [sym_parenthesized_expression] = STATE(383),
    [sym_tuple] = STATE(383),
    [sym_generator_expression] = STATE(383),
    [sym_conditional_expression] = STATE(637),
    [sym_concatenated_string] = STATE(383),
    [sym_string] = STATE(381),
    [sym_await] = STATE(637),
    [sym_identifier] = ACTIONS(387),
    [anon_sym_LPAREN] = ACTIONS(389),
    [anon_sym_print] = ACTIONS(393),
    [anon_sym_exec] = ACTIONS(393),
    [anon_sym_not] = ACTIONS(361),
    [anon_sym_PLUS] = ACTIONS(363),
    [anon_sym_DASH] = ACTIONS(363),
    [anon_sym_TILDE] = ACTIONS(363),
    [anon_sym_lambda] = ACTIONS(365),
    [anon_sym_LBRACK] = ACTIONS(367),
    [sym_ellipsis] = ACTIONS(369),
    [anon_sym_LBRACE] = ACTIONS(371),
    [sym_integer] = ACTIONS(373),
    [sym_float] = ACTIONS(369),
    [sym_true] = ACTIONS(373),
    [sym_false] = ACTIONS(373),
    [sym_none] = ACTIONS(373),
    [anon_sym_await] = ACTIONS(375),
    [sym_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(377),
  },
  [344] = {
    [sym_named_expression] = STATE(723),
    [sym__expression] = STATE(723),
    [sym__primary_expression] = STATE(503),
    [sym_not_operator] = STATE(723),
    [sym_boolean_operator] = STATE(723),
    [sym_binary_operator] = STATE(503),
    [sym_unary_operator] = STATE(503),
    [sym_comparison_operator] = STATE(723),
    [sym_lambda] = STATE(723),
    [sym_attribute] = STATE(503),
    [sym_subscript] = STATE(503),
    [sym_call] = STATE(503),
    [sym_list] = STATE(503),
    [sym_list_comprehension] = STATE(503),
    [sym_dictionary] = STATE(503),
    [sym_dictionary_comprehension] = STATE(503),
    [sym_set] = STATE(503),
    [sym_set_comprehension] = STATE(503),
    [sym_parenthesized_expression] = STATE(503),
    [sym_tuple] = STATE(503),
    [sym_generator_expression] = STATE(503),
    [sym_conditional_expression] = STATE(723),
    [sym_concatenated_string] = STATE(503),
    [sym_string] = STATE(505),
    [sym_await] = STATE(723),
    [sym_identifier] = ACTIONS(810),
    [anon_sym_LPAREN] = ACTIONS(812),
    [anon_sym_print] = ACTIONS(814),
    [anon_sym_exec] = ACTIONS(814),
    [anon_sym_not] = ACTIONS(818),
    [anon_sym_PLUS] = ACTIONS(820),
    [anon_sym_DASH] = ACTIONS(820),
    [anon_sym_TILDE] = ACTIONS(820),
    [anon_sym_lambda] = ACTIONS(822),
    [anon_sym_LBRACK] = ACTIONS(824),
    [sym_ellipsis] = ACTIONS(826),
    [anon_sym_LBRACE] = ACTIONS(828),
    [sym_integer] = ACTIONS(830),
    [sym_float] = ACTIONS(826),
    [sym_true] = ACTIONS(830),
    [sym_false] = ACTIONS(830),
    [sym_none] = ACTIONS(830),
    [anon_sym_await] = ACTIONS(832),
    [sym_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(834),
  },
  [345] = {
    [sym_named_expression] = STATE(720),
    [sym__expression] = STATE(720),
    [sym__primary_expression] = STATE(503),
    [sym_not_operator] = STATE(720),
    [sym_boolean_operator] = STATE(720),
    [sym_binary_operator] = STATE(503),
    [sym_unary_operator] = STATE(503),
    [sym_comparison_operator] = STATE(720),
    [sym_lambda] = STATE(720),
    [sym_attribute] = STATE(503),
    [sym_subscript] = STATE(503),
    [sym_call] = STATE(503),
    [sym_list] = STATE(503),
    [sym_list_comprehension] = STATE(503),
    [sym_dictionary] = STATE(503),
    [sym_dictionary_comprehension] = STATE(503),
    [sym_set] = STATE(503),
    [sym_set_comprehension] = STATE(503),
    [sym_parenthesized_expression] = STATE(503),
    [sym_tuple] = STATE(503),
    [sym_generator_expression] = STATE(503),
    [sym_conditional_expression] = STATE(720),
    [sym_concatenated_string] = STATE(503),
    [sym_string] = STATE(505),
    [sym_await] = STATE(720),
    [sym_identifier] = ACTIONS(810),
    [anon_sym_LPAREN] = ACTIONS(812),
    [anon_sym_print] = ACTIONS(814),
    [anon_sym_exec] = ACTIONS(814),
    [anon_sym_not] = ACTIONS(818),
    [anon_sym_PLUS] = ACTIONS(820),
    [anon_sym_DASH] = ACTIONS(820),
    [anon_sym_TILDE] = ACTIONS(820),
    [anon_sym_lambda] = ACTIONS(822),
    [anon_sym_LBRACK] = ACTIONS(824),
    [sym_ellipsis] = ACTIONS(826),
    [anon_sym_LBRACE] = ACTIONS(828),
    [sym_integer] = ACTIONS(830),
    [sym_float] = ACTIONS(826),
    [sym_true] = ACTIONS(830),
    [sym_false] = ACTIONS(830),
    [sym_none] = ACTIONS(830),
    [anon_sym_await] = ACTIONS(832),
    [sym_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(834),
  },
  [346] = {
    [sym_named_expression] = STATE(606),
    [sym__expression] = STATE(606),
    [sym__primary_expression] = STATE(109),
    [sym_not_operator] = STATE(606),
    [sym_boolean_operator] = STATE(606),
    [sym_binary_operator] = STATE(109),
    [sym_unary_operator] = STATE(109),
    [sym_comparison_operator] = STATE(606),
    [sym_lambda] = STATE(606),
    [sym_attribute] = STATE(109),
    [sym_subscript] = STATE(109),
    [sym_call] = STATE(109),
    [sym_list] = STATE(109),
    [sym_list_comprehension] = STATE(109),
    [sym_dictionary] = STATE(109),
    [sym_dictionary_comprehension] = STATE(109),
    [sym_set] = STATE(109),
    [sym_set_comprehension] = STATE(109),
    [sym_parenthesized_expression] = STATE(109),
    [sym_tuple] = STATE(109),
    [sym_generator_expression] = STATE(109),
    [sym_conditional_expression] = STATE(606),
    [sym_concatenated_string] = STATE(109),
    [sym_string] = STATE(117),
    [sym_await] = STATE(606),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(13),
    [anon_sym_print] = ACTIONS(237),
    [anon_sym_exec] = ACTIONS(237),
    [anon_sym_not] = ACTIONS(55),
    [anon_sym_PLUS] = ACTIONS(57),
    [anon_sym_DASH] = ACTIONS(57),
    [anon_sym_TILDE] = ACTIONS(57),
    [anon_sym_lambda] = ACTIONS(59),
    [anon_sym_LBRACK] = ACTIONS(63),
    [sym_ellipsis] = ACTIONS(65),
    [anon_sym_LBRACE] = ACTIONS(67),
    [sym_integer] = ACTIONS(69),
    [sym_float] = ACTIONS(65),
    [sym_true] = ACTIONS(69),
    [sym_false] = ACTIONS(69),
    [sym_none] = ACTIONS(69),
    [anon_sym_await] = ACTIONS(71),
    [sym_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(73),
  },
  [347] = {
    [sym_named_expression] = STATE(636),
    [sym__expression] = STATE(636),
    [sym__primary_expression] = STATE(383),
    [sym_not_operator] = STATE(636),
    [sym_boolean_operator] = STATE(636),
    [sym_binary_operator] = STATE(383),
    [sym_unary_operator] = STATE(383),
    [sym_comparison_operator] = STATE(636),
    [sym_lambda] = STATE(636),
    [sym_attribute] = STATE(383),
    [sym_subscript] = STATE(383),
    [sym_call] = STATE(383),
    [sym_list] = STATE(383),
    [sym_list_comprehension] = STATE(383),
    [sym_dictionary] = STATE(383),
    [sym_dictionary_comprehension] = STATE(383),
    [sym_set] = STATE(383),
    [sym_set_comprehension] = STATE(383),
    [sym_parenthesized_expression] = STATE(383),
    [sym_tuple] = STATE(383),
    [sym_generator_expression] = STATE(383),
    [sym_conditional_expression] = STATE(636),
    [sym_concatenated_string] = STATE(383),
    [sym_string] = STATE(381),
    [sym_await] = STATE(636),
    [sym_identifier] = ACTIONS(387),
    [anon_sym_LPAREN] = ACTIONS(389),
    [anon_sym_print] = ACTIONS(393),
    [anon_sym_exec] = ACTIONS(393),
    [anon_sym_not] = ACTIONS(361),
    [anon_sym_PLUS] = ACTIONS(363),
    [anon_sym_DASH] = ACTIONS(363),
    [anon_sym_TILDE] = ACTIONS(363),
    [anon_sym_lambda] = ACTIONS(365),
    [anon_sym_LBRACK] = ACTIONS(367),
    [sym_ellipsis] = ACTIONS(369),
    [anon_sym_LBRACE] = ACTIONS(371),
    [sym_integer] = ACTIONS(373),
    [sym_float] = ACTIONS(369),
    [sym_true] = ACTIONS(373),
    [sym_false] = ACTIONS(373),
    [sym_none] = ACTIONS(373),
    [anon_sym_await] = ACTIONS(375),
    [sym_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(377),
  },
  [348] = {
    [sym_named_expression] = STATE(741),
    [sym__expression] = STATE(741),
    [sym__primary_expression] = STATE(383),
    [sym_not_operator] = STATE(741),
    [sym_boolean_operator] = STATE(741),
    [sym_binary_operator] = STATE(383),
    [sym_unary_operator] = STATE(383),
    [sym_comparison_operator] = STATE(741),
    [sym_lambda] = STATE(741),
    [sym_attribute] = STATE(383),
    [sym_subscript] = STATE(383),
    [sym_call] = STATE(383),
    [sym_list] = STATE(383),
    [sym_list_comprehension] = STATE(383),
    [sym_dictionary] = STATE(383),
    [sym_dictionary_comprehension] = STATE(383),
    [sym_set] = STATE(383),
    [sym_set_comprehension] = STATE(383),
    [sym_parenthesized_expression] = STATE(383),
    [sym_tuple] = STATE(383),
    [sym_generator_expression] = STATE(383),
    [sym_conditional_expression] = STATE(741),
    [sym_concatenated_string] = STATE(383),
    [sym_string] = STATE(381),
    [sym_await] = STATE(741),
    [sym_identifier] = ACTIONS(387),
    [anon_sym_LPAREN] = ACTIONS(389),
    [anon_sym_print] = ACTIONS(393),
    [anon_sym_exec] = ACTIONS(393),
    [anon_sym_not] = ACTIONS(361),
    [anon_sym_PLUS] = ACTIONS(363),
    [anon_sym_DASH] = ACTIONS(363),
    [anon_sym_TILDE] = ACTIONS(363),
    [anon_sym_lambda] = ACTIONS(365),
    [anon_sym_LBRACK] = ACTIONS(367),
    [sym_ellipsis] = ACTIONS(369),
    [anon_sym_LBRACE] = ACTIONS(371),
    [sym_integer] = ACTIONS(373),
    [sym_float] = ACTIONS(369),
    [sym_true] = ACTIONS(373),
    [sym_false] = ACTIONS(373),
    [sym_none] = ACTIONS(373),
    [anon_sym_await] = ACTIONS(375),
    [sym_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(377),
  },
  [349] = {
    [sym_named_expression] = STATE(747),
    [sym__expression] = STATE(747),
    [sym__primary_expression] = STATE(383),
    [sym_not_operator] = STATE(747),
    [sym_boolean_operator] = STATE(747),
    [sym_binary_operator] = STATE(383),
    [sym_unary_operator] = STATE(383),
    [sym_comparison_operator] = STATE(747),
    [sym_lambda] = STATE(747),
    [sym_attribute] = STATE(383),
    [sym_subscript] = STATE(383),
    [sym_call] = STATE(383),
    [sym_list] = STATE(383),
    [sym_list_comprehension] = STATE(383),
    [sym_dictionary] = STATE(383),
    [sym_dictionary_comprehension] = STATE(383),
    [sym_set] = STATE(383),
    [sym_set_comprehension] = STATE(383),
    [sym_parenthesized_expression] = STATE(383),
    [sym_tuple] = STATE(383),
    [sym_generator_expression] = STATE(383),
    [sym_conditional_expression] = STATE(747),
    [sym_concatenated_string] = STATE(383),
    [sym_string] = STATE(381),
    [sym_await] = STATE(747),
    [sym_identifier] = ACTIONS(387),
    [anon_sym_LPAREN] = ACTIONS(389),
    [anon_sym_print] = ACTIONS(393),
    [anon_sym_exec] = ACTIONS(393),
    [anon_sym_not] = ACTIONS(361),
    [anon_sym_PLUS] = ACTIONS(363),
    [anon_sym_DASH] = ACTIONS(363),
    [anon_sym_TILDE] = ACTIONS(363),
    [anon_sym_lambda] = ACTIONS(365),
    [anon_sym_LBRACK] = ACTIONS(367),
    [sym_ellipsis] = ACTIONS(369),
    [anon_sym_LBRACE] = ACTIONS(371),
    [sym_integer] = ACTIONS(373),
    [sym_float] = ACTIONS(369),
    [sym_true] = ACTIONS(373),
    [sym_false] = ACTIONS(373),
    [sym_none] = ACTIONS(373),
    [anon_sym_await] = ACTIONS(375),
    [sym_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(377),
  },
  [350] = {
    [sym_named_expression] = STATE(684),
    [sym__expression] = STATE(684),
    [sym__primary_expression] = STATE(109),
    [sym_not_operator] = STATE(684),
    [sym_boolean_operator] = STATE(684),
    [sym_binary_operator] = STATE(109),
    [sym_unary_operator] = STATE(109),
    [sym_comparison_operator] = STATE(684),
    [sym_lambda] = STATE(684),
    [sym_attribute] = STATE(109),
    [sym_subscript] = STATE(109),
    [sym_call] = STATE(109),
    [sym_list] = STATE(109),
    [sym_list_comprehension] = STATE(109),
    [sym_dictionary] = STATE(109),
    [sym_dictionary_comprehension] = STATE(109),
    [sym_set] = STATE(109),
    [sym_set_comprehension] = STATE(109),
    [sym_parenthesized_expression] = STATE(109),
    [sym_tuple] = STATE(109),
    [sym_generator_expression] = STATE(109),
    [sym_conditional_expression] = STATE(684),
    [sym_concatenated_string] = STATE(109),
    [sym_string] = STATE(117),
    [sym_await] = STATE(684),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(13),
    [anon_sym_print] = ACTIONS(237),
    [anon_sym_exec] = ACTIONS(237),
    [anon_sym_not] = ACTIONS(55),
    [anon_sym_PLUS] = ACTIONS(57),
    [anon_sym_DASH] = ACTIONS(57),
    [anon_sym_TILDE] = ACTIONS(57),
    [anon_sym_lambda] = ACTIONS(59),
    [anon_sym_LBRACK] = ACTIONS(63),
    [sym_ellipsis] = ACTIONS(65),
    [anon_sym_LBRACE] = ACTIONS(67),
    [sym_integer] = ACTIONS(69),
    [sym_float] = ACTIONS(65),
    [sym_true] = ACTIONS(69),
    [sym_false] = ACTIONS(69),
    [sym_none] = ACTIONS(69),
    [anon_sym_await] = ACTIONS(71),
    [sym_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(73),
  },
  [351] = {
    [sym_named_expression] = STATE(746),
    [sym__expression] = STATE(746),
    [sym__primary_expression] = STATE(383),
    [sym_not_operator] = STATE(746),
    [sym_boolean_operator] = STATE(746),
    [sym_binary_operator] = STATE(383),
    [sym_unary_operator] = STATE(383),
    [sym_comparison_operator] = STATE(746),
    [sym_lambda] = STATE(746),
    [sym_attribute] = STATE(383),
    [sym_subscript] = STATE(383),
    [sym_call] = STATE(383),
    [sym_list] = STATE(383),
    [sym_list_comprehension] = STATE(383),
    [sym_dictionary] = STATE(383),
    [sym_dictionary_comprehension] = STATE(383),
    [sym_set] = STATE(383),
    [sym_set_comprehension] = STATE(383),
    [sym_parenthesized_expression] = STATE(383),
    [sym_tuple] = STATE(383),
    [sym_generator_expression] = STATE(383),
    [sym_conditional_expression] = STATE(746),
    [sym_concatenated_string] = STATE(383),
    [sym_string] = STATE(381),
    [sym_await] = STATE(746),
    [sym_identifier] = ACTIONS(387),
    [anon_sym_LPAREN] = ACTIONS(389),
    [anon_sym_print] = ACTIONS(393),
    [anon_sym_exec] = ACTIONS(393),
    [anon_sym_not] = ACTIONS(361),
    [anon_sym_PLUS] = ACTIONS(363),
    [anon_sym_DASH] = ACTIONS(363),
    [anon_sym_TILDE] = ACTIONS(363),
    [anon_sym_lambda] = ACTIONS(365),
    [anon_sym_LBRACK] = ACTIONS(367),
    [sym_ellipsis] = ACTIONS(369),
    [anon_sym_LBRACE] = ACTIONS(371),
    [sym_integer] = ACTIONS(373),
    [sym_float] = ACTIONS(369),
    [sym_true] = ACTIONS(373),
    [sym_false] = ACTIONS(373),
    [sym_none] = ACTIONS(373),
    [anon_sym_await] = ACTIONS(375),
    [sym_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(377),
  },
  [352] = {
    [sym_named_expression] = STATE(780),
    [sym__expression] = STATE(780),
    [sym__primary_expression] = STATE(383),
    [sym_not_operator] = STATE(780),
    [sym_boolean_operator] = STATE(780),
    [sym_binary_operator] = STATE(383),
    [sym_unary_operator] = STATE(383),
    [sym_comparison_operator] = STATE(780),
    [sym_lambda] = STATE(780),
    [sym_attribute] = STATE(383),
    [sym_subscript] = STATE(383),
    [sym_call] = STATE(383),
    [sym_list] = STATE(383),
    [sym_list_comprehension] = STATE(383),
    [sym_dictionary] = STATE(383),
    [sym_dictionary_comprehension] = STATE(383),
    [sym_set] = STATE(383),
    [sym_set_comprehension] = STATE(383),
    [sym_parenthesized_expression] = STATE(383),
    [sym_tuple] = STATE(383),
    [sym_generator_expression] = STATE(383),
    [sym_conditional_expression] = STATE(780),
    [sym_concatenated_string] = STATE(383),
    [sym_string] = STATE(381),
    [sym_await] = STATE(780),
    [sym_identifier] = ACTIONS(387),
    [anon_sym_LPAREN] = ACTIONS(389),
    [anon_sym_print] = ACTIONS(393),
    [anon_sym_exec] = ACTIONS(393),
    [anon_sym_not] = ACTIONS(361),
    [anon_sym_PLUS] = ACTIONS(363),
    [anon_sym_DASH] = ACTIONS(363),
    [anon_sym_TILDE] = ACTIONS(363),
    [anon_sym_lambda] = ACTIONS(365),
    [anon_sym_LBRACK] = ACTIONS(367),
    [sym_ellipsis] = ACTIONS(369),
    [anon_sym_LBRACE] = ACTIONS(371),
    [sym_integer] = ACTIONS(373),
    [sym_float] = ACTIONS(369),
    [sym_true] = ACTIONS(373),
    [sym_false] = ACTIONS(373),
    [sym_none] = ACTIONS(373),
    [anon_sym_await] = ACTIONS(375),
    [sym_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(377),
  },
  [353] = {
    [sym_named_expression] = STATE(716),
    [sym__expression] = STATE(716),
    [sym__primary_expression] = STATE(503),
    [sym_not_operator] = STATE(716),
    [sym_boolean_operator] = STATE(716),
    [sym_binary_operator] = STATE(503),
    [sym_unary_operator] = STATE(503),
    [sym_comparison_operator] = STATE(716),
    [sym_lambda] = STATE(716),
    [sym_attribute] = STATE(503),
    [sym_subscript] = STATE(503),
    [sym_call] = STATE(503),
    [sym_list] = STATE(503),
    [sym_list_comprehension] = STATE(503),
    [sym_dictionary] = STATE(503),
    [sym_dictionary_comprehension] = STATE(503),
    [sym_set] = STATE(503),
    [sym_set_comprehension] = STATE(503),
    [sym_parenthesized_expression] = STATE(503),
    [sym_tuple] = STATE(503),
    [sym_generator_expression] = STATE(503),
    [sym_conditional_expression] = STATE(716),
    [sym_concatenated_string] = STATE(503),
    [sym_string] = STATE(505),
    [sym_await] = STATE(716),
    [sym_identifier] = ACTIONS(810),
    [anon_sym_LPAREN] = ACTIONS(812),
    [anon_sym_print] = ACTIONS(814),
    [anon_sym_exec] = ACTIONS(814),
    [anon_sym_not] = ACTIONS(818),
    [anon_sym_PLUS] = ACTIONS(820),
    [anon_sym_DASH] = ACTIONS(820),
    [anon_sym_TILDE] = ACTIONS(820),
    [anon_sym_lambda] = ACTIONS(822),
    [anon_sym_LBRACK] = ACTIONS(824),
    [sym_ellipsis] = ACTIONS(826),
    [anon_sym_LBRACE] = ACTIONS(828),
    [sym_integer] = ACTIONS(830),
    [sym_float] = ACTIONS(826),
    [sym_true] = ACTIONS(830),
    [sym_false] = ACTIONS(830),
    [sym_none] = ACTIONS(830),
    [anon_sym_await] = ACTIONS(832),
    [sym_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(834),
  },
  [354] = {
    [sym_named_expression] = STATE(709),
    [sym__expression] = STATE(709),
    [sym__primary_expression] = STATE(503),
    [sym_not_operator] = STATE(709),
    [sym_boolean_operator] = STATE(709),
    [sym_binary_operator] = STATE(503),
    [sym_unary_operator] = STATE(503),
    [sym_comparison_operator] = STATE(709),
    [sym_lambda] = STATE(709),
    [sym_attribute] = STATE(503),
    [sym_subscript] = STATE(503),
    [sym_call] = STATE(503),
    [sym_list] = STATE(503),
    [sym_list_comprehension] = STATE(503),
    [sym_dictionary] = STATE(503),
    [sym_dictionary_comprehension] = STATE(503),
    [sym_set] = STATE(503),
    [sym_set_comprehension] = STATE(503),
    [sym_parenthesized_expression] = STATE(503),
    [sym_tuple] = STATE(503),
    [sym_generator_expression] = STATE(503),
    [sym_conditional_expression] = STATE(709),
    [sym_concatenated_string] = STATE(503),
    [sym_string] = STATE(505),
    [sym_await] = STATE(709),
    [sym_identifier] = ACTIONS(810),
    [anon_sym_LPAREN] = ACTIONS(812),
    [anon_sym_print] = ACTIONS(814),
    [anon_sym_exec] = ACTIONS(814),
    [anon_sym_not] = ACTIONS(818),
    [anon_sym_PLUS] = ACTIONS(820),
    [anon_sym_DASH] = ACTIONS(820),
    [anon_sym_TILDE] = ACTIONS(820),
    [anon_sym_lambda] = ACTIONS(822),
    [anon_sym_LBRACK] = ACTIONS(824),
    [sym_ellipsis] = ACTIONS(826),
    [anon_sym_LBRACE] = ACTIONS(828),
    [sym_integer] = ACTIONS(830),
    [sym_float] = ACTIONS(826),
    [sym_true] = ACTIONS(830),
    [sym_false] = ACTIONS(830),
    [sym_none] = ACTIONS(830),
    [anon_sym_await] = ACTIONS(832),
    [sym_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(834),
  },
  [355] = {
    [sym_else_clause] = STATE(445),
    [ts_builtin_sym_end] = ACTIONS(892),
    [sym_identifier] = ACTIONS(894),
    [anon_sym_import] = ACTIONS(894),
    [anon_sym_from] = ACTIONS(894),
    [anon_sym_LPAREN] = ACTIONS(892),
    [anon_sym_print] = ACTIONS(894),
    [anon_sym_assert] = ACTIONS(894),
    [anon_sym_return] = ACTIONS(894),
    [anon_sym_del] = ACTIONS(894),
    [anon_sym_raise] = ACTIONS(894),
    [anon_sym_pass] = ACTIONS(894),
    [anon_sym_break] = ACTIONS(894),
    [anon_sym_continue] = ACTIONS(894),
    [anon_sym_if] = ACTIONS(894),
    [anon_sym_else] = ACTIONS(548),
    [anon_sym_async] = ACTIONS(894),
    [anon_sym_for] = ACTIONS(894),
    [anon_sym_while] = ACTIONS(894),
    [anon_sym_try] = ACTIONS(894),
    [anon_sym_with] = ACTIONS(894),
    [anon_sym_def] = ACTIONS(894),
    [anon_sym_global] = ACTIONS(894),
    [anon_sym_nonlocal] = ACTIONS(894),
    [anon_sym_exec] = ACTIONS(894),
    [anon_sym_class] = ACTIONS(894),
    [anon_sym_AT] = ACTIONS(892),
    [anon_sym_not] = ACTIONS(894),
    [anon_sym_PLUS] = ACTIONS(892),
    [anon_sym_DASH] = ACTIONS(892),
    [anon_sym_TILDE] = ACTIONS(892),
    [anon_sym_lambda] = ACTIONS(894),
    [anon_sym_yield] = ACTIONS(894),
    [anon_sym_LBRACK] = ACTIONS(892),
    [sym_ellipsis] = ACTIONS(892),
    [anon_sym_LBRACE] = ACTIONS(892),
    [sym_integer] = ACTIONS(894),
    [sym_float] = ACTIONS(892),
    [sym_true] = ACTIONS(894),
    [sym_false] = ACTIONS(894),
    [sym_none] = ACTIONS(894),
    [anon_sym_await] = ACTIONS(894),
    [sym_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(892),
  },
  [356] = {
    [sym_else_clause] = STATE(457),
    [sym_identifier] = ACTIONS(896),
    [anon_sym_import] = ACTIONS(896),
    [anon_sym_from] = ACTIONS(896),
    [anon_sym_LPAREN] = ACTIONS(898),
    [anon_sym_print] = ACTIONS(896),
    [anon_sym_assert] = ACTIONS(896),
    [anon_sym_return] = ACTIONS(896),
    [anon_sym_del] = ACTIONS(896),
    [anon_sym_raise] = ACTIONS(896),
    [anon_sym_pass] = ACTIONS(896),
    [anon_sym_break] = ACTIONS(896),
    [anon_sym_continue] = ACTIONS(896),
    [anon_sym_if] = ACTIONS(896),
    [anon_sym_else] = ACTIONS(684),
    [anon_sym_async] = ACTIONS(896),
    [anon_sym_for] = ACTIONS(896),
    [anon_sym_while] = ACTIONS(896),
    [anon_sym_try] = ACTIONS(896),
    [anon_sym_with] = ACTIONS(896),
    [anon_sym_def] = ACTIONS(896),
    [anon_sym_global] = ACTIONS(896),
    [anon_sym_nonlocal] = ACTIONS(896),
    [anon_sym_exec] = ACTIONS(896),
    [anon_sym_class] = ACTIONS(896),
    [anon_sym_AT] = ACTIONS(898),
    [anon_sym_not] = ACTIONS(896),
    [anon_sym_PLUS] = ACTIONS(898),
    [anon_sym_DASH] = ACTIONS(898),
    [anon_sym_TILDE] = ACTIONS(898),
    [anon_sym_lambda] = ACTIONS(896),
    [anon_sym_yield] = ACTIONS(896),
    [anon_sym_LBRACK] = ACTIONS(898),
    [sym_ellipsis] = ACTIONS(898),
    [anon_sym_LBRACE] = ACTIONS(898),
    [sym_integer] = ACTIONS(896),
    [sym_float] = ACTIONS(898),
    [sym_true] = ACTIONS(896),
    [sym_false] = ACTIONS(896),
    [sym_none] = ACTIONS(896),
    [anon_sym_await] = ACTIONS(896),
    [sym_comment] = ACTIONS(3),
    [sym__dedent] = ACTIONS(898),
    [sym__string_start] = ACTIONS(898),
  },
  [357] = {
    [sym_else_clause] = STATE(454),
    [ts_builtin_sym_end] = ACTIONS(900),
    [sym_identifier] = ACTIONS(902),
    [anon_sym_import] = ACTIONS(902),
    [anon_sym_from] = ACTIONS(902),
    [anon_sym_LPAREN] = ACTIONS(900),
    [anon_sym_print] = ACTIONS(902),
    [anon_sym_assert] = ACTIONS(902),
    [anon_sym_return] = ACTIONS(902),
    [anon_sym_del] = ACTIONS(902),
    [anon_sym_raise] = ACTIONS(902),
    [anon_sym_pass] = ACTIONS(902),
    [anon_sym_break] = ACTIONS(902),
    [anon_sym_continue] = ACTIONS(902),
    [anon_sym_if] = ACTIONS(902),
    [anon_sym_else] = ACTIONS(548),
    [anon_sym_async] = ACTIONS(902),
    [anon_sym_for] = ACTIONS(902),
    [anon_sym_while] = ACTIONS(902),
    [anon_sym_try] = ACTIONS(902),
    [anon_sym_with] = ACTIONS(902),
    [anon_sym_def] = ACTIONS(902),
    [anon_sym_global] = ACTIONS(902),
    [anon_sym_nonlocal] = ACTIONS(902),
    [anon_sym_exec] = ACTIONS(902),
    [anon_sym_class] = ACTIONS(902),
    [anon_sym_AT] = ACTIONS(900),
    [anon_sym_not] = ACTIONS(902),
    [anon_sym_PLUS] = ACTIONS(900),
    [anon_sym_DASH] = ACTIONS(900),
    [anon_sym_TILDE] = ACTIONS(900),
    [anon_sym_lambda] = ACTIONS(902),
    [anon_sym_yield] = ACTIONS(902),
    [anon_sym_LBRACK] = ACTIONS(900),
    [sym_ellipsis] = ACTIONS(900),
    [anon_sym_LBRACE] = ACTIONS(900),
    [sym_integer] = ACTIONS(902),
    [sym_float] = ACTIONS(900),
    [sym_true] = ACTIONS(902),
    [sym_false] = ACTIONS(902),
    [sym_none] = ACTIONS(902),
    [anon_sym_await] = ACTIONS(902),
    [sym_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(900),
  },
  [358] = {
    [sym_finally_clause] = STATE(435),
    [sym_identifier] = ACTIONS(904),
    [anon_sym_import] = ACTIONS(904),
    [anon_sym_from] = ACTIONS(904),
    [anon_sym_LPAREN] = ACTIONS(906),
    [anon_sym_print] = ACTIONS(904),
    [anon_sym_assert] = ACTIONS(904),
    [anon_sym_return] = ACTIONS(904),
    [anon_sym_del] = ACTIONS(904),
    [anon_sym_raise] = ACTIONS(904),
    [anon_sym_pass] = ACTIONS(904),
    [anon_sym_break] = ACTIONS(904),
    [anon_sym_continue] = ACTIONS(904),
    [anon_sym_if] = ACTIONS(904),
    [anon_sym_async] = ACTIONS(904),
    [anon_sym_for] = ACTIONS(904),
    [anon_sym_while] = ACTIONS(904),
    [anon_sym_try] = ACTIONS(904),
    [anon_sym_finally] = ACTIONS(688),
    [anon_sym_with] = ACTIONS(904),
    [anon_sym_def] = ACTIONS(904),
    [anon_sym_global] = ACTIONS(904),
    [anon_sym_nonlocal] = ACTIONS(904),
    [anon_sym_exec] = ACTIONS(904),
    [anon_sym_class] = ACTIONS(904),
    [anon_sym_AT] = ACTIONS(906),
    [anon_sym_not] = ACTIONS(904),
    [anon_sym_PLUS] = ACTIONS(906),
    [anon_sym_DASH] = ACTIONS(906),
    [anon_sym_TILDE] = ACTIONS(906),
    [anon_sym_lambda] = ACTIONS(904),
    [anon_sym_yield] = ACTIONS(904),
    [anon_sym_LBRACK] = ACTIONS(906),
    [sym_ellipsis] = ACTIONS(906),
    [anon_sym_LBRACE] = ACTIONS(906),
    [sym_integer] = ACTIONS(904),
    [sym_float] = ACTIONS(906),
    [sym_true] = ACTIONS(904),
    [sym_false] = ACTIONS(904),
    [sym_none] = ACTIONS(904),
    [anon_sym_await] = ACTIONS(904),
    [sym_comment] = ACTIONS(3),
    [sym__dedent] = ACTIONS(906),
    [sym__string_start] = ACTIONS(906),
  },
  [359] = {
    [sym_else_clause] = STATE(447),
    [ts_builtin_sym_end] = ACTIONS(908),
    [sym_identifier] = ACTIONS(910),
    [anon_sym_import] = ACTIONS(910),
    [anon_sym_from] = ACTIONS(910),
    [anon_sym_LPAREN] = ACTIONS(908),
    [anon_sym_print] = ACTIONS(910),
    [anon_sym_assert] = ACTIONS(910),
    [anon_sym_return] = ACTIONS(910),
    [anon_sym_del] = ACTIONS(910),
    [anon_sym_raise] = ACTIONS(910),
    [anon_sym_pass] = ACTIONS(910),
    [anon_sym_break] = ACTIONS(910),
    [anon_sym_continue] = ACTIONS(910),
    [anon_sym_if] = ACTIONS(910),
    [anon_sym_else] = ACTIONS(548),
    [anon_sym_async] = ACTIONS(910),
    [anon_sym_for] = ACTIONS(910),
    [anon_sym_while] = ACTIONS(910),
    [anon_sym_try] = ACTIONS(910),
    [anon_sym_with] = ACTIONS(910),
    [anon_sym_def] = ACTIONS(910),
    [anon_sym_global] = ACTIONS(910),
    [anon_sym_nonlocal] = ACTIONS(910),
    [anon_sym_exec] = ACTIONS(910),
    [anon_sym_class] = ACTIONS(910),
    [anon_sym_AT] = ACTIONS(908),
    [anon_sym_not] = ACTIONS(910),
    [anon_sym_PLUS] = ACTIONS(908),
    [anon_sym_DASH] = ACTIONS(908),
    [anon_sym_TILDE] = ACTIONS(908),
    [anon_sym_lambda] = ACTIONS(910),
    [anon_sym_yield] = ACTIONS(910),
    [anon_sym_LBRACK] = ACTIONS(908),
    [sym_ellipsis] = ACTIONS(908),
    [anon_sym_LBRACE] = ACTIONS(908),
    [sym_integer] = ACTIONS(910),
    [sym_float] = ACTIONS(908),
    [sym_true] = ACTIONS(910),
    [sym_false] = ACTIONS(910),
    [sym_none] = ACTIONS(910),
    [anon_sym_await] = ACTIONS(910),
    [sym_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(908),
  },
  [360] = {
    [ts_builtin_sym_end] = ACTIONS(912),
    [sym_identifier] = ACTIONS(914),
    [anon_sym_import] = ACTIONS(914),
    [anon_sym_from] = ACTIONS(914),
    [anon_sym_LPAREN] = ACTIONS(912),
    [anon_sym_print] = ACTIONS(914),
    [anon_sym_assert] = ACTIONS(914),
    [anon_sym_return] = ACTIONS(914),
    [anon_sym_del] = ACTIONS(914),
    [anon_sym_raise] = ACTIONS(914),
    [anon_sym_pass] = ACTIONS(914),
    [anon_sym_break] = ACTIONS(914),
    [anon_sym_continue] = ACTIONS(914),
    [anon_sym_if] = ACTIONS(914),
    [anon_sym_elif] = ACTIONS(914),
    [anon_sym_else] = ACTIONS(914),
    [anon_sym_async] = ACTIONS(914),
    [anon_sym_for] = ACTIONS(914),
    [anon_sym_while] = ACTIONS(914),
    [anon_sym_try] = ACTIONS(914),
    [anon_sym_with] = ACTIONS(914),
    [anon_sym_def] = ACTIONS(914),
    [anon_sym_global] = ACTIONS(914),
    [anon_sym_nonlocal] = ACTIONS(914),
    [anon_sym_exec] = ACTIONS(914),
    [anon_sym_class] = ACTIONS(914),
    [anon_sym_AT] = ACTIONS(912),
    [anon_sym_not] = ACTIONS(914),
    [anon_sym_PLUS] = ACTIONS(912),
    [anon_sym_DASH] = ACTIONS(912),
    [anon_sym_TILDE] = ACTIONS(912),
    [anon_sym_lambda] = ACTIONS(914),
    [anon_sym_yield] = ACTIONS(914),
    [anon_sym_LBRACK] = ACTIONS(912),
    [sym_ellipsis] = ACTIONS(912),
    [anon_sym_LBRACE] = ACTIONS(912),
    [sym_integer] = ACTIONS(914),
    [sym_float] = ACTIONS(912),
    [sym_true] = ACTIONS(914),
    [sym_false] = ACTIONS(914),
    [sym_none] = ACTIONS(914),
    [anon_sym_await] = ACTIONS(914),
    [sym_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(912),
  },
  [361] = {
    [sym_identifier] = ACTIONS(916),
    [anon_sym_import] = ACTIONS(916),
    [anon_sym_from] = ACTIONS(916),
    [anon_sym_LPAREN] = ACTIONS(918),
    [anon_sym_print] = ACTIONS(916),
    [anon_sym_assert] = ACTIONS(916),
    [anon_sym_return] = ACTIONS(916),
    [anon_sym_del] = ACTIONS(916),
    [anon_sym_raise] = ACTIONS(916),
    [anon_sym_pass] = ACTIONS(916),
    [anon_sym_break] = ACTIONS(916),
    [anon_sym_continue] = ACTIONS(916),
    [anon_sym_if] = ACTIONS(916),
    [anon_sym_elif] = ACTIONS(916),
    [anon_sym_else] = ACTIONS(916),
    [anon_sym_async] = ACTIONS(916),
    [anon_sym_for] = ACTIONS(916),
    [anon_sym_while] = ACTIONS(916),
    [anon_sym_try] = ACTIONS(916),
    [anon_sym_with] = ACTIONS(916),
    [anon_sym_def] = ACTIONS(916),
    [anon_sym_global] = ACTIONS(916),
    [anon_sym_nonlocal] = ACTIONS(916),
    [anon_sym_exec] = ACTIONS(916),
    [anon_sym_class] = ACTIONS(916),
    [anon_sym_AT] = ACTIONS(918),
    [anon_sym_not] = ACTIONS(916),
    [anon_sym_PLUS] = ACTIONS(918),
    [anon_sym_DASH] = ACTIONS(918),
    [anon_sym_TILDE] = ACTIONS(918),
    [anon_sym_lambda] = ACTIONS(916),
    [anon_sym_yield] = ACTIONS(916),
    [anon_sym_LBRACK] = ACTIONS(918),
    [sym_ellipsis] = ACTIONS(918),
    [anon_sym_LBRACE] = ACTIONS(918),
    [sym_integer] = ACTIONS(916),
    [sym_float] = ACTIONS(918),
    [sym_true] = ACTIONS(916),
    [sym_false] = ACTIONS(916),
    [sym_none] = ACTIONS(916),
    [anon_sym_await] = ACTIONS(916),
    [sym_comment] = ACTIONS(3),
    [sym__dedent] = ACTIONS(918),
    [sym__string_start] = ACTIONS(918),
  },
  [362] = {
    [ts_builtin_sym_end] = ACTIONS(920),
    [sym_identifier] = ACTIONS(922),
    [anon_sym_import] = ACTIONS(922),
    [anon_sym_from] = ACTIONS(922),
    [anon_sym_LPAREN] = ACTIONS(920),
    [anon_sym_print] = ACTIONS(922),
    [anon_sym_assert] = ACTIONS(922),
    [anon_sym_return] = ACTIONS(922),
    [anon_sym_del] = ACTIONS(922),
    [anon_sym_raise] = ACTIONS(922),
    [anon_sym_pass] = ACTIONS(922),
    [anon_sym_break] = ACTIONS(922),
    [anon_sym_continue] = ACTIONS(922),
    [anon_sym_if] = ACTIONS(922),
    [anon_sym_elif] = ACTIONS(922),
    [anon_sym_else] = ACTIONS(922),
    [anon_sym_async] = ACTIONS(922),
    [anon_sym_for] = ACTIONS(922),
    [anon_sym_while] = ACTIONS(922),
    [anon_sym_try] = ACTIONS(922),
    [anon_sym_with] = ACTIONS(922),
    [anon_sym_def] = ACTIONS(922),
    [anon_sym_global] = ACTIONS(922),
    [anon_sym_nonlocal] = ACTIONS(922),
    [anon_sym_exec] = ACTIONS(922),
    [anon_sym_class] = ACTIONS(922),
    [anon_sym_AT] = ACTIONS(920),
    [anon_sym_not] = ACTIONS(922),
    [anon_sym_PLUS] = ACTIONS(920),
    [anon_sym_DASH] = ACTIONS(920),
    [anon_sym_TILDE] = ACTIONS(920),
    [anon_sym_lambda] = ACTIONS(922),
    [anon_sym_yield] = ACTIONS(922),
    [anon_sym_LBRACK] = ACTIONS(920),
    [sym_ellipsis] = ACTIONS(920),
    [anon_sym_LBRACE] = ACTIONS(920),
    [sym_integer] = ACTIONS(922),
    [sym_float] = ACTIONS(920),
    [sym_true] = ACTIONS(922),
    [sym_false] = ACTIONS(922),
    [sym_none] = ACTIONS(922),
    [anon_sym_await] = ACTIONS(922),
    [sym_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(920),
  },
  [363] = {
    [sym_else_clause] = STATE(442),
    [ts_builtin_sym_end] = ACTIONS(898),
    [sym_identifier] = ACTIONS(896),
    [anon_sym_import] = ACTIONS(896),
    [anon_sym_from] = ACTIONS(896),
    [anon_sym_LPAREN] = ACTIONS(898),
    [anon_sym_print] = ACTIONS(896),
    [anon_sym_assert] = ACTIONS(896),
    [anon_sym_return] = ACTIONS(896),
    [anon_sym_del] = ACTIONS(896),
    [anon_sym_raise] = ACTIONS(896),
    [anon_sym_pass] = ACTIONS(896),
    [anon_sym_break] = ACTIONS(896),
    [anon_sym_continue] = ACTIONS(896),
    [anon_sym_if] = ACTIONS(896),
    [anon_sym_else] = ACTIONS(548),
    [anon_sym_async] = ACTIONS(896),
    [anon_sym_for] = ACTIONS(896),
    [anon_sym_while] = ACTIONS(896),
    [anon_sym_try] = ACTIONS(896),
    [anon_sym_with] = ACTIONS(896),
    [anon_sym_def] = ACTIONS(896),
    [anon_sym_global] = ACTIONS(896),
    [anon_sym_nonlocal] = ACTIONS(896),
    [anon_sym_exec] = ACTIONS(896),
    [anon_sym_class] = ACTIONS(896),
    [anon_sym_AT] = ACTIONS(898),
    [anon_sym_not] = ACTIONS(896),
    [anon_sym_PLUS] = ACTIONS(898),
    [anon_sym_DASH] = ACTIONS(898),
    [anon_sym_TILDE] = ACTIONS(898),
    [anon_sym_lambda] = ACTIONS(896),
    [anon_sym_yield] = ACTIONS(896),
    [anon_sym_LBRACK] = ACTIONS(898),
    [sym_ellipsis] = ACTIONS(898),
    [anon_sym_LBRACE] = ACTIONS(898),
    [sym_integer] = ACTIONS(896),
    [sym_float] = ACTIONS(898),
    [sym_true] = ACTIONS(896),
    [sym_false] = ACTIONS(896),
    [sym_none] = ACTIONS(896),
    [anon_sym_await] = ACTIONS(896),
    [sym_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(898),
  },
  [364] = {
    [ts_builtin_sym_end] = ACTIONS(918),
    [sym_identifier] = ACTIONS(916),
    [anon_sym_import] = ACTIONS(916),
    [anon_sym_from] = ACTIONS(916),
    [anon_sym_LPAREN] = ACTIONS(918),
    [anon_sym_print] = ACTIONS(916),
    [anon_sym_assert] = ACTIONS(916),
    [anon_sym_return] = ACTIONS(916),
    [anon_sym_del] = ACTIONS(916),
    [anon_sym_raise] = ACTIONS(916),
    [anon_sym_pass] = ACTIONS(916),
    [anon_sym_break] = ACTIONS(916),
    [anon_sym_continue] = ACTIONS(916),
    [anon_sym_if] = ACTIONS(916),
    [anon_sym_elif] = ACTIONS(916),
    [anon_sym_else] = ACTIONS(916),
    [anon_sym_async] = ACTIONS(916),
    [anon_sym_for] = ACTIONS(916),
    [anon_sym_while] = ACTIONS(916),
    [anon_sym_try] = ACTIONS(916),
    [anon_sym_with] = ACTIONS(916),
    [anon_sym_def] = ACTIONS(916),
    [anon_sym_global] = ACTIONS(916),
    [anon_sym_nonlocal] = ACTIONS(916),
    [anon_sym_exec] = ACTIONS(916),
    [anon_sym_class] = ACTIONS(916),
    [anon_sym_AT] = ACTIONS(918),
    [anon_sym_not] = ACTIONS(916),
    [anon_sym_PLUS] = ACTIONS(918),
    [anon_sym_DASH] = ACTIONS(918),
    [anon_sym_TILDE] = ACTIONS(918),
    [anon_sym_lambda] = ACTIONS(916),
    [anon_sym_yield] = ACTIONS(916),
    [anon_sym_LBRACK] = ACTIONS(918),
    [sym_ellipsis] = ACTIONS(918),
    [anon_sym_LBRACE] = ACTIONS(918),
    [sym_integer] = ACTIONS(916),
    [sym_float] = ACTIONS(918),
    [sym_true] = ACTIONS(916),
    [sym_false] = ACTIONS(916),
    [sym_none] = ACTIONS(916),
    [anon_sym_await] = ACTIONS(916),
    [sym_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(918),
  },
  [365] = {
    [sym_identifier] = ACTIONS(922),
    [anon_sym_import] = ACTIONS(922),
    [anon_sym_from] = ACTIONS(922),
    [anon_sym_LPAREN] = ACTIONS(920),
    [anon_sym_print] = ACTIONS(922),
    [anon_sym_assert] = ACTIONS(922),
    [anon_sym_return] = ACTIONS(922),
    [anon_sym_del] = ACTIONS(922),
    [anon_sym_raise] = ACTIONS(922),
    [anon_sym_pass] = ACTIONS(922),
    [anon_sym_break] = ACTIONS(922),
    [anon_sym_continue] = ACTIONS(922),
    [anon_sym_if] = ACTIONS(922),
    [anon_sym_elif] = ACTIONS(922),
    [anon_sym_else] = ACTIONS(922),
    [anon_sym_async] = ACTIONS(922),
    [anon_sym_for] = ACTIONS(922),
    [anon_sym_while] = ACTIONS(922),
    [anon_sym_try] = ACTIONS(922),
    [anon_sym_with] = ACTIONS(922),
    [anon_sym_def] = ACTIONS(922),
    [anon_sym_global] = ACTIONS(922),
    [anon_sym_nonlocal] = ACTIONS(922),
    [anon_sym_exec] = ACTIONS(922),
    [anon_sym_class] = ACTIONS(922),
    [anon_sym_AT] = ACTIONS(920),
    [anon_sym_not] = ACTIONS(922),
    [anon_sym_PLUS] = ACTIONS(920),
    [anon_sym_DASH] = ACTIONS(920),
    [anon_sym_TILDE] = ACTIONS(920),
    [anon_sym_lambda] = ACTIONS(922),
    [anon_sym_yield] = ACTIONS(922),
    [anon_sym_LBRACK] = ACTIONS(920),
    [sym_ellipsis] = ACTIONS(920),
    [anon_sym_LBRACE] = ACTIONS(920),
    [sym_integer] = ACTIONS(922),
    [sym_float] = ACTIONS(920),
    [sym_true] = ACTIONS(922),
    [sym_false] = ACTIONS(922),
    [sym_none] = ACTIONS(922),
    [anon_sym_await] = ACTIONS(922),
    [sym_comment] = ACTIONS(3),
    [sym__dedent] = ACTIONS(920),
    [sym__string_start] = ACTIONS(920),
  },
  [366] = {
    [sym_else_clause] = STATE(419),
    [sym_identifier] = ACTIONS(902),
    [anon_sym_import] = ACTIONS(902),
    [anon_sym_from] = ACTIONS(902),
    [anon_sym_LPAREN] = ACTIONS(900),
    [anon_sym_print] = ACTIONS(902),
    [anon_sym_assert] = ACTIONS(902),
    [anon_sym_return] = ACTIONS(902),
    [anon_sym_del] = ACTIONS(902),
    [anon_sym_raise] = ACTIONS(902),
    [anon_sym_pass] = ACTIONS(902),
    [anon_sym_break] = ACTIONS(902),
    [anon_sym_continue] = ACTIONS(902),
    [anon_sym_if] = ACTIONS(902),
    [anon_sym_else] = ACTIONS(684),
    [anon_sym_async] = ACTIONS(902),
    [anon_sym_for] = ACTIONS(902),
    [anon_sym_while] = ACTIONS(902),
    [anon_sym_try] = ACTIONS(902),
    [anon_sym_with] = ACTIONS(902),
    [anon_sym_def] = ACTIONS(902),
    [anon_sym_global] = ACTIONS(902),
    [anon_sym_nonlocal] = ACTIONS(902),
    [anon_sym_exec] = ACTIONS(902),
    [anon_sym_class] = ACTIONS(902),
    [anon_sym_AT] = ACTIONS(900),
    [anon_sym_not] = ACTIONS(902),
    [anon_sym_PLUS] = ACTIONS(900),
    [anon_sym_DASH] = ACTIONS(900),
    [anon_sym_TILDE] = ACTIONS(900),
    [anon_sym_lambda] = ACTIONS(902),
    [anon_sym_yield] = ACTIONS(902),
    [anon_sym_LBRACK] = ACTIONS(900),
    [sym_ellipsis] = ACTIONS(900),
    [anon_sym_LBRACE] = ACTIONS(900),
    [sym_integer] = ACTIONS(902),
    [sym_float] = ACTIONS(900),
    [sym_true] = ACTIONS(902),
    [sym_false] = ACTIONS(902),
    [sym_none] = ACTIONS(902),
    [anon_sym_await] = ACTIONS(902),
    [sym_comment] = ACTIONS(3),
    [sym__dedent] = ACTIONS(900),
    [sym__string_start] = ACTIONS(900),
  },
  [367] = {
    [sym_else_clause] = STATE(391),
    [sym_identifier] = ACTIONS(924),
    [anon_sym_import] = ACTIONS(924),
    [anon_sym_from] = ACTIONS(924),
    [anon_sym_LPAREN] = ACTIONS(926),
    [anon_sym_print] = ACTIONS(924),
    [anon_sym_assert] = ACTIONS(924),
    [anon_sym_return] = ACTIONS(924),
    [anon_sym_del] = ACTIONS(924),
    [anon_sym_raise] = ACTIONS(924),
    [anon_sym_pass] = ACTIONS(924),
    [anon_sym_break] = ACTIONS(924),
    [anon_sym_continue] = ACTIONS(924),
    [anon_sym_if] = ACTIONS(924),
    [anon_sym_else] = ACTIONS(684),
    [anon_sym_async] = ACTIONS(924),
    [anon_sym_for] = ACTIONS(924),
    [anon_sym_while] = ACTIONS(924),
    [anon_sym_try] = ACTIONS(924),
    [anon_sym_with] = ACTIONS(924),
    [anon_sym_def] = ACTIONS(924),
    [anon_sym_global] = ACTIONS(924),
    [anon_sym_nonlocal] = ACTIONS(924),
    [anon_sym_exec] = ACTIONS(924),
    [anon_sym_class] = ACTIONS(924),
    [anon_sym_AT] = ACTIONS(926),
    [anon_sym_not] = ACTIONS(924),
    [anon_sym_PLUS] = ACTIONS(926),
    [anon_sym_DASH] = ACTIONS(926),
    [anon_sym_TILDE] = ACTIONS(926),
    [anon_sym_lambda] = ACTIONS(924),
    [anon_sym_yield] = ACTIONS(924),
    [anon_sym_LBRACK] = ACTIONS(926),
    [sym_ellipsis] = ACTIONS(926),
    [anon_sym_LBRACE] = ACTIONS(926),
    [sym_integer] = ACTIONS(924),
    [sym_float] = ACTIONS(926),
    [sym_true] = ACTIONS(924),
    [sym_false] = ACTIONS(924),
    [sym_none] = ACTIONS(924),
    [anon_sym_await] = ACTIONS(924),
    [sym_comment] = ACTIONS(3),
    [sym__dedent] = ACTIONS(926),
    [sym__string_start] = ACTIONS(926),
  },
  [368] = {
    [sym_identifier] = ACTIONS(914),
    [anon_sym_import] = ACTIONS(914),
    [anon_sym_from] = ACTIONS(914),
    [anon_sym_LPAREN] = ACTIONS(912),
    [anon_sym_print] = ACTIONS(914),
    [anon_sym_assert] = ACTIONS(914),
    [anon_sym_return] = ACTIONS(914),
    [anon_sym_del] = ACTIONS(914),
    [anon_sym_raise] = ACTIONS(914),
    [anon_sym_pass] = ACTIONS(914),
    [anon_sym_break] = ACTIONS(914),
    [anon_sym_continue] = ACTIONS(914),
    [anon_sym_if] = ACTIONS(914),
    [anon_sym_elif] = ACTIONS(914),
    [anon_sym_else] = ACTIONS(914),
    [anon_sym_async] = ACTIONS(914),
    [anon_sym_for] = ACTIONS(914),
    [anon_sym_while] = ACTIONS(914),
    [anon_sym_try] = ACTIONS(914),
    [anon_sym_with] = ACTIONS(914),
    [anon_sym_def] = ACTIONS(914),
    [anon_sym_global] = ACTIONS(914),
    [anon_sym_nonlocal] = ACTIONS(914),
    [anon_sym_exec] = ACTIONS(914),
    [anon_sym_class] = ACTIONS(914),
    [anon_sym_AT] = ACTIONS(912),
    [anon_sym_not] = ACTIONS(914),
    [anon_sym_PLUS] = ACTIONS(912),
    [anon_sym_DASH] = ACTIONS(912),
    [anon_sym_TILDE] = ACTIONS(912),
    [anon_sym_lambda] = ACTIONS(914),
    [anon_sym_yield] = ACTIONS(914),
    [anon_sym_LBRACK] = ACTIONS(912),
    [sym_ellipsis] = ACTIONS(912),
    [anon_sym_LBRACE] = ACTIONS(912),
    [sym_integer] = ACTIONS(914),
    [sym_float] = ACTIONS(912),
    [sym_true] = ACTIONS(914),
    [sym_false] = ACTIONS(914),
    [sym_none] = ACTIONS(914),
    [anon_sym_await] = ACTIONS(914),
    [sym_comment] = ACTIONS(3),
    [sym__dedent] = ACTIONS(912),
    [sym__string_start] = ACTIONS(912),
  },
  [369] = {
    [sym_finally_clause] = STATE(388),
    [sym_identifier] = ACTIONS(928),
    [anon_sym_import] = ACTIONS(928),
    [anon_sym_from] = ACTIONS(928),
    [anon_sym_LPAREN] = ACTIONS(930),
    [anon_sym_print] = ACTIONS(928),
    [anon_sym_assert] = ACTIONS(928),
    [anon_sym_return] = ACTIONS(928),
    [anon_sym_del] = ACTIONS(928),
    [anon_sym_raise] = ACTIONS(928),
    [anon_sym_pass] = ACTIONS(928),
    [anon_sym_break] = ACTIONS(928),
    [anon_sym_continue] = ACTIONS(928),
    [anon_sym_if] = ACTIONS(928),
    [anon_sym_async] = ACTIONS(928),
    [anon_sym_for] = ACTIONS(928),
    [anon_sym_while] = ACTIONS(928),
    [anon_sym_try] = ACTIONS(928),
    [anon_sym_finally] = ACTIONS(688),
    [anon_sym_with] = ACTIONS(928),
    [anon_sym_def] = ACTIONS(928),
    [anon_sym_global] = ACTIONS(928),
    [anon_sym_nonlocal] = ACTIONS(928),
    [anon_sym_exec] = ACTIONS(928),
    [anon_sym_class] = ACTIONS(928),
    [anon_sym_AT] = ACTIONS(930),
    [anon_sym_not] = ACTIONS(928),
    [anon_sym_PLUS] = ACTIONS(930),
    [anon_sym_DASH] = ACTIONS(930),
    [anon_sym_TILDE] = ACTIONS(930),
    [anon_sym_lambda] = ACTIONS(928),
    [anon_sym_yield] = ACTIONS(928),
    [anon_sym_LBRACK] = ACTIONS(930),
    [sym_ellipsis] = ACTIONS(930),
    [anon_sym_LBRACE] = ACTIONS(930),
    [sym_integer] = ACTIONS(928),
    [sym_float] = ACTIONS(930),
    [sym_true] = ACTIONS(928),
    [sym_false] = ACTIONS(928),
    [sym_none] = ACTIONS(928),
    [anon_sym_await] = ACTIONS(928),
    [sym_comment] = ACTIONS(3),
    [sym__dedent] = ACTIONS(930),
    [sym__string_start] = ACTIONS(930),
  },
  [370] = {
    [sym_else_clause] = STATE(440),
    [ts_builtin_sym_end] = ACTIONS(926),
    [sym_identifier] = ACTIONS(924),
    [anon_sym_import] = ACTIONS(924),
    [anon_sym_from] = ACTIONS(924),
    [anon_sym_LPAREN] = ACTIONS(926),
    [anon_sym_print] = ACTIONS(924),
    [anon_sym_assert] = ACTIONS(924),
    [anon_sym_return] = ACTIONS(924),
    [anon_sym_del] = ACTIONS(924),
    [anon_sym_raise] = ACTIONS(924),
    [anon_sym_pass] = ACTIONS(924),
    [anon_sym_break] = ACTIONS(924),
    [anon_sym_continue] = ACTIONS(924),
    [anon_sym_if] = ACTIONS(924),
    [anon_sym_else] = ACTIONS(548),
    [anon_sym_async] = ACTIONS(924),
    [anon_sym_for] = ACTIONS(924),
    [anon_sym_while] = ACTIONS(924),
    [anon_sym_try] = ACTIONS(924),
    [anon_sym_with] = ACTIONS(924),
    [anon_sym_def] = ACTIONS(924),
    [anon_sym_global] = ACTIONS(924),
    [anon_sym_nonlocal] = ACTIONS(924),
    [anon_sym_exec] = ACTIONS(924),
    [anon_sym_class] = ACTIONS(924),
    [anon_sym_AT] = ACTIONS(926),
    [anon_sym_not] = ACTIONS(924),
    [anon_sym_PLUS] = ACTIONS(926),
    [anon_sym_DASH] = ACTIONS(926),
    [anon_sym_TILDE] = ACTIONS(926),
    [anon_sym_lambda] = ACTIONS(924),
    [anon_sym_yield] = ACTIONS(924),
    [anon_sym_LBRACK] = ACTIONS(926),
    [sym_ellipsis] = ACTIONS(926),
    [anon_sym_LBRACE] = ACTIONS(926),
    [sym_integer] = ACTIONS(924),
    [sym_float] = ACTIONS(926),
    [sym_true] = ACTIONS(924),
    [sym_false] = ACTIONS(924),
    [sym_none] = ACTIONS(924),
    [anon_sym_await] = ACTIONS(924),
    [sym_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(926),
  },
  [371] = {
    [sym_finally_clause] = STATE(462),
    [ts_builtin_sym_end] = ACTIONS(930),
    [sym_identifier] = ACTIONS(928),
    [anon_sym_import] = ACTIONS(928),
    [anon_sym_from] = ACTIONS(928),
    [anon_sym_LPAREN] = ACTIONS(930),
    [anon_sym_print] = ACTIONS(928),
    [anon_sym_assert] = ACTIONS(928),
    [anon_sym_return] = ACTIONS(928),
    [anon_sym_del] = ACTIONS(928),
    [anon_sym_raise] = ACTIONS(928),
    [anon_sym_pass] = ACTIONS(928),
    [anon_sym_break] = ACTIONS(928),
    [anon_sym_continue] = ACTIONS(928),
    [anon_sym_if] = ACTIONS(928),
    [anon_sym_async] = ACTIONS(928),
    [anon_sym_for] = ACTIONS(928),
    [anon_sym_while] = ACTIONS(928),
    [anon_sym_try] = ACTIONS(928),
    [anon_sym_finally] = ACTIONS(552),
    [anon_sym_with] = ACTIONS(928),
    [anon_sym_def] = ACTIONS(928),
    [anon_sym_global] = ACTIONS(928),
    [anon_sym_nonlocal] = ACTIONS(928),
    [anon_sym_exec] = ACTIONS(928),
    [anon_sym_class] = ACTIONS(928),
    [anon_sym_AT] = ACTIONS(930),
    [anon_sym_not] = ACTIONS(928),
    [anon_sym_PLUS] = ACTIONS(930),
    [anon_sym_DASH] = ACTIONS(930),
    [anon_sym_TILDE] = ACTIONS(930),
    [anon_sym_lambda] = ACTIONS(928),
    [anon_sym_yield] = ACTIONS(928),
    [anon_sym_LBRACK] = ACTIONS(930),
    [sym_ellipsis] = ACTIONS(930),
    [anon_sym_LBRACE] = ACTIONS(930),
    [sym_integer] = ACTIONS(928),
    [sym_float] = ACTIONS(930),
    [sym_true] = ACTIONS(928),
    [sym_false] = ACTIONS(928),
    [sym_none] = ACTIONS(928),
    [anon_sym_await] = ACTIONS(928),
    [sym_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(930),
  },
  [372] = {
    [sym_else_clause] = STATE(412),
    [ts_builtin_sym_end] = ACTIONS(932),
    [sym_identifier] = ACTIONS(934),
    [anon_sym_import] = ACTIONS(934),
    [anon_sym_from] = ACTIONS(934),
    [anon_sym_LPAREN] = ACTIONS(932),
    [anon_sym_print] = ACTIONS(934),
    [anon_sym_assert] = ACTIONS(934),
    [anon_sym_return] = ACTIONS(934),
    [anon_sym_del] = ACTIONS(934),
    [anon_sym_raise] = ACTIONS(934),
    [anon_sym_pass] = ACTIONS(934),
    [anon_sym_break] = ACTIONS(934),
    [anon_sym_continue] = ACTIONS(934),
    [anon_sym_if] = ACTIONS(934),
    [anon_sym_else] = ACTIONS(548),
    [anon_sym_async] = ACTIONS(934),
    [anon_sym_for] = ACTIONS(934),
    [anon_sym_while] = ACTIONS(934),
    [anon_sym_try] = ACTIONS(934),
    [anon_sym_with] = ACTIONS(934),
    [anon_sym_def] = ACTIONS(934),
    [anon_sym_global] = ACTIONS(934),
    [anon_sym_nonlocal] = ACTIONS(934),
    [anon_sym_exec] = ACTIONS(934),
    [anon_sym_class] = ACTIONS(934),
    [anon_sym_AT] = ACTIONS(932),
    [anon_sym_not] = ACTIONS(934),
    [anon_sym_PLUS] = ACTIONS(932),
    [anon_sym_DASH] = ACTIONS(932),
    [anon_sym_TILDE] = ACTIONS(932),
    [anon_sym_lambda] = ACTIONS(934),
    [anon_sym_yield] = ACTIONS(934),
    [anon_sym_LBRACK] = ACTIONS(932),
    [sym_ellipsis] = ACTIONS(932),
    [anon_sym_LBRACE] = ACTIONS(932),
    [sym_integer] = ACTIONS(934),
    [sym_float] = ACTIONS(932),
    [sym_true] = ACTIONS(934),
    [sym_false] = ACTIONS(934),
    [sym_none] = ACTIONS(934),
    [anon_sym_await] = ACTIONS(934),
    [sym_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(932),
  },
  [373] = {
    [sym_else_clause] = STATE(449),
    [sym_identifier] = ACTIONS(894),
    [anon_sym_import] = ACTIONS(894),
    [anon_sym_from] = ACTIONS(894),
    [anon_sym_LPAREN] = ACTIONS(892),
    [anon_sym_print] = ACTIONS(894),
    [anon_sym_assert] = ACTIONS(894),
    [anon_sym_return] = ACTIONS(894),
    [anon_sym_del] = ACTIONS(894),
    [anon_sym_raise] = ACTIONS(894),
    [anon_sym_pass] = ACTIONS(894),
    [anon_sym_break] = ACTIONS(894),
    [anon_sym_continue] = ACTIONS(894),
    [anon_sym_if] = ACTIONS(894),
    [anon_sym_else] = ACTIONS(684),
    [anon_sym_async] = ACTIONS(894),
    [anon_sym_for] = ACTIONS(894),
    [anon_sym_while] = ACTIONS(894),
    [anon_sym_try] = ACTIONS(894),
    [anon_sym_with] = ACTIONS(894),
    [anon_sym_def] = ACTIONS(894),
    [anon_sym_global] = ACTIONS(894),
    [anon_sym_nonlocal] = ACTIONS(894),
    [anon_sym_exec] = ACTIONS(894),
    [anon_sym_class] = ACTIONS(894),
    [anon_sym_AT] = ACTIONS(892),
    [anon_sym_not] = ACTIONS(894),
    [anon_sym_PLUS] = ACTIONS(892),
    [anon_sym_DASH] = ACTIONS(892),
    [anon_sym_TILDE] = ACTIONS(892),
    [anon_sym_lambda] = ACTIONS(894),
    [anon_sym_yield] = ACTIONS(894),
    [anon_sym_LBRACK] = ACTIONS(892),
    [sym_ellipsis] = ACTIONS(892),
    [anon_sym_LBRACE] = ACTIONS(892),
    [sym_integer] = ACTIONS(894),
    [sym_float] = ACTIONS(892),
    [sym_true] = ACTIONS(894),
    [sym_false] = ACTIONS(894),
    [sym_none] = ACTIONS(894),
    [anon_sym_await] = ACTIONS(894),
    [sym_comment] = ACTIONS(3),
    [sym__dedent] = ACTIONS(892),
    [sym__string_start] = ACTIONS(892),
  },
  [374] = {
    [sym_else_clause] = STATE(403),
    [sym_identifier] = ACTIONS(934),
    [anon_sym_import] = ACTIONS(934),
    [anon_sym_from] = ACTIONS(934),
    [anon_sym_LPAREN] = ACTIONS(932),
    [anon_sym_print] = ACTIONS(934),
    [anon_sym_assert] = ACTIONS(934),
    [anon_sym_return] = ACTIONS(934),
    [anon_sym_del] = ACTIONS(934),
    [anon_sym_raise] = ACTIONS(934),
    [anon_sym_pass] = ACTIONS(934),
    [anon_sym_break] = ACTIONS(934),
    [anon_sym_continue] = ACTIONS(934),
    [anon_sym_if] = ACTIONS(934),
    [anon_sym_else] = ACTIONS(684),
    [anon_sym_async] = ACTIONS(934),
    [anon_sym_for] = ACTIONS(934),
    [anon_sym_while] = ACTIONS(934),
    [anon_sym_try] = ACTIONS(934),
    [anon_sym_with] = ACTIONS(934),
    [anon_sym_def] = ACTIONS(934),
    [anon_sym_global] = ACTIONS(934),
    [anon_sym_nonlocal] = ACTIONS(934),
    [anon_sym_exec] = ACTIONS(934),
    [anon_sym_class] = ACTIONS(934),
    [anon_sym_AT] = ACTIONS(932),
    [anon_sym_not] = ACTIONS(934),
    [anon_sym_PLUS] = ACTIONS(932),
    [anon_sym_DASH] = ACTIONS(932),
    [anon_sym_TILDE] = ACTIONS(932),
    [anon_sym_lambda] = ACTIONS(934),
    [anon_sym_yield] = ACTIONS(934),
    [anon_sym_LBRACK] = ACTIONS(932),
    [sym_ellipsis] = ACTIONS(932),
    [anon_sym_LBRACE] = ACTIONS(932),
    [sym_integer] = ACTIONS(934),
    [sym_float] = ACTIONS(932),
    [sym_true] = ACTIONS(934),
    [sym_false] = ACTIONS(934),
    [sym_none] = ACTIONS(934),
    [anon_sym_await] = ACTIONS(934),
    [sym_comment] = ACTIONS(3),
    [sym__dedent] = ACTIONS(932),
    [sym__string_start] = ACTIONS(932),
  },
  [375] = {
    [sym_else_clause] = STATE(443),
    [sym_identifier] = ACTIONS(910),
    [anon_sym_import] = ACTIONS(910),
    [anon_sym_from] = ACTIONS(910),
    [anon_sym_LPAREN] = ACTIONS(908),
    [anon_sym_print] = ACTIONS(910),
    [anon_sym_assert] = ACTIONS(910),
    [anon_sym_return] = ACTIONS(910),
    [anon_sym_del] = ACTIONS(910),
    [anon_sym_raise] = ACTIONS(910),
    [anon_sym_pass] = ACTIONS(910),
    [anon_sym_break] = ACTIONS(910),
    [anon_sym_continue] = ACTIONS(910),
    [anon_sym_if] = ACTIONS(910),
    [anon_sym_else] = ACTIONS(684),
    [anon_sym_async] = ACTIONS(910),
    [anon_sym_for] = ACTIONS(910),
    [anon_sym_while] = ACTIONS(910),
    [anon_sym_try] = ACTIONS(910),
    [anon_sym_with] = ACTIONS(910),
    [anon_sym_def] = ACTIONS(910),
    [anon_sym_global] = ACTIONS(910),
    [anon_sym_nonlocal] = ACTIONS(910),
    [anon_sym_exec] = ACTIONS(910),
    [anon_sym_class] = ACTIONS(910),
    [anon_sym_AT] = ACTIONS(908),
    [anon_sym_not] = ACTIONS(910),
    [anon_sym_PLUS] = ACTIONS(908),
    [anon_sym_DASH] = ACTIONS(908),
    [anon_sym_TILDE] = ACTIONS(908),
    [anon_sym_lambda] = ACTIONS(910),
    [anon_sym_yield] = ACTIONS(910),
    [anon_sym_LBRACK] = ACTIONS(908),
    [sym_ellipsis] = ACTIONS(908),
    [anon_sym_LBRACE] = ACTIONS(908),
    [sym_integer] = ACTIONS(910),
    [sym_float] = ACTIONS(908),
    [sym_true] = ACTIONS(910),
    [sym_false] = ACTIONS(910),
    [sym_none] = ACTIONS(910),
    [anon_sym_await] = ACTIONS(910),
    [sym_comment] = ACTIONS(3),
    [sym__dedent] = ACTIONS(908),
    [sym__string_start] = ACTIONS(908),
  },
  [376] = {
    [sym_finally_clause] = STATE(453),
    [ts_builtin_sym_end] = ACTIONS(906),
    [sym_identifier] = ACTIONS(904),
    [anon_sym_import] = ACTIONS(904),
    [anon_sym_from] = ACTIONS(904),
    [anon_sym_LPAREN] = ACTIONS(906),
    [anon_sym_print] = ACTIONS(904),
    [anon_sym_assert] = ACTIONS(904),
    [anon_sym_return] = ACTIONS(904),
    [anon_sym_del] = ACTIONS(904),
    [anon_sym_raise] = ACTIONS(904),
    [anon_sym_pass] = ACTIONS(904),
    [anon_sym_break] = ACTIONS(904),
    [anon_sym_continue] = ACTIONS(904),
    [anon_sym_if] = ACTIONS(904),
    [anon_sym_async] = ACTIONS(904),
    [anon_sym_for] = ACTIONS(904),
    [anon_sym_while] = ACTIONS(904),
    [anon_sym_try] = ACTIONS(904),
    [anon_sym_finally] = ACTIONS(552),
    [anon_sym_with] = ACTIONS(904),
    [anon_sym_def] = ACTIONS(904),
    [anon_sym_global] = ACTIONS(904),
    [anon_sym_nonlocal] = ACTIONS(904),
    [anon_sym_exec] = ACTIONS(904),
    [anon_sym_class] = ACTIONS(904),
    [anon_sym_AT] = ACTIONS(906),
    [anon_sym_not] = ACTIONS(904),
    [anon_sym_PLUS] = ACTIONS(906),
    [anon_sym_DASH] = ACTIONS(906),
    [anon_sym_TILDE] = ACTIONS(906),
    [anon_sym_lambda] = ACTIONS(904),
    [anon_sym_yield] = ACTIONS(904),
    [anon_sym_LBRACK] = ACTIONS(906),
    [sym_ellipsis] = ACTIONS(906),
    [anon_sym_LBRACE] = ACTIONS(906),
    [sym_integer] = ACTIONS(904),
    [sym_float] = ACTIONS(906),
    [sym_true] = ACTIONS(904),
    [sym_false] = ACTIONS(904),
    [sym_none] = ACTIONS(904),
    [anon_sym_await] = ACTIONS(904),
    [sym_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(906),
  },
  [377] = {
    [sym_string] = STATE(378),
    [aux_sym_concatenated_string_repeat1] = STATE(378),
    [anon_sym_DOT] = ACTIONS(486),
    [anon_sym_LPAREN] = ACTIONS(486),
    [anon_sym_RPAREN] = ACTIONS(486),
    [anon_sym_COMMA] = ACTIONS(486),
    [anon_sym_STAR] = ACTIONS(488),
    [anon_sym_GT_GT] = ACTIONS(486),
    [anon_sym_if] = ACTIONS(486),
    [anon_sym_COLON] = ACTIONS(486),
    [anon_sym_else] = ACTIONS(486),
    [anon_sym_async] = ACTIONS(486),
    [anon_sym_for] = ACTIONS(486),
    [anon_sym_in] = ACTIONS(486),
    [anon_sym_EQ] = ACTIONS(488),
    [anon_sym_STAR_STAR] = ACTIONS(486),
    [anon_sym_AT] = ACTIONS(486),
    [anon_sym_not] = ACTIONS(486),
    [anon_sym_and] = ACTIONS(486),
    [anon_sym_or] = ACTIONS(486),
    [anon_sym_PLUS] = ACTIONS(486),
    [anon_sym_DASH] = ACTIONS(486),
    [anon_sym_SLASH] = ACTIONS(488),
    [anon_sym_PERCENT] = ACTIONS(486),
    [anon_sym_SLASH_SLASH] = ACTIONS(486),
    [anon_sym_PIPE] = ACTIONS(486),
    [anon_sym_AMP] = ACTIONS(486),
    [anon_sym_CARET] = ACTIONS(486),
    [anon_sym_LT_LT] = ACTIONS(486),
    [anon_sym_LT] = ACTIONS(488),
    [anon_sym_LT_EQ] = ACTIONS(486),
    [anon_sym_EQ_EQ] = ACTIONS(486),
    [anon_sym_BANG_EQ] = ACTIONS(486),
    [anon_sym_GT_EQ] = ACTIONS(486),
    [anon_sym_GT] = ACTIONS(488),
    [anon_sym_LT_GT] = ACTIONS(486),
    [anon_sym_is] = ACTIONS(486),
    [anon_sym_LBRACK] = ACTIONS(486),
    [anon_sym_RBRACK] = ACTIONS(486),
    [anon_sym_RBRACE] = ACTIONS(486),
    [sym_type_conversion] = ACTIONS(486),
    [sym_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(377),
  },
  [378] = {
    [sym_string] = STATE(378),
    [aux_sym_concatenated_string_repeat1] = STATE(378),
    [anon_sym_DOT] = ACTIONS(475),
    [anon_sym_LPAREN] = ACTIONS(475),
    [anon_sym_RPAREN] = ACTIONS(475),
    [anon_sym_COMMA] = ACTIONS(475),
    [anon_sym_STAR] = ACTIONS(477),
    [anon_sym_GT_GT] = ACTIONS(475),
    [anon_sym_if] = ACTIONS(475),
    [anon_sym_COLON] = ACTIONS(475),
    [anon_sym_else] = ACTIONS(475),
    [anon_sym_async] = ACTIONS(475),
    [anon_sym_for] = ACTIONS(475),
    [anon_sym_in] = ACTIONS(475),
    [anon_sym_EQ] = ACTIONS(477),
    [anon_sym_STAR_STAR] = ACTIONS(475),
    [anon_sym_AT] = ACTIONS(475),
    [anon_sym_not] = ACTIONS(475),
    [anon_sym_and] = ACTIONS(475),
    [anon_sym_or] = ACTIONS(475),
    [anon_sym_PLUS] = ACTIONS(475),
    [anon_sym_DASH] = ACTIONS(475),
    [anon_sym_SLASH] = ACTIONS(477),
    [anon_sym_PERCENT] = ACTIONS(475),
    [anon_sym_SLASH_SLASH] = ACTIONS(475),
    [anon_sym_PIPE] = ACTIONS(475),
    [anon_sym_AMP] = ACTIONS(475),
    [anon_sym_CARET] = ACTIONS(475),
    [anon_sym_LT_LT] = ACTIONS(475),
    [anon_sym_LT] = ACTIONS(477),
    [anon_sym_LT_EQ] = ACTIONS(475),
    [anon_sym_EQ_EQ] = ACTIONS(475),
    [anon_sym_BANG_EQ] = ACTIONS(475),
    [anon_sym_GT_EQ] = ACTIONS(475),
    [anon_sym_GT] = ACTIONS(477),
    [anon_sym_LT_GT] = ACTIONS(475),
    [anon_sym_is] = ACTIONS(475),
    [anon_sym_LBRACK] = ACTIONS(475),
    [anon_sym_RBRACK] = ACTIONS(475),
    [anon_sym_RBRACE] = ACTIONS(475),
    [sym_type_conversion] = ACTIONS(475),
    [sym_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(936),
  },
  [379] = {
    [sym_identifier] = ACTIONS(939),
    [anon_sym_import] = ACTIONS(939),
    [anon_sym_from] = ACTIONS(939),
    [anon_sym_LPAREN] = ACTIONS(941),
    [anon_sym_print] = ACTIONS(939),
    [anon_sym_assert] = ACTIONS(939),
    [anon_sym_return] = ACTIONS(939),
    [anon_sym_del] = ACTIONS(939),
    [anon_sym_raise] = ACTIONS(939),
    [anon_sym_pass] = ACTIONS(939),
    [anon_sym_break] = ACTIONS(939),
    [anon_sym_continue] = ACTIONS(939),
    [anon_sym_if] = ACTIONS(939),
    [anon_sym_async] = ACTIONS(939),
    [anon_sym_for] = ACTIONS(939),
    [anon_sym_while] = ACTIONS(939),
    [anon_sym_try] = ACTIONS(939),
    [anon_sym_finally] = ACTIONS(939),
    [anon_sym_with] = ACTIONS(939),
    [anon_sym_def] = ACTIONS(939),
    [anon_sym_global] = ACTIONS(939),
    [anon_sym_nonlocal] = ACTIONS(939),
    [anon_sym_exec] = ACTIONS(939),
    [anon_sym_class] = ACTIONS(939),
    [anon_sym_AT] = ACTIONS(941),
    [anon_sym_not] = ACTIONS(939),
    [anon_sym_PLUS] = ACTIONS(941),
    [anon_sym_DASH] = ACTIONS(941),
    [anon_sym_TILDE] = ACTIONS(941),
    [anon_sym_lambda] = ACTIONS(939),
    [anon_sym_yield] = ACTIONS(939),
    [anon_sym_LBRACK] = ACTIONS(941),
    [sym_ellipsis] = ACTIONS(941),
    [anon_sym_LBRACE] = ACTIONS(941),
    [sym_integer] = ACTIONS(939),
    [sym_float] = ACTIONS(941),
    [sym_true] = ACTIONS(939),
    [sym_false] = ACTIONS(939),
    [sym_none] = ACTIONS(939),
    [anon_sym_await] = ACTIONS(939),
    [sym_comment] = ACTIONS(3),
    [sym__dedent] = ACTIONS(941),
    [sym__string_start] = ACTIONS(941),
  },
  [380] = {
    [ts_builtin_sym_end] = ACTIONS(941),
    [sym_identifier] = ACTIONS(939),
    [anon_sym_import] = ACTIONS(939),
    [anon_sym_from] = ACTIONS(939),
    [anon_sym_LPAREN] = ACTIONS(941),
    [anon_sym_print] = ACTIONS(939),
    [anon_sym_assert] = ACTIONS(939),
    [anon_sym_return] = ACTIONS(939),
    [anon_sym_del] = ACTIONS(939),
    [anon_sym_raise] = ACTIONS(939),
    [anon_sym_pass] = ACTIONS(939),
    [anon_sym_break] = ACTIONS(939),
    [anon_sym_continue] = ACTIONS(939),
    [anon_sym_if] = ACTIONS(939),
    [anon_sym_async] = ACTIONS(939),
    [anon_sym_for] = ACTIONS(939),
    [anon_sym_while] = ACTIONS(939),
    [anon_sym_try] = ACTIONS(939),
    [anon_sym_finally] = ACTIONS(939),
    [anon_sym_with] = ACTIONS(939),
    [anon_sym_def] = ACTIONS(939),
    [anon_sym_global] = ACTIONS(939),
    [anon_sym_nonlocal] = ACTIONS(939),
    [anon_sym_exec] = ACTIONS(939),
    [anon_sym_class] = ACTIONS(939),
    [anon_sym_AT] = ACTIONS(941),
    [anon_sym_not] = ACTIONS(939),
    [anon_sym_PLUS] = ACTIONS(941),
    [anon_sym_DASH] = ACTIONS(941),
    [anon_sym_TILDE] = ACTIONS(941),
    [anon_sym_lambda] = ACTIONS(939),
    [anon_sym_yield] = ACTIONS(939),
    [anon_sym_LBRACK] = ACTIONS(941),
    [sym_ellipsis] = ACTIONS(941),
    [anon_sym_LBRACE] = ACTIONS(941),
    [sym_integer] = ACTIONS(939),
    [sym_float] = ACTIONS(941),
    [sym_true] = ACTIONS(939),
    [sym_false] = ACTIONS(939),
    [sym_none] = ACTIONS(939),
    [anon_sym_await] = ACTIONS(939),
    [sym_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(941),
  },
  [381] = {
    [sym_string] = STATE(377),
    [aux_sym_concatenated_string_repeat1] = STATE(377),
    [anon_sym_DOT] = ACTIONS(467),
    [anon_sym_LPAREN] = ACTIONS(467),
    [anon_sym_RPAREN] = ACTIONS(467),
    [anon_sym_COMMA] = ACTIONS(467),
    [anon_sym_STAR] = ACTIONS(469),
    [anon_sym_GT_GT] = ACTIONS(467),
    [anon_sym_if] = ACTIONS(467),
    [anon_sym_COLON] = ACTIONS(467),
    [anon_sym_else] = ACTIONS(467),
    [anon_sym_async] = ACTIONS(467),
    [anon_sym_for] = ACTIONS(467),
    [anon_sym_in] = ACTIONS(467),
    [anon_sym_EQ] = ACTIONS(469),
    [anon_sym_STAR_STAR] = ACTIONS(467),
    [anon_sym_AT] = ACTIONS(467),
    [anon_sym_not] = ACTIONS(467),
    [anon_sym_and] = ACTIONS(467),
    [anon_sym_or] = ACTIONS(467),
    [anon_sym_PLUS] = ACTIONS(467),
    [anon_sym_DASH] = ACTIONS(467),
    [anon_sym_SLASH] = ACTIONS(469),
    [anon_sym_PERCENT] = ACTIONS(467),
    [anon_sym_SLASH_SLASH] = ACTIONS(467),
    [anon_sym_PIPE] = ACTIONS(467),
    [anon_sym_AMP] = ACTIONS(467),
    [anon_sym_CARET] = ACTIONS(467),
    [anon_sym_LT_LT] = ACTIONS(467),
    [anon_sym_LT] = ACTIONS(469),
    [anon_sym_LT_EQ] = ACTIONS(467),
    [anon_sym_EQ_EQ] = ACTIONS(467),
    [anon_sym_BANG_EQ] = ACTIONS(467),
    [anon_sym_GT_EQ] = ACTIONS(467),
    [anon_sym_GT] = ACTIONS(469),
    [anon_sym_LT_GT] = ACTIONS(467),
    [anon_sym_is] = ACTIONS(467),
    [anon_sym_LBRACK] = ACTIONS(467),
    [anon_sym_RBRACK] = ACTIONS(467),
    [anon_sym_RBRACE] = ACTIONS(467),
    [sym_type_conversion] = ACTIONS(467),
    [sym_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(377),
  },
  [382] = {
    [sym_identifier] = ACTIONS(943),
    [anon_sym_import] = ACTIONS(943),
    [anon_sym_from] = ACTIONS(943),
    [anon_sym_LPAREN] = ACTIONS(945),
    [anon_sym_print] = ACTIONS(943),
    [anon_sym_assert] = ACTIONS(943),
    [anon_sym_return] = ACTIONS(943),
    [anon_sym_del] = ACTIONS(943),
    [anon_sym_raise] = ACTIONS(943),
    [anon_sym_pass] = ACTIONS(943),
    [anon_sym_break] = ACTIONS(943),
    [anon_sym_continue] = ACTIONS(943),
    [anon_sym_if] = ACTIONS(943),
    [anon_sym_async] = ACTIONS(943),
    [anon_sym_for] = ACTIONS(943),
    [anon_sym_while] = ACTIONS(943),
    [anon_sym_try] = ACTIONS(943),
    [anon_sym_finally] = ACTIONS(943),
    [anon_sym_with] = ACTIONS(943),
    [anon_sym_def] = ACTIONS(943),
    [anon_sym_global] = ACTIONS(943),
    [anon_sym_nonlocal] = ACTIONS(943),
    [anon_sym_exec] = ACTIONS(943),
    [anon_sym_class] = ACTIONS(943),
    [anon_sym_AT] = ACTIONS(945),
    [anon_sym_not] = ACTIONS(943),
    [anon_sym_PLUS] = ACTIONS(945),
    [anon_sym_DASH] = ACTIONS(945),
    [anon_sym_TILDE] = ACTIONS(945),
    [anon_sym_lambda] = ACTIONS(943),
    [anon_sym_yield] = ACTIONS(943),
    [anon_sym_LBRACK] = ACTIONS(945),
    [sym_ellipsis] = ACTIONS(945),
    [anon_sym_LBRACE] = ACTIONS(945),
    [sym_integer] = ACTIONS(943),
    [sym_float] = ACTIONS(945),
    [sym_true] = ACTIONS(943),
    [sym_false] = ACTIONS(943),
    [sym_none] = ACTIONS(943),
    [anon_sym_await] = ACTIONS(943),
    [sym_comment] = ACTIONS(3),
    [sym__dedent] = ACTIONS(945),
    [sym__string_start] = ACTIONS(945),
  },
  [383] = {
    [sym_argument_list] = STATE(474),
    [sym_generator_expression] = STATE(474),
    [aux_sym_comparison_operator_repeat1] = STATE(598),
    [anon_sym_DOT] = ACTIONS(947),
    [anon_sym_LPAREN] = ACTIONS(949),
    [anon_sym_RPAREN] = ACTIONS(413),
    [anon_sym_COMMA] = ACTIONS(413),
    [anon_sym_STAR] = ACTIONS(951),
    [anon_sym_GT_GT] = ACTIONS(953),
    [anon_sym_if] = ACTIONS(413),
    [anon_sym_COLON] = ACTIONS(413),
    [anon_sym_else] = ACTIONS(413),
    [anon_sym_async] = ACTIONS(413),
    [anon_sym_for] = ACTIONS(413),
    [anon_sym_in] = ACTIONS(955),
    [anon_sym_EQ] = ACTIONS(423),
    [anon_sym_STAR_STAR] = ACTIONS(957),
    [anon_sym_AT] = ACTIONS(959),
    [anon_sym_not] = ACTIONS(961),
    [anon_sym_and] = ACTIONS(413),
    [anon_sym_or] = ACTIONS(413),
    [anon_sym_PLUS] = ACTIONS(963),
    [anon_sym_DASH] = ACTIONS(963),
    [anon_sym_SLASH] = ACTIONS(951),
    [anon_sym_PERCENT] = ACTIONS(959),
    [anon_sym_SLASH_SLASH] = ACTIONS(959),
    [anon_sym_PIPE] = ACTIONS(965),
    [anon_sym_AMP] = ACTIONS(967),
    [anon_sym_CARET] = ACTIONS(969),
    [anon_sym_LT_LT] = ACTIONS(953),
    [anon_sym_LT] = ACTIONS(971),
    [anon_sym_LT_EQ] = ACTIONS(955),
    [anon_sym_EQ_EQ] = ACTIONS(955),
    [anon_sym_BANG_EQ] = ACTIONS(955),
    [anon_sym_GT_EQ] = ACTIONS(955),
    [anon_sym_GT] = ACTIONS(971),
    [anon_sym_LT_GT] = ACTIONS(955),
    [anon_sym_is] = ACTIONS(973),
    [anon_sym_LBRACK] = ACTIONS(975),
    [anon_sym_RBRACK] = ACTIONS(413),
    [anon_sym_RBRACE] = ACTIONS(413),
    [sym_type_conversion] = ACTIONS(413),
    [sym_comment] = ACTIONS(3),
  },
  [384] = {
    [ts_builtin_sym_end] = ACTIONS(945),
    [sym_identifier] = ACTIONS(943),
    [anon_sym_import] = ACTIONS(943),
    [anon_sym_from] = ACTIONS(943),
    [anon_sym_LPAREN] = ACTIONS(945),
    [anon_sym_print] = ACTIONS(943),
    [anon_sym_assert] = ACTIONS(943),
    [anon_sym_return] = ACTIONS(943),
    [anon_sym_del] = ACTIONS(943),
    [anon_sym_raise] = ACTIONS(943),
    [anon_sym_pass] = ACTIONS(943),
    [anon_sym_break] = ACTIONS(943),
    [anon_sym_continue] = ACTIONS(943),
    [anon_sym_if] = ACTIONS(943),
    [anon_sym_async] = ACTIONS(943),
    [anon_sym_for] = ACTIONS(943),
    [anon_sym_while] = ACTIONS(943),
    [anon_sym_try] = ACTIONS(943),
    [anon_sym_finally] = ACTIONS(943),
    [anon_sym_with] = ACTIONS(943),
    [anon_sym_def] = ACTIONS(943),
    [anon_sym_global] = ACTIONS(943),
    [anon_sym_nonlocal] = ACTIONS(943),
    [anon_sym_exec] = ACTIONS(943),
    [anon_sym_class] = ACTIONS(943),
    [anon_sym_AT] = ACTIONS(945),
    [anon_sym_not] = ACTIONS(943),
    [anon_sym_PLUS] = ACTIONS(945),
    [anon_sym_DASH] = ACTIONS(945),
    [anon_sym_TILDE] = ACTIONS(945),
    [anon_sym_lambda] = ACTIONS(943),
    [anon_sym_yield] = ACTIONS(943),
    [anon_sym_LBRACK] = ACTIONS(945),
    [sym_ellipsis] = ACTIONS(945),
    [anon_sym_LBRACE] = ACTIONS(945),
    [sym_integer] = ACTIONS(943),
    [sym_float] = ACTIONS(945),
    [sym_true] = ACTIONS(943),
    [sym_false] = ACTIONS(943),
    [sym_none] = ACTIONS(943),
    [anon_sym_await] = ACTIONS(943),
    [sym_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(945),
  },
  [385] = {
    [sym_identifier] = ACTIONS(977),
    [anon_sym_import] = ACTIONS(977),
    [anon_sym_from] = ACTIONS(977),
    [anon_sym_LPAREN] = ACTIONS(979),
    [anon_sym_print] = ACTIONS(977),
    [anon_sym_assert] = ACTIONS(977),
    [anon_sym_return] = ACTIONS(977),
    [anon_sym_del] = ACTIONS(977),
    [anon_sym_raise] = ACTIONS(977),
    [anon_sym_pass] = ACTIONS(977),
    [anon_sym_break] = ACTIONS(977),
    [anon_sym_continue] = ACTIONS(977),
    [anon_sym_if] = ACTIONS(977),
    [anon_sym_async] = ACTIONS(977),
    [anon_sym_for] = ACTIONS(977),
    [anon_sym_while] = ACTIONS(977),
    [anon_sym_try] = ACTIONS(977),
    [anon_sym_with] = ACTIONS(977),
    [anon_sym_def] = ACTIONS(977),
    [anon_sym_global] = ACTIONS(977),
    [anon_sym_nonlocal] = ACTIONS(977),
    [anon_sym_exec] = ACTIONS(977),
    [anon_sym_class] = ACTIONS(977),
    [anon_sym_AT] = ACTIONS(979),
    [anon_sym_not] = ACTIONS(977),
    [anon_sym_PLUS] = ACTIONS(979),
    [anon_sym_DASH] = ACTIONS(979),
    [anon_sym_TILDE] = ACTIONS(979),
    [anon_sym_lambda] = ACTIONS(977),
    [anon_sym_yield] = ACTIONS(977),
    [anon_sym_LBRACK] = ACTIONS(979),
    [sym_ellipsis] = ACTIONS(979),
    [anon_sym_LBRACE] = ACTIONS(979),
    [sym_integer] = ACTIONS(977),
    [sym_float] = ACTIONS(979),
    [sym_true] = ACTIONS(977),
    [sym_false] = ACTIONS(977),
    [sym_none] = ACTIONS(977),
    [anon_sym_await] = ACTIONS(977),
    [sym_comment] = ACTIONS(3),
    [sym__dedent] = ACTIONS(979),
    [sym__string_start] = ACTIONS(979),
  },
  [386] = {
    [ts_builtin_sym_end] = ACTIONS(981),
    [sym_identifier] = ACTIONS(983),
    [anon_sym_import] = ACTIONS(983),
    [anon_sym_from] = ACTIONS(983),
    [anon_sym_LPAREN] = ACTIONS(981),
    [anon_sym_print] = ACTIONS(983),
    [anon_sym_assert] = ACTIONS(983),
    [anon_sym_return] = ACTIONS(983),
    [anon_sym_del] = ACTIONS(983),
    [anon_sym_raise] = ACTIONS(983),
    [anon_sym_pass] = ACTIONS(983),
    [anon_sym_break] = ACTIONS(983),
    [anon_sym_continue] = ACTIONS(983),
    [anon_sym_if] = ACTIONS(983),
    [anon_sym_async] = ACTIONS(983),
    [anon_sym_for] = ACTIONS(983),
    [anon_sym_while] = ACTIONS(983),
    [anon_sym_try] = ACTIONS(983),
    [anon_sym_with] = ACTIONS(983),
    [anon_sym_def] = ACTIONS(983),
    [anon_sym_global] = ACTIONS(983),
    [anon_sym_nonlocal] = ACTIONS(983),
    [anon_sym_exec] = ACTIONS(983),
    [anon_sym_class] = ACTIONS(983),
    [anon_sym_AT] = ACTIONS(981),
    [anon_sym_not] = ACTIONS(983),
    [anon_sym_PLUS] = ACTIONS(981),
    [anon_sym_DASH] = ACTIONS(981),
    [anon_sym_TILDE] = ACTIONS(981),
    [anon_sym_lambda] = ACTIONS(983),
    [anon_sym_yield] = ACTIONS(983),
    [anon_sym_LBRACK] = ACTIONS(981),
    [sym_ellipsis] = ACTIONS(981),
    [anon_sym_LBRACE] = ACTIONS(981),
    [sym_integer] = ACTIONS(983),
    [sym_float] = ACTIONS(981),
    [sym_true] = ACTIONS(983),
    [sym_false] = ACTIONS(983),
    [sym_none] = ACTIONS(983),
    [anon_sym_await] = ACTIONS(983),
    [sym_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(981),
  },
  [387] = {
    [sym_identifier] = ACTIONS(985),
    [anon_sym_import] = ACTIONS(985),
    [anon_sym_from] = ACTIONS(985),
    [anon_sym_LPAREN] = ACTIONS(987),
    [anon_sym_print] = ACTIONS(985),
    [anon_sym_assert] = ACTIONS(985),
    [anon_sym_return] = ACTIONS(985),
    [anon_sym_del] = ACTIONS(985),
    [anon_sym_raise] = ACTIONS(985),
    [anon_sym_pass] = ACTIONS(985),
    [anon_sym_break] = ACTIONS(985),
    [anon_sym_continue] = ACTIONS(985),
    [anon_sym_if] = ACTIONS(985),
    [anon_sym_async] = ACTIONS(985),
    [anon_sym_for] = ACTIONS(985),
    [anon_sym_while] = ACTIONS(985),
    [anon_sym_try] = ACTIONS(985),
    [anon_sym_with] = ACTIONS(985),
    [anon_sym_def] = ACTIONS(985),
    [anon_sym_global] = ACTIONS(985),
    [anon_sym_nonlocal] = ACTIONS(985),
    [anon_sym_exec] = ACTIONS(985),
    [anon_sym_class] = ACTIONS(985),
    [anon_sym_AT] = ACTIONS(987),
    [anon_sym_not] = ACTIONS(985),
    [anon_sym_PLUS] = ACTIONS(987),
    [anon_sym_DASH] = ACTIONS(987),
    [anon_sym_TILDE] = ACTIONS(987),
    [anon_sym_lambda] = ACTIONS(985),
    [anon_sym_yield] = ACTIONS(985),
    [anon_sym_LBRACK] = ACTIONS(987),
    [sym_ellipsis] = ACTIONS(987),
    [anon_sym_LBRACE] = ACTIONS(987),
    [sym_integer] = ACTIONS(985),
    [sym_float] = ACTIONS(987),
    [sym_true] = ACTIONS(985),
    [sym_false] = ACTIONS(985),
    [sym_none] = ACTIONS(985),
    [anon_sym_await] = ACTIONS(985),
    [sym_comment] = ACTIONS(3),
    [sym__dedent] = ACTIONS(987),
    [sym__string_start] = ACTIONS(987),
  },
  [388] = {
    [sym_identifier] = ACTIONS(989),
    [anon_sym_import] = ACTIONS(989),
    [anon_sym_from] = ACTIONS(989),
    [anon_sym_LPAREN] = ACTIONS(991),
    [anon_sym_print] = ACTIONS(989),
    [anon_sym_assert] = ACTIONS(989),
    [anon_sym_return] = ACTIONS(989),
    [anon_sym_del] = ACTIONS(989),
    [anon_sym_raise] = ACTIONS(989),
    [anon_sym_pass] = ACTIONS(989),
    [anon_sym_break] = ACTIONS(989),
    [anon_sym_continue] = ACTIONS(989),
    [anon_sym_if] = ACTIONS(989),
    [anon_sym_async] = ACTIONS(989),
    [anon_sym_for] = ACTIONS(989),
    [anon_sym_while] = ACTIONS(989),
    [anon_sym_try] = ACTIONS(989),
    [anon_sym_with] = ACTIONS(989),
    [anon_sym_def] = ACTIONS(989),
    [anon_sym_global] = ACTIONS(989),
    [anon_sym_nonlocal] = ACTIONS(989),
    [anon_sym_exec] = ACTIONS(989),
    [anon_sym_class] = ACTIONS(989),
    [anon_sym_AT] = ACTIONS(991),
    [anon_sym_not] = ACTIONS(989),
    [anon_sym_PLUS] = ACTIONS(991),
    [anon_sym_DASH] = ACTIONS(991),
    [anon_sym_TILDE] = ACTIONS(991),
    [anon_sym_lambda] = ACTIONS(989),
    [anon_sym_yield] = ACTIONS(989),
    [anon_sym_LBRACK] = ACTIONS(991),
    [sym_ellipsis] = ACTIONS(991),
    [anon_sym_LBRACE] = ACTIONS(991),
    [sym_integer] = ACTIONS(989),
    [sym_float] = ACTIONS(991),
    [sym_true] = ACTIONS(989),
    [sym_false] = ACTIONS(989),
    [sym_none] = ACTIONS(989),
    [anon_sym_await] = ACTIONS(989),
    [sym_comment] = ACTIONS(3),
    [sym__dedent] = ACTIONS(991),
    [sym__string_start] = ACTIONS(991),
  },
  [389] = {
    [sym_identifier] = ACTIONS(993),
    [anon_sym_import] = ACTIONS(993),
    [anon_sym_from] = ACTIONS(993),
    [anon_sym_LPAREN] = ACTIONS(995),
    [anon_sym_print] = ACTIONS(993),
    [anon_sym_assert] = ACTIONS(993),
    [anon_sym_return] = ACTIONS(993),
    [anon_sym_del] = ACTIONS(993),
    [anon_sym_raise] = ACTIONS(993),
    [anon_sym_pass] = ACTIONS(993),
    [anon_sym_break] = ACTIONS(993),
    [anon_sym_continue] = ACTIONS(993),
    [anon_sym_if] = ACTIONS(993),
    [anon_sym_async] = ACTIONS(993),
    [anon_sym_for] = ACTIONS(993),
    [anon_sym_while] = ACTIONS(993),
    [anon_sym_try] = ACTIONS(993),
    [anon_sym_with] = ACTIONS(993),
    [anon_sym_def] = ACTIONS(993),
    [anon_sym_global] = ACTIONS(993),
    [anon_sym_nonlocal] = ACTIONS(993),
    [anon_sym_exec] = ACTIONS(993),
    [anon_sym_class] = ACTIONS(993),
    [anon_sym_AT] = ACTIONS(995),
    [anon_sym_not] = ACTIONS(993),
    [anon_sym_PLUS] = ACTIONS(995),
    [anon_sym_DASH] = ACTIONS(995),
    [anon_sym_TILDE] = ACTIONS(995),
    [anon_sym_lambda] = ACTIONS(993),
    [anon_sym_yield] = ACTIONS(993),
    [anon_sym_LBRACK] = ACTIONS(995),
    [sym_ellipsis] = ACTIONS(995),
    [anon_sym_LBRACE] = ACTIONS(995),
    [sym_integer] = ACTIONS(993),
    [sym_float] = ACTIONS(995),
    [sym_true] = ACTIONS(993),
    [sym_false] = ACTIONS(993),
    [sym_none] = ACTIONS(993),
    [anon_sym_await] = ACTIONS(993),
    [sym_comment] = ACTIONS(3),
    [sym__dedent] = ACTIONS(995),
    [sym__string_start] = ACTIONS(995),
  },
  [390] = {
    [sym_identifier] = ACTIONS(904),
    [anon_sym_import] = ACTIONS(904),
    [anon_sym_from] = ACTIONS(904),
    [anon_sym_LPAREN] = ACTIONS(906),
    [anon_sym_print] = ACTIONS(904),
    [anon_sym_assert] = ACTIONS(904),
    [anon_sym_return] = ACTIONS(904),
    [anon_sym_del] = ACTIONS(904),
    [anon_sym_raise] = ACTIONS(904),
    [anon_sym_pass] = ACTIONS(904),
    [anon_sym_break] = ACTIONS(904),
    [anon_sym_continue] = ACTIONS(904),
    [anon_sym_if] = ACTIONS(904),
    [anon_sym_async] = ACTIONS(904),
    [anon_sym_for] = ACTIONS(904),
    [anon_sym_while] = ACTIONS(904),
    [anon_sym_try] = ACTIONS(904),
    [anon_sym_with] = ACTIONS(904),
    [anon_sym_def] = ACTIONS(904),
    [anon_sym_global] = ACTIONS(904),
    [anon_sym_nonlocal] = ACTIONS(904),
    [anon_sym_exec] = ACTIONS(904),
    [anon_sym_class] = ACTIONS(904),
    [anon_sym_AT] = ACTIONS(906),
    [anon_sym_not] = ACTIONS(904),
    [anon_sym_PLUS] = ACTIONS(906),
    [anon_sym_DASH] = ACTIONS(906),
    [anon_sym_TILDE] = ACTIONS(906),
    [anon_sym_lambda] = ACTIONS(904),
    [anon_sym_yield] = ACTIONS(904),
    [anon_sym_LBRACK] = ACTIONS(906),
    [sym_ellipsis] = ACTIONS(906),
    [anon_sym_LBRACE] = ACTIONS(906),
    [sym_integer] = ACTIONS(904),
    [sym_float] = ACTIONS(906),
    [sym_true] = ACTIONS(904),
    [sym_false] = ACTIONS(904),
    [sym_none] = ACTIONS(904),
    [anon_sym_await] = ACTIONS(904),
    [sym_comment] = ACTIONS(3),
    [sym__dedent] = ACTIONS(906),
    [sym__string_start] = ACTIONS(906),
  },
  [391] = {
    [sym_identifier] = ACTIONS(997),
    [anon_sym_import] = ACTIONS(997),
    [anon_sym_from] = ACTIONS(997),
    [anon_sym_LPAREN] = ACTIONS(999),
    [anon_sym_print] = ACTIONS(997),
    [anon_sym_assert] = ACTIONS(997),
    [anon_sym_return] = ACTIONS(997),
    [anon_sym_del] = ACTIONS(997),
    [anon_sym_raise] = ACTIONS(997),
    [anon_sym_pass] = ACTIONS(997),
    [anon_sym_break] = ACTIONS(997),
    [anon_sym_continue] = ACTIONS(997),
    [anon_sym_if] = ACTIONS(997),
    [anon_sym_async] = ACTIONS(997),
    [anon_sym_for] = ACTIONS(997),
    [anon_sym_while] = ACTIONS(997),
    [anon_sym_try] = ACTIONS(997),
    [anon_sym_with] = ACTIONS(997),
    [anon_sym_def] = ACTIONS(997),
    [anon_sym_global] = ACTIONS(997),
    [anon_sym_nonlocal] = ACTIONS(997),
    [anon_sym_exec] = ACTIONS(997),
    [anon_sym_class] = ACTIONS(997),
    [anon_sym_AT] = ACTIONS(999),
    [anon_sym_not] = ACTIONS(997),
    [anon_sym_PLUS] = ACTIONS(999),
    [anon_sym_DASH] = ACTIONS(999),
    [anon_sym_TILDE] = ACTIONS(999),
    [anon_sym_lambda] = ACTIONS(997),
    [anon_sym_yield] = ACTIONS(997),
    [anon_sym_LBRACK] = ACTIONS(999),
    [sym_ellipsis] = ACTIONS(999),
    [anon_sym_LBRACE] = ACTIONS(999),
    [sym_integer] = ACTIONS(997),
    [sym_float] = ACTIONS(999),
    [sym_true] = ACTIONS(997),
    [sym_false] = ACTIONS(997),
    [sym_none] = ACTIONS(997),
    [anon_sym_await] = ACTIONS(997),
    [sym_comment] = ACTIONS(3),
    [sym__dedent] = ACTIONS(999),
    [sym__string_start] = ACTIONS(999),
  },
  [392] = {
    [sym_identifier] = ACTIONS(1001),
    [anon_sym_import] = ACTIONS(1001),
    [anon_sym_from] = ACTIONS(1001),
    [anon_sym_LPAREN] = ACTIONS(1003),
    [anon_sym_print] = ACTIONS(1001),
    [anon_sym_assert] = ACTIONS(1001),
    [anon_sym_return] = ACTIONS(1001),
    [anon_sym_del] = ACTIONS(1001),
    [anon_sym_raise] = ACTIONS(1001),
    [anon_sym_pass] = ACTIONS(1001),
    [anon_sym_break] = ACTIONS(1001),
    [anon_sym_continue] = ACTIONS(1001),
    [anon_sym_if] = ACTIONS(1001),
    [anon_sym_async] = ACTIONS(1001),
    [anon_sym_for] = ACTIONS(1001),
    [anon_sym_while] = ACTIONS(1001),
    [anon_sym_try] = ACTIONS(1001),
    [anon_sym_with] = ACTIONS(1001),
    [anon_sym_def] = ACTIONS(1001),
    [anon_sym_global] = ACTIONS(1001),
    [anon_sym_nonlocal] = ACTIONS(1001),
    [anon_sym_exec] = ACTIONS(1001),
    [anon_sym_class] = ACTIONS(1001),
    [anon_sym_AT] = ACTIONS(1003),
    [anon_sym_not] = ACTIONS(1001),
    [anon_sym_PLUS] = ACTIONS(1003),
    [anon_sym_DASH] = ACTIONS(1003),
    [anon_sym_TILDE] = ACTIONS(1003),
    [anon_sym_lambda] = ACTIONS(1001),
    [anon_sym_yield] = ACTIONS(1001),
    [anon_sym_LBRACK] = ACTIONS(1003),
    [sym_ellipsis] = ACTIONS(1003),
    [anon_sym_LBRACE] = ACTIONS(1003),
    [sym_integer] = ACTIONS(1001),
    [sym_float] = ACTIONS(1003),
    [sym_true] = ACTIONS(1001),
    [sym_false] = ACTIONS(1001),
    [sym_none] = ACTIONS(1001),
    [anon_sym_await] = ACTIONS(1001),
    [sym_comment] = ACTIONS(3),
    [sym__dedent] = ACTIONS(1003),
    [sym__string_start] = ACTIONS(1003),
  },
  [393] = {
    [sym_identifier] = ACTIONS(1005),
    [anon_sym_import] = ACTIONS(1005),
    [anon_sym_from] = ACTIONS(1005),
    [anon_sym_LPAREN] = ACTIONS(1007),
    [anon_sym_print] = ACTIONS(1005),
    [anon_sym_assert] = ACTIONS(1005),
    [anon_sym_return] = ACTIONS(1005),
    [anon_sym_del] = ACTIONS(1005),
    [anon_sym_raise] = ACTIONS(1005),
    [anon_sym_pass] = ACTIONS(1005),
    [anon_sym_break] = ACTIONS(1005),
    [anon_sym_continue] = ACTIONS(1005),
    [anon_sym_if] = ACTIONS(1005),
    [anon_sym_async] = ACTIONS(1005),
    [anon_sym_for] = ACTIONS(1005),
    [anon_sym_while] = ACTIONS(1005),
    [anon_sym_try] = ACTIONS(1005),
    [anon_sym_with] = ACTIONS(1005),
    [anon_sym_def] = ACTIONS(1005),
    [anon_sym_global] = ACTIONS(1005),
    [anon_sym_nonlocal] = ACTIONS(1005),
    [anon_sym_exec] = ACTIONS(1005),
    [anon_sym_class] = ACTIONS(1005),
    [anon_sym_AT] = ACTIONS(1007),
    [anon_sym_not] = ACTIONS(1005),
    [anon_sym_PLUS] = ACTIONS(1007),
    [anon_sym_DASH] = ACTIONS(1007),
    [anon_sym_TILDE] = ACTIONS(1007),
    [anon_sym_lambda] = ACTIONS(1005),
    [anon_sym_yield] = ACTIONS(1005),
    [anon_sym_LBRACK] = ACTIONS(1007),
    [sym_ellipsis] = ACTIONS(1007),
    [anon_sym_LBRACE] = ACTIONS(1007),
    [sym_integer] = ACTIONS(1005),
    [sym_float] = ACTIONS(1007),
    [sym_true] = ACTIONS(1005),
    [sym_false] = ACTIONS(1005),
    [sym_none] = ACTIONS(1005),
    [anon_sym_await] = ACTIONS(1005),
    [sym_comment] = ACTIONS(3),
    [sym__dedent] = ACTIONS(1007),
    [sym__string_start] = ACTIONS(1007),
  },
  [394] = {
    [sym_identifier] = ACTIONS(1009),
    [anon_sym_import] = ACTIONS(1009),
    [anon_sym_from] = ACTIONS(1009),
    [anon_sym_LPAREN] = ACTIONS(1011),
    [anon_sym_print] = ACTIONS(1009),
    [anon_sym_assert] = ACTIONS(1009),
    [anon_sym_return] = ACTIONS(1009),
    [anon_sym_del] = ACTIONS(1009),
    [anon_sym_raise] = ACTIONS(1009),
    [anon_sym_pass] = ACTIONS(1009),
    [anon_sym_break] = ACTIONS(1009),
    [anon_sym_continue] = ACTIONS(1009),
    [anon_sym_if] = ACTIONS(1009),
    [anon_sym_async] = ACTIONS(1009),
    [anon_sym_for] = ACTIONS(1009),
    [anon_sym_while] = ACTIONS(1009),
    [anon_sym_try] = ACTIONS(1009),
    [anon_sym_with] = ACTIONS(1009),
    [anon_sym_def] = ACTIONS(1009),
    [anon_sym_global] = ACTIONS(1009),
    [anon_sym_nonlocal] = ACTIONS(1009),
    [anon_sym_exec] = ACTIONS(1009),
    [anon_sym_class] = ACTIONS(1009),
    [anon_sym_AT] = ACTIONS(1011),
    [anon_sym_not] = ACTIONS(1009),
    [anon_sym_PLUS] = ACTIONS(1011),
    [anon_sym_DASH] = ACTIONS(1011),
    [anon_sym_TILDE] = ACTIONS(1011),
    [anon_sym_lambda] = ACTIONS(1009),
    [anon_sym_yield] = ACTIONS(1009),
    [anon_sym_LBRACK] = ACTIONS(1011),
    [sym_ellipsis] = ACTIONS(1011),
    [anon_sym_LBRACE] = ACTIONS(1011),
    [sym_integer] = ACTIONS(1009),
    [sym_float] = ACTIONS(1011),
    [sym_true] = ACTIONS(1009),
    [sym_false] = ACTIONS(1009),
    [sym_none] = ACTIONS(1009),
    [anon_sym_await] = ACTIONS(1009),
    [sym_comment] = ACTIONS(3),
    [sym__dedent] = ACTIONS(1011),
    [sym__string_start] = ACTIONS(1011),
  },
  [395] = {
    [sym_identifier] = ACTIONS(1013),
    [anon_sym_import] = ACTIONS(1013),
    [anon_sym_from] = ACTIONS(1013),
    [anon_sym_LPAREN] = ACTIONS(1015),
    [anon_sym_print] = ACTIONS(1013),
    [anon_sym_assert] = ACTIONS(1013),
    [anon_sym_return] = ACTIONS(1013),
    [anon_sym_del] = ACTIONS(1013),
    [anon_sym_raise] = ACTIONS(1013),
    [anon_sym_pass] = ACTIONS(1013),
    [anon_sym_break] = ACTIONS(1013),
    [anon_sym_continue] = ACTIONS(1013),
    [anon_sym_if] = ACTIONS(1013),
    [anon_sym_async] = ACTIONS(1013),
    [anon_sym_for] = ACTIONS(1013),
    [anon_sym_while] = ACTIONS(1013),
    [anon_sym_try] = ACTIONS(1013),
    [anon_sym_with] = ACTIONS(1013),
    [anon_sym_def] = ACTIONS(1013),
    [anon_sym_global] = ACTIONS(1013),
    [anon_sym_nonlocal] = ACTIONS(1013),
    [anon_sym_exec] = ACTIONS(1013),
    [anon_sym_class] = ACTIONS(1013),
    [anon_sym_AT] = ACTIONS(1015),
    [anon_sym_not] = ACTIONS(1013),
    [anon_sym_PLUS] = ACTIONS(1015),
    [anon_sym_DASH] = ACTIONS(1015),
    [anon_sym_TILDE] = ACTIONS(1015),
    [anon_sym_lambda] = ACTIONS(1013),
    [anon_sym_yield] = ACTIONS(1013),
    [anon_sym_LBRACK] = ACTIONS(1015),
    [sym_ellipsis] = ACTIONS(1015),
    [anon_sym_LBRACE] = ACTIONS(1015),
    [sym_integer] = ACTIONS(1013),
    [sym_float] = ACTIONS(1015),
    [sym_true] = ACTIONS(1013),
    [sym_false] = ACTIONS(1013),
    [sym_none] = ACTIONS(1013),
    [anon_sym_await] = ACTIONS(1013),
    [sym_comment] = ACTIONS(3),
    [sym__dedent] = ACTIONS(1015),
    [sym__string_start] = ACTIONS(1015),
  },
  [396] = {
    [sym_identifier] = ACTIONS(1017),
    [anon_sym_import] = ACTIONS(1017),
    [anon_sym_from] = ACTIONS(1017),
    [anon_sym_LPAREN] = ACTIONS(1019),
    [anon_sym_print] = ACTIONS(1017),
    [anon_sym_assert] = ACTIONS(1017),
    [anon_sym_return] = ACTIONS(1017),
    [anon_sym_del] = ACTIONS(1017),
    [anon_sym_raise] = ACTIONS(1017),
    [anon_sym_pass] = ACTIONS(1017),
    [anon_sym_break] = ACTIONS(1017),
    [anon_sym_continue] = ACTIONS(1017),
    [anon_sym_if] = ACTIONS(1017),
    [anon_sym_async] = ACTIONS(1017),
    [anon_sym_for] = ACTIONS(1017),
    [anon_sym_while] = ACTIONS(1017),
    [anon_sym_try] = ACTIONS(1017),
    [anon_sym_with] = ACTIONS(1017),
    [anon_sym_def] = ACTIONS(1017),
    [anon_sym_global] = ACTIONS(1017),
    [anon_sym_nonlocal] = ACTIONS(1017),
    [anon_sym_exec] = ACTIONS(1017),
    [anon_sym_class] = ACTIONS(1017),
    [anon_sym_AT] = ACTIONS(1019),
    [anon_sym_not] = ACTIONS(1017),
    [anon_sym_PLUS] = ACTIONS(1019),
    [anon_sym_DASH] = ACTIONS(1019),
    [anon_sym_TILDE] = ACTIONS(1019),
    [anon_sym_lambda] = ACTIONS(1017),
    [anon_sym_yield] = ACTIONS(1017),
    [anon_sym_LBRACK] = ACTIONS(1019),
    [sym_ellipsis] = ACTIONS(1019),
    [anon_sym_LBRACE] = ACTIONS(1019),
    [sym_integer] = ACTIONS(1017),
    [sym_float] = ACTIONS(1019),
    [sym_true] = ACTIONS(1017),
    [sym_false] = ACTIONS(1017),
    [sym_none] = ACTIONS(1017),
    [anon_sym_await] = ACTIONS(1017),
    [sym_comment] = ACTIONS(3),
    [sym__dedent] = ACTIONS(1019),
    [sym__string_start] = ACTIONS(1019),
  },
  [397] = {
    [sym_identifier] = ACTIONS(1021),
    [anon_sym_import] = ACTIONS(1021),
    [anon_sym_from] = ACTIONS(1021),
    [anon_sym_LPAREN] = ACTIONS(1023),
    [anon_sym_print] = ACTIONS(1021),
    [anon_sym_assert] = ACTIONS(1021),
    [anon_sym_return] = ACTIONS(1021),
    [anon_sym_del] = ACTIONS(1021),
    [anon_sym_raise] = ACTIONS(1021),
    [anon_sym_pass] = ACTIONS(1021),
    [anon_sym_break] = ACTIONS(1021),
    [anon_sym_continue] = ACTIONS(1021),
    [anon_sym_if] = ACTIONS(1021),
    [anon_sym_async] = ACTIONS(1021),
    [anon_sym_for] = ACTIONS(1021),
    [anon_sym_while] = ACTIONS(1021),
    [anon_sym_try] = ACTIONS(1021),
    [anon_sym_with] = ACTIONS(1021),
    [anon_sym_def] = ACTIONS(1021),
    [anon_sym_global] = ACTIONS(1021),
    [anon_sym_nonlocal] = ACTIONS(1021),
    [anon_sym_exec] = ACTIONS(1021),
    [anon_sym_class] = ACTIONS(1021),
    [anon_sym_AT] = ACTIONS(1023),
    [anon_sym_not] = ACTIONS(1021),
    [anon_sym_PLUS] = ACTIONS(1023),
    [anon_sym_DASH] = ACTIONS(1023),
    [anon_sym_TILDE] = ACTIONS(1023),
    [anon_sym_lambda] = ACTIONS(1021),
    [anon_sym_yield] = ACTIONS(1021),
    [anon_sym_LBRACK] = ACTIONS(1023),
    [sym_ellipsis] = ACTIONS(1023),
    [anon_sym_LBRACE] = ACTIONS(1023),
    [sym_integer] = ACTIONS(1021),
    [sym_float] = ACTIONS(1023),
    [sym_true] = ACTIONS(1021),
    [sym_false] = ACTIONS(1021),
    [sym_none] = ACTIONS(1021),
    [anon_sym_await] = ACTIONS(1021),
    [sym_comment] = ACTIONS(3),
    [sym__dedent] = ACTIONS(1023),
    [sym__string_start] = ACTIONS(1023),
  },
  [398] = {
    [sym_identifier] = ACTIONS(983),
    [anon_sym_import] = ACTIONS(983),
    [anon_sym_from] = ACTIONS(983),
    [anon_sym_LPAREN] = ACTIONS(981),
    [anon_sym_print] = ACTIONS(983),
    [anon_sym_assert] = ACTIONS(983),
    [anon_sym_return] = ACTIONS(983),
    [anon_sym_del] = ACTIONS(983),
    [anon_sym_raise] = ACTIONS(983),
    [anon_sym_pass] = ACTIONS(983),
    [anon_sym_break] = ACTIONS(983),
    [anon_sym_continue] = ACTIONS(983),
    [anon_sym_if] = ACTIONS(983),
    [anon_sym_async] = ACTIONS(983),
    [anon_sym_for] = ACTIONS(983),
    [anon_sym_while] = ACTIONS(983),
    [anon_sym_try] = ACTIONS(983),
    [anon_sym_with] = ACTIONS(983),
    [anon_sym_def] = ACTIONS(983),
    [anon_sym_global] = ACTIONS(983),
    [anon_sym_nonlocal] = ACTIONS(983),
    [anon_sym_exec] = ACTIONS(983),
    [anon_sym_class] = ACTIONS(983),
    [anon_sym_AT] = ACTIONS(981),
    [anon_sym_not] = ACTIONS(983),
    [anon_sym_PLUS] = ACTIONS(981),
    [anon_sym_DASH] = ACTIONS(981),
    [anon_sym_TILDE] = ACTIONS(981),
    [anon_sym_lambda] = ACTIONS(983),
    [anon_sym_yield] = ACTIONS(983),
    [anon_sym_LBRACK] = ACTIONS(981),
    [sym_ellipsis] = ACTIONS(981),
    [anon_sym_LBRACE] = ACTIONS(981),
    [sym_integer] = ACTIONS(983),
    [sym_float] = ACTIONS(981),
    [sym_true] = ACTIONS(983),
    [sym_false] = ACTIONS(983),
    [sym_none] = ACTIONS(983),
    [anon_sym_await] = ACTIONS(983),
    [sym_comment] = ACTIONS(3),
    [sym__dedent] = ACTIONS(981),
    [sym__string_start] = ACTIONS(981),
  },
  [399] = {
    [sym_identifier] = ACTIONS(1025),
    [anon_sym_import] = ACTIONS(1025),
    [anon_sym_from] = ACTIONS(1025),
    [anon_sym_LPAREN] = ACTIONS(1027),
    [anon_sym_print] = ACTIONS(1025),
    [anon_sym_assert] = ACTIONS(1025),
    [anon_sym_return] = ACTIONS(1025),
    [anon_sym_del] = ACTIONS(1025),
    [anon_sym_raise] = ACTIONS(1025),
    [anon_sym_pass] = ACTIONS(1025),
    [anon_sym_break] = ACTIONS(1025),
    [anon_sym_continue] = ACTIONS(1025),
    [anon_sym_if] = ACTIONS(1025),
    [anon_sym_async] = ACTIONS(1025),
    [anon_sym_for] = ACTIONS(1025),
    [anon_sym_while] = ACTIONS(1025),
    [anon_sym_try] = ACTIONS(1025),
    [anon_sym_with] = ACTIONS(1025),
    [anon_sym_def] = ACTIONS(1025),
    [anon_sym_global] = ACTIONS(1025),
    [anon_sym_nonlocal] = ACTIONS(1025),
    [anon_sym_exec] = ACTIONS(1025),
    [anon_sym_class] = ACTIONS(1025),
    [anon_sym_AT] = ACTIONS(1027),
    [anon_sym_not] = ACTIONS(1025),
    [anon_sym_PLUS] = ACTIONS(1027),
    [anon_sym_DASH] = ACTIONS(1027),
    [anon_sym_TILDE] = ACTIONS(1027),
    [anon_sym_lambda] = ACTIONS(1025),
    [anon_sym_yield] = ACTIONS(1025),
    [anon_sym_LBRACK] = ACTIONS(1027),
    [sym_ellipsis] = ACTIONS(1027),
    [anon_sym_LBRACE] = ACTIONS(1027),
    [sym_integer] = ACTIONS(1025),
    [sym_float] = ACTIONS(1027),
    [sym_true] = ACTIONS(1025),
    [sym_false] = ACTIONS(1025),
    [sym_none] = ACTIONS(1025),
    [anon_sym_await] = ACTIONS(1025),
    [sym_comment] = ACTIONS(3),
    [sym__dedent] = ACTIONS(1027),
    [sym__string_start] = ACTIONS(1027),
  },
  [400] = {
    [sym_identifier] = ACTIONS(1029),
    [anon_sym_import] = ACTIONS(1029),
    [anon_sym_from] = ACTIONS(1029),
    [anon_sym_LPAREN] = ACTIONS(1031),
    [anon_sym_print] = ACTIONS(1029),
    [anon_sym_assert] = ACTIONS(1029),
    [anon_sym_return] = ACTIONS(1029),
    [anon_sym_del] = ACTIONS(1029),
    [anon_sym_raise] = ACTIONS(1029),
    [anon_sym_pass] = ACTIONS(1029),
    [anon_sym_break] = ACTIONS(1029),
    [anon_sym_continue] = ACTIONS(1029),
    [anon_sym_if] = ACTIONS(1029),
    [anon_sym_async] = ACTIONS(1029),
    [anon_sym_for] = ACTIONS(1029),
    [anon_sym_while] = ACTIONS(1029),
    [anon_sym_try] = ACTIONS(1029),
    [anon_sym_with] = ACTIONS(1029),
    [anon_sym_def] = ACTIONS(1029),
    [anon_sym_global] = ACTIONS(1029),
    [anon_sym_nonlocal] = ACTIONS(1029),
    [anon_sym_exec] = ACTIONS(1029),
    [anon_sym_class] = ACTIONS(1029),
    [anon_sym_AT] = ACTIONS(1031),
    [anon_sym_not] = ACTIONS(1029),
    [anon_sym_PLUS] = ACTIONS(1031),
    [anon_sym_DASH] = ACTIONS(1031),
    [anon_sym_TILDE] = ACTIONS(1031),
    [anon_sym_lambda] = ACTIONS(1029),
    [anon_sym_yield] = ACTIONS(1029),
    [anon_sym_LBRACK] = ACTIONS(1031),
    [sym_ellipsis] = ACTIONS(1031),
    [anon_sym_LBRACE] = ACTIONS(1031),
    [sym_integer] = ACTIONS(1029),
    [sym_float] = ACTIONS(1031),
    [sym_true] = ACTIONS(1029),
    [sym_false] = ACTIONS(1029),
    [sym_none] = ACTIONS(1029),
    [anon_sym_await] = ACTIONS(1029),
    [sym_comment] = ACTIONS(3),
    [sym__dedent] = ACTIONS(1031),
    [sym__string_start] = ACTIONS(1031),
  },
  [401] = {
    [sym_identifier] = ACTIONS(928),
    [anon_sym_import] = ACTIONS(928),
    [anon_sym_from] = ACTIONS(928),
    [anon_sym_LPAREN] = ACTIONS(930),
    [anon_sym_print] = ACTIONS(928),
    [anon_sym_assert] = ACTIONS(928),
    [anon_sym_return] = ACTIONS(928),
    [anon_sym_del] = ACTIONS(928),
    [anon_sym_raise] = ACTIONS(928),
    [anon_sym_pass] = ACTIONS(928),
    [anon_sym_break] = ACTIONS(928),
    [anon_sym_continue] = ACTIONS(928),
    [anon_sym_if] = ACTIONS(928),
    [anon_sym_async] = ACTIONS(928),
    [anon_sym_for] = ACTIONS(928),
    [anon_sym_while] = ACTIONS(928),
    [anon_sym_try] = ACTIONS(928),
    [anon_sym_with] = ACTIONS(928),
    [anon_sym_def] = ACTIONS(928),
    [anon_sym_global] = ACTIONS(928),
    [anon_sym_nonlocal] = ACTIONS(928),
    [anon_sym_exec] = ACTIONS(928),
    [anon_sym_class] = ACTIONS(928),
    [anon_sym_AT] = ACTIONS(930),
    [anon_sym_not] = ACTIONS(928),
    [anon_sym_PLUS] = ACTIONS(930),
    [anon_sym_DASH] = ACTIONS(930),
    [anon_sym_TILDE] = ACTIONS(930),
    [anon_sym_lambda] = ACTIONS(928),
    [anon_sym_yield] = ACTIONS(928),
    [anon_sym_LBRACK] = ACTIONS(930),
    [sym_ellipsis] = ACTIONS(930),
    [anon_sym_LBRACE] = ACTIONS(930),
    [sym_integer] = ACTIONS(928),
    [sym_float] = ACTIONS(930),
    [sym_true] = ACTIONS(928),
    [sym_false] = ACTIONS(928),
    [sym_none] = ACTIONS(928),
    [anon_sym_await] = ACTIONS(928),
    [sym_comment] = ACTIONS(3),
    [sym__dedent] = ACTIONS(930),
    [sym__string_start] = ACTIONS(930),
  },
  [402] = {
    [sym_identifier] = ACTIONS(656),
    [anon_sym_import] = ACTIONS(656),
    [anon_sym_from] = ACTIONS(656),
    [anon_sym_LPAREN] = ACTIONS(654),
    [anon_sym_print] = ACTIONS(656),
    [anon_sym_assert] = ACTIONS(656),
    [anon_sym_return] = ACTIONS(656),
    [anon_sym_del] = ACTIONS(656),
    [anon_sym_raise] = ACTIONS(656),
    [anon_sym_pass] = ACTIONS(656),
    [anon_sym_break] = ACTIONS(656),
    [anon_sym_continue] = ACTIONS(656),
    [anon_sym_if] = ACTIONS(656),
    [anon_sym_async] = ACTIONS(656),
    [anon_sym_for] = ACTIONS(656),
    [anon_sym_while] = ACTIONS(656),
    [anon_sym_try] = ACTIONS(656),
    [anon_sym_with] = ACTIONS(656),
    [anon_sym_def] = ACTIONS(656),
    [anon_sym_global] = ACTIONS(656),
    [anon_sym_nonlocal] = ACTIONS(656),
    [anon_sym_exec] = ACTIONS(656),
    [anon_sym_class] = ACTIONS(656),
    [anon_sym_AT] = ACTIONS(654),
    [anon_sym_not] = ACTIONS(656),
    [anon_sym_PLUS] = ACTIONS(654),
    [anon_sym_DASH] = ACTIONS(654),
    [anon_sym_TILDE] = ACTIONS(654),
    [anon_sym_lambda] = ACTIONS(656),
    [anon_sym_yield] = ACTIONS(656),
    [anon_sym_LBRACK] = ACTIONS(654),
    [sym_ellipsis] = ACTIONS(654),
    [anon_sym_LBRACE] = ACTIONS(654),
    [sym_integer] = ACTIONS(656),
    [sym_float] = ACTIONS(654),
    [sym_true] = ACTIONS(656),
    [sym_false] = ACTIONS(656),
    [sym_none] = ACTIONS(656),
    [anon_sym_await] = ACTIONS(656),
    [sym_comment] = ACTIONS(3),
    [sym__dedent] = ACTIONS(654),
    [sym__string_start] = ACTIONS(654),
  },
  [403] = {
    [sym_identifier] = ACTIONS(1033),
    [anon_sym_import] = ACTIONS(1033),
    [anon_sym_from] = ACTIONS(1033),
    [anon_sym_LPAREN] = ACTIONS(1035),
    [anon_sym_print] = ACTIONS(1033),
    [anon_sym_assert] = ACTIONS(1033),
    [anon_sym_return] = ACTIONS(1033),
    [anon_sym_del] = ACTIONS(1033),
    [anon_sym_raise] = ACTIONS(1033),
    [anon_sym_pass] = ACTIONS(1033),
    [anon_sym_break] = ACTIONS(1033),
    [anon_sym_continue] = ACTIONS(1033),
    [anon_sym_if] = ACTIONS(1033),
    [anon_sym_async] = ACTIONS(1033),
    [anon_sym_for] = ACTIONS(1033),
    [anon_sym_while] = ACTIONS(1033),
    [anon_sym_try] = ACTIONS(1033),
    [anon_sym_with] = ACTIONS(1033),
    [anon_sym_def] = ACTIONS(1033),
    [anon_sym_global] = ACTIONS(1033),
    [anon_sym_nonlocal] = ACTIONS(1033),
    [anon_sym_exec] = ACTIONS(1033),
    [anon_sym_class] = ACTIONS(1033),
    [anon_sym_AT] = ACTIONS(1035),
    [anon_sym_not] = ACTIONS(1033),
    [anon_sym_PLUS] = ACTIONS(1035),
    [anon_sym_DASH] = ACTIONS(1035),
    [anon_sym_TILDE] = ACTIONS(1035),
    [anon_sym_lambda] = ACTIONS(1033),
    [anon_sym_yield] = ACTIONS(1033),
    [anon_sym_LBRACK] = ACTIONS(1035),
    [sym_ellipsis] = ACTIONS(1035),
    [anon_sym_LBRACE] = ACTIONS(1035),
    [sym_integer] = ACTIONS(1033),
    [sym_float] = ACTIONS(1035),
    [sym_true] = ACTIONS(1033),
    [sym_false] = ACTIONS(1033),
    [sym_none] = ACTIONS(1033),
    [anon_sym_await] = ACTIONS(1033),
    [sym_comment] = ACTIONS(3),
    [sym__dedent] = ACTIONS(1035),
    [sym__string_start] = ACTIONS(1035),
  },
  [404] = {
    [ts_builtin_sym_end] = ACTIONS(1037),
    [sym_identifier] = ACTIONS(1039),
    [anon_sym_import] = ACTIONS(1039),
    [anon_sym_from] = ACTIONS(1039),
    [anon_sym_LPAREN] = ACTIONS(1037),
    [anon_sym_print] = ACTIONS(1039),
    [anon_sym_assert] = ACTIONS(1039),
    [anon_sym_return] = ACTIONS(1039),
    [anon_sym_del] = ACTIONS(1039),
    [anon_sym_raise] = ACTIONS(1039),
    [anon_sym_pass] = ACTIONS(1039),
    [anon_sym_break] = ACTIONS(1039),
    [anon_sym_continue] = ACTIONS(1039),
    [anon_sym_if] = ACTIONS(1039),
    [anon_sym_async] = ACTIONS(1039),
    [anon_sym_for] = ACTIONS(1039),
    [anon_sym_while] = ACTIONS(1039),
    [anon_sym_try] = ACTIONS(1039),
    [anon_sym_with] = ACTIONS(1039),
    [anon_sym_def] = ACTIONS(1039),
    [anon_sym_global] = ACTIONS(1039),
    [anon_sym_nonlocal] = ACTIONS(1039),
    [anon_sym_exec] = ACTIONS(1039),
    [anon_sym_class] = ACTIONS(1039),
    [anon_sym_AT] = ACTIONS(1037),
    [anon_sym_not] = ACTIONS(1039),
    [anon_sym_PLUS] = ACTIONS(1037),
    [anon_sym_DASH] = ACTIONS(1037),
    [anon_sym_TILDE] = ACTIONS(1037),
    [anon_sym_lambda] = ACTIONS(1039),
    [anon_sym_yield] = ACTIONS(1039),
    [anon_sym_LBRACK] = ACTIONS(1037),
    [sym_ellipsis] = ACTIONS(1037),
    [anon_sym_LBRACE] = ACTIONS(1037),
    [sym_integer] = ACTIONS(1039),
    [sym_float] = ACTIONS(1037),
    [sym_true] = ACTIONS(1039),
    [sym_false] = ACTIONS(1039),
    [sym_none] = ACTIONS(1039),
    [anon_sym_await] = ACTIONS(1039),
    [sym_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(1037),
  },
  [405] = {
    [sym_identifier] = ACTIONS(1041),
    [anon_sym_import] = ACTIONS(1041),
    [anon_sym_from] = ACTIONS(1041),
    [anon_sym_LPAREN] = ACTIONS(1043),
    [anon_sym_print] = ACTIONS(1041),
    [anon_sym_assert] = ACTIONS(1041),
    [anon_sym_return] = ACTIONS(1041),
    [anon_sym_del] = ACTIONS(1041),
    [anon_sym_raise] = ACTIONS(1041),
    [anon_sym_pass] = ACTIONS(1041),
    [anon_sym_break] = ACTIONS(1041),
    [anon_sym_continue] = ACTIONS(1041),
    [anon_sym_if] = ACTIONS(1041),
    [anon_sym_async] = ACTIONS(1041),
    [anon_sym_for] = ACTIONS(1041),
    [anon_sym_while] = ACTIONS(1041),
    [anon_sym_try] = ACTIONS(1041),
    [anon_sym_with] = ACTIONS(1041),
    [anon_sym_def] = ACTIONS(1041),
    [anon_sym_global] = ACTIONS(1041),
    [anon_sym_nonlocal] = ACTIONS(1041),
    [anon_sym_exec] = ACTIONS(1041),
    [anon_sym_class] = ACTIONS(1041),
    [anon_sym_AT] = ACTIONS(1043),
    [anon_sym_not] = ACTIONS(1041),
    [anon_sym_PLUS] = ACTIONS(1043),
    [anon_sym_DASH] = ACTIONS(1043),
    [anon_sym_TILDE] = ACTIONS(1043),
    [anon_sym_lambda] = ACTIONS(1041),
    [anon_sym_yield] = ACTIONS(1041),
    [anon_sym_LBRACK] = ACTIONS(1043),
    [sym_ellipsis] = ACTIONS(1043),
    [anon_sym_LBRACE] = ACTIONS(1043),
    [sym_integer] = ACTIONS(1041),
    [sym_float] = ACTIONS(1043),
    [sym_true] = ACTIONS(1041),
    [sym_false] = ACTIONS(1041),
    [sym_none] = ACTIONS(1041),
    [anon_sym_await] = ACTIONS(1041),
    [sym_comment] = ACTIONS(3),
    [sym__dedent] = ACTIONS(1043),
    [sym__string_start] = ACTIONS(1043),
  },
  [406] = {
    [sym_identifier] = ACTIONS(1039),
    [anon_sym_import] = ACTIONS(1039),
    [anon_sym_from] = ACTIONS(1039),
    [anon_sym_LPAREN] = ACTIONS(1037),
    [anon_sym_print] = ACTIONS(1039),
    [anon_sym_assert] = ACTIONS(1039),
    [anon_sym_return] = ACTIONS(1039),
    [anon_sym_del] = ACTIONS(1039),
    [anon_sym_raise] = ACTIONS(1039),
    [anon_sym_pass] = ACTIONS(1039),
    [anon_sym_break] = ACTIONS(1039),
    [anon_sym_continue] = ACTIONS(1039),
    [anon_sym_if] = ACTIONS(1039),
    [anon_sym_async] = ACTIONS(1039),
    [anon_sym_for] = ACTIONS(1039),
    [anon_sym_while] = ACTIONS(1039),
    [anon_sym_try] = ACTIONS(1039),
    [anon_sym_with] = ACTIONS(1039),
    [anon_sym_def] = ACTIONS(1039),
    [anon_sym_global] = ACTIONS(1039),
    [anon_sym_nonlocal] = ACTIONS(1039),
    [anon_sym_exec] = ACTIONS(1039),
    [anon_sym_class] = ACTIONS(1039),
    [anon_sym_AT] = ACTIONS(1037),
    [anon_sym_not] = ACTIONS(1039),
    [anon_sym_PLUS] = ACTIONS(1037),
    [anon_sym_DASH] = ACTIONS(1037),
    [anon_sym_TILDE] = ACTIONS(1037),
    [anon_sym_lambda] = ACTIONS(1039),
    [anon_sym_yield] = ACTIONS(1039),
    [anon_sym_LBRACK] = ACTIONS(1037),
    [sym_ellipsis] = ACTIONS(1037),
    [anon_sym_LBRACE] = ACTIONS(1037),
    [sym_integer] = ACTIONS(1039),
    [sym_float] = ACTIONS(1037),
    [sym_true] = ACTIONS(1039),
    [sym_false] = ACTIONS(1039),
    [sym_none] = ACTIONS(1039),
    [anon_sym_await] = ACTIONS(1039),
    [sym_comment] = ACTIONS(3),
    [sym__dedent] = ACTIONS(1037),
    [sym__string_start] = ACTIONS(1037),
  },
  [407] = {
    [ts_builtin_sym_end] = ACTIONS(1043),
    [sym_identifier] = ACTIONS(1041),
    [anon_sym_import] = ACTIONS(1041),
    [anon_sym_from] = ACTIONS(1041),
    [anon_sym_LPAREN] = ACTIONS(1043),
    [anon_sym_print] = ACTIONS(1041),
    [anon_sym_assert] = ACTIONS(1041),
    [anon_sym_return] = ACTIONS(1041),
    [anon_sym_del] = ACTIONS(1041),
    [anon_sym_raise] = ACTIONS(1041),
    [anon_sym_pass] = ACTIONS(1041),
    [anon_sym_break] = ACTIONS(1041),
    [anon_sym_continue] = ACTIONS(1041),
    [anon_sym_if] = ACTIONS(1041),
    [anon_sym_async] = ACTIONS(1041),
    [anon_sym_for] = ACTIONS(1041),
    [anon_sym_while] = ACTIONS(1041),
    [anon_sym_try] = ACTIONS(1041),
    [anon_sym_with] = ACTIONS(1041),
    [anon_sym_def] = ACTIONS(1041),
    [anon_sym_global] = ACTIONS(1041),
    [anon_sym_nonlocal] = ACTIONS(1041),
    [anon_sym_exec] = ACTIONS(1041),
    [anon_sym_class] = ACTIONS(1041),
    [anon_sym_AT] = ACTIONS(1043),
    [anon_sym_not] = ACTIONS(1041),
    [anon_sym_PLUS] = ACTIONS(1043),
    [anon_sym_DASH] = ACTIONS(1043),
    [anon_sym_TILDE] = ACTIONS(1043),
    [anon_sym_lambda] = ACTIONS(1041),
    [anon_sym_yield] = ACTIONS(1041),
    [anon_sym_LBRACK] = ACTIONS(1043),
    [sym_ellipsis] = ACTIONS(1043),
    [anon_sym_LBRACE] = ACTIONS(1043),
    [sym_integer] = ACTIONS(1041),
    [sym_float] = ACTIONS(1043),
    [sym_true] = ACTIONS(1041),
    [sym_false] = ACTIONS(1041),
    [sym_none] = ACTIONS(1041),
    [anon_sym_await] = ACTIONS(1041),
    [sym_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(1043),
  },
  [408] = {
    [ts_builtin_sym_end] = ACTIONS(979),
    [sym_identifier] = ACTIONS(977),
    [anon_sym_import] = ACTIONS(977),
    [anon_sym_from] = ACTIONS(977),
    [anon_sym_LPAREN] = ACTIONS(979),
    [anon_sym_print] = ACTIONS(977),
    [anon_sym_assert] = ACTIONS(977),
    [anon_sym_return] = ACTIONS(977),
    [anon_sym_del] = ACTIONS(977),
    [anon_sym_raise] = ACTIONS(977),
    [anon_sym_pass] = ACTIONS(977),
    [anon_sym_break] = ACTIONS(977),
    [anon_sym_continue] = ACTIONS(977),
    [anon_sym_if] = ACTIONS(977),
    [anon_sym_async] = ACTIONS(977),
    [anon_sym_for] = ACTIONS(977),
    [anon_sym_while] = ACTIONS(977),
    [anon_sym_try] = ACTIONS(977),
    [anon_sym_with] = ACTIONS(977),
    [anon_sym_def] = ACTIONS(977),
    [anon_sym_global] = ACTIONS(977),
    [anon_sym_nonlocal] = ACTIONS(977),
    [anon_sym_exec] = ACTIONS(977),
    [anon_sym_class] = ACTIONS(977),
    [anon_sym_AT] = ACTIONS(979),
    [anon_sym_not] = ACTIONS(977),
    [anon_sym_PLUS] = ACTIONS(979),
    [anon_sym_DASH] = ACTIONS(979),
    [anon_sym_TILDE] = ACTIONS(979),
    [anon_sym_lambda] = ACTIONS(977),
    [anon_sym_yield] = ACTIONS(977),
    [anon_sym_LBRACK] = ACTIONS(979),
    [sym_ellipsis] = ACTIONS(979),
    [anon_sym_LBRACE] = ACTIONS(979),
    [sym_integer] = ACTIONS(977),
    [sym_float] = ACTIONS(979),
    [sym_true] = ACTIONS(977),
    [sym_false] = ACTIONS(977),
    [sym_none] = ACTIONS(977),
    [anon_sym_await] = ACTIONS(977),
    [sym_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(979),
  },
  [409] = {
    [ts_builtin_sym_end] = ACTIONS(544),
    [sym_identifier] = ACTIONS(546),
    [anon_sym_import] = ACTIONS(546),
    [anon_sym_from] = ACTIONS(546),
    [anon_sym_LPAREN] = ACTIONS(544),
    [anon_sym_print] = ACTIONS(546),
    [anon_sym_assert] = ACTIONS(546),
    [anon_sym_return] = ACTIONS(546),
    [anon_sym_del] = ACTIONS(546),
    [anon_sym_raise] = ACTIONS(546),
    [anon_sym_pass] = ACTIONS(546),
    [anon_sym_break] = ACTIONS(546),
    [anon_sym_continue] = ACTIONS(546),
    [anon_sym_if] = ACTIONS(546),
    [anon_sym_async] = ACTIONS(546),
    [anon_sym_for] = ACTIONS(546),
    [anon_sym_while] = ACTIONS(546),
    [anon_sym_try] = ACTIONS(546),
    [anon_sym_with] = ACTIONS(546),
    [anon_sym_def] = ACTIONS(546),
    [anon_sym_global] = ACTIONS(546),
    [anon_sym_nonlocal] = ACTIONS(546),
    [anon_sym_exec] = ACTIONS(546),
    [anon_sym_class] = ACTIONS(546),
    [anon_sym_AT] = ACTIONS(544),
    [anon_sym_not] = ACTIONS(546),
    [anon_sym_PLUS] = ACTIONS(544),
    [anon_sym_DASH] = ACTIONS(544),
    [anon_sym_TILDE] = ACTIONS(544),
    [anon_sym_lambda] = ACTIONS(546),
    [anon_sym_yield] = ACTIONS(546),
    [anon_sym_LBRACK] = ACTIONS(544),
    [sym_ellipsis] = ACTIONS(544),
    [anon_sym_LBRACE] = ACTIONS(544),
    [sym_integer] = ACTIONS(546),
    [sym_float] = ACTIONS(544),
    [sym_true] = ACTIONS(546),
    [sym_false] = ACTIONS(546),
    [sym_none] = ACTIONS(546),
    [anon_sym_await] = ACTIONS(546),
    [sym_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(544),
  },
  [410] = {
    [sym_argument_list] = STATE(474),
    [sym_generator_expression] = STATE(474),
    [anon_sym_DOT] = ACTIONS(947),
    [anon_sym_LPAREN] = ACTIONS(949),
    [anon_sym_RPAREN] = ACTIONS(502),
    [anon_sym_COMMA] = ACTIONS(502),
    [anon_sym_STAR] = ACTIONS(951),
    [anon_sym_GT_GT] = ACTIONS(953),
    [anon_sym_if] = ACTIONS(502),
    [anon_sym_COLON] = ACTIONS(502),
    [anon_sym_else] = ACTIONS(502),
    [anon_sym_async] = ACTIONS(502),
    [anon_sym_for] = ACTIONS(502),
    [anon_sym_in] = ACTIONS(502),
    [anon_sym_EQ] = ACTIONS(504),
    [anon_sym_STAR_STAR] = ACTIONS(957),
    [anon_sym_AT] = ACTIONS(959),
    [anon_sym_not] = ACTIONS(502),
    [anon_sym_and] = ACTIONS(502),
    [anon_sym_or] = ACTIONS(502),
    [anon_sym_PLUS] = ACTIONS(963),
    [anon_sym_DASH] = ACTIONS(963),
    [anon_sym_SLASH] = ACTIONS(951),
    [anon_sym_PERCENT] = ACTIONS(959),
    [anon_sym_SLASH_SLASH] = ACTIONS(959),
    [anon_sym_PIPE] = ACTIONS(965),
    [anon_sym_AMP] = ACTIONS(967),
    [anon_sym_CARET] = ACTIONS(969),
    [anon_sym_LT_LT] = ACTIONS(953),
    [anon_sym_LT] = ACTIONS(504),
    [anon_sym_LT_EQ] = ACTIONS(502),
    [anon_sym_EQ_EQ] = ACTIONS(502),
    [anon_sym_BANG_EQ] = ACTIONS(502),
    [anon_sym_GT_EQ] = ACTIONS(502),
    [anon_sym_GT] = ACTIONS(504),
    [anon_sym_LT_GT] = ACTIONS(502),
    [anon_sym_is] = ACTIONS(502),
    [anon_sym_LBRACK] = ACTIONS(975),
    [anon_sym_RBRACK] = ACTIONS(502),
    [anon_sym_RBRACE] = ACTIONS(502),
    [sym_type_conversion] = ACTIONS(502),
    [sym_comment] = ACTIONS(3),
  },
  [411] = {
    [sym_identifier] = ACTIONS(1045),
    [anon_sym_import] = ACTIONS(1045),
    [anon_sym_from] = ACTIONS(1045),
    [anon_sym_LPAREN] = ACTIONS(1047),
    [anon_sym_print] = ACTIONS(1045),
    [anon_sym_assert] = ACTIONS(1045),
    [anon_sym_return] = ACTIONS(1045),
    [anon_sym_del] = ACTIONS(1045),
    [anon_sym_raise] = ACTIONS(1045),
    [anon_sym_pass] = ACTIONS(1045),
    [anon_sym_break] = ACTIONS(1045),
    [anon_sym_continue] = ACTIONS(1045),
    [anon_sym_if] = ACTIONS(1045),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_for] = ACTIONS(1045),
    [anon_sym_while] = ACTIONS(1045),
    [anon_sym_try] = ACTIONS(1045),
    [anon_sym_with] = ACTIONS(1045),
    [anon_sym_def] = ACTIONS(1045),
    [anon_sym_global] = ACTIONS(1045),
    [anon_sym_nonlocal] = ACTIONS(1045),
    [anon_sym_exec] = ACTIONS(1045),
    [anon_sym_class] = ACTIONS(1045),
    [anon_sym_AT] = ACTIONS(1047),
    [anon_sym_not] = ACTIONS(1045),
    [anon_sym_PLUS] = ACTIONS(1047),
    [anon_sym_DASH] = ACTIONS(1047),
    [anon_sym_TILDE] = ACTIONS(1047),
    [anon_sym_lambda] = ACTIONS(1045),
    [anon_sym_yield] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1047),
    [sym_ellipsis] = ACTIONS(1047),
    [anon_sym_LBRACE] = ACTIONS(1047),
    [sym_integer] = ACTIONS(1045),
    [sym_float] = ACTIONS(1047),
    [sym_true] = ACTIONS(1045),
    [sym_false] = ACTIONS(1045),
    [sym_none] = ACTIONS(1045),
    [anon_sym_await] = ACTIONS(1045),
    [sym_comment] = ACTIONS(3),
    [sym__dedent] = ACTIONS(1047),
    [sym__string_start] = ACTIONS(1047),
  },
  [412] = {
    [ts_builtin_sym_end] = ACTIONS(1035),
    [sym_identifier] = ACTIONS(1033),
    [anon_sym_import] = ACTIONS(1033),
    [anon_sym_from] = ACTIONS(1033),
    [anon_sym_LPAREN] = ACTIONS(1035),
    [anon_sym_print] = ACTIONS(1033),
    [anon_sym_assert] = ACTIONS(1033),
    [anon_sym_return] = ACTIONS(1033),
    [anon_sym_del] = ACTIONS(1033),
    [anon_sym_raise] = ACTIONS(1033),
    [anon_sym_pass] = ACTIONS(1033),
    [anon_sym_break] = ACTIONS(1033),
    [anon_sym_continue] = ACTIONS(1033),
    [anon_sym_if] = ACTIONS(1033),
    [anon_sym_async] = ACTIONS(1033),
    [anon_sym_for] = ACTIONS(1033),
    [anon_sym_while] = ACTIONS(1033),
    [anon_sym_try] = ACTIONS(1033),
    [anon_sym_with] = ACTIONS(1033),
    [anon_sym_def] = ACTIONS(1033),
    [anon_sym_global] = ACTIONS(1033),
    [anon_sym_nonlocal] = ACTIONS(1033),
    [anon_sym_exec] = ACTIONS(1033),
    [anon_sym_class] = ACTIONS(1033),
    [anon_sym_AT] = ACTIONS(1035),
    [anon_sym_not] = ACTIONS(1033),
    [anon_sym_PLUS] = ACTIONS(1035),
    [anon_sym_DASH] = ACTIONS(1035),
    [anon_sym_TILDE] = ACTIONS(1035),
    [anon_sym_lambda] = ACTIONS(1033),
    [anon_sym_yield] = ACTIONS(1033),
    [anon_sym_LBRACK] = ACTIONS(1035),
    [sym_ellipsis] = ACTIONS(1035),
    [anon_sym_LBRACE] = ACTIONS(1035),
    [sym_integer] = ACTIONS(1033),
    [sym_float] = ACTIONS(1035),
    [sym_true] = ACTIONS(1033),
    [sym_false] = ACTIONS(1033),
    [sym_none] = ACTIONS(1033),
    [anon_sym_await] = ACTIONS(1033),
    [sym_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(1035),
  },
  [413] = {
    [ts_builtin_sym_end] = ACTIONS(654),
    [sym_identifier] = ACTIONS(656),
    [anon_sym_import] = ACTIONS(656),
    [anon_sym_from] = ACTIONS(656),
    [anon_sym_LPAREN] = ACTIONS(654),
    [anon_sym_print] = ACTIONS(656),
    [anon_sym_assert] = ACTIONS(656),
    [anon_sym_return] = ACTIONS(656),
    [anon_sym_del] = ACTIONS(656),
    [anon_sym_raise] = ACTIONS(656),
    [anon_sym_pass] = ACTIONS(656),
    [anon_sym_break] = ACTIONS(656),
    [anon_sym_continue] = ACTIONS(656),
    [anon_sym_if] = ACTIONS(656),
    [anon_sym_async] = ACTIONS(656),
    [anon_sym_for] = ACTIONS(656),
    [anon_sym_while] = ACTIONS(656),
    [anon_sym_try] = ACTIONS(656),
    [anon_sym_with] = ACTIONS(656),
    [anon_sym_def] = ACTIONS(656),
    [anon_sym_global] = ACTIONS(656),
    [anon_sym_nonlocal] = ACTIONS(656),
    [anon_sym_exec] = ACTIONS(656),
    [anon_sym_class] = ACTIONS(656),
    [anon_sym_AT] = ACTIONS(654),
    [anon_sym_not] = ACTIONS(656),
    [anon_sym_PLUS] = ACTIONS(654),
    [anon_sym_DASH] = ACTIONS(654),
    [anon_sym_TILDE] = ACTIONS(654),
    [anon_sym_lambda] = ACTIONS(656),
    [anon_sym_yield] = ACTIONS(656),
    [anon_sym_LBRACK] = ACTIONS(654),
    [sym_ellipsis] = ACTIONS(654),
    [anon_sym_LBRACE] = ACTIONS(654),
    [sym_integer] = ACTIONS(656),
    [sym_float] = ACTIONS(654),
    [sym_true] = ACTIONS(656),
    [sym_false] = ACTIONS(656),
    [sym_none] = ACTIONS(656),
    [anon_sym_await] = ACTIONS(656),
    [sym_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(654),
  },
  [414] = {
    [ts_builtin_sym_end] = ACTIONS(1047),
    [sym_identifier] = ACTIONS(1045),
    [anon_sym_import] = ACTIONS(1045),
    [anon_sym_from] = ACTIONS(1045),
    [anon_sym_LPAREN] = ACTIONS(1047),
    [anon_sym_print] = ACTIONS(1045),
    [anon_sym_assert] = ACTIONS(1045),
    [anon_sym_return] = ACTIONS(1045),
    [anon_sym_del] = ACTIONS(1045),
    [anon_sym_raise] = ACTIONS(1045),
    [anon_sym_pass] = ACTIONS(1045),
    [anon_sym_break] = ACTIONS(1045),
    [anon_sym_continue] = ACTIONS(1045),
    [anon_sym_if] = ACTIONS(1045),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_for] = ACTIONS(1045),
    [anon_sym_while] = ACTIONS(1045),
    [anon_sym_try] = ACTIONS(1045),
    [anon_sym_with] = ACTIONS(1045),
    [anon_sym_def] = ACTIONS(1045),
    [anon_sym_global] = ACTIONS(1045),
    [anon_sym_nonlocal] = ACTIONS(1045),
    [anon_sym_exec] = ACTIONS(1045),
    [anon_sym_class] = ACTIONS(1045),
    [anon_sym_AT] = ACTIONS(1047),
    [anon_sym_not] = ACTIONS(1045),
    [anon_sym_PLUS] = ACTIONS(1047),
    [anon_sym_DASH] = ACTIONS(1047),
    [anon_sym_TILDE] = ACTIONS(1047),
    [anon_sym_lambda] = ACTIONS(1045),
    [anon_sym_yield] = ACTIONS(1045),
    [anon_sym_LBRACK] = ACTIONS(1047),
    [sym_ellipsis] = ACTIONS(1047),
    [anon_sym_LBRACE] = ACTIONS(1047),
    [sym_integer] = ACTIONS(1045),
    [sym_float] = ACTIONS(1047),
    [sym_true] = ACTIONS(1045),
    [sym_false] = ACTIONS(1045),
    [sym_none] = ACTIONS(1045),
    [anon_sym_await] = ACTIONS(1045),
    [sym_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(1047),
  },
  [415] = {
    [sym_identifier] = ACTIONS(546),
    [anon_sym_import] = ACTIONS(546),
    [anon_sym_from] = ACTIONS(546),
    [anon_sym_LPAREN] = ACTIONS(544),
    [anon_sym_print] = ACTIONS(546),
    [anon_sym_assert] = ACTIONS(546),
    [anon_sym_return] = ACTIONS(546),
    [anon_sym_del] = ACTIONS(546),
    [anon_sym_raise] = ACTIONS(546),
    [anon_sym_pass] = ACTIONS(546),
    [anon_sym_break] = ACTIONS(546),
    [anon_sym_continue] = ACTIONS(546),
    [anon_sym_if] = ACTIONS(546),
    [anon_sym_async] = ACTIONS(546),
    [anon_sym_for] = ACTIONS(546),
    [anon_sym_while] = ACTIONS(546),
    [anon_sym_try] = ACTIONS(546),
    [anon_sym_with] = ACTIONS(546),
    [anon_sym_def] = ACTIONS(546),
    [anon_sym_global] = ACTIONS(546),
    [anon_sym_nonlocal] = ACTIONS(546),
    [anon_sym_exec] = ACTIONS(546),
    [anon_sym_class] = ACTIONS(546),
    [anon_sym_AT] = ACTIONS(544),
    [anon_sym_not] = ACTIONS(546),
    [anon_sym_PLUS] = ACTIONS(544),
    [anon_sym_DASH] = ACTIONS(544),
    [anon_sym_TILDE] = ACTIONS(544),
    [anon_sym_lambda] = ACTIONS(546),
    [anon_sym_yield] = ACTIONS(546),
    [anon_sym_LBRACK] = ACTIONS(544),
    [sym_ellipsis] = ACTIONS(544),
    [anon_sym_LBRACE] = ACTIONS(544),
    [sym_integer] = ACTIONS(546),
    [sym_float] = ACTIONS(544),
    [sym_true] = ACTIONS(546),
    [sym_false] = ACTIONS(546),
    [sym_none] = ACTIONS(546),
    [anon_sym_await] = ACTIONS(546),
    [sym_comment] = ACTIONS(3),
    [sym__dedent] = ACTIONS(544),
    [sym__string_start] = ACTIONS(544),
  },
  [416] = {
    [sym_identifier] = ACTIONS(1049),
    [anon_sym_import] = ACTIONS(1049),
    [anon_sym_from] = ACTIONS(1049),
    [anon_sym_LPAREN] = ACTIONS(1051),
    [anon_sym_print] = ACTIONS(1049),
    [anon_sym_assert] = ACTIONS(1049),
    [anon_sym_return] = ACTIONS(1049),
    [anon_sym_del] = ACTIONS(1049),
    [anon_sym_raise] = ACTIONS(1049),
    [anon_sym_pass] = ACTIONS(1049),
    [anon_sym_break] = ACTIONS(1049),
    [anon_sym_continue] = ACTIONS(1049),
    [anon_sym_if] = ACTIONS(1049),
    [anon_sym_async] = ACTIONS(1049),
    [anon_sym_for] = ACTIONS(1049),
    [anon_sym_while] = ACTIONS(1049),
    [anon_sym_try] = ACTIONS(1049),
    [anon_sym_with] = ACTIONS(1049),
    [anon_sym_def] = ACTIONS(1049),
    [anon_sym_global] = ACTIONS(1049),
    [anon_sym_nonlocal] = ACTIONS(1049),
    [anon_sym_exec] = ACTIONS(1049),
    [anon_sym_class] = ACTIONS(1049),
    [anon_sym_AT] = ACTIONS(1051),
    [anon_sym_not] = ACTIONS(1049),
    [anon_sym_PLUS] = ACTIONS(1051),
    [anon_sym_DASH] = ACTIONS(1051),
    [anon_sym_TILDE] = ACTIONS(1051),
    [anon_sym_lambda] = ACTIONS(1049),
    [anon_sym_yield] = ACTIONS(1049),
    [anon_sym_LBRACK] = ACTIONS(1051),
    [sym_ellipsis] = ACTIONS(1051),
    [anon_sym_LBRACE] = ACTIONS(1051),
    [sym_integer] = ACTIONS(1049),
    [sym_float] = ACTIONS(1051),
    [sym_true] = ACTIONS(1049),
    [sym_false] = ACTIONS(1049),
    [sym_none] = ACTIONS(1049),
    [anon_sym_await] = ACTIONS(1049),
    [sym_comment] = ACTIONS(3),
    [sym__dedent] = ACTIONS(1051),
    [sym__string_start] = ACTIONS(1051),
  },
  [417] = {
    [sym_identifier] = ACTIONS(1053),
    [anon_sym_import] = ACTIONS(1053),
    [anon_sym_from] = ACTIONS(1053),
    [anon_sym_LPAREN] = ACTIONS(1055),
    [anon_sym_print] = ACTIONS(1053),
    [anon_sym_assert] = ACTIONS(1053),
    [anon_sym_return] = ACTIONS(1053),
    [anon_sym_del] = ACTIONS(1053),
    [anon_sym_raise] = ACTIONS(1053),
    [anon_sym_pass] = ACTIONS(1053),
    [anon_sym_break] = ACTIONS(1053),
    [anon_sym_continue] = ACTIONS(1053),
    [anon_sym_if] = ACTIONS(1053),
    [anon_sym_async] = ACTIONS(1053),
    [anon_sym_for] = ACTIONS(1053),
    [anon_sym_while] = ACTIONS(1053),
    [anon_sym_try] = ACTIONS(1053),
    [anon_sym_with] = ACTIONS(1053),
    [anon_sym_def] = ACTIONS(1053),
    [anon_sym_global] = ACTIONS(1053),
    [anon_sym_nonlocal] = ACTIONS(1053),
    [anon_sym_exec] = ACTIONS(1053),
    [anon_sym_class] = ACTIONS(1053),
    [anon_sym_AT] = ACTIONS(1055),
    [anon_sym_not] = ACTIONS(1053),
    [anon_sym_PLUS] = ACTIONS(1055),
    [anon_sym_DASH] = ACTIONS(1055),
    [anon_sym_TILDE] = ACTIONS(1055),
    [anon_sym_lambda] = ACTIONS(1053),
    [anon_sym_yield] = ACTIONS(1053),
    [anon_sym_LBRACK] = ACTIONS(1055),
    [sym_ellipsis] = ACTIONS(1055),
    [anon_sym_LBRACE] = ACTIONS(1055),
    [sym_integer] = ACTIONS(1053),
    [sym_float] = ACTIONS(1055),
    [sym_true] = ACTIONS(1053),
    [sym_false] = ACTIONS(1053),
    [sym_none] = ACTIONS(1053),
    [anon_sym_await] = ACTIONS(1053),
    [sym_comment] = ACTIONS(3),
    [sym__dedent] = ACTIONS(1055),
    [sym__string_start] = ACTIONS(1055),
  },
  [418] = {
    [sym_identifier] = ACTIONS(1057),
    [anon_sym_import] = ACTIONS(1057),
    [anon_sym_from] = ACTIONS(1057),
    [anon_sym_LPAREN] = ACTIONS(1059),
    [anon_sym_print] = ACTIONS(1057),
    [anon_sym_assert] = ACTIONS(1057),
    [anon_sym_return] = ACTIONS(1057),
    [anon_sym_del] = ACTIONS(1057),
    [anon_sym_raise] = ACTIONS(1057),
    [anon_sym_pass] = ACTIONS(1057),
    [anon_sym_break] = ACTIONS(1057),
    [anon_sym_continue] = ACTIONS(1057),
    [anon_sym_if] = ACTIONS(1057),
    [anon_sym_async] = ACTIONS(1057),
    [anon_sym_for] = ACTIONS(1057),
    [anon_sym_while] = ACTIONS(1057),
    [anon_sym_try] = ACTIONS(1057),
    [anon_sym_with] = ACTIONS(1057),
    [anon_sym_def] = ACTIONS(1057),
    [anon_sym_global] = ACTIONS(1057),
    [anon_sym_nonlocal] = ACTIONS(1057),
    [anon_sym_exec] = ACTIONS(1057),
    [anon_sym_class] = ACTIONS(1057),
    [anon_sym_AT] = ACTIONS(1059),
    [anon_sym_not] = ACTIONS(1057),
    [anon_sym_PLUS] = ACTIONS(1059),
    [anon_sym_DASH] = ACTIONS(1059),
    [anon_sym_TILDE] = ACTIONS(1059),
    [anon_sym_lambda] = ACTIONS(1057),
    [anon_sym_yield] = ACTIONS(1057),
    [anon_sym_LBRACK] = ACTIONS(1059),
    [sym_ellipsis] = ACTIONS(1059),
    [anon_sym_LBRACE] = ACTIONS(1059),
    [sym_integer] = ACTIONS(1057),
    [sym_float] = ACTIONS(1059),
    [sym_true] = ACTIONS(1057),
    [sym_false] = ACTIONS(1057),
    [sym_none] = ACTIONS(1057),
    [anon_sym_await] = ACTIONS(1057),
    [sym_comment] = ACTIONS(3),
    [sym__dedent] = ACTIONS(1059),
    [sym__string_start] = ACTIONS(1059),
  },
  [419] = {
    [sym_identifier] = ACTIONS(1061),
    [anon_sym_import] = ACTIONS(1061),
    [anon_sym_from] = ACTIONS(1061),
    [anon_sym_LPAREN] = ACTIONS(1063),
    [anon_sym_print] = ACTIONS(1061),
    [anon_sym_assert] = ACTIONS(1061),
    [anon_sym_return] = ACTIONS(1061),
    [anon_sym_del] = ACTIONS(1061),
    [anon_sym_raise] = ACTIONS(1061),
    [anon_sym_pass] = ACTIONS(1061),
    [anon_sym_break] = ACTIONS(1061),
    [anon_sym_continue] = ACTIONS(1061),
    [anon_sym_if] = ACTIONS(1061),
    [anon_sym_async] = ACTIONS(1061),
    [anon_sym_for] = ACTIONS(1061),
    [anon_sym_while] = ACTIONS(1061),
    [anon_sym_try] = ACTIONS(1061),
    [anon_sym_with] = ACTIONS(1061),
    [anon_sym_def] = ACTIONS(1061),
    [anon_sym_global] = ACTIONS(1061),
    [anon_sym_nonlocal] = ACTIONS(1061),
    [anon_sym_exec] = ACTIONS(1061),
    [anon_sym_class] = ACTIONS(1061),
    [anon_sym_AT] = ACTIONS(1063),
    [anon_sym_not] = ACTIONS(1061),
    [anon_sym_PLUS] = ACTIONS(1063),
    [anon_sym_DASH] = ACTIONS(1063),
    [anon_sym_TILDE] = ACTIONS(1063),
    [anon_sym_lambda] = ACTIONS(1061),
    [anon_sym_yield] = ACTIONS(1061),
    [anon_sym_LBRACK] = ACTIONS(1063),
    [sym_ellipsis] = ACTIONS(1063),
    [anon_sym_LBRACE] = ACTIONS(1063),
    [sym_integer] = ACTIONS(1061),
    [sym_float] = ACTIONS(1063),
    [sym_true] = ACTIONS(1061),
    [sym_false] = ACTIONS(1061),
    [sym_none] = ACTIONS(1061),
    [anon_sym_await] = ACTIONS(1061),
    [sym_comment] = ACTIONS(3),
    [sym__dedent] = ACTIONS(1063),
    [sym__string_start] = ACTIONS(1063),
  },
  [420] = {
    [ts_builtin_sym_end] = ACTIONS(930),
    [sym_identifier] = ACTIONS(928),
    [anon_sym_import] = ACTIONS(928),
    [anon_sym_from] = ACTIONS(928),
    [anon_sym_LPAREN] = ACTIONS(930),
    [anon_sym_print] = ACTIONS(928),
    [anon_sym_assert] = ACTIONS(928),
    [anon_sym_return] = ACTIONS(928),
    [anon_sym_del] = ACTIONS(928),
    [anon_sym_raise] = ACTIONS(928),
    [anon_sym_pass] = ACTIONS(928),
    [anon_sym_break] = ACTIONS(928),
    [anon_sym_continue] = ACTIONS(928),
    [anon_sym_if] = ACTIONS(928),
    [anon_sym_async] = ACTIONS(928),
    [anon_sym_for] = ACTIONS(928),
    [anon_sym_while] = ACTIONS(928),
    [anon_sym_try] = ACTIONS(928),
    [anon_sym_with] = ACTIONS(928),
    [anon_sym_def] = ACTIONS(928),
    [anon_sym_global] = ACTIONS(928),
    [anon_sym_nonlocal] = ACTIONS(928),
    [anon_sym_exec] = ACTIONS(928),
    [anon_sym_class] = ACTIONS(928),
    [anon_sym_AT] = ACTIONS(930),
    [anon_sym_not] = ACTIONS(928),
    [anon_sym_PLUS] = ACTIONS(930),
    [anon_sym_DASH] = ACTIONS(930),
    [anon_sym_TILDE] = ACTIONS(930),
    [anon_sym_lambda] = ACTIONS(928),
    [anon_sym_yield] = ACTIONS(928),
    [anon_sym_LBRACK] = ACTIONS(930),
    [sym_ellipsis] = ACTIONS(930),
    [anon_sym_LBRACE] = ACTIONS(930),
    [sym_integer] = ACTIONS(928),
    [sym_float] = ACTIONS(930),
    [sym_true] = ACTIONS(928),
    [sym_false] = ACTIONS(928),
    [sym_none] = ACTIONS(928),
    [anon_sym_await] = ACTIONS(928),
    [sym_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(930),
  },
  [421] = {
    [sym_argument_list] = STATE(474),
    [sym_generator_expression] = STATE(474),
    [anon_sym_DOT] = ACTIONS(494),
    [anon_sym_LPAREN] = ACTIONS(949),
    [anon_sym_RPAREN] = ACTIONS(494),
    [anon_sym_COMMA] = ACTIONS(494),
    [anon_sym_STAR] = ACTIONS(951),
    [anon_sym_GT_GT] = ACTIONS(953),
    [anon_sym_if] = ACTIONS(494),
    [anon_sym_COLON] = ACTIONS(494),
    [anon_sym_else] = ACTIONS(494),
    [anon_sym_async] = ACTIONS(494),
    [anon_sym_for] = ACTIONS(494),
    [anon_sym_in] = ACTIONS(494),
    [anon_sym_EQ] = ACTIONS(496),
    [anon_sym_STAR_STAR] = ACTIONS(957),
    [anon_sym_AT] = ACTIONS(959),
    [anon_sym_not] = ACTIONS(494),
    [anon_sym_and] = ACTIONS(494),
    [anon_sym_or] = ACTIONS(494),
    [anon_sym_PLUS] = ACTIONS(963),
    [anon_sym_DASH] = ACTIONS(963),
    [anon_sym_SLASH] = ACTIONS(951),
    [anon_sym_PERCENT] = ACTIONS(959),
    [anon_sym_SLASH_SLASH] = ACTIONS(959),
    [anon_sym_PIPE] = ACTIONS(494),
    [anon_sym_AMP] = ACTIONS(494),
    [anon_sym_CARET] = ACTIONS(494),
    [anon_sym_LT_LT] = ACTIONS(953),
    [anon_sym_LT] = ACTIONS(496),
    [anon_sym_LT_EQ] = ACTIONS(494),
    [anon_sym_EQ_EQ] = ACTIONS(494),
    [anon_sym_BANG_EQ] = ACTIONS(494),
    [anon_sym_GT_EQ] = ACTIONS(494),
    [anon_sym_GT] = ACTIONS(496),
    [anon_sym_LT_GT] = ACTIONS(494),
    [anon_sym_is] = ACTIONS(494),
    [anon_sym_LBRACK] = ACTIONS(494),
    [anon_sym_RBRACK] = ACTIONS(494),
    [anon_sym_RBRACE] = ACTIONS(494),
    [sym_type_conversion] = ACTIONS(494),
    [sym_comment] = ACTIONS(3),
  },
  [422] = {
    [ts_builtin_sym_end] = ACTIONS(1031),
    [sym_identifier] = ACTIONS(1029),
    [anon_sym_import] = ACTIONS(1029),
    [anon_sym_from] = ACTIONS(1029),
    [anon_sym_LPAREN] = ACTIONS(1031),
    [anon_sym_print] = ACTIONS(1029),
    [anon_sym_assert] = ACTIONS(1029),
    [anon_sym_return] = ACTIONS(1029),
    [anon_sym_del] = ACTIONS(1029),
    [anon_sym_raise] = ACTIONS(1029),
    [anon_sym_pass] = ACTIONS(1029),
    [anon_sym_break] = ACTIONS(1029),
    [anon_sym_continue] = ACTIONS(1029),
    [anon_sym_if] = ACTIONS(1029),
    [anon_sym_async] = ACTIONS(1029),
    [anon_sym_for] = ACTIONS(1029),
    [anon_sym_while] = ACTIONS(1029),
    [anon_sym_try] = ACTIONS(1029),
    [anon_sym_with] = ACTIONS(1029),
    [anon_sym_def] = ACTIONS(1029),
    [anon_sym_global] = ACTIONS(1029),
    [anon_sym_nonlocal] = ACTIONS(1029),
    [anon_sym_exec] = ACTIONS(1029),
    [anon_sym_class] = ACTIONS(1029),
    [anon_sym_AT] = ACTIONS(1031),
    [anon_sym_not] = ACTIONS(1029),
    [anon_sym_PLUS] = ACTIONS(1031),
    [anon_sym_DASH] = ACTIONS(1031),
    [anon_sym_TILDE] = ACTIONS(1031),
    [anon_sym_lambda] = ACTIONS(1029),
    [anon_sym_yield] = ACTIONS(1029),
    [anon_sym_LBRACK] = ACTIONS(1031),
    [sym_ellipsis] = ACTIONS(1031),
    [anon_sym_LBRACE] = ACTIONS(1031),
    [sym_integer] = ACTIONS(1029),
    [sym_float] = ACTIONS(1031),
    [sym_true] = ACTIONS(1029),
    [sym_false] = ACTIONS(1029),
    [sym_none] = ACTIONS(1029),
    [anon_sym_await] = ACTIONS(1029),
    [sym_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(1031),
  },
  [423] = {
    [sym_argument_list] = STATE(474),
    [sym_generator_expression] = STATE(474),
    [anon_sym_DOT] = ACTIONS(494),
    [anon_sym_LPAREN] = ACTIONS(949),
    [anon_sym_RPAREN] = ACTIONS(494),
    [anon_sym_COMMA] = ACTIONS(494),
    [anon_sym_STAR] = ACTIONS(951),
    [anon_sym_GT_GT] = ACTIONS(953),
    [anon_sym_if] = ACTIONS(494),
    [anon_sym_COLON] = ACTIONS(494),
    [anon_sym_else] = ACTIONS(494),
    [anon_sym_async] = ACTIONS(494),
    [anon_sym_for] = ACTIONS(494),
    [anon_sym_in] = ACTIONS(494),
    [anon_sym_EQ] = ACTIONS(496),
    [anon_sym_STAR_STAR] = ACTIONS(957),
    [anon_sym_AT] = ACTIONS(959),
    [anon_sym_not] = ACTIONS(494),
    [anon_sym_and] = ACTIONS(494),
    [anon_sym_or] = ACTIONS(494),
    [anon_sym_PLUS] = ACTIONS(963),
    [anon_sym_DASH] = ACTIONS(963),
    [anon_sym_SLASH] = ACTIONS(951),
    [anon_sym_PERCENT] = ACTIONS(959),
    [anon_sym_SLASH_SLASH] = ACTIONS(959),
    [anon_sym_PIPE] = ACTIONS(494),
    [anon_sym_AMP] = ACTIONS(494),
    [anon_sym_CARET] = ACTIONS(969),
    [anon_sym_LT_LT] = ACTIONS(953),
    [anon_sym_LT] = ACTIONS(496),
    [anon_sym_LT_EQ] = ACTIONS(494),
    [anon_sym_EQ_EQ] = ACTIONS(494),
    [anon_sym_BANG_EQ] = ACTIONS(494),
    [anon_sym_GT_EQ] = ACTIONS(494),
    [anon_sym_GT] = ACTIONS(496),
    [anon_sym_LT_GT] = ACTIONS(494),
    [anon_sym_is] = ACTIONS(494),
    [anon_sym_LBRACK] = ACTIONS(494),
    [anon_sym_RBRACK] = ACTIONS(494),
    [anon_sym_RBRACE] = ACTIONS(494),
    [sym_type_conversion] = ACTIONS(494),
    [sym_comment] = ACTIONS(3),
  },
  [424] = {
    [sym_argument_list] = STATE(474),
    [sym_generator_expression] = STATE(474),
    [anon_sym_DOT] = ACTIONS(494),
    [anon_sym_LPAREN] = ACTIONS(949),
    [anon_sym_RPAREN] = ACTIONS(494),
    [anon_sym_COMMA] = ACTIONS(494),
    [anon_sym_STAR] = ACTIONS(951),
    [anon_sym_GT_GT] = ACTIONS(953),
    [anon_sym_if] = ACTIONS(494),
    [anon_sym_COLON] = ACTIONS(494),
    [anon_sym_else] = ACTIONS(494),
    [anon_sym_async] = ACTIONS(494),
    [anon_sym_for] = ACTIONS(494),
    [anon_sym_in] = ACTIONS(494),
    [anon_sym_EQ] = ACTIONS(496),
    [anon_sym_STAR_STAR] = ACTIONS(957),
    [anon_sym_AT] = ACTIONS(959),
    [anon_sym_not] = ACTIONS(494),
    [anon_sym_and] = ACTIONS(494),
    [anon_sym_or] = ACTIONS(494),
    [anon_sym_PLUS] = ACTIONS(963),
    [anon_sym_DASH] = ACTIONS(963),
    [anon_sym_SLASH] = ACTIONS(951),
    [anon_sym_PERCENT] = ACTIONS(959),
    [anon_sym_SLASH_SLASH] = ACTIONS(959),
    [anon_sym_PIPE] = ACTIONS(494),
    [anon_sym_AMP] = ACTIONS(967),
    [anon_sym_CARET] = ACTIONS(969),
    [anon_sym_LT_LT] = ACTIONS(953),
    [anon_sym_LT] = ACTIONS(496),
    [anon_sym_LT_EQ] = ACTIONS(494),
    [anon_sym_EQ_EQ] = ACTIONS(494),
    [anon_sym_BANG_EQ] = ACTIONS(494),
    [anon_sym_GT_EQ] = ACTIONS(494),
    [anon_sym_GT] = ACTIONS(496),
    [anon_sym_LT_GT] = ACTIONS(494),
    [anon_sym_is] = ACTIONS(494),
    [anon_sym_LBRACK] = ACTIONS(494),
    [anon_sym_RBRACK] = ACTIONS(494),
    [anon_sym_RBRACE] = ACTIONS(494),
    [sym_type_conversion] = ACTIONS(494),
    [sym_comment] = ACTIONS(3),
  },
  [425] = {
    [ts_builtin_sym_end] = ACTIONS(1027),
    [sym_identifier] = ACTIONS(1025),
    [anon_sym_import] = ACTIONS(1025),
    [anon_sym_from] = ACTIONS(1025),
    [anon_sym_LPAREN] = ACTIONS(1027),
    [anon_sym_print] = ACTIONS(1025),
    [anon_sym_assert] = ACTIONS(1025),
    [anon_sym_return] = ACTIONS(1025),
    [anon_sym_del] = ACTIONS(1025),
    [anon_sym_raise] = ACTIONS(1025),
    [anon_sym_pass] = ACTIONS(1025),
    [anon_sym_break] = ACTIONS(1025),
    [anon_sym_continue] = ACTIONS(1025),
    [anon_sym_if] = ACTIONS(1025),
    [anon_sym_async] = ACTIONS(1025),
    [anon_sym_for] = ACTIONS(1025),
    [anon_sym_while] = ACTIONS(1025),
    [anon_sym_try] = ACTIONS(1025),
    [anon_sym_with] = ACTIONS(1025),
    [anon_sym_def] = ACTIONS(1025),
    [anon_sym_global] = ACTIONS(1025),
    [anon_sym_nonlocal] = ACTIONS(1025),
    [anon_sym_exec] = ACTIONS(1025),
    [anon_sym_class] = ACTIONS(1025),
    [anon_sym_AT] = ACTIONS(1027),
    [anon_sym_not] = ACTIONS(1025),
    [anon_sym_PLUS] = ACTIONS(1027),
    [anon_sym_DASH] = ACTIONS(1027),
    [anon_sym_TILDE] = ACTIONS(1027),
    [anon_sym_lambda] = ACTIONS(1025),
    [anon_sym_yield] = ACTIONS(1025),
    [anon_sym_LBRACK] = ACTIONS(1027),
    [sym_ellipsis] = ACTIONS(1027),
    [anon_sym_LBRACE] = ACTIONS(1027),
    [sym_integer] = ACTIONS(1025),
    [sym_float] = ACTIONS(1027),
    [sym_true] = ACTIONS(1025),
    [sym_false] = ACTIONS(1025),
    [sym_none] = ACTIONS(1025),
    [anon_sym_await] = ACTIONS(1025),
    [sym_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(1027),
  },
  [426] = {
    [sym_argument_list] = STATE(474),
    [sym_generator_expression] = STATE(474),
    [anon_sym_DOT] = ACTIONS(494),
    [anon_sym_LPAREN] = ACTIONS(949),
    [anon_sym_RPAREN] = ACTIONS(494),
    [anon_sym_COMMA] = ACTIONS(494),
    [anon_sym_STAR] = ACTIONS(951),
    [anon_sym_GT_GT] = ACTIONS(494),
    [anon_sym_if] = ACTIONS(494),
    [anon_sym_COLON] = ACTIONS(494),
    [anon_sym_else] = ACTIONS(494),
    [anon_sym_async] = ACTIONS(494),
    [anon_sym_for] = ACTIONS(494),
    [anon_sym_in] = ACTIONS(494),
    [anon_sym_EQ] = ACTIONS(496),
    [anon_sym_STAR_STAR] = ACTIONS(957),
    [anon_sym_AT] = ACTIONS(959),
    [anon_sym_not] = ACTIONS(494),
    [anon_sym_and] = ACTIONS(494),
    [anon_sym_or] = ACTIONS(494),
    [anon_sym_PLUS] = ACTIONS(494),
    [anon_sym_DASH] = ACTIONS(494),
    [anon_sym_SLASH] = ACTIONS(951),
    [anon_sym_PERCENT] = ACTIONS(959),
    [anon_sym_SLASH_SLASH] = ACTIONS(959),
    [anon_sym_PIPE] = ACTIONS(494),
    [anon_sym_AMP] = ACTIONS(494),
    [anon_sym_CARET] = ACTIONS(494),
    [anon_sym_LT_LT] = ACTIONS(494),
    [anon_sym_LT] = ACTIONS(496),
    [anon_sym_LT_EQ] = ACTIONS(494),
    [anon_sym_EQ_EQ] = ACTIONS(494),
    [anon_sym_BANG_EQ] = ACTIONS(494),
    [anon_sym_GT_EQ] = ACTIONS(494),
    [anon_sym_GT] = ACTIONS(496),
    [anon_sym_LT_GT] = ACTIONS(494),
    [anon_sym_is] = ACTIONS(494),
    [anon_sym_LBRACK] = ACTIONS(494),
    [anon_sym_RBRACK] = ACTIONS(494),
    [anon_sym_RBRACE] = ACTIONS(494),
    [sym_type_conversion] = ACTIONS(494),
    [sym_comment] = ACTIONS(3),
  },
  [427] = {
    [sym_argument_list] = STATE(474),
    [sym_generator_expression] = STATE(474),
    [anon_sym_DOT] = ACTIONS(494),
    [anon_sym_LPAREN] = ACTIONS(949),
    [anon_sym_RPAREN] = ACTIONS(494),
    [anon_sym_COMMA] = ACTIONS(494),
    [anon_sym_STAR] = ACTIONS(496),
    [anon_sym_GT_GT] = ACTIONS(494),
    [anon_sym_if] = ACTIONS(494),
    [anon_sym_COLON] = ACTIONS(494),
    [anon_sym_else] = ACTIONS(494),
    [anon_sym_async] = ACTIONS(494),
    [anon_sym_for] = ACTIONS(494),
    [anon_sym_in] = ACTIONS(494),
    [anon_sym_EQ] = ACTIONS(496),
    [anon_sym_STAR_STAR] = ACTIONS(494),
    [anon_sym_AT] = ACTIONS(494),
    [anon_sym_not] = ACTIONS(494),
    [anon_sym_and] = ACTIONS(494),
    [anon_sym_or] = ACTIONS(494),
    [anon_sym_PLUS] = ACTIONS(494),
    [anon_sym_DASH] = ACTIONS(494),
    [anon_sym_SLASH] = ACTIONS(496),
    [anon_sym_PERCENT] = ACTIONS(494),
    [anon_sym_SLASH_SLASH] = ACTIONS(494),
    [anon_sym_PIPE] = ACTIONS(494),
    [anon_sym_AMP] = ACTIONS(494),
    [anon_sym_CARET] = ACTIONS(494),
    [anon_sym_LT_LT] = ACTIONS(494),
    [anon_sym_LT] = ACTIONS(496),
    [anon_sym_LT_EQ] = ACTIONS(494),
    [anon_sym_EQ_EQ] = ACTIONS(494),
    [anon_sym_BANG_EQ] = ACTIONS(494),
    [anon_sym_GT_EQ] = ACTIONS(494),
    [anon_sym_GT] = ACTIONS(496),
    [anon_sym_LT_GT] = ACTIONS(494),
    [anon_sym_is] = ACTIONS(494),
    [anon_sym_LBRACK] = ACTIONS(494),
    [anon_sym_RBRACK] = ACTIONS(494),
    [anon_sym_RBRACE] = ACTIONS(494),
    [sym_type_conversion] = ACTIONS(494),
    [sym_comment] = ACTIONS(3),
  },
  [428] = {
    [sym_identifier] = ACTIONS(1065),
    [anon_sym_import] = ACTIONS(1065),
    [anon_sym_from] = ACTIONS(1065),
    [anon_sym_LPAREN] = ACTIONS(1067),
    [anon_sym_print] = ACTIONS(1065),
    [anon_sym_assert] = ACTIONS(1065),
    [anon_sym_return] = ACTIONS(1065),
    [anon_sym_del] = ACTIONS(1065),
    [anon_sym_raise] = ACTIONS(1065),
    [anon_sym_pass] = ACTIONS(1065),
    [anon_sym_break] = ACTIONS(1065),
    [anon_sym_continue] = ACTIONS(1065),
    [anon_sym_if] = ACTIONS(1065),
    [anon_sym_async] = ACTIONS(1065),
    [anon_sym_for] = ACTIONS(1065),
    [anon_sym_while] = ACTIONS(1065),
    [anon_sym_try] = ACTIONS(1065),
    [anon_sym_with] = ACTIONS(1065),
    [anon_sym_def] = ACTIONS(1065),
    [anon_sym_global] = ACTIONS(1065),
    [anon_sym_nonlocal] = ACTIONS(1065),
    [anon_sym_exec] = ACTIONS(1065),
    [anon_sym_class] = ACTIONS(1065),
    [anon_sym_AT] = ACTIONS(1067),
    [anon_sym_not] = ACTIONS(1065),
    [anon_sym_PLUS] = ACTIONS(1067),
    [anon_sym_DASH] = ACTIONS(1067),
    [anon_sym_TILDE] = ACTIONS(1067),
    [anon_sym_lambda] = ACTIONS(1065),
    [anon_sym_yield] = ACTIONS(1065),
    [anon_sym_LBRACK] = ACTIONS(1067),
    [sym_ellipsis] = ACTIONS(1067),
    [anon_sym_LBRACE] = ACTIONS(1067),
    [sym_integer] = ACTIONS(1065),
    [sym_float] = ACTIONS(1067),
    [sym_true] = ACTIONS(1065),
    [sym_false] = ACTIONS(1065),
    [sym_none] = ACTIONS(1065),
    [anon_sym_await] = ACTIONS(1065),
    [sym_comment] = ACTIONS(3),
    [sym__dedent] = ACTIONS(1067),
    [sym__string_start] = ACTIONS(1067),
  },
  [429] = {
    [sym_argument_list] = STATE(474),
    [sym_generator_expression] = STATE(474),
    [anon_sym_DOT] = ACTIONS(947),
    [anon_sym_LPAREN] = ACTIONS(949),
    [anon_sym_RPAREN] = ACTIONS(498),
    [anon_sym_COMMA] = ACTIONS(498),
    [anon_sym_STAR] = ACTIONS(951),
    [anon_sym_GT_GT] = ACTIONS(953),
    [anon_sym_if] = ACTIONS(498),
    [anon_sym_COLON] = ACTIONS(498),
    [anon_sym_else] = ACTIONS(498),
    [anon_sym_async] = ACTIONS(498),
    [anon_sym_for] = ACTIONS(498),
    [anon_sym_in] = ACTIONS(498),
    [anon_sym_EQ] = ACTIONS(500),
    [anon_sym_STAR_STAR] = ACTIONS(957),
    [anon_sym_AT] = ACTIONS(959),
    [anon_sym_not] = ACTIONS(498),
    [anon_sym_and] = ACTIONS(498),
    [anon_sym_or] = ACTIONS(498),
    [anon_sym_PLUS] = ACTIONS(963),
    [anon_sym_DASH] = ACTIONS(963),
    [anon_sym_SLASH] = ACTIONS(951),
    [anon_sym_PERCENT] = ACTIONS(959),
    [anon_sym_SLASH_SLASH] = ACTIONS(959),
    [anon_sym_PIPE] = ACTIONS(965),
    [anon_sym_AMP] = ACTIONS(967),
    [anon_sym_CARET] = ACTIONS(969),
    [anon_sym_LT_LT] = ACTIONS(953),
    [anon_sym_LT] = ACTIONS(500),
    [anon_sym_LT_EQ] = ACTIONS(498),
    [anon_sym_EQ_EQ] = ACTIONS(498),
    [anon_sym_BANG_EQ] = ACTIONS(498),
    [anon_sym_GT_EQ] = ACTIONS(498),
    [anon_sym_GT] = ACTIONS(500),
    [anon_sym_LT_GT] = ACTIONS(498),
    [anon_sym_is] = ACTIONS(498),
    [anon_sym_LBRACK] = ACTIONS(975),
    [anon_sym_RBRACK] = ACTIONS(498),
    [anon_sym_RBRACE] = ACTIONS(498),
    [sym_type_conversion] = ACTIONS(498),
    [sym_comment] = ACTIONS(3),
  },
  [430] = {
    [ts_builtin_sym_end] = ACTIONS(1023),
    [sym_identifier] = ACTIONS(1021),
    [anon_sym_import] = ACTIONS(1021),
    [anon_sym_from] = ACTIONS(1021),
    [anon_sym_LPAREN] = ACTIONS(1023),
    [anon_sym_print] = ACTIONS(1021),
    [anon_sym_assert] = ACTIONS(1021),
    [anon_sym_return] = ACTIONS(1021),
    [anon_sym_del] = ACTIONS(1021),
    [anon_sym_raise] = ACTIONS(1021),
    [anon_sym_pass] = ACTIONS(1021),
    [anon_sym_break] = ACTIONS(1021),
    [anon_sym_continue] = ACTIONS(1021),
    [anon_sym_if] = ACTIONS(1021),
    [anon_sym_async] = ACTIONS(1021),
    [anon_sym_for] = ACTIONS(1021),
    [anon_sym_while] = ACTIONS(1021),
    [anon_sym_try] = ACTIONS(1021),
    [anon_sym_with] = ACTIONS(1021),
    [anon_sym_def] = ACTIONS(1021),
    [anon_sym_global] = ACTIONS(1021),
    [anon_sym_nonlocal] = ACTIONS(1021),
    [anon_sym_exec] = ACTIONS(1021),
    [anon_sym_class] = ACTIONS(1021),
    [anon_sym_AT] = ACTIONS(1023),
    [anon_sym_not] = ACTIONS(1021),
    [anon_sym_PLUS] = ACTIONS(1023),
    [anon_sym_DASH] = ACTIONS(1023),
    [anon_sym_TILDE] = ACTIONS(1023),
    [anon_sym_lambda] = ACTIONS(1021),
    [anon_sym_yield] = ACTIONS(1021),
    [anon_sym_LBRACK] = ACTIONS(1023),
    [sym_ellipsis] = ACTIONS(1023),
    [anon_sym_LBRACE] = ACTIONS(1023),
    [sym_integer] = ACTIONS(1021),
    [sym_float] = ACTIONS(1023),
    [sym_true] = ACTIONS(1021),
    [sym_false] = ACTIONS(1021),
    [sym_none] = ACTIONS(1021),
    [anon_sym_await] = ACTIONS(1021),
    [sym_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(1023),
  },
  [431] = {
    [sym_argument_list] = STATE(474),
    [sym_generator_expression] = STATE(474),
    [anon_sym_DOT] = ACTIONS(494),
    [anon_sym_LPAREN] = ACTIONS(949),
    [anon_sym_RPAREN] = ACTIONS(494),
    [anon_sym_COMMA] = ACTIONS(494),
    [anon_sym_STAR] = ACTIONS(951),
    [anon_sym_GT_GT] = ACTIONS(494),
    [anon_sym_if] = ACTIONS(494),
    [anon_sym_COLON] = ACTIONS(494),
    [anon_sym_else] = ACTIONS(494),
    [anon_sym_async] = ACTIONS(494),
    [anon_sym_for] = ACTIONS(494),
    [anon_sym_in] = ACTIONS(494),
    [anon_sym_EQ] = ACTIONS(496),
    [anon_sym_STAR_STAR] = ACTIONS(957),
    [anon_sym_AT] = ACTIONS(959),
    [anon_sym_not] = ACTIONS(494),
    [anon_sym_and] = ACTIONS(494),
    [anon_sym_or] = ACTIONS(494),
    [anon_sym_PLUS] = ACTIONS(963),
    [anon_sym_DASH] = ACTIONS(963),
    [anon_sym_SLASH] = ACTIONS(951),
    [anon_sym_PERCENT] = ACTIONS(959),
    [anon_sym_SLASH_SLASH] = ACTIONS(959),
    [anon_sym_PIPE] = ACTIONS(494),
    [anon_sym_AMP] = ACTIONS(494),
    [anon_sym_CARET] = ACTIONS(494),
    [anon_sym_LT_LT] = ACTIONS(494),
    [anon_sym_LT] = ACTIONS(496),
    [anon_sym_LT_EQ] = ACTIONS(494),
    [anon_sym_EQ_EQ] = ACTIONS(494),
    [anon_sym_BANG_EQ] = ACTIONS(494),
    [anon_sym_GT_EQ] = ACTIONS(494),
    [anon_sym_GT] = ACTIONS(496),
    [anon_sym_LT_GT] = ACTIONS(494),
    [anon_sym_is] = ACTIONS(494),
    [anon_sym_LBRACK] = ACTIONS(494),
    [anon_sym_RBRACK] = ACTIONS(494),
    [anon_sym_RBRACE] = ACTIONS(494),
    [sym_type_conversion] = ACTIONS(494),
    [sym_comment] = ACTIONS(3),
  },
  [432] = {
    [sym_argument_list] = STATE(474),
    [sym_generator_expression] = STATE(474),
    [anon_sym_DOT] = ACTIONS(494),
    [anon_sym_LPAREN] = ACTIONS(949),
    [anon_sym_RPAREN] = ACTIONS(494),
    [anon_sym_COMMA] = ACTIONS(494),
    [anon_sym_STAR] = ACTIONS(496),
    [anon_sym_GT_GT] = ACTIONS(494),
    [anon_sym_if] = ACTIONS(494),
    [anon_sym_COLON] = ACTIONS(494),
    [anon_sym_else] = ACTIONS(494),
    [anon_sym_async] = ACTIONS(494),
    [anon_sym_for] = ACTIONS(494),
    [anon_sym_in] = ACTIONS(494),
    [anon_sym_EQ] = ACTIONS(496),
    [anon_sym_STAR_STAR] = ACTIONS(957),
    [anon_sym_AT] = ACTIONS(494),
    [anon_sym_not] = ACTIONS(494),
    [anon_sym_and] = ACTIONS(494),
    [anon_sym_or] = ACTIONS(494),
    [anon_sym_PLUS] = ACTIONS(494),
    [anon_sym_DASH] = ACTIONS(494),
    [anon_sym_SLASH] = ACTIONS(496),
    [anon_sym_PERCENT] = ACTIONS(494),
    [anon_sym_SLASH_SLASH] = ACTIONS(494),
    [anon_sym_PIPE] = ACTIONS(494),
    [anon_sym_AMP] = ACTIONS(494),
    [anon_sym_CARET] = ACTIONS(494),
    [anon_sym_LT_LT] = ACTIONS(494),
    [anon_sym_LT] = ACTIONS(496),
    [anon_sym_LT_EQ] = ACTIONS(494),
    [anon_sym_EQ_EQ] = ACTIONS(494),
    [anon_sym_BANG_EQ] = ACTIONS(494),
    [anon_sym_GT_EQ] = ACTIONS(494),
    [anon_sym_GT] = ACTIONS(496),
    [anon_sym_LT_GT] = ACTIONS(494),
    [anon_sym_is] = ACTIONS(494),
    [anon_sym_LBRACK] = ACTIONS(494),
    [anon_sym_RBRACK] = ACTIONS(494),
    [anon_sym_RBRACE] = ACTIONS(494),
    [sym_type_conversion] = ACTIONS(494),
    [sym_comment] = ACTIONS(3),
  },
  [433] = {
    [ts_builtin_sym_end] = ACTIONS(1015),
    [sym_identifier] = ACTIONS(1013),
    [anon_sym_import] = ACTIONS(1013),
    [anon_sym_from] = ACTIONS(1013),
    [anon_sym_LPAREN] = ACTIONS(1015),
    [anon_sym_print] = ACTIONS(1013),
    [anon_sym_assert] = ACTIONS(1013),
    [anon_sym_return] = ACTIONS(1013),
    [anon_sym_del] = ACTIONS(1013),
    [anon_sym_raise] = ACTIONS(1013),
    [anon_sym_pass] = ACTIONS(1013),
    [anon_sym_break] = ACTIONS(1013),
    [anon_sym_continue] = ACTIONS(1013),
    [anon_sym_if] = ACTIONS(1013),
    [anon_sym_async] = ACTIONS(1013),
    [anon_sym_for] = ACTIONS(1013),
    [anon_sym_while] = ACTIONS(1013),
    [anon_sym_try] = ACTIONS(1013),
    [anon_sym_with] = ACTIONS(1013),
    [anon_sym_def] = ACTIONS(1013),
    [anon_sym_global] = ACTIONS(1013),
    [anon_sym_nonlocal] = ACTIONS(1013),
    [anon_sym_exec] = ACTIONS(1013),
    [anon_sym_class] = ACTIONS(1013),
    [anon_sym_AT] = ACTIONS(1015),
    [anon_sym_not] = ACTIONS(1013),
    [anon_sym_PLUS] = ACTIONS(1015),
    [anon_sym_DASH] = ACTIONS(1015),
    [anon_sym_TILDE] = ACTIONS(1015),
    [anon_sym_lambda] = ACTIONS(1013),
    [anon_sym_yield] = ACTIONS(1013),
    [anon_sym_LBRACK] = ACTIONS(1015),
    [sym_ellipsis] = ACTIONS(1015),
    [anon_sym_LBRACE] = ACTIONS(1015),
    [sym_integer] = ACTIONS(1013),
    [sym_float] = ACTIONS(1015),
    [sym_true] = ACTIONS(1013),
    [sym_false] = ACTIONS(1013),
    [sym_none] = ACTIONS(1013),
    [anon_sym_await] = ACTIONS(1013),
    [sym_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(1015),
  },
  [434] = {
    [sym_identifier] = ACTIONS(1069),
    [anon_sym_import] = ACTIONS(1069),
    [anon_sym_from] = ACTIONS(1069),
    [anon_sym_LPAREN] = ACTIONS(1071),
    [anon_sym_print] = ACTIONS(1069),
    [anon_sym_assert] = ACTIONS(1069),
    [anon_sym_return] = ACTIONS(1069),
    [anon_sym_del] = ACTIONS(1069),
    [anon_sym_raise] = ACTIONS(1069),
    [anon_sym_pass] = ACTIONS(1069),
    [anon_sym_break] = ACTIONS(1069),
    [anon_sym_continue] = ACTIONS(1069),
    [anon_sym_if] = ACTIONS(1069),
    [anon_sym_async] = ACTIONS(1069),
    [anon_sym_for] = ACTIONS(1069),
    [anon_sym_while] = ACTIONS(1069),
    [anon_sym_try] = ACTIONS(1069),
    [anon_sym_with] = ACTIONS(1069),
    [anon_sym_def] = ACTIONS(1069),
    [anon_sym_global] = ACTIONS(1069),
    [anon_sym_nonlocal] = ACTIONS(1069),
    [anon_sym_exec] = ACTIONS(1069),
    [anon_sym_class] = ACTIONS(1069),
    [anon_sym_AT] = ACTIONS(1071),
    [anon_sym_not] = ACTIONS(1069),
    [anon_sym_PLUS] = ACTIONS(1071),
    [anon_sym_DASH] = ACTIONS(1071),
    [anon_sym_TILDE] = ACTIONS(1071),
    [anon_sym_lambda] = ACTIONS(1069),
    [anon_sym_yield] = ACTIONS(1069),
    [anon_sym_LBRACK] = ACTIONS(1071),
    [sym_ellipsis] = ACTIONS(1071),
    [anon_sym_LBRACE] = ACTIONS(1071),
    [sym_integer] = ACTIONS(1069),
    [sym_float] = ACTIONS(1071),
    [sym_true] = ACTIONS(1069),
    [sym_false] = ACTIONS(1069),
    [sym_none] = ACTIONS(1069),
    [anon_sym_await] = ACTIONS(1069),
    [sym_comment] = ACTIONS(3),
    [sym__dedent] = ACTIONS(1071),
    [sym__string_start] = ACTIONS(1071),
  },
  [435] = {
    [sym_identifier] = ACTIONS(1073),
    [anon_sym_import] = ACTIONS(1073),
    [anon_sym_from] = ACTIONS(1073),
    [anon_sym_LPAREN] = ACTIONS(1075),
    [anon_sym_print] = ACTIONS(1073),
    [anon_sym_assert] = ACTIONS(1073),
    [anon_sym_return] = ACTIONS(1073),
    [anon_sym_del] = ACTIONS(1073),
    [anon_sym_raise] = ACTIONS(1073),
    [anon_sym_pass] = ACTIONS(1073),
    [anon_sym_break] = ACTIONS(1073),
    [anon_sym_continue] = ACTIONS(1073),
    [anon_sym_if] = ACTIONS(1073),
    [anon_sym_async] = ACTIONS(1073),
    [anon_sym_for] = ACTIONS(1073),
    [anon_sym_while] = ACTIONS(1073),
    [anon_sym_try] = ACTIONS(1073),
    [anon_sym_with] = ACTIONS(1073),
    [anon_sym_def] = ACTIONS(1073),
    [anon_sym_global] = ACTIONS(1073),
    [anon_sym_nonlocal] = ACTIONS(1073),
    [anon_sym_exec] = ACTIONS(1073),
    [anon_sym_class] = ACTIONS(1073),
    [anon_sym_AT] = ACTIONS(1075),
    [anon_sym_not] = ACTIONS(1073),
    [anon_sym_PLUS] = ACTIONS(1075),
    [anon_sym_DASH] = ACTIONS(1075),
    [anon_sym_TILDE] = ACTIONS(1075),
    [anon_sym_lambda] = ACTIONS(1073),
    [anon_sym_yield] = ACTIONS(1073),
    [anon_sym_LBRACK] = ACTIONS(1075),
    [sym_ellipsis] = ACTIONS(1075),
    [anon_sym_LBRACE] = ACTIONS(1075),
    [sym_integer] = ACTIONS(1073),
    [sym_float] = ACTIONS(1075),
    [sym_true] = ACTIONS(1073),
    [sym_false] = ACTIONS(1073),
    [sym_none] = ACTIONS(1073),
    [anon_sym_await] = ACTIONS(1073),
    [sym_comment] = ACTIONS(3),
    [sym__dedent] = ACTIONS(1075),
    [sym__string_start] = ACTIONS(1075),
  },
  [436] = {
    [sym_argument_list] = STATE(474),
    [sym_generator_expression] = STATE(474),
    [anon_sym_DOT] = ACTIONS(490),
    [anon_sym_LPAREN] = ACTIONS(949),
    [anon_sym_RPAREN] = ACTIONS(490),
    [anon_sym_COMMA] = ACTIONS(490),
    [anon_sym_STAR] = ACTIONS(492),
    [anon_sym_GT_GT] = ACTIONS(490),
    [anon_sym_if] = ACTIONS(490),
    [anon_sym_COLON] = ACTIONS(490),
    [anon_sym_else] = ACTIONS(490),
    [anon_sym_async] = ACTIONS(490),
    [anon_sym_for] = ACTIONS(490),
    [anon_sym_in] = ACTIONS(490),
    [anon_sym_EQ] = ACTIONS(492),
    [anon_sym_STAR_STAR] = ACTIONS(490),
    [anon_sym_AT] = ACTIONS(490),
    [anon_sym_not] = ACTIONS(490),
    [anon_sym_and] = ACTIONS(490),
    [anon_sym_or] = ACTIONS(490),
    [anon_sym_PLUS] = ACTIONS(490),
    [anon_sym_DASH] = ACTIONS(490),
    [anon_sym_SLASH] = ACTIONS(492),
    [anon_sym_PERCENT] = ACTIONS(490),
    [anon_sym_SLASH_SLASH] = ACTIONS(490),
    [anon_sym_PIPE] = ACTIONS(490),
    [anon_sym_AMP] = ACTIONS(490),
    [anon_sym_CARET] = ACTIONS(490),
    [anon_sym_LT_LT] = ACTIONS(490),
    [anon_sym_LT] = ACTIONS(492),
    [anon_sym_LT_EQ] = ACTIONS(490),
    [anon_sym_EQ_EQ] = ACTIONS(490),
    [anon_sym_BANG_EQ] = ACTIONS(490),
    [anon_sym_GT_EQ] = ACTIONS(490),
    [anon_sym_GT] = ACTIONS(492),
    [anon_sym_LT_GT] = ACTIONS(490),
    [anon_sym_is] = ACTIONS(490),
    [anon_sym_LBRACK] = ACTIONS(490),
    [anon_sym_RBRACK] = ACTIONS(490),
    [anon_sym_RBRACE] = ACTIONS(490),
    [sym_type_conversion] = ACTIONS(490),
    [sym_comment] = ACTIONS(3),
  },
  [437] = {
    [ts_builtin_sym_end] = ACTIONS(1003),
    [sym_identifier] = ACTIONS(1001),
    [anon_sym_import] = ACTIONS(1001),
    [anon_sym_from] = ACTIONS(1001),
    [anon_sym_LPAREN] = ACTIONS(1003),
    [anon_sym_print] = ACTIONS(1001),
    [anon_sym_assert] = ACTIONS(1001),
    [anon_sym_return] = ACTIONS(1001),
    [anon_sym_del] = ACTIONS(1001),
    [anon_sym_raise] = ACTIONS(1001),
    [anon_sym_pass] = ACTIONS(1001),
    [anon_sym_break] = ACTIONS(1001),
    [anon_sym_continue] = ACTIONS(1001),
    [anon_sym_if] = ACTIONS(1001),
    [anon_sym_async] = ACTIONS(1001),
    [anon_sym_for] = ACTIONS(1001),
    [anon_sym_while] = ACTIONS(1001),
    [anon_sym_try] = ACTIONS(1001),
    [anon_sym_with] = ACTIONS(1001),
    [anon_sym_def] = ACTIONS(1001),
    [anon_sym_global] = ACTIONS(1001),
    [anon_sym_nonlocal] = ACTIONS(1001),
    [anon_sym_exec] = ACTIONS(1001),
    [anon_sym_class] = ACTIONS(1001),
    [anon_sym_AT] = ACTIONS(1003),
    [anon_sym_not] = ACTIONS(1001),
    [anon_sym_PLUS] = ACTIONS(1003),
    [anon_sym_DASH] = ACTIONS(1003),
    [anon_sym_TILDE] = ACTIONS(1003),
    [anon_sym_lambda] = ACTIONS(1001),
    [anon_sym_yield] = ACTIONS(1001),
    [anon_sym_LBRACK] = ACTIONS(1003),
    [sym_ellipsis] = ACTIONS(1003),
    [anon_sym_LBRACE] = ACTIONS(1003),
    [sym_integer] = ACTIONS(1001),
    [sym_float] = ACTIONS(1003),
    [sym_true] = ACTIONS(1001),
    [sym_false] = ACTIONS(1001),
    [sym_none] = ACTIONS(1001),
    [anon_sym_await] = ACTIONS(1001),
    [sym_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(1003),
  },
  [438] = {
    [sym_identifier] = ACTIONS(1077),
    [anon_sym_import] = ACTIONS(1077),
    [anon_sym_from] = ACTIONS(1077),
    [anon_sym_LPAREN] = ACTIONS(1079),
    [anon_sym_print] = ACTIONS(1077),
    [anon_sym_assert] = ACTIONS(1077),
    [anon_sym_return] = ACTIONS(1077),
    [anon_sym_del] = ACTIONS(1077),
    [anon_sym_raise] = ACTIONS(1077),
    [anon_sym_pass] = ACTIONS(1077),
    [anon_sym_break] = ACTIONS(1077),
    [anon_sym_continue] = ACTIONS(1077),
    [anon_sym_if] = ACTIONS(1077),
    [anon_sym_async] = ACTIONS(1077),
    [anon_sym_for] = ACTIONS(1077),
    [anon_sym_while] = ACTIONS(1077),
    [anon_sym_try] = ACTIONS(1077),
    [anon_sym_with] = ACTIONS(1077),
    [anon_sym_def] = ACTIONS(1077),
    [anon_sym_global] = ACTIONS(1077),
    [anon_sym_nonlocal] = ACTIONS(1077),
    [anon_sym_exec] = ACTIONS(1077),
    [anon_sym_class] = ACTIONS(1077),
    [anon_sym_AT] = ACTIONS(1079),
    [anon_sym_not] = ACTIONS(1077),
    [anon_sym_PLUS] = ACTIONS(1079),
    [anon_sym_DASH] = ACTIONS(1079),
    [anon_sym_TILDE] = ACTIONS(1079),
    [anon_sym_lambda] = ACTIONS(1077),
    [anon_sym_yield] = ACTIONS(1077),
    [anon_sym_LBRACK] = ACTIONS(1079),
    [sym_ellipsis] = ACTIONS(1079),
    [anon_sym_LBRACE] = ACTIONS(1079),
    [sym_integer] = ACTIONS(1077),
    [sym_float] = ACTIONS(1079),
    [sym_true] = ACTIONS(1077),
    [sym_false] = ACTIONS(1077),
    [sym_none] = ACTIONS(1077),
    [anon_sym_await] = ACTIONS(1077),
    [sym_comment] = ACTIONS(3),
    [sym__dedent] = ACTIONS(1079),
    [sym__string_start] = ACTIONS(1079),
  },
  [439] = {
    [sym_identifier] = ACTIONS(1081),
    [anon_sym_import] = ACTIONS(1081),
    [anon_sym_from] = ACTIONS(1081),
    [anon_sym_LPAREN] = ACTIONS(1083),
    [anon_sym_print] = ACTIONS(1081),
    [anon_sym_assert] = ACTIONS(1081),
    [anon_sym_return] = ACTIONS(1081),
    [anon_sym_del] = ACTIONS(1081),
    [anon_sym_raise] = ACTIONS(1081),
    [anon_sym_pass] = ACTIONS(1081),
    [anon_sym_break] = ACTIONS(1081),
    [anon_sym_continue] = ACTIONS(1081),
    [anon_sym_if] = ACTIONS(1081),
    [anon_sym_async] = ACTIONS(1081),
    [anon_sym_for] = ACTIONS(1081),
    [anon_sym_while] = ACTIONS(1081),
    [anon_sym_try] = ACTIONS(1081),
    [anon_sym_with] = ACTIONS(1081),
    [anon_sym_def] = ACTIONS(1081),
    [anon_sym_global] = ACTIONS(1081),
    [anon_sym_nonlocal] = ACTIONS(1081),
    [anon_sym_exec] = ACTIONS(1081),
    [anon_sym_class] = ACTIONS(1081),
    [anon_sym_AT] = ACTIONS(1083),
    [anon_sym_not] = ACTIONS(1081),
    [anon_sym_PLUS] = ACTIONS(1083),
    [anon_sym_DASH] = ACTIONS(1083),
    [anon_sym_TILDE] = ACTIONS(1083),
    [anon_sym_lambda] = ACTIONS(1081),
    [anon_sym_yield] = ACTIONS(1081),
    [anon_sym_LBRACK] = ACTIONS(1083),
    [sym_ellipsis] = ACTIONS(1083),
    [anon_sym_LBRACE] = ACTIONS(1083),
    [sym_integer] = ACTIONS(1081),
    [sym_float] = ACTIONS(1083),
    [sym_true] = ACTIONS(1081),
    [sym_false] = ACTIONS(1081),
    [sym_none] = ACTIONS(1081),
    [anon_sym_await] = ACTIONS(1081),
    [sym_comment] = ACTIONS(3),
    [sym__dedent] = ACTIONS(1083),
    [sym__string_start] = ACTIONS(1083),
  },
  [440] = {
    [ts_builtin_sym_end] = ACTIONS(999),
    [sym_identifier] = ACTIONS(997),
    [anon_sym_import] = ACTIONS(997),
    [anon_sym_from] = ACTIONS(997),
    [anon_sym_LPAREN] = ACTIONS(999),
    [anon_sym_print] = ACTIONS(997),
    [anon_sym_assert] = ACTIONS(997),
    [anon_sym_return] = ACTIONS(997),
    [anon_sym_del] = ACTIONS(997),
    [anon_sym_raise] = ACTIONS(997),
    [anon_sym_pass] = ACTIONS(997),
    [anon_sym_break] = ACTIONS(997),
    [anon_sym_continue] = ACTIONS(997),
    [anon_sym_if] = ACTIONS(997),
    [anon_sym_async] = ACTIONS(997),
    [anon_sym_for] = ACTIONS(997),
    [anon_sym_while] = ACTIONS(997),
    [anon_sym_try] = ACTIONS(997),
    [anon_sym_with] = ACTIONS(997),
    [anon_sym_def] = ACTIONS(997),
    [anon_sym_global] = ACTIONS(997),
    [anon_sym_nonlocal] = ACTIONS(997),
    [anon_sym_exec] = ACTIONS(997),
    [anon_sym_class] = ACTIONS(997),
    [anon_sym_AT] = ACTIONS(999),
    [anon_sym_not] = ACTIONS(997),
    [anon_sym_PLUS] = ACTIONS(999),
    [anon_sym_DASH] = ACTIONS(999),
    [anon_sym_TILDE] = ACTIONS(999),
    [anon_sym_lambda] = ACTIONS(997),
    [anon_sym_yield] = ACTIONS(997),
    [anon_sym_LBRACK] = ACTIONS(999),
    [sym_ellipsis] = ACTIONS(999),
    [anon_sym_LBRACE] = ACTIONS(999),
    [sym_integer] = ACTIONS(997),
    [sym_float] = ACTIONS(999),
    [sym_true] = ACTIONS(997),
    [sym_false] = ACTIONS(997),
    [sym_none] = ACTIONS(997),
    [anon_sym_await] = ACTIONS(997),
    [sym_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(999),
  },
  [441] = {
    [ts_builtin_sym_end] = ACTIONS(1085),
    [sym_identifier] = ACTIONS(1087),
    [anon_sym_import] = ACTIONS(1087),
    [anon_sym_from] = ACTIONS(1087),
    [anon_sym_LPAREN] = ACTIONS(1085),
    [anon_sym_print] = ACTIONS(1087),
    [anon_sym_assert] = ACTIONS(1087),
    [anon_sym_return] = ACTIONS(1087),
    [anon_sym_del] = ACTIONS(1087),
    [anon_sym_raise] = ACTIONS(1087),
    [anon_sym_pass] = ACTIONS(1087),
    [anon_sym_break] = ACTIONS(1087),
    [anon_sym_continue] = ACTIONS(1087),
    [anon_sym_if] = ACTIONS(1087),
    [anon_sym_async] = ACTIONS(1087),
    [anon_sym_for] = ACTIONS(1087),
    [anon_sym_while] = ACTIONS(1087),
    [anon_sym_try] = ACTIONS(1087),
    [anon_sym_with] = ACTIONS(1087),
    [anon_sym_def] = ACTIONS(1087),
    [anon_sym_global] = ACTIONS(1087),
    [anon_sym_nonlocal] = ACTIONS(1087),
    [anon_sym_exec] = ACTIONS(1087),
    [anon_sym_class] = ACTIONS(1087),
    [anon_sym_AT] = ACTIONS(1085),
    [anon_sym_not] = ACTIONS(1087),
    [anon_sym_PLUS] = ACTIONS(1085),
    [anon_sym_DASH] = ACTIONS(1085),
    [anon_sym_TILDE] = ACTIONS(1085),
    [anon_sym_lambda] = ACTIONS(1087),
    [anon_sym_yield] = ACTIONS(1087),
    [anon_sym_LBRACK] = ACTIONS(1085),
    [sym_ellipsis] = ACTIONS(1085),
    [anon_sym_LBRACE] = ACTIONS(1085),
    [sym_integer] = ACTIONS(1087),
    [sym_float] = ACTIONS(1085),
    [sym_true] = ACTIONS(1087),
    [sym_false] = ACTIONS(1087),
    [sym_none] = ACTIONS(1087),
    [anon_sym_await] = ACTIONS(1087),
    [sym_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(1085),
  },
  [442] = {
    [ts_builtin_sym_end] = ACTIONS(1089),
    [sym_identifier] = ACTIONS(1091),
    [anon_sym_import] = ACTIONS(1091),
    [anon_sym_from] = ACTIONS(1091),
    [anon_sym_LPAREN] = ACTIONS(1089),
    [anon_sym_print] = ACTIONS(1091),
    [anon_sym_assert] = ACTIONS(1091),
    [anon_sym_return] = ACTIONS(1091),
    [anon_sym_del] = ACTIONS(1091),
    [anon_sym_raise] = ACTIONS(1091),
    [anon_sym_pass] = ACTIONS(1091),
    [anon_sym_break] = ACTIONS(1091),
    [anon_sym_continue] = ACTIONS(1091),
    [anon_sym_if] = ACTIONS(1091),
    [anon_sym_async] = ACTIONS(1091),
    [anon_sym_for] = ACTIONS(1091),
    [anon_sym_while] = ACTIONS(1091),
    [anon_sym_try] = ACTIONS(1091),
    [anon_sym_with] = ACTIONS(1091),
    [anon_sym_def] = ACTIONS(1091),
    [anon_sym_global] = ACTIONS(1091),
    [anon_sym_nonlocal] = ACTIONS(1091),
    [anon_sym_exec] = ACTIONS(1091),
    [anon_sym_class] = ACTIONS(1091),
    [anon_sym_AT] = ACTIONS(1089),
    [anon_sym_not] = ACTIONS(1091),
    [anon_sym_PLUS] = ACTIONS(1089),
    [anon_sym_DASH] = ACTIONS(1089),
    [anon_sym_TILDE] = ACTIONS(1089),
    [anon_sym_lambda] = ACTIONS(1091),
    [anon_sym_yield] = ACTIONS(1091),
    [anon_sym_LBRACK] = ACTIONS(1089),
    [sym_ellipsis] = ACTIONS(1089),
    [anon_sym_LBRACE] = ACTIONS(1089),
    [sym_integer] = ACTIONS(1091),
    [sym_float] = ACTIONS(1089),
    [sym_true] = ACTIONS(1091),
    [sym_false] = ACTIONS(1091),
    [sym_none] = ACTIONS(1091),
    [anon_sym_await] = ACTIONS(1091),
    [sym_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(1089),
  },
  [443] = {
    [sym_identifier] = ACTIONS(1093),
    [anon_sym_import] = ACTIONS(1093),
    [anon_sym_from] = ACTIONS(1093),
    [anon_sym_LPAREN] = ACTIONS(1095),
    [anon_sym_print] = ACTIONS(1093),
    [anon_sym_assert] = ACTIONS(1093),
    [anon_sym_return] = ACTIONS(1093),
    [anon_sym_del] = ACTIONS(1093),
    [anon_sym_raise] = ACTIONS(1093),
    [anon_sym_pass] = ACTIONS(1093),
    [anon_sym_break] = ACTIONS(1093),
    [anon_sym_continue] = ACTIONS(1093),
    [anon_sym_if] = ACTIONS(1093),
    [anon_sym_async] = ACTIONS(1093),
    [anon_sym_for] = ACTIONS(1093),
    [anon_sym_while] = ACTIONS(1093),
    [anon_sym_try] = ACTIONS(1093),
    [anon_sym_with] = ACTIONS(1093),
    [anon_sym_def] = ACTIONS(1093),
    [anon_sym_global] = ACTIONS(1093),
    [anon_sym_nonlocal] = ACTIONS(1093),
    [anon_sym_exec] = ACTIONS(1093),
    [anon_sym_class] = ACTIONS(1093),
    [anon_sym_AT] = ACTIONS(1095),
    [anon_sym_not] = ACTIONS(1093),
    [anon_sym_PLUS] = ACTIONS(1095),
    [anon_sym_DASH] = ACTIONS(1095),
    [anon_sym_TILDE] = ACTIONS(1095),
    [anon_sym_lambda] = ACTIONS(1093),
    [anon_sym_yield] = ACTIONS(1093),
    [anon_sym_LBRACK] = ACTIONS(1095),
    [sym_ellipsis] = ACTIONS(1095),
    [anon_sym_LBRACE] = ACTIONS(1095),
    [sym_integer] = ACTIONS(1093),
    [sym_float] = ACTIONS(1095),
    [sym_true] = ACTIONS(1093),
    [sym_false] = ACTIONS(1093),
    [sym_none] = ACTIONS(1093),
    [anon_sym_await] = ACTIONS(1093),
    [sym_comment] = ACTIONS(3),
    [sym__dedent] = ACTIONS(1095),
    [sym__string_start] = ACTIONS(1095),
  },
  [444] = {
    [ts_builtin_sym_end] = ACTIONS(1097),
    [sym_identifier] = ACTIONS(1099),
    [anon_sym_import] = ACTIONS(1099),
    [anon_sym_from] = ACTIONS(1099),
    [anon_sym_LPAREN] = ACTIONS(1097),
    [anon_sym_print] = ACTIONS(1099),
    [anon_sym_assert] = ACTIONS(1099),
    [anon_sym_return] = ACTIONS(1099),
    [anon_sym_del] = ACTIONS(1099),
    [anon_sym_raise] = ACTIONS(1099),
    [anon_sym_pass] = ACTIONS(1099),
    [anon_sym_break] = ACTIONS(1099),
    [anon_sym_continue] = ACTIONS(1099),
    [anon_sym_if] = ACTIONS(1099),
    [anon_sym_async] = ACTIONS(1099),
    [anon_sym_for] = ACTIONS(1099),
    [anon_sym_while] = ACTIONS(1099),
    [anon_sym_try] = ACTIONS(1099),
    [anon_sym_with] = ACTIONS(1099),
    [anon_sym_def] = ACTIONS(1099),
    [anon_sym_global] = ACTIONS(1099),
    [anon_sym_nonlocal] = ACTIONS(1099),
    [anon_sym_exec] = ACTIONS(1099),
    [anon_sym_class] = ACTIONS(1099),
    [anon_sym_AT] = ACTIONS(1097),
    [anon_sym_not] = ACTIONS(1099),
    [anon_sym_PLUS] = ACTIONS(1097),
    [anon_sym_DASH] = ACTIONS(1097),
    [anon_sym_TILDE] = ACTIONS(1097),
    [anon_sym_lambda] = ACTIONS(1099),
    [anon_sym_yield] = ACTIONS(1099),
    [anon_sym_LBRACK] = ACTIONS(1097),
    [sym_ellipsis] = ACTIONS(1097),
    [anon_sym_LBRACE] = ACTIONS(1097),
    [sym_integer] = ACTIONS(1099),
    [sym_float] = ACTIONS(1097),
    [sym_true] = ACTIONS(1099),
    [sym_false] = ACTIONS(1099),
    [sym_none] = ACTIONS(1099),
    [anon_sym_await] = ACTIONS(1099),
    [sym_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(1097),
  },
  [445] = {
    [ts_builtin_sym_end] = ACTIONS(1101),
    [sym_identifier] = ACTIONS(1103),
    [anon_sym_import] = ACTIONS(1103),
    [anon_sym_from] = ACTIONS(1103),
    [anon_sym_LPAREN] = ACTIONS(1101),
    [anon_sym_print] = ACTIONS(1103),
    [anon_sym_assert] = ACTIONS(1103),
    [anon_sym_return] = ACTIONS(1103),
    [anon_sym_del] = ACTIONS(1103),
    [anon_sym_raise] = ACTIONS(1103),
    [anon_sym_pass] = ACTIONS(1103),
    [anon_sym_break] = ACTIONS(1103),
    [anon_sym_continue] = ACTIONS(1103),
    [anon_sym_if] = ACTIONS(1103),
    [anon_sym_async] = ACTIONS(1103),
    [anon_sym_for] = ACTIONS(1103),
    [anon_sym_while] = ACTIONS(1103),
    [anon_sym_try] = ACTIONS(1103),
    [anon_sym_with] = ACTIONS(1103),
    [anon_sym_def] = ACTIONS(1103),
    [anon_sym_global] = ACTIONS(1103),
    [anon_sym_nonlocal] = ACTIONS(1103),
    [anon_sym_exec] = ACTIONS(1103),
    [anon_sym_class] = ACTIONS(1103),
    [anon_sym_AT] = ACTIONS(1101),
    [anon_sym_not] = ACTIONS(1103),
    [anon_sym_PLUS] = ACTIONS(1101),
    [anon_sym_DASH] = ACTIONS(1101),
    [anon_sym_TILDE] = ACTIONS(1101),
    [anon_sym_lambda] = ACTIONS(1103),
    [anon_sym_yield] = ACTIONS(1103),
    [anon_sym_LBRACK] = ACTIONS(1101),
    [sym_ellipsis] = ACTIONS(1101),
    [anon_sym_LBRACE] = ACTIONS(1101),
    [sym_integer] = ACTIONS(1103),
    [sym_float] = ACTIONS(1101),
    [sym_true] = ACTIONS(1103),
    [sym_false] = ACTIONS(1103),
    [sym_none] = ACTIONS(1103),
    [anon_sym_await] = ACTIONS(1103),
    [sym_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(1101),
  },
  [446] = {
    [ts_builtin_sym_end] = ACTIONS(1105),
    [sym_identifier] = ACTIONS(1107),
    [anon_sym_import] = ACTIONS(1107),
    [anon_sym_from] = ACTIONS(1107),
    [anon_sym_LPAREN] = ACTIONS(1105),
    [anon_sym_print] = ACTIONS(1107),
    [anon_sym_assert] = ACTIONS(1107),
    [anon_sym_return] = ACTIONS(1107),
    [anon_sym_del] = ACTIONS(1107),
    [anon_sym_raise] = ACTIONS(1107),
    [anon_sym_pass] = ACTIONS(1107),
    [anon_sym_break] = ACTIONS(1107),
    [anon_sym_continue] = ACTIONS(1107),
    [anon_sym_if] = ACTIONS(1107),
    [anon_sym_async] = ACTIONS(1107),
    [anon_sym_for] = ACTIONS(1107),
    [anon_sym_while] = ACTIONS(1107),
    [anon_sym_try] = ACTIONS(1107),
    [anon_sym_with] = ACTIONS(1107),
    [anon_sym_def] = ACTIONS(1107),
    [anon_sym_global] = ACTIONS(1107),
    [anon_sym_nonlocal] = ACTIONS(1107),
    [anon_sym_exec] = ACTIONS(1107),
    [anon_sym_class] = ACTIONS(1107),
    [anon_sym_AT] = ACTIONS(1105),
    [anon_sym_not] = ACTIONS(1107),
    [anon_sym_PLUS] = ACTIONS(1105),
    [anon_sym_DASH] = ACTIONS(1105),
    [anon_sym_TILDE] = ACTIONS(1105),
    [anon_sym_lambda] = ACTIONS(1107),
    [anon_sym_yield] = ACTIONS(1107),
    [anon_sym_LBRACK] = ACTIONS(1105),
    [sym_ellipsis] = ACTIONS(1105),
    [anon_sym_LBRACE] = ACTIONS(1105),
    [sym_integer] = ACTIONS(1107),
    [sym_float] = ACTIONS(1105),
    [sym_true] = ACTIONS(1107),
    [sym_false] = ACTIONS(1107),
    [sym_none] = ACTIONS(1107),
    [anon_sym_await] = ACTIONS(1107),
    [sym_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(1105),
  },
  [447] = {
    [ts_builtin_sym_end] = ACTIONS(1095),
    [sym_identifier] = ACTIONS(1093),
    [anon_sym_import] = ACTIONS(1093),
    [anon_sym_from] = ACTIONS(1093),
    [anon_sym_LPAREN] = ACTIONS(1095),
    [anon_sym_print] = ACTIONS(1093),
    [anon_sym_assert] = ACTIONS(1093),
    [anon_sym_return] = ACTIONS(1093),
    [anon_sym_del] = ACTIONS(1093),
    [anon_sym_raise] = ACTIONS(1093),
    [anon_sym_pass] = ACTIONS(1093),
    [anon_sym_break] = ACTIONS(1093),
    [anon_sym_continue] = ACTIONS(1093),
    [anon_sym_if] = ACTIONS(1093),
    [anon_sym_async] = ACTIONS(1093),
    [anon_sym_for] = ACTIONS(1093),
    [anon_sym_while] = ACTIONS(1093),
    [anon_sym_try] = ACTIONS(1093),
    [anon_sym_with] = ACTIONS(1093),
    [anon_sym_def] = ACTIONS(1093),
    [anon_sym_global] = ACTIONS(1093),
    [anon_sym_nonlocal] = ACTIONS(1093),
    [anon_sym_exec] = ACTIONS(1093),
    [anon_sym_class] = ACTIONS(1093),
    [anon_sym_AT] = ACTIONS(1095),
    [anon_sym_not] = ACTIONS(1093),
    [anon_sym_PLUS] = ACTIONS(1095),
    [anon_sym_DASH] = ACTIONS(1095),
    [anon_sym_TILDE] = ACTIONS(1095),
    [anon_sym_lambda] = ACTIONS(1093),
    [anon_sym_yield] = ACTIONS(1093),
    [anon_sym_LBRACK] = ACTIONS(1095),
    [sym_ellipsis] = ACTIONS(1095),
    [anon_sym_LBRACE] = ACTIONS(1095),
    [sym_integer] = ACTIONS(1093),
    [sym_float] = ACTIONS(1095),
    [sym_true] = ACTIONS(1093),
    [sym_false] = ACTIONS(1093),
    [sym_none] = ACTIONS(1093),
    [anon_sym_await] = ACTIONS(1093),
    [sym_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(1095),
  },
  [448] = {
    [sym_identifier] = ACTIONS(1107),
    [anon_sym_import] = ACTIONS(1107),
    [anon_sym_from] = ACTIONS(1107),
    [anon_sym_LPAREN] = ACTIONS(1105),
    [anon_sym_print] = ACTIONS(1107),
    [anon_sym_assert] = ACTIONS(1107),
    [anon_sym_return] = ACTIONS(1107),
    [anon_sym_del] = ACTIONS(1107),
    [anon_sym_raise] = ACTIONS(1107),
    [anon_sym_pass] = ACTIONS(1107),
    [anon_sym_break] = ACTIONS(1107),
    [anon_sym_continue] = ACTIONS(1107),
    [anon_sym_if] = ACTIONS(1107),
    [anon_sym_async] = ACTIONS(1107),
    [anon_sym_for] = ACTIONS(1107),
    [anon_sym_while] = ACTIONS(1107),
    [anon_sym_try] = ACTIONS(1107),
    [anon_sym_with] = ACTIONS(1107),
    [anon_sym_def] = ACTIONS(1107),
    [anon_sym_global] = ACTIONS(1107),
    [anon_sym_nonlocal] = ACTIONS(1107),
    [anon_sym_exec] = ACTIONS(1107),
    [anon_sym_class] = ACTIONS(1107),
    [anon_sym_AT] = ACTIONS(1105),
    [anon_sym_not] = ACTIONS(1107),
    [anon_sym_PLUS] = ACTIONS(1105),
    [anon_sym_DASH] = ACTIONS(1105),
    [anon_sym_TILDE] = ACTIONS(1105),
    [anon_sym_lambda] = ACTIONS(1107),
    [anon_sym_yield] = ACTIONS(1107),
    [anon_sym_LBRACK] = ACTIONS(1105),
    [sym_ellipsis] = ACTIONS(1105),
    [anon_sym_LBRACE] = ACTIONS(1105),
    [sym_integer] = ACTIONS(1107),
    [sym_float] = ACTIONS(1105),
    [sym_true] = ACTIONS(1107),
    [sym_false] = ACTIONS(1107),
    [sym_none] = ACTIONS(1107),
    [anon_sym_await] = ACTIONS(1107),
    [sym_comment] = ACTIONS(3),
    [sym__dedent] = ACTIONS(1105),
    [sym__string_start] = ACTIONS(1105),
  },
  [449] = {
    [sym_identifier] = ACTIONS(1103),
    [anon_sym_import] = ACTIONS(1103),
    [anon_sym_from] = ACTIONS(1103),
    [anon_sym_LPAREN] = ACTIONS(1101),
    [anon_sym_print] = ACTIONS(1103),
    [anon_sym_assert] = ACTIONS(1103),
    [anon_sym_return] = ACTIONS(1103),
    [anon_sym_del] = ACTIONS(1103),
    [anon_sym_raise] = ACTIONS(1103),
    [anon_sym_pass] = ACTIONS(1103),
    [anon_sym_break] = ACTIONS(1103),
    [anon_sym_continue] = ACTIONS(1103),
    [anon_sym_if] = ACTIONS(1103),
    [anon_sym_async] = ACTIONS(1103),
    [anon_sym_for] = ACTIONS(1103),
    [anon_sym_while] = ACTIONS(1103),
    [anon_sym_try] = ACTIONS(1103),
    [anon_sym_with] = ACTIONS(1103),
    [anon_sym_def] = ACTIONS(1103),
    [anon_sym_global] = ACTIONS(1103),
    [anon_sym_nonlocal] = ACTIONS(1103),
    [anon_sym_exec] = ACTIONS(1103),
    [anon_sym_class] = ACTIONS(1103),
    [anon_sym_AT] = ACTIONS(1101),
    [anon_sym_not] = ACTIONS(1103),
    [anon_sym_PLUS] = ACTIONS(1101),
    [anon_sym_DASH] = ACTIONS(1101),
    [anon_sym_TILDE] = ACTIONS(1101),
    [anon_sym_lambda] = ACTIONS(1103),
    [anon_sym_yield] = ACTIONS(1103),
    [anon_sym_LBRACK] = ACTIONS(1101),
    [sym_ellipsis] = ACTIONS(1101),
    [anon_sym_LBRACE] = ACTIONS(1101),
    [sym_integer] = ACTIONS(1103),
    [sym_float] = ACTIONS(1101),
    [sym_true] = ACTIONS(1103),
    [sym_false] = ACTIONS(1103),
    [sym_none] = ACTIONS(1103),
    [anon_sym_await] = ACTIONS(1103),
    [sym_comment] = ACTIONS(3),
    [sym__dedent] = ACTIONS(1101),
    [sym__string_start] = ACTIONS(1101),
  },
  [450] = {
    [sym_identifier] = ACTIONS(1099),
    [anon_sym_import] = ACTIONS(1099),
    [anon_sym_from] = ACTIONS(1099),
    [anon_sym_LPAREN] = ACTIONS(1097),
    [anon_sym_print] = ACTIONS(1099),
    [anon_sym_assert] = ACTIONS(1099),
    [anon_sym_return] = ACTIONS(1099),
    [anon_sym_del] = ACTIONS(1099),
    [anon_sym_raise] = ACTIONS(1099),
    [anon_sym_pass] = ACTIONS(1099),
    [anon_sym_break] = ACTIONS(1099),
    [anon_sym_continue] = ACTIONS(1099),
    [anon_sym_if] = ACTIONS(1099),
    [anon_sym_async] = ACTIONS(1099),
    [anon_sym_for] = ACTIONS(1099),
    [anon_sym_while] = ACTIONS(1099),
    [anon_sym_try] = ACTIONS(1099),
    [anon_sym_with] = ACTIONS(1099),
    [anon_sym_def] = ACTIONS(1099),
    [anon_sym_global] = ACTIONS(1099),
    [anon_sym_nonlocal] = ACTIONS(1099),
    [anon_sym_exec] = ACTIONS(1099),
    [anon_sym_class] = ACTIONS(1099),
    [anon_sym_AT] = ACTIONS(1097),
    [anon_sym_not] = ACTIONS(1099),
    [anon_sym_PLUS] = ACTIONS(1097),
    [anon_sym_DASH] = ACTIONS(1097),
    [anon_sym_TILDE] = ACTIONS(1097),
    [anon_sym_lambda] = ACTIONS(1099),
    [anon_sym_yield] = ACTIONS(1099),
    [anon_sym_LBRACK] = ACTIONS(1097),
    [sym_ellipsis] = ACTIONS(1097),
    [anon_sym_LBRACE] = ACTIONS(1097),
    [sym_integer] = ACTIONS(1099),
    [sym_float] = ACTIONS(1097),
    [sym_true] = ACTIONS(1099),
    [sym_false] = ACTIONS(1099),
    [sym_none] = ACTIONS(1099),
    [anon_sym_await] = ACTIONS(1099),
    [sym_comment] = ACTIONS(3),
    [sym__dedent] = ACTIONS(1097),
    [sym__string_start] = ACTIONS(1097),
  },
  [451] = {
    [ts_builtin_sym_end] = ACTIONS(1083),
    [sym_identifier] = ACTIONS(1081),
    [anon_sym_import] = ACTIONS(1081),
    [anon_sym_from] = ACTIONS(1081),
    [anon_sym_LPAREN] = ACTIONS(1083),
    [anon_sym_print] = ACTIONS(1081),
    [anon_sym_assert] = ACTIONS(1081),
    [anon_sym_return] = ACTIONS(1081),
    [anon_sym_del] = ACTIONS(1081),
    [anon_sym_raise] = ACTIONS(1081),
    [anon_sym_pass] = ACTIONS(1081),
    [anon_sym_break] = ACTIONS(1081),
    [anon_sym_continue] = ACTIONS(1081),
    [anon_sym_if] = ACTIONS(1081),
    [anon_sym_async] = ACTIONS(1081),
    [anon_sym_for] = ACTIONS(1081),
    [anon_sym_while] = ACTIONS(1081),
    [anon_sym_try] = ACTIONS(1081),
    [anon_sym_with] = ACTIONS(1081),
    [anon_sym_def] = ACTIONS(1081),
    [anon_sym_global] = ACTIONS(1081),
    [anon_sym_nonlocal] = ACTIONS(1081),
    [anon_sym_exec] = ACTIONS(1081),
    [anon_sym_class] = ACTIONS(1081),
    [anon_sym_AT] = ACTIONS(1083),
    [anon_sym_not] = ACTIONS(1081),
    [anon_sym_PLUS] = ACTIONS(1083),
    [anon_sym_DASH] = ACTIONS(1083),
    [anon_sym_TILDE] = ACTIONS(1083),
    [anon_sym_lambda] = ACTIONS(1081),
    [anon_sym_yield] = ACTIONS(1081),
    [anon_sym_LBRACK] = ACTIONS(1083),
    [sym_ellipsis] = ACTIONS(1083),
    [anon_sym_LBRACE] = ACTIONS(1083),
    [sym_integer] = ACTIONS(1081),
    [sym_float] = ACTIONS(1083),
    [sym_true] = ACTIONS(1081),
    [sym_false] = ACTIONS(1081),
    [sym_none] = ACTIONS(1081),
    [anon_sym_await] = ACTIONS(1081),
    [sym_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(1083),
  },
  [452] = {
    [ts_builtin_sym_end] = ACTIONS(1079),
    [sym_identifier] = ACTIONS(1077),
    [anon_sym_import] = ACTIONS(1077),
    [anon_sym_from] = ACTIONS(1077),
    [anon_sym_LPAREN] = ACTIONS(1079),
    [anon_sym_print] = ACTIONS(1077),
    [anon_sym_assert] = ACTIONS(1077),
    [anon_sym_return] = ACTIONS(1077),
    [anon_sym_del] = ACTIONS(1077),
    [anon_sym_raise] = ACTIONS(1077),
    [anon_sym_pass] = ACTIONS(1077),
    [anon_sym_break] = ACTIONS(1077),
    [anon_sym_continue] = ACTIONS(1077),
    [anon_sym_if] = ACTIONS(1077),
    [anon_sym_async] = ACTIONS(1077),
    [anon_sym_for] = ACTIONS(1077),
    [anon_sym_while] = ACTIONS(1077),
    [anon_sym_try] = ACTIONS(1077),
    [anon_sym_with] = ACTIONS(1077),
    [anon_sym_def] = ACTIONS(1077),
    [anon_sym_global] = ACTIONS(1077),
    [anon_sym_nonlocal] = ACTIONS(1077),
    [anon_sym_exec] = ACTIONS(1077),
    [anon_sym_class] = ACTIONS(1077),
    [anon_sym_AT] = ACTIONS(1079),
    [anon_sym_not] = ACTIONS(1077),
    [anon_sym_PLUS] = ACTIONS(1079),
    [anon_sym_DASH] = ACTIONS(1079),
    [anon_sym_TILDE] = ACTIONS(1079),
    [anon_sym_lambda] = ACTIONS(1077),
    [anon_sym_yield] = ACTIONS(1077),
    [anon_sym_LBRACK] = ACTIONS(1079),
    [sym_ellipsis] = ACTIONS(1079),
    [anon_sym_LBRACE] = ACTIONS(1079),
    [sym_integer] = ACTIONS(1077),
    [sym_float] = ACTIONS(1079),
    [sym_true] = ACTIONS(1077),
    [sym_false] = ACTIONS(1077),
    [sym_none] = ACTIONS(1077),
    [anon_sym_await] = ACTIONS(1077),
    [sym_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(1079),
  },
  [453] = {
    [ts_builtin_sym_end] = ACTIONS(1075),
    [sym_identifier] = ACTIONS(1073),
    [anon_sym_import] = ACTIONS(1073),
    [anon_sym_from] = ACTIONS(1073),
    [anon_sym_LPAREN] = ACTIONS(1075),
    [anon_sym_print] = ACTIONS(1073),
    [anon_sym_assert] = ACTIONS(1073),
    [anon_sym_return] = ACTIONS(1073),
    [anon_sym_del] = ACTIONS(1073),
    [anon_sym_raise] = ACTIONS(1073),
    [anon_sym_pass] = ACTIONS(1073),
    [anon_sym_break] = ACTIONS(1073),
    [anon_sym_continue] = ACTIONS(1073),
    [anon_sym_if] = ACTIONS(1073),
    [anon_sym_async] = ACTIONS(1073),
    [anon_sym_for] = ACTIONS(1073),
    [anon_sym_while] = ACTIONS(1073),
    [anon_sym_try] = ACTIONS(1073),
    [anon_sym_with] = ACTIONS(1073),
    [anon_sym_def] = ACTIONS(1073),
    [anon_sym_global] = ACTIONS(1073),
    [anon_sym_nonlocal] = ACTIONS(1073),
    [anon_sym_exec] = ACTIONS(1073),
    [anon_sym_class] = ACTIONS(1073),
    [anon_sym_AT] = ACTIONS(1075),
    [anon_sym_not] = ACTIONS(1073),
    [anon_sym_PLUS] = ACTIONS(1075),
    [anon_sym_DASH] = ACTIONS(1075),
    [anon_sym_TILDE] = ACTIONS(1075),
    [anon_sym_lambda] = ACTIONS(1073),
    [anon_sym_yield] = ACTIONS(1073),
    [anon_sym_LBRACK] = ACTIONS(1075),
    [sym_ellipsis] = ACTIONS(1075),
    [anon_sym_LBRACE] = ACTIONS(1075),
    [sym_integer] = ACTIONS(1073),
    [sym_float] = ACTIONS(1075),
    [sym_true] = ACTIONS(1073),
    [sym_false] = ACTIONS(1073),
    [sym_none] = ACTIONS(1073),
    [anon_sym_await] = ACTIONS(1073),
    [sym_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(1075),
  },
  [454] = {
    [ts_builtin_sym_end] = ACTIONS(1063),
    [sym_identifier] = ACTIONS(1061),
    [anon_sym_import] = ACTIONS(1061),
    [anon_sym_from] = ACTIONS(1061),
    [anon_sym_LPAREN] = ACTIONS(1063),
    [anon_sym_print] = ACTIONS(1061),
    [anon_sym_assert] = ACTIONS(1061),
    [anon_sym_return] = ACTIONS(1061),
    [anon_sym_del] = ACTIONS(1061),
    [anon_sym_raise] = ACTIONS(1061),
    [anon_sym_pass] = ACTIONS(1061),
    [anon_sym_break] = ACTIONS(1061),
    [anon_sym_continue] = ACTIONS(1061),
    [anon_sym_if] = ACTIONS(1061),
    [anon_sym_async] = ACTIONS(1061),
    [anon_sym_for] = ACTIONS(1061),
    [anon_sym_while] = ACTIONS(1061),
    [anon_sym_try] = ACTIONS(1061),
    [anon_sym_with] = ACTIONS(1061),
    [anon_sym_def] = ACTIONS(1061),
    [anon_sym_global] = ACTIONS(1061),
    [anon_sym_nonlocal] = ACTIONS(1061),
    [anon_sym_exec] = ACTIONS(1061),
    [anon_sym_class] = ACTIONS(1061),
    [anon_sym_AT] = ACTIONS(1063),
    [anon_sym_not] = ACTIONS(1061),
    [anon_sym_PLUS] = ACTIONS(1063),
    [anon_sym_DASH] = ACTIONS(1063),
    [anon_sym_TILDE] = ACTIONS(1063),
    [anon_sym_lambda] = ACTIONS(1061),
    [anon_sym_yield] = ACTIONS(1061),
    [anon_sym_LBRACK] = ACTIONS(1063),
    [sym_ellipsis] = ACTIONS(1063),
    [anon_sym_LBRACE] = ACTIONS(1063),
    [sym_integer] = ACTIONS(1061),
    [sym_float] = ACTIONS(1063),
    [sym_true] = ACTIONS(1061),
    [sym_false] = ACTIONS(1061),
    [sym_none] = ACTIONS(1061),
    [anon_sym_await] = ACTIONS(1061),
    [sym_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(1063),
  },
  [455] = {
    [ts_builtin_sym_end] = ACTIONS(1059),
    [sym_identifier] = ACTIONS(1057),
    [anon_sym_import] = ACTIONS(1057),
    [anon_sym_from] = ACTIONS(1057),
    [anon_sym_LPAREN] = ACTIONS(1059),
    [anon_sym_print] = ACTIONS(1057),
    [anon_sym_assert] = ACTIONS(1057),
    [anon_sym_return] = ACTIONS(1057),
    [anon_sym_del] = ACTIONS(1057),
    [anon_sym_raise] = ACTIONS(1057),
    [anon_sym_pass] = ACTIONS(1057),
    [anon_sym_break] = ACTIONS(1057),
    [anon_sym_continue] = ACTIONS(1057),
    [anon_sym_if] = ACTIONS(1057),
    [anon_sym_async] = ACTIONS(1057),
    [anon_sym_for] = ACTIONS(1057),
    [anon_sym_while] = ACTIONS(1057),
    [anon_sym_try] = ACTIONS(1057),
    [anon_sym_with] = ACTIONS(1057),
    [anon_sym_def] = ACTIONS(1057),
    [anon_sym_global] = ACTIONS(1057),
    [anon_sym_nonlocal] = ACTIONS(1057),
    [anon_sym_exec] = ACTIONS(1057),
    [anon_sym_class] = ACTIONS(1057),
    [anon_sym_AT] = ACTIONS(1059),
    [anon_sym_not] = ACTIONS(1057),
    [anon_sym_PLUS] = ACTIONS(1059),
    [anon_sym_DASH] = ACTIONS(1059),
    [anon_sym_TILDE] = ACTIONS(1059),
    [anon_sym_lambda] = ACTIONS(1057),
    [anon_sym_yield] = ACTIONS(1057),
    [anon_sym_LBRACK] = ACTIONS(1059),
    [sym_ellipsis] = ACTIONS(1059),
    [anon_sym_LBRACE] = ACTIONS(1059),
    [sym_integer] = ACTIONS(1057),
    [sym_float] = ACTIONS(1059),
    [sym_true] = ACTIONS(1057),
    [sym_false] = ACTIONS(1057),
    [sym_none] = ACTIONS(1057),
    [anon_sym_await] = ACTIONS(1057),
    [sym_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(1059),
  },
  [456] = {
    [ts_builtin_sym_end] = ACTIONS(1055),
    [sym_identifier] = ACTIONS(1053),
    [anon_sym_import] = ACTIONS(1053),
    [anon_sym_from] = ACTIONS(1053),
    [anon_sym_LPAREN] = ACTIONS(1055),
    [anon_sym_print] = ACTIONS(1053),
    [anon_sym_assert] = ACTIONS(1053),
    [anon_sym_return] = ACTIONS(1053),
    [anon_sym_del] = ACTIONS(1053),
    [anon_sym_raise] = ACTIONS(1053),
    [anon_sym_pass] = ACTIONS(1053),
    [anon_sym_break] = ACTIONS(1053),
    [anon_sym_continue] = ACTIONS(1053),
    [anon_sym_if] = ACTIONS(1053),
    [anon_sym_async] = ACTIONS(1053),
    [anon_sym_for] = ACTIONS(1053),
    [anon_sym_while] = ACTIONS(1053),
    [anon_sym_try] = ACTIONS(1053),
    [anon_sym_with] = ACTIONS(1053),
    [anon_sym_def] = ACTIONS(1053),
    [anon_sym_global] = ACTIONS(1053),
    [anon_sym_nonlocal] = ACTIONS(1053),
    [anon_sym_exec] = ACTIONS(1053),
    [anon_sym_class] = ACTIONS(1053),
    [anon_sym_AT] = ACTIONS(1055),
    [anon_sym_not] = ACTIONS(1053),
    [anon_sym_PLUS] = ACTIONS(1055),
    [anon_sym_DASH] = ACTIONS(1055),
    [anon_sym_TILDE] = ACTIONS(1055),
    [anon_sym_lambda] = ACTIONS(1053),
    [anon_sym_yield] = ACTIONS(1053),
    [anon_sym_LBRACK] = ACTIONS(1055),
    [sym_ellipsis] = ACTIONS(1055),
    [anon_sym_LBRACE] = ACTIONS(1055),
    [sym_integer] = ACTIONS(1053),
    [sym_float] = ACTIONS(1055),
    [sym_true] = ACTIONS(1053),
    [sym_false] = ACTIONS(1053),
    [sym_none] = ACTIONS(1053),
    [anon_sym_await] = ACTIONS(1053),
    [sym_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(1055),
  },
  [457] = {
    [sym_identifier] = ACTIONS(1091),
    [anon_sym_import] = ACTIONS(1091),
    [anon_sym_from] = ACTIONS(1091),
    [anon_sym_LPAREN] = ACTIONS(1089),
    [anon_sym_print] = ACTIONS(1091),
    [anon_sym_assert] = ACTIONS(1091),
    [anon_sym_return] = ACTIONS(1091),
    [anon_sym_del] = ACTIONS(1091),
    [anon_sym_raise] = ACTIONS(1091),
    [anon_sym_pass] = ACTIONS(1091),
    [anon_sym_break] = ACTIONS(1091),
    [anon_sym_continue] = ACTIONS(1091),
    [anon_sym_if] = ACTIONS(1091),
    [anon_sym_async] = ACTIONS(1091),
    [anon_sym_for] = ACTIONS(1091),
    [anon_sym_while] = ACTIONS(1091),
    [anon_sym_try] = ACTIONS(1091),
    [anon_sym_with] = ACTIONS(1091),
    [anon_sym_def] = ACTIONS(1091),
    [anon_sym_global] = ACTIONS(1091),
    [anon_sym_nonlocal] = ACTIONS(1091),
    [anon_sym_exec] = ACTIONS(1091),
    [anon_sym_class] = ACTIONS(1091),
    [anon_sym_AT] = ACTIONS(1089),
    [anon_sym_not] = ACTIONS(1091),
    [anon_sym_PLUS] = ACTIONS(1089),
    [anon_sym_DASH] = ACTIONS(1089),
    [anon_sym_TILDE] = ACTIONS(1089),
    [anon_sym_lambda] = ACTIONS(1091),
    [anon_sym_yield] = ACTIONS(1091),
    [anon_sym_LBRACK] = ACTIONS(1089),
    [sym_ellipsis] = ACTIONS(1089),
    [anon_sym_LBRACE] = ACTIONS(1089),
    [sym_integer] = ACTIONS(1091),
    [sym_float] = ACTIONS(1089),
    [sym_true] = ACTIONS(1091),
    [sym_false] = ACTIONS(1091),
    [sym_none] = ACTIONS(1091),
    [anon_sym_await] = ACTIONS(1091),
    [sym_comment] = ACTIONS(3),
    [sym__dedent] = ACTIONS(1089),
    [sym__string_start] = ACTIONS(1089),
  },
  [458] = {
    [sym_identifier] = ACTIONS(1087),
    [anon_sym_import] = ACTIONS(1087),
    [anon_sym_from] = ACTIONS(1087),
    [anon_sym_LPAREN] = ACTIONS(1085),
    [anon_sym_print] = ACTIONS(1087),
    [anon_sym_assert] = ACTIONS(1087),
    [anon_sym_return] = ACTIONS(1087),
    [anon_sym_del] = ACTIONS(1087),
    [anon_sym_raise] = ACTIONS(1087),
    [anon_sym_pass] = ACTIONS(1087),
    [anon_sym_break] = ACTIONS(1087),
    [anon_sym_continue] = ACTIONS(1087),
    [anon_sym_if] = ACTIONS(1087),
    [anon_sym_async] = ACTIONS(1087),
    [anon_sym_for] = ACTIONS(1087),
    [anon_sym_while] = ACTIONS(1087),
    [anon_sym_try] = ACTIONS(1087),
    [anon_sym_with] = ACTIONS(1087),
    [anon_sym_def] = ACTIONS(1087),
    [anon_sym_global] = ACTIONS(1087),
    [anon_sym_nonlocal] = ACTIONS(1087),
    [anon_sym_exec] = ACTIONS(1087),
    [anon_sym_class] = ACTIONS(1087),
    [anon_sym_AT] = ACTIONS(1085),
    [anon_sym_not] = ACTIONS(1087),
    [anon_sym_PLUS] = ACTIONS(1085),
    [anon_sym_DASH] = ACTIONS(1085),
    [anon_sym_TILDE] = ACTIONS(1085),
    [anon_sym_lambda] = ACTIONS(1087),
    [anon_sym_yield] = ACTIONS(1087),
    [anon_sym_LBRACK] = ACTIONS(1085),
    [sym_ellipsis] = ACTIONS(1085),
    [anon_sym_LBRACE] = ACTIONS(1085),
    [sym_integer] = ACTIONS(1087),
    [sym_float] = ACTIONS(1085),
    [sym_true] = ACTIONS(1087),
    [sym_false] = ACTIONS(1087),
    [sym_none] = ACTIONS(1087),
    [anon_sym_await] = ACTIONS(1087),
    [sym_comment] = ACTIONS(3),
    [sym__dedent] = ACTIONS(1085),
    [sym__string_start] = ACTIONS(1085),
  },
  [459] = {
    [ts_builtin_sym_end] = ACTIONS(1051),
    [sym_identifier] = ACTIONS(1049),
    [anon_sym_import] = ACTIONS(1049),
    [anon_sym_from] = ACTIONS(1049),
    [anon_sym_LPAREN] = ACTIONS(1051),
    [anon_sym_print] = ACTIONS(1049),
    [anon_sym_assert] = ACTIONS(1049),
    [anon_sym_return] = ACTIONS(1049),
    [anon_sym_del] = ACTIONS(1049),
    [anon_sym_raise] = ACTIONS(1049),
    [anon_sym_pass] = ACTIONS(1049),
    [anon_sym_break] = ACTIONS(1049),
    [anon_sym_continue] = ACTIONS(1049),
    [anon_sym_if] = ACTIONS(1049),
    [anon_sym_async] = ACTIONS(1049),
    [anon_sym_for] = ACTIONS(1049),
    [anon_sym_while] = ACTIONS(1049),
    [anon_sym_try] = ACTIONS(1049),
    [anon_sym_with] = ACTIONS(1049),
    [anon_sym_def] = ACTIONS(1049),
    [anon_sym_global] = ACTIONS(1049),
    [anon_sym_nonlocal] = ACTIONS(1049),
    [anon_sym_exec] = ACTIONS(1049),
    [anon_sym_class] = ACTIONS(1049),
    [anon_sym_AT] = ACTIONS(1051),
    [anon_sym_not] = ACTIONS(1049),
    [anon_sym_PLUS] = ACTIONS(1051),
    [anon_sym_DASH] = ACTIONS(1051),
    [anon_sym_TILDE] = ACTIONS(1051),
    [anon_sym_lambda] = ACTIONS(1049),
    [anon_sym_yield] = ACTIONS(1049),
    [anon_sym_LBRACK] = ACTIONS(1051),
    [sym_ellipsis] = ACTIONS(1051),
    [anon_sym_LBRACE] = ACTIONS(1051),
    [sym_integer] = ACTIONS(1049),
    [sym_float] = ACTIONS(1051),
    [sym_true] = ACTIONS(1049),
    [sym_false] = ACTIONS(1049),
    [sym_none] = ACTIONS(1049),
    [anon_sym_await] = ACTIONS(1049),
    [sym_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(1051),
  },
  [460] = {
    [ts_builtin_sym_end] = ACTIONS(1067),
    [sym_identifier] = ACTIONS(1065),
    [anon_sym_import] = ACTIONS(1065),
    [anon_sym_from] = ACTIONS(1065),
    [anon_sym_LPAREN] = ACTIONS(1067),
    [anon_sym_print] = ACTIONS(1065),
    [anon_sym_assert] = ACTIONS(1065),
    [anon_sym_return] = ACTIONS(1065),
    [anon_sym_del] = ACTIONS(1065),
    [anon_sym_raise] = ACTIONS(1065),
    [anon_sym_pass] = ACTIONS(1065),
    [anon_sym_break] = ACTIONS(1065),
    [anon_sym_continue] = ACTIONS(1065),
    [anon_sym_if] = ACTIONS(1065),
    [anon_sym_async] = ACTIONS(1065),
    [anon_sym_for] = ACTIONS(1065),
    [anon_sym_while] = ACTIONS(1065),
    [anon_sym_try] = ACTIONS(1065),
    [anon_sym_with] = ACTIONS(1065),
    [anon_sym_def] = ACTIONS(1065),
    [anon_sym_global] = ACTIONS(1065),
    [anon_sym_nonlocal] = ACTIONS(1065),
    [anon_sym_exec] = ACTIONS(1065),
    [anon_sym_class] = ACTIONS(1065),
    [anon_sym_AT] = ACTIONS(1067),
    [anon_sym_not] = ACTIONS(1065),
    [anon_sym_PLUS] = ACTIONS(1067),
    [anon_sym_DASH] = ACTIONS(1067),
    [anon_sym_TILDE] = ACTIONS(1067),
    [anon_sym_lambda] = ACTIONS(1065),
    [anon_sym_yield] = ACTIONS(1065),
    [anon_sym_LBRACK] = ACTIONS(1067),
    [sym_ellipsis] = ACTIONS(1067),
    [anon_sym_LBRACE] = ACTIONS(1067),
    [sym_integer] = ACTIONS(1065),
    [sym_float] = ACTIONS(1067),
    [sym_true] = ACTIONS(1065),
    [sym_false] = ACTIONS(1065),
    [sym_none] = ACTIONS(1065),
    [anon_sym_await] = ACTIONS(1065),
    [sym_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(1067),
  },
  [461] = {
    [ts_builtin_sym_end] = ACTIONS(987),
    [sym_identifier] = ACTIONS(985),
    [anon_sym_import] = ACTIONS(985),
    [anon_sym_from] = ACTIONS(985),
    [anon_sym_LPAREN] = ACTIONS(987),
    [anon_sym_print] = ACTIONS(985),
    [anon_sym_assert] = ACTIONS(985),
    [anon_sym_return] = ACTIONS(985),
    [anon_sym_del] = ACTIONS(985),
    [anon_sym_raise] = ACTIONS(985),
    [anon_sym_pass] = ACTIONS(985),
    [anon_sym_break] = ACTIONS(985),
    [anon_sym_continue] = ACTIONS(985),
    [anon_sym_if] = ACTIONS(985),
    [anon_sym_async] = ACTIONS(985),
    [anon_sym_for] = ACTIONS(985),
    [anon_sym_while] = ACTIONS(985),
    [anon_sym_try] = ACTIONS(985),
    [anon_sym_with] = ACTIONS(985),
    [anon_sym_def] = ACTIONS(985),
    [anon_sym_global] = ACTIONS(985),
    [anon_sym_nonlocal] = ACTIONS(985),
    [anon_sym_exec] = ACTIONS(985),
    [anon_sym_class] = ACTIONS(985),
    [anon_sym_AT] = ACTIONS(987),
    [anon_sym_not] = ACTIONS(985),
    [anon_sym_PLUS] = ACTIONS(987),
    [anon_sym_DASH] = ACTIONS(987),
    [anon_sym_TILDE] = ACTIONS(987),
    [anon_sym_lambda] = ACTIONS(985),
    [anon_sym_yield] = ACTIONS(985),
    [anon_sym_LBRACK] = ACTIONS(987),
    [sym_ellipsis] = ACTIONS(987),
    [anon_sym_LBRACE] = ACTIONS(987),
    [sym_integer] = ACTIONS(985),
    [sym_float] = ACTIONS(987),
    [sym_true] = ACTIONS(985),
    [sym_false] = ACTIONS(985),
    [sym_none] = ACTIONS(985),
    [anon_sym_await] = ACTIONS(985),
    [sym_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(987),
  },
  [462] = {
    [ts_builtin_sym_end] = ACTIONS(991),
    [sym_identifier] = ACTIONS(989),
    [anon_sym_import] = ACTIONS(989),
    [anon_sym_from] = ACTIONS(989),
    [anon_sym_LPAREN] = ACTIONS(991),
    [anon_sym_print] = ACTIONS(989),
    [anon_sym_assert] = ACTIONS(989),
    [anon_sym_return] = ACTIONS(989),
    [anon_sym_del] = ACTIONS(989),
    [anon_sym_raise] = ACTIONS(989),
    [anon_sym_pass] = ACTIONS(989),
    [anon_sym_break] = ACTIONS(989),
    [anon_sym_continue] = ACTIONS(989),
    [anon_sym_if] = ACTIONS(989),
    [anon_sym_async] = ACTIONS(989),
    [anon_sym_for] = ACTIONS(989),
    [anon_sym_while] = ACTIONS(989),
    [anon_sym_try] = ACTIONS(989),
    [anon_sym_with] = ACTIONS(989),
    [anon_sym_def] = ACTIONS(989),
    [anon_sym_global] = ACTIONS(989),
    [anon_sym_nonlocal] = ACTIONS(989),
    [anon_sym_exec] = ACTIONS(989),
    [anon_sym_class] = ACTIONS(989),
    [anon_sym_AT] = ACTIONS(991),
    [anon_sym_not] = ACTIONS(989),
    [anon_sym_PLUS] = ACTIONS(991),
    [anon_sym_DASH] = ACTIONS(991),
    [anon_sym_TILDE] = ACTIONS(991),
    [anon_sym_lambda] = ACTIONS(989),
    [anon_sym_yield] = ACTIONS(989),
    [anon_sym_LBRACK] = ACTIONS(991),
    [sym_ellipsis] = ACTIONS(991),
    [anon_sym_LBRACE] = ACTIONS(991),
    [sym_integer] = ACTIONS(989),
    [sym_float] = ACTIONS(991),
    [sym_true] = ACTIONS(989),
    [sym_false] = ACTIONS(989),
    [sym_none] = ACTIONS(989),
    [anon_sym_await] = ACTIONS(989),
    [sym_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(991),
  },
  [463] = {
    [ts_builtin_sym_end] = ACTIONS(995),
    [sym_identifier] = ACTIONS(993),
    [anon_sym_import] = ACTIONS(993),
    [anon_sym_from] = ACTIONS(993),
    [anon_sym_LPAREN] = ACTIONS(995),
    [anon_sym_print] = ACTIONS(993),
    [anon_sym_assert] = ACTIONS(993),
    [anon_sym_return] = ACTIONS(993),
    [anon_sym_del] = ACTIONS(993),
    [anon_sym_raise] = ACTIONS(993),
    [anon_sym_pass] = ACTIONS(993),
    [anon_sym_break] = ACTIONS(993),
    [anon_sym_continue] = ACTIONS(993),
    [anon_sym_if] = ACTIONS(993),
    [anon_sym_async] = ACTIONS(993),
    [anon_sym_for] = ACTIONS(993),
    [anon_sym_while] = ACTIONS(993),
    [anon_sym_try] = ACTIONS(993),
    [anon_sym_with] = ACTIONS(993),
    [anon_sym_def] = ACTIONS(993),
    [anon_sym_global] = ACTIONS(993),
    [anon_sym_nonlocal] = ACTIONS(993),
    [anon_sym_exec] = ACTIONS(993),
    [anon_sym_class] = ACTIONS(993),
    [anon_sym_AT] = ACTIONS(995),
    [anon_sym_not] = ACTIONS(993),
    [anon_sym_PLUS] = ACTIONS(995),
    [anon_sym_DASH] = ACTIONS(995),
    [anon_sym_TILDE] = ACTIONS(995),
    [anon_sym_lambda] = ACTIONS(993),
    [anon_sym_yield] = ACTIONS(993),
    [anon_sym_LBRACK] = ACTIONS(995),
    [sym_ellipsis] = ACTIONS(995),
    [anon_sym_LBRACE] = ACTIONS(995),
    [sym_integer] = ACTIONS(993),
    [sym_float] = ACTIONS(995),
    [sym_true] = ACTIONS(993),
    [sym_false] = ACTIONS(993),
    [sym_none] = ACTIONS(993),
    [anon_sym_await] = ACTIONS(993),
    [sym_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(995),
  },
  [464] = {
    [ts_builtin_sym_end] = ACTIONS(906),
    [sym_identifier] = ACTIONS(904),
    [anon_sym_import] = ACTIONS(904),
    [anon_sym_from] = ACTIONS(904),
    [anon_sym_LPAREN] = ACTIONS(906),
    [anon_sym_print] = ACTIONS(904),
    [anon_sym_assert] = ACTIONS(904),
    [anon_sym_return] = ACTIONS(904),
    [anon_sym_del] = ACTIONS(904),
    [anon_sym_raise] = ACTIONS(904),
    [anon_sym_pass] = ACTIONS(904),
    [anon_sym_break] = ACTIONS(904),
    [anon_sym_continue] = ACTIONS(904),
    [anon_sym_if] = ACTIONS(904),
    [anon_sym_async] = ACTIONS(904),
    [anon_sym_for] = ACTIONS(904),
    [anon_sym_while] = ACTIONS(904),
    [anon_sym_try] = ACTIONS(904),
    [anon_sym_with] = ACTIONS(904),
    [anon_sym_def] = ACTIONS(904),
    [anon_sym_global] = ACTIONS(904),
    [anon_sym_nonlocal] = ACTIONS(904),
    [anon_sym_exec] = ACTIONS(904),
    [anon_sym_class] = ACTIONS(904),
    [anon_sym_AT] = ACTIONS(906),
    [anon_sym_not] = ACTIONS(904),
    [anon_sym_PLUS] = ACTIONS(906),
    [anon_sym_DASH] = ACTIONS(906),
    [anon_sym_TILDE] = ACTIONS(906),
    [anon_sym_lambda] = ACTIONS(904),
    [anon_sym_yield] = ACTIONS(904),
    [anon_sym_LBRACK] = ACTIONS(906),
    [sym_ellipsis] = ACTIONS(906),
    [anon_sym_LBRACE] = ACTIONS(906),
    [sym_integer] = ACTIONS(904),
    [sym_float] = ACTIONS(906),
    [sym_true] = ACTIONS(904),
    [sym_false] = ACTIONS(904),
    [sym_none] = ACTIONS(904),
    [anon_sym_await] = ACTIONS(904),
    [sym_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(906),
  },
  [465] = {
    [ts_builtin_sym_end] = ACTIONS(1011),
    [sym_identifier] = ACTIONS(1009),
    [anon_sym_import] = ACTIONS(1009),
    [anon_sym_from] = ACTIONS(1009),
    [anon_sym_LPAREN] = ACTIONS(1011),
    [anon_sym_print] = ACTIONS(1009),
    [anon_sym_assert] = ACTIONS(1009),
    [anon_sym_return] = ACTIONS(1009),
    [anon_sym_del] = ACTIONS(1009),
    [anon_sym_raise] = ACTIONS(1009),
    [anon_sym_pass] = ACTIONS(1009),
    [anon_sym_break] = ACTIONS(1009),
    [anon_sym_continue] = ACTIONS(1009),
    [anon_sym_if] = ACTIONS(1009),
    [anon_sym_async] = ACTIONS(1009),
    [anon_sym_for] = ACTIONS(1009),
    [anon_sym_while] = ACTIONS(1009),
    [anon_sym_try] = ACTIONS(1009),
    [anon_sym_with] = ACTIONS(1009),
    [anon_sym_def] = ACTIONS(1009),
    [anon_sym_global] = ACTIONS(1009),
    [anon_sym_nonlocal] = ACTIONS(1009),
    [anon_sym_exec] = ACTIONS(1009),
    [anon_sym_class] = ACTIONS(1009),
    [anon_sym_AT] = ACTIONS(1011),
    [anon_sym_not] = ACTIONS(1009),
    [anon_sym_PLUS] = ACTIONS(1011),
    [anon_sym_DASH] = ACTIONS(1011),
    [anon_sym_TILDE] = ACTIONS(1011),
    [anon_sym_lambda] = ACTIONS(1009),
    [anon_sym_yield] = ACTIONS(1009),
    [anon_sym_LBRACK] = ACTIONS(1011),
    [sym_ellipsis] = ACTIONS(1011),
    [anon_sym_LBRACE] = ACTIONS(1011),
    [sym_integer] = ACTIONS(1009),
    [sym_float] = ACTIONS(1011),
    [sym_true] = ACTIONS(1009),
    [sym_false] = ACTIONS(1009),
    [sym_none] = ACTIONS(1009),
    [anon_sym_await] = ACTIONS(1009),
    [sym_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(1011),
  },
  [466] = {
    [ts_builtin_sym_end] = ACTIONS(1071),
    [sym_identifier] = ACTIONS(1069),
    [anon_sym_import] = ACTIONS(1069),
    [anon_sym_from] = ACTIONS(1069),
    [anon_sym_LPAREN] = ACTIONS(1071),
    [anon_sym_print] = ACTIONS(1069),
    [anon_sym_assert] = ACTIONS(1069),
    [anon_sym_return] = ACTIONS(1069),
    [anon_sym_del] = ACTIONS(1069),
    [anon_sym_raise] = ACTIONS(1069),
    [anon_sym_pass] = ACTIONS(1069),
    [anon_sym_break] = ACTIONS(1069),
    [anon_sym_continue] = ACTIONS(1069),
    [anon_sym_if] = ACTIONS(1069),
    [anon_sym_async] = ACTIONS(1069),
    [anon_sym_for] = ACTIONS(1069),
    [anon_sym_while] = ACTIONS(1069),
    [anon_sym_try] = ACTIONS(1069),
    [anon_sym_with] = ACTIONS(1069),
    [anon_sym_def] = ACTIONS(1069),
    [anon_sym_global] = ACTIONS(1069),
    [anon_sym_nonlocal] = ACTIONS(1069),
    [anon_sym_exec] = ACTIONS(1069),
    [anon_sym_class] = ACTIONS(1069),
    [anon_sym_AT] = ACTIONS(1071),
    [anon_sym_not] = ACTIONS(1069),
    [anon_sym_PLUS] = ACTIONS(1071),
    [anon_sym_DASH] = ACTIONS(1071),
    [anon_sym_TILDE] = ACTIONS(1071),
    [anon_sym_lambda] = ACTIONS(1069),
    [anon_sym_yield] = ACTIONS(1069),
    [anon_sym_LBRACK] = ACTIONS(1071),
    [sym_ellipsis] = ACTIONS(1071),
    [anon_sym_LBRACE] = ACTIONS(1071),
    [sym_integer] = ACTIONS(1069),
    [sym_float] = ACTIONS(1071),
    [sym_true] = ACTIONS(1069),
    [sym_false] = ACTIONS(1069),
    [sym_none] = ACTIONS(1069),
    [anon_sym_await] = ACTIONS(1069),
    [sym_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(1071),
  },
  [467] = {
    [ts_builtin_sym_end] = ACTIONS(1019),
    [sym_identifier] = ACTIONS(1017),
    [anon_sym_import] = ACTIONS(1017),
    [anon_sym_from] = ACTIONS(1017),
    [anon_sym_LPAREN] = ACTIONS(1019),
    [anon_sym_print] = ACTIONS(1017),
    [anon_sym_assert] = ACTIONS(1017),
    [anon_sym_return] = ACTIONS(1017),
    [anon_sym_del] = ACTIONS(1017),
    [anon_sym_raise] = ACTIONS(1017),
    [anon_sym_pass] = ACTIONS(1017),
    [anon_sym_break] = ACTIONS(1017),
    [anon_sym_continue] = ACTIONS(1017),
    [anon_sym_if] = ACTIONS(1017),
    [anon_sym_async] = ACTIONS(1017),
    [anon_sym_for] = ACTIONS(1017),
    [anon_sym_while] = ACTIONS(1017),
    [anon_sym_try] = ACTIONS(1017),
    [anon_sym_with] = ACTIONS(1017),
    [anon_sym_def] = ACTIONS(1017),
    [anon_sym_global] = ACTIONS(1017),
    [anon_sym_nonlocal] = ACTIONS(1017),
    [anon_sym_exec] = ACTIONS(1017),
    [anon_sym_class] = ACTIONS(1017),
    [anon_sym_AT] = ACTIONS(1019),
    [anon_sym_not] = ACTIONS(1017),
    [anon_sym_PLUS] = ACTIONS(1019),
    [anon_sym_DASH] = ACTIONS(1019),
    [anon_sym_TILDE] = ACTIONS(1019),
    [anon_sym_lambda] = ACTIONS(1017),
    [anon_sym_yield] = ACTIONS(1017),
    [anon_sym_LBRACK] = ACTIONS(1019),
    [sym_ellipsis] = ACTIONS(1019),
    [anon_sym_LBRACE] = ACTIONS(1019),
    [sym_integer] = ACTIONS(1017),
    [sym_float] = ACTIONS(1019),
    [sym_true] = ACTIONS(1017),
    [sym_false] = ACTIONS(1017),
    [sym_none] = ACTIONS(1017),
    [anon_sym_await] = ACTIONS(1017),
    [sym_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(1019),
  },
  [468] = {
    [ts_builtin_sym_end] = ACTIONS(1007),
    [sym_identifier] = ACTIONS(1005),
    [anon_sym_import] = ACTIONS(1005),
    [anon_sym_from] = ACTIONS(1005),
    [anon_sym_LPAREN] = ACTIONS(1007),
    [anon_sym_print] = ACTIONS(1005),
    [anon_sym_assert] = ACTIONS(1005),
    [anon_sym_return] = ACTIONS(1005),
    [anon_sym_del] = ACTIONS(1005),
    [anon_sym_raise] = ACTIONS(1005),
    [anon_sym_pass] = ACTIONS(1005),
    [anon_sym_break] = ACTIONS(1005),
    [anon_sym_continue] = ACTIONS(1005),
    [anon_sym_if] = ACTIONS(1005),
    [anon_sym_async] = ACTIONS(1005),
    [anon_sym_for] = ACTIONS(1005),
    [anon_sym_while] = ACTIONS(1005),
    [anon_sym_try] = ACTIONS(1005),
    [anon_sym_with] = ACTIONS(1005),
    [anon_sym_def] = ACTIONS(1005),
    [anon_sym_global] = ACTIONS(1005),
    [anon_sym_nonlocal] = ACTIONS(1005),
    [anon_sym_exec] = ACTIONS(1005),
    [anon_sym_class] = ACTIONS(1005),
    [anon_sym_AT] = ACTIONS(1007),
    [anon_sym_not] = ACTIONS(1005),
    [anon_sym_PLUS] = ACTIONS(1007),
    [anon_sym_DASH] = ACTIONS(1007),
    [anon_sym_TILDE] = ACTIONS(1007),
    [anon_sym_lambda] = ACTIONS(1005),
    [anon_sym_yield] = ACTIONS(1005),
    [anon_sym_LBRACK] = ACTIONS(1007),
    [sym_ellipsis] = ACTIONS(1007),
    [anon_sym_LBRACE] = ACTIONS(1007),
    [sym_integer] = ACTIONS(1005),
    [sym_float] = ACTIONS(1007),
    [sym_true] = ACTIONS(1005),
    [sym_false] = ACTIONS(1005),
    [sym_none] = ACTIONS(1005),
    [anon_sym_await] = ACTIONS(1005),
    [sym_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(1007),
  },
  [469] = {
    [anon_sym_DOT] = ACTIONS(467),
    [anon_sym_LPAREN] = ACTIONS(467),
    [anon_sym_RPAREN] = ACTIONS(467),
    [anon_sym_COMMA] = ACTIONS(467),
    [anon_sym_STAR] = ACTIONS(469),
    [anon_sym_GT_GT] = ACTIONS(467),
    [anon_sym_COLON_EQ] = ACTIONS(1109),
    [anon_sym_if] = ACTIONS(467),
    [anon_sym_COLON] = ACTIONS(469),
    [anon_sym_else] = ACTIONS(467),
    [anon_sym_async] = ACTIONS(467),
    [anon_sym_for] = ACTIONS(467),
    [anon_sym_in] = ACTIONS(467),
    [anon_sym_EQ] = ACTIONS(469),
    [anon_sym_STAR_STAR] = ACTIONS(467),
    [anon_sym_AT] = ACTIONS(467),
    [anon_sym_not] = ACTIONS(467),
    [anon_sym_and] = ACTIONS(467),
    [anon_sym_or] = ACTIONS(467),
    [anon_sym_PLUS] = ACTIONS(467),
    [anon_sym_DASH] = ACTIONS(467),
    [anon_sym_SLASH] = ACTIONS(469),
    [anon_sym_PERCENT] = ACTIONS(467),
    [anon_sym_SLASH_SLASH] = ACTIONS(467),
    [anon_sym_PIPE] = ACTIONS(467),
    [anon_sym_AMP] = ACTIONS(467),
    [anon_sym_CARET] = ACTIONS(467),
    [anon_sym_LT_LT] = ACTIONS(467),
    [anon_sym_LT] = ACTIONS(469),
    [anon_sym_LT_EQ] = ACTIONS(467),
    [anon_sym_EQ_EQ] = ACTIONS(467),
    [anon_sym_BANG_EQ] = ACTIONS(467),
    [anon_sym_GT_EQ] = ACTIONS(467),
    [anon_sym_GT] = ACTIONS(469),
    [anon_sym_LT_GT] = ACTIONS(467),
    [anon_sym_is] = ACTIONS(467),
    [anon_sym_LBRACK] = ACTIONS(467),
    [anon_sym_RBRACK] = ACTIONS(467),
    [anon_sym_RBRACE] = ACTIONS(467),
    [sym_type_conversion] = ACTIONS(467),
    [sym_comment] = ACTIONS(3),
  },
  [470] = {
    [anon_sym_DOT] = ACTIONS(506),
    [anon_sym_LPAREN] = ACTIONS(506),
    [anon_sym_RPAREN] = ACTIONS(506),
    [anon_sym_COMMA] = ACTIONS(506),
    [anon_sym_STAR] = ACTIONS(508),
    [anon_sym_GT_GT] = ACTIONS(506),
    [anon_sym_if] = ACTIONS(506),
    [anon_sym_COLON] = ACTIONS(506),
    [anon_sym_else] = ACTIONS(506),
    [anon_sym_async] = ACTIONS(506),
    [anon_sym_for] = ACTIONS(506),
    [anon_sym_in] = ACTIONS(506),
    [anon_sym_EQ] = ACTIONS(508),
    [anon_sym_STAR_STAR] = ACTIONS(506),
    [anon_sym_AT] = ACTIONS(506),
    [anon_sym_not] = ACTIONS(506),
    [anon_sym_and] = ACTIONS(506),
    [anon_sym_or] = ACTIONS(506),
    [anon_sym_PLUS] = ACTIONS(506),
    [anon_sym_DASH] = ACTIONS(506),
    [anon_sym_SLASH] = ACTIONS(508),
    [anon_sym_PERCENT] = ACTIONS(506),
    [anon_sym_SLASH_SLASH] = ACTIONS(506),
    [anon_sym_PIPE] = ACTIONS(506),
    [anon_sym_AMP] = ACTIONS(506),
    [anon_sym_CARET] = ACTIONS(506),
    [anon_sym_LT_LT] = ACTIONS(506),
    [anon_sym_LT] = ACTIONS(508),
    [anon_sym_LT_EQ] = ACTIONS(506),
    [anon_sym_EQ_EQ] = ACTIONS(506),
    [anon_sym_BANG_EQ] = ACTIONS(506),
    [anon_sym_GT_EQ] = ACTIONS(506),
    [anon_sym_GT] = ACTIONS(508),
    [anon_sym_LT_GT] = ACTIONS(506),
    [anon_sym_is] = ACTIONS(506),
    [anon_sym_LBRACK] = ACTIONS(506),
    [anon_sym_RBRACK] = ACTIONS(506),
    [anon_sym_RBRACE] = ACTIONS(506),
    [sym_type_conversion] = ACTIONS(506),
    [sym_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(506),
  },
  [471] = {
    [anon_sym_DOT] = ACTIONS(514),
    [anon_sym_LPAREN] = ACTIONS(514),
    [anon_sym_RPAREN] = ACTIONS(514),
    [anon_sym_COMMA] = ACTIONS(514),
    [anon_sym_STAR] = ACTIONS(516),
    [anon_sym_GT_GT] = ACTIONS(514),
    [anon_sym_if] = ACTIONS(514),
    [anon_sym_COLON] = ACTIONS(514),
    [anon_sym_else] = ACTIONS(514),
    [anon_sym_async] = ACTIONS(514),
    [anon_sym_for] = ACTIONS(514),
    [anon_sym_in] = ACTIONS(514),
    [anon_sym_EQ] = ACTIONS(516),
    [anon_sym_STAR_STAR] = ACTIONS(514),
    [anon_sym_AT] = ACTIONS(514),
    [anon_sym_not] = ACTIONS(514),
    [anon_sym_and] = ACTIONS(514),
    [anon_sym_or] = ACTIONS(514),
    [anon_sym_PLUS] = ACTIONS(514),
    [anon_sym_DASH] = ACTIONS(514),
    [anon_sym_SLASH] = ACTIONS(516),
    [anon_sym_PERCENT] = ACTIONS(514),
    [anon_sym_SLASH_SLASH] = ACTIONS(514),
    [anon_sym_PIPE] = ACTIONS(514),
    [anon_sym_AMP] = ACTIONS(514),
    [anon_sym_CARET] = ACTIONS(514),
    [anon_sym_LT_LT] = ACTIONS(514),
    [anon_sym_LT] = ACTIONS(516),
    [anon_sym_LT_EQ] = ACTIONS(514),
    [anon_sym_EQ_EQ] = ACTIONS(514),
    [anon_sym_BANG_EQ] = ACTIONS(514),
    [anon_sym_GT_EQ] = ACTIONS(514),
    [anon_sym_GT] = ACTIONS(516),
    [anon_sym_LT_GT] = ACTIONS(514),
    [anon_sym_is] = ACTIONS(514),
    [anon_sym_LBRACK] = ACTIONS(514),
    [anon_sym_RBRACK] = ACTIONS(514),
    [anon_sym_RBRACE] = ACTIONS(514),
    [sym_type_conversion] = ACTIONS(514),
    [sym_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(514),
  },
  [472] = {
    [anon_sym_DOT] = ACTIONS(646),
    [anon_sym_LPAREN] = ACTIONS(646),
    [anon_sym_RPAREN] = ACTIONS(646),
    [anon_sym_COMMA] = ACTIONS(646),
    [anon_sym_STAR] = ACTIONS(648),
    [anon_sym_GT_GT] = ACTIONS(646),
    [anon_sym_if] = ACTIONS(646),
    [anon_sym_COLON] = ACTIONS(646),
    [anon_sym_else] = ACTIONS(646),
    [anon_sym_async] = ACTIONS(646),
    [anon_sym_for] = ACTIONS(646),
    [anon_sym_in] = ACTIONS(646),
    [anon_sym_EQ] = ACTIONS(648),
    [anon_sym_STAR_STAR] = ACTIONS(646),
    [anon_sym_AT] = ACTIONS(646),
    [anon_sym_not] = ACTIONS(646),
    [anon_sym_and] = ACTIONS(646),
    [anon_sym_or] = ACTIONS(646),
    [anon_sym_PLUS] = ACTIONS(646),
    [anon_sym_DASH] = ACTIONS(646),
    [anon_sym_SLASH] = ACTIONS(648),
    [anon_sym_PERCENT] = ACTIONS(646),
    [anon_sym_SLASH_SLASH] = ACTIONS(646),
    [anon_sym_PIPE] = ACTIONS(646),
    [anon_sym_AMP] = ACTIONS(646),
    [anon_sym_CARET] = ACTIONS(646),
    [anon_sym_LT_LT] = ACTIONS(646),
    [anon_sym_LT] = ACTIONS(648),
    [anon_sym_LT_EQ] = ACTIONS(646),
    [anon_sym_EQ_EQ] = ACTIONS(646),
    [anon_sym_BANG_EQ] = ACTIONS(646),
    [anon_sym_GT_EQ] = ACTIONS(646),
    [anon_sym_GT] = ACTIONS(648),
    [anon_sym_LT_GT] = ACTIONS(646),
    [anon_sym_is] = ACTIONS(646),
    [anon_sym_LBRACK] = ACTIONS(646),
    [anon_sym_RBRACK] = ACTIONS(646),
    [anon_sym_RBRACE] = ACTIONS(646),
    [sym_type_conversion] = ACTIONS(646),
    [sym_comment] = ACTIONS(3),
  },
  [473] = {
    [anon_sym_DOT] = ACTIONS(658),
    [anon_sym_LPAREN] = ACTIONS(658),
    [anon_sym_RPAREN] = ACTIONS(658),
    [anon_sym_COMMA] = ACTIONS(658),
    [anon_sym_STAR] = ACTIONS(660),
    [anon_sym_GT_GT] = ACTIONS(658),
    [anon_sym_if] = ACTIONS(658),
    [anon_sym_COLON] = ACTIONS(658),
    [anon_sym_else] = ACTIONS(658),
    [anon_sym_async] = ACTIONS(658),
    [anon_sym_for] = ACTIONS(658),
    [anon_sym_in] = ACTIONS(658),
    [anon_sym_EQ] = ACTIONS(660),
    [anon_sym_STAR_STAR] = ACTIONS(658),
    [anon_sym_AT] = ACTIONS(658),
    [anon_sym_not] = ACTIONS(658),
    [anon_sym_and] = ACTIONS(658),
    [anon_sym_or] = ACTIONS(658),
    [anon_sym_PLUS] = ACTIONS(658),
    [anon_sym_DASH] = ACTIONS(658),
    [anon_sym_SLASH] = ACTIONS(660),
    [anon_sym_PERCENT] = ACTIONS(658),
    [anon_sym_SLASH_SLASH] = ACTIONS(658),
    [anon_sym_PIPE] = ACTIONS(658),
    [anon_sym_AMP] = ACTIONS(658),
    [anon_sym_CARET] = ACTIONS(658),
    [anon_sym_LT_LT] = ACTIONS(658),
    [anon_sym_LT] = ACTIONS(660),
    [anon_sym_LT_EQ] = ACTIONS(658),
    [anon_sym_EQ_EQ] = ACTIONS(658),
    [anon_sym_BANG_EQ] = ACTIONS(658),
    [anon_sym_GT_EQ] = ACTIONS(658),
    [anon_sym_GT] = ACTIONS(660),
    [anon_sym_LT_GT] = ACTIONS(658),
    [anon_sym_is] = ACTIONS(658),
    [anon_sym_LBRACK] = ACTIONS(658),
    [anon_sym_RBRACK] = ACTIONS(658),
    [anon_sym_RBRACE] = ACTIONS(658),
    [sym_type_conversion] = ACTIONS(658),
    [sym_comment] = ACTIONS(3),
  },
  [474] = {
    [anon_sym_DOT] = ACTIONS(530),
    [anon_sym_LPAREN] = ACTIONS(530),
    [anon_sym_RPAREN] = ACTIONS(530),
    [anon_sym_COMMA] = ACTIONS(530),
    [anon_sym_STAR] = ACTIONS(532),
    [anon_sym_GT_GT] = ACTIONS(530),
    [anon_sym_if] = ACTIONS(530),
    [anon_sym_COLON] = ACTIONS(530),
    [anon_sym_else] = ACTIONS(530),
    [anon_sym_async] = ACTIONS(530),
    [anon_sym_for] = ACTIONS(530),
    [anon_sym_in] = ACTIONS(530),
    [anon_sym_EQ] = ACTIONS(532),
    [anon_sym_STAR_STAR] = ACTIONS(530),
    [anon_sym_AT] = ACTIONS(530),
    [anon_sym_not] = ACTIONS(530),
    [anon_sym_and] = ACTIONS(530),
    [anon_sym_or] = ACTIONS(530),
    [anon_sym_PLUS] = ACTIONS(530),
    [anon_sym_DASH] = ACTIONS(530),
    [anon_sym_SLASH] = ACTIONS(532),
    [anon_sym_PERCENT] = ACTIONS(530),
    [anon_sym_SLASH_SLASH] = ACTIONS(530),
    [anon_sym_PIPE] = ACTIONS(530),
    [anon_sym_AMP] = ACTIONS(530),
    [anon_sym_CARET] = ACTIONS(530),
    [anon_sym_LT_LT] = ACTIONS(530),
    [anon_sym_LT] = ACTIONS(532),
    [anon_sym_LT_EQ] = ACTIONS(530),
    [anon_sym_EQ_EQ] = ACTIONS(530),
    [anon_sym_BANG_EQ] = ACTIONS(530),
    [anon_sym_GT_EQ] = ACTIONS(530),
    [anon_sym_GT] = ACTIONS(532),
    [anon_sym_LT_GT] = ACTIONS(530),
    [anon_sym_is] = ACTIONS(530),
    [anon_sym_LBRACK] = ACTIONS(530),
    [anon_sym_RBRACK] = ACTIONS(530),
    [anon_sym_RBRACE] = ACTIONS(530),
    [sym_type_conversion] = ACTIONS(530),
    [sym_comment] = ACTIONS(3),
  },
  [475] = {
    [anon_sym_DOT] = ACTIONS(566),
    [anon_sym_LPAREN] = ACTIONS(566),
    [anon_sym_RPAREN] = ACTIONS(566),
    [anon_sym_COMMA] = ACTIONS(566),
    [anon_sym_STAR] = ACTIONS(568),
    [anon_sym_GT_GT] = ACTIONS(566),
    [anon_sym_if] = ACTIONS(566),
    [anon_sym_COLON] = ACTIONS(566),
    [anon_sym_else] = ACTIONS(566),
    [anon_sym_async] = ACTIONS(566),
    [anon_sym_for] = ACTIONS(566),
    [anon_sym_in] = ACTIONS(566),
    [anon_sym_EQ] = ACTIONS(568),
    [anon_sym_STAR_STAR] = ACTIONS(566),
    [anon_sym_AT] = ACTIONS(566),
    [anon_sym_not] = ACTIONS(566),
    [anon_sym_and] = ACTIONS(566),
    [anon_sym_or] = ACTIONS(566),
    [anon_sym_PLUS] = ACTIONS(566),
    [anon_sym_DASH] = ACTIONS(566),
    [anon_sym_SLASH] = ACTIONS(568),
    [anon_sym_PERCENT] = ACTIONS(566),
    [anon_sym_SLASH_SLASH] = ACTIONS(566),
    [anon_sym_PIPE] = ACTIONS(566),
    [anon_sym_AMP] = ACTIONS(566),
    [anon_sym_CARET] = ACTIONS(566),
    [anon_sym_LT_LT] = ACTIONS(566),
    [anon_sym_LT] = ACTIONS(568),
    [anon_sym_LT_EQ] = ACTIONS(566),
    [anon_sym_EQ_EQ] = ACTIONS(566),
    [anon_sym_BANG_EQ] = ACTIONS(566),
    [anon_sym_GT_EQ] = ACTIONS(566),
    [anon_sym_GT] = ACTIONS(568),
    [anon_sym_LT_GT] = ACTIONS(566),
    [anon_sym_is] = ACTIONS(566),
    [anon_sym_LBRACK] = ACTIONS(566),
    [anon_sym_RBRACK] = ACTIONS(566),
    [anon_sym_RBRACE] = ACTIONS(566),
    [sym_type_conversion] = ACTIONS(566),
    [sym_comment] = ACTIONS(3),
  },
  [476] = {
    [anon_sym_DOT] = ACTIONS(570),
    [anon_sym_LPAREN] = ACTIONS(570),
    [anon_sym_RPAREN] = ACTIONS(570),
    [anon_sym_COMMA] = ACTIONS(570),
    [anon_sym_STAR] = ACTIONS(572),
    [anon_sym_GT_GT] = ACTIONS(570),
    [anon_sym_if] = ACTIONS(570),
    [anon_sym_COLON] = ACTIONS(570),
    [anon_sym_else] = ACTIONS(570),
    [anon_sym_async] = ACTIONS(570),
    [anon_sym_for] = ACTIONS(570),
    [anon_sym_in] = ACTIONS(570),
    [anon_sym_EQ] = ACTIONS(572),
    [anon_sym_STAR_STAR] = ACTIONS(570),
    [anon_sym_AT] = ACTIONS(570),
    [anon_sym_not] = ACTIONS(570),
    [anon_sym_and] = ACTIONS(570),
    [anon_sym_or] = ACTIONS(570),
    [anon_sym_PLUS] = ACTIONS(570),
    [anon_sym_DASH] = ACTIONS(570),
    [anon_sym_SLASH] = ACTIONS(572),
    [anon_sym_PERCENT] = ACTIONS(570),
    [anon_sym_SLASH_SLASH] = ACTIONS(570),
    [anon_sym_PIPE] = ACTIONS(570),
    [anon_sym_AMP] = ACTIONS(570),
    [anon_sym_CARET] = ACTIONS(570),
    [anon_sym_LT_LT] = ACTIONS(570),
    [anon_sym_LT] = ACTIONS(572),
    [anon_sym_LT_EQ] = ACTIONS(570),
    [anon_sym_EQ_EQ] = ACTIONS(570),
    [anon_sym_BANG_EQ] = ACTIONS(570),
    [anon_sym_GT_EQ] = ACTIONS(570),
    [anon_sym_GT] = ACTIONS(572),
    [anon_sym_LT_GT] = ACTIONS(570),
    [anon_sym_is] = ACTIONS(570),
    [anon_sym_LBRACK] = ACTIONS(570),
    [anon_sym_RBRACK] = ACTIONS(570),
    [anon_sym_RBRACE] = ACTIONS(570),
    [sym_type_conversion] = ACTIONS(570),
    [sym_comment] = ACTIONS(3),
  },
  [477] = {
    [anon_sym_DOT] = ACTIONS(536),
    [anon_sym_LPAREN] = ACTIONS(536),
    [anon_sym_RPAREN] = ACTIONS(536),
    [anon_sym_COMMA] = ACTIONS(536),
    [anon_sym_STAR] = ACTIONS(538),
    [anon_sym_GT_GT] = ACTIONS(536),
    [anon_sym_if] = ACTIONS(536),
    [anon_sym_COLON] = ACTIONS(536),
    [anon_sym_else] = ACTIONS(536),
    [anon_sym_async] = ACTIONS(536),
    [anon_sym_for] = ACTIONS(536),
    [anon_sym_in] = ACTIONS(536),
    [anon_sym_EQ] = ACTIONS(538),
    [anon_sym_STAR_STAR] = ACTIONS(536),
    [anon_sym_AT] = ACTIONS(536),
    [anon_sym_not] = ACTIONS(536),
    [anon_sym_and] = ACTIONS(536),
    [anon_sym_or] = ACTIONS(536),
    [anon_sym_PLUS] = ACTIONS(536),
    [anon_sym_DASH] = ACTIONS(536),
    [anon_sym_SLASH] = ACTIONS(538),
    [anon_sym_PERCENT] = ACTIONS(536),
    [anon_sym_SLASH_SLASH] = ACTIONS(536),
    [anon_sym_PIPE] = ACTIONS(536),
    [anon_sym_AMP] = ACTIONS(536),
    [anon_sym_CARET] = ACTIONS(536),
    [anon_sym_LT_LT] = ACTIONS(536),
    [anon_sym_LT] = ACTIONS(538),
    [anon_sym_LT_EQ] = ACTIONS(536),
    [anon_sym_EQ_EQ] = ACTIONS(536),
    [anon_sym_BANG_EQ] = ACTIONS(536),
    [anon_sym_GT_EQ] = ACTIONS(536),
    [anon_sym_GT] = ACTIONS(538),
    [anon_sym_LT_GT] = ACTIONS(536),
    [anon_sym_is] = ACTIONS(536),
    [anon_sym_LBRACK] = ACTIONS(536),
    [anon_sym_RBRACK] = ACTIONS(536),
    [anon_sym_RBRACE] = ACTIONS(536),
    [sym_type_conversion] = ACTIONS(536),
    [sym_comment] = ACTIONS(3),
  },
  [478] = {
    [anon_sym_DOT] = ACTIONS(680),
    [anon_sym_LPAREN] = ACTIONS(680),
    [anon_sym_RPAREN] = ACTIONS(680),
    [anon_sym_COMMA] = ACTIONS(680),
    [anon_sym_STAR] = ACTIONS(682),
    [anon_sym_GT_GT] = ACTIONS(680),
    [anon_sym_if] = ACTIONS(680),
    [anon_sym_COLON] = ACTIONS(680),
    [anon_sym_else] = ACTIONS(680),
    [anon_sym_async] = ACTIONS(680),
    [anon_sym_for] = ACTIONS(680),
    [anon_sym_in] = ACTIONS(680),
    [anon_sym_EQ] = ACTIONS(682),
    [anon_sym_STAR_STAR] = ACTIONS(680),
    [anon_sym_AT] = ACTIONS(680),
    [anon_sym_not] = ACTIONS(680),
    [anon_sym_and] = ACTIONS(680),
    [anon_sym_or] = ACTIONS(680),
    [anon_sym_PLUS] = ACTIONS(680),
    [anon_sym_DASH] = ACTIONS(680),
    [anon_sym_SLASH] = ACTIONS(682),
    [anon_sym_PERCENT] = ACTIONS(680),
    [anon_sym_SLASH_SLASH] = ACTIONS(680),
    [anon_sym_PIPE] = ACTIONS(680),
    [anon_sym_AMP] = ACTIONS(680),
    [anon_sym_CARET] = ACTIONS(680),
    [anon_sym_LT_LT] = ACTIONS(680),
    [anon_sym_LT] = ACTIONS(682),
    [anon_sym_LT_EQ] = ACTIONS(680),
    [anon_sym_EQ_EQ] = ACTIONS(680),
    [anon_sym_BANG_EQ] = ACTIONS(680),
    [anon_sym_GT_EQ] = ACTIONS(680),
    [anon_sym_GT] = ACTIONS(682),
    [anon_sym_LT_GT] = ACTIONS(680),
    [anon_sym_is] = ACTIONS(680),
    [anon_sym_LBRACK] = ACTIONS(680),
    [anon_sym_RBRACK] = ACTIONS(680),
    [anon_sym_RBRACE] = ACTIONS(680),
    [sym_type_conversion] = ACTIONS(680),
    [sym_comment] = ACTIONS(3),
  },
  [479] = {
    [anon_sym_DOT] = ACTIONS(650),
    [anon_sym_LPAREN] = ACTIONS(650),
    [anon_sym_RPAREN] = ACTIONS(650),
    [anon_sym_COMMA] = ACTIONS(650),
    [anon_sym_STAR] = ACTIONS(652),
    [anon_sym_GT_GT] = ACTIONS(650),
    [anon_sym_if] = ACTIONS(650),
    [anon_sym_COLON] = ACTIONS(650),
    [anon_sym_else] = ACTIONS(650),
    [anon_sym_async] = ACTIONS(650),
    [anon_sym_for] = ACTIONS(650),
    [anon_sym_in] = ACTIONS(650),
    [anon_sym_EQ] = ACTIONS(652),
    [anon_sym_STAR_STAR] = ACTIONS(650),
    [anon_sym_AT] = ACTIONS(650),
    [anon_sym_not] = ACTIONS(650),
    [anon_sym_and] = ACTIONS(650),
    [anon_sym_or] = ACTIONS(650),
    [anon_sym_PLUS] = ACTIONS(650),
    [anon_sym_DASH] = ACTIONS(650),
    [anon_sym_SLASH] = ACTIONS(652),
    [anon_sym_PERCENT] = ACTIONS(650),
    [anon_sym_SLASH_SLASH] = ACTIONS(650),
    [anon_sym_PIPE] = ACTIONS(650),
    [anon_sym_AMP] = ACTIONS(650),
    [anon_sym_CARET] = ACTIONS(650),
    [anon_sym_LT_LT] = ACTIONS(650),
    [anon_sym_LT] = ACTIONS(652),
    [anon_sym_LT_EQ] = ACTIONS(650),
    [anon_sym_EQ_EQ] = ACTIONS(650),
    [anon_sym_BANG_EQ] = ACTIONS(650),
    [anon_sym_GT_EQ] = ACTIONS(650),
    [anon_sym_GT] = ACTIONS(652),
    [anon_sym_LT_GT] = ACTIONS(650),
    [anon_sym_is] = ACTIONS(650),
    [anon_sym_LBRACK] = ACTIONS(650),
    [anon_sym_RBRACK] = ACTIONS(650),
    [anon_sym_RBRACE] = ACTIONS(650),
    [sym_type_conversion] = ACTIONS(650),
    [sym_comment] = ACTIONS(3),
  },
  [480] = {
    [anon_sym_DOT] = ACTIONS(574),
    [anon_sym_LPAREN] = ACTIONS(574),
    [anon_sym_RPAREN] = ACTIONS(574),
    [anon_sym_COMMA] = ACTIONS(574),
    [anon_sym_STAR] = ACTIONS(576),
    [anon_sym_GT_GT] = ACTIONS(574),
    [anon_sym_if] = ACTIONS(574),
    [anon_sym_COLON] = ACTIONS(574),
    [anon_sym_else] = ACTIONS(574),
    [anon_sym_async] = ACTIONS(574),
    [anon_sym_for] = ACTIONS(574),
    [anon_sym_in] = ACTIONS(574),
    [anon_sym_EQ] = ACTIONS(576),
    [anon_sym_STAR_STAR] = ACTIONS(574),
    [anon_sym_AT] = ACTIONS(574),
    [anon_sym_not] = ACTIONS(574),
    [anon_sym_and] = ACTIONS(574),
    [anon_sym_or] = ACTIONS(574),
    [anon_sym_PLUS] = ACTIONS(574),
    [anon_sym_DASH] = ACTIONS(574),
    [anon_sym_SLASH] = ACTIONS(576),
    [anon_sym_PERCENT] = ACTIONS(574),
    [anon_sym_SLASH_SLASH] = ACTIONS(574),
    [anon_sym_PIPE] = ACTIONS(574),
    [anon_sym_AMP] = ACTIONS(574),
    [anon_sym_CARET] = ACTIONS(574),
    [anon_sym_LT_LT] = ACTIONS(574),
    [anon_sym_LT] = ACTIONS(576),
    [anon_sym_LT_EQ] = ACTIONS(574),
    [anon_sym_EQ_EQ] = ACTIONS(574),
    [anon_sym_BANG_EQ] = ACTIONS(574),
    [anon_sym_GT_EQ] = ACTIONS(574),
    [anon_sym_GT] = ACTIONS(576),
    [anon_sym_LT_GT] = ACTIONS(574),
    [anon_sym_is] = ACTIONS(574),
    [anon_sym_LBRACK] = ACTIONS(574),
    [anon_sym_RBRACK] = ACTIONS(574),
    [anon_sym_RBRACE] = ACTIONS(574),
    [sym_type_conversion] = ACTIONS(574),
    [sym_comment] = ACTIONS(3),
  },
  [481] = {
    [anon_sym_DOT] = ACTIONS(598),
    [anon_sym_LPAREN] = ACTIONS(598),
    [anon_sym_RPAREN] = ACTIONS(598),
    [anon_sym_COMMA] = ACTIONS(598),
    [anon_sym_STAR] = ACTIONS(600),
    [anon_sym_GT_GT] = ACTIONS(598),
    [anon_sym_if] = ACTIONS(598),
    [anon_sym_COLON] = ACTIONS(598),
    [anon_sym_else] = ACTIONS(598),
    [anon_sym_async] = ACTIONS(598),
    [anon_sym_for] = ACTIONS(598),
    [anon_sym_in] = ACTIONS(598),
    [anon_sym_EQ] = ACTIONS(600),
    [anon_sym_STAR_STAR] = ACTIONS(598),
    [anon_sym_AT] = ACTIONS(598),
    [anon_sym_not] = ACTIONS(598),
    [anon_sym_and] = ACTIONS(598),
    [anon_sym_or] = ACTIONS(598),
    [anon_sym_PLUS] = ACTIONS(598),
    [anon_sym_DASH] = ACTIONS(598),
    [anon_sym_SLASH] = ACTIONS(600),
    [anon_sym_PERCENT] = ACTIONS(598),
    [anon_sym_SLASH_SLASH] = ACTIONS(598),
    [anon_sym_PIPE] = ACTIONS(598),
    [anon_sym_AMP] = ACTIONS(598),
    [anon_sym_CARET] = ACTIONS(598),
    [anon_sym_LT_LT] = ACTIONS(598),
    [anon_sym_LT] = ACTIONS(600),
    [anon_sym_LT_EQ] = ACTIONS(598),
    [anon_sym_EQ_EQ] = ACTIONS(598),
    [anon_sym_BANG_EQ] = ACTIONS(598),
    [anon_sym_GT_EQ] = ACTIONS(598),
    [anon_sym_GT] = ACTIONS(600),
    [anon_sym_LT_GT] = ACTIONS(598),
    [anon_sym_is] = ACTIONS(598),
    [anon_sym_LBRACK] = ACTIONS(598),
    [anon_sym_RBRACK] = ACTIONS(598),
    [anon_sym_RBRACE] = ACTIONS(598),
    [sym_type_conversion] = ACTIONS(598),
    [sym_comment] = ACTIONS(3),
  },
  [482] = {
    [anon_sym_DOT] = ACTIONS(235),
    [anon_sym_LPAREN] = ACTIONS(235),
    [anon_sym_RPAREN] = ACTIONS(235),
    [anon_sym_COMMA] = ACTIONS(235),
    [anon_sym_STAR] = ACTIONS(233),
    [anon_sym_GT_GT] = ACTIONS(235),
    [anon_sym_if] = ACTIONS(235),
    [anon_sym_COLON] = ACTIONS(235),
    [anon_sym_else] = ACTIONS(235),
    [anon_sym_async] = ACTIONS(235),
    [anon_sym_for] = ACTIONS(235),
    [anon_sym_in] = ACTIONS(235),
    [anon_sym_EQ] = ACTIONS(233),
    [anon_sym_STAR_STAR] = ACTIONS(235),
    [anon_sym_AT] = ACTIONS(235),
    [anon_sym_not] = ACTIONS(235),
    [anon_sym_and] = ACTIONS(235),
    [anon_sym_or] = ACTIONS(235),
    [anon_sym_PLUS] = ACTIONS(235),
    [anon_sym_DASH] = ACTIONS(235),
    [anon_sym_SLASH] = ACTIONS(233),
    [anon_sym_PERCENT] = ACTIONS(235),
    [anon_sym_SLASH_SLASH] = ACTIONS(235),
    [anon_sym_PIPE] = ACTIONS(235),
    [anon_sym_AMP] = ACTIONS(235),
    [anon_sym_CARET] = ACTIONS(235),
    [anon_sym_LT_LT] = ACTIONS(235),
    [anon_sym_LT] = ACTIONS(233),
    [anon_sym_LT_EQ] = ACTIONS(235),
    [anon_sym_EQ_EQ] = ACTIONS(235),
    [anon_sym_BANG_EQ] = ACTIONS(235),
    [anon_sym_GT_EQ] = ACTIONS(235),
    [anon_sym_GT] = ACTIONS(233),
    [anon_sym_LT_GT] = ACTIONS(235),
    [anon_sym_is] = ACTIONS(235),
    [anon_sym_LBRACK] = ACTIONS(235),
    [anon_sym_RBRACK] = ACTIONS(235),
    [anon_sym_RBRACE] = ACTIONS(235),
    [sym_type_conversion] = ACTIONS(235),
    [sym_comment] = ACTIONS(3),
  },
  [483] = {
    [anon_sym_DOT] = ACTIONS(522),
    [anon_sym_LPAREN] = ACTIONS(522),
    [anon_sym_RPAREN] = ACTIONS(522),
    [anon_sym_COMMA] = ACTIONS(522),
    [anon_sym_STAR] = ACTIONS(524),
    [anon_sym_GT_GT] = ACTIONS(522),
    [anon_sym_if] = ACTIONS(522),
    [anon_sym_COLON] = ACTIONS(522),
    [anon_sym_else] = ACTIONS(522),
    [anon_sym_async] = ACTIONS(522),
    [anon_sym_for] = ACTIONS(522),
    [anon_sym_in] = ACTIONS(522),
    [anon_sym_EQ] = ACTIONS(524),
    [anon_sym_STAR_STAR] = ACTIONS(522),
    [anon_sym_AT] = ACTIONS(522),
    [anon_sym_not] = ACTIONS(522),
    [anon_sym_and] = ACTIONS(522),
    [anon_sym_or] = ACTIONS(522),
    [anon_sym_PLUS] = ACTIONS(522),
    [anon_sym_DASH] = ACTIONS(522),
    [anon_sym_SLASH] = ACTIONS(524),
    [anon_sym_PERCENT] = ACTIONS(522),
    [anon_sym_SLASH_SLASH] = ACTIONS(522),
    [anon_sym_PIPE] = ACTIONS(522),
    [anon_sym_AMP] = ACTIONS(522),
    [anon_sym_CARET] = ACTIONS(522),
    [anon_sym_LT_LT] = ACTIONS(522),
    [anon_sym_LT] = ACTIONS(524),
    [anon_sym_LT_EQ] = ACTIONS(522),
    [anon_sym_EQ_EQ] = ACTIONS(522),
    [anon_sym_BANG_EQ] = ACTIONS(522),
    [anon_sym_GT_EQ] = ACTIONS(522),
    [anon_sym_GT] = ACTIONS(524),
    [anon_sym_LT_GT] = ACTIONS(522),
    [anon_sym_is] = ACTIONS(522),
    [anon_sym_LBRACK] = ACTIONS(522),
    [anon_sym_RBRACK] = ACTIONS(522),
    [anon_sym_RBRACE] = ACTIONS(522),
    [sym_type_conversion] = ACTIONS(522),
    [sym_comment] = ACTIONS(3),
  },
  [484] = {
    [anon_sym_DOT] = ACTIONS(642),
    [anon_sym_LPAREN] = ACTIONS(642),
    [anon_sym_RPAREN] = ACTIONS(642),
    [anon_sym_COMMA] = ACTIONS(642),
    [anon_sym_STAR] = ACTIONS(644),
    [anon_sym_GT_GT] = ACTIONS(642),
    [anon_sym_if] = ACTIONS(642),
    [anon_sym_COLON] = ACTIONS(642),
    [anon_sym_else] = ACTIONS(642),
    [anon_sym_async] = ACTIONS(642),
    [anon_sym_for] = ACTIONS(642),
    [anon_sym_in] = ACTIONS(642),
    [anon_sym_EQ] = ACTIONS(644),
    [anon_sym_STAR_STAR] = ACTIONS(642),
    [anon_sym_AT] = ACTIONS(642),
    [anon_sym_not] = ACTIONS(642),
    [anon_sym_and] = ACTIONS(642),
    [anon_sym_or] = ACTIONS(642),
    [anon_sym_PLUS] = ACTIONS(642),
    [anon_sym_DASH] = ACTIONS(642),
    [anon_sym_SLASH] = ACTIONS(644),
    [anon_sym_PERCENT] = ACTIONS(642),
    [anon_sym_SLASH_SLASH] = ACTIONS(642),
    [anon_sym_PIPE] = ACTIONS(642),
    [anon_sym_AMP] = ACTIONS(642),
    [anon_sym_CARET] = ACTIONS(642),
    [anon_sym_LT_LT] = ACTIONS(642),
    [anon_sym_LT] = ACTIONS(644),
    [anon_sym_LT_EQ] = ACTIONS(642),
    [anon_sym_EQ_EQ] = ACTIONS(642),
    [anon_sym_BANG_EQ] = ACTIONS(642),
    [anon_sym_GT_EQ] = ACTIONS(642),
    [anon_sym_GT] = ACTIONS(644),
    [anon_sym_LT_GT] = ACTIONS(642),
    [anon_sym_is] = ACTIONS(642),
    [anon_sym_LBRACK] = ACTIONS(642),
    [anon_sym_RBRACK] = ACTIONS(642),
    [anon_sym_RBRACE] = ACTIONS(642),
    [sym_type_conversion] = ACTIONS(642),
    [sym_comment] = ACTIONS(3),
  },
  [485] = {
    [anon_sym_DOT] = ACTIONS(626),
    [anon_sym_LPAREN] = ACTIONS(626),
    [anon_sym_RPAREN] = ACTIONS(626),
    [anon_sym_COMMA] = ACTIONS(626),
    [anon_sym_STAR] = ACTIONS(628),
    [anon_sym_GT_GT] = ACTIONS(626),
    [anon_sym_if] = ACTIONS(626),
    [anon_sym_COLON] = ACTIONS(626),
    [anon_sym_else] = ACTIONS(626),
    [anon_sym_async] = ACTIONS(626),
    [anon_sym_for] = ACTIONS(626),
    [anon_sym_in] = ACTIONS(626),
    [anon_sym_EQ] = ACTIONS(628),
    [anon_sym_STAR_STAR] = ACTIONS(626),
    [anon_sym_AT] = ACTIONS(626),
    [anon_sym_not] = ACTIONS(626),
    [anon_sym_and] = ACTIONS(626),
    [anon_sym_or] = ACTIONS(626),
    [anon_sym_PLUS] = ACTIONS(626),
    [anon_sym_DASH] = ACTIONS(626),
    [anon_sym_SLASH] = ACTIONS(628),
    [anon_sym_PERCENT] = ACTIONS(626),
    [anon_sym_SLASH_SLASH] = ACTIONS(626),
    [anon_sym_PIPE] = ACTIONS(626),
    [anon_sym_AMP] = ACTIONS(626),
    [anon_sym_CARET] = ACTIONS(626),
    [anon_sym_LT_LT] = ACTIONS(626),
    [anon_sym_LT] = ACTIONS(628),
    [anon_sym_LT_EQ] = ACTIONS(626),
    [anon_sym_EQ_EQ] = ACTIONS(626),
    [anon_sym_BANG_EQ] = ACTIONS(626),
    [anon_sym_GT_EQ] = ACTIONS(626),
    [anon_sym_GT] = ACTIONS(628),
    [anon_sym_LT_GT] = ACTIONS(626),
    [anon_sym_is] = ACTIONS(626),
    [anon_sym_LBRACK] = ACTIONS(626),
    [anon_sym_RBRACK] = ACTIONS(626),
    [anon_sym_RBRACE] = ACTIONS(626),
    [sym_type_conversion] = ACTIONS(626),
    [sym_comment] = ACTIONS(3),
  },
  [486] = {
    [anon_sym_DOT] = ACTIONS(558),
    [anon_sym_LPAREN] = ACTIONS(558),
    [anon_sym_RPAREN] = ACTIONS(558),
    [anon_sym_COMMA] = ACTIONS(558),
    [anon_sym_STAR] = ACTIONS(560),
    [anon_sym_GT_GT] = ACTIONS(558),
    [anon_sym_if] = ACTIONS(558),
    [anon_sym_COLON] = ACTIONS(558),
    [anon_sym_else] = ACTIONS(558),
    [anon_sym_async] = ACTIONS(558),
    [anon_sym_for] = ACTIONS(558),
    [anon_sym_in] = ACTIONS(558),
    [anon_sym_EQ] = ACTIONS(560),
    [anon_sym_STAR_STAR] = ACTIONS(558),
    [anon_sym_AT] = ACTIONS(558),
    [anon_sym_not] = ACTIONS(558),
    [anon_sym_and] = ACTIONS(558),
    [anon_sym_or] = ACTIONS(558),
    [anon_sym_PLUS] = ACTIONS(558),
    [anon_sym_DASH] = ACTIONS(558),
    [anon_sym_SLASH] = ACTIONS(560),
    [anon_sym_PERCENT] = ACTIONS(558),
    [anon_sym_SLASH_SLASH] = ACTIONS(558),
    [anon_sym_PIPE] = ACTIONS(558),
    [anon_sym_AMP] = ACTIONS(558),
    [anon_sym_CARET] = ACTIONS(558),
    [anon_sym_LT_LT] = ACTIONS(558),
    [anon_sym_LT] = ACTIONS(560),
    [anon_sym_LT_EQ] = ACTIONS(558),
    [anon_sym_EQ_EQ] = ACTIONS(558),
    [anon_sym_BANG_EQ] = ACTIONS(558),
    [anon_sym_GT_EQ] = ACTIONS(558),
    [anon_sym_GT] = ACTIONS(560),
    [anon_sym_LT_GT] = ACTIONS(558),
    [anon_sym_is] = ACTIONS(558),
    [anon_sym_LBRACK] = ACTIONS(558),
    [anon_sym_RBRACK] = ACTIONS(558),
    [anon_sym_RBRACE] = ACTIONS(558),
    [sym_type_conversion] = ACTIONS(558),
    [sym_comment] = ACTIONS(3),
  },
  [487] = {
    [anon_sym_DOT] = ACTIONS(618),
    [anon_sym_LPAREN] = ACTIONS(618),
    [anon_sym_RPAREN] = ACTIONS(618),
    [anon_sym_COMMA] = ACTIONS(618),
    [anon_sym_STAR] = ACTIONS(620),
    [anon_sym_GT_GT] = ACTIONS(618),
    [anon_sym_if] = ACTIONS(618),
    [anon_sym_COLON] = ACTIONS(618),
    [anon_sym_else] = ACTIONS(618),
    [anon_sym_async] = ACTIONS(618),
    [anon_sym_for] = ACTIONS(618),
    [anon_sym_in] = ACTIONS(618),
    [anon_sym_EQ] = ACTIONS(620),
    [anon_sym_STAR_STAR] = ACTIONS(618),
    [anon_sym_AT] = ACTIONS(618),
    [anon_sym_not] = ACTIONS(618),
    [anon_sym_and] = ACTIONS(618),
    [anon_sym_or] = ACTIONS(618),
    [anon_sym_PLUS] = ACTIONS(618),
    [anon_sym_DASH] = ACTIONS(618),
    [anon_sym_SLASH] = ACTIONS(620),
    [anon_sym_PERCENT] = ACTIONS(618),
    [anon_sym_SLASH_SLASH] = ACTIONS(618),
    [anon_sym_PIPE] = ACTIONS(618),
    [anon_sym_AMP] = ACTIONS(618),
    [anon_sym_CARET] = ACTIONS(618),
    [anon_sym_LT_LT] = ACTIONS(618),
    [anon_sym_LT] = ACTIONS(620),
    [anon_sym_LT_EQ] = ACTIONS(618),
    [anon_sym_EQ_EQ] = ACTIONS(618),
    [anon_sym_BANG_EQ] = ACTIONS(618),
    [anon_sym_GT_EQ] = ACTIONS(618),
    [anon_sym_GT] = ACTIONS(620),
    [anon_sym_LT_GT] = ACTIONS(618),
    [anon_sym_is] = ACTIONS(618),
    [anon_sym_LBRACK] = ACTIONS(618),
    [anon_sym_RBRACK] = ACTIONS(618),
    [anon_sym_RBRACE] = ACTIONS(618),
    [sym_type_conversion] = ACTIONS(618),
    [sym_comment] = ACTIONS(3),
  },
  [488] = {
    [anon_sym_DOT] = ACTIONS(666),
    [anon_sym_LPAREN] = ACTIONS(666),
    [anon_sym_RPAREN] = ACTIONS(666),
    [anon_sym_COMMA] = ACTIONS(666),
    [anon_sym_STAR] = ACTIONS(668),
    [anon_sym_GT_GT] = ACTIONS(666),
    [anon_sym_if] = ACTIONS(666),
    [anon_sym_COLON] = ACTIONS(666),
    [anon_sym_else] = ACTIONS(666),
    [anon_sym_async] = ACTIONS(666),
    [anon_sym_for] = ACTIONS(666),
    [anon_sym_in] = ACTIONS(666),
    [anon_sym_EQ] = ACTIONS(668),
    [anon_sym_STAR_STAR] = ACTIONS(666),
    [anon_sym_AT] = ACTIONS(666),
    [anon_sym_not] = ACTIONS(666),
    [anon_sym_and] = ACTIONS(666),
    [anon_sym_or] = ACTIONS(666),
    [anon_sym_PLUS] = ACTIONS(666),
    [anon_sym_DASH] = ACTIONS(666),
    [anon_sym_SLASH] = ACTIONS(668),
    [anon_sym_PERCENT] = ACTIONS(666),
    [anon_sym_SLASH_SLASH] = ACTIONS(666),
    [anon_sym_PIPE] = ACTIONS(666),
    [anon_sym_AMP] = ACTIONS(666),
    [anon_sym_CARET] = ACTIONS(666),
    [anon_sym_LT_LT] = ACTIONS(666),
    [anon_sym_LT] = ACTIONS(668),
    [anon_sym_LT_EQ] = ACTIONS(666),
    [anon_sym_EQ_EQ] = ACTIONS(666),
    [anon_sym_BANG_EQ] = ACTIONS(666),
    [anon_sym_GT_EQ] = ACTIONS(666),
    [anon_sym_GT] = ACTIONS(668),
    [anon_sym_LT_GT] = ACTIONS(666),
    [anon_sym_is] = ACTIONS(666),
    [anon_sym_LBRACK] = ACTIONS(666),
    [anon_sym_RBRACK] = ACTIONS(666),
    [anon_sym_RBRACE] = ACTIONS(666),
    [sym_type_conversion] = ACTIONS(666),
    [sym_comment] = ACTIONS(3),
  },
  [489] = {
    [anon_sym_DOT] = ACTIONS(588),
    [anon_sym_LPAREN] = ACTIONS(588),
    [anon_sym_RPAREN] = ACTIONS(588),
    [anon_sym_COMMA] = ACTIONS(588),
    [anon_sym_STAR] = ACTIONS(590),
    [anon_sym_GT_GT] = ACTIONS(588),
    [anon_sym_if] = ACTIONS(588),
    [anon_sym_COLON] = ACTIONS(588),
    [anon_sym_else] = ACTIONS(588),
    [anon_sym_async] = ACTIONS(588),
    [anon_sym_for] = ACTIONS(588),
    [anon_sym_in] = ACTIONS(588),
    [anon_sym_EQ] = ACTIONS(590),
    [anon_sym_STAR_STAR] = ACTIONS(588),
    [anon_sym_AT] = ACTIONS(588),
    [anon_sym_not] = ACTIONS(588),
    [anon_sym_and] = ACTIONS(588),
    [anon_sym_or] = ACTIONS(588),
    [anon_sym_PLUS] = ACTIONS(588),
    [anon_sym_DASH] = ACTIONS(588),
    [anon_sym_SLASH] = ACTIONS(590),
    [anon_sym_PERCENT] = ACTIONS(588),
    [anon_sym_SLASH_SLASH] = ACTIONS(588),
    [anon_sym_PIPE] = ACTIONS(588),
    [anon_sym_AMP] = ACTIONS(588),
    [anon_sym_CARET] = ACTIONS(588),
    [anon_sym_LT_LT] = ACTIONS(588),
    [anon_sym_LT] = ACTIONS(590),
    [anon_sym_LT_EQ] = ACTIONS(588),
    [anon_sym_EQ_EQ] = ACTIONS(588),
    [anon_sym_BANG_EQ] = ACTIONS(588),
    [anon_sym_GT_EQ] = ACTIONS(588),
    [anon_sym_GT] = ACTIONS(590),
    [anon_sym_LT_GT] = ACTIONS(588),
    [anon_sym_is] = ACTIONS(588),
    [anon_sym_LBRACK] = ACTIONS(588),
    [anon_sym_RBRACK] = ACTIONS(588),
    [anon_sym_RBRACE] = ACTIONS(588),
    [sym_type_conversion] = ACTIONS(588),
    [sym_comment] = ACTIONS(3),
  },
  [490] = {
    [anon_sym_DOT] = ACTIONS(690),
    [anon_sym_LPAREN] = ACTIONS(690),
    [anon_sym_RPAREN] = ACTIONS(690),
    [anon_sym_COMMA] = ACTIONS(690),
    [anon_sym_STAR] = ACTIONS(692),
    [anon_sym_GT_GT] = ACTIONS(690),
    [anon_sym_if] = ACTIONS(690),
    [anon_sym_COLON] = ACTIONS(690),
    [anon_sym_else] = ACTIONS(690),
    [anon_sym_async] = ACTIONS(690),
    [anon_sym_for] = ACTIONS(690),
    [anon_sym_in] = ACTIONS(690),
    [anon_sym_EQ] = ACTIONS(692),
    [anon_sym_STAR_STAR] = ACTIONS(690),
    [anon_sym_AT] = ACTIONS(690),
    [anon_sym_not] = ACTIONS(690),
    [anon_sym_and] = ACTIONS(690),
    [anon_sym_or] = ACTIONS(690),
    [anon_sym_PLUS] = ACTIONS(690),
    [anon_sym_DASH] = ACTIONS(690),
    [anon_sym_SLASH] = ACTIONS(692),
    [anon_sym_PERCENT] = ACTIONS(690),
    [anon_sym_SLASH_SLASH] = ACTIONS(690),
    [anon_sym_PIPE] = ACTIONS(690),
    [anon_sym_AMP] = ACTIONS(690),
    [anon_sym_CARET] = ACTIONS(690),
    [anon_sym_LT_LT] = ACTIONS(690),
    [anon_sym_LT] = ACTIONS(692),
    [anon_sym_LT_EQ] = ACTIONS(690),
    [anon_sym_EQ_EQ] = ACTIONS(690),
    [anon_sym_BANG_EQ] = ACTIONS(690),
    [anon_sym_GT_EQ] = ACTIONS(690),
    [anon_sym_GT] = ACTIONS(692),
    [anon_sym_LT_GT] = ACTIONS(690),
    [anon_sym_is] = ACTIONS(690),
    [anon_sym_LBRACK] = ACTIONS(690),
    [anon_sym_RBRACK] = ACTIONS(690),
    [anon_sym_RBRACE] = ACTIONS(690),
    [sym_type_conversion] = ACTIONS(690),
    [sym_comment] = ACTIONS(3),
  },
  [491] = {
    [anon_sym_DOT] = ACTIONS(630),
    [anon_sym_LPAREN] = ACTIONS(630),
    [anon_sym_RPAREN] = ACTIONS(630),
    [anon_sym_COMMA] = ACTIONS(630),
    [anon_sym_STAR] = ACTIONS(632),
    [anon_sym_GT_GT] = ACTIONS(630),
    [anon_sym_if] = ACTIONS(630),
    [anon_sym_COLON] = ACTIONS(630),
    [anon_sym_else] = ACTIONS(630),
    [anon_sym_async] = ACTIONS(630),
    [anon_sym_for] = ACTIONS(630),
    [anon_sym_in] = ACTIONS(630),
    [anon_sym_EQ] = ACTIONS(632),
    [anon_sym_STAR_STAR] = ACTIONS(630),
    [anon_sym_AT] = ACTIONS(630),
    [anon_sym_not] = ACTIONS(630),
    [anon_sym_and] = ACTIONS(630),
    [anon_sym_or] = ACTIONS(630),
    [anon_sym_PLUS] = ACTIONS(630),
    [anon_sym_DASH] = ACTIONS(630),
    [anon_sym_SLASH] = ACTIONS(632),
    [anon_sym_PERCENT] = ACTIONS(630),
    [anon_sym_SLASH_SLASH] = ACTIONS(630),
    [anon_sym_PIPE] = ACTIONS(630),
    [anon_sym_AMP] = ACTIONS(630),
    [anon_sym_CARET] = ACTIONS(630),
    [anon_sym_LT_LT] = ACTIONS(630),
    [anon_sym_LT] = ACTIONS(632),
    [anon_sym_LT_EQ] = ACTIONS(630),
    [anon_sym_EQ_EQ] = ACTIONS(630),
    [anon_sym_BANG_EQ] = ACTIONS(630),
    [anon_sym_GT_EQ] = ACTIONS(630),
    [anon_sym_GT] = ACTIONS(632),
    [anon_sym_LT_GT] = ACTIONS(630),
    [anon_sym_is] = ACTIONS(630),
    [anon_sym_LBRACK] = ACTIONS(630),
    [anon_sym_RBRACK] = ACTIONS(630),
    [anon_sym_RBRACE] = ACTIONS(630),
    [sym_type_conversion] = ACTIONS(630),
    [sym_comment] = ACTIONS(3),
  },
  [492] = {
    [anon_sym_DOT] = ACTIONS(672),
    [anon_sym_LPAREN] = ACTIONS(672),
    [anon_sym_RPAREN] = ACTIONS(672),
    [anon_sym_COMMA] = ACTIONS(672),
    [anon_sym_STAR] = ACTIONS(674),
    [anon_sym_GT_GT] = ACTIONS(672),
    [anon_sym_if] = ACTIONS(672),
    [anon_sym_COLON] = ACTIONS(672),
    [anon_sym_else] = ACTIONS(672),
    [anon_sym_async] = ACTIONS(672),
    [anon_sym_for] = ACTIONS(672),
    [anon_sym_in] = ACTIONS(672),
    [anon_sym_EQ] = ACTIONS(674),
    [anon_sym_STAR_STAR] = ACTIONS(672),
    [anon_sym_AT] = ACTIONS(672),
    [anon_sym_not] = ACTIONS(672),
    [anon_sym_and] = ACTIONS(672),
    [anon_sym_or] = ACTIONS(672),
    [anon_sym_PLUS] = ACTIONS(672),
    [anon_sym_DASH] = ACTIONS(672),
    [anon_sym_SLASH] = ACTIONS(674),
    [anon_sym_PERCENT] = ACTIONS(672),
    [anon_sym_SLASH_SLASH] = ACTIONS(672),
    [anon_sym_PIPE] = ACTIONS(672),
    [anon_sym_AMP] = ACTIONS(672),
    [anon_sym_CARET] = ACTIONS(672),
    [anon_sym_LT_LT] = ACTIONS(672),
    [anon_sym_LT] = ACTIONS(674),
    [anon_sym_LT_EQ] = ACTIONS(672),
    [anon_sym_EQ_EQ] = ACTIONS(672),
    [anon_sym_BANG_EQ] = ACTIONS(672),
    [anon_sym_GT_EQ] = ACTIONS(672),
    [anon_sym_GT] = ACTIONS(674),
    [anon_sym_LT_GT] = ACTIONS(672),
    [anon_sym_is] = ACTIONS(672),
    [anon_sym_LBRACK] = ACTIONS(672),
    [anon_sym_RBRACK] = ACTIONS(672),
    [anon_sym_RBRACE] = ACTIONS(672),
    [sym_type_conversion] = ACTIONS(672),
    [sym_comment] = ACTIONS(3),
  },
  [493] = {
    [anon_sym_DOT] = ACTIONS(582),
    [anon_sym_LPAREN] = ACTIONS(582),
    [anon_sym_RPAREN] = ACTIONS(582),
    [anon_sym_COMMA] = ACTIONS(582),
    [anon_sym_STAR] = ACTIONS(584),
    [anon_sym_GT_GT] = ACTIONS(582),
    [anon_sym_if] = ACTIONS(582),
    [anon_sym_COLON] = ACTIONS(582),
    [anon_sym_else] = ACTIONS(582),
    [anon_sym_async] = ACTIONS(582),
    [anon_sym_for] = ACTIONS(582),
    [anon_sym_in] = ACTIONS(582),
    [anon_sym_EQ] = ACTIONS(584),
    [anon_sym_STAR_STAR] = ACTIONS(582),
    [anon_sym_AT] = ACTIONS(582),
    [anon_sym_not] = ACTIONS(582),
    [anon_sym_and] = ACTIONS(582),
    [anon_sym_or] = ACTIONS(582),
    [anon_sym_PLUS] = ACTIONS(582),
    [anon_sym_DASH] = ACTIONS(582),
    [anon_sym_SLASH] = ACTIONS(584),
    [anon_sym_PERCENT] = ACTIONS(582),
    [anon_sym_SLASH_SLASH] = ACTIONS(582),
    [anon_sym_PIPE] = ACTIONS(582),
    [anon_sym_AMP] = ACTIONS(582),
    [anon_sym_CARET] = ACTIONS(582),
    [anon_sym_LT_LT] = ACTIONS(582),
    [anon_sym_LT] = ACTIONS(584),
    [anon_sym_LT_EQ] = ACTIONS(582),
    [anon_sym_EQ_EQ] = ACTIONS(582),
    [anon_sym_BANG_EQ] = ACTIONS(582),
    [anon_sym_GT_EQ] = ACTIONS(582),
    [anon_sym_GT] = ACTIONS(584),
    [anon_sym_LT_GT] = ACTIONS(582),
    [anon_sym_is] = ACTIONS(582),
    [anon_sym_LBRACK] = ACTIONS(582),
    [anon_sym_RBRACK] = ACTIONS(582),
    [anon_sym_RBRACE] = ACTIONS(582),
    [sym_type_conversion] = ACTIONS(582),
    [sym_comment] = ACTIONS(3),
  },
  [494] = {
    [anon_sym_DOT] = ACTIONS(540),
    [anon_sym_LPAREN] = ACTIONS(540),
    [anon_sym_RPAREN] = ACTIONS(540),
    [anon_sym_COMMA] = ACTIONS(540),
    [anon_sym_STAR] = ACTIONS(542),
    [anon_sym_GT_GT] = ACTIONS(540),
    [anon_sym_if] = ACTIONS(540),
    [anon_sym_COLON] = ACTIONS(540),
    [anon_sym_else] = ACTIONS(540),
    [anon_sym_async] = ACTIONS(540),
    [anon_sym_for] = ACTIONS(540),
    [anon_sym_in] = ACTIONS(540),
    [anon_sym_EQ] = ACTIONS(542),
    [anon_sym_STAR_STAR] = ACTIONS(540),
    [anon_sym_AT] = ACTIONS(540),
    [anon_sym_not] = ACTIONS(540),
    [anon_sym_and] = ACTIONS(540),
    [anon_sym_or] = ACTIONS(540),
    [anon_sym_PLUS] = ACTIONS(540),
    [anon_sym_DASH] = ACTIONS(540),
    [anon_sym_SLASH] = ACTIONS(542),
    [anon_sym_PERCENT] = ACTIONS(540),
    [anon_sym_SLASH_SLASH] = ACTIONS(540),
    [anon_sym_PIPE] = ACTIONS(540),
    [anon_sym_AMP] = ACTIONS(540),
    [anon_sym_CARET] = ACTIONS(540),
    [anon_sym_LT_LT] = ACTIONS(540),
    [anon_sym_LT] = ACTIONS(542),
    [anon_sym_LT_EQ] = ACTIONS(540),
    [anon_sym_EQ_EQ] = ACTIONS(540),
    [anon_sym_BANG_EQ] = ACTIONS(540),
    [anon_sym_GT_EQ] = ACTIONS(540),
    [anon_sym_GT] = ACTIONS(542),
    [anon_sym_LT_GT] = ACTIONS(540),
    [anon_sym_is] = ACTIONS(540),
    [anon_sym_LBRACK] = ACTIONS(540),
    [anon_sym_RBRACK] = ACTIONS(540),
    [anon_sym_RBRACE] = ACTIONS(540),
    [sym_type_conversion] = ACTIONS(540),
    [sym_comment] = ACTIONS(3),
  },
  [495] = {
    [anon_sym_DOT] = ACTIONS(606),
    [anon_sym_LPAREN] = ACTIONS(606),
    [anon_sym_RPAREN] = ACTIONS(606),
    [anon_sym_COMMA] = ACTIONS(606),
    [anon_sym_STAR] = ACTIONS(608),
    [anon_sym_GT_GT] = ACTIONS(606),
    [anon_sym_if] = ACTIONS(606),
    [anon_sym_COLON] = ACTIONS(606),
    [anon_sym_else] = ACTIONS(606),
    [anon_sym_async] = ACTIONS(606),
    [anon_sym_for] = ACTIONS(606),
    [anon_sym_in] = ACTIONS(606),
    [anon_sym_EQ] = ACTIONS(608),
    [anon_sym_STAR_STAR] = ACTIONS(606),
    [anon_sym_AT] = ACTIONS(606),
    [anon_sym_not] = ACTIONS(606),
    [anon_sym_and] = ACTIONS(606),
    [anon_sym_or] = ACTIONS(606),
    [anon_sym_PLUS] = ACTIONS(606),
    [anon_sym_DASH] = ACTIONS(606),
    [anon_sym_SLASH] = ACTIONS(608),
    [anon_sym_PERCENT] = ACTIONS(606),
    [anon_sym_SLASH_SLASH] = ACTIONS(606),
    [anon_sym_PIPE] = ACTIONS(606),
    [anon_sym_AMP] = ACTIONS(606),
    [anon_sym_CARET] = ACTIONS(606),
    [anon_sym_LT_LT] = ACTIONS(606),
    [anon_sym_LT] = ACTIONS(608),
    [anon_sym_LT_EQ] = ACTIONS(606),
    [anon_sym_EQ_EQ] = ACTIONS(606),
    [anon_sym_BANG_EQ] = ACTIONS(606),
    [anon_sym_GT_EQ] = ACTIONS(606),
    [anon_sym_GT] = ACTIONS(608),
    [anon_sym_LT_GT] = ACTIONS(606),
    [anon_sym_is] = ACTIONS(606),
    [anon_sym_LBRACK] = ACTIONS(606),
    [anon_sym_RBRACK] = ACTIONS(606),
    [anon_sym_RBRACE] = ACTIONS(606),
    [sym_type_conversion] = ACTIONS(606),
    [sym_comment] = ACTIONS(3),
  },
  [496] = {
    [anon_sym_DOT] = ACTIONS(634),
    [anon_sym_LPAREN] = ACTIONS(634),
    [anon_sym_RPAREN] = ACTIONS(634),
    [anon_sym_COMMA] = ACTIONS(634),
    [anon_sym_STAR] = ACTIONS(636),
    [anon_sym_GT_GT] = ACTIONS(634),
    [anon_sym_if] = ACTIONS(634),
    [anon_sym_COLON] = ACTIONS(634),
    [anon_sym_else] = ACTIONS(634),
    [anon_sym_async] = ACTIONS(634),
    [anon_sym_for] = ACTIONS(634),
    [anon_sym_in] = ACTIONS(634),
    [anon_sym_EQ] = ACTIONS(636),
    [anon_sym_STAR_STAR] = ACTIONS(634),
    [anon_sym_AT] = ACTIONS(634),
    [anon_sym_not] = ACTIONS(634),
    [anon_sym_and] = ACTIONS(634),
    [anon_sym_or] = ACTIONS(634),
    [anon_sym_PLUS] = ACTIONS(634),
    [anon_sym_DASH] = ACTIONS(634),
    [anon_sym_SLASH] = ACTIONS(636),
    [anon_sym_PERCENT] = ACTIONS(634),
    [anon_sym_SLASH_SLASH] = ACTIONS(634),
    [anon_sym_PIPE] = ACTIONS(634),
    [anon_sym_AMP] = ACTIONS(634),
    [anon_sym_CARET] = ACTIONS(634),
    [anon_sym_LT_LT] = ACTIONS(634),
    [anon_sym_LT] = ACTIONS(636),
    [anon_sym_LT_EQ] = ACTIONS(634),
    [anon_sym_EQ_EQ] = ACTIONS(634),
    [anon_sym_BANG_EQ] = ACTIONS(634),
    [anon_sym_GT_EQ] = ACTIONS(634),
    [anon_sym_GT] = ACTIONS(636),
    [anon_sym_LT_GT] = ACTIONS(634),
    [anon_sym_is] = ACTIONS(634),
    [anon_sym_LBRACK] = ACTIONS(634),
    [anon_sym_RBRACK] = ACTIONS(634),
    [anon_sym_RBRACE] = ACTIONS(634),
    [sym_type_conversion] = ACTIONS(634),
    [sym_comment] = ACTIONS(3),
  },
  [497] = {
    [anon_sym_DOT] = ACTIONS(676),
    [anon_sym_LPAREN] = ACTIONS(676),
    [anon_sym_RPAREN] = ACTIONS(676),
    [anon_sym_COMMA] = ACTIONS(676),
    [anon_sym_STAR] = ACTIONS(678),
    [anon_sym_GT_GT] = ACTIONS(676),
    [anon_sym_if] = ACTIONS(676),
    [anon_sym_COLON] = ACTIONS(676),
    [anon_sym_else] = ACTIONS(676),
    [anon_sym_async] = ACTIONS(676),
    [anon_sym_for] = ACTIONS(676),
    [anon_sym_in] = ACTIONS(676),
    [anon_sym_EQ] = ACTIONS(678),
    [anon_sym_STAR_STAR] = ACTIONS(676),
    [anon_sym_AT] = ACTIONS(676),
    [anon_sym_not] = ACTIONS(676),
    [anon_sym_and] = ACTIONS(676),
    [anon_sym_or] = ACTIONS(676),
    [anon_sym_PLUS] = ACTIONS(676),
    [anon_sym_DASH] = ACTIONS(676),
    [anon_sym_SLASH] = ACTIONS(678),
    [anon_sym_PERCENT] = ACTIONS(676),
    [anon_sym_SLASH_SLASH] = ACTIONS(676),
    [anon_sym_PIPE] = ACTIONS(676),
    [anon_sym_AMP] = ACTIONS(676),
    [anon_sym_CARET] = ACTIONS(676),
    [anon_sym_LT_LT] = ACTIONS(676),
    [anon_sym_LT] = ACTIONS(678),
    [anon_sym_LT_EQ] = ACTIONS(676),
    [anon_sym_EQ_EQ] = ACTIONS(676),
    [anon_sym_BANG_EQ] = ACTIONS(676),
    [anon_sym_GT_EQ] = ACTIONS(676),
    [anon_sym_GT] = ACTIONS(678),
    [anon_sym_LT_GT] = ACTIONS(676),
    [anon_sym_is] = ACTIONS(676),
    [anon_sym_LBRACK] = ACTIONS(676),
    [anon_sym_RBRACK] = ACTIONS(676),
    [anon_sym_RBRACE] = ACTIONS(676),
    [sym_type_conversion] = ACTIONS(676),
    [sym_comment] = ACTIONS(3),
  },
  [498] = {
    [anon_sym_DOT] = ACTIONS(610),
    [anon_sym_LPAREN] = ACTIONS(610),
    [anon_sym_RPAREN] = ACTIONS(610),
    [anon_sym_COMMA] = ACTIONS(610),
    [anon_sym_STAR] = ACTIONS(612),
    [anon_sym_GT_GT] = ACTIONS(610),
    [anon_sym_if] = ACTIONS(610),
    [anon_sym_COLON] = ACTIONS(610),
    [anon_sym_else] = ACTIONS(610),
    [anon_sym_async] = ACTIONS(610),
    [anon_sym_for] = ACTIONS(610),
    [anon_sym_in] = ACTIONS(610),
    [anon_sym_EQ] = ACTIONS(612),
    [anon_sym_STAR_STAR] = ACTIONS(610),
    [anon_sym_AT] = ACTIONS(610),
    [anon_sym_not] = ACTIONS(610),
    [anon_sym_and] = ACTIONS(610),
    [anon_sym_or] = ACTIONS(610),
    [anon_sym_PLUS] = ACTIONS(610),
    [anon_sym_DASH] = ACTIONS(610),
    [anon_sym_SLASH] = ACTIONS(612),
    [anon_sym_PERCENT] = ACTIONS(610),
    [anon_sym_SLASH_SLASH] = ACTIONS(610),
    [anon_sym_PIPE] = ACTIONS(610),
    [anon_sym_AMP] = ACTIONS(610),
    [anon_sym_CARET] = ACTIONS(610),
    [anon_sym_LT_LT] = ACTIONS(610),
    [anon_sym_LT] = ACTIONS(612),
    [anon_sym_LT_EQ] = ACTIONS(610),
    [anon_sym_EQ_EQ] = ACTIONS(610),
    [anon_sym_BANG_EQ] = ACTIONS(610),
    [anon_sym_GT_EQ] = ACTIONS(610),
    [anon_sym_GT] = ACTIONS(612),
    [anon_sym_LT_GT] = ACTIONS(610),
    [anon_sym_is] = ACTIONS(610),
    [anon_sym_LBRACK] = ACTIONS(610),
    [anon_sym_RBRACK] = ACTIONS(610),
    [anon_sym_RBRACE] = ACTIONS(610),
    [sym_type_conversion] = ACTIONS(610),
    [sym_comment] = ACTIONS(3),
  },
  [499] = {
    [anon_sym_DOT] = ACTIONS(602),
    [anon_sym_LPAREN] = ACTIONS(602),
    [anon_sym_RPAREN] = ACTIONS(602),
    [anon_sym_COMMA] = ACTIONS(602),
    [anon_sym_STAR] = ACTIONS(604),
    [anon_sym_GT_GT] = ACTIONS(602),
    [anon_sym_if] = ACTIONS(602),
    [anon_sym_COLON] = ACTIONS(602),
    [anon_sym_else] = ACTIONS(602),
    [anon_sym_async] = ACTIONS(602),
    [anon_sym_for] = ACTIONS(602),
    [anon_sym_in] = ACTIONS(602),
    [anon_sym_EQ] = ACTIONS(604),
    [anon_sym_STAR_STAR] = ACTIONS(602),
    [anon_sym_AT] = ACTIONS(602),
    [anon_sym_not] = ACTIONS(602),
    [anon_sym_and] = ACTIONS(602),
    [anon_sym_or] = ACTIONS(602),
    [anon_sym_PLUS] = ACTIONS(602),
    [anon_sym_DASH] = ACTIONS(602),
    [anon_sym_SLASH] = ACTIONS(604),
    [anon_sym_PERCENT] = ACTIONS(602),
    [anon_sym_SLASH_SLASH] = ACTIONS(602),
    [anon_sym_PIPE] = ACTIONS(602),
    [anon_sym_AMP] = ACTIONS(602),
    [anon_sym_CARET] = ACTIONS(602),
    [anon_sym_LT_LT] = ACTIONS(602),
    [anon_sym_LT] = ACTIONS(604),
    [anon_sym_LT_EQ] = ACTIONS(602),
    [anon_sym_EQ_EQ] = ACTIONS(602),
    [anon_sym_BANG_EQ] = ACTIONS(602),
    [anon_sym_GT_EQ] = ACTIONS(602),
    [anon_sym_GT] = ACTIONS(604),
    [anon_sym_LT_GT] = ACTIONS(602),
    [anon_sym_is] = ACTIONS(602),
    [anon_sym_LBRACK] = ACTIONS(602),
    [anon_sym_RBRACK] = ACTIONS(602),
    [anon_sym_RBRACE] = ACTIONS(602),
    [sym_type_conversion] = ACTIONS(602),
    [sym_comment] = ACTIONS(3),
  },
  [500] = {
    [anon_sym_DOT] = ACTIONS(594),
    [anon_sym_LPAREN] = ACTIONS(594),
    [anon_sym_RPAREN] = ACTIONS(594),
    [anon_sym_COMMA] = ACTIONS(594),
    [anon_sym_STAR] = ACTIONS(596),
    [anon_sym_GT_GT] = ACTIONS(594),
    [anon_sym_if] = ACTIONS(594),
    [anon_sym_COLON] = ACTIONS(594),
    [anon_sym_else] = ACTIONS(594),
    [anon_sym_async] = ACTIONS(594),
    [anon_sym_for] = ACTIONS(594),
    [anon_sym_in] = ACTIONS(594),
    [anon_sym_EQ] = ACTIONS(596),
    [anon_sym_STAR_STAR] = ACTIONS(594),
    [anon_sym_AT] = ACTIONS(594),
    [anon_sym_not] = ACTIONS(594),
    [anon_sym_and] = ACTIONS(594),
    [anon_sym_or] = ACTIONS(594),
    [anon_sym_PLUS] = ACTIONS(594),
    [anon_sym_DASH] = ACTIONS(594),
    [anon_sym_SLASH] = ACTIONS(596),
    [anon_sym_PERCENT] = ACTIONS(594),
    [anon_sym_SLASH_SLASH] = ACTIONS(594),
    [anon_sym_PIPE] = ACTIONS(594),
    [anon_sym_AMP] = ACTIONS(594),
    [anon_sym_CARET] = ACTIONS(594),
    [anon_sym_LT_LT] = ACTIONS(594),
    [anon_sym_LT] = ACTIONS(596),
    [anon_sym_LT_EQ] = ACTIONS(594),
    [anon_sym_EQ_EQ] = ACTIONS(594),
    [anon_sym_BANG_EQ] = ACTIONS(594),
    [anon_sym_GT_EQ] = ACTIONS(594),
    [anon_sym_GT] = ACTIONS(596),
    [anon_sym_LT_GT] = ACTIONS(594),
    [anon_sym_is] = ACTIONS(594),
    [anon_sym_LBRACK] = ACTIONS(594),
    [anon_sym_RBRACK] = ACTIONS(594),
    [anon_sym_RBRACE] = ACTIONS(594),
    [sym_type_conversion] = ACTIONS(594),
    [sym_comment] = ACTIONS(3),
  },
  [501] = {
    [anon_sym_DOT] = ACTIONS(638),
    [anon_sym_LPAREN] = ACTIONS(638),
    [anon_sym_RPAREN] = ACTIONS(638),
    [anon_sym_COMMA] = ACTIONS(638),
    [anon_sym_STAR] = ACTIONS(640),
    [anon_sym_GT_GT] = ACTIONS(638),
    [anon_sym_if] = ACTIONS(638),
    [anon_sym_COLON] = ACTIONS(638),
    [anon_sym_else] = ACTIONS(638),
    [anon_sym_async] = ACTIONS(638),
    [anon_sym_for] = ACTIONS(638),
    [anon_sym_in] = ACTIONS(638),
    [anon_sym_EQ] = ACTIONS(640),
    [anon_sym_STAR_STAR] = ACTIONS(638),
    [anon_sym_AT] = ACTIONS(638),
    [anon_sym_not] = ACTIONS(638),
    [anon_sym_and] = ACTIONS(638),
    [anon_sym_or] = ACTIONS(638),
    [anon_sym_PLUS] = ACTIONS(638),
    [anon_sym_DASH] = ACTIONS(638),
    [anon_sym_SLASH] = ACTIONS(640),
    [anon_sym_PERCENT] = ACTIONS(638),
    [anon_sym_SLASH_SLASH] = ACTIONS(638),
    [anon_sym_PIPE] = ACTIONS(638),
    [anon_sym_AMP] = ACTIONS(638),
    [anon_sym_CARET] = ACTIONS(638),
    [anon_sym_LT_LT] = ACTIONS(638),
    [anon_sym_LT] = ACTIONS(640),
    [anon_sym_LT_EQ] = ACTIONS(638),
    [anon_sym_EQ_EQ] = ACTIONS(638),
    [anon_sym_BANG_EQ] = ACTIONS(638),
    [anon_sym_GT_EQ] = ACTIONS(638),
    [anon_sym_GT] = ACTIONS(640),
    [anon_sym_LT_GT] = ACTIONS(638),
    [anon_sym_is] = ACTIONS(638),
    [anon_sym_LBRACK] = ACTIONS(638),
    [anon_sym_RBRACK] = ACTIONS(638),
    [anon_sym_RBRACE] = ACTIONS(638),
    [sym_type_conversion] = ACTIONS(638),
    [sym_comment] = ACTIONS(3),
  },
  [502] = {
    [anon_sym_DOT] = ACTIONS(696),
    [anon_sym_LPAREN] = ACTIONS(696),
    [anon_sym_RPAREN] = ACTIONS(696),
    [anon_sym_COMMA] = ACTIONS(696),
    [anon_sym_STAR] = ACTIONS(698),
    [anon_sym_GT_GT] = ACTIONS(696),
    [anon_sym_if] = ACTIONS(696),
    [anon_sym_COLON] = ACTIONS(696),
    [anon_sym_else] = ACTIONS(696),
    [anon_sym_async] = ACTIONS(696),
    [anon_sym_for] = ACTIONS(696),
    [anon_sym_in] = ACTIONS(696),
    [anon_sym_EQ] = ACTIONS(698),
    [anon_sym_STAR_STAR] = ACTIONS(696),
    [anon_sym_AT] = ACTIONS(696),
    [anon_sym_not] = ACTIONS(696),
    [anon_sym_and] = ACTIONS(696),
    [anon_sym_or] = ACTIONS(696),
    [anon_sym_PLUS] = ACTIONS(696),
    [anon_sym_DASH] = ACTIONS(696),
    [anon_sym_SLASH] = ACTIONS(698),
    [anon_sym_PERCENT] = ACTIONS(696),
    [anon_sym_SLASH_SLASH] = ACTIONS(696),
    [anon_sym_PIPE] = ACTIONS(696),
    [anon_sym_AMP] = ACTIONS(696),
    [anon_sym_CARET] = ACTIONS(696),
    [anon_sym_LT_LT] = ACTIONS(696),
    [anon_sym_LT] = ACTIONS(698),
    [anon_sym_LT_EQ] = ACTIONS(696),
    [anon_sym_EQ_EQ] = ACTIONS(696),
    [anon_sym_BANG_EQ] = ACTIONS(696),
    [anon_sym_GT_EQ] = ACTIONS(696),
    [anon_sym_GT] = ACTIONS(698),
    [anon_sym_LT_GT] = ACTIONS(696),
    [anon_sym_is] = ACTIONS(696),
    [anon_sym_LBRACK] = ACTIONS(696),
    [anon_sym_RBRACK] = ACTIONS(696),
    [anon_sym_RBRACE] = ACTIONS(696),
    [sym_type_conversion] = ACTIONS(696),
    [sym_comment] = ACTIONS(3),
  },
  [503] = {
    [sym_argument_list] = STATE(572),
    [sym_generator_expression] = STATE(572),
    [aux_sym_comparison_operator_repeat1] = STATE(616),
    [anon_sym_DOT] = ACTIONS(1111),
    [anon_sym_LPAREN] = ACTIONS(1113),
    [anon_sym_COMMA] = ACTIONS(413),
    [anon_sym_as] = ACTIONS(413),
    [anon_sym_STAR] = ACTIONS(1115),
    [anon_sym_GT_GT] = ACTIONS(1117),
    [anon_sym_if] = ACTIONS(413),
    [anon_sym_COLON] = ACTIONS(413),
    [anon_sym_in] = ACTIONS(1119),
    [anon_sym_STAR_STAR] = ACTIONS(1121),
    [anon_sym_AT] = ACTIONS(1123),
    [anon_sym_not] = ACTIONS(1125),
    [anon_sym_and] = ACTIONS(413),
    [anon_sym_or] = ACTIONS(413),
    [anon_sym_PLUS] = ACTIONS(1127),
    [anon_sym_DASH] = ACTIONS(1127),
    [anon_sym_SLASH] = ACTIONS(1115),
    [anon_sym_PERCENT] = ACTIONS(1123),
    [anon_sym_SLASH_SLASH] = ACTIONS(1123),
    [anon_sym_PIPE] = ACTIONS(1129),
    [anon_sym_AMP] = ACTIONS(1131),
    [anon_sym_CARET] = ACTIONS(1133),
    [anon_sym_LT_LT] = ACTIONS(1117),
    [anon_sym_LT] = ACTIONS(1135),
    [anon_sym_LT_EQ] = ACTIONS(1119),
    [anon_sym_EQ_EQ] = ACTIONS(1119),
    [anon_sym_BANG_EQ] = ACTIONS(1119),
    [anon_sym_GT_EQ] = ACTIONS(1119),
    [anon_sym_GT] = ACTIONS(1135),
    [anon_sym_LT_GT] = ACTIONS(1119),
    [anon_sym_is] = ACTIONS(1137),
    [anon_sym_LBRACK] = ACTIONS(1139),
    [sym_comment] = ACTIONS(3),
  },
  [504] = {
    [anon_sym_DOT] = ACTIONS(467),
    [anon_sym_LPAREN] = ACTIONS(467),
    [anon_sym_RPAREN] = ACTIONS(467),
    [anon_sym_COMMA] = ACTIONS(467),
    [anon_sym_STAR] = ACTIONS(469),
    [anon_sym_GT_GT] = ACTIONS(467),
    [anon_sym_COLON_EQ] = ACTIONS(1109),
    [anon_sym_if] = ACTIONS(467),
    [anon_sym_async] = ACTIONS(467),
    [anon_sym_for] = ACTIONS(467),
    [anon_sym_in] = ACTIONS(467),
    [anon_sym_EQ] = ACTIONS(1141),
    [anon_sym_STAR_STAR] = ACTIONS(467),
    [anon_sym_AT] = ACTIONS(467),
    [anon_sym_not] = ACTIONS(467),
    [anon_sym_and] = ACTIONS(467),
    [anon_sym_or] = ACTIONS(467),
    [anon_sym_PLUS] = ACTIONS(467),
    [anon_sym_DASH] = ACTIONS(467),
    [anon_sym_SLASH] = ACTIONS(469),
    [anon_sym_PERCENT] = ACTIONS(467),
    [anon_sym_SLASH_SLASH] = ACTIONS(467),
    [anon_sym_PIPE] = ACTIONS(467),
    [anon_sym_AMP] = ACTIONS(467),
    [anon_sym_CARET] = ACTIONS(467),
    [anon_sym_LT_LT] = ACTIONS(467),
    [anon_sym_LT] = ACTIONS(469),
    [anon_sym_LT_EQ] = ACTIONS(467),
    [anon_sym_EQ_EQ] = ACTIONS(467),
    [anon_sym_BANG_EQ] = ACTIONS(467),
    [anon_sym_GT_EQ] = ACTIONS(467),
    [anon_sym_GT] = ACTIONS(469),
    [anon_sym_LT_GT] = ACTIONS(467),
    [anon_sym_is] = ACTIONS(467),
    [anon_sym_LBRACK] = ACTIONS(467),
    [sym_comment] = ACTIONS(3),
  },
  [505] = {
    [sym_string] = STATE(506),
    [aux_sym_concatenated_string_repeat1] = STATE(506),
    [anon_sym_DOT] = ACTIONS(467),
    [anon_sym_LPAREN] = ACTIONS(467),
    [anon_sym_COMMA] = ACTIONS(467),
    [anon_sym_as] = ACTIONS(467),
    [anon_sym_STAR] = ACTIONS(469),
    [anon_sym_GT_GT] = ACTIONS(467),
    [anon_sym_if] = ACTIONS(467),
    [anon_sym_COLON] = ACTIONS(467),
    [anon_sym_in] = ACTIONS(467),
    [anon_sym_STAR_STAR] = ACTIONS(467),
    [anon_sym_AT] = ACTIONS(467),
    [anon_sym_not] = ACTIONS(467),
    [anon_sym_and] = ACTIONS(467),
    [anon_sym_or] = ACTIONS(467),
    [anon_sym_PLUS] = ACTIONS(467),
    [anon_sym_DASH] = ACTIONS(467),
    [anon_sym_SLASH] = ACTIONS(469),
    [anon_sym_PERCENT] = ACTIONS(467),
    [anon_sym_SLASH_SLASH] = ACTIONS(467),
    [anon_sym_PIPE] = ACTIONS(467),
    [anon_sym_AMP] = ACTIONS(467),
    [anon_sym_CARET] = ACTIONS(467),
    [anon_sym_LT_LT] = ACTIONS(467),
    [anon_sym_LT] = ACTIONS(469),
    [anon_sym_LT_EQ] = ACTIONS(467),
    [anon_sym_EQ_EQ] = ACTIONS(467),
    [anon_sym_BANG_EQ] = ACTIONS(467),
    [anon_sym_GT_EQ] = ACTIONS(467),
    [anon_sym_GT] = ACTIONS(469),
    [anon_sym_LT_GT] = ACTIONS(467),
    [anon_sym_is] = ACTIONS(467),
    [anon_sym_LBRACK] = ACTIONS(467),
    [sym_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(834),
  },
  [506] = {
    [sym_string] = STATE(507),
    [aux_sym_concatenated_string_repeat1] = STATE(507),
    [anon_sym_DOT] = ACTIONS(486),
    [anon_sym_LPAREN] = ACTIONS(486),
    [anon_sym_COMMA] = ACTIONS(486),
    [anon_sym_as] = ACTIONS(486),
    [anon_sym_STAR] = ACTIONS(488),
    [anon_sym_GT_GT] = ACTIONS(486),
    [anon_sym_if] = ACTIONS(486),
    [anon_sym_COLON] = ACTIONS(486),
    [anon_sym_in] = ACTIONS(486),
    [anon_sym_STAR_STAR] = ACTIONS(486),
    [anon_sym_AT] = ACTIONS(486),
    [anon_sym_not] = ACTIONS(486),
    [anon_sym_and] = ACTIONS(486),
    [anon_sym_or] = ACTIONS(486),
    [anon_sym_PLUS] = ACTIONS(486),
    [anon_sym_DASH] = ACTIONS(486),
    [anon_sym_SLASH] = ACTIONS(488),
    [anon_sym_PERCENT] = ACTIONS(486),
    [anon_sym_SLASH_SLASH] = ACTIONS(486),
    [anon_sym_PIPE] = ACTIONS(486),
    [anon_sym_AMP] = ACTIONS(486),
    [anon_sym_CARET] = ACTIONS(486),
    [anon_sym_LT_LT] = ACTIONS(486),
    [anon_sym_LT] = ACTIONS(488),
    [anon_sym_LT_EQ] = ACTIONS(486),
    [anon_sym_EQ_EQ] = ACTIONS(486),
    [anon_sym_BANG_EQ] = ACTIONS(486),
    [anon_sym_GT_EQ] = ACTIONS(486),
    [anon_sym_GT] = ACTIONS(488),
    [anon_sym_LT_GT] = ACTIONS(486),
    [anon_sym_is] = ACTIONS(486),
    [anon_sym_LBRACK] = ACTIONS(486),
    [sym_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(834),
  },
  [507] = {
    [sym_string] = STATE(507),
    [aux_sym_concatenated_string_repeat1] = STATE(507),
    [anon_sym_DOT] = ACTIONS(475),
    [anon_sym_LPAREN] = ACTIONS(475),
    [anon_sym_COMMA] = ACTIONS(475),
    [anon_sym_as] = ACTIONS(475),
    [anon_sym_STAR] = ACTIONS(477),
    [anon_sym_GT_GT] = ACTIONS(475),
    [anon_sym_if] = ACTIONS(475),
    [anon_sym_COLON] = ACTIONS(475),
    [anon_sym_in] = ACTIONS(475),
    [anon_sym_STAR_STAR] = ACTIONS(475),
    [anon_sym_AT] = ACTIONS(475),
    [anon_sym_not] = ACTIONS(475),
    [anon_sym_and] = ACTIONS(475),
    [anon_sym_or] = ACTIONS(475),
    [anon_sym_PLUS] = ACTIONS(475),
    [anon_sym_DASH] = ACTIONS(475),
    [anon_sym_SLASH] = ACTIONS(477),
    [anon_sym_PERCENT] = ACTIONS(475),
    [anon_sym_SLASH_SLASH] = ACTIONS(475),
    [anon_sym_PIPE] = ACTIONS(475),
    [anon_sym_AMP] = ACTIONS(475),
    [anon_sym_CARET] = ACTIONS(475),
    [anon_sym_LT_LT] = ACTIONS(475),
    [anon_sym_LT] = ACTIONS(477),
    [anon_sym_LT_EQ] = ACTIONS(475),
    [anon_sym_EQ_EQ] = ACTIONS(475),
    [anon_sym_BANG_EQ] = ACTIONS(475),
    [anon_sym_GT_EQ] = ACTIONS(475),
    [anon_sym_GT] = ACTIONS(477),
    [anon_sym_LT_GT] = ACTIONS(475),
    [anon_sym_is] = ACTIONS(475),
    [anon_sym_LBRACK] = ACTIONS(475),
    [sym_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(1143),
  },
  [508] = {
    [sym_variables] = STATE(997),
    [sym__primary_expression] = STATE(610),
    [sym_binary_operator] = STATE(610),
    [sym_unary_operator] = STATE(610),
    [sym_attribute] = STATE(610),
    [sym_subscript] = STATE(610),
    [sym_call] = STATE(610),
    [sym_list] = STATE(610),
    [sym_list_comprehension] = STATE(610),
    [sym_dictionary] = STATE(610),
    [sym_dictionary_comprehension] = STATE(610),
    [sym_set] = STATE(610),
    [sym_set_comprehension] = STATE(610),
    [sym_parenthesized_expression] = STATE(610),
    [sym_tuple] = STATE(610),
    [sym_generator_expression] = STATE(610),
    [sym_concatenated_string] = STATE(610),
    [sym_string] = STATE(381),
    [sym_identifier] = ACTIONS(1146),
    [anon_sym_LPAREN] = ACTIONS(389),
    [anon_sym_print] = ACTIONS(393),
    [anon_sym_exec] = ACTIONS(393),
    [anon_sym_PLUS] = ACTIONS(363),
    [anon_sym_DASH] = ACTIONS(363),
    [anon_sym_TILDE] = ACTIONS(363),
    [anon_sym_LBRACK] = ACTIONS(367),
    [sym_ellipsis] = ACTIONS(1148),
    [anon_sym_LBRACE] = ACTIONS(371),
    [sym_integer] = ACTIONS(1146),
    [sym_float] = ACTIONS(1148),
    [sym_true] = ACTIONS(1146),
    [sym_false] = ACTIONS(1146),
    [sym_none] = ACTIONS(1146),
    [sym_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(377),
  },
  [509] = {
    [sym__primary_expression] = STATE(132),
    [sym_binary_operator] = STATE(132),
    [sym_unary_operator] = STATE(132),
    [sym_attribute] = STATE(132),
    [sym_subscript] = STATE(132),
    [sym_call] = STATE(132),
    [sym_list] = STATE(132),
    [sym_list_comprehension] = STATE(132),
    [sym_dictionary] = STATE(132),
    [sym_dictionary_comprehension] = STATE(132),
    [sym_set] = STATE(132),
    [sym_set_comprehension] = STATE(132),
    [sym_parenthesized_expression] = STATE(132),
    [sym_tuple] = STATE(132),
    [sym_generator_expression] = STATE(132),
    [sym_concatenated_string] = STATE(132),
    [sym_string] = STATE(117),
    [sym_identifier] = ACTIONS(1150),
    [anon_sym_LPAREN] = ACTIONS(13),
    [anon_sym_print] = ACTIONS(237),
    [anon_sym_exec] = ACTIONS(237),
    [anon_sym_not] = ACTIONS(1152),
    [anon_sym_PLUS] = ACTIONS(57),
    [anon_sym_DASH] = ACTIONS(57),
    [anon_sym_TILDE] = ACTIONS(57),
    [anon_sym_LBRACK] = ACTIONS(63),
    [sym_ellipsis] = ACTIONS(1154),
    [anon_sym_LBRACE] = ACTIONS(67),
    [sym_integer] = ACTIONS(1150),
    [sym_float] = ACTIONS(1154),
    [sym_true] = ACTIONS(1150),
    [sym_false] = ACTIONS(1150),
    [sym_none] = ACTIONS(1150),
    [sym_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(73),
  },
  [510] = {
    [sym_argument_list] = STATE(572),
    [sym_generator_expression] = STATE(572),
    [anon_sym_DOT] = ACTIONS(494),
    [anon_sym_LPAREN] = ACTIONS(1113),
    [anon_sym_COMMA] = ACTIONS(494),
    [anon_sym_as] = ACTIONS(494),
    [anon_sym_STAR] = ACTIONS(1115),
    [anon_sym_GT_GT] = ACTIONS(494),
    [anon_sym_if] = ACTIONS(494),
    [anon_sym_COLON] = ACTIONS(494),
    [anon_sym_in] = ACTIONS(494),
    [anon_sym_STAR_STAR] = ACTIONS(1121),
    [anon_sym_AT] = ACTIONS(1123),
    [anon_sym_not] = ACTIONS(494),
    [anon_sym_and] = ACTIONS(494),
    [anon_sym_or] = ACTIONS(494),
    [anon_sym_PLUS] = ACTIONS(494),
    [anon_sym_DASH] = ACTIONS(494),
    [anon_sym_SLASH] = ACTIONS(1115),
    [anon_sym_PERCENT] = ACTIONS(1123),
    [anon_sym_SLASH_SLASH] = ACTIONS(1123),
    [anon_sym_PIPE] = ACTIONS(494),
    [anon_sym_AMP] = ACTIONS(494),
    [anon_sym_CARET] = ACTIONS(494),
    [anon_sym_LT_LT] = ACTIONS(494),
    [anon_sym_LT] = ACTIONS(496),
    [anon_sym_LT_EQ] = ACTIONS(494),
    [anon_sym_EQ_EQ] = ACTIONS(494),
    [anon_sym_BANG_EQ] = ACTIONS(494),
    [anon_sym_GT_EQ] = ACTIONS(494),
    [anon_sym_GT] = ACTIONS(496),
    [anon_sym_LT_GT] = ACTIONS(494),
    [anon_sym_is] = ACTIONS(494),
    [anon_sym_LBRACK] = ACTIONS(494),
    [sym_comment] = ACTIONS(3),
  },
  [511] = {
    [anon_sym_DOT] = ACTIONS(235),
    [anon_sym_LPAREN] = ACTIONS(235),
    [anon_sym_RPAREN] = ACTIONS(235),
    [anon_sym_COMMA] = ACTIONS(235),
    [anon_sym_STAR] = ACTIONS(233),
    [anon_sym_GT_GT] = ACTIONS(235),
    [anon_sym_if] = ACTIONS(235),
    [anon_sym_async] = ACTIONS(235),
    [anon_sym_for] = ACTIONS(235),
    [anon_sym_in] = ACTIONS(235),
    [anon_sym_EQ] = ACTIONS(1156),
    [anon_sym_STAR_STAR] = ACTIONS(235),
    [anon_sym_AT] = ACTIONS(235),
    [anon_sym_not] = ACTIONS(235),
    [anon_sym_and] = ACTIONS(235),
    [anon_sym_or] = ACTIONS(235),
    [anon_sym_PLUS] = ACTIONS(235),
    [anon_sym_DASH] = ACTIONS(235),
    [anon_sym_SLASH] = ACTIONS(233),
    [anon_sym_PERCENT] = ACTIONS(235),
    [anon_sym_SLASH_SLASH] = ACTIONS(235),
    [anon_sym_PIPE] = ACTIONS(235),
    [anon_sym_AMP] = ACTIONS(235),
    [anon_sym_CARET] = ACTIONS(235),
    [anon_sym_LT_LT] = ACTIONS(235),
    [anon_sym_LT] = ACTIONS(233),
    [anon_sym_LT_EQ] = ACTIONS(235),
    [anon_sym_EQ_EQ] = ACTIONS(235),
    [anon_sym_BANG_EQ] = ACTIONS(235),
    [anon_sym_GT_EQ] = ACTIONS(235),
    [anon_sym_GT] = ACTIONS(233),
    [anon_sym_LT_GT] = ACTIONS(235),
    [anon_sym_is] = ACTIONS(235),
    [anon_sym_LBRACK] = ACTIONS(235),
    [sym_comment] = ACTIONS(3),
  },
  [512] = {
    [sym__primary_expression] = STATE(611),
    [sym_binary_operator] = STATE(611),
    [sym_unary_operator] = STATE(611),
    [sym_attribute] = STATE(611),
    [sym_subscript] = STATE(611),
    [sym_call] = STATE(611),
    [sym_list] = STATE(611),
    [sym_list_comprehension] = STATE(611),
    [sym_dictionary] = STATE(611),
    [sym_dictionary_comprehension] = STATE(611),
    [sym_set] = STATE(611),
    [sym_set_comprehension] = STATE(611),
    [sym_parenthesized_expression] = STATE(611),
    [sym_tuple] = STATE(611),
    [sym_generator_expression] = STATE(611),
    [sym_concatenated_string] = STATE(611),
    [sym_string] = STATE(381),
    [sym_identifier] = ACTIONS(1158),
    [anon_sym_LPAREN] = ACTIONS(389),
    [anon_sym_print] = ACTIONS(393),
    [anon_sym_in] = ACTIONS(1160),
    [anon_sym_exec] = ACTIONS(393),
    [anon_sym_PLUS] = ACTIONS(363),
    [anon_sym_DASH] = ACTIONS(363),
    [anon_sym_TILDE] = ACTIONS(363),
    [anon_sym_LBRACK] = ACTIONS(367),
    [sym_ellipsis] = ACTIONS(1162),
    [anon_sym_LBRACE] = ACTIONS(371),
    [sym_integer] = ACTIONS(1158),
    [sym_float] = ACTIONS(1162),
    [sym_true] = ACTIONS(1158),
    [sym_false] = ACTIONS(1158),
    [sym_none] = ACTIONS(1158),
    [sym_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(377),
  },
  [513] = {
    [sym__primary_expression] = STATE(611),
    [sym_binary_operator] = STATE(611),
    [sym_unary_operator] = STATE(611),
    [sym_attribute] = STATE(611),
    [sym_subscript] = STATE(611),
    [sym_call] = STATE(611),
    [sym_list] = STATE(611),
    [sym_list_comprehension] = STATE(611),
    [sym_dictionary] = STATE(611),
    [sym_dictionary_comprehension] = STATE(611),
    [sym_set] = STATE(611),
    [sym_set_comprehension] = STATE(611),
    [sym_parenthesized_expression] = STATE(611),
    [sym_tuple] = STATE(611),
    [sym_generator_expression] = STATE(611),
    [sym_concatenated_string] = STATE(611),
    [sym_string] = STATE(381),
    [sym_identifier] = ACTIONS(1158),
    [anon_sym_LPAREN] = ACTIONS(389),
    [anon_sym_print] = ACTIONS(393),
    [anon_sym_in] = ACTIONS(1164),
    [anon_sym_exec] = ACTIONS(393),
    [anon_sym_PLUS] = ACTIONS(363),
    [anon_sym_DASH] = ACTIONS(363),
    [anon_sym_TILDE] = ACTIONS(363),
    [anon_sym_LBRACK] = ACTIONS(367),
    [sym_ellipsis] = ACTIONS(1162),
    [anon_sym_LBRACE] = ACTIONS(371),
    [sym_integer] = ACTIONS(1158),
    [sym_float] = ACTIONS(1162),
    [sym_true] = ACTIONS(1158),
    [sym_false] = ACTIONS(1158),
    [sym_none] = ACTIONS(1158),
    [sym_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(377),
  },
  [514] = {
    [sym_argument_list] = STATE(572),
    [sym_generator_expression] = STATE(572),
    [anon_sym_DOT] = ACTIONS(494),
    [anon_sym_LPAREN] = ACTIONS(1113),
    [anon_sym_COMMA] = ACTIONS(494),
    [anon_sym_as] = ACTIONS(494),
    [anon_sym_STAR] = ACTIONS(1115),
    [anon_sym_GT_GT] = ACTIONS(1117),
    [anon_sym_if] = ACTIONS(494),
    [anon_sym_COLON] = ACTIONS(494),
    [anon_sym_in] = ACTIONS(494),
    [anon_sym_STAR_STAR] = ACTIONS(1121),
    [anon_sym_AT] = ACTIONS(1123),
    [anon_sym_not] = ACTIONS(494),
    [anon_sym_and] = ACTIONS(494),
    [anon_sym_or] = ACTIONS(494),
    [anon_sym_PLUS] = ACTIONS(1127),
    [anon_sym_DASH] = ACTIONS(1127),
    [anon_sym_SLASH] = ACTIONS(1115),
    [anon_sym_PERCENT] = ACTIONS(1123),
    [anon_sym_SLASH_SLASH] = ACTIONS(1123),
    [anon_sym_PIPE] = ACTIONS(494),
    [anon_sym_AMP] = ACTIONS(1131),
    [anon_sym_CARET] = ACTIONS(1133),
    [anon_sym_LT_LT] = ACTIONS(1117),
    [anon_sym_LT] = ACTIONS(496),
    [anon_sym_LT_EQ] = ACTIONS(494),
    [anon_sym_EQ_EQ] = ACTIONS(494),
    [anon_sym_BANG_EQ] = ACTIONS(494),
    [anon_sym_GT_EQ] = ACTIONS(494),
    [anon_sym_GT] = ACTIONS(496),
    [anon_sym_LT_GT] = ACTIONS(494),
    [anon_sym_is] = ACTIONS(494),
    [anon_sym_LBRACK] = ACTIONS(494),
    [sym_comment] = ACTIONS(3),
  },
  [515] = {
    [sym_argument_list] = STATE(572),
    [sym_generator_expression] = STATE(572),
    [anon_sym_DOT] = ACTIONS(494),
    [anon_sym_LPAREN] = ACTIONS(1113),
    [anon_sym_COMMA] = ACTIONS(494),
    [anon_sym_as] = ACTIONS(494),
    [anon_sym_STAR] = ACTIONS(1115),
    [anon_sym_GT_GT] = ACTIONS(1117),
    [anon_sym_if] = ACTIONS(494),
    [anon_sym_COLON] = ACTIONS(494),
    [anon_sym_in] = ACTIONS(494),
    [anon_sym_STAR_STAR] = ACTIONS(1121),
    [anon_sym_AT] = ACTIONS(1123),
    [anon_sym_not] = ACTIONS(494),
    [anon_sym_and] = ACTIONS(494),
    [anon_sym_or] = ACTIONS(494),
    [anon_sym_PLUS] = ACTIONS(1127),
    [anon_sym_DASH] = ACTIONS(1127),
    [anon_sym_SLASH] = ACTIONS(1115),
    [anon_sym_PERCENT] = ACTIONS(1123),
    [anon_sym_SLASH_SLASH] = ACTIONS(1123),
    [anon_sym_PIPE] = ACTIONS(494),
    [anon_sym_AMP] = ACTIONS(494),
    [anon_sym_CARET] = ACTIONS(1133),
    [anon_sym_LT_LT] = ACTIONS(1117),
    [anon_sym_LT] = ACTIONS(496),
    [anon_sym_LT_EQ] = ACTIONS(494),
    [anon_sym_EQ_EQ] = ACTIONS(494),
    [anon_sym_BANG_EQ] = ACTIONS(494),
    [anon_sym_GT_EQ] = ACTIONS(494),
    [anon_sym_GT] = ACTIONS(496),
    [anon_sym_LT_GT] = ACTIONS(494),
    [anon_sym_is] = ACTIONS(494),
    [anon_sym_LBRACK] = ACTIONS(494),
    [sym_comment] = ACTIONS(3),
  },
  [516] = {
    [sym_argument_list] = STATE(572),
    [sym_generator_expression] = STATE(572),
    [anon_sym_DOT] = ACTIONS(494),
    [anon_sym_LPAREN] = ACTIONS(1113),
    [anon_sym_COMMA] = ACTIONS(494),
    [anon_sym_as] = ACTIONS(494),
    [anon_sym_STAR] = ACTIONS(1115),
    [anon_sym_GT_GT] = ACTIONS(1117),
    [anon_sym_if] = ACTIONS(494),
    [anon_sym_COLON] = ACTIONS(494),
    [anon_sym_in] = ACTIONS(494),
    [anon_sym_STAR_STAR] = ACTIONS(1121),
    [anon_sym_AT] = ACTIONS(1123),
    [anon_sym_not] = ACTIONS(494),
    [anon_sym_and] = ACTIONS(494),
    [anon_sym_or] = ACTIONS(494),
    [anon_sym_PLUS] = ACTIONS(1127),
    [anon_sym_DASH] = ACTIONS(1127),
    [anon_sym_SLASH] = ACTIONS(1115),
    [anon_sym_PERCENT] = ACTIONS(1123),
    [anon_sym_SLASH_SLASH] = ACTIONS(1123),
    [anon_sym_PIPE] = ACTIONS(494),
    [anon_sym_AMP] = ACTIONS(494),
    [anon_sym_CARET] = ACTIONS(494),
    [anon_sym_LT_LT] = ACTIONS(1117),
    [anon_sym_LT] = ACTIONS(496),
    [anon_sym_LT_EQ] = ACTIONS(494),
    [anon_sym_EQ_EQ] = ACTIONS(494),
    [anon_sym_BANG_EQ] = ACTIONS(494),
    [anon_sym_GT_EQ] = ACTIONS(494),
    [anon_sym_GT] = ACTIONS(496),
    [anon_sym_LT_GT] = ACTIONS(494),
    [anon_sym_is] = ACTIONS(494),
    [anon_sym_LBRACK] = ACTIONS(494),
    [sym_comment] = ACTIONS(3),
  },
  [517] = {
    [sym_variables] = STATE(1034),
    [sym__primary_expression] = STATE(610),
    [sym_binary_operator] = STATE(610),
    [sym_unary_operator] = STATE(610),
    [sym_attribute] = STATE(610),
    [sym_subscript] = STATE(610),
    [sym_call] = STATE(610),
    [sym_list] = STATE(610),
    [sym_list_comprehension] = STATE(610),
    [sym_dictionary] = STATE(610),
    [sym_dictionary_comprehension] = STATE(610),
    [sym_set] = STATE(610),
    [sym_set_comprehension] = STATE(610),
    [sym_parenthesized_expression] = STATE(610),
    [sym_tuple] = STATE(610),
    [sym_generator_expression] = STATE(610),
    [sym_concatenated_string] = STATE(610),
    [sym_string] = STATE(381),
    [sym_identifier] = ACTIONS(1146),
    [anon_sym_LPAREN] = ACTIONS(389),
    [anon_sym_print] = ACTIONS(393),
    [anon_sym_exec] = ACTIONS(393),
    [anon_sym_PLUS] = ACTIONS(363),
    [anon_sym_DASH] = ACTIONS(363),
    [anon_sym_TILDE] = ACTIONS(363),
    [anon_sym_LBRACK] = ACTIONS(367),
    [sym_ellipsis] = ACTIONS(1148),
    [anon_sym_LBRACE] = ACTIONS(371),
    [sym_integer] = ACTIONS(1146),
    [sym_float] = ACTIONS(1148),
    [sym_true] = ACTIONS(1146),
    [sym_false] = ACTIONS(1146),
    [sym_none] = ACTIONS(1146),
    [sym_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(377),
  },
  [518] = {
    [sym_argument_list] = STATE(572),
    [sym_generator_expression] = STATE(572),
    [anon_sym_DOT] = ACTIONS(494),
    [anon_sym_LPAREN] = ACTIONS(1113),
    [anon_sym_COMMA] = ACTIONS(494),
    [anon_sym_as] = ACTIONS(494),
    [anon_sym_STAR] = ACTIONS(496),
    [anon_sym_GT_GT] = ACTIONS(494),
    [anon_sym_if] = ACTIONS(494),
    [anon_sym_COLON] = ACTIONS(494),
    [anon_sym_in] = ACTIONS(494),
    [anon_sym_STAR_STAR] = ACTIONS(494),
    [anon_sym_AT] = ACTIONS(494),
    [anon_sym_not] = ACTIONS(494),
    [anon_sym_and] = ACTIONS(494),
    [anon_sym_or] = ACTIONS(494),
    [anon_sym_PLUS] = ACTIONS(494),
    [anon_sym_DASH] = ACTIONS(494),
    [anon_sym_SLASH] = ACTIONS(496),
    [anon_sym_PERCENT] = ACTIONS(494),
    [anon_sym_SLASH_SLASH] = ACTIONS(494),
    [anon_sym_PIPE] = ACTIONS(494),
    [anon_sym_AMP] = ACTIONS(494),
    [anon_sym_CARET] = ACTIONS(494),
    [anon_sym_LT_LT] = ACTIONS(494),
    [anon_sym_LT] = ACTIONS(496),
    [anon_sym_LT_EQ] = ACTIONS(494),
    [anon_sym_EQ_EQ] = ACTIONS(494),
    [anon_sym_BANG_EQ] = ACTIONS(494),
    [anon_sym_GT_EQ] = ACTIONS(494),
    [anon_sym_GT] = ACTIONS(496),
    [anon_sym_LT_GT] = ACTIONS(494),
    [anon_sym_is] = ACTIONS(494),
    [anon_sym_LBRACK] = ACTIONS(494),
    [sym_comment] = ACTIONS(3),
  },
  [519] = {
    [sym_argument_list] = STATE(572),
    [sym_generator_expression] = STATE(572),
    [anon_sym_DOT] = ACTIONS(1111),
    [anon_sym_LPAREN] = ACTIONS(1113),
    [anon_sym_COMMA] = ACTIONS(498),
    [anon_sym_as] = ACTIONS(498),
    [anon_sym_STAR] = ACTIONS(1115),
    [anon_sym_GT_GT] = ACTIONS(1117),
    [anon_sym_if] = ACTIONS(498),
    [anon_sym_COLON] = ACTIONS(498),
    [anon_sym_in] = ACTIONS(498),
    [anon_sym_STAR_STAR] = ACTIONS(1121),
    [anon_sym_AT] = ACTIONS(1123),
    [anon_sym_not] = ACTIONS(498),
    [anon_sym_and] = ACTIONS(498),
    [anon_sym_or] = ACTIONS(498),
    [anon_sym_PLUS] = ACTIONS(1127),
    [anon_sym_DASH] = ACTIONS(1127),
    [anon_sym_SLASH] = ACTIONS(1115),
    [anon_sym_PERCENT] = ACTIONS(1123),
    [anon_sym_SLASH_SLASH] = ACTIONS(1123),
    [anon_sym_PIPE] = ACTIONS(1129),
    [anon_sym_AMP] = ACTIONS(1131),
    [anon_sym_CARET] = ACTIONS(1133),
    [anon_sym_LT_LT] = ACTIONS(1117),
    [anon_sym_LT] = ACTIONS(500),
    [anon_sym_LT_EQ] = ACTIONS(498),
    [anon_sym_EQ_EQ] = ACTIONS(498),
    [anon_sym_BANG_EQ] = ACTIONS(498),
    [anon_sym_GT_EQ] = ACTIONS(498),
    [anon_sym_GT] = ACTIONS(500),
    [anon_sym_LT_GT] = ACTIONS(498),
    [anon_sym_is] = ACTIONS(498),
    [anon_sym_LBRACK] = ACTIONS(1139),
    [sym_comment] = ACTIONS(3),
  },
  [520] = {
    [sym_argument_list] = STATE(572),
    [sym_generator_expression] = STATE(572),
    [anon_sym_DOT] = ACTIONS(494),
    [anon_sym_LPAREN] = ACTIONS(1113),
    [anon_sym_COMMA] = ACTIONS(494),
    [anon_sym_as] = ACTIONS(494),
    [anon_sym_STAR] = ACTIONS(1115),
    [anon_sym_GT_GT] = ACTIONS(494),
    [anon_sym_if] = ACTIONS(494),
    [anon_sym_COLON] = ACTIONS(494),
    [anon_sym_in] = ACTIONS(494),
    [anon_sym_STAR_STAR] = ACTIONS(1121),
    [anon_sym_AT] = ACTIONS(1123),
    [anon_sym_not] = ACTIONS(494),
    [anon_sym_and] = ACTIONS(494),
    [anon_sym_or] = ACTIONS(494),
    [anon_sym_PLUS] = ACTIONS(1127),
    [anon_sym_DASH] = ACTIONS(1127),
    [anon_sym_SLASH] = ACTIONS(1115),
    [anon_sym_PERCENT] = ACTIONS(1123),
    [anon_sym_SLASH_SLASH] = ACTIONS(1123),
    [anon_sym_PIPE] = ACTIONS(494),
    [anon_sym_AMP] = ACTIONS(494),
    [anon_sym_CARET] = ACTIONS(494),
    [anon_sym_LT_LT] = ACTIONS(494),
    [anon_sym_LT] = ACTIONS(496),
    [anon_sym_LT_EQ] = ACTIONS(494),
    [anon_sym_EQ_EQ] = ACTIONS(494),
    [anon_sym_BANG_EQ] = ACTIONS(494),
    [anon_sym_GT_EQ] = ACTIONS(494),
    [anon_sym_GT] = ACTIONS(496),
    [anon_sym_LT_GT] = ACTIONS(494),
    [anon_sym_is] = ACTIONS(494),
    [anon_sym_LBRACK] = ACTIONS(494),
    [sym_comment] = ACTIONS(3),
  },
  [521] = {
    [sym_argument_list] = STATE(572),
    [sym_generator_expression] = STATE(572),
    [anon_sym_DOT] = ACTIONS(494),
    [anon_sym_LPAREN] = ACTIONS(1113),
    [anon_sym_COMMA] = ACTIONS(494),
    [anon_sym_as] = ACTIONS(494),
    [anon_sym_STAR] = ACTIONS(496),
    [anon_sym_GT_GT] = ACTIONS(494),
    [anon_sym_if] = ACTIONS(494),
    [anon_sym_COLON] = ACTIONS(494),
    [anon_sym_in] = ACTIONS(494),
    [anon_sym_STAR_STAR] = ACTIONS(1121),
    [anon_sym_AT] = ACTIONS(494),
    [anon_sym_not] = ACTIONS(494),
    [anon_sym_and] = ACTIONS(494),
    [anon_sym_or] = ACTIONS(494),
    [anon_sym_PLUS] = ACTIONS(494),
    [anon_sym_DASH] = ACTIONS(494),
    [anon_sym_SLASH] = ACTIONS(496),
    [anon_sym_PERCENT] = ACTIONS(494),
    [anon_sym_SLASH_SLASH] = ACTIONS(494),
    [anon_sym_PIPE] = ACTIONS(494),
    [anon_sym_AMP] = ACTIONS(494),
    [anon_sym_CARET] = ACTIONS(494),
    [anon_sym_LT_LT] = ACTIONS(494),
    [anon_sym_LT] = ACTIONS(496),
    [anon_sym_LT_EQ] = ACTIONS(494),
    [anon_sym_EQ_EQ] = ACTIONS(494),
    [anon_sym_BANG_EQ] = ACTIONS(494),
    [anon_sym_GT_EQ] = ACTIONS(494),
    [anon_sym_GT] = ACTIONS(496),
    [anon_sym_LT_GT] = ACTIONS(494),
    [anon_sym_is] = ACTIONS(494),
    [anon_sym_LBRACK] = ACTIONS(494),
    [sym_comment] = ACTIONS(3),
  },
  [522] = {
    [sym_variables] = STATE(1008),
    [sym__primary_expression] = STATE(610),
    [sym_binary_operator] = STATE(610),
    [sym_unary_operator] = STATE(610),
    [sym_attribute] = STATE(610),
    [sym_subscript] = STATE(610),
    [sym_call] = STATE(610),
    [sym_list] = STATE(610),
    [sym_list_comprehension] = STATE(610),
    [sym_dictionary] = STATE(610),
    [sym_dictionary_comprehension] = STATE(610),
    [sym_set] = STATE(610),
    [sym_set_comprehension] = STATE(610),
    [sym_parenthesized_expression] = STATE(610),
    [sym_tuple] = STATE(610),
    [sym_generator_expression] = STATE(610),
    [sym_concatenated_string] = STATE(610),
    [sym_string] = STATE(381),
    [sym_identifier] = ACTIONS(1146),
    [anon_sym_LPAREN] = ACTIONS(389),
    [anon_sym_print] = ACTIONS(393),
    [anon_sym_exec] = ACTIONS(393),
    [anon_sym_PLUS] = ACTIONS(363),
    [anon_sym_DASH] = ACTIONS(363),
    [anon_sym_TILDE] = ACTIONS(363),
    [anon_sym_LBRACK] = ACTIONS(367),
    [sym_ellipsis] = ACTIONS(1148),
    [anon_sym_LBRACE] = ACTIONS(371),
    [sym_integer] = ACTIONS(1146),
    [sym_float] = ACTIONS(1148),
    [sym_true] = ACTIONS(1146),
    [sym_false] = ACTIONS(1146),
    [sym_none] = ACTIONS(1146),
    [sym_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(377),
  },
  [523] = {
    [sym__primary_expression] = STATE(519),
    [sym_binary_operator] = STATE(519),
    [sym_unary_operator] = STATE(519),
    [sym_attribute] = STATE(519),
    [sym_subscript] = STATE(519),
    [sym_call] = STATE(519),
    [sym_list] = STATE(519),
    [sym_list_comprehension] = STATE(519),
    [sym_dictionary] = STATE(519),
    [sym_dictionary_comprehension] = STATE(519),
    [sym_set] = STATE(519),
    [sym_set_comprehension] = STATE(519),
    [sym_parenthesized_expression] = STATE(519),
    [sym_tuple] = STATE(519),
    [sym_generator_expression] = STATE(519),
    [sym_concatenated_string] = STATE(519),
    [sym_string] = STATE(505),
    [sym_identifier] = ACTIONS(1166),
    [anon_sym_LPAREN] = ACTIONS(812),
    [anon_sym_print] = ACTIONS(814),
    [anon_sym_exec] = ACTIONS(814),
    [anon_sym_not] = ACTIONS(1168),
    [anon_sym_PLUS] = ACTIONS(820),
    [anon_sym_DASH] = ACTIONS(820),
    [anon_sym_TILDE] = ACTIONS(820),
    [anon_sym_LBRACK] = ACTIONS(824),
    [sym_ellipsis] = ACTIONS(1170),
    [anon_sym_LBRACE] = ACTIONS(828),
    [sym_integer] = ACTIONS(1166),
    [sym_float] = ACTIONS(1170),
    [sym_true] = ACTIONS(1166),
    [sym_false] = ACTIONS(1166),
    [sym_none] = ACTIONS(1166),
    [sym_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(834),
  },
  [524] = {
    [sym_variables] = STATE(1025),
    [sym__primary_expression] = STATE(610),
    [sym_binary_operator] = STATE(610),
    [sym_unary_operator] = STATE(610),
    [sym_attribute] = STATE(610),
    [sym_subscript] = STATE(610),
    [sym_call] = STATE(610),
    [sym_list] = STATE(610),
    [sym_list_comprehension] = STATE(610),
    [sym_dictionary] = STATE(610),
    [sym_dictionary_comprehension] = STATE(610),
    [sym_set] = STATE(610),
    [sym_set_comprehension] = STATE(610),
    [sym_parenthesized_expression] = STATE(610),
    [sym_tuple] = STATE(610),
    [sym_generator_expression] = STATE(610),
    [sym_concatenated_string] = STATE(610),
    [sym_string] = STATE(381),
    [sym_identifier] = ACTIONS(1146),
    [anon_sym_LPAREN] = ACTIONS(389),
    [anon_sym_print] = ACTIONS(393),
    [anon_sym_exec] = ACTIONS(393),
    [anon_sym_PLUS] = ACTIONS(363),
    [anon_sym_DASH] = ACTIONS(363),
    [anon_sym_TILDE] = ACTIONS(363),
    [anon_sym_LBRACK] = ACTIONS(367),
    [sym_ellipsis] = ACTIONS(1148),
    [anon_sym_LBRACE] = ACTIONS(371),
    [sym_integer] = ACTIONS(1146),
    [sym_float] = ACTIONS(1148),
    [sym_true] = ACTIONS(1146),
    [sym_false] = ACTIONS(1146),
    [sym_none] = ACTIONS(1146),
    [sym_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(377),
  },
  [525] = {
    [sym_variables] = STATE(957),
    [sym__primary_expression] = STATE(610),
    [sym_binary_operator] = STATE(610),
    [sym_unary_operator] = STATE(610),
    [sym_attribute] = STATE(610),
    [sym_subscript] = STATE(610),
    [sym_call] = STATE(610),
    [sym_list] = STATE(610),
    [sym_list_comprehension] = STATE(610),
    [sym_dictionary] = STATE(610),
    [sym_dictionary_comprehension] = STATE(610),
    [sym_set] = STATE(610),
    [sym_set_comprehension] = STATE(610),
    [sym_parenthesized_expression] = STATE(610),
    [sym_tuple] = STATE(610),
    [sym_generator_expression] = STATE(610),
    [sym_concatenated_string] = STATE(610),
    [sym_string] = STATE(381),
    [sym_identifier] = ACTIONS(1146),
    [anon_sym_LPAREN] = ACTIONS(389),
    [anon_sym_print] = ACTIONS(393),
    [anon_sym_exec] = ACTIONS(393),
    [anon_sym_PLUS] = ACTIONS(363),
    [anon_sym_DASH] = ACTIONS(363),
    [anon_sym_TILDE] = ACTIONS(363),
    [anon_sym_LBRACK] = ACTIONS(367),
    [sym_ellipsis] = ACTIONS(1148),
    [anon_sym_LBRACE] = ACTIONS(371),
    [sym_integer] = ACTIONS(1146),
    [sym_float] = ACTIONS(1148),
    [sym_true] = ACTIONS(1146),
    [sym_false] = ACTIONS(1146),
    [sym_none] = ACTIONS(1146),
    [sym_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(377),
  },
  [526] = {
    [sym_argument_list] = STATE(572),
    [sym_generator_expression] = STATE(572),
    [anon_sym_DOT] = ACTIONS(490),
    [anon_sym_LPAREN] = ACTIONS(1113),
    [anon_sym_COMMA] = ACTIONS(490),
    [anon_sym_as] = ACTIONS(490),
    [anon_sym_STAR] = ACTIONS(492),
    [anon_sym_GT_GT] = ACTIONS(490),
    [anon_sym_if] = ACTIONS(490),
    [anon_sym_COLON] = ACTIONS(490),
    [anon_sym_in] = ACTIONS(490),
    [anon_sym_STAR_STAR] = ACTIONS(490),
    [anon_sym_AT] = ACTIONS(490),
    [anon_sym_not] = ACTIONS(490),
    [anon_sym_and] = ACTIONS(490),
    [anon_sym_or] = ACTIONS(490),
    [anon_sym_PLUS] = ACTIONS(490),
    [anon_sym_DASH] = ACTIONS(490),
    [anon_sym_SLASH] = ACTIONS(492),
    [anon_sym_PERCENT] = ACTIONS(490),
    [anon_sym_SLASH_SLASH] = ACTIONS(490),
    [anon_sym_PIPE] = ACTIONS(490),
    [anon_sym_AMP] = ACTIONS(490),
    [anon_sym_CARET] = ACTIONS(490),
    [anon_sym_LT_LT] = ACTIONS(490),
    [anon_sym_LT] = ACTIONS(492),
    [anon_sym_LT_EQ] = ACTIONS(490),
    [anon_sym_EQ_EQ] = ACTIONS(490),
    [anon_sym_BANG_EQ] = ACTIONS(490),
    [anon_sym_GT_EQ] = ACTIONS(490),
    [anon_sym_GT] = ACTIONS(492),
    [anon_sym_LT_GT] = ACTIONS(490),
    [anon_sym_is] = ACTIONS(490),
    [anon_sym_LBRACK] = ACTIONS(490),
    [sym_comment] = ACTIONS(3),
  },
  [527] = {
    [sym_variables] = STATE(1032),
    [sym__primary_expression] = STATE(610),
    [sym_binary_operator] = STATE(610),
    [sym_unary_operator] = STATE(610),
    [sym_attribute] = STATE(610),
    [sym_subscript] = STATE(610),
    [sym_call] = STATE(610),
    [sym_list] = STATE(610),
    [sym_list_comprehension] = STATE(610),
    [sym_dictionary] = STATE(610),
    [sym_dictionary_comprehension] = STATE(610),
    [sym_set] = STATE(610),
    [sym_set_comprehension] = STATE(610),
    [sym_parenthesized_expression] = STATE(610),
    [sym_tuple] = STATE(610),
    [sym_generator_expression] = STATE(610),
    [sym_concatenated_string] = STATE(610),
    [sym_string] = STATE(381),
    [sym_identifier] = ACTIONS(1146),
    [anon_sym_LPAREN] = ACTIONS(389),
    [anon_sym_print] = ACTIONS(393),
    [anon_sym_exec] = ACTIONS(393),
    [anon_sym_PLUS] = ACTIONS(363),
    [anon_sym_DASH] = ACTIONS(363),
    [anon_sym_TILDE] = ACTIONS(363),
    [anon_sym_LBRACK] = ACTIONS(367),
    [sym_ellipsis] = ACTIONS(1148),
    [anon_sym_LBRACE] = ACTIONS(371),
    [sym_integer] = ACTIONS(1146),
    [sym_float] = ACTIONS(1148),
    [sym_true] = ACTIONS(1146),
    [sym_false] = ACTIONS(1146),
    [sym_none] = ACTIONS(1146),
    [sym_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(377),
  },
  [528] = {
    [sym__primary_expression] = STATE(429),
    [sym_binary_operator] = STATE(429),
    [sym_unary_operator] = STATE(429),
    [sym_attribute] = STATE(429),
    [sym_subscript] = STATE(429),
    [sym_call] = STATE(429),
    [sym_list] = STATE(429),
    [sym_list_comprehension] = STATE(429),
    [sym_dictionary] = STATE(429),
    [sym_dictionary_comprehension] = STATE(429),
    [sym_set] = STATE(429),
    [sym_set_comprehension] = STATE(429),
    [sym_parenthesized_expression] = STATE(429),
    [sym_tuple] = STATE(429),
    [sym_generator_expression] = STATE(429),
    [sym_concatenated_string] = STATE(429),
    [sym_string] = STATE(381),
    [sym_identifier] = ACTIONS(1172),
    [anon_sym_LPAREN] = ACTIONS(389),
    [anon_sym_print] = ACTIONS(393),
    [anon_sym_exec] = ACTIONS(393),
    [anon_sym_not] = ACTIONS(1174),
    [anon_sym_PLUS] = ACTIONS(363),
    [anon_sym_DASH] = ACTIONS(363),
    [anon_sym_TILDE] = ACTIONS(363),
    [anon_sym_LBRACK] = ACTIONS(367),
    [sym_ellipsis] = ACTIONS(1176),
    [anon_sym_LBRACE] = ACTIONS(371),
    [sym_integer] = ACTIONS(1172),
    [sym_float] = ACTIONS(1176),
    [sym_true] = ACTIONS(1172),
    [sym_false] = ACTIONS(1172),
    [sym_none] = ACTIONS(1172),
    [sym_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(377),
  },
  [529] = {
    [sym_argument_list] = STATE(572),
    [sym_generator_expression] = STATE(572),
    [anon_sym_DOT] = ACTIONS(1111),
    [anon_sym_LPAREN] = ACTIONS(1113),
    [anon_sym_COMMA] = ACTIONS(502),
    [anon_sym_as] = ACTIONS(502),
    [anon_sym_STAR] = ACTIONS(1115),
    [anon_sym_GT_GT] = ACTIONS(1117),
    [anon_sym_if] = ACTIONS(502),
    [anon_sym_COLON] = ACTIONS(502),
    [anon_sym_in] = ACTIONS(502),
    [anon_sym_STAR_STAR] = ACTIONS(1121),
    [anon_sym_AT] = ACTIONS(1123),
    [anon_sym_not] = ACTIONS(502),
    [anon_sym_and] = ACTIONS(502),
    [anon_sym_or] = ACTIONS(502),
    [anon_sym_PLUS] = ACTIONS(1127),
    [anon_sym_DASH] = ACTIONS(1127),
    [anon_sym_SLASH] = ACTIONS(1115),
    [anon_sym_PERCENT] = ACTIONS(1123),
    [anon_sym_SLASH_SLASH] = ACTIONS(1123),
    [anon_sym_PIPE] = ACTIONS(1129),
    [anon_sym_AMP] = ACTIONS(1131),
    [anon_sym_CARET] = ACTIONS(1133),
    [anon_sym_LT_LT] = ACTIONS(1117),
    [anon_sym_LT] = ACTIONS(504),
    [anon_sym_LT_EQ] = ACTIONS(502),
    [anon_sym_EQ_EQ] = ACTIONS(502),
    [anon_sym_BANG_EQ] = ACTIONS(502),
    [anon_sym_GT_EQ] = ACTIONS(502),
    [anon_sym_GT] = ACTIONS(504),
    [anon_sym_LT_GT] = ACTIONS(502),
    [anon_sym_is] = ACTIONS(502),
    [anon_sym_LBRACK] = ACTIONS(1139),
    [sym_comment] = ACTIONS(3),
  },
  [530] = {
    [sym__primary_expression] = STATE(127),
    [sym_binary_operator] = STATE(127),
    [sym_unary_operator] = STATE(127),
    [sym_attribute] = STATE(127),
    [sym_subscript] = STATE(127),
    [sym_call] = STATE(127),
    [sym_list] = STATE(127),
    [sym_list_comprehension] = STATE(127),
    [sym_dictionary] = STATE(127),
    [sym_dictionary_comprehension] = STATE(127),
    [sym_set] = STATE(127),
    [sym_set_comprehension] = STATE(127),
    [sym_parenthesized_expression] = STATE(127),
    [sym_tuple] = STATE(127),
    [sym_generator_expression] = STATE(127),
    [sym_concatenated_string] = STATE(127),
    [sym_string] = STATE(117),
    [sym_identifier] = ACTIONS(1178),
    [anon_sym_LPAREN] = ACTIONS(13),
    [anon_sym_print] = ACTIONS(237),
    [anon_sym_exec] = ACTIONS(237),
    [anon_sym_PLUS] = ACTIONS(57),
    [anon_sym_DASH] = ACTIONS(57),
    [anon_sym_TILDE] = ACTIONS(57),
    [anon_sym_LBRACK] = ACTIONS(63),
    [sym_ellipsis] = ACTIONS(1180),
    [anon_sym_LBRACE] = ACTIONS(67),
    [sym_integer] = ACTIONS(1178),
    [sym_float] = ACTIONS(1180),
    [sym_true] = ACTIONS(1178),
    [sym_false] = ACTIONS(1178),
    [sym_none] = ACTIONS(1178),
    [sym_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(73),
  },
  [531] = {
    [sym__primary_expression] = STATE(519),
    [sym_binary_operator] = STATE(519),
    [sym_unary_operator] = STATE(519),
    [sym_attribute] = STATE(519),
    [sym_subscript] = STATE(519),
    [sym_call] = STATE(519),
    [sym_list] = STATE(519),
    [sym_list_comprehension] = STATE(519),
    [sym_dictionary] = STATE(519),
    [sym_dictionary_comprehension] = STATE(519),
    [sym_set] = STATE(519),
    [sym_set_comprehension] = STATE(519),
    [sym_parenthesized_expression] = STATE(519),
    [sym_tuple] = STATE(519),
    [sym_generator_expression] = STATE(519),
    [sym_concatenated_string] = STATE(519),
    [sym_string] = STATE(505),
    [sym_identifier] = ACTIONS(1166),
    [anon_sym_LPAREN] = ACTIONS(812),
    [anon_sym_print] = ACTIONS(814),
    [anon_sym_exec] = ACTIONS(814),
    [anon_sym_PLUS] = ACTIONS(820),
    [anon_sym_DASH] = ACTIONS(820),
    [anon_sym_TILDE] = ACTIONS(820),
    [anon_sym_LBRACK] = ACTIONS(824),
    [sym_ellipsis] = ACTIONS(1170),
    [anon_sym_LBRACE] = ACTIONS(828),
    [sym_integer] = ACTIONS(1166),
    [sym_float] = ACTIONS(1170),
    [sym_true] = ACTIONS(1166),
    [sym_false] = ACTIONS(1166),
    [sym_none] = ACTIONS(1166),
    [sym_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(834),
  },
  [532] = {
    [anon_sym_DOT] = ACTIONS(506),
    [anon_sym_LPAREN] = ACTIONS(506),
    [anon_sym_COMMA] = ACTIONS(506),
    [anon_sym_as] = ACTIONS(506),
    [anon_sym_STAR] = ACTIONS(508),
    [anon_sym_GT_GT] = ACTIONS(506),
    [anon_sym_if] = ACTIONS(506),
    [anon_sym_COLON] = ACTIONS(506),
    [anon_sym_in] = ACTIONS(506),
    [anon_sym_STAR_STAR] = ACTIONS(506),
    [anon_sym_AT] = ACTIONS(506),
    [anon_sym_not] = ACTIONS(506),
    [anon_sym_and] = ACTIONS(506),
    [anon_sym_or] = ACTIONS(506),
    [anon_sym_PLUS] = ACTIONS(506),
    [anon_sym_DASH] = ACTIONS(506),
    [anon_sym_SLASH] = ACTIONS(508),
    [anon_sym_PERCENT] = ACTIONS(506),
    [anon_sym_SLASH_SLASH] = ACTIONS(506),
    [anon_sym_PIPE] = ACTIONS(506),
    [anon_sym_AMP] = ACTIONS(506),
    [anon_sym_CARET] = ACTIONS(506),
    [anon_sym_LT_LT] = ACTIONS(506),
    [anon_sym_LT] = ACTIONS(508),
    [anon_sym_LT_EQ] = ACTIONS(506),
    [anon_sym_EQ_EQ] = ACTIONS(506),
    [anon_sym_BANG_EQ] = ACTIONS(506),
    [anon_sym_GT_EQ] = ACTIONS(506),
    [anon_sym_GT] = ACTIONS(508),
    [anon_sym_LT_GT] = ACTIONS(506),
    [anon_sym_is] = ACTIONS(506),
    [anon_sym_LBRACK] = ACTIONS(506),
    [sym_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(506),
  },
  [533] = {
    [sym__primary_expression] = STATE(436),
    [sym_binary_operator] = STATE(436),
    [sym_unary_operator] = STATE(436),
    [sym_attribute] = STATE(436),
    [sym_subscript] = STATE(436),
    [sym_call] = STATE(436),
    [sym_list] = STATE(436),
    [sym_list_comprehension] = STATE(436),
    [sym_dictionary] = STATE(436),
    [sym_dictionary_comprehension] = STATE(436),
    [sym_set] = STATE(436),
    [sym_set_comprehension] = STATE(436),
    [sym_parenthesized_expression] = STATE(436),
    [sym_tuple] = STATE(436),
    [sym_generator_expression] = STATE(436),
    [sym_concatenated_string] = STATE(436),
    [sym_string] = STATE(381),
    [sym_identifier] = ACTIONS(1182),
    [anon_sym_LPAREN] = ACTIONS(389),
    [anon_sym_print] = ACTIONS(393),
    [anon_sym_exec] = ACTIONS(393),
    [anon_sym_PLUS] = ACTIONS(363),
    [anon_sym_DASH] = ACTIONS(363),
    [anon_sym_TILDE] = ACTIONS(363),
    [anon_sym_LBRACK] = ACTIONS(367),
    [sym_ellipsis] = ACTIONS(1184),
    [anon_sym_LBRACE] = ACTIONS(371),
    [sym_integer] = ACTIONS(1182),
    [sym_float] = ACTIONS(1184),
    [sym_true] = ACTIONS(1182),
    [sym_false] = ACTIONS(1182),
    [sym_none] = ACTIONS(1182),
    [sym_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(377),
  },
  [534] = {
    [sym__primary_expression] = STATE(421),
    [sym_binary_operator] = STATE(421),
    [sym_unary_operator] = STATE(421),
    [sym_attribute] = STATE(421),
    [sym_subscript] = STATE(421),
    [sym_call] = STATE(421),
    [sym_list] = STATE(421),
    [sym_list_comprehension] = STATE(421),
    [sym_dictionary] = STATE(421),
    [sym_dictionary_comprehension] = STATE(421),
    [sym_set] = STATE(421),
    [sym_set_comprehension] = STATE(421),
    [sym_parenthesized_expression] = STATE(421),
    [sym_tuple] = STATE(421),
    [sym_generator_expression] = STATE(421),
    [sym_concatenated_string] = STATE(421),
    [sym_string] = STATE(381),
    [sym_identifier] = ACTIONS(1186),
    [anon_sym_LPAREN] = ACTIONS(389),
    [anon_sym_print] = ACTIONS(393),
    [anon_sym_exec] = ACTIONS(393),
    [anon_sym_PLUS] = ACTIONS(363),
    [anon_sym_DASH] = ACTIONS(363),
    [anon_sym_TILDE] = ACTIONS(363),
    [anon_sym_LBRACK] = ACTIONS(367),
    [sym_ellipsis] = ACTIONS(1188),
    [anon_sym_LBRACE] = ACTIONS(371),
    [sym_integer] = ACTIONS(1186),
    [sym_float] = ACTIONS(1188),
    [sym_true] = ACTIONS(1186),
    [sym_false] = ACTIONS(1186),
    [sym_none] = ACTIONS(1186),
    [sym_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(377),
  },
  [535] = {
    [sym__primary_expression] = STATE(521),
    [sym_binary_operator] = STATE(521),
    [sym_unary_operator] = STATE(521),
    [sym_attribute] = STATE(521),
    [sym_subscript] = STATE(521),
    [sym_call] = STATE(521),
    [sym_list] = STATE(521),
    [sym_list_comprehension] = STATE(521),
    [sym_dictionary] = STATE(521),
    [sym_dictionary_comprehension] = STATE(521),
    [sym_set] = STATE(521),
    [sym_set_comprehension] = STATE(521),
    [sym_parenthesized_expression] = STATE(521),
    [sym_tuple] = STATE(521),
    [sym_generator_expression] = STATE(521),
    [sym_concatenated_string] = STATE(521),
    [sym_string] = STATE(505),
    [sym_identifier] = ACTIONS(1190),
    [anon_sym_LPAREN] = ACTIONS(812),
    [anon_sym_print] = ACTIONS(814),
    [anon_sym_exec] = ACTIONS(814),
    [anon_sym_PLUS] = ACTIONS(820),
    [anon_sym_DASH] = ACTIONS(820),
    [anon_sym_TILDE] = ACTIONS(820),
    [anon_sym_LBRACK] = ACTIONS(824),
    [sym_ellipsis] = ACTIONS(1192),
    [anon_sym_LBRACE] = ACTIONS(828),
    [sym_integer] = ACTIONS(1190),
    [sym_float] = ACTIONS(1192),
    [sym_true] = ACTIONS(1190),
    [sym_false] = ACTIONS(1190),
    [sym_none] = ACTIONS(1190),
    [sym_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(834),
  },
  [536] = {
    [sym__primary_expression] = STATE(423),
    [sym_binary_operator] = STATE(423),
    [sym_unary_operator] = STATE(423),
    [sym_attribute] = STATE(423),
    [sym_subscript] = STATE(423),
    [sym_call] = STATE(423),
    [sym_list] = STATE(423),
    [sym_list_comprehension] = STATE(423),
    [sym_dictionary] = STATE(423),
    [sym_dictionary_comprehension] = STATE(423),
    [sym_set] = STATE(423),
    [sym_set_comprehension] = STATE(423),
    [sym_parenthesized_expression] = STATE(423),
    [sym_tuple] = STATE(423),
    [sym_generator_expression] = STATE(423),
    [sym_concatenated_string] = STATE(423),
    [sym_string] = STATE(381),
    [sym_identifier] = ACTIONS(1194),
    [anon_sym_LPAREN] = ACTIONS(389),
    [anon_sym_print] = ACTIONS(393),
    [anon_sym_exec] = ACTIONS(393),
    [anon_sym_PLUS] = ACTIONS(363),
    [anon_sym_DASH] = ACTIONS(363),
    [anon_sym_TILDE] = ACTIONS(363),
    [anon_sym_LBRACK] = ACTIONS(367),
    [sym_ellipsis] = ACTIONS(1196),
    [anon_sym_LBRACE] = ACTIONS(371),
    [sym_integer] = ACTIONS(1194),
    [sym_float] = ACTIONS(1196),
    [sym_true] = ACTIONS(1194),
    [sym_false] = ACTIONS(1194),
    [sym_none] = ACTIONS(1194),
    [sym_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(377),
  },
  [537] = {
    [sym__primary_expression] = STATE(424),
    [sym_binary_operator] = STATE(424),
    [sym_unary_operator] = STATE(424),
    [sym_attribute] = STATE(424),
    [sym_subscript] = STATE(424),
    [sym_call] = STATE(424),
    [sym_list] = STATE(424),
    [sym_list_comprehension] = STATE(424),
    [sym_dictionary] = STATE(424),
    [sym_dictionary_comprehension] = STATE(424),
    [sym_set] = STATE(424),
    [sym_set_comprehension] = STATE(424),
    [sym_parenthesized_expression] = STATE(424),
    [sym_tuple] = STATE(424),
    [sym_generator_expression] = STATE(424),
    [sym_concatenated_string] = STATE(424),
    [sym_string] = STATE(381),
    [sym_identifier] = ACTIONS(1198),
    [anon_sym_LPAREN] = ACTIONS(389),
    [anon_sym_print] = ACTIONS(393),
    [anon_sym_exec] = ACTIONS(393),
    [anon_sym_PLUS] = ACTIONS(363),
    [anon_sym_DASH] = ACTIONS(363),
    [anon_sym_TILDE] = ACTIONS(363),
    [anon_sym_LBRACK] = ACTIONS(367),
    [sym_ellipsis] = ACTIONS(1200),
    [anon_sym_LBRACE] = ACTIONS(371),
    [sym_integer] = ACTIONS(1198),
    [sym_float] = ACTIONS(1200),
    [sym_true] = ACTIONS(1198),
    [sym_false] = ACTIONS(1198),
    [sym_none] = ACTIONS(1198),
    [sym_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(377),
  },
  [538] = {
    [sym__primary_expression] = STATE(426),
    [sym_binary_operator] = STATE(426),
    [sym_unary_operator] = STATE(426),
    [sym_attribute] = STATE(426),
    [sym_subscript] = STATE(426),
    [sym_call] = STATE(426),
    [sym_list] = STATE(426),
    [sym_list_comprehension] = STATE(426),
    [sym_dictionary] = STATE(426),
    [sym_dictionary_comprehension] = STATE(426),
    [sym_set] = STATE(426),
    [sym_set_comprehension] = STATE(426),
    [sym_parenthesized_expression] = STATE(426),
    [sym_tuple] = STATE(426),
    [sym_generator_expression] = STATE(426),
    [sym_concatenated_string] = STATE(426),
    [sym_string] = STATE(381),
    [sym_identifier] = ACTIONS(1202),
    [anon_sym_LPAREN] = ACTIONS(389),
    [anon_sym_print] = ACTIONS(393),
    [anon_sym_exec] = ACTIONS(393),
    [anon_sym_PLUS] = ACTIONS(363),
    [anon_sym_DASH] = ACTIONS(363),
    [anon_sym_TILDE] = ACTIONS(363),
    [anon_sym_LBRACK] = ACTIONS(367),
    [sym_ellipsis] = ACTIONS(1204),
    [anon_sym_LBRACE] = ACTIONS(371),
    [sym_integer] = ACTIONS(1202),
    [sym_float] = ACTIONS(1204),
    [sym_true] = ACTIONS(1202),
    [sym_false] = ACTIONS(1202),
    [sym_none] = ACTIONS(1202),
    [sym_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(377),
  },
  [539] = {
    [sym__primary_expression] = STATE(520),
    [sym_binary_operator] = STATE(520),
    [sym_unary_operator] = STATE(520),
    [sym_attribute] = STATE(520),
    [sym_subscript] = STATE(520),
    [sym_call] = STATE(520),
    [sym_list] = STATE(520),
    [sym_list_comprehension] = STATE(520),
    [sym_dictionary] = STATE(520),
    [sym_dictionary_comprehension] = STATE(520),
    [sym_set] = STATE(520),
    [sym_set_comprehension] = STATE(520),
    [sym_parenthesized_expression] = STATE(520),
    [sym_tuple] = STATE(520),
    [sym_generator_expression] = STATE(520),
    [sym_concatenated_string] = STATE(520),
    [sym_string] = STATE(505),
    [sym_identifier] = ACTIONS(1206),
    [anon_sym_LPAREN] = ACTIONS(812),
    [anon_sym_print] = ACTIONS(814),
    [anon_sym_exec] = ACTIONS(814),
    [anon_sym_PLUS] = ACTIONS(820),
    [anon_sym_DASH] = ACTIONS(820),
    [anon_sym_TILDE] = ACTIONS(820),
    [anon_sym_LBRACK] = ACTIONS(824),
    [sym_ellipsis] = ACTIONS(1208),
    [anon_sym_LBRACE] = ACTIONS(828),
    [sym_integer] = ACTIONS(1206),
    [sym_float] = ACTIONS(1208),
    [sym_true] = ACTIONS(1206),
    [sym_false] = ACTIONS(1206),
    [sym_none] = ACTIONS(1206),
    [sym_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(834),
  },
  [540] = {
    [sym__primary_expression] = STATE(427),
    [sym_binary_operator] = STATE(427),
    [sym_unary_operator] = STATE(427),
    [sym_attribute] = STATE(427),
    [sym_subscript] = STATE(427),
    [sym_call] = STATE(427),
    [sym_list] = STATE(427),
    [sym_list_comprehension] = STATE(427),
    [sym_dictionary] = STATE(427),
    [sym_dictionary_comprehension] = STATE(427),
    [sym_set] = STATE(427),
    [sym_set_comprehension] = STATE(427),
    [sym_parenthesized_expression] = STATE(427),
    [sym_tuple] = STATE(427),
    [sym_generator_expression] = STATE(427),
    [sym_concatenated_string] = STATE(427),
    [sym_string] = STATE(381),
    [sym_identifier] = ACTIONS(1210),
    [anon_sym_LPAREN] = ACTIONS(389),
    [anon_sym_print] = ACTIONS(393),
    [anon_sym_exec] = ACTIONS(393),
    [anon_sym_PLUS] = ACTIONS(363),
    [anon_sym_DASH] = ACTIONS(363),
    [anon_sym_TILDE] = ACTIONS(363),
    [anon_sym_LBRACK] = ACTIONS(367),
    [sym_ellipsis] = ACTIONS(1212),
    [anon_sym_LBRACE] = ACTIONS(371),
    [sym_integer] = ACTIONS(1210),
    [sym_float] = ACTIONS(1212),
    [sym_true] = ACTIONS(1210),
    [sym_false] = ACTIONS(1210),
    [sym_none] = ACTIONS(1210),
    [sym_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(377),
  },
  [541] = {
    [sym__primary_expression] = STATE(429),
    [sym_binary_operator] = STATE(429),
    [sym_unary_operator] = STATE(429),
    [sym_attribute] = STATE(429),
    [sym_subscript] = STATE(429),
    [sym_call] = STATE(429),
    [sym_list] = STATE(429),
    [sym_list_comprehension] = STATE(429),
    [sym_dictionary] = STATE(429),
    [sym_dictionary_comprehension] = STATE(429),
    [sym_set] = STATE(429),
    [sym_set_comprehension] = STATE(429),
    [sym_parenthesized_expression] = STATE(429),
    [sym_tuple] = STATE(429),
    [sym_generator_expression] = STATE(429),
    [sym_concatenated_string] = STATE(429),
    [sym_string] = STATE(381),
    [sym_identifier] = ACTIONS(1172),
    [anon_sym_LPAREN] = ACTIONS(389),
    [anon_sym_print] = ACTIONS(393),
    [anon_sym_exec] = ACTIONS(393),
    [anon_sym_PLUS] = ACTIONS(363),
    [anon_sym_DASH] = ACTIONS(363),
    [anon_sym_TILDE] = ACTIONS(363),
    [anon_sym_LBRACK] = ACTIONS(367),
    [sym_ellipsis] = ACTIONS(1176),
    [anon_sym_LBRACE] = ACTIONS(371),
    [sym_integer] = ACTIONS(1172),
    [sym_float] = ACTIONS(1176),
    [sym_true] = ACTIONS(1172),
    [sym_false] = ACTIONS(1172),
    [sym_none] = ACTIONS(1172),
    [sym_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(377),
  },
  [542] = {
    [sym__primary_expression] = STATE(431),
    [sym_binary_operator] = STATE(431),
    [sym_unary_operator] = STATE(431),
    [sym_attribute] = STATE(431),
    [sym_subscript] = STATE(431),
    [sym_call] = STATE(431),
    [sym_list] = STATE(431),
    [sym_list_comprehension] = STATE(431),
    [sym_dictionary] = STATE(431),
    [sym_dictionary_comprehension] = STATE(431),
    [sym_set] = STATE(431),
    [sym_set_comprehension] = STATE(431),
    [sym_parenthesized_expression] = STATE(431),
    [sym_tuple] = STATE(431),
    [sym_generator_expression] = STATE(431),
    [sym_concatenated_string] = STATE(431),
    [sym_string] = STATE(381),
    [sym_identifier] = ACTIONS(1214),
    [anon_sym_LPAREN] = ACTIONS(389),
    [anon_sym_print] = ACTIONS(393),
    [anon_sym_exec] = ACTIONS(393),
    [anon_sym_PLUS] = ACTIONS(363),
    [anon_sym_DASH] = ACTIONS(363),
    [anon_sym_TILDE] = ACTIONS(363),
    [anon_sym_LBRACK] = ACTIONS(367),
    [sym_ellipsis] = ACTIONS(1216),
    [anon_sym_LBRACE] = ACTIONS(371),
    [sym_integer] = ACTIONS(1214),
    [sym_float] = ACTIONS(1216),
    [sym_true] = ACTIONS(1214),
    [sym_false] = ACTIONS(1214),
    [sym_none] = ACTIONS(1214),
    [sym_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(377),
  },
  [543] = {
    [sym__primary_expression] = STATE(432),
    [sym_binary_operator] = STATE(432),
    [sym_unary_operator] = STATE(432),
    [sym_attribute] = STATE(432),
    [sym_subscript] = STATE(432),
    [sym_call] = STATE(432),
    [sym_list] = STATE(432),
    [sym_list_comprehension] = STATE(432),
    [sym_dictionary] = STATE(432),
    [sym_dictionary_comprehension] = STATE(432),
    [sym_set] = STATE(432),
    [sym_set_comprehension] = STATE(432),
    [sym_parenthesized_expression] = STATE(432),
    [sym_tuple] = STATE(432),
    [sym_generator_expression] = STATE(432),
    [sym_concatenated_string] = STATE(432),
    [sym_string] = STATE(381),
    [sym_identifier] = ACTIONS(1218),
    [anon_sym_LPAREN] = ACTIONS(389),
    [anon_sym_print] = ACTIONS(393),
    [anon_sym_exec] = ACTIONS(393),
    [anon_sym_PLUS] = ACTIONS(363),
    [anon_sym_DASH] = ACTIONS(363),
    [anon_sym_TILDE] = ACTIONS(363),
    [anon_sym_LBRACK] = ACTIONS(367),
    [sym_ellipsis] = ACTIONS(1220),
    [anon_sym_LBRACE] = ACTIONS(371),
    [sym_integer] = ACTIONS(1218),
    [sym_float] = ACTIONS(1220),
    [sym_true] = ACTIONS(1218),
    [sym_false] = ACTIONS(1218),
    [sym_none] = ACTIONS(1218),
    [sym_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(377),
  },
  [544] = {
    [sym__primary_expression] = STATE(518),
    [sym_binary_operator] = STATE(518),
    [sym_unary_operator] = STATE(518),
    [sym_attribute] = STATE(518),
    [sym_subscript] = STATE(518),
    [sym_call] = STATE(518),
    [sym_list] = STATE(518),
    [sym_list_comprehension] = STATE(518),
    [sym_dictionary] = STATE(518),
    [sym_dictionary_comprehension] = STATE(518),
    [sym_set] = STATE(518),
    [sym_set_comprehension] = STATE(518),
    [sym_parenthesized_expression] = STATE(518),
    [sym_tuple] = STATE(518),
    [sym_generator_expression] = STATE(518),
    [sym_concatenated_string] = STATE(518),
    [sym_string] = STATE(505),
    [sym_identifier] = ACTIONS(1222),
    [anon_sym_LPAREN] = ACTIONS(812),
    [anon_sym_print] = ACTIONS(814),
    [anon_sym_exec] = ACTIONS(814),
    [anon_sym_PLUS] = ACTIONS(820),
    [anon_sym_DASH] = ACTIONS(820),
    [anon_sym_TILDE] = ACTIONS(820),
    [anon_sym_LBRACK] = ACTIONS(824),
    [sym_ellipsis] = ACTIONS(1224),
    [anon_sym_LBRACE] = ACTIONS(828),
    [sym_integer] = ACTIONS(1222),
    [sym_float] = ACTIONS(1224),
    [sym_true] = ACTIONS(1222),
    [sym_false] = ACTIONS(1222),
    [sym_none] = ACTIONS(1222),
    [sym_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(834),
  },
  [545] = {
    [sym__primary_expression] = STATE(510),
    [sym_binary_operator] = STATE(510),
    [sym_unary_operator] = STATE(510),
    [sym_attribute] = STATE(510),
    [sym_subscript] = STATE(510),
    [sym_call] = STATE(510),
    [sym_list] = STATE(510),
    [sym_list_comprehension] = STATE(510),
    [sym_dictionary] = STATE(510),
    [sym_dictionary_comprehension] = STATE(510),
    [sym_set] = STATE(510),
    [sym_set_comprehension] = STATE(510),
    [sym_parenthesized_expression] = STATE(510),
    [sym_tuple] = STATE(510),
    [sym_generator_expression] = STATE(510),
    [sym_concatenated_string] = STATE(510),
    [sym_string] = STATE(505),
    [sym_identifier] = ACTIONS(1226),
    [anon_sym_LPAREN] = ACTIONS(812),
    [anon_sym_print] = ACTIONS(814),
    [anon_sym_exec] = ACTIONS(814),
    [anon_sym_PLUS] = ACTIONS(820),
    [anon_sym_DASH] = ACTIONS(820),
    [anon_sym_TILDE] = ACTIONS(820),
    [anon_sym_LBRACK] = ACTIONS(824),
    [sym_ellipsis] = ACTIONS(1228),
    [anon_sym_LBRACE] = ACTIONS(828),
    [sym_integer] = ACTIONS(1226),
    [sym_float] = ACTIONS(1228),
    [sym_true] = ACTIONS(1226),
    [sym_false] = ACTIONS(1226),
    [sym_none] = ACTIONS(1226),
    [sym_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(834),
  },
  [546] = {
    [sym__primary_expression] = STATE(125),
    [sym_binary_operator] = STATE(125),
    [sym_unary_operator] = STATE(125),
    [sym_attribute] = STATE(125),
    [sym_subscript] = STATE(125),
    [sym_call] = STATE(125),
    [sym_list] = STATE(125),
    [sym_list_comprehension] = STATE(125),
    [sym_dictionary] = STATE(125),
    [sym_dictionary_comprehension] = STATE(125),
    [sym_set] = STATE(125),
    [sym_set_comprehension] = STATE(125),
    [sym_parenthesized_expression] = STATE(125),
    [sym_tuple] = STATE(125),
    [sym_generator_expression] = STATE(125),
    [sym_concatenated_string] = STATE(125),
    [sym_string] = STATE(117),
    [sym_identifier] = ACTIONS(1230),
    [anon_sym_LPAREN] = ACTIONS(13),
    [anon_sym_print] = ACTIONS(237),
    [anon_sym_exec] = ACTIONS(237),
    [anon_sym_PLUS] = ACTIONS(57),
    [anon_sym_DASH] = ACTIONS(57),
    [anon_sym_TILDE] = ACTIONS(57),
    [anon_sym_LBRACK] = ACTIONS(63),
    [sym_ellipsis] = ACTIONS(1232),
    [anon_sym_LBRACE] = ACTIONS(67),
    [sym_integer] = ACTIONS(1230),
    [sym_float] = ACTIONS(1232),
    [sym_true] = ACTIONS(1230),
    [sym_false] = ACTIONS(1230),
    [sym_none] = ACTIONS(1230),
    [sym_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(73),
  },
  [547] = {
    [anon_sym_DOT] = ACTIONS(467),
    [anon_sym_LPAREN] = ACTIONS(467),
    [anon_sym_COMMA] = ACTIONS(467),
    [anon_sym_as] = ACTIONS(467),
    [anon_sym_STAR] = ACTIONS(469),
    [anon_sym_GT_GT] = ACTIONS(467),
    [anon_sym_COLON_EQ] = ACTIONS(1234),
    [anon_sym_if] = ACTIONS(467),
    [anon_sym_COLON] = ACTIONS(469),
    [anon_sym_in] = ACTIONS(467),
    [anon_sym_STAR_STAR] = ACTIONS(467),
    [anon_sym_AT] = ACTIONS(467),
    [anon_sym_not] = ACTIONS(467),
    [anon_sym_and] = ACTIONS(467),
    [anon_sym_or] = ACTIONS(467),
    [anon_sym_PLUS] = ACTIONS(467),
    [anon_sym_DASH] = ACTIONS(467),
    [anon_sym_SLASH] = ACTIONS(469),
    [anon_sym_PERCENT] = ACTIONS(467),
    [anon_sym_SLASH_SLASH] = ACTIONS(467),
    [anon_sym_PIPE] = ACTIONS(467),
    [anon_sym_AMP] = ACTIONS(467),
    [anon_sym_CARET] = ACTIONS(467),
    [anon_sym_LT_LT] = ACTIONS(467),
    [anon_sym_LT] = ACTIONS(469),
    [anon_sym_LT_EQ] = ACTIONS(467),
    [anon_sym_EQ_EQ] = ACTIONS(467),
    [anon_sym_BANG_EQ] = ACTIONS(467),
    [anon_sym_GT_EQ] = ACTIONS(467),
    [anon_sym_GT] = ACTIONS(469),
    [anon_sym_LT_GT] = ACTIONS(467),
    [anon_sym_is] = ACTIONS(467),
    [anon_sym_LBRACK] = ACTIONS(467),
    [sym_comment] = ACTIONS(3),
  },
  [548] = {
    [aux_sym_comparison_operator_repeat1] = STATE(557),
    [anon_sym_from] = ACTIONS(1236),
    [anon_sym_COMMA] = ACTIONS(1236),
    [anon_sym_if] = ACTIONS(1236),
    [anon_sym_COLON] = ACTIONS(1236),
    [anon_sym_in] = ACTIONS(421),
    [anon_sym_EQ] = ACTIONS(1238),
    [anon_sym_not] = ACTIONS(427),
    [anon_sym_and] = ACTIONS(1236),
    [anon_sym_or] = ACTIONS(1236),
    [anon_sym_LT] = ACTIONS(437),
    [anon_sym_LT_EQ] = ACTIONS(421),
    [anon_sym_EQ_EQ] = ACTIONS(421),
    [anon_sym_BANG_EQ] = ACTIONS(421),
    [anon_sym_GT_EQ] = ACTIONS(421),
    [anon_sym_GT] = ACTIONS(437),
    [anon_sym_LT_GT] = ACTIONS(421),
    [anon_sym_is] = ACTIONS(439),
    [anon_sym_PLUS_EQ] = ACTIONS(1236),
    [anon_sym_DASH_EQ] = ACTIONS(1236),
    [anon_sym_STAR_EQ] = ACTIONS(1236),
    [anon_sym_SLASH_EQ] = ACTIONS(1236),
    [anon_sym_AT_EQ] = ACTIONS(1236),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(1236),
    [anon_sym_PERCENT_EQ] = ACTIONS(1236),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1236),
    [anon_sym_GT_GT_EQ] = ACTIONS(1236),
    [anon_sym_LT_LT_EQ] = ACTIONS(1236),
    [anon_sym_AMP_EQ] = ACTIONS(1236),
    [anon_sym_CARET_EQ] = ACTIONS(1236),
    [anon_sym_PIPE_EQ] = ACTIONS(1236),
    [sym_comment] = ACTIONS(3),
    [sym__semicolon] = ACTIONS(1236),
    [sym__newline] = ACTIONS(1236),
  },
  [549] = {
    [sym__primary_expression] = STATE(410),
    [sym_binary_operator] = STATE(410),
    [sym_unary_operator] = STATE(410),
    [sym_attribute] = STATE(410),
    [sym_subscript] = STATE(410),
    [sym_call] = STATE(410),
    [sym_list] = STATE(410),
    [sym_list_comprehension] = STATE(410),
    [sym_dictionary] = STATE(410),
    [sym_dictionary_comprehension] = STATE(410),
    [sym_set] = STATE(410),
    [sym_set_comprehension] = STATE(410),
    [sym_parenthesized_expression] = STATE(410),
    [sym_tuple] = STATE(410),
    [sym_generator_expression] = STATE(410),
    [sym_concatenated_string] = STATE(410),
    [sym_string] = STATE(381),
    [sym_identifier] = ACTIONS(1240),
    [anon_sym_LPAREN] = ACTIONS(389),
    [anon_sym_print] = ACTIONS(393),
    [anon_sym_exec] = ACTIONS(393),
    [anon_sym_PLUS] = ACTIONS(363),
    [anon_sym_DASH] = ACTIONS(363),
    [anon_sym_TILDE] = ACTIONS(363),
    [anon_sym_LBRACK] = ACTIONS(367),
    [sym_ellipsis] = ACTIONS(1242),
    [anon_sym_LBRACE] = ACTIONS(371),
    [sym_integer] = ACTIONS(1240),
    [sym_float] = ACTIONS(1242),
    [sym_true] = ACTIONS(1240),
    [sym_false] = ACTIONS(1240),
    [sym_none] = ACTIONS(1240),
    [sym_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(377),
  },
  [550] = {
    [sym__primary_expression] = STATE(131),
    [sym_binary_operator] = STATE(131),
    [sym_unary_operator] = STATE(131),
    [sym_attribute] = STATE(131),
    [sym_subscript] = STATE(131),
    [sym_call] = STATE(131),
    [sym_list] = STATE(131),
    [sym_list_comprehension] = STATE(131),
    [sym_dictionary] = STATE(131),
    [sym_dictionary_comprehension] = STATE(131),
    [sym_set] = STATE(131),
    [sym_set_comprehension] = STATE(131),
    [sym_parenthesized_expression] = STATE(131),
    [sym_tuple] = STATE(131),
    [sym_generator_expression] = STATE(131),
    [sym_concatenated_string] = STATE(131),
    [sym_string] = STATE(117),
    [sym_identifier] = ACTIONS(1244),
    [anon_sym_LPAREN] = ACTIONS(13),
    [anon_sym_print] = ACTIONS(237),
    [anon_sym_exec] = ACTIONS(237),
    [anon_sym_PLUS] = ACTIONS(57),
    [anon_sym_DASH] = ACTIONS(57),
    [anon_sym_TILDE] = ACTIONS(57),
    [anon_sym_LBRACK] = ACTIONS(63),
    [sym_ellipsis] = ACTIONS(1246),
    [anon_sym_LBRACE] = ACTIONS(67),
    [sym_integer] = ACTIONS(1244),
    [sym_float] = ACTIONS(1246),
    [sym_true] = ACTIONS(1244),
    [sym_false] = ACTIONS(1244),
    [sym_none] = ACTIONS(1244),
    [sym_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(73),
  },
  [551] = {
    [sym__primary_expression] = STATE(133),
    [sym_binary_operator] = STATE(133),
    [sym_unary_operator] = STATE(133),
    [sym_attribute] = STATE(133),
    [sym_subscript] = STATE(133),
    [sym_call] = STATE(133),
    [sym_list] = STATE(133),
    [sym_list_comprehension] = STATE(133),
    [sym_dictionary] = STATE(133),
    [sym_dictionary_comprehension] = STATE(133),
    [sym_set] = STATE(133),
    [sym_set_comprehension] = STATE(133),
    [sym_parenthesized_expression] = STATE(133),
    [sym_tuple] = STATE(133),
    [sym_generator_expression] = STATE(133),
    [sym_concatenated_string] = STATE(133),
    [sym_string] = STATE(117),
    [sym_identifier] = ACTIONS(1248),
    [anon_sym_LPAREN] = ACTIONS(13),
    [anon_sym_print] = ACTIONS(237),
    [anon_sym_exec] = ACTIONS(237),
    [anon_sym_PLUS] = ACTIONS(57),
    [anon_sym_DASH] = ACTIONS(57),
    [anon_sym_TILDE] = ACTIONS(57),
    [anon_sym_LBRACK] = ACTIONS(63),
    [sym_ellipsis] = ACTIONS(1250),
    [anon_sym_LBRACE] = ACTIONS(67),
    [sym_integer] = ACTIONS(1248),
    [sym_float] = ACTIONS(1250),
    [sym_true] = ACTIONS(1248),
    [sym_false] = ACTIONS(1248),
    [sym_none] = ACTIONS(1248),
    [sym_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(73),
  },
  [552] = {
    [sym__primary_expression] = STATE(134),
    [sym_binary_operator] = STATE(134),
    [sym_unary_operator] = STATE(134),
    [sym_attribute] = STATE(134),
    [sym_subscript] = STATE(134),
    [sym_call] = STATE(134),
    [sym_list] = STATE(134),
    [sym_list_comprehension] = STATE(134),
    [sym_dictionary] = STATE(134),
    [sym_dictionary_comprehension] = STATE(134),
    [sym_set] = STATE(134),
    [sym_set_comprehension] = STATE(134),
    [sym_parenthesized_expression] = STATE(134),
    [sym_tuple] = STATE(134),
    [sym_generator_expression] = STATE(134),
    [sym_concatenated_string] = STATE(134),
    [sym_string] = STATE(117),
    [sym_identifier] = ACTIONS(1252),
    [anon_sym_LPAREN] = ACTIONS(13),
    [anon_sym_print] = ACTIONS(237),
    [anon_sym_exec] = ACTIONS(237),
    [anon_sym_PLUS] = ACTIONS(57),
    [anon_sym_DASH] = ACTIONS(57),
    [anon_sym_TILDE] = ACTIONS(57),
    [anon_sym_LBRACK] = ACTIONS(63),
    [sym_ellipsis] = ACTIONS(1254),
    [anon_sym_LBRACE] = ACTIONS(67),
    [sym_integer] = ACTIONS(1252),
    [sym_float] = ACTIONS(1254),
    [sym_true] = ACTIONS(1252),
    [sym_false] = ACTIONS(1252),
    [sym_none] = ACTIONS(1252),
    [sym_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(73),
  },
  [553] = {
    [sym__primary_expression] = STATE(529),
    [sym_binary_operator] = STATE(529),
    [sym_unary_operator] = STATE(529),
    [sym_attribute] = STATE(529),
    [sym_subscript] = STATE(529),
    [sym_call] = STATE(529),
    [sym_list] = STATE(529),
    [sym_list_comprehension] = STATE(529),
    [sym_dictionary] = STATE(529),
    [sym_dictionary_comprehension] = STATE(529),
    [sym_set] = STATE(529),
    [sym_set_comprehension] = STATE(529),
    [sym_parenthesized_expression] = STATE(529),
    [sym_tuple] = STATE(529),
    [sym_generator_expression] = STATE(529),
    [sym_concatenated_string] = STATE(529),
    [sym_string] = STATE(505),
    [sym_identifier] = ACTIONS(1256),
    [anon_sym_LPAREN] = ACTIONS(812),
    [anon_sym_print] = ACTIONS(814),
    [anon_sym_exec] = ACTIONS(814),
    [anon_sym_PLUS] = ACTIONS(820),
    [anon_sym_DASH] = ACTIONS(820),
    [anon_sym_TILDE] = ACTIONS(820),
    [anon_sym_LBRACK] = ACTIONS(824),
    [sym_ellipsis] = ACTIONS(1258),
    [anon_sym_LBRACE] = ACTIONS(828),
    [sym_integer] = ACTIONS(1256),
    [sym_float] = ACTIONS(1258),
    [sym_true] = ACTIONS(1256),
    [sym_false] = ACTIONS(1256),
    [sym_none] = ACTIONS(1256),
    [sym_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(834),
  },
  [554] = {
    [sym__primary_expression] = STATE(135),
    [sym_binary_operator] = STATE(135),
    [sym_unary_operator] = STATE(135),
    [sym_attribute] = STATE(135),
    [sym_subscript] = STATE(135),
    [sym_call] = STATE(135),
    [sym_list] = STATE(135),
    [sym_list_comprehension] = STATE(135),
    [sym_dictionary] = STATE(135),
    [sym_dictionary_comprehension] = STATE(135),
    [sym_set] = STATE(135),
    [sym_set_comprehension] = STATE(135),
    [sym_parenthesized_expression] = STATE(135),
    [sym_tuple] = STATE(135),
    [sym_generator_expression] = STATE(135),
    [sym_concatenated_string] = STATE(135),
    [sym_string] = STATE(117),
    [sym_identifier] = ACTIONS(1260),
    [anon_sym_LPAREN] = ACTIONS(13),
    [anon_sym_print] = ACTIONS(237),
    [anon_sym_exec] = ACTIONS(237),
    [anon_sym_PLUS] = ACTIONS(57),
    [anon_sym_DASH] = ACTIONS(57),
    [anon_sym_TILDE] = ACTIONS(57),
    [anon_sym_LBRACK] = ACTIONS(63),
    [sym_ellipsis] = ACTIONS(1262),
    [anon_sym_LBRACE] = ACTIONS(67),
    [sym_integer] = ACTIONS(1260),
    [sym_float] = ACTIONS(1262),
    [sym_true] = ACTIONS(1260),
    [sym_false] = ACTIONS(1260),
    [sym_none] = ACTIONS(1260),
    [sym_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(73),
  },
  [555] = {
    [sym__primary_expression] = STATE(136),
    [sym_binary_operator] = STATE(136),
    [sym_unary_operator] = STATE(136),
    [sym_attribute] = STATE(136),
    [sym_subscript] = STATE(136),
    [sym_call] = STATE(136),
    [sym_list] = STATE(136),
    [sym_list_comprehension] = STATE(136),
    [sym_dictionary] = STATE(136),
    [sym_dictionary_comprehension] = STATE(136),
    [sym_set] = STATE(136),
    [sym_set_comprehension] = STATE(136),
    [sym_parenthesized_expression] = STATE(136),
    [sym_tuple] = STATE(136),
    [sym_generator_expression] = STATE(136),
    [sym_concatenated_string] = STATE(136),
    [sym_string] = STATE(117),
    [sym_identifier] = ACTIONS(1264),
    [anon_sym_LPAREN] = ACTIONS(13),
    [anon_sym_print] = ACTIONS(237),
    [anon_sym_exec] = ACTIONS(237),
    [anon_sym_PLUS] = ACTIONS(57),
    [anon_sym_DASH] = ACTIONS(57),
    [anon_sym_TILDE] = ACTIONS(57),
    [anon_sym_LBRACK] = ACTIONS(63),
    [sym_ellipsis] = ACTIONS(1266),
    [anon_sym_LBRACE] = ACTIONS(67),
    [sym_integer] = ACTIONS(1264),
    [sym_float] = ACTIONS(1266),
    [sym_true] = ACTIONS(1264),
    [sym_false] = ACTIONS(1264),
    [sym_none] = ACTIONS(1264),
    [sym_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(73),
  },
  [556] = {
    [sym__primary_expression] = STATE(132),
    [sym_binary_operator] = STATE(132),
    [sym_unary_operator] = STATE(132),
    [sym_attribute] = STATE(132),
    [sym_subscript] = STATE(132),
    [sym_call] = STATE(132),
    [sym_list] = STATE(132),
    [sym_list_comprehension] = STATE(132),
    [sym_dictionary] = STATE(132),
    [sym_dictionary_comprehension] = STATE(132),
    [sym_set] = STATE(132),
    [sym_set_comprehension] = STATE(132),
    [sym_parenthesized_expression] = STATE(132),
    [sym_tuple] = STATE(132),
    [sym_generator_expression] = STATE(132),
    [sym_concatenated_string] = STATE(132),
    [sym_string] = STATE(117),
    [sym_identifier] = ACTIONS(1150),
    [anon_sym_LPAREN] = ACTIONS(13),
    [anon_sym_print] = ACTIONS(237),
    [anon_sym_exec] = ACTIONS(237),
    [anon_sym_PLUS] = ACTIONS(57),
    [anon_sym_DASH] = ACTIONS(57),
    [anon_sym_TILDE] = ACTIONS(57),
    [anon_sym_LBRACK] = ACTIONS(63),
    [sym_ellipsis] = ACTIONS(1154),
    [anon_sym_LBRACE] = ACTIONS(67),
    [sym_integer] = ACTIONS(1150),
    [sym_float] = ACTIONS(1154),
    [sym_true] = ACTIONS(1150),
    [sym_false] = ACTIONS(1150),
    [sym_none] = ACTIONS(1150),
    [sym_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(73),
  },
  [557] = {
    [aux_sym_comparison_operator_repeat1] = STATE(557),
    [anon_sym_from] = ACTIONS(498),
    [anon_sym_COMMA] = ACTIONS(498),
    [anon_sym_if] = ACTIONS(498),
    [anon_sym_COLON] = ACTIONS(498),
    [anon_sym_in] = ACTIONS(1268),
    [anon_sym_EQ] = ACTIONS(500),
    [anon_sym_not] = ACTIONS(1271),
    [anon_sym_and] = ACTIONS(498),
    [anon_sym_or] = ACTIONS(498),
    [anon_sym_LT] = ACTIONS(1274),
    [anon_sym_LT_EQ] = ACTIONS(1268),
    [anon_sym_EQ_EQ] = ACTIONS(1268),
    [anon_sym_BANG_EQ] = ACTIONS(1268),
    [anon_sym_GT_EQ] = ACTIONS(1268),
    [anon_sym_GT] = ACTIONS(1274),
    [anon_sym_LT_GT] = ACTIONS(1268),
    [anon_sym_is] = ACTIONS(1277),
    [anon_sym_PLUS_EQ] = ACTIONS(498),
    [anon_sym_DASH_EQ] = ACTIONS(498),
    [anon_sym_STAR_EQ] = ACTIONS(498),
    [anon_sym_SLASH_EQ] = ACTIONS(498),
    [anon_sym_AT_EQ] = ACTIONS(498),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(498),
    [anon_sym_PERCENT_EQ] = ACTIONS(498),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(498),
    [anon_sym_GT_GT_EQ] = ACTIONS(498),
    [anon_sym_LT_LT_EQ] = ACTIONS(498),
    [anon_sym_AMP_EQ] = ACTIONS(498),
    [anon_sym_CARET_EQ] = ACTIONS(498),
    [anon_sym_PIPE_EQ] = ACTIONS(498),
    [sym_comment] = ACTIONS(3),
    [sym__semicolon] = ACTIONS(498),
    [sym__newline] = ACTIONS(498),
  },
  [558] = {
    [sym__primary_expression] = STATE(514),
    [sym_binary_operator] = STATE(514),
    [sym_unary_operator] = STATE(514),
    [sym_attribute] = STATE(514),
    [sym_subscript] = STATE(514),
    [sym_call] = STATE(514),
    [sym_list] = STATE(514),
    [sym_list_comprehension] = STATE(514),
    [sym_dictionary] = STATE(514),
    [sym_dictionary_comprehension] = STATE(514),
    [sym_set] = STATE(514),
    [sym_set_comprehension] = STATE(514),
    [sym_parenthesized_expression] = STATE(514),
    [sym_tuple] = STATE(514),
    [sym_generator_expression] = STATE(514),
    [sym_concatenated_string] = STATE(514),
    [sym_string] = STATE(505),
    [sym_identifier] = ACTIONS(1280),
    [anon_sym_LPAREN] = ACTIONS(812),
    [anon_sym_print] = ACTIONS(814),
    [anon_sym_exec] = ACTIONS(814),
    [anon_sym_PLUS] = ACTIONS(820),
    [anon_sym_DASH] = ACTIONS(820),
    [anon_sym_TILDE] = ACTIONS(820),
    [anon_sym_LBRACK] = ACTIONS(824),
    [sym_ellipsis] = ACTIONS(1282),
    [anon_sym_LBRACE] = ACTIONS(828),
    [sym_integer] = ACTIONS(1280),
    [sym_float] = ACTIONS(1282),
    [sym_true] = ACTIONS(1280),
    [sym_false] = ACTIONS(1280),
    [sym_none] = ACTIONS(1280),
    [sym_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(834),
  },
  [559] = {
    [sym__primary_expression] = STATE(515),
    [sym_binary_operator] = STATE(515),
    [sym_unary_operator] = STATE(515),
    [sym_attribute] = STATE(515),
    [sym_subscript] = STATE(515),
    [sym_call] = STATE(515),
    [sym_list] = STATE(515),
    [sym_list_comprehension] = STATE(515),
    [sym_dictionary] = STATE(515),
    [sym_dictionary_comprehension] = STATE(515),
    [sym_set] = STATE(515),
    [sym_set_comprehension] = STATE(515),
    [sym_parenthesized_expression] = STATE(515),
    [sym_tuple] = STATE(515),
    [sym_generator_expression] = STATE(515),
    [sym_concatenated_string] = STATE(515),
    [sym_string] = STATE(505),
    [sym_identifier] = ACTIONS(1284),
    [anon_sym_LPAREN] = ACTIONS(812),
    [anon_sym_print] = ACTIONS(814),
    [anon_sym_exec] = ACTIONS(814),
    [anon_sym_PLUS] = ACTIONS(820),
    [anon_sym_DASH] = ACTIONS(820),
    [anon_sym_TILDE] = ACTIONS(820),
    [anon_sym_LBRACK] = ACTIONS(824),
    [sym_ellipsis] = ACTIONS(1286),
    [anon_sym_LBRACE] = ACTIONS(828),
    [sym_integer] = ACTIONS(1284),
    [sym_float] = ACTIONS(1286),
    [sym_true] = ACTIONS(1284),
    [sym_false] = ACTIONS(1284),
    [sym_none] = ACTIONS(1284),
    [sym_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(834),
  },
  [560] = {
    [sym__primary_expression] = STATE(129),
    [sym_binary_operator] = STATE(129),
    [sym_unary_operator] = STATE(129),
    [sym_attribute] = STATE(129),
    [sym_subscript] = STATE(129),
    [sym_call] = STATE(129),
    [sym_list] = STATE(129),
    [sym_list_comprehension] = STATE(129),
    [sym_dictionary] = STATE(129),
    [sym_dictionary_comprehension] = STATE(129),
    [sym_set] = STATE(129),
    [sym_set_comprehension] = STATE(129),
    [sym_parenthesized_expression] = STATE(129),
    [sym_tuple] = STATE(129),
    [sym_generator_expression] = STATE(129),
    [sym_concatenated_string] = STATE(129),
    [sym_string] = STATE(117),
    [sym_identifier] = ACTIONS(1288),
    [anon_sym_LPAREN] = ACTIONS(13),
    [anon_sym_print] = ACTIONS(237),
    [anon_sym_exec] = ACTIONS(237),
    [anon_sym_PLUS] = ACTIONS(57),
    [anon_sym_DASH] = ACTIONS(57),
    [anon_sym_TILDE] = ACTIONS(57),
    [anon_sym_LBRACK] = ACTIONS(63),
    [sym_ellipsis] = ACTIONS(1290),
    [anon_sym_LBRACE] = ACTIONS(67),
    [sym_integer] = ACTIONS(1288),
    [sym_float] = ACTIONS(1290),
    [sym_true] = ACTIONS(1288),
    [sym_false] = ACTIONS(1288),
    [sym_none] = ACTIONS(1288),
    [sym_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(73),
  },
  [561] = {
    [sym__primary_expression] = STATE(516),
    [sym_binary_operator] = STATE(516),
    [sym_unary_operator] = STATE(516),
    [sym_attribute] = STATE(516),
    [sym_subscript] = STATE(516),
    [sym_call] = STATE(516),
    [sym_list] = STATE(516),
    [sym_list_comprehension] = STATE(516),
    [sym_dictionary] = STATE(516),
    [sym_dictionary_comprehension] = STATE(516),
    [sym_set] = STATE(516),
    [sym_set_comprehension] = STATE(516),
    [sym_parenthesized_expression] = STATE(516),
    [sym_tuple] = STATE(516),
    [sym_generator_expression] = STATE(516),
    [sym_concatenated_string] = STATE(516),
    [sym_string] = STATE(505),
    [sym_identifier] = ACTIONS(1292),
    [anon_sym_LPAREN] = ACTIONS(812),
    [anon_sym_print] = ACTIONS(814),
    [anon_sym_exec] = ACTIONS(814),
    [anon_sym_PLUS] = ACTIONS(820),
    [anon_sym_DASH] = ACTIONS(820),
    [anon_sym_TILDE] = ACTIONS(820),
    [anon_sym_LBRACK] = ACTIONS(824),
    [sym_ellipsis] = ACTIONS(1294),
    [anon_sym_LBRACE] = ACTIONS(828),
    [sym_integer] = ACTIONS(1292),
    [sym_float] = ACTIONS(1294),
    [sym_true] = ACTIONS(1292),
    [sym_false] = ACTIONS(1292),
    [sym_none] = ACTIONS(1292),
    [sym_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(834),
  },
  [562] = {
    [sym__primary_expression] = STATE(128),
    [sym_binary_operator] = STATE(128),
    [sym_unary_operator] = STATE(128),
    [sym_attribute] = STATE(128),
    [sym_subscript] = STATE(128),
    [sym_call] = STATE(128),
    [sym_list] = STATE(128),
    [sym_list_comprehension] = STATE(128),
    [sym_dictionary] = STATE(128),
    [sym_dictionary_comprehension] = STATE(128),
    [sym_set] = STATE(128),
    [sym_set_comprehension] = STATE(128),
    [sym_parenthesized_expression] = STATE(128),
    [sym_tuple] = STATE(128),
    [sym_generator_expression] = STATE(128),
    [sym_concatenated_string] = STATE(128),
    [sym_string] = STATE(117),
    [sym_identifier] = ACTIONS(1296),
    [anon_sym_LPAREN] = ACTIONS(13),
    [anon_sym_print] = ACTIONS(237),
    [anon_sym_exec] = ACTIONS(237),
    [anon_sym_PLUS] = ACTIONS(57),
    [anon_sym_DASH] = ACTIONS(57),
    [anon_sym_TILDE] = ACTIONS(57),
    [anon_sym_LBRACK] = ACTIONS(63),
    [sym_ellipsis] = ACTIONS(1298),
    [anon_sym_LBRACE] = ACTIONS(67),
    [sym_integer] = ACTIONS(1296),
    [sym_float] = ACTIONS(1298),
    [sym_true] = ACTIONS(1296),
    [sym_false] = ACTIONS(1296),
    [sym_none] = ACTIONS(1296),
    [sym_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(73),
  },
  [563] = {
    [sym__primary_expression] = STATE(526),
    [sym_binary_operator] = STATE(526),
    [sym_unary_operator] = STATE(526),
    [sym_attribute] = STATE(526),
    [sym_subscript] = STATE(526),
    [sym_call] = STATE(526),
    [sym_list] = STATE(526),
    [sym_list_comprehension] = STATE(526),
    [sym_dictionary] = STATE(526),
    [sym_dictionary_comprehension] = STATE(526),
    [sym_set] = STATE(526),
    [sym_set_comprehension] = STATE(526),
    [sym_parenthesized_expression] = STATE(526),
    [sym_tuple] = STATE(526),
    [sym_generator_expression] = STATE(526),
    [sym_concatenated_string] = STATE(526),
    [sym_string] = STATE(505),
    [sym_identifier] = ACTIONS(1300),
    [anon_sym_LPAREN] = ACTIONS(812),
    [anon_sym_print] = ACTIONS(814),
    [anon_sym_exec] = ACTIONS(814),
    [anon_sym_PLUS] = ACTIONS(820),
    [anon_sym_DASH] = ACTIONS(820),
    [anon_sym_TILDE] = ACTIONS(820),
    [anon_sym_LBRACK] = ACTIONS(824),
    [sym_ellipsis] = ACTIONS(1302),
    [anon_sym_LBRACE] = ACTIONS(828),
    [sym_integer] = ACTIONS(1300),
    [sym_float] = ACTIONS(1302),
    [sym_true] = ACTIONS(1300),
    [sym_false] = ACTIONS(1300),
    [sym_none] = ACTIONS(1300),
    [sym_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(834),
  },
  [564] = {
    [anon_sym_DOT] = ACTIONS(514),
    [anon_sym_LPAREN] = ACTIONS(514),
    [anon_sym_COMMA] = ACTIONS(514),
    [anon_sym_as] = ACTIONS(514),
    [anon_sym_STAR] = ACTIONS(516),
    [anon_sym_GT_GT] = ACTIONS(514),
    [anon_sym_if] = ACTIONS(514),
    [anon_sym_COLON] = ACTIONS(514),
    [anon_sym_in] = ACTIONS(514),
    [anon_sym_STAR_STAR] = ACTIONS(514),
    [anon_sym_AT] = ACTIONS(514),
    [anon_sym_not] = ACTIONS(514),
    [anon_sym_and] = ACTIONS(514),
    [anon_sym_or] = ACTIONS(514),
    [anon_sym_PLUS] = ACTIONS(514),
    [anon_sym_DASH] = ACTIONS(514),
    [anon_sym_SLASH] = ACTIONS(516),
    [anon_sym_PERCENT] = ACTIONS(514),
    [anon_sym_SLASH_SLASH] = ACTIONS(514),
    [anon_sym_PIPE] = ACTIONS(514),
    [anon_sym_AMP] = ACTIONS(514),
    [anon_sym_CARET] = ACTIONS(514),
    [anon_sym_LT_LT] = ACTIONS(514),
    [anon_sym_LT] = ACTIONS(516),
    [anon_sym_LT_EQ] = ACTIONS(514),
    [anon_sym_EQ_EQ] = ACTIONS(514),
    [anon_sym_BANG_EQ] = ACTIONS(514),
    [anon_sym_GT_EQ] = ACTIONS(514),
    [anon_sym_GT] = ACTIONS(516),
    [anon_sym_LT_GT] = ACTIONS(514),
    [anon_sym_is] = ACTIONS(514),
    [anon_sym_LBRACK] = ACTIONS(514),
    [sym_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(514),
  },
  [565] = {
    [sym__primary_expression] = STATE(611),
    [sym_binary_operator] = STATE(611),
    [sym_unary_operator] = STATE(611),
    [sym_attribute] = STATE(611),
    [sym_subscript] = STATE(611),
    [sym_call] = STATE(611),
    [sym_list] = STATE(611),
    [sym_list_comprehension] = STATE(611),
    [sym_dictionary] = STATE(611),
    [sym_dictionary_comprehension] = STATE(611),
    [sym_set] = STATE(611),
    [sym_set_comprehension] = STATE(611),
    [sym_parenthesized_expression] = STATE(611),
    [sym_tuple] = STATE(611),
    [sym_generator_expression] = STATE(611),
    [sym_concatenated_string] = STATE(611),
    [sym_string] = STATE(381),
    [sym_identifier] = ACTIONS(1158),
    [anon_sym_LPAREN] = ACTIONS(389),
    [anon_sym_print] = ACTIONS(393),
    [anon_sym_exec] = ACTIONS(393),
    [anon_sym_PLUS] = ACTIONS(363),
    [anon_sym_DASH] = ACTIONS(363),
    [anon_sym_TILDE] = ACTIONS(363),
    [anon_sym_LBRACK] = ACTIONS(367),
    [sym_ellipsis] = ACTIONS(1162),
    [anon_sym_LBRACE] = ACTIONS(371),
    [sym_integer] = ACTIONS(1158),
    [sym_float] = ACTIONS(1162),
    [sym_true] = ACTIONS(1158),
    [sym_false] = ACTIONS(1158),
    [sym_none] = ACTIONS(1158),
    [sym_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(377),
  },
  [566] = {
    [anon_sym_DOT] = ACTIONS(570),
    [anon_sym_LPAREN] = ACTIONS(570),
    [anon_sym_COMMA] = ACTIONS(570),
    [anon_sym_as] = ACTIONS(570),
    [anon_sym_STAR] = ACTIONS(572),
    [anon_sym_GT_GT] = ACTIONS(570),
    [anon_sym_if] = ACTIONS(570),
    [anon_sym_COLON] = ACTIONS(570),
    [anon_sym_in] = ACTIONS(570),
    [anon_sym_STAR_STAR] = ACTIONS(570),
    [anon_sym_AT] = ACTIONS(570),
    [anon_sym_not] = ACTIONS(570),
    [anon_sym_and] = ACTIONS(570),
    [anon_sym_or] = ACTIONS(570),
    [anon_sym_PLUS] = ACTIONS(570),
    [anon_sym_DASH] = ACTIONS(570),
    [anon_sym_SLASH] = ACTIONS(572),
    [anon_sym_PERCENT] = ACTIONS(570),
    [anon_sym_SLASH_SLASH] = ACTIONS(570),
    [anon_sym_PIPE] = ACTIONS(570),
    [anon_sym_AMP] = ACTIONS(570),
    [anon_sym_CARET] = ACTIONS(570),
    [anon_sym_LT_LT] = ACTIONS(570),
    [anon_sym_LT] = ACTIONS(572),
    [anon_sym_LT_EQ] = ACTIONS(570),
    [anon_sym_EQ_EQ] = ACTIONS(570),
    [anon_sym_BANG_EQ] = ACTIONS(570),
    [anon_sym_GT_EQ] = ACTIONS(570),
    [anon_sym_GT] = ACTIONS(572),
    [anon_sym_LT_GT] = ACTIONS(570),
    [anon_sym_is] = ACTIONS(570),
    [anon_sym_LBRACK] = ACTIONS(570),
    [sym_comment] = ACTIONS(3),
  },
  [567] = {
    [anon_sym_DOT] = ACTIONS(558),
    [anon_sym_LPAREN] = ACTIONS(558),
    [anon_sym_COMMA] = ACTIONS(558),
    [anon_sym_as] = ACTIONS(558),
    [anon_sym_STAR] = ACTIONS(560),
    [anon_sym_GT_GT] = ACTIONS(558),
    [anon_sym_if] = ACTIONS(558),
    [anon_sym_COLON] = ACTIONS(558),
    [anon_sym_in] = ACTIONS(558),
    [anon_sym_STAR_STAR] = ACTIONS(558),
    [anon_sym_AT] = ACTIONS(558),
    [anon_sym_not] = ACTIONS(558),
    [anon_sym_and] = ACTIONS(558),
    [anon_sym_or] = ACTIONS(558),
    [anon_sym_PLUS] = ACTIONS(558),
    [anon_sym_DASH] = ACTIONS(558),
    [anon_sym_SLASH] = ACTIONS(560),
    [anon_sym_PERCENT] = ACTIONS(558),
    [anon_sym_SLASH_SLASH] = ACTIONS(558),
    [anon_sym_PIPE] = ACTIONS(558),
    [anon_sym_AMP] = ACTIONS(558),
    [anon_sym_CARET] = ACTIONS(558),
    [anon_sym_LT_LT] = ACTIONS(558),
    [anon_sym_LT] = ACTIONS(560),
    [anon_sym_LT_EQ] = ACTIONS(558),
    [anon_sym_EQ_EQ] = ACTIONS(558),
    [anon_sym_BANG_EQ] = ACTIONS(558),
    [anon_sym_GT_EQ] = ACTIONS(558),
    [anon_sym_GT] = ACTIONS(560),
    [anon_sym_LT_GT] = ACTIONS(558),
    [anon_sym_is] = ACTIONS(558),
    [anon_sym_LBRACK] = ACTIONS(558),
    [sym_comment] = ACTIONS(3),
  },
  [568] = {
    [anon_sym_DOT] = ACTIONS(566),
    [anon_sym_LPAREN] = ACTIONS(566),
    [anon_sym_COMMA] = ACTIONS(566),
    [anon_sym_as] = ACTIONS(566),
    [anon_sym_STAR] = ACTIONS(568),
    [anon_sym_GT_GT] = ACTIONS(566),
    [anon_sym_if] = ACTIONS(566),
    [anon_sym_COLON] = ACTIONS(566),
    [anon_sym_in] = ACTIONS(566),
    [anon_sym_STAR_STAR] = ACTIONS(566),
    [anon_sym_AT] = ACTIONS(566),
    [anon_sym_not] = ACTIONS(566),
    [anon_sym_and] = ACTIONS(566),
    [anon_sym_or] = ACTIONS(566),
    [anon_sym_PLUS] = ACTIONS(566),
    [anon_sym_DASH] = ACTIONS(566),
    [anon_sym_SLASH] = ACTIONS(568),
    [anon_sym_PERCENT] = ACTIONS(566),
    [anon_sym_SLASH_SLASH] = ACTIONS(566),
    [anon_sym_PIPE] = ACTIONS(566),
    [anon_sym_AMP] = ACTIONS(566),
    [anon_sym_CARET] = ACTIONS(566),
    [anon_sym_LT_LT] = ACTIONS(566),
    [anon_sym_LT] = ACTIONS(568),
    [anon_sym_LT_EQ] = ACTIONS(566),
    [anon_sym_EQ_EQ] = ACTIONS(566),
    [anon_sym_BANG_EQ] = ACTIONS(566),
    [anon_sym_GT_EQ] = ACTIONS(566),
    [anon_sym_GT] = ACTIONS(568),
    [anon_sym_LT_GT] = ACTIONS(566),
    [anon_sym_is] = ACTIONS(566),
    [anon_sym_LBRACK] = ACTIONS(566),
    [sym_comment] = ACTIONS(3),
  },
  [569] = {
    [anon_sym_DOT] = ACTIONS(666),
    [anon_sym_LPAREN] = ACTIONS(666),
    [anon_sym_COMMA] = ACTIONS(666),
    [anon_sym_as] = ACTIONS(666),
    [anon_sym_STAR] = ACTIONS(668),
    [anon_sym_GT_GT] = ACTIONS(666),
    [anon_sym_if] = ACTIONS(666),
    [anon_sym_COLON] = ACTIONS(666),
    [anon_sym_in] = ACTIONS(666),
    [anon_sym_STAR_STAR] = ACTIONS(666),
    [anon_sym_AT] = ACTIONS(666),
    [anon_sym_not] = ACTIONS(666),
    [anon_sym_and] = ACTIONS(666),
    [anon_sym_or] = ACTIONS(666),
    [anon_sym_PLUS] = ACTIONS(666),
    [anon_sym_DASH] = ACTIONS(666),
    [anon_sym_SLASH] = ACTIONS(668),
    [anon_sym_PERCENT] = ACTIONS(666),
    [anon_sym_SLASH_SLASH] = ACTIONS(666),
    [anon_sym_PIPE] = ACTIONS(666),
    [anon_sym_AMP] = ACTIONS(666),
    [anon_sym_CARET] = ACTIONS(666),
    [anon_sym_LT_LT] = ACTIONS(666),
    [anon_sym_LT] = ACTIONS(668),
    [anon_sym_LT_EQ] = ACTIONS(666),
    [anon_sym_EQ_EQ] = ACTIONS(666),
    [anon_sym_BANG_EQ] = ACTIONS(666),
    [anon_sym_GT_EQ] = ACTIONS(666),
    [anon_sym_GT] = ACTIONS(668),
    [anon_sym_LT_GT] = ACTIONS(666),
    [anon_sym_is] = ACTIONS(666),
    [anon_sym_LBRACK] = ACTIONS(666),
    [sym_comment] = ACTIONS(3),
  },
  [570] = {
    [anon_sym_DOT] = ACTIONS(610),
    [anon_sym_LPAREN] = ACTIONS(610),
    [anon_sym_COMMA] = ACTIONS(610),
    [anon_sym_as] = ACTIONS(610),
    [anon_sym_STAR] = ACTIONS(612),
    [anon_sym_GT_GT] = ACTIONS(610),
    [anon_sym_if] = ACTIONS(610),
    [anon_sym_COLON] = ACTIONS(610),
    [anon_sym_in] = ACTIONS(610),
    [anon_sym_STAR_STAR] = ACTIONS(610),
    [anon_sym_AT] = ACTIONS(610),
    [anon_sym_not] = ACTIONS(610),
    [anon_sym_and] = ACTIONS(610),
    [anon_sym_or] = ACTIONS(610),
    [anon_sym_PLUS] = ACTIONS(610),
    [anon_sym_DASH] = ACTIONS(610),
    [anon_sym_SLASH] = ACTIONS(612),
    [anon_sym_PERCENT] = ACTIONS(610),
    [anon_sym_SLASH_SLASH] = ACTIONS(610),
    [anon_sym_PIPE] = ACTIONS(610),
    [anon_sym_AMP] = ACTIONS(610),
    [anon_sym_CARET] = ACTIONS(610),
    [anon_sym_LT_LT] = ACTIONS(610),
    [anon_sym_LT] = ACTIONS(612),
    [anon_sym_LT_EQ] = ACTIONS(610),
    [anon_sym_EQ_EQ] = ACTIONS(610),
    [anon_sym_BANG_EQ] = ACTIONS(610),
    [anon_sym_GT_EQ] = ACTIONS(610),
    [anon_sym_GT] = ACTIONS(612),
    [anon_sym_LT_GT] = ACTIONS(610),
    [anon_sym_is] = ACTIONS(610),
    [anon_sym_LBRACK] = ACTIONS(610),
    [sym_comment] = ACTIONS(3),
  },
  [571] = {
    [anon_sym_DOT] = ACTIONS(646),
    [anon_sym_LPAREN] = ACTIONS(646),
    [anon_sym_COMMA] = ACTIONS(646),
    [anon_sym_as] = ACTIONS(646),
    [anon_sym_STAR] = ACTIONS(648),
    [anon_sym_GT_GT] = ACTIONS(646),
    [anon_sym_if] = ACTIONS(646),
    [anon_sym_COLON] = ACTIONS(646),
    [anon_sym_in] = ACTIONS(646),
    [anon_sym_STAR_STAR] = ACTIONS(646),
    [anon_sym_AT] = ACTIONS(646),
    [anon_sym_not] = ACTIONS(646),
    [anon_sym_and] = ACTIONS(646),
    [anon_sym_or] = ACTIONS(646),
    [anon_sym_PLUS] = ACTIONS(646),
    [anon_sym_DASH] = ACTIONS(646),
    [anon_sym_SLASH] = ACTIONS(648),
    [anon_sym_PERCENT] = ACTIONS(646),
    [anon_sym_SLASH_SLASH] = ACTIONS(646),
    [anon_sym_PIPE] = ACTIONS(646),
    [anon_sym_AMP] = ACTIONS(646),
    [anon_sym_CARET] = ACTIONS(646),
    [anon_sym_LT_LT] = ACTIONS(646),
    [anon_sym_LT] = ACTIONS(648),
    [anon_sym_LT_EQ] = ACTIONS(646),
    [anon_sym_EQ_EQ] = ACTIONS(646),
    [anon_sym_BANG_EQ] = ACTIONS(646),
    [anon_sym_GT_EQ] = ACTIONS(646),
    [anon_sym_GT] = ACTIONS(648),
    [anon_sym_LT_GT] = ACTIONS(646),
    [anon_sym_is] = ACTIONS(646),
    [anon_sym_LBRACK] = ACTIONS(646),
    [sym_comment] = ACTIONS(3),
  },
  [572] = {
    [anon_sym_DOT] = ACTIONS(530),
    [anon_sym_LPAREN] = ACTIONS(530),
    [anon_sym_COMMA] = ACTIONS(530),
    [anon_sym_as] = ACTIONS(530),
    [anon_sym_STAR] = ACTIONS(532),
    [anon_sym_GT_GT] = ACTIONS(530),
    [anon_sym_if] = ACTIONS(530),
    [anon_sym_COLON] = ACTIONS(530),
    [anon_sym_in] = ACTIONS(530),
    [anon_sym_STAR_STAR] = ACTIONS(530),
    [anon_sym_AT] = ACTIONS(530),
    [anon_sym_not] = ACTIONS(530),
    [anon_sym_and] = ACTIONS(530),
    [anon_sym_or] = ACTIONS(530),
    [anon_sym_PLUS] = ACTIONS(530),
    [anon_sym_DASH] = ACTIONS(530),
    [anon_sym_SLASH] = ACTIONS(532),
    [anon_sym_PERCENT] = ACTIONS(530),
    [anon_sym_SLASH_SLASH] = ACTIONS(530),
    [anon_sym_PIPE] = ACTIONS(530),
    [anon_sym_AMP] = ACTIONS(530),
    [anon_sym_CARET] = ACTIONS(530),
    [anon_sym_LT_LT] = ACTIONS(530),
    [anon_sym_LT] = ACTIONS(532),
    [anon_sym_LT_EQ] = ACTIONS(530),
    [anon_sym_EQ_EQ] = ACTIONS(530),
    [anon_sym_BANG_EQ] = ACTIONS(530),
    [anon_sym_GT_EQ] = ACTIONS(530),
    [anon_sym_GT] = ACTIONS(532),
    [anon_sym_LT_GT] = ACTIONS(530),
    [anon_sym_is] = ACTIONS(530),
    [anon_sym_LBRACK] = ACTIONS(530),
    [sym_comment] = ACTIONS(3),
  },
  [573] = {
    [anon_sym_DOT] = ACTIONS(634),
    [anon_sym_LPAREN] = ACTIONS(634),
    [anon_sym_COMMA] = ACTIONS(634),
    [anon_sym_as] = ACTIONS(634),
    [anon_sym_STAR] = ACTIONS(636),
    [anon_sym_GT_GT] = ACTIONS(634),
    [anon_sym_if] = ACTIONS(634),
    [anon_sym_COLON] = ACTIONS(634),
    [anon_sym_in] = ACTIONS(634),
    [anon_sym_STAR_STAR] = ACTIONS(634),
    [anon_sym_AT] = ACTIONS(634),
    [anon_sym_not] = ACTIONS(634),
    [anon_sym_and] = ACTIONS(634),
    [anon_sym_or] = ACTIONS(634),
    [anon_sym_PLUS] = ACTIONS(634),
    [anon_sym_DASH] = ACTIONS(634),
    [anon_sym_SLASH] = ACTIONS(636),
    [anon_sym_PERCENT] = ACTIONS(634),
    [anon_sym_SLASH_SLASH] = ACTIONS(634),
    [anon_sym_PIPE] = ACTIONS(634),
    [anon_sym_AMP] = ACTIONS(634),
    [anon_sym_CARET] = ACTIONS(634),
    [anon_sym_LT_LT] = ACTIONS(634),
    [anon_sym_LT] = ACTIONS(636),
    [anon_sym_LT_EQ] = ACTIONS(634),
    [anon_sym_EQ_EQ] = ACTIONS(634),
    [anon_sym_BANG_EQ] = ACTIONS(634),
    [anon_sym_GT_EQ] = ACTIONS(634),
    [anon_sym_GT] = ACTIONS(636),
    [anon_sym_LT_GT] = ACTIONS(634),
    [anon_sym_is] = ACTIONS(634),
    [anon_sym_LBRACK] = ACTIONS(634),
    [sym_comment] = ACTIONS(3),
  },
  [574] = {
    [anon_sym_DOT] = ACTIONS(690),
    [anon_sym_LPAREN] = ACTIONS(690),
    [anon_sym_COMMA] = ACTIONS(690),
    [anon_sym_as] = ACTIONS(690),
    [anon_sym_STAR] = ACTIONS(692),
    [anon_sym_GT_GT] = ACTIONS(690),
    [anon_sym_if] = ACTIONS(690),
    [anon_sym_COLON] = ACTIONS(690),
    [anon_sym_in] = ACTIONS(690),
    [anon_sym_STAR_STAR] = ACTIONS(690),
    [anon_sym_AT] = ACTIONS(690),
    [anon_sym_not] = ACTIONS(690),
    [anon_sym_and] = ACTIONS(690),
    [anon_sym_or] = ACTIONS(690),
    [anon_sym_PLUS] = ACTIONS(690),
    [anon_sym_DASH] = ACTIONS(690),
    [anon_sym_SLASH] = ACTIONS(692),
    [anon_sym_PERCENT] = ACTIONS(690),
    [anon_sym_SLASH_SLASH] = ACTIONS(690),
    [anon_sym_PIPE] = ACTIONS(690),
    [anon_sym_AMP] = ACTIONS(690),
    [anon_sym_CARET] = ACTIONS(690),
    [anon_sym_LT_LT] = ACTIONS(690),
    [anon_sym_LT] = ACTIONS(692),
    [anon_sym_LT_EQ] = ACTIONS(690),
    [anon_sym_EQ_EQ] = ACTIONS(690),
    [anon_sym_BANG_EQ] = ACTIONS(690),
    [anon_sym_GT_EQ] = ACTIONS(690),
    [anon_sym_GT] = ACTIONS(692),
    [anon_sym_LT_GT] = ACTIONS(690),
    [anon_sym_is] = ACTIONS(690),
    [anon_sym_LBRACK] = ACTIONS(690),
    [sym_comment] = ACTIONS(3),
  },
  [575] = {
    [anon_sym_DOT] = ACTIONS(676),
    [anon_sym_LPAREN] = ACTIONS(676),
    [anon_sym_COMMA] = ACTIONS(676),
    [anon_sym_as] = ACTIONS(676),
    [anon_sym_STAR] = ACTIONS(678),
    [anon_sym_GT_GT] = ACTIONS(676),
    [anon_sym_if] = ACTIONS(676),
    [anon_sym_COLON] = ACTIONS(676),
    [anon_sym_in] = ACTIONS(676),
    [anon_sym_STAR_STAR] = ACTIONS(676),
    [anon_sym_AT] = ACTIONS(676),
    [anon_sym_not] = ACTIONS(676),
    [anon_sym_and] = ACTIONS(676),
    [anon_sym_or] = ACTIONS(676),
    [anon_sym_PLUS] = ACTIONS(676),
    [anon_sym_DASH] = ACTIONS(676),
    [anon_sym_SLASH] = ACTIONS(678),
    [anon_sym_PERCENT] = ACTIONS(676),
    [anon_sym_SLASH_SLASH] = ACTIONS(676),
    [anon_sym_PIPE] = ACTIONS(676),
    [anon_sym_AMP] = ACTIONS(676),
    [anon_sym_CARET] = ACTIONS(676),
    [anon_sym_LT_LT] = ACTIONS(676),
    [anon_sym_LT] = ACTIONS(678),
    [anon_sym_LT_EQ] = ACTIONS(676),
    [anon_sym_EQ_EQ] = ACTIONS(676),
    [anon_sym_BANG_EQ] = ACTIONS(676),
    [anon_sym_GT_EQ] = ACTIONS(676),
    [anon_sym_GT] = ACTIONS(678),
    [anon_sym_LT_GT] = ACTIONS(676),
    [anon_sym_is] = ACTIONS(676),
    [anon_sym_LBRACK] = ACTIONS(676),
    [sym_comment] = ACTIONS(3),
  },
  [576] = {
    [anon_sym_DOT] = ACTIONS(235),
    [anon_sym_LPAREN] = ACTIONS(235),
    [anon_sym_COMMA] = ACTIONS(235),
    [anon_sym_as] = ACTIONS(235),
    [anon_sym_STAR] = ACTIONS(233),
    [anon_sym_GT_GT] = ACTIONS(235),
    [anon_sym_if] = ACTIONS(235),
    [anon_sym_COLON] = ACTIONS(235),
    [anon_sym_in] = ACTIONS(235),
    [anon_sym_STAR_STAR] = ACTIONS(235),
    [anon_sym_AT] = ACTIONS(235),
    [anon_sym_not] = ACTIONS(235),
    [anon_sym_and] = ACTIONS(235),
    [anon_sym_or] = ACTIONS(235),
    [anon_sym_PLUS] = ACTIONS(235),
    [anon_sym_DASH] = ACTIONS(235),
    [anon_sym_SLASH] = ACTIONS(233),
    [anon_sym_PERCENT] = ACTIONS(235),
    [anon_sym_SLASH_SLASH] = ACTIONS(235),
    [anon_sym_PIPE] = ACTIONS(235),
    [anon_sym_AMP] = ACTIONS(235),
    [anon_sym_CARET] = ACTIONS(235),
    [anon_sym_LT_LT] = ACTIONS(235),
    [anon_sym_LT] = ACTIONS(233),
    [anon_sym_LT_EQ] = ACTIONS(235),
    [anon_sym_EQ_EQ] = ACTIONS(235),
    [anon_sym_BANG_EQ] = ACTIONS(235),
    [anon_sym_GT_EQ] = ACTIONS(235),
    [anon_sym_GT] = ACTIONS(233),
    [anon_sym_LT_GT] = ACTIONS(235),
    [anon_sym_is] = ACTIONS(235),
    [anon_sym_LBRACK] = ACTIONS(235),
    [sym_comment] = ACTIONS(3),
  },
  [577] = {
    [anon_sym_DOT] = ACTIONS(594),
    [anon_sym_LPAREN] = ACTIONS(594),
    [anon_sym_COMMA] = ACTIONS(594),
    [anon_sym_as] = ACTIONS(594),
    [anon_sym_STAR] = ACTIONS(596),
    [anon_sym_GT_GT] = ACTIONS(594),
    [anon_sym_if] = ACTIONS(594),
    [anon_sym_COLON] = ACTIONS(594),
    [anon_sym_in] = ACTIONS(594),
    [anon_sym_STAR_STAR] = ACTIONS(594),
    [anon_sym_AT] = ACTIONS(594),
    [anon_sym_not] = ACTIONS(594),
    [anon_sym_and] = ACTIONS(594),
    [anon_sym_or] = ACTIONS(594),
    [anon_sym_PLUS] = ACTIONS(594),
    [anon_sym_DASH] = ACTIONS(594),
    [anon_sym_SLASH] = ACTIONS(596),
    [anon_sym_PERCENT] = ACTIONS(594),
    [anon_sym_SLASH_SLASH] = ACTIONS(594),
    [anon_sym_PIPE] = ACTIONS(594),
    [anon_sym_AMP] = ACTIONS(594),
    [anon_sym_CARET] = ACTIONS(594),
    [anon_sym_LT_LT] = ACTIONS(594),
    [anon_sym_LT] = ACTIONS(596),
    [anon_sym_LT_EQ] = ACTIONS(594),
    [anon_sym_EQ_EQ] = ACTIONS(594),
    [anon_sym_BANG_EQ] = ACTIONS(594),
    [anon_sym_GT_EQ] = ACTIONS(594),
    [anon_sym_GT] = ACTIONS(596),
    [anon_sym_LT_GT] = ACTIONS(594),
    [anon_sym_is] = ACTIONS(594),
    [anon_sym_LBRACK] = ACTIONS(594),
    [sym_comment] = ACTIONS(3),
  },
  [578] = {
    [anon_sym_DOT] = ACTIONS(588),
    [anon_sym_LPAREN] = ACTIONS(588),
    [anon_sym_COMMA] = ACTIONS(588),
    [anon_sym_as] = ACTIONS(588),
    [anon_sym_STAR] = ACTIONS(590),
    [anon_sym_GT_GT] = ACTIONS(588),
    [anon_sym_if] = ACTIONS(588),
    [anon_sym_COLON] = ACTIONS(588),
    [anon_sym_in] = ACTIONS(588),
    [anon_sym_STAR_STAR] = ACTIONS(588),
    [anon_sym_AT] = ACTIONS(588),
    [anon_sym_not] = ACTIONS(588),
    [anon_sym_and] = ACTIONS(588),
    [anon_sym_or] = ACTIONS(588),
    [anon_sym_PLUS] = ACTIONS(588),
    [anon_sym_DASH] = ACTIONS(588),
    [anon_sym_SLASH] = ACTIONS(590),
    [anon_sym_PERCENT] = ACTIONS(588),
    [anon_sym_SLASH_SLASH] = ACTIONS(588),
    [anon_sym_PIPE] = ACTIONS(588),
    [anon_sym_AMP] = ACTIONS(588),
    [anon_sym_CARET] = ACTIONS(588),
    [anon_sym_LT_LT] = ACTIONS(588),
    [anon_sym_LT] = ACTIONS(590),
    [anon_sym_LT_EQ] = ACTIONS(588),
    [anon_sym_EQ_EQ] = ACTIONS(588),
    [anon_sym_BANG_EQ] = ACTIONS(588),
    [anon_sym_GT_EQ] = ACTIONS(588),
    [anon_sym_GT] = ACTIONS(590),
    [anon_sym_LT_GT] = ACTIONS(588),
    [anon_sym_is] = ACTIONS(588),
    [anon_sym_LBRACK] = ACTIONS(588),
    [sym_comment] = ACTIONS(3),
  },
  [579] = {
    [anon_sym_DOT] = ACTIONS(696),
    [anon_sym_LPAREN] = ACTIONS(696),
    [anon_sym_COMMA] = ACTIONS(696),
    [anon_sym_as] = ACTIONS(696),
    [anon_sym_STAR] = ACTIONS(698),
    [anon_sym_GT_GT] = ACTIONS(696),
    [anon_sym_if] = ACTIONS(696),
    [anon_sym_COLON] = ACTIONS(696),
    [anon_sym_in] = ACTIONS(696),
    [anon_sym_STAR_STAR] = ACTIONS(696),
    [anon_sym_AT] = ACTIONS(696),
    [anon_sym_not] = ACTIONS(696),
    [anon_sym_and] = ACTIONS(696),
    [anon_sym_or] = ACTIONS(696),
    [anon_sym_PLUS] = ACTIONS(696),
    [anon_sym_DASH] = ACTIONS(696),
    [anon_sym_SLASH] = ACTIONS(698),
    [anon_sym_PERCENT] = ACTIONS(696),
    [anon_sym_SLASH_SLASH] = ACTIONS(696),
    [anon_sym_PIPE] = ACTIONS(696),
    [anon_sym_AMP] = ACTIONS(696),
    [anon_sym_CARET] = ACTIONS(696),
    [anon_sym_LT_LT] = ACTIONS(696),
    [anon_sym_LT] = ACTIONS(698),
    [anon_sym_LT_EQ] = ACTIONS(696),
    [anon_sym_EQ_EQ] = ACTIONS(696),
    [anon_sym_BANG_EQ] = ACTIONS(696),
    [anon_sym_GT_EQ] = ACTIONS(696),
    [anon_sym_GT] = ACTIONS(698),
    [anon_sym_LT_GT] = ACTIONS(696),
    [anon_sym_is] = ACTIONS(696),
    [anon_sym_LBRACK] = ACTIONS(696),
    [sym_comment] = ACTIONS(3),
  },
  [580] = {
    [anon_sym_DOT] = ACTIONS(638),
    [anon_sym_LPAREN] = ACTIONS(638),
    [anon_sym_COMMA] = ACTIONS(638),
    [anon_sym_as] = ACTIONS(638),
    [anon_sym_STAR] = ACTIONS(640),
    [anon_sym_GT_GT] = ACTIONS(638),
    [anon_sym_if] = ACTIONS(638),
    [anon_sym_COLON] = ACTIONS(638),
    [anon_sym_in] = ACTIONS(638),
    [anon_sym_STAR_STAR] = ACTIONS(638),
    [anon_sym_AT] = ACTIONS(638),
    [anon_sym_not] = ACTIONS(638),
    [anon_sym_and] = ACTIONS(638),
    [anon_sym_or] = ACTIONS(638),
    [anon_sym_PLUS] = ACTIONS(638),
    [anon_sym_DASH] = ACTIONS(638),
    [anon_sym_SLASH] = ACTIONS(640),
    [anon_sym_PERCENT] = ACTIONS(638),
    [anon_sym_SLASH_SLASH] = ACTIONS(638),
    [anon_sym_PIPE] = ACTIONS(638),
    [anon_sym_AMP] = ACTIONS(638),
    [anon_sym_CARET] = ACTIONS(638),
    [anon_sym_LT_LT] = ACTIONS(638),
    [anon_sym_LT] = ACTIONS(640),
    [anon_sym_LT_EQ] = ACTIONS(638),
    [anon_sym_EQ_EQ] = ACTIONS(638),
    [anon_sym_BANG_EQ] = ACTIONS(638),
    [anon_sym_GT_EQ] = ACTIONS(638),
    [anon_sym_GT] = ACTIONS(640),
    [anon_sym_LT_GT] = ACTIONS(638),
    [anon_sym_is] = ACTIONS(638),
    [anon_sym_LBRACK] = ACTIONS(638),
    [sym_comment] = ACTIONS(3),
  },
  [581] = {
    [anon_sym_DOT] = ACTIONS(606),
    [anon_sym_LPAREN] = ACTIONS(606),
    [anon_sym_COMMA] = ACTIONS(606),
    [anon_sym_as] = ACTIONS(606),
    [anon_sym_STAR] = ACTIONS(608),
    [anon_sym_GT_GT] = ACTIONS(606),
    [anon_sym_if] = ACTIONS(606),
    [anon_sym_COLON] = ACTIONS(606),
    [anon_sym_in] = ACTIONS(606),
    [anon_sym_STAR_STAR] = ACTIONS(606),
    [anon_sym_AT] = ACTIONS(606),
    [anon_sym_not] = ACTIONS(606),
    [anon_sym_and] = ACTIONS(606),
    [anon_sym_or] = ACTIONS(606),
    [anon_sym_PLUS] = ACTIONS(606),
    [anon_sym_DASH] = ACTIONS(606),
    [anon_sym_SLASH] = ACTIONS(608),
    [anon_sym_PERCENT] = ACTIONS(606),
    [anon_sym_SLASH_SLASH] = ACTIONS(606),
    [anon_sym_PIPE] = ACTIONS(606),
    [anon_sym_AMP] = ACTIONS(606),
    [anon_sym_CARET] = ACTIONS(606),
    [anon_sym_LT_LT] = ACTIONS(606),
    [anon_sym_LT] = ACTIONS(608),
    [anon_sym_LT_EQ] = ACTIONS(606),
    [anon_sym_EQ_EQ] = ACTIONS(606),
    [anon_sym_BANG_EQ] = ACTIONS(606),
    [anon_sym_GT_EQ] = ACTIONS(606),
    [anon_sym_GT] = ACTIONS(608),
    [anon_sym_LT_GT] = ACTIONS(606),
    [anon_sym_is] = ACTIONS(606),
    [anon_sym_LBRACK] = ACTIONS(606),
    [sym_comment] = ACTIONS(3),
  },
  [582] = {
    [anon_sym_DOT] = ACTIONS(626),
    [anon_sym_LPAREN] = ACTIONS(626),
    [anon_sym_COMMA] = ACTIONS(626),
    [anon_sym_as] = ACTIONS(626),
    [anon_sym_STAR] = ACTIONS(628),
    [anon_sym_GT_GT] = ACTIONS(626),
    [anon_sym_if] = ACTIONS(626),
    [anon_sym_COLON] = ACTIONS(626),
    [anon_sym_in] = ACTIONS(626),
    [anon_sym_STAR_STAR] = ACTIONS(626),
    [anon_sym_AT] = ACTIONS(626),
    [anon_sym_not] = ACTIONS(626),
    [anon_sym_and] = ACTIONS(626),
    [anon_sym_or] = ACTIONS(626),
    [anon_sym_PLUS] = ACTIONS(626),
    [anon_sym_DASH] = ACTIONS(626),
    [anon_sym_SLASH] = ACTIONS(628),
    [anon_sym_PERCENT] = ACTIONS(626),
    [anon_sym_SLASH_SLASH] = ACTIONS(626),
    [anon_sym_PIPE] = ACTIONS(626),
    [anon_sym_AMP] = ACTIONS(626),
    [anon_sym_CARET] = ACTIONS(626),
    [anon_sym_LT_LT] = ACTIONS(626),
    [anon_sym_LT] = ACTIONS(628),
    [anon_sym_LT_EQ] = ACTIONS(626),
    [anon_sym_EQ_EQ] = ACTIONS(626),
    [anon_sym_BANG_EQ] = ACTIONS(626),
    [anon_sym_GT_EQ] = ACTIONS(626),
    [anon_sym_GT] = ACTIONS(628),
    [anon_sym_LT_GT] = ACTIONS(626),
    [anon_sym_is] = ACTIONS(626),
    [anon_sym_LBRACK] = ACTIONS(626),
    [sym_comment] = ACTIONS(3),
  },
  [583] = {
    [anon_sym_DOT] = ACTIONS(672),
    [anon_sym_LPAREN] = ACTIONS(672),
    [anon_sym_COMMA] = ACTIONS(672),
    [anon_sym_as] = ACTIONS(672),
    [anon_sym_STAR] = ACTIONS(674),
    [anon_sym_GT_GT] = ACTIONS(672),
    [anon_sym_if] = ACTIONS(672),
    [anon_sym_COLON] = ACTIONS(672),
    [anon_sym_in] = ACTIONS(672),
    [anon_sym_STAR_STAR] = ACTIONS(672),
    [anon_sym_AT] = ACTIONS(672),
    [anon_sym_not] = ACTIONS(672),
    [anon_sym_and] = ACTIONS(672),
    [anon_sym_or] = ACTIONS(672),
    [anon_sym_PLUS] = ACTIONS(672),
    [anon_sym_DASH] = ACTIONS(672),
    [anon_sym_SLASH] = ACTIONS(674),
    [anon_sym_PERCENT] = ACTIONS(672),
    [anon_sym_SLASH_SLASH] = ACTIONS(672),
    [anon_sym_PIPE] = ACTIONS(672),
    [anon_sym_AMP] = ACTIONS(672),
    [anon_sym_CARET] = ACTIONS(672),
    [anon_sym_LT_LT] = ACTIONS(672),
    [anon_sym_LT] = ACTIONS(674),
    [anon_sym_LT_EQ] = ACTIONS(672),
    [anon_sym_EQ_EQ] = ACTIONS(672),
    [anon_sym_BANG_EQ] = ACTIONS(672),
    [anon_sym_GT_EQ] = ACTIONS(672),
    [anon_sym_GT] = ACTIONS(674),
    [anon_sym_LT_GT] = ACTIONS(672),
    [anon_sym_is] = ACTIONS(672),
    [anon_sym_LBRACK] = ACTIONS(672),
    [sym_comment] = ACTIONS(3),
  },
  [584] = {
    [anon_sym_DOT] = ACTIONS(602),
    [anon_sym_LPAREN] = ACTIONS(602),
    [anon_sym_COMMA] = ACTIONS(602),
    [anon_sym_as] = ACTIONS(602),
    [anon_sym_STAR] = ACTIONS(604),
    [anon_sym_GT_GT] = ACTIONS(602),
    [anon_sym_if] = ACTIONS(602),
    [anon_sym_COLON] = ACTIONS(602),
    [anon_sym_in] = ACTIONS(602),
    [anon_sym_STAR_STAR] = ACTIONS(602),
    [anon_sym_AT] = ACTIONS(602),
    [anon_sym_not] = ACTIONS(602),
    [anon_sym_and] = ACTIONS(602),
    [anon_sym_or] = ACTIONS(602),
    [anon_sym_PLUS] = ACTIONS(602),
    [anon_sym_DASH] = ACTIONS(602),
    [anon_sym_SLASH] = ACTIONS(604),
    [anon_sym_PERCENT] = ACTIONS(602),
    [anon_sym_SLASH_SLASH] = ACTIONS(602),
    [anon_sym_PIPE] = ACTIONS(602),
    [anon_sym_AMP] = ACTIONS(602),
    [anon_sym_CARET] = ACTIONS(602),
    [anon_sym_LT_LT] = ACTIONS(602),
    [anon_sym_LT] = ACTIONS(604),
    [anon_sym_LT_EQ] = ACTIONS(602),
    [anon_sym_EQ_EQ] = ACTIONS(602),
    [anon_sym_BANG_EQ] = ACTIONS(602),
    [anon_sym_GT_EQ] = ACTIONS(602),
    [anon_sym_GT] = ACTIONS(604),
    [anon_sym_LT_GT] = ACTIONS(602),
    [anon_sym_is] = ACTIONS(602),
    [anon_sym_LBRACK] = ACTIONS(602),
    [sym_comment] = ACTIONS(3),
  },
  [585] = {
    [anon_sym_DOT] = ACTIONS(630),
    [anon_sym_LPAREN] = ACTIONS(630),
    [anon_sym_COMMA] = ACTIONS(630),
    [anon_sym_as] = ACTIONS(630),
    [anon_sym_STAR] = ACTIONS(632),
    [anon_sym_GT_GT] = ACTIONS(630),
    [anon_sym_if] = ACTIONS(630),
    [anon_sym_COLON] = ACTIONS(630),
    [anon_sym_in] = ACTIONS(630),
    [anon_sym_STAR_STAR] = ACTIONS(630),
    [anon_sym_AT] = ACTIONS(630),
    [anon_sym_not] = ACTIONS(630),
    [anon_sym_and] = ACTIONS(630),
    [anon_sym_or] = ACTIONS(630),
    [anon_sym_PLUS] = ACTIONS(630),
    [anon_sym_DASH] = ACTIONS(630),
    [anon_sym_SLASH] = ACTIONS(632),
    [anon_sym_PERCENT] = ACTIONS(630),
    [anon_sym_SLASH_SLASH] = ACTIONS(630),
    [anon_sym_PIPE] = ACTIONS(630),
    [anon_sym_AMP] = ACTIONS(630),
    [anon_sym_CARET] = ACTIONS(630),
    [anon_sym_LT_LT] = ACTIONS(630),
    [anon_sym_LT] = ACTIONS(632),
    [anon_sym_LT_EQ] = ACTIONS(630),
    [anon_sym_EQ_EQ] = ACTIONS(630),
    [anon_sym_BANG_EQ] = ACTIONS(630),
    [anon_sym_GT_EQ] = ACTIONS(630),
    [anon_sym_GT] = ACTIONS(632),
    [anon_sym_LT_GT] = ACTIONS(630),
    [anon_sym_is] = ACTIONS(630),
    [anon_sym_LBRACK] = ACTIONS(630),
    [sym_comment] = ACTIONS(3),
  },
  [586] = {
    [anon_sym_DOT] = ACTIONS(680),
    [anon_sym_LPAREN] = ACTIONS(680),
    [anon_sym_COMMA] = ACTIONS(680),
    [anon_sym_as] = ACTIONS(680),
    [anon_sym_STAR] = ACTIONS(682),
    [anon_sym_GT_GT] = ACTIONS(680),
    [anon_sym_if] = ACTIONS(680),
    [anon_sym_COLON] = ACTIONS(680),
    [anon_sym_in] = ACTIONS(680),
    [anon_sym_STAR_STAR] = ACTIONS(680),
    [anon_sym_AT] = ACTIONS(680),
    [anon_sym_not] = ACTIONS(680),
    [anon_sym_and] = ACTIONS(680),
    [anon_sym_or] = ACTIONS(680),
    [anon_sym_PLUS] = ACTIONS(680),
    [anon_sym_DASH] = ACTIONS(680),
    [anon_sym_SLASH] = ACTIONS(682),
    [anon_sym_PERCENT] = ACTIONS(680),
    [anon_sym_SLASH_SLASH] = ACTIONS(680),
    [anon_sym_PIPE] = ACTIONS(680),
    [anon_sym_AMP] = ACTIONS(680),
    [anon_sym_CARET] = ACTIONS(680),
    [anon_sym_LT_LT] = ACTIONS(680),
    [anon_sym_LT] = ACTIONS(682),
    [anon_sym_LT_EQ] = ACTIONS(680),
    [anon_sym_EQ_EQ] = ACTIONS(680),
    [anon_sym_BANG_EQ] = ACTIONS(680),
    [anon_sym_GT_EQ] = ACTIONS(680),
    [anon_sym_GT] = ACTIONS(682),
    [anon_sym_LT_GT] = ACTIONS(680),
    [anon_sym_is] = ACTIONS(680),
    [anon_sym_LBRACK] = ACTIONS(680),
    [sym_comment] = ACTIONS(3),
  },
  [587] = {
    [anon_sym_DOT] = ACTIONS(536),
    [anon_sym_LPAREN] = ACTIONS(536),
    [anon_sym_COMMA] = ACTIONS(536),
    [anon_sym_as] = ACTIONS(536),
    [anon_sym_STAR] = ACTIONS(538),
    [anon_sym_GT_GT] = ACTIONS(536),
    [anon_sym_if] = ACTIONS(536),
    [anon_sym_COLON] = ACTIONS(536),
    [anon_sym_in] = ACTIONS(536),
    [anon_sym_STAR_STAR] = ACTIONS(536),
    [anon_sym_AT] = ACTIONS(536),
    [anon_sym_not] = ACTIONS(536),
    [anon_sym_and] = ACTIONS(536),
    [anon_sym_or] = ACTIONS(536),
    [anon_sym_PLUS] = ACTIONS(536),
    [anon_sym_DASH] = ACTIONS(536),
    [anon_sym_SLASH] = ACTIONS(538),
    [anon_sym_PERCENT] = ACTIONS(536),
    [anon_sym_SLASH_SLASH] = ACTIONS(536),
    [anon_sym_PIPE] = ACTIONS(536),
    [anon_sym_AMP] = ACTIONS(536),
    [anon_sym_CARET] = ACTIONS(536),
    [anon_sym_LT_LT] = ACTIONS(536),
    [anon_sym_LT] = ACTIONS(538),
    [anon_sym_LT_EQ] = ACTIONS(536),
    [anon_sym_EQ_EQ] = ACTIONS(536),
    [anon_sym_BANG_EQ] = ACTIONS(536),
    [anon_sym_GT_EQ] = ACTIONS(536),
    [anon_sym_GT] = ACTIONS(538),
    [anon_sym_LT_GT] = ACTIONS(536),
    [anon_sym_is] = ACTIONS(536),
    [anon_sym_LBRACK] = ACTIONS(536),
    [sym_comment] = ACTIONS(3),
  },
  [588] = {
    [anon_sym_DOT] = ACTIONS(650),
    [anon_sym_LPAREN] = ACTIONS(650),
    [anon_sym_COMMA] = ACTIONS(650),
    [anon_sym_as] = ACTIONS(650),
    [anon_sym_STAR] = ACTIONS(652),
    [anon_sym_GT_GT] = ACTIONS(650),
    [anon_sym_if] = ACTIONS(650),
    [anon_sym_COLON] = ACTIONS(650),
    [anon_sym_in] = ACTIONS(650),
    [anon_sym_STAR_STAR] = ACTIONS(650),
    [anon_sym_AT] = ACTIONS(650),
    [anon_sym_not] = ACTIONS(650),
    [anon_sym_and] = ACTIONS(650),
    [anon_sym_or] = ACTIONS(650),
    [anon_sym_PLUS] = ACTIONS(650),
    [anon_sym_DASH] = ACTIONS(650),
    [anon_sym_SLASH] = ACTIONS(652),
    [anon_sym_PERCENT] = ACTIONS(650),
    [anon_sym_SLASH_SLASH] = ACTIONS(650),
    [anon_sym_PIPE] = ACTIONS(650),
    [anon_sym_AMP] = ACTIONS(650),
    [anon_sym_CARET] = ACTIONS(650),
    [anon_sym_LT_LT] = ACTIONS(650),
    [anon_sym_LT] = ACTIONS(652),
    [anon_sym_LT_EQ] = ACTIONS(650),
    [anon_sym_EQ_EQ] = ACTIONS(650),
    [anon_sym_BANG_EQ] = ACTIONS(650),
    [anon_sym_GT_EQ] = ACTIONS(650),
    [anon_sym_GT] = ACTIONS(652),
    [anon_sym_LT_GT] = ACTIONS(650),
    [anon_sym_is] = ACTIONS(650),
    [anon_sym_LBRACK] = ACTIONS(650),
    [sym_comment] = ACTIONS(3),
  },
  [589] = {
    [anon_sym_DOT] = ACTIONS(574),
    [anon_sym_LPAREN] = ACTIONS(574),
    [anon_sym_COMMA] = ACTIONS(574),
    [anon_sym_as] = ACTIONS(574),
    [anon_sym_STAR] = ACTIONS(576),
    [anon_sym_GT_GT] = ACTIONS(574),
    [anon_sym_if] = ACTIONS(574),
    [anon_sym_COLON] = ACTIONS(574),
    [anon_sym_in] = ACTIONS(574),
    [anon_sym_STAR_STAR] = ACTIONS(574),
    [anon_sym_AT] = ACTIONS(574),
    [anon_sym_not] = ACTIONS(574),
    [anon_sym_and] = ACTIONS(574),
    [anon_sym_or] = ACTIONS(574),
    [anon_sym_PLUS] = ACTIONS(574),
    [anon_sym_DASH] = ACTIONS(574),
    [anon_sym_SLASH] = ACTIONS(576),
    [anon_sym_PERCENT] = ACTIONS(574),
    [anon_sym_SLASH_SLASH] = ACTIONS(574),
    [anon_sym_PIPE] = ACTIONS(574),
    [anon_sym_AMP] = ACTIONS(574),
    [anon_sym_CARET] = ACTIONS(574),
    [anon_sym_LT_LT] = ACTIONS(574),
    [anon_sym_LT] = ACTIONS(576),
    [anon_sym_LT_EQ] = ACTIONS(574),
    [anon_sym_EQ_EQ] = ACTIONS(574),
    [anon_sym_BANG_EQ] = ACTIONS(574),
    [anon_sym_GT_EQ] = ACTIONS(574),
    [anon_sym_GT] = ACTIONS(576),
    [anon_sym_LT_GT] = ACTIONS(574),
    [anon_sym_is] = ACTIONS(574),
    [anon_sym_LBRACK] = ACTIONS(574),
    [sym_comment] = ACTIONS(3),
  },
  [590] = {
    [anon_sym_DOT] = ACTIONS(598),
    [anon_sym_LPAREN] = ACTIONS(598),
    [anon_sym_COMMA] = ACTIONS(598),
    [anon_sym_as] = ACTIONS(598),
    [anon_sym_STAR] = ACTIONS(600),
    [anon_sym_GT_GT] = ACTIONS(598),
    [anon_sym_if] = ACTIONS(598),
    [anon_sym_COLON] = ACTIONS(598),
    [anon_sym_in] = ACTIONS(598),
    [anon_sym_STAR_STAR] = ACTIONS(598),
    [anon_sym_AT] = ACTIONS(598),
    [anon_sym_not] = ACTIONS(598),
    [anon_sym_and] = ACTIONS(598),
    [anon_sym_or] = ACTIONS(598),
    [anon_sym_PLUS] = ACTIONS(598),
    [anon_sym_DASH] = ACTIONS(598),
    [anon_sym_SLASH] = ACTIONS(600),
    [anon_sym_PERCENT] = ACTIONS(598),
    [anon_sym_SLASH_SLASH] = ACTIONS(598),
    [anon_sym_PIPE] = ACTIONS(598),
    [anon_sym_AMP] = ACTIONS(598),
    [anon_sym_CARET] = ACTIONS(598),
    [anon_sym_LT_LT] = ACTIONS(598),
    [anon_sym_LT] = ACTIONS(600),
    [anon_sym_LT_EQ] = ACTIONS(598),
    [anon_sym_EQ_EQ] = ACTIONS(598),
    [anon_sym_BANG_EQ] = ACTIONS(598),
    [anon_sym_GT_EQ] = ACTIONS(598),
    [anon_sym_GT] = ACTIONS(600),
    [anon_sym_LT_GT] = ACTIONS(598),
    [anon_sym_is] = ACTIONS(598),
    [anon_sym_LBRACK] = ACTIONS(598),
    [sym_comment] = ACTIONS(3),
  },
  [591] = {
    [anon_sym_DOT] = ACTIONS(522),
    [anon_sym_LPAREN] = ACTIONS(522),
    [anon_sym_COMMA] = ACTIONS(522),
    [anon_sym_as] = ACTIONS(522),
    [anon_sym_STAR] = ACTIONS(524),
    [anon_sym_GT_GT] = ACTIONS(522),
    [anon_sym_if] = ACTIONS(522),
    [anon_sym_COLON] = ACTIONS(522),
    [anon_sym_in] = ACTIONS(522),
    [anon_sym_STAR_STAR] = ACTIONS(522),
    [anon_sym_AT] = ACTIONS(522),
    [anon_sym_not] = ACTIONS(522),
    [anon_sym_and] = ACTIONS(522),
    [anon_sym_or] = ACTIONS(522),
    [anon_sym_PLUS] = ACTIONS(522),
    [anon_sym_DASH] = ACTIONS(522),
    [anon_sym_SLASH] = ACTIONS(524),
    [anon_sym_PERCENT] = ACTIONS(522),
    [anon_sym_SLASH_SLASH] = ACTIONS(522),
    [anon_sym_PIPE] = ACTIONS(522),
    [anon_sym_AMP] = ACTIONS(522),
    [anon_sym_CARET] = ACTIONS(522),
    [anon_sym_LT_LT] = ACTIONS(522),
    [anon_sym_LT] = ACTIONS(524),
    [anon_sym_LT_EQ] = ACTIONS(522),
    [anon_sym_EQ_EQ] = ACTIONS(522),
    [anon_sym_BANG_EQ] = ACTIONS(522),
    [anon_sym_GT_EQ] = ACTIONS(522),
    [anon_sym_GT] = ACTIONS(524),
    [anon_sym_LT_GT] = ACTIONS(522),
    [anon_sym_is] = ACTIONS(522),
    [anon_sym_LBRACK] = ACTIONS(522),
    [sym_comment] = ACTIONS(3),
  },
  [592] = {
    [anon_sym_DOT] = ACTIONS(642),
    [anon_sym_LPAREN] = ACTIONS(642),
    [anon_sym_COMMA] = ACTIONS(642),
    [anon_sym_as] = ACTIONS(642),
    [anon_sym_STAR] = ACTIONS(644),
    [anon_sym_GT_GT] = ACTIONS(642),
    [anon_sym_if] = ACTIONS(642),
    [anon_sym_COLON] = ACTIONS(642),
    [anon_sym_in] = ACTIONS(642),
    [anon_sym_STAR_STAR] = ACTIONS(642),
    [anon_sym_AT] = ACTIONS(642),
    [anon_sym_not] = ACTIONS(642),
    [anon_sym_and] = ACTIONS(642),
    [anon_sym_or] = ACTIONS(642),
    [anon_sym_PLUS] = ACTIONS(642),
    [anon_sym_DASH] = ACTIONS(642),
    [anon_sym_SLASH] = ACTIONS(644),
    [anon_sym_PERCENT] = ACTIONS(642),
    [anon_sym_SLASH_SLASH] = ACTIONS(642),
    [anon_sym_PIPE] = ACTIONS(642),
    [anon_sym_AMP] = ACTIONS(642),
    [anon_sym_CARET] = ACTIONS(642),
    [anon_sym_LT_LT] = ACTIONS(642),
    [anon_sym_LT] = ACTIONS(644),
    [anon_sym_LT_EQ] = ACTIONS(642),
    [anon_sym_EQ_EQ] = ACTIONS(642),
    [anon_sym_BANG_EQ] = ACTIONS(642),
    [anon_sym_GT_EQ] = ACTIONS(642),
    [anon_sym_GT] = ACTIONS(644),
    [anon_sym_LT_GT] = ACTIONS(642),
    [anon_sym_is] = ACTIONS(642),
    [anon_sym_LBRACK] = ACTIONS(642),
    [sym_comment] = ACTIONS(3),
  },
  [593] = {
    [anon_sym_DOT] = ACTIONS(618),
    [anon_sym_LPAREN] = ACTIONS(618),
    [anon_sym_COMMA] = ACTIONS(618),
    [anon_sym_as] = ACTIONS(618),
    [anon_sym_STAR] = ACTIONS(620),
    [anon_sym_GT_GT] = ACTIONS(618),
    [anon_sym_if] = ACTIONS(618),
    [anon_sym_COLON] = ACTIONS(618),
    [anon_sym_in] = ACTIONS(618),
    [anon_sym_STAR_STAR] = ACTIONS(618),
    [anon_sym_AT] = ACTIONS(618),
    [anon_sym_not] = ACTIONS(618),
    [anon_sym_and] = ACTIONS(618),
    [anon_sym_or] = ACTIONS(618),
    [anon_sym_PLUS] = ACTIONS(618),
    [anon_sym_DASH] = ACTIONS(618),
    [anon_sym_SLASH] = ACTIONS(620),
    [anon_sym_PERCENT] = ACTIONS(618),
    [anon_sym_SLASH_SLASH] = ACTIONS(618),
    [anon_sym_PIPE] = ACTIONS(618),
    [anon_sym_AMP] = ACTIONS(618),
    [anon_sym_CARET] = ACTIONS(618),
    [anon_sym_LT_LT] = ACTIONS(618),
    [anon_sym_LT] = ACTIONS(620),
    [anon_sym_LT_EQ] = ACTIONS(618),
    [anon_sym_EQ_EQ] = ACTIONS(618),
    [anon_sym_BANG_EQ] = ACTIONS(618),
    [anon_sym_GT_EQ] = ACTIONS(618),
    [anon_sym_GT] = ACTIONS(620),
    [anon_sym_LT_GT] = ACTIONS(618),
    [anon_sym_is] = ACTIONS(618),
    [anon_sym_LBRACK] = ACTIONS(618),
    [sym_comment] = ACTIONS(3),
  },
  [594] = {
    [anon_sym_DOT] = ACTIONS(540),
    [anon_sym_LPAREN] = ACTIONS(540),
    [anon_sym_COMMA] = ACTIONS(540),
    [anon_sym_as] = ACTIONS(540),
    [anon_sym_STAR] = ACTIONS(542),
    [anon_sym_GT_GT] = ACTIONS(540),
    [anon_sym_if] = ACTIONS(540),
    [anon_sym_COLON] = ACTIONS(540),
    [anon_sym_in] = ACTIONS(540),
    [anon_sym_STAR_STAR] = ACTIONS(540),
    [anon_sym_AT] = ACTIONS(540),
    [anon_sym_not] = ACTIONS(540),
    [anon_sym_and] = ACTIONS(540),
    [anon_sym_or] = ACTIONS(540),
    [anon_sym_PLUS] = ACTIONS(540),
    [anon_sym_DASH] = ACTIONS(540),
    [anon_sym_SLASH] = ACTIONS(542),
    [anon_sym_PERCENT] = ACTIONS(540),
    [anon_sym_SLASH_SLASH] = ACTIONS(540),
    [anon_sym_PIPE] = ACTIONS(540),
    [anon_sym_AMP] = ACTIONS(540),
    [anon_sym_CARET] = ACTIONS(540),
    [anon_sym_LT_LT] = ACTIONS(540),
    [anon_sym_LT] = ACTIONS(542),
    [anon_sym_LT_EQ] = ACTIONS(540),
    [anon_sym_EQ_EQ] = ACTIONS(540),
    [anon_sym_BANG_EQ] = ACTIONS(540),
    [anon_sym_GT_EQ] = ACTIONS(540),
    [anon_sym_GT] = ACTIONS(542),
    [anon_sym_LT_GT] = ACTIONS(540),
    [anon_sym_is] = ACTIONS(540),
    [anon_sym_LBRACK] = ACTIONS(540),
    [sym_comment] = ACTIONS(3),
  },
  [595] = {
    [anon_sym_DOT] = ACTIONS(582),
    [anon_sym_LPAREN] = ACTIONS(582),
    [anon_sym_COMMA] = ACTIONS(582),
    [anon_sym_as] = ACTIONS(582),
    [anon_sym_STAR] = ACTIONS(584),
    [anon_sym_GT_GT] = ACTIONS(582),
    [anon_sym_if] = ACTIONS(582),
    [anon_sym_COLON] = ACTIONS(582),
    [anon_sym_in] = ACTIONS(582),
    [anon_sym_STAR_STAR] = ACTIONS(582),
    [anon_sym_AT] = ACTIONS(582),
    [anon_sym_not] = ACTIONS(582),
    [anon_sym_and] = ACTIONS(582),
    [anon_sym_or] = ACTIONS(582),
    [anon_sym_PLUS] = ACTIONS(582),
    [anon_sym_DASH] = ACTIONS(582),
    [anon_sym_SLASH] = ACTIONS(584),
    [anon_sym_PERCENT] = ACTIONS(582),
    [anon_sym_SLASH_SLASH] = ACTIONS(582),
    [anon_sym_PIPE] = ACTIONS(582),
    [anon_sym_AMP] = ACTIONS(582),
    [anon_sym_CARET] = ACTIONS(582),
    [anon_sym_LT_LT] = ACTIONS(582),
    [anon_sym_LT] = ACTIONS(584),
    [anon_sym_LT_EQ] = ACTIONS(582),
    [anon_sym_EQ_EQ] = ACTIONS(582),
    [anon_sym_BANG_EQ] = ACTIONS(582),
    [anon_sym_GT_EQ] = ACTIONS(582),
    [anon_sym_GT] = ACTIONS(584),
    [anon_sym_LT_GT] = ACTIONS(582),
    [anon_sym_is] = ACTIONS(582),
    [anon_sym_LBRACK] = ACTIONS(582),
    [sym_comment] = ACTIONS(3),
  },
  [596] = {
    [anon_sym_DOT] = ACTIONS(658),
    [anon_sym_LPAREN] = ACTIONS(658),
    [anon_sym_COMMA] = ACTIONS(658),
    [anon_sym_as] = ACTIONS(658),
    [anon_sym_STAR] = ACTIONS(660),
    [anon_sym_GT_GT] = ACTIONS(658),
    [anon_sym_if] = ACTIONS(658),
    [anon_sym_COLON] = ACTIONS(658),
    [anon_sym_in] = ACTIONS(658),
    [anon_sym_STAR_STAR] = ACTIONS(658),
    [anon_sym_AT] = ACTIONS(658),
    [anon_sym_not] = ACTIONS(658),
    [anon_sym_and] = ACTIONS(658),
    [anon_sym_or] = ACTIONS(658),
    [anon_sym_PLUS] = ACTIONS(658),
    [anon_sym_DASH] = ACTIONS(658),
    [anon_sym_SLASH] = ACTIONS(660),
    [anon_sym_PERCENT] = ACTIONS(658),
    [anon_sym_SLASH_SLASH] = ACTIONS(658),
    [anon_sym_PIPE] = ACTIONS(658),
    [anon_sym_AMP] = ACTIONS(658),
    [anon_sym_CARET] = ACTIONS(658),
    [anon_sym_LT_LT] = ACTIONS(658),
    [anon_sym_LT] = ACTIONS(660),
    [anon_sym_LT_EQ] = ACTIONS(658),
    [anon_sym_EQ_EQ] = ACTIONS(658),
    [anon_sym_BANG_EQ] = ACTIONS(658),
    [anon_sym_GT_EQ] = ACTIONS(658),
    [anon_sym_GT] = ACTIONS(660),
    [anon_sym_LT_GT] = ACTIONS(658),
    [anon_sym_is] = ACTIONS(658),
    [anon_sym_LBRACK] = ACTIONS(658),
    [sym_comment] = ACTIONS(3),
  },
  [597] = {
    [aux_sym_comparison_operator_repeat1] = STATE(597),
    [anon_sym_RPAREN] = ACTIONS(498),
    [anon_sym_COMMA] = ACTIONS(498),
    [anon_sym_if] = ACTIONS(498),
    [anon_sym_COLON] = ACTIONS(498),
    [anon_sym_else] = ACTIONS(498),
    [anon_sym_async] = ACTIONS(498),
    [anon_sym_for] = ACTIONS(498),
    [anon_sym_in] = ACTIONS(1304),
    [anon_sym_EQ] = ACTIONS(500),
    [anon_sym_not] = ACTIONS(1307),
    [anon_sym_and] = ACTIONS(498),
    [anon_sym_or] = ACTIONS(498),
    [anon_sym_LT] = ACTIONS(1310),
    [anon_sym_LT_EQ] = ACTIONS(1304),
    [anon_sym_EQ_EQ] = ACTIONS(1304),
    [anon_sym_BANG_EQ] = ACTIONS(1304),
    [anon_sym_GT_EQ] = ACTIONS(1304),
    [anon_sym_GT] = ACTIONS(1310),
    [anon_sym_LT_GT] = ACTIONS(1304),
    [anon_sym_is] = ACTIONS(1313),
    [anon_sym_RBRACK] = ACTIONS(498),
    [anon_sym_RBRACE] = ACTIONS(498),
    [sym_type_conversion] = ACTIONS(498),
    [sym_comment] = ACTIONS(3),
  },
  [598] = {
    [aux_sym_comparison_operator_repeat1] = STATE(597),
    [anon_sym_RPAREN] = ACTIONS(1236),
    [anon_sym_COMMA] = ACTIONS(1236),
    [anon_sym_if] = ACTIONS(1236),
    [anon_sym_COLON] = ACTIONS(1236),
    [anon_sym_else] = ACTIONS(1236),
    [anon_sym_async] = ACTIONS(1236),
    [anon_sym_for] = ACTIONS(1236),
    [anon_sym_in] = ACTIONS(955),
    [anon_sym_EQ] = ACTIONS(1238),
    [anon_sym_not] = ACTIONS(961),
    [anon_sym_and] = ACTIONS(1236),
    [anon_sym_or] = ACTIONS(1236),
    [anon_sym_LT] = ACTIONS(971),
    [anon_sym_LT_EQ] = ACTIONS(955),
    [anon_sym_EQ_EQ] = ACTIONS(955),
    [anon_sym_BANG_EQ] = ACTIONS(955),
    [anon_sym_GT_EQ] = ACTIONS(955),
    [anon_sym_GT] = ACTIONS(971),
    [anon_sym_LT_GT] = ACTIONS(955),
    [anon_sym_is] = ACTIONS(973),
    [anon_sym_RBRACK] = ACTIONS(1236),
    [anon_sym_RBRACE] = ACTIONS(1236),
    [sym_type_conversion] = ACTIONS(1236),
    [sym_comment] = ACTIONS(3),
  },
  [599] = {
    [aux_sym_assert_statement_repeat1] = STATE(612),
    [anon_sym_from] = ACTIONS(1316),
    [anon_sym_COMMA] = ACTIONS(1318),
    [anon_sym_if] = ACTIONS(1320),
    [anon_sym_COLON] = ACTIONS(1316),
    [anon_sym_EQ] = ACTIONS(1316),
    [anon_sym_and] = ACTIONS(1322),
    [anon_sym_or] = ACTIONS(1324),
    [anon_sym_PLUS_EQ] = ACTIONS(1316),
    [anon_sym_DASH_EQ] = ACTIONS(1316),
    [anon_sym_STAR_EQ] = ACTIONS(1316),
    [anon_sym_SLASH_EQ] = ACTIONS(1316),
    [anon_sym_AT_EQ] = ACTIONS(1316),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(1316),
    [anon_sym_PERCENT_EQ] = ACTIONS(1316),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1316),
    [anon_sym_GT_GT_EQ] = ACTIONS(1316),
    [anon_sym_LT_LT_EQ] = ACTIONS(1316),
    [anon_sym_AMP_EQ] = ACTIONS(1316),
    [anon_sym_CARET_EQ] = ACTIONS(1316),
    [anon_sym_PIPE_EQ] = ACTIONS(1316),
    [sym_comment] = ACTIONS(3),
    [sym__semicolon] = ACTIONS(1316),
    [sym__newline] = ACTIONS(1316),
  },
  [600] = {
    [anon_sym_from] = ACTIONS(1326),
    [anon_sym_COMMA] = ACTIONS(1326),
    [anon_sym_if] = ACTIONS(1320),
    [anon_sym_COLON] = ACTIONS(1326),
    [anon_sym_EQ] = ACTIONS(1326),
    [anon_sym_and] = ACTIONS(1322),
    [anon_sym_or] = ACTIONS(1324),
    [anon_sym_PLUS_EQ] = ACTIONS(1326),
    [anon_sym_DASH_EQ] = ACTIONS(1326),
    [anon_sym_STAR_EQ] = ACTIONS(1326),
    [anon_sym_SLASH_EQ] = ACTIONS(1326),
    [anon_sym_AT_EQ] = ACTIONS(1326),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(1326),
    [anon_sym_PERCENT_EQ] = ACTIONS(1326),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1326),
    [anon_sym_GT_GT_EQ] = ACTIONS(1326),
    [anon_sym_LT_LT_EQ] = ACTIONS(1326),
    [anon_sym_AMP_EQ] = ACTIONS(1326),
    [anon_sym_CARET_EQ] = ACTIONS(1326),
    [anon_sym_PIPE_EQ] = ACTIONS(1326),
    [sym_comment] = ACTIONS(3),
    [sym__semicolon] = ACTIONS(1326),
    [sym__newline] = ACTIONS(1326),
  },
  [601] = {
    [aux_sym_assert_statement_repeat1] = STATE(614),
    [anon_sym_COMMA] = ACTIONS(1328),
    [anon_sym_if] = ACTIONS(1320),
    [anon_sym_COLON] = ACTIONS(1316),
    [anon_sym_EQ] = ACTIONS(1316),
    [anon_sym_and] = ACTIONS(1322),
    [anon_sym_or] = ACTIONS(1324),
    [anon_sym_PLUS_EQ] = ACTIONS(1316),
    [anon_sym_DASH_EQ] = ACTIONS(1316),
    [anon_sym_STAR_EQ] = ACTIONS(1316),
    [anon_sym_SLASH_EQ] = ACTIONS(1316),
    [anon_sym_AT_EQ] = ACTIONS(1316),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(1316),
    [anon_sym_PERCENT_EQ] = ACTIONS(1316),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1316),
    [anon_sym_GT_GT_EQ] = ACTIONS(1316),
    [anon_sym_LT_LT_EQ] = ACTIONS(1316),
    [anon_sym_AMP_EQ] = ACTIONS(1316),
    [anon_sym_CARET_EQ] = ACTIONS(1316),
    [anon_sym_PIPE_EQ] = ACTIONS(1316),
    [sym_comment] = ACTIONS(3),
    [sym__semicolon] = ACTIONS(1330),
    [sym__newline] = ACTIONS(1330),
  },
  [602] = {
    [anon_sym_from] = ACTIONS(1332),
    [anon_sym_COMMA] = ACTIONS(1332),
    [anon_sym_if] = ACTIONS(1332),
    [anon_sym_COLON] = ACTIONS(1332),
    [anon_sym_EQ] = ACTIONS(1332),
    [anon_sym_and] = ACTIONS(1322),
    [anon_sym_or] = ACTIONS(1324),
    [anon_sym_PLUS_EQ] = ACTIONS(1332),
    [anon_sym_DASH_EQ] = ACTIONS(1332),
    [anon_sym_STAR_EQ] = ACTIONS(1332),
    [anon_sym_SLASH_EQ] = ACTIONS(1332),
    [anon_sym_AT_EQ] = ACTIONS(1332),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(1332),
    [anon_sym_PERCENT_EQ] = ACTIONS(1332),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1332),
    [anon_sym_GT_GT_EQ] = ACTIONS(1332),
    [anon_sym_LT_LT_EQ] = ACTIONS(1332),
    [anon_sym_AMP_EQ] = ACTIONS(1332),
    [anon_sym_CARET_EQ] = ACTIONS(1332),
    [anon_sym_PIPE_EQ] = ACTIONS(1332),
    [sym_comment] = ACTIONS(3),
    [sym__semicolon] = ACTIONS(1332),
    [sym__newline] = ACTIONS(1332),
  },
  [603] = {
    [anon_sym_from] = ACTIONS(1334),
    [anon_sym_COMMA] = ACTIONS(1334),
    [anon_sym_if] = ACTIONS(1334),
    [anon_sym_COLON] = ACTIONS(1334),
    [anon_sym_EQ] = ACTIONS(1334),
    [anon_sym_and] = ACTIONS(1322),
    [anon_sym_or] = ACTIONS(1324),
    [anon_sym_PLUS_EQ] = ACTIONS(1334),
    [anon_sym_DASH_EQ] = ACTIONS(1334),
    [anon_sym_STAR_EQ] = ACTIONS(1334),
    [anon_sym_SLASH_EQ] = ACTIONS(1334),
    [anon_sym_AT_EQ] = ACTIONS(1334),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(1334),
    [anon_sym_PERCENT_EQ] = ACTIONS(1334),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1334),
    [anon_sym_GT_GT_EQ] = ACTIONS(1334),
    [anon_sym_LT_LT_EQ] = ACTIONS(1334),
    [anon_sym_AMP_EQ] = ACTIONS(1334),
    [anon_sym_CARET_EQ] = ACTIONS(1334),
    [anon_sym_PIPE_EQ] = ACTIONS(1334),
    [sym_comment] = ACTIONS(3),
    [sym__semicolon] = ACTIONS(1334),
    [sym__newline] = ACTIONS(1334),
  },
  [604] = {
    [anon_sym_from] = ACTIONS(1336),
    [anon_sym_COMMA] = ACTIONS(1336),
    [anon_sym_if] = ACTIONS(1320),
    [anon_sym_COLON] = ACTIONS(1336),
    [anon_sym_EQ] = ACTIONS(1336),
    [anon_sym_and] = ACTIONS(1322),
    [anon_sym_or] = ACTIONS(1324),
    [anon_sym_PLUS_EQ] = ACTIONS(1336),
    [anon_sym_DASH_EQ] = ACTIONS(1336),
    [anon_sym_STAR_EQ] = ACTIONS(1336),
    [anon_sym_SLASH_EQ] = ACTIONS(1336),
    [anon_sym_AT_EQ] = ACTIONS(1336),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(1336),
    [anon_sym_PERCENT_EQ] = ACTIONS(1336),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1336),
    [anon_sym_GT_GT_EQ] = ACTIONS(1336),
    [anon_sym_LT_LT_EQ] = ACTIONS(1336),
    [anon_sym_AMP_EQ] = ACTIONS(1336),
    [anon_sym_CARET_EQ] = ACTIONS(1336),
    [anon_sym_PIPE_EQ] = ACTIONS(1336),
    [sym_comment] = ACTIONS(3),
    [sym__semicolon] = ACTIONS(1336),
    [sym__newline] = ACTIONS(1336),
  },
  [605] = {
    [anon_sym_from] = ACTIONS(1338),
    [anon_sym_COMMA] = ACTIONS(1338),
    [anon_sym_if] = ACTIONS(1338),
    [anon_sym_COLON] = ACTIONS(1338),
    [anon_sym_EQ] = ACTIONS(1338),
    [anon_sym_and] = ACTIONS(1338),
    [anon_sym_or] = ACTIONS(1338),
    [anon_sym_PLUS_EQ] = ACTIONS(1338),
    [anon_sym_DASH_EQ] = ACTIONS(1338),
    [anon_sym_STAR_EQ] = ACTIONS(1338),
    [anon_sym_SLASH_EQ] = ACTIONS(1338),
    [anon_sym_AT_EQ] = ACTIONS(1338),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(1338),
    [anon_sym_PERCENT_EQ] = ACTIONS(1338),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1338),
    [anon_sym_GT_GT_EQ] = ACTIONS(1338),
    [anon_sym_LT_LT_EQ] = ACTIONS(1338),
    [anon_sym_AMP_EQ] = ACTIONS(1338),
    [anon_sym_CARET_EQ] = ACTIONS(1338),
    [anon_sym_PIPE_EQ] = ACTIONS(1338),
    [sym_comment] = ACTIONS(3),
    [sym__semicolon] = ACTIONS(1338),
    [sym__newline] = ACTIONS(1338),
  },
  [606] = {
    [anon_sym_from] = ACTIONS(1340),
    [anon_sym_COMMA] = ACTIONS(1340),
    [anon_sym_if] = ACTIONS(1320),
    [anon_sym_COLON] = ACTIONS(1340),
    [anon_sym_EQ] = ACTIONS(1340),
    [anon_sym_and] = ACTIONS(1322),
    [anon_sym_or] = ACTIONS(1324),
    [anon_sym_PLUS_EQ] = ACTIONS(1340),
    [anon_sym_DASH_EQ] = ACTIONS(1340),
    [anon_sym_STAR_EQ] = ACTIONS(1340),
    [anon_sym_SLASH_EQ] = ACTIONS(1340),
    [anon_sym_AT_EQ] = ACTIONS(1340),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(1340),
    [anon_sym_PERCENT_EQ] = ACTIONS(1340),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1340),
    [anon_sym_GT_GT_EQ] = ACTIONS(1340),
    [anon_sym_LT_LT_EQ] = ACTIONS(1340),
    [anon_sym_AMP_EQ] = ACTIONS(1340),
    [anon_sym_CARET_EQ] = ACTIONS(1340),
    [anon_sym_PIPE_EQ] = ACTIONS(1340),
    [sym_comment] = ACTIONS(3),
    [sym__semicolon] = ACTIONS(1340),
    [sym__newline] = ACTIONS(1340),
  },
  [607] = {
    [anon_sym_from] = ACTIONS(1342),
    [anon_sym_COMMA] = ACTIONS(1342),
    [anon_sym_if] = ACTIONS(1320),
    [anon_sym_COLON] = ACTIONS(1342),
    [anon_sym_EQ] = ACTIONS(1342),
    [anon_sym_and] = ACTIONS(1322),
    [anon_sym_or] = ACTIONS(1324),
    [anon_sym_PLUS_EQ] = ACTIONS(1342),
    [anon_sym_DASH_EQ] = ACTIONS(1342),
    [anon_sym_STAR_EQ] = ACTIONS(1342),
    [anon_sym_SLASH_EQ] = ACTIONS(1342),
    [anon_sym_AT_EQ] = ACTIONS(1342),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(1342),
    [anon_sym_PERCENT_EQ] = ACTIONS(1342),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1342),
    [anon_sym_GT_GT_EQ] = ACTIONS(1342),
    [anon_sym_LT_LT_EQ] = ACTIONS(1342),
    [anon_sym_AMP_EQ] = ACTIONS(1342),
    [anon_sym_CARET_EQ] = ACTIONS(1342),
    [anon_sym_PIPE_EQ] = ACTIONS(1342),
    [sym_comment] = ACTIONS(3),
    [sym__semicolon] = ACTIONS(1342),
    [sym__newline] = ACTIONS(1342),
  },
  [608] = {
    [anon_sym_from] = ACTIONS(1344),
    [anon_sym_COMMA] = ACTIONS(1344),
    [anon_sym_if] = ACTIONS(1344),
    [anon_sym_COLON] = ACTIONS(1344),
    [anon_sym_EQ] = ACTIONS(1344),
    [anon_sym_and] = ACTIONS(1322),
    [anon_sym_or] = ACTIONS(1344),
    [anon_sym_PLUS_EQ] = ACTIONS(1344),
    [anon_sym_DASH_EQ] = ACTIONS(1344),
    [anon_sym_STAR_EQ] = ACTIONS(1344),
    [anon_sym_SLASH_EQ] = ACTIONS(1344),
    [anon_sym_AT_EQ] = ACTIONS(1344),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(1344),
    [anon_sym_PERCENT_EQ] = ACTIONS(1344),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1344),
    [anon_sym_GT_GT_EQ] = ACTIONS(1344),
    [anon_sym_LT_LT_EQ] = ACTIONS(1344),
    [anon_sym_AMP_EQ] = ACTIONS(1344),
    [anon_sym_CARET_EQ] = ACTIONS(1344),
    [anon_sym_PIPE_EQ] = ACTIONS(1344),
    [sym_comment] = ACTIONS(3),
    [sym__semicolon] = ACTIONS(1344),
    [sym__newline] = ACTIONS(1344),
  },
  [609] = {
    [anon_sym_from] = ACTIONS(1344),
    [anon_sym_COMMA] = ACTIONS(1344),
    [anon_sym_if] = ACTIONS(1344),
    [anon_sym_COLON] = ACTIONS(1344),
    [anon_sym_EQ] = ACTIONS(1344),
    [anon_sym_and] = ACTIONS(1344),
    [anon_sym_or] = ACTIONS(1344),
    [anon_sym_PLUS_EQ] = ACTIONS(1344),
    [anon_sym_DASH_EQ] = ACTIONS(1344),
    [anon_sym_STAR_EQ] = ACTIONS(1344),
    [anon_sym_SLASH_EQ] = ACTIONS(1344),
    [anon_sym_AT_EQ] = ACTIONS(1344),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(1344),
    [anon_sym_PERCENT_EQ] = ACTIONS(1344),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1344),
    [anon_sym_GT_GT_EQ] = ACTIONS(1344),
    [anon_sym_LT_LT_EQ] = ACTIONS(1344),
    [anon_sym_AMP_EQ] = ACTIONS(1344),
    [anon_sym_CARET_EQ] = ACTIONS(1344),
    [anon_sym_PIPE_EQ] = ACTIONS(1344),
    [sym_comment] = ACTIONS(3),
    [sym__semicolon] = ACTIONS(1344),
    [sym__newline] = ACTIONS(1344),
  },
  [610] = {
    [sym_argument_list] = STATE(474),
    [sym_generator_expression] = STATE(474),
    [aux_sym_variables_repeat1] = STATE(907),
    [anon_sym_DOT] = ACTIONS(947),
    [anon_sym_LPAREN] = ACTIONS(949),
    [anon_sym_COMMA] = ACTIONS(1346),
    [anon_sym_STAR] = ACTIONS(951),
    [anon_sym_GT_GT] = ACTIONS(953),
    [anon_sym_in] = ACTIONS(1348),
    [anon_sym_STAR_STAR] = ACTIONS(957),
    [anon_sym_AT] = ACTIONS(959),
    [anon_sym_PLUS] = ACTIONS(963),
    [anon_sym_DASH] = ACTIONS(963),
    [anon_sym_SLASH] = ACTIONS(951),
    [anon_sym_PERCENT] = ACTIONS(959),
    [anon_sym_SLASH_SLASH] = ACTIONS(959),
    [anon_sym_PIPE] = ACTIONS(965),
    [anon_sym_AMP] = ACTIONS(967),
    [anon_sym_CARET] = ACTIONS(969),
    [anon_sym_LT_LT] = ACTIONS(953),
    [anon_sym_LBRACK] = ACTIONS(975),
    [sym_comment] = ACTIONS(3),
  },
  [611] = {
    [sym_argument_list] = STATE(474),
    [sym_generator_expression] = STATE(474),
    [anon_sym_DOT] = ACTIONS(947),
    [anon_sym_LPAREN] = ACTIONS(949),
    [anon_sym_COMMA] = ACTIONS(1350),
    [anon_sym_STAR] = ACTIONS(951),
    [anon_sym_GT_GT] = ACTIONS(953),
    [anon_sym_in] = ACTIONS(1350),
    [anon_sym_STAR_STAR] = ACTIONS(957),
    [anon_sym_AT] = ACTIONS(959),
    [anon_sym_PLUS] = ACTIONS(963),
    [anon_sym_DASH] = ACTIONS(963),
    [anon_sym_SLASH] = ACTIONS(951),
    [anon_sym_PERCENT] = ACTIONS(959),
    [anon_sym_SLASH_SLASH] = ACTIONS(959),
    [anon_sym_PIPE] = ACTIONS(965),
    [anon_sym_AMP] = ACTIONS(967),
    [anon_sym_CARET] = ACTIONS(969),
    [anon_sym_LT_LT] = ACTIONS(953),
    [anon_sym_LBRACK] = ACTIONS(975),
    [sym_comment] = ACTIONS(3),
  },
  [612] = {
    [aux_sym_assert_statement_repeat1] = STATE(613),
    [anon_sym_from] = ACTIONS(341),
    [anon_sym_COMMA] = ACTIONS(1352),
    [anon_sym_COLON] = ACTIONS(341),
    [anon_sym_EQ] = ACTIONS(341),
    [anon_sym_PLUS_EQ] = ACTIONS(341),
    [anon_sym_DASH_EQ] = ACTIONS(341),
    [anon_sym_STAR_EQ] = ACTIONS(341),
    [anon_sym_SLASH_EQ] = ACTIONS(341),
    [anon_sym_AT_EQ] = ACTIONS(341),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(341),
    [anon_sym_PERCENT_EQ] = ACTIONS(341),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(341),
    [anon_sym_GT_GT_EQ] = ACTIONS(341),
    [anon_sym_LT_LT_EQ] = ACTIONS(341),
    [anon_sym_AMP_EQ] = ACTIONS(341),
    [anon_sym_CARET_EQ] = ACTIONS(341),
    [anon_sym_PIPE_EQ] = ACTIONS(341),
    [sym_comment] = ACTIONS(3),
    [sym__semicolon] = ACTIONS(341),
    [sym__newline] = ACTIONS(341),
  },
  [613] = {
    [aux_sym_assert_statement_repeat1] = STATE(613),
    [anon_sym_from] = ACTIONS(1326),
    [anon_sym_COMMA] = ACTIONS(1354),
    [anon_sym_COLON] = ACTIONS(1326),
    [anon_sym_EQ] = ACTIONS(1326),
    [anon_sym_PLUS_EQ] = ACTIONS(1326),
    [anon_sym_DASH_EQ] = ACTIONS(1326),
    [anon_sym_STAR_EQ] = ACTIONS(1326),
    [anon_sym_SLASH_EQ] = ACTIONS(1326),
    [anon_sym_AT_EQ] = ACTIONS(1326),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(1326),
    [anon_sym_PERCENT_EQ] = ACTIONS(1326),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1326),
    [anon_sym_GT_GT_EQ] = ACTIONS(1326),
    [anon_sym_LT_LT_EQ] = ACTIONS(1326),
    [anon_sym_AMP_EQ] = ACTIONS(1326),
    [anon_sym_CARET_EQ] = ACTIONS(1326),
    [anon_sym_PIPE_EQ] = ACTIONS(1326),
    [sym_comment] = ACTIONS(3),
    [sym__semicolon] = ACTIONS(1326),
    [sym__newline] = ACTIONS(1326),
  },
  [614] = {
    [aux_sym_assert_statement_repeat1] = STATE(613),
    [anon_sym_COMMA] = ACTIONS(1357),
    [anon_sym_COLON] = ACTIONS(341),
    [anon_sym_EQ] = ACTIONS(341),
    [anon_sym_PLUS_EQ] = ACTIONS(341),
    [anon_sym_DASH_EQ] = ACTIONS(341),
    [anon_sym_STAR_EQ] = ACTIONS(341),
    [anon_sym_SLASH_EQ] = ACTIONS(341),
    [anon_sym_AT_EQ] = ACTIONS(341),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(341),
    [anon_sym_PERCENT_EQ] = ACTIONS(341),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(341),
    [anon_sym_GT_GT_EQ] = ACTIONS(341),
    [anon_sym_LT_LT_EQ] = ACTIONS(341),
    [anon_sym_AMP_EQ] = ACTIONS(341),
    [anon_sym_CARET_EQ] = ACTIONS(341),
    [anon_sym_PIPE_EQ] = ACTIONS(341),
    [sym_comment] = ACTIONS(3),
    [sym__semicolon] = ACTIONS(343),
    [sym__newline] = ACTIONS(343),
  },
  [615] = {
    [anon_sym_COLON] = ACTIONS(1359),
    [anon_sym_EQ] = ACTIONS(1361),
    [anon_sym_PLUS_EQ] = ACTIONS(1363),
    [anon_sym_DASH_EQ] = ACTIONS(1363),
    [anon_sym_STAR_EQ] = ACTIONS(1363),
    [anon_sym_SLASH_EQ] = ACTIONS(1363),
    [anon_sym_AT_EQ] = ACTIONS(1363),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(1363),
    [anon_sym_PERCENT_EQ] = ACTIONS(1363),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1363),
    [anon_sym_GT_GT_EQ] = ACTIONS(1363),
    [anon_sym_LT_LT_EQ] = ACTIONS(1363),
    [anon_sym_AMP_EQ] = ACTIONS(1363),
    [anon_sym_CARET_EQ] = ACTIONS(1363),
    [anon_sym_PIPE_EQ] = ACTIONS(1363),
    [sym_comment] = ACTIONS(3),
    [sym__semicolon] = ACTIONS(1365),
    [sym__newline] = ACTIONS(1365),
  },
  [616] = {
    [aux_sym_comparison_operator_repeat1] = STATE(617),
    [anon_sym_COMMA] = ACTIONS(1236),
    [anon_sym_as] = ACTIONS(1236),
    [anon_sym_if] = ACTIONS(1236),
    [anon_sym_COLON] = ACTIONS(1236),
    [anon_sym_in] = ACTIONS(1119),
    [anon_sym_not] = ACTIONS(1125),
    [anon_sym_and] = ACTIONS(1236),
    [anon_sym_or] = ACTIONS(1236),
    [anon_sym_LT] = ACTIONS(1135),
    [anon_sym_LT_EQ] = ACTIONS(1119),
    [anon_sym_EQ_EQ] = ACTIONS(1119),
    [anon_sym_BANG_EQ] = ACTIONS(1119),
    [anon_sym_GT_EQ] = ACTIONS(1119),
    [anon_sym_GT] = ACTIONS(1135),
    [anon_sym_LT_GT] = ACTIONS(1119),
    [anon_sym_is] = ACTIONS(1137),
    [sym_comment] = ACTIONS(3),
  },
  [617] = {
    [aux_sym_comparison_operator_repeat1] = STATE(617),
    [anon_sym_COMMA] = ACTIONS(498),
    [anon_sym_as] = ACTIONS(498),
    [anon_sym_if] = ACTIONS(498),
    [anon_sym_COLON] = ACTIONS(498),
    [anon_sym_in] = ACTIONS(1367),
    [anon_sym_not] = ACTIONS(1370),
    [anon_sym_and] = ACTIONS(498),
    [anon_sym_or] = ACTIONS(498),
    [anon_sym_LT] = ACTIONS(1373),
    [anon_sym_LT_EQ] = ACTIONS(1367),
    [anon_sym_EQ_EQ] = ACTIONS(1367),
    [anon_sym_BANG_EQ] = ACTIONS(1367),
    [anon_sym_GT_EQ] = ACTIONS(1367),
    [anon_sym_GT] = ACTIONS(1373),
    [anon_sym_LT_GT] = ACTIONS(1367),
    [anon_sym_is] = ACTIONS(1376),
    [sym_comment] = ACTIONS(3),
  },
  [618] = {
    [anon_sym_COLON] = ACTIONS(1359),
    [anon_sym_EQ] = ACTIONS(1361),
    [anon_sym_PLUS_EQ] = ACTIONS(1363),
    [anon_sym_DASH_EQ] = ACTIONS(1363),
    [anon_sym_STAR_EQ] = ACTIONS(1363),
    [anon_sym_SLASH_EQ] = ACTIONS(1363),
    [anon_sym_AT_EQ] = ACTIONS(1363),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(1363),
    [anon_sym_PERCENT_EQ] = ACTIONS(1363),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1363),
    [anon_sym_GT_GT_EQ] = ACTIONS(1363),
    [anon_sym_LT_LT_EQ] = ACTIONS(1363),
    [anon_sym_AMP_EQ] = ACTIONS(1363),
    [anon_sym_CARET_EQ] = ACTIONS(1363),
    [anon_sym_PIPE_EQ] = ACTIONS(1363),
    [sym_comment] = ACTIONS(3),
  },
  [619] = {
    [sym_lambda_parameters] = STATE(971),
    [sym__parameters] = STATE(972),
    [sym_default_parameter] = STATE(906),
    [sym_typed_default_parameter] = STATE(906),
    [sym_list_splat] = STATE(905),
    [sym_dictionary_splat] = STATE(905),
    [sym_typed_parameter] = STATE(906),
    [sym_tuple] = STATE(906),
    [sym_identifier] = ACTIONS(1379),
    [anon_sym_LPAREN] = ACTIONS(1381),
    [anon_sym_STAR] = ACTIONS(1383),
    [anon_sym_print] = ACTIONS(1385),
    [anon_sym_COLON] = ACTIONS(1387),
    [anon_sym_STAR_STAR] = ACTIONS(359),
    [anon_sym_exec] = ACTIONS(1385),
    [sym_comment] = ACTIONS(3),
  },
  [620] = {
    [sym_lambda_parameters] = STATE(978),
    [sym__parameters] = STATE(972),
    [sym_default_parameter] = STATE(906),
    [sym_typed_default_parameter] = STATE(906),
    [sym_list_splat] = STATE(905),
    [sym_dictionary_splat] = STATE(905),
    [sym_typed_parameter] = STATE(906),
    [sym_tuple] = STATE(906),
    [sym_identifier] = ACTIONS(1379),
    [anon_sym_LPAREN] = ACTIONS(1381),
    [anon_sym_STAR] = ACTIONS(1383),
    [anon_sym_print] = ACTIONS(1385),
    [anon_sym_COLON] = ACTIONS(1389),
    [anon_sym_STAR_STAR] = ACTIONS(359),
    [anon_sym_exec] = ACTIONS(1385),
    [sym_comment] = ACTIONS(3),
  },
  [621] = {
    [sym_lambda_parameters] = STATE(992),
    [sym__parameters] = STATE(972),
    [sym_default_parameter] = STATE(906),
    [sym_typed_default_parameter] = STATE(906),
    [sym_list_splat] = STATE(905),
    [sym_dictionary_splat] = STATE(905),
    [sym_typed_parameter] = STATE(906),
    [sym_tuple] = STATE(906),
    [sym_identifier] = ACTIONS(1379),
    [anon_sym_LPAREN] = ACTIONS(1381),
    [anon_sym_STAR] = ACTIONS(1383),
    [anon_sym_print] = ACTIONS(1385),
    [anon_sym_COLON] = ACTIONS(1391),
    [anon_sym_STAR_STAR] = ACTIONS(359),
    [anon_sym_exec] = ACTIONS(1385),
    [sym_comment] = ACTIONS(3),
  },
  [622] = {
    [sym_lambda_parameters] = STATE(961),
    [sym__parameters] = STATE(972),
    [sym_default_parameter] = STATE(906),
    [sym_typed_default_parameter] = STATE(906),
    [sym_list_splat] = STATE(905),
    [sym_dictionary_splat] = STATE(905),
    [sym_typed_parameter] = STATE(906),
    [sym_tuple] = STATE(906),
    [sym_identifier] = ACTIONS(1379),
    [anon_sym_LPAREN] = ACTIONS(1381),
    [anon_sym_STAR] = ACTIONS(1383),
    [anon_sym_print] = ACTIONS(1385),
    [anon_sym_COLON] = ACTIONS(1393),
    [anon_sym_STAR_STAR] = ACTIONS(359),
    [anon_sym_exec] = ACTIONS(1385),
    [sym_comment] = ACTIONS(3),
  },
  [623] = {
    [sym__parameters] = STATE(1026),
    [sym_default_parameter] = STATE(823),
    [sym_typed_default_parameter] = STATE(823),
    [sym_list_splat] = STATE(769),
    [sym_dictionary_splat] = STATE(769),
    [sym_typed_parameter] = STATE(823),
    [sym_tuple] = STATE(823),
    [sym_identifier] = ACTIONS(1395),
    [anon_sym_LPAREN] = ACTIONS(1381),
    [anon_sym_RPAREN] = ACTIONS(1397),
    [anon_sym_STAR] = ACTIONS(1399),
    [anon_sym_print] = ACTIONS(1401),
    [anon_sym_STAR_STAR] = ACTIONS(359),
    [anon_sym_exec] = ACTIONS(1401),
    [sym_comment] = ACTIONS(3),
  },
  [624] = {
    [sym_default_parameter] = STATE(870),
    [sym_typed_default_parameter] = STATE(870),
    [sym_list_splat] = STATE(930),
    [sym_dictionary_splat] = STATE(930),
    [sym_typed_parameter] = STATE(870),
    [sym_tuple] = STATE(870),
    [sym_identifier] = ACTIONS(1403),
    [anon_sym_LPAREN] = ACTIONS(1381),
    [anon_sym_STAR] = ACTIONS(1405),
    [anon_sym_print] = ACTIONS(1407),
    [anon_sym_COLON] = ACTIONS(1409),
    [anon_sym_STAR_STAR] = ACTIONS(359),
    [anon_sym_exec] = ACTIONS(1407),
    [sym_comment] = ACTIONS(3),
  },
  [625] = {
    [sym_default_parameter] = STATE(870),
    [sym_typed_default_parameter] = STATE(870),
    [sym_list_splat] = STATE(847),
    [sym_dictionary_splat] = STATE(847),
    [sym_typed_parameter] = STATE(870),
    [sym_tuple] = STATE(870),
    [sym_identifier] = ACTIONS(1411),
    [anon_sym_LPAREN] = ACTIONS(1381),
    [anon_sym_RPAREN] = ACTIONS(1413),
    [anon_sym_STAR] = ACTIONS(1405),
    [anon_sym_print] = ACTIONS(1415),
    [anon_sym_STAR_STAR] = ACTIONS(359),
    [anon_sym_exec] = ACTIONS(1415),
    [sym_comment] = ACTIONS(3),
  },
  [626] = {
    [anon_sym_RPAREN] = ACTIONS(1344),
    [anon_sym_COMMA] = ACTIONS(1344),
    [anon_sym_if] = ACTIONS(1344),
    [anon_sym_COLON] = ACTIONS(1344),
    [anon_sym_else] = ACTIONS(1344),
    [anon_sym_async] = ACTIONS(1344),
    [anon_sym_for] = ACTIONS(1344),
    [anon_sym_EQ] = ACTIONS(1344),
    [anon_sym_and] = ACTIONS(1344),
    [anon_sym_or] = ACTIONS(1344),
    [anon_sym_RBRACK] = ACTIONS(1344),
    [anon_sym_RBRACE] = ACTIONS(1344),
    [sym_type_conversion] = ACTIONS(1344),
    [sym_comment] = ACTIONS(3),
  },
  [627] = {
    [anon_sym_RPAREN] = ACTIONS(1332),
    [anon_sym_COMMA] = ACTIONS(1332),
    [anon_sym_if] = ACTIONS(1332),
    [anon_sym_COLON] = ACTIONS(1332),
    [anon_sym_else] = ACTIONS(1332),
    [anon_sym_async] = ACTIONS(1332),
    [anon_sym_for] = ACTIONS(1332),
    [anon_sym_EQ] = ACTIONS(1332),
    [anon_sym_and] = ACTIONS(1417),
    [anon_sym_or] = ACTIONS(1419),
    [anon_sym_RBRACK] = ACTIONS(1332),
    [anon_sym_RBRACE] = ACTIONS(1332),
    [sym_type_conversion] = ACTIONS(1332),
    [sym_comment] = ACTIONS(3),
  },
  [628] = {
    [anon_sym_RPAREN] = ACTIONS(1336),
    [anon_sym_COMMA] = ACTIONS(1336),
    [anon_sym_if] = ACTIONS(1421),
    [anon_sym_COLON] = ACTIONS(1336),
    [anon_sym_else] = ACTIONS(1336),
    [anon_sym_async] = ACTIONS(1336),
    [anon_sym_for] = ACTIONS(1336),
    [anon_sym_EQ] = ACTIONS(1336),
    [anon_sym_and] = ACTIONS(1417),
    [anon_sym_or] = ACTIONS(1419),
    [anon_sym_RBRACK] = ACTIONS(1336),
    [anon_sym_RBRACE] = ACTIONS(1336),
    [sym_type_conversion] = ACTIONS(1336),
    [sym_comment] = ACTIONS(3),
  },
  [629] = {
    [sym_default_parameter] = STATE(870),
    [sym_typed_default_parameter] = STATE(870),
    [sym_list_splat] = STATE(847),
    [sym_dictionary_splat] = STATE(847),
    [sym_typed_parameter] = STATE(870),
    [sym_tuple] = STATE(870),
    [sym_identifier] = ACTIONS(1411),
    [anon_sym_LPAREN] = ACTIONS(1381),
    [anon_sym_RPAREN] = ACTIONS(1423),
    [anon_sym_STAR] = ACTIONS(1405),
    [anon_sym_print] = ACTIONS(1415),
    [anon_sym_STAR_STAR] = ACTIONS(359),
    [anon_sym_exec] = ACTIONS(1415),
    [sym_comment] = ACTIONS(3),
  },
  [630] = {
    [sym_default_parameter] = STATE(870),
    [sym_typed_default_parameter] = STATE(870),
    [sym_list_splat] = STATE(847),
    [sym_dictionary_splat] = STATE(847),
    [sym_typed_parameter] = STATE(870),
    [sym_tuple] = STATE(870),
    [sym_identifier] = ACTIONS(1411),
    [anon_sym_LPAREN] = ACTIONS(1381),
    [anon_sym_RPAREN] = ACTIONS(1409),
    [anon_sym_STAR] = ACTIONS(1405),
    [anon_sym_print] = ACTIONS(1415),
    [anon_sym_STAR_STAR] = ACTIONS(359),
    [anon_sym_exec] = ACTIONS(1415),
    [sym_comment] = ACTIONS(3),
  },
  [631] = {
    [sym_default_parameter] = STATE(870),
    [sym_typed_default_parameter] = STATE(870),
    [sym_list_splat] = STATE(847),
    [sym_dictionary_splat] = STATE(847),
    [sym_typed_parameter] = STATE(870),
    [sym_tuple] = STATE(870),
    [sym_identifier] = ACTIONS(1411),
    [anon_sym_LPAREN] = ACTIONS(1381),
    [anon_sym_RPAREN] = ACTIONS(1425),
    [anon_sym_STAR] = ACTIONS(1405),
    [anon_sym_print] = ACTIONS(1415),
    [anon_sym_STAR_STAR] = ACTIONS(359),
    [anon_sym_exec] = ACTIONS(1415),
    [sym_comment] = ACTIONS(3),
  },
  [632] = {
    [sym_default_parameter] = STATE(870),
    [sym_typed_default_parameter] = STATE(870),
    [sym_list_splat] = STATE(930),
    [sym_dictionary_splat] = STATE(930),
    [sym_typed_parameter] = STATE(870),
    [sym_tuple] = STATE(870),
    [sym_identifier] = ACTIONS(1403),
    [anon_sym_LPAREN] = ACTIONS(1381),
    [anon_sym_STAR] = ACTIONS(1405),
    [anon_sym_print] = ACTIONS(1407),
    [anon_sym_COLON] = ACTIONS(1425),
    [anon_sym_STAR_STAR] = ACTIONS(359),
    [anon_sym_exec] = ACTIONS(1407),
    [sym_comment] = ACTIONS(3),
  },
  [633] = {
    [anon_sym_RPAREN] = ACTIONS(1342),
    [anon_sym_COMMA] = ACTIONS(1342),
    [anon_sym_if] = ACTIONS(1421),
    [anon_sym_COLON] = ACTIONS(1342),
    [anon_sym_else] = ACTIONS(1342),
    [anon_sym_async] = ACTIONS(1342),
    [anon_sym_for] = ACTIONS(1342),
    [anon_sym_EQ] = ACTIONS(1342),
    [anon_sym_and] = ACTIONS(1417),
    [anon_sym_or] = ACTIONS(1419),
    [anon_sym_RBRACK] = ACTIONS(1342),
    [anon_sym_RBRACE] = ACTIONS(1342),
    [sym_type_conversion] = ACTIONS(1342),
    [sym_comment] = ACTIONS(3),
  },
  [634] = {
    [sym_default_parameter] = STATE(870),
    [sym_typed_default_parameter] = STATE(870),
    [sym_list_splat] = STATE(847),
    [sym_dictionary_splat] = STATE(847),
    [sym_typed_parameter] = STATE(870),
    [sym_tuple] = STATE(870),
    [sym_identifier] = ACTIONS(1411),
    [anon_sym_LPAREN] = ACTIONS(1381),
    [anon_sym_RPAREN] = ACTIONS(1427),
    [anon_sym_STAR] = ACTIONS(1405),
    [anon_sym_print] = ACTIONS(1415),
    [anon_sym_STAR_STAR] = ACTIONS(359),
    [anon_sym_exec] = ACTIONS(1415),
    [sym_comment] = ACTIONS(3),
  },
  [635] = {
    [sym_default_parameter] = STATE(870),
    [sym_typed_default_parameter] = STATE(870),
    [sym_list_splat] = STATE(930),
    [sym_dictionary_splat] = STATE(930),
    [sym_typed_parameter] = STATE(870),
    [sym_tuple] = STATE(870),
    [sym_identifier] = ACTIONS(1403),
    [anon_sym_LPAREN] = ACTIONS(1381),
    [anon_sym_STAR] = ACTIONS(1405),
    [anon_sym_print] = ACTIONS(1407),
    [anon_sym_COLON] = ACTIONS(1427),
    [anon_sym_STAR_STAR] = ACTIONS(359),
    [anon_sym_exec] = ACTIONS(1407),
    [sym_comment] = ACTIONS(3),
  },
  [636] = {
    [anon_sym_RPAREN] = ACTIONS(1340),
    [anon_sym_COMMA] = ACTIONS(1340),
    [anon_sym_if] = ACTIONS(1421),
    [anon_sym_COLON] = ACTIONS(1340),
    [anon_sym_else] = ACTIONS(1340),
    [anon_sym_async] = ACTIONS(1340),
    [anon_sym_for] = ACTIONS(1340),
    [anon_sym_EQ] = ACTIONS(1340),
    [anon_sym_and] = ACTIONS(1417),
    [anon_sym_or] = ACTIONS(1419),
    [anon_sym_RBRACK] = ACTIONS(1340),
    [anon_sym_RBRACE] = ACTIONS(1340),
    [sym_type_conversion] = ACTIONS(1340),
    [sym_comment] = ACTIONS(3),
  },
  [637] = {
    [anon_sym_RPAREN] = ACTIONS(1334),
    [anon_sym_COMMA] = ACTIONS(1334),
    [anon_sym_if] = ACTIONS(1334),
    [anon_sym_COLON] = ACTIONS(1334),
    [anon_sym_else] = ACTIONS(1334),
    [anon_sym_async] = ACTIONS(1334),
    [anon_sym_for] = ACTIONS(1334),
    [anon_sym_EQ] = ACTIONS(1334),
    [anon_sym_and] = ACTIONS(1417),
    [anon_sym_or] = ACTIONS(1419),
    [anon_sym_RBRACK] = ACTIONS(1334),
    [anon_sym_RBRACE] = ACTIONS(1334),
    [sym_type_conversion] = ACTIONS(1334),
    [sym_comment] = ACTIONS(3),
  },
  [638] = {
    [sym_default_parameter] = STATE(870),
    [sym_typed_default_parameter] = STATE(870),
    [sym_list_splat] = STATE(930),
    [sym_dictionary_splat] = STATE(930),
    [sym_typed_parameter] = STATE(870),
    [sym_tuple] = STATE(870),
    [sym_identifier] = ACTIONS(1403),
    [anon_sym_LPAREN] = ACTIONS(1381),
    [anon_sym_STAR] = ACTIONS(1405),
    [anon_sym_print] = ACTIONS(1407),
    [anon_sym_COLON] = ACTIONS(1413),
    [anon_sym_STAR_STAR] = ACTIONS(359),
    [anon_sym_exec] = ACTIONS(1407),
    [sym_comment] = ACTIONS(3),
  },
  [639] = {
    [sym_default_parameter] = STATE(870),
    [sym_typed_default_parameter] = STATE(870),
    [sym_list_splat] = STATE(930),
    [sym_dictionary_splat] = STATE(930),
    [sym_typed_parameter] = STATE(870),
    [sym_tuple] = STATE(870),
    [sym_identifier] = ACTIONS(1403),
    [anon_sym_LPAREN] = ACTIONS(1381),
    [anon_sym_STAR] = ACTIONS(1405),
    [anon_sym_print] = ACTIONS(1407),
    [anon_sym_COLON] = ACTIONS(1423),
    [anon_sym_STAR_STAR] = ACTIONS(359),
    [anon_sym_exec] = ACTIONS(1407),
    [sym_comment] = ACTIONS(3),
  },
  [640] = {
    [anon_sym_RPAREN] = ACTIONS(1344),
    [anon_sym_COMMA] = ACTIONS(1344),
    [anon_sym_if] = ACTIONS(1344),
    [anon_sym_COLON] = ACTIONS(1344),
    [anon_sym_else] = ACTIONS(1344),
    [anon_sym_async] = ACTIONS(1344),
    [anon_sym_for] = ACTIONS(1344),
    [anon_sym_EQ] = ACTIONS(1344),
    [anon_sym_and] = ACTIONS(1417),
    [anon_sym_or] = ACTIONS(1344),
    [anon_sym_RBRACK] = ACTIONS(1344),
    [anon_sym_RBRACE] = ACTIONS(1344),
    [sym_type_conversion] = ACTIONS(1344),
    [sym_comment] = ACTIONS(3),
  },
  [641] = {
    [sym_default_parameter] = STATE(870),
    [sym_typed_default_parameter] = STATE(870),
    [sym_list_splat] = STATE(847),
    [sym_dictionary_splat] = STATE(847),
    [sym_typed_parameter] = STATE(870),
    [sym_tuple] = STATE(870),
    [sym_identifier] = ACTIONS(1411),
    [anon_sym_LPAREN] = ACTIONS(1381),
    [anon_sym_RPAREN] = ACTIONS(1429),
    [anon_sym_STAR] = ACTIONS(1405),
    [anon_sym_print] = ACTIONS(1415),
    [anon_sym_STAR_STAR] = ACTIONS(359),
    [anon_sym_exec] = ACTIONS(1415),
    [sym_comment] = ACTIONS(3),
  },
  [642] = {
    [sym_default_parameter] = STATE(870),
    [sym_typed_default_parameter] = STATE(870),
    [sym_list_splat] = STATE(930),
    [sym_dictionary_splat] = STATE(930),
    [sym_typed_parameter] = STATE(870),
    [sym_tuple] = STATE(870),
    [sym_identifier] = ACTIONS(1403),
    [anon_sym_LPAREN] = ACTIONS(1381),
    [anon_sym_STAR] = ACTIONS(1405),
    [anon_sym_print] = ACTIONS(1407),
    [anon_sym_COLON] = ACTIONS(1429),
    [anon_sym_STAR_STAR] = ACTIONS(359),
    [anon_sym_exec] = ACTIONS(1407),
    [sym_comment] = ACTIONS(3),
  },
  [643] = {
    [anon_sym_RPAREN] = ACTIONS(1338),
    [anon_sym_COMMA] = ACTIONS(1338),
    [anon_sym_if] = ACTIONS(1338),
    [anon_sym_COLON] = ACTIONS(1338),
    [anon_sym_else] = ACTIONS(1338),
    [anon_sym_async] = ACTIONS(1338),
    [anon_sym_for] = ACTIONS(1338),
    [anon_sym_EQ] = ACTIONS(1338),
    [anon_sym_and] = ACTIONS(1338),
    [anon_sym_or] = ACTIONS(1338),
    [anon_sym_RBRACK] = ACTIONS(1338),
    [anon_sym_RBRACE] = ACTIONS(1338),
    [sym_type_conversion] = ACTIONS(1338),
    [sym_comment] = ACTIONS(3),
  },
  [644] = {
    [sym_default_parameter] = STATE(870),
    [sym_typed_default_parameter] = STATE(870),
    [sym_list_splat] = STATE(847),
    [sym_dictionary_splat] = STATE(847),
    [sym_typed_parameter] = STATE(870),
    [sym_tuple] = STATE(870),
    [sym_identifier] = ACTIONS(1411),
    [anon_sym_LPAREN] = ACTIONS(1381),
    [anon_sym_STAR] = ACTIONS(1405),
    [anon_sym_print] = ACTIONS(1415),
    [anon_sym_STAR_STAR] = ACTIONS(359),
    [anon_sym_exec] = ACTIONS(1415),
    [sym_comment] = ACTIONS(3),
  },
  [645] = {
    [sym_default_parameter] = STATE(870),
    [sym_typed_default_parameter] = STATE(870),
    [sym_list_splat] = STATE(930),
    [sym_dictionary_splat] = STATE(930),
    [sym_typed_parameter] = STATE(870),
    [sym_tuple] = STATE(870),
    [sym_identifier] = ACTIONS(1403),
    [anon_sym_LPAREN] = ACTIONS(1381),
    [anon_sym_STAR] = ACTIONS(1405),
    [anon_sym_print] = ACTIONS(1407),
    [anon_sym_STAR_STAR] = ACTIONS(359),
    [anon_sym_exec] = ACTIONS(1407),
    [sym_comment] = ACTIONS(3),
  },
  [646] = {
    [sym__comprehension_clauses] = STATE(965),
    [sym_for_in_clause] = STATE(658),
    [aux_sym_list_repeat1] = STATE(817),
    [anon_sym_COMMA] = ACTIONS(1431),
    [anon_sym_if] = ACTIONS(1421),
    [anon_sym_COLON] = ACTIONS(1433),
    [anon_sym_async] = ACTIONS(1435),
    [anon_sym_for] = ACTIONS(1437),
    [anon_sym_and] = ACTIONS(1417),
    [anon_sym_or] = ACTIONS(1419),
    [anon_sym_RBRACE] = ACTIONS(1439),
    [sym_comment] = ACTIONS(3),
  },
  [647] = {
    [sym__comprehension_clauses] = STATE(981),
    [sym_for_in_clause] = STATE(658),
    [aux_sym_list_repeat1] = STATE(869),
    [anon_sym_COMMA] = ACTIONS(1441),
    [anon_sym_if] = ACTIONS(1421),
    [anon_sym_COLON] = ACTIONS(1433),
    [anon_sym_async] = ACTIONS(1435),
    [anon_sym_for] = ACTIONS(1437),
    [anon_sym_and] = ACTIONS(1417),
    [anon_sym_or] = ACTIONS(1419),
    [anon_sym_RBRACE] = ACTIONS(1443),
    [sym_comment] = ACTIONS(3),
  },
  [648] = {
    [sym__comprehension_clauses] = STATE(1001),
    [sym_for_in_clause] = STATE(658),
    [aux_sym_list_repeat1] = STATE(832),
    [anon_sym_COMMA] = ACTIONS(1445),
    [anon_sym_if] = ACTIONS(1421),
    [anon_sym_COLON] = ACTIONS(1433),
    [anon_sym_async] = ACTIONS(1435),
    [anon_sym_for] = ACTIONS(1437),
    [anon_sym_and] = ACTIONS(1417),
    [anon_sym_or] = ACTIONS(1419),
    [anon_sym_RBRACE] = ACTIONS(1447),
    [sym_comment] = ACTIONS(3),
  },
  [649] = {
    [sym__comprehension_clauses] = STATE(956),
    [sym_for_in_clause] = STATE(658),
    [aux_sym_tuple_repeat1] = STATE(821),
    [anon_sym_RPAREN] = ACTIONS(1449),
    [anon_sym_COMMA] = ACTIONS(1451),
    [anon_sym_if] = ACTIONS(1421),
    [anon_sym_async] = ACTIONS(1435),
    [anon_sym_for] = ACTIONS(1437),
    [anon_sym_and] = ACTIONS(1417),
    [anon_sym_or] = ACTIONS(1419),
    [sym_comment] = ACTIONS(3),
  },
  [650] = {
    [sym__comprehension_clauses] = STATE(960),
    [sym_for_in_clause] = STATE(658),
    [aux_sym_list_repeat1] = STATE(818),
    [anon_sym_COMMA] = ACTIONS(1453),
    [anon_sym_if] = ACTIONS(1421),
    [anon_sym_async] = ACTIONS(1435),
    [anon_sym_for] = ACTIONS(1437),
    [anon_sym_and] = ACTIONS(1417),
    [anon_sym_or] = ACTIONS(1419),
    [anon_sym_RBRACK] = ACTIONS(1455),
    [sym_comment] = ACTIONS(3),
  },
  [651] = {
    [sym__comprehension_clauses] = STATE(982),
    [sym_for_in_clause] = STATE(658),
    [aux_sym_list_repeat1] = STATE(866),
    [anon_sym_COMMA] = ACTIONS(1457),
    [anon_sym_if] = ACTIONS(1421),
    [anon_sym_async] = ACTIONS(1435),
    [anon_sym_for] = ACTIONS(1437),
    [anon_sym_and] = ACTIONS(1417),
    [anon_sym_or] = ACTIONS(1419),
    [anon_sym_RBRACK] = ACTIONS(1459),
    [sym_comment] = ACTIONS(3),
  },
  [652] = {
    [sym__comprehension_clauses] = STATE(1004),
    [sym_for_in_clause] = STATE(658),
    [aux_sym_tuple_repeat1] = STATE(855),
    [anon_sym_RPAREN] = ACTIONS(1461),
    [anon_sym_COMMA] = ACTIONS(1463),
    [anon_sym_if] = ACTIONS(1421),
    [anon_sym_async] = ACTIONS(1435),
    [anon_sym_for] = ACTIONS(1437),
    [anon_sym_and] = ACTIONS(1417),
    [anon_sym_or] = ACTIONS(1419),
    [sym_comment] = ACTIONS(3),
  },
  [653] = {
    [sym__comprehension_clauses] = STATE(956),
    [sym_for_in_clause] = STATE(658),
    [aux_sym_argument_list_repeat1] = STATE(872),
    [anon_sym_RPAREN] = ACTIONS(1465),
    [anon_sym_COMMA] = ACTIONS(1467),
    [anon_sym_if] = ACTIONS(1421),
    [anon_sym_async] = ACTIONS(1435),
    [anon_sym_for] = ACTIONS(1437),
    [anon_sym_and] = ACTIONS(1417),
    [anon_sym_or] = ACTIONS(1419),
    [sym_comment] = ACTIONS(3),
  },
  [654] = {
    [sym__comprehension_clauses] = STATE(985),
    [sym_for_in_clause] = STATE(658),
    [aux_sym_tuple_repeat1] = STATE(852),
    [anon_sym_RPAREN] = ACTIONS(1469),
    [anon_sym_COMMA] = ACTIONS(1471),
    [anon_sym_if] = ACTIONS(1421),
    [anon_sym_async] = ACTIONS(1435),
    [anon_sym_for] = ACTIONS(1437),
    [anon_sym_and] = ACTIONS(1417),
    [anon_sym_or] = ACTIONS(1419),
    [sym_comment] = ACTIONS(3),
  },
  [655] = {
    [sym__comprehension_clauses] = STATE(985),
    [sym_for_in_clause] = STATE(658),
    [aux_sym_argument_list_repeat1] = STATE(897),
    [anon_sym_RPAREN] = ACTIONS(1473),
    [anon_sym_COMMA] = ACTIONS(1475),
    [anon_sym_if] = ACTIONS(1421),
    [anon_sym_async] = ACTIONS(1435),
    [anon_sym_for] = ACTIONS(1437),
    [anon_sym_and] = ACTIONS(1417),
    [anon_sym_or] = ACTIONS(1419),
    [sym_comment] = ACTIONS(3),
  },
  [656] = {
    [sym__comprehension_clauses] = STATE(1004),
    [sym_for_in_clause] = STATE(658),
    [aux_sym_argument_list_repeat1] = STATE(889),
    [anon_sym_RPAREN] = ACTIONS(1477),
    [anon_sym_COMMA] = ACTIONS(1479),
    [anon_sym_if] = ACTIONS(1421),
    [anon_sym_async] = ACTIONS(1435),
    [anon_sym_for] = ACTIONS(1437),
    [anon_sym_and] = ACTIONS(1417),
    [anon_sym_or] = ACTIONS(1419),
    [sym_comment] = ACTIONS(3),
  },
  [657] = {
    [sym__comprehension_clauses] = STATE(1002),
    [sym_for_in_clause] = STATE(658),
    [aux_sym_list_repeat1] = STATE(841),
    [anon_sym_COMMA] = ACTIONS(1481),
    [anon_sym_if] = ACTIONS(1421),
    [anon_sym_async] = ACTIONS(1435),
    [anon_sym_for] = ACTIONS(1437),
    [anon_sym_and] = ACTIONS(1417),
    [anon_sym_or] = ACTIONS(1419),
    [anon_sym_RBRACK] = ACTIONS(1483),
    [sym_comment] = ACTIONS(3),
  },
  [658] = {
    [sym_for_in_clause] = STATE(661),
    [sym_if_clause] = STATE(661),
    [aux_sym__comprehension_clauses_repeat1] = STATE(661),
    [anon_sym_RPAREN] = ACTIONS(1485),
    [anon_sym_if] = ACTIONS(1487),
    [anon_sym_async] = ACTIONS(1435),
    [anon_sym_for] = ACTIONS(1437),
    [anon_sym_RBRACK] = ACTIONS(1485),
    [anon_sym_RBRACE] = ACTIONS(1485),
    [sym_comment] = ACTIONS(3),
  },
  [659] = {
    [anon_sym_RPAREN] = ACTIONS(1489),
    [anon_sym_COMMA] = ACTIONS(1489),
    [anon_sym_if] = ACTIONS(1489),
    [anon_sym_async] = ACTIONS(1489),
    [anon_sym_for] = ACTIONS(1489),
    [anon_sym_and] = ACTIONS(1417),
    [anon_sym_or] = ACTIONS(1419),
    [anon_sym_RBRACK] = ACTIONS(1489),
    [anon_sym_RBRACE] = ACTIONS(1489),
    [sym_comment] = ACTIONS(3),
  },
  [660] = {
    [anon_sym_RPAREN] = ACTIONS(1489),
    [anon_sym_COMMA] = ACTIONS(1489),
    [anon_sym_if] = ACTIONS(1489),
    [anon_sym_async] = ACTIONS(1489),
    [anon_sym_for] = ACTIONS(1489),
    [anon_sym_and] = ACTIONS(1417),
    [anon_sym_or] = ACTIONS(1419),
    [anon_sym_RBRACK] = ACTIONS(1489),
    [anon_sym_RBRACE] = ACTIONS(1489),
    [sym_comment] = ACTIONS(3),
  },
  [661] = {
    [sym_for_in_clause] = STATE(663),
    [sym_if_clause] = STATE(663),
    [aux_sym__comprehension_clauses_repeat1] = STATE(663),
    [anon_sym_RPAREN] = ACTIONS(1491),
    [anon_sym_if] = ACTIONS(1487),
    [anon_sym_async] = ACTIONS(1435),
    [anon_sym_for] = ACTIONS(1437),
    [anon_sym_RBRACK] = ACTIONS(1491),
    [anon_sym_RBRACE] = ACTIONS(1491),
    [sym_comment] = ACTIONS(3),
  },
  [662] = {
    [anon_sym_RPAREN] = ACTIONS(1489),
    [anon_sym_COMMA] = ACTIONS(1489),
    [anon_sym_if] = ACTIONS(1489),
    [anon_sym_async] = ACTIONS(1489),
    [anon_sym_for] = ACTIONS(1489),
    [anon_sym_and] = ACTIONS(1417),
    [anon_sym_or] = ACTIONS(1419),
    [anon_sym_RBRACK] = ACTIONS(1489),
    [anon_sym_RBRACE] = ACTIONS(1489),
    [sym_comment] = ACTIONS(3),
  },
  [663] = {
    [sym_for_in_clause] = STATE(663),
    [sym_if_clause] = STATE(663),
    [aux_sym__comprehension_clauses_repeat1] = STATE(663),
    [anon_sym_RPAREN] = ACTIONS(1493),
    [anon_sym_if] = ACTIONS(1495),
    [anon_sym_async] = ACTIONS(1498),
    [anon_sym_for] = ACTIONS(1501),
    [anon_sym_RBRACK] = ACTIONS(1493),
    [anon_sym_RBRACE] = ACTIONS(1493),
    [sym_comment] = ACTIONS(3),
  },
  [664] = {
    [aux_sym_for_in_clause_repeat1] = STATE(666),
    [anon_sym_RPAREN] = ACTIONS(1504),
    [anon_sym_COMMA] = ACTIONS(1506),
    [anon_sym_if] = ACTIONS(1504),
    [anon_sym_async] = ACTIONS(1504),
    [anon_sym_for] = ACTIONS(1504),
    [anon_sym_RBRACK] = ACTIONS(1504),
    [anon_sym_RBRACE] = ACTIONS(1504),
    [sym_comment] = ACTIONS(3),
  },
  [665] = {
    [aux_sym_for_in_clause_repeat1] = STATE(665),
    [anon_sym_RPAREN] = ACTIONS(1508),
    [anon_sym_COMMA] = ACTIONS(1510),
    [anon_sym_if] = ACTIONS(1508),
    [anon_sym_async] = ACTIONS(1508),
    [anon_sym_for] = ACTIONS(1508),
    [anon_sym_RBRACK] = ACTIONS(1508),
    [anon_sym_RBRACE] = ACTIONS(1508),
    [sym_comment] = ACTIONS(3),
  },
  [666] = {
    [aux_sym_for_in_clause_repeat1] = STATE(665),
    [anon_sym_RPAREN] = ACTIONS(1513),
    [anon_sym_COMMA] = ACTIONS(1515),
    [anon_sym_if] = ACTIONS(1513),
    [anon_sym_async] = ACTIONS(1513),
    [anon_sym_for] = ACTIONS(1513),
    [anon_sym_RBRACK] = ACTIONS(1513),
    [anon_sym_RBRACE] = ACTIONS(1513),
    [sym_comment] = ACTIONS(3),
  },
  [667] = {
    [sym_function_definition] = STATE(434),
    [sym_class_definition] = STATE(434),
    [sym_decorator] = STATE(725),
    [aux_sym_decorated_definition_repeat1] = STATE(725),
    [anon_sym_async] = ACTIONS(1517),
    [anon_sym_def] = ACTIONS(1519),
    [anon_sym_class] = ACTIONS(1521),
    [anon_sym_AT] = ACTIONS(53),
    [sym_comment] = ACTIONS(3),
  },
  [668] = {
    [anon_sym_RPAREN] = ACTIONS(1523),
    [anon_sym_COMMA] = ACTIONS(1523),
    [anon_sym_if] = ACTIONS(1421),
    [anon_sym_COLON] = ACTIONS(1523),
    [anon_sym_and] = ACTIONS(1417),
    [anon_sym_or] = ACTIONS(1419),
    [anon_sym_RBRACK] = ACTIONS(1523),
    [anon_sym_RBRACE] = ACTIONS(1523),
    [sym_comment] = ACTIONS(3),
  },
  [669] = {
    [sym_function_definition] = STATE(466),
    [sym_class_definition] = STATE(466),
    [sym_decorator] = STATE(725),
    [aux_sym_decorated_definition_repeat1] = STATE(725),
    [anon_sym_async] = ACTIONS(1525),
    [anon_sym_def] = ACTIONS(1527),
    [anon_sym_class] = ACTIONS(1529),
    [anon_sym_AT] = ACTIONS(53),
    [sym_comment] = ACTIONS(3),
  },
  [670] = {
    [anon_sym_RPAREN] = ACTIONS(1531),
    [anon_sym_if] = ACTIONS(1531),
    [anon_sym_async] = ACTIONS(1531),
    [anon_sym_for] = ACTIONS(1531),
    [anon_sym_and] = ACTIONS(1417),
    [anon_sym_or] = ACTIONS(1419),
    [anon_sym_RBRACK] = ACTIONS(1531),
    [anon_sym_RBRACE] = ACTIONS(1531),
    [sym_comment] = ACTIONS(3),
  },
  [671] = {
    [aux_sym_for_in_clause_repeat1] = STATE(672),
    [anon_sym_RPAREN] = ACTIONS(1533),
    [anon_sym_COMMA] = ACTIONS(1535),
    [anon_sym_if] = ACTIONS(1533),
    [anon_sym_async] = ACTIONS(1533),
    [anon_sym_for] = ACTIONS(1533),
    [anon_sym_RBRACK] = ACTIONS(1533),
    [anon_sym_RBRACE] = ACTIONS(1533),
    [sym_comment] = ACTIONS(3),
  },
  [672] = {
    [aux_sym_for_in_clause_repeat1] = STATE(665),
    [anon_sym_RPAREN] = ACTIONS(1537),
    [anon_sym_COMMA] = ACTIONS(1539),
    [anon_sym_if] = ACTIONS(1537),
    [anon_sym_async] = ACTIONS(1537),
    [anon_sym_for] = ACTIONS(1537),
    [anon_sym_RBRACK] = ACTIONS(1537),
    [anon_sym_RBRACE] = ACTIONS(1537),
    [sym_comment] = ACTIONS(3),
  },
  [673] = {
    [aux_sym_subscript_repeat1] = STATE(890),
    [anon_sym_COMMA] = ACTIONS(1541),
    [anon_sym_if] = ACTIONS(1421),
    [anon_sym_COLON] = ACTIONS(1543),
    [anon_sym_and] = ACTIONS(1417),
    [anon_sym_or] = ACTIONS(1419),
    [anon_sym_RBRACK] = ACTIONS(1545),
    [sym_comment] = ACTIONS(3),
  },
  [674] = {
    [sym_interpolation] = STATE(674),
    [aux_sym_string_repeat1] = STATE(674),
    [anon_sym_LBRACE] = ACTIONS(1547),
    [sym_escape_sequence] = ACTIONS(1550),
    [sym__not_escape_sequence] = ACTIONS(1550),
    [sym_comment] = ACTIONS(1553),
    [sym__string_content] = ACTIONS(1555),
    [sym__string_end] = ACTIONS(1558),
  },
  [675] = {
    [sym_interpolation] = STATE(674),
    [aux_sym_string_repeat1] = STATE(674),
    [anon_sym_LBRACE] = ACTIONS(1560),
    [sym_escape_sequence] = ACTIONS(1562),
    [sym__not_escape_sequence] = ACTIONS(1562),
    [sym_comment] = ACTIONS(1553),
    [sym__string_content] = ACTIONS(1564),
    [sym__string_end] = ACTIONS(1566),
  },
  [676] = {
    [anon_sym_RPAREN] = ACTIONS(1508),
    [anon_sym_COMMA] = ACTIONS(1508),
    [anon_sym_if] = ACTIONS(1508),
    [anon_sym_async] = ACTIONS(1508),
    [anon_sym_for] = ACTIONS(1508),
    [anon_sym_RBRACK] = ACTIONS(1508),
    [anon_sym_RBRACE] = ACTIONS(1508),
    [sym_comment] = ACTIONS(3),
  },
  [677] = {
    [sym__comprehension_clauses] = STATE(999),
    [sym_for_in_clause] = STATE(658),
    [aux_sym_dictionary_repeat1] = STATE(830),
    [anon_sym_COMMA] = ACTIONS(1568),
    [anon_sym_async] = ACTIONS(1435),
    [anon_sym_for] = ACTIONS(1437),
    [anon_sym_RBRACE] = ACTIONS(1570),
    [sym_comment] = ACTIONS(3),
  },
  [678] = {
    [sym_interpolation] = STATE(674),
    [aux_sym_string_repeat1] = STATE(674),
    [anon_sym_LBRACE] = ACTIONS(1560),
    [sym_escape_sequence] = ACTIONS(1562),
    [sym__not_escape_sequence] = ACTIONS(1562),
    [sym_comment] = ACTIONS(1553),
    [sym__string_content] = ACTIONS(1564),
    [sym__string_end] = ACTIONS(1572),
  },
  [679] = {
    [sym__import_list] = STATE(934),
    [sym_aliased_import] = STATE(767),
    [sym_wildcard_import] = STATE(934),
    [sym_dotted_name] = STATE(758),
    [sym_identifier] = ACTIONS(1574),
    [anon_sym_LPAREN] = ACTIONS(1576),
    [anon_sym_STAR] = ACTIONS(1578),
    [sym_comment] = ACTIONS(3),
  },
  [680] = {
    [aux_sym_print_statement_repeat1] = STATE(786),
    [anon_sym_COMMA] = ACTIONS(1580),
    [anon_sym_if] = ACTIONS(1320),
    [anon_sym_and] = ACTIONS(1322),
    [anon_sym_or] = ACTIONS(1324),
    [sym_comment] = ACTIONS(3),
    [sym__semicolon] = ACTIONS(1582),
    [sym__newline] = ACTIONS(1582),
  },
  [681] = {
    [aux_sym_dotted_name_repeat1] = STATE(681),
    [anon_sym_DOT] = ACTIONS(1584),
    [anon_sym_LPAREN] = ACTIONS(1587),
    [anon_sym_COMMA] = ACTIONS(1587),
    [anon_sym_as] = ACTIONS(1587),
    [sym_comment] = ACTIONS(3),
    [sym__semicolon] = ACTIONS(1587),
    [sym__newline] = ACTIONS(1587),
  },
  [682] = {
    [anon_sym_RPAREN] = ACTIONS(1589),
    [anon_sym_COMMA] = ACTIONS(1589),
    [anon_sym_if] = ACTIONS(1421),
    [anon_sym_COLON] = ACTIONS(1589),
    [anon_sym_EQ] = ACTIONS(1589),
    [anon_sym_and] = ACTIONS(1417),
    [anon_sym_or] = ACTIONS(1419),
    [sym_comment] = ACTIONS(3),
  },
  [683] = {
    [sym_import_prefix] = STATE(814),
    [sym_relative_import] = STATE(963),
    [sym_dotted_name] = STATE(963),
    [aux_sym_import_prefix_repeat1] = STATE(773),
    [sym_identifier] = ACTIONS(1591),
    [anon_sym_DOT] = ACTIONS(1593),
    [anon_sym___future__] = ACTIONS(1595),
    [sym_comment] = ACTIONS(3),
  },
  [684] = {
    [aux_sym_assert_statement_repeat1] = STATE(801),
    [anon_sym_COMMA] = ACTIONS(1597),
    [anon_sym_if] = ACTIONS(1320),
    [anon_sym_and] = ACTIONS(1322),
    [anon_sym_or] = ACTIONS(1324),
    [sym_comment] = ACTIONS(3),
    [sym__semicolon] = ACTIONS(1599),
    [sym__newline] = ACTIONS(1599),
  },
  [685] = {
    [sym_interpolation] = STATE(678),
    [aux_sym_string_repeat1] = STATE(678),
    [anon_sym_LBRACE] = ACTIONS(1560),
    [sym_escape_sequence] = ACTIONS(1601),
    [sym__not_escape_sequence] = ACTIONS(1601),
    [sym_comment] = ACTIONS(1553),
    [sym__string_content] = ACTIONS(1603),
    [sym__string_end] = ACTIONS(1605),
  },
  [686] = {
    [aux_sym_dotted_name_repeat1] = STATE(699),
    [anon_sym_DOT] = ACTIONS(1607),
    [anon_sym_LPAREN] = ACTIONS(1609),
    [anon_sym_COMMA] = ACTIONS(1609),
    [anon_sym_as] = ACTIONS(1609),
    [sym_comment] = ACTIONS(3),
    [sym__semicolon] = ACTIONS(1609),
    [sym__newline] = ACTIONS(1609),
  },
  [687] = {
    [sym_interpolation] = STATE(694),
    [aux_sym_string_repeat1] = STATE(694),
    [anon_sym_LBRACE] = ACTIONS(1560),
    [sym_escape_sequence] = ACTIONS(1611),
    [sym__not_escape_sequence] = ACTIONS(1611),
    [sym_comment] = ACTIONS(1553),
    [sym__string_content] = ACTIONS(1613),
    [sym__string_end] = ACTIONS(1615),
  },
  [688] = {
    [aux_sym_subscript_repeat1] = STATE(899),
    [anon_sym_COMMA] = ACTIONS(1617),
    [anon_sym_if] = ACTIONS(1421),
    [anon_sym_COLON] = ACTIONS(1543),
    [anon_sym_and] = ACTIONS(1417),
    [anon_sym_or] = ACTIONS(1419),
    [anon_sym_RBRACK] = ACTIONS(1619),
    [sym_comment] = ACTIONS(3),
  },
  [689] = {
    [sym_format_specifier] = STATE(959),
    [anon_sym_if] = ACTIONS(1421),
    [anon_sym_COLON] = ACTIONS(1621),
    [anon_sym_and] = ACTIONS(1417),
    [anon_sym_or] = ACTIONS(1419),
    [anon_sym_RBRACE] = ACTIONS(1623),
    [sym_type_conversion] = ACTIONS(1625),
    [sym_comment] = ACTIONS(3),
  },
  [690] = {
    [anon_sym_RPAREN] = ACTIONS(1627),
    [anon_sym_COMMA] = ACTIONS(1627),
    [anon_sym_if] = ACTIONS(1627),
    [anon_sym_async] = ACTIONS(1627),
    [anon_sym_for] = ACTIONS(1627),
    [anon_sym_RBRACK] = ACTIONS(1627),
    [anon_sym_RBRACE] = ACTIONS(1627),
    [sym_comment] = ACTIONS(3),
  },
  [691] = {
    [aux_sym_assert_statement_repeat1] = STATE(778),
    [anon_sym_COMMA] = ACTIONS(1597),
    [anon_sym_if] = ACTIONS(1320),
    [anon_sym_and] = ACTIONS(1322),
    [anon_sym_or] = ACTIONS(1324),
    [sym_comment] = ACTIONS(3),
    [sym__semicolon] = ACTIONS(1629),
    [sym__newline] = ACTIONS(1629),
  },
  [692] = {
    [sym_interpolation] = STATE(695),
    [aux_sym_string_repeat1] = STATE(695),
    [anon_sym_LBRACE] = ACTIONS(1560),
    [sym_escape_sequence] = ACTIONS(1631),
    [sym__not_escape_sequence] = ACTIONS(1631),
    [sym_comment] = ACTIONS(1553),
    [sym__string_content] = ACTIONS(1633),
    [sym__string_end] = ACTIONS(1635),
  },
  [693] = {
    [sym__comprehension_clauses] = STATE(966),
    [sym_for_in_clause] = STATE(658),
    [aux_sym_dictionary_repeat1] = STATE(816),
    [anon_sym_COMMA] = ACTIONS(1637),
    [anon_sym_async] = ACTIONS(1435),
    [anon_sym_for] = ACTIONS(1437),
    [anon_sym_RBRACE] = ACTIONS(1639),
    [sym_comment] = ACTIONS(3),
  },
  [694] = {
    [sym_interpolation] = STATE(674),
    [aux_sym_string_repeat1] = STATE(674),
    [anon_sym_LBRACE] = ACTIONS(1560),
    [sym_escape_sequence] = ACTIONS(1562),
    [sym__not_escape_sequence] = ACTIONS(1562),
    [sym_comment] = ACTIONS(1553),
    [sym__string_content] = ACTIONS(1564),
    [sym__string_end] = ACTIONS(1641),
  },
  [695] = {
    [sym_interpolation] = STATE(674),
    [aux_sym_string_repeat1] = STATE(674),
    [anon_sym_LBRACE] = ACTIONS(1560),
    [sym_escape_sequence] = ACTIONS(1562),
    [sym__not_escape_sequence] = ACTIONS(1562),
    [sym_comment] = ACTIONS(1553),
    [sym__string_content] = ACTIONS(1564),
    [sym__string_end] = ACTIONS(1643),
  },
  [696] = {
    [anon_sym_COMMA] = ACTIONS(1645),
    [anon_sym_if] = ACTIONS(1421),
    [anon_sym_async] = ACTIONS(1645),
    [anon_sym_for] = ACTIONS(1645),
    [anon_sym_and] = ACTIONS(1417),
    [anon_sym_or] = ACTIONS(1419),
    [anon_sym_RBRACE] = ACTIONS(1645),
    [sym_comment] = ACTIONS(3),
  },
  [697] = {
    [anon_sym_RPAREN] = ACTIONS(1647),
    [anon_sym_COMMA] = ACTIONS(1647),
    [anon_sym_if] = ACTIONS(1421),
    [anon_sym_COLON] = ACTIONS(1647),
    [anon_sym_and] = ACTIONS(1417),
    [anon_sym_or] = ACTIONS(1419),
    [anon_sym_RBRACE] = ACTIONS(1647),
    [sym_comment] = ACTIONS(3),
  },
  [698] = {
    [aux_sym_assert_statement_repeat1] = STATE(795),
    [anon_sym_RPAREN] = ACTIONS(1316),
    [anon_sym_COMMA] = ACTIONS(1649),
    [anon_sym_if] = ACTIONS(1421),
    [anon_sym_COLON] = ACTIONS(1316),
    [anon_sym_and] = ACTIONS(1417),
    [anon_sym_or] = ACTIONS(1419),
    [sym_comment] = ACTIONS(3),
  },
  [699] = {
    [aux_sym_dotted_name_repeat1] = STATE(681),
    [anon_sym_DOT] = ACTIONS(1607),
    [anon_sym_LPAREN] = ACTIONS(1651),
    [anon_sym_COMMA] = ACTIONS(1651),
    [anon_sym_as] = ACTIONS(1651),
    [sym_comment] = ACTIONS(3),
    [sym__semicolon] = ACTIONS(1651),
    [sym__newline] = ACTIONS(1651),
  },
  [700] = {
    [anon_sym_RPAREN] = ACTIONS(1653),
    [anon_sym_COMMA] = ACTIONS(1653),
    [anon_sym_if] = ACTIONS(1653),
    [anon_sym_async] = ACTIONS(1653),
    [anon_sym_for] = ACTIONS(1653),
    [anon_sym_RBRACK] = ACTIONS(1653),
    [anon_sym_RBRACE] = ACTIONS(1653),
    [sym_comment] = ACTIONS(3),
  },
  [701] = {
    [sym__comprehension_clauses] = STATE(980),
    [sym_for_in_clause] = STATE(658),
    [aux_sym_dictionary_repeat1] = STATE(871),
    [anon_sym_COMMA] = ACTIONS(1655),
    [anon_sym_async] = ACTIONS(1435),
    [anon_sym_for] = ACTIONS(1437),
    [anon_sym_RBRACE] = ACTIONS(1657),
    [sym_comment] = ACTIONS(3),
  },
  [702] = {
    [aux_sym_subscript_repeat1] = STATE(863),
    [anon_sym_COMMA] = ACTIONS(1659),
    [anon_sym_if] = ACTIONS(1421),
    [anon_sym_COLON] = ACTIONS(1543),
    [anon_sym_and] = ACTIONS(1417),
    [anon_sym_or] = ACTIONS(1419),
    [anon_sym_RBRACK] = ACTIONS(1661),
    [sym_comment] = ACTIONS(3),
  },
  [703] = {
    [sym_interpolation] = STATE(675),
    [aux_sym_string_repeat1] = STATE(675),
    [anon_sym_LBRACE] = ACTIONS(1560),
    [sym_escape_sequence] = ACTIONS(1663),
    [sym__not_escape_sequence] = ACTIONS(1663),
    [sym_comment] = ACTIONS(1553),
    [sym__string_content] = ACTIONS(1665),
    [sym__string_end] = ACTIONS(1667),
  },
  [704] = {
    [anon_sym_COMMA] = ACTIONS(1332),
    [anon_sym_as] = ACTIONS(1332),
    [anon_sym_if] = ACTIONS(1332),
    [anon_sym_COLON] = ACTIONS(1332),
    [anon_sym_and] = ACTIONS(1669),
    [anon_sym_or] = ACTIONS(1671),
    [sym_comment] = ACTIONS(3),
  },
  [705] = {
    [anon_sym_RPAREN] = ACTIONS(1673),
    [anon_sym_COMMA] = ACTIONS(1673),
    [anon_sym_if] = ACTIONS(1421),
    [anon_sym_COLON] = ACTIONS(1673),
    [anon_sym_and] = ACTIONS(1417),
    [anon_sym_or] = ACTIONS(1419),
    [sym_comment] = ACTIONS(3),
  },
  [706] = {
    [anon_sym_RPAREN] = ACTIONS(1675),
    [anon_sym_COMMA] = ACTIONS(1675),
    [anon_sym_if] = ACTIONS(1421),
    [anon_sym_COLON] = ACTIONS(1675),
    [anon_sym_and] = ACTIONS(1417),
    [anon_sym_or] = ACTIONS(1419),
    [sym_comment] = ACTIONS(3),
  },
  [707] = {
    [aux_sym_dotted_name_repeat1] = STATE(724),
    [anon_sym_import] = ACTIONS(1609),
    [anon_sym_DOT] = ACTIONS(1677),
    [anon_sym_RPAREN] = ACTIONS(1609),
    [anon_sym_COMMA] = ACTIONS(1609),
    [anon_sym_as] = ACTIONS(1609),
    [sym_comment] = ACTIONS(3),
  },
  [708] = {
    [anon_sym_DOT] = ACTIONS(1587),
    [anon_sym_LPAREN] = ACTIONS(1587),
    [anon_sym_COMMA] = ACTIONS(1587),
    [anon_sym_as] = ACTIONS(1587),
    [sym_comment] = ACTIONS(3),
    [sym__semicolon] = ACTIONS(1587),
    [sym__newline] = ACTIONS(1587),
  },
  [709] = {
    [anon_sym_COMMA] = ACTIONS(1344),
    [anon_sym_as] = ACTIONS(1344),
    [anon_sym_if] = ACTIONS(1344),
    [anon_sym_COLON] = ACTIONS(1344),
    [anon_sym_and] = ACTIONS(1344),
    [anon_sym_or] = ACTIONS(1344),
    [sym_comment] = ACTIONS(3),
  },
  [710] = {
    [aux_sym_argument_list_repeat1] = STATE(889),
    [anon_sym_RPAREN] = ACTIONS(1477),
    [anon_sym_COMMA] = ACTIONS(1479),
    [anon_sym_if] = ACTIONS(1421),
    [anon_sym_and] = ACTIONS(1417),
    [anon_sym_or] = ACTIONS(1419),
    [sym_comment] = ACTIONS(3),
  },
  [711] = {
    [anon_sym_COMMA] = ACTIONS(714),
    [anon_sym_if] = ACTIONS(1421),
    [anon_sym_COLON] = ACTIONS(716),
    [anon_sym_and] = ACTIONS(1417),
    [anon_sym_or] = ACTIONS(1419),
    [anon_sym_RBRACK] = ACTIONS(714),
    [sym_comment] = ACTIONS(3),
  },
  [712] = {
    [anon_sym_COMMA] = ACTIONS(1336),
    [anon_sym_as] = ACTIONS(1336),
    [anon_sym_if] = ACTIONS(1679),
    [anon_sym_COLON] = ACTIONS(1336),
    [anon_sym_and] = ACTIONS(1669),
    [anon_sym_or] = ACTIONS(1671),
    [sym_comment] = ACTIONS(3),
  },
  [713] = {
    [aux_sym_argument_list_repeat1] = STATE(897),
    [anon_sym_RPAREN] = ACTIONS(1473),
    [anon_sym_COMMA] = ACTIONS(1475),
    [anon_sym_if] = ACTIONS(1421),
    [anon_sym_and] = ACTIONS(1417),
    [anon_sym_or] = ACTIONS(1419),
    [sym_comment] = ACTIONS(3),
  },
  [714] = {
    [anon_sym_COMMA] = ACTIONS(1681),
    [anon_sym_if] = ACTIONS(1320),
    [anon_sym_and] = ACTIONS(1322),
    [anon_sym_or] = ACTIONS(1324),
    [sym_comment] = ACTIONS(3),
    [sym__semicolon] = ACTIONS(1681),
    [sym__newline] = ACTIONS(1681),
  },
  [715] = {
    [aux_sym_dotted_name_repeat1] = STATE(715),
    [anon_sym_import] = ACTIONS(1587),
    [anon_sym_DOT] = ACTIONS(1683),
    [anon_sym_RPAREN] = ACTIONS(1587),
    [anon_sym_COMMA] = ACTIONS(1587),
    [anon_sym_as] = ACTIONS(1587),
    [sym_comment] = ACTIONS(3),
  },
  [716] = {
    [anon_sym_COMMA] = ACTIONS(1344),
    [anon_sym_as] = ACTIONS(1344),
    [anon_sym_if] = ACTIONS(1344),
    [anon_sym_COLON] = ACTIONS(1344),
    [anon_sym_and] = ACTIONS(1669),
    [anon_sym_or] = ACTIONS(1344),
    [sym_comment] = ACTIONS(3),
  },
  [717] = {
    [anon_sym_COMMA] = ACTIONS(795),
    [anon_sym_if] = ACTIONS(1421),
    [anon_sym_COLON] = ACTIONS(1686),
    [anon_sym_and] = ACTIONS(1417),
    [anon_sym_or] = ACTIONS(1419),
    [anon_sym_RBRACK] = ACTIONS(795),
    [sym_comment] = ACTIONS(3),
  },
  [718] = {
    [aux_sym_tuple_repeat1] = STATE(852),
    [anon_sym_RPAREN] = ACTIONS(1688),
    [anon_sym_COMMA] = ACTIONS(1471),
    [anon_sym_if] = ACTIONS(1421),
    [anon_sym_and] = ACTIONS(1417),
    [anon_sym_or] = ACTIONS(1419),
    [sym_comment] = ACTIONS(3),
  },
  [719] = {
    [anon_sym_RPAREN] = ACTIONS(1326),
    [anon_sym_COMMA] = ACTIONS(1326),
    [anon_sym_if] = ACTIONS(1421),
    [anon_sym_COLON] = ACTIONS(1326),
    [anon_sym_and] = ACTIONS(1417),
    [anon_sym_or] = ACTIONS(1419),
    [sym_comment] = ACTIONS(3),
  },
  [720] = {
    [anon_sym_COMMA] = ACTIONS(1342),
    [anon_sym_as] = ACTIONS(1342),
    [anon_sym_if] = ACTIONS(1679),
    [anon_sym_COLON] = ACTIONS(1342),
    [anon_sym_and] = ACTIONS(1669),
    [anon_sym_or] = ACTIONS(1671),
    [sym_comment] = ACTIONS(3),
  },
  [721] = {
    [anon_sym_COMMA] = ACTIONS(1690),
    [anon_sym_if] = ACTIONS(1421),
    [anon_sym_and] = ACTIONS(1417),
    [anon_sym_or] = ACTIONS(1419),
    [anon_sym_RBRACK] = ACTIONS(1690),
    [anon_sym_RBRACE] = ACTIONS(1690),
    [sym_comment] = ACTIONS(3),
  },
  [722] = {
    [anon_sym_COMMA] = ACTIONS(1692),
    [anon_sym_as] = ACTIONS(1694),
    [anon_sym_if] = ACTIONS(1679),
    [anon_sym_COLON] = ACTIONS(1692),
    [anon_sym_and] = ACTIONS(1669),
    [anon_sym_or] = ACTIONS(1671),
    [sym_comment] = ACTIONS(3),
  },
  [723] = {
    [anon_sym_COMMA] = ACTIONS(1340),
    [anon_sym_as] = ACTIONS(1340),
    [anon_sym_if] = ACTIONS(1679),
    [anon_sym_COLON] = ACTIONS(1340),
    [anon_sym_and] = ACTIONS(1669),
    [anon_sym_or] = ACTIONS(1671),
    [sym_comment] = ACTIONS(3),
  },
  [724] = {
    [aux_sym_dotted_name_repeat1] = STATE(715),
    [anon_sym_import] = ACTIONS(1651),
    [anon_sym_DOT] = ACTIONS(1677),
    [anon_sym_RPAREN] = ACTIONS(1651),
    [anon_sym_COMMA] = ACTIONS(1651),
    [anon_sym_as] = ACTIONS(1651),
    [sym_comment] = ACTIONS(3),
  },
  [725] = {
    [sym_decorator] = STATE(725),
    [aux_sym_decorated_definition_repeat1] = STATE(725),
    [anon_sym_async] = ACTIONS(1696),
    [anon_sym_def] = ACTIONS(1696),
    [anon_sym_class] = ACTIONS(1696),
    [anon_sym_AT] = ACTIONS(1698),
    [sym_comment] = ACTIONS(3),
  },
  [726] = {
    [anon_sym_COMMA] = ACTIONS(1701),
    [anon_sym_if] = ACTIONS(1320),
    [anon_sym_and] = ACTIONS(1322),
    [anon_sym_or] = ACTIONS(1324),
    [sym_comment] = ACTIONS(3),
    [sym__semicolon] = ACTIONS(1701),
    [sym__newline] = ACTIONS(1701),
  },
  [727] = {
    [anon_sym_RPAREN] = ACTIONS(1703),
    [anon_sym_COMMA] = ACTIONS(1703),
    [anon_sym_if] = ACTIONS(1421),
    [anon_sym_COLON] = ACTIONS(1703),
    [anon_sym_and] = ACTIONS(1417),
    [anon_sym_or] = ACTIONS(1419),
    [sym_comment] = ACTIONS(3),
  },
  [728] = {
    [anon_sym_COMMA] = ACTIONS(1338),
    [anon_sym_as] = ACTIONS(1338),
    [anon_sym_if] = ACTIONS(1338),
    [anon_sym_COLON] = ACTIONS(1338),
    [anon_sym_and] = ACTIONS(1338),
    [anon_sym_or] = ACTIONS(1338),
    [sym_comment] = ACTIONS(3),
  },
  [729] = {
    [anon_sym_COMMA] = ACTIONS(1705),
    [anon_sym_if] = ACTIONS(1421),
    [anon_sym_COLON] = ACTIONS(1543),
    [anon_sym_and] = ACTIONS(1417),
    [anon_sym_or] = ACTIONS(1419),
    [anon_sym_RBRACK] = ACTIONS(1705),
    [sym_comment] = ACTIONS(3),
  },
  [730] = {
    [anon_sym_COMMA] = ACTIONS(1334),
    [anon_sym_as] = ACTIONS(1334),
    [anon_sym_if] = ACTIONS(1334),
    [anon_sym_COLON] = ACTIONS(1334),
    [anon_sym_and] = ACTIONS(1669),
    [anon_sym_or] = ACTIONS(1671),
    [sym_comment] = ACTIONS(3),
  },
  [731] = {
    [anon_sym_COMMA] = ACTIONS(1707),
    [anon_sym_as] = ACTIONS(1707),
    [anon_sym_if] = ACTIONS(1679),
    [anon_sym_COLON] = ACTIONS(1709),
    [anon_sym_and] = ACTIONS(1669),
    [anon_sym_or] = ACTIONS(1671),
    [sym_comment] = ACTIONS(3),
  },
  [732] = {
    [anon_sym_if] = ACTIONS(1320),
    [anon_sym_EQ] = ACTIONS(1589),
    [anon_sym_and] = ACTIONS(1322),
    [anon_sym_or] = ACTIONS(1324),
    [sym_comment] = ACTIONS(3),
    [sym__semicolon] = ACTIONS(1589),
    [sym__newline] = ACTIONS(1589),
  },
  [733] = {
    [anon_sym_COMMA] = ACTIONS(1711),
    [anon_sym_as] = ACTIONS(1711),
    [anon_sym_if] = ACTIONS(1679),
    [anon_sym_COLON] = ACTIONS(1713),
    [anon_sym_and] = ACTIONS(1669),
    [anon_sym_or] = ACTIONS(1671),
    [sym_comment] = ACTIONS(3),
  },
  [734] = {
    [anon_sym_RPAREN] = ACTIONS(1715),
    [anon_sym_COMMA] = ACTIONS(1715),
    [anon_sym_if] = ACTIONS(1421),
    [anon_sym_COLON] = ACTIONS(1715),
    [anon_sym_and] = ACTIONS(1417),
    [anon_sym_or] = ACTIONS(1419),
    [sym_comment] = ACTIONS(3),
  },
  [735] = {
    [sym_format_expression] = STATE(754),
    [aux_sym_format_specifier_repeat1] = STATE(754),
    [anon_sym_LBRACE] = ACTIONS(1717),
    [anon_sym_RBRACE] = ACTIONS(1719),
    [aux_sym_format_specifier_token1] = ACTIONS(1721),
    [sym_comment] = ACTIONS(1553),
  },
  [736] = {
    [anon_sym_LBRACE] = ACTIONS(1723),
    [sym_escape_sequence] = ACTIONS(1723),
    [sym__not_escape_sequence] = ACTIONS(1723),
    [sym_comment] = ACTIONS(1553),
    [sym__string_content] = ACTIONS(1725),
    [sym__string_end] = ACTIONS(1725),
  },
  [737] = {
    [anon_sym_COMMA] = ACTIONS(1727),
    [anon_sym_if] = ACTIONS(1421),
    [anon_sym_and] = ACTIONS(1417),
    [anon_sym_or] = ACTIONS(1419),
    [anon_sym_RBRACK] = ACTIONS(1727),
    [sym_comment] = ACTIONS(3),
  },
  [738] = {
    [anon_sym_if] = ACTIONS(1320),
    [anon_sym_and] = ACTIONS(1322),
    [anon_sym_or] = ACTIONS(1324),
    [sym_comment] = ACTIONS(3),
    [sym__semicolon] = ACTIONS(1729),
    [sym__newline] = ACTIONS(1729),
  },
  [739] = {
    [anon_sym_COMMA] = ACTIONS(795),
    [anon_sym_if] = ACTIONS(1421),
    [anon_sym_and] = ACTIONS(1417),
    [anon_sym_or] = ACTIONS(1419),
    [anon_sym_RBRACK] = ACTIONS(795),
    [sym_comment] = ACTIONS(3),
  },
  [740] = {
    [anon_sym_RPAREN] = ACTIONS(1731),
    [anon_sym_COMMA] = ACTIONS(1731),
    [anon_sym_if] = ACTIONS(1421),
    [anon_sym_and] = ACTIONS(1417),
    [anon_sym_or] = ACTIONS(1419),
    [sym_comment] = ACTIONS(3),
  },
  [741] = {
    [anon_sym_COMMA] = ACTIONS(1733),
    [anon_sym_if] = ACTIONS(1421),
    [anon_sym_COLON] = ACTIONS(1733),
    [anon_sym_and] = ACTIONS(1417),
    [anon_sym_or] = ACTIONS(1419),
    [sym_comment] = ACTIONS(3),
  },
  [742] = {
    [anon_sym_RPAREN] = ACTIONS(1735),
    [anon_sym_COMMA] = ACTIONS(1735),
    [anon_sym_if] = ACTIONS(1421),
    [anon_sym_and] = ACTIONS(1417),
    [anon_sym_or] = ACTIONS(1419),
    [sym_comment] = ACTIONS(3),
  },
  [743] = {
    [sym_except_clause] = STATE(179),
    [sym_finally_clause] = STATE(413),
    [aux_sym_try_statement_repeat1] = STATE(179),
    [anon_sym_except] = ACTIONS(1737),
    [anon_sym_finally] = ACTIONS(1739),
    [sym_comment] = ACTIONS(3),
  },
  [744] = {
    [sym__import_list] = STATE(944),
    [sym_aliased_import] = STATE(767),
    [sym_dotted_name] = STATE(758),
    [sym_identifier] = ACTIONS(1574),
    [anon_sym_LPAREN] = ACTIONS(1741),
    [sym_comment] = ACTIONS(3),
  },
  [745] = {
    [sym_aliased_import] = STATE(826),
    [sym_dotted_name] = STATE(790),
    [sym_identifier] = ACTIONS(1574),
    [sym_comment] = ACTIONS(3),
    [sym__semicolon] = ACTIONS(1743),
    [sym__newline] = ACTIONS(1743),
  },
  [746] = {
    [anon_sym_RPAREN] = ACTIONS(1745),
    [anon_sym_COMMA] = ACTIONS(1745),
    [anon_sym_if] = ACTIONS(1421),
    [anon_sym_and] = ACTIONS(1417),
    [anon_sym_or] = ACTIONS(1419),
    [sym_comment] = ACTIONS(3),
  },
  [747] = {
    [anon_sym_RPAREN] = ACTIONS(1747),
    [anon_sym_COMMA] = ACTIONS(1747),
    [anon_sym_if] = ACTIONS(1421),
    [anon_sym_and] = ACTIONS(1417),
    [anon_sym_or] = ACTIONS(1419),
    [sym_comment] = ACTIONS(3),
  },
  [748] = {
    [anon_sym_RPAREN] = ACTIONS(1749),
    [anon_sym_COMMA] = ACTIONS(1749),
    [anon_sym_if] = ACTIONS(1421),
    [anon_sym_and] = ACTIONS(1417),
    [anon_sym_or] = ACTIONS(1419),
    [sym_comment] = ACTIONS(3),
  },
  [749] = {
    [sym_except_clause] = STATE(191),
    [sym_finally_clause] = STATE(415),
    [aux_sym_try_statement_repeat1] = STATE(191),
    [anon_sym_except] = ACTIONS(1751),
    [anon_sym_finally] = ACTIONS(1753),
    [sym_comment] = ACTIONS(3),
  },
  [750] = {
    [anon_sym_LBRACE] = ACTIONS(1755),
    [sym_escape_sequence] = ACTIONS(1755),
    [sym__not_escape_sequence] = ACTIONS(1755),
    [sym_comment] = ACTIONS(1553),
    [sym__string_content] = ACTIONS(1757),
    [sym__string_end] = ACTIONS(1757),
  },
  [751] = {
    [anon_sym_if] = ACTIONS(1320),
    [anon_sym_and] = ACTIONS(1322),
    [anon_sym_or] = ACTIONS(1324),
    [sym_comment] = ACTIONS(3),
    [sym__semicolon] = ACTIONS(1731),
    [sym__newline] = ACTIONS(1731),
  },
  [752] = {
    [sym_except_clause] = STATE(149),
    [sym_finally_clause] = STATE(409),
    [aux_sym_try_statement_repeat1] = STATE(149),
    [anon_sym_except] = ACTIONS(1737),
    [anon_sym_finally] = ACTIONS(1739),
    [sym_comment] = ACTIONS(3),
  },
  [753] = {
    [sym_aliased_import] = STATE(826),
    [sym_dotted_name] = STATE(790),
    [sym_identifier] = ACTIONS(1574),
    [sym_comment] = ACTIONS(3),
    [sym__semicolon] = ACTIONS(1759),
    [sym__newline] = ACTIONS(1759),
  },
  [754] = {
    [sym_format_expression] = STATE(754),
    [aux_sym_format_specifier_repeat1] = STATE(754),
    [anon_sym_LBRACE] = ACTIONS(1761),
    [anon_sym_RBRACE] = ACTIONS(1764),
    [aux_sym_format_specifier_token1] = ACTIONS(1766),
    [sym_comment] = ACTIONS(1553),
  },
  [755] = {
    [anon_sym_LBRACE] = ACTIONS(1769),
    [sym_escape_sequence] = ACTIONS(1769),
    [sym__not_escape_sequence] = ACTIONS(1769),
    [sym_comment] = ACTIONS(1553),
    [sym__string_content] = ACTIONS(1771),
    [sym__string_end] = ACTIONS(1771),
  },
  [756] = {
    [anon_sym_import] = ACTIONS(1587),
    [anon_sym_DOT] = ACTIONS(1587),
    [anon_sym_RPAREN] = ACTIONS(1587),
    [anon_sym_COMMA] = ACTIONS(1587),
    [anon_sym_as] = ACTIONS(1587),
    [sym_comment] = ACTIONS(3),
  },
  [757] = {
    [anon_sym_if] = ACTIONS(1320),
    [anon_sym_and] = ACTIONS(1322),
    [anon_sym_or] = ACTIONS(1324),
    [sym_comment] = ACTIONS(3),
    [sym__semicolon] = ACTIONS(1773),
    [sym__newline] = ACTIONS(1773),
  },
  [758] = {
    [aux_sym__import_list_repeat1] = STATE(792),
    [anon_sym_COMMA] = ACTIONS(1775),
    [anon_sym_as] = ACTIONS(1777),
    [sym_comment] = ACTIONS(3),
    [sym__semicolon] = ACTIONS(1779),
    [sym__newline] = ACTIONS(1779),
  },
  [759] = {
    [aux_sym__parameters_repeat1] = STATE(864),
    [anon_sym_RPAREN] = ACTIONS(1781),
    [anon_sym_COMMA] = ACTIONS(1783),
    [anon_sym_COLON] = ACTIONS(1785),
    [anon_sym_EQ] = ACTIONS(1787),
    [sym_comment] = ACTIONS(3),
  },
  [760] = {
    [aux_sym__parameters_repeat1] = STATE(862),
    [anon_sym_RPAREN] = ACTIONS(1789),
    [anon_sym_COMMA] = ACTIONS(1791),
    [anon_sym_COLON] = ACTIONS(1793),
    [anon_sym_EQ] = ACTIONS(1795),
    [sym_comment] = ACTIONS(3),
  },
  [761] = {
    [anon_sym_COMMA] = ACTIONS(805),
    [anon_sym_if] = ACTIONS(1421),
    [anon_sym_and] = ACTIONS(1417),
    [anon_sym_or] = ACTIONS(1419),
    [anon_sym_RBRACK] = ACTIONS(805),
    [sym_comment] = ACTIONS(3),
  },
  [762] = {
    [sym_format_expression] = STATE(735),
    [aux_sym_format_specifier_repeat1] = STATE(735),
    [anon_sym_LBRACE] = ACTIONS(1717),
    [anon_sym_RBRACE] = ACTIONS(1797),
    [aux_sym_format_specifier_token1] = ACTIONS(1799),
    [sym_comment] = ACTIONS(1553),
  },
  [763] = {
    [sym_except_clause] = STATE(187),
    [sym_finally_clause] = STATE(402),
    [aux_sym_try_statement_repeat1] = STATE(187),
    [anon_sym_except] = ACTIONS(1751),
    [anon_sym_finally] = ACTIONS(1753),
    [sym_comment] = ACTIONS(3),
  },
  [764] = {
    [anon_sym_if] = ACTIONS(1421),
    [anon_sym_COLON] = ACTIONS(1801),
    [anon_sym_and] = ACTIONS(1417),
    [anon_sym_or] = ACTIONS(1419),
    [sym_comment] = ACTIONS(3),
  },
  [765] = {
    [anon_sym_async] = ACTIONS(1803),
    [anon_sym_def] = ACTIONS(1803),
    [anon_sym_class] = ACTIONS(1803),
    [anon_sym_AT] = ACTIONS(1803),
    [sym_comment] = ACTIONS(3),
  },
  [766] = {
    [aux_sym_list_repeat1] = STATE(766),
    [anon_sym_COMMA] = ACTIONS(1805),
    [anon_sym_RBRACK] = ACTIONS(1690),
    [anon_sym_RBRACE] = ACTIONS(1690),
    [sym_comment] = ACTIONS(3),
  },
  [767] = {
    [aux_sym__import_list_repeat1] = STATE(792),
    [anon_sym_COMMA] = ACTIONS(1775),
    [sym_comment] = ACTIONS(3),
    [sym__semicolon] = ACTIONS(1779),
    [sym__newline] = ACTIONS(1779),
  },
  [768] = {
    [anon_sym_if] = ACTIONS(1421),
    [anon_sym_COLON] = ACTIONS(1433),
    [anon_sym_and] = ACTIONS(1417),
    [anon_sym_or] = ACTIONS(1419),
    [sym_comment] = ACTIONS(3),
  },
  [769] = {
    [aux_sym__parameters_repeat1] = STATE(864),
    [anon_sym_RPAREN] = ACTIONS(1781),
    [anon_sym_COMMA] = ACTIONS(1783),
    [anon_sym_COLON] = ACTIONS(1808),
    [sym_comment] = ACTIONS(3),
  },
  [770] = {
    [anon_sym_if] = ACTIONS(1421),
    [anon_sym_COLON] = ACTIONS(1810),
    [anon_sym_and] = ACTIONS(1417),
    [anon_sym_or] = ACTIONS(1419),
    [sym_comment] = ACTIONS(3),
  },
  [771] = {
    [aux_sym__import_list_repeat1] = STATE(829),
    [anon_sym_RPAREN] = ACTIONS(1779),
    [anon_sym_COMMA] = ACTIONS(1812),
    [anon_sym_as] = ACTIONS(1814),
    [sym_comment] = ACTIONS(3),
  },
  [772] = {
    [anon_sym_if] = ACTIONS(1421),
    [anon_sym_COLON] = ACTIONS(1816),
    [anon_sym_and] = ACTIONS(1417),
    [anon_sym_or] = ACTIONS(1419),
    [sym_comment] = ACTIONS(3),
  },
  [773] = {
    [aux_sym_import_prefix_repeat1] = STATE(803),
    [sym_identifier] = ACTIONS(1818),
    [anon_sym_import] = ACTIONS(1818),
    [anon_sym_DOT] = ACTIONS(1820),
    [sym_comment] = ACTIONS(3),
  },
  [774] = {
    [aux_sym__import_list_repeat1] = STATE(774),
    [anon_sym_COMMA] = ACTIONS(1822),
    [sym_comment] = ACTIONS(3),
    [sym__semicolon] = ACTIONS(1825),
    [sym__newline] = ACTIONS(1825),
  },
  [775] = {
    [anon_sym_if] = ACTIONS(1421),
    [anon_sym_else] = ACTIONS(1827),
    [anon_sym_and] = ACTIONS(1417),
    [anon_sym_or] = ACTIONS(1419),
    [sym_comment] = ACTIONS(3),
  },
  [776] = {
    [anon_sym_if] = ACTIONS(1421),
    [anon_sym_COLON] = ACTIONS(1829),
    [anon_sym_and] = ACTIONS(1417),
    [anon_sym_or] = ACTIONS(1419),
    [sym_comment] = ACTIONS(3),
  },
  [777] = {
    [anon_sym_async] = ACTIONS(1831),
    [anon_sym_def] = ACTIONS(1831),
    [anon_sym_class] = ACTIONS(1831),
    [anon_sym_AT] = ACTIONS(1831),
    [sym_comment] = ACTIONS(3),
  },
  [778] = {
    [aux_sym_assert_statement_repeat1] = STATE(613),
    [anon_sym_COMMA] = ACTIONS(1597),
    [sym_comment] = ACTIONS(3),
    [sym__semicolon] = ACTIONS(1833),
    [sym__newline] = ACTIONS(1833),
  },
  [779] = {
    [anon_sym_RPAREN] = ACTIONS(1835),
    [anon_sym_COMMA] = ACTIONS(1835),
    [anon_sym_COLON] = ACTIONS(1835),
    [anon_sym_EQ] = ACTIONS(1837),
    [sym_comment] = ACTIONS(3),
  },
  [780] = {
    [anon_sym_if] = ACTIONS(1421),
    [anon_sym_COLON] = ACTIONS(1839),
    [anon_sym_and] = ACTIONS(1417),
    [anon_sym_or] = ACTIONS(1419),
    [sym_comment] = ACTIONS(3),
  },
  [781] = {
    [aux_sym_print_statement_repeat1] = STATE(787),
    [anon_sym_COMMA] = ACTIONS(1841),
    [sym_comment] = ACTIONS(3),
    [sym__semicolon] = ACTIONS(1843),
    [sym__newline] = ACTIONS(1843),
  },
  [782] = {
    [sym_aliased_import] = STATE(910),
    [sym_dotted_name] = STATE(904),
    [sym_identifier] = ACTIONS(1845),
    [anon_sym_RPAREN] = ACTIONS(1743),
    [sym_comment] = ACTIONS(3),
  },
  [783] = {
    [aux_sym__parameters_repeat1] = STATE(848),
    [anon_sym_COMMA] = ACTIONS(1847),
    [anon_sym_COLON] = ACTIONS(1781),
    [anon_sym_EQ] = ACTIONS(1787),
    [sym_comment] = ACTIONS(3),
  },
  [784] = {
    [aux_sym__parameters_repeat1] = STATE(851),
    [anon_sym_COMMA] = ACTIONS(1849),
    [anon_sym_COLON] = ACTIONS(1789),
    [anon_sym_EQ] = ACTIONS(1795),
    [sym_comment] = ACTIONS(3),
  },
  [785] = {
    [sym_aliased_import] = STATE(910),
    [sym_dotted_name] = STATE(904),
    [sym_identifier] = ACTIONS(1845),
    [anon_sym_RPAREN] = ACTIONS(1759),
    [sym_comment] = ACTIONS(3),
  },
  [786] = {
    [aux_sym_print_statement_repeat1] = STATE(787),
    [anon_sym_COMMA] = ACTIONS(1851),
    [sym_comment] = ACTIONS(3),
    [sym__semicolon] = ACTIONS(1853),
    [sym__newline] = ACTIONS(1853),
  },
  [787] = {
    [aux_sym_print_statement_repeat1] = STATE(787),
    [anon_sym_COMMA] = ACTIONS(1855),
    [sym_comment] = ACTIONS(3),
    [sym__semicolon] = ACTIONS(1858),
    [sym__newline] = ACTIONS(1858),
  },
  [788] = {
    [aux_sym_global_statement_repeat1] = STATE(796),
    [anon_sym_COMMA] = ACTIONS(1860),
    [sym_comment] = ACTIONS(3),
    [sym__semicolon] = ACTIONS(1862),
    [sym__newline] = ACTIONS(1862),
  },
  [789] = {
    [anon_sym_if] = ACTIONS(1421),
    [anon_sym_else] = ACTIONS(1864),
    [anon_sym_and] = ACTIONS(1417),
    [anon_sym_or] = ACTIONS(1419),
    [sym_comment] = ACTIONS(3),
  },
  [790] = {
    [anon_sym_COMMA] = ACTIONS(1866),
    [anon_sym_as] = ACTIONS(1777),
    [sym_comment] = ACTIONS(3),
    [sym__semicolon] = ACTIONS(1866),
    [sym__newline] = ACTIONS(1866),
  },
  [791] = {
    [aux_sym_global_statement_repeat1] = STATE(788),
    [anon_sym_COMMA] = ACTIONS(1860),
    [sym_comment] = ACTIONS(3),
    [sym__semicolon] = ACTIONS(1868),
    [sym__newline] = ACTIONS(1868),
  },
  [792] = {
    [aux_sym__import_list_repeat1] = STATE(774),
    [anon_sym_COMMA] = ACTIONS(1870),
    [sym_comment] = ACTIONS(3),
    [sym__semicolon] = ACTIONS(1872),
    [sym__newline] = ACTIONS(1872),
  },
  [793] = {
    [anon_sym_if] = ACTIONS(1421),
    [anon_sym_COLON] = ACTIONS(1874),
    [anon_sym_and] = ACTIONS(1417),
    [anon_sym_or] = ACTIONS(1419),
    [sym_comment] = ACTIONS(3),
  },
  [794] = {
    [anon_sym_if] = ACTIONS(1421),
    [anon_sym_else] = ACTIONS(1876),
    [anon_sym_and] = ACTIONS(1417),
    [anon_sym_or] = ACTIONS(1419),
    [sym_comment] = ACTIONS(3),
  },
  [795] = {
    [aux_sym_assert_statement_repeat1] = STATE(807),
    [anon_sym_RPAREN] = ACTIONS(341),
    [anon_sym_COMMA] = ACTIONS(1878),
    [anon_sym_COLON] = ACTIONS(341),
    [sym_comment] = ACTIONS(3),
  },
  [796] = {
    [aux_sym_global_statement_repeat1] = STATE(796),
    [anon_sym_COMMA] = ACTIONS(1880),
    [sym_comment] = ACTIONS(3),
    [sym__semicolon] = ACTIONS(1883),
    [sym__newline] = ACTIONS(1883),
  },
  [797] = {
    [anon_sym_if] = ACTIONS(1421),
    [anon_sym_and] = ACTIONS(1417),
    [anon_sym_or] = ACTIONS(1419),
    [anon_sym_RBRACE] = ACTIONS(1885),
    [sym_comment] = ACTIONS(3),
  },
  [798] = {
    [aux_sym_global_statement_repeat1] = STATE(799),
    [anon_sym_COMMA] = ACTIONS(1860),
    [sym_comment] = ACTIONS(3),
    [sym__semicolon] = ACTIONS(1887),
    [sym__newline] = ACTIONS(1887),
  },
  [799] = {
    [aux_sym_global_statement_repeat1] = STATE(796),
    [anon_sym_COMMA] = ACTIONS(1860),
    [sym_comment] = ACTIONS(3),
    [sym__semicolon] = ACTIONS(1889),
    [sym__newline] = ACTIONS(1889),
  },
  [800] = {
    [anon_sym_if] = ACTIONS(1421),
    [anon_sym_COLON] = ACTIONS(1891),
    [anon_sym_and] = ACTIONS(1417),
    [anon_sym_or] = ACTIONS(1419),
    [sym_comment] = ACTIONS(3),
  },
  [801] = {
    [aux_sym_assert_statement_repeat1] = STATE(613),
    [anon_sym_COMMA] = ACTIONS(1597),
    [sym_comment] = ACTIONS(3),
    [sym__semicolon] = ACTIONS(1893),
    [sym__newline] = ACTIONS(1893),
  },
  [802] = {
    [anon_sym_if] = ACTIONS(1421),
    [anon_sym_COLON] = ACTIONS(1895),
    [anon_sym_and] = ACTIONS(1417),
    [anon_sym_or] = ACTIONS(1419),
    [sym_comment] = ACTIONS(3),
  },
  [803] = {
    [aux_sym_import_prefix_repeat1] = STATE(803),
    [sym_identifier] = ACTIONS(1897),
    [anon_sym_import] = ACTIONS(1897),
    [anon_sym_DOT] = ACTIONS(1899),
    [sym_comment] = ACTIONS(3),
  },
  [804] = {
    [sym__import_list] = STATE(920),
    [sym_aliased_import] = STATE(767),
    [sym_dotted_name] = STATE(758),
    [sym_identifier] = ACTIONS(1574),
    [sym_comment] = ACTIONS(3),
  },
  [805] = {
    [aux_sym_print_statement_repeat1] = STATE(781),
    [anon_sym_COMMA] = ACTIONS(1902),
    [sym_comment] = ACTIONS(3),
    [sym__semicolon] = ACTIONS(1904),
    [sym__newline] = ACTIONS(1904),
  },
  [806] = {
    [anon_sym_RPAREN] = ACTIONS(1906),
    [anon_sym_COMMA] = ACTIONS(1906),
    [anon_sym_COLON] = ACTIONS(1793),
    [anon_sym_EQ] = ACTIONS(1795),
    [sym_comment] = ACTIONS(3),
  },
  [807] = {
    [aux_sym_assert_statement_repeat1] = STATE(807),
    [anon_sym_RPAREN] = ACTIONS(1326),
    [anon_sym_COMMA] = ACTIONS(1908),
    [anon_sym_COLON] = ACTIONS(1326),
    [sym_comment] = ACTIONS(3),
  },
  [808] = {
    [sym__import_list] = STATE(1024),
    [sym_aliased_import] = STATE(845),
    [sym_dotted_name] = STATE(771),
    [sym_identifier] = ACTIONS(1845),
    [sym_comment] = ACTIONS(3),
  },
  [809] = {
    [sym__import_list] = STATE(1023),
    [sym_aliased_import] = STATE(845),
    [sym_dotted_name] = STATE(771),
    [sym_identifier] = ACTIONS(1845),
    [sym_comment] = ACTIONS(3),
  },
  [810] = {
    [anon_sym_RPAREN] = ACTIONS(1911),
    [anon_sym_COMMA] = ACTIONS(1911),
    [anon_sym_COLON] = ACTIONS(1785),
    [anon_sym_EQ] = ACTIONS(1787),
    [sym_comment] = ACTIONS(3),
  },
  [811] = {
    [aux_sym__parameters_repeat1] = STATE(811),
    [anon_sym_COMMA] = ACTIONS(1913),
    [anon_sym_COLON] = ACTIONS(1911),
    [sym_comment] = ACTIONS(3),
  },
  [812] = {
    [anon_sym_COMMA] = ACTIONS(1690),
    [anon_sym_RBRACK] = ACTIONS(1690),
    [anon_sym_RBRACE] = ACTIONS(1690),
    [sym_comment] = ACTIONS(3),
  },
  [813] = {
    [aux_sym_argument_list_repeat1] = STATE(813),
    [anon_sym_RPAREN] = ACTIONS(1735),
    [anon_sym_COMMA] = ACTIONS(1916),
    [sym_comment] = ACTIONS(3),
  },
  [814] = {
    [sym_dotted_name] = STATE(996),
    [sym_identifier] = ACTIONS(1591),
    [anon_sym_import] = ACTIONS(1919),
    [sym_comment] = ACTIONS(3),
  },
  [815] = {
    [anon_sym_EQ] = ACTIONS(1921),
    [sym_comment] = ACTIONS(3),
    [sym__semicolon] = ACTIONS(1923),
    [sym__newline] = ACTIONS(1923),
  },
  [816] = {
    [aux_sym_dictionary_repeat1] = STATE(886),
    [anon_sym_COMMA] = ACTIONS(1925),
    [anon_sym_RBRACE] = ACTIONS(528),
    [sym_comment] = ACTIONS(3),
  },
  [817] = {
    [aux_sym_list_repeat1] = STATE(766),
    [anon_sym_COMMA] = ACTIONS(1927),
    [anon_sym_RBRACE] = ACTIONS(762),
    [sym_comment] = ACTIONS(3),
  },
  [818] = {
    [aux_sym_list_repeat1] = STATE(766),
    [anon_sym_COMMA] = ACTIONS(1929),
    [anon_sym_RBRACK] = ACTIONS(766),
    [sym_comment] = ACTIONS(3),
  },
  [819] = {
    [anon_sym_in] = ACTIONS(506),
    [sym_comment] = ACTIONS(3),
    [sym__semicolon] = ACTIONS(506),
    [sym__newline] = ACTIONS(506),
  },
  [820] = {
    [anon_sym_in] = ACTIONS(514),
    [sym_comment] = ACTIONS(3),
    [sym__semicolon] = ACTIONS(514),
    [sym__newline] = ACTIONS(514),
  },
  [821] = {
    [aux_sym_tuple_repeat1] = STATE(843),
    [anon_sym_RPAREN] = ACTIONS(754),
    [anon_sym_COMMA] = ACTIONS(1931),
    [sym_comment] = ACTIONS(3),
  },
  [822] = {
    [aux_sym_with_statement_repeat1] = STATE(837),
    [anon_sym_COMMA] = ACTIONS(1933),
    [anon_sym_COLON] = ACTIONS(1935),
    [sym_comment] = ACTIONS(3),
  },
  [823] = {
    [aux_sym__parameters_repeat1] = STATE(864),
    [anon_sym_RPAREN] = ACTIONS(1781),
    [anon_sym_COMMA] = ACTIONS(1783),
    [sym_comment] = ACTIONS(3),
  },
  [824] = {
    [aux_sym__simple_statements_repeat1] = STATE(882),
    [sym_comment] = ACTIONS(3),
    [sym__semicolon] = ACTIONS(1937),
    [sym__newline] = ACTIONS(327),
  },
  [825] = {
    [aux_sym_tuple_repeat1] = STATE(855),
    [anon_sym_RPAREN] = ACTIONS(1461),
    [anon_sym_COMMA] = ACTIONS(1463),
    [sym_comment] = ACTIONS(3),
  },
  [826] = {
    [anon_sym_COMMA] = ACTIONS(1866),
    [sym_comment] = ACTIONS(3),
    [sym__semicolon] = ACTIONS(1866),
    [sym__newline] = ACTIONS(1866),
  },
  [827] = {
    [aux_sym_with_statement_repeat1] = STATE(867),
    [anon_sym_COMMA] = ACTIONS(1933),
    [anon_sym_COLON] = ACTIONS(1935),
    [sym_comment] = ACTIONS(3),
  },
  [828] = {
    [aux_sym__simple_statements_repeat1] = STATE(844),
    [sym_comment] = ACTIONS(3),
    [sym__semicolon] = ACTIONS(1939),
    [sym__newline] = ACTIONS(1941),
  },
  [829] = {
    [aux_sym__import_list_repeat1] = STATE(887),
    [anon_sym_RPAREN] = ACTIONS(1872),
    [anon_sym_COMMA] = ACTIONS(1943),
    [sym_comment] = ACTIONS(3),
  },
  [830] = {
    [aux_sym_dictionary_repeat1] = STATE(886),
    [anon_sym_COMMA] = ACTIONS(1945),
    [anon_sym_RBRACE] = ACTIONS(670),
    [sym_comment] = ACTIONS(3),
  },
  [831] = {
    [aux_sym__simple_statements_repeat1] = STATE(891),
    [sym_comment] = ACTIONS(3),
    [sym__semicolon] = ACTIONS(1947),
    [sym__newline] = ACTIONS(1949),
  },
  [832] = {
    [aux_sym_list_repeat1] = STATE(766),
    [anon_sym_COMMA] = ACTIONS(1951),
    [anon_sym_RBRACE] = ACTIONS(764),
    [sym_comment] = ACTIONS(3),
  },
  [833] = {
    [aux_sym_tuple_repeat1] = STATE(852),
    [anon_sym_RPAREN] = ACTIONS(1469),
    [anon_sym_COMMA] = ACTIONS(1471),
    [sym_comment] = ACTIONS(3),
  },
  [834] = {
    [sym_argument_list] = STATE(1000),
    [anon_sym_LPAREN] = ACTIONS(1953),
    [anon_sym_COLON] = ACTIONS(1955),
    [sym_comment] = ACTIONS(3),
  },
  [835] = {
    [aux_sym_with_statement_repeat1] = STATE(827),
    [anon_sym_COMMA] = ACTIONS(1933),
    [anon_sym_COLON] = ACTIONS(1957),
    [sym_comment] = ACTIONS(3),
  },
  [836] = {
    [aux_sym_list_repeat1] = STATE(866),
    [anon_sym_COMMA] = ACTIONS(1457),
    [anon_sym_RBRACK] = ACTIONS(1459),
    [sym_comment] = ACTIONS(3),
  },
  [837] = {
    [aux_sym_with_statement_repeat1] = STATE(867),
    [anon_sym_COMMA] = ACTIONS(1933),
    [anon_sym_COLON] = ACTIONS(1959),
    [sym_comment] = ACTIONS(3),
  },
  [838] = {
    [anon_sym_COMMA] = ACTIONS(1961),
    [sym_comment] = ACTIONS(3),
    [sym__semicolon] = ACTIONS(1961),
    [sym__newline] = ACTIONS(1961),
  },
  [839] = {
    [aux_sym_list_repeat1] = STATE(869),
    [anon_sym_COMMA] = ACTIONS(1441),
    [anon_sym_RBRACE] = ACTIONS(1443),
    [sym_comment] = ACTIONS(3),
  },
  [840] = {
    [aux_sym_dictionary_repeat1] = STATE(871),
    [anon_sym_COMMA] = ACTIONS(1655),
    [anon_sym_RBRACE] = ACTIONS(1657),
    [sym_comment] = ACTIONS(3),
  },
  [841] = {
    [aux_sym_list_repeat1] = STATE(766),
    [anon_sym_COMMA] = ACTIONS(1963),
    [anon_sym_RBRACK] = ACTIONS(760),
    [sym_comment] = ACTIONS(3),
  },
  [842] = {
    [aux_sym_dictionary_repeat1] = STATE(816),
    [anon_sym_COMMA] = ACTIONS(1637),
    [anon_sym_RBRACE] = ACTIONS(1639),
    [sym_comment] = ACTIONS(3),
  },
  [843] = {
    [aux_sym_tuple_repeat1] = STATE(843),
    [anon_sym_RPAREN] = ACTIONS(1749),
    [anon_sym_COMMA] = ACTIONS(1965),
    [sym_comment] = ACTIONS(3),
  },
  [844] = {
    [aux_sym__simple_statements_repeat1] = STATE(882),
    [sym_comment] = ACTIONS(3),
    [sym__semicolon] = ACTIONS(1968),
    [sym__newline] = ACTIONS(331),
  },
  [845] = {
    [aux_sym__import_list_repeat1] = STATE(829),
    [anon_sym_RPAREN] = ACTIONS(1779),
    [anon_sym_COMMA] = ACTIONS(1812),
    [sym_comment] = ACTIONS(3),
  },
  [846] = {
    [aux_sym_list_repeat1] = STATE(817),
    [anon_sym_COMMA] = ACTIONS(1431),
    [anon_sym_RBRACE] = ACTIONS(1439),
    [sym_comment] = ACTIONS(3),
  },
  [847] = {
    [anon_sym_RPAREN] = ACTIONS(1911),
    [anon_sym_COMMA] = ACTIONS(1911),
    [anon_sym_COLON] = ACTIONS(1808),
    [sym_comment] = ACTIONS(3),
  },
  [848] = {
    [aux_sym__parameters_repeat1] = STATE(811),
    [anon_sym_COMMA] = ACTIONS(1970),
    [anon_sym_COLON] = ACTIONS(1425),
    [sym_comment] = ACTIONS(3),
  },
  [849] = {
    [sym_aliased_import] = STATE(910),
    [sym_dotted_name] = STATE(904),
    [sym_identifier] = ACTIONS(1845),
    [sym_comment] = ACTIONS(3),
  },
  [850] = {
    [aux_sym_list_repeat1] = STATE(818),
    [anon_sym_COMMA] = ACTIONS(1453),
    [anon_sym_RBRACK] = ACTIONS(1455),
    [sym_comment] = ACTIONS(3),
  },
  [851] = {
    [aux_sym__parameters_repeat1] = STATE(811),
    [anon_sym_COMMA] = ACTIONS(1972),
    [anon_sym_COLON] = ACTIONS(1409),
    [sym_comment] = ACTIONS(3),
  },
  [852] = {
    [aux_sym_tuple_repeat1] = STATE(843),
    [anon_sym_RPAREN] = ACTIONS(734),
    [anon_sym_COMMA] = ACTIONS(1974),
    [sym_comment] = ACTIONS(3),
  },
  [853] = {
    [aux_sym__parameters_repeat1] = STATE(811),
    [anon_sym_COMMA] = ACTIONS(1976),
    [anon_sym_COLON] = ACTIONS(1423),
    [sym_comment] = ACTIONS(3),
  },
  [854] = {
    [aux_sym_with_statement_repeat1] = STATE(867),
    [anon_sym_COMMA] = ACTIONS(1933),
    [anon_sym_COLON] = ACTIONS(1978),
    [sym_comment] = ACTIONS(3),
  },
  [855] = {
    [aux_sym_tuple_repeat1] = STATE(843),
    [anon_sym_RPAREN] = ACTIONS(722),
    [anon_sym_COMMA] = ACTIONS(1980),
    [sym_comment] = ACTIONS(3),
  },
  [856] = {
    [anon_sym_COMMA] = ACTIONS(1906),
    [anon_sym_COLON] = ACTIONS(1906),
    [anon_sym_EQ] = ACTIONS(1795),
    [sym_comment] = ACTIONS(3),
  },
  [857] = {
    [aux_sym_tuple_repeat1] = STATE(821),
    [anon_sym_RPAREN] = ACTIONS(1449),
    [anon_sym_COMMA] = ACTIONS(1451),
    [sym_comment] = ACTIONS(3),
  },
  [858] = {
    [anon_sym_for] = ACTIONS(1982),
    [anon_sym_with] = ACTIONS(1984),
    [anon_sym_def] = ACTIONS(1986),
    [sym_comment] = ACTIONS(3),
  },
  [859] = {
    [aux_sym_subscript_repeat1] = STATE(859),
    [anon_sym_COMMA] = ACTIONS(1988),
    [anon_sym_RBRACK] = ACTIONS(1705),
    [sym_comment] = ACTIONS(3),
  },
  [860] = {
    [aux_sym__parameters_repeat1] = STATE(892),
    [anon_sym_RPAREN] = ACTIONS(1423),
    [anon_sym_COMMA] = ACTIONS(1991),
    [sym_comment] = ACTIONS(3),
  },
  [861] = {
    [aux_sym__simple_statements_repeat1] = STATE(824),
    [sym_comment] = ACTIONS(3),
    [sym__semicolon] = ACTIONS(1993),
    [sym__newline] = ACTIONS(1995),
  },
  [862] = {
    [aux_sym__parameters_repeat1] = STATE(892),
    [anon_sym_RPAREN] = ACTIONS(1409),
    [anon_sym_COMMA] = ACTIONS(1997),
    [sym_comment] = ACTIONS(3),
  },
  [863] = {
    [aux_sym_subscript_repeat1] = STATE(859),
    [anon_sym_COMMA] = ACTIONS(1999),
    [anon_sym_RBRACK] = ACTIONS(2001),
    [sym_comment] = ACTIONS(3),
  },
  [864] = {
    [aux_sym__parameters_repeat1] = STATE(892),
    [anon_sym_RPAREN] = ACTIONS(1425),
    [anon_sym_COMMA] = ACTIONS(2003),
    [sym_comment] = ACTIONS(3),
  },
  [865] = {
    [aux_sym_tuple_repeat1] = STATE(852),
    [anon_sym_RPAREN] = ACTIONS(1688),
    [anon_sym_COMMA] = ACTIONS(1471),
    [sym_comment] = ACTIONS(3),
  },
  [866] = {
    [aux_sym_list_repeat1] = STATE(766),
    [anon_sym_COMMA] = ACTIONS(2005),
    [anon_sym_RBRACK] = ACTIONS(708),
    [sym_comment] = ACTIONS(3),
  },
  [867] = {
    [aux_sym_with_statement_repeat1] = STATE(867),
    [anon_sym_COMMA] = ACTIONS(2007),
    [anon_sym_COLON] = ACTIONS(2010),
    [sym_comment] = ACTIONS(3),
  },
  [868] = {
    [anon_sym_COMMA] = ACTIONS(1911),
    [anon_sym_COLON] = ACTIONS(1911),
    [anon_sym_EQ] = ACTIONS(1787),
    [sym_comment] = ACTIONS(3),
  },
  [869] = {
    [aux_sym_list_repeat1] = STATE(766),
    [anon_sym_COMMA] = ACTIONS(2012),
    [anon_sym_RBRACE] = ACTIONS(736),
    [sym_comment] = ACTIONS(3),
  },
  [870] = {
    [anon_sym_RPAREN] = ACTIONS(1911),
    [anon_sym_COMMA] = ACTIONS(1911),
    [anon_sym_COLON] = ACTIONS(1911),
    [sym_comment] = ACTIONS(3),
  },
  [871] = {
    [aux_sym_dictionary_repeat1] = STATE(886),
    [anon_sym_COMMA] = ACTIONS(2014),
    [anon_sym_RBRACE] = ACTIONS(526),
    [sym_comment] = ACTIONS(3),
  },
  [872] = {
    [aux_sym_argument_list_repeat1] = STATE(813),
    [anon_sym_RPAREN] = ACTIONS(451),
    [anon_sym_COMMA] = ACTIONS(2016),
    [sym_comment] = ACTIONS(3),
  },
  [873] = {
    [sym_format_specifier] = STATE(1022),
    [anon_sym_COLON] = ACTIONS(1621),
    [anon_sym_RBRACE] = ACTIONS(2018),
    [sym_comment] = ACTIONS(3),
  },
  [874] = {
    [aux_sym_argument_list_repeat1] = STATE(889),
    [anon_sym_RPAREN] = ACTIONS(1477),
    [anon_sym_COMMA] = ACTIONS(1479),
    [sym_comment] = ACTIONS(3),
  },
  [875] = {
    [anon_sym_from] = ACTIONS(2020),
    [sym_comment] = ACTIONS(3),
    [sym__semicolon] = ACTIONS(2022),
    [sym__newline] = ACTIONS(2022),
  },
  [876] = {
    [aux_sym_with_statement_repeat1] = STATE(854),
    [anon_sym_COMMA] = ACTIONS(1933),
    [anon_sym_COLON] = ACTIONS(2024),
    [sym_comment] = ACTIONS(3),
  },
  [877] = {
    [aux_sym_argument_list_repeat1] = STATE(897),
    [anon_sym_RPAREN] = ACTIONS(1473),
    [anon_sym_COMMA] = ACTIONS(1475),
    [sym_comment] = ACTIONS(3),
  },
  [878] = {
    [aux_sym_with_statement_repeat1] = STATE(867),
    [anon_sym_COMMA] = ACTIONS(1933),
    [anon_sym_COLON] = ACTIONS(2024),
    [sym_comment] = ACTIONS(3),
  },
  [879] = {
    [aux_sym_with_statement_repeat1] = STATE(878),
    [anon_sym_COMMA] = ACTIONS(1933),
    [anon_sym_COLON] = ACTIONS(2026),
    [sym_comment] = ACTIONS(3),
  },
  [880] = {
    [aux_sym_subscript_repeat1] = STATE(899),
    [anon_sym_COMMA] = ACTIONS(1617),
    [anon_sym_RBRACK] = ACTIONS(1619),
    [sym_comment] = ACTIONS(3),
  },
  [881] = {
    [anon_sym_RPAREN] = ACTIONS(1835),
    [anon_sym_COMMA] = ACTIONS(1835),
    [anon_sym_COLON] = ACTIONS(1835),
    [sym_comment] = ACTIONS(3),
  },
  [882] = {
    [aux_sym__simple_statements_repeat1] = STATE(882),
    [sym_comment] = ACTIONS(3),
    [sym__semicolon] = ACTIONS(2028),
    [sym__newline] = ACTIONS(2031),
  },
  [883] = {
    [anon_sym_LBRACE] = ACTIONS(2033),
    [anon_sym_RBRACE] = ACTIONS(2033),
    [aux_sym_format_specifier_token1] = ACTIONS(2033),
    [sym_comment] = ACTIONS(1553),
  },
  [884] = {
    [aux_sym_subscript_repeat1] = STATE(890),
    [anon_sym_COMMA] = ACTIONS(1541),
    [anon_sym_RBRACK] = ACTIONS(1545),
    [sym_comment] = ACTIONS(3),
  },
  [885] = {
    [anon_sym_COMMA] = ACTIONS(1883),
    [sym_comment] = ACTIONS(3),
    [sym__semicolon] = ACTIONS(1883),
    [sym__newline] = ACTIONS(1883),
  },
  [886] = {
    [aux_sym_dictionary_repeat1] = STATE(886),
    [anon_sym_COMMA] = ACTIONS(2035),
    [anon_sym_RBRACE] = ACTIONS(2038),
    [sym_comment] = ACTIONS(3),
  },
  [887] = {
    [aux_sym__import_list_repeat1] = STATE(887),
    [anon_sym_RPAREN] = ACTIONS(1825),
    [anon_sym_COMMA] = ACTIONS(2040),
    [sym_comment] = ACTIONS(3),
  },
  [888] = {
    [aux_sym_variables_repeat1] = STATE(888),
    [anon_sym_COMMA] = ACTIONS(2043),
    [anon_sym_in] = ACTIONS(1350),
    [sym_comment] = ACTIONS(3),
  },
  [889] = {
    [aux_sym_argument_list_repeat1] = STATE(813),
    [anon_sym_RPAREN] = ACTIONS(453),
    [anon_sym_COMMA] = ACTIONS(2046),
    [sym_comment] = ACTIONS(3),
  },
  [890] = {
    [aux_sym_subscript_repeat1] = STATE(859),
    [anon_sym_COMMA] = ACTIONS(2048),
    [anon_sym_RBRACK] = ACTIONS(2050),
    [sym_comment] = ACTIONS(3),
  },
  [891] = {
    [aux_sym__simple_statements_repeat1] = STATE(882),
    [sym_comment] = ACTIONS(3),
    [sym__semicolon] = ACTIONS(2052),
    [sym__newline] = ACTIONS(321),
  },
  [892] = {
    [aux_sym__parameters_repeat1] = STATE(892),
    [anon_sym_RPAREN] = ACTIONS(1911),
    [anon_sym_COMMA] = ACTIONS(2054),
    [sym_comment] = ACTIONS(3),
  },
  [893] = {
    [anon_sym_in] = ACTIONS(2057),
    [sym_comment] = ACTIONS(3),
    [sym__semicolon] = ACTIONS(2059),
    [sym__newline] = ACTIONS(2059),
  },
  [894] = {
    [sym_aliased_import] = STATE(826),
    [sym_dotted_name] = STATE(790),
    [sym_identifier] = ACTIONS(1574),
    [sym_comment] = ACTIONS(3),
  },
  [895] = {
    [sym_argument_list] = STATE(998),
    [anon_sym_LPAREN] = ACTIONS(1953),
    [anon_sym_COLON] = ACTIONS(2061),
    [sym_comment] = ACTIONS(3),
  },
  [896] = {
    [aux_sym_dictionary_repeat1] = STATE(830),
    [anon_sym_COMMA] = ACTIONS(1568),
    [anon_sym_RBRACE] = ACTIONS(1570),
    [sym_comment] = ACTIONS(3),
  },
  [897] = {
    [aux_sym_argument_list_repeat1] = STATE(813),
    [anon_sym_RPAREN] = ACTIONS(455),
    [anon_sym_COMMA] = ACTIONS(2063),
    [sym_comment] = ACTIONS(3),
  },
  [898] = {
    [aux_sym_list_repeat1] = STATE(832),
    [anon_sym_COMMA] = ACTIONS(1445),
    [anon_sym_RBRACE] = ACTIONS(1447),
    [sym_comment] = ACTIONS(3),
  },
  [899] = {
    [aux_sym_subscript_repeat1] = STATE(859),
    [anon_sym_COMMA] = ACTIONS(2065),
    [anon_sym_RBRACK] = ACTIONS(2067),
    [sym_comment] = ACTIONS(3),
  },
  [900] = {
    [aux_sym_subscript_repeat1] = STATE(863),
    [anon_sym_COMMA] = ACTIONS(1659),
    [anon_sym_RBRACK] = ACTIONS(1661),
    [sym_comment] = ACTIONS(3),
  },
  [901] = {
    [sym_argument_list] = STATE(1027),
    [anon_sym_LPAREN] = ACTIONS(2069),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(2071),
  },
  [902] = {
    [aux_sym_list_repeat1] = STATE(841),
    [anon_sym_COMMA] = ACTIONS(1481),
    [anon_sym_RBRACK] = ACTIONS(1483),
    [sym_comment] = ACTIONS(3),
  },
  [903] = {
    [anon_sym_for] = ACTIONS(2073),
    [anon_sym_with] = ACTIONS(2075),
    [anon_sym_def] = ACTIONS(2077),
    [sym_comment] = ACTIONS(3),
  },
  [904] = {
    [anon_sym_RPAREN] = ACTIONS(1866),
    [anon_sym_COMMA] = ACTIONS(1866),
    [anon_sym_as] = ACTIONS(1814),
    [sym_comment] = ACTIONS(3),
  },
  [905] = {
    [aux_sym__parameters_repeat1] = STATE(848),
    [anon_sym_COMMA] = ACTIONS(1847),
    [anon_sym_COLON] = ACTIONS(1781),
    [sym_comment] = ACTIONS(3),
  },
  [906] = {
    [aux_sym__parameters_repeat1] = STATE(848),
    [anon_sym_COMMA] = ACTIONS(1847),
    [anon_sym_COLON] = ACTIONS(1781),
    [sym_comment] = ACTIONS(3),
  },
  [907] = {
    [aux_sym_variables_repeat1] = STATE(888),
    [anon_sym_COMMA] = ACTIONS(2079),
    [anon_sym_in] = ACTIONS(2081),
    [sym_comment] = ACTIONS(3),
  },
  [908] = {
    [aux_sym_argument_list_repeat1] = STATE(872),
    [anon_sym_RPAREN] = ACTIONS(1465),
    [anon_sym_COMMA] = ACTIONS(1467),
    [sym_comment] = ACTIONS(3),
  },
  [909] = {
    [sym_comment] = ACTIONS(3),
    [sym__semicolon] = ACTIONS(2083),
    [sym__newline] = ACTIONS(2083),
  },
  [910] = {
    [anon_sym_RPAREN] = ACTIONS(1866),
    [anon_sym_COMMA] = ACTIONS(1866),
    [sym_comment] = ACTIONS(3),
  },
  [911] = {
    [sym_comment] = ACTIONS(3),
    [sym__semicolon] = ACTIONS(2085),
    [sym__newline] = ACTIONS(2085),
  },
  [912] = {
    [sym_parameters] = STATE(939),
    [anon_sym_LPAREN] = ACTIONS(2087),
    [sym_comment] = ACTIONS(3),
  },
  [913] = {
    [sym_comment] = ACTIONS(3),
    [sym__semicolon] = ACTIONS(2089),
    [sym__newline] = ACTIONS(2089),
  },
  [914] = {
    [sym_parameters] = STATE(946),
    [anon_sym_LPAREN] = ACTIONS(2087),
    [sym_comment] = ACTIONS(3),
  },
  [915] = {
    [anon_sym_COLON] = ACTIONS(2091),
    [anon_sym_DASH_GT] = ACTIONS(2091),
    [sym_comment] = ACTIONS(3),
  },
  [916] = {
    [anon_sym_RPAREN] = ACTIONS(1961),
    [anon_sym_COMMA] = ACTIONS(1961),
    [sym_comment] = ACTIONS(3),
  },
  [917] = {
    [sym_parameters] = STATE(931),
    [anon_sym_LPAREN] = ACTIONS(2087),
    [sym_comment] = ACTIONS(3),
  },
  [918] = {
    [anon_sym_COMMA] = ACTIONS(2038),
    [anon_sym_RBRACE] = ACTIONS(2038),
    [sym_comment] = ACTIONS(3),
  },
  [919] = {
    [sym_parameters] = STATE(926),
    [anon_sym_LPAREN] = ACTIONS(2087),
    [sym_comment] = ACTIONS(3),
  },
  [920] = {
    [sym_comment] = ACTIONS(3),
    [sym__semicolon] = ACTIONS(2093),
    [sym__newline] = ACTIONS(2093),
  },
  [921] = {
    [sym_comment] = ACTIONS(3),
    [sym__semicolon] = ACTIONS(2095),
    [sym__newline] = ACTIONS(2095),
  },
  [922] = {
    [sym_comment] = ACTIONS(3),
    [sym__semicolon] = ACTIONS(2097),
    [sym__newline] = ACTIONS(2097),
  },
  [923] = {
    [sym_comment] = ACTIONS(3),
    [sym__semicolon] = ACTIONS(2099),
    [sym__newline] = ACTIONS(2099),
  },
  [924] = {
    [sym_dotted_name] = STATE(901),
    [sym_identifier] = ACTIONS(1574),
    [sym_comment] = ACTIONS(3),
  },
  [925] = {
    [sym_comment] = ACTIONS(3),
    [sym__semicolon] = ACTIONS(2101),
    [sym__newline] = ACTIONS(2101),
  },
  [926] = {
    [anon_sym_COLON] = ACTIONS(2103),
    [anon_sym_DASH_GT] = ACTIONS(2105),
    [sym_comment] = ACTIONS(3),
  },
  [927] = {
    [anon_sym_COLON] = ACTIONS(2107),
    [anon_sym_DASH_GT] = ACTIONS(2107),
    [sym_comment] = ACTIONS(3),
  },
  [928] = {
    [sym_comment] = ACTIONS(3),
    [sym__semicolon] = ACTIONS(2109),
    [sym__newline] = ACTIONS(2109),
  },
  [929] = {
    [sym_comment] = ACTIONS(3),
    [sym__semicolon] = ACTIONS(2111),
    [sym__newline] = ACTIONS(2111),
  },
  [930] = {
    [anon_sym_COMMA] = ACTIONS(1911),
    [anon_sym_COLON] = ACTIONS(1911),
    [sym_comment] = ACTIONS(3),
  },
  [931] = {
    [anon_sym_COLON] = ACTIONS(2113),
    [anon_sym_DASH_GT] = ACTIONS(2115),
    [sym_comment] = ACTIONS(3),
  },
  [932] = {
    [anon_sym_except] = ACTIONS(846),
    [anon_sym_finally] = ACTIONS(846),
    [sym_comment] = ACTIONS(3),
  },
  [933] = {
    [anon_sym_RPAREN] = ACTIONS(2117),
    [anon_sym_COMMA] = ACTIONS(2117),
    [sym_comment] = ACTIONS(3),
  },
  [934] = {
    [sym_comment] = ACTIONS(3),
    [sym__semicolon] = ACTIONS(2119),
    [sym__newline] = ACTIONS(2119),
  },
  [935] = {
    [anon_sym_COMMA] = ACTIONS(2010),
    [anon_sym_COLON] = ACTIONS(2010),
    [sym_comment] = ACTIONS(3),
  },
  [936] = {
    [sym_comment] = ACTIONS(3),
    [sym__semicolon] = ACTIONS(1330),
    [sym__newline] = ACTIONS(1330),
  },
  [937] = {
    [anon_sym_except] = ACTIONS(838),
    [anon_sym_finally] = ACTIONS(838),
    [sym_comment] = ACTIONS(3),
  },
  [938] = {
    [anon_sym_RPAREN] = ACTIONS(2085),
    [anon_sym_COMMA] = ACTIONS(2085),
    [sym_comment] = ACTIONS(3),
  },
  [939] = {
    [anon_sym_COLON] = ACTIONS(2121),
    [anon_sym_DASH_GT] = ACTIONS(2123),
    [sym_comment] = ACTIONS(3),
  },
  [940] = {
    [sym_comment] = ACTIONS(3),
    [sym__semicolon] = ACTIONS(2125),
    [sym__newline] = ACTIONS(2125),
  },
  [941] = {
    [anon_sym_RPAREN] = ACTIONS(1735),
    [anon_sym_COMMA] = ACTIONS(1735),
    [sym_comment] = ACTIONS(3),
  },
  [942] = {
    [anon_sym_except] = ACTIONS(850),
    [anon_sym_finally] = ACTIONS(850),
    [sym_comment] = ACTIONS(3),
  },
  [943] = {
    [sym_comment] = ACTIONS(3),
    [sym__semicolon] = ACTIONS(2031),
    [sym__newline] = ACTIONS(2031),
  },
  [944] = {
    [sym_comment] = ACTIONS(3),
    [sym__semicolon] = ACTIONS(2127),
    [sym__newline] = ACTIONS(2127),
  },
  [945] = {
    [anon_sym_except] = ACTIONS(840),
    [anon_sym_finally] = ACTIONS(840),
    [sym_comment] = ACTIONS(3),
  },
  [946] = {
    [anon_sym_COLON] = ACTIONS(2129),
    [anon_sym_DASH_GT] = ACTIONS(2131),
    [sym_comment] = ACTIONS(3),
  },
  [947] = {
    [anon_sym_COMMA] = ACTIONS(1705),
    [anon_sym_RBRACK] = ACTIONS(1705),
    [sym_comment] = ACTIONS(3),
  },
  [948] = {
    [anon_sym_except] = ACTIONS(854),
    [anon_sym_finally] = ACTIONS(854),
    [sym_comment] = ACTIONS(3),
  },
  [949] = {
    [sym_comment] = ACTIONS(3),
    [sym__semicolon] = ACTIONS(2133),
    [sym__newline] = ACTIONS(2133),
  },
  [950] = {
    [sym_comment] = ACTIONS(3),
    [sym__semicolon] = ACTIONS(2135),
    [sym__newline] = ACTIONS(2135),
  },
  [951] = {
    [anon_sym_RPAREN] = ACTIONS(1749),
    [anon_sym_COMMA] = ACTIONS(1749),
    [sym_comment] = ACTIONS(3),
  },
  [952] = {
    [anon_sym_in] = ACTIONS(2137),
    [sym_comment] = ACTIONS(3),
  },
  [953] = {
    [anon_sym_RBRACE] = ACTIONS(1639),
    [sym_comment] = ACTIONS(3),
  },
  [954] = {
    [anon_sym_in] = ACTIONS(2139),
    [sym_comment] = ACTIONS(3),
  },
  [955] = {
    [anon_sym_COLON] = ACTIONS(2141),
    [sym_comment] = ACTIONS(3),
  },
  [956] = {
    [anon_sym_RPAREN] = ACTIONS(2143),
    [sym_comment] = ACTIONS(3),
  },
  [957] = {
    [anon_sym_in] = ACTIONS(2145),
    [sym_comment] = ACTIONS(3),
  },
  [958] = {
    [anon_sym_RPAREN] = ACTIONS(2147),
    [sym_comment] = ACTIONS(3),
  },
  [959] = {
    [anon_sym_RBRACE] = ACTIONS(2018),
    [sym_comment] = ACTIONS(3),
  },
  [960] = {
    [anon_sym_RBRACK] = ACTIONS(2149),
    [sym_comment] = ACTIONS(3),
  },
  [961] = {
    [anon_sym_COLON] = ACTIONS(2151),
    [sym_comment] = ACTIONS(3),
  },
  [962] = {
    [anon_sym_RBRACK] = ACTIONS(1455),
    [sym_comment] = ACTIONS(3),
  },
  [963] = {
    [anon_sym_import] = ACTIONS(2153),
    [sym_comment] = ACTIONS(3),
  },
  [964] = {
    [sym_identifier] = ACTIONS(2155),
    [sym_comment] = ACTIONS(3),
  },
  [965] = {
    [anon_sym_RBRACE] = ACTIONS(2157),
    [sym_comment] = ACTIONS(3),
  },
  [966] = {
    [anon_sym_RBRACE] = ACTIONS(2159),
    [sym_comment] = ACTIONS(3),
  },
  [967] = {
    [anon_sym_RPAREN] = ACTIONS(2161),
    [sym_comment] = ACTIONS(3),
  },
  [968] = {
    [sym_identifier] = ACTIONS(2163),
    [sym_comment] = ACTIONS(3),
  },
  [969] = {
    [anon_sym_RPAREN] = ACTIONS(1465),
    [sym_comment] = ACTIONS(3),
  },
  [970] = {
    [anon_sym_for] = ACTIONS(2165),
    [sym_comment] = ACTIONS(3),
  },
  [971] = {
    [anon_sym_COLON] = ACTIONS(2167),
    [sym_comment] = ACTIONS(3),
  },
  [972] = {
    [anon_sym_COLON] = ACTIONS(2169),
    [sym_comment] = ACTIONS(3),
  },
  [973] = {
    [anon_sym_RBRACK] = ACTIONS(1483),
    [sym_comment] = ACTIONS(3),
  },
  [974] = {
    [anon_sym_import] = ACTIONS(2171),
    [sym_comment] = ACTIONS(3),
  },
  [975] = {
    [anon_sym_RBRACE] = ACTIONS(1570),
    [sym_comment] = ACTIONS(3),
  },
  [976] = {
    [sym_identifier] = ACTIONS(2173),
    [sym_comment] = ACTIONS(3),
  },
  [977] = {
    [anon_sym_in] = ACTIONS(2175),
    [sym_comment] = ACTIONS(3),
  },
  [978] = {
    [anon_sym_COLON] = ACTIONS(2177),
    [sym_comment] = ACTIONS(3),
  },
  [979] = {
    [anon_sym_RPAREN] = ACTIONS(1473),
    [sym_comment] = ACTIONS(3),
  },
  [980] = {
    [anon_sym_RBRACE] = ACTIONS(2179),
    [sym_comment] = ACTIONS(3),
  },
  [981] = {
    [anon_sym_RBRACE] = ACTIONS(2181),
    [sym_comment] = ACTIONS(3),
  },
  [982] = {
    [anon_sym_RBRACK] = ACTIONS(2183),
    [sym_comment] = ACTIONS(3),
  },
  [983] = {
    [anon_sym_RPAREN] = ACTIONS(1477),
    [sym_comment] = ACTIONS(3),
  },
  [984] = {
    [anon_sym_def] = ACTIONS(2077),
    [sym_comment] = ACTIONS(3),
  },
  [985] = {
    [anon_sym_RPAREN] = ACTIONS(2185),
    [sym_comment] = ACTIONS(3),
  },
  [986] = {
    [sym_identifier] = ACTIONS(2187),
    [sym_comment] = ACTIONS(3),
  },
  [987] = {
    [sym_identifier] = ACTIONS(2189),
    [sym_comment] = ACTIONS(3),
  },
  [988] = {
    [sym_identifier] = ACTIONS(2191),
    [sym_comment] = ACTIONS(3),
  },
  [989] = {
    [sym_identifier] = ACTIONS(2193),
    [sym_comment] = ACTIONS(3),
  },
  [990] = {
    [anon_sym_RBRACE] = ACTIONS(1657),
    [sym_comment] = ACTIONS(3),
  },
  [991] = {
    [anon_sym_RBRACK] = ACTIONS(1459),
    [sym_comment] = ACTIONS(3),
  },
  [992] = {
    [anon_sym_COLON] = ACTIONS(2195),
    [sym_comment] = ACTIONS(3),
  },
  [993] = {
    [anon_sym_RPAREN] = ACTIONS(1688),
    [sym_comment] = ACTIONS(3),
  },
  [994] = {
    [ts_builtin_sym_end] = ACTIONS(2197),
    [sym_comment] = ACTIONS(3),
  },
  [995] = {
    [sym_identifier] = ACTIONS(2199),
    [sym_comment] = ACTIONS(3),
  },
  [996] = {
    [anon_sym_import] = ACTIONS(2201),
    [sym_comment] = ACTIONS(3),
  },
  [997] = {
    [anon_sym_in] = ACTIONS(2203),
    [sym_comment] = ACTIONS(3),
  },
  [998] = {
    [anon_sym_COLON] = ACTIONS(2205),
    [sym_comment] = ACTIONS(3),
  },
  [999] = {
    [anon_sym_RBRACE] = ACTIONS(2207),
    [sym_comment] = ACTIONS(3),
  },
  [1000] = {
    [anon_sym_COLON] = ACTIONS(2209),
    [sym_comment] = ACTIONS(3),
  },
  [1001] = {
    [anon_sym_RBRACE] = ACTIONS(2211),
    [sym_comment] = ACTIONS(3),
  },
  [1002] = {
    [anon_sym_RBRACK] = ACTIONS(2213),
    [sym_comment] = ACTIONS(3),
  },
  [1003] = {
    [anon_sym_COLON] = ACTIONS(2215),
    [sym_comment] = ACTIONS(3),
  },
  [1004] = {
    [anon_sym_RPAREN] = ACTIONS(2217),
    [sym_comment] = ACTIONS(3),
  },
  [1005] = {
    [anon_sym_COLON] = ACTIONS(2219),
    [sym_comment] = ACTIONS(3),
  },
  [1006] = {
    [anon_sym_COLON] = ACTIONS(2221),
    [sym_comment] = ACTIONS(3),
  },
  [1007] = {
    [anon_sym_COLON] = ACTIONS(2223),
    [sym_comment] = ACTIONS(3),
  },
  [1008] = {
    [anon_sym_in] = ACTIONS(2225),
    [sym_comment] = ACTIONS(3),
  },
  [1009] = {
    [anon_sym_COLON] = ACTIONS(2227),
    [sym_comment] = ACTIONS(3),
  },
  [1010] = {
    [anon_sym_EQ] = ACTIONS(2229),
    [sym_comment] = ACTIONS(3),
  },
  [1011] = {
    [anon_sym_COLON] = ACTIONS(2231),
    [sym_comment] = ACTIONS(3),
  },
  [1012] = {
    [anon_sym_COLON] = ACTIONS(2233),
    [sym_comment] = ACTIONS(3),
  },
  [1013] = {
    [sym_identifier] = ACTIONS(2235),
    [sym_comment] = ACTIONS(3),
  },
  [1014] = {
    [sym_identifier] = ACTIONS(2237),
    [sym_comment] = ACTIONS(3),
  },
  [1015] = {
    [sym_identifier] = ACTIONS(2239),
    [sym_comment] = ACTIONS(3),
  },
  [1016] = {
    [sym_identifier] = ACTIONS(2241),
    [sym_comment] = ACTIONS(3),
  },
  [1017] = {
    [anon_sym_COLON] = ACTIONS(2243),
    [sym_comment] = ACTIONS(3),
  },
  [1018] = {
    [anon_sym_COLON] = ACTIONS(2245),
    [sym_comment] = ACTIONS(3),
  },
  [1019] = {
    [sym_identifier] = ACTIONS(2247),
    [sym_comment] = ACTIONS(3),
  },
  [1020] = {
    [anon_sym_COLON] = ACTIONS(2249),
    [sym_comment] = ACTIONS(3),
  },
  [1021] = {
    [anon_sym_RPAREN] = ACTIONS(2251),
    [sym_comment] = ACTIONS(3),
  },
  [1022] = {
    [anon_sym_RBRACE] = ACTIONS(2253),
    [sym_comment] = ACTIONS(3),
  },
  [1023] = {
    [anon_sym_RPAREN] = ACTIONS(2255),
    [sym_comment] = ACTIONS(3),
  },
  [1024] = {
    [anon_sym_RPAREN] = ACTIONS(2257),
    [sym_comment] = ACTIONS(3),
  },
  [1025] = {
    [anon_sym_in] = ACTIONS(2259),
    [sym_comment] = ACTIONS(3),
  },
  [1026] = {
    [anon_sym_RPAREN] = ACTIONS(2261),
    [sym_comment] = ACTIONS(3),
  },
  [1027] = {
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(2263),
  },
  [1028] = {
    [anon_sym_COLON] = ACTIONS(2265),
    [sym_comment] = ACTIONS(3),
  },
  [1029] = {
    [anon_sym_COLON] = ACTIONS(2267),
    [sym_comment] = ACTIONS(3),
  },
  [1030] = {
    [sym_identifier] = ACTIONS(2269),
    [sym_comment] = ACTIONS(3),
  },
  [1031] = {
    [sym_identifier] = ACTIONS(2271),
    [sym_comment] = ACTIONS(3),
  },
  [1032] = {
    [anon_sym_in] = ACTIONS(2273),
    [sym_comment] = ACTIONS(3),
  },
  [1033] = {
    [anon_sym_def] = ACTIONS(1986),
    [sym_comment] = ACTIONS(3),
  },
  [1034] = {
    [anon_sym_in] = ACTIONS(2275),
    [sym_comment] = ACTIONS(3),
  },
  [1035] = {
    [sym_identifier] = ACTIONS(2277),
    [sym_comment] = ACTIONS(3),
  },
  [1036] = {
    [anon_sym_COLON] = ACTIONS(2279),
    [sym_comment] = ACTIONS(3),
  },
};

static TSParseActionEntry ts_parse_actions[] = {
  [0] = {.count = 0, .reusable = false},
  [1] = {.count = 1, .reusable = false}, RECOVER(),
  [3] = {.count = 1, .reusable = true}, SHIFT_EXTRA(),
  [5] = {.count = 1, .reusable = true}, REDUCE(sym_module, 0),
  [7] = {.count = 1, .reusable = false}, SHIFT(138),
  [9] = {.count = 1, .reusable = false}, SHIFT(804),
  [11] = {.count = 1, .reusable = false}, SHIFT(683),
  [13] = {.count = 1, .reusable = true}, SHIFT(181),
  [15] = {.count = 1, .reusable = false}, SHIFT(48),
  [17] = {.count = 1, .reusable = false}, SHIFT(350),
  [19] = {.count = 1, .reusable = false}, SHIFT(197),
  [21] = {.count = 1, .reusable = false}, SHIFT(258),
  [23] = {.count = 1, .reusable = false}, SHIFT(167),
  [25] = {.count = 1, .reusable = false}, SHIFT(929),
  [27] = {.count = 1, .reusable = false}, SHIFT(923),
  [29] = {.count = 1, .reusable = false}, SHIFT(909),
  [31] = {.count = 1, .reusable = false}, SHIFT(338),
  [33] = {.count = 1, .reusable = false}, SHIFT(903),
  [35] = {.count = 1, .reusable = false}, SHIFT(525),
  [37] = {.count = 1, .reusable = false}, SHIFT(333),
  [39] = {.count = 1, .reusable = false}, SHIFT(1018),
  [41] = {.count = 1, .reusable = false}, SHIFT(270),
  [43] = {.count = 1, .reusable = false}, SHIFT(1016),
  [45] = {.count = 1, .reusable = false}, SHIFT(1015),
  [47] = {.count = 1, .reusable = false}, SHIFT(1014),
  [49] = {.count = 1, .reusable = false}, SHIFT(139),
  [51] = {.count = 1, .reusable = false}, SHIFT(1013),
  [53] = {.count = 1, .reusable = true}, SHIFT(924),
  [55] = {.count = 1, .reusable = false}, SHIFT(318),
  [57] = {.count = 1, .reusable = true}, SHIFT(546),
  [59] = {.count = 1, .reusable = false}, SHIFT(619),
  [61] = {.count = 1, .reusable = false}, SHIFT(141),
  [63] = {.count = 1, .reusable = true}, SHIFT(153),
  [65] = {.count = 1, .reusable = true}, SHIFT(109),
  [67] = {.count = 1, .reusable = true}, SHIFT(121),
  [69] = {.count = 1, .reusable = false}, SHIFT(109),
  [71] = {.count = 1, .reusable = false}, SHIFT(313),
  [73] = {.count = 1, .reusable = true}, SHIFT(703),
  [75] = {.count = 1, .reusable = false}, SHIFT(328),
  [77] = {.count = 1, .reusable = false}, SHIFT(858),
  [79] = {.count = 1, .reusable = false}, SHIFT(527),
  [81] = {.count = 1, .reusable = false}, SHIFT(331),
  [83] = {.count = 1, .reusable = false}, SHIFT(1017),
  [85] = {.count = 1, .reusable = false}, SHIFT(269),
  [87] = {.count = 1, .reusable = false}, SHIFT(1030),
  [89] = {.count = 1, .reusable = false}, SHIFT(1019),
  [91] = {.count = 1, .reusable = true}, SHIFT(267),
  [93] = {.count = 1, .reusable = true}, SHIFT(261),
  [95] = {.count = 1, .reusable = true}, SHIFT(942),
  [97] = {.count = 1, .reusable = true}, REDUCE(sym_module, 1),
  [99] = {.count = 1, .reusable = true}, SHIFT(945),
  [101] = {.count = 1, .reusable = true}, SHIFT(257),
  [103] = {.count = 1, .reusable = true}, REDUCE(aux_sym_module_repeat1, 2),
  [105] = {.count = 2, .reusable = false}, REDUCE(aux_sym_module_repeat1, 2), SHIFT_REPEAT(138),
  [108] = {.count = 2, .reusable = false}, REDUCE(aux_sym_module_repeat1, 2), SHIFT_REPEAT(804),
  [111] = {.count = 2, .reusable = false}, REDUCE(aux_sym_module_repeat1, 2), SHIFT_REPEAT(683),
  [114] = {.count = 2, .reusable = true}, REDUCE(aux_sym_module_repeat1, 2), SHIFT_REPEAT(181),
  [117] = {.count = 2, .reusable = false}, REDUCE(aux_sym_module_repeat1, 2), SHIFT_REPEAT(48),
  [120] = {.count = 2, .reusable = false}, REDUCE(aux_sym_module_repeat1, 2), SHIFT_REPEAT(350),
  [123] = {.count = 2, .reusable = false}, REDUCE(aux_sym_module_repeat1, 2), SHIFT_REPEAT(197),
  [126] = {.count = 2, .reusable = false}, REDUCE(aux_sym_module_repeat1, 2), SHIFT_REPEAT(258),
  [129] = {.count = 2, .reusable = false}, REDUCE(aux_sym_module_repeat1, 2), SHIFT_REPEAT(167),
  [132] = {.count = 2, .reusable = false}, REDUCE(aux_sym_module_repeat1, 2), SHIFT_REPEAT(929),
  [135] = {.count = 2, .reusable = false}, REDUCE(aux_sym_module_repeat1, 2), SHIFT_REPEAT(923),
  [138] = {.count = 2, .reusable = false}, REDUCE(aux_sym_module_repeat1, 2), SHIFT_REPEAT(909),
  [141] = {.count = 2, .reusable = false}, REDUCE(aux_sym_module_repeat1, 2), SHIFT_REPEAT(338),
  [144] = {.count = 2, .reusable = false}, REDUCE(aux_sym_module_repeat1, 2), SHIFT_REPEAT(903),
  [147] = {.count = 2, .reusable = false}, REDUCE(aux_sym_module_repeat1, 2), SHIFT_REPEAT(525),
  [150] = {.count = 2, .reusable = false}, REDUCE(aux_sym_module_repeat1, 2), SHIFT_REPEAT(333),
  [153] = {.count = 2, .reusable = false}, REDUCE(aux_sym_module_repeat1, 2), SHIFT_REPEAT(1018),
  [156] = {.count = 2, .reusable = false}, REDUCE(aux_sym_module_repeat1, 2), SHIFT_REPEAT(270),
  [159] = {.count = 2, .reusable = false}, REDUCE(aux_sym_module_repeat1, 2), SHIFT_REPEAT(1016),
  [162] = {.count = 2, .reusable = false}, REDUCE(aux_sym_module_repeat1, 2), SHIFT_REPEAT(1015),
  [165] = {.count = 2, .reusable = false}, REDUCE(aux_sym_module_repeat1, 2), SHIFT_REPEAT(1014),
  [168] = {.count = 2, .reusable = false}, REDUCE(aux_sym_module_repeat1, 2), SHIFT_REPEAT(139),
  [171] = {.count = 2, .reusable = false}, REDUCE(aux_sym_module_repeat1, 2), SHIFT_REPEAT(1013),
  [174] = {.count = 2, .reusable = true}, REDUCE(aux_sym_module_repeat1, 2), SHIFT_REPEAT(924),
  [177] = {.count = 2, .reusable = false}, REDUCE(aux_sym_module_repeat1, 2), SHIFT_REPEAT(318),
  [180] = {.count = 2, .reusable = true}, REDUCE(aux_sym_module_repeat1, 2), SHIFT_REPEAT(546),
  [183] = {.count = 2, .reusable = false}, REDUCE(aux_sym_module_repeat1, 2), SHIFT_REPEAT(619),
  [186] = {.count = 2, .reusable = false}, REDUCE(aux_sym_module_repeat1, 2), SHIFT_REPEAT(141),
  [189] = {.count = 2, .reusable = true}, REDUCE(aux_sym_module_repeat1, 2), SHIFT_REPEAT(153),
  [192] = {.count = 2, .reusable = true}, REDUCE(aux_sym_module_repeat1, 2), SHIFT_REPEAT(109),
  [195] = {.count = 2, .reusable = true}, REDUCE(aux_sym_module_repeat1, 2), SHIFT_REPEAT(121),
  [198] = {.count = 2, .reusable = false}, REDUCE(aux_sym_module_repeat1, 2), SHIFT_REPEAT(109),
  [201] = {.count = 2, .reusable = false}, REDUCE(aux_sym_module_repeat1, 2), SHIFT_REPEAT(313),
  [204] = {.count = 2, .reusable = true}, REDUCE(aux_sym_module_repeat1, 2), SHIFT_REPEAT(703),
  [207] = {.count = 2, .reusable = false}, REDUCE(aux_sym_module_repeat1, 2), SHIFT_REPEAT(328),
  [210] = {.count = 2, .reusable = false}, REDUCE(aux_sym_module_repeat1, 2), SHIFT_REPEAT(858),
  [213] = {.count = 2, .reusable = false}, REDUCE(aux_sym_module_repeat1, 2), SHIFT_REPEAT(527),
  [216] = {.count = 2, .reusable = false}, REDUCE(aux_sym_module_repeat1, 2), SHIFT_REPEAT(331),
  [219] = {.count = 2, .reusable = false}, REDUCE(aux_sym_module_repeat1, 2), SHIFT_REPEAT(1017),
  [222] = {.count = 2, .reusable = false}, REDUCE(aux_sym_module_repeat1, 2), SHIFT_REPEAT(269),
  [225] = {.count = 2, .reusable = false}, REDUCE(aux_sym_module_repeat1, 2), SHIFT_REPEAT(1030),
  [228] = {.count = 2, .reusable = false}, REDUCE(aux_sym_module_repeat1, 2), SHIFT_REPEAT(1019),
  [231] = {.count = 1, .reusable = true}, SHIFT(264),
  [233] = {.count = 1, .reusable = false}, REDUCE(sym__primary_expression, 1, .production_id = 1),
  [235] = {.count = 1, .reusable = true}, REDUCE(sym__primary_expression, 1, .production_id = 1),
  [237] = {.count = 1, .reusable = false}, SHIFT(174),
  [239] = {.count = 1, .reusable = false}, SHIFT(299),
  [241] = {.count = 1, .reusable = true}, SHIFT(37),
  [243] = {.count = 1, .reusable = true}, SHIFT(16),
  [245] = {.count = 1, .reusable = true}, SHIFT(22),
  [247] = {.count = 1, .reusable = true}, SHIFT(39),
  [249] = {.count = 1, .reusable = true}, SHIFT(2),
  [251] = {.count = 1, .reusable = true}, SHIFT(17),
  [253] = {.count = 1, .reusable = true}, SHIFT(15),
  [255] = {.count = 1, .reusable = true}, SHIFT(23),
  [257] = {.count = 1, .reusable = true}, SHIFT(25),
  [259] = {.count = 1, .reusable = true}, SHIFT(32),
  [261] = {.count = 1, .reusable = true}, SHIFT(5),
  [263] = {.count = 1, .reusable = true}, SHIFT(7),
  [265] = {.count = 1, .reusable = true}, SHIFT(14),
  [267] = {.count = 1, .reusable = true}, SHIFT(19),
  [269] = {.count = 1, .reusable = true}, SHIFT(3),
  [271] = {.count = 1, .reusable = true}, SHIFT(21),
  [273] = {.count = 1, .reusable = true}, SHIFT(18),
  [275] = {.count = 1, .reusable = true}, SHIFT(26),
  [277] = {.count = 1, .reusable = true}, SHIFT(29),
  [279] = {.count = 1, .reusable = true}, SHIFT(6),
  [281] = {.count = 1, .reusable = true}, SHIFT(8),
  [283] = {.count = 1, .reusable = true}, SHIFT(10),
  [285] = {.count = 1, .reusable = true}, SHIFT(9),
  [287] = {.count = 1, .reusable = true}, SHIFT(27),
  [289] = {.count = 1, .reusable = true}, SHIFT(31),
  [291] = {.count = 1, .reusable = true}, SHIFT(20),
  [293] = {.count = 1, .reusable = true}, SHIFT(11),
  [295] = {.count = 1, .reusable = true}, SHIFT(24),
  [297] = {.count = 1, .reusable = true}, SHIFT(13),
  [299] = {.count = 1, .reusable = true}, SHIFT(12),
  [301] = {.count = 1, .reusable = true}, SHIFT(41),
  [303] = {.count = 1, .reusable = true}, SHIFT(30),
  [305] = {.count = 1, .reusable = true}, SHIFT(33),
  [307] = {.count = 1, .reusable = true}, SHIFT(4),
  [309] = {.count = 1, .reusable = true}, SHIFT(34),
  [311] = {.count = 1, .reusable = true}, SHIFT(35),
  [313] = {.count = 1, .reusable = true}, SHIFT(38),
  [315] = {.count = 1, .reusable = true}, SHIFT(40),
  [317] = {.count = 1, .reusable = true}, SHIFT(36),
  [319] = {.count = 1, .reusable = true}, SHIFT(28),
  [321] = {.count = 1, .reusable = true}, SHIFT(282),
  [323] = {.count = 1, .reusable = true}, SHIFT(263),
  [325] = {.count = 1, .reusable = true}, SHIFT(948),
  [327] = {.count = 1, .reusable = true}, SHIFT(260),
  [329] = {.count = 1, .reusable = true}, SHIFT(262),
  [331] = {.count = 1, .reusable = true}, SHIFT(932),
  [333] = {.count = 1, .reusable = false}, REDUCE(sym_expression_list, 3),
  [335] = {.count = 1, .reusable = true}, REDUCE(sym_expression_list, 3),
  [337] = {.count = 1, .reusable = false}, SHIFT(546),
  [339] = {.count = 1, .reusable = false}, REDUCE(sym_expression_list, 2),
  [341] = {.count = 1, .reusable = true}, REDUCE(sym_expression_list, 2),
  [343] = {.count = 1, .reusable = true}, REDUCE(sym_expression_statement, 2),
  [345] = {.count = 1, .reusable = true}, REDUCE(sym_expression_statement, 3),
  [347] = {.count = 1, .reusable = false}, SHIFT(504),
  [349] = {.count = 1, .reusable = true}, SHIFT(116),
  [351] = {.count = 1, .reusable = true}, SHIFT(160),
  [353] = {.count = 1, .reusable = true}, SHIFT(983),
  [355] = {.count = 1, .reusable = false}, SHIFT(311),
  [357] = {.count = 1, .reusable = false}, SHIFT(511),
  [359] = {.count = 1, .reusable = true}, SHIFT(288),
  [361] = {.count = 1, .reusable = false}, SHIFT(343),
  [363] = {.count = 1, .reusable = true}, SHIFT(533),
  [365] = {.count = 1, .reusable = false}, SHIFT(621),
  [367] = {.count = 1, .reusable = true}, SHIFT(150),
  [369] = {.count = 1, .reusable = true}, SHIFT(383),
  [371] = {.count = 1, .reusable = true}, SHIFT(110),
  [373] = {.count = 1, .reusable = false}, SHIFT(383),
  [375] = {.count = 1, .reusable = false}, SHIFT(308),
  [377] = {.count = 1, .reusable = true}, SHIFT(687),
  [379] = {.count = 1, .reusable = true}, SHIFT(489),
  [381] = {.count = 1, .reusable = true}, SHIFT(979),
  [383] = {.count = 1, .reusable = true}, SHIFT(578),
  [385] = {.count = 1, .reusable = true}, SHIFT(969),
  [387] = {.count = 1, .reusable = false}, SHIFT(469),
  [389] = {.count = 1, .reusable = true}, SHIFT(151),
  [391] = {.count = 1, .reusable = true}, REDUCE(sym_for_in_clause, 7, .production_id = 84),
  [393] = {.count = 1, .reusable = false}, SHIFT(482),
  [395] = {.count = 1, .reusable = false}, REDUCE(sym_for_in_clause, 7, .production_id = 84),
  [397] = {.count = 1, .reusable = false}, SHIFT(620),
  [399] = {.count = 1, .reusable = true}, REDUCE(sym_for_in_clause, 6, .production_id = 75),
  [401] = {.count = 1, .reusable = false}, REDUCE(sym_for_in_clause, 6, .production_id = 75),
  [403] = {.count = 1, .reusable = true}, REDUCE(sym_for_in_clause, 6, .production_id = 74),
  [405] = {.count = 1, .reusable = false}, REDUCE(sym_for_in_clause, 6, .production_id = 74),
  [407] = {.count = 1, .reusable = true}, REDUCE(sym_for_in_clause, 5, .production_id = 59),
  [409] = {.count = 1, .reusable = false}, REDUCE(sym_for_in_clause, 5, .production_id = 59),
  [411] = {.count = 1, .reusable = true}, SHIFT(976),
  [413] = {.count = 1, .reusable = true}, REDUCE(sym__expression, 1),
  [415] = {.count = 1, .reusable = true}, SHIFT(104),
  [417] = {.count = 1, .reusable = false}, SHIFT(530),
  [419] = {.count = 1, .reusable = false}, SHIFT(562),
  [421] = {.count = 1, .reusable = true}, SHIFT(556),
  [423] = {.count = 1, .reusable = false}, REDUCE(sym__expression, 1),
  [425] = {.count = 1, .reusable = false}, SHIFT(555),
  [427] = {.count = 1, .reusable = true}, SHIFT(977),
  [429] = {.count = 1, .reusable = false}, SHIFT(552),
  [431] = {.count = 1, .reusable = false}, SHIFT(560),
  [433] = {.count = 1, .reusable = false}, SHIFT(551),
  [435] = {.count = 1, .reusable = false}, SHIFT(550),
  [437] = {.count = 1, .reusable = false}, SHIFT(556),
  [439] = {.count = 1, .reusable = true}, SHIFT(509),
  [441] = {.count = 1, .reusable = true}, SHIFT(246),
  [443] = {.count = 1, .reusable = true}, SHIFT(990),
  [445] = {.count = 1, .reusable = true}, SHIFT(499),
  [447] = {.count = 1, .reusable = true}, SHIFT(953),
  [449] = {.count = 1, .reusable = true}, SHIFT(584),
  [451] = {.count = 1, .reusable = true}, SHIFT(580),
  [453] = {.count = 1, .reusable = true}, SHIFT(173),
  [455] = {.count = 1, .reusable = true}, SHIFT(501),
  [457] = {.count = 1, .reusable = true}, SHIFT(166),
  [459] = {.count = 1, .reusable = true}, SHIFT(496),
  [461] = {.count = 1, .reusable = true}, SHIFT(993),
  [463] = {.count = 1, .reusable = true}, SHIFT(311),
  [465] = {.count = 1, .reusable = false}, SHIFT(189),
  [467] = {.count = 1, .reusable = true}, REDUCE(sym__primary_expression, 1),
  [469] = {.count = 1, .reusable = false}, REDUCE(sym__primary_expression, 1),
  [471] = {.count = 1, .reusable = true}, SHIFT(570),
  [473] = {.count = 1, .reusable = true}, SHIFT(498),
  [475] = {.count = 1, .reusable = true}, REDUCE(aux_sym_concatenated_string_repeat1, 2),
  [477] = {.count = 1, .reusable = false}, REDUCE(aux_sym_concatenated_string_repeat1, 2),
  [479] = {.count = 2, .reusable = true}, REDUCE(aux_sym_concatenated_string_repeat1, 2), SHIFT_REPEAT(703),
  [482] = {.count = 1, .reusable = true}, SHIFT(975),
  [484] = {.count = 1, .reusable = true}, SHIFT(164),
  [486] = {.count = 1, .reusable = true}, REDUCE(sym_concatenated_string, 2),
  [488] = {.count = 1, .reusable = false}, REDUCE(sym_concatenated_string, 2),
  [490] = {.count = 1, .reusable = true}, REDUCE(sym_unary_operator, 2, .production_id = 7),
  [492] = {.count = 1, .reusable = false}, REDUCE(sym_unary_operator, 2, .production_id = 7),
  [494] = {.count = 1, .reusable = true}, REDUCE(sym_binary_operator, 3, .production_id = 19),
  [496] = {.count = 1, .reusable = false}, REDUCE(sym_binary_operator, 3, .production_id = 19),
  [498] = {.count = 1, .reusable = true}, REDUCE(aux_sym_comparison_operator_repeat1, 2),
  [500] = {.count = 1, .reusable = false}, REDUCE(aux_sym_comparison_operator_repeat1, 2),
  [502] = {.count = 1, .reusable = true}, REDUCE(aux_sym_comparison_operator_repeat1, 3),
  [504] = {.count = 1, .reusable = false}, REDUCE(aux_sym_comparison_operator_repeat1, 3),
  [506] = {.count = 1, .reusable = true}, REDUCE(sym_string, 2),
  [508] = {.count = 1, .reusable = false}, REDUCE(sym_string, 2),
  [510] = {.count = 1, .reusable = true}, SHIFT(326),
  [512] = {.count = 1, .reusable = true}, SHIFT(692),
  [514] = {.count = 1, .reusable = true}, REDUCE(sym_string, 3),
  [516] = {.count = 1, .reusable = false}, REDUCE(sym_string, 3),
  [518] = {.count = 1, .reusable = false}, SHIFT(287),
  [520] = {.count = 1, .reusable = true}, REDUCE(sym_yield, 1),
  [522] = {.count = 1, .reusable = true}, REDUCE(sym_dictionary_comprehension, 4, .production_id = 26),
  [524] = {.count = 1, .reusable = false}, REDUCE(sym_dictionary_comprehension, 4, .production_id = 26),
  [526] = {.count = 1, .reusable = true}, SHIFT(480),
  [528] = {.count = 1, .reusable = true}, SHIFT(589),
  [530] = {.count = 1, .reusable = true}, REDUCE(sym_call, 2, .production_id = 9),
  [532] = {.count = 1, .reusable = false}, REDUCE(sym_call, 2, .production_id = 9),
  [534] = {.count = 1, .reusable = true}, SHIFT(581),
  [536] = {.count = 1, .reusable = true}, REDUCE(sym_list_comprehension, 4, .production_id = 26),
  [538] = {.count = 1, .reusable = false}, REDUCE(sym_list_comprehension, 4, .production_id = 26),
  [540] = {.count = 1, .reusable = true}, REDUCE(sym_set, 5),
  [542] = {.count = 1, .reusable = false}, REDUCE(sym_set, 5),
  [544] = {.count = 1, .reusable = true}, REDUCE(sym_try_statement, 4, .production_id = 31),
  [546] = {.count = 1, .reusable = false}, REDUCE(sym_try_statement, 4, .production_id = 31),
  [548] = {.count = 1, .reusable = false}, SHIFT(1028),
  [550] = {.count = 1, .reusable = false}, SHIFT(253),
  [552] = {.count = 1, .reusable = false}, SHIFT(1036),
  [554] = {.count = 1, .reusable = true}, SHIFT(991),
  [556] = {.count = 1, .reusable = true}, SHIFT(485),
  [558] = {.count = 1, .reusable = true}, REDUCE(sym_subscript, 6, .production_id = 56),
  [560] = {.count = 1, .reusable = false}, REDUCE(sym_subscript, 6, .production_id = 56),
  [562] = {.count = 1, .reusable = true}, SHIFT(973),
  [564] = {.count = 1, .reusable = true}, SHIFT(170),
  [566] = {.count = 1, .reusable = true}, REDUCE(sym_tuple, 3),
  [568] = {.count = 1, .reusable = false}, REDUCE(sym_tuple, 3),
  [570] = {.count = 1, .reusable = true}, REDUCE(sym_parenthesized_expression, 3),
  [572] = {.count = 1, .reusable = false}, REDUCE(sym_parenthesized_expression, 3),
  [574] = {.count = 1, .reusable = true}, REDUCE(sym_dictionary, 4),
  [576] = {.count = 1, .reusable = false}, REDUCE(sym_dictionary, 4),
  [578] = {.count = 1, .reusable = true}, SHIFT(962),
  [580] = {.count = 1, .reusable = true}, SHIFT(582),
  [582] = {.count = 1, .reusable = true}, REDUCE(sym_list, 5),
  [584] = {.count = 1, .reusable = false}, REDUCE(sym_list, 5),
  [586] = {.count = 1, .reusable = true}, SHIFT(165),
  [588] = {.count = 1, .reusable = true}, REDUCE(sym_argument_list, 2),
  [590] = {.count = 1, .reusable = false}, REDUCE(sym_argument_list, 2),
  [592] = {.count = 1, .reusable = true}, SHIFT(495),
  [594] = {.count = 1, .reusable = true}, REDUCE(sym_attribute, 3, .production_id = 20),
  [596] = {.count = 1, .reusable = false}, REDUCE(sym_attribute, 3, .production_id = 20),
  [598] = {.count = 1, .reusable = true}, REDUCE(sym_set_comprehension, 4, .production_id = 26),
  [600] = {.count = 1, .reusable = false}, REDUCE(sym_set_comprehension, 4, .production_id = 26),
  [602] = {.count = 1, .reusable = true}, REDUCE(sym_dictionary, 2),
  [604] = {.count = 1, .reusable = false}, REDUCE(sym_dictionary, 2),
  [606] = {.count = 1, .reusable = true}, REDUCE(sym_dictionary, 5),
  [608] = {.count = 1, .reusable = false}, REDUCE(sym_dictionary, 5),
  [610] = {.count = 1, .reusable = true}, REDUCE(sym_argument_list, 5),
  [612] = {.count = 1, .reusable = false}, REDUCE(sym_argument_list, 5),
  [614] = {.count = 1, .reusable = false}, SHIFT(295),
  [616] = {.count = 1, .reusable = true}, REDUCE(sym_raise_statement, 1),
  [618] = {.count = 1, .reusable = true}, REDUCE(sym_subscript, 4, .production_id = 42),
  [620] = {.count = 1, .reusable = false}, REDUCE(sym_subscript, 4, .production_id = 42),
  [622] = {.count = 1, .reusable = true}, SHIFT(573),
  [624] = {.count = 1, .reusable = true}, SHIFT(967),
  [626] = {.count = 1, .reusable = true}, REDUCE(sym_list, 2),
  [628] = {.count = 1, .reusable = false}, REDUCE(sym_list, 2),
  [630] = {.count = 1, .reusable = true}, REDUCE(sym_generator_expression, 4, .production_id = 26),
  [632] = {.count = 1, .reusable = false}, REDUCE(sym_generator_expression, 4, .production_id = 26),
  [634] = {.count = 1, .reusable = true}, REDUCE(sym_tuple, 2),
  [636] = {.count = 1, .reusable = false}, REDUCE(sym_tuple, 2),
  [638] = {.count = 1, .reusable = true}, REDUCE(sym_argument_list, 4),
  [640] = {.count = 1, .reusable = false}, REDUCE(sym_argument_list, 4),
  [642] = {.count = 1, .reusable = true}, REDUCE(sym_argument_list, 3),
  [644] = {.count = 1, .reusable = false}, REDUCE(sym_argument_list, 3),
  [646] = {.count = 1, .reusable = true}, REDUCE(sym_subscript, 5, .production_id = 56),
  [648] = {.count = 1, .reusable = false}, REDUCE(sym_subscript, 5, .production_id = 56),
  [650] = {.count = 1, .reusable = true}, REDUCE(sym_set, 4),
  [652] = {.count = 1, .reusable = false}, REDUCE(sym_set, 4),
  [654] = {.count = 1, .reusable = true}, REDUCE(sym_try_statement, 5, .production_id = 50),
  [656] = {.count = 1, .reusable = false}, REDUCE(sym_try_statement, 5, .production_id = 50),
  [658] = {.count = 1, .reusable = true}, REDUCE(sym_tuple, 5),
  [660] = {.count = 1, .reusable = false}, REDUCE(sym_tuple, 5),
  [662] = {.count = 1, .reusable = true}, SHIFT(172),
  [664] = {.count = 1, .reusable = true}, SHIFT(958),
  [666] = {.count = 1, .reusable = true}, REDUCE(sym_list, 3),
  [668] = {.count = 1, .reusable = false}, REDUCE(sym_list, 3),
  [670] = {.count = 1, .reusable = true}, SHIFT(156),
  [672] = {.count = 1, .reusable = true}, REDUCE(sym_tuple, 4),
  [674] = {.count = 1, .reusable = false}, REDUCE(sym_tuple, 4),
  [676] = {.count = 1, .reusable = true}, REDUCE(sym_set, 3),
  [678] = {.count = 1, .reusable = false}, REDUCE(sym_set, 3),
  [680] = {.count = 1, .reusable = true}, REDUCE(sym_list, 4),
  [682] = {.count = 1, .reusable = false}, REDUCE(sym_list, 4),
  [684] = {.count = 1, .reusable = false}, SHIFT(1006),
  [686] = {.count = 1, .reusable = false}, SHIFT(276),
  [688] = {.count = 1, .reusable = false}, SHIFT(1005),
  [690] = {.count = 1, .reusable = true}, REDUCE(sym_dictionary, 3),
  [692] = {.count = 1, .reusable = false}, REDUCE(sym_dictionary, 3),
  [694] = {.count = 1, .reusable = false}, SHIFT(317),
  [696] = {.count = 1, .reusable = true}, REDUCE(sym_subscript, 5, .production_id = 42),
  [698] = {.count = 1, .reusable = false}, REDUCE(sym_subscript, 5, .production_id = 42),
  [700] = {.count = 1, .reusable = true}, SHIFT(199),
  [702] = {.count = 1, .reusable = true}, SHIFT(486),
  [704] = {.count = 1, .reusable = true}, SHIFT(502),
  [706] = {.count = 1, .reusable = true}, SHIFT(473),
  [708] = {.count = 1, .reusable = true}, SHIFT(478),
  [710] = {.count = 1, .reusable = true}, SHIFT(158),
  [712] = {.count = 1, .reusable = true}, REDUCE(sym_return_statement, 1),
  [714] = {.count = 1, .reusable = true}, REDUCE(sym_slice, 2),
  [716] = {.count = 1, .reusable = true}, SHIFT(236),
  [718] = {.count = 1, .reusable = true}, REDUCE(sym_slice, 1),
  [720] = {.count = 1, .reusable = true}, SHIFT(244),
  [722] = {.count = 1, .reusable = true}, SHIFT(184),
  [724] = {.count = 1, .reusable = true}, SHIFT(190),
  [726] = {.count = 1, .reusable = true}, SHIFT(493),
  [728] = {.count = 1, .reusable = true}, REDUCE(aux_sym__parameters_repeat1, 2, .production_id = 36),
  [730] = {.count = 1, .reusable = true}, SHIFT(494),
  [732] = {.count = 1, .reusable = true}, SHIFT(148),
  [734] = {.count = 1, .reusable = true}, SHIFT(492),
  [736] = {.count = 1, .reusable = true}, SHIFT(479),
  [738] = {.count = 1, .reusable = true}, SHIFT(152),
  [740] = {.count = 1, .reusable = true}, SHIFT(639),
  [742] = {.count = 1, .reusable = true}, REDUCE(sym__parameters, 1, .production_id = 8),
  [744] = {.count = 1, .reusable = true}, SHIFT(180),
  [746] = {.count = 1, .reusable = true}, SHIFT(629),
  [748] = {.count = 1, .reusable = true}, SHIFT(567),
  [750] = {.count = 1, .reusable = true}, SHIFT(579),
  [752] = {.count = 1, .reusable = true}, SHIFT(594),
  [754] = {.count = 1, .reusable = true}, SHIFT(583),
  [756] = {.count = 1, .reusable = true}, SHIFT(595),
  [758] = {.count = 1, .reusable = true}, SHIFT(596),
  [760] = {.count = 1, .reusable = true}, SHIFT(186),
  [762] = {.count = 1, .reusable = true}, SHIFT(588),
  [764] = {.count = 1, .reusable = true}, SHIFT(177),
  [766] = {.count = 1, .reusable = true}, SHIFT(586),
  [768] = {.count = 1, .reusable = true}, REDUCE(sym_if_statement, 4, .production_id = 29),
  [770] = {.count = 1, .reusable = false}, REDUCE(sym_if_statement, 4, .production_id = 29),
  [772] = {.count = 1, .reusable = false}, SHIFT(322),
  [774] = {.count = 1, .reusable = false}, REDUCE(sym_if_statement, 6, .production_id = 61),
  [776] = {.count = 1, .reusable = true}, REDUCE(sym_if_statement, 6, .production_id = 61),
  [778] = {.count = 1, .reusable = false}, SHIFT(352),
  [780] = {.count = 1, .reusable = true}, REDUCE(sym_print_statement, 4, .production_id = 13),
  [782] = {.count = 1, .reusable = true}, REDUCE(sym_print_statement, 4, .production_id = 12),
  [784] = {.count = 1, .reusable = true}, REDUCE(aux_sym_try_statement_repeat1, 2),
  [786] = {.count = 1, .reusable = false}, REDUCE(aux_sym_try_statement_repeat1, 2),
  [788] = {.count = 2, .reusable = false}, REDUCE(aux_sym_try_statement_repeat1, 2), SHIFT_REPEAT(253),
  [791] = {.count = 1, .reusable = true}, REDUCE(sym_if_statement, 5, .production_id = 46),
  [793] = {.count = 1, .reusable = false}, REDUCE(sym_if_statement, 5, .production_id = 46),
  [795] = {.count = 1, .reusable = true}, REDUCE(sym_slice, 3),
  [797] = {.count = 1, .reusable = true}, REDUCE(sym_if_statement, 5, .production_id = 43),
  [799] = {.count = 1, .reusable = false}, REDUCE(sym_if_statement, 5, .production_id = 43),
  [801] = {.count = 1, .reusable = true}, REDUCE(sym_print_statement, 3, .production_id = 4),
  [803] = {.count = 1, .reusable = true}, REDUCE(sym_print_statement, 3),
  [805] = {.count = 1, .reusable = true}, REDUCE(sym_slice, 4),
  [807] = {.count = 2, .reusable = false}, REDUCE(aux_sym_try_statement_repeat1, 2), SHIFT_REPEAT(276),
  [810] = {.count = 1, .reusable = false}, SHIFT(547),
  [812] = {.count = 1, .reusable = true}, SHIFT(169),
  [814] = {.count = 1, .reusable = false}, SHIFT(576),
  [816] = {.count = 1, .reusable = true}, SHIFT(56),
  [818] = {.count = 1, .reusable = false}, SHIFT(296),
  [820] = {.count = 1, .reusable = true}, SHIFT(563),
  [822] = {.count = 1, .reusable = false}, SHIFT(622),
  [824] = {.count = 1, .reusable = true}, SHIFT(157),
  [826] = {.count = 1, .reusable = true}, SHIFT(503),
  [828] = {.count = 1, .reusable = true}, SHIFT(111),
  [830] = {.count = 1, .reusable = false}, SHIFT(503),
  [832] = {.count = 1, .reusable = false}, SHIFT(325),
  [834] = {.count = 1, .reusable = true}, SHIFT(685),
  [836] = {.count = 1, .reusable = false}, REDUCE(sym__simple_statements, 2),
  [838] = {.count = 1, .reusable = true}, REDUCE(sym__simple_statements, 2),
  [840] = {.count = 1, .reusable = true}, REDUCE(sym_block, 2),
  [842] = {.count = 1, .reusable = false}, REDUCE(sym_block, 2),
  [844] = {.count = 1, .reusable = false}, REDUCE(sym__simple_statements, 3),
  [846] = {.count = 1, .reusable = true}, REDUCE(sym__simple_statements, 3),
  [848] = {.count = 1, .reusable = false}, REDUCE(sym_block, 1),
  [850] = {.count = 1, .reusable = true}, REDUCE(sym_block, 1),
  [852] = {.count = 1, .reusable = false}, REDUCE(sym__simple_statements, 4),
  [854] = {.count = 1, .reusable = true}, REDUCE(sym__simple_statements, 4),
  [856] = {.count = 1, .reusable = true}, SHIFT(87),
  [858] = {.count = 1, .reusable = true}, REDUCE(aux_sym_if_statement_repeat1, 2, .production_id = 63),
  [860] = {.count = 1, .reusable = false}, REDUCE(aux_sym_if_statement_repeat1, 2, .production_id = 63),
  [862] = {.count = 2, .reusable = false}, REDUCE(aux_sym_if_statement_repeat1, 2, .production_id = 63), SHIFT_REPEAT(322),
  [865] = {.count = 2, .reusable = false}, REDUCE(aux_sym_if_statement_repeat1, 2, .production_id = 63), SHIFT_REPEAT(352),
  [868] = {.count = 1, .reusable = false}, REDUCE(sym_except_clause, 6, .production_id = 92),
  [870] = {.count = 1, .reusable = true}, REDUCE(sym_except_clause, 6, .production_id = 92),
  [872] = {.count = 1, .reusable = false}, REDUCE(sym_except_clause, 5),
  [874] = {.count = 1, .reusable = true}, REDUCE(sym_except_clause, 5),
  [876] = {.count = 1, .reusable = false}, REDUCE(sym_except_clause, 4, .production_id = 82),
  [878] = {.count = 1, .reusable = true}, REDUCE(sym_except_clause, 4, .production_id = 82),
  [880] = {.count = 1, .reusable = false}, REDUCE(sym_except_clause, 4),
  [882] = {.count = 1, .reusable = true}, REDUCE(sym_except_clause, 4),
  [884] = {.count = 1, .reusable = false}, REDUCE(sym_except_clause, 3, .production_id = 69),
  [886] = {.count = 1, .reusable = true}, REDUCE(sym_except_clause, 3, .production_id = 69),
  [888] = {.count = 1, .reusable = true}, REDUCE(sym_except_clause, 7),
  [890] = {.count = 1, .reusable = false}, REDUCE(sym_except_clause, 7),
  [892] = {.count = 1, .reusable = true}, REDUCE(sym_for_statement, 7, .production_id = 80),
  [894] = {.count = 1, .reusable = false}, REDUCE(sym_for_statement, 7, .production_id = 80),
  [896] = {.count = 1, .reusable = false}, REDUCE(sym_for_statement, 8, .production_id = 85),
  [898] = {.count = 1, .reusable = true}, REDUCE(sym_for_statement, 8, .production_id = 85),
  [900] = {.count = 1, .reusable = true}, REDUCE(sym_for_statement, 6, .production_id = 67),
  [902] = {.count = 1, .reusable = false}, REDUCE(sym_for_statement, 6, .production_id = 67),
  [904] = {.count = 1, .reusable = false}, REDUCE(sym_try_statement, 6, .production_id = 50),
  [906] = {.count = 1, .reusable = true}, REDUCE(sym_try_statement, 6, .production_id = 50),
  [908] = {.count = 1, .reusable = true}, REDUCE(sym_for_statement, 7, .production_id = 77),
  [910] = {.count = 1, .reusable = false}, REDUCE(sym_for_statement, 7, .production_id = 77),
  [912] = {.count = 1, .reusable = true}, REDUCE(sym_elif_clause, 4, .production_id = 29),
  [914] = {.count = 1, .reusable = false}, REDUCE(sym_elif_clause, 4, .production_id = 29),
  [916] = {.count = 1, .reusable = false}, REDUCE(sym_elif_clause, 5, .production_id = 43),
  [918] = {.count = 1, .reusable = true}, REDUCE(sym_elif_clause, 5, .production_id = 43),
  [920] = {.count = 1, .reusable = true}, REDUCE(aux_sym_if_statement_repeat1, 1, .production_id = 44),
  [922] = {.count = 1, .reusable = false}, REDUCE(aux_sym_if_statement_repeat1, 1, .production_id = 44),
  [924] = {.count = 1, .reusable = false}, REDUCE(sym_while_statement, 5, .production_id = 48),
  [926] = {.count = 1, .reusable = true}, REDUCE(sym_while_statement, 5, .production_id = 48),
  [928] = {.count = 1, .reusable = false}, REDUCE(sym_try_statement, 5, .production_id = 31),
  [930] = {.count = 1, .reusable = true}, REDUCE(sym_try_statement, 5, .production_id = 31),
  [932] = {.count = 1, .reusable = true}, REDUCE(sym_while_statement, 4, .production_id = 30),
  [934] = {.count = 1, .reusable = false}, REDUCE(sym_while_statement, 4, .production_id = 30),
  [936] = {.count = 2, .reusable = true}, REDUCE(aux_sym_concatenated_string_repeat1, 2), SHIFT_REPEAT(687),
  [939] = {.count = 1, .reusable = false}, REDUCE(sym_else_clause, 3, .production_id = 31),
  [941] = {.count = 1, .reusable = true}, REDUCE(sym_else_clause, 3, .production_id = 31),
  [943] = {.count = 1, .reusable = false}, REDUCE(sym_else_clause, 4, .production_id = 50),
  [945] = {.count = 1, .reusable = true}, REDUCE(sym_else_clause, 4, .production_id = 50),
  [947] = {.count = 1, .reusable = true}, SHIFT(989),
  [949] = {.count = 1, .reusable = true}, SHIFT(108),
  [951] = {.count = 1, .reusable = false}, SHIFT(543),
  [953] = {.count = 1, .reusable = true}, SHIFT(542),
  [955] = {.count = 1, .reusable = true}, SHIFT(541),
  [957] = {.count = 1, .reusable = true}, SHIFT(540),
  [959] = {.count = 1, .reusable = true}, SHIFT(543),
  [961] = {.count = 1, .reusable = true}, SHIFT(952),
  [963] = {.count = 1, .reusable = true}, SHIFT(538),
  [965] = {.count = 1, .reusable = true}, SHIFT(537),
  [967] = {.count = 1, .reusable = true}, SHIFT(536),
  [969] = {.count = 1, .reusable = true}, SHIFT(534),
  [971] = {.count = 1, .reusable = false}, SHIFT(541),
  [973] = {.count = 1, .reusable = true}, SHIFT(528),
  [975] = {.count = 1, .reusable = true}, SHIFT(233),
  [977] = {.count = 1, .reusable = false}, REDUCE(sym_with_statement, 4, .production_id = 32),
  [979] = {.count = 1, .reusable = true}, REDUCE(sym_with_statement, 4, .production_id = 32),
  [981] = {.count = 1, .reusable = true}, REDUCE(sym_class_definition, 5, .production_id = 53),
  [983] = {.count = 1, .reusable = false}, REDUCE(sym_class_definition, 5, .production_id = 53),
  [985] = {.count = 1, .reusable = false}, REDUCE(sym_function_definition, 6, .production_id = 70),
  [987] = {.count = 1, .reusable = true}, REDUCE(sym_function_definition, 6, .production_id = 70),
  [989] = {.count = 1, .reusable = false}, REDUCE(sym_try_statement, 6, .production_id = 31),
  [991] = {.count = 1, .reusable = true}, REDUCE(sym_try_statement, 6, .production_id = 31),
  [993] = {.count = 1, .reusable = false}, REDUCE(sym_finally_clause, 3, .production_id = 69),
  [995] = {.count = 1, .reusable = true}, REDUCE(sym_finally_clause, 3, .production_id = 69),
  [997] = {.count = 1, .reusable = false}, REDUCE(sym_while_statement, 6, .production_id = 68),
  [999] = {.count = 1, .reusable = true}, REDUCE(sym_while_statement, 6, .production_id = 68),
  [1001] = {.count = 1, .reusable = false}, REDUCE(sym_function_definition, 6, .production_id = 66),
  [1003] = {.count = 1, .reusable = true}, REDUCE(sym_function_definition, 6, .production_id = 66),
  [1005] = {.count = 1, .reusable = false}, REDUCE(sym_with_statement, 6, .production_id = 65),
  [1007] = {.count = 1, .reusable = true}, REDUCE(sym_with_statement, 6, .production_id = 65),
  [1009] = {.count = 1, .reusable = false}, REDUCE(sym_with_statement, 6, .production_id = 64),
  [1011] = {.count = 1, .reusable = true}, REDUCE(sym_with_statement, 6, .production_id = 64),
  [1013] = {.count = 1, .reusable = false}, REDUCE(sym_if_statement, 6, .production_id = 62),
  [1015] = {.count = 1, .reusable = true}, REDUCE(sym_if_statement, 6, .production_id = 62),
  [1017] = {.count = 1, .reusable = false}, REDUCE(sym_if_statement, 6, .production_id = 60),
  [1019] = {.count = 1, .reusable = true}, REDUCE(sym_if_statement, 6, .production_id = 60),
  [1021] = {.count = 1, .reusable = false}, REDUCE(sym_class_definition, 5, .production_id = 54),
  [1023] = {.count = 1, .reusable = true}, REDUCE(sym_class_definition, 5, .production_id = 54),
  [1025] = {.count = 1, .reusable = false}, REDUCE(sym_function_definition, 5, .production_id = 52),
  [1027] = {.count = 1, .reusable = true}, REDUCE(sym_function_definition, 5, .production_id = 52),
  [1029] = {.count = 1, .reusable = false}, REDUCE(sym_with_statement, 5, .production_id = 51),
  [1031] = {.count = 1, .reusable = true}, REDUCE(sym_with_statement, 5, .production_id = 51),
  [1033] = {.count = 1, .reusable = false}, REDUCE(sym_while_statement, 5, .production_id = 49),
  [1035] = {.count = 1, .reusable = true}, REDUCE(sym_while_statement, 5, .production_id = 49),
  [1037] = {.count = 1, .reusable = true}, REDUCE(sym_if_statement, 5, .production_id = 45),
  [1039] = {.count = 1, .reusable = false}, REDUCE(sym_if_statement, 5, .production_id = 45),
  [1041] = {.count = 1, .reusable = false}, REDUCE(sym_with_statement, 5, .production_id = 47),
  [1043] = {.count = 1, .reusable = true}, REDUCE(sym_with_statement, 5, .production_id = 47),
  [1045] = {.count = 1, .reusable = false}, REDUCE(sym_class_definition, 4, .production_id = 34),
  [1047] = {.count = 1, .reusable = true}, REDUCE(sym_class_definition, 4, .production_id = 34),
  [1049] = {.count = 1, .reusable = false}, REDUCE(sym_if_statement, 7, .production_id = 76),
  [1051] = {.count = 1, .reusable = true}, REDUCE(sym_if_statement, 7, .production_id = 76),
  [1053] = {.count = 1, .reusable = false}, REDUCE(sym_with_statement, 7, .production_id = 78),
  [1055] = {.count = 1, .reusable = true}, REDUCE(sym_with_statement, 7, .production_id = 78),
  [1057] = {.count = 1, .reusable = false}, REDUCE(sym_function_definition, 7, .production_id = 79),
  [1059] = {.count = 1, .reusable = true}, REDUCE(sym_function_definition, 7, .production_id = 79),
  [1061] = {.count = 1, .reusable = false}, REDUCE(sym_for_statement, 7, .production_id = 81),
  [1063] = {.count = 1, .reusable = true}, REDUCE(sym_for_statement, 7, .production_id = 81),
  [1065] = {.count = 1, .reusable = false}, REDUCE(sym_class_definition, 6, .production_id = 71),
  [1067] = {.count = 1, .reusable = true}, REDUCE(sym_class_definition, 6, .production_id = 71),
  [1069] = {.count = 1, .reusable = false}, REDUCE(sym_decorated_definition, 2, .production_id = 10),
  [1071] = {.count = 1, .reusable = true}, REDUCE(sym_decorated_definition, 2, .production_id = 10),
  [1073] = {.count = 1, .reusable = false}, REDUCE(sym_try_statement, 7, .production_id = 50),
  [1075] = {.count = 1, .reusable = true}, REDUCE(sym_try_statement, 7, .production_id = 50),
  [1077] = {.count = 1, .reusable = false}, REDUCE(sym_finally_clause, 4),
  [1079] = {.count = 1, .reusable = true}, REDUCE(sym_finally_clause, 4),
  [1081] = {.count = 1, .reusable = false}, REDUCE(sym_function_definition, 7, .production_id = 83),
  [1083] = {.count = 1, .reusable = true}, REDUCE(sym_function_definition, 7, .production_id = 83),
  [1085] = {.count = 1, .reusable = true}, REDUCE(sym_function_definition, 9, .production_id = 91),
  [1087] = {.count = 1, .reusable = false}, REDUCE(sym_function_definition, 9, .production_id = 91),
  [1089] = {.count = 1, .reusable = true}, REDUCE(sym_for_statement, 9, .production_id = 90),
  [1091] = {.count = 1, .reusable = false}, REDUCE(sym_for_statement, 9, .production_id = 90),
  [1093] = {.count = 1, .reusable = false}, REDUCE(sym_for_statement, 8, .production_id = 86),
  [1095] = {.count = 1, .reusable = true}, REDUCE(sym_for_statement, 8, .production_id = 86),
  [1097] = {.count = 1, .reusable = true}, REDUCE(sym_function_definition, 8, .production_id = 89),
  [1099] = {.count = 1, .reusable = false}, REDUCE(sym_function_definition, 8, .production_id = 89),
  [1101] = {.count = 1, .reusable = true}, REDUCE(sym_for_statement, 8, .production_id = 88),
  [1103] = {.count = 1, .reusable = false}, REDUCE(sym_for_statement, 8, .production_id = 88),
  [1105] = {.count = 1, .reusable = true}, REDUCE(sym_function_definition, 8, .production_id = 87),
  [1107] = {.count = 1, .reusable = false}, REDUCE(sym_function_definition, 8, .production_id = 87),
  [1109] = {.count = 1, .reusable = true}, SHIFT(321),
  [1111] = {.count = 1, .reusable = true}, SHIFT(968),
  [1113] = {.count = 1, .reusable = true}, SHIFT(102),
  [1115] = {.count = 1, .reusable = false}, SHIFT(535),
  [1117] = {.count = 1, .reusable = true}, SHIFT(539),
  [1119] = {.count = 1, .reusable = true}, SHIFT(531),
  [1121] = {.count = 1, .reusable = true}, SHIFT(544),
  [1123] = {.count = 1, .reusable = true}, SHIFT(535),
  [1125] = {.count = 1, .reusable = true}, SHIFT(954),
  [1127] = {.count = 1, .reusable = true}, SHIFT(545),
  [1129] = {.count = 1, .reusable = true}, SHIFT(558),
  [1131] = {.count = 1, .reusable = true}, SHIFT(559),
  [1133] = {.count = 1, .reusable = true}, SHIFT(561),
  [1135] = {.count = 1, .reusable = false}, SHIFT(531),
  [1137] = {.count = 1, .reusable = true}, SHIFT(523),
  [1139] = {.count = 1, .reusable = true}, SHIFT(240),
  [1141] = {.count = 1, .reusable = false}, SHIFT(351),
  [1143] = {.count = 2, .reusable = true}, REDUCE(aux_sym_concatenated_string_repeat1, 2), SHIFT_REPEAT(685),
  [1146] = {.count = 1, .reusable = false}, SHIFT(610),
  [1148] = {.count = 1, .reusable = true}, SHIFT(610),
  [1150] = {.count = 1, .reusable = false}, SHIFT(132),
  [1152] = {.count = 1, .reusable = false}, SHIFT(554),
  [1154] = {.count = 1, .reusable = true}, SHIFT(132),
  [1156] = {.count = 1, .reusable = false}, SHIFT(349),
  [1158] = {.count = 1, .reusable = false}, SHIFT(611),
  [1160] = {.count = 1, .reusable = false}, REDUCE(sym_variables, 3),
  [1162] = {.count = 1, .reusable = true}, SHIFT(611),
  [1164] = {.count = 1, .reusable = false}, REDUCE(sym_variables, 2),
  [1166] = {.count = 1, .reusable = false}, SHIFT(519),
  [1168] = {.count = 1, .reusable = false}, SHIFT(553),
  [1170] = {.count = 1, .reusable = true}, SHIFT(519),
  [1172] = {.count = 1, .reusable = false}, SHIFT(429),
  [1174] = {.count = 1, .reusable = false}, SHIFT(549),
  [1176] = {.count = 1, .reusable = true}, SHIFT(429),
  [1178] = {.count = 1, .reusable = false}, SHIFT(127),
  [1180] = {.count = 1, .reusable = true}, SHIFT(127),
  [1182] = {.count = 1, .reusable = false}, SHIFT(436),
  [1184] = {.count = 1, .reusable = true}, SHIFT(436),
  [1186] = {.count = 1, .reusable = false}, SHIFT(421),
  [1188] = {.count = 1, .reusable = true}, SHIFT(421),
  [1190] = {.count = 1, .reusable = false}, SHIFT(521),
  [1192] = {.count = 1, .reusable = true}, SHIFT(521),
  [1194] = {.count = 1, .reusable = false}, SHIFT(423),
  [1196] = {.count = 1, .reusable = true}, SHIFT(423),
  [1198] = {.count = 1, .reusable = false}, SHIFT(424),
  [1200] = {.count = 1, .reusable = true}, SHIFT(424),
  [1202] = {.count = 1, .reusable = false}, SHIFT(426),
  [1204] = {.count = 1, .reusable = true}, SHIFT(426),
  [1206] = {.count = 1, .reusable = false}, SHIFT(520),
  [1208] = {.count = 1, .reusable = true}, SHIFT(520),
  [1210] = {.count = 1, .reusable = false}, SHIFT(427),
  [1212] = {.count = 1, .reusable = true}, SHIFT(427),
  [1214] = {.count = 1, .reusable = false}, SHIFT(431),
  [1216] = {.count = 1, .reusable = true}, SHIFT(431),
  [1218] = {.count = 1, .reusable = false}, SHIFT(432),
  [1220] = {.count = 1, .reusable = true}, SHIFT(432),
  [1222] = {.count = 1, .reusable = false}, SHIFT(518),
  [1224] = {.count = 1, .reusable = true}, SHIFT(518),
  [1226] = {.count = 1, .reusable = false}, SHIFT(510),
  [1228] = {.count = 1, .reusable = true}, SHIFT(510),
  [1230] = {.count = 1, .reusable = false}, SHIFT(125),
  [1232] = {.count = 1, .reusable = true}, SHIFT(125),
  [1234] = {.count = 1, .reusable = true}, SHIFT(306),
  [1236] = {.count = 1, .reusable = true}, REDUCE(sym_comparison_operator, 2),
  [1238] = {.count = 1, .reusable = false}, REDUCE(sym_comparison_operator, 2),
  [1240] = {.count = 1, .reusable = false}, SHIFT(410),
  [1242] = {.count = 1, .reusable = true}, SHIFT(410),
  [1244] = {.count = 1, .reusable = false}, SHIFT(131),
  [1246] = {.count = 1, .reusable = true}, SHIFT(131),
  [1248] = {.count = 1, .reusable = false}, SHIFT(133),
  [1250] = {.count = 1, .reusable = true}, SHIFT(133),
  [1252] = {.count = 1, .reusable = false}, SHIFT(134),
  [1254] = {.count = 1, .reusable = true}, SHIFT(134),
  [1256] = {.count = 1, .reusable = false}, SHIFT(529),
  [1258] = {.count = 1, .reusable = true}, SHIFT(529),
  [1260] = {.count = 1, .reusable = false}, SHIFT(135),
  [1262] = {.count = 1, .reusable = true}, SHIFT(135),
  [1264] = {.count = 1, .reusable = false}, SHIFT(136),
  [1266] = {.count = 1, .reusable = true}, SHIFT(136),
  [1268] = {.count = 2, .reusable = true}, REDUCE(aux_sym_comparison_operator_repeat1, 2), SHIFT_REPEAT(556),
  [1271] = {.count = 2, .reusable = true}, REDUCE(aux_sym_comparison_operator_repeat1, 2), SHIFT_REPEAT(977),
  [1274] = {.count = 2, .reusable = false}, REDUCE(aux_sym_comparison_operator_repeat1, 2), SHIFT_REPEAT(556),
  [1277] = {.count = 2, .reusable = true}, REDUCE(aux_sym_comparison_operator_repeat1, 2), SHIFT_REPEAT(509),
  [1280] = {.count = 1, .reusable = false}, SHIFT(514),
  [1282] = {.count = 1, .reusable = true}, SHIFT(514),
  [1284] = {.count = 1, .reusable = false}, SHIFT(515),
  [1286] = {.count = 1, .reusable = true}, SHIFT(515),
  [1288] = {.count = 1, .reusable = false}, SHIFT(129),
  [1290] = {.count = 1, .reusable = true}, SHIFT(129),
  [1292] = {.count = 1, .reusable = false}, SHIFT(516),
  [1294] = {.count = 1, .reusable = true}, SHIFT(516),
  [1296] = {.count = 1, .reusable = false}, SHIFT(128),
  [1298] = {.count = 1, .reusable = true}, SHIFT(128),
  [1300] = {.count = 1, .reusable = false}, SHIFT(526),
  [1302] = {.count = 1, .reusable = true}, SHIFT(526),
  [1304] = {.count = 2, .reusable = true}, REDUCE(aux_sym_comparison_operator_repeat1, 2), SHIFT_REPEAT(541),
  [1307] = {.count = 2, .reusable = true}, REDUCE(aux_sym_comparison_operator_repeat1, 2), SHIFT_REPEAT(952),
  [1310] = {.count = 2, .reusable = false}, REDUCE(aux_sym_comparison_operator_repeat1, 2), SHIFT_REPEAT(541),
  [1313] = {.count = 2, .reusable = true}, REDUCE(aux_sym_comparison_operator_repeat1, 2), SHIFT_REPEAT(528),
  [1316] = {.count = 1, .reusable = true}, REDUCE(sym_expression_list, 1),
  [1318] = {.count = 1, .reusable = true}, SHIFT(97),
  [1320] = {.count = 1, .reusable = true}, SHIFT(336),
  [1322] = {.count = 1, .reusable = true}, SHIFT(337),
  [1324] = {.count = 1, .reusable = true}, SHIFT(341),
  [1326] = {.count = 1, .reusable = true}, REDUCE(aux_sym_assert_statement_repeat1, 2),
  [1328] = {.count = 1, .reusable = true}, SHIFT(98),
  [1330] = {.count = 1, .reusable = true}, REDUCE(sym_expression_statement, 1),
  [1332] = {.count = 1, .reusable = true}, REDUCE(sym_named_expression, 3, .production_id = 16),
  [1334] = {.count = 1, .reusable = true}, REDUCE(sym_not_operator, 2, .production_id = 4),
  [1336] = {.count = 1, .reusable = true}, REDUCE(sym_lambda, 3, .production_id = 15),
  [1338] = {.count = 1, .reusable = true}, REDUCE(sym_await, 2),
  [1340] = {.count = 1, .reusable = true}, REDUCE(sym_conditional_expression, 5),
  [1342] = {.count = 1, .reusable = true}, REDUCE(sym_lambda, 4, .production_id = 40),
  [1344] = {.count = 1, .reusable = true}, REDUCE(sym_boolean_operator, 3, .production_id = 19),
  [1346] = {.count = 1, .reusable = true}, SHIFT(513),
  [1348] = {.count = 1, .reusable = true}, REDUCE(sym_variables, 1),
  [1350] = {.count = 1, .reusable = true}, REDUCE(aux_sym_variables_repeat1, 2),
  [1352] = {.count = 1, .reusable = true}, SHIFT(96),
  [1354] = {.count = 2, .reusable = true}, REDUCE(aux_sym_assert_statement_repeat1, 2), SHIFT_REPEAT(319),
  [1357] = {.count = 1, .reusable = true}, SHIFT(99),
  [1359] = {.count = 1, .reusable = true}, SHIFT(272),
  [1361] = {.count = 1, .reusable = true}, SHIFT(123),
  [1363] = {.count = 1, .reusable = true}, SHIFT(124),
  [1365] = {.count = 1, .reusable = true}, REDUCE(sym__right_hand_side, 1),
  [1367] = {.count = 2, .reusable = true}, REDUCE(aux_sym_comparison_operator_repeat1, 2), SHIFT_REPEAT(531),
  [1370] = {.count = 2, .reusable = true}, REDUCE(aux_sym_comparison_operator_repeat1, 2), SHIFT_REPEAT(954),
  [1373] = {.count = 2, .reusable = false}, REDUCE(aux_sym_comparison_operator_repeat1, 2), SHIFT_REPEAT(531),
  [1376] = {.count = 2, .reusable = true}, REDUCE(aux_sym_comparison_operator_repeat1, 2), SHIFT_REPEAT(523),
  [1379] = {.count = 1, .reusable = false}, SHIFT(783),
  [1381] = {.count = 1, .reusable = true}, SHIFT(178),
  [1383] = {.count = 1, .reusable = false}, SHIFT(211),
  [1385] = {.count = 1, .reusable = false}, SHIFT(784),
  [1387] = {.count = 1, .reusable = true}, SHIFT(290),
  [1389] = {.count = 1, .reusable = true}, SHIFT(251),
  [1391] = {.count = 1, .reusable = true}, SHIFT(312),
  [1393] = {.count = 1, .reusable = true}, SHIFT(304),
  [1395] = {.count = 1, .reusable = false}, SHIFT(759),
  [1397] = {.count = 1, .reusable = true}, SHIFT(927),
  [1399] = {.count = 1, .reusable = false}, SHIFT(214),
  [1401] = {.count = 1, .reusable = false}, SHIFT(760),
  [1403] = {.count = 1, .reusable = false}, SHIFT(868),
  [1405] = {.count = 1, .reusable = false}, SHIFT(203),
  [1407] = {.count = 1, .reusable = false}, SHIFT(856),
  [1409] = {.count = 1, .reusable = true}, REDUCE(sym__parameters, 2, .production_id = 1),
  [1411] = {.count = 1, .reusable = false}, SHIFT(810),
  [1413] = {.count = 1, .reusable = true}, REDUCE(sym__parameters, 3, .production_id = 1),
  [1415] = {.count = 1, .reusable = false}, SHIFT(806),
  [1417] = {.count = 1, .reusable = true}, SHIFT(327),
  [1419] = {.count = 1, .reusable = true}, SHIFT(329),
  [1421] = {.count = 1, .reusable = true}, SHIFT(316),
  [1423] = {.count = 1, .reusable = true}, REDUCE(sym__parameters, 2, .production_id = 8),
  [1425] = {.count = 1, .reusable = true}, REDUCE(sym__parameters, 2),
  [1427] = {.count = 1, .reusable = true}, REDUCE(sym__parameters, 3),
  [1429] = {.count = 1, .reusable = true}, REDUCE(sym__parameters, 3, .production_id = 8),
  [1431] = {.count = 1, .reusable = true}, SHIFT(222),
  [1433] = {.count = 1, .reusable = true}, SHIFT(301),
  [1435] = {.count = 1, .reusable = true}, SHIFT(970),
  [1437] = {.count = 1, .reusable = true}, SHIFT(508),
  [1439] = {.count = 1, .reusable = true}, SHIFT(575),
  [1441] = {.count = 1, .reusable = true}, SHIFT(209),
  [1443] = {.count = 1, .reusable = true}, SHIFT(497),
  [1445] = {.count = 1, .reusable = true}, SHIFT(223),
  [1447] = {.count = 1, .reusable = true}, SHIFT(185),
  [1449] = {.count = 1, .reusable = true}, SHIFT(566),
  [1451] = {.count = 1, .reusable = true}, SHIFT(218),
  [1453] = {.count = 1, .reusable = true}, SHIFT(224),
  [1455] = {.count = 1, .reusable = true}, SHIFT(569),
  [1457] = {.count = 1, .reusable = true}, SHIFT(195),
  [1459] = {.count = 1, .reusable = true}, SHIFT(488),
  [1461] = {.count = 1, .reusable = true}, SHIFT(155),
  [1463] = {.count = 1, .reusable = true}, SHIFT(200),
  [1465] = {.count = 1, .reusable = true}, SHIFT(592),
  [1467] = {.count = 1, .reusable = true}, SHIFT(112),
  [1469] = {.count = 1, .reusable = true}, SHIFT(476),
  [1471] = {.count = 1, .reusable = true}, SHIFT(208),
  [1473] = {.count = 1, .reusable = true}, SHIFT(484),
  [1475] = {.count = 1, .reusable = true}, SHIFT(114),
  [1477] = {.count = 1, .reusable = true}, SHIFT(175),
  [1479] = {.count = 1, .reusable = true}, SHIFT(113),
  [1481] = {.count = 1, .reusable = true}, SHIFT(221),
  [1483] = {.count = 1, .reusable = true}, SHIFT(182),
  [1485] = {.count = 1, .reusable = true}, REDUCE(sym__comprehension_clauses, 1),
  [1487] = {.count = 1, .reusable = true}, SHIFT(292),
  [1489] = {.count = 1, .reusable = true}, REDUCE(sym__expression_within_for_in_clause, 1),
  [1491] = {.count = 1, .reusable = true}, REDUCE(sym__comprehension_clauses, 2),
  [1493] = {.count = 1, .reusable = true}, REDUCE(aux_sym__comprehension_clauses_repeat1, 2),
  [1495] = {.count = 2, .reusable = true}, REDUCE(aux_sym__comprehension_clauses_repeat1, 2), SHIFT_REPEAT(292),
  [1498] = {.count = 2, .reusable = true}, REDUCE(aux_sym__comprehension_clauses_repeat1, 2), SHIFT_REPEAT(970),
  [1501] = {.count = 2, .reusable = true}, REDUCE(aux_sym__comprehension_clauses_repeat1, 2), SHIFT_REPEAT(508),
  [1504] = {.count = 1, .reusable = true}, REDUCE(sym_for_in_clause, 5, .production_id = 74),
  [1506] = {.count = 1, .reusable = true}, SHIFT(106),
  [1508] = {.count = 1, .reusable = true}, REDUCE(aux_sym_for_in_clause_repeat1, 2),
  [1510] = {.count = 2, .reusable = true}, REDUCE(aux_sym_for_in_clause_repeat1, 2), SHIFT_REPEAT(227),
  [1513] = {.count = 1, .reusable = true}, REDUCE(sym_for_in_clause, 6, .production_id = 84),
  [1515] = {.count = 1, .reusable = true}, SHIFT(103),
  [1517] = {.count = 1, .reusable = true}, SHIFT(1033),
  [1519] = {.count = 1, .reusable = true}, SHIFT(1030),
  [1521] = {.count = 1, .reusable = true}, SHIFT(1019),
  [1523] = {.count = 1, .reusable = true}, REDUCE(sym_list_splat, 2),
  [1525] = {.count = 1, .reusable = true}, SHIFT(984),
  [1527] = {.count = 1, .reusable = true}, SHIFT(1016),
  [1529] = {.count = 1, .reusable = true}, SHIFT(1013),
  [1531] = {.count = 1, .reusable = true}, REDUCE(sym_if_clause, 2),
  [1533] = {.count = 1, .reusable = true}, REDUCE(sym_for_in_clause, 4, .production_id = 59),
  [1535] = {.count = 1, .reusable = true}, SHIFT(107),
  [1537] = {.count = 1, .reusable = true}, REDUCE(sym_for_in_clause, 5, .production_id = 75),
  [1539] = {.count = 1, .reusable = true}, SHIFT(105),
  [1541] = {.count = 1, .reusable = true}, SHIFT(201),
  [1543] = {.count = 1, .reusable = true}, SHIFT(198),
  [1545] = {.count = 1, .reusable = true}, SHIFT(168),
  [1547] = {.count = 2, .reusable = false}, REDUCE(aux_sym_string_repeat1, 2), SHIFT_REPEAT(309),
  [1550] = {.count = 2, .reusable = false}, REDUCE(aux_sym_string_repeat1, 2), SHIFT_REPEAT(674),
  [1553] = {.count = 1, .reusable = false}, SHIFT_EXTRA(),
  [1555] = {.count = 2, .reusable = true}, REDUCE(aux_sym_string_repeat1, 2), SHIFT_REPEAT(674),
  [1558] = {.count = 1, .reusable = true}, REDUCE(aux_sym_string_repeat1, 2),
  [1560] = {.count = 1, .reusable = false}, SHIFT(309),
  [1562] = {.count = 1, .reusable = false}, SHIFT(674),
  [1564] = {.count = 1, .reusable = true}, SHIFT(674),
  [1566] = {.count = 1, .reusable = true}, SHIFT(140),
  [1568] = {.count = 1, .reusable = true}, SHIFT(183),
  [1570] = {.count = 1, .reusable = true}, SHIFT(188),
  [1572] = {.count = 1, .reusable = true}, SHIFT(564),
  [1574] = {.count = 1, .reusable = true}, SHIFT(686),
  [1576] = {.count = 1, .reusable = true}, SHIFT(808),
  [1578] = {.count = 1, .reusable = true}, SHIFT(922),
  [1580] = {.count = 1, .reusable = true}, SHIFT(243),
  [1582] = {.count = 1, .reusable = true}, REDUCE(sym_print_statement, 2, .production_id = 4),
  [1584] = {.count = 2, .reusable = true}, REDUCE(aux_sym_dotted_name_repeat1, 2), SHIFT_REPEAT(988),
  [1587] = {.count = 1, .reusable = true}, REDUCE(aux_sym_dotted_name_repeat1, 2),
  [1589] = {.count = 1, .reusable = true}, REDUCE(sym_type, 1),
  [1591] = {.count = 1, .reusable = false}, SHIFT(707),
  [1593] = {.count = 1, .reusable = true}, SHIFT(773),
  [1595] = {.count = 1, .reusable = false}, SHIFT(974),
  [1597] = {.count = 1, .reusable = true}, SHIFT(319),
  [1599] = {.count = 1, .reusable = true}, REDUCE(sym_assert_statement, 2),
  [1601] = {.count = 1, .reusable = false}, SHIFT(678),
  [1603] = {.count = 1, .reusable = true}, SHIFT(678),
  [1605] = {.count = 1, .reusable = true}, SHIFT(532),
  [1607] = {.count = 1, .reusable = true}, SHIFT(988),
  [1609] = {.count = 1, .reusable = true}, REDUCE(sym_dotted_name, 1),
  [1611] = {.count = 1, .reusable = false}, SHIFT(694),
  [1613] = {.count = 1, .reusable = true}, SHIFT(694),
  [1615] = {.count = 1, .reusable = true}, SHIFT(470),
  [1617] = {.count = 1, .reusable = true}, SHIFT(193),
  [1619] = {.count = 1, .reusable = true}, SHIFT(487),
  [1621] = {.count = 1, .reusable = true}, SHIFT(762),
  [1623] = {.count = 1, .reusable = true}, SHIFT(750),
  [1625] = {.count = 1, .reusable = true}, SHIFT(873),
  [1627] = {.count = 1, .reusable = true}, REDUCE(sym_lambda_within_for_in_clause, 4, .production_id = 40),
  [1629] = {.count = 1, .reusable = true}, REDUCE(sym_exec_statement, 4, .production_id = 6),
  [1631] = {.count = 1, .reusable = false}, SHIFT(695),
  [1633] = {.count = 1, .reusable = true}, SHIFT(695),
  [1635] = {.count = 1, .reusable = true}, SHIFT(819),
  [1637] = {.count = 1, .reusable = true}, SHIFT(144),
  [1639] = {.count = 1, .reusable = true}, SHIFT(574),
  [1641] = {.count = 1, .reusable = true}, SHIFT(471),
  [1643] = {.count = 1, .reusable = true}, SHIFT(820),
  [1645] = {.count = 1, .reusable = true}, REDUCE(sym_pair, 3, .production_id = 41),
  [1647] = {.count = 1, .reusable = true}, REDUCE(sym_dictionary_splat, 2),
  [1649] = {.count = 1, .reusable = true}, SHIFT(207),
  [1651] = {.count = 1, .reusable = true}, REDUCE(sym_dotted_name, 2),
  [1653] = {.count = 1, .reusable = true}, REDUCE(sym_lambda_within_for_in_clause, 3, .production_id = 15),
  [1655] = {.count = 1, .reusable = true}, SHIFT(143),
  [1657] = {.count = 1, .reusable = true}, SHIFT(490),
  [1659] = {.count = 1, .reusable = true}, SHIFT(216),
  [1661] = {.count = 1, .reusable = true}, SHIFT(593),
  [1663] = {.count = 1, .reusable = false}, SHIFT(675),
  [1665] = {.count = 1, .reusable = true}, SHIFT(675),
  [1667] = {.count = 1, .reusable = true}, SHIFT(137),
  [1669] = {.count = 1, .reusable = true}, SHIFT(354),
  [1671] = {.count = 1, .reusable = true}, SHIFT(353),
  [1673] = {.count = 1, .reusable = true}, REDUCE(sym_typed_default_parameter, 5, .production_id = 72),
  [1675] = {.count = 1, .reusable = true}, REDUCE(sym_typed_default_parameter, 5, .production_id = 73),
  [1677] = {.count = 1, .reusable = true}, SHIFT(987),
  [1679] = {.count = 1, .reusable = true}, SHIFT(286),
  [1681] = {.count = 1, .reusable = true}, REDUCE(aux_sym_print_statement_repeat1, 2, .production_id = 4),
  [1683] = {.count = 2, .reusable = true}, REDUCE(aux_sym_dotted_name_repeat1, 2), SHIFT_REPEAT(987),
  [1686] = {.count = 1, .reusable = true}, SHIFT(248),
  [1688] = {.count = 1, .reusable = true}, SHIFT(475),
  [1690] = {.count = 1, .reusable = true}, REDUCE(aux_sym_list_repeat1, 2),
  [1692] = {.count = 1, .reusable = true}, REDUCE(sym_with_item, 1, .production_id = 5),
  [1694] = {.count = 1, .reusable = true}, SHIFT(348),
  [1696] = {.count = 1, .reusable = true}, REDUCE(aux_sym_decorated_definition_repeat1, 2),
  [1698] = {.count = 2, .reusable = true}, REDUCE(aux_sym_decorated_definition_repeat1, 2), SHIFT_REPEAT(924),
  [1701] = {.count = 1, .reusable = true}, REDUCE(sym_chevron, 2),
  [1703] = {.count = 1, .reusable = true}, REDUCE(sym_default_parameter, 3, .production_id = 16),
  [1705] = {.count = 1, .reusable = true}, REDUCE(aux_sym_subscript_repeat1, 2),
  [1707] = {.count = 1, .reusable = true}, SHIFT(342),
  [1709] = {.count = 1, .reusable = true}, SHIFT(84),
  [1711] = {.count = 1, .reusable = true}, SHIFT(334),
  [1713] = {.count = 1, .reusable = true}, SHIFT(71),
  [1715] = {.count = 1, .reusable = true}, REDUCE(sym_default_parameter, 3, .production_id = 38),
  [1717] = {.count = 1, .reusable = false}, SHIFT(339),
  [1719] = {.count = 1, .reusable = false}, REDUCE(sym_format_specifier, 2),
  [1721] = {.count = 1, .reusable = false}, SHIFT(754),
  [1723] = {.count = 1, .reusable = false}, REDUCE(sym_interpolation, 5),
  [1725] = {.count = 1, .reusable = true}, REDUCE(sym_interpolation, 5),
  [1727] = {.count = 1, .reusable = true}, REDUCE(sym_slice, 5),
  [1729] = {.count = 1, .reusable = true}, REDUCE(sym_raise_statement, 3, .production_id = 14),
  [1731] = {.count = 1, .reusable = true}, REDUCE(sym_yield, 3),
  [1733] = {.count = 1, .reusable = true}, REDUCE(sym_with_item, 3, .production_id = 33),
  [1735] = {.count = 1, .reusable = true}, REDUCE(aux_sym_argument_list_repeat1, 2),
  [1737] = {.count = 1, .reusable = true}, SHIFT(253),
  [1739] = {.count = 1, .reusable = true}, SHIFT(1036),
  [1741] = {.count = 1, .reusable = true}, SHIFT(809),
  [1743] = {.count = 1, .reusable = true}, REDUCE(sym__import_list, 2, .production_id = 3),
  [1745] = {.count = 1, .reusable = true}, REDUCE(sym_keyword_argument, 3, .production_id = 16),
  [1747] = {.count = 1, .reusable = true}, REDUCE(sym_keyword_argument, 3, .production_id = 38),
  [1749] = {.count = 1, .reusable = true}, REDUCE(aux_sym_tuple_repeat1, 2),
  [1751] = {.count = 1, .reusable = true}, SHIFT(276),
  [1753] = {.count = 1, .reusable = true}, SHIFT(1005),
  [1755] = {.count = 1, .reusable = false}, REDUCE(sym_interpolation, 3),
  [1757] = {.count = 1, .reusable = true}, REDUCE(sym_interpolation, 3),
  [1759] = {.count = 1, .reusable = true}, REDUCE(sym__import_list, 3, .production_id = 11),
  [1761] = {.count = 2, .reusable = false}, REDUCE(aux_sym_format_specifier_repeat1, 2), SHIFT_REPEAT(339),
  [1764] = {.count = 1, .reusable = false}, REDUCE(aux_sym_format_specifier_repeat1, 2),
  [1766] = {.count = 2, .reusable = false}, REDUCE(aux_sym_format_specifier_repeat1, 2), SHIFT_REPEAT(754),
  [1769] = {.count = 1, .reusable = false}, REDUCE(sym_interpolation, 4),
  [1771] = {.count = 1, .reusable = true}, REDUCE(sym_interpolation, 4),
  [1773] = {.count = 1, .reusable = true}, REDUCE(sym_raise_statement, 4, .production_id = 28),
  [1775] = {.count = 1, .reusable = true}, SHIFT(745),
  [1777] = {.count = 1, .reusable = true}, SHIFT(995),
  [1779] = {.count = 1, .reusable = true}, REDUCE(sym__import_list, 1, .production_id = 3),
  [1781] = {.count = 1, .reusable = true}, REDUCE(sym__parameters, 1),
  [1783] = {.count = 1, .reusable = true}, SHIFT(631),
  [1785] = {.count = 1, .reusable = true}, SHIFT(280),
  [1787] = {.count = 1, .reusable = true}, SHIFT(310),
  [1789] = {.count = 1, .reusable = true}, REDUCE(sym__parameters, 1, .production_id = 1),
  [1791] = {.count = 1, .reusable = true}, SHIFT(630),
  [1793] = {.count = 1, .reusable = true}, SHIFT(274),
  [1795] = {.count = 1, .reusable = true}, SHIFT(323),
  [1797] = {.count = 1, .reusable = false}, REDUCE(sym_format_specifier, 1),
  [1799] = {.count = 1, .reusable = false}, SHIFT(735),
  [1801] = {.count = 1, .reusable = true}, SHIFT(60),
  [1803] = {.count = 1, .reusable = true}, REDUCE(sym_decorator, 4, .production_id = 35),
  [1805] = {.count = 2, .reusable = true}, REDUCE(aux_sym_list_repeat1, 2), SHIFT_REPEAT(230),
  [1808] = {.count = 1, .reusable = true}, SHIFT(281),
  [1810] = {.count = 1, .reusable = true}, SHIFT(61),
  [1812] = {.count = 1, .reusable = true}, SHIFT(782),
  [1814] = {.count = 1, .reusable = true}, SHIFT(986),
  [1816] = {.count = 1, .reusable = true}, SHIFT(63),
  [1818] = {.count = 1, .reusable = false}, REDUCE(sym_import_prefix, 1),
  [1820] = {.count = 1, .reusable = true}, SHIFT(803),
  [1822] = {.count = 2, .reusable = true}, REDUCE(aux_sym__import_list_repeat1, 2, .production_id = 22), SHIFT_REPEAT(894),
  [1825] = {.count = 1, .reusable = true}, REDUCE(aux_sym__import_list_repeat1, 2, .production_id = 22),
  [1827] = {.count = 1, .reusable = true}, SHIFT(347),
  [1829] = {.count = 1, .reusable = true}, SHIFT(77),
  [1831] = {.count = 1, .reusable = true}, REDUCE(sym_decorator, 3),
  [1833] = {.count = 1, .reusable = true}, REDUCE(sym_exec_statement, 5, .production_id = 6),
  [1835] = {.count = 1, .reusable = true}, REDUCE(sym_typed_parameter, 3, .production_id = 39),
  [1837] = {.count = 1, .reusable = true}, SHIFT(303),
  [1839] = {.count = 1, .reusable = true}, SHIFT(81),
  [1841] = {.count = 1, .reusable = true}, SHIFT(231),
  [1843] = {.count = 1, .reusable = true}, REDUCE(sym_print_statement, 3, .production_id = 12),
  [1845] = {.count = 1, .reusable = true}, SHIFT(707),
  [1847] = {.count = 1, .reusable = true}, SHIFT(632),
  [1849] = {.count = 1, .reusable = true}, SHIFT(624),
  [1851] = {.count = 1, .reusable = true}, SHIFT(229),
  [1853] = {.count = 1, .reusable = true}, REDUCE(sym_print_statement, 3, .production_id = 13),
  [1855] = {.count = 2, .reusable = true}, REDUCE(aux_sym_print_statement_repeat1, 2, .production_id = 27), SHIFT_REPEAT(324),
  [1858] = {.count = 1, .reusable = true}, REDUCE(aux_sym_print_statement_repeat1, 2, .production_id = 27),
  [1860] = {.count = 1, .reusable = true}, SHIFT(1035),
  [1862] = {.count = 1, .reusable = true}, REDUCE(sym_nonlocal_statement, 3),
  [1864] = {.count = 1, .reusable = true}, SHIFT(344),
  [1866] = {.count = 1, .reusable = true}, REDUCE(aux_sym__import_list_repeat1, 2, .production_id = 21),
  [1868] = {.count = 1, .reusable = true}, REDUCE(sym_nonlocal_statement, 2),
  [1870] = {.count = 1, .reusable = true}, SHIFT(753),
  [1872] = {.count = 1, .reusable = true}, REDUCE(sym__import_list, 2, .production_id = 11),
  [1874] = {.count = 1, .reusable = true}, SHIFT(57),
  [1876] = {.count = 1, .reusable = true}, SHIFT(346),
  [1878] = {.count = 1, .reusable = true}, SHIFT(205),
  [1880] = {.count = 2, .reusable = true}, REDUCE(aux_sym_global_statement_repeat1, 2), SHIFT_REPEAT(1035),
  [1883] = {.count = 1, .reusable = true}, REDUCE(aux_sym_global_statement_repeat1, 2),
  [1885] = {.count = 1, .reusable = true}, SHIFT(883),
  [1887] = {.count = 1, .reusable = true}, REDUCE(sym_global_statement, 2),
  [1889] = {.count = 1, .reusable = true}, REDUCE(sym_global_statement, 3),
  [1891] = {.count = 1, .reusable = true}, SHIFT(52),
  [1893] = {.count = 1, .reusable = true}, REDUCE(sym_assert_statement, 3),
  [1895] = {.count = 1, .reusable = true}, SHIFT(58),
  [1897] = {.count = 1, .reusable = false}, REDUCE(aux_sym_import_prefix_repeat1, 2),
  [1899] = {.count = 2, .reusable = true}, REDUCE(aux_sym_import_prefix_repeat1, 2), SHIFT_REPEAT(803),
  [1902] = {.count = 1, .reusable = true}, SHIFT(245),
  [1904] = {.count = 1, .reusable = true}, REDUCE(sym_print_statement, 2),
  [1906] = {.count = 1, .reusable = true}, REDUCE(aux_sym__parameters_repeat1, 2, .production_id = 37),
  [1908] = {.count = 2, .reusable = true}, REDUCE(aux_sym_assert_statement_repeat1, 2), SHIFT_REPEAT(332),
  [1911] = {.count = 1, .reusable = true}, REDUCE(aux_sym__parameters_repeat1, 2),
  [1913] = {.count = 2, .reusable = true}, REDUCE(aux_sym__parameters_repeat1, 2), SHIFT_REPEAT(645),
  [1916] = {.count = 2, .reusable = true}, REDUCE(aux_sym_argument_list_repeat1, 2), SHIFT_REPEAT(130),
  [1919] = {.count = 1, .reusable = false}, REDUCE(sym_relative_import, 1),
  [1921] = {.count = 1, .reusable = true}, SHIFT(126),
  [1923] = {.count = 1, .reusable = true}, REDUCE(sym_assignment, 3, .production_id = 17),
  [1925] = {.count = 1, .reusable = true}, SHIFT(146),
  [1927] = {.count = 1, .reusable = true}, SHIFT(217),
  [1929] = {.count = 1, .reusable = true}, SHIFT(219),
  [1931] = {.count = 1, .reusable = true}, SHIFT(220),
  [1933] = {.count = 1, .reusable = true}, SHIFT(275),
  [1935] = {.count = 1, .reusable = true}, SHIFT(67),
  [1937] = {.count = 1, .reusable = true}, SHIFT(93),
  [1939] = {.count = 1, .reusable = true}, SHIFT(94),
  [1941] = {.count = 1, .reusable = true}, SHIFT(937),
  [1943] = {.count = 1, .reusable = true}, SHIFT(785),
  [1945] = {.count = 1, .reusable = true}, SHIFT(159),
  [1947] = {.count = 1, .reusable = true}, SHIFT(89),
  [1949] = {.count = 1, .reusable = true}, SHIFT(273),
  [1951] = {.count = 1, .reusable = true}, SHIFT(206),
  [1953] = {.count = 1, .reusable = true}, SHIFT(101),
  [1955] = {.count = 1, .reusable = true}, SHIFT(66),
  [1957] = {.count = 1, .reusable = true}, SHIFT(65),
  [1959] = {.count = 1, .reusable = true}, SHIFT(76),
  [1961] = {.count = 1, .reusable = true}, REDUCE(sym_aliased_import, 3, .production_id = 23),
  [1963] = {.count = 1, .reusable = true}, SHIFT(196),
  [1965] = {.count = 2, .reusable = true}, REDUCE(aux_sym_tuple_repeat1, 2), SHIFT_REPEAT(241),
  [1968] = {.count = 1, .reusable = true}, SHIFT(91),
  [1970] = {.count = 1, .reusable = true}, SHIFT(635),
  [1972] = {.count = 1, .reusable = true}, SHIFT(638),
  [1974] = {.count = 1, .reusable = true}, SHIFT(194),
  [1976] = {.count = 1, .reusable = true}, SHIFT(642),
  [1978] = {.count = 1, .reusable = true}, SHIFT(72),
  [1980] = {.count = 1, .reusable = true}, SHIFT(213),
  [1982] = {.count = 1, .reusable = true}, SHIFT(517),
  [1984] = {.count = 1, .reusable = true}, SHIFT(268),
  [1986] = {.count = 1, .reusable = true}, SHIFT(1031),
  [1988] = {.count = 2, .reusable = true}, REDUCE(aux_sym_subscript_repeat1, 2), SHIFT_REPEAT(252),
  [1991] = {.count = 1, .reusable = true}, SHIFT(641),
  [1993] = {.count = 1, .reusable = true}, SHIFT(92),
  [1995] = {.count = 1, .reusable = true}, SHIFT(256),
  [1997] = {.count = 1, .reusable = true}, SHIFT(625),
  [1999] = {.count = 1, .reusable = true}, SHIFT(215),
  [2001] = {.count = 1, .reusable = true}, SHIFT(571),
  [2003] = {.count = 1, .reusable = true}, SHIFT(634),
  [2005] = {.count = 1, .reusable = true}, SHIFT(202),
  [2007] = {.count = 2, .reusable = true}, REDUCE(aux_sym_with_statement_repeat1, 2), SHIFT_REPEAT(275),
  [2010] = {.count = 1, .reusable = true}, REDUCE(aux_sym_with_statement_repeat1, 2),
  [2012] = {.count = 1, .reusable = true}, SHIFT(204),
  [2014] = {.count = 1, .reusable = true}, SHIFT(161),
  [2016] = {.count = 1, .reusable = true}, SHIFT(118),
  [2018] = {.count = 1, .reusable = true}, SHIFT(755),
  [2020] = {.count = 1, .reusable = true}, SHIFT(293),
  [2022] = {.count = 1, .reusable = true}, REDUCE(sym_raise_statement, 2),
  [2024] = {.count = 1, .reusable = true}, SHIFT(64),
  [2026] = {.count = 1, .reusable = true}, SHIFT(51),
  [2028] = {.count = 2, .reusable = true}, REDUCE(aux_sym__simple_statements_repeat1, 2), SHIFT_REPEAT(95),
  [2031] = {.count = 1, .reusable = true}, REDUCE(aux_sym__simple_statements_repeat1, 2),
  [2033] = {.count = 1, .reusable = false}, REDUCE(sym_format_expression, 3),
  [2035] = {.count = 2, .reusable = true}, REDUCE(aux_sym_dictionary_repeat1, 2), SHIFT_REPEAT(212),
  [2038] = {.count = 1, .reusable = true}, REDUCE(aux_sym_dictionary_repeat1, 2),
  [2040] = {.count = 2, .reusable = true}, REDUCE(aux_sym__import_list_repeat1, 2, .production_id = 22), SHIFT_REPEAT(849),
  [2043] = {.count = 2, .reusable = true}, REDUCE(aux_sym_variables_repeat1, 2), SHIFT_REPEAT(565),
  [2046] = {.count = 1, .reusable = true}, SHIFT(115),
  [2048] = {.count = 1, .reusable = true}, SHIFT(210),
  [2050] = {.count = 1, .reusable = true}, SHIFT(176),
  [2052] = {.count = 1, .reusable = true}, SHIFT(90),
  [2054] = {.count = 2, .reusable = true}, REDUCE(aux_sym__parameters_repeat1, 2), SHIFT_REPEAT(644),
  [2057] = {.count = 1, .reusable = true}, SHIFT(340),
  [2059] = {.count = 1, .reusable = true}, REDUCE(sym_exec_statement, 2, .production_id = 6),
  [2061] = {.count = 1, .reusable = true}, SHIFT(54),
  [2063] = {.count = 1, .reusable = true}, SHIFT(119),
  [2065] = {.count = 1, .reusable = true}, SHIFT(192),
  [2067] = {.count = 1, .reusable = true}, SHIFT(472),
  [2069] = {.count = 1, .reusable = true}, SHIFT(100),
  [2071] = {.count = 1, .reusable = true}, SHIFT(777),
  [2073] = {.count = 1, .reusable = true}, SHIFT(522),
  [2075] = {.count = 1, .reusable = true}, SHIFT(284),
  [2077] = {.count = 1, .reusable = true}, SHIFT(964),
  [2079] = {.count = 1, .reusable = true}, SHIFT(512),
  [2081] = {.count = 1, .reusable = true}, REDUCE(sym_variables, 2),
  [2083] = {.count = 1, .reusable = true}, REDUCE(sym_continue_statement, 1),
  [2085] = {.count = 1, .reusable = true}, REDUCE(sym_yield, 2),
  [2087] = {.count = 1, .reusable = true}, SHIFT(623),
  [2089] = {.count = 1, .reusable = true}, REDUCE(sym_future_import_statement, 6, .production_id = 57),
  [2091] = {.count = 1, .reusable = true}, REDUCE(sym_parameters, 3),
  [2093] = {.count = 1, .reusable = true}, REDUCE(sym_import_statement, 2, .production_id = 2),
  [2095] = {.count = 1, .reusable = true}, REDUCE(sym_import_from_statement, 6, .production_id = 58),
  [2097] = {.count = 1, .reusable = true}, REDUCE(sym_wildcard_import, 1),
  [2099] = {.count = 1, .reusable = true}, REDUCE(sym_break_statement, 1),
  [2101] = {.count = 1, .reusable = true}, REDUCE(sym_delete_statement, 2),
  [2103] = {.count = 1, .reusable = true}, SHIFT(74),
  [2105] = {.count = 1, .reusable = true}, SHIFT(278),
  [2107] = {.count = 1, .reusable = true}, REDUCE(sym_parameters, 2),
  [2109] = {.count = 1, .reusable = true}, REDUCE(sym_return_statement, 2),
  [2111] = {.count = 1, .reusable = true}, REDUCE(sym_pass_statement, 1),
  [2113] = {.count = 1, .reusable = true}, SHIFT(70),
  [2115] = {.count = 1, .reusable = true}, SHIFT(271),
  [2117] = {.count = 1, .reusable = true}, REDUCE(sym_parenthesized_list_splat, 3),
  [2119] = {.count = 1, .reusable = true}, REDUCE(sym_import_from_statement, 4, .production_id = 25),
  [2121] = {.count = 1, .reusable = true}, SHIFT(79),
  [2123] = {.count = 1, .reusable = true}, SHIFT(255),
  [2125] = {.count = 1, .reusable = true}, REDUCE(sym_assignment, 5, .production_id = 55),
  [2127] = {.count = 1, .reusable = true}, REDUCE(sym_future_import_statement, 4, .production_id = 24),
  [2129] = {.count = 1, .reusable = true}, SHIFT(50),
  [2131] = {.count = 1, .reusable = true}, SHIFT(259),
  [2133] = {.count = 1, .reusable = true}, REDUCE(sym_augmented_assignment, 3, .production_id = 19),
  [2135] = {.count = 1, .reusable = true}, REDUCE(sym_assignment, 3, .production_id = 18),
  [2137] = {.count = 1, .reusable = true}, SHIFT(549),
  [2139] = {.count = 1, .reusable = true}, SHIFT(553),
  [2141] = {.count = 1, .reusable = true}, SHIFT(59),
  [2143] = {.count = 1, .reusable = true}, SHIFT(585),
  [2145] = {.count = 1, .reusable = true}, SHIFT(254),
  [2147] = {.count = 1, .reusable = true}, SHIFT(154),
  [2149] = {.count = 1, .reusable = true}, SHIFT(587),
  [2151] = {.count = 1, .reusable = true}, SHIFT(345),
  [2153] = {.count = 1, .reusable = true}, SHIFT(679),
  [2155] = {.count = 1, .reusable = true}, SHIFT(919),
  [2157] = {.count = 1, .reusable = true}, SHIFT(590),
  [2159] = {.count = 1, .reusable = true}, SHIFT(591),
  [2161] = {.count = 1, .reusable = true}, SHIFT(568),
  [2163] = {.count = 1, .reusable = true}, SHIFT(577),
  [2165] = {.count = 1, .reusable = true}, SHIFT(524),
  [2167] = {.count = 1, .reusable = true}, SHIFT(307),
  [2169] = {.count = 1, .reusable = true}, REDUCE(sym_lambda_parameters, 1),
  [2171] = {.count = 1, .reusable = true}, SHIFT(744),
  [2173] = {.count = 1, .reusable = true}, SHIFT(162),
  [2175] = {.count = 1, .reusable = true}, SHIFT(554),
  [2177] = {.count = 1, .reusable = true}, SHIFT(235),
  [2179] = {.count = 1, .reusable = true}, SHIFT(483),
  [2181] = {.count = 1, .reusable = true}, SHIFT(481),
  [2183] = {.count = 1, .reusable = true}, SHIFT(477),
  [2185] = {.count = 1, .reusable = true}, SHIFT(491),
  [2187] = {.count = 1, .reusable = true}, SHIFT(916),
  [2189] = {.count = 1, .reusable = true}, SHIFT(756),
  [2191] = {.count = 1, .reusable = true}, SHIFT(708),
  [2193] = {.count = 1, .reusable = true}, SHIFT(500),
  [2195] = {.count = 1, .reusable = true}, SHIFT(335),
  [2197] = {.count = 1, .reusable = true},  ACCEPT_INPUT(),
  [2199] = {.count = 1, .reusable = true}, SHIFT(838),
  [2201] = {.count = 1, .reusable = true}, REDUCE(sym_relative_import, 2),
  [2203] = {.count = 1, .reusable = true}, SHIFT(225),
  [2205] = {.count = 1, .reusable = true}, SHIFT(68),
  [2207] = {.count = 1, .reusable = true}, SHIFT(142),
  [2209] = {.count = 1, .reusable = true}, SHIFT(73),
  [2211] = {.count = 1, .reusable = true}, SHIFT(163),
  [2213] = {.count = 1, .reusable = true}, SHIFT(147),
  [2215] = {.count = 1, .reusable = true}, SHIFT(49),
  [2217] = {.count = 1, .reusable = true}, SHIFT(171),
  [2219] = {.count = 1, .reusable = true}, SHIFT(88),
  [2221] = {.count = 1, .reusable = true}, SHIFT(86),
  [2223] = {.count = 1, .reusable = true}, SHIFT(85),
  [2225] = {.count = 1, .reusable = true}, SHIFT(283),
  [2227] = {.count = 1, .reusable = true}, SHIFT(83),
  [2229] = {.count = 1, .reusable = true}, SHIFT(285),
  [2231] = {.count = 1, .reusable = true}, SHIFT(80),
  [2233] = {.count = 1, .reusable = true}, SHIFT(53),
  [2235] = {.count = 1, .reusable = true}, SHIFT(895),
  [2237] = {.count = 1, .reusable = true}, SHIFT(791),
  [2239] = {.count = 1, .reusable = true}, SHIFT(798),
  [2241] = {.count = 1, .reusable = true}, SHIFT(917),
  [2243] = {.count = 1, .reusable = true}, SHIFT(55),
  [2245] = {.count = 1, .reusable = true}, SHIFT(82),
  [2247] = {.count = 1, .reusable = true}, SHIFT(834),
  [2249] = {.count = 1, .reusable = true}, SHIFT(69),
  [2251] = {.count = 1, .reusable = true}, SHIFT(933),
  [2253] = {.count = 1, .reusable = true}, SHIFT(736),
  [2255] = {.count = 1, .reusable = true}, SHIFT(913),
  [2257] = {.count = 1, .reusable = true}, SHIFT(921),
  [2259] = {.count = 1, .reusable = true}, SHIFT(238),
  [2261] = {.count = 1, .reusable = true}, SHIFT(915),
  [2263] = {.count = 1, .reusable = true}, SHIFT(765),
  [2265] = {.count = 1, .reusable = true}, SHIFT(78),
  [2267] = {.count = 1, .reusable = true}, SHIFT(75),
  [2269] = {.count = 1, .reusable = true}, SHIFT(914),
  [2271] = {.count = 1, .reusable = true}, SHIFT(912),
  [2273] = {.count = 1, .reusable = true}, SHIFT(266),
  [2275] = {.count = 1, .reusable = true}, SHIFT(265),
  [2277] = {.count = 1, .reusable = true}, SHIFT(885),
  [2279] = {.count = 1, .reusable = true}, SHIFT(62),
};

void *tree_sitter_python_external_scanner_create(void);
void tree_sitter_python_external_scanner_destroy(void *);
bool tree_sitter_python_external_scanner_scan(void *, TSLexer *, const bool *);
unsigned tree_sitter_python_external_scanner_serialize(void *, char *);
void tree_sitter_python_external_scanner_deserialize(void *, const char *, unsigned);

#ifdef _WIN32
#define extern __declspec(dllexport)
#endif

extern const TSLanguage *tree_sitter_python(void) {
  static TSLanguage language = {
    .version = LANGUAGE_VERSION,
    .symbol_count = SYMBOL_COUNT,
    .alias_count = ALIAS_COUNT,
    .token_count = TOKEN_COUNT,
    .symbol_metadata = ts_symbol_metadata,
    .parse_table = (const unsigned short *)ts_parse_table,
    .parse_actions = ts_parse_actions,
    .lex_modes = ts_lex_modes,
    .symbol_names = ts_symbol_names,
    .alias_sequences = (const TSSymbol *)ts_alias_sequences,
    .field_count = FIELD_COUNT,
    .field_names = ts_field_names,
    .field_map_slices = (const TSFieldMapSlice *)ts_field_map_slices,
    .field_map_entries = (const TSFieldMapEntry *)ts_field_map_entries,
    .max_alias_sequence_length = MAX_ALIAS_SEQUENCE_LENGTH,
    .lex_fn = ts_lex,
    .keyword_lex_fn = ts_lex_keywords,
    .keyword_capture_token = sym_identifier,
    .external_token_count = EXTERNAL_TOKEN_COUNT,
    .external_scanner = {
      (const bool *)ts_external_scanner_states,
      ts_external_scanner_symbol_map,
      tree_sitter_python_external_scanner_create,
      tree_sitter_python_external_scanner_destroy,
      tree_sitter_python_external_scanner_scan,
      tree_sitter_python_external_scanner_serialize,
      tree_sitter_python_external_scanner_deserialize,
    },
  };
  return &language;
}
